// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Header.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Header.h"
#include "HeaderTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 284ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Header::Header()
{
    // ros2_interface::msg::Time m_time

    // long m_x
    m_x = 0;
    // long m_y
    m_y = 0;
    // long m_shapesize
    m_shapesize = 0;
    // long m_seq
    m_seq = 0;
    // string m_frame_id
    m_frame_id ="";

    // Just to register all known types
    registerHeaderTypes();
}

ros2_interface::msg::Header::~Header()
{






}

ros2_interface::msg::Header::Header(
        const Header& x)
{
    m_time = x.m_time;
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
    m_seq = x.m_seq;
    m_frame_id = x.m_frame_id;
}

ros2_interface::msg::Header::Header(
        Header&& x) noexcept 
{
    m_time = std::move(x.m_time);
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
    m_seq = x.m_seq;
    m_frame_id = std::move(x.m_frame_id);
}

ros2_interface::msg::Header& ros2_interface::msg::Header::operator =(
        const Header& x)
{

    m_time = x.m_time;
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
    m_seq = x.m_seq;
    m_frame_id = x.m_frame_id;

    return *this;
}

ros2_interface::msg::Header& ros2_interface::msg::Header::operator =(
        Header&& x) noexcept
{

    m_time = std::move(x.m_time);
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
    m_seq = x.m_seq;
    m_frame_id = std::move(x.m_frame_id);

    return *this;
}

bool ros2_interface::msg::Header::operator ==(
        const Header& x) const
{

    return (m_time == x.m_time && m_x == x.m_x && m_y == x.m_y && m_shapesize == x.m_shapesize && m_seq == x.m_seq && m_frame_id == x.m_frame_id);
}

bool ros2_interface::msg::Header::operator !=(
        const Header& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Header::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Header_max_cdr_typesize;
}

size_t ros2_interface::msg::Header::getCdrSerializedSize(
        const ros2_interface::msg::Header& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.time(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.frame_id().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Header::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_time;
    scdr << m_x;
    scdr << m_y;
    scdr << m_shapesize;
    scdr << m_seq;
    scdr << m_frame_id.c_str();

}

void ros2_interface::msg::Header::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_time;
    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_shapesize;
    dcdr >> m_seq;
    dcdr >> m_frame_id;
}

/*!
 * @brief This function copies the value in member time
 * @param _time New value to be copied in member time
 */
void ros2_interface::msg::Header::time(
        const ros2_interface::msg::Time& _time)
{
    m_time = _time;
}

/*!
 * @brief This function moves the value in member time
 * @param _time New value to be moved in member time
 */
void ros2_interface::msg::Header::time(
        ros2_interface::msg::Time&& _time)
{
    m_time = std::move(_time);
}

/*!
 * @brief This function returns a constant reference to member time
 * @return Constant reference to member time
 */
const ros2_interface::msg::Time& ros2_interface::msg::Header::time() const
{
    return m_time;
}

/*!
 * @brief This function returns a reference to member time
 * @return Reference to member time
 */
ros2_interface::msg::Time& ros2_interface::msg::Header::time()
{
    return m_time;
}
/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::Header::x(
        int32_t _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
int32_t ros2_interface::msg::Header::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
int32_t& ros2_interface::msg::Header::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::Header::y(
        int32_t _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
int32_t ros2_interface::msg::Header::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
int32_t& ros2_interface::msg::Header::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member shapesize
 * @param _shapesize New value for member shapesize
 */
void ros2_interface::msg::Header::shapesize(
        int32_t _shapesize)
{
    m_shapesize = _shapesize;
}

/*!
 * @brief This function returns the value of member shapesize
 * @return Value of member shapesize
 */
int32_t ros2_interface::msg::Header::shapesize() const
{
    return m_shapesize;
}

/*!
 * @brief This function returns a reference to member shapesize
 * @return Reference to member shapesize
 */
int32_t& ros2_interface::msg::Header::shapesize()
{
    return m_shapesize;
}

/*!
 * @brief This function sets a value in member seq
 * @param _seq New value for member seq
 */
void ros2_interface::msg::Header::seq(
        int32_t _seq)
{
    m_seq = _seq;
}

/*!
 * @brief This function returns the value of member seq
 * @return Value of member seq
 */
int32_t ros2_interface::msg::Header::seq() const
{
    return m_seq;
}

/*!
 * @brief This function returns a reference to member seq
 * @return Reference to member seq
 */
int32_t& ros2_interface::msg::Header::seq()
{
    return m_seq;
}

/*!
 * @brief This function copies the value in member frame_id
 * @param _frame_id New value to be copied in member frame_id
 */
void ros2_interface::msg::Header::frame_id(
        const std::string& _frame_id)
{
    m_frame_id = _frame_id;
}

/*!
 * @brief This function moves the value in member frame_id
 * @param _frame_id New value to be moved in member frame_id
 */
void ros2_interface::msg::Header::frame_id(
        std::string&& _frame_id)
{
    m_frame_id = std::move(_frame_id);
}

/*!
 * @brief This function returns a constant reference to member frame_id
 * @return Constant reference to member frame_id
 */
const std::string& ros2_interface::msg::Header::frame_id() const
{
    return m_frame_id;
}

/*!
 * @brief This function returns a reference to member frame_id
 * @return Reference to member frame_id
 */
std::string& ros2_interface::msg::Header::frame_id()
{
    return m_frame_id;
}


size_t ros2_interface::msg::Header::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Header_max_key_cdr_typesize;
}

bool ros2_interface::msg::Header::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Header::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



