// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Shape.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Shape.h"
#include "ShapeTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 284ULL;
#define ros2_interface_msg_ShapeType_max_cdr_typesize 556ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ShapeType_max_key_cdr_typesize 260ULL;

ros2_interface::msg::ShapeType::ShapeType()
{
    // ros2_interface::msg::Header m_header

    // string m_color
    m_color ="";
    // long m_x
    m_x = 0;
    // long m_y
    m_y = 0;
    // long m_shapesize
    m_shapesize = 0;

    // Just to register all known types
    registerShapeTypes();
}

ros2_interface::msg::ShapeType::~ShapeType()
{





}

ros2_interface::msg::ShapeType::ShapeType(
        const ShapeType& x)
{
    m_header = x.m_header;
    m_color = x.m_color;
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
}

ros2_interface::msg::ShapeType::ShapeType(
        ShapeType&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_color = std::move(x.m_color);
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;
}

ros2_interface::msg::ShapeType& ros2_interface::msg::ShapeType::operator =(
        const ShapeType& x)
{

    m_header = x.m_header;
    m_color = x.m_color;
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;

    return *this;
}

ros2_interface::msg::ShapeType& ros2_interface::msg::ShapeType::operator =(
        ShapeType&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_color = std::move(x.m_color);
    m_x = x.m_x;
    m_y = x.m_y;
    m_shapesize = x.m_shapesize;

    return *this;
}

bool ros2_interface::msg::ShapeType::operator ==(
        const ShapeType& x) const
{

    return (m_header == x.m_header && m_color == x.m_color && m_x == x.m_x && m_y == x.m_y && m_shapesize == x.m_shapesize);
}

bool ros2_interface::msg::ShapeType::operator !=(
        const ShapeType& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ShapeType::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ShapeType_max_cdr_typesize;
}

size_t ros2_interface::msg::ShapeType::getCdrSerializedSize(
        const ros2_interface::msg::ShapeType& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.color().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ShapeType::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_color.c_str();
    scdr << m_x;
    scdr << m_y;
    scdr << m_shapesize;

}

void ros2_interface::msg::ShapeType::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_color;
    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_shapesize;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ShapeType::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ShapeType::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ShapeType::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ShapeType::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member color
 * @param _color New value to be copied in member color
 */
void ros2_interface::msg::ShapeType::color(
        const std::string& _color)
{
    m_color = _color;
}

/*!
 * @brief This function moves the value in member color
 * @param _color New value to be moved in member color
 */
void ros2_interface::msg::ShapeType::color(
        std::string&& _color)
{
    m_color = std::move(_color);
}

/*!
 * @brief This function returns a constant reference to member color
 * @return Constant reference to member color
 */
const std::string& ros2_interface::msg::ShapeType::color() const
{
    return m_color;
}

/*!
 * @brief This function returns a reference to member color
 * @return Reference to member color
 */
std::string& ros2_interface::msg::ShapeType::color()
{
    return m_color;
}
/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::ShapeType::x(
        int32_t _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
int32_t ros2_interface::msg::ShapeType::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
int32_t& ros2_interface::msg::ShapeType::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::ShapeType::y(
        int32_t _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
int32_t ros2_interface::msg::ShapeType::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
int32_t& ros2_interface::msg::ShapeType::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member shapesize
 * @param _shapesize New value for member shapesize
 */
void ros2_interface::msg::ShapeType::shapesize(
        int32_t _shapesize)
{
    m_shapesize = _shapesize;
}

/*!
 * @brief This function returns the value of member shapesize
 * @return Value of member shapesize
 */
int32_t ros2_interface::msg::ShapeType::shapesize() const
{
    return m_shapesize;
}

/*!
 * @brief This function returns a reference to member shapesize
 * @return Reference to member shapesize
 */
int32_t& ros2_interface::msg::ShapeType::shapesize()
{
    return m_shapesize;
}



size_t ros2_interface::msg::ShapeType::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ShapeType_max_key_cdr_typesize;
}

bool ros2_interface::msg::ShapeType::isKeyDefined()
{
    return true;
}

void ros2_interface::msg::ShapeType::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
  
  scdr << m_color.c_str();
   
 
 
  
}



