// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Time.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Time.h"
#include "TimeTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Time::Time()
{
    // unsigned long m_x
    m_x = 0;
    // unsigned long m_y
    m_y = 0;

    // Just to register all known types
    registerTimeTypes();
}

ros2_interface::msg::Time::~Time()
{


}

ros2_interface::msg::Time::Time(
        const Time& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
}

ros2_interface::msg::Time::Time(
        Time&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
}

ros2_interface::msg::Time& ros2_interface::msg::Time::operator =(
        const Time& x)
{

    m_x = x.m_x;
    m_y = x.m_y;

    return *this;
}

ros2_interface::msg::Time& ros2_interface::msg::Time::operator =(
        Time&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;

    return *this;
}

bool ros2_interface::msg::Time::operator ==(
        const Time& x) const
{

    return (m_x == x.m_x && m_y == x.m_y);
}

bool ros2_interface::msg::Time::operator !=(
        const Time& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Time::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Time_max_cdr_typesize;
}

size_t ros2_interface::msg::Time::getCdrSerializedSize(
        const ros2_interface::msg::Time& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Time::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;

}

void ros2_interface::msg::Time::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::Time::x(
        uint32_t _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
uint32_t ros2_interface::msg::Time::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
uint32_t& ros2_interface::msg::Time::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::Time::y(
        uint32_t _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
uint32_t ros2_interface::msg::Time::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
uint32_t& ros2_interface::msg::Time::y()
{
    return m_y;
}



size_t ros2_interface::msg::Time::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Time_max_key_cdr_typesize;
}

bool ros2_interface::msg::Time::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Time::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



