// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file AlarmMessage.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "AlarmMessage.h"
#include "AlarmMessageTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_AlarmMessage_max_cdr_typesize 808ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_AlarmMessage_max_key_cdr_typesize 0ULL;

ros2_interface::msg::AlarmMessage::AlarmMessage()
{
    // ros2_interface::msg::Header m_header

    // string m_alarm_proc
    m_alarm_proc ="";
    // long m_alarm_level
    m_alarm_level = 0;
    // long m_alarm_type
    m_alarm_type = 0;
    // long m_alarm_id
    m_alarm_id = 0;
    // long m_alarm_display
    m_alarm_display = 0;
    // string m_alarm_data
    m_alarm_data ="";

    // Just to register all known types
    registerAlarmMessageTypes();
}

ros2_interface::msg::AlarmMessage::~AlarmMessage()
{







}

ros2_interface::msg::AlarmMessage::AlarmMessage(
        const AlarmMessage& x)
{
    m_header = x.m_header;
    m_alarm_proc = x.m_alarm_proc;
    m_alarm_level = x.m_alarm_level;
    m_alarm_type = x.m_alarm_type;
    m_alarm_id = x.m_alarm_id;
    m_alarm_display = x.m_alarm_display;
    m_alarm_data = x.m_alarm_data;
}

ros2_interface::msg::AlarmMessage::AlarmMessage(
        AlarmMessage&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_alarm_proc = std::move(x.m_alarm_proc);
    m_alarm_level = x.m_alarm_level;
    m_alarm_type = x.m_alarm_type;
    m_alarm_id = x.m_alarm_id;
    m_alarm_display = x.m_alarm_display;
    m_alarm_data = std::move(x.m_alarm_data);
}

ros2_interface::msg::AlarmMessage& ros2_interface::msg::AlarmMessage::operator =(
        const AlarmMessage& x)
{

    m_header = x.m_header;
    m_alarm_proc = x.m_alarm_proc;
    m_alarm_level = x.m_alarm_level;
    m_alarm_type = x.m_alarm_type;
    m_alarm_id = x.m_alarm_id;
    m_alarm_display = x.m_alarm_display;
    m_alarm_data = x.m_alarm_data;

    return *this;
}

ros2_interface::msg::AlarmMessage& ros2_interface::msg::AlarmMessage::operator =(
        AlarmMessage&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_alarm_proc = std::move(x.m_alarm_proc);
    m_alarm_level = x.m_alarm_level;
    m_alarm_type = x.m_alarm_type;
    m_alarm_id = x.m_alarm_id;
    m_alarm_display = x.m_alarm_display;
    m_alarm_data = std::move(x.m_alarm_data);

    return *this;
}

bool ros2_interface::msg::AlarmMessage::operator ==(
        const AlarmMessage& x) const
{

    return (m_header == x.m_header && m_alarm_proc == x.m_alarm_proc && m_alarm_level == x.m_alarm_level && m_alarm_type == x.m_alarm_type && m_alarm_id == x.m_alarm_id && m_alarm_display == x.m_alarm_display && m_alarm_data == x.m_alarm_data);
}

bool ros2_interface::msg::AlarmMessage::operator !=(
        const AlarmMessage& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::AlarmMessage::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_AlarmMessage_max_cdr_typesize;
}

size_t ros2_interface::msg::AlarmMessage::getCdrSerializedSize(
        const ros2_interface::msg::AlarmMessage& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.alarm_proc().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.alarm_data().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::AlarmMessage::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_alarm_proc.c_str();
    scdr << m_alarm_level;
    scdr << m_alarm_type;
    scdr << m_alarm_id;
    scdr << m_alarm_display;
    scdr << m_alarm_data.c_str();

}

void ros2_interface::msg::AlarmMessage::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_alarm_proc;
    dcdr >> m_alarm_level;
    dcdr >> m_alarm_type;
    dcdr >> m_alarm_id;
    dcdr >> m_alarm_display;
    dcdr >> m_alarm_data;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::AlarmMessage::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::AlarmMessage::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::AlarmMessage::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::AlarmMessage::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member alarm_proc
 * @param _alarm_proc New value to be copied in member alarm_proc
 */
void ros2_interface::msg::AlarmMessage::alarm_proc(
        const std::string& _alarm_proc)
{
    m_alarm_proc = _alarm_proc;
}

/*!
 * @brief This function moves the value in member alarm_proc
 * @param _alarm_proc New value to be moved in member alarm_proc
 */
void ros2_interface::msg::AlarmMessage::alarm_proc(
        std::string&& _alarm_proc)
{
    m_alarm_proc = std::move(_alarm_proc);
}

/*!
 * @brief This function returns a constant reference to member alarm_proc
 * @return Constant reference to member alarm_proc
 */
const std::string& ros2_interface::msg::AlarmMessage::alarm_proc() const
{
    return m_alarm_proc;
}

/*!
 * @brief This function returns a reference to member alarm_proc
 * @return Reference to member alarm_proc
 */
std::string& ros2_interface::msg::AlarmMessage::alarm_proc()
{
    return m_alarm_proc;
}
/*!
 * @brief This function sets a value in member alarm_level
 * @param _alarm_level New value for member alarm_level
 */
void ros2_interface::msg::AlarmMessage::alarm_level(
        int32_t _alarm_level)
{
    m_alarm_level = _alarm_level;
}

/*!
 * @brief This function returns the value of member alarm_level
 * @return Value of member alarm_level
 */
int32_t ros2_interface::msg::AlarmMessage::alarm_level() const
{
    return m_alarm_level;
}

/*!
 * @brief This function returns a reference to member alarm_level
 * @return Reference to member alarm_level
 */
int32_t& ros2_interface::msg::AlarmMessage::alarm_level()
{
    return m_alarm_level;
}

/*!
 * @brief This function sets a value in member alarm_type
 * @param _alarm_type New value for member alarm_type
 */
void ros2_interface::msg::AlarmMessage::alarm_type(
        int32_t _alarm_type)
{
    m_alarm_type = _alarm_type;
}

/*!
 * @brief This function returns the value of member alarm_type
 * @return Value of member alarm_type
 */
int32_t ros2_interface::msg::AlarmMessage::alarm_type() const
{
    return m_alarm_type;
}

/*!
 * @brief This function returns a reference to member alarm_type
 * @return Reference to member alarm_type
 */
int32_t& ros2_interface::msg::AlarmMessage::alarm_type()
{
    return m_alarm_type;
}

/*!
 * @brief This function sets a value in member alarm_id
 * @param _alarm_id New value for member alarm_id
 */
void ros2_interface::msg::AlarmMessage::alarm_id(
        int32_t _alarm_id)
{
    m_alarm_id = _alarm_id;
}

/*!
 * @brief This function returns the value of member alarm_id
 * @return Value of member alarm_id
 */
int32_t ros2_interface::msg::AlarmMessage::alarm_id() const
{
    return m_alarm_id;
}

/*!
 * @brief This function returns a reference to member alarm_id
 * @return Reference to member alarm_id
 */
int32_t& ros2_interface::msg::AlarmMessage::alarm_id()
{
    return m_alarm_id;
}

/*!
 * @brief This function sets a value in member alarm_display
 * @param _alarm_display New value for member alarm_display
 */
void ros2_interface::msg::AlarmMessage::alarm_display(
        int32_t _alarm_display)
{
    m_alarm_display = _alarm_display;
}

/*!
 * @brief This function returns the value of member alarm_display
 * @return Value of member alarm_display
 */
int32_t ros2_interface::msg::AlarmMessage::alarm_display() const
{
    return m_alarm_display;
}

/*!
 * @brief This function returns a reference to member alarm_display
 * @return Reference to member alarm_display
 */
int32_t& ros2_interface::msg::AlarmMessage::alarm_display()
{
    return m_alarm_display;
}

/*!
 * @brief This function copies the value in member alarm_data
 * @param _alarm_data New value to be copied in member alarm_data
 */
void ros2_interface::msg::AlarmMessage::alarm_data(
        const std::string& _alarm_data)
{
    m_alarm_data = _alarm_data;
}

/*!
 * @brief This function moves the value in member alarm_data
 * @param _alarm_data New value to be moved in member alarm_data
 */
void ros2_interface::msg::AlarmMessage::alarm_data(
        std::string&& _alarm_data)
{
    m_alarm_data = std::move(_alarm_data);
}

/*!
 * @brief This function returns a constant reference to member alarm_data
 * @return Constant reference to member alarm_data
 */
const std::string& ros2_interface::msg::AlarmMessage::alarm_data() const
{
    return m_alarm_data;
}

/*!
 * @brief This function returns a reference to member alarm_data
 * @return Reference to member alarm_data
 */
std::string& ros2_interface::msg::AlarmMessage::alarm_data()
{
    return m_alarm_data;
}


size_t ros2_interface::msg::AlarmMessage::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_AlarmMessage_max_key_cdr_typesize;
}

bool ros2_interface::msg::AlarmMessage::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::AlarmMessage::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



