// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file AlarmMessage.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ALARMMESSAGE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ALARMMESSAGE_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(ALARMMESSAGE_SOURCE)
#define ALARMMESSAGE_DllAPI __declspec( dllexport )
#else
#define ALARMMESSAGE_DllAPI __declspec( dllimport )
#endif // ALARMMESSAGE_SOURCE
#else
#define ALARMMESSAGE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define ALARMMESSAGE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure AlarmMessage defined by the user in the IDL file.
         * @ingroup AlarmMessage
         */
        class AlarmMessage
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport AlarmMessage();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~AlarmMessage();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::AlarmMessage that will be copied.
             */
            eProsima_user_DllExport AlarmMessage(
                    const AlarmMessage& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::AlarmMessage that will be copied.
             */
            eProsima_user_DllExport AlarmMessage(
                    AlarmMessage&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::AlarmMessage that will be copied.
             */
            eProsima_user_DllExport AlarmMessage& operator =(
                    const AlarmMessage& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::AlarmMessage that will be copied.
             */
            eProsima_user_DllExport AlarmMessage& operator =(
                    AlarmMessage&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::AlarmMessage object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const AlarmMessage& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::AlarmMessage object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const AlarmMessage& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member alarm_proc
             * @param _alarm_proc New value to be copied in member alarm_proc
             */
            eProsima_user_DllExport void alarm_proc(
                    const std::string& _alarm_proc);

            /*!
             * @brief This function moves the value in member alarm_proc
             * @param _alarm_proc New value to be moved in member alarm_proc
             */
            eProsima_user_DllExport void alarm_proc(
                    std::string&& _alarm_proc);

            /*!
             * @brief This function returns a constant reference to member alarm_proc
             * @return Constant reference to member alarm_proc
             */
            eProsima_user_DllExport const std::string& alarm_proc() const;

            /*!
             * @brief This function returns a reference to member alarm_proc
             * @return Reference to member alarm_proc
             */
            eProsima_user_DllExport std::string& alarm_proc();
            /*!
             * @brief This function sets a value in member alarm_level
             * @param _alarm_level New value for member alarm_level
             */
            eProsima_user_DllExport void alarm_level(
                    int32_t _alarm_level);

            /*!
             * @brief This function returns the value of member alarm_level
             * @return Value of member alarm_level
             */
            eProsima_user_DllExport int32_t alarm_level() const;

            /*!
             * @brief This function returns a reference to member alarm_level
             * @return Reference to member alarm_level
             */
            eProsima_user_DllExport int32_t& alarm_level();

            /*!
             * @brief This function sets a value in member alarm_type
             * @param _alarm_type New value for member alarm_type
             */
            eProsima_user_DllExport void alarm_type(
                    int32_t _alarm_type);

            /*!
             * @brief This function returns the value of member alarm_type
             * @return Value of member alarm_type
             */
            eProsima_user_DllExport int32_t alarm_type() const;

            /*!
             * @brief This function returns a reference to member alarm_type
             * @return Reference to member alarm_type
             */
            eProsima_user_DllExport int32_t& alarm_type();

            /*!
             * @brief This function sets a value in member alarm_id
             * @param _alarm_id New value for member alarm_id
             */
            eProsima_user_DllExport void alarm_id(
                    int32_t _alarm_id);

            /*!
             * @brief This function returns the value of member alarm_id
             * @return Value of member alarm_id
             */
            eProsima_user_DllExport int32_t alarm_id() const;

            /*!
             * @brief This function returns a reference to member alarm_id
             * @return Reference to member alarm_id
             */
            eProsima_user_DllExport int32_t& alarm_id();

            /*!
             * @brief This function sets a value in member alarm_display
             * @param _alarm_display New value for member alarm_display
             */
            eProsima_user_DllExport void alarm_display(
                    int32_t _alarm_display);

            /*!
             * @brief This function returns the value of member alarm_display
             * @return Value of member alarm_display
             */
            eProsima_user_DllExport int32_t alarm_display() const;

            /*!
             * @brief This function returns a reference to member alarm_display
             * @return Reference to member alarm_display
             */
            eProsima_user_DllExport int32_t& alarm_display();

            /*!
             * @brief This function copies the value in member alarm_data
             * @param _alarm_data New value to be copied in member alarm_data
             */
            eProsima_user_DllExport void alarm_data(
                    const std::string& _alarm_data);

            /*!
             * @brief This function moves the value in member alarm_data
             * @param _alarm_data New value to be moved in member alarm_data
             */
            eProsima_user_DllExport void alarm_data(
                    std::string&& _alarm_data);

            /*!
             * @brief This function returns a constant reference to member alarm_data
             * @return Constant reference to member alarm_data
             */
            eProsima_user_DllExport const std::string& alarm_data() const;

            /*!
             * @brief This function returns a reference to member alarm_data
             * @return Reference to member alarm_data
             */
            eProsima_user_DllExport std::string& alarm_data();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::AlarmMessage& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::string m_alarm_proc;
            int32_t m_alarm_level;
            int32_t m_alarm_type;
            int32_t m_alarm_id;
            int32_t m_alarm_display;
            std::string m_alarm_data;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ALARMMESSAGE_H_

