// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file BBox2D.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "BBox2D.h"
#include "BBox2DTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_BBox2D_max_cdr_typesize 8ULL;
#define ros2_interface_msg_BBox2D_max_key_cdr_typesize 0ULL;

ros2_interface::msg::BBox2D::BBox2D()
{
    // short m_xmin
    m_xmin = 0;
    // short m_ymin
    m_ymin = 0;
    // short m_xmax
    m_xmax = 0;
    // short m_ymax
    m_ymax = 0;

    // Just to register all known types
    registerBBox2DTypes();
}

ros2_interface::msg::BBox2D::~BBox2D()
{




}

ros2_interface::msg::BBox2D::BBox2D(
        const BBox2D& x)
{
    m_xmin = x.m_xmin;
    m_ymin = x.m_ymin;
    m_xmax = x.m_xmax;
    m_ymax = x.m_ymax;
}

ros2_interface::msg::BBox2D::BBox2D(
        BBox2D&& x) noexcept 
{
    m_xmin = x.m_xmin;
    m_ymin = x.m_ymin;
    m_xmax = x.m_xmax;
    m_ymax = x.m_ymax;
}

ros2_interface::msg::BBox2D& ros2_interface::msg::BBox2D::operator =(
        const BBox2D& x)
{

    m_xmin = x.m_xmin;
    m_ymin = x.m_ymin;
    m_xmax = x.m_xmax;
    m_ymax = x.m_ymax;

    return *this;
}

ros2_interface::msg::BBox2D& ros2_interface::msg::BBox2D::operator =(
        BBox2D&& x) noexcept
{

    m_xmin = x.m_xmin;
    m_ymin = x.m_ymin;
    m_xmax = x.m_xmax;
    m_ymax = x.m_ymax;

    return *this;
}

bool ros2_interface::msg::BBox2D::operator ==(
        const BBox2D& x) const
{

    return (m_xmin == x.m_xmin && m_ymin == x.m_ymin && m_xmax == x.m_xmax && m_ymax == x.m_ymax);
}

bool ros2_interface::msg::BBox2D::operator !=(
        const BBox2D& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::BBox2D::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_BBox2D_max_cdr_typesize;
}

size_t ros2_interface::msg::BBox2D::getCdrSerializedSize(
        const ros2_interface::msg::BBox2D& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::BBox2D::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_xmin;
    scdr << m_ymin;
    scdr << m_xmax;
    scdr << m_ymax;

}

void ros2_interface::msg::BBox2D::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_xmin;
    dcdr >> m_ymin;
    dcdr >> m_xmax;
    dcdr >> m_ymax;
}

/*!
 * @brief This function sets a value in member xmin
 * @param _xmin New value for member xmin
 */
void ros2_interface::msg::BBox2D::xmin(
        int16_t _xmin)
{
    m_xmin = _xmin;
}

/*!
 * @brief This function returns the value of member xmin
 * @return Value of member xmin
 */
int16_t ros2_interface::msg::BBox2D::xmin() const
{
    return m_xmin;
}

/*!
 * @brief This function returns a reference to member xmin
 * @return Reference to member xmin
 */
int16_t& ros2_interface::msg::BBox2D::xmin()
{
    return m_xmin;
}

/*!
 * @brief This function sets a value in member ymin
 * @param _ymin New value for member ymin
 */
void ros2_interface::msg::BBox2D::ymin(
        int16_t _ymin)
{
    m_ymin = _ymin;
}

/*!
 * @brief This function returns the value of member ymin
 * @return Value of member ymin
 */
int16_t ros2_interface::msg::BBox2D::ymin() const
{
    return m_ymin;
}

/*!
 * @brief This function returns a reference to member ymin
 * @return Reference to member ymin
 */
int16_t& ros2_interface::msg::BBox2D::ymin()
{
    return m_ymin;
}

/*!
 * @brief This function sets a value in member xmax
 * @param _xmax New value for member xmax
 */
void ros2_interface::msg::BBox2D::xmax(
        int16_t _xmax)
{
    m_xmax = _xmax;
}

/*!
 * @brief This function returns the value of member xmax
 * @return Value of member xmax
 */
int16_t ros2_interface::msg::BBox2D::xmax() const
{
    return m_xmax;
}

/*!
 * @brief This function returns a reference to member xmax
 * @return Reference to member xmax
 */
int16_t& ros2_interface::msg::BBox2D::xmax()
{
    return m_xmax;
}

/*!
 * @brief This function sets a value in member ymax
 * @param _ymax New value for member ymax
 */
void ros2_interface::msg::BBox2D::ymax(
        int16_t _ymax)
{
    m_ymax = _ymax;
}

/*!
 * @brief This function returns the value of member ymax
 * @return Value of member ymax
 */
int16_t ros2_interface::msg::BBox2D::ymax() const
{
    return m_ymax;
}

/*!
 * @brief This function returns a reference to member ymax
 * @return Reference to member ymax
 */
int16_t& ros2_interface::msg::BBox2D::ymax()
{
    return m_ymax;
}



size_t ros2_interface::msg::BBox2D::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_BBox2D_max_key_cdr_typesize;
}

bool ros2_interface::msg::BBox2D::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::BBox2D::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



