// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file BBox2D.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_BBOX2D_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_BBOX2D_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(BBOX2D_SOURCE)
#define BBOX2D_DllAPI __declspec( dllexport )
#else
#define BBOX2D_DllAPI __declspec( dllimport )
#endif // BBOX2D_SOURCE
#else
#define BBOX2D_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define BBOX2D_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure BBox2D defined by the user in the IDL file.
         * @ingroup BBox2D
         */
        class BBox2D
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport BBox2D();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~BBox2D();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::BBox2D that will be copied.
             */
            eProsima_user_DllExport BBox2D(
                    const BBox2D& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::BBox2D that will be copied.
             */
            eProsima_user_DllExport BBox2D(
                    BBox2D&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::BBox2D that will be copied.
             */
            eProsima_user_DllExport BBox2D& operator =(
                    const BBox2D& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::BBox2D that will be copied.
             */
            eProsima_user_DllExport BBox2D& operator =(
                    BBox2D&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::BBox2D object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const BBox2D& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::BBox2D object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const BBox2D& x) const;

            /*!
             * @brief This function sets a value in member xmin
             * @param _xmin New value for member xmin
             */
            eProsima_user_DllExport void xmin(
                    int16_t _xmin);

            /*!
             * @brief This function returns the value of member xmin
             * @return Value of member xmin
             */
            eProsima_user_DllExport int16_t xmin() const;

            /*!
             * @brief This function returns a reference to member xmin
             * @return Reference to member xmin
             */
            eProsima_user_DllExport int16_t& xmin();

            /*!
             * @brief This function sets a value in member ymin
             * @param _ymin New value for member ymin
             */
            eProsima_user_DllExport void ymin(
                    int16_t _ymin);

            /*!
             * @brief This function returns the value of member ymin
             * @return Value of member ymin
             */
            eProsima_user_DllExport int16_t ymin() const;

            /*!
             * @brief This function returns a reference to member ymin
             * @return Reference to member ymin
             */
            eProsima_user_DllExport int16_t& ymin();

            /*!
             * @brief This function sets a value in member xmax
             * @param _xmax New value for member xmax
             */
            eProsima_user_DllExport void xmax(
                    int16_t _xmax);

            /*!
             * @brief This function returns the value of member xmax
             * @return Value of member xmax
             */
            eProsima_user_DllExport int16_t xmax() const;

            /*!
             * @brief This function returns a reference to member xmax
             * @return Reference to member xmax
             */
            eProsima_user_DllExport int16_t& xmax();

            /*!
             * @brief This function sets a value in member ymax
             * @param _ymax New value for member ymax
             */
            eProsima_user_DllExport void ymax(
                    int16_t _ymax);

            /*!
             * @brief This function returns the value of member ymax
             * @return Value of member ymax
             */
            eProsima_user_DllExport int16_t ymax() const;

            /*!
             * @brief This function returns a reference to member ymax
             * @return Reference to member ymax
             */
            eProsima_user_DllExport int16_t& ymax();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::BBox2D& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int16_t m_xmin;
            int16_t m_ymin;
            int16_t m_xmax;
            int16_t m_ymax;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_BBOX2D_H_

