// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file BBox2DTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "BBox2D.h"
#include "BBox2DTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerBBox2DTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::BBox2D", ros2_interface::msg::GetBBox2DIdentifier(true),
                        ros2_interface::msg::GetBBox2DObject(true));
                factory->add_type_object("ros2_interface::msg::BBox2D", ros2_interface::msg::GetBBox2DIdentifier(false),
                        ros2_interface::msg::GetBBox2DObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetBBox2DIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("BBox2D", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetBBox2DObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("BBox2D", complete);
        }

        const TypeObject* GetBBox2DObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("BBox2D", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteBBox2DObject();
            }
            //else
            return GetMinimalBBox2DObject();
        }

        const TypeObject* GetMinimalBBox2DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("BBox2D", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_xmin;
            mst_xmin.common().member_id(memberId++);
            mst_xmin.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_xmin.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_xmin.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_xmin.common().member_flags().IS_OPTIONAL(false);
            mst_xmin.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_xmin.common().member_flags().IS_KEY(false);
            mst_xmin.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_xmin.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 xmin_hash("xmin");
            for(int i = 0; i < 4; ++i)
            {
                mst_xmin.detail().name_hash()[i] = xmin_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_xmin);

            MinimalStructMember mst_ymin;
            mst_ymin.common().member_id(memberId++);
            mst_ymin.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ymin.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ymin.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ymin.common().member_flags().IS_OPTIONAL(false);
            mst_ymin.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ymin.common().member_flags().IS_KEY(false);
            mst_ymin.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ymin.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 ymin_hash("ymin");
            for(int i = 0; i < 4; ++i)
            {
                mst_ymin.detail().name_hash()[i] = ymin_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ymin);

            MinimalStructMember mst_xmax;
            mst_xmax.common().member_id(memberId++);
            mst_xmax.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_xmax.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_xmax.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_xmax.common().member_flags().IS_OPTIONAL(false);
            mst_xmax.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_xmax.common().member_flags().IS_KEY(false);
            mst_xmax.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_xmax.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 xmax_hash("xmax");
            for(int i = 0; i < 4; ++i)
            {
                mst_xmax.detail().name_hash()[i] = xmax_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_xmax);

            MinimalStructMember mst_ymax;
            mst_ymax.common().member_id(memberId++);
            mst_ymax.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ymax.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ymax.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ymax.common().member_flags().IS_OPTIONAL(false);
            mst_ymax.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ymax.common().member_flags().IS_KEY(false);
            mst_ymax.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ymax.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 ymax_hash("ymax");
            for(int i = 0; i < 4; ++i)
            {
                mst_ymax.detail().name_hash()[i] = ymax_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ymax);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("BBox2D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("BBox2D", false);
        }

        const TypeObject* GetCompleteBBox2DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("BBox2D", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_xmin;
            cst_xmin.common().member_id(memberId++);
            cst_xmin.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_xmin.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_xmin.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_xmin.common().member_flags().IS_OPTIONAL(false);
            cst_xmin.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_xmin.common().member_flags().IS_KEY(false);
            cst_xmin.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_xmin.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_xmin.detail().name("xmin");

            type_object->complete().struct_type().member_seq().emplace_back(cst_xmin);

            CompleteStructMember cst_ymin;
            cst_ymin.common().member_id(memberId++);
            cst_ymin.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ymin.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ymin.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ymin.common().member_flags().IS_OPTIONAL(false);
            cst_ymin.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ymin.common().member_flags().IS_KEY(false);
            cst_ymin.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ymin.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_ymin.detail().name("ymin");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ymin);

            CompleteStructMember cst_xmax;
            cst_xmax.common().member_id(memberId++);
            cst_xmax.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_xmax.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_xmax.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_xmax.common().member_flags().IS_OPTIONAL(false);
            cst_xmax.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_xmax.common().member_flags().IS_KEY(false);
            cst_xmax.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_xmax.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_xmax.detail().name("xmax");

            type_object->complete().struct_type().member_seq().emplace_back(cst_xmax);

            CompleteStructMember cst_ymax;
            cst_ymax.common().member_id(memberId++);
            cst_ymax.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ymax.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ymax.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ymax.common().member_flags().IS_OPTIONAL(false);
            cst_ymax.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ymax.common().member_flags().IS_KEY(false);
            cst_ymax.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ymax.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_ymax.detail().name("ymax");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ymax);


            // Header
            type_object->complete().struct_type().header().detail().type_name("BBox2D");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("BBox2D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("BBox2D", true);
        }

    } // namespace msg
} // namespace ros2_interface