// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CameraParkingInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CAMERAPARKINGINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CAMERAPARKINGINFO_H_

#include "Header.h"
#include "Point3D.h"
#include "ImageKeyPoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(CAMERAPARKINGINFO_SOURCE)
#define CAMERAPARKINGINFO_DllAPI __declspec( dllexport )
#else
#define CAMERAPARKINGINFO_DllAPI __declspec( dllimport )
#endif // CAMERAPARKINGINFO_SOURCE
#else
#define CAMERAPARKINGINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define CAMERAPARKINGINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure CameraParkingInfo defined by the user in the IDL file.
         * @ingroup CameraParkingInfo
         */
        class CameraParkingInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport CameraParkingInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~CameraParkingInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::CameraParkingInfo that will be copied.
             */
            eProsima_user_DllExport CameraParkingInfo(
                    const CameraParkingInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::CameraParkingInfo that will be copied.
             */
            eProsima_user_DllExport CameraParkingInfo(
                    CameraParkingInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::CameraParkingInfo that will be copied.
             */
            eProsima_user_DllExport CameraParkingInfo& operator =(
                    const CameraParkingInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::CameraParkingInfo that will be copied.
             */
            eProsima_user_DllExport CameraParkingInfo& operator =(
                    CameraParkingInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::CameraParkingInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const CameraParkingInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::CameraParkingInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const CameraParkingInfo& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member parking_space_id
             * @param _parking_space_id New value for member parking_space_id
             */
            eProsima_user_DllExport void parking_space_id(
                    int32_t _parking_space_id);

            /*!
             * @brief This function returns the value of member parking_space_id
             * @return Value of member parking_space_id
             */
            eProsima_user_DllExport int32_t parking_space_id() const;

            /*!
             * @brief This function returns a reference to member parking_space_id
             * @return Reference to member parking_space_id
             */
            eProsima_user_DllExport int32_t& parking_space_id();

            /*!
             * @brief This function sets a value in member parking_type
             * @param _parking_type New value for member parking_type
             */
            eProsima_user_DllExport void parking_type(
                    int32_t _parking_type);

            /*!
             * @brief This function returns the value of member parking_type
             * @return Value of member parking_type
             */
            eProsima_user_DllExport int32_t parking_type() const;

            /*!
             * @brief This function returns a reference to member parking_type
             * @return Reference to member parking_type
             */
            eProsima_user_DllExport int32_t& parking_type();

            /*!
             * @brief This function sets a value in member is_parking_enable
             * @param _is_parking_enable New value for member is_parking_enable
             */
            eProsima_user_DllExport void is_parking_enable(
                    bool _is_parking_enable);

            /*!
             * @brief This function returns the value of member is_parking_enable
             * @return Value of member is_parking_enable
             */
            eProsima_user_DllExport bool is_parking_enable() const;

            /*!
             * @brief This function returns a reference to member is_parking_enable
             * @return Reference to member is_parking_enable
             */
            eProsima_user_DllExport bool& is_parking_enable();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function copies the value in member center_point_of_parking
             * @param _center_point_of_parking New value to be copied in member center_point_of_parking
             */
            eProsima_user_DllExport void center_point_of_parking(
                    const ros2_interface::msg::Point3D& _center_point_of_parking);

            /*!
             * @brief This function moves the value in member center_point_of_parking
             * @param _center_point_of_parking New value to be moved in member center_point_of_parking
             */
            eProsima_user_DllExport void center_point_of_parking(
                    ros2_interface::msg::Point3D&& _center_point_of_parking);

            /*!
             * @brief This function returns a constant reference to member center_point_of_parking
             * @return Constant reference to member center_point_of_parking
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& center_point_of_parking() const;

            /*!
             * @brief This function returns a reference to member center_point_of_parking
             * @return Reference to member center_point_of_parking
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& center_point_of_parking();
            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member yaw_offset
             * @param _yaw_offset New value for member yaw_offset
             */
            eProsima_user_DllExport void yaw_offset(
                    double _yaw_offset);

            /*!
             * @brief This function returns the value of member yaw_offset
             * @return Value of member yaw_offset
             */
            eProsima_user_DllExport double yaw_offset() const;

            /*!
             * @brief This function returns a reference to member yaw_offset
             * @return Reference to member yaw_offset
             */
            eProsima_user_DllExport double& yaw_offset();

            /*!
             * @brief This function copies the value in member parking_points_in_image
             * @param _parking_points_in_image New value to be copied in member parking_points_in_image
             */
            eProsima_user_DllExport void parking_points_in_image(
                    const std::vector<ros2_interface::msg::ImageKeyPoint>& _parking_points_in_image);

            /*!
             * @brief This function moves the value in member parking_points_in_image
             * @param _parking_points_in_image New value to be moved in member parking_points_in_image
             */
            eProsima_user_DllExport void parking_points_in_image(
                    std::vector<ros2_interface::msg::ImageKeyPoint>&& _parking_points_in_image);

            /*!
             * @brief This function returns a constant reference to member parking_points_in_image
             * @return Constant reference to member parking_points_in_image
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::ImageKeyPoint>& parking_points_in_image() const;

            /*!
             * @brief This function returns a reference to member parking_points_in_image
             * @return Reference to member parking_points_in_image
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::ImageKeyPoint>& parking_points_in_image();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::CameraParkingInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_parking_space_id;
            int32_t m_parking_type;
            bool m_is_parking_enable;
            double m_confidence;
            ros2_interface::msg::Point3D m_center_point_of_parking;
            double m_theta;
            double m_width;
            double m_length;
            double m_yaw_offset;
            std::vector<ros2_interface::msg::ImageKeyPoint> m_parking_points_in_image;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CAMERAPARKINGINFO_H_

