// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CameraParkingInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "CameraParkingInfo.h"
#include "CameraParkingInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerCameraParkingInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::ImageKeyPoint", ros2_interface::msg::GetImageKeyPointIdentifier(true),
                        ros2_interface::msg::GetImageKeyPointObject(true));
                factory->add_type_object("ros2_interface::msg::ImageKeyPoint", ros2_interface::msg::GetImageKeyPointIdentifier(false),
                        ros2_interface::msg::GetImageKeyPointObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::CameraParkingInfo", ros2_interface::msg::GetCameraParkingInfoIdentifier(true),
                        ros2_interface::msg::GetCameraParkingInfoObject(true));
                factory->add_type_object("ros2_interface::msg::CameraParkingInfo", ros2_interface::msg::GetCameraParkingInfoIdentifier(false),
                        ros2_interface::msg::GetCameraParkingInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetCameraParkingInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("CameraParkingInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetCameraParkingInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("CameraParkingInfo", complete);
        }

        const TypeObject* GetCameraParkingInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CameraParkingInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteCameraParkingInfoObject();
            }
            //else
            return GetMinimalCameraParkingInfoObject();
        }

        const TypeObject* GetMinimalCameraParkingInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CameraParkingInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_parking_space_id;
            mst_parking_space_id.common().member_id(memberId++);
            mst_parking_space_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_space_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_space_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_space_id.common().member_flags().IS_OPTIONAL(false);
            mst_parking_space_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_space_id.common().member_flags().IS_KEY(false);
            mst_parking_space_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_space_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_space_id_hash("parking_space_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_space_id.detail().name_hash()[i] = parking_space_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_space_id);

            MinimalStructMember mst_parking_type;
            mst_parking_type.common().member_id(memberId++);
            mst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_type.common().member_flags().IS_OPTIONAL(false);
            mst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_type.common().member_flags().IS_KEY(false);
            mst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_type_hash("parking_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_type.detail().name_hash()[i] = parking_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_type);

            MinimalStructMember mst_is_parking_enable;
            mst_is_parking_enable.common().member_id(memberId++);
            mst_is_parking_enable.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_parking_enable.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_parking_enable.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_parking_enable.common().member_flags().IS_OPTIONAL(false);
            mst_is_parking_enable.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_parking_enable.common().member_flags().IS_KEY(false);
            mst_is_parking_enable.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_parking_enable.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_parking_enable_hash("is_parking_enable");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_parking_enable.detail().name_hash()[i] = is_parking_enable_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_parking_enable);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_center_point_of_parking;
            mst_center_point_of_parking.common().member_id(memberId++);
            mst_center_point_of_parking.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_center_point_of_parking.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_center_point_of_parking.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_center_point_of_parking.common().member_flags().IS_OPTIONAL(false);
            mst_center_point_of_parking.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_center_point_of_parking.common().member_flags().IS_KEY(false);
            mst_center_point_of_parking.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_center_point_of_parking.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 center_point_of_parking_hash("center_point_of_parking");
            for(int i = 0; i < 4; ++i)
            {
                mst_center_point_of_parking.detail().name_hash()[i] = center_point_of_parking_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_center_point_of_parking);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_yaw_offset;
            mst_yaw_offset.common().member_id(memberId++);
            mst_yaw_offset.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_yaw_offset.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_yaw_offset.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_yaw_offset.common().member_flags().IS_OPTIONAL(false);
            mst_yaw_offset.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_yaw_offset.common().member_flags().IS_KEY(false);
            mst_yaw_offset.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_yaw_offset.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 yaw_offset_hash("yaw_offset");
            for(int i = 0; i < 4; ++i)
            {
                mst_yaw_offset.detail().name_hash()[i] = yaw_offset_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_yaw_offset);

            MinimalStructMember mst_parking_points_in_image;
            mst_parking_points_in_image.common().member_id(memberId++);
            mst_parking_points_in_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_points_in_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_points_in_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_points_in_image.common().member_flags().IS_OPTIONAL(false);
            mst_parking_points_in_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_points_in_image.common().member_flags().IS_KEY(false);
            mst_parking_points_in_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_points_in_image.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ImageKeyPoint", 100, false));


            MD5 parking_points_in_image_hash("parking_points_in_image");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_points_in_image.detail().name_hash()[i] = parking_points_in_image_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_points_in_image);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CameraParkingInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CameraParkingInfo", false);
        }

        const TypeObject* GetCompleteCameraParkingInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CameraParkingInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_parking_space_id;
            cst_parking_space_id.common().member_id(memberId++);
            cst_parking_space_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_space_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_space_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_space_id.common().member_flags().IS_OPTIONAL(false);
            cst_parking_space_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_space_id.common().member_flags().IS_KEY(false);
            cst_parking_space_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_space_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_space_id.detail().name("parking_space_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_space_id);

            CompleteStructMember cst_parking_type;
            cst_parking_type.common().member_id(memberId++);
            cst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_type.common().member_flags().IS_OPTIONAL(false);
            cst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_type.common().member_flags().IS_KEY(false);
            cst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_type.detail().name("parking_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_type);

            CompleteStructMember cst_is_parking_enable;
            cst_is_parking_enable.common().member_id(memberId++);
            cst_is_parking_enable.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_parking_enable.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_parking_enable.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_parking_enable.common().member_flags().IS_OPTIONAL(false);
            cst_is_parking_enable.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_parking_enable.common().member_flags().IS_KEY(false);
            cst_is_parking_enable.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_parking_enable.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_parking_enable.detail().name("is_parking_enable");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_parking_enable);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_center_point_of_parking;
            cst_center_point_of_parking.common().member_id(memberId++);
            cst_center_point_of_parking.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_center_point_of_parking.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_center_point_of_parking.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_center_point_of_parking.common().member_flags().IS_OPTIONAL(false);
            cst_center_point_of_parking.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_center_point_of_parking.common().member_flags().IS_KEY(false);
            cst_center_point_of_parking.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_center_point_of_parking.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_center_point_of_parking.detail().name("center_point_of_parking");

            type_object->complete().struct_type().member_seq().emplace_back(cst_center_point_of_parking);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_yaw_offset;
            cst_yaw_offset.common().member_id(memberId++);
            cst_yaw_offset.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_yaw_offset.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_yaw_offset.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_yaw_offset.common().member_flags().IS_OPTIONAL(false);
            cst_yaw_offset.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_yaw_offset.common().member_flags().IS_KEY(false);
            cst_yaw_offset.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_yaw_offset.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_yaw_offset.detail().name("yaw_offset");

            type_object->complete().struct_type().member_seq().emplace_back(cst_yaw_offset);

            CompleteStructMember cst_parking_points_in_image;
            cst_parking_points_in_image.common().member_id(memberId++);
            cst_parking_points_in_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_points_in_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_points_in_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_points_in_image.common().member_flags().IS_OPTIONAL(false);
            cst_parking_points_in_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_points_in_image.common().member_flags().IS_KEY(false);
            cst_parking_points_in_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_points_in_image.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ImageKeyPoint", 100, true));


            cst_parking_points_in_image.detail().name("parking_points_in_image");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_points_in_image);


            // Header
            type_object->complete().struct_type().header().detail().type_name("CameraParkingInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CameraParkingInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CameraParkingInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface