// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Chassis.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Chassis.h"
#include "ChassisTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Chassis_max_cdr_typesize 1156ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Chassis_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Chassis::Chassis()
{
    // ros2_interface::msg::Header m_header

    // long m_moving_status
    m_moving_status = 0;
    // long m_driving_mode
    m_driving_mode = 0;
    // long m_steer_driving_mode
    m_steer_driving_mode = 0;
    // long m_steering_status
    m_steering_status = 0;
    // double m_front_steering_value
    m_front_steering_value = 0.0;
    // double m_rear_steering_value
    m_rear_steering_value = 0.0;
    // double m_steering_torque_nm
    m_steering_torque_nm = 0.0;
    // double m_front_steering_rate_dps
    m_front_steering_rate_dps = 0.0;
    // double m_rear_steering_rate_dps
    m_rear_steering_rate_dps = 0.0;
    // long m_accel_driving_mode
    m_accel_driving_mode = 0;
    // long m_accel_status
    m_accel_status = 0;
    // double m_accel_value
    m_accel_value = 0.0;
    // long m_brake_driving_mode
    m_brake_driving_mode = 0;
    // long m_brake_status
    m_brake_status = 0;
    // double m_brake_value
    m_brake_value = 0.0;
    // long m_brake_padel
    m_brake_padel = 0;
    // boolean m_lf_wheel_wheel_brake_status
    m_lf_wheel_wheel_brake_status = false;
    // boolean m_rf_wheel_wheel_brake_status
    m_rf_wheel_wheel_brake_status = false;
    // boolean m_lr_wheel_wheel_brake_status
    m_lr_wheel_wheel_brake_status = false;
    // boolean m_rr_wheel_wheel_brake_status
    m_rr_wheel_wheel_brake_status = false;
    // long m_backup_brake_driving_mode
    m_backup_brake_driving_mode = 0;
    // long m_backup_brake_status
    m_backup_brake_status = 0;
    // double m_backup_brake_value
    m_backup_brake_value = 0.0;
    // long m_epb_driving_mode
    m_epb_driving_mode = 0;
    // long m_epb_status
    m_epb_status = 0;
    // long m_epb_level
    m_epb_level = 0;
    // long m_gear_driving_mode
    m_gear_driving_mode = 0;
    // long m_gear_status
    m_gear_status = 0;
    // long m_gear_location
    m_gear_location = 0;
    // double m_engine_rpm
    m_engine_rpm = 0.0;
    // double m_engine_torque
    m_engine_torque = 0.0;
    // boolean m_is_speed_valid
    m_is_speed_valid = false;
    // double m_speed_mps
    m_speed_mps = 0.0;
    // boolean m_is_veh_lat_accel_valid
    m_is_veh_lat_accel_valid = false;
    // double m_veh_lat_accel
    m_veh_lat_accel = 0.0;
    // boolean m_is_veh_lon_accel_valid
    m_is_veh_lon_accel_valid = false;
    // double m_veh_lon_accel
    m_veh_lon_accel = 0.0;
    // boolean m_is_yaw_rate_valid
    m_is_yaw_rate_valid = false;
    // double m_yaw_rate
    m_yaw_rate = 0.0;
    // double m_odometer_m
    m_odometer_m = 0.0;
    // long m_daytime_running_lights_status
    m_daytime_running_lights_status = 0;
    // long m_automatic_light_control_status
    m_automatic_light_control_status = 0;
    // long m_parking_lights_status
    m_parking_lights_status = 0;
    // long m_high_beam_status
    m_high_beam_status = 0;
    // long m_low_beam_status
    m_low_beam_status = 0;
    // long m_horn_status
    m_horn_status = 0;
    // long m_turn_lamp_status
    m_turn_lamp_status = 0;
    // long m_front_wiper_status
    m_front_wiper_status = 0;
    // long m_rear_wiper_status
    m_rear_wiper_status = 0;
    // long m_position_lamp_status
    m_position_lamp_status = 0;
    // long m_front_fog_lamp_status
    m_front_fog_lamp_status = 0;
    // long m_rear_fog_lamp_status
    m_rear_fog_lamp_status = 0;
    // long m_brake_lamp_status
    m_brake_lamp_status = 0;
    // long m_alarm_lamp_status
    m_alarm_lamp_status = 0;
    // long m_lf_door_status
    m_lf_door_status = 0;
    // long m_rf_door_status
    m_rf_door_status = 0;
    // long m_lr_door_status
    m_lr_door_status = 0;
    // long m_rr_door_status
    m_rr_door_status = 0;
    // long m_rearview_mirror_status
    m_rearview_mirror_status = 0;
    // long m_trunk_status
    m_trunk_status = 0;
    // long m_engine_bay_door_status
    m_engine_bay_door_status = 0;
    // long m_wheel_direction_rr
    m_wheel_direction_rr = 0;
    // double m_wheel_spd_rr
    m_wheel_spd_rr = 0.0;
    // long m_wheel_direction_rl
    m_wheel_direction_rl = 0;
    // double m_wheel_spd_rl
    m_wheel_spd_rl = 0.0;
    // long m_wheel_direction_fr
    m_wheel_direction_fr = 0;
    // double m_wheel_spd_fr
    m_wheel_spd_fr = 0.0;
    // long m_wheel_direction_fl
    m_wheel_direction_fl = 0;
    // double m_wheel_spd_fl
    m_wheel_spd_fl = 0.0;
    // boolean m_is_wss_rr_edges_sum_valid
    m_is_wss_rr_edges_sum_valid = false;
    // long m_wss_rr_edges_sum
    m_wss_rr_edges_sum = 0;
    // boolean m_is_wss_rl_edges_sum_valid
    m_is_wss_rl_edges_sum_valid = false;
    // long m_wss_rl_edges_sum
    m_wss_rl_edges_sum = 0;
    // boolean m_is_wss_fr_edges_sum_valid
    m_is_wss_fr_edges_sum_valid = false;
    // long m_wss_fr_edges_sum
    m_wss_fr_edges_sum = 0;
    // boolean m_is_wss_fl_edges_sum_valid
    m_is_wss_fl_edges_sum_valid = false;
    // long m_wss_fl_edges_sum
    m_wss_fl_edges_sum = 0;
    // long m_is_tire_pressure_ok
    m_is_tire_pressure_ok = 0;
    // long m_is_tire_pressure_lf_valid
    m_is_tire_pressure_lf_valid = 0;
    // double m_tire_pressure_lf
    m_tire_pressure_lf = 0.0;
    // long m_is_tire_pressure_rf_valid
    m_is_tire_pressure_rf_valid = 0;
    // double m_tire_pressure_rf
    m_tire_pressure_rf = 0.0;
    // long m_is_tire_pressure_lr_valid
    m_is_tire_pressure_lr_valid = 0;
    // double m_tire_pressure_lr
    m_tire_pressure_lr = 0.0;
    // long m_is_tire_pressure_rr_valid
    m_is_tire_pressure_rr_valid = 0;
    // double m_tire_pressure_rr
    m_tire_pressure_rr = 0.0;
    // long m_air_bag_status
    m_air_bag_status = 0;
    // long m_charging_gun_status
    m_charging_gun_status = 0;
    // long m_charge
    m_charge = 0;
    // long m_vehicle_power_status
    m_vehicle_power_status = 0;
    // sequence<long> m_chassis_error_code


    // Just to register all known types
    registerChassisTypes();
}

ros2_interface::msg::Chassis::~Chassis()
{




























































































}

ros2_interface::msg::Chassis::Chassis(
        const Chassis& x)
{
    m_header = x.m_header;
    m_moving_status = x.m_moving_status;
    m_driving_mode = x.m_driving_mode;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_status = x.m_steering_status;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_front_steering_rate_dps = x.m_front_steering_rate_dps;
    m_rear_steering_rate_dps = x.m_rear_steering_rate_dps;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_status = x.m_accel_status;
    m_accel_value = x.m_accel_value;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_status = x.m_brake_status;
    m_brake_value = x.m_brake_value;
    m_brake_padel = x.m_brake_padel;
    m_lf_wheel_wheel_brake_status = x.m_lf_wheel_wheel_brake_status;
    m_rf_wheel_wheel_brake_status = x.m_rf_wheel_wheel_brake_status;
    m_lr_wheel_wheel_brake_status = x.m_lr_wheel_wheel_brake_status;
    m_rr_wheel_wheel_brake_status = x.m_rr_wheel_wheel_brake_status;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_status = x.m_backup_brake_status;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_status = x.m_epb_status;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_gear_status = x.m_gear_status;
    m_gear_location = x.m_gear_location;
    m_engine_rpm = x.m_engine_rpm;
    m_engine_torque = x.m_engine_torque;
    m_is_speed_valid = x.m_is_speed_valid;
    m_speed_mps = x.m_speed_mps;
    m_is_veh_lat_accel_valid = x.m_is_veh_lat_accel_valid;
    m_veh_lat_accel = x.m_veh_lat_accel;
    m_is_veh_lon_accel_valid = x.m_is_veh_lon_accel_valid;
    m_veh_lon_accel = x.m_veh_lon_accel;
    m_is_yaw_rate_valid = x.m_is_yaw_rate_valid;
    m_yaw_rate = x.m_yaw_rate;
    m_odometer_m = x.m_odometer_m;
    m_daytime_running_lights_status = x.m_daytime_running_lights_status;
    m_automatic_light_control_status = x.m_automatic_light_control_status;
    m_parking_lights_status = x.m_parking_lights_status;
    m_high_beam_status = x.m_high_beam_status;
    m_low_beam_status = x.m_low_beam_status;
    m_horn_status = x.m_horn_status;
    m_turn_lamp_status = x.m_turn_lamp_status;
    m_front_wiper_status = x.m_front_wiper_status;
    m_rear_wiper_status = x.m_rear_wiper_status;
    m_position_lamp_status = x.m_position_lamp_status;
    m_front_fog_lamp_status = x.m_front_fog_lamp_status;
    m_rear_fog_lamp_status = x.m_rear_fog_lamp_status;
    m_brake_lamp_status = x.m_brake_lamp_status;
    m_alarm_lamp_status = x.m_alarm_lamp_status;
    m_lf_door_status = x.m_lf_door_status;
    m_rf_door_status = x.m_rf_door_status;
    m_lr_door_status = x.m_lr_door_status;
    m_rr_door_status = x.m_rr_door_status;
    m_rearview_mirror_status = x.m_rearview_mirror_status;
    m_trunk_status = x.m_trunk_status;
    m_engine_bay_door_status = x.m_engine_bay_door_status;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_is_wss_rr_edges_sum_valid = x.m_is_wss_rr_edges_sum_valid;
    m_wss_rr_edges_sum = x.m_wss_rr_edges_sum;
    m_is_wss_rl_edges_sum_valid = x.m_is_wss_rl_edges_sum_valid;
    m_wss_rl_edges_sum = x.m_wss_rl_edges_sum;
    m_is_wss_fr_edges_sum_valid = x.m_is_wss_fr_edges_sum_valid;
    m_wss_fr_edges_sum = x.m_wss_fr_edges_sum;
    m_is_wss_fl_edges_sum_valid = x.m_is_wss_fl_edges_sum_valid;
    m_wss_fl_edges_sum = x.m_wss_fl_edges_sum;
    m_is_tire_pressure_ok = x.m_is_tire_pressure_ok;
    m_is_tire_pressure_lf_valid = x.m_is_tire_pressure_lf_valid;
    m_tire_pressure_lf = x.m_tire_pressure_lf;
    m_is_tire_pressure_rf_valid = x.m_is_tire_pressure_rf_valid;
    m_tire_pressure_rf = x.m_tire_pressure_rf;
    m_is_tire_pressure_lr_valid = x.m_is_tire_pressure_lr_valid;
    m_tire_pressure_lr = x.m_tire_pressure_lr;
    m_is_tire_pressure_rr_valid = x.m_is_tire_pressure_rr_valid;
    m_tire_pressure_rr = x.m_tire_pressure_rr;
    m_air_bag_status = x.m_air_bag_status;
    m_charging_gun_status = x.m_charging_gun_status;
    m_charge = x.m_charge;
    m_vehicle_power_status = x.m_vehicle_power_status;
    m_chassis_error_code = x.m_chassis_error_code;
}

ros2_interface::msg::Chassis::Chassis(
        Chassis&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_moving_status = x.m_moving_status;
    m_driving_mode = x.m_driving_mode;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_status = x.m_steering_status;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_front_steering_rate_dps = x.m_front_steering_rate_dps;
    m_rear_steering_rate_dps = x.m_rear_steering_rate_dps;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_status = x.m_accel_status;
    m_accel_value = x.m_accel_value;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_status = x.m_brake_status;
    m_brake_value = x.m_brake_value;
    m_brake_padel = x.m_brake_padel;
    m_lf_wheel_wheel_brake_status = x.m_lf_wheel_wheel_brake_status;
    m_rf_wheel_wheel_brake_status = x.m_rf_wheel_wheel_brake_status;
    m_lr_wheel_wheel_brake_status = x.m_lr_wheel_wheel_brake_status;
    m_rr_wheel_wheel_brake_status = x.m_rr_wheel_wheel_brake_status;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_status = x.m_backup_brake_status;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_status = x.m_epb_status;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_gear_status = x.m_gear_status;
    m_gear_location = x.m_gear_location;
    m_engine_rpm = x.m_engine_rpm;
    m_engine_torque = x.m_engine_torque;
    m_is_speed_valid = x.m_is_speed_valid;
    m_speed_mps = x.m_speed_mps;
    m_is_veh_lat_accel_valid = x.m_is_veh_lat_accel_valid;
    m_veh_lat_accel = x.m_veh_lat_accel;
    m_is_veh_lon_accel_valid = x.m_is_veh_lon_accel_valid;
    m_veh_lon_accel = x.m_veh_lon_accel;
    m_is_yaw_rate_valid = x.m_is_yaw_rate_valid;
    m_yaw_rate = x.m_yaw_rate;
    m_odometer_m = x.m_odometer_m;
    m_daytime_running_lights_status = x.m_daytime_running_lights_status;
    m_automatic_light_control_status = x.m_automatic_light_control_status;
    m_parking_lights_status = x.m_parking_lights_status;
    m_high_beam_status = x.m_high_beam_status;
    m_low_beam_status = x.m_low_beam_status;
    m_horn_status = x.m_horn_status;
    m_turn_lamp_status = x.m_turn_lamp_status;
    m_front_wiper_status = x.m_front_wiper_status;
    m_rear_wiper_status = x.m_rear_wiper_status;
    m_position_lamp_status = x.m_position_lamp_status;
    m_front_fog_lamp_status = x.m_front_fog_lamp_status;
    m_rear_fog_lamp_status = x.m_rear_fog_lamp_status;
    m_brake_lamp_status = x.m_brake_lamp_status;
    m_alarm_lamp_status = x.m_alarm_lamp_status;
    m_lf_door_status = x.m_lf_door_status;
    m_rf_door_status = x.m_rf_door_status;
    m_lr_door_status = x.m_lr_door_status;
    m_rr_door_status = x.m_rr_door_status;
    m_rearview_mirror_status = x.m_rearview_mirror_status;
    m_trunk_status = x.m_trunk_status;
    m_engine_bay_door_status = x.m_engine_bay_door_status;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_is_wss_rr_edges_sum_valid = x.m_is_wss_rr_edges_sum_valid;
    m_wss_rr_edges_sum = x.m_wss_rr_edges_sum;
    m_is_wss_rl_edges_sum_valid = x.m_is_wss_rl_edges_sum_valid;
    m_wss_rl_edges_sum = x.m_wss_rl_edges_sum;
    m_is_wss_fr_edges_sum_valid = x.m_is_wss_fr_edges_sum_valid;
    m_wss_fr_edges_sum = x.m_wss_fr_edges_sum;
    m_is_wss_fl_edges_sum_valid = x.m_is_wss_fl_edges_sum_valid;
    m_wss_fl_edges_sum = x.m_wss_fl_edges_sum;
    m_is_tire_pressure_ok = x.m_is_tire_pressure_ok;
    m_is_tire_pressure_lf_valid = x.m_is_tire_pressure_lf_valid;
    m_tire_pressure_lf = x.m_tire_pressure_lf;
    m_is_tire_pressure_rf_valid = x.m_is_tire_pressure_rf_valid;
    m_tire_pressure_rf = x.m_tire_pressure_rf;
    m_is_tire_pressure_lr_valid = x.m_is_tire_pressure_lr_valid;
    m_tire_pressure_lr = x.m_tire_pressure_lr;
    m_is_tire_pressure_rr_valid = x.m_is_tire_pressure_rr_valid;
    m_tire_pressure_rr = x.m_tire_pressure_rr;
    m_air_bag_status = x.m_air_bag_status;
    m_charging_gun_status = x.m_charging_gun_status;
    m_charge = x.m_charge;
    m_vehicle_power_status = x.m_vehicle_power_status;
    m_chassis_error_code = std::move(x.m_chassis_error_code);
}

ros2_interface::msg::Chassis& ros2_interface::msg::Chassis::operator =(
        const Chassis& x)
{

    m_header = x.m_header;
    m_moving_status = x.m_moving_status;
    m_driving_mode = x.m_driving_mode;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_status = x.m_steering_status;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_front_steering_rate_dps = x.m_front_steering_rate_dps;
    m_rear_steering_rate_dps = x.m_rear_steering_rate_dps;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_status = x.m_accel_status;
    m_accel_value = x.m_accel_value;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_status = x.m_brake_status;
    m_brake_value = x.m_brake_value;
    m_brake_padel = x.m_brake_padel;
    m_lf_wheel_wheel_brake_status = x.m_lf_wheel_wheel_brake_status;
    m_rf_wheel_wheel_brake_status = x.m_rf_wheel_wheel_brake_status;
    m_lr_wheel_wheel_brake_status = x.m_lr_wheel_wheel_brake_status;
    m_rr_wheel_wheel_brake_status = x.m_rr_wheel_wheel_brake_status;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_status = x.m_backup_brake_status;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_status = x.m_epb_status;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_gear_status = x.m_gear_status;
    m_gear_location = x.m_gear_location;
    m_engine_rpm = x.m_engine_rpm;
    m_engine_torque = x.m_engine_torque;
    m_is_speed_valid = x.m_is_speed_valid;
    m_speed_mps = x.m_speed_mps;
    m_is_veh_lat_accel_valid = x.m_is_veh_lat_accel_valid;
    m_veh_lat_accel = x.m_veh_lat_accel;
    m_is_veh_lon_accel_valid = x.m_is_veh_lon_accel_valid;
    m_veh_lon_accel = x.m_veh_lon_accel;
    m_is_yaw_rate_valid = x.m_is_yaw_rate_valid;
    m_yaw_rate = x.m_yaw_rate;
    m_odometer_m = x.m_odometer_m;
    m_daytime_running_lights_status = x.m_daytime_running_lights_status;
    m_automatic_light_control_status = x.m_automatic_light_control_status;
    m_parking_lights_status = x.m_parking_lights_status;
    m_high_beam_status = x.m_high_beam_status;
    m_low_beam_status = x.m_low_beam_status;
    m_horn_status = x.m_horn_status;
    m_turn_lamp_status = x.m_turn_lamp_status;
    m_front_wiper_status = x.m_front_wiper_status;
    m_rear_wiper_status = x.m_rear_wiper_status;
    m_position_lamp_status = x.m_position_lamp_status;
    m_front_fog_lamp_status = x.m_front_fog_lamp_status;
    m_rear_fog_lamp_status = x.m_rear_fog_lamp_status;
    m_brake_lamp_status = x.m_brake_lamp_status;
    m_alarm_lamp_status = x.m_alarm_lamp_status;
    m_lf_door_status = x.m_lf_door_status;
    m_rf_door_status = x.m_rf_door_status;
    m_lr_door_status = x.m_lr_door_status;
    m_rr_door_status = x.m_rr_door_status;
    m_rearview_mirror_status = x.m_rearview_mirror_status;
    m_trunk_status = x.m_trunk_status;
    m_engine_bay_door_status = x.m_engine_bay_door_status;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_is_wss_rr_edges_sum_valid = x.m_is_wss_rr_edges_sum_valid;
    m_wss_rr_edges_sum = x.m_wss_rr_edges_sum;
    m_is_wss_rl_edges_sum_valid = x.m_is_wss_rl_edges_sum_valid;
    m_wss_rl_edges_sum = x.m_wss_rl_edges_sum;
    m_is_wss_fr_edges_sum_valid = x.m_is_wss_fr_edges_sum_valid;
    m_wss_fr_edges_sum = x.m_wss_fr_edges_sum;
    m_is_wss_fl_edges_sum_valid = x.m_is_wss_fl_edges_sum_valid;
    m_wss_fl_edges_sum = x.m_wss_fl_edges_sum;
    m_is_tire_pressure_ok = x.m_is_tire_pressure_ok;
    m_is_tire_pressure_lf_valid = x.m_is_tire_pressure_lf_valid;
    m_tire_pressure_lf = x.m_tire_pressure_lf;
    m_is_tire_pressure_rf_valid = x.m_is_tire_pressure_rf_valid;
    m_tire_pressure_rf = x.m_tire_pressure_rf;
    m_is_tire_pressure_lr_valid = x.m_is_tire_pressure_lr_valid;
    m_tire_pressure_lr = x.m_tire_pressure_lr;
    m_is_tire_pressure_rr_valid = x.m_is_tire_pressure_rr_valid;
    m_tire_pressure_rr = x.m_tire_pressure_rr;
    m_air_bag_status = x.m_air_bag_status;
    m_charging_gun_status = x.m_charging_gun_status;
    m_charge = x.m_charge;
    m_vehicle_power_status = x.m_vehicle_power_status;
    m_chassis_error_code = x.m_chassis_error_code;

    return *this;
}

ros2_interface::msg::Chassis& ros2_interface::msg::Chassis::operator =(
        Chassis&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_moving_status = x.m_moving_status;
    m_driving_mode = x.m_driving_mode;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_status = x.m_steering_status;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_front_steering_rate_dps = x.m_front_steering_rate_dps;
    m_rear_steering_rate_dps = x.m_rear_steering_rate_dps;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_status = x.m_accel_status;
    m_accel_value = x.m_accel_value;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_status = x.m_brake_status;
    m_brake_value = x.m_brake_value;
    m_brake_padel = x.m_brake_padel;
    m_lf_wheel_wheel_brake_status = x.m_lf_wheel_wheel_brake_status;
    m_rf_wheel_wheel_brake_status = x.m_rf_wheel_wheel_brake_status;
    m_lr_wheel_wheel_brake_status = x.m_lr_wheel_wheel_brake_status;
    m_rr_wheel_wheel_brake_status = x.m_rr_wheel_wheel_brake_status;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_status = x.m_backup_brake_status;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_status = x.m_epb_status;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_gear_status = x.m_gear_status;
    m_gear_location = x.m_gear_location;
    m_engine_rpm = x.m_engine_rpm;
    m_engine_torque = x.m_engine_torque;
    m_is_speed_valid = x.m_is_speed_valid;
    m_speed_mps = x.m_speed_mps;
    m_is_veh_lat_accel_valid = x.m_is_veh_lat_accel_valid;
    m_veh_lat_accel = x.m_veh_lat_accel;
    m_is_veh_lon_accel_valid = x.m_is_veh_lon_accel_valid;
    m_veh_lon_accel = x.m_veh_lon_accel;
    m_is_yaw_rate_valid = x.m_is_yaw_rate_valid;
    m_yaw_rate = x.m_yaw_rate;
    m_odometer_m = x.m_odometer_m;
    m_daytime_running_lights_status = x.m_daytime_running_lights_status;
    m_automatic_light_control_status = x.m_automatic_light_control_status;
    m_parking_lights_status = x.m_parking_lights_status;
    m_high_beam_status = x.m_high_beam_status;
    m_low_beam_status = x.m_low_beam_status;
    m_horn_status = x.m_horn_status;
    m_turn_lamp_status = x.m_turn_lamp_status;
    m_front_wiper_status = x.m_front_wiper_status;
    m_rear_wiper_status = x.m_rear_wiper_status;
    m_position_lamp_status = x.m_position_lamp_status;
    m_front_fog_lamp_status = x.m_front_fog_lamp_status;
    m_rear_fog_lamp_status = x.m_rear_fog_lamp_status;
    m_brake_lamp_status = x.m_brake_lamp_status;
    m_alarm_lamp_status = x.m_alarm_lamp_status;
    m_lf_door_status = x.m_lf_door_status;
    m_rf_door_status = x.m_rf_door_status;
    m_lr_door_status = x.m_lr_door_status;
    m_rr_door_status = x.m_rr_door_status;
    m_rearview_mirror_status = x.m_rearview_mirror_status;
    m_trunk_status = x.m_trunk_status;
    m_engine_bay_door_status = x.m_engine_bay_door_status;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_is_wss_rr_edges_sum_valid = x.m_is_wss_rr_edges_sum_valid;
    m_wss_rr_edges_sum = x.m_wss_rr_edges_sum;
    m_is_wss_rl_edges_sum_valid = x.m_is_wss_rl_edges_sum_valid;
    m_wss_rl_edges_sum = x.m_wss_rl_edges_sum;
    m_is_wss_fr_edges_sum_valid = x.m_is_wss_fr_edges_sum_valid;
    m_wss_fr_edges_sum = x.m_wss_fr_edges_sum;
    m_is_wss_fl_edges_sum_valid = x.m_is_wss_fl_edges_sum_valid;
    m_wss_fl_edges_sum = x.m_wss_fl_edges_sum;
    m_is_tire_pressure_ok = x.m_is_tire_pressure_ok;
    m_is_tire_pressure_lf_valid = x.m_is_tire_pressure_lf_valid;
    m_tire_pressure_lf = x.m_tire_pressure_lf;
    m_is_tire_pressure_rf_valid = x.m_is_tire_pressure_rf_valid;
    m_tire_pressure_rf = x.m_tire_pressure_rf;
    m_is_tire_pressure_lr_valid = x.m_is_tire_pressure_lr_valid;
    m_tire_pressure_lr = x.m_tire_pressure_lr;
    m_is_tire_pressure_rr_valid = x.m_is_tire_pressure_rr_valid;
    m_tire_pressure_rr = x.m_tire_pressure_rr;
    m_air_bag_status = x.m_air_bag_status;
    m_charging_gun_status = x.m_charging_gun_status;
    m_charge = x.m_charge;
    m_vehicle_power_status = x.m_vehicle_power_status;
    m_chassis_error_code = std::move(x.m_chassis_error_code);

    return *this;
}

bool ros2_interface::msg::Chassis::operator ==(
        const Chassis& x) const
{

    return (m_header == x.m_header && m_moving_status == x.m_moving_status && m_driving_mode == x.m_driving_mode && m_steer_driving_mode == x.m_steer_driving_mode && m_steering_status == x.m_steering_status && m_front_steering_value == x.m_front_steering_value && m_rear_steering_value == x.m_rear_steering_value && m_steering_torque_nm == x.m_steering_torque_nm && m_front_steering_rate_dps == x.m_front_steering_rate_dps && m_rear_steering_rate_dps == x.m_rear_steering_rate_dps && m_accel_driving_mode == x.m_accel_driving_mode && m_accel_status == x.m_accel_status && m_accel_value == x.m_accel_value && m_brake_driving_mode == x.m_brake_driving_mode && m_brake_status == x.m_brake_status && m_brake_value == x.m_brake_value && m_brake_padel == x.m_brake_padel && m_lf_wheel_wheel_brake_status == x.m_lf_wheel_wheel_brake_status && m_rf_wheel_wheel_brake_status == x.m_rf_wheel_wheel_brake_status && m_lr_wheel_wheel_brake_status == x.m_lr_wheel_wheel_brake_status && m_rr_wheel_wheel_brake_status == x.m_rr_wheel_wheel_brake_status && m_backup_brake_driving_mode == x.m_backup_brake_driving_mode && m_backup_brake_status == x.m_backup_brake_status && m_backup_brake_value == x.m_backup_brake_value && m_epb_driving_mode == x.m_epb_driving_mode && m_epb_status == x.m_epb_status && m_epb_level == x.m_epb_level && m_gear_driving_mode == x.m_gear_driving_mode && m_gear_status == x.m_gear_status && m_gear_location == x.m_gear_location && m_engine_rpm == x.m_engine_rpm && m_engine_torque == x.m_engine_torque && m_is_speed_valid == x.m_is_speed_valid && m_speed_mps == x.m_speed_mps && m_is_veh_lat_accel_valid == x.m_is_veh_lat_accel_valid && m_veh_lat_accel == x.m_veh_lat_accel && m_is_veh_lon_accel_valid == x.m_is_veh_lon_accel_valid && m_veh_lon_accel == x.m_veh_lon_accel && m_is_yaw_rate_valid == x.m_is_yaw_rate_valid && m_yaw_rate == x.m_yaw_rate && m_odometer_m == x.m_odometer_m && m_daytime_running_lights_status == x.m_daytime_running_lights_status && m_automatic_light_control_status == x.m_automatic_light_control_status && m_parking_lights_status == x.m_parking_lights_status && m_high_beam_status == x.m_high_beam_status && m_low_beam_status == x.m_low_beam_status && m_horn_status == x.m_horn_status && m_turn_lamp_status == x.m_turn_lamp_status && m_front_wiper_status == x.m_front_wiper_status && m_rear_wiper_status == x.m_rear_wiper_status && m_position_lamp_status == x.m_position_lamp_status && m_front_fog_lamp_status == x.m_front_fog_lamp_status && m_rear_fog_lamp_status == x.m_rear_fog_lamp_status && m_brake_lamp_status == x.m_brake_lamp_status && m_alarm_lamp_status == x.m_alarm_lamp_status && m_lf_door_status == x.m_lf_door_status && m_rf_door_status == x.m_rf_door_status && m_lr_door_status == x.m_lr_door_status && m_rr_door_status == x.m_rr_door_status && m_rearview_mirror_status == x.m_rearview_mirror_status && m_trunk_status == x.m_trunk_status && m_engine_bay_door_status == x.m_engine_bay_door_status && m_wheel_direction_rr == x.m_wheel_direction_rr && m_wheel_spd_rr == x.m_wheel_spd_rr && m_wheel_direction_rl == x.m_wheel_direction_rl && m_wheel_spd_rl == x.m_wheel_spd_rl && m_wheel_direction_fr == x.m_wheel_direction_fr && m_wheel_spd_fr == x.m_wheel_spd_fr && m_wheel_direction_fl == x.m_wheel_direction_fl && m_wheel_spd_fl == x.m_wheel_spd_fl && m_is_wss_rr_edges_sum_valid == x.m_is_wss_rr_edges_sum_valid && m_wss_rr_edges_sum == x.m_wss_rr_edges_sum && m_is_wss_rl_edges_sum_valid == x.m_is_wss_rl_edges_sum_valid && m_wss_rl_edges_sum == x.m_wss_rl_edges_sum && m_is_wss_fr_edges_sum_valid == x.m_is_wss_fr_edges_sum_valid && m_wss_fr_edges_sum == x.m_wss_fr_edges_sum && m_is_wss_fl_edges_sum_valid == x.m_is_wss_fl_edges_sum_valid && m_wss_fl_edges_sum == x.m_wss_fl_edges_sum && m_is_tire_pressure_ok == x.m_is_tire_pressure_ok && m_is_tire_pressure_lf_valid == x.m_is_tire_pressure_lf_valid && m_tire_pressure_lf == x.m_tire_pressure_lf && m_is_tire_pressure_rf_valid == x.m_is_tire_pressure_rf_valid && m_tire_pressure_rf == x.m_tire_pressure_rf && m_is_tire_pressure_lr_valid == x.m_is_tire_pressure_lr_valid && m_tire_pressure_lr == x.m_tire_pressure_lr && m_is_tire_pressure_rr_valid == x.m_is_tire_pressure_rr_valid && m_tire_pressure_rr == x.m_tire_pressure_rr && m_air_bag_status == x.m_air_bag_status && m_charging_gun_status == x.m_charging_gun_status && m_charge == x.m_charge && m_vehicle_power_status == x.m_vehicle_power_status && m_chassis_error_code == x.m_chassis_error_code);
}

bool ros2_interface::msg::Chassis::operator !=(
        const Chassis& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Chassis::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Chassis_max_cdr_typesize;
}

size_t ros2_interface::msg::Chassis::getCdrSerializedSize(
        const ros2_interface::msg::Chassis& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.chassis_error_code().size() > 0)
    {
        current_alignment += (data.chassis_error_code().size() * 4) + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);
    }




    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Chassis::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_moving_status;
    scdr << m_driving_mode;
    scdr << m_steer_driving_mode;
    scdr << m_steering_status;
    scdr << m_front_steering_value;
    scdr << m_rear_steering_value;
    scdr << m_steering_torque_nm;
    scdr << m_front_steering_rate_dps;
    scdr << m_rear_steering_rate_dps;
    scdr << m_accel_driving_mode;
    scdr << m_accel_status;
    scdr << m_accel_value;
    scdr << m_brake_driving_mode;
    scdr << m_brake_status;
    scdr << m_brake_value;
    scdr << m_brake_padel;
    scdr << m_lf_wheel_wheel_brake_status;
    scdr << m_rf_wheel_wheel_brake_status;
    scdr << m_lr_wheel_wheel_brake_status;
    scdr << m_rr_wheel_wheel_brake_status;
    scdr << m_backup_brake_driving_mode;
    scdr << m_backup_brake_status;
    scdr << m_backup_brake_value;
    scdr << m_epb_driving_mode;
    scdr << m_epb_status;
    scdr << m_epb_level;
    scdr << m_gear_driving_mode;
    scdr << m_gear_status;
    scdr << m_gear_location;
    scdr << m_engine_rpm;
    scdr << m_engine_torque;
    scdr << m_is_speed_valid;
    scdr << m_speed_mps;
    scdr << m_is_veh_lat_accel_valid;
    scdr << m_veh_lat_accel;
    scdr << m_is_veh_lon_accel_valid;
    scdr << m_veh_lon_accel;
    scdr << m_is_yaw_rate_valid;
    scdr << m_yaw_rate;
    scdr << m_odometer_m;
    scdr << m_daytime_running_lights_status;
    scdr << m_automatic_light_control_status;
    scdr << m_parking_lights_status;
    scdr << m_high_beam_status;
    scdr << m_low_beam_status;
    scdr << m_horn_status;
    scdr << m_turn_lamp_status;
    scdr << m_front_wiper_status;
    scdr << m_rear_wiper_status;
    scdr << m_position_lamp_status;
    scdr << m_front_fog_lamp_status;
    scdr << m_rear_fog_lamp_status;
    scdr << m_brake_lamp_status;
    scdr << m_alarm_lamp_status;
    scdr << m_lf_door_status;
    scdr << m_rf_door_status;
    scdr << m_lr_door_status;
    scdr << m_rr_door_status;
    scdr << m_rearview_mirror_status;
    scdr << m_trunk_status;
    scdr << m_engine_bay_door_status;
    scdr << m_wheel_direction_rr;
    scdr << m_wheel_spd_rr;
    scdr << m_wheel_direction_rl;
    scdr << m_wheel_spd_rl;
    scdr << m_wheel_direction_fr;
    scdr << m_wheel_spd_fr;
    scdr << m_wheel_direction_fl;
    scdr << m_wheel_spd_fl;
    scdr << m_is_wss_rr_edges_sum_valid;
    scdr << m_wss_rr_edges_sum;
    scdr << m_is_wss_rl_edges_sum_valid;
    scdr << m_wss_rl_edges_sum;
    scdr << m_is_wss_fr_edges_sum_valid;
    scdr << m_wss_fr_edges_sum;
    scdr << m_is_wss_fl_edges_sum_valid;
    scdr << m_wss_fl_edges_sum;
    scdr << m_is_tire_pressure_ok;
    scdr << m_is_tire_pressure_lf_valid;
    scdr << m_tire_pressure_lf;
    scdr << m_is_tire_pressure_rf_valid;
    scdr << m_tire_pressure_rf;
    scdr << m_is_tire_pressure_lr_valid;
    scdr << m_tire_pressure_lr;
    scdr << m_is_tire_pressure_rr_valid;
    scdr << m_tire_pressure_rr;
    scdr << m_air_bag_status;
    scdr << m_charging_gun_status;
    scdr << m_charge;
    scdr << m_vehicle_power_status;
    scdr << m_chassis_error_code;

}

void ros2_interface::msg::Chassis::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_moving_status;
    dcdr >> m_driving_mode;
    dcdr >> m_steer_driving_mode;
    dcdr >> m_steering_status;
    dcdr >> m_front_steering_value;
    dcdr >> m_rear_steering_value;
    dcdr >> m_steering_torque_nm;
    dcdr >> m_front_steering_rate_dps;
    dcdr >> m_rear_steering_rate_dps;
    dcdr >> m_accel_driving_mode;
    dcdr >> m_accel_status;
    dcdr >> m_accel_value;
    dcdr >> m_brake_driving_mode;
    dcdr >> m_brake_status;
    dcdr >> m_brake_value;
    dcdr >> m_brake_padel;
    dcdr >> m_lf_wheel_wheel_brake_status;
    dcdr >> m_rf_wheel_wheel_brake_status;
    dcdr >> m_lr_wheel_wheel_brake_status;
    dcdr >> m_rr_wheel_wheel_brake_status;
    dcdr >> m_backup_brake_driving_mode;
    dcdr >> m_backup_brake_status;
    dcdr >> m_backup_brake_value;
    dcdr >> m_epb_driving_mode;
    dcdr >> m_epb_status;
    dcdr >> m_epb_level;
    dcdr >> m_gear_driving_mode;
    dcdr >> m_gear_status;
    dcdr >> m_gear_location;
    dcdr >> m_engine_rpm;
    dcdr >> m_engine_torque;
    dcdr >> m_is_speed_valid;
    dcdr >> m_speed_mps;
    dcdr >> m_is_veh_lat_accel_valid;
    dcdr >> m_veh_lat_accel;
    dcdr >> m_is_veh_lon_accel_valid;
    dcdr >> m_veh_lon_accel;
    dcdr >> m_is_yaw_rate_valid;
    dcdr >> m_yaw_rate;
    dcdr >> m_odometer_m;
    dcdr >> m_daytime_running_lights_status;
    dcdr >> m_automatic_light_control_status;
    dcdr >> m_parking_lights_status;
    dcdr >> m_high_beam_status;
    dcdr >> m_low_beam_status;
    dcdr >> m_horn_status;
    dcdr >> m_turn_lamp_status;
    dcdr >> m_front_wiper_status;
    dcdr >> m_rear_wiper_status;
    dcdr >> m_position_lamp_status;
    dcdr >> m_front_fog_lamp_status;
    dcdr >> m_rear_fog_lamp_status;
    dcdr >> m_brake_lamp_status;
    dcdr >> m_alarm_lamp_status;
    dcdr >> m_lf_door_status;
    dcdr >> m_rf_door_status;
    dcdr >> m_lr_door_status;
    dcdr >> m_rr_door_status;
    dcdr >> m_rearview_mirror_status;
    dcdr >> m_trunk_status;
    dcdr >> m_engine_bay_door_status;
    dcdr >> m_wheel_direction_rr;
    dcdr >> m_wheel_spd_rr;
    dcdr >> m_wheel_direction_rl;
    dcdr >> m_wheel_spd_rl;
    dcdr >> m_wheel_direction_fr;
    dcdr >> m_wheel_spd_fr;
    dcdr >> m_wheel_direction_fl;
    dcdr >> m_wheel_spd_fl;
    dcdr >> m_is_wss_rr_edges_sum_valid;
    dcdr >> m_wss_rr_edges_sum;
    dcdr >> m_is_wss_rl_edges_sum_valid;
    dcdr >> m_wss_rl_edges_sum;
    dcdr >> m_is_wss_fr_edges_sum_valid;
    dcdr >> m_wss_fr_edges_sum;
    dcdr >> m_is_wss_fl_edges_sum_valid;
    dcdr >> m_wss_fl_edges_sum;
    dcdr >> m_is_tire_pressure_ok;
    dcdr >> m_is_tire_pressure_lf_valid;
    dcdr >> m_tire_pressure_lf;
    dcdr >> m_is_tire_pressure_rf_valid;
    dcdr >> m_tire_pressure_rf;
    dcdr >> m_is_tire_pressure_lr_valid;
    dcdr >> m_tire_pressure_lr;
    dcdr >> m_is_tire_pressure_rr_valid;
    dcdr >> m_tire_pressure_rr;
    dcdr >> m_air_bag_status;
    dcdr >> m_charging_gun_status;
    dcdr >> m_charge;
    dcdr >> m_vehicle_power_status;
    dcdr >> m_chassis_error_code;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Chassis::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Chassis::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Chassis::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Chassis::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member moving_status
 * @param _moving_status New value for member moving_status
 */
void ros2_interface::msg::Chassis::moving_status(
        int32_t _moving_status)
{
    m_moving_status = _moving_status;
}

/*!
 * @brief This function returns the value of member moving_status
 * @return Value of member moving_status
 */
int32_t ros2_interface::msg::Chassis::moving_status() const
{
    return m_moving_status;
}

/*!
 * @brief This function returns a reference to member moving_status
 * @return Reference to member moving_status
 */
int32_t& ros2_interface::msg::Chassis::moving_status()
{
    return m_moving_status;
}

/*!
 * @brief This function sets a value in member driving_mode
 * @param _driving_mode New value for member driving_mode
 */
void ros2_interface::msg::Chassis::driving_mode(
        int32_t _driving_mode)
{
    m_driving_mode = _driving_mode;
}

/*!
 * @brief This function returns the value of member driving_mode
 * @return Value of member driving_mode
 */
int32_t ros2_interface::msg::Chassis::driving_mode() const
{
    return m_driving_mode;
}

/*!
 * @brief This function returns a reference to member driving_mode
 * @return Reference to member driving_mode
 */
int32_t& ros2_interface::msg::Chassis::driving_mode()
{
    return m_driving_mode;
}

/*!
 * @brief This function sets a value in member steer_driving_mode
 * @param _steer_driving_mode New value for member steer_driving_mode
 */
void ros2_interface::msg::Chassis::steer_driving_mode(
        int32_t _steer_driving_mode)
{
    m_steer_driving_mode = _steer_driving_mode;
}

/*!
 * @brief This function returns the value of member steer_driving_mode
 * @return Value of member steer_driving_mode
 */
int32_t ros2_interface::msg::Chassis::steer_driving_mode() const
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function returns a reference to member steer_driving_mode
 * @return Reference to member steer_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::steer_driving_mode()
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function sets a value in member steering_status
 * @param _steering_status New value for member steering_status
 */
void ros2_interface::msg::Chassis::steering_status(
        int32_t _steering_status)
{
    m_steering_status = _steering_status;
}

/*!
 * @brief This function returns the value of member steering_status
 * @return Value of member steering_status
 */
int32_t ros2_interface::msg::Chassis::steering_status() const
{
    return m_steering_status;
}

/*!
 * @brief This function returns a reference to member steering_status
 * @return Reference to member steering_status
 */
int32_t& ros2_interface::msg::Chassis::steering_status()
{
    return m_steering_status;
}

/*!
 * @brief This function sets a value in member front_steering_value
 * @param _front_steering_value New value for member front_steering_value
 */
void ros2_interface::msg::Chassis::front_steering_value(
        double _front_steering_value)
{
    m_front_steering_value = _front_steering_value;
}

/*!
 * @brief This function returns the value of member front_steering_value
 * @return Value of member front_steering_value
 */
double ros2_interface::msg::Chassis::front_steering_value() const
{
    return m_front_steering_value;
}

/*!
 * @brief This function returns a reference to member front_steering_value
 * @return Reference to member front_steering_value
 */
double& ros2_interface::msg::Chassis::front_steering_value()
{
    return m_front_steering_value;
}

/*!
 * @brief This function sets a value in member rear_steering_value
 * @param _rear_steering_value New value for member rear_steering_value
 */
void ros2_interface::msg::Chassis::rear_steering_value(
        double _rear_steering_value)
{
    m_rear_steering_value = _rear_steering_value;
}

/*!
 * @brief This function returns the value of member rear_steering_value
 * @return Value of member rear_steering_value
 */
double ros2_interface::msg::Chassis::rear_steering_value() const
{
    return m_rear_steering_value;
}

/*!
 * @brief This function returns a reference to member rear_steering_value
 * @return Reference to member rear_steering_value
 */
double& ros2_interface::msg::Chassis::rear_steering_value()
{
    return m_rear_steering_value;
}

/*!
 * @brief This function sets a value in member steering_torque_nm
 * @param _steering_torque_nm New value for member steering_torque_nm
 */
void ros2_interface::msg::Chassis::steering_torque_nm(
        double _steering_torque_nm)
{
    m_steering_torque_nm = _steering_torque_nm;
}

/*!
 * @brief This function returns the value of member steering_torque_nm
 * @return Value of member steering_torque_nm
 */
double ros2_interface::msg::Chassis::steering_torque_nm() const
{
    return m_steering_torque_nm;
}

/*!
 * @brief This function returns a reference to member steering_torque_nm
 * @return Reference to member steering_torque_nm
 */
double& ros2_interface::msg::Chassis::steering_torque_nm()
{
    return m_steering_torque_nm;
}

/*!
 * @brief This function sets a value in member front_steering_rate_dps
 * @param _front_steering_rate_dps New value for member front_steering_rate_dps
 */
void ros2_interface::msg::Chassis::front_steering_rate_dps(
        double _front_steering_rate_dps)
{
    m_front_steering_rate_dps = _front_steering_rate_dps;
}

/*!
 * @brief This function returns the value of member front_steering_rate_dps
 * @return Value of member front_steering_rate_dps
 */
double ros2_interface::msg::Chassis::front_steering_rate_dps() const
{
    return m_front_steering_rate_dps;
}

/*!
 * @brief This function returns a reference to member front_steering_rate_dps
 * @return Reference to member front_steering_rate_dps
 */
double& ros2_interface::msg::Chassis::front_steering_rate_dps()
{
    return m_front_steering_rate_dps;
}

/*!
 * @brief This function sets a value in member rear_steering_rate_dps
 * @param _rear_steering_rate_dps New value for member rear_steering_rate_dps
 */
void ros2_interface::msg::Chassis::rear_steering_rate_dps(
        double _rear_steering_rate_dps)
{
    m_rear_steering_rate_dps = _rear_steering_rate_dps;
}

/*!
 * @brief This function returns the value of member rear_steering_rate_dps
 * @return Value of member rear_steering_rate_dps
 */
double ros2_interface::msg::Chassis::rear_steering_rate_dps() const
{
    return m_rear_steering_rate_dps;
}

/*!
 * @brief This function returns a reference to member rear_steering_rate_dps
 * @return Reference to member rear_steering_rate_dps
 */
double& ros2_interface::msg::Chassis::rear_steering_rate_dps()
{
    return m_rear_steering_rate_dps;
}

/*!
 * @brief This function sets a value in member accel_driving_mode
 * @param _accel_driving_mode New value for member accel_driving_mode
 */
void ros2_interface::msg::Chassis::accel_driving_mode(
        int32_t _accel_driving_mode)
{
    m_accel_driving_mode = _accel_driving_mode;
}

/*!
 * @brief This function returns the value of member accel_driving_mode
 * @return Value of member accel_driving_mode
 */
int32_t ros2_interface::msg::Chassis::accel_driving_mode() const
{
    return m_accel_driving_mode;
}

/*!
 * @brief This function returns a reference to member accel_driving_mode
 * @return Reference to member accel_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::accel_driving_mode()
{
    return m_accel_driving_mode;
}

/*!
 * @brief This function sets a value in member accel_status
 * @param _accel_status New value for member accel_status
 */
void ros2_interface::msg::Chassis::accel_status(
        int32_t _accel_status)
{
    m_accel_status = _accel_status;
}

/*!
 * @brief This function returns the value of member accel_status
 * @return Value of member accel_status
 */
int32_t ros2_interface::msg::Chassis::accel_status() const
{
    return m_accel_status;
}

/*!
 * @brief This function returns a reference to member accel_status
 * @return Reference to member accel_status
 */
int32_t& ros2_interface::msg::Chassis::accel_status()
{
    return m_accel_status;
}

/*!
 * @brief This function sets a value in member accel_value
 * @param _accel_value New value for member accel_value
 */
void ros2_interface::msg::Chassis::accel_value(
        double _accel_value)
{
    m_accel_value = _accel_value;
}

/*!
 * @brief This function returns the value of member accel_value
 * @return Value of member accel_value
 */
double ros2_interface::msg::Chassis::accel_value() const
{
    return m_accel_value;
}

/*!
 * @brief This function returns a reference to member accel_value
 * @return Reference to member accel_value
 */
double& ros2_interface::msg::Chassis::accel_value()
{
    return m_accel_value;
}

/*!
 * @brief This function sets a value in member brake_driving_mode
 * @param _brake_driving_mode New value for member brake_driving_mode
 */
void ros2_interface::msg::Chassis::brake_driving_mode(
        int32_t _brake_driving_mode)
{
    m_brake_driving_mode = _brake_driving_mode;
}

/*!
 * @brief This function returns the value of member brake_driving_mode
 * @return Value of member brake_driving_mode
 */
int32_t ros2_interface::msg::Chassis::brake_driving_mode() const
{
    return m_brake_driving_mode;
}

/*!
 * @brief This function returns a reference to member brake_driving_mode
 * @return Reference to member brake_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::brake_driving_mode()
{
    return m_brake_driving_mode;
}

/*!
 * @brief This function sets a value in member brake_status
 * @param _brake_status New value for member brake_status
 */
void ros2_interface::msg::Chassis::brake_status(
        int32_t _brake_status)
{
    m_brake_status = _brake_status;
}

/*!
 * @brief This function returns the value of member brake_status
 * @return Value of member brake_status
 */
int32_t ros2_interface::msg::Chassis::brake_status() const
{
    return m_brake_status;
}

/*!
 * @brief This function returns a reference to member brake_status
 * @return Reference to member brake_status
 */
int32_t& ros2_interface::msg::Chassis::brake_status()
{
    return m_brake_status;
}

/*!
 * @brief This function sets a value in member brake_value
 * @param _brake_value New value for member brake_value
 */
void ros2_interface::msg::Chassis::brake_value(
        double _brake_value)
{
    m_brake_value = _brake_value;
}

/*!
 * @brief This function returns the value of member brake_value
 * @return Value of member brake_value
 */
double ros2_interface::msg::Chassis::brake_value() const
{
    return m_brake_value;
}

/*!
 * @brief This function returns a reference to member brake_value
 * @return Reference to member brake_value
 */
double& ros2_interface::msg::Chassis::brake_value()
{
    return m_brake_value;
}

/*!
 * @brief This function sets a value in member brake_padel
 * @param _brake_padel New value for member brake_padel
 */
void ros2_interface::msg::Chassis::brake_padel(
        int32_t _brake_padel)
{
    m_brake_padel = _brake_padel;
}

/*!
 * @brief This function returns the value of member brake_padel
 * @return Value of member brake_padel
 */
int32_t ros2_interface::msg::Chassis::brake_padel() const
{
    return m_brake_padel;
}

/*!
 * @brief This function returns a reference to member brake_padel
 * @return Reference to member brake_padel
 */
int32_t& ros2_interface::msg::Chassis::brake_padel()
{
    return m_brake_padel;
}

/*!
 * @brief This function sets a value in member lf_wheel_wheel_brake_status
 * @param _lf_wheel_wheel_brake_status New value for member lf_wheel_wheel_brake_status
 */
void ros2_interface::msg::Chassis::lf_wheel_wheel_brake_status(
        bool _lf_wheel_wheel_brake_status)
{
    m_lf_wheel_wheel_brake_status = _lf_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns the value of member lf_wheel_wheel_brake_status
 * @return Value of member lf_wheel_wheel_brake_status
 */
bool ros2_interface::msg::Chassis::lf_wheel_wheel_brake_status() const
{
    return m_lf_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns a reference to member lf_wheel_wheel_brake_status
 * @return Reference to member lf_wheel_wheel_brake_status
 */
bool& ros2_interface::msg::Chassis::lf_wheel_wheel_brake_status()
{
    return m_lf_wheel_wheel_brake_status;
}

/*!
 * @brief This function sets a value in member rf_wheel_wheel_brake_status
 * @param _rf_wheel_wheel_brake_status New value for member rf_wheel_wheel_brake_status
 */
void ros2_interface::msg::Chassis::rf_wheel_wheel_brake_status(
        bool _rf_wheel_wheel_brake_status)
{
    m_rf_wheel_wheel_brake_status = _rf_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns the value of member rf_wheel_wheel_brake_status
 * @return Value of member rf_wheel_wheel_brake_status
 */
bool ros2_interface::msg::Chassis::rf_wheel_wheel_brake_status() const
{
    return m_rf_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns a reference to member rf_wheel_wheel_brake_status
 * @return Reference to member rf_wheel_wheel_brake_status
 */
bool& ros2_interface::msg::Chassis::rf_wheel_wheel_brake_status()
{
    return m_rf_wheel_wheel_brake_status;
}

/*!
 * @brief This function sets a value in member lr_wheel_wheel_brake_status
 * @param _lr_wheel_wheel_brake_status New value for member lr_wheel_wheel_brake_status
 */
void ros2_interface::msg::Chassis::lr_wheel_wheel_brake_status(
        bool _lr_wheel_wheel_brake_status)
{
    m_lr_wheel_wheel_brake_status = _lr_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns the value of member lr_wheel_wheel_brake_status
 * @return Value of member lr_wheel_wheel_brake_status
 */
bool ros2_interface::msg::Chassis::lr_wheel_wheel_brake_status() const
{
    return m_lr_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns a reference to member lr_wheel_wheel_brake_status
 * @return Reference to member lr_wheel_wheel_brake_status
 */
bool& ros2_interface::msg::Chassis::lr_wheel_wheel_brake_status()
{
    return m_lr_wheel_wheel_brake_status;
}

/*!
 * @brief This function sets a value in member rr_wheel_wheel_brake_status
 * @param _rr_wheel_wheel_brake_status New value for member rr_wheel_wheel_brake_status
 */
void ros2_interface::msg::Chassis::rr_wheel_wheel_brake_status(
        bool _rr_wheel_wheel_brake_status)
{
    m_rr_wheel_wheel_brake_status = _rr_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns the value of member rr_wheel_wheel_brake_status
 * @return Value of member rr_wheel_wheel_brake_status
 */
bool ros2_interface::msg::Chassis::rr_wheel_wheel_brake_status() const
{
    return m_rr_wheel_wheel_brake_status;
}

/*!
 * @brief This function returns a reference to member rr_wheel_wheel_brake_status
 * @return Reference to member rr_wheel_wheel_brake_status
 */
bool& ros2_interface::msg::Chassis::rr_wheel_wheel_brake_status()
{
    return m_rr_wheel_wheel_brake_status;
}

/*!
 * @brief This function sets a value in member backup_brake_driving_mode
 * @param _backup_brake_driving_mode New value for member backup_brake_driving_mode
 */
void ros2_interface::msg::Chassis::backup_brake_driving_mode(
        int32_t _backup_brake_driving_mode)
{
    m_backup_brake_driving_mode = _backup_brake_driving_mode;
}

/*!
 * @brief This function returns the value of member backup_brake_driving_mode
 * @return Value of member backup_brake_driving_mode
 */
int32_t ros2_interface::msg::Chassis::backup_brake_driving_mode() const
{
    return m_backup_brake_driving_mode;
}

/*!
 * @brief This function returns a reference to member backup_brake_driving_mode
 * @return Reference to member backup_brake_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::backup_brake_driving_mode()
{
    return m_backup_brake_driving_mode;
}

/*!
 * @brief This function sets a value in member backup_brake_status
 * @param _backup_brake_status New value for member backup_brake_status
 */
void ros2_interface::msg::Chassis::backup_brake_status(
        int32_t _backup_brake_status)
{
    m_backup_brake_status = _backup_brake_status;
}

/*!
 * @brief This function returns the value of member backup_brake_status
 * @return Value of member backup_brake_status
 */
int32_t ros2_interface::msg::Chassis::backup_brake_status() const
{
    return m_backup_brake_status;
}

/*!
 * @brief This function returns a reference to member backup_brake_status
 * @return Reference to member backup_brake_status
 */
int32_t& ros2_interface::msg::Chassis::backup_brake_status()
{
    return m_backup_brake_status;
}

/*!
 * @brief This function sets a value in member backup_brake_value
 * @param _backup_brake_value New value for member backup_brake_value
 */
void ros2_interface::msg::Chassis::backup_brake_value(
        double _backup_brake_value)
{
    m_backup_brake_value = _backup_brake_value;
}

/*!
 * @brief This function returns the value of member backup_brake_value
 * @return Value of member backup_brake_value
 */
double ros2_interface::msg::Chassis::backup_brake_value() const
{
    return m_backup_brake_value;
}

/*!
 * @brief This function returns a reference to member backup_brake_value
 * @return Reference to member backup_brake_value
 */
double& ros2_interface::msg::Chassis::backup_brake_value()
{
    return m_backup_brake_value;
}

/*!
 * @brief This function sets a value in member epb_driving_mode
 * @param _epb_driving_mode New value for member epb_driving_mode
 */
void ros2_interface::msg::Chassis::epb_driving_mode(
        int32_t _epb_driving_mode)
{
    m_epb_driving_mode = _epb_driving_mode;
}

/*!
 * @brief This function returns the value of member epb_driving_mode
 * @return Value of member epb_driving_mode
 */
int32_t ros2_interface::msg::Chassis::epb_driving_mode() const
{
    return m_epb_driving_mode;
}

/*!
 * @brief This function returns a reference to member epb_driving_mode
 * @return Reference to member epb_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::epb_driving_mode()
{
    return m_epb_driving_mode;
}

/*!
 * @brief This function sets a value in member epb_status
 * @param _epb_status New value for member epb_status
 */
void ros2_interface::msg::Chassis::epb_status(
        int32_t _epb_status)
{
    m_epb_status = _epb_status;
}

/*!
 * @brief This function returns the value of member epb_status
 * @return Value of member epb_status
 */
int32_t ros2_interface::msg::Chassis::epb_status() const
{
    return m_epb_status;
}

/*!
 * @brief This function returns a reference to member epb_status
 * @return Reference to member epb_status
 */
int32_t& ros2_interface::msg::Chassis::epb_status()
{
    return m_epb_status;
}

/*!
 * @brief This function sets a value in member epb_level
 * @param _epb_level New value for member epb_level
 */
void ros2_interface::msg::Chassis::epb_level(
        int32_t _epb_level)
{
    m_epb_level = _epb_level;
}

/*!
 * @brief This function returns the value of member epb_level
 * @return Value of member epb_level
 */
int32_t ros2_interface::msg::Chassis::epb_level() const
{
    return m_epb_level;
}

/*!
 * @brief This function returns a reference to member epb_level
 * @return Reference to member epb_level
 */
int32_t& ros2_interface::msg::Chassis::epb_level()
{
    return m_epb_level;
}

/*!
 * @brief This function sets a value in member gear_driving_mode
 * @param _gear_driving_mode New value for member gear_driving_mode
 */
void ros2_interface::msg::Chassis::gear_driving_mode(
        int32_t _gear_driving_mode)
{
    m_gear_driving_mode = _gear_driving_mode;
}

/*!
 * @brief This function returns the value of member gear_driving_mode
 * @return Value of member gear_driving_mode
 */
int32_t ros2_interface::msg::Chassis::gear_driving_mode() const
{
    return m_gear_driving_mode;
}

/*!
 * @brief This function returns a reference to member gear_driving_mode
 * @return Reference to member gear_driving_mode
 */
int32_t& ros2_interface::msg::Chassis::gear_driving_mode()
{
    return m_gear_driving_mode;
}

/*!
 * @brief This function sets a value in member gear_status
 * @param _gear_status New value for member gear_status
 */
void ros2_interface::msg::Chassis::gear_status(
        int32_t _gear_status)
{
    m_gear_status = _gear_status;
}

/*!
 * @brief This function returns the value of member gear_status
 * @return Value of member gear_status
 */
int32_t ros2_interface::msg::Chassis::gear_status() const
{
    return m_gear_status;
}

/*!
 * @brief This function returns a reference to member gear_status
 * @return Reference to member gear_status
 */
int32_t& ros2_interface::msg::Chassis::gear_status()
{
    return m_gear_status;
}

/*!
 * @brief This function sets a value in member gear_location
 * @param _gear_location New value for member gear_location
 */
void ros2_interface::msg::Chassis::gear_location(
        int32_t _gear_location)
{
    m_gear_location = _gear_location;
}

/*!
 * @brief This function returns the value of member gear_location
 * @return Value of member gear_location
 */
int32_t ros2_interface::msg::Chassis::gear_location() const
{
    return m_gear_location;
}

/*!
 * @brief This function returns a reference to member gear_location
 * @return Reference to member gear_location
 */
int32_t& ros2_interface::msg::Chassis::gear_location()
{
    return m_gear_location;
}

/*!
 * @brief This function sets a value in member engine_rpm
 * @param _engine_rpm New value for member engine_rpm
 */
void ros2_interface::msg::Chassis::engine_rpm(
        double _engine_rpm)
{
    m_engine_rpm = _engine_rpm;
}

/*!
 * @brief This function returns the value of member engine_rpm
 * @return Value of member engine_rpm
 */
double ros2_interface::msg::Chassis::engine_rpm() const
{
    return m_engine_rpm;
}

/*!
 * @brief This function returns a reference to member engine_rpm
 * @return Reference to member engine_rpm
 */
double& ros2_interface::msg::Chassis::engine_rpm()
{
    return m_engine_rpm;
}

/*!
 * @brief This function sets a value in member engine_torque
 * @param _engine_torque New value for member engine_torque
 */
void ros2_interface::msg::Chassis::engine_torque(
        double _engine_torque)
{
    m_engine_torque = _engine_torque;
}

/*!
 * @brief This function returns the value of member engine_torque
 * @return Value of member engine_torque
 */
double ros2_interface::msg::Chassis::engine_torque() const
{
    return m_engine_torque;
}

/*!
 * @brief This function returns a reference to member engine_torque
 * @return Reference to member engine_torque
 */
double& ros2_interface::msg::Chassis::engine_torque()
{
    return m_engine_torque;
}

/*!
 * @brief This function sets a value in member is_speed_valid
 * @param _is_speed_valid New value for member is_speed_valid
 */
void ros2_interface::msg::Chassis::is_speed_valid(
        bool _is_speed_valid)
{
    m_is_speed_valid = _is_speed_valid;
}

/*!
 * @brief This function returns the value of member is_speed_valid
 * @return Value of member is_speed_valid
 */
bool ros2_interface::msg::Chassis::is_speed_valid() const
{
    return m_is_speed_valid;
}

/*!
 * @brief This function returns a reference to member is_speed_valid
 * @return Reference to member is_speed_valid
 */
bool& ros2_interface::msg::Chassis::is_speed_valid()
{
    return m_is_speed_valid;
}

/*!
 * @brief This function sets a value in member speed_mps
 * @param _speed_mps New value for member speed_mps
 */
void ros2_interface::msg::Chassis::speed_mps(
        double _speed_mps)
{
    m_speed_mps = _speed_mps;
}

/*!
 * @brief This function returns the value of member speed_mps
 * @return Value of member speed_mps
 */
double ros2_interface::msg::Chassis::speed_mps() const
{
    return m_speed_mps;
}

/*!
 * @brief This function returns a reference to member speed_mps
 * @return Reference to member speed_mps
 */
double& ros2_interface::msg::Chassis::speed_mps()
{
    return m_speed_mps;
}

/*!
 * @brief This function sets a value in member is_veh_lat_accel_valid
 * @param _is_veh_lat_accel_valid New value for member is_veh_lat_accel_valid
 */
void ros2_interface::msg::Chassis::is_veh_lat_accel_valid(
        bool _is_veh_lat_accel_valid)
{
    m_is_veh_lat_accel_valid = _is_veh_lat_accel_valid;
}

/*!
 * @brief This function returns the value of member is_veh_lat_accel_valid
 * @return Value of member is_veh_lat_accel_valid
 */
bool ros2_interface::msg::Chassis::is_veh_lat_accel_valid() const
{
    return m_is_veh_lat_accel_valid;
}

/*!
 * @brief This function returns a reference to member is_veh_lat_accel_valid
 * @return Reference to member is_veh_lat_accel_valid
 */
bool& ros2_interface::msg::Chassis::is_veh_lat_accel_valid()
{
    return m_is_veh_lat_accel_valid;
}

/*!
 * @brief This function sets a value in member veh_lat_accel
 * @param _veh_lat_accel New value for member veh_lat_accel
 */
void ros2_interface::msg::Chassis::veh_lat_accel(
        double _veh_lat_accel)
{
    m_veh_lat_accel = _veh_lat_accel;
}

/*!
 * @brief This function returns the value of member veh_lat_accel
 * @return Value of member veh_lat_accel
 */
double ros2_interface::msg::Chassis::veh_lat_accel() const
{
    return m_veh_lat_accel;
}

/*!
 * @brief This function returns a reference to member veh_lat_accel
 * @return Reference to member veh_lat_accel
 */
double& ros2_interface::msg::Chassis::veh_lat_accel()
{
    return m_veh_lat_accel;
}

/*!
 * @brief This function sets a value in member is_veh_lon_accel_valid
 * @param _is_veh_lon_accel_valid New value for member is_veh_lon_accel_valid
 */
void ros2_interface::msg::Chassis::is_veh_lon_accel_valid(
        bool _is_veh_lon_accel_valid)
{
    m_is_veh_lon_accel_valid = _is_veh_lon_accel_valid;
}

/*!
 * @brief This function returns the value of member is_veh_lon_accel_valid
 * @return Value of member is_veh_lon_accel_valid
 */
bool ros2_interface::msg::Chassis::is_veh_lon_accel_valid() const
{
    return m_is_veh_lon_accel_valid;
}

/*!
 * @brief This function returns a reference to member is_veh_lon_accel_valid
 * @return Reference to member is_veh_lon_accel_valid
 */
bool& ros2_interface::msg::Chassis::is_veh_lon_accel_valid()
{
    return m_is_veh_lon_accel_valid;
}

/*!
 * @brief This function sets a value in member veh_lon_accel
 * @param _veh_lon_accel New value for member veh_lon_accel
 */
void ros2_interface::msg::Chassis::veh_lon_accel(
        double _veh_lon_accel)
{
    m_veh_lon_accel = _veh_lon_accel;
}

/*!
 * @brief This function returns the value of member veh_lon_accel
 * @return Value of member veh_lon_accel
 */
double ros2_interface::msg::Chassis::veh_lon_accel() const
{
    return m_veh_lon_accel;
}

/*!
 * @brief This function returns a reference to member veh_lon_accel
 * @return Reference to member veh_lon_accel
 */
double& ros2_interface::msg::Chassis::veh_lon_accel()
{
    return m_veh_lon_accel;
}

/*!
 * @brief This function sets a value in member is_yaw_rate_valid
 * @param _is_yaw_rate_valid New value for member is_yaw_rate_valid
 */
void ros2_interface::msg::Chassis::is_yaw_rate_valid(
        bool _is_yaw_rate_valid)
{
    m_is_yaw_rate_valid = _is_yaw_rate_valid;
}

/*!
 * @brief This function returns the value of member is_yaw_rate_valid
 * @return Value of member is_yaw_rate_valid
 */
bool ros2_interface::msg::Chassis::is_yaw_rate_valid() const
{
    return m_is_yaw_rate_valid;
}

/*!
 * @brief This function returns a reference to member is_yaw_rate_valid
 * @return Reference to member is_yaw_rate_valid
 */
bool& ros2_interface::msg::Chassis::is_yaw_rate_valid()
{
    return m_is_yaw_rate_valid;
}

/*!
 * @brief This function sets a value in member yaw_rate
 * @param _yaw_rate New value for member yaw_rate
 */
void ros2_interface::msg::Chassis::yaw_rate(
        double _yaw_rate)
{
    m_yaw_rate = _yaw_rate;
}

/*!
 * @brief This function returns the value of member yaw_rate
 * @return Value of member yaw_rate
 */
double ros2_interface::msg::Chassis::yaw_rate() const
{
    return m_yaw_rate;
}

/*!
 * @brief This function returns a reference to member yaw_rate
 * @return Reference to member yaw_rate
 */
double& ros2_interface::msg::Chassis::yaw_rate()
{
    return m_yaw_rate;
}

/*!
 * @brief This function sets a value in member odometer_m
 * @param _odometer_m New value for member odometer_m
 */
void ros2_interface::msg::Chassis::odometer_m(
        double _odometer_m)
{
    m_odometer_m = _odometer_m;
}

/*!
 * @brief This function returns the value of member odometer_m
 * @return Value of member odometer_m
 */
double ros2_interface::msg::Chassis::odometer_m() const
{
    return m_odometer_m;
}

/*!
 * @brief This function returns a reference to member odometer_m
 * @return Reference to member odometer_m
 */
double& ros2_interface::msg::Chassis::odometer_m()
{
    return m_odometer_m;
}

/*!
 * @brief This function sets a value in member daytime_running_lights_status
 * @param _daytime_running_lights_status New value for member daytime_running_lights_status
 */
void ros2_interface::msg::Chassis::daytime_running_lights_status(
        int32_t _daytime_running_lights_status)
{
    m_daytime_running_lights_status = _daytime_running_lights_status;
}

/*!
 * @brief This function returns the value of member daytime_running_lights_status
 * @return Value of member daytime_running_lights_status
 */
int32_t ros2_interface::msg::Chassis::daytime_running_lights_status() const
{
    return m_daytime_running_lights_status;
}

/*!
 * @brief This function returns a reference to member daytime_running_lights_status
 * @return Reference to member daytime_running_lights_status
 */
int32_t& ros2_interface::msg::Chassis::daytime_running_lights_status()
{
    return m_daytime_running_lights_status;
}

/*!
 * @brief This function sets a value in member automatic_light_control_status
 * @param _automatic_light_control_status New value for member automatic_light_control_status
 */
void ros2_interface::msg::Chassis::automatic_light_control_status(
        int32_t _automatic_light_control_status)
{
    m_automatic_light_control_status = _automatic_light_control_status;
}

/*!
 * @brief This function returns the value of member automatic_light_control_status
 * @return Value of member automatic_light_control_status
 */
int32_t ros2_interface::msg::Chassis::automatic_light_control_status() const
{
    return m_automatic_light_control_status;
}

/*!
 * @brief This function returns a reference to member automatic_light_control_status
 * @return Reference to member automatic_light_control_status
 */
int32_t& ros2_interface::msg::Chassis::automatic_light_control_status()
{
    return m_automatic_light_control_status;
}

/*!
 * @brief This function sets a value in member parking_lights_status
 * @param _parking_lights_status New value for member parking_lights_status
 */
void ros2_interface::msg::Chassis::parking_lights_status(
        int32_t _parking_lights_status)
{
    m_parking_lights_status = _parking_lights_status;
}

/*!
 * @brief This function returns the value of member parking_lights_status
 * @return Value of member parking_lights_status
 */
int32_t ros2_interface::msg::Chassis::parking_lights_status() const
{
    return m_parking_lights_status;
}

/*!
 * @brief This function returns a reference to member parking_lights_status
 * @return Reference to member parking_lights_status
 */
int32_t& ros2_interface::msg::Chassis::parking_lights_status()
{
    return m_parking_lights_status;
}

/*!
 * @brief This function sets a value in member high_beam_status
 * @param _high_beam_status New value for member high_beam_status
 */
void ros2_interface::msg::Chassis::high_beam_status(
        int32_t _high_beam_status)
{
    m_high_beam_status = _high_beam_status;
}

/*!
 * @brief This function returns the value of member high_beam_status
 * @return Value of member high_beam_status
 */
int32_t ros2_interface::msg::Chassis::high_beam_status() const
{
    return m_high_beam_status;
}

/*!
 * @brief This function returns a reference to member high_beam_status
 * @return Reference to member high_beam_status
 */
int32_t& ros2_interface::msg::Chassis::high_beam_status()
{
    return m_high_beam_status;
}

/*!
 * @brief This function sets a value in member low_beam_status
 * @param _low_beam_status New value for member low_beam_status
 */
void ros2_interface::msg::Chassis::low_beam_status(
        int32_t _low_beam_status)
{
    m_low_beam_status = _low_beam_status;
}

/*!
 * @brief This function returns the value of member low_beam_status
 * @return Value of member low_beam_status
 */
int32_t ros2_interface::msg::Chassis::low_beam_status() const
{
    return m_low_beam_status;
}

/*!
 * @brief This function returns a reference to member low_beam_status
 * @return Reference to member low_beam_status
 */
int32_t& ros2_interface::msg::Chassis::low_beam_status()
{
    return m_low_beam_status;
}

/*!
 * @brief This function sets a value in member horn_status
 * @param _horn_status New value for member horn_status
 */
void ros2_interface::msg::Chassis::horn_status(
        int32_t _horn_status)
{
    m_horn_status = _horn_status;
}

/*!
 * @brief This function returns the value of member horn_status
 * @return Value of member horn_status
 */
int32_t ros2_interface::msg::Chassis::horn_status() const
{
    return m_horn_status;
}

/*!
 * @brief This function returns a reference to member horn_status
 * @return Reference to member horn_status
 */
int32_t& ros2_interface::msg::Chassis::horn_status()
{
    return m_horn_status;
}

/*!
 * @brief This function sets a value in member turn_lamp_status
 * @param _turn_lamp_status New value for member turn_lamp_status
 */
void ros2_interface::msg::Chassis::turn_lamp_status(
        int32_t _turn_lamp_status)
{
    m_turn_lamp_status = _turn_lamp_status;
}

/*!
 * @brief This function returns the value of member turn_lamp_status
 * @return Value of member turn_lamp_status
 */
int32_t ros2_interface::msg::Chassis::turn_lamp_status() const
{
    return m_turn_lamp_status;
}

/*!
 * @brief This function returns a reference to member turn_lamp_status
 * @return Reference to member turn_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::turn_lamp_status()
{
    return m_turn_lamp_status;
}

/*!
 * @brief This function sets a value in member front_wiper_status
 * @param _front_wiper_status New value for member front_wiper_status
 */
void ros2_interface::msg::Chassis::front_wiper_status(
        int32_t _front_wiper_status)
{
    m_front_wiper_status = _front_wiper_status;
}

/*!
 * @brief This function returns the value of member front_wiper_status
 * @return Value of member front_wiper_status
 */
int32_t ros2_interface::msg::Chassis::front_wiper_status() const
{
    return m_front_wiper_status;
}

/*!
 * @brief This function returns a reference to member front_wiper_status
 * @return Reference to member front_wiper_status
 */
int32_t& ros2_interface::msg::Chassis::front_wiper_status()
{
    return m_front_wiper_status;
}

/*!
 * @brief This function sets a value in member rear_wiper_status
 * @param _rear_wiper_status New value for member rear_wiper_status
 */
void ros2_interface::msg::Chassis::rear_wiper_status(
        int32_t _rear_wiper_status)
{
    m_rear_wiper_status = _rear_wiper_status;
}

/*!
 * @brief This function returns the value of member rear_wiper_status
 * @return Value of member rear_wiper_status
 */
int32_t ros2_interface::msg::Chassis::rear_wiper_status() const
{
    return m_rear_wiper_status;
}

/*!
 * @brief This function returns a reference to member rear_wiper_status
 * @return Reference to member rear_wiper_status
 */
int32_t& ros2_interface::msg::Chassis::rear_wiper_status()
{
    return m_rear_wiper_status;
}

/*!
 * @brief This function sets a value in member position_lamp_status
 * @param _position_lamp_status New value for member position_lamp_status
 */
void ros2_interface::msg::Chassis::position_lamp_status(
        int32_t _position_lamp_status)
{
    m_position_lamp_status = _position_lamp_status;
}

/*!
 * @brief This function returns the value of member position_lamp_status
 * @return Value of member position_lamp_status
 */
int32_t ros2_interface::msg::Chassis::position_lamp_status() const
{
    return m_position_lamp_status;
}

/*!
 * @brief This function returns a reference to member position_lamp_status
 * @return Reference to member position_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::position_lamp_status()
{
    return m_position_lamp_status;
}

/*!
 * @brief This function sets a value in member front_fog_lamp_status
 * @param _front_fog_lamp_status New value for member front_fog_lamp_status
 */
void ros2_interface::msg::Chassis::front_fog_lamp_status(
        int32_t _front_fog_lamp_status)
{
    m_front_fog_lamp_status = _front_fog_lamp_status;
}

/*!
 * @brief This function returns the value of member front_fog_lamp_status
 * @return Value of member front_fog_lamp_status
 */
int32_t ros2_interface::msg::Chassis::front_fog_lamp_status() const
{
    return m_front_fog_lamp_status;
}

/*!
 * @brief This function returns a reference to member front_fog_lamp_status
 * @return Reference to member front_fog_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::front_fog_lamp_status()
{
    return m_front_fog_lamp_status;
}

/*!
 * @brief This function sets a value in member rear_fog_lamp_status
 * @param _rear_fog_lamp_status New value for member rear_fog_lamp_status
 */
void ros2_interface::msg::Chassis::rear_fog_lamp_status(
        int32_t _rear_fog_lamp_status)
{
    m_rear_fog_lamp_status = _rear_fog_lamp_status;
}

/*!
 * @brief This function returns the value of member rear_fog_lamp_status
 * @return Value of member rear_fog_lamp_status
 */
int32_t ros2_interface::msg::Chassis::rear_fog_lamp_status() const
{
    return m_rear_fog_lamp_status;
}

/*!
 * @brief This function returns a reference to member rear_fog_lamp_status
 * @return Reference to member rear_fog_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::rear_fog_lamp_status()
{
    return m_rear_fog_lamp_status;
}

/*!
 * @brief This function sets a value in member brake_lamp_status
 * @param _brake_lamp_status New value for member brake_lamp_status
 */
void ros2_interface::msg::Chassis::brake_lamp_status(
        int32_t _brake_lamp_status)
{
    m_brake_lamp_status = _brake_lamp_status;
}

/*!
 * @brief This function returns the value of member brake_lamp_status
 * @return Value of member brake_lamp_status
 */
int32_t ros2_interface::msg::Chassis::brake_lamp_status() const
{
    return m_brake_lamp_status;
}

/*!
 * @brief This function returns a reference to member brake_lamp_status
 * @return Reference to member brake_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::brake_lamp_status()
{
    return m_brake_lamp_status;
}

/*!
 * @brief This function sets a value in member alarm_lamp_status
 * @param _alarm_lamp_status New value for member alarm_lamp_status
 */
void ros2_interface::msg::Chassis::alarm_lamp_status(
        int32_t _alarm_lamp_status)
{
    m_alarm_lamp_status = _alarm_lamp_status;
}

/*!
 * @brief This function returns the value of member alarm_lamp_status
 * @return Value of member alarm_lamp_status
 */
int32_t ros2_interface::msg::Chassis::alarm_lamp_status() const
{
    return m_alarm_lamp_status;
}

/*!
 * @brief This function returns a reference to member alarm_lamp_status
 * @return Reference to member alarm_lamp_status
 */
int32_t& ros2_interface::msg::Chassis::alarm_lamp_status()
{
    return m_alarm_lamp_status;
}

/*!
 * @brief This function sets a value in member lf_door_status
 * @param _lf_door_status New value for member lf_door_status
 */
void ros2_interface::msg::Chassis::lf_door_status(
        int32_t _lf_door_status)
{
    m_lf_door_status = _lf_door_status;
}

/*!
 * @brief This function returns the value of member lf_door_status
 * @return Value of member lf_door_status
 */
int32_t ros2_interface::msg::Chassis::lf_door_status() const
{
    return m_lf_door_status;
}

/*!
 * @brief This function returns a reference to member lf_door_status
 * @return Reference to member lf_door_status
 */
int32_t& ros2_interface::msg::Chassis::lf_door_status()
{
    return m_lf_door_status;
}

/*!
 * @brief This function sets a value in member rf_door_status
 * @param _rf_door_status New value for member rf_door_status
 */
void ros2_interface::msg::Chassis::rf_door_status(
        int32_t _rf_door_status)
{
    m_rf_door_status = _rf_door_status;
}

/*!
 * @brief This function returns the value of member rf_door_status
 * @return Value of member rf_door_status
 */
int32_t ros2_interface::msg::Chassis::rf_door_status() const
{
    return m_rf_door_status;
}

/*!
 * @brief This function returns a reference to member rf_door_status
 * @return Reference to member rf_door_status
 */
int32_t& ros2_interface::msg::Chassis::rf_door_status()
{
    return m_rf_door_status;
}

/*!
 * @brief This function sets a value in member lr_door_status
 * @param _lr_door_status New value for member lr_door_status
 */
void ros2_interface::msg::Chassis::lr_door_status(
        int32_t _lr_door_status)
{
    m_lr_door_status = _lr_door_status;
}

/*!
 * @brief This function returns the value of member lr_door_status
 * @return Value of member lr_door_status
 */
int32_t ros2_interface::msg::Chassis::lr_door_status() const
{
    return m_lr_door_status;
}

/*!
 * @brief This function returns a reference to member lr_door_status
 * @return Reference to member lr_door_status
 */
int32_t& ros2_interface::msg::Chassis::lr_door_status()
{
    return m_lr_door_status;
}

/*!
 * @brief This function sets a value in member rr_door_status
 * @param _rr_door_status New value for member rr_door_status
 */
void ros2_interface::msg::Chassis::rr_door_status(
        int32_t _rr_door_status)
{
    m_rr_door_status = _rr_door_status;
}

/*!
 * @brief This function returns the value of member rr_door_status
 * @return Value of member rr_door_status
 */
int32_t ros2_interface::msg::Chassis::rr_door_status() const
{
    return m_rr_door_status;
}

/*!
 * @brief This function returns a reference to member rr_door_status
 * @return Reference to member rr_door_status
 */
int32_t& ros2_interface::msg::Chassis::rr_door_status()
{
    return m_rr_door_status;
}

/*!
 * @brief This function sets a value in member rearview_mirror_status
 * @param _rearview_mirror_status New value for member rearview_mirror_status
 */
void ros2_interface::msg::Chassis::rearview_mirror_status(
        int32_t _rearview_mirror_status)
{
    m_rearview_mirror_status = _rearview_mirror_status;
}

/*!
 * @brief This function returns the value of member rearview_mirror_status
 * @return Value of member rearview_mirror_status
 */
int32_t ros2_interface::msg::Chassis::rearview_mirror_status() const
{
    return m_rearview_mirror_status;
}

/*!
 * @brief This function returns a reference to member rearview_mirror_status
 * @return Reference to member rearview_mirror_status
 */
int32_t& ros2_interface::msg::Chassis::rearview_mirror_status()
{
    return m_rearview_mirror_status;
}

/*!
 * @brief This function sets a value in member trunk_status
 * @param _trunk_status New value for member trunk_status
 */
void ros2_interface::msg::Chassis::trunk_status(
        int32_t _trunk_status)
{
    m_trunk_status = _trunk_status;
}

/*!
 * @brief This function returns the value of member trunk_status
 * @return Value of member trunk_status
 */
int32_t ros2_interface::msg::Chassis::trunk_status() const
{
    return m_trunk_status;
}

/*!
 * @brief This function returns a reference to member trunk_status
 * @return Reference to member trunk_status
 */
int32_t& ros2_interface::msg::Chassis::trunk_status()
{
    return m_trunk_status;
}

/*!
 * @brief This function sets a value in member engine_bay_door_status
 * @param _engine_bay_door_status New value for member engine_bay_door_status
 */
void ros2_interface::msg::Chassis::engine_bay_door_status(
        int32_t _engine_bay_door_status)
{
    m_engine_bay_door_status = _engine_bay_door_status;
}

/*!
 * @brief This function returns the value of member engine_bay_door_status
 * @return Value of member engine_bay_door_status
 */
int32_t ros2_interface::msg::Chassis::engine_bay_door_status() const
{
    return m_engine_bay_door_status;
}

/*!
 * @brief This function returns a reference to member engine_bay_door_status
 * @return Reference to member engine_bay_door_status
 */
int32_t& ros2_interface::msg::Chassis::engine_bay_door_status()
{
    return m_engine_bay_door_status;
}

/*!
 * @brief This function sets a value in member wheel_direction_rr
 * @param _wheel_direction_rr New value for member wheel_direction_rr
 */
void ros2_interface::msg::Chassis::wheel_direction_rr(
        int32_t _wheel_direction_rr)
{
    m_wheel_direction_rr = _wheel_direction_rr;
}

/*!
 * @brief This function returns the value of member wheel_direction_rr
 * @return Value of member wheel_direction_rr
 */
int32_t ros2_interface::msg::Chassis::wheel_direction_rr() const
{
    return m_wheel_direction_rr;
}

/*!
 * @brief This function returns a reference to member wheel_direction_rr
 * @return Reference to member wheel_direction_rr
 */
int32_t& ros2_interface::msg::Chassis::wheel_direction_rr()
{
    return m_wheel_direction_rr;
}

/*!
 * @brief This function sets a value in member wheel_spd_rr
 * @param _wheel_spd_rr New value for member wheel_spd_rr
 */
void ros2_interface::msg::Chassis::wheel_spd_rr(
        double _wheel_spd_rr)
{
    m_wheel_spd_rr = _wheel_spd_rr;
}

/*!
 * @brief This function returns the value of member wheel_spd_rr
 * @return Value of member wheel_spd_rr
 */
double ros2_interface::msg::Chassis::wheel_spd_rr() const
{
    return m_wheel_spd_rr;
}

/*!
 * @brief This function returns a reference to member wheel_spd_rr
 * @return Reference to member wheel_spd_rr
 */
double& ros2_interface::msg::Chassis::wheel_spd_rr()
{
    return m_wheel_spd_rr;
}

/*!
 * @brief This function sets a value in member wheel_direction_rl
 * @param _wheel_direction_rl New value for member wheel_direction_rl
 */
void ros2_interface::msg::Chassis::wheel_direction_rl(
        int32_t _wheel_direction_rl)
{
    m_wheel_direction_rl = _wheel_direction_rl;
}

/*!
 * @brief This function returns the value of member wheel_direction_rl
 * @return Value of member wheel_direction_rl
 */
int32_t ros2_interface::msg::Chassis::wheel_direction_rl() const
{
    return m_wheel_direction_rl;
}

/*!
 * @brief This function returns a reference to member wheel_direction_rl
 * @return Reference to member wheel_direction_rl
 */
int32_t& ros2_interface::msg::Chassis::wheel_direction_rl()
{
    return m_wheel_direction_rl;
}

/*!
 * @brief This function sets a value in member wheel_spd_rl
 * @param _wheel_spd_rl New value for member wheel_spd_rl
 */
void ros2_interface::msg::Chassis::wheel_spd_rl(
        double _wheel_spd_rl)
{
    m_wheel_spd_rl = _wheel_spd_rl;
}

/*!
 * @brief This function returns the value of member wheel_spd_rl
 * @return Value of member wheel_spd_rl
 */
double ros2_interface::msg::Chassis::wheel_spd_rl() const
{
    return m_wheel_spd_rl;
}

/*!
 * @brief This function returns a reference to member wheel_spd_rl
 * @return Reference to member wheel_spd_rl
 */
double& ros2_interface::msg::Chassis::wheel_spd_rl()
{
    return m_wheel_spd_rl;
}

/*!
 * @brief This function sets a value in member wheel_direction_fr
 * @param _wheel_direction_fr New value for member wheel_direction_fr
 */
void ros2_interface::msg::Chassis::wheel_direction_fr(
        int32_t _wheel_direction_fr)
{
    m_wheel_direction_fr = _wheel_direction_fr;
}

/*!
 * @brief This function returns the value of member wheel_direction_fr
 * @return Value of member wheel_direction_fr
 */
int32_t ros2_interface::msg::Chassis::wheel_direction_fr() const
{
    return m_wheel_direction_fr;
}

/*!
 * @brief This function returns a reference to member wheel_direction_fr
 * @return Reference to member wheel_direction_fr
 */
int32_t& ros2_interface::msg::Chassis::wheel_direction_fr()
{
    return m_wheel_direction_fr;
}

/*!
 * @brief This function sets a value in member wheel_spd_fr
 * @param _wheel_spd_fr New value for member wheel_spd_fr
 */
void ros2_interface::msg::Chassis::wheel_spd_fr(
        double _wheel_spd_fr)
{
    m_wheel_spd_fr = _wheel_spd_fr;
}

/*!
 * @brief This function returns the value of member wheel_spd_fr
 * @return Value of member wheel_spd_fr
 */
double ros2_interface::msg::Chassis::wheel_spd_fr() const
{
    return m_wheel_spd_fr;
}

/*!
 * @brief This function returns a reference to member wheel_spd_fr
 * @return Reference to member wheel_spd_fr
 */
double& ros2_interface::msg::Chassis::wheel_spd_fr()
{
    return m_wheel_spd_fr;
}

/*!
 * @brief This function sets a value in member wheel_direction_fl
 * @param _wheel_direction_fl New value for member wheel_direction_fl
 */
void ros2_interface::msg::Chassis::wheel_direction_fl(
        int32_t _wheel_direction_fl)
{
    m_wheel_direction_fl = _wheel_direction_fl;
}

/*!
 * @brief This function returns the value of member wheel_direction_fl
 * @return Value of member wheel_direction_fl
 */
int32_t ros2_interface::msg::Chassis::wheel_direction_fl() const
{
    return m_wheel_direction_fl;
}

/*!
 * @brief This function returns a reference to member wheel_direction_fl
 * @return Reference to member wheel_direction_fl
 */
int32_t& ros2_interface::msg::Chassis::wheel_direction_fl()
{
    return m_wheel_direction_fl;
}

/*!
 * @brief This function sets a value in member wheel_spd_fl
 * @param _wheel_spd_fl New value for member wheel_spd_fl
 */
void ros2_interface::msg::Chassis::wheel_spd_fl(
        double _wheel_spd_fl)
{
    m_wheel_spd_fl = _wheel_spd_fl;
}

/*!
 * @brief This function returns the value of member wheel_spd_fl
 * @return Value of member wheel_spd_fl
 */
double ros2_interface::msg::Chassis::wheel_spd_fl() const
{
    return m_wheel_spd_fl;
}

/*!
 * @brief This function returns a reference to member wheel_spd_fl
 * @return Reference to member wheel_spd_fl
 */
double& ros2_interface::msg::Chassis::wheel_spd_fl()
{
    return m_wheel_spd_fl;
}

/*!
 * @brief This function sets a value in member is_wss_rr_edges_sum_valid
 * @param _is_wss_rr_edges_sum_valid New value for member is_wss_rr_edges_sum_valid
 */
void ros2_interface::msg::Chassis::is_wss_rr_edges_sum_valid(
        bool _is_wss_rr_edges_sum_valid)
{
    m_is_wss_rr_edges_sum_valid = _is_wss_rr_edges_sum_valid;
}

/*!
 * @brief This function returns the value of member is_wss_rr_edges_sum_valid
 * @return Value of member is_wss_rr_edges_sum_valid
 */
bool ros2_interface::msg::Chassis::is_wss_rr_edges_sum_valid() const
{
    return m_is_wss_rr_edges_sum_valid;
}

/*!
 * @brief This function returns a reference to member is_wss_rr_edges_sum_valid
 * @return Reference to member is_wss_rr_edges_sum_valid
 */
bool& ros2_interface::msg::Chassis::is_wss_rr_edges_sum_valid()
{
    return m_is_wss_rr_edges_sum_valid;
}

/*!
 * @brief This function sets a value in member wss_rr_edges_sum
 * @param _wss_rr_edges_sum New value for member wss_rr_edges_sum
 */
void ros2_interface::msg::Chassis::wss_rr_edges_sum(
        int32_t _wss_rr_edges_sum)
{
    m_wss_rr_edges_sum = _wss_rr_edges_sum;
}

/*!
 * @brief This function returns the value of member wss_rr_edges_sum
 * @return Value of member wss_rr_edges_sum
 */
int32_t ros2_interface::msg::Chassis::wss_rr_edges_sum() const
{
    return m_wss_rr_edges_sum;
}

/*!
 * @brief This function returns a reference to member wss_rr_edges_sum
 * @return Reference to member wss_rr_edges_sum
 */
int32_t& ros2_interface::msg::Chassis::wss_rr_edges_sum()
{
    return m_wss_rr_edges_sum;
}

/*!
 * @brief This function sets a value in member is_wss_rl_edges_sum_valid
 * @param _is_wss_rl_edges_sum_valid New value for member is_wss_rl_edges_sum_valid
 */
void ros2_interface::msg::Chassis::is_wss_rl_edges_sum_valid(
        bool _is_wss_rl_edges_sum_valid)
{
    m_is_wss_rl_edges_sum_valid = _is_wss_rl_edges_sum_valid;
}

/*!
 * @brief This function returns the value of member is_wss_rl_edges_sum_valid
 * @return Value of member is_wss_rl_edges_sum_valid
 */
bool ros2_interface::msg::Chassis::is_wss_rl_edges_sum_valid() const
{
    return m_is_wss_rl_edges_sum_valid;
}

/*!
 * @brief This function returns a reference to member is_wss_rl_edges_sum_valid
 * @return Reference to member is_wss_rl_edges_sum_valid
 */
bool& ros2_interface::msg::Chassis::is_wss_rl_edges_sum_valid()
{
    return m_is_wss_rl_edges_sum_valid;
}

/*!
 * @brief This function sets a value in member wss_rl_edges_sum
 * @param _wss_rl_edges_sum New value for member wss_rl_edges_sum
 */
void ros2_interface::msg::Chassis::wss_rl_edges_sum(
        int32_t _wss_rl_edges_sum)
{
    m_wss_rl_edges_sum = _wss_rl_edges_sum;
}

/*!
 * @brief This function returns the value of member wss_rl_edges_sum
 * @return Value of member wss_rl_edges_sum
 */
int32_t ros2_interface::msg::Chassis::wss_rl_edges_sum() const
{
    return m_wss_rl_edges_sum;
}

/*!
 * @brief This function returns a reference to member wss_rl_edges_sum
 * @return Reference to member wss_rl_edges_sum
 */
int32_t& ros2_interface::msg::Chassis::wss_rl_edges_sum()
{
    return m_wss_rl_edges_sum;
}

/*!
 * @brief This function sets a value in member is_wss_fr_edges_sum_valid
 * @param _is_wss_fr_edges_sum_valid New value for member is_wss_fr_edges_sum_valid
 */
void ros2_interface::msg::Chassis::is_wss_fr_edges_sum_valid(
        bool _is_wss_fr_edges_sum_valid)
{
    m_is_wss_fr_edges_sum_valid = _is_wss_fr_edges_sum_valid;
}

/*!
 * @brief This function returns the value of member is_wss_fr_edges_sum_valid
 * @return Value of member is_wss_fr_edges_sum_valid
 */
bool ros2_interface::msg::Chassis::is_wss_fr_edges_sum_valid() const
{
    return m_is_wss_fr_edges_sum_valid;
}

/*!
 * @brief This function returns a reference to member is_wss_fr_edges_sum_valid
 * @return Reference to member is_wss_fr_edges_sum_valid
 */
bool& ros2_interface::msg::Chassis::is_wss_fr_edges_sum_valid()
{
    return m_is_wss_fr_edges_sum_valid;
}

/*!
 * @brief This function sets a value in member wss_fr_edges_sum
 * @param _wss_fr_edges_sum New value for member wss_fr_edges_sum
 */
void ros2_interface::msg::Chassis::wss_fr_edges_sum(
        int32_t _wss_fr_edges_sum)
{
    m_wss_fr_edges_sum = _wss_fr_edges_sum;
}

/*!
 * @brief This function returns the value of member wss_fr_edges_sum
 * @return Value of member wss_fr_edges_sum
 */
int32_t ros2_interface::msg::Chassis::wss_fr_edges_sum() const
{
    return m_wss_fr_edges_sum;
}

/*!
 * @brief This function returns a reference to member wss_fr_edges_sum
 * @return Reference to member wss_fr_edges_sum
 */
int32_t& ros2_interface::msg::Chassis::wss_fr_edges_sum()
{
    return m_wss_fr_edges_sum;
}

/*!
 * @brief This function sets a value in member is_wss_fl_edges_sum_valid
 * @param _is_wss_fl_edges_sum_valid New value for member is_wss_fl_edges_sum_valid
 */
void ros2_interface::msg::Chassis::is_wss_fl_edges_sum_valid(
        bool _is_wss_fl_edges_sum_valid)
{
    m_is_wss_fl_edges_sum_valid = _is_wss_fl_edges_sum_valid;
}

/*!
 * @brief This function returns the value of member is_wss_fl_edges_sum_valid
 * @return Value of member is_wss_fl_edges_sum_valid
 */
bool ros2_interface::msg::Chassis::is_wss_fl_edges_sum_valid() const
{
    return m_is_wss_fl_edges_sum_valid;
}

/*!
 * @brief This function returns a reference to member is_wss_fl_edges_sum_valid
 * @return Reference to member is_wss_fl_edges_sum_valid
 */
bool& ros2_interface::msg::Chassis::is_wss_fl_edges_sum_valid()
{
    return m_is_wss_fl_edges_sum_valid;
}

/*!
 * @brief This function sets a value in member wss_fl_edges_sum
 * @param _wss_fl_edges_sum New value for member wss_fl_edges_sum
 */
void ros2_interface::msg::Chassis::wss_fl_edges_sum(
        int32_t _wss_fl_edges_sum)
{
    m_wss_fl_edges_sum = _wss_fl_edges_sum;
}

/*!
 * @brief This function returns the value of member wss_fl_edges_sum
 * @return Value of member wss_fl_edges_sum
 */
int32_t ros2_interface::msg::Chassis::wss_fl_edges_sum() const
{
    return m_wss_fl_edges_sum;
}

/*!
 * @brief This function returns a reference to member wss_fl_edges_sum
 * @return Reference to member wss_fl_edges_sum
 */
int32_t& ros2_interface::msg::Chassis::wss_fl_edges_sum()
{
    return m_wss_fl_edges_sum;
}

/*!
 * @brief This function sets a value in member is_tire_pressure_ok
 * @param _is_tire_pressure_ok New value for member is_tire_pressure_ok
 */
void ros2_interface::msg::Chassis::is_tire_pressure_ok(
        int32_t _is_tire_pressure_ok)
{
    m_is_tire_pressure_ok = _is_tire_pressure_ok;
}

/*!
 * @brief This function returns the value of member is_tire_pressure_ok
 * @return Value of member is_tire_pressure_ok
 */
int32_t ros2_interface::msg::Chassis::is_tire_pressure_ok() const
{
    return m_is_tire_pressure_ok;
}

/*!
 * @brief This function returns a reference to member is_tire_pressure_ok
 * @return Reference to member is_tire_pressure_ok
 */
int32_t& ros2_interface::msg::Chassis::is_tire_pressure_ok()
{
    return m_is_tire_pressure_ok;
}

/*!
 * @brief This function sets a value in member is_tire_pressure_lf_valid
 * @param _is_tire_pressure_lf_valid New value for member is_tire_pressure_lf_valid
 */
void ros2_interface::msg::Chassis::is_tire_pressure_lf_valid(
        int32_t _is_tire_pressure_lf_valid)
{
    m_is_tire_pressure_lf_valid = _is_tire_pressure_lf_valid;
}

/*!
 * @brief This function returns the value of member is_tire_pressure_lf_valid
 * @return Value of member is_tire_pressure_lf_valid
 */
int32_t ros2_interface::msg::Chassis::is_tire_pressure_lf_valid() const
{
    return m_is_tire_pressure_lf_valid;
}

/*!
 * @brief This function returns a reference to member is_tire_pressure_lf_valid
 * @return Reference to member is_tire_pressure_lf_valid
 */
int32_t& ros2_interface::msg::Chassis::is_tire_pressure_lf_valid()
{
    return m_is_tire_pressure_lf_valid;
}

/*!
 * @brief This function sets a value in member tire_pressure_lf
 * @param _tire_pressure_lf New value for member tire_pressure_lf
 */
void ros2_interface::msg::Chassis::tire_pressure_lf(
        double _tire_pressure_lf)
{
    m_tire_pressure_lf = _tire_pressure_lf;
}

/*!
 * @brief This function returns the value of member tire_pressure_lf
 * @return Value of member tire_pressure_lf
 */
double ros2_interface::msg::Chassis::tire_pressure_lf() const
{
    return m_tire_pressure_lf;
}

/*!
 * @brief This function returns a reference to member tire_pressure_lf
 * @return Reference to member tire_pressure_lf
 */
double& ros2_interface::msg::Chassis::tire_pressure_lf()
{
    return m_tire_pressure_lf;
}

/*!
 * @brief This function sets a value in member is_tire_pressure_rf_valid
 * @param _is_tire_pressure_rf_valid New value for member is_tire_pressure_rf_valid
 */
void ros2_interface::msg::Chassis::is_tire_pressure_rf_valid(
        int32_t _is_tire_pressure_rf_valid)
{
    m_is_tire_pressure_rf_valid = _is_tire_pressure_rf_valid;
}

/*!
 * @brief This function returns the value of member is_tire_pressure_rf_valid
 * @return Value of member is_tire_pressure_rf_valid
 */
int32_t ros2_interface::msg::Chassis::is_tire_pressure_rf_valid() const
{
    return m_is_tire_pressure_rf_valid;
}

/*!
 * @brief This function returns a reference to member is_tire_pressure_rf_valid
 * @return Reference to member is_tire_pressure_rf_valid
 */
int32_t& ros2_interface::msg::Chassis::is_tire_pressure_rf_valid()
{
    return m_is_tire_pressure_rf_valid;
}

/*!
 * @brief This function sets a value in member tire_pressure_rf
 * @param _tire_pressure_rf New value for member tire_pressure_rf
 */
void ros2_interface::msg::Chassis::tire_pressure_rf(
        double _tire_pressure_rf)
{
    m_tire_pressure_rf = _tire_pressure_rf;
}

/*!
 * @brief This function returns the value of member tire_pressure_rf
 * @return Value of member tire_pressure_rf
 */
double ros2_interface::msg::Chassis::tire_pressure_rf() const
{
    return m_tire_pressure_rf;
}

/*!
 * @brief This function returns a reference to member tire_pressure_rf
 * @return Reference to member tire_pressure_rf
 */
double& ros2_interface::msg::Chassis::tire_pressure_rf()
{
    return m_tire_pressure_rf;
}

/*!
 * @brief This function sets a value in member is_tire_pressure_lr_valid
 * @param _is_tire_pressure_lr_valid New value for member is_tire_pressure_lr_valid
 */
void ros2_interface::msg::Chassis::is_tire_pressure_lr_valid(
        int32_t _is_tire_pressure_lr_valid)
{
    m_is_tire_pressure_lr_valid = _is_tire_pressure_lr_valid;
}

/*!
 * @brief This function returns the value of member is_tire_pressure_lr_valid
 * @return Value of member is_tire_pressure_lr_valid
 */
int32_t ros2_interface::msg::Chassis::is_tire_pressure_lr_valid() const
{
    return m_is_tire_pressure_lr_valid;
}

/*!
 * @brief This function returns a reference to member is_tire_pressure_lr_valid
 * @return Reference to member is_tire_pressure_lr_valid
 */
int32_t& ros2_interface::msg::Chassis::is_tire_pressure_lr_valid()
{
    return m_is_tire_pressure_lr_valid;
}

/*!
 * @brief This function sets a value in member tire_pressure_lr
 * @param _tire_pressure_lr New value for member tire_pressure_lr
 */
void ros2_interface::msg::Chassis::tire_pressure_lr(
        double _tire_pressure_lr)
{
    m_tire_pressure_lr = _tire_pressure_lr;
}

/*!
 * @brief This function returns the value of member tire_pressure_lr
 * @return Value of member tire_pressure_lr
 */
double ros2_interface::msg::Chassis::tire_pressure_lr() const
{
    return m_tire_pressure_lr;
}

/*!
 * @brief This function returns a reference to member tire_pressure_lr
 * @return Reference to member tire_pressure_lr
 */
double& ros2_interface::msg::Chassis::tire_pressure_lr()
{
    return m_tire_pressure_lr;
}

/*!
 * @brief This function sets a value in member is_tire_pressure_rr_valid
 * @param _is_tire_pressure_rr_valid New value for member is_tire_pressure_rr_valid
 */
void ros2_interface::msg::Chassis::is_tire_pressure_rr_valid(
        int32_t _is_tire_pressure_rr_valid)
{
    m_is_tire_pressure_rr_valid = _is_tire_pressure_rr_valid;
}

/*!
 * @brief This function returns the value of member is_tire_pressure_rr_valid
 * @return Value of member is_tire_pressure_rr_valid
 */
int32_t ros2_interface::msg::Chassis::is_tire_pressure_rr_valid() const
{
    return m_is_tire_pressure_rr_valid;
}

/*!
 * @brief This function returns a reference to member is_tire_pressure_rr_valid
 * @return Reference to member is_tire_pressure_rr_valid
 */
int32_t& ros2_interface::msg::Chassis::is_tire_pressure_rr_valid()
{
    return m_is_tire_pressure_rr_valid;
}

/*!
 * @brief This function sets a value in member tire_pressure_rr
 * @param _tire_pressure_rr New value for member tire_pressure_rr
 */
void ros2_interface::msg::Chassis::tire_pressure_rr(
        double _tire_pressure_rr)
{
    m_tire_pressure_rr = _tire_pressure_rr;
}

/*!
 * @brief This function returns the value of member tire_pressure_rr
 * @return Value of member tire_pressure_rr
 */
double ros2_interface::msg::Chassis::tire_pressure_rr() const
{
    return m_tire_pressure_rr;
}

/*!
 * @brief This function returns a reference to member tire_pressure_rr
 * @return Reference to member tire_pressure_rr
 */
double& ros2_interface::msg::Chassis::tire_pressure_rr()
{
    return m_tire_pressure_rr;
}

/*!
 * @brief This function sets a value in member air_bag_status
 * @param _air_bag_status New value for member air_bag_status
 */
void ros2_interface::msg::Chassis::air_bag_status(
        int32_t _air_bag_status)
{
    m_air_bag_status = _air_bag_status;
}

/*!
 * @brief This function returns the value of member air_bag_status
 * @return Value of member air_bag_status
 */
int32_t ros2_interface::msg::Chassis::air_bag_status() const
{
    return m_air_bag_status;
}

/*!
 * @brief This function returns a reference to member air_bag_status
 * @return Reference to member air_bag_status
 */
int32_t& ros2_interface::msg::Chassis::air_bag_status()
{
    return m_air_bag_status;
}

/*!
 * @brief This function sets a value in member charging_gun_status
 * @param _charging_gun_status New value for member charging_gun_status
 */
void ros2_interface::msg::Chassis::charging_gun_status(
        int32_t _charging_gun_status)
{
    m_charging_gun_status = _charging_gun_status;
}

/*!
 * @brief This function returns the value of member charging_gun_status
 * @return Value of member charging_gun_status
 */
int32_t ros2_interface::msg::Chassis::charging_gun_status() const
{
    return m_charging_gun_status;
}

/*!
 * @brief This function returns a reference to member charging_gun_status
 * @return Reference to member charging_gun_status
 */
int32_t& ros2_interface::msg::Chassis::charging_gun_status()
{
    return m_charging_gun_status;
}

/*!
 * @brief This function sets a value in member charge
 * @param _charge New value for member charge
 */
void ros2_interface::msg::Chassis::charge(
        int32_t _charge)
{
    m_charge = _charge;
}

/*!
 * @brief This function returns the value of member charge
 * @return Value of member charge
 */
int32_t ros2_interface::msg::Chassis::charge() const
{
    return m_charge;
}

/*!
 * @brief This function returns a reference to member charge
 * @return Reference to member charge
 */
int32_t& ros2_interface::msg::Chassis::charge()
{
    return m_charge;
}

/*!
 * @brief This function sets a value in member vehicle_power_status
 * @param _vehicle_power_status New value for member vehicle_power_status
 */
void ros2_interface::msg::Chassis::vehicle_power_status(
        int32_t _vehicle_power_status)
{
    m_vehicle_power_status = _vehicle_power_status;
}

/*!
 * @brief This function returns the value of member vehicle_power_status
 * @return Value of member vehicle_power_status
 */
int32_t ros2_interface::msg::Chassis::vehicle_power_status() const
{
    return m_vehicle_power_status;
}

/*!
 * @brief This function returns a reference to member vehicle_power_status
 * @return Reference to member vehicle_power_status
 */
int32_t& ros2_interface::msg::Chassis::vehicle_power_status()
{
    return m_vehicle_power_status;
}

/*!
 * @brief This function copies the value in member chassis_error_code
 * @param _chassis_error_code New value to be copied in member chassis_error_code
 */
void ros2_interface::msg::Chassis::chassis_error_code(
        const std::vector<int32_t>& _chassis_error_code)
{
    m_chassis_error_code = _chassis_error_code;
}

/*!
 * @brief This function moves the value in member chassis_error_code
 * @param _chassis_error_code New value to be moved in member chassis_error_code
 */
void ros2_interface::msg::Chassis::chassis_error_code(
        std::vector<int32_t>&& _chassis_error_code)
{
    m_chassis_error_code = std::move(_chassis_error_code);
}

/*!
 * @brief This function returns a constant reference to member chassis_error_code
 * @return Constant reference to member chassis_error_code
 */
const std::vector<int32_t>& ros2_interface::msg::Chassis::chassis_error_code() const
{
    return m_chassis_error_code;
}

/*!
 * @brief This function returns a reference to member chassis_error_code
 * @return Reference to member chassis_error_code
 */
std::vector<int32_t>& ros2_interface::msg::Chassis::chassis_error_code()
{
    return m_chassis_error_code;
}


size_t ros2_interface::msg::Chassis::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Chassis_max_key_cdr_typesize;
}

bool ros2_interface::msg::Chassis::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Chassis::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



