// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Chassis.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CHASSIS_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CHASSIS_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(CHASSIS_SOURCE)
#define CHASSIS_DllAPI __declspec( dllexport )
#else
#define CHASSIS_DllAPI __declspec( dllimport )
#endif // CHASSIS_SOURCE
#else
#define CHASSIS_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define CHASSIS_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Chassis defined by the user in the IDL file.
         * @ingroup Chassis
         */
        class Chassis
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Chassis();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Chassis();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Chassis that will be copied.
             */
            eProsima_user_DllExport Chassis(
                    const Chassis& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Chassis that will be copied.
             */
            eProsima_user_DllExport Chassis(
                    Chassis&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Chassis that will be copied.
             */
            eProsima_user_DllExport Chassis& operator =(
                    const Chassis& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Chassis that will be copied.
             */
            eProsima_user_DllExport Chassis& operator =(
                    Chassis&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Chassis object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Chassis& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Chassis object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Chassis& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member moving_status
             * @param _moving_status New value for member moving_status
             */
            eProsima_user_DllExport void moving_status(
                    int32_t _moving_status);

            /*!
             * @brief This function returns the value of member moving_status
             * @return Value of member moving_status
             */
            eProsima_user_DllExport int32_t moving_status() const;

            /*!
             * @brief This function returns a reference to member moving_status
             * @return Reference to member moving_status
             */
            eProsima_user_DllExport int32_t& moving_status();

            /*!
             * @brief This function sets a value in member driving_mode
             * @param _driving_mode New value for member driving_mode
             */
            eProsima_user_DllExport void driving_mode(
                    int32_t _driving_mode);

            /*!
             * @brief This function returns the value of member driving_mode
             * @return Value of member driving_mode
             */
            eProsima_user_DllExport int32_t driving_mode() const;

            /*!
             * @brief This function returns a reference to member driving_mode
             * @return Reference to member driving_mode
             */
            eProsima_user_DllExport int32_t& driving_mode();

            /*!
             * @brief This function sets a value in member steer_driving_mode
             * @param _steer_driving_mode New value for member steer_driving_mode
             */
            eProsima_user_DllExport void steer_driving_mode(
                    int32_t _steer_driving_mode);

            /*!
             * @brief This function returns the value of member steer_driving_mode
             * @return Value of member steer_driving_mode
             */
            eProsima_user_DllExport int32_t steer_driving_mode() const;

            /*!
             * @brief This function returns a reference to member steer_driving_mode
             * @return Reference to member steer_driving_mode
             */
            eProsima_user_DllExport int32_t& steer_driving_mode();

            /*!
             * @brief This function sets a value in member steering_status
             * @param _steering_status New value for member steering_status
             */
            eProsima_user_DllExport void steering_status(
                    int32_t _steering_status);

            /*!
             * @brief This function returns the value of member steering_status
             * @return Value of member steering_status
             */
            eProsima_user_DllExport int32_t steering_status() const;

            /*!
             * @brief This function returns a reference to member steering_status
             * @return Reference to member steering_status
             */
            eProsima_user_DllExport int32_t& steering_status();

            /*!
             * @brief This function sets a value in member front_steering_value
             * @param _front_steering_value New value for member front_steering_value
             */
            eProsima_user_DllExport void front_steering_value(
                    double _front_steering_value);

            /*!
             * @brief This function returns the value of member front_steering_value
             * @return Value of member front_steering_value
             */
            eProsima_user_DllExport double front_steering_value() const;

            /*!
             * @brief This function returns a reference to member front_steering_value
             * @return Reference to member front_steering_value
             */
            eProsima_user_DllExport double& front_steering_value();

            /*!
             * @brief This function sets a value in member rear_steering_value
             * @param _rear_steering_value New value for member rear_steering_value
             */
            eProsima_user_DllExport void rear_steering_value(
                    double _rear_steering_value);

            /*!
             * @brief This function returns the value of member rear_steering_value
             * @return Value of member rear_steering_value
             */
            eProsima_user_DllExport double rear_steering_value() const;

            /*!
             * @brief This function returns a reference to member rear_steering_value
             * @return Reference to member rear_steering_value
             */
            eProsima_user_DllExport double& rear_steering_value();

            /*!
             * @brief This function sets a value in member steering_torque_nm
             * @param _steering_torque_nm New value for member steering_torque_nm
             */
            eProsima_user_DllExport void steering_torque_nm(
                    double _steering_torque_nm);

            /*!
             * @brief This function returns the value of member steering_torque_nm
             * @return Value of member steering_torque_nm
             */
            eProsima_user_DllExport double steering_torque_nm() const;

            /*!
             * @brief This function returns a reference to member steering_torque_nm
             * @return Reference to member steering_torque_nm
             */
            eProsima_user_DllExport double& steering_torque_nm();

            /*!
             * @brief This function sets a value in member front_steering_rate_dps
             * @param _front_steering_rate_dps New value for member front_steering_rate_dps
             */
            eProsima_user_DllExport void front_steering_rate_dps(
                    double _front_steering_rate_dps);

            /*!
             * @brief This function returns the value of member front_steering_rate_dps
             * @return Value of member front_steering_rate_dps
             */
            eProsima_user_DllExport double front_steering_rate_dps() const;

            /*!
             * @brief This function returns a reference to member front_steering_rate_dps
             * @return Reference to member front_steering_rate_dps
             */
            eProsima_user_DllExport double& front_steering_rate_dps();

            /*!
             * @brief This function sets a value in member rear_steering_rate_dps
             * @param _rear_steering_rate_dps New value for member rear_steering_rate_dps
             */
            eProsima_user_DllExport void rear_steering_rate_dps(
                    double _rear_steering_rate_dps);

            /*!
             * @brief This function returns the value of member rear_steering_rate_dps
             * @return Value of member rear_steering_rate_dps
             */
            eProsima_user_DllExport double rear_steering_rate_dps() const;

            /*!
             * @brief This function returns a reference to member rear_steering_rate_dps
             * @return Reference to member rear_steering_rate_dps
             */
            eProsima_user_DllExport double& rear_steering_rate_dps();

            /*!
             * @brief This function sets a value in member accel_driving_mode
             * @param _accel_driving_mode New value for member accel_driving_mode
             */
            eProsima_user_DllExport void accel_driving_mode(
                    int32_t _accel_driving_mode);

            /*!
             * @brief This function returns the value of member accel_driving_mode
             * @return Value of member accel_driving_mode
             */
            eProsima_user_DllExport int32_t accel_driving_mode() const;

            /*!
             * @brief This function returns a reference to member accel_driving_mode
             * @return Reference to member accel_driving_mode
             */
            eProsima_user_DllExport int32_t& accel_driving_mode();

            /*!
             * @brief This function sets a value in member accel_status
             * @param _accel_status New value for member accel_status
             */
            eProsima_user_DllExport void accel_status(
                    int32_t _accel_status);

            /*!
             * @brief This function returns the value of member accel_status
             * @return Value of member accel_status
             */
            eProsima_user_DllExport int32_t accel_status() const;

            /*!
             * @brief This function returns a reference to member accel_status
             * @return Reference to member accel_status
             */
            eProsima_user_DllExport int32_t& accel_status();

            /*!
             * @brief This function sets a value in member accel_value
             * @param _accel_value New value for member accel_value
             */
            eProsima_user_DllExport void accel_value(
                    double _accel_value);

            /*!
             * @brief This function returns the value of member accel_value
             * @return Value of member accel_value
             */
            eProsima_user_DllExport double accel_value() const;

            /*!
             * @brief This function returns a reference to member accel_value
             * @return Reference to member accel_value
             */
            eProsima_user_DllExport double& accel_value();

            /*!
             * @brief This function sets a value in member brake_driving_mode
             * @param _brake_driving_mode New value for member brake_driving_mode
             */
            eProsima_user_DllExport void brake_driving_mode(
                    int32_t _brake_driving_mode);

            /*!
             * @brief This function returns the value of member brake_driving_mode
             * @return Value of member brake_driving_mode
             */
            eProsima_user_DllExport int32_t brake_driving_mode() const;

            /*!
             * @brief This function returns a reference to member brake_driving_mode
             * @return Reference to member brake_driving_mode
             */
            eProsima_user_DllExport int32_t& brake_driving_mode();

            /*!
             * @brief This function sets a value in member brake_status
             * @param _brake_status New value for member brake_status
             */
            eProsima_user_DllExport void brake_status(
                    int32_t _brake_status);

            /*!
             * @brief This function returns the value of member brake_status
             * @return Value of member brake_status
             */
            eProsima_user_DllExport int32_t brake_status() const;

            /*!
             * @brief This function returns a reference to member brake_status
             * @return Reference to member brake_status
             */
            eProsima_user_DllExport int32_t& brake_status();

            /*!
             * @brief This function sets a value in member brake_value
             * @param _brake_value New value for member brake_value
             */
            eProsima_user_DllExport void brake_value(
                    double _brake_value);

            /*!
             * @brief This function returns the value of member brake_value
             * @return Value of member brake_value
             */
            eProsima_user_DllExport double brake_value() const;

            /*!
             * @brief This function returns a reference to member brake_value
             * @return Reference to member brake_value
             */
            eProsima_user_DllExport double& brake_value();

            /*!
             * @brief This function sets a value in member brake_padel
             * @param _brake_padel New value for member brake_padel
             */
            eProsima_user_DllExport void brake_padel(
                    int32_t _brake_padel);

            /*!
             * @brief This function returns the value of member brake_padel
             * @return Value of member brake_padel
             */
            eProsima_user_DllExport int32_t brake_padel() const;

            /*!
             * @brief This function returns a reference to member brake_padel
             * @return Reference to member brake_padel
             */
            eProsima_user_DllExport int32_t& brake_padel();

            /*!
             * @brief This function sets a value in member lf_wheel_wheel_brake_status
             * @param _lf_wheel_wheel_brake_status New value for member lf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport void lf_wheel_wheel_brake_status(
                    bool _lf_wheel_wheel_brake_status);

            /*!
             * @brief This function returns the value of member lf_wheel_wheel_brake_status
             * @return Value of member lf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool lf_wheel_wheel_brake_status() const;

            /*!
             * @brief This function returns a reference to member lf_wheel_wheel_brake_status
             * @return Reference to member lf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool& lf_wheel_wheel_brake_status();

            /*!
             * @brief This function sets a value in member rf_wheel_wheel_brake_status
             * @param _rf_wheel_wheel_brake_status New value for member rf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport void rf_wheel_wheel_brake_status(
                    bool _rf_wheel_wheel_brake_status);

            /*!
             * @brief This function returns the value of member rf_wheel_wheel_brake_status
             * @return Value of member rf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool rf_wheel_wheel_brake_status() const;

            /*!
             * @brief This function returns a reference to member rf_wheel_wheel_brake_status
             * @return Reference to member rf_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool& rf_wheel_wheel_brake_status();

            /*!
             * @brief This function sets a value in member lr_wheel_wheel_brake_status
             * @param _lr_wheel_wheel_brake_status New value for member lr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport void lr_wheel_wheel_brake_status(
                    bool _lr_wheel_wheel_brake_status);

            /*!
             * @brief This function returns the value of member lr_wheel_wheel_brake_status
             * @return Value of member lr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool lr_wheel_wheel_brake_status() const;

            /*!
             * @brief This function returns a reference to member lr_wheel_wheel_brake_status
             * @return Reference to member lr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool& lr_wheel_wheel_brake_status();

            /*!
             * @brief This function sets a value in member rr_wheel_wheel_brake_status
             * @param _rr_wheel_wheel_brake_status New value for member rr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport void rr_wheel_wheel_brake_status(
                    bool _rr_wheel_wheel_brake_status);

            /*!
             * @brief This function returns the value of member rr_wheel_wheel_brake_status
             * @return Value of member rr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool rr_wheel_wheel_brake_status() const;

            /*!
             * @brief This function returns a reference to member rr_wheel_wheel_brake_status
             * @return Reference to member rr_wheel_wheel_brake_status
             */
            eProsima_user_DllExport bool& rr_wheel_wheel_brake_status();

            /*!
             * @brief This function sets a value in member backup_brake_driving_mode
             * @param _backup_brake_driving_mode New value for member backup_brake_driving_mode
             */
            eProsima_user_DllExport void backup_brake_driving_mode(
                    int32_t _backup_brake_driving_mode);

            /*!
             * @brief This function returns the value of member backup_brake_driving_mode
             * @return Value of member backup_brake_driving_mode
             */
            eProsima_user_DllExport int32_t backup_brake_driving_mode() const;

            /*!
             * @brief This function returns a reference to member backup_brake_driving_mode
             * @return Reference to member backup_brake_driving_mode
             */
            eProsima_user_DllExport int32_t& backup_brake_driving_mode();

            /*!
             * @brief This function sets a value in member backup_brake_status
             * @param _backup_brake_status New value for member backup_brake_status
             */
            eProsima_user_DllExport void backup_brake_status(
                    int32_t _backup_brake_status);

            /*!
             * @brief This function returns the value of member backup_brake_status
             * @return Value of member backup_brake_status
             */
            eProsima_user_DllExport int32_t backup_brake_status() const;

            /*!
             * @brief This function returns a reference to member backup_brake_status
             * @return Reference to member backup_brake_status
             */
            eProsima_user_DllExport int32_t& backup_brake_status();

            /*!
             * @brief This function sets a value in member backup_brake_value
             * @param _backup_brake_value New value for member backup_brake_value
             */
            eProsima_user_DllExport void backup_brake_value(
                    double _backup_brake_value);

            /*!
             * @brief This function returns the value of member backup_brake_value
             * @return Value of member backup_brake_value
             */
            eProsima_user_DllExport double backup_brake_value() const;

            /*!
             * @brief This function returns a reference to member backup_brake_value
             * @return Reference to member backup_brake_value
             */
            eProsima_user_DllExport double& backup_brake_value();

            /*!
             * @brief This function sets a value in member epb_driving_mode
             * @param _epb_driving_mode New value for member epb_driving_mode
             */
            eProsima_user_DllExport void epb_driving_mode(
                    int32_t _epb_driving_mode);

            /*!
             * @brief This function returns the value of member epb_driving_mode
             * @return Value of member epb_driving_mode
             */
            eProsima_user_DllExport int32_t epb_driving_mode() const;

            /*!
             * @brief This function returns a reference to member epb_driving_mode
             * @return Reference to member epb_driving_mode
             */
            eProsima_user_DllExport int32_t& epb_driving_mode();

            /*!
             * @brief This function sets a value in member epb_status
             * @param _epb_status New value for member epb_status
             */
            eProsima_user_DllExport void epb_status(
                    int32_t _epb_status);

            /*!
             * @brief This function returns the value of member epb_status
             * @return Value of member epb_status
             */
            eProsima_user_DllExport int32_t epb_status() const;

            /*!
             * @brief This function returns a reference to member epb_status
             * @return Reference to member epb_status
             */
            eProsima_user_DllExport int32_t& epb_status();

            /*!
             * @brief This function sets a value in member epb_level
             * @param _epb_level New value for member epb_level
             */
            eProsima_user_DllExport void epb_level(
                    int32_t _epb_level);

            /*!
             * @brief This function returns the value of member epb_level
             * @return Value of member epb_level
             */
            eProsima_user_DllExport int32_t epb_level() const;

            /*!
             * @brief This function returns a reference to member epb_level
             * @return Reference to member epb_level
             */
            eProsima_user_DllExport int32_t& epb_level();

            /*!
             * @brief This function sets a value in member gear_driving_mode
             * @param _gear_driving_mode New value for member gear_driving_mode
             */
            eProsima_user_DllExport void gear_driving_mode(
                    int32_t _gear_driving_mode);

            /*!
             * @brief This function returns the value of member gear_driving_mode
             * @return Value of member gear_driving_mode
             */
            eProsima_user_DllExport int32_t gear_driving_mode() const;

            /*!
             * @brief This function returns a reference to member gear_driving_mode
             * @return Reference to member gear_driving_mode
             */
            eProsima_user_DllExport int32_t& gear_driving_mode();

            /*!
             * @brief This function sets a value in member gear_status
             * @param _gear_status New value for member gear_status
             */
            eProsima_user_DllExport void gear_status(
                    int32_t _gear_status);

            /*!
             * @brief This function returns the value of member gear_status
             * @return Value of member gear_status
             */
            eProsima_user_DllExport int32_t gear_status() const;

            /*!
             * @brief This function returns a reference to member gear_status
             * @return Reference to member gear_status
             */
            eProsima_user_DllExport int32_t& gear_status();

            /*!
             * @brief This function sets a value in member gear_location
             * @param _gear_location New value for member gear_location
             */
            eProsima_user_DllExport void gear_location(
                    int32_t _gear_location);

            /*!
             * @brief This function returns the value of member gear_location
             * @return Value of member gear_location
             */
            eProsima_user_DllExport int32_t gear_location() const;

            /*!
             * @brief This function returns a reference to member gear_location
             * @return Reference to member gear_location
             */
            eProsima_user_DllExport int32_t& gear_location();

            /*!
             * @brief This function sets a value in member engine_rpm
             * @param _engine_rpm New value for member engine_rpm
             */
            eProsima_user_DllExport void engine_rpm(
                    double _engine_rpm);

            /*!
             * @brief This function returns the value of member engine_rpm
             * @return Value of member engine_rpm
             */
            eProsima_user_DllExport double engine_rpm() const;

            /*!
             * @brief This function returns a reference to member engine_rpm
             * @return Reference to member engine_rpm
             */
            eProsima_user_DllExport double& engine_rpm();

            /*!
             * @brief This function sets a value in member engine_torque
             * @param _engine_torque New value for member engine_torque
             */
            eProsima_user_DllExport void engine_torque(
                    double _engine_torque);

            /*!
             * @brief This function returns the value of member engine_torque
             * @return Value of member engine_torque
             */
            eProsima_user_DllExport double engine_torque() const;

            /*!
             * @brief This function returns a reference to member engine_torque
             * @return Reference to member engine_torque
             */
            eProsima_user_DllExport double& engine_torque();

            /*!
             * @brief This function sets a value in member is_speed_valid
             * @param _is_speed_valid New value for member is_speed_valid
             */
            eProsima_user_DllExport void is_speed_valid(
                    bool _is_speed_valid);

            /*!
             * @brief This function returns the value of member is_speed_valid
             * @return Value of member is_speed_valid
             */
            eProsima_user_DllExport bool is_speed_valid() const;

            /*!
             * @brief This function returns a reference to member is_speed_valid
             * @return Reference to member is_speed_valid
             */
            eProsima_user_DllExport bool& is_speed_valid();

            /*!
             * @brief This function sets a value in member speed_mps
             * @param _speed_mps New value for member speed_mps
             */
            eProsima_user_DllExport void speed_mps(
                    double _speed_mps);

            /*!
             * @brief This function returns the value of member speed_mps
             * @return Value of member speed_mps
             */
            eProsima_user_DllExport double speed_mps() const;

            /*!
             * @brief This function returns a reference to member speed_mps
             * @return Reference to member speed_mps
             */
            eProsima_user_DllExport double& speed_mps();

            /*!
             * @brief This function sets a value in member is_veh_lat_accel_valid
             * @param _is_veh_lat_accel_valid New value for member is_veh_lat_accel_valid
             */
            eProsima_user_DllExport void is_veh_lat_accel_valid(
                    bool _is_veh_lat_accel_valid);

            /*!
             * @brief This function returns the value of member is_veh_lat_accel_valid
             * @return Value of member is_veh_lat_accel_valid
             */
            eProsima_user_DllExport bool is_veh_lat_accel_valid() const;

            /*!
             * @brief This function returns a reference to member is_veh_lat_accel_valid
             * @return Reference to member is_veh_lat_accel_valid
             */
            eProsima_user_DllExport bool& is_veh_lat_accel_valid();

            /*!
             * @brief This function sets a value in member veh_lat_accel
             * @param _veh_lat_accel New value for member veh_lat_accel
             */
            eProsima_user_DllExport void veh_lat_accel(
                    double _veh_lat_accel);

            /*!
             * @brief This function returns the value of member veh_lat_accel
             * @return Value of member veh_lat_accel
             */
            eProsima_user_DllExport double veh_lat_accel() const;

            /*!
             * @brief This function returns a reference to member veh_lat_accel
             * @return Reference to member veh_lat_accel
             */
            eProsima_user_DllExport double& veh_lat_accel();

            /*!
             * @brief This function sets a value in member is_veh_lon_accel_valid
             * @param _is_veh_lon_accel_valid New value for member is_veh_lon_accel_valid
             */
            eProsima_user_DllExport void is_veh_lon_accel_valid(
                    bool _is_veh_lon_accel_valid);

            /*!
             * @brief This function returns the value of member is_veh_lon_accel_valid
             * @return Value of member is_veh_lon_accel_valid
             */
            eProsima_user_DllExport bool is_veh_lon_accel_valid() const;

            /*!
             * @brief This function returns a reference to member is_veh_lon_accel_valid
             * @return Reference to member is_veh_lon_accel_valid
             */
            eProsima_user_DllExport bool& is_veh_lon_accel_valid();

            /*!
             * @brief This function sets a value in member veh_lon_accel
             * @param _veh_lon_accel New value for member veh_lon_accel
             */
            eProsima_user_DllExport void veh_lon_accel(
                    double _veh_lon_accel);

            /*!
             * @brief This function returns the value of member veh_lon_accel
             * @return Value of member veh_lon_accel
             */
            eProsima_user_DllExport double veh_lon_accel() const;

            /*!
             * @brief This function returns a reference to member veh_lon_accel
             * @return Reference to member veh_lon_accel
             */
            eProsima_user_DllExport double& veh_lon_accel();

            /*!
             * @brief This function sets a value in member is_yaw_rate_valid
             * @param _is_yaw_rate_valid New value for member is_yaw_rate_valid
             */
            eProsima_user_DllExport void is_yaw_rate_valid(
                    bool _is_yaw_rate_valid);

            /*!
             * @brief This function returns the value of member is_yaw_rate_valid
             * @return Value of member is_yaw_rate_valid
             */
            eProsima_user_DllExport bool is_yaw_rate_valid() const;

            /*!
             * @brief This function returns a reference to member is_yaw_rate_valid
             * @return Reference to member is_yaw_rate_valid
             */
            eProsima_user_DllExport bool& is_yaw_rate_valid();

            /*!
             * @brief This function sets a value in member yaw_rate
             * @param _yaw_rate New value for member yaw_rate
             */
            eProsima_user_DllExport void yaw_rate(
                    double _yaw_rate);

            /*!
             * @brief This function returns the value of member yaw_rate
             * @return Value of member yaw_rate
             */
            eProsima_user_DllExport double yaw_rate() const;

            /*!
             * @brief This function returns a reference to member yaw_rate
             * @return Reference to member yaw_rate
             */
            eProsima_user_DllExport double& yaw_rate();

            /*!
             * @brief This function sets a value in member odometer_m
             * @param _odometer_m New value for member odometer_m
             */
            eProsima_user_DllExport void odometer_m(
                    double _odometer_m);

            /*!
             * @brief This function returns the value of member odometer_m
             * @return Value of member odometer_m
             */
            eProsima_user_DllExport double odometer_m() const;

            /*!
             * @brief This function returns a reference to member odometer_m
             * @return Reference to member odometer_m
             */
            eProsima_user_DllExport double& odometer_m();

            /*!
             * @brief This function sets a value in member daytime_running_lights_status
             * @param _daytime_running_lights_status New value for member daytime_running_lights_status
             */
            eProsima_user_DllExport void daytime_running_lights_status(
                    int32_t _daytime_running_lights_status);

            /*!
             * @brief This function returns the value of member daytime_running_lights_status
             * @return Value of member daytime_running_lights_status
             */
            eProsima_user_DllExport int32_t daytime_running_lights_status() const;

            /*!
             * @brief This function returns a reference to member daytime_running_lights_status
             * @return Reference to member daytime_running_lights_status
             */
            eProsima_user_DllExport int32_t& daytime_running_lights_status();

            /*!
             * @brief This function sets a value in member automatic_light_control_status
             * @param _automatic_light_control_status New value for member automatic_light_control_status
             */
            eProsima_user_DllExport void automatic_light_control_status(
                    int32_t _automatic_light_control_status);

            /*!
             * @brief This function returns the value of member automatic_light_control_status
             * @return Value of member automatic_light_control_status
             */
            eProsima_user_DllExport int32_t automatic_light_control_status() const;

            /*!
             * @brief This function returns a reference to member automatic_light_control_status
             * @return Reference to member automatic_light_control_status
             */
            eProsima_user_DllExport int32_t& automatic_light_control_status();

            /*!
             * @brief This function sets a value in member parking_lights_status
             * @param _parking_lights_status New value for member parking_lights_status
             */
            eProsima_user_DllExport void parking_lights_status(
                    int32_t _parking_lights_status);

            /*!
             * @brief This function returns the value of member parking_lights_status
             * @return Value of member parking_lights_status
             */
            eProsima_user_DllExport int32_t parking_lights_status() const;

            /*!
             * @brief This function returns a reference to member parking_lights_status
             * @return Reference to member parking_lights_status
             */
            eProsima_user_DllExport int32_t& parking_lights_status();

            /*!
             * @brief This function sets a value in member high_beam_status
             * @param _high_beam_status New value for member high_beam_status
             */
            eProsima_user_DllExport void high_beam_status(
                    int32_t _high_beam_status);

            /*!
             * @brief This function returns the value of member high_beam_status
             * @return Value of member high_beam_status
             */
            eProsima_user_DllExport int32_t high_beam_status() const;

            /*!
             * @brief This function returns a reference to member high_beam_status
             * @return Reference to member high_beam_status
             */
            eProsima_user_DllExport int32_t& high_beam_status();

            /*!
             * @brief This function sets a value in member low_beam_status
             * @param _low_beam_status New value for member low_beam_status
             */
            eProsima_user_DllExport void low_beam_status(
                    int32_t _low_beam_status);

            /*!
             * @brief This function returns the value of member low_beam_status
             * @return Value of member low_beam_status
             */
            eProsima_user_DllExport int32_t low_beam_status() const;

            /*!
             * @brief This function returns a reference to member low_beam_status
             * @return Reference to member low_beam_status
             */
            eProsima_user_DllExport int32_t& low_beam_status();

            /*!
             * @brief This function sets a value in member horn_status
             * @param _horn_status New value for member horn_status
             */
            eProsima_user_DllExport void horn_status(
                    int32_t _horn_status);

            /*!
             * @brief This function returns the value of member horn_status
             * @return Value of member horn_status
             */
            eProsima_user_DllExport int32_t horn_status() const;

            /*!
             * @brief This function returns a reference to member horn_status
             * @return Reference to member horn_status
             */
            eProsima_user_DllExport int32_t& horn_status();

            /*!
             * @brief This function sets a value in member turn_lamp_status
             * @param _turn_lamp_status New value for member turn_lamp_status
             */
            eProsima_user_DllExport void turn_lamp_status(
                    int32_t _turn_lamp_status);

            /*!
             * @brief This function returns the value of member turn_lamp_status
             * @return Value of member turn_lamp_status
             */
            eProsima_user_DllExport int32_t turn_lamp_status() const;

            /*!
             * @brief This function returns a reference to member turn_lamp_status
             * @return Reference to member turn_lamp_status
             */
            eProsima_user_DllExport int32_t& turn_lamp_status();

            /*!
             * @brief This function sets a value in member front_wiper_status
             * @param _front_wiper_status New value for member front_wiper_status
             */
            eProsima_user_DllExport void front_wiper_status(
                    int32_t _front_wiper_status);

            /*!
             * @brief This function returns the value of member front_wiper_status
             * @return Value of member front_wiper_status
             */
            eProsima_user_DllExport int32_t front_wiper_status() const;

            /*!
             * @brief This function returns a reference to member front_wiper_status
             * @return Reference to member front_wiper_status
             */
            eProsima_user_DllExport int32_t& front_wiper_status();

            /*!
             * @brief This function sets a value in member rear_wiper_status
             * @param _rear_wiper_status New value for member rear_wiper_status
             */
            eProsima_user_DllExport void rear_wiper_status(
                    int32_t _rear_wiper_status);

            /*!
             * @brief This function returns the value of member rear_wiper_status
             * @return Value of member rear_wiper_status
             */
            eProsima_user_DllExport int32_t rear_wiper_status() const;

            /*!
             * @brief This function returns a reference to member rear_wiper_status
             * @return Reference to member rear_wiper_status
             */
            eProsima_user_DllExport int32_t& rear_wiper_status();

            /*!
             * @brief This function sets a value in member position_lamp_status
             * @param _position_lamp_status New value for member position_lamp_status
             */
            eProsima_user_DllExport void position_lamp_status(
                    int32_t _position_lamp_status);

            /*!
             * @brief This function returns the value of member position_lamp_status
             * @return Value of member position_lamp_status
             */
            eProsima_user_DllExport int32_t position_lamp_status() const;

            /*!
             * @brief This function returns a reference to member position_lamp_status
             * @return Reference to member position_lamp_status
             */
            eProsima_user_DllExport int32_t& position_lamp_status();

            /*!
             * @brief This function sets a value in member front_fog_lamp_status
             * @param _front_fog_lamp_status New value for member front_fog_lamp_status
             */
            eProsima_user_DllExport void front_fog_lamp_status(
                    int32_t _front_fog_lamp_status);

            /*!
             * @brief This function returns the value of member front_fog_lamp_status
             * @return Value of member front_fog_lamp_status
             */
            eProsima_user_DllExport int32_t front_fog_lamp_status() const;

            /*!
             * @brief This function returns a reference to member front_fog_lamp_status
             * @return Reference to member front_fog_lamp_status
             */
            eProsima_user_DllExport int32_t& front_fog_lamp_status();

            /*!
             * @brief This function sets a value in member rear_fog_lamp_status
             * @param _rear_fog_lamp_status New value for member rear_fog_lamp_status
             */
            eProsima_user_DllExport void rear_fog_lamp_status(
                    int32_t _rear_fog_lamp_status);

            /*!
             * @brief This function returns the value of member rear_fog_lamp_status
             * @return Value of member rear_fog_lamp_status
             */
            eProsima_user_DllExport int32_t rear_fog_lamp_status() const;

            /*!
             * @brief This function returns a reference to member rear_fog_lamp_status
             * @return Reference to member rear_fog_lamp_status
             */
            eProsima_user_DllExport int32_t& rear_fog_lamp_status();

            /*!
             * @brief This function sets a value in member brake_lamp_status
             * @param _brake_lamp_status New value for member brake_lamp_status
             */
            eProsima_user_DllExport void brake_lamp_status(
                    int32_t _brake_lamp_status);

            /*!
             * @brief This function returns the value of member brake_lamp_status
             * @return Value of member brake_lamp_status
             */
            eProsima_user_DllExport int32_t brake_lamp_status() const;

            /*!
             * @brief This function returns a reference to member brake_lamp_status
             * @return Reference to member brake_lamp_status
             */
            eProsima_user_DllExport int32_t& brake_lamp_status();

            /*!
             * @brief This function sets a value in member alarm_lamp_status
             * @param _alarm_lamp_status New value for member alarm_lamp_status
             */
            eProsima_user_DllExport void alarm_lamp_status(
                    int32_t _alarm_lamp_status);

            /*!
             * @brief This function returns the value of member alarm_lamp_status
             * @return Value of member alarm_lamp_status
             */
            eProsima_user_DllExport int32_t alarm_lamp_status() const;

            /*!
             * @brief This function returns a reference to member alarm_lamp_status
             * @return Reference to member alarm_lamp_status
             */
            eProsima_user_DllExport int32_t& alarm_lamp_status();

            /*!
             * @brief This function sets a value in member lf_door_status
             * @param _lf_door_status New value for member lf_door_status
             */
            eProsima_user_DllExport void lf_door_status(
                    int32_t _lf_door_status);

            /*!
             * @brief This function returns the value of member lf_door_status
             * @return Value of member lf_door_status
             */
            eProsima_user_DllExport int32_t lf_door_status() const;

            /*!
             * @brief This function returns a reference to member lf_door_status
             * @return Reference to member lf_door_status
             */
            eProsima_user_DllExport int32_t& lf_door_status();

            /*!
             * @brief This function sets a value in member rf_door_status
             * @param _rf_door_status New value for member rf_door_status
             */
            eProsima_user_DllExport void rf_door_status(
                    int32_t _rf_door_status);

            /*!
             * @brief This function returns the value of member rf_door_status
             * @return Value of member rf_door_status
             */
            eProsima_user_DllExport int32_t rf_door_status() const;

            /*!
             * @brief This function returns a reference to member rf_door_status
             * @return Reference to member rf_door_status
             */
            eProsima_user_DllExport int32_t& rf_door_status();

            /*!
             * @brief This function sets a value in member lr_door_status
             * @param _lr_door_status New value for member lr_door_status
             */
            eProsima_user_DllExport void lr_door_status(
                    int32_t _lr_door_status);

            /*!
             * @brief This function returns the value of member lr_door_status
             * @return Value of member lr_door_status
             */
            eProsima_user_DllExport int32_t lr_door_status() const;

            /*!
             * @brief This function returns a reference to member lr_door_status
             * @return Reference to member lr_door_status
             */
            eProsima_user_DllExport int32_t& lr_door_status();

            /*!
             * @brief This function sets a value in member rr_door_status
             * @param _rr_door_status New value for member rr_door_status
             */
            eProsima_user_DllExport void rr_door_status(
                    int32_t _rr_door_status);

            /*!
             * @brief This function returns the value of member rr_door_status
             * @return Value of member rr_door_status
             */
            eProsima_user_DllExport int32_t rr_door_status() const;

            /*!
             * @brief This function returns a reference to member rr_door_status
             * @return Reference to member rr_door_status
             */
            eProsima_user_DllExport int32_t& rr_door_status();

            /*!
             * @brief This function sets a value in member rearview_mirror_status
             * @param _rearview_mirror_status New value for member rearview_mirror_status
             */
            eProsima_user_DllExport void rearview_mirror_status(
                    int32_t _rearview_mirror_status);

            /*!
             * @brief This function returns the value of member rearview_mirror_status
             * @return Value of member rearview_mirror_status
             */
            eProsima_user_DllExport int32_t rearview_mirror_status() const;

            /*!
             * @brief This function returns a reference to member rearview_mirror_status
             * @return Reference to member rearview_mirror_status
             */
            eProsima_user_DllExport int32_t& rearview_mirror_status();

            /*!
             * @brief This function sets a value in member trunk_status
             * @param _trunk_status New value for member trunk_status
             */
            eProsima_user_DllExport void trunk_status(
                    int32_t _trunk_status);

            /*!
             * @brief This function returns the value of member trunk_status
             * @return Value of member trunk_status
             */
            eProsima_user_DllExport int32_t trunk_status() const;

            /*!
             * @brief This function returns a reference to member trunk_status
             * @return Reference to member trunk_status
             */
            eProsima_user_DllExport int32_t& trunk_status();

            /*!
             * @brief This function sets a value in member engine_bay_door_status
             * @param _engine_bay_door_status New value for member engine_bay_door_status
             */
            eProsima_user_DllExport void engine_bay_door_status(
                    int32_t _engine_bay_door_status);

            /*!
             * @brief This function returns the value of member engine_bay_door_status
             * @return Value of member engine_bay_door_status
             */
            eProsima_user_DllExport int32_t engine_bay_door_status() const;

            /*!
             * @brief This function returns a reference to member engine_bay_door_status
             * @return Reference to member engine_bay_door_status
             */
            eProsima_user_DllExport int32_t& engine_bay_door_status();

            /*!
             * @brief This function sets a value in member wheel_direction_rr
             * @param _wheel_direction_rr New value for member wheel_direction_rr
             */
            eProsima_user_DllExport void wheel_direction_rr(
                    int32_t _wheel_direction_rr);

            /*!
             * @brief This function returns the value of member wheel_direction_rr
             * @return Value of member wheel_direction_rr
             */
            eProsima_user_DllExport int32_t wheel_direction_rr() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_rr
             * @return Reference to member wheel_direction_rr
             */
            eProsima_user_DllExport int32_t& wheel_direction_rr();

            /*!
             * @brief This function sets a value in member wheel_spd_rr
             * @param _wheel_spd_rr New value for member wheel_spd_rr
             */
            eProsima_user_DllExport void wheel_spd_rr(
                    double _wheel_spd_rr);

            /*!
             * @brief This function returns the value of member wheel_spd_rr
             * @return Value of member wheel_spd_rr
             */
            eProsima_user_DllExport double wheel_spd_rr() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_rr
             * @return Reference to member wheel_spd_rr
             */
            eProsima_user_DllExport double& wheel_spd_rr();

            /*!
             * @brief This function sets a value in member wheel_direction_rl
             * @param _wheel_direction_rl New value for member wheel_direction_rl
             */
            eProsima_user_DllExport void wheel_direction_rl(
                    int32_t _wheel_direction_rl);

            /*!
             * @brief This function returns the value of member wheel_direction_rl
             * @return Value of member wheel_direction_rl
             */
            eProsima_user_DllExport int32_t wheel_direction_rl() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_rl
             * @return Reference to member wheel_direction_rl
             */
            eProsima_user_DllExport int32_t& wheel_direction_rl();

            /*!
             * @brief This function sets a value in member wheel_spd_rl
             * @param _wheel_spd_rl New value for member wheel_spd_rl
             */
            eProsima_user_DllExport void wheel_spd_rl(
                    double _wheel_spd_rl);

            /*!
             * @brief This function returns the value of member wheel_spd_rl
             * @return Value of member wheel_spd_rl
             */
            eProsima_user_DllExport double wheel_spd_rl() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_rl
             * @return Reference to member wheel_spd_rl
             */
            eProsima_user_DllExport double& wheel_spd_rl();

            /*!
             * @brief This function sets a value in member wheel_direction_fr
             * @param _wheel_direction_fr New value for member wheel_direction_fr
             */
            eProsima_user_DllExport void wheel_direction_fr(
                    int32_t _wheel_direction_fr);

            /*!
             * @brief This function returns the value of member wheel_direction_fr
             * @return Value of member wheel_direction_fr
             */
            eProsima_user_DllExport int32_t wheel_direction_fr() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_fr
             * @return Reference to member wheel_direction_fr
             */
            eProsima_user_DllExport int32_t& wheel_direction_fr();

            /*!
             * @brief This function sets a value in member wheel_spd_fr
             * @param _wheel_spd_fr New value for member wheel_spd_fr
             */
            eProsima_user_DllExport void wheel_spd_fr(
                    double _wheel_spd_fr);

            /*!
             * @brief This function returns the value of member wheel_spd_fr
             * @return Value of member wheel_spd_fr
             */
            eProsima_user_DllExport double wheel_spd_fr() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_fr
             * @return Reference to member wheel_spd_fr
             */
            eProsima_user_DllExport double& wheel_spd_fr();

            /*!
             * @brief This function sets a value in member wheel_direction_fl
             * @param _wheel_direction_fl New value for member wheel_direction_fl
             */
            eProsima_user_DllExport void wheel_direction_fl(
                    int32_t _wheel_direction_fl);

            /*!
             * @brief This function returns the value of member wheel_direction_fl
             * @return Value of member wheel_direction_fl
             */
            eProsima_user_DllExport int32_t wheel_direction_fl() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_fl
             * @return Reference to member wheel_direction_fl
             */
            eProsima_user_DllExport int32_t& wheel_direction_fl();

            /*!
             * @brief This function sets a value in member wheel_spd_fl
             * @param _wheel_spd_fl New value for member wheel_spd_fl
             */
            eProsima_user_DllExport void wheel_spd_fl(
                    double _wheel_spd_fl);

            /*!
             * @brief This function returns the value of member wheel_spd_fl
             * @return Value of member wheel_spd_fl
             */
            eProsima_user_DllExport double wheel_spd_fl() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_fl
             * @return Reference to member wheel_spd_fl
             */
            eProsima_user_DllExport double& wheel_spd_fl();

            /*!
             * @brief This function sets a value in member is_wss_rr_edges_sum_valid
             * @param _is_wss_rr_edges_sum_valid New value for member is_wss_rr_edges_sum_valid
             */
            eProsima_user_DllExport void is_wss_rr_edges_sum_valid(
                    bool _is_wss_rr_edges_sum_valid);

            /*!
             * @brief This function returns the value of member is_wss_rr_edges_sum_valid
             * @return Value of member is_wss_rr_edges_sum_valid
             */
            eProsima_user_DllExport bool is_wss_rr_edges_sum_valid() const;

            /*!
             * @brief This function returns a reference to member is_wss_rr_edges_sum_valid
             * @return Reference to member is_wss_rr_edges_sum_valid
             */
            eProsima_user_DllExport bool& is_wss_rr_edges_sum_valid();

            /*!
             * @brief This function sets a value in member wss_rr_edges_sum
             * @param _wss_rr_edges_sum New value for member wss_rr_edges_sum
             */
            eProsima_user_DllExport void wss_rr_edges_sum(
                    int32_t _wss_rr_edges_sum);

            /*!
             * @brief This function returns the value of member wss_rr_edges_sum
             * @return Value of member wss_rr_edges_sum
             */
            eProsima_user_DllExport int32_t wss_rr_edges_sum() const;

            /*!
             * @brief This function returns a reference to member wss_rr_edges_sum
             * @return Reference to member wss_rr_edges_sum
             */
            eProsima_user_DllExport int32_t& wss_rr_edges_sum();

            /*!
             * @brief This function sets a value in member is_wss_rl_edges_sum_valid
             * @param _is_wss_rl_edges_sum_valid New value for member is_wss_rl_edges_sum_valid
             */
            eProsima_user_DllExport void is_wss_rl_edges_sum_valid(
                    bool _is_wss_rl_edges_sum_valid);

            /*!
             * @brief This function returns the value of member is_wss_rl_edges_sum_valid
             * @return Value of member is_wss_rl_edges_sum_valid
             */
            eProsima_user_DllExport bool is_wss_rl_edges_sum_valid() const;

            /*!
             * @brief This function returns a reference to member is_wss_rl_edges_sum_valid
             * @return Reference to member is_wss_rl_edges_sum_valid
             */
            eProsima_user_DllExport bool& is_wss_rl_edges_sum_valid();

            /*!
             * @brief This function sets a value in member wss_rl_edges_sum
             * @param _wss_rl_edges_sum New value for member wss_rl_edges_sum
             */
            eProsima_user_DllExport void wss_rl_edges_sum(
                    int32_t _wss_rl_edges_sum);

            /*!
             * @brief This function returns the value of member wss_rl_edges_sum
             * @return Value of member wss_rl_edges_sum
             */
            eProsima_user_DllExport int32_t wss_rl_edges_sum() const;

            /*!
             * @brief This function returns a reference to member wss_rl_edges_sum
             * @return Reference to member wss_rl_edges_sum
             */
            eProsima_user_DllExport int32_t& wss_rl_edges_sum();

            /*!
             * @brief This function sets a value in member is_wss_fr_edges_sum_valid
             * @param _is_wss_fr_edges_sum_valid New value for member is_wss_fr_edges_sum_valid
             */
            eProsima_user_DllExport void is_wss_fr_edges_sum_valid(
                    bool _is_wss_fr_edges_sum_valid);

            /*!
             * @brief This function returns the value of member is_wss_fr_edges_sum_valid
             * @return Value of member is_wss_fr_edges_sum_valid
             */
            eProsima_user_DllExport bool is_wss_fr_edges_sum_valid() const;

            /*!
             * @brief This function returns a reference to member is_wss_fr_edges_sum_valid
             * @return Reference to member is_wss_fr_edges_sum_valid
             */
            eProsima_user_DllExport bool& is_wss_fr_edges_sum_valid();

            /*!
             * @brief This function sets a value in member wss_fr_edges_sum
             * @param _wss_fr_edges_sum New value for member wss_fr_edges_sum
             */
            eProsima_user_DllExport void wss_fr_edges_sum(
                    int32_t _wss_fr_edges_sum);

            /*!
             * @brief This function returns the value of member wss_fr_edges_sum
             * @return Value of member wss_fr_edges_sum
             */
            eProsima_user_DllExport int32_t wss_fr_edges_sum() const;

            /*!
             * @brief This function returns a reference to member wss_fr_edges_sum
             * @return Reference to member wss_fr_edges_sum
             */
            eProsima_user_DllExport int32_t& wss_fr_edges_sum();

            /*!
             * @brief This function sets a value in member is_wss_fl_edges_sum_valid
             * @param _is_wss_fl_edges_sum_valid New value for member is_wss_fl_edges_sum_valid
             */
            eProsima_user_DllExport void is_wss_fl_edges_sum_valid(
                    bool _is_wss_fl_edges_sum_valid);

            /*!
             * @brief This function returns the value of member is_wss_fl_edges_sum_valid
             * @return Value of member is_wss_fl_edges_sum_valid
             */
            eProsima_user_DllExport bool is_wss_fl_edges_sum_valid() const;

            /*!
             * @brief This function returns a reference to member is_wss_fl_edges_sum_valid
             * @return Reference to member is_wss_fl_edges_sum_valid
             */
            eProsima_user_DllExport bool& is_wss_fl_edges_sum_valid();

            /*!
             * @brief This function sets a value in member wss_fl_edges_sum
             * @param _wss_fl_edges_sum New value for member wss_fl_edges_sum
             */
            eProsima_user_DllExport void wss_fl_edges_sum(
                    int32_t _wss_fl_edges_sum);

            /*!
             * @brief This function returns the value of member wss_fl_edges_sum
             * @return Value of member wss_fl_edges_sum
             */
            eProsima_user_DllExport int32_t wss_fl_edges_sum() const;

            /*!
             * @brief This function returns a reference to member wss_fl_edges_sum
             * @return Reference to member wss_fl_edges_sum
             */
            eProsima_user_DllExport int32_t& wss_fl_edges_sum();

            /*!
             * @brief This function sets a value in member is_tire_pressure_ok
             * @param _is_tire_pressure_ok New value for member is_tire_pressure_ok
             */
            eProsima_user_DllExport void is_tire_pressure_ok(
                    int32_t _is_tire_pressure_ok);

            /*!
             * @brief This function returns the value of member is_tire_pressure_ok
             * @return Value of member is_tire_pressure_ok
             */
            eProsima_user_DllExport int32_t is_tire_pressure_ok() const;

            /*!
             * @brief This function returns a reference to member is_tire_pressure_ok
             * @return Reference to member is_tire_pressure_ok
             */
            eProsima_user_DllExport int32_t& is_tire_pressure_ok();

            /*!
             * @brief This function sets a value in member is_tire_pressure_lf_valid
             * @param _is_tire_pressure_lf_valid New value for member is_tire_pressure_lf_valid
             */
            eProsima_user_DllExport void is_tire_pressure_lf_valid(
                    int32_t _is_tire_pressure_lf_valid);

            /*!
             * @brief This function returns the value of member is_tire_pressure_lf_valid
             * @return Value of member is_tire_pressure_lf_valid
             */
            eProsima_user_DllExport int32_t is_tire_pressure_lf_valid() const;

            /*!
             * @brief This function returns a reference to member is_tire_pressure_lf_valid
             * @return Reference to member is_tire_pressure_lf_valid
             */
            eProsima_user_DllExport int32_t& is_tire_pressure_lf_valid();

            /*!
             * @brief This function sets a value in member tire_pressure_lf
             * @param _tire_pressure_lf New value for member tire_pressure_lf
             */
            eProsima_user_DllExport void tire_pressure_lf(
                    double _tire_pressure_lf);

            /*!
             * @brief This function returns the value of member tire_pressure_lf
             * @return Value of member tire_pressure_lf
             */
            eProsima_user_DllExport double tire_pressure_lf() const;

            /*!
             * @brief This function returns a reference to member tire_pressure_lf
             * @return Reference to member tire_pressure_lf
             */
            eProsima_user_DllExport double& tire_pressure_lf();

            /*!
             * @brief This function sets a value in member is_tire_pressure_rf_valid
             * @param _is_tire_pressure_rf_valid New value for member is_tire_pressure_rf_valid
             */
            eProsima_user_DllExport void is_tire_pressure_rf_valid(
                    int32_t _is_tire_pressure_rf_valid);

            /*!
             * @brief This function returns the value of member is_tire_pressure_rf_valid
             * @return Value of member is_tire_pressure_rf_valid
             */
            eProsima_user_DllExport int32_t is_tire_pressure_rf_valid() const;

            /*!
             * @brief This function returns a reference to member is_tire_pressure_rf_valid
             * @return Reference to member is_tire_pressure_rf_valid
             */
            eProsima_user_DllExport int32_t& is_tire_pressure_rf_valid();

            /*!
             * @brief This function sets a value in member tire_pressure_rf
             * @param _tire_pressure_rf New value for member tire_pressure_rf
             */
            eProsima_user_DllExport void tire_pressure_rf(
                    double _tire_pressure_rf);

            /*!
             * @brief This function returns the value of member tire_pressure_rf
             * @return Value of member tire_pressure_rf
             */
            eProsima_user_DllExport double tire_pressure_rf() const;

            /*!
             * @brief This function returns a reference to member tire_pressure_rf
             * @return Reference to member tire_pressure_rf
             */
            eProsima_user_DllExport double& tire_pressure_rf();

            /*!
             * @brief This function sets a value in member is_tire_pressure_lr_valid
             * @param _is_tire_pressure_lr_valid New value for member is_tire_pressure_lr_valid
             */
            eProsima_user_DllExport void is_tire_pressure_lr_valid(
                    int32_t _is_tire_pressure_lr_valid);

            /*!
             * @brief This function returns the value of member is_tire_pressure_lr_valid
             * @return Value of member is_tire_pressure_lr_valid
             */
            eProsima_user_DllExport int32_t is_tire_pressure_lr_valid() const;

            /*!
             * @brief This function returns a reference to member is_tire_pressure_lr_valid
             * @return Reference to member is_tire_pressure_lr_valid
             */
            eProsima_user_DllExport int32_t& is_tire_pressure_lr_valid();

            /*!
             * @brief This function sets a value in member tire_pressure_lr
             * @param _tire_pressure_lr New value for member tire_pressure_lr
             */
            eProsima_user_DllExport void tire_pressure_lr(
                    double _tire_pressure_lr);

            /*!
             * @brief This function returns the value of member tire_pressure_lr
             * @return Value of member tire_pressure_lr
             */
            eProsima_user_DllExport double tire_pressure_lr() const;

            /*!
             * @brief This function returns a reference to member tire_pressure_lr
             * @return Reference to member tire_pressure_lr
             */
            eProsima_user_DllExport double& tire_pressure_lr();

            /*!
             * @brief This function sets a value in member is_tire_pressure_rr_valid
             * @param _is_tire_pressure_rr_valid New value for member is_tire_pressure_rr_valid
             */
            eProsima_user_DllExport void is_tire_pressure_rr_valid(
                    int32_t _is_tire_pressure_rr_valid);

            /*!
             * @brief This function returns the value of member is_tire_pressure_rr_valid
             * @return Value of member is_tire_pressure_rr_valid
             */
            eProsima_user_DllExport int32_t is_tire_pressure_rr_valid() const;

            /*!
             * @brief This function returns a reference to member is_tire_pressure_rr_valid
             * @return Reference to member is_tire_pressure_rr_valid
             */
            eProsima_user_DllExport int32_t& is_tire_pressure_rr_valid();

            /*!
             * @brief This function sets a value in member tire_pressure_rr
             * @param _tire_pressure_rr New value for member tire_pressure_rr
             */
            eProsima_user_DllExport void tire_pressure_rr(
                    double _tire_pressure_rr);

            /*!
             * @brief This function returns the value of member tire_pressure_rr
             * @return Value of member tire_pressure_rr
             */
            eProsima_user_DllExport double tire_pressure_rr() const;

            /*!
             * @brief This function returns a reference to member tire_pressure_rr
             * @return Reference to member tire_pressure_rr
             */
            eProsima_user_DllExport double& tire_pressure_rr();

            /*!
             * @brief This function sets a value in member air_bag_status
             * @param _air_bag_status New value for member air_bag_status
             */
            eProsima_user_DllExport void air_bag_status(
                    int32_t _air_bag_status);

            /*!
             * @brief This function returns the value of member air_bag_status
             * @return Value of member air_bag_status
             */
            eProsima_user_DllExport int32_t air_bag_status() const;

            /*!
             * @brief This function returns a reference to member air_bag_status
             * @return Reference to member air_bag_status
             */
            eProsima_user_DllExport int32_t& air_bag_status();

            /*!
             * @brief This function sets a value in member charging_gun_status
             * @param _charging_gun_status New value for member charging_gun_status
             */
            eProsima_user_DllExport void charging_gun_status(
                    int32_t _charging_gun_status);

            /*!
             * @brief This function returns the value of member charging_gun_status
             * @return Value of member charging_gun_status
             */
            eProsima_user_DllExport int32_t charging_gun_status() const;

            /*!
             * @brief This function returns a reference to member charging_gun_status
             * @return Reference to member charging_gun_status
             */
            eProsima_user_DllExport int32_t& charging_gun_status();

            /*!
             * @brief This function sets a value in member charge
             * @param _charge New value for member charge
             */
            eProsima_user_DllExport void charge(
                    int32_t _charge);

            /*!
             * @brief This function returns the value of member charge
             * @return Value of member charge
             */
            eProsima_user_DllExport int32_t charge() const;

            /*!
             * @brief This function returns a reference to member charge
             * @return Reference to member charge
             */
            eProsima_user_DllExport int32_t& charge();

            /*!
             * @brief This function sets a value in member vehicle_power_status
             * @param _vehicle_power_status New value for member vehicle_power_status
             */
            eProsima_user_DllExport void vehicle_power_status(
                    int32_t _vehicle_power_status);

            /*!
             * @brief This function returns the value of member vehicle_power_status
             * @return Value of member vehicle_power_status
             */
            eProsima_user_DllExport int32_t vehicle_power_status() const;

            /*!
             * @brief This function returns a reference to member vehicle_power_status
             * @return Reference to member vehicle_power_status
             */
            eProsima_user_DllExport int32_t& vehicle_power_status();

            /*!
             * @brief This function copies the value in member chassis_error_code
             * @param _chassis_error_code New value to be copied in member chassis_error_code
             */
            eProsima_user_DllExport void chassis_error_code(
                    const std::vector<int32_t>& _chassis_error_code);

            /*!
             * @brief This function moves the value in member chassis_error_code
             * @param _chassis_error_code New value to be moved in member chassis_error_code
             */
            eProsima_user_DllExport void chassis_error_code(
                    std::vector<int32_t>&& _chassis_error_code);

            /*!
             * @brief This function returns a constant reference to member chassis_error_code
             * @return Constant reference to member chassis_error_code
             */
            eProsima_user_DllExport const std::vector<int32_t>& chassis_error_code() const;

            /*!
             * @brief This function returns a reference to member chassis_error_code
             * @return Reference to member chassis_error_code
             */
            eProsima_user_DllExport std::vector<int32_t>& chassis_error_code();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Chassis& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_moving_status;
            int32_t m_driving_mode;
            int32_t m_steer_driving_mode;
            int32_t m_steering_status;
            double m_front_steering_value;
            double m_rear_steering_value;
            double m_steering_torque_nm;
            double m_front_steering_rate_dps;
            double m_rear_steering_rate_dps;
            int32_t m_accel_driving_mode;
            int32_t m_accel_status;
            double m_accel_value;
            int32_t m_brake_driving_mode;
            int32_t m_brake_status;
            double m_brake_value;
            int32_t m_brake_padel;
            bool m_lf_wheel_wheel_brake_status;
            bool m_rf_wheel_wheel_brake_status;
            bool m_lr_wheel_wheel_brake_status;
            bool m_rr_wheel_wheel_brake_status;
            int32_t m_backup_brake_driving_mode;
            int32_t m_backup_brake_status;
            double m_backup_brake_value;
            int32_t m_epb_driving_mode;
            int32_t m_epb_status;
            int32_t m_epb_level;
            int32_t m_gear_driving_mode;
            int32_t m_gear_status;
            int32_t m_gear_location;
            double m_engine_rpm;
            double m_engine_torque;
            bool m_is_speed_valid;
            double m_speed_mps;
            bool m_is_veh_lat_accel_valid;
            double m_veh_lat_accel;
            bool m_is_veh_lon_accel_valid;
            double m_veh_lon_accel;
            bool m_is_yaw_rate_valid;
            double m_yaw_rate;
            double m_odometer_m;
            int32_t m_daytime_running_lights_status;
            int32_t m_automatic_light_control_status;
            int32_t m_parking_lights_status;
            int32_t m_high_beam_status;
            int32_t m_low_beam_status;
            int32_t m_horn_status;
            int32_t m_turn_lamp_status;
            int32_t m_front_wiper_status;
            int32_t m_rear_wiper_status;
            int32_t m_position_lamp_status;
            int32_t m_front_fog_lamp_status;
            int32_t m_rear_fog_lamp_status;
            int32_t m_brake_lamp_status;
            int32_t m_alarm_lamp_status;
            int32_t m_lf_door_status;
            int32_t m_rf_door_status;
            int32_t m_lr_door_status;
            int32_t m_rr_door_status;
            int32_t m_rearview_mirror_status;
            int32_t m_trunk_status;
            int32_t m_engine_bay_door_status;
            int32_t m_wheel_direction_rr;
            double m_wheel_spd_rr;
            int32_t m_wheel_direction_rl;
            double m_wheel_spd_rl;
            int32_t m_wheel_direction_fr;
            double m_wheel_spd_fr;
            int32_t m_wheel_direction_fl;
            double m_wheel_spd_fl;
            bool m_is_wss_rr_edges_sum_valid;
            int32_t m_wss_rr_edges_sum;
            bool m_is_wss_rl_edges_sum_valid;
            int32_t m_wss_rl_edges_sum;
            bool m_is_wss_fr_edges_sum_valid;
            int32_t m_wss_fr_edges_sum;
            bool m_is_wss_fl_edges_sum_valid;
            int32_t m_wss_fl_edges_sum;
            int32_t m_is_tire_pressure_ok;
            int32_t m_is_tire_pressure_lf_valid;
            double m_tire_pressure_lf;
            int32_t m_is_tire_pressure_rf_valid;
            double m_tire_pressure_rf;
            int32_t m_is_tire_pressure_lr_valid;
            double m_tire_pressure_lr;
            int32_t m_is_tire_pressure_rr_valid;
            double m_tire_pressure_rr;
            int32_t m_air_bag_status;
            int32_t m_charging_gun_status;
            int32_t m_charge;
            int32_t m_vehicle_power_status;
            std::vector<int32_t> m_chassis_error_code;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CHASSIS_H_

