// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CommCommand.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "CommCommand.h"
#include "CommCommandTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_CommCommand_max_cdr_typesize 27340ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Command_max_cdr_typesize 268ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_CommCommand_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Command_max_key_cdr_typesize 0ULL;

ros2_interface::msg::CommCommand::CommCommand()
{
    // ros2_interface::msg::Header m_header

    // string m_name
    m_name ="";
    // int8 m_self_id
    m_self_id = 0;
    // sequence<ros2_interface::msg::Command> m_commands


    // Just to register all known types
    registerCommCommandTypes();
}

ros2_interface::msg::CommCommand::~CommCommand()
{




}

ros2_interface::msg::CommCommand::CommCommand(
        const CommCommand& x)
{
    m_header = x.m_header;
    m_name = x.m_name;
    m_self_id = x.m_self_id;
    m_commands = x.m_commands;
}

ros2_interface::msg::CommCommand::CommCommand(
        CommCommand&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_name = std::move(x.m_name);
    m_self_id = x.m_self_id;
    m_commands = std::move(x.m_commands);
}

ros2_interface::msg::CommCommand& ros2_interface::msg::CommCommand::operator =(
        const CommCommand& x)
{

    m_header = x.m_header;
    m_name = x.m_name;
    m_self_id = x.m_self_id;
    m_commands = x.m_commands;

    return *this;
}

ros2_interface::msg::CommCommand& ros2_interface::msg::CommCommand::operator =(
        CommCommand&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_name = std::move(x.m_name);
    m_self_id = x.m_self_id;
    m_commands = std::move(x.m_commands);

    return *this;
}

bool ros2_interface::msg::CommCommand::operator ==(
        const CommCommand& x) const
{

    return (m_header == x.m_header && m_name == x.m_name && m_self_id == x.m_self_id && m_commands == x.m_commands);
}

bool ros2_interface::msg::CommCommand::operator !=(
        const CommCommand& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::CommCommand::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_CommCommand_max_cdr_typesize;
}

size_t ros2_interface::msg::CommCommand::getCdrSerializedSize(
        const ros2_interface::msg::CommCommand& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.commands().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Command::getCdrSerializedSize(data.commands().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::CommCommand::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_name.c_str();
    scdr << m_self_id;
    scdr << m_commands;

}

void ros2_interface::msg::CommCommand::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_name;
    dcdr >> m_self_id;
    dcdr >> m_commands;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::CommCommand::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::CommCommand::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::CommCommand::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::CommCommand::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::CommCommand::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::CommCommand::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::CommCommand::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::CommCommand::name()
{
    return m_name;
}
/*!
 * @brief This function sets a value in member self_id
 * @param _self_id New value for member self_id
 */
void ros2_interface::msg::CommCommand::self_id(
        int8_t _self_id)
{
    m_self_id = _self_id;
}

/*!
 * @brief This function returns the value of member self_id
 * @return Value of member self_id
 */
int8_t ros2_interface::msg::CommCommand::self_id() const
{
    return m_self_id;
}

/*!
 * @brief This function returns a reference to member self_id
 * @return Reference to member self_id
 */
int8_t& ros2_interface::msg::CommCommand::self_id()
{
    return m_self_id;
}

/*!
 * @brief This function copies the value in member commands
 * @param _commands New value to be copied in member commands
 */
void ros2_interface::msg::CommCommand::commands(
        const std::vector<ros2_interface::msg::Command>& _commands)
{
    m_commands = _commands;
}

/*!
 * @brief This function moves the value in member commands
 * @param _commands New value to be moved in member commands
 */
void ros2_interface::msg::CommCommand::commands(
        std::vector<ros2_interface::msg::Command>&& _commands)
{
    m_commands = std::move(_commands);
}

/*!
 * @brief This function returns a constant reference to member commands
 * @return Constant reference to member commands
 */
const std::vector<ros2_interface::msg::Command>& ros2_interface::msg::CommCommand::commands() const
{
    return m_commands;
}

/*!
 * @brief This function returns a reference to member commands
 * @return Reference to member commands
 */
std::vector<ros2_interface::msg::Command>& ros2_interface::msg::CommCommand::commands()
{
    return m_commands;
}


size_t ros2_interface::msg::CommCommand::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_CommCommand_max_key_cdr_typesize;
}

bool ros2_interface::msg::CommCommand::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::CommCommand::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



