// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CommCommandTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "CommCommand.h"
#include "CommCommandTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerCommCommandTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Command", ros2_interface::msg::GetCommandIdentifier(true),
                        ros2_interface::msg::GetCommandObject(true));
                factory->add_type_object("ros2_interface::msg::Command", ros2_interface::msg::GetCommandIdentifier(false),
                        ros2_interface::msg::GetCommandObject(false));



                factory->add_type_object("ros2_interface::msg::CommCommand", ros2_interface::msg::GetCommCommandIdentifier(true),
                        ros2_interface::msg::GetCommCommandObject(true));
                factory->add_type_object("ros2_interface::msg::CommCommand", ros2_interface::msg::GetCommCommandIdentifier(false),
                        ros2_interface::msg::GetCommCommandObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetCommCommandIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("CommCommand", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetCommCommandObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("CommCommand", complete);
        }

        const TypeObject* GetCommCommandObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CommCommand", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteCommCommandObject();
            }
            //else
            return GetMinimalCommCommandObject();
        }

        const TypeObject* GetMinimalCommCommandObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CommCommand", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_name;
            mst_name.common().member_id(memberId++);
            mst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_name.common().member_flags().IS_OPTIONAL(false);
            mst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_name.common().member_flags().IS_KEY(false);
            mst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 name_hash("name");
            for(int i = 0; i < 4; ++i)
            {
                mst_name.detail().name_hash()[i] = name_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_name);

            MinimalStructMember mst_self_id;
            mst_self_id.common().member_id(memberId++);
            mst_self_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_self_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_self_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_self_id.common().member_flags().IS_OPTIONAL(false);
            mst_self_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_self_id.common().member_flags().IS_KEY(false);
            mst_self_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_self_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 self_id_hash("self_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_self_id.detail().name_hash()[i] = self_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_self_id);

            MinimalStructMember mst_commands;
            mst_commands.common().member_id(memberId++);
            mst_commands.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_commands.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_commands.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_commands.common().member_flags().IS_OPTIONAL(false);
            mst_commands.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_commands.common().member_flags().IS_KEY(false);
            mst_commands.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_commands.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Command", 100, false));


            MD5 commands_hash("commands");
            for(int i = 0; i < 4; ++i)
            {
                mst_commands.detail().name_hash()[i] = commands_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_commands);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CommCommand", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CommCommand", false);
        }

        const TypeObject* GetCompleteCommCommandObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CommCommand", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_name;
            cst_name.common().member_id(memberId++);
            cst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_name.common().member_flags().IS_OPTIONAL(false);
            cst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_name.common().member_flags().IS_KEY(false);
            cst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_name.detail().name("name");

            type_object->complete().struct_type().member_seq().emplace_back(cst_name);

            CompleteStructMember cst_self_id;
            cst_self_id.common().member_id(memberId++);
            cst_self_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_self_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_self_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_self_id.common().member_flags().IS_OPTIONAL(false);
            cst_self_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_self_id.common().member_flags().IS_KEY(false);
            cst_self_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_self_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_self_id.detail().name("self_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_self_id);

            CompleteStructMember cst_commands;
            cst_commands.common().member_id(memberId++);
            cst_commands.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_commands.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_commands.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_commands.common().member_flags().IS_OPTIONAL(false);
            cst_commands.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_commands.common().member_flags().IS_KEY(false);
            cst_commands.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_commands.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Command", 100, true));


            cst_commands.detail().name("commands");

            type_object->complete().struct_type().member_seq().emplace_back(cst_commands);


            // Header
            type_object->complete().struct_type().header().detail().type_name("CommCommand");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CommCommand", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CommCommand", true);
        }

    } // namespace msg
} // namespace ros2_interface