// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Command.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Command.h"
#include "CommandTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Command_max_cdr_typesize 268ULL;
#define ros2_interface_msg_Command_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Command::Command()
{
    // string m_target_module
    m_target_module ="";
    // int8 m_target_id
    m_target_id = 0;
    // long m_target_switch
    m_target_switch = 0;

    // Just to register all known types
    registerCommandTypes();
}

ros2_interface::msg::Command::~Command()
{



}

ros2_interface::msg::Command::Command(
        const Command& x)
{
    m_target_module = x.m_target_module;
    m_target_id = x.m_target_id;
    m_target_switch = x.m_target_switch;
}

ros2_interface::msg::Command::Command(
        Command&& x) noexcept 
{
    m_target_module = std::move(x.m_target_module);
    m_target_id = x.m_target_id;
    m_target_switch = x.m_target_switch;
}

ros2_interface::msg::Command& ros2_interface::msg::Command::operator =(
        const Command& x)
{

    m_target_module = x.m_target_module;
    m_target_id = x.m_target_id;
    m_target_switch = x.m_target_switch;

    return *this;
}

ros2_interface::msg::Command& ros2_interface::msg::Command::operator =(
        Command&& x) noexcept
{

    m_target_module = std::move(x.m_target_module);
    m_target_id = x.m_target_id;
    m_target_switch = x.m_target_switch;

    return *this;
}

bool ros2_interface::msg::Command::operator ==(
        const Command& x) const
{

    return (m_target_module == x.m_target_module && m_target_id == x.m_target_id && m_target_switch == x.m_target_switch);
}

bool ros2_interface::msg::Command::operator !=(
        const Command& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Command::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Command_max_cdr_typesize;
}

size_t ros2_interface::msg::Command::getCdrSerializedSize(
        const ros2_interface::msg::Command& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.target_module().size() + 1;

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Command::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_target_module.c_str();
    scdr << m_target_id;
    scdr << m_target_switch;

}

void ros2_interface::msg::Command::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_target_module;
    dcdr >> m_target_id;
    dcdr >> m_target_switch;
}

/*!
 * @brief This function copies the value in member target_module
 * @param _target_module New value to be copied in member target_module
 */
void ros2_interface::msg::Command::target_module(
        const std::string& _target_module)
{
    m_target_module = _target_module;
}

/*!
 * @brief This function moves the value in member target_module
 * @param _target_module New value to be moved in member target_module
 */
void ros2_interface::msg::Command::target_module(
        std::string&& _target_module)
{
    m_target_module = std::move(_target_module);
}

/*!
 * @brief This function returns a constant reference to member target_module
 * @return Constant reference to member target_module
 */
const std::string& ros2_interface::msg::Command::target_module() const
{
    return m_target_module;
}

/*!
 * @brief This function returns a reference to member target_module
 * @return Reference to member target_module
 */
std::string& ros2_interface::msg::Command::target_module()
{
    return m_target_module;
}
/*!
 * @brief This function sets a value in member target_id
 * @param _target_id New value for member target_id
 */
void ros2_interface::msg::Command::target_id(
        int8_t _target_id)
{
    m_target_id = _target_id;
}

/*!
 * @brief This function returns the value of member target_id
 * @return Value of member target_id
 */
int8_t ros2_interface::msg::Command::target_id() const
{
    return m_target_id;
}

/*!
 * @brief This function returns a reference to member target_id
 * @return Reference to member target_id
 */
int8_t& ros2_interface::msg::Command::target_id()
{
    return m_target_id;
}

/*!
 * @brief This function sets a value in member target_switch
 * @param _target_switch New value for member target_switch
 */
void ros2_interface::msg::Command::target_switch(
        int32_t _target_switch)
{
    m_target_switch = _target_switch;
}

/*!
 * @brief This function returns the value of member target_switch
 * @return Value of member target_switch
 */
int32_t ros2_interface::msg::Command::target_switch() const
{
    return m_target_switch;
}

/*!
 * @brief This function returns a reference to member target_switch
 * @return Reference to member target_switch
 */
int32_t& ros2_interface::msg::Command::target_switch()
{
    return m_target_switch;
}



size_t ros2_interface::msg::Command::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Command_max_key_cdr_typesize;
}

bool ros2_interface::msg::Command::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Command::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



