// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Command.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMAND_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMAND_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(COMMAND_SOURCE)
#define COMMAND_DllAPI __declspec( dllexport )
#else
#define COMMAND_DllAPI __declspec( dllimport )
#endif // COMMAND_SOURCE
#else
#define COMMAND_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define COMMAND_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Command defined by the user in the IDL file.
         * @ingroup Command
         */
        class Command
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Command();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Command();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Command that will be copied.
             */
            eProsima_user_DllExport Command(
                    const Command& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Command that will be copied.
             */
            eProsima_user_DllExport Command(
                    Command&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Command that will be copied.
             */
            eProsima_user_DllExport Command& operator =(
                    const Command& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Command that will be copied.
             */
            eProsima_user_DllExport Command& operator =(
                    Command&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Command object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Command& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Command object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Command& x) const;

            /*!
             * @brief This function copies the value in member target_module
             * @param _target_module New value to be copied in member target_module
             */
            eProsima_user_DllExport void target_module(
                    const std::string& _target_module);

            /*!
             * @brief This function moves the value in member target_module
             * @param _target_module New value to be moved in member target_module
             */
            eProsima_user_DllExport void target_module(
                    std::string&& _target_module);

            /*!
             * @brief This function returns a constant reference to member target_module
             * @return Constant reference to member target_module
             */
            eProsima_user_DllExport const std::string& target_module() const;

            /*!
             * @brief This function returns a reference to member target_module
             * @return Reference to member target_module
             */
            eProsima_user_DllExport std::string& target_module();
            /*!
             * @brief This function sets a value in member target_id
             * @param _target_id New value for member target_id
             */
            eProsima_user_DllExport void target_id(
                    int8_t _target_id);

            /*!
             * @brief This function returns the value of member target_id
             * @return Value of member target_id
             */
            eProsima_user_DllExport int8_t target_id() const;

            /*!
             * @brief This function returns a reference to member target_id
             * @return Reference to member target_id
             */
            eProsima_user_DllExport int8_t& target_id();

            /*!
             * @brief This function sets a value in member target_switch
             * @param _target_switch New value for member target_switch
             */
            eProsima_user_DllExport void target_switch(
                    int32_t _target_switch);

            /*!
             * @brief This function returns the value of member target_switch
             * @return Value of member target_switch
             */
            eProsima_user_DllExport int32_t target_switch() const;

            /*!
             * @brief This function returns a reference to member target_switch
             * @return Reference to member target_switch
             */
            eProsima_user_DllExport int32_t& target_switch();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Command& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::string m_target_module;
            int8_t m_target_id;
            int32_t m_target_switch;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMAND_H_

