// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CommandRespond.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMANDRESPOND_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMANDRESPOND_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(COMMANDRESPOND_SOURCE)
#define COMMANDRESPOND_DllAPI __declspec( dllexport )
#else
#define COMMANDRESPOND_DllAPI __declspec( dllimport )
#endif // COMMANDRESPOND_SOURCE
#else
#define COMMANDRESPOND_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define COMMANDRESPOND_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure CommandRespond defined by the user in the IDL file.
         * @ingroup CommandRespond
         */
        class CommandRespond
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport CommandRespond();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~CommandRespond();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::CommandRespond that will be copied.
             */
            eProsima_user_DllExport CommandRespond(
                    const CommandRespond& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::CommandRespond that will be copied.
             */
            eProsima_user_DllExport CommandRespond(
                    CommandRespond&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::CommandRespond that will be copied.
             */
            eProsima_user_DllExport CommandRespond& operator =(
                    const CommandRespond& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::CommandRespond that will be copied.
             */
            eProsima_user_DllExport CommandRespond& operator =(
                    CommandRespond&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::CommandRespond object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const CommandRespond& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::CommandRespond object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const CommandRespond& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member name
             * @param _name New value to be copied in member name
             */
            eProsima_user_DllExport void name(
                    const std::string& _name);

            /*!
             * @brief This function moves the value in member name
             * @param _name New value to be moved in member name
             */
            eProsima_user_DllExport void name(
                    std::string&& _name);

            /*!
             * @brief This function returns a constant reference to member name
             * @return Constant reference to member name
             */
            eProsima_user_DllExport const std::string& name() const;

            /*!
             * @brief This function returns a reference to member name
             * @return Reference to member name
             */
            eProsima_user_DllExport std::string& name();
            /*!
             * @brief This function sets a value in member self_id
             * @param _self_id New value for member self_id
             */
            eProsima_user_DllExport void self_id(
                    int8_t _self_id);

            /*!
             * @brief This function returns the value of member self_id
             * @return Value of member self_id
             */
            eProsima_user_DllExport int8_t self_id() const;

            /*!
             * @brief This function returns a reference to member self_id
             * @return Reference to member self_id
             */
            eProsima_user_DllExport int8_t& self_id();

            /*!
             * @brief This function sets a value in member respond_id
             * @param _respond_id New value for member respond_id
             */
            eProsima_user_DllExport void respond_id(
                    int8_t _respond_id);

            /*!
             * @brief This function returns the value of member respond_id
             * @return Value of member respond_id
             */
            eProsima_user_DllExport int8_t respond_id() const;

            /*!
             * @brief This function returns a reference to member respond_id
             * @return Reference to member respond_id
             */
            eProsima_user_DllExport int8_t& respond_id();

            /*!
             * @brief This function sets a value in member status
             * @param _status New value for member status
             */
            eProsima_user_DllExport void status(
                    int8_t _status);

            /*!
             * @brief This function returns the value of member status
             * @return Value of member status
             */
            eProsima_user_DllExport int8_t status() const;

            /*!
             * @brief This function returns a reference to member status
             * @return Reference to member status
             */
            eProsima_user_DllExport int8_t& status();

            /*!
             * @brief This function sets a value in member fail_code
             * @param _fail_code New value for member fail_code
             */
            eProsima_user_DllExport void fail_code(
                    int32_t _fail_code);

            /*!
             * @brief This function returns the value of member fail_code
             * @return Value of member fail_code
             */
            eProsima_user_DllExport int32_t fail_code() const;

            /*!
             * @brief This function returns a reference to member fail_code
             * @return Reference to member fail_code
             */
            eProsima_user_DllExport int32_t& fail_code();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::CommandRespond& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::string m_name;
            int8_t m_self_id;
            int8_t m_respond_id;
            int8_t m_status;
            int32_t m_fail_code;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_COMMANDRESPOND_H_

