// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CompressedImage.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "CompressedImage.h"
#include "CompressedImageTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_CompressedImage_max_cdr_typesize 908ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_CompressedImage_max_key_cdr_typesize 0ULL;

ros2_interface::msg::CompressedImage::CompressedImage()
{
    // ros2_interface::msg::Header m_header

    // string m_frame_id
    m_frame_id ="";
    // string m_format
    m_format ="";
    // sequence<int8> m_data

    // double m_measurement_time
    m_measurement_time = 0.0;
    // unsigned long m_frame_type
    m_frame_type = 0;

    // Just to register all known types
    registerCompressedImageTypes();
}

ros2_interface::msg::CompressedImage::~CompressedImage()
{






}

ros2_interface::msg::CompressedImage::CompressedImage(
        const CompressedImage& x)
{
    m_header = x.m_header;
    m_frame_id = x.m_frame_id;
    m_format = x.m_format;
    m_data = x.m_data;
    m_measurement_time = x.m_measurement_time;
    m_frame_type = x.m_frame_type;
}

ros2_interface::msg::CompressedImage::CompressedImage(
        CompressedImage&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_frame_id = std::move(x.m_frame_id);
    m_format = std::move(x.m_format);
    m_data = std::move(x.m_data);
    m_measurement_time = x.m_measurement_time;
    m_frame_type = x.m_frame_type;
}

ros2_interface::msg::CompressedImage& ros2_interface::msg::CompressedImage::operator =(
        const CompressedImage& x)
{

    m_header = x.m_header;
    m_frame_id = x.m_frame_id;
    m_format = x.m_format;
    m_data = x.m_data;
    m_measurement_time = x.m_measurement_time;
    m_frame_type = x.m_frame_type;

    return *this;
}

ros2_interface::msg::CompressedImage& ros2_interface::msg::CompressedImage::operator =(
        CompressedImage&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_frame_id = std::move(x.m_frame_id);
    m_format = std::move(x.m_format);
    m_data = std::move(x.m_data);
    m_measurement_time = x.m_measurement_time;
    m_frame_type = x.m_frame_type;

    return *this;
}

bool ros2_interface::msg::CompressedImage::operator ==(
        const CompressedImage& x) const
{

    return (m_header == x.m_header && m_frame_id == x.m_frame_id && m_format == x.m_format && m_data == x.m_data && m_measurement_time == x.m_measurement_time && m_frame_type == x.m_frame_type);
}

bool ros2_interface::msg::CompressedImage::operator !=(
        const CompressedImage& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::CompressedImage::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_CompressedImage_max_cdr_typesize;
}

size_t ros2_interface::msg::CompressedImage::getCdrSerializedSize(
        const ros2_interface::msg::CompressedImage& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.frame_id().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.format().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.data().size() > 0)
    {
        current_alignment += (data.data().size() * 1) + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);
    }



    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::CompressedImage::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_frame_id.c_str();
    scdr << m_format.c_str();
    scdr << m_data;
    scdr << m_measurement_time;
    scdr << m_frame_type;

}

void ros2_interface::msg::CompressedImage::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_frame_id;
    dcdr >> m_format;
    dcdr >> m_data;
    dcdr >> m_measurement_time;
    dcdr >> m_frame_type;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::CompressedImage::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::CompressedImage::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::CompressedImage::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::CompressedImage::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member frame_id
 * @param _frame_id New value to be copied in member frame_id
 */
void ros2_interface::msg::CompressedImage::frame_id(
        const std::string& _frame_id)
{
    m_frame_id = _frame_id;
}

/*!
 * @brief This function moves the value in member frame_id
 * @param _frame_id New value to be moved in member frame_id
 */
void ros2_interface::msg::CompressedImage::frame_id(
        std::string&& _frame_id)
{
    m_frame_id = std::move(_frame_id);
}

/*!
 * @brief This function returns a constant reference to member frame_id
 * @return Constant reference to member frame_id
 */
const std::string& ros2_interface::msg::CompressedImage::frame_id() const
{
    return m_frame_id;
}

/*!
 * @brief This function returns a reference to member frame_id
 * @return Reference to member frame_id
 */
std::string& ros2_interface::msg::CompressedImage::frame_id()
{
    return m_frame_id;
}
/*!
 * @brief This function copies the value in member format
 * @param _format New value to be copied in member format
 */
void ros2_interface::msg::CompressedImage::format(
        const std::string& _format)
{
    m_format = _format;
}

/*!
 * @brief This function moves the value in member format
 * @param _format New value to be moved in member format
 */
void ros2_interface::msg::CompressedImage::format(
        std::string&& _format)
{
    m_format = std::move(_format);
}

/*!
 * @brief This function returns a constant reference to member format
 * @return Constant reference to member format
 */
const std::string& ros2_interface::msg::CompressedImage::format() const
{
    return m_format;
}

/*!
 * @brief This function returns a reference to member format
 * @return Reference to member format
 */
std::string& ros2_interface::msg::CompressedImage::format()
{
    return m_format;
}
/*!
 * @brief This function copies the value in member data
 * @param _data New value to be copied in member data
 */
void ros2_interface::msg::CompressedImage::data(
        const std::vector<int8_t>& _data)
{
    m_data = _data;
}

/*!
 * @brief This function moves the value in member data
 * @param _data New value to be moved in member data
 */
void ros2_interface::msg::CompressedImage::data(
        std::vector<int8_t>&& _data)
{
    m_data = std::move(_data);
}

/*!
 * @brief This function returns a constant reference to member data
 * @return Constant reference to member data
 */
const std::vector<int8_t>& ros2_interface::msg::CompressedImage::data() const
{
    return m_data;
}

/*!
 * @brief This function returns a reference to member data
 * @return Reference to member data
 */
std::vector<int8_t>& ros2_interface::msg::CompressedImage::data()
{
    return m_data;
}
/*!
 * @brief This function sets a value in member measurement_time
 * @param _measurement_time New value for member measurement_time
 */
void ros2_interface::msg::CompressedImage::measurement_time(
        double _measurement_time)
{
    m_measurement_time = _measurement_time;
}

/*!
 * @brief This function returns the value of member measurement_time
 * @return Value of member measurement_time
 */
double ros2_interface::msg::CompressedImage::measurement_time() const
{
    return m_measurement_time;
}

/*!
 * @brief This function returns a reference to member measurement_time
 * @return Reference to member measurement_time
 */
double& ros2_interface::msg::CompressedImage::measurement_time()
{
    return m_measurement_time;
}

/*!
 * @brief This function sets a value in member frame_type
 * @param _frame_type New value for member frame_type
 */
void ros2_interface::msg::CompressedImage::frame_type(
        uint32_t _frame_type)
{
    m_frame_type = _frame_type;
}

/*!
 * @brief This function returns the value of member frame_type
 * @return Value of member frame_type
 */
uint32_t ros2_interface::msg::CompressedImage::frame_type() const
{
    return m_frame_type;
}

/*!
 * @brief This function returns a reference to member frame_type
 * @return Reference to member frame_type
 */
uint32_t& ros2_interface::msg::CompressedImage::frame_type()
{
    return m_frame_type;
}



size_t ros2_interface::msg::CompressedImage::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_CompressedImage_max_key_cdr_typesize;
}

bool ros2_interface::msg::CompressedImage::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::CompressedImage::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



