// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file CompressedImageTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "CompressedImage.h"
#include "CompressedImageTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerCompressedImageTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::CompressedImage", ros2_interface::msg::GetCompressedImageIdentifier(true),
                        ros2_interface::msg::GetCompressedImageObject(true));
                factory->add_type_object("ros2_interface::msg::CompressedImage", ros2_interface::msg::GetCompressedImageIdentifier(false),
                        ros2_interface::msg::GetCompressedImageObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetCompressedImageIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("CompressedImage", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetCompressedImageObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("CompressedImage", complete);
        }

        const TypeObject* GetCompressedImageObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CompressedImage", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteCompressedImageObject();
            }
            //else
            return GetMinimalCompressedImageObject();
        }

        const TypeObject* GetMinimalCompressedImageObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CompressedImage", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_frame_id;
            mst_frame_id.common().member_id(memberId++);
            mst_frame_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_frame_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_frame_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_frame_id.common().member_flags().IS_OPTIONAL(false);
            mst_frame_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_frame_id.common().member_flags().IS_KEY(false);
            mst_frame_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_frame_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 frame_id_hash("frame_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_frame_id.detail().name_hash()[i] = frame_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_frame_id);

            MinimalStructMember mst_format;
            mst_format.common().member_id(memberId++);
            mst_format.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_format.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_format.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_format.common().member_flags().IS_OPTIONAL(false);
            mst_format.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_format.common().member_flags().IS_KEY(false);
            mst_format.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_format.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 format_hash("format");
            for(int i = 0; i < 4; ++i)
            {
                mst_format.detail().name_hash()[i] = format_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_format);

            MinimalStructMember mst_data;
            mst_data.common().member_id(memberId++);
            mst_data.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_data.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_data.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_data.common().member_flags().IS_OPTIONAL(false);
            mst_data.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_data.common().member_flags().IS_KEY(false);
            mst_data.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_data.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int8_t", 100, false));


            MD5 data_hash("data");
            for(int i = 0; i < 4; ++i)
            {
                mst_data.detail().name_hash()[i] = data_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_data);

            MinimalStructMember mst_measurement_time;
            mst_measurement_time.common().member_id(memberId++);
            mst_measurement_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_measurement_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_measurement_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_measurement_time.common().member_flags().IS_OPTIONAL(false);
            mst_measurement_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_measurement_time.common().member_flags().IS_KEY(false);
            mst_measurement_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_measurement_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 measurement_time_hash("measurement_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_measurement_time.detail().name_hash()[i] = measurement_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_measurement_time);

            MinimalStructMember mst_frame_type;
            mst_frame_type.common().member_id(memberId++);
            mst_frame_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_frame_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_frame_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_frame_type.common().member_flags().IS_OPTIONAL(false);
            mst_frame_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_frame_type.common().member_flags().IS_KEY(false);
            mst_frame_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_frame_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 frame_type_hash("frame_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_frame_type.detail().name_hash()[i] = frame_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_frame_type);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CompressedImage", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CompressedImage", false);
        }

        const TypeObject* GetCompleteCompressedImageObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("CompressedImage", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_frame_id;
            cst_frame_id.common().member_id(memberId++);
            cst_frame_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_frame_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_frame_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_frame_id.common().member_flags().IS_OPTIONAL(false);
            cst_frame_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_frame_id.common().member_flags().IS_KEY(false);
            cst_frame_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_frame_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_frame_id.detail().name("frame_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_frame_id);

            CompleteStructMember cst_format;
            cst_format.common().member_id(memberId++);
            cst_format.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_format.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_format.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_format.common().member_flags().IS_OPTIONAL(false);
            cst_format.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_format.common().member_flags().IS_KEY(false);
            cst_format.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_format.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_format.detail().name("format");

            type_object->complete().struct_type().member_seq().emplace_back(cst_format);

            CompleteStructMember cst_data;
            cst_data.common().member_id(memberId++);
            cst_data.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_data.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_data.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_data.common().member_flags().IS_OPTIONAL(false);
            cst_data.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_data.common().member_flags().IS_KEY(false);
            cst_data.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_data.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int8_t", 100, true));


            cst_data.detail().name("data");

            type_object->complete().struct_type().member_seq().emplace_back(cst_data);

            CompleteStructMember cst_measurement_time;
            cst_measurement_time.common().member_id(memberId++);
            cst_measurement_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_measurement_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_measurement_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_measurement_time.common().member_flags().IS_OPTIONAL(false);
            cst_measurement_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_measurement_time.common().member_flags().IS_KEY(false);
            cst_measurement_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_measurement_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_measurement_time.detail().name("measurement_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_measurement_time);

            CompleteStructMember cst_frame_type;
            cst_frame_type.common().member_id(memberId++);
            cst_frame_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_frame_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_frame_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_frame_type.common().member_flags().IS_OPTIONAL(false);
            cst_frame_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_frame_type.common().member_flags().IS_KEY(false);
            cst_frame_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_frame_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_frame_type.detail().name("frame_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_frame_type);


            // Header
            type_object->complete().struct_type().header().detail().type_name("CompressedImage");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("CompressedImage", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("CompressedImage", true);
        }

    } // namespace msg
} // namespace ros2_interface