// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ControlAnalysis.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ControlAnalysis.h"
#include "ControlAnalysisTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ControlAnalysis_max_cdr_typesize 864ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ControlAnalysis_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ControlAnalysis::ControlAnalysis()
{
    // ros2_interface::msg::Header m_header

    // long m_driving_mode
    m_driving_mode = 0;
    // long m_driving_mode_fd
    m_driving_mode_fd = 0;
    // long m_gear_location_fd
    m_gear_location_fd = 0;
    // long m_gear_location_cmd
    m_gear_location_cmd = 0;
    // long m_epb_level_fd
    m_epb_level_fd = 0;
    // long m_epb_level_cmd
    m_epb_level_cmd = 0;
    // double m_speed_mps
    m_speed_mps = 0.0;
    // double m_speed_reference
    m_speed_reference = 0.0;
    // double m_accel_value_fd
    m_accel_value_fd = 0.0;
    // double m_accel_value_cmd
    m_accel_value_cmd = 0.0;
    // double m_brake_value_fd
    m_brake_value_fd = 0.0;
    // double m_brake_value_cmd
    m_brake_value_cmd = 0.0;
    // double m_path_remain
    m_path_remain = 0.0;
    // boolean m_has_stop_point
    m_has_stop_point = false;
    // boolean m_is_full_stop
    m_is_full_stop = false;
    // boolean m_is_stopped
    m_is_stopped = false;
    // double m_lon_acc_jerk
    m_lon_acc_jerk = 0.0;
    // double m_acceleration_cmd
    m_acceleration_cmd = 0.0;
    // double m_acceleration_cmd_closeloop
    m_acceleration_cmd_closeloop = 0.0;
    // double m_preview_acceleration_reference
    m_preview_acceleration_reference = 0.0;
    // double m_slope_offset_compensation
    m_slope_offset_compensation = 0.0;
    // double m_turning_offset_compensation
    m_turning_offset_compensation = 0.0;
    // double m_speed_error_limited
    m_speed_error_limited = 0.0;
    // double m_speed_error
    m_speed_error = 0.0;
    // double m_speed_offset
    m_speed_offset = 0.0;
    // double m_station_error_limited
    m_station_error_limited = 0.0;
    // double m_station_error
    m_station_error = 0.0;
    // double m_lon_target_point_s
    m_lon_target_point_s = 0.0;
    // long long m_lon_calculate_time
    m_lon_calculate_time = 0;
    // long long m_lon_calculate_time_max
    m_lon_calculate_time_max = 0;
    // double m_ref_curvature
    m_ref_curvature = 0.0;
    // double m_ref_heading
    m_ref_heading = 0.0;
    // double m_current_heading
    m_current_heading = 0.0;
    // double m_heading_error
    m_heading_error = 0.0;
    // double m_heading_error_rate
    m_heading_error_rate = 0.0;
    // double m_lateral_error
    m_lateral_error = 0.0;
    // double m_lateral_error_rate
    m_lateral_error_rate = 0.0;
    // double m_lon_error
    m_lon_error = 0.0;
    // double m_front_steering_value_fd
    m_front_steering_value_fd = 0.0;
    // double m_front_steering_target
    m_front_steering_target = 0.0;
    // double m_front_steering_rate
    m_front_steering_rate = 0.0;
    // double m_front_steer_angle_feedforward
    m_front_steer_angle_feedforward = 0.0;
    // double m_front_steer_angle_feedback
    m_front_steer_angle_feedback = 0.0;
    // double m_front_steer_angle_lateral_contribution
    m_front_steer_angle_lateral_contribution = 0.0;
    // double m_front_steer_angle_lateral_rate_contribution
    m_front_steer_angle_lateral_rate_contribution = 0.0;
    // double m_front_steer_angle_heading_contribution
    m_front_steer_angle_heading_contribution = 0.0;
    // double m_front_steer_angle_heading_rate_contribution
    m_front_steer_angle_heading_rate_contribution = 0.0;
    // double m_rear_steering_value_fd
    m_rear_steering_value_fd = 0.0;
    // double m_rear_steering_target
    m_rear_steering_target = 0.0;
    // double m_rear_steering_rate
    m_rear_steering_rate = 0.0;
    // double m_rear_steer_angle_feedforward
    m_rear_steer_angle_feedforward = 0.0;
    // double m_rear_steer_angle_feedback
    m_rear_steer_angle_feedback = 0.0;
    // double m_rear_steer_angle_lateral_contribution
    m_rear_steer_angle_lateral_contribution = 0.0;
    // double m_rear_steer_angle_lateral_rate_contribution
    m_rear_steer_angle_lateral_rate_contribution = 0.0;
    // double m_rear_steer_angle_heading_contribution
    m_rear_steer_angle_heading_contribution = 0.0;
    // double m_rear_steer_angle_heading_rate_contribution
    m_rear_steer_angle_heading_rate_contribution = 0.0;
    // double m_matrix_k_00
    m_matrix_k_00 = 0.0;
    // double m_matrix_k_01
    m_matrix_k_01 = 0.0;
    // double m_matrix_k_02
    m_matrix_k_02 = 0.0;
    // double m_matrix_k_03
    m_matrix_k_03 = 0.0;
    // double m_matrix_k_10
    m_matrix_k_10 = 0.0;
    // double m_matrix_k_11
    m_matrix_k_11 = 0.0;
    // double m_matrix_k_12
    m_matrix_k_12 = 0.0;
    // double m_matrix_k_13
    m_matrix_k_13 = 0.0;
    // double m_matrix_state_0
    m_matrix_state_0 = 0.0;
    // double m_matrix_state_1
    m_matrix_state_1 = 0.0;
    // double m_matrix_state_2
    m_matrix_state_2 = 0.0;
    // double m_matrix_state_3
    m_matrix_state_3 = 0.0;
    // double m_matrix_q_updated_0
    m_matrix_q_updated_0 = 0.0;
    // double m_matrix_q_updated_1
    m_matrix_q_updated_1 = 0.0;
    // double m_matrix_q_updated_2
    m_matrix_q_updated_2 = 0.0;
    // double m_matrix_q_updated_3
    m_matrix_q_updated_3 = 0.0;
    // double m_current_x
    m_current_x = 0.0;
    // double m_current_y
    m_current_y = 0.0;
    // double m_target_point_x
    m_target_point_x = 0.0;
    // double m_target_point_y
    m_target_point_y = 0.0;
    // double m_lat_target_point_s
    m_lat_target_point_s = 0.0;
    // long long m_lqr_calculate_time
    m_lqr_calculate_time = 0;
    // long long m_lqr_calculate_time_max
    m_lqr_calculate_time_max = 0;

    // Just to register all known types
    registerControlAnalysisTypes();
}

ros2_interface::msg::ControlAnalysis::~ControlAnalysis()
{
















































































}

ros2_interface::msg::ControlAnalysis::ControlAnalysis(
        const ControlAnalysis& x)
{
    m_header = x.m_header;
    m_driving_mode = x.m_driving_mode;
    m_driving_mode_fd = x.m_driving_mode_fd;
    m_gear_location_fd = x.m_gear_location_fd;
    m_gear_location_cmd = x.m_gear_location_cmd;
    m_epb_level_fd = x.m_epb_level_fd;
    m_epb_level_cmd = x.m_epb_level_cmd;
    m_speed_mps = x.m_speed_mps;
    m_speed_reference = x.m_speed_reference;
    m_accel_value_fd = x.m_accel_value_fd;
    m_accel_value_cmd = x.m_accel_value_cmd;
    m_brake_value_fd = x.m_brake_value_fd;
    m_brake_value_cmd = x.m_brake_value_cmd;
    m_path_remain = x.m_path_remain;
    m_has_stop_point = x.m_has_stop_point;
    m_is_full_stop = x.m_is_full_stop;
    m_is_stopped = x.m_is_stopped;
    m_lon_acc_jerk = x.m_lon_acc_jerk;
    m_acceleration_cmd = x.m_acceleration_cmd;
    m_acceleration_cmd_closeloop = x.m_acceleration_cmd_closeloop;
    m_preview_acceleration_reference = x.m_preview_acceleration_reference;
    m_slope_offset_compensation = x.m_slope_offset_compensation;
    m_turning_offset_compensation = x.m_turning_offset_compensation;
    m_speed_error_limited = x.m_speed_error_limited;
    m_speed_error = x.m_speed_error;
    m_speed_offset = x.m_speed_offset;
    m_station_error_limited = x.m_station_error_limited;
    m_station_error = x.m_station_error;
    m_lon_target_point_s = x.m_lon_target_point_s;
    m_lon_calculate_time = x.m_lon_calculate_time;
    m_lon_calculate_time_max = x.m_lon_calculate_time_max;
    m_ref_curvature = x.m_ref_curvature;
    m_ref_heading = x.m_ref_heading;
    m_current_heading = x.m_current_heading;
    m_heading_error = x.m_heading_error;
    m_heading_error_rate = x.m_heading_error_rate;
    m_lateral_error = x.m_lateral_error;
    m_lateral_error_rate = x.m_lateral_error_rate;
    m_lon_error = x.m_lon_error;
    m_front_steering_value_fd = x.m_front_steering_value_fd;
    m_front_steering_target = x.m_front_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_front_steer_angle_feedforward = x.m_front_steer_angle_feedforward;
    m_front_steer_angle_feedback = x.m_front_steer_angle_feedback;
    m_front_steer_angle_lateral_contribution = x.m_front_steer_angle_lateral_contribution;
    m_front_steer_angle_lateral_rate_contribution = x.m_front_steer_angle_lateral_rate_contribution;
    m_front_steer_angle_heading_contribution = x.m_front_steer_angle_heading_contribution;
    m_front_steer_angle_heading_rate_contribution = x.m_front_steer_angle_heading_rate_contribution;
    m_rear_steering_value_fd = x.m_rear_steering_value_fd;
    m_rear_steering_target = x.m_rear_steering_target;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_rear_steer_angle_feedforward = x.m_rear_steer_angle_feedforward;
    m_rear_steer_angle_feedback = x.m_rear_steer_angle_feedback;
    m_rear_steer_angle_lateral_contribution = x.m_rear_steer_angle_lateral_contribution;
    m_rear_steer_angle_lateral_rate_contribution = x.m_rear_steer_angle_lateral_rate_contribution;
    m_rear_steer_angle_heading_contribution = x.m_rear_steer_angle_heading_contribution;
    m_rear_steer_angle_heading_rate_contribution = x.m_rear_steer_angle_heading_rate_contribution;
    m_matrix_k_00 = x.m_matrix_k_00;
    m_matrix_k_01 = x.m_matrix_k_01;
    m_matrix_k_02 = x.m_matrix_k_02;
    m_matrix_k_03 = x.m_matrix_k_03;
    m_matrix_k_10 = x.m_matrix_k_10;
    m_matrix_k_11 = x.m_matrix_k_11;
    m_matrix_k_12 = x.m_matrix_k_12;
    m_matrix_k_13 = x.m_matrix_k_13;
    m_matrix_state_0 = x.m_matrix_state_0;
    m_matrix_state_1 = x.m_matrix_state_1;
    m_matrix_state_2 = x.m_matrix_state_2;
    m_matrix_state_3 = x.m_matrix_state_3;
    m_matrix_q_updated_0 = x.m_matrix_q_updated_0;
    m_matrix_q_updated_1 = x.m_matrix_q_updated_1;
    m_matrix_q_updated_2 = x.m_matrix_q_updated_2;
    m_matrix_q_updated_3 = x.m_matrix_q_updated_3;
    m_current_x = x.m_current_x;
    m_current_y = x.m_current_y;
    m_target_point_x = x.m_target_point_x;
    m_target_point_y = x.m_target_point_y;
    m_lat_target_point_s = x.m_lat_target_point_s;
    m_lqr_calculate_time = x.m_lqr_calculate_time;
    m_lqr_calculate_time_max = x.m_lqr_calculate_time_max;
}

ros2_interface::msg::ControlAnalysis::ControlAnalysis(
        ControlAnalysis&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_driving_mode = x.m_driving_mode;
    m_driving_mode_fd = x.m_driving_mode_fd;
    m_gear_location_fd = x.m_gear_location_fd;
    m_gear_location_cmd = x.m_gear_location_cmd;
    m_epb_level_fd = x.m_epb_level_fd;
    m_epb_level_cmd = x.m_epb_level_cmd;
    m_speed_mps = x.m_speed_mps;
    m_speed_reference = x.m_speed_reference;
    m_accel_value_fd = x.m_accel_value_fd;
    m_accel_value_cmd = x.m_accel_value_cmd;
    m_brake_value_fd = x.m_brake_value_fd;
    m_brake_value_cmd = x.m_brake_value_cmd;
    m_path_remain = x.m_path_remain;
    m_has_stop_point = x.m_has_stop_point;
    m_is_full_stop = x.m_is_full_stop;
    m_is_stopped = x.m_is_stopped;
    m_lon_acc_jerk = x.m_lon_acc_jerk;
    m_acceleration_cmd = x.m_acceleration_cmd;
    m_acceleration_cmd_closeloop = x.m_acceleration_cmd_closeloop;
    m_preview_acceleration_reference = x.m_preview_acceleration_reference;
    m_slope_offset_compensation = x.m_slope_offset_compensation;
    m_turning_offset_compensation = x.m_turning_offset_compensation;
    m_speed_error_limited = x.m_speed_error_limited;
    m_speed_error = x.m_speed_error;
    m_speed_offset = x.m_speed_offset;
    m_station_error_limited = x.m_station_error_limited;
    m_station_error = x.m_station_error;
    m_lon_target_point_s = x.m_lon_target_point_s;
    m_lon_calculate_time = x.m_lon_calculate_time;
    m_lon_calculate_time_max = x.m_lon_calculate_time_max;
    m_ref_curvature = x.m_ref_curvature;
    m_ref_heading = x.m_ref_heading;
    m_current_heading = x.m_current_heading;
    m_heading_error = x.m_heading_error;
    m_heading_error_rate = x.m_heading_error_rate;
    m_lateral_error = x.m_lateral_error;
    m_lateral_error_rate = x.m_lateral_error_rate;
    m_lon_error = x.m_lon_error;
    m_front_steering_value_fd = x.m_front_steering_value_fd;
    m_front_steering_target = x.m_front_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_front_steer_angle_feedforward = x.m_front_steer_angle_feedforward;
    m_front_steer_angle_feedback = x.m_front_steer_angle_feedback;
    m_front_steer_angle_lateral_contribution = x.m_front_steer_angle_lateral_contribution;
    m_front_steer_angle_lateral_rate_contribution = x.m_front_steer_angle_lateral_rate_contribution;
    m_front_steer_angle_heading_contribution = x.m_front_steer_angle_heading_contribution;
    m_front_steer_angle_heading_rate_contribution = x.m_front_steer_angle_heading_rate_contribution;
    m_rear_steering_value_fd = x.m_rear_steering_value_fd;
    m_rear_steering_target = x.m_rear_steering_target;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_rear_steer_angle_feedforward = x.m_rear_steer_angle_feedforward;
    m_rear_steer_angle_feedback = x.m_rear_steer_angle_feedback;
    m_rear_steer_angle_lateral_contribution = x.m_rear_steer_angle_lateral_contribution;
    m_rear_steer_angle_lateral_rate_contribution = x.m_rear_steer_angle_lateral_rate_contribution;
    m_rear_steer_angle_heading_contribution = x.m_rear_steer_angle_heading_contribution;
    m_rear_steer_angle_heading_rate_contribution = x.m_rear_steer_angle_heading_rate_contribution;
    m_matrix_k_00 = x.m_matrix_k_00;
    m_matrix_k_01 = x.m_matrix_k_01;
    m_matrix_k_02 = x.m_matrix_k_02;
    m_matrix_k_03 = x.m_matrix_k_03;
    m_matrix_k_10 = x.m_matrix_k_10;
    m_matrix_k_11 = x.m_matrix_k_11;
    m_matrix_k_12 = x.m_matrix_k_12;
    m_matrix_k_13 = x.m_matrix_k_13;
    m_matrix_state_0 = x.m_matrix_state_0;
    m_matrix_state_1 = x.m_matrix_state_1;
    m_matrix_state_2 = x.m_matrix_state_2;
    m_matrix_state_3 = x.m_matrix_state_3;
    m_matrix_q_updated_0 = x.m_matrix_q_updated_0;
    m_matrix_q_updated_1 = x.m_matrix_q_updated_1;
    m_matrix_q_updated_2 = x.m_matrix_q_updated_2;
    m_matrix_q_updated_3 = x.m_matrix_q_updated_3;
    m_current_x = x.m_current_x;
    m_current_y = x.m_current_y;
    m_target_point_x = x.m_target_point_x;
    m_target_point_y = x.m_target_point_y;
    m_lat_target_point_s = x.m_lat_target_point_s;
    m_lqr_calculate_time = x.m_lqr_calculate_time;
    m_lqr_calculate_time_max = x.m_lqr_calculate_time_max;
}

ros2_interface::msg::ControlAnalysis& ros2_interface::msg::ControlAnalysis::operator =(
        const ControlAnalysis& x)
{

    m_header = x.m_header;
    m_driving_mode = x.m_driving_mode;
    m_driving_mode_fd = x.m_driving_mode_fd;
    m_gear_location_fd = x.m_gear_location_fd;
    m_gear_location_cmd = x.m_gear_location_cmd;
    m_epb_level_fd = x.m_epb_level_fd;
    m_epb_level_cmd = x.m_epb_level_cmd;
    m_speed_mps = x.m_speed_mps;
    m_speed_reference = x.m_speed_reference;
    m_accel_value_fd = x.m_accel_value_fd;
    m_accel_value_cmd = x.m_accel_value_cmd;
    m_brake_value_fd = x.m_brake_value_fd;
    m_brake_value_cmd = x.m_brake_value_cmd;
    m_path_remain = x.m_path_remain;
    m_has_stop_point = x.m_has_stop_point;
    m_is_full_stop = x.m_is_full_stop;
    m_is_stopped = x.m_is_stopped;
    m_lon_acc_jerk = x.m_lon_acc_jerk;
    m_acceleration_cmd = x.m_acceleration_cmd;
    m_acceleration_cmd_closeloop = x.m_acceleration_cmd_closeloop;
    m_preview_acceleration_reference = x.m_preview_acceleration_reference;
    m_slope_offset_compensation = x.m_slope_offset_compensation;
    m_turning_offset_compensation = x.m_turning_offset_compensation;
    m_speed_error_limited = x.m_speed_error_limited;
    m_speed_error = x.m_speed_error;
    m_speed_offset = x.m_speed_offset;
    m_station_error_limited = x.m_station_error_limited;
    m_station_error = x.m_station_error;
    m_lon_target_point_s = x.m_lon_target_point_s;
    m_lon_calculate_time = x.m_lon_calculate_time;
    m_lon_calculate_time_max = x.m_lon_calculate_time_max;
    m_ref_curvature = x.m_ref_curvature;
    m_ref_heading = x.m_ref_heading;
    m_current_heading = x.m_current_heading;
    m_heading_error = x.m_heading_error;
    m_heading_error_rate = x.m_heading_error_rate;
    m_lateral_error = x.m_lateral_error;
    m_lateral_error_rate = x.m_lateral_error_rate;
    m_lon_error = x.m_lon_error;
    m_front_steering_value_fd = x.m_front_steering_value_fd;
    m_front_steering_target = x.m_front_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_front_steer_angle_feedforward = x.m_front_steer_angle_feedforward;
    m_front_steer_angle_feedback = x.m_front_steer_angle_feedback;
    m_front_steer_angle_lateral_contribution = x.m_front_steer_angle_lateral_contribution;
    m_front_steer_angle_lateral_rate_contribution = x.m_front_steer_angle_lateral_rate_contribution;
    m_front_steer_angle_heading_contribution = x.m_front_steer_angle_heading_contribution;
    m_front_steer_angle_heading_rate_contribution = x.m_front_steer_angle_heading_rate_contribution;
    m_rear_steering_value_fd = x.m_rear_steering_value_fd;
    m_rear_steering_target = x.m_rear_steering_target;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_rear_steer_angle_feedforward = x.m_rear_steer_angle_feedforward;
    m_rear_steer_angle_feedback = x.m_rear_steer_angle_feedback;
    m_rear_steer_angle_lateral_contribution = x.m_rear_steer_angle_lateral_contribution;
    m_rear_steer_angle_lateral_rate_contribution = x.m_rear_steer_angle_lateral_rate_contribution;
    m_rear_steer_angle_heading_contribution = x.m_rear_steer_angle_heading_contribution;
    m_rear_steer_angle_heading_rate_contribution = x.m_rear_steer_angle_heading_rate_contribution;
    m_matrix_k_00 = x.m_matrix_k_00;
    m_matrix_k_01 = x.m_matrix_k_01;
    m_matrix_k_02 = x.m_matrix_k_02;
    m_matrix_k_03 = x.m_matrix_k_03;
    m_matrix_k_10 = x.m_matrix_k_10;
    m_matrix_k_11 = x.m_matrix_k_11;
    m_matrix_k_12 = x.m_matrix_k_12;
    m_matrix_k_13 = x.m_matrix_k_13;
    m_matrix_state_0 = x.m_matrix_state_0;
    m_matrix_state_1 = x.m_matrix_state_1;
    m_matrix_state_2 = x.m_matrix_state_2;
    m_matrix_state_3 = x.m_matrix_state_3;
    m_matrix_q_updated_0 = x.m_matrix_q_updated_0;
    m_matrix_q_updated_1 = x.m_matrix_q_updated_1;
    m_matrix_q_updated_2 = x.m_matrix_q_updated_2;
    m_matrix_q_updated_3 = x.m_matrix_q_updated_3;
    m_current_x = x.m_current_x;
    m_current_y = x.m_current_y;
    m_target_point_x = x.m_target_point_x;
    m_target_point_y = x.m_target_point_y;
    m_lat_target_point_s = x.m_lat_target_point_s;
    m_lqr_calculate_time = x.m_lqr_calculate_time;
    m_lqr_calculate_time_max = x.m_lqr_calculate_time_max;

    return *this;
}

ros2_interface::msg::ControlAnalysis& ros2_interface::msg::ControlAnalysis::operator =(
        ControlAnalysis&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_driving_mode = x.m_driving_mode;
    m_driving_mode_fd = x.m_driving_mode_fd;
    m_gear_location_fd = x.m_gear_location_fd;
    m_gear_location_cmd = x.m_gear_location_cmd;
    m_epb_level_fd = x.m_epb_level_fd;
    m_epb_level_cmd = x.m_epb_level_cmd;
    m_speed_mps = x.m_speed_mps;
    m_speed_reference = x.m_speed_reference;
    m_accel_value_fd = x.m_accel_value_fd;
    m_accel_value_cmd = x.m_accel_value_cmd;
    m_brake_value_fd = x.m_brake_value_fd;
    m_brake_value_cmd = x.m_brake_value_cmd;
    m_path_remain = x.m_path_remain;
    m_has_stop_point = x.m_has_stop_point;
    m_is_full_stop = x.m_is_full_stop;
    m_is_stopped = x.m_is_stopped;
    m_lon_acc_jerk = x.m_lon_acc_jerk;
    m_acceleration_cmd = x.m_acceleration_cmd;
    m_acceleration_cmd_closeloop = x.m_acceleration_cmd_closeloop;
    m_preview_acceleration_reference = x.m_preview_acceleration_reference;
    m_slope_offset_compensation = x.m_slope_offset_compensation;
    m_turning_offset_compensation = x.m_turning_offset_compensation;
    m_speed_error_limited = x.m_speed_error_limited;
    m_speed_error = x.m_speed_error;
    m_speed_offset = x.m_speed_offset;
    m_station_error_limited = x.m_station_error_limited;
    m_station_error = x.m_station_error;
    m_lon_target_point_s = x.m_lon_target_point_s;
    m_lon_calculate_time = x.m_lon_calculate_time;
    m_lon_calculate_time_max = x.m_lon_calculate_time_max;
    m_ref_curvature = x.m_ref_curvature;
    m_ref_heading = x.m_ref_heading;
    m_current_heading = x.m_current_heading;
    m_heading_error = x.m_heading_error;
    m_heading_error_rate = x.m_heading_error_rate;
    m_lateral_error = x.m_lateral_error;
    m_lateral_error_rate = x.m_lateral_error_rate;
    m_lon_error = x.m_lon_error;
    m_front_steering_value_fd = x.m_front_steering_value_fd;
    m_front_steering_target = x.m_front_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_front_steer_angle_feedforward = x.m_front_steer_angle_feedforward;
    m_front_steer_angle_feedback = x.m_front_steer_angle_feedback;
    m_front_steer_angle_lateral_contribution = x.m_front_steer_angle_lateral_contribution;
    m_front_steer_angle_lateral_rate_contribution = x.m_front_steer_angle_lateral_rate_contribution;
    m_front_steer_angle_heading_contribution = x.m_front_steer_angle_heading_contribution;
    m_front_steer_angle_heading_rate_contribution = x.m_front_steer_angle_heading_rate_contribution;
    m_rear_steering_value_fd = x.m_rear_steering_value_fd;
    m_rear_steering_target = x.m_rear_steering_target;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_rear_steer_angle_feedforward = x.m_rear_steer_angle_feedforward;
    m_rear_steer_angle_feedback = x.m_rear_steer_angle_feedback;
    m_rear_steer_angle_lateral_contribution = x.m_rear_steer_angle_lateral_contribution;
    m_rear_steer_angle_lateral_rate_contribution = x.m_rear_steer_angle_lateral_rate_contribution;
    m_rear_steer_angle_heading_contribution = x.m_rear_steer_angle_heading_contribution;
    m_rear_steer_angle_heading_rate_contribution = x.m_rear_steer_angle_heading_rate_contribution;
    m_matrix_k_00 = x.m_matrix_k_00;
    m_matrix_k_01 = x.m_matrix_k_01;
    m_matrix_k_02 = x.m_matrix_k_02;
    m_matrix_k_03 = x.m_matrix_k_03;
    m_matrix_k_10 = x.m_matrix_k_10;
    m_matrix_k_11 = x.m_matrix_k_11;
    m_matrix_k_12 = x.m_matrix_k_12;
    m_matrix_k_13 = x.m_matrix_k_13;
    m_matrix_state_0 = x.m_matrix_state_0;
    m_matrix_state_1 = x.m_matrix_state_1;
    m_matrix_state_2 = x.m_matrix_state_2;
    m_matrix_state_3 = x.m_matrix_state_3;
    m_matrix_q_updated_0 = x.m_matrix_q_updated_0;
    m_matrix_q_updated_1 = x.m_matrix_q_updated_1;
    m_matrix_q_updated_2 = x.m_matrix_q_updated_2;
    m_matrix_q_updated_3 = x.m_matrix_q_updated_3;
    m_current_x = x.m_current_x;
    m_current_y = x.m_current_y;
    m_target_point_x = x.m_target_point_x;
    m_target_point_y = x.m_target_point_y;
    m_lat_target_point_s = x.m_lat_target_point_s;
    m_lqr_calculate_time = x.m_lqr_calculate_time;
    m_lqr_calculate_time_max = x.m_lqr_calculate_time_max;

    return *this;
}

bool ros2_interface::msg::ControlAnalysis::operator ==(
        const ControlAnalysis& x) const
{

    return (m_header == x.m_header && m_driving_mode == x.m_driving_mode && m_driving_mode_fd == x.m_driving_mode_fd && m_gear_location_fd == x.m_gear_location_fd && m_gear_location_cmd == x.m_gear_location_cmd && m_epb_level_fd == x.m_epb_level_fd && m_epb_level_cmd == x.m_epb_level_cmd && m_speed_mps == x.m_speed_mps && m_speed_reference == x.m_speed_reference && m_accel_value_fd == x.m_accel_value_fd && m_accel_value_cmd == x.m_accel_value_cmd && m_brake_value_fd == x.m_brake_value_fd && m_brake_value_cmd == x.m_brake_value_cmd && m_path_remain == x.m_path_remain && m_has_stop_point == x.m_has_stop_point && m_is_full_stop == x.m_is_full_stop && m_is_stopped == x.m_is_stopped && m_lon_acc_jerk == x.m_lon_acc_jerk && m_acceleration_cmd == x.m_acceleration_cmd && m_acceleration_cmd_closeloop == x.m_acceleration_cmd_closeloop && m_preview_acceleration_reference == x.m_preview_acceleration_reference && m_slope_offset_compensation == x.m_slope_offset_compensation && m_turning_offset_compensation == x.m_turning_offset_compensation && m_speed_error_limited == x.m_speed_error_limited && m_speed_error == x.m_speed_error && m_speed_offset == x.m_speed_offset && m_station_error_limited == x.m_station_error_limited && m_station_error == x.m_station_error && m_lon_target_point_s == x.m_lon_target_point_s && m_lon_calculate_time == x.m_lon_calculate_time && m_lon_calculate_time_max == x.m_lon_calculate_time_max && m_ref_curvature == x.m_ref_curvature && m_ref_heading == x.m_ref_heading && m_current_heading == x.m_current_heading && m_heading_error == x.m_heading_error && m_heading_error_rate == x.m_heading_error_rate && m_lateral_error == x.m_lateral_error && m_lateral_error_rate == x.m_lateral_error_rate && m_lon_error == x.m_lon_error && m_front_steering_value_fd == x.m_front_steering_value_fd && m_front_steering_target == x.m_front_steering_target && m_front_steering_rate == x.m_front_steering_rate && m_front_steer_angle_feedforward == x.m_front_steer_angle_feedforward && m_front_steer_angle_feedback == x.m_front_steer_angle_feedback && m_front_steer_angle_lateral_contribution == x.m_front_steer_angle_lateral_contribution && m_front_steer_angle_lateral_rate_contribution == x.m_front_steer_angle_lateral_rate_contribution && m_front_steer_angle_heading_contribution == x.m_front_steer_angle_heading_contribution && m_front_steer_angle_heading_rate_contribution == x.m_front_steer_angle_heading_rate_contribution && m_rear_steering_value_fd == x.m_rear_steering_value_fd && m_rear_steering_target == x.m_rear_steering_target && m_rear_steering_rate == x.m_rear_steering_rate && m_rear_steer_angle_feedforward == x.m_rear_steer_angle_feedforward && m_rear_steer_angle_feedback == x.m_rear_steer_angle_feedback && m_rear_steer_angle_lateral_contribution == x.m_rear_steer_angle_lateral_contribution && m_rear_steer_angle_lateral_rate_contribution == x.m_rear_steer_angle_lateral_rate_contribution && m_rear_steer_angle_heading_contribution == x.m_rear_steer_angle_heading_contribution && m_rear_steer_angle_heading_rate_contribution == x.m_rear_steer_angle_heading_rate_contribution && m_matrix_k_00 == x.m_matrix_k_00 && m_matrix_k_01 == x.m_matrix_k_01 && m_matrix_k_02 == x.m_matrix_k_02 && m_matrix_k_03 == x.m_matrix_k_03 && m_matrix_k_10 == x.m_matrix_k_10 && m_matrix_k_11 == x.m_matrix_k_11 && m_matrix_k_12 == x.m_matrix_k_12 && m_matrix_k_13 == x.m_matrix_k_13 && m_matrix_state_0 == x.m_matrix_state_0 && m_matrix_state_1 == x.m_matrix_state_1 && m_matrix_state_2 == x.m_matrix_state_2 && m_matrix_state_3 == x.m_matrix_state_3 && m_matrix_q_updated_0 == x.m_matrix_q_updated_0 && m_matrix_q_updated_1 == x.m_matrix_q_updated_1 && m_matrix_q_updated_2 == x.m_matrix_q_updated_2 && m_matrix_q_updated_3 == x.m_matrix_q_updated_3 && m_current_x == x.m_current_x && m_current_y == x.m_current_y && m_target_point_x == x.m_target_point_x && m_target_point_y == x.m_target_point_y && m_lat_target_point_s == x.m_lat_target_point_s && m_lqr_calculate_time == x.m_lqr_calculate_time && m_lqr_calculate_time_max == x.m_lqr_calculate_time_max);
}

bool ros2_interface::msg::ControlAnalysis::operator !=(
        const ControlAnalysis& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ControlAnalysis::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ControlAnalysis_max_cdr_typesize;
}

size_t ros2_interface::msg::ControlAnalysis::getCdrSerializedSize(
        const ros2_interface::msg::ControlAnalysis& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ControlAnalysis::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_driving_mode;
    scdr << m_driving_mode_fd;
    scdr << m_gear_location_fd;
    scdr << m_gear_location_cmd;
    scdr << m_epb_level_fd;
    scdr << m_epb_level_cmd;
    scdr << m_speed_mps;
    scdr << m_speed_reference;
    scdr << m_accel_value_fd;
    scdr << m_accel_value_cmd;
    scdr << m_brake_value_fd;
    scdr << m_brake_value_cmd;
    scdr << m_path_remain;
    scdr << m_has_stop_point;
    scdr << m_is_full_stop;
    scdr << m_is_stopped;
    scdr << m_lon_acc_jerk;
    scdr << m_acceleration_cmd;
    scdr << m_acceleration_cmd_closeloop;
    scdr << m_preview_acceleration_reference;
    scdr << m_slope_offset_compensation;
    scdr << m_turning_offset_compensation;
    scdr << m_speed_error_limited;
    scdr << m_speed_error;
    scdr << m_speed_offset;
    scdr << m_station_error_limited;
    scdr << m_station_error;
    scdr << m_lon_target_point_s;
    scdr << m_lon_calculate_time;
    scdr << m_lon_calculate_time_max;
    scdr << m_ref_curvature;
    scdr << m_ref_heading;
    scdr << m_current_heading;
    scdr << m_heading_error;
    scdr << m_heading_error_rate;
    scdr << m_lateral_error;
    scdr << m_lateral_error_rate;
    scdr << m_lon_error;
    scdr << m_front_steering_value_fd;
    scdr << m_front_steering_target;
    scdr << m_front_steering_rate;
    scdr << m_front_steer_angle_feedforward;
    scdr << m_front_steer_angle_feedback;
    scdr << m_front_steer_angle_lateral_contribution;
    scdr << m_front_steer_angle_lateral_rate_contribution;
    scdr << m_front_steer_angle_heading_contribution;
    scdr << m_front_steer_angle_heading_rate_contribution;
    scdr << m_rear_steering_value_fd;
    scdr << m_rear_steering_target;
    scdr << m_rear_steering_rate;
    scdr << m_rear_steer_angle_feedforward;
    scdr << m_rear_steer_angle_feedback;
    scdr << m_rear_steer_angle_lateral_contribution;
    scdr << m_rear_steer_angle_lateral_rate_contribution;
    scdr << m_rear_steer_angle_heading_contribution;
    scdr << m_rear_steer_angle_heading_rate_contribution;
    scdr << m_matrix_k_00;
    scdr << m_matrix_k_01;
    scdr << m_matrix_k_02;
    scdr << m_matrix_k_03;
    scdr << m_matrix_k_10;
    scdr << m_matrix_k_11;
    scdr << m_matrix_k_12;
    scdr << m_matrix_k_13;
    scdr << m_matrix_state_0;
    scdr << m_matrix_state_1;
    scdr << m_matrix_state_2;
    scdr << m_matrix_state_3;
    scdr << m_matrix_q_updated_0;
    scdr << m_matrix_q_updated_1;
    scdr << m_matrix_q_updated_2;
    scdr << m_matrix_q_updated_3;
    scdr << m_current_x;
    scdr << m_current_y;
    scdr << m_target_point_x;
    scdr << m_target_point_y;
    scdr << m_lat_target_point_s;
    scdr << m_lqr_calculate_time;
    scdr << m_lqr_calculate_time_max;

}

void ros2_interface::msg::ControlAnalysis::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_driving_mode;
    dcdr >> m_driving_mode_fd;
    dcdr >> m_gear_location_fd;
    dcdr >> m_gear_location_cmd;
    dcdr >> m_epb_level_fd;
    dcdr >> m_epb_level_cmd;
    dcdr >> m_speed_mps;
    dcdr >> m_speed_reference;
    dcdr >> m_accel_value_fd;
    dcdr >> m_accel_value_cmd;
    dcdr >> m_brake_value_fd;
    dcdr >> m_brake_value_cmd;
    dcdr >> m_path_remain;
    dcdr >> m_has_stop_point;
    dcdr >> m_is_full_stop;
    dcdr >> m_is_stopped;
    dcdr >> m_lon_acc_jerk;
    dcdr >> m_acceleration_cmd;
    dcdr >> m_acceleration_cmd_closeloop;
    dcdr >> m_preview_acceleration_reference;
    dcdr >> m_slope_offset_compensation;
    dcdr >> m_turning_offset_compensation;
    dcdr >> m_speed_error_limited;
    dcdr >> m_speed_error;
    dcdr >> m_speed_offset;
    dcdr >> m_station_error_limited;
    dcdr >> m_station_error;
    dcdr >> m_lon_target_point_s;
    dcdr >> m_lon_calculate_time;
    dcdr >> m_lon_calculate_time_max;
    dcdr >> m_ref_curvature;
    dcdr >> m_ref_heading;
    dcdr >> m_current_heading;
    dcdr >> m_heading_error;
    dcdr >> m_heading_error_rate;
    dcdr >> m_lateral_error;
    dcdr >> m_lateral_error_rate;
    dcdr >> m_lon_error;
    dcdr >> m_front_steering_value_fd;
    dcdr >> m_front_steering_target;
    dcdr >> m_front_steering_rate;
    dcdr >> m_front_steer_angle_feedforward;
    dcdr >> m_front_steer_angle_feedback;
    dcdr >> m_front_steer_angle_lateral_contribution;
    dcdr >> m_front_steer_angle_lateral_rate_contribution;
    dcdr >> m_front_steer_angle_heading_contribution;
    dcdr >> m_front_steer_angle_heading_rate_contribution;
    dcdr >> m_rear_steering_value_fd;
    dcdr >> m_rear_steering_target;
    dcdr >> m_rear_steering_rate;
    dcdr >> m_rear_steer_angle_feedforward;
    dcdr >> m_rear_steer_angle_feedback;
    dcdr >> m_rear_steer_angle_lateral_contribution;
    dcdr >> m_rear_steer_angle_lateral_rate_contribution;
    dcdr >> m_rear_steer_angle_heading_contribution;
    dcdr >> m_rear_steer_angle_heading_rate_contribution;
    dcdr >> m_matrix_k_00;
    dcdr >> m_matrix_k_01;
    dcdr >> m_matrix_k_02;
    dcdr >> m_matrix_k_03;
    dcdr >> m_matrix_k_10;
    dcdr >> m_matrix_k_11;
    dcdr >> m_matrix_k_12;
    dcdr >> m_matrix_k_13;
    dcdr >> m_matrix_state_0;
    dcdr >> m_matrix_state_1;
    dcdr >> m_matrix_state_2;
    dcdr >> m_matrix_state_3;
    dcdr >> m_matrix_q_updated_0;
    dcdr >> m_matrix_q_updated_1;
    dcdr >> m_matrix_q_updated_2;
    dcdr >> m_matrix_q_updated_3;
    dcdr >> m_current_x;
    dcdr >> m_current_y;
    dcdr >> m_target_point_x;
    dcdr >> m_target_point_y;
    dcdr >> m_lat_target_point_s;
    dcdr >> m_lqr_calculate_time;
    dcdr >> m_lqr_calculate_time_max;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ControlAnalysis::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ControlAnalysis::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ControlAnalysis::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ControlAnalysis::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member driving_mode
 * @param _driving_mode New value for member driving_mode
 */
void ros2_interface::msg::ControlAnalysis::driving_mode(
        int32_t _driving_mode)
{
    m_driving_mode = _driving_mode;
}

/*!
 * @brief This function returns the value of member driving_mode
 * @return Value of member driving_mode
 */
int32_t ros2_interface::msg::ControlAnalysis::driving_mode() const
{
    return m_driving_mode;
}

/*!
 * @brief This function returns a reference to member driving_mode
 * @return Reference to member driving_mode
 */
int32_t& ros2_interface::msg::ControlAnalysis::driving_mode()
{
    return m_driving_mode;
}

/*!
 * @brief This function sets a value in member driving_mode_fd
 * @param _driving_mode_fd New value for member driving_mode_fd
 */
void ros2_interface::msg::ControlAnalysis::driving_mode_fd(
        int32_t _driving_mode_fd)
{
    m_driving_mode_fd = _driving_mode_fd;
}

/*!
 * @brief This function returns the value of member driving_mode_fd
 * @return Value of member driving_mode_fd
 */
int32_t ros2_interface::msg::ControlAnalysis::driving_mode_fd() const
{
    return m_driving_mode_fd;
}

/*!
 * @brief This function returns a reference to member driving_mode_fd
 * @return Reference to member driving_mode_fd
 */
int32_t& ros2_interface::msg::ControlAnalysis::driving_mode_fd()
{
    return m_driving_mode_fd;
}

/*!
 * @brief This function sets a value in member gear_location_fd
 * @param _gear_location_fd New value for member gear_location_fd
 */
void ros2_interface::msg::ControlAnalysis::gear_location_fd(
        int32_t _gear_location_fd)
{
    m_gear_location_fd = _gear_location_fd;
}

/*!
 * @brief This function returns the value of member gear_location_fd
 * @return Value of member gear_location_fd
 */
int32_t ros2_interface::msg::ControlAnalysis::gear_location_fd() const
{
    return m_gear_location_fd;
}

/*!
 * @brief This function returns a reference to member gear_location_fd
 * @return Reference to member gear_location_fd
 */
int32_t& ros2_interface::msg::ControlAnalysis::gear_location_fd()
{
    return m_gear_location_fd;
}

/*!
 * @brief This function sets a value in member gear_location_cmd
 * @param _gear_location_cmd New value for member gear_location_cmd
 */
void ros2_interface::msg::ControlAnalysis::gear_location_cmd(
        int32_t _gear_location_cmd)
{
    m_gear_location_cmd = _gear_location_cmd;
}

/*!
 * @brief This function returns the value of member gear_location_cmd
 * @return Value of member gear_location_cmd
 */
int32_t ros2_interface::msg::ControlAnalysis::gear_location_cmd() const
{
    return m_gear_location_cmd;
}

/*!
 * @brief This function returns a reference to member gear_location_cmd
 * @return Reference to member gear_location_cmd
 */
int32_t& ros2_interface::msg::ControlAnalysis::gear_location_cmd()
{
    return m_gear_location_cmd;
}

/*!
 * @brief This function sets a value in member epb_level_fd
 * @param _epb_level_fd New value for member epb_level_fd
 */
void ros2_interface::msg::ControlAnalysis::epb_level_fd(
        int32_t _epb_level_fd)
{
    m_epb_level_fd = _epb_level_fd;
}

/*!
 * @brief This function returns the value of member epb_level_fd
 * @return Value of member epb_level_fd
 */
int32_t ros2_interface::msg::ControlAnalysis::epb_level_fd() const
{
    return m_epb_level_fd;
}

/*!
 * @brief This function returns a reference to member epb_level_fd
 * @return Reference to member epb_level_fd
 */
int32_t& ros2_interface::msg::ControlAnalysis::epb_level_fd()
{
    return m_epb_level_fd;
}

/*!
 * @brief This function sets a value in member epb_level_cmd
 * @param _epb_level_cmd New value for member epb_level_cmd
 */
void ros2_interface::msg::ControlAnalysis::epb_level_cmd(
        int32_t _epb_level_cmd)
{
    m_epb_level_cmd = _epb_level_cmd;
}

/*!
 * @brief This function returns the value of member epb_level_cmd
 * @return Value of member epb_level_cmd
 */
int32_t ros2_interface::msg::ControlAnalysis::epb_level_cmd() const
{
    return m_epb_level_cmd;
}

/*!
 * @brief This function returns a reference to member epb_level_cmd
 * @return Reference to member epb_level_cmd
 */
int32_t& ros2_interface::msg::ControlAnalysis::epb_level_cmd()
{
    return m_epb_level_cmd;
}

/*!
 * @brief This function sets a value in member speed_mps
 * @param _speed_mps New value for member speed_mps
 */
void ros2_interface::msg::ControlAnalysis::speed_mps(
        double _speed_mps)
{
    m_speed_mps = _speed_mps;
}

/*!
 * @brief This function returns the value of member speed_mps
 * @return Value of member speed_mps
 */
double ros2_interface::msg::ControlAnalysis::speed_mps() const
{
    return m_speed_mps;
}

/*!
 * @brief This function returns a reference to member speed_mps
 * @return Reference to member speed_mps
 */
double& ros2_interface::msg::ControlAnalysis::speed_mps()
{
    return m_speed_mps;
}

/*!
 * @brief This function sets a value in member speed_reference
 * @param _speed_reference New value for member speed_reference
 */
void ros2_interface::msg::ControlAnalysis::speed_reference(
        double _speed_reference)
{
    m_speed_reference = _speed_reference;
}

/*!
 * @brief This function returns the value of member speed_reference
 * @return Value of member speed_reference
 */
double ros2_interface::msg::ControlAnalysis::speed_reference() const
{
    return m_speed_reference;
}

/*!
 * @brief This function returns a reference to member speed_reference
 * @return Reference to member speed_reference
 */
double& ros2_interface::msg::ControlAnalysis::speed_reference()
{
    return m_speed_reference;
}

/*!
 * @brief This function sets a value in member accel_value_fd
 * @param _accel_value_fd New value for member accel_value_fd
 */
void ros2_interface::msg::ControlAnalysis::accel_value_fd(
        double _accel_value_fd)
{
    m_accel_value_fd = _accel_value_fd;
}

/*!
 * @brief This function returns the value of member accel_value_fd
 * @return Value of member accel_value_fd
 */
double ros2_interface::msg::ControlAnalysis::accel_value_fd() const
{
    return m_accel_value_fd;
}

/*!
 * @brief This function returns a reference to member accel_value_fd
 * @return Reference to member accel_value_fd
 */
double& ros2_interface::msg::ControlAnalysis::accel_value_fd()
{
    return m_accel_value_fd;
}

/*!
 * @brief This function sets a value in member accel_value_cmd
 * @param _accel_value_cmd New value for member accel_value_cmd
 */
void ros2_interface::msg::ControlAnalysis::accel_value_cmd(
        double _accel_value_cmd)
{
    m_accel_value_cmd = _accel_value_cmd;
}

/*!
 * @brief This function returns the value of member accel_value_cmd
 * @return Value of member accel_value_cmd
 */
double ros2_interface::msg::ControlAnalysis::accel_value_cmd() const
{
    return m_accel_value_cmd;
}

/*!
 * @brief This function returns a reference to member accel_value_cmd
 * @return Reference to member accel_value_cmd
 */
double& ros2_interface::msg::ControlAnalysis::accel_value_cmd()
{
    return m_accel_value_cmd;
}

/*!
 * @brief This function sets a value in member brake_value_fd
 * @param _brake_value_fd New value for member brake_value_fd
 */
void ros2_interface::msg::ControlAnalysis::brake_value_fd(
        double _brake_value_fd)
{
    m_brake_value_fd = _brake_value_fd;
}

/*!
 * @brief This function returns the value of member brake_value_fd
 * @return Value of member brake_value_fd
 */
double ros2_interface::msg::ControlAnalysis::brake_value_fd() const
{
    return m_brake_value_fd;
}

/*!
 * @brief This function returns a reference to member brake_value_fd
 * @return Reference to member brake_value_fd
 */
double& ros2_interface::msg::ControlAnalysis::brake_value_fd()
{
    return m_brake_value_fd;
}

/*!
 * @brief This function sets a value in member brake_value_cmd
 * @param _brake_value_cmd New value for member brake_value_cmd
 */
void ros2_interface::msg::ControlAnalysis::brake_value_cmd(
        double _brake_value_cmd)
{
    m_brake_value_cmd = _brake_value_cmd;
}

/*!
 * @brief This function returns the value of member brake_value_cmd
 * @return Value of member brake_value_cmd
 */
double ros2_interface::msg::ControlAnalysis::brake_value_cmd() const
{
    return m_brake_value_cmd;
}

/*!
 * @brief This function returns a reference to member brake_value_cmd
 * @return Reference to member brake_value_cmd
 */
double& ros2_interface::msg::ControlAnalysis::brake_value_cmd()
{
    return m_brake_value_cmd;
}

/*!
 * @brief This function sets a value in member path_remain
 * @param _path_remain New value for member path_remain
 */
void ros2_interface::msg::ControlAnalysis::path_remain(
        double _path_remain)
{
    m_path_remain = _path_remain;
}

/*!
 * @brief This function returns the value of member path_remain
 * @return Value of member path_remain
 */
double ros2_interface::msg::ControlAnalysis::path_remain() const
{
    return m_path_remain;
}

/*!
 * @brief This function returns a reference to member path_remain
 * @return Reference to member path_remain
 */
double& ros2_interface::msg::ControlAnalysis::path_remain()
{
    return m_path_remain;
}

/*!
 * @brief This function sets a value in member has_stop_point
 * @param _has_stop_point New value for member has_stop_point
 */
void ros2_interface::msg::ControlAnalysis::has_stop_point(
        bool _has_stop_point)
{
    m_has_stop_point = _has_stop_point;
}

/*!
 * @brief This function returns the value of member has_stop_point
 * @return Value of member has_stop_point
 */
bool ros2_interface::msg::ControlAnalysis::has_stop_point() const
{
    return m_has_stop_point;
}

/*!
 * @brief This function returns a reference to member has_stop_point
 * @return Reference to member has_stop_point
 */
bool& ros2_interface::msg::ControlAnalysis::has_stop_point()
{
    return m_has_stop_point;
}

/*!
 * @brief This function sets a value in member is_full_stop
 * @param _is_full_stop New value for member is_full_stop
 */
void ros2_interface::msg::ControlAnalysis::is_full_stop(
        bool _is_full_stop)
{
    m_is_full_stop = _is_full_stop;
}

/*!
 * @brief This function returns the value of member is_full_stop
 * @return Value of member is_full_stop
 */
bool ros2_interface::msg::ControlAnalysis::is_full_stop() const
{
    return m_is_full_stop;
}

/*!
 * @brief This function returns a reference to member is_full_stop
 * @return Reference to member is_full_stop
 */
bool& ros2_interface::msg::ControlAnalysis::is_full_stop()
{
    return m_is_full_stop;
}

/*!
 * @brief This function sets a value in member is_stopped
 * @param _is_stopped New value for member is_stopped
 */
void ros2_interface::msg::ControlAnalysis::is_stopped(
        bool _is_stopped)
{
    m_is_stopped = _is_stopped;
}

/*!
 * @brief This function returns the value of member is_stopped
 * @return Value of member is_stopped
 */
bool ros2_interface::msg::ControlAnalysis::is_stopped() const
{
    return m_is_stopped;
}

/*!
 * @brief This function returns a reference to member is_stopped
 * @return Reference to member is_stopped
 */
bool& ros2_interface::msg::ControlAnalysis::is_stopped()
{
    return m_is_stopped;
}

/*!
 * @brief This function sets a value in member lon_acc_jerk
 * @param _lon_acc_jerk New value for member lon_acc_jerk
 */
void ros2_interface::msg::ControlAnalysis::lon_acc_jerk(
        double _lon_acc_jerk)
{
    m_lon_acc_jerk = _lon_acc_jerk;
}

/*!
 * @brief This function returns the value of member lon_acc_jerk
 * @return Value of member lon_acc_jerk
 */
double ros2_interface::msg::ControlAnalysis::lon_acc_jerk() const
{
    return m_lon_acc_jerk;
}

/*!
 * @brief This function returns a reference to member lon_acc_jerk
 * @return Reference to member lon_acc_jerk
 */
double& ros2_interface::msg::ControlAnalysis::lon_acc_jerk()
{
    return m_lon_acc_jerk;
}

/*!
 * @brief This function sets a value in member acceleration_cmd
 * @param _acceleration_cmd New value for member acceleration_cmd
 */
void ros2_interface::msg::ControlAnalysis::acceleration_cmd(
        double _acceleration_cmd)
{
    m_acceleration_cmd = _acceleration_cmd;
}

/*!
 * @brief This function returns the value of member acceleration_cmd
 * @return Value of member acceleration_cmd
 */
double ros2_interface::msg::ControlAnalysis::acceleration_cmd() const
{
    return m_acceleration_cmd;
}

/*!
 * @brief This function returns a reference to member acceleration_cmd
 * @return Reference to member acceleration_cmd
 */
double& ros2_interface::msg::ControlAnalysis::acceleration_cmd()
{
    return m_acceleration_cmd;
}

/*!
 * @brief This function sets a value in member acceleration_cmd_closeloop
 * @param _acceleration_cmd_closeloop New value for member acceleration_cmd_closeloop
 */
void ros2_interface::msg::ControlAnalysis::acceleration_cmd_closeloop(
        double _acceleration_cmd_closeloop)
{
    m_acceleration_cmd_closeloop = _acceleration_cmd_closeloop;
}

/*!
 * @brief This function returns the value of member acceleration_cmd_closeloop
 * @return Value of member acceleration_cmd_closeloop
 */
double ros2_interface::msg::ControlAnalysis::acceleration_cmd_closeloop() const
{
    return m_acceleration_cmd_closeloop;
}

/*!
 * @brief This function returns a reference to member acceleration_cmd_closeloop
 * @return Reference to member acceleration_cmd_closeloop
 */
double& ros2_interface::msg::ControlAnalysis::acceleration_cmd_closeloop()
{
    return m_acceleration_cmd_closeloop;
}

/*!
 * @brief This function sets a value in member preview_acceleration_reference
 * @param _preview_acceleration_reference New value for member preview_acceleration_reference
 */
void ros2_interface::msg::ControlAnalysis::preview_acceleration_reference(
        double _preview_acceleration_reference)
{
    m_preview_acceleration_reference = _preview_acceleration_reference;
}

/*!
 * @brief This function returns the value of member preview_acceleration_reference
 * @return Value of member preview_acceleration_reference
 */
double ros2_interface::msg::ControlAnalysis::preview_acceleration_reference() const
{
    return m_preview_acceleration_reference;
}

/*!
 * @brief This function returns a reference to member preview_acceleration_reference
 * @return Reference to member preview_acceleration_reference
 */
double& ros2_interface::msg::ControlAnalysis::preview_acceleration_reference()
{
    return m_preview_acceleration_reference;
}

/*!
 * @brief This function sets a value in member slope_offset_compensation
 * @param _slope_offset_compensation New value for member slope_offset_compensation
 */
void ros2_interface::msg::ControlAnalysis::slope_offset_compensation(
        double _slope_offset_compensation)
{
    m_slope_offset_compensation = _slope_offset_compensation;
}

/*!
 * @brief This function returns the value of member slope_offset_compensation
 * @return Value of member slope_offset_compensation
 */
double ros2_interface::msg::ControlAnalysis::slope_offset_compensation() const
{
    return m_slope_offset_compensation;
}

/*!
 * @brief This function returns a reference to member slope_offset_compensation
 * @return Reference to member slope_offset_compensation
 */
double& ros2_interface::msg::ControlAnalysis::slope_offset_compensation()
{
    return m_slope_offset_compensation;
}

/*!
 * @brief This function sets a value in member turning_offset_compensation
 * @param _turning_offset_compensation New value for member turning_offset_compensation
 */
void ros2_interface::msg::ControlAnalysis::turning_offset_compensation(
        double _turning_offset_compensation)
{
    m_turning_offset_compensation = _turning_offset_compensation;
}

/*!
 * @brief This function returns the value of member turning_offset_compensation
 * @return Value of member turning_offset_compensation
 */
double ros2_interface::msg::ControlAnalysis::turning_offset_compensation() const
{
    return m_turning_offset_compensation;
}

/*!
 * @brief This function returns a reference to member turning_offset_compensation
 * @return Reference to member turning_offset_compensation
 */
double& ros2_interface::msg::ControlAnalysis::turning_offset_compensation()
{
    return m_turning_offset_compensation;
}

/*!
 * @brief This function sets a value in member speed_error_limited
 * @param _speed_error_limited New value for member speed_error_limited
 */
void ros2_interface::msg::ControlAnalysis::speed_error_limited(
        double _speed_error_limited)
{
    m_speed_error_limited = _speed_error_limited;
}

/*!
 * @brief This function returns the value of member speed_error_limited
 * @return Value of member speed_error_limited
 */
double ros2_interface::msg::ControlAnalysis::speed_error_limited() const
{
    return m_speed_error_limited;
}

/*!
 * @brief This function returns a reference to member speed_error_limited
 * @return Reference to member speed_error_limited
 */
double& ros2_interface::msg::ControlAnalysis::speed_error_limited()
{
    return m_speed_error_limited;
}

/*!
 * @brief This function sets a value in member speed_error
 * @param _speed_error New value for member speed_error
 */
void ros2_interface::msg::ControlAnalysis::speed_error(
        double _speed_error)
{
    m_speed_error = _speed_error;
}

/*!
 * @brief This function returns the value of member speed_error
 * @return Value of member speed_error
 */
double ros2_interface::msg::ControlAnalysis::speed_error() const
{
    return m_speed_error;
}

/*!
 * @brief This function returns a reference to member speed_error
 * @return Reference to member speed_error
 */
double& ros2_interface::msg::ControlAnalysis::speed_error()
{
    return m_speed_error;
}

/*!
 * @brief This function sets a value in member speed_offset
 * @param _speed_offset New value for member speed_offset
 */
void ros2_interface::msg::ControlAnalysis::speed_offset(
        double _speed_offset)
{
    m_speed_offset = _speed_offset;
}

/*!
 * @brief This function returns the value of member speed_offset
 * @return Value of member speed_offset
 */
double ros2_interface::msg::ControlAnalysis::speed_offset() const
{
    return m_speed_offset;
}

/*!
 * @brief This function returns a reference to member speed_offset
 * @return Reference to member speed_offset
 */
double& ros2_interface::msg::ControlAnalysis::speed_offset()
{
    return m_speed_offset;
}

/*!
 * @brief This function sets a value in member station_error_limited
 * @param _station_error_limited New value for member station_error_limited
 */
void ros2_interface::msg::ControlAnalysis::station_error_limited(
        double _station_error_limited)
{
    m_station_error_limited = _station_error_limited;
}

/*!
 * @brief This function returns the value of member station_error_limited
 * @return Value of member station_error_limited
 */
double ros2_interface::msg::ControlAnalysis::station_error_limited() const
{
    return m_station_error_limited;
}

/*!
 * @brief This function returns a reference to member station_error_limited
 * @return Reference to member station_error_limited
 */
double& ros2_interface::msg::ControlAnalysis::station_error_limited()
{
    return m_station_error_limited;
}

/*!
 * @brief This function sets a value in member station_error
 * @param _station_error New value for member station_error
 */
void ros2_interface::msg::ControlAnalysis::station_error(
        double _station_error)
{
    m_station_error = _station_error;
}

/*!
 * @brief This function returns the value of member station_error
 * @return Value of member station_error
 */
double ros2_interface::msg::ControlAnalysis::station_error() const
{
    return m_station_error;
}

/*!
 * @brief This function returns a reference to member station_error
 * @return Reference to member station_error
 */
double& ros2_interface::msg::ControlAnalysis::station_error()
{
    return m_station_error;
}

/*!
 * @brief This function sets a value in member lon_target_point_s
 * @param _lon_target_point_s New value for member lon_target_point_s
 */
void ros2_interface::msg::ControlAnalysis::lon_target_point_s(
        double _lon_target_point_s)
{
    m_lon_target_point_s = _lon_target_point_s;
}

/*!
 * @brief This function returns the value of member lon_target_point_s
 * @return Value of member lon_target_point_s
 */
double ros2_interface::msg::ControlAnalysis::lon_target_point_s() const
{
    return m_lon_target_point_s;
}

/*!
 * @brief This function returns a reference to member lon_target_point_s
 * @return Reference to member lon_target_point_s
 */
double& ros2_interface::msg::ControlAnalysis::lon_target_point_s()
{
    return m_lon_target_point_s;
}

/*!
 * @brief This function sets a value in member lon_calculate_time
 * @param _lon_calculate_time New value for member lon_calculate_time
 */
void ros2_interface::msg::ControlAnalysis::lon_calculate_time(
        int64_t _lon_calculate_time)
{
    m_lon_calculate_time = _lon_calculate_time;
}

/*!
 * @brief This function returns the value of member lon_calculate_time
 * @return Value of member lon_calculate_time
 */
int64_t ros2_interface::msg::ControlAnalysis::lon_calculate_time() const
{
    return m_lon_calculate_time;
}

/*!
 * @brief This function returns a reference to member lon_calculate_time
 * @return Reference to member lon_calculate_time
 */
int64_t& ros2_interface::msg::ControlAnalysis::lon_calculate_time()
{
    return m_lon_calculate_time;
}

/*!
 * @brief This function sets a value in member lon_calculate_time_max
 * @param _lon_calculate_time_max New value for member lon_calculate_time_max
 */
void ros2_interface::msg::ControlAnalysis::lon_calculate_time_max(
        int64_t _lon_calculate_time_max)
{
    m_lon_calculate_time_max = _lon_calculate_time_max;
}

/*!
 * @brief This function returns the value of member lon_calculate_time_max
 * @return Value of member lon_calculate_time_max
 */
int64_t ros2_interface::msg::ControlAnalysis::lon_calculate_time_max() const
{
    return m_lon_calculate_time_max;
}

/*!
 * @brief This function returns a reference to member lon_calculate_time_max
 * @return Reference to member lon_calculate_time_max
 */
int64_t& ros2_interface::msg::ControlAnalysis::lon_calculate_time_max()
{
    return m_lon_calculate_time_max;
}

/*!
 * @brief This function sets a value in member ref_curvature
 * @param _ref_curvature New value for member ref_curvature
 */
void ros2_interface::msg::ControlAnalysis::ref_curvature(
        double _ref_curvature)
{
    m_ref_curvature = _ref_curvature;
}

/*!
 * @brief This function returns the value of member ref_curvature
 * @return Value of member ref_curvature
 */
double ros2_interface::msg::ControlAnalysis::ref_curvature() const
{
    return m_ref_curvature;
}

/*!
 * @brief This function returns a reference to member ref_curvature
 * @return Reference to member ref_curvature
 */
double& ros2_interface::msg::ControlAnalysis::ref_curvature()
{
    return m_ref_curvature;
}

/*!
 * @brief This function sets a value in member ref_heading
 * @param _ref_heading New value for member ref_heading
 */
void ros2_interface::msg::ControlAnalysis::ref_heading(
        double _ref_heading)
{
    m_ref_heading = _ref_heading;
}

/*!
 * @brief This function returns the value of member ref_heading
 * @return Value of member ref_heading
 */
double ros2_interface::msg::ControlAnalysis::ref_heading() const
{
    return m_ref_heading;
}

/*!
 * @brief This function returns a reference to member ref_heading
 * @return Reference to member ref_heading
 */
double& ros2_interface::msg::ControlAnalysis::ref_heading()
{
    return m_ref_heading;
}

/*!
 * @brief This function sets a value in member current_heading
 * @param _current_heading New value for member current_heading
 */
void ros2_interface::msg::ControlAnalysis::current_heading(
        double _current_heading)
{
    m_current_heading = _current_heading;
}

/*!
 * @brief This function returns the value of member current_heading
 * @return Value of member current_heading
 */
double ros2_interface::msg::ControlAnalysis::current_heading() const
{
    return m_current_heading;
}

/*!
 * @brief This function returns a reference to member current_heading
 * @return Reference to member current_heading
 */
double& ros2_interface::msg::ControlAnalysis::current_heading()
{
    return m_current_heading;
}

/*!
 * @brief This function sets a value in member heading_error
 * @param _heading_error New value for member heading_error
 */
void ros2_interface::msg::ControlAnalysis::heading_error(
        double _heading_error)
{
    m_heading_error = _heading_error;
}

/*!
 * @brief This function returns the value of member heading_error
 * @return Value of member heading_error
 */
double ros2_interface::msg::ControlAnalysis::heading_error() const
{
    return m_heading_error;
}

/*!
 * @brief This function returns a reference to member heading_error
 * @return Reference to member heading_error
 */
double& ros2_interface::msg::ControlAnalysis::heading_error()
{
    return m_heading_error;
}

/*!
 * @brief This function sets a value in member heading_error_rate
 * @param _heading_error_rate New value for member heading_error_rate
 */
void ros2_interface::msg::ControlAnalysis::heading_error_rate(
        double _heading_error_rate)
{
    m_heading_error_rate = _heading_error_rate;
}

/*!
 * @brief This function returns the value of member heading_error_rate
 * @return Value of member heading_error_rate
 */
double ros2_interface::msg::ControlAnalysis::heading_error_rate() const
{
    return m_heading_error_rate;
}

/*!
 * @brief This function returns a reference to member heading_error_rate
 * @return Reference to member heading_error_rate
 */
double& ros2_interface::msg::ControlAnalysis::heading_error_rate()
{
    return m_heading_error_rate;
}

/*!
 * @brief This function sets a value in member lateral_error
 * @param _lateral_error New value for member lateral_error
 */
void ros2_interface::msg::ControlAnalysis::lateral_error(
        double _lateral_error)
{
    m_lateral_error = _lateral_error;
}

/*!
 * @brief This function returns the value of member lateral_error
 * @return Value of member lateral_error
 */
double ros2_interface::msg::ControlAnalysis::lateral_error() const
{
    return m_lateral_error;
}

/*!
 * @brief This function returns a reference to member lateral_error
 * @return Reference to member lateral_error
 */
double& ros2_interface::msg::ControlAnalysis::lateral_error()
{
    return m_lateral_error;
}

/*!
 * @brief This function sets a value in member lateral_error_rate
 * @param _lateral_error_rate New value for member lateral_error_rate
 */
void ros2_interface::msg::ControlAnalysis::lateral_error_rate(
        double _lateral_error_rate)
{
    m_lateral_error_rate = _lateral_error_rate;
}

/*!
 * @brief This function returns the value of member lateral_error_rate
 * @return Value of member lateral_error_rate
 */
double ros2_interface::msg::ControlAnalysis::lateral_error_rate() const
{
    return m_lateral_error_rate;
}

/*!
 * @brief This function returns a reference to member lateral_error_rate
 * @return Reference to member lateral_error_rate
 */
double& ros2_interface::msg::ControlAnalysis::lateral_error_rate()
{
    return m_lateral_error_rate;
}

/*!
 * @brief This function sets a value in member lon_error
 * @param _lon_error New value for member lon_error
 */
void ros2_interface::msg::ControlAnalysis::lon_error(
        double _lon_error)
{
    m_lon_error = _lon_error;
}

/*!
 * @brief This function returns the value of member lon_error
 * @return Value of member lon_error
 */
double ros2_interface::msg::ControlAnalysis::lon_error() const
{
    return m_lon_error;
}

/*!
 * @brief This function returns a reference to member lon_error
 * @return Reference to member lon_error
 */
double& ros2_interface::msg::ControlAnalysis::lon_error()
{
    return m_lon_error;
}

/*!
 * @brief This function sets a value in member front_steering_value_fd
 * @param _front_steering_value_fd New value for member front_steering_value_fd
 */
void ros2_interface::msg::ControlAnalysis::front_steering_value_fd(
        double _front_steering_value_fd)
{
    m_front_steering_value_fd = _front_steering_value_fd;
}

/*!
 * @brief This function returns the value of member front_steering_value_fd
 * @return Value of member front_steering_value_fd
 */
double ros2_interface::msg::ControlAnalysis::front_steering_value_fd() const
{
    return m_front_steering_value_fd;
}

/*!
 * @brief This function returns a reference to member front_steering_value_fd
 * @return Reference to member front_steering_value_fd
 */
double& ros2_interface::msg::ControlAnalysis::front_steering_value_fd()
{
    return m_front_steering_value_fd;
}

/*!
 * @brief This function sets a value in member front_steering_target
 * @param _front_steering_target New value for member front_steering_target
 */
void ros2_interface::msg::ControlAnalysis::front_steering_target(
        double _front_steering_target)
{
    m_front_steering_target = _front_steering_target;
}

/*!
 * @brief This function returns the value of member front_steering_target
 * @return Value of member front_steering_target
 */
double ros2_interface::msg::ControlAnalysis::front_steering_target() const
{
    return m_front_steering_target;
}

/*!
 * @brief This function returns a reference to member front_steering_target
 * @return Reference to member front_steering_target
 */
double& ros2_interface::msg::ControlAnalysis::front_steering_target()
{
    return m_front_steering_target;
}

/*!
 * @brief This function sets a value in member front_steering_rate
 * @param _front_steering_rate New value for member front_steering_rate
 */
void ros2_interface::msg::ControlAnalysis::front_steering_rate(
        double _front_steering_rate)
{
    m_front_steering_rate = _front_steering_rate;
}

/*!
 * @brief This function returns the value of member front_steering_rate
 * @return Value of member front_steering_rate
 */
double ros2_interface::msg::ControlAnalysis::front_steering_rate() const
{
    return m_front_steering_rate;
}

/*!
 * @brief This function returns a reference to member front_steering_rate
 * @return Reference to member front_steering_rate
 */
double& ros2_interface::msg::ControlAnalysis::front_steering_rate()
{
    return m_front_steering_rate;
}

/*!
 * @brief This function sets a value in member front_steer_angle_feedforward
 * @param _front_steer_angle_feedforward New value for member front_steer_angle_feedforward
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_feedforward(
        double _front_steer_angle_feedforward)
{
    m_front_steer_angle_feedforward = _front_steer_angle_feedforward;
}

/*!
 * @brief This function returns the value of member front_steer_angle_feedforward
 * @return Value of member front_steer_angle_feedforward
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_feedforward() const
{
    return m_front_steer_angle_feedforward;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_feedforward
 * @return Reference to member front_steer_angle_feedforward
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_feedforward()
{
    return m_front_steer_angle_feedforward;
}

/*!
 * @brief This function sets a value in member front_steer_angle_feedback
 * @param _front_steer_angle_feedback New value for member front_steer_angle_feedback
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_feedback(
        double _front_steer_angle_feedback)
{
    m_front_steer_angle_feedback = _front_steer_angle_feedback;
}

/*!
 * @brief This function returns the value of member front_steer_angle_feedback
 * @return Value of member front_steer_angle_feedback
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_feedback() const
{
    return m_front_steer_angle_feedback;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_feedback
 * @return Reference to member front_steer_angle_feedback
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_feedback()
{
    return m_front_steer_angle_feedback;
}

/*!
 * @brief This function sets a value in member front_steer_angle_lateral_contribution
 * @param _front_steer_angle_lateral_contribution New value for member front_steer_angle_lateral_contribution
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_contribution(
        double _front_steer_angle_lateral_contribution)
{
    m_front_steer_angle_lateral_contribution = _front_steer_angle_lateral_contribution;
}

/*!
 * @brief This function returns the value of member front_steer_angle_lateral_contribution
 * @return Value of member front_steer_angle_lateral_contribution
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_contribution() const
{
    return m_front_steer_angle_lateral_contribution;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_lateral_contribution
 * @return Reference to member front_steer_angle_lateral_contribution
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_contribution()
{
    return m_front_steer_angle_lateral_contribution;
}

/*!
 * @brief This function sets a value in member front_steer_angle_lateral_rate_contribution
 * @param _front_steer_angle_lateral_rate_contribution New value for member front_steer_angle_lateral_rate_contribution
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_rate_contribution(
        double _front_steer_angle_lateral_rate_contribution)
{
    m_front_steer_angle_lateral_rate_contribution = _front_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function returns the value of member front_steer_angle_lateral_rate_contribution
 * @return Value of member front_steer_angle_lateral_rate_contribution
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_rate_contribution() const
{
    return m_front_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_lateral_rate_contribution
 * @return Reference to member front_steer_angle_lateral_rate_contribution
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_lateral_rate_contribution()
{
    return m_front_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function sets a value in member front_steer_angle_heading_contribution
 * @param _front_steer_angle_heading_contribution New value for member front_steer_angle_heading_contribution
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_contribution(
        double _front_steer_angle_heading_contribution)
{
    m_front_steer_angle_heading_contribution = _front_steer_angle_heading_contribution;
}

/*!
 * @brief This function returns the value of member front_steer_angle_heading_contribution
 * @return Value of member front_steer_angle_heading_contribution
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_contribution() const
{
    return m_front_steer_angle_heading_contribution;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_heading_contribution
 * @return Reference to member front_steer_angle_heading_contribution
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_contribution()
{
    return m_front_steer_angle_heading_contribution;
}

/*!
 * @brief This function sets a value in member front_steer_angle_heading_rate_contribution
 * @param _front_steer_angle_heading_rate_contribution New value for member front_steer_angle_heading_rate_contribution
 */
void ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_rate_contribution(
        double _front_steer_angle_heading_rate_contribution)
{
    m_front_steer_angle_heading_rate_contribution = _front_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function returns the value of member front_steer_angle_heading_rate_contribution
 * @return Value of member front_steer_angle_heading_rate_contribution
 */
double ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_rate_contribution() const
{
    return m_front_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function returns a reference to member front_steer_angle_heading_rate_contribution
 * @return Reference to member front_steer_angle_heading_rate_contribution
 */
double& ros2_interface::msg::ControlAnalysis::front_steer_angle_heading_rate_contribution()
{
    return m_front_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function sets a value in member rear_steering_value_fd
 * @param _rear_steering_value_fd New value for member rear_steering_value_fd
 */
void ros2_interface::msg::ControlAnalysis::rear_steering_value_fd(
        double _rear_steering_value_fd)
{
    m_rear_steering_value_fd = _rear_steering_value_fd;
}

/*!
 * @brief This function returns the value of member rear_steering_value_fd
 * @return Value of member rear_steering_value_fd
 */
double ros2_interface::msg::ControlAnalysis::rear_steering_value_fd() const
{
    return m_rear_steering_value_fd;
}

/*!
 * @brief This function returns a reference to member rear_steering_value_fd
 * @return Reference to member rear_steering_value_fd
 */
double& ros2_interface::msg::ControlAnalysis::rear_steering_value_fd()
{
    return m_rear_steering_value_fd;
}

/*!
 * @brief This function sets a value in member rear_steering_target
 * @param _rear_steering_target New value for member rear_steering_target
 */
void ros2_interface::msg::ControlAnalysis::rear_steering_target(
        double _rear_steering_target)
{
    m_rear_steering_target = _rear_steering_target;
}

/*!
 * @brief This function returns the value of member rear_steering_target
 * @return Value of member rear_steering_target
 */
double ros2_interface::msg::ControlAnalysis::rear_steering_target() const
{
    return m_rear_steering_target;
}

/*!
 * @brief This function returns a reference to member rear_steering_target
 * @return Reference to member rear_steering_target
 */
double& ros2_interface::msg::ControlAnalysis::rear_steering_target()
{
    return m_rear_steering_target;
}

/*!
 * @brief This function sets a value in member rear_steering_rate
 * @param _rear_steering_rate New value for member rear_steering_rate
 */
void ros2_interface::msg::ControlAnalysis::rear_steering_rate(
        double _rear_steering_rate)
{
    m_rear_steering_rate = _rear_steering_rate;
}

/*!
 * @brief This function returns the value of member rear_steering_rate
 * @return Value of member rear_steering_rate
 */
double ros2_interface::msg::ControlAnalysis::rear_steering_rate() const
{
    return m_rear_steering_rate;
}

/*!
 * @brief This function returns a reference to member rear_steering_rate
 * @return Reference to member rear_steering_rate
 */
double& ros2_interface::msg::ControlAnalysis::rear_steering_rate()
{
    return m_rear_steering_rate;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_feedforward
 * @param _rear_steer_angle_feedforward New value for member rear_steer_angle_feedforward
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedforward(
        double _rear_steer_angle_feedforward)
{
    m_rear_steer_angle_feedforward = _rear_steer_angle_feedforward;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_feedforward
 * @return Value of member rear_steer_angle_feedforward
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedforward() const
{
    return m_rear_steer_angle_feedforward;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_feedforward
 * @return Reference to member rear_steer_angle_feedforward
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedforward()
{
    return m_rear_steer_angle_feedforward;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_feedback
 * @param _rear_steer_angle_feedback New value for member rear_steer_angle_feedback
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedback(
        double _rear_steer_angle_feedback)
{
    m_rear_steer_angle_feedback = _rear_steer_angle_feedback;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_feedback
 * @return Value of member rear_steer_angle_feedback
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedback() const
{
    return m_rear_steer_angle_feedback;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_feedback
 * @return Reference to member rear_steer_angle_feedback
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_feedback()
{
    return m_rear_steer_angle_feedback;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_lateral_contribution
 * @param _rear_steer_angle_lateral_contribution New value for member rear_steer_angle_lateral_contribution
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_contribution(
        double _rear_steer_angle_lateral_contribution)
{
    m_rear_steer_angle_lateral_contribution = _rear_steer_angle_lateral_contribution;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_lateral_contribution
 * @return Value of member rear_steer_angle_lateral_contribution
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_contribution() const
{
    return m_rear_steer_angle_lateral_contribution;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_lateral_contribution
 * @return Reference to member rear_steer_angle_lateral_contribution
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_contribution()
{
    return m_rear_steer_angle_lateral_contribution;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_lateral_rate_contribution
 * @param _rear_steer_angle_lateral_rate_contribution New value for member rear_steer_angle_lateral_rate_contribution
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_rate_contribution(
        double _rear_steer_angle_lateral_rate_contribution)
{
    m_rear_steer_angle_lateral_rate_contribution = _rear_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_lateral_rate_contribution
 * @return Value of member rear_steer_angle_lateral_rate_contribution
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_rate_contribution() const
{
    return m_rear_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_lateral_rate_contribution
 * @return Reference to member rear_steer_angle_lateral_rate_contribution
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_lateral_rate_contribution()
{
    return m_rear_steer_angle_lateral_rate_contribution;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_heading_contribution
 * @param _rear_steer_angle_heading_contribution New value for member rear_steer_angle_heading_contribution
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_contribution(
        double _rear_steer_angle_heading_contribution)
{
    m_rear_steer_angle_heading_contribution = _rear_steer_angle_heading_contribution;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_heading_contribution
 * @return Value of member rear_steer_angle_heading_contribution
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_contribution() const
{
    return m_rear_steer_angle_heading_contribution;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_heading_contribution
 * @return Reference to member rear_steer_angle_heading_contribution
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_contribution()
{
    return m_rear_steer_angle_heading_contribution;
}

/*!
 * @brief This function sets a value in member rear_steer_angle_heading_rate_contribution
 * @param _rear_steer_angle_heading_rate_contribution New value for member rear_steer_angle_heading_rate_contribution
 */
void ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_rate_contribution(
        double _rear_steer_angle_heading_rate_contribution)
{
    m_rear_steer_angle_heading_rate_contribution = _rear_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function returns the value of member rear_steer_angle_heading_rate_contribution
 * @return Value of member rear_steer_angle_heading_rate_contribution
 */
double ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_rate_contribution() const
{
    return m_rear_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function returns a reference to member rear_steer_angle_heading_rate_contribution
 * @return Reference to member rear_steer_angle_heading_rate_contribution
 */
double& ros2_interface::msg::ControlAnalysis::rear_steer_angle_heading_rate_contribution()
{
    return m_rear_steer_angle_heading_rate_contribution;
}

/*!
 * @brief This function sets a value in member matrix_k_00
 * @param _matrix_k_00 New value for member matrix_k_00
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_00(
        double _matrix_k_00)
{
    m_matrix_k_00 = _matrix_k_00;
}

/*!
 * @brief This function returns the value of member matrix_k_00
 * @return Value of member matrix_k_00
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_00() const
{
    return m_matrix_k_00;
}

/*!
 * @brief This function returns a reference to member matrix_k_00
 * @return Reference to member matrix_k_00
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_00()
{
    return m_matrix_k_00;
}

/*!
 * @brief This function sets a value in member matrix_k_01
 * @param _matrix_k_01 New value for member matrix_k_01
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_01(
        double _matrix_k_01)
{
    m_matrix_k_01 = _matrix_k_01;
}

/*!
 * @brief This function returns the value of member matrix_k_01
 * @return Value of member matrix_k_01
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_01() const
{
    return m_matrix_k_01;
}

/*!
 * @brief This function returns a reference to member matrix_k_01
 * @return Reference to member matrix_k_01
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_01()
{
    return m_matrix_k_01;
}

/*!
 * @brief This function sets a value in member matrix_k_02
 * @param _matrix_k_02 New value for member matrix_k_02
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_02(
        double _matrix_k_02)
{
    m_matrix_k_02 = _matrix_k_02;
}

/*!
 * @brief This function returns the value of member matrix_k_02
 * @return Value of member matrix_k_02
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_02() const
{
    return m_matrix_k_02;
}

/*!
 * @brief This function returns a reference to member matrix_k_02
 * @return Reference to member matrix_k_02
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_02()
{
    return m_matrix_k_02;
}

/*!
 * @brief This function sets a value in member matrix_k_03
 * @param _matrix_k_03 New value for member matrix_k_03
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_03(
        double _matrix_k_03)
{
    m_matrix_k_03 = _matrix_k_03;
}

/*!
 * @brief This function returns the value of member matrix_k_03
 * @return Value of member matrix_k_03
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_03() const
{
    return m_matrix_k_03;
}

/*!
 * @brief This function returns a reference to member matrix_k_03
 * @return Reference to member matrix_k_03
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_03()
{
    return m_matrix_k_03;
}

/*!
 * @brief This function sets a value in member matrix_k_10
 * @param _matrix_k_10 New value for member matrix_k_10
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_10(
        double _matrix_k_10)
{
    m_matrix_k_10 = _matrix_k_10;
}

/*!
 * @brief This function returns the value of member matrix_k_10
 * @return Value of member matrix_k_10
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_10() const
{
    return m_matrix_k_10;
}

/*!
 * @brief This function returns a reference to member matrix_k_10
 * @return Reference to member matrix_k_10
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_10()
{
    return m_matrix_k_10;
}

/*!
 * @brief This function sets a value in member matrix_k_11
 * @param _matrix_k_11 New value for member matrix_k_11
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_11(
        double _matrix_k_11)
{
    m_matrix_k_11 = _matrix_k_11;
}

/*!
 * @brief This function returns the value of member matrix_k_11
 * @return Value of member matrix_k_11
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_11() const
{
    return m_matrix_k_11;
}

/*!
 * @brief This function returns a reference to member matrix_k_11
 * @return Reference to member matrix_k_11
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_11()
{
    return m_matrix_k_11;
}

/*!
 * @brief This function sets a value in member matrix_k_12
 * @param _matrix_k_12 New value for member matrix_k_12
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_12(
        double _matrix_k_12)
{
    m_matrix_k_12 = _matrix_k_12;
}

/*!
 * @brief This function returns the value of member matrix_k_12
 * @return Value of member matrix_k_12
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_12() const
{
    return m_matrix_k_12;
}

/*!
 * @brief This function returns a reference to member matrix_k_12
 * @return Reference to member matrix_k_12
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_12()
{
    return m_matrix_k_12;
}

/*!
 * @brief This function sets a value in member matrix_k_13
 * @param _matrix_k_13 New value for member matrix_k_13
 */
void ros2_interface::msg::ControlAnalysis::matrix_k_13(
        double _matrix_k_13)
{
    m_matrix_k_13 = _matrix_k_13;
}

/*!
 * @brief This function returns the value of member matrix_k_13
 * @return Value of member matrix_k_13
 */
double ros2_interface::msg::ControlAnalysis::matrix_k_13() const
{
    return m_matrix_k_13;
}

/*!
 * @brief This function returns a reference to member matrix_k_13
 * @return Reference to member matrix_k_13
 */
double& ros2_interface::msg::ControlAnalysis::matrix_k_13()
{
    return m_matrix_k_13;
}

/*!
 * @brief This function sets a value in member matrix_state_0
 * @param _matrix_state_0 New value for member matrix_state_0
 */
void ros2_interface::msg::ControlAnalysis::matrix_state_0(
        double _matrix_state_0)
{
    m_matrix_state_0 = _matrix_state_0;
}

/*!
 * @brief This function returns the value of member matrix_state_0
 * @return Value of member matrix_state_0
 */
double ros2_interface::msg::ControlAnalysis::matrix_state_0() const
{
    return m_matrix_state_0;
}

/*!
 * @brief This function returns a reference to member matrix_state_0
 * @return Reference to member matrix_state_0
 */
double& ros2_interface::msg::ControlAnalysis::matrix_state_0()
{
    return m_matrix_state_0;
}

/*!
 * @brief This function sets a value in member matrix_state_1
 * @param _matrix_state_1 New value for member matrix_state_1
 */
void ros2_interface::msg::ControlAnalysis::matrix_state_1(
        double _matrix_state_1)
{
    m_matrix_state_1 = _matrix_state_1;
}

/*!
 * @brief This function returns the value of member matrix_state_1
 * @return Value of member matrix_state_1
 */
double ros2_interface::msg::ControlAnalysis::matrix_state_1() const
{
    return m_matrix_state_1;
}

/*!
 * @brief This function returns a reference to member matrix_state_1
 * @return Reference to member matrix_state_1
 */
double& ros2_interface::msg::ControlAnalysis::matrix_state_1()
{
    return m_matrix_state_1;
}

/*!
 * @brief This function sets a value in member matrix_state_2
 * @param _matrix_state_2 New value for member matrix_state_2
 */
void ros2_interface::msg::ControlAnalysis::matrix_state_2(
        double _matrix_state_2)
{
    m_matrix_state_2 = _matrix_state_2;
}

/*!
 * @brief This function returns the value of member matrix_state_2
 * @return Value of member matrix_state_2
 */
double ros2_interface::msg::ControlAnalysis::matrix_state_2() const
{
    return m_matrix_state_2;
}

/*!
 * @brief This function returns a reference to member matrix_state_2
 * @return Reference to member matrix_state_2
 */
double& ros2_interface::msg::ControlAnalysis::matrix_state_2()
{
    return m_matrix_state_2;
}

/*!
 * @brief This function sets a value in member matrix_state_3
 * @param _matrix_state_3 New value for member matrix_state_3
 */
void ros2_interface::msg::ControlAnalysis::matrix_state_3(
        double _matrix_state_3)
{
    m_matrix_state_3 = _matrix_state_3;
}

/*!
 * @brief This function returns the value of member matrix_state_3
 * @return Value of member matrix_state_3
 */
double ros2_interface::msg::ControlAnalysis::matrix_state_3() const
{
    return m_matrix_state_3;
}

/*!
 * @brief This function returns a reference to member matrix_state_3
 * @return Reference to member matrix_state_3
 */
double& ros2_interface::msg::ControlAnalysis::matrix_state_3()
{
    return m_matrix_state_3;
}

/*!
 * @brief This function sets a value in member matrix_q_updated_0
 * @param _matrix_q_updated_0 New value for member matrix_q_updated_0
 */
void ros2_interface::msg::ControlAnalysis::matrix_q_updated_0(
        double _matrix_q_updated_0)
{
    m_matrix_q_updated_0 = _matrix_q_updated_0;
}

/*!
 * @brief This function returns the value of member matrix_q_updated_0
 * @return Value of member matrix_q_updated_0
 */
double ros2_interface::msg::ControlAnalysis::matrix_q_updated_0() const
{
    return m_matrix_q_updated_0;
}

/*!
 * @brief This function returns a reference to member matrix_q_updated_0
 * @return Reference to member matrix_q_updated_0
 */
double& ros2_interface::msg::ControlAnalysis::matrix_q_updated_0()
{
    return m_matrix_q_updated_0;
}

/*!
 * @brief This function sets a value in member matrix_q_updated_1
 * @param _matrix_q_updated_1 New value for member matrix_q_updated_1
 */
void ros2_interface::msg::ControlAnalysis::matrix_q_updated_1(
        double _matrix_q_updated_1)
{
    m_matrix_q_updated_1 = _matrix_q_updated_1;
}

/*!
 * @brief This function returns the value of member matrix_q_updated_1
 * @return Value of member matrix_q_updated_1
 */
double ros2_interface::msg::ControlAnalysis::matrix_q_updated_1() const
{
    return m_matrix_q_updated_1;
}

/*!
 * @brief This function returns a reference to member matrix_q_updated_1
 * @return Reference to member matrix_q_updated_1
 */
double& ros2_interface::msg::ControlAnalysis::matrix_q_updated_1()
{
    return m_matrix_q_updated_1;
}

/*!
 * @brief This function sets a value in member matrix_q_updated_2
 * @param _matrix_q_updated_2 New value for member matrix_q_updated_2
 */
void ros2_interface::msg::ControlAnalysis::matrix_q_updated_2(
        double _matrix_q_updated_2)
{
    m_matrix_q_updated_2 = _matrix_q_updated_2;
}

/*!
 * @brief This function returns the value of member matrix_q_updated_2
 * @return Value of member matrix_q_updated_2
 */
double ros2_interface::msg::ControlAnalysis::matrix_q_updated_2() const
{
    return m_matrix_q_updated_2;
}

/*!
 * @brief This function returns a reference to member matrix_q_updated_2
 * @return Reference to member matrix_q_updated_2
 */
double& ros2_interface::msg::ControlAnalysis::matrix_q_updated_2()
{
    return m_matrix_q_updated_2;
}

/*!
 * @brief This function sets a value in member matrix_q_updated_3
 * @param _matrix_q_updated_3 New value for member matrix_q_updated_3
 */
void ros2_interface::msg::ControlAnalysis::matrix_q_updated_3(
        double _matrix_q_updated_3)
{
    m_matrix_q_updated_3 = _matrix_q_updated_3;
}

/*!
 * @brief This function returns the value of member matrix_q_updated_3
 * @return Value of member matrix_q_updated_3
 */
double ros2_interface::msg::ControlAnalysis::matrix_q_updated_3() const
{
    return m_matrix_q_updated_3;
}

/*!
 * @brief This function returns a reference to member matrix_q_updated_3
 * @return Reference to member matrix_q_updated_3
 */
double& ros2_interface::msg::ControlAnalysis::matrix_q_updated_3()
{
    return m_matrix_q_updated_3;
}

/*!
 * @brief This function sets a value in member current_x
 * @param _current_x New value for member current_x
 */
void ros2_interface::msg::ControlAnalysis::current_x(
        double _current_x)
{
    m_current_x = _current_x;
}

/*!
 * @brief This function returns the value of member current_x
 * @return Value of member current_x
 */
double ros2_interface::msg::ControlAnalysis::current_x() const
{
    return m_current_x;
}

/*!
 * @brief This function returns a reference to member current_x
 * @return Reference to member current_x
 */
double& ros2_interface::msg::ControlAnalysis::current_x()
{
    return m_current_x;
}

/*!
 * @brief This function sets a value in member current_y
 * @param _current_y New value for member current_y
 */
void ros2_interface::msg::ControlAnalysis::current_y(
        double _current_y)
{
    m_current_y = _current_y;
}

/*!
 * @brief This function returns the value of member current_y
 * @return Value of member current_y
 */
double ros2_interface::msg::ControlAnalysis::current_y() const
{
    return m_current_y;
}

/*!
 * @brief This function returns a reference to member current_y
 * @return Reference to member current_y
 */
double& ros2_interface::msg::ControlAnalysis::current_y()
{
    return m_current_y;
}

/*!
 * @brief This function sets a value in member target_point_x
 * @param _target_point_x New value for member target_point_x
 */
void ros2_interface::msg::ControlAnalysis::target_point_x(
        double _target_point_x)
{
    m_target_point_x = _target_point_x;
}

/*!
 * @brief This function returns the value of member target_point_x
 * @return Value of member target_point_x
 */
double ros2_interface::msg::ControlAnalysis::target_point_x() const
{
    return m_target_point_x;
}

/*!
 * @brief This function returns a reference to member target_point_x
 * @return Reference to member target_point_x
 */
double& ros2_interface::msg::ControlAnalysis::target_point_x()
{
    return m_target_point_x;
}

/*!
 * @brief This function sets a value in member target_point_y
 * @param _target_point_y New value for member target_point_y
 */
void ros2_interface::msg::ControlAnalysis::target_point_y(
        double _target_point_y)
{
    m_target_point_y = _target_point_y;
}

/*!
 * @brief This function returns the value of member target_point_y
 * @return Value of member target_point_y
 */
double ros2_interface::msg::ControlAnalysis::target_point_y() const
{
    return m_target_point_y;
}

/*!
 * @brief This function returns a reference to member target_point_y
 * @return Reference to member target_point_y
 */
double& ros2_interface::msg::ControlAnalysis::target_point_y()
{
    return m_target_point_y;
}

/*!
 * @brief This function sets a value in member lat_target_point_s
 * @param _lat_target_point_s New value for member lat_target_point_s
 */
void ros2_interface::msg::ControlAnalysis::lat_target_point_s(
        double _lat_target_point_s)
{
    m_lat_target_point_s = _lat_target_point_s;
}

/*!
 * @brief This function returns the value of member lat_target_point_s
 * @return Value of member lat_target_point_s
 */
double ros2_interface::msg::ControlAnalysis::lat_target_point_s() const
{
    return m_lat_target_point_s;
}

/*!
 * @brief This function returns a reference to member lat_target_point_s
 * @return Reference to member lat_target_point_s
 */
double& ros2_interface::msg::ControlAnalysis::lat_target_point_s()
{
    return m_lat_target_point_s;
}

/*!
 * @brief This function sets a value in member lqr_calculate_time
 * @param _lqr_calculate_time New value for member lqr_calculate_time
 */
void ros2_interface::msg::ControlAnalysis::lqr_calculate_time(
        int64_t _lqr_calculate_time)
{
    m_lqr_calculate_time = _lqr_calculate_time;
}

/*!
 * @brief This function returns the value of member lqr_calculate_time
 * @return Value of member lqr_calculate_time
 */
int64_t ros2_interface::msg::ControlAnalysis::lqr_calculate_time() const
{
    return m_lqr_calculate_time;
}

/*!
 * @brief This function returns a reference to member lqr_calculate_time
 * @return Reference to member lqr_calculate_time
 */
int64_t& ros2_interface::msg::ControlAnalysis::lqr_calculate_time()
{
    return m_lqr_calculate_time;
}

/*!
 * @brief This function sets a value in member lqr_calculate_time_max
 * @param _lqr_calculate_time_max New value for member lqr_calculate_time_max
 */
void ros2_interface::msg::ControlAnalysis::lqr_calculate_time_max(
        int64_t _lqr_calculate_time_max)
{
    m_lqr_calculate_time_max = _lqr_calculate_time_max;
}

/*!
 * @brief This function returns the value of member lqr_calculate_time_max
 * @return Value of member lqr_calculate_time_max
 */
int64_t ros2_interface::msg::ControlAnalysis::lqr_calculate_time_max() const
{
    return m_lqr_calculate_time_max;
}

/*!
 * @brief This function returns a reference to member lqr_calculate_time_max
 * @return Reference to member lqr_calculate_time_max
 */
int64_t& ros2_interface::msg::ControlAnalysis::lqr_calculate_time_max()
{
    return m_lqr_calculate_time_max;
}



size_t ros2_interface::msg::ControlAnalysis::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ControlAnalysis_max_key_cdr_typesize;
}

bool ros2_interface::msg::ControlAnalysis::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ControlAnalysis::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



