// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ControlAnalysis.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLANALYSIS_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLANALYSIS_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(CONTROLANALYSIS_SOURCE)
#define CONTROLANALYSIS_DllAPI __declspec( dllexport )
#else
#define CONTROLANALYSIS_DllAPI __declspec( dllimport )
#endif // CONTROLANALYSIS_SOURCE
#else
#define CONTROLANALYSIS_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define CONTROLANALYSIS_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ControlAnalysis defined by the user in the IDL file.
         * @ingroup ControlAnalysis
         */
        class ControlAnalysis
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ControlAnalysis();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ControlAnalysis();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ControlAnalysis that will be copied.
             */
            eProsima_user_DllExport ControlAnalysis(
                    const ControlAnalysis& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ControlAnalysis that will be copied.
             */
            eProsima_user_DllExport ControlAnalysis(
                    ControlAnalysis&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ControlAnalysis that will be copied.
             */
            eProsima_user_DllExport ControlAnalysis& operator =(
                    const ControlAnalysis& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ControlAnalysis that will be copied.
             */
            eProsima_user_DllExport ControlAnalysis& operator =(
                    ControlAnalysis&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ControlAnalysis object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ControlAnalysis& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ControlAnalysis object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ControlAnalysis& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member driving_mode
             * @param _driving_mode New value for member driving_mode
             */
            eProsima_user_DllExport void driving_mode(
                    int32_t _driving_mode);

            /*!
             * @brief This function returns the value of member driving_mode
             * @return Value of member driving_mode
             */
            eProsima_user_DllExport int32_t driving_mode() const;

            /*!
             * @brief This function returns a reference to member driving_mode
             * @return Reference to member driving_mode
             */
            eProsima_user_DllExport int32_t& driving_mode();

            /*!
             * @brief This function sets a value in member driving_mode_fd
             * @param _driving_mode_fd New value for member driving_mode_fd
             */
            eProsima_user_DllExport void driving_mode_fd(
                    int32_t _driving_mode_fd);

            /*!
             * @brief This function returns the value of member driving_mode_fd
             * @return Value of member driving_mode_fd
             */
            eProsima_user_DllExport int32_t driving_mode_fd() const;

            /*!
             * @brief This function returns a reference to member driving_mode_fd
             * @return Reference to member driving_mode_fd
             */
            eProsima_user_DllExport int32_t& driving_mode_fd();

            /*!
             * @brief This function sets a value in member gear_location_fd
             * @param _gear_location_fd New value for member gear_location_fd
             */
            eProsima_user_DllExport void gear_location_fd(
                    int32_t _gear_location_fd);

            /*!
             * @brief This function returns the value of member gear_location_fd
             * @return Value of member gear_location_fd
             */
            eProsima_user_DllExport int32_t gear_location_fd() const;

            /*!
             * @brief This function returns a reference to member gear_location_fd
             * @return Reference to member gear_location_fd
             */
            eProsima_user_DllExport int32_t& gear_location_fd();

            /*!
             * @brief This function sets a value in member gear_location_cmd
             * @param _gear_location_cmd New value for member gear_location_cmd
             */
            eProsima_user_DllExport void gear_location_cmd(
                    int32_t _gear_location_cmd);

            /*!
             * @brief This function returns the value of member gear_location_cmd
             * @return Value of member gear_location_cmd
             */
            eProsima_user_DllExport int32_t gear_location_cmd() const;

            /*!
             * @brief This function returns a reference to member gear_location_cmd
             * @return Reference to member gear_location_cmd
             */
            eProsima_user_DllExport int32_t& gear_location_cmd();

            /*!
             * @brief This function sets a value in member epb_level_fd
             * @param _epb_level_fd New value for member epb_level_fd
             */
            eProsima_user_DllExport void epb_level_fd(
                    int32_t _epb_level_fd);

            /*!
             * @brief This function returns the value of member epb_level_fd
             * @return Value of member epb_level_fd
             */
            eProsima_user_DllExport int32_t epb_level_fd() const;

            /*!
             * @brief This function returns a reference to member epb_level_fd
             * @return Reference to member epb_level_fd
             */
            eProsima_user_DllExport int32_t& epb_level_fd();

            /*!
             * @brief This function sets a value in member epb_level_cmd
             * @param _epb_level_cmd New value for member epb_level_cmd
             */
            eProsima_user_DllExport void epb_level_cmd(
                    int32_t _epb_level_cmd);

            /*!
             * @brief This function returns the value of member epb_level_cmd
             * @return Value of member epb_level_cmd
             */
            eProsima_user_DllExport int32_t epb_level_cmd() const;

            /*!
             * @brief This function returns a reference to member epb_level_cmd
             * @return Reference to member epb_level_cmd
             */
            eProsima_user_DllExport int32_t& epb_level_cmd();

            /*!
             * @brief This function sets a value in member speed_mps
             * @param _speed_mps New value for member speed_mps
             */
            eProsima_user_DllExport void speed_mps(
                    double _speed_mps);

            /*!
             * @brief This function returns the value of member speed_mps
             * @return Value of member speed_mps
             */
            eProsima_user_DllExport double speed_mps() const;

            /*!
             * @brief This function returns a reference to member speed_mps
             * @return Reference to member speed_mps
             */
            eProsima_user_DllExport double& speed_mps();

            /*!
             * @brief This function sets a value in member speed_reference
             * @param _speed_reference New value for member speed_reference
             */
            eProsima_user_DllExport void speed_reference(
                    double _speed_reference);

            /*!
             * @brief This function returns the value of member speed_reference
             * @return Value of member speed_reference
             */
            eProsima_user_DllExport double speed_reference() const;

            /*!
             * @brief This function returns a reference to member speed_reference
             * @return Reference to member speed_reference
             */
            eProsima_user_DllExport double& speed_reference();

            /*!
             * @brief This function sets a value in member accel_value_fd
             * @param _accel_value_fd New value for member accel_value_fd
             */
            eProsima_user_DllExport void accel_value_fd(
                    double _accel_value_fd);

            /*!
             * @brief This function returns the value of member accel_value_fd
             * @return Value of member accel_value_fd
             */
            eProsima_user_DllExport double accel_value_fd() const;

            /*!
             * @brief This function returns a reference to member accel_value_fd
             * @return Reference to member accel_value_fd
             */
            eProsima_user_DllExport double& accel_value_fd();

            /*!
             * @brief This function sets a value in member accel_value_cmd
             * @param _accel_value_cmd New value for member accel_value_cmd
             */
            eProsima_user_DllExport void accel_value_cmd(
                    double _accel_value_cmd);

            /*!
             * @brief This function returns the value of member accel_value_cmd
             * @return Value of member accel_value_cmd
             */
            eProsima_user_DllExport double accel_value_cmd() const;

            /*!
             * @brief This function returns a reference to member accel_value_cmd
             * @return Reference to member accel_value_cmd
             */
            eProsima_user_DllExport double& accel_value_cmd();

            /*!
             * @brief This function sets a value in member brake_value_fd
             * @param _brake_value_fd New value for member brake_value_fd
             */
            eProsima_user_DllExport void brake_value_fd(
                    double _brake_value_fd);

            /*!
             * @brief This function returns the value of member brake_value_fd
             * @return Value of member brake_value_fd
             */
            eProsima_user_DllExport double brake_value_fd() const;

            /*!
             * @brief This function returns a reference to member brake_value_fd
             * @return Reference to member brake_value_fd
             */
            eProsima_user_DllExport double& brake_value_fd();

            /*!
             * @brief This function sets a value in member brake_value_cmd
             * @param _brake_value_cmd New value for member brake_value_cmd
             */
            eProsima_user_DllExport void brake_value_cmd(
                    double _brake_value_cmd);

            /*!
             * @brief This function returns the value of member brake_value_cmd
             * @return Value of member brake_value_cmd
             */
            eProsima_user_DllExport double brake_value_cmd() const;

            /*!
             * @brief This function returns a reference to member brake_value_cmd
             * @return Reference to member brake_value_cmd
             */
            eProsima_user_DllExport double& brake_value_cmd();

            /*!
             * @brief This function sets a value in member path_remain
             * @param _path_remain New value for member path_remain
             */
            eProsima_user_DllExport void path_remain(
                    double _path_remain);

            /*!
             * @brief This function returns the value of member path_remain
             * @return Value of member path_remain
             */
            eProsima_user_DllExport double path_remain() const;

            /*!
             * @brief This function returns a reference to member path_remain
             * @return Reference to member path_remain
             */
            eProsima_user_DllExport double& path_remain();

            /*!
             * @brief This function sets a value in member has_stop_point
             * @param _has_stop_point New value for member has_stop_point
             */
            eProsima_user_DllExport void has_stop_point(
                    bool _has_stop_point);

            /*!
             * @brief This function returns the value of member has_stop_point
             * @return Value of member has_stop_point
             */
            eProsima_user_DllExport bool has_stop_point() const;

            /*!
             * @brief This function returns a reference to member has_stop_point
             * @return Reference to member has_stop_point
             */
            eProsima_user_DllExport bool& has_stop_point();

            /*!
             * @brief This function sets a value in member is_full_stop
             * @param _is_full_stop New value for member is_full_stop
             */
            eProsima_user_DllExport void is_full_stop(
                    bool _is_full_stop);

            /*!
             * @brief This function returns the value of member is_full_stop
             * @return Value of member is_full_stop
             */
            eProsima_user_DllExport bool is_full_stop() const;

            /*!
             * @brief This function returns a reference to member is_full_stop
             * @return Reference to member is_full_stop
             */
            eProsima_user_DllExport bool& is_full_stop();

            /*!
             * @brief This function sets a value in member is_stopped
             * @param _is_stopped New value for member is_stopped
             */
            eProsima_user_DllExport void is_stopped(
                    bool _is_stopped);

            /*!
             * @brief This function returns the value of member is_stopped
             * @return Value of member is_stopped
             */
            eProsima_user_DllExport bool is_stopped() const;

            /*!
             * @brief This function returns a reference to member is_stopped
             * @return Reference to member is_stopped
             */
            eProsima_user_DllExport bool& is_stopped();

            /*!
             * @brief This function sets a value in member lon_acc_jerk
             * @param _lon_acc_jerk New value for member lon_acc_jerk
             */
            eProsima_user_DllExport void lon_acc_jerk(
                    double _lon_acc_jerk);

            /*!
             * @brief This function returns the value of member lon_acc_jerk
             * @return Value of member lon_acc_jerk
             */
            eProsima_user_DllExport double lon_acc_jerk() const;

            /*!
             * @brief This function returns a reference to member lon_acc_jerk
             * @return Reference to member lon_acc_jerk
             */
            eProsima_user_DllExport double& lon_acc_jerk();

            /*!
             * @brief This function sets a value in member acceleration_cmd
             * @param _acceleration_cmd New value for member acceleration_cmd
             */
            eProsima_user_DllExport void acceleration_cmd(
                    double _acceleration_cmd);

            /*!
             * @brief This function returns the value of member acceleration_cmd
             * @return Value of member acceleration_cmd
             */
            eProsima_user_DllExport double acceleration_cmd() const;

            /*!
             * @brief This function returns a reference to member acceleration_cmd
             * @return Reference to member acceleration_cmd
             */
            eProsima_user_DllExport double& acceleration_cmd();

            /*!
             * @brief This function sets a value in member acceleration_cmd_closeloop
             * @param _acceleration_cmd_closeloop New value for member acceleration_cmd_closeloop
             */
            eProsima_user_DllExport void acceleration_cmd_closeloop(
                    double _acceleration_cmd_closeloop);

            /*!
             * @brief This function returns the value of member acceleration_cmd_closeloop
             * @return Value of member acceleration_cmd_closeloop
             */
            eProsima_user_DllExport double acceleration_cmd_closeloop() const;

            /*!
             * @brief This function returns a reference to member acceleration_cmd_closeloop
             * @return Reference to member acceleration_cmd_closeloop
             */
            eProsima_user_DllExport double& acceleration_cmd_closeloop();

            /*!
             * @brief This function sets a value in member preview_acceleration_reference
             * @param _preview_acceleration_reference New value for member preview_acceleration_reference
             */
            eProsima_user_DllExport void preview_acceleration_reference(
                    double _preview_acceleration_reference);

            /*!
             * @brief This function returns the value of member preview_acceleration_reference
             * @return Value of member preview_acceleration_reference
             */
            eProsima_user_DllExport double preview_acceleration_reference() const;

            /*!
             * @brief This function returns a reference to member preview_acceleration_reference
             * @return Reference to member preview_acceleration_reference
             */
            eProsima_user_DllExport double& preview_acceleration_reference();

            /*!
             * @brief This function sets a value in member slope_offset_compensation
             * @param _slope_offset_compensation New value for member slope_offset_compensation
             */
            eProsima_user_DllExport void slope_offset_compensation(
                    double _slope_offset_compensation);

            /*!
             * @brief This function returns the value of member slope_offset_compensation
             * @return Value of member slope_offset_compensation
             */
            eProsima_user_DllExport double slope_offset_compensation() const;

            /*!
             * @brief This function returns a reference to member slope_offset_compensation
             * @return Reference to member slope_offset_compensation
             */
            eProsima_user_DllExport double& slope_offset_compensation();

            /*!
             * @brief This function sets a value in member turning_offset_compensation
             * @param _turning_offset_compensation New value for member turning_offset_compensation
             */
            eProsima_user_DllExport void turning_offset_compensation(
                    double _turning_offset_compensation);

            /*!
             * @brief This function returns the value of member turning_offset_compensation
             * @return Value of member turning_offset_compensation
             */
            eProsima_user_DllExport double turning_offset_compensation() const;

            /*!
             * @brief This function returns a reference to member turning_offset_compensation
             * @return Reference to member turning_offset_compensation
             */
            eProsima_user_DllExport double& turning_offset_compensation();

            /*!
             * @brief This function sets a value in member speed_error_limited
             * @param _speed_error_limited New value for member speed_error_limited
             */
            eProsima_user_DllExport void speed_error_limited(
                    double _speed_error_limited);

            /*!
             * @brief This function returns the value of member speed_error_limited
             * @return Value of member speed_error_limited
             */
            eProsima_user_DllExport double speed_error_limited() const;

            /*!
             * @brief This function returns a reference to member speed_error_limited
             * @return Reference to member speed_error_limited
             */
            eProsima_user_DllExport double& speed_error_limited();

            /*!
             * @brief This function sets a value in member speed_error
             * @param _speed_error New value for member speed_error
             */
            eProsima_user_DllExport void speed_error(
                    double _speed_error);

            /*!
             * @brief This function returns the value of member speed_error
             * @return Value of member speed_error
             */
            eProsima_user_DllExport double speed_error() const;

            /*!
             * @brief This function returns a reference to member speed_error
             * @return Reference to member speed_error
             */
            eProsima_user_DllExport double& speed_error();

            /*!
             * @brief This function sets a value in member speed_offset
             * @param _speed_offset New value for member speed_offset
             */
            eProsima_user_DllExport void speed_offset(
                    double _speed_offset);

            /*!
             * @brief This function returns the value of member speed_offset
             * @return Value of member speed_offset
             */
            eProsima_user_DllExport double speed_offset() const;

            /*!
             * @brief This function returns a reference to member speed_offset
             * @return Reference to member speed_offset
             */
            eProsima_user_DllExport double& speed_offset();

            /*!
             * @brief This function sets a value in member station_error_limited
             * @param _station_error_limited New value for member station_error_limited
             */
            eProsima_user_DllExport void station_error_limited(
                    double _station_error_limited);

            /*!
             * @brief This function returns the value of member station_error_limited
             * @return Value of member station_error_limited
             */
            eProsima_user_DllExport double station_error_limited() const;

            /*!
             * @brief This function returns a reference to member station_error_limited
             * @return Reference to member station_error_limited
             */
            eProsima_user_DllExport double& station_error_limited();

            /*!
             * @brief This function sets a value in member station_error
             * @param _station_error New value for member station_error
             */
            eProsima_user_DllExport void station_error(
                    double _station_error);

            /*!
             * @brief This function returns the value of member station_error
             * @return Value of member station_error
             */
            eProsima_user_DllExport double station_error() const;

            /*!
             * @brief This function returns a reference to member station_error
             * @return Reference to member station_error
             */
            eProsima_user_DllExport double& station_error();

            /*!
             * @brief This function sets a value in member lon_target_point_s
             * @param _lon_target_point_s New value for member lon_target_point_s
             */
            eProsima_user_DllExport void lon_target_point_s(
                    double _lon_target_point_s);

            /*!
             * @brief This function returns the value of member lon_target_point_s
             * @return Value of member lon_target_point_s
             */
            eProsima_user_DllExport double lon_target_point_s() const;

            /*!
             * @brief This function returns a reference to member lon_target_point_s
             * @return Reference to member lon_target_point_s
             */
            eProsima_user_DllExport double& lon_target_point_s();

            /*!
             * @brief This function sets a value in member lon_calculate_time
             * @param _lon_calculate_time New value for member lon_calculate_time
             */
            eProsima_user_DllExport void lon_calculate_time(
                    int64_t _lon_calculate_time);

            /*!
             * @brief This function returns the value of member lon_calculate_time
             * @return Value of member lon_calculate_time
             */
            eProsima_user_DllExport int64_t lon_calculate_time() const;

            /*!
             * @brief This function returns a reference to member lon_calculate_time
             * @return Reference to member lon_calculate_time
             */
            eProsima_user_DllExport int64_t& lon_calculate_time();

            /*!
             * @brief This function sets a value in member lon_calculate_time_max
             * @param _lon_calculate_time_max New value for member lon_calculate_time_max
             */
            eProsima_user_DllExport void lon_calculate_time_max(
                    int64_t _lon_calculate_time_max);

            /*!
             * @brief This function returns the value of member lon_calculate_time_max
             * @return Value of member lon_calculate_time_max
             */
            eProsima_user_DllExport int64_t lon_calculate_time_max() const;

            /*!
             * @brief This function returns a reference to member lon_calculate_time_max
             * @return Reference to member lon_calculate_time_max
             */
            eProsima_user_DllExport int64_t& lon_calculate_time_max();

            /*!
             * @brief This function sets a value in member ref_curvature
             * @param _ref_curvature New value for member ref_curvature
             */
            eProsima_user_DllExport void ref_curvature(
                    double _ref_curvature);

            /*!
             * @brief This function returns the value of member ref_curvature
             * @return Value of member ref_curvature
             */
            eProsima_user_DllExport double ref_curvature() const;

            /*!
             * @brief This function returns a reference to member ref_curvature
             * @return Reference to member ref_curvature
             */
            eProsima_user_DllExport double& ref_curvature();

            /*!
             * @brief This function sets a value in member ref_heading
             * @param _ref_heading New value for member ref_heading
             */
            eProsima_user_DllExport void ref_heading(
                    double _ref_heading);

            /*!
             * @brief This function returns the value of member ref_heading
             * @return Value of member ref_heading
             */
            eProsima_user_DllExport double ref_heading() const;

            /*!
             * @brief This function returns a reference to member ref_heading
             * @return Reference to member ref_heading
             */
            eProsima_user_DllExport double& ref_heading();

            /*!
             * @brief This function sets a value in member current_heading
             * @param _current_heading New value for member current_heading
             */
            eProsima_user_DllExport void current_heading(
                    double _current_heading);

            /*!
             * @brief This function returns the value of member current_heading
             * @return Value of member current_heading
             */
            eProsima_user_DllExport double current_heading() const;

            /*!
             * @brief This function returns a reference to member current_heading
             * @return Reference to member current_heading
             */
            eProsima_user_DllExport double& current_heading();

            /*!
             * @brief This function sets a value in member heading_error
             * @param _heading_error New value for member heading_error
             */
            eProsima_user_DllExport void heading_error(
                    double _heading_error);

            /*!
             * @brief This function returns the value of member heading_error
             * @return Value of member heading_error
             */
            eProsima_user_DllExport double heading_error() const;

            /*!
             * @brief This function returns a reference to member heading_error
             * @return Reference to member heading_error
             */
            eProsima_user_DllExport double& heading_error();

            /*!
             * @brief This function sets a value in member heading_error_rate
             * @param _heading_error_rate New value for member heading_error_rate
             */
            eProsima_user_DllExport void heading_error_rate(
                    double _heading_error_rate);

            /*!
             * @brief This function returns the value of member heading_error_rate
             * @return Value of member heading_error_rate
             */
            eProsima_user_DllExport double heading_error_rate() const;

            /*!
             * @brief This function returns a reference to member heading_error_rate
             * @return Reference to member heading_error_rate
             */
            eProsima_user_DllExport double& heading_error_rate();

            /*!
             * @brief This function sets a value in member lateral_error
             * @param _lateral_error New value for member lateral_error
             */
            eProsima_user_DllExport void lateral_error(
                    double _lateral_error);

            /*!
             * @brief This function returns the value of member lateral_error
             * @return Value of member lateral_error
             */
            eProsima_user_DllExport double lateral_error() const;

            /*!
             * @brief This function returns a reference to member lateral_error
             * @return Reference to member lateral_error
             */
            eProsima_user_DllExport double& lateral_error();

            /*!
             * @brief This function sets a value in member lateral_error_rate
             * @param _lateral_error_rate New value for member lateral_error_rate
             */
            eProsima_user_DllExport void lateral_error_rate(
                    double _lateral_error_rate);

            /*!
             * @brief This function returns the value of member lateral_error_rate
             * @return Value of member lateral_error_rate
             */
            eProsima_user_DllExport double lateral_error_rate() const;

            /*!
             * @brief This function returns a reference to member lateral_error_rate
             * @return Reference to member lateral_error_rate
             */
            eProsima_user_DllExport double& lateral_error_rate();

            /*!
             * @brief This function sets a value in member lon_error
             * @param _lon_error New value for member lon_error
             */
            eProsima_user_DllExport void lon_error(
                    double _lon_error);

            /*!
             * @brief This function returns the value of member lon_error
             * @return Value of member lon_error
             */
            eProsima_user_DllExport double lon_error() const;

            /*!
             * @brief This function returns a reference to member lon_error
             * @return Reference to member lon_error
             */
            eProsima_user_DllExport double& lon_error();

            /*!
             * @brief This function sets a value in member front_steering_value_fd
             * @param _front_steering_value_fd New value for member front_steering_value_fd
             */
            eProsima_user_DllExport void front_steering_value_fd(
                    double _front_steering_value_fd);

            /*!
             * @brief This function returns the value of member front_steering_value_fd
             * @return Value of member front_steering_value_fd
             */
            eProsima_user_DllExport double front_steering_value_fd() const;

            /*!
             * @brief This function returns a reference to member front_steering_value_fd
             * @return Reference to member front_steering_value_fd
             */
            eProsima_user_DllExport double& front_steering_value_fd();

            /*!
             * @brief This function sets a value in member front_steering_target
             * @param _front_steering_target New value for member front_steering_target
             */
            eProsima_user_DllExport void front_steering_target(
                    double _front_steering_target);

            /*!
             * @brief This function returns the value of member front_steering_target
             * @return Value of member front_steering_target
             */
            eProsima_user_DllExport double front_steering_target() const;

            /*!
             * @brief This function returns a reference to member front_steering_target
             * @return Reference to member front_steering_target
             */
            eProsima_user_DllExport double& front_steering_target();

            /*!
             * @brief This function sets a value in member front_steering_rate
             * @param _front_steering_rate New value for member front_steering_rate
             */
            eProsima_user_DllExport void front_steering_rate(
                    double _front_steering_rate);

            /*!
             * @brief This function returns the value of member front_steering_rate
             * @return Value of member front_steering_rate
             */
            eProsima_user_DllExport double front_steering_rate() const;

            /*!
             * @brief This function returns a reference to member front_steering_rate
             * @return Reference to member front_steering_rate
             */
            eProsima_user_DllExport double& front_steering_rate();

            /*!
             * @brief This function sets a value in member front_steer_angle_feedforward
             * @param _front_steer_angle_feedforward New value for member front_steer_angle_feedforward
             */
            eProsima_user_DllExport void front_steer_angle_feedforward(
                    double _front_steer_angle_feedforward);

            /*!
             * @brief This function returns the value of member front_steer_angle_feedforward
             * @return Value of member front_steer_angle_feedforward
             */
            eProsima_user_DllExport double front_steer_angle_feedforward() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_feedforward
             * @return Reference to member front_steer_angle_feedforward
             */
            eProsima_user_DllExport double& front_steer_angle_feedforward();

            /*!
             * @brief This function sets a value in member front_steer_angle_feedback
             * @param _front_steer_angle_feedback New value for member front_steer_angle_feedback
             */
            eProsima_user_DllExport void front_steer_angle_feedback(
                    double _front_steer_angle_feedback);

            /*!
             * @brief This function returns the value of member front_steer_angle_feedback
             * @return Value of member front_steer_angle_feedback
             */
            eProsima_user_DllExport double front_steer_angle_feedback() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_feedback
             * @return Reference to member front_steer_angle_feedback
             */
            eProsima_user_DllExport double& front_steer_angle_feedback();

            /*!
             * @brief This function sets a value in member front_steer_angle_lateral_contribution
             * @param _front_steer_angle_lateral_contribution New value for member front_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport void front_steer_angle_lateral_contribution(
                    double _front_steer_angle_lateral_contribution);

            /*!
             * @brief This function returns the value of member front_steer_angle_lateral_contribution
             * @return Value of member front_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport double front_steer_angle_lateral_contribution() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_lateral_contribution
             * @return Reference to member front_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport double& front_steer_angle_lateral_contribution();

            /*!
             * @brief This function sets a value in member front_steer_angle_lateral_rate_contribution
             * @param _front_steer_angle_lateral_rate_contribution New value for member front_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport void front_steer_angle_lateral_rate_contribution(
                    double _front_steer_angle_lateral_rate_contribution);

            /*!
             * @brief This function returns the value of member front_steer_angle_lateral_rate_contribution
             * @return Value of member front_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport double front_steer_angle_lateral_rate_contribution() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_lateral_rate_contribution
             * @return Reference to member front_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport double& front_steer_angle_lateral_rate_contribution();

            /*!
             * @brief This function sets a value in member front_steer_angle_heading_contribution
             * @param _front_steer_angle_heading_contribution New value for member front_steer_angle_heading_contribution
             */
            eProsima_user_DllExport void front_steer_angle_heading_contribution(
                    double _front_steer_angle_heading_contribution);

            /*!
             * @brief This function returns the value of member front_steer_angle_heading_contribution
             * @return Value of member front_steer_angle_heading_contribution
             */
            eProsima_user_DllExport double front_steer_angle_heading_contribution() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_heading_contribution
             * @return Reference to member front_steer_angle_heading_contribution
             */
            eProsima_user_DllExport double& front_steer_angle_heading_contribution();

            /*!
             * @brief This function sets a value in member front_steer_angle_heading_rate_contribution
             * @param _front_steer_angle_heading_rate_contribution New value for member front_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport void front_steer_angle_heading_rate_contribution(
                    double _front_steer_angle_heading_rate_contribution);

            /*!
             * @brief This function returns the value of member front_steer_angle_heading_rate_contribution
             * @return Value of member front_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport double front_steer_angle_heading_rate_contribution() const;

            /*!
             * @brief This function returns a reference to member front_steer_angle_heading_rate_contribution
             * @return Reference to member front_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport double& front_steer_angle_heading_rate_contribution();

            /*!
             * @brief This function sets a value in member rear_steering_value_fd
             * @param _rear_steering_value_fd New value for member rear_steering_value_fd
             */
            eProsima_user_DllExport void rear_steering_value_fd(
                    double _rear_steering_value_fd);

            /*!
             * @brief This function returns the value of member rear_steering_value_fd
             * @return Value of member rear_steering_value_fd
             */
            eProsima_user_DllExport double rear_steering_value_fd() const;

            /*!
             * @brief This function returns a reference to member rear_steering_value_fd
             * @return Reference to member rear_steering_value_fd
             */
            eProsima_user_DllExport double& rear_steering_value_fd();

            /*!
             * @brief This function sets a value in member rear_steering_target
             * @param _rear_steering_target New value for member rear_steering_target
             */
            eProsima_user_DllExport void rear_steering_target(
                    double _rear_steering_target);

            /*!
             * @brief This function returns the value of member rear_steering_target
             * @return Value of member rear_steering_target
             */
            eProsima_user_DllExport double rear_steering_target() const;

            /*!
             * @brief This function returns a reference to member rear_steering_target
             * @return Reference to member rear_steering_target
             */
            eProsima_user_DllExport double& rear_steering_target();

            /*!
             * @brief This function sets a value in member rear_steering_rate
             * @param _rear_steering_rate New value for member rear_steering_rate
             */
            eProsima_user_DllExport void rear_steering_rate(
                    double _rear_steering_rate);

            /*!
             * @brief This function returns the value of member rear_steering_rate
             * @return Value of member rear_steering_rate
             */
            eProsima_user_DllExport double rear_steering_rate() const;

            /*!
             * @brief This function returns a reference to member rear_steering_rate
             * @return Reference to member rear_steering_rate
             */
            eProsima_user_DllExport double& rear_steering_rate();

            /*!
             * @brief This function sets a value in member rear_steer_angle_feedforward
             * @param _rear_steer_angle_feedforward New value for member rear_steer_angle_feedforward
             */
            eProsima_user_DllExport void rear_steer_angle_feedforward(
                    double _rear_steer_angle_feedforward);

            /*!
             * @brief This function returns the value of member rear_steer_angle_feedforward
             * @return Value of member rear_steer_angle_feedforward
             */
            eProsima_user_DllExport double rear_steer_angle_feedforward() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_feedforward
             * @return Reference to member rear_steer_angle_feedforward
             */
            eProsima_user_DllExport double& rear_steer_angle_feedforward();

            /*!
             * @brief This function sets a value in member rear_steer_angle_feedback
             * @param _rear_steer_angle_feedback New value for member rear_steer_angle_feedback
             */
            eProsima_user_DllExport void rear_steer_angle_feedback(
                    double _rear_steer_angle_feedback);

            /*!
             * @brief This function returns the value of member rear_steer_angle_feedback
             * @return Value of member rear_steer_angle_feedback
             */
            eProsima_user_DllExport double rear_steer_angle_feedback() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_feedback
             * @return Reference to member rear_steer_angle_feedback
             */
            eProsima_user_DllExport double& rear_steer_angle_feedback();

            /*!
             * @brief This function sets a value in member rear_steer_angle_lateral_contribution
             * @param _rear_steer_angle_lateral_contribution New value for member rear_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport void rear_steer_angle_lateral_contribution(
                    double _rear_steer_angle_lateral_contribution);

            /*!
             * @brief This function returns the value of member rear_steer_angle_lateral_contribution
             * @return Value of member rear_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport double rear_steer_angle_lateral_contribution() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_lateral_contribution
             * @return Reference to member rear_steer_angle_lateral_contribution
             */
            eProsima_user_DllExport double& rear_steer_angle_lateral_contribution();

            /*!
             * @brief This function sets a value in member rear_steer_angle_lateral_rate_contribution
             * @param _rear_steer_angle_lateral_rate_contribution New value for member rear_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport void rear_steer_angle_lateral_rate_contribution(
                    double _rear_steer_angle_lateral_rate_contribution);

            /*!
             * @brief This function returns the value of member rear_steer_angle_lateral_rate_contribution
             * @return Value of member rear_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport double rear_steer_angle_lateral_rate_contribution() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_lateral_rate_contribution
             * @return Reference to member rear_steer_angle_lateral_rate_contribution
             */
            eProsima_user_DllExport double& rear_steer_angle_lateral_rate_contribution();

            /*!
             * @brief This function sets a value in member rear_steer_angle_heading_contribution
             * @param _rear_steer_angle_heading_contribution New value for member rear_steer_angle_heading_contribution
             */
            eProsima_user_DllExport void rear_steer_angle_heading_contribution(
                    double _rear_steer_angle_heading_contribution);

            /*!
             * @brief This function returns the value of member rear_steer_angle_heading_contribution
             * @return Value of member rear_steer_angle_heading_contribution
             */
            eProsima_user_DllExport double rear_steer_angle_heading_contribution() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_heading_contribution
             * @return Reference to member rear_steer_angle_heading_contribution
             */
            eProsima_user_DllExport double& rear_steer_angle_heading_contribution();

            /*!
             * @brief This function sets a value in member rear_steer_angle_heading_rate_contribution
             * @param _rear_steer_angle_heading_rate_contribution New value for member rear_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport void rear_steer_angle_heading_rate_contribution(
                    double _rear_steer_angle_heading_rate_contribution);

            /*!
             * @brief This function returns the value of member rear_steer_angle_heading_rate_contribution
             * @return Value of member rear_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport double rear_steer_angle_heading_rate_contribution() const;

            /*!
             * @brief This function returns a reference to member rear_steer_angle_heading_rate_contribution
             * @return Reference to member rear_steer_angle_heading_rate_contribution
             */
            eProsima_user_DllExport double& rear_steer_angle_heading_rate_contribution();

            /*!
             * @brief This function sets a value in member matrix_k_00
             * @param _matrix_k_00 New value for member matrix_k_00
             */
            eProsima_user_DllExport void matrix_k_00(
                    double _matrix_k_00);

            /*!
             * @brief This function returns the value of member matrix_k_00
             * @return Value of member matrix_k_00
             */
            eProsima_user_DllExport double matrix_k_00() const;

            /*!
             * @brief This function returns a reference to member matrix_k_00
             * @return Reference to member matrix_k_00
             */
            eProsima_user_DllExport double& matrix_k_00();

            /*!
             * @brief This function sets a value in member matrix_k_01
             * @param _matrix_k_01 New value for member matrix_k_01
             */
            eProsima_user_DllExport void matrix_k_01(
                    double _matrix_k_01);

            /*!
             * @brief This function returns the value of member matrix_k_01
             * @return Value of member matrix_k_01
             */
            eProsima_user_DllExport double matrix_k_01() const;

            /*!
             * @brief This function returns a reference to member matrix_k_01
             * @return Reference to member matrix_k_01
             */
            eProsima_user_DllExport double& matrix_k_01();

            /*!
             * @brief This function sets a value in member matrix_k_02
             * @param _matrix_k_02 New value for member matrix_k_02
             */
            eProsima_user_DllExport void matrix_k_02(
                    double _matrix_k_02);

            /*!
             * @brief This function returns the value of member matrix_k_02
             * @return Value of member matrix_k_02
             */
            eProsima_user_DllExport double matrix_k_02() const;

            /*!
             * @brief This function returns a reference to member matrix_k_02
             * @return Reference to member matrix_k_02
             */
            eProsima_user_DllExport double& matrix_k_02();

            /*!
             * @brief This function sets a value in member matrix_k_03
             * @param _matrix_k_03 New value for member matrix_k_03
             */
            eProsima_user_DllExport void matrix_k_03(
                    double _matrix_k_03);

            /*!
             * @brief This function returns the value of member matrix_k_03
             * @return Value of member matrix_k_03
             */
            eProsima_user_DllExport double matrix_k_03() const;

            /*!
             * @brief This function returns a reference to member matrix_k_03
             * @return Reference to member matrix_k_03
             */
            eProsima_user_DllExport double& matrix_k_03();

            /*!
             * @brief This function sets a value in member matrix_k_10
             * @param _matrix_k_10 New value for member matrix_k_10
             */
            eProsima_user_DllExport void matrix_k_10(
                    double _matrix_k_10);

            /*!
             * @brief This function returns the value of member matrix_k_10
             * @return Value of member matrix_k_10
             */
            eProsima_user_DllExport double matrix_k_10() const;

            /*!
             * @brief This function returns a reference to member matrix_k_10
             * @return Reference to member matrix_k_10
             */
            eProsima_user_DllExport double& matrix_k_10();

            /*!
             * @brief This function sets a value in member matrix_k_11
             * @param _matrix_k_11 New value for member matrix_k_11
             */
            eProsima_user_DllExport void matrix_k_11(
                    double _matrix_k_11);

            /*!
             * @brief This function returns the value of member matrix_k_11
             * @return Value of member matrix_k_11
             */
            eProsima_user_DllExport double matrix_k_11() const;

            /*!
             * @brief This function returns a reference to member matrix_k_11
             * @return Reference to member matrix_k_11
             */
            eProsima_user_DllExport double& matrix_k_11();

            /*!
             * @brief This function sets a value in member matrix_k_12
             * @param _matrix_k_12 New value for member matrix_k_12
             */
            eProsima_user_DllExport void matrix_k_12(
                    double _matrix_k_12);

            /*!
             * @brief This function returns the value of member matrix_k_12
             * @return Value of member matrix_k_12
             */
            eProsima_user_DllExport double matrix_k_12() const;

            /*!
             * @brief This function returns a reference to member matrix_k_12
             * @return Reference to member matrix_k_12
             */
            eProsima_user_DllExport double& matrix_k_12();

            /*!
             * @brief This function sets a value in member matrix_k_13
             * @param _matrix_k_13 New value for member matrix_k_13
             */
            eProsima_user_DllExport void matrix_k_13(
                    double _matrix_k_13);

            /*!
             * @brief This function returns the value of member matrix_k_13
             * @return Value of member matrix_k_13
             */
            eProsima_user_DllExport double matrix_k_13() const;

            /*!
             * @brief This function returns a reference to member matrix_k_13
             * @return Reference to member matrix_k_13
             */
            eProsima_user_DllExport double& matrix_k_13();

            /*!
             * @brief This function sets a value in member matrix_state_0
             * @param _matrix_state_0 New value for member matrix_state_0
             */
            eProsima_user_DllExport void matrix_state_0(
                    double _matrix_state_0);

            /*!
             * @brief This function returns the value of member matrix_state_0
             * @return Value of member matrix_state_0
             */
            eProsima_user_DllExport double matrix_state_0() const;

            /*!
             * @brief This function returns a reference to member matrix_state_0
             * @return Reference to member matrix_state_0
             */
            eProsima_user_DllExport double& matrix_state_0();

            /*!
             * @brief This function sets a value in member matrix_state_1
             * @param _matrix_state_1 New value for member matrix_state_1
             */
            eProsima_user_DllExport void matrix_state_1(
                    double _matrix_state_1);

            /*!
             * @brief This function returns the value of member matrix_state_1
             * @return Value of member matrix_state_1
             */
            eProsima_user_DllExport double matrix_state_1() const;

            /*!
             * @brief This function returns a reference to member matrix_state_1
             * @return Reference to member matrix_state_1
             */
            eProsima_user_DllExport double& matrix_state_1();

            /*!
             * @brief This function sets a value in member matrix_state_2
             * @param _matrix_state_2 New value for member matrix_state_2
             */
            eProsima_user_DllExport void matrix_state_2(
                    double _matrix_state_2);

            /*!
             * @brief This function returns the value of member matrix_state_2
             * @return Value of member matrix_state_2
             */
            eProsima_user_DllExport double matrix_state_2() const;

            /*!
             * @brief This function returns a reference to member matrix_state_2
             * @return Reference to member matrix_state_2
             */
            eProsima_user_DllExport double& matrix_state_2();

            /*!
             * @brief This function sets a value in member matrix_state_3
             * @param _matrix_state_3 New value for member matrix_state_3
             */
            eProsima_user_DllExport void matrix_state_3(
                    double _matrix_state_3);

            /*!
             * @brief This function returns the value of member matrix_state_3
             * @return Value of member matrix_state_3
             */
            eProsima_user_DllExport double matrix_state_3() const;

            /*!
             * @brief This function returns a reference to member matrix_state_3
             * @return Reference to member matrix_state_3
             */
            eProsima_user_DllExport double& matrix_state_3();

            /*!
             * @brief This function sets a value in member matrix_q_updated_0
             * @param _matrix_q_updated_0 New value for member matrix_q_updated_0
             */
            eProsima_user_DllExport void matrix_q_updated_0(
                    double _matrix_q_updated_0);

            /*!
             * @brief This function returns the value of member matrix_q_updated_0
             * @return Value of member matrix_q_updated_0
             */
            eProsima_user_DllExport double matrix_q_updated_0() const;

            /*!
             * @brief This function returns a reference to member matrix_q_updated_0
             * @return Reference to member matrix_q_updated_0
             */
            eProsima_user_DllExport double& matrix_q_updated_0();

            /*!
             * @brief This function sets a value in member matrix_q_updated_1
             * @param _matrix_q_updated_1 New value for member matrix_q_updated_1
             */
            eProsima_user_DllExport void matrix_q_updated_1(
                    double _matrix_q_updated_1);

            /*!
             * @brief This function returns the value of member matrix_q_updated_1
             * @return Value of member matrix_q_updated_1
             */
            eProsima_user_DllExport double matrix_q_updated_1() const;

            /*!
             * @brief This function returns a reference to member matrix_q_updated_1
             * @return Reference to member matrix_q_updated_1
             */
            eProsima_user_DllExport double& matrix_q_updated_1();

            /*!
             * @brief This function sets a value in member matrix_q_updated_2
             * @param _matrix_q_updated_2 New value for member matrix_q_updated_2
             */
            eProsima_user_DllExport void matrix_q_updated_2(
                    double _matrix_q_updated_2);

            /*!
             * @brief This function returns the value of member matrix_q_updated_2
             * @return Value of member matrix_q_updated_2
             */
            eProsima_user_DllExport double matrix_q_updated_2() const;

            /*!
             * @brief This function returns a reference to member matrix_q_updated_2
             * @return Reference to member matrix_q_updated_2
             */
            eProsima_user_DllExport double& matrix_q_updated_2();

            /*!
             * @brief This function sets a value in member matrix_q_updated_3
             * @param _matrix_q_updated_3 New value for member matrix_q_updated_3
             */
            eProsima_user_DllExport void matrix_q_updated_3(
                    double _matrix_q_updated_3);

            /*!
             * @brief This function returns the value of member matrix_q_updated_3
             * @return Value of member matrix_q_updated_3
             */
            eProsima_user_DllExport double matrix_q_updated_3() const;

            /*!
             * @brief This function returns a reference to member matrix_q_updated_3
             * @return Reference to member matrix_q_updated_3
             */
            eProsima_user_DllExport double& matrix_q_updated_3();

            /*!
             * @brief This function sets a value in member current_x
             * @param _current_x New value for member current_x
             */
            eProsima_user_DllExport void current_x(
                    double _current_x);

            /*!
             * @brief This function returns the value of member current_x
             * @return Value of member current_x
             */
            eProsima_user_DllExport double current_x() const;

            /*!
             * @brief This function returns a reference to member current_x
             * @return Reference to member current_x
             */
            eProsima_user_DllExport double& current_x();

            /*!
             * @brief This function sets a value in member current_y
             * @param _current_y New value for member current_y
             */
            eProsima_user_DllExport void current_y(
                    double _current_y);

            /*!
             * @brief This function returns the value of member current_y
             * @return Value of member current_y
             */
            eProsima_user_DllExport double current_y() const;

            /*!
             * @brief This function returns a reference to member current_y
             * @return Reference to member current_y
             */
            eProsima_user_DllExport double& current_y();

            /*!
             * @brief This function sets a value in member target_point_x
             * @param _target_point_x New value for member target_point_x
             */
            eProsima_user_DllExport void target_point_x(
                    double _target_point_x);

            /*!
             * @brief This function returns the value of member target_point_x
             * @return Value of member target_point_x
             */
            eProsima_user_DllExport double target_point_x() const;

            /*!
             * @brief This function returns a reference to member target_point_x
             * @return Reference to member target_point_x
             */
            eProsima_user_DllExport double& target_point_x();

            /*!
             * @brief This function sets a value in member target_point_y
             * @param _target_point_y New value for member target_point_y
             */
            eProsima_user_DllExport void target_point_y(
                    double _target_point_y);

            /*!
             * @brief This function returns the value of member target_point_y
             * @return Value of member target_point_y
             */
            eProsima_user_DllExport double target_point_y() const;

            /*!
             * @brief This function returns a reference to member target_point_y
             * @return Reference to member target_point_y
             */
            eProsima_user_DllExport double& target_point_y();

            /*!
             * @brief This function sets a value in member lat_target_point_s
             * @param _lat_target_point_s New value for member lat_target_point_s
             */
            eProsima_user_DllExport void lat_target_point_s(
                    double _lat_target_point_s);

            /*!
             * @brief This function returns the value of member lat_target_point_s
             * @return Value of member lat_target_point_s
             */
            eProsima_user_DllExport double lat_target_point_s() const;

            /*!
             * @brief This function returns a reference to member lat_target_point_s
             * @return Reference to member lat_target_point_s
             */
            eProsima_user_DllExport double& lat_target_point_s();

            /*!
             * @brief This function sets a value in member lqr_calculate_time
             * @param _lqr_calculate_time New value for member lqr_calculate_time
             */
            eProsima_user_DllExport void lqr_calculate_time(
                    int64_t _lqr_calculate_time);

            /*!
             * @brief This function returns the value of member lqr_calculate_time
             * @return Value of member lqr_calculate_time
             */
            eProsima_user_DllExport int64_t lqr_calculate_time() const;

            /*!
             * @brief This function returns a reference to member lqr_calculate_time
             * @return Reference to member lqr_calculate_time
             */
            eProsima_user_DllExport int64_t& lqr_calculate_time();

            /*!
             * @brief This function sets a value in member lqr_calculate_time_max
             * @param _lqr_calculate_time_max New value for member lqr_calculate_time_max
             */
            eProsima_user_DllExport void lqr_calculate_time_max(
                    int64_t _lqr_calculate_time_max);

            /*!
             * @brief This function returns the value of member lqr_calculate_time_max
             * @return Value of member lqr_calculate_time_max
             */
            eProsima_user_DllExport int64_t lqr_calculate_time_max() const;

            /*!
             * @brief This function returns a reference to member lqr_calculate_time_max
             * @return Reference to member lqr_calculate_time_max
             */
            eProsima_user_DllExport int64_t& lqr_calculate_time_max();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ControlAnalysis& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_driving_mode;
            int32_t m_driving_mode_fd;
            int32_t m_gear_location_fd;
            int32_t m_gear_location_cmd;
            int32_t m_epb_level_fd;
            int32_t m_epb_level_cmd;
            double m_speed_mps;
            double m_speed_reference;
            double m_accel_value_fd;
            double m_accel_value_cmd;
            double m_brake_value_fd;
            double m_brake_value_cmd;
            double m_path_remain;
            bool m_has_stop_point;
            bool m_is_full_stop;
            bool m_is_stopped;
            double m_lon_acc_jerk;
            double m_acceleration_cmd;
            double m_acceleration_cmd_closeloop;
            double m_preview_acceleration_reference;
            double m_slope_offset_compensation;
            double m_turning_offset_compensation;
            double m_speed_error_limited;
            double m_speed_error;
            double m_speed_offset;
            double m_station_error_limited;
            double m_station_error;
            double m_lon_target_point_s;
            int64_t m_lon_calculate_time;
            int64_t m_lon_calculate_time_max;
            double m_ref_curvature;
            double m_ref_heading;
            double m_current_heading;
            double m_heading_error;
            double m_heading_error_rate;
            double m_lateral_error;
            double m_lateral_error_rate;
            double m_lon_error;
            double m_front_steering_value_fd;
            double m_front_steering_target;
            double m_front_steering_rate;
            double m_front_steer_angle_feedforward;
            double m_front_steer_angle_feedback;
            double m_front_steer_angle_lateral_contribution;
            double m_front_steer_angle_lateral_rate_contribution;
            double m_front_steer_angle_heading_contribution;
            double m_front_steer_angle_heading_rate_contribution;
            double m_rear_steering_value_fd;
            double m_rear_steering_target;
            double m_rear_steering_rate;
            double m_rear_steer_angle_feedforward;
            double m_rear_steer_angle_feedback;
            double m_rear_steer_angle_lateral_contribution;
            double m_rear_steer_angle_lateral_rate_contribution;
            double m_rear_steer_angle_heading_contribution;
            double m_rear_steer_angle_heading_rate_contribution;
            double m_matrix_k_00;
            double m_matrix_k_01;
            double m_matrix_k_02;
            double m_matrix_k_03;
            double m_matrix_k_10;
            double m_matrix_k_11;
            double m_matrix_k_12;
            double m_matrix_k_13;
            double m_matrix_state_0;
            double m_matrix_state_1;
            double m_matrix_state_2;
            double m_matrix_state_3;
            double m_matrix_q_updated_0;
            double m_matrix_q_updated_1;
            double m_matrix_q_updated_2;
            double m_matrix_q_updated_3;
            double m_current_x;
            double m_current_y;
            double m_target_point_x;
            double m_target_point_y;
            double m_lat_target_point_s;
            int64_t m_lqr_calculate_time;
            int64_t m_lqr_calculate_time_max;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLANALYSIS_H_

