// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ControlAnalysisTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "ControlAnalysis.h"
#include "ControlAnalysisTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerControlAnalysisTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::ControlAnalysis", ros2_interface::msg::GetControlAnalysisIdentifier(true),
                        ros2_interface::msg::GetControlAnalysisObject(true));
                factory->add_type_object("ros2_interface::msg::ControlAnalysis", ros2_interface::msg::GetControlAnalysisIdentifier(false),
                        ros2_interface::msg::GetControlAnalysisObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetControlAnalysisIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("ControlAnalysis", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetControlAnalysisObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("ControlAnalysis", complete);
        }

        const TypeObject* GetControlAnalysisObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ControlAnalysis", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteControlAnalysisObject();
            }
            //else
            return GetMinimalControlAnalysisObject();
        }

        const TypeObject* GetMinimalControlAnalysisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ControlAnalysis", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_driving_mode;
            mst_driving_mode.common().member_id(memberId++);
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_mode.common().member_flags().IS_KEY(false);
            mst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 driving_mode_hash("driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_mode.detail().name_hash()[i] = driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_mode);

            MinimalStructMember mst_driving_mode_fd;
            mst_driving_mode_fd.common().member_id(memberId++);
            mst_driving_mode_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_mode_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_mode_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_mode_fd.common().member_flags().IS_OPTIONAL(false);
            mst_driving_mode_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_mode_fd.common().member_flags().IS_KEY(false);
            mst_driving_mode_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_mode_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 driving_mode_fd_hash("driving_mode_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_mode_fd.detail().name_hash()[i] = driving_mode_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_mode_fd);

            MinimalStructMember mst_gear_location_fd;
            mst_gear_location_fd.common().member_id(memberId++);
            mst_gear_location_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_location_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_location_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_location_fd.common().member_flags().IS_OPTIONAL(false);
            mst_gear_location_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_location_fd.common().member_flags().IS_KEY(false);
            mst_gear_location_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_location_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_location_fd_hash("gear_location_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_location_fd.detail().name_hash()[i] = gear_location_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_location_fd);

            MinimalStructMember mst_gear_location_cmd;
            mst_gear_location_cmd.common().member_id(memberId++);
            mst_gear_location_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_location_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_location_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_location_cmd.common().member_flags().IS_OPTIONAL(false);
            mst_gear_location_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_location_cmd.common().member_flags().IS_KEY(false);
            mst_gear_location_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_location_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_location_cmd_hash("gear_location_cmd");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_location_cmd.detail().name_hash()[i] = gear_location_cmd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_location_cmd);

            MinimalStructMember mst_epb_level_fd;
            mst_epb_level_fd.common().member_id(memberId++);
            mst_epb_level_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_epb_level_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_epb_level_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_epb_level_fd.common().member_flags().IS_OPTIONAL(false);
            mst_epb_level_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_epb_level_fd.common().member_flags().IS_KEY(false);
            mst_epb_level_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_epb_level_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 epb_level_fd_hash("epb_level_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_epb_level_fd.detail().name_hash()[i] = epb_level_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_epb_level_fd);

            MinimalStructMember mst_epb_level_cmd;
            mst_epb_level_cmd.common().member_id(memberId++);
            mst_epb_level_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_epb_level_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_epb_level_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_epb_level_cmd.common().member_flags().IS_OPTIONAL(false);
            mst_epb_level_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_epb_level_cmd.common().member_flags().IS_KEY(false);
            mst_epb_level_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_epb_level_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 epb_level_cmd_hash("epb_level_cmd");
            for(int i = 0; i < 4; ++i)
            {
                mst_epb_level_cmd.detail().name_hash()[i] = epb_level_cmd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_epb_level_cmd);

            MinimalStructMember mst_speed_mps;
            mst_speed_mps.common().member_id(memberId++);
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            mst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_mps.common().member_flags().IS_KEY(false);
            mst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_mps_hash("speed_mps");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_mps.detail().name_hash()[i] = speed_mps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_mps);

            MinimalStructMember mst_speed_reference;
            mst_speed_reference.common().member_id(memberId++);
            mst_speed_reference.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_reference.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_reference.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_reference.common().member_flags().IS_OPTIONAL(false);
            mst_speed_reference.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_reference.common().member_flags().IS_KEY(false);
            mst_speed_reference.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_reference.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_reference_hash("speed_reference");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_reference.detail().name_hash()[i] = speed_reference_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_reference);

            MinimalStructMember mst_accel_value_fd;
            mst_accel_value_fd.common().member_id(memberId++);
            mst_accel_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_value_fd.common().member_flags().IS_OPTIONAL(false);
            mst_accel_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_value_fd.common().member_flags().IS_KEY(false);
            mst_accel_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 accel_value_fd_hash("accel_value_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_value_fd.detail().name_hash()[i] = accel_value_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_value_fd);

            MinimalStructMember mst_accel_value_cmd;
            mst_accel_value_cmd.common().member_id(memberId++);
            mst_accel_value_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_value_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_value_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_value_cmd.common().member_flags().IS_OPTIONAL(false);
            mst_accel_value_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_value_cmd.common().member_flags().IS_KEY(false);
            mst_accel_value_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_value_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 accel_value_cmd_hash("accel_value_cmd");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_value_cmd.detail().name_hash()[i] = accel_value_cmd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_value_cmd);

            MinimalStructMember mst_brake_value_fd;
            mst_brake_value_fd.common().member_id(memberId++);
            mst_brake_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_value_fd.common().member_flags().IS_OPTIONAL(false);
            mst_brake_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_value_fd.common().member_flags().IS_KEY(false);
            mst_brake_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_value_fd_hash("brake_value_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_value_fd.detail().name_hash()[i] = brake_value_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_value_fd);

            MinimalStructMember mst_brake_value_cmd;
            mst_brake_value_cmd.common().member_id(memberId++);
            mst_brake_value_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_value_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_value_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_value_cmd.common().member_flags().IS_OPTIONAL(false);
            mst_brake_value_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_value_cmd.common().member_flags().IS_KEY(false);
            mst_brake_value_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_value_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_value_cmd_hash("brake_value_cmd");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_value_cmd.detail().name_hash()[i] = brake_value_cmd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_value_cmd);

            MinimalStructMember mst_path_remain;
            mst_path_remain.common().member_id(memberId++);
            mst_path_remain.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_path_remain.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_path_remain.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_path_remain.common().member_flags().IS_OPTIONAL(false);
            mst_path_remain.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_path_remain.common().member_flags().IS_KEY(false);
            mst_path_remain.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_path_remain.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 path_remain_hash("path_remain");
            for(int i = 0; i < 4; ++i)
            {
                mst_path_remain.detail().name_hash()[i] = path_remain_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_path_remain);

            MinimalStructMember mst_has_stop_point;
            mst_has_stop_point.common().member_id(memberId++);
            mst_has_stop_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_has_stop_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_has_stop_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_has_stop_point.common().member_flags().IS_OPTIONAL(false);
            mst_has_stop_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_has_stop_point.common().member_flags().IS_KEY(false);
            mst_has_stop_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_has_stop_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 has_stop_point_hash("has_stop_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_has_stop_point.detail().name_hash()[i] = has_stop_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_has_stop_point);

            MinimalStructMember mst_is_full_stop;
            mst_is_full_stop.common().member_id(memberId++);
            mst_is_full_stop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_full_stop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_full_stop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_full_stop.common().member_flags().IS_OPTIONAL(false);
            mst_is_full_stop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_full_stop.common().member_flags().IS_KEY(false);
            mst_is_full_stop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_full_stop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_full_stop_hash("is_full_stop");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_full_stop.detail().name_hash()[i] = is_full_stop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_full_stop);

            MinimalStructMember mst_is_stopped;
            mst_is_stopped.common().member_id(memberId++);
            mst_is_stopped.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_stopped.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_stopped.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_stopped.common().member_flags().IS_OPTIONAL(false);
            mst_is_stopped.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_stopped.common().member_flags().IS_KEY(false);
            mst_is_stopped.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_stopped.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_stopped_hash("is_stopped");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_stopped.detail().name_hash()[i] = is_stopped_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_stopped);

            MinimalStructMember mst_lon_acc_jerk;
            mst_lon_acc_jerk.common().member_id(memberId++);
            mst_lon_acc_jerk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_acc_jerk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_acc_jerk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_acc_jerk.common().member_flags().IS_OPTIONAL(false);
            mst_lon_acc_jerk.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_acc_jerk.common().member_flags().IS_KEY(false);
            mst_lon_acc_jerk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_acc_jerk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lon_acc_jerk_hash("lon_acc_jerk");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_acc_jerk.detail().name_hash()[i] = lon_acc_jerk_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_acc_jerk);

            MinimalStructMember mst_acceleration_cmd;
            mst_acceleration_cmd.common().member_id(memberId++);
            mst_acceleration_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_cmd.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_cmd.common().member_flags().IS_KEY(false);
            mst_acceleration_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acceleration_cmd_hash("acceleration_cmd");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_cmd.detail().name_hash()[i] = acceleration_cmd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_cmd);

            MinimalStructMember mst_acceleration_cmd_closeloop;
            mst_acceleration_cmd_closeloop.common().member_id(memberId++);
            mst_acceleration_cmd_closeloop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_cmd_closeloop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_cmd_closeloop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_cmd_closeloop.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_cmd_closeloop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_cmd_closeloop.common().member_flags().IS_KEY(false);
            mst_acceleration_cmd_closeloop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_cmd_closeloop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acceleration_cmd_closeloop_hash("acceleration_cmd_closeloop");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_cmd_closeloop.detail().name_hash()[i] = acceleration_cmd_closeloop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_cmd_closeloop);

            MinimalStructMember mst_preview_acceleration_reference;
            mst_preview_acceleration_reference.common().member_id(memberId++);
            mst_preview_acceleration_reference.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_preview_acceleration_reference.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_preview_acceleration_reference.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_preview_acceleration_reference.common().member_flags().IS_OPTIONAL(false);
            mst_preview_acceleration_reference.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_preview_acceleration_reference.common().member_flags().IS_KEY(false);
            mst_preview_acceleration_reference.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_preview_acceleration_reference.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 preview_acceleration_reference_hash("preview_acceleration_reference");
            for(int i = 0; i < 4; ++i)
            {
                mst_preview_acceleration_reference.detail().name_hash()[i] = preview_acceleration_reference_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_preview_acceleration_reference);

            MinimalStructMember mst_slope_offset_compensation;
            mst_slope_offset_compensation.common().member_id(memberId++);
            mst_slope_offset_compensation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_slope_offset_compensation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_slope_offset_compensation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_slope_offset_compensation.common().member_flags().IS_OPTIONAL(false);
            mst_slope_offset_compensation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_slope_offset_compensation.common().member_flags().IS_KEY(false);
            mst_slope_offset_compensation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_slope_offset_compensation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 slope_offset_compensation_hash("slope_offset_compensation");
            for(int i = 0; i < 4; ++i)
            {
                mst_slope_offset_compensation.detail().name_hash()[i] = slope_offset_compensation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_slope_offset_compensation);

            MinimalStructMember mst_turning_offset_compensation;
            mst_turning_offset_compensation.common().member_id(memberId++);
            mst_turning_offset_compensation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_turning_offset_compensation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_turning_offset_compensation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_turning_offset_compensation.common().member_flags().IS_OPTIONAL(false);
            mst_turning_offset_compensation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_turning_offset_compensation.common().member_flags().IS_KEY(false);
            mst_turning_offset_compensation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_turning_offset_compensation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 turning_offset_compensation_hash("turning_offset_compensation");
            for(int i = 0; i < 4; ++i)
            {
                mst_turning_offset_compensation.detail().name_hash()[i] = turning_offset_compensation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_turning_offset_compensation);

            MinimalStructMember mst_speed_error_limited;
            mst_speed_error_limited.common().member_id(memberId++);
            mst_speed_error_limited.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_error_limited.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_error_limited.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_error_limited.common().member_flags().IS_OPTIONAL(false);
            mst_speed_error_limited.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_error_limited.common().member_flags().IS_KEY(false);
            mst_speed_error_limited.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_error_limited.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_error_limited_hash("speed_error_limited");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_error_limited.detail().name_hash()[i] = speed_error_limited_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_error_limited);

            MinimalStructMember mst_speed_error;
            mst_speed_error.common().member_id(memberId++);
            mst_speed_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_error.common().member_flags().IS_OPTIONAL(false);
            mst_speed_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_error.common().member_flags().IS_KEY(false);
            mst_speed_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_error_hash("speed_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_error.detail().name_hash()[i] = speed_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_error);

            MinimalStructMember mst_speed_offset;
            mst_speed_offset.common().member_id(memberId++);
            mst_speed_offset.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_offset.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_offset.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_offset.common().member_flags().IS_OPTIONAL(false);
            mst_speed_offset.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_offset.common().member_flags().IS_KEY(false);
            mst_speed_offset.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_offset.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_offset_hash("speed_offset");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_offset.detail().name_hash()[i] = speed_offset_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_offset);

            MinimalStructMember mst_station_error_limited;
            mst_station_error_limited.common().member_id(memberId++);
            mst_station_error_limited.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_station_error_limited.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_station_error_limited.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_station_error_limited.common().member_flags().IS_OPTIONAL(false);
            mst_station_error_limited.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_station_error_limited.common().member_flags().IS_KEY(false);
            mst_station_error_limited.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_station_error_limited.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 station_error_limited_hash("station_error_limited");
            for(int i = 0; i < 4; ++i)
            {
                mst_station_error_limited.detail().name_hash()[i] = station_error_limited_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_station_error_limited);

            MinimalStructMember mst_station_error;
            mst_station_error.common().member_id(memberId++);
            mst_station_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_station_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_station_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_station_error.common().member_flags().IS_OPTIONAL(false);
            mst_station_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_station_error.common().member_flags().IS_KEY(false);
            mst_station_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_station_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 station_error_hash("station_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_station_error.detail().name_hash()[i] = station_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_station_error);

            MinimalStructMember mst_lon_target_point_s;
            mst_lon_target_point_s.common().member_id(memberId++);
            mst_lon_target_point_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_target_point_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_target_point_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_target_point_s.common().member_flags().IS_OPTIONAL(false);
            mst_lon_target_point_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_target_point_s.common().member_flags().IS_KEY(false);
            mst_lon_target_point_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_target_point_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lon_target_point_s_hash("lon_target_point_s");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_target_point_s.detail().name_hash()[i] = lon_target_point_s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_target_point_s);

            MinimalStructMember mst_lon_calculate_time;
            mst_lon_calculate_time.common().member_id(memberId++);
            mst_lon_calculate_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_calculate_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_calculate_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_calculate_time.common().member_flags().IS_OPTIONAL(false);
            mst_lon_calculate_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_calculate_time.common().member_flags().IS_KEY(false);
            mst_lon_calculate_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_calculate_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            MD5 lon_calculate_time_hash("lon_calculate_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_calculate_time.detail().name_hash()[i] = lon_calculate_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_calculate_time);

            MinimalStructMember mst_lon_calculate_time_max;
            mst_lon_calculate_time_max.common().member_id(memberId++);
            mst_lon_calculate_time_max.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_calculate_time_max.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_calculate_time_max.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_calculate_time_max.common().member_flags().IS_OPTIONAL(false);
            mst_lon_calculate_time_max.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_calculate_time_max.common().member_flags().IS_KEY(false);
            mst_lon_calculate_time_max.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_calculate_time_max.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            MD5 lon_calculate_time_max_hash("lon_calculate_time_max");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_calculate_time_max.detail().name_hash()[i] = lon_calculate_time_max_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_calculate_time_max);

            MinimalStructMember mst_ref_curvature;
            mst_ref_curvature.common().member_id(memberId++);
            mst_ref_curvature.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ref_curvature.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ref_curvature.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ref_curvature.common().member_flags().IS_OPTIONAL(false);
            mst_ref_curvature.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ref_curvature.common().member_flags().IS_KEY(false);
            mst_ref_curvature.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ref_curvature.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ref_curvature_hash("ref_curvature");
            for(int i = 0; i < 4; ++i)
            {
                mst_ref_curvature.detail().name_hash()[i] = ref_curvature_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ref_curvature);

            MinimalStructMember mst_ref_heading;
            mst_ref_heading.common().member_id(memberId++);
            mst_ref_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ref_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ref_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ref_heading.common().member_flags().IS_OPTIONAL(false);
            mst_ref_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ref_heading.common().member_flags().IS_KEY(false);
            mst_ref_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ref_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ref_heading_hash("ref_heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_ref_heading.detail().name_hash()[i] = ref_heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ref_heading);

            MinimalStructMember mst_current_heading;
            mst_current_heading.common().member_id(memberId++);
            mst_current_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_current_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_current_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_current_heading.common().member_flags().IS_OPTIONAL(false);
            mst_current_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_current_heading.common().member_flags().IS_KEY(false);
            mst_current_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_current_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 current_heading_hash("current_heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_current_heading.detail().name_hash()[i] = current_heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_current_heading);

            MinimalStructMember mst_heading_error;
            mst_heading_error.common().member_id(memberId++);
            mst_heading_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading_error.common().member_flags().IS_OPTIONAL(false);
            mst_heading_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading_error.common().member_flags().IS_KEY(false);
            mst_heading_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_error_hash("heading_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading_error.detail().name_hash()[i] = heading_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading_error);

            MinimalStructMember mst_heading_error_rate;
            mst_heading_error_rate.common().member_id(memberId++);
            mst_heading_error_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading_error_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading_error_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading_error_rate.common().member_flags().IS_OPTIONAL(false);
            mst_heading_error_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading_error_rate.common().member_flags().IS_KEY(false);
            mst_heading_error_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading_error_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_error_rate_hash("heading_error_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading_error_rate.detail().name_hash()[i] = heading_error_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading_error_rate);

            MinimalStructMember mst_lateral_error;
            mst_lateral_error.common().member_id(memberId++);
            mst_lateral_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lateral_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lateral_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lateral_error.common().member_flags().IS_OPTIONAL(false);
            mst_lateral_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lateral_error.common().member_flags().IS_KEY(false);
            mst_lateral_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lateral_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lateral_error_hash("lateral_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_lateral_error.detail().name_hash()[i] = lateral_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lateral_error);

            MinimalStructMember mst_lateral_error_rate;
            mst_lateral_error_rate.common().member_id(memberId++);
            mst_lateral_error_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lateral_error_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lateral_error_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lateral_error_rate.common().member_flags().IS_OPTIONAL(false);
            mst_lateral_error_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lateral_error_rate.common().member_flags().IS_KEY(false);
            mst_lateral_error_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lateral_error_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lateral_error_rate_hash("lateral_error_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_lateral_error_rate.detail().name_hash()[i] = lateral_error_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lateral_error_rate);

            MinimalStructMember mst_lon_error;
            mst_lon_error.common().member_id(memberId++);
            mst_lon_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_error.common().member_flags().IS_OPTIONAL(false);
            mst_lon_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_error.common().member_flags().IS_KEY(false);
            mst_lon_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lon_error_hash("lon_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_error.detail().name_hash()[i] = lon_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_error);

            MinimalStructMember mst_front_steering_value_fd;
            mst_front_steering_value_fd.common().member_id(memberId++);
            mst_front_steering_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_value_fd.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_value_fd.common().member_flags().IS_KEY(false);
            mst_front_steering_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_value_fd_hash("front_steering_value_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_value_fd.detail().name_hash()[i] = front_steering_value_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_value_fd);

            MinimalStructMember mst_front_steering_target;
            mst_front_steering_target.common().member_id(memberId++);
            mst_front_steering_target.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_target.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_target.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_target.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_target.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_target.common().member_flags().IS_KEY(false);
            mst_front_steering_target.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_target.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_target_hash("front_steering_target");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_target.detail().name_hash()[i] = front_steering_target_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_target);

            MinimalStructMember mst_front_steering_rate;
            mst_front_steering_rate.common().member_id(memberId++);
            mst_front_steering_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_rate.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_rate.common().member_flags().IS_KEY(false);
            mst_front_steering_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_rate_hash("front_steering_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_rate.detail().name_hash()[i] = front_steering_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_rate);

            MinimalStructMember mst_front_steer_angle_feedforward;
            mst_front_steer_angle_feedforward.common().member_id(memberId++);
            mst_front_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_feedforward.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_feedforward.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_feedforward.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_feedforward.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_feedforward.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_feedforward.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_feedforward_hash("front_steer_angle_feedforward");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_feedforward.detail().name_hash()[i] = front_steer_angle_feedforward_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_feedforward);

            MinimalStructMember mst_front_steer_angle_feedback;
            mst_front_steer_angle_feedback.common().member_id(memberId++);
            mst_front_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_feedback.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_feedback.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_feedback.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_feedback.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_feedback.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_feedback.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_feedback_hash("front_steer_angle_feedback");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_feedback.detail().name_hash()[i] = front_steer_angle_feedback_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_feedback);

            MinimalStructMember mst_front_steer_angle_lateral_contribution;
            mst_front_steer_angle_lateral_contribution.common().member_id(memberId++);
            mst_front_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_lateral_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_lateral_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_lateral_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_lateral_contribution.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_lateral_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_lateral_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_lateral_contribution_hash("front_steer_angle_lateral_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_lateral_contribution.detail().name_hash()[i] = front_steer_angle_lateral_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_lateral_contribution);

            MinimalStructMember mst_front_steer_angle_lateral_rate_contribution;
            mst_front_steer_angle_lateral_rate_contribution.common().member_id(memberId++);
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_lateral_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_lateral_rate_contribution_hash("front_steer_angle_lateral_rate_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_lateral_rate_contribution.detail().name_hash()[i] = front_steer_angle_lateral_rate_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_lateral_rate_contribution);

            MinimalStructMember mst_front_steer_angle_heading_contribution;
            mst_front_steer_angle_heading_contribution.common().member_id(memberId++);
            mst_front_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_heading_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_heading_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_heading_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_heading_contribution.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_heading_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_heading_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_heading_contribution_hash("front_steer_angle_heading_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_heading_contribution.detail().name_hash()[i] = front_steer_angle_heading_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_heading_contribution);

            MinimalStructMember mst_front_steer_angle_heading_rate_contribution;
            mst_front_steer_angle_heading_rate_contribution.common().member_id(memberId++);
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_KEY(false);
            mst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steer_angle_heading_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steer_angle_heading_rate_contribution_hash("front_steer_angle_heading_rate_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steer_angle_heading_rate_contribution.detail().name_hash()[i] = front_steer_angle_heading_rate_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steer_angle_heading_rate_contribution);

            MinimalStructMember mst_rear_steering_value_fd;
            mst_rear_steering_value_fd.common().member_id(memberId++);
            mst_rear_steering_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_value_fd.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_value_fd.common().member_flags().IS_KEY(false);
            mst_rear_steering_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_value_fd_hash("rear_steering_value_fd");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_value_fd.detail().name_hash()[i] = rear_steering_value_fd_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_value_fd);

            MinimalStructMember mst_rear_steering_target;
            mst_rear_steering_target.common().member_id(memberId++);
            mst_rear_steering_target.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_target.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_target.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_target.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_target.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_target.common().member_flags().IS_KEY(false);
            mst_rear_steering_target.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_target.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_target_hash("rear_steering_target");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_target.detail().name_hash()[i] = rear_steering_target_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_target);

            MinimalStructMember mst_rear_steering_rate;
            mst_rear_steering_rate.common().member_id(memberId++);
            mst_rear_steering_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_rate.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_rate.common().member_flags().IS_KEY(false);
            mst_rear_steering_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_rate_hash("rear_steering_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_rate.detail().name_hash()[i] = rear_steering_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_rate);

            MinimalStructMember mst_rear_steer_angle_feedforward;
            mst_rear_steer_angle_feedforward.common().member_id(memberId++);
            mst_rear_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_feedforward.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_feedforward.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_feedforward.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_feedforward.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_feedforward.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_feedforward.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_feedforward_hash("rear_steer_angle_feedforward");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_feedforward.detail().name_hash()[i] = rear_steer_angle_feedforward_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_feedforward);

            MinimalStructMember mst_rear_steer_angle_feedback;
            mst_rear_steer_angle_feedback.common().member_id(memberId++);
            mst_rear_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_feedback.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_feedback.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_feedback.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_feedback.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_feedback.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_feedback.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_feedback_hash("rear_steer_angle_feedback");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_feedback.detail().name_hash()[i] = rear_steer_angle_feedback_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_feedback);

            MinimalStructMember mst_rear_steer_angle_lateral_contribution;
            mst_rear_steer_angle_lateral_contribution.common().member_id(memberId++);
            mst_rear_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_lateral_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_lateral_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_lateral_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_lateral_contribution.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_lateral_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_lateral_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_lateral_contribution_hash("rear_steer_angle_lateral_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_lateral_contribution.detail().name_hash()[i] = rear_steer_angle_lateral_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_lateral_contribution);

            MinimalStructMember mst_rear_steer_angle_lateral_rate_contribution;
            mst_rear_steer_angle_lateral_rate_contribution.common().member_id(memberId++);
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_lateral_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_lateral_rate_contribution_hash("rear_steer_angle_lateral_rate_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_lateral_rate_contribution.detail().name_hash()[i] = rear_steer_angle_lateral_rate_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_lateral_rate_contribution);

            MinimalStructMember mst_rear_steer_angle_heading_contribution;
            mst_rear_steer_angle_heading_contribution.common().member_id(memberId++);
            mst_rear_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_heading_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_heading_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_heading_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_heading_contribution.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_heading_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_heading_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_heading_contribution_hash("rear_steer_angle_heading_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_heading_contribution.detail().name_hash()[i] = rear_steer_angle_heading_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_heading_contribution);

            MinimalStructMember mst_rear_steer_angle_heading_rate_contribution;
            mst_rear_steer_angle_heading_rate_contribution.common().member_id(memberId++);
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_KEY(false);
            mst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steer_angle_heading_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steer_angle_heading_rate_contribution_hash("rear_steer_angle_heading_rate_contribution");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steer_angle_heading_rate_contribution.detail().name_hash()[i] = rear_steer_angle_heading_rate_contribution_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steer_angle_heading_rate_contribution);

            MinimalStructMember mst_matrix_k_00;
            mst_matrix_k_00.common().member_id(memberId++);
            mst_matrix_k_00.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_00.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_00.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_00.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_00.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_00.common().member_flags().IS_KEY(false);
            mst_matrix_k_00.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_00.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_00_hash("matrix_k_00");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_00.detail().name_hash()[i] = matrix_k_00_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_00);

            MinimalStructMember mst_matrix_k_01;
            mst_matrix_k_01.common().member_id(memberId++);
            mst_matrix_k_01.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_01.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_01.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_01.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_01.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_01.common().member_flags().IS_KEY(false);
            mst_matrix_k_01.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_01.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_01_hash("matrix_k_01");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_01.detail().name_hash()[i] = matrix_k_01_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_01);

            MinimalStructMember mst_matrix_k_02;
            mst_matrix_k_02.common().member_id(memberId++);
            mst_matrix_k_02.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_02.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_02.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_02.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_02.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_02.common().member_flags().IS_KEY(false);
            mst_matrix_k_02.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_02.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_02_hash("matrix_k_02");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_02.detail().name_hash()[i] = matrix_k_02_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_02);

            MinimalStructMember mst_matrix_k_03;
            mst_matrix_k_03.common().member_id(memberId++);
            mst_matrix_k_03.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_03.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_03.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_03.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_03.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_03.common().member_flags().IS_KEY(false);
            mst_matrix_k_03.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_03.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_03_hash("matrix_k_03");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_03.detail().name_hash()[i] = matrix_k_03_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_03);

            MinimalStructMember mst_matrix_k_10;
            mst_matrix_k_10.common().member_id(memberId++);
            mst_matrix_k_10.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_10.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_10.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_10.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_10.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_10.common().member_flags().IS_KEY(false);
            mst_matrix_k_10.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_10.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_10_hash("matrix_k_10");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_10.detail().name_hash()[i] = matrix_k_10_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_10);

            MinimalStructMember mst_matrix_k_11;
            mst_matrix_k_11.common().member_id(memberId++);
            mst_matrix_k_11.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_11.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_11.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_11.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_11.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_11.common().member_flags().IS_KEY(false);
            mst_matrix_k_11.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_11.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_11_hash("matrix_k_11");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_11.detail().name_hash()[i] = matrix_k_11_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_11);

            MinimalStructMember mst_matrix_k_12;
            mst_matrix_k_12.common().member_id(memberId++);
            mst_matrix_k_12.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_12.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_12.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_12.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_12.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_12.common().member_flags().IS_KEY(false);
            mst_matrix_k_12.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_12.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_12_hash("matrix_k_12");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_12.detail().name_hash()[i] = matrix_k_12_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_12);

            MinimalStructMember mst_matrix_k_13;
            mst_matrix_k_13.common().member_id(memberId++);
            mst_matrix_k_13.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_k_13.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_k_13.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_k_13.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_k_13.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_k_13.common().member_flags().IS_KEY(false);
            mst_matrix_k_13.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_k_13.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_k_13_hash("matrix_k_13");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_k_13.detail().name_hash()[i] = matrix_k_13_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_k_13);

            MinimalStructMember mst_matrix_state_0;
            mst_matrix_state_0.common().member_id(memberId++);
            mst_matrix_state_0.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_state_0.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_state_0.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_state_0.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_state_0.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_state_0.common().member_flags().IS_KEY(false);
            mst_matrix_state_0.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_state_0.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_state_0_hash("matrix_state_0");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_state_0.detail().name_hash()[i] = matrix_state_0_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_state_0);

            MinimalStructMember mst_matrix_state_1;
            mst_matrix_state_1.common().member_id(memberId++);
            mst_matrix_state_1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_state_1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_state_1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_state_1.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_state_1.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_state_1.common().member_flags().IS_KEY(false);
            mst_matrix_state_1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_state_1.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_state_1_hash("matrix_state_1");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_state_1.detail().name_hash()[i] = matrix_state_1_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_state_1);

            MinimalStructMember mst_matrix_state_2;
            mst_matrix_state_2.common().member_id(memberId++);
            mst_matrix_state_2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_state_2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_state_2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_state_2.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_state_2.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_state_2.common().member_flags().IS_KEY(false);
            mst_matrix_state_2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_state_2.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_state_2_hash("matrix_state_2");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_state_2.detail().name_hash()[i] = matrix_state_2_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_state_2);

            MinimalStructMember mst_matrix_state_3;
            mst_matrix_state_3.common().member_id(memberId++);
            mst_matrix_state_3.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_state_3.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_state_3.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_state_3.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_state_3.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_state_3.common().member_flags().IS_KEY(false);
            mst_matrix_state_3.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_state_3.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_state_3_hash("matrix_state_3");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_state_3.detail().name_hash()[i] = matrix_state_3_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_state_3);

            MinimalStructMember mst_matrix_q_updated_0;
            mst_matrix_q_updated_0.common().member_id(memberId++);
            mst_matrix_q_updated_0.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_q_updated_0.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_q_updated_0.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_q_updated_0.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_q_updated_0.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_q_updated_0.common().member_flags().IS_KEY(false);
            mst_matrix_q_updated_0.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_q_updated_0.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_q_updated_0_hash("matrix_q_updated_0");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_q_updated_0.detail().name_hash()[i] = matrix_q_updated_0_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_q_updated_0);

            MinimalStructMember mst_matrix_q_updated_1;
            mst_matrix_q_updated_1.common().member_id(memberId++);
            mst_matrix_q_updated_1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_q_updated_1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_q_updated_1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_q_updated_1.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_q_updated_1.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_q_updated_1.common().member_flags().IS_KEY(false);
            mst_matrix_q_updated_1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_q_updated_1.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_q_updated_1_hash("matrix_q_updated_1");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_q_updated_1.detail().name_hash()[i] = matrix_q_updated_1_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_q_updated_1);

            MinimalStructMember mst_matrix_q_updated_2;
            mst_matrix_q_updated_2.common().member_id(memberId++);
            mst_matrix_q_updated_2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_q_updated_2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_q_updated_2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_q_updated_2.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_q_updated_2.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_q_updated_2.common().member_flags().IS_KEY(false);
            mst_matrix_q_updated_2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_q_updated_2.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_q_updated_2_hash("matrix_q_updated_2");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_q_updated_2.detail().name_hash()[i] = matrix_q_updated_2_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_q_updated_2);

            MinimalStructMember mst_matrix_q_updated_3;
            mst_matrix_q_updated_3.common().member_id(memberId++);
            mst_matrix_q_updated_3.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_matrix_q_updated_3.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_matrix_q_updated_3.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_matrix_q_updated_3.common().member_flags().IS_OPTIONAL(false);
            mst_matrix_q_updated_3.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_matrix_q_updated_3.common().member_flags().IS_KEY(false);
            mst_matrix_q_updated_3.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_matrix_q_updated_3.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 matrix_q_updated_3_hash("matrix_q_updated_3");
            for(int i = 0; i < 4; ++i)
            {
                mst_matrix_q_updated_3.detail().name_hash()[i] = matrix_q_updated_3_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_matrix_q_updated_3);

            MinimalStructMember mst_current_x;
            mst_current_x.common().member_id(memberId++);
            mst_current_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_current_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_current_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_current_x.common().member_flags().IS_OPTIONAL(false);
            mst_current_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_current_x.common().member_flags().IS_KEY(false);
            mst_current_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_current_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 current_x_hash("current_x");
            for(int i = 0; i < 4; ++i)
            {
                mst_current_x.detail().name_hash()[i] = current_x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_current_x);

            MinimalStructMember mst_current_y;
            mst_current_y.common().member_id(memberId++);
            mst_current_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_current_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_current_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_current_y.common().member_flags().IS_OPTIONAL(false);
            mst_current_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_current_y.common().member_flags().IS_KEY(false);
            mst_current_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_current_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 current_y_hash("current_y");
            for(int i = 0; i < 4; ++i)
            {
                mst_current_y.detail().name_hash()[i] = current_y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_current_y);

            MinimalStructMember mst_target_point_x;
            mst_target_point_x.common().member_id(memberId++);
            mst_target_point_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_target_point_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_target_point_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_target_point_x.common().member_flags().IS_OPTIONAL(false);
            mst_target_point_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_target_point_x.common().member_flags().IS_KEY(false);
            mst_target_point_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_target_point_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 target_point_x_hash("target_point_x");
            for(int i = 0; i < 4; ++i)
            {
                mst_target_point_x.detail().name_hash()[i] = target_point_x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_target_point_x);

            MinimalStructMember mst_target_point_y;
            mst_target_point_y.common().member_id(memberId++);
            mst_target_point_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_target_point_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_target_point_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_target_point_y.common().member_flags().IS_OPTIONAL(false);
            mst_target_point_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_target_point_y.common().member_flags().IS_KEY(false);
            mst_target_point_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_target_point_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 target_point_y_hash("target_point_y");
            for(int i = 0; i < 4; ++i)
            {
                mst_target_point_y.detail().name_hash()[i] = target_point_y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_target_point_y);

            MinimalStructMember mst_lat_target_point_s;
            mst_lat_target_point_s.common().member_id(memberId++);
            mst_lat_target_point_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lat_target_point_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lat_target_point_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lat_target_point_s.common().member_flags().IS_OPTIONAL(false);
            mst_lat_target_point_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lat_target_point_s.common().member_flags().IS_KEY(false);
            mst_lat_target_point_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lat_target_point_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lat_target_point_s_hash("lat_target_point_s");
            for(int i = 0; i < 4; ++i)
            {
                mst_lat_target_point_s.detail().name_hash()[i] = lat_target_point_s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lat_target_point_s);

            MinimalStructMember mst_lqr_calculate_time;
            mst_lqr_calculate_time.common().member_id(memberId++);
            mst_lqr_calculate_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lqr_calculate_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lqr_calculate_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lqr_calculate_time.common().member_flags().IS_OPTIONAL(false);
            mst_lqr_calculate_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lqr_calculate_time.common().member_flags().IS_KEY(false);
            mst_lqr_calculate_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lqr_calculate_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            MD5 lqr_calculate_time_hash("lqr_calculate_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_lqr_calculate_time.detail().name_hash()[i] = lqr_calculate_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lqr_calculate_time);

            MinimalStructMember mst_lqr_calculate_time_max;
            mst_lqr_calculate_time_max.common().member_id(memberId++);
            mst_lqr_calculate_time_max.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lqr_calculate_time_max.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lqr_calculate_time_max.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lqr_calculate_time_max.common().member_flags().IS_OPTIONAL(false);
            mst_lqr_calculate_time_max.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lqr_calculate_time_max.common().member_flags().IS_KEY(false);
            mst_lqr_calculate_time_max.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lqr_calculate_time_max.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            MD5 lqr_calculate_time_max_hash("lqr_calculate_time_max");
            for(int i = 0; i < 4; ++i)
            {
                mst_lqr_calculate_time_max.detail().name_hash()[i] = lqr_calculate_time_max_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lqr_calculate_time_max);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ControlAnalysis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ControlAnalysis", false);
        }

        const TypeObject* GetCompleteControlAnalysisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ControlAnalysis", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_driving_mode;
            cst_driving_mode.common().member_id(memberId++);
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_mode.common().member_flags().IS_KEY(false);
            cst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_driving_mode.detail().name("driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_mode);

            CompleteStructMember cst_driving_mode_fd;
            cst_driving_mode_fd.common().member_id(memberId++);
            cst_driving_mode_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_mode_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_mode_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_mode_fd.common().member_flags().IS_OPTIONAL(false);
            cst_driving_mode_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_mode_fd.common().member_flags().IS_KEY(false);
            cst_driving_mode_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_mode_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_driving_mode_fd.detail().name("driving_mode_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_mode_fd);

            CompleteStructMember cst_gear_location_fd;
            cst_gear_location_fd.common().member_id(memberId++);
            cst_gear_location_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_location_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_location_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_location_fd.common().member_flags().IS_OPTIONAL(false);
            cst_gear_location_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_location_fd.common().member_flags().IS_KEY(false);
            cst_gear_location_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_location_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_location_fd.detail().name("gear_location_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_location_fd);

            CompleteStructMember cst_gear_location_cmd;
            cst_gear_location_cmd.common().member_id(memberId++);
            cst_gear_location_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_location_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_location_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_location_cmd.common().member_flags().IS_OPTIONAL(false);
            cst_gear_location_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_location_cmd.common().member_flags().IS_KEY(false);
            cst_gear_location_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_location_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_location_cmd.detail().name("gear_location_cmd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_location_cmd);

            CompleteStructMember cst_epb_level_fd;
            cst_epb_level_fd.common().member_id(memberId++);
            cst_epb_level_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_epb_level_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_epb_level_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_epb_level_fd.common().member_flags().IS_OPTIONAL(false);
            cst_epb_level_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_epb_level_fd.common().member_flags().IS_KEY(false);
            cst_epb_level_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_epb_level_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_epb_level_fd.detail().name("epb_level_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_epb_level_fd);

            CompleteStructMember cst_epb_level_cmd;
            cst_epb_level_cmd.common().member_id(memberId++);
            cst_epb_level_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_epb_level_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_epb_level_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_epb_level_cmd.common().member_flags().IS_OPTIONAL(false);
            cst_epb_level_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_epb_level_cmd.common().member_flags().IS_KEY(false);
            cst_epb_level_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_epb_level_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_epb_level_cmd.detail().name("epb_level_cmd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_epb_level_cmd);

            CompleteStructMember cst_speed_mps;
            cst_speed_mps.common().member_id(memberId++);
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            cst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_mps.common().member_flags().IS_KEY(false);
            cst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_mps.detail().name("speed_mps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_mps);

            CompleteStructMember cst_speed_reference;
            cst_speed_reference.common().member_id(memberId++);
            cst_speed_reference.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_reference.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_reference.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_reference.common().member_flags().IS_OPTIONAL(false);
            cst_speed_reference.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_reference.common().member_flags().IS_KEY(false);
            cst_speed_reference.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_reference.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_reference.detail().name("speed_reference");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_reference);

            CompleteStructMember cst_accel_value_fd;
            cst_accel_value_fd.common().member_id(memberId++);
            cst_accel_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_value_fd.common().member_flags().IS_OPTIONAL(false);
            cst_accel_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_value_fd.common().member_flags().IS_KEY(false);
            cst_accel_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_accel_value_fd.detail().name("accel_value_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_value_fd);

            CompleteStructMember cst_accel_value_cmd;
            cst_accel_value_cmd.common().member_id(memberId++);
            cst_accel_value_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_value_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_value_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_value_cmd.common().member_flags().IS_OPTIONAL(false);
            cst_accel_value_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_value_cmd.common().member_flags().IS_KEY(false);
            cst_accel_value_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_value_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_accel_value_cmd.detail().name("accel_value_cmd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_value_cmd);

            CompleteStructMember cst_brake_value_fd;
            cst_brake_value_fd.common().member_id(memberId++);
            cst_brake_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_value_fd.common().member_flags().IS_OPTIONAL(false);
            cst_brake_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_value_fd.common().member_flags().IS_KEY(false);
            cst_brake_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_value_fd.detail().name("brake_value_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_value_fd);

            CompleteStructMember cst_brake_value_cmd;
            cst_brake_value_cmd.common().member_id(memberId++);
            cst_brake_value_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_value_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_value_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_value_cmd.common().member_flags().IS_OPTIONAL(false);
            cst_brake_value_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_value_cmd.common().member_flags().IS_KEY(false);
            cst_brake_value_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_value_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_value_cmd.detail().name("brake_value_cmd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_value_cmd);

            CompleteStructMember cst_path_remain;
            cst_path_remain.common().member_id(memberId++);
            cst_path_remain.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_path_remain.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_path_remain.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_path_remain.common().member_flags().IS_OPTIONAL(false);
            cst_path_remain.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_path_remain.common().member_flags().IS_KEY(false);
            cst_path_remain.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_path_remain.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_path_remain.detail().name("path_remain");

            type_object->complete().struct_type().member_seq().emplace_back(cst_path_remain);

            CompleteStructMember cst_has_stop_point;
            cst_has_stop_point.common().member_id(memberId++);
            cst_has_stop_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_has_stop_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_has_stop_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_has_stop_point.common().member_flags().IS_OPTIONAL(false);
            cst_has_stop_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_has_stop_point.common().member_flags().IS_KEY(false);
            cst_has_stop_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_has_stop_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_has_stop_point.detail().name("has_stop_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_has_stop_point);

            CompleteStructMember cst_is_full_stop;
            cst_is_full_stop.common().member_id(memberId++);
            cst_is_full_stop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_full_stop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_full_stop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_full_stop.common().member_flags().IS_OPTIONAL(false);
            cst_is_full_stop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_full_stop.common().member_flags().IS_KEY(false);
            cst_is_full_stop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_full_stop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_full_stop.detail().name("is_full_stop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_full_stop);

            CompleteStructMember cst_is_stopped;
            cst_is_stopped.common().member_id(memberId++);
            cst_is_stopped.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_stopped.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_stopped.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_stopped.common().member_flags().IS_OPTIONAL(false);
            cst_is_stopped.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_stopped.common().member_flags().IS_KEY(false);
            cst_is_stopped.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_stopped.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_stopped.detail().name("is_stopped");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_stopped);

            CompleteStructMember cst_lon_acc_jerk;
            cst_lon_acc_jerk.common().member_id(memberId++);
            cst_lon_acc_jerk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_acc_jerk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_acc_jerk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_acc_jerk.common().member_flags().IS_OPTIONAL(false);
            cst_lon_acc_jerk.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_acc_jerk.common().member_flags().IS_KEY(false);
            cst_lon_acc_jerk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_acc_jerk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lon_acc_jerk.detail().name("lon_acc_jerk");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_acc_jerk);

            CompleteStructMember cst_acceleration_cmd;
            cst_acceleration_cmd.common().member_id(memberId++);
            cst_acceleration_cmd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_cmd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_cmd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_cmd.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_cmd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_cmd.common().member_flags().IS_KEY(false);
            cst_acceleration_cmd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_cmd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acceleration_cmd.detail().name("acceleration_cmd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_cmd);

            CompleteStructMember cst_acceleration_cmd_closeloop;
            cst_acceleration_cmd_closeloop.common().member_id(memberId++);
            cst_acceleration_cmd_closeloop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_cmd_closeloop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_cmd_closeloop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_cmd_closeloop.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_cmd_closeloop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_cmd_closeloop.common().member_flags().IS_KEY(false);
            cst_acceleration_cmd_closeloop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_cmd_closeloop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acceleration_cmd_closeloop.detail().name("acceleration_cmd_closeloop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_cmd_closeloop);

            CompleteStructMember cst_preview_acceleration_reference;
            cst_preview_acceleration_reference.common().member_id(memberId++);
            cst_preview_acceleration_reference.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_preview_acceleration_reference.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_preview_acceleration_reference.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_preview_acceleration_reference.common().member_flags().IS_OPTIONAL(false);
            cst_preview_acceleration_reference.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_preview_acceleration_reference.common().member_flags().IS_KEY(false);
            cst_preview_acceleration_reference.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_preview_acceleration_reference.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_preview_acceleration_reference.detail().name("preview_acceleration_reference");

            type_object->complete().struct_type().member_seq().emplace_back(cst_preview_acceleration_reference);

            CompleteStructMember cst_slope_offset_compensation;
            cst_slope_offset_compensation.common().member_id(memberId++);
            cst_slope_offset_compensation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_slope_offset_compensation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_slope_offset_compensation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_slope_offset_compensation.common().member_flags().IS_OPTIONAL(false);
            cst_slope_offset_compensation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_slope_offset_compensation.common().member_flags().IS_KEY(false);
            cst_slope_offset_compensation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_slope_offset_compensation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_slope_offset_compensation.detail().name("slope_offset_compensation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_slope_offset_compensation);

            CompleteStructMember cst_turning_offset_compensation;
            cst_turning_offset_compensation.common().member_id(memberId++);
            cst_turning_offset_compensation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_turning_offset_compensation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_turning_offset_compensation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_turning_offset_compensation.common().member_flags().IS_OPTIONAL(false);
            cst_turning_offset_compensation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_turning_offset_compensation.common().member_flags().IS_KEY(false);
            cst_turning_offset_compensation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_turning_offset_compensation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_turning_offset_compensation.detail().name("turning_offset_compensation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_turning_offset_compensation);

            CompleteStructMember cst_speed_error_limited;
            cst_speed_error_limited.common().member_id(memberId++);
            cst_speed_error_limited.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_error_limited.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_error_limited.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_error_limited.common().member_flags().IS_OPTIONAL(false);
            cst_speed_error_limited.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_error_limited.common().member_flags().IS_KEY(false);
            cst_speed_error_limited.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_error_limited.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_error_limited.detail().name("speed_error_limited");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_error_limited);

            CompleteStructMember cst_speed_error;
            cst_speed_error.common().member_id(memberId++);
            cst_speed_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_error.common().member_flags().IS_OPTIONAL(false);
            cst_speed_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_error.common().member_flags().IS_KEY(false);
            cst_speed_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_error.detail().name("speed_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_error);

            CompleteStructMember cst_speed_offset;
            cst_speed_offset.common().member_id(memberId++);
            cst_speed_offset.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_offset.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_offset.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_offset.common().member_flags().IS_OPTIONAL(false);
            cst_speed_offset.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_offset.common().member_flags().IS_KEY(false);
            cst_speed_offset.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_offset.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_offset.detail().name("speed_offset");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_offset);

            CompleteStructMember cst_station_error_limited;
            cst_station_error_limited.common().member_id(memberId++);
            cst_station_error_limited.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_station_error_limited.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_station_error_limited.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_station_error_limited.common().member_flags().IS_OPTIONAL(false);
            cst_station_error_limited.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_station_error_limited.common().member_flags().IS_KEY(false);
            cst_station_error_limited.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_station_error_limited.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_station_error_limited.detail().name("station_error_limited");

            type_object->complete().struct_type().member_seq().emplace_back(cst_station_error_limited);

            CompleteStructMember cst_station_error;
            cst_station_error.common().member_id(memberId++);
            cst_station_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_station_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_station_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_station_error.common().member_flags().IS_OPTIONAL(false);
            cst_station_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_station_error.common().member_flags().IS_KEY(false);
            cst_station_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_station_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_station_error.detail().name("station_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_station_error);

            CompleteStructMember cst_lon_target_point_s;
            cst_lon_target_point_s.common().member_id(memberId++);
            cst_lon_target_point_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_target_point_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_target_point_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_target_point_s.common().member_flags().IS_OPTIONAL(false);
            cst_lon_target_point_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_target_point_s.common().member_flags().IS_KEY(false);
            cst_lon_target_point_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_target_point_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lon_target_point_s.detail().name("lon_target_point_s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_target_point_s);

            CompleteStructMember cst_lon_calculate_time;
            cst_lon_calculate_time.common().member_id(memberId++);
            cst_lon_calculate_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_calculate_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_calculate_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_calculate_time.common().member_flags().IS_OPTIONAL(false);
            cst_lon_calculate_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_calculate_time.common().member_flags().IS_KEY(false);
            cst_lon_calculate_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_calculate_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            cst_lon_calculate_time.detail().name("lon_calculate_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_calculate_time);

            CompleteStructMember cst_lon_calculate_time_max;
            cst_lon_calculate_time_max.common().member_id(memberId++);
            cst_lon_calculate_time_max.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_calculate_time_max.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_calculate_time_max.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_calculate_time_max.common().member_flags().IS_OPTIONAL(false);
            cst_lon_calculate_time_max.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_calculate_time_max.common().member_flags().IS_KEY(false);
            cst_lon_calculate_time_max.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_calculate_time_max.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            cst_lon_calculate_time_max.detail().name("lon_calculate_time_max");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_calculate_time_max);

            CompleteStructMember cst_ref_curvature;
            cst_ref_curvature.common().member_id(memberId++);
            cst_ref_curvature.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ref_curvature.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ref_curvature.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ref_curvature.common().member_flags().IS_OPTIONAL(false);
            cst_ref_curvature.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ref_curvature.common().member_flags().IS_KEY(false);
            cst_ref_curvature.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ref_curvature.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ref_curvature.detail().name("ref_curvature");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ref_curvature);

            CompleteStructMember cst_ref_heading;
            cst_ref_heading.common().member_id(memberId++);
            cst_ref_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ref_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ref_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ref_heading.common().member_flags().IS_OPTIONAL(false);
            cst_ref_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ref_heading.common().member_flags().IS_KEY(false);
            cst_ref_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ref_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ref_heading.detail().name("ref_heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ref_heading);

            CompleteStructMember cst_current_heading;
            cst_current_heading.common().member_id(memberId++);
            cst_current_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_current_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_current_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_current_heading.common().member_flags().IS_OPTIONAL(false);
            cst_current_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_current_heading.common().member_flags().IS_KEY(false);
            cst_current_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_current_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_current_heading.detail().name("current_heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_current_heading);

            CompleteStructMember cst_heading_error;
            cst_heading_error.common().member_id(memberId++);
            cst_heading_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading_error.common().member_flags().IS_OPTIONAL(false);
            cst_heading_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading_error.common().member_flags().IS_KEY(false);
            cst_heading_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading_error.detail().name("heading_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading_error);

            CompleteStructMember cst_heading_error_rate;
            cst_heading_error_rate.common().member_id(memberId++);
            cst_heading_error_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading_error_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading_error_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading_error_rate.common().member_flags().IS_OPTIONAL(false);
            cst_heading_error_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading_error_rate.common().member_flags().IS_KEY(false);
            cst_heading_error_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading_error_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading_error_rate.detail().name("heading_error_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading_error_rate);

            CompleteStructMember cst_lateral_error;
            cst_lateral_error.common().member_id(memberId++);
            cst_lateral_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lateral_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lateral_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lateral_error.common().member_flags().IS_OPTIONAL(false);
            cst_lateral_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lateral_error.common().member_flags().IS_KEY(false);
            cst_lateral_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lateral_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lateral_error.detail().name("lateral_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lateral_error);

            CompleteStructMember cst_lateral_error_rate;
            cst_lateral_error_rate.common().member_id(memberId++);
            cst_lateral_error_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lateral_error_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lateral_error_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lateral_error_rate.common().member_flags().IS_OPTIONAL(false);
            cst_lateral_error_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lateral_error_rate.common().member_flags().IS_KEY(false);
            cst_lateral_error_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lateral_error_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lateral_error_rate.detail().name("lateral_error_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lateral_error_rate);

            CompleteStructMember cst_lon_error;
            cst_lon_error.common().member_id(memberId++);
            cst_lon_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_error.common().member_flags().IS_OPTIONAL(false);
            cst_lon_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_error.common().member_flags().IS_KEY(false);
            cst_lon_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lon_error.detail().name("lon_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_error);

            CompleteStructMember cst_front_steering_value_fd;
            cst_front_steering_value_fd.common().member_id(memberId++);
            cst_front_steering_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_value_fd.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_value_fd.common().member_flags().IS_KEY(false);
            cst_front_steering_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_value_fd.detail().name("front_steering_value_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_value_fd);

            CompleteStructMember cst_front_steering_target;
            cst_front_steering_target.common().member_id(memberId++);
            cst_front_steering_target.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_target.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_target.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_target.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_target.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_target.common().member_flags().IS_KEY(false);
            cst_front_steering_target.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_target.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_target.detail().name("front_steering_target");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_target);

            CompleteStructMember cst_front_steering_rate;
            cst_front_steering_rate.common().member_id(memberId++);
            cst_front_steering_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_rate.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_rate.common().member_flags().IS_KEY(false);
            cst_front_steering_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_rate.detail().name("front_steering_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_rate);

            CompleteStructMember cst_front_steer_angle_feedforward;
            cst_front_steer_angle_feedforward.common().member_id(memberId++);
            cst_front_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_feedforward.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_feedforward.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_feedforward.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_feedforward.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_feedforward.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_feedforward.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_feedforward.detail().name("front_steer_angle_feedforward");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_feedforward);

            CompleteStructMember cst_front_steer_angle_feedback;
            cst_front_steer_angle_feedback.common().member_id(memberId++);
            cst_front_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_feedback.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_feedback.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_feedback.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_feedback.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_feedback.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_feedback.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_feedback.detail().name("front_steer_angle_feedback");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_feedback);

            CompleteStructMember cst_front_steer_angle_lateral_contribution;
            cst_front_steer_angle_lateral_contribution.common().member_id(memberId++);
            cst_front_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_lateral_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_lateral_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_lateral_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_lateral_contribution.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_lateral_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_lateral_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_lateral_contribution.detail().name("front_steer_angle_lateral_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_lateral_contribution);

            CompleteStructMember cst_front_steer_angle_lateral_rate_contribution;
            cst_front_steer_angle_lateral_rate_contribution.common().member_id(memberId++);
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_lateral_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_lateral_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_lateral_rate_contribution.detail().name("front_steer_angle_lateral_rate_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_lateral_rate_contribution);

            CompleteStructMember cst_front_steer_angle_heading_contribution;
            cst_front_steer_angle_heading_contribution.common().member_id(memberId++);
            cst_front_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_heading_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_heading_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_heading_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_heading_contribution.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_heading_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_heading_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_heading_contribution.detail().name("front_steer_angle_heading_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_heading_contribution);

            CompleteStructMember cst_front_steer_angle_heading_rate_contribution;
            cst_front_steer_angle_heading_rate_contribution.common().member_id(memberId++);
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_KEY(false);
            cst_front_steer_angle_heading_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steer_angle_heading_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steer_angle_heading_rate_contribution.detail().name("front_steer_angle_heading_rate_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steer_angle_heading_rate_contribution);

            CompleteStructMember cst_rear_steering_value_fd;
            cst_rear_steering_value_fd.common().member_id(memberId++);
            cst_rear_steering_value_fd.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_value_fd.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_value_fd.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_value_fd.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_value_fd.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_value_fd.common().member_flags().IS_KEY(false);
            cst_rear_steering_value_fd.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_value_fd.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_value_fd.detail().name("rear_steering_value_fd");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_value_fd);

            CompleteStructMember cst_rear_steering_target;
            cst_rear_steering_target.common().member_id(memberId++);
            cst_rear_steering_target.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_target.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_target.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_target.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_target.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_target.common().member_flags().IS_KEY(false);
            cst_rear_steering_target.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_target.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_target.detail().name("rear_steering_target");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_target);

            CompleteStructMember cst_rear_steering_rate;
            cst_rear_steering_rate.common().member_id(memberId++);
            cst_rear_steering_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_rate.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_rate.common().member_flags().IS_KEY(false);
            cst_rear_steering_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_rate.detail().name("rear_steering_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_rate);

            CompleteStructMember cst_rear_steer_angle_feedforward;
            cst_rear_steer_angle_feedforward.common().member_id(memberId++);
            cst_rear_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_feedforward.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_feedforward.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_feedforward.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_feedforward.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_feedforward.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_feedforward.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_feedforward.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_feedforward.detail().name("rear_steer_angle_feedforward");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_feedforward);

            CompleteStructMember cst_rear_steer_angle_feedback;
            cst_rear_steer_angle_feedback.common().member_id(memberId++);
            cst_rear_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_feedback.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_feedback.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_feedback.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_feedback.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_feedback.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_feedback.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_feedback.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_feedback.detail().name("rear_steer_angle_feedback");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_feedback);

            CompleteStructMember cst_rear_steer_angle_lateral_contribution;
            cst_rear_steer_angle_lateral_contribution.common().member_id(memberId++);
            cst_rear_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_lateral_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_lateral_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_lateral_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_lateral_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_lateral_contribution.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_lateral_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_lateral_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_lateral_contribution.detail().name("rear_steer_angle_lateral_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_lateral_contribution);

            CompleteStructMember cst_rear_steer_angle_lateral_rate_contribution;
            cst_rear_steer_angle_lateral_rate_contribution.common().member_id(memberId++);
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_lateral_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_lateral_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_lateral_rate_contribution.detail().name("rear_steer_angle_lateral_rate_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_lateral_rate_contribution);

            CompleteStructMember cst_rear_steer_angle_heading_contribution;
            cst_rear_steer_angle_heading_contribution.common().member_id(memberId++);
            cst_rear_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_heading_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_heading_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_heading_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_heading_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_heading_contribution.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_heading_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_heading_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_heading_contribution.detail().name("rear_steer_angle_heading_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_heading_contribution);

            CompleteStructMember cst_rear_steer_angle_heading_rate_contribution;
            cst_rear_steer_angle_heading_rate_contribution.common().member_id(memberId++);
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_KEY(false);
            cst_rear_steer_angle_heading_rate_contribution.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steer_angle_heading_rate_contribution.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steer_angle_heading_rate_contribution.detail().name("rear_steer_angle_heading_rate_contribution");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steer_angle_heading_rate_contribution);

            CompleteStructMember cst_matrix_k_00;
            cst_matrix_k_00.common().member_id(memberId++);
            cst_matrix_k_00.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_00.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_00.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_00.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_00.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_00.common().member_flags().IS_KEY(false);
            cst_matrix_k_00.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_00.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_00.detail().name("matrix_k_00");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_00);

            CompleteStructMember cst_matrix_k_01;
            cst_matrix_k_01.common().member_id(memberId++);
            cst_matrix_k_01.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_01.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_01.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_01.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_01.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_01.common().member_flags().IS_KEY(false);
            cst_matrix_k_01.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_01.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_01.detail().name("matrix_k_01");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_01);

            CompleteStructMember cst_matrix_k_02;
            cst_matrix_k_02.common().member_id(memberId++);
            cst_matrix_k_02.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_02.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_02.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_02.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_02.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_02.common().member_flags().IS_KEY(false);
            cst_matrix_k_02.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_02.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_02.detail().name("matrix_k_02");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_02);

            CompleteStructMember cst_matrix_k_03;
            cst_matrix_k_03.common().member_id(memberId++);
            cst_matrix_k_03.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_03.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_03.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_03.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_03.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_03.common().member_flags().IS_KEY(false);
            cst_matrix_k_03.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_03.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_03.detail().name("matrix_k_03");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_03);

            CompleteStructMember cst_matrix_k_10;
            cst_matrix_k_10.common().member_id(memberId++);
            cst_matrix_k_10.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_10.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_10.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_10.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_10.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_10.common().member_flags().IS_KEY(false);
            cst_matrix_k_10.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_10.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_10.detail().name("matrix_k_10");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_10);

            CompleteStructMember cst_matrix_k_11;
            cst_matrix_k_11.common().member_id(memberId++);
            cst_matrix_k_11.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_11.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_11.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_11.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_11.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_11.common().member_flags().IS_KEY(false);
            cst_matrix_k_11.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_11.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_11.detail().name("matrix_k_11");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_11);

            CompleteStructMember cst_matrix_k_12;
            cst_matrix_k_12.common().member_id(memberId++);
            cst_matrix_k_12.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_12.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_12.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_12.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_12.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_12.common().member_flags().IS_KEY(false);
            cst_matrix_k_12.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_12.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_12.detail().name("matrix_k_12");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_12);

            CompleteStructMember cst_matrix_k_13;
            cst_matrix_k_13.common().member_id(memberId++);
            cst_matrix_k_13.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_k_13.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_k_13.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_k_13.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_k_13.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_k_13.common().member_flags().IS_KEY(false);
            cst_matrix_k_13.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_k_13.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_k_13.detail().name("matrix_k_13");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_k_13);

            CompleteStructMember cst_matrix_state_0;
            cst_matrix_state_0.common().member_id(memberId++);
            cst_matrix_state_0.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_state_0.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_state_0.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_state_0.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_state_0.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_state_0.common().member_flags().IS_KEY(false);
            cst_matrix_state_0.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_state_0.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_state_0.detail().name("matrix_state_0");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_state_0);

            CompleteStructMember cst_matrix_state_1;
            cst_matrix_state_1.common().member_id(memberId++);
            cst_matrix_state_1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_state_1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_state_1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_state_1.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_state_1.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_state_1.common().member_flags().IS_KEY(false);
            cst_matrix_state_1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_state_1.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_state_1.detail().name("matrix_state_1");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_state_1);

            CompleteStructMember cst_matrix_state_2;
            cst_matrix_state_2.common().member_id(memberId++);
            cst_matrix_state_2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_state_2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_state_2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_state_2.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_state_2.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_state_2.common().member_flags().IS_KEY(false);
            cst_matrix_state_2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_state_2.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_state_2.detail().name("matrix_state_2");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_state_2);

            CompleteStructMember cst_matrix_state_3;
            cst_matrix_state_3.common().member_id(memberId++);
            cst_matrix_state_3.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_state_3.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_state_3.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_state_3.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_state_3.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_state_3.common().member_flags().IS_KEY(false);
            cst_matrix_state_3.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_state_3.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_state_3.detail().name("matrix_state_3");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_state_3);

            CompleteStructMember cst_matrix_q_updated_0;
            cst_matrix_q_updated_0.common().member_id(memberId++);
            cst_matrix_q_updated_0.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_q_updated_0.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_q_updated_0.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_q_updated_0.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_q_updated_0.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_q_updated_0.common().member_flags().IS_KEY(false);
            cst_matrix_q_updated_0.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_q_updated_0.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_q_updated_0.detail().name("matrix_q_updated_0");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_q_updated_0);

            CompleteStructMember cst_matrix_q_updated_1;
            cst_matrix_q_updated_1.common().member_id(memberId++);
            cst_matrix_q_updated_1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_q_updated_1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_q_updated_1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_q_updated_1.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_q_updated_1.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_q_updated_1.common().member_flags().IS_KEY(false);
            cst_matrix_q_updated_1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_q_updated_1.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_q_updated_1.detail().name("matrix_q_updated_1");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_q_updated_1);

            CompleteStructMember cst_matrix_q_updated_2;
            cst_matrix_q_updated_2.common().member_id(memberId++);
            cst_matrix_q_updated_2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_q_updated_2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_q_updated_2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_q_updated_2.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_q_updated_2.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_q_updated_2.common().member_flags().IS_KEY(false);
            cst_matrix_q_updated_2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_q_updated_2.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_q_updated_2.detail().name("matrix_q_updated_2");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_q_updated_2);

            CompleteStructMember cst_matrix_q_updated_3;
            cst_matrix_q_updated_3.common().member_id(memberId++);
            cst_matrix_q_updated_3.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_matrix_q_updated_3.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_matrix_q_updated_3.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_matrix_q_updated_3.common().member_flags().IS_OPTIONAL(false);
            cst_matrix_q_updated_3.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_matrix_q_updated_3.common().member_flags().IS_KEY(false);
            cst_matrix_q_updated_3.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_matrix_q_updated_3.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_matrix_q_updated_3.detail().name("matrix_q_updated_3");

            type_object->complete().struct_type().member_seq().emplace_back(cst_matrix_q_updated_3);

            CompleteStructMember cst_current_x;
            cst_current_x.common().member_id(memberId++);
            cst_current_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_current_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_current_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_current_x.common().member_flags().IS_OPTIONAL(false);
            cst_current_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_current_x.common().member_flags().IS_KEY(false);
            cst_current_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_current_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_current_x.detail().name("current_x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_current_x);

            CompleteStructMember cst_current_y;
            cst_current_y.common().member_id(memberId++);
            cst_current_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_current_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_current_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_current_y.common().member_flags().IS_OPTIONAL(false);
            cst_current_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_current_y.common().member_flags().IS_KEY(false);
            cst_current_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_current_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_current_y.detail().name("current_y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_current_y);

            CompleteStructMember cst_target_point_x;
            cst_target_point_x.common().member_id(memberId++);
            cst_target_point_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_target_point_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_target_point_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_target_point_x.common().member_flags().IS_OPTIONAL(false);
            cst_target_point_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_target_point_x.common().member_flags().IS_KEY(false);
            cst_target_point_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_target_point_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_target_point_x.detail().name("target_point_x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_target_point_x);

            CompleteStructMember cst_target_point_y;
            cst_target_point_y.common().member_id(memberId++);
            cst_target_point_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_target_point_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_target_point_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_target_point_y.common().member_flags().IS_OPTIONAL(false);
            cst_target_point_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_target_point_y.common().member_flags().IS_KEY(false);
            cst_target_point_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_target_point_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_target_point_y.detail().name("target_point_y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_target_point_y);

            CompleteStructMember cst_lat_target_point_s;
            cst_lat_target_point_s.common().member_id(memberId++);
            cst_lat_target_point_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lat_target_point_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lat_target_point_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lat_target_point_s.common().member_flags().IS_OPTIONAL(false);
            cst_lat_target_point_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lat_target_point_s.common().member_flags().IS_KEY(false);
            cst_lat_target_point_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lat_target_point_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lat_target_point_s.detail().name("lat_target_point_s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lat_target_point_s);

            CompleteStructMember cst_lqr_calculate_time;
            cst_lqr_calculate_time.common().member_id(memberId++);
            cst_lqr_calculate_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lqr_calculate_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lqr_calculate_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lqr_calculate_time.common().member_flags().IS_OPTIONAL(false);
            cst_lqr_calculate_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lqr_calculate_time.common().member_flags().IS_KEY(false);
            cst_lqr_calculate_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lqr_calculate_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            cst_lqr_calculate_time.detail().name("lqr_calculate_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lqr_calculate_time);

            CompleteStructMember cst_lqr_calculate_time_max;
            cst_lqr_calculate_time_max.common().member_id(memberId++);
            cst_lqr_calculate_time_max.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lqr_calculate_time_max.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lqr_calculate_time_max.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lqr_calculate_time_max.common().member_flags().IS_OPTIONAL(false);
            cst_lqr_calculate_time_max.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lqr_calculate_time_max.common().member_flags().IS_KEY(false);
            cst_lqr_calculate_time_max.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lqr_calculate_time_max.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int64_t", false));

            cst_lqr_calculate_time_max.detail().name("lqr_calculate_time_max");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lqr_calculate_time_max);


            // Header
            type_object->complete().struct_type().header().detail().type_name("ControlAnalysis");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ControlAnalysis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ControlAnalysis", true);
        }

    } // namespace msg
} // namespace ros2_interface