// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ControlCommand.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ControlCommand.h"
#include "ControlCommandTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ControlCommand_max_cdr_typesize 456ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ControlCommand_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ControlCommand::ControlCommand()
{
    // ros2_interface::msg::Header m_header

    // long m_steer_driving_mode
    m_steer_driving_mode = 0;
    // double m_front_steering_target
    m_front_steering_target = 0.0;
    // double m_rear_steering_target
    m_rear_steering_target = 0.0;
    // double m_front_steering_rate
    m_front_steering_rate = 0.0;
    // double m_rear_steering_rate
    m_rear_steering_rate = 0.0;
    // long m_accel_driving_mode
    m_accel_driving_mode = 0;
    // double m_accel_value
    m_accel_value = 0.0;
    // double m_speed
    m_speed = 0.0;
    // double m_acceleration
    m_acceleration = 0.0;
    // long m_brake_driving_mode
    m_brake_driving_mode = 0;
    // double m_brake_value
    m_brake_value = 0.0;
    // long m_backup_brake_driving_mode
    m_backup_brake_driving_mode = 0;
    // double m_backup_brake_value
    m_backup_brake_value = 0.0;
    // long m_epb_driving_mode
    m_epb_driving_mode = 0;
    // long m_epb_level
    m_epb_level = 0;
    // long m_gear_driving_mode
    m_gear_driving_mode = 0;
    // int8 m_emergency_brake_enable
    m_emergency_brake_enable = 0;
    // long m_gear_location
    m_gear_location = 0;
    // long m_turn_lamp_ctrl
    m_turn_lamp_ctrl = 0;
    // long m_high_beam_ctrl
    m_high_beam_ctrl = 0;
    // long m_low_beam_ctrl
    m_low_beam_ctrl = 0;
    // long m_horn_ctrl
    m_horn_ctrl = 0;
    // long m_front_wiper_ctrl
    m_front_wiper_ctrl = 0;
    // long m_rear_wiper_ctrl
    m_rear_wiper_ctrl = 0;
    // long m_position_lamp_ctrl
    m_position_lamp_ctrl = 0;
    // long m_front_fog_lamp_ctrl
    m_front_fog_lamp_ctrl = 0;
    // long m_rear_fog_lamp_ctrl
    m_rear_fog_lamp_ctrl = 0;
    // long m_brake_lamp_ctrl
    m_brake_lamp_ctrl = 0;
    // long m_alarm_lamp_ctrl
    m_alarm_lamp_ctrl = 0;
    // long m_lf_door_ctrl
    m_lf_door_ctrl = 0;
    // long m_rf_door_ctrl
    m_rf_door_ctrl = 0;
    // long m_lr_door_ctrl
    m_lr_door_ctrl = 0;
    // long m_rr_door_ctrl
    m_rr_door_ctrl = 0;

    // Just to register all known types
    registerControlCommandTypes();
}

ros2_interface::msg::ControlCommand::~ControlCommand()
{


































}

ros2_interface::msg::ControlCommand::ControlCommand(
        const ControlCommand& x)
{
    m_header = x.m_header;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_front_steering_target = x.m_front_steering_target;
    m_rear_steering_target = x.m_rear_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_value = x.m_accel_value;
    m_speed = x.m_speed;
    m_acceleration = x.m_acceleration;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_value = x.m_brake_value;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_emergency_brake_enable = x.m_emergency_brake_enable;
    m_gear_location = x.m_gear_location;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;
}

ros2_interface::msg::ControlCommand::ControlCommand(
        ControlCommand&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_front_steering_target = x.m_front_steering_target;
    m_rear_steering_target = x.m_rear_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_value = x.m_accel_value;
    m_speed = x.m_speed;
    m_acceleration = x.m_acceleration;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_value = x.m_brake_value;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_emergency_brake_enable = x.m_emergency_brake_enable;
    m_gear_location = x.m_gear_location;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;
}

ros2_interface::msg::ControlCommand& ros2_interface::msg::ControlCommand::operator =(
        const ControlCommand& x)
{

    m_header = x.m_header;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_front_steering_target = x.m_front_steering_target;
    m_rear_steering_target = x.m_rear_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_value = x.m_accel_value;
    m_speed = x.m_speed;
    m_acceleration = x.m_acceleration;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_value = x.m_brake_value;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_emergency_brake_enable = x.m_emergency_brake_enable;
    m_gear_location = x.m_gear_location;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;

    return *this;
}

ros2_interface::msg::ControlCommand& ros2_interface::msg::ControlCommand::operator =(
        ControlCommand&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_front_steering_target = x.m_front_steering_target;
    m_rear_steering_target = x.m_rear_steering_target;
    m_front_steering_rate = x.m_front_steering_rate;
    m_rear_steering_rate = x.m_rear_steering_rate;
    m_accel_driving_mode = x.m_accel_driving_mode;
    m_accel_value = x.m_accel_value;
    m_speed = x.m_speed;
    m_acceleration = x.m_acceleration;
    m_brake_driving_mode = x.m_brake_driving_mode;
    m_brake_value = x.m_brake_value;
    m_backup_brake_driving_mode = x.m_backup_brake_driving_mode;
    m_backup_brake_value = x.m_backup_brake_value;
    m_epb_driving_mode = x.m_epb_driving_mode;
    m_epb_level = x.m_epb_level;
    m_gear_driving_mode = x.m_gear_driving_mode;
    m_emergency_brake_enable = x.m_emergency_brake_enable;
    m_gear_location = x.m_gear_location;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;

    return *this;
}

bool ros2_interface::msg::ControlCommand::operator ==(
        const ControlCommand& x) const
{

    return (m_header == x.m_header && m_steer_driving_mode == x.m_steer_driving_mode && m_front_steering_target == x.m_front_steering_target && m_rear_steering_target == x.m_rear_steering_target && m_front_steering_rate == x.m_front_steering_rate && m_rear_steering_rate == x.m_rear_steering_rate && m_accel_driving_mode == x.m_accel_driving_mode && m_accel_value == x.m_accel_value && m_speed == x.m_speed && m_acceleration == x.m_acceleration && m_brake_driving_mode == x.m_brake_driving_mode && m_brake_value == x.m_brake_value && m_backup_brake_driving_mode == x.m_backup_brake_driving_mode && m_backup_brake_value == x.m_backup_brake_value && m_epb_driving_mode == x.m_epb_driving_mode && m_epb_level == x.m_epb_level && m_gear_driving_mode == x.m_gear_driving_mode && m_emergency_brake_enable == x.m_emergency_brake_enable && m_gear_location == x.m_gear_location && m_turn_lamp_ctrl == x.m_turn_lamp_ctrl && m_high_beam_ctrl == x.m_high_beam_ctrl && m_low_beam_ctrl == x.m_low_beam_ctrl && m_horn_ctrl == x.m_horn_ctrl && m_front_wiper_ctrl == x.m_front_wiper_ctrl && m_rear_wiper_ctrl == x.m_rear_wiper_ctrl && m_position_lamp_ctrl == x.m_position_lamp_ctrl && m_front_fog_lamp_ctrl == x.m_front_fog_lamp_ctrl && m_rear_fog_lamp_ctrl == x.m_rear_fog_lamp_ctrl && m_brake_lamp_ctrl == x.m_brake_lamp_ctrl && m_alarm_lamp_ctrl == x.m_alarm_lamp_ctrl && m_lf_door_ctrl == x.m_lf_door_ctrl && m_rf_door_ctrl == x.m_rf_door_ctrl && m_lr_door_ctrl == x.m_lr_door_ctrl && m_rr_door_ctrl == x.m_rr_door_ctrl);
}

bool ros2_interface::msg::ControlCommand::operator !=(
        const ControlCommand& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ControlCommand::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ControlCommand_max_cdr_typesize;
}

size_t ros2_interface::msg::ControlCommand::getCdrSerializedSize(
        const ros2_interface::msg::ControlCommand& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ControlCommand::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_steer_driving_mode;
    scdr << m_front_steering_target;
    scdr << m_rear_steering_target;
    scdr << m_front_steering_rate;
    scdr << m_rear_steering_rate;
    scdr << m_accel_driving_mode;
    scdr << m_accel_value;
    scdr << m_speed;
    scdr << m_acceleration;
    scdr << m_brake_driving_mode;
    scdr << m_brake_value;
    scdr << m_backup_brake_driving_mode;
    scdr << m_backup_brake_value;
    scdr << m_epb_driving_mode;
    scdr << m_epb_level;
    scdr << m_gear_driving_mode;
    scdr << m_emergency_brake_enable;
    scdr << m_gear_location;
    scdr << m_turn_lamp_ctrl;
    scdr << m_high_beam_ctrl;
    scdr << m_low_beam_ctrl;
    scdr << m_horn_ctrl;
    scdr << m_front_wiper_ctrl;
    scdr << m_rear_wiper_ctrl;
    scdr << m_position_lamp_ctrl;
    scdr << m_front_fog_lamp_ctrl;
    scdr << m_rear_fog_lamp_ctrl;
    scdr << m_brake_lamp_ctrl;
    scdr << m_alarm_lamp_ctrl;
    scdr << m_lf_door_ctrl;
    scdr << m_rf_door_ctrl;
    scdr << m_lr_door_ctrl;
    scdr << m_rr_door_ctrl;

}

void ros2_interface::msg::ControlCommand::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_steer_driving_mode;
    dcdr >> m_front_steering_target;
    dcdr >> m_rear_steering_target;
    dcdr >> m_front_steering_rate;
    dcdr >> m_rear_steering_rate;
    dcdr >> m_accel_driving_mode;
    dcdr >> m_accel_value;
    dcdr >> m_speed;
    dcdr >> m_acceleration;
    dcdr >> m_brake_driving_mode;
    dcdr >> m_brake_value;
    dcdr >> m_backup_brake_driving_mode;
    dcdr >> m_backup_brake_value;
    dcdr >> m_epb_driving_mode;
    dcdr >> m_epb_level;
    dcdr >> m_gear_driving_mode;
    dcdr >> m_emergency_brake_enable;
    dcdr >> m_gear_location;
    dcdr >> m_turn_lamp_ctrl;
    dcdr >> m_high_beam_ctrl;
    dcdr >> m_low_beam_ctrl;
    dcdr >> m_horn_ctrl;
    dcdr >> m_front_wiper_ctrl;
    dcdr >> m_rear_wiper_ctrl;
    dcdr >> m_position_lamp_ctrl;
    dcdr >> m_front_fog_lamp_ctrl;
    dcdr >> m_rear_fog_lamp_ctrl;
    dcdr >> m_brake_lamp_ctrl;
    dcdr >> m_alarm_lamp_ctrl;
    dcdr >> m_lf_door_ctrl;
    dcdr >> m_rf_door_ctrl;
    dcdr >> m_lr_door_ctrl;
    dcdr >> m_rr_door_ctrl;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ControlCommand::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ControlCommand::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ControlCommand::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ControlCommand::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member steer_driving_mode
 * @param _steer_driving_mode New value for member steer_driving_mode
 */
void ros2_interface::msg::ControlCommand::steer_driving_mode(
        int32_t _steer_driving_mode)
{
    m_steer_driving_mode = _steer_driving_mode;
}

/*!
 * @brief This function returns the value of member steer_driving_mode
 * @return Value of member steer_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::steer_driving_mode() const
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function returns a reference to member steer_driving_mode
 * @return Reference to member steer_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::steer_driving_mode()
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function sets a value in member front_steering_target
 * @param _front_steering_target New value for member front_steering_target
 */
void ros2_interface::msg::ControlCommand::front_steering_target(
        double _front_steering_target)
{
    m_front_steering_target = _front_steering_target;
}

/*!
 * @brief This function returns the value of member front_steering_target
 * @return Value of member front_steering_target
 */
double ros2_interface::msg::ControlCommand::front_steering_target() const
{
    return m_front_steering_target;
}

/*!
 * @brief This function returns a reference to member front_steering_target
 * @return Reference to member front_steering_target
 */
double& ros2_interface::msg::ControlCommand::front_steering_target()
{
    return m_front_steering_target;
}

/*!
 * @brief This function sets a value in member rear_steering_target
 * @param _rear_steering_target New value for member rear_steering_target
 */
void ros2_interface::msg::ControlCommand::rear_steering_target(
        double _rear_steering_target)
{
    m_rear_steering_target = _rear_steering_target;
}

/*!
 * @brief This function returns the value of member rear_steering_target
 * @return Value of member rear_steering_target
 */
double ros2_interface::msg::ControlCommand::rear_steering_target() const
{
    return m_rear_steering_target;
}

/*!
 * @brief This function returns a reference to member rear_steering_target
 * @return Reference to member rear_steering_target
 */
double& ros2_interface::msg::ControlCommand::rear_steering_target()
{
    return m_rear_steering_target;
}

/*!
 * @brief This function sets a value in member front_steering_rate
 * @param _front_steering_rate New value for member front_steering_rate
 */
void ros2_interface::msg::ControlCommand::front_steering_rate(
        double _front_steering_rate)
{
    m_front_steering_rate = _front_steering_rate;
}

/*!
 * @brief This function returns the value of member front_steering_rate
 * @return Value of member front_steering_rate
 */
double ros2_interface::msg::ControlCommand::front_steering_rate() const
{
    return m_front_steering_rate;
}

/*!
 * @brief This function returns a reference to member front_steering_rate
 * @return Reference to member front_steering_rate
 */
double& ros2_interface::msg::ControlCommand::front_steering_rate()
{
    return m_front_steering_rate;
}

/*!
 * @brief This function sets a value in member rear_steering_rate
 * @param _rear_steering_rate New value for member rear_steering_rate
 */
void ros2_interface::msg::ControlCommand::rear_steering_rate(
        double _rear_steering_rate)
{
    m_rear_steering_rate = _rear_steering_rate;
}

/*!
 * @brief This function returns the value of member rear_steering_rate
 * @return Value of member rear_steering_rate
 */
double ros2_interface::msg::ControlCommand::rear_steering_rate() const
{
    return m_rear_steering_rate;
}

/*!
 * @brief This function returns a reference to member rear_steering_rate
 * @return Reference to member rear_steering_rate
 */
double& ros2_interface::msg::ControlCommand::rear_steering_rate()
{
    return m_rear_steering_rate;
}

/*!
 * @brief This function sets a value in member accel_driving_mode
 * @param _accel_driving_mode New value for member accel_driving_mode
 */
void ros2_interface::msg::ControlCommand::accel_driving_mode(
        int32_t _accel_driving_mode)
{
    m_accel_driving_mode = _accel_driving_mode;
}

/*!
 * @brief This function returns the value of member accel_driving_mode
 * @return Value of member accel_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::accel_driving_mode() const
{
    return m_accel_driving_mode;
}

/*!
 * @brief This function returns a reference to member accel_driving_mode
 * @return Reference to member accel_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::accel_driving_mode()
{
    return m_accel_driving_mode;
}

/*!
 * @brief This function sets a value in member accel_value
 * @param _accel_value New value for member accel_value
 */
void ros2_interface::msg::ControlCommand::accel_value(
        double _accel_value)
{
    m_accel_value = _accel_value;
}

/*!
 * @brief This function returns the value of member accel_value
 * @return Value of member accel_value
 */
double ros2_interface::msg::ControlCommand::accel_value() const
{
    return m_accel_value;
}

/*!
 * @brief This function returns a reference to member accel_value
 * @return Reference to member accel_value
 */
double& ros2_interface::msg::ControlCommand::accel_value()
{
    return m_accel_value;
}

/*!
 * @brief This function sets a value in member speed
 * @param _speed New value for member speed
 */
void ros2_interface::msg::ControlCommand::speed(
        double _speed)
{
    m_speed = _speed;
}

/*!
 * @brief This function returns the value of member speed
 * @return Value of member speed
 */
double ros2_interface::msg::ControlCommand::speed() const
{
    return m_speed;
}

/*!
 * @brief This function returns a reference to member speed
 * @return Reference to member speed
 */
double& ros2_interface::msg::ControlCommand::speed()
{
    return m_speed;
}

/*!
 * @brief This function sets a value in member acceleration
 * @param _acceleration New value for member acceleration
 */
void ros2_interface::msg::ControlCommand::acceleration(
        double _acceleration)
{
    m_acceleration = _acceleration;
}

/*!
 * @brief This function returns the value of member acceleration
 * @return Value of member acceleration
 */
double ros2_interface::msg::ControlCommand::acceleration() const
{
    return m_acceleration;
}

/*!
 * @brief This function returns a reference to member acceleration
 * @return Reference to member acceleration
 */
double& ros2_interface::msg::ControlCommand::acceleration()
{
    return m_acceleration;
}

/*!
 * @brief This function sets a value in member brake_driving_mode
 * @param _brake_driving_mode New value for member brake_driving_mode
 */
void ros2_interface::msg::ControlCommand::brake_driving_mode(
        int32_t _brake_driving_mode)
{
    m_brake_driving_mode = _brake_driving_mode;
}

/*!
 * @brief This function returns the value of member brake_driving_mode
 * @return Value of member brake_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::brake_driving_mode() const
{
    return m_brake_driving_mode;
}

/*!
 * @brief This function returns a reference to member brake_driving_mode
 * @return Reference to member brake_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::brake_driving_mode()
{
    return m_brake_driving_mode;
}

/*!
 * @brief This function sets a value in member brake_value
 * @param _brake_value New value for member brake_value
 */
void ros2_interface::msg::ControlCommand::brake_value(
        double _brake_value)
{
    m_brake_value = _brake_value;
}

/*!
 * @brief This function returns the value of member brake_value
 * @return Value of member brake_value
 */
double ros2_interface::msg::ControlCommand::brake_value() const
{
    return m_brake_value;
}

/*!
 * @brief This function returns a reference to member brake_value
 * @return Reference to member brake_value
 */
double& ros2_interface::msg::ControlCommand::brake_value()
{
    return m_brake_value;
}

/*!
 * @brief This function sets a value in member backup_brake_driving_mode
 * @param _backup_brake_driving_mode New value for member backup_brake_driving_mode
 */
void ros2_interface::msg::ControlCommand::backup_brake_driving_mode(
        int32_t _backup_brake_driving_mode)
{
    m_backup_brake_driving_mode = _backup_brake_driving_mode;
}

/*!
 * @brief This function returns the value of member backup_brake_driving_mode
 * @return Value of member backup_brake_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::backup_brake_driving_mode() const
{
    return m_backup_brake_driving_mode;
}

/*!
 * @brief This function returns a reference to member backup_brake_driving_mode
 * @return Reference to member backup_brake_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::backup_brake_driving_mode()
{
    return m_backup_brake_driving_mode;
}

/*!
 * @brief This function sets a value in member backup_brake_value
 * @param _backup_brake_value New value for member backup_brake_value
 */
void ros2_interface::msg::ControlCommand::backup_brake_value(
        double _backup_brake_value)
{
    m_backup_brake_value = _backup_brake_value;
}

/*!
 * @brief This function returns the value of member backup_brake_value
 * @return Value of member backup_brake_value
 */
double ros2_interface::msg::ControlCommand::backup_brake_value() const
{
    return m_backup_brake_value;
}

/*!
 * @brief This function returns a reference to member backup_brake_value
 * @return Reference to member backup_brake_value
 */
double& ros2_interface::msg::ControlCommand::backup_brake_value()
{
    return m_backup_brake_value;
}

/*!
 * @brief This function sets a value in member epb_driving_mode
 * @param _epb_driving_mode New value for member epb_driving_mode
 */
void ros2_interface::msg::ControlCommand::epb_driving_mode(
        int32_t _epb_driving_mode)
{
    m_epb_driving_mode = _epb_driving_mode;
}

/*!
 * @brief This function returns the value of member epb_driving_mode
 * @return Value of member epb_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::epb_driving_mode() const
{
    return m_epb_driving_mode;
}

/*!
 * @brief This function returns a reference to member epb_driving_mode
 * @return Reference to member epb_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::epb_driving_mode()
{
    return m_epb_driving_mode;
}

/*!
 * @brief This function sets a value in member epb_level
 * @param _epb_level New value for member epb_level
 */
void ros2_interface::msg::ControlCommand::epb_level(
        int32_t _epb_level)
{
    m_epb_level = _epb_level;
}

/*!
 * @brief This function returns the value of member epb_level
 * @return Value of member epb_level
 */
int32_t ros2_interface::msg::ControlCommand::epb_level() const
{
    return m_epb_level;
}

/*!
 * @brief This function returns a reference to member epb_level
 * @return Reference to member epb_level
 */
int32_t& ros2_interface::msg::ControlCommand::epb_level()
{
    return m_epb_level;
}

/*!
 * @brief This function sets a value in member gear_driving_mode
 * @param _gear_driving_mode New value for member gear_driving_mode
 */
void ros2_interface::msg::ControlCommand::gear_driving_mode(
        int32_t _gear_driving_mode)
{
    m_gear_driving_mode = _gear_driving_mode;
}

/*!
 * @brief This function returns the value of member gear_driving_mode
 * @return Value of member gear_driving_mode
 */
int32_t ros2_interface::msg::ControlCommand::gear_driving_mode() const
{
    return m_gear_driving_mode;
}

/*!
 * @brief This function returns a reference to member gear_driving_mode
 * @return Reference to member gear_driving_mode
 */
int32_t& ros2_interface::msg::ControlCommand::gear_driving_mode()
{
    return m_gear_driving_mode;
}

/*!
 * @brief This function sets a value in member emergency_brake_enable
 * @param _emergency_brake_enable New value for member emergency_brake_enable
 */
void ros2_interface::msg::ControlCommand::emergency_brake_enable(
        int8_t _emergency_brake_enable)
{
    m_emergency_brake_enable = _emergency_brake_enable;
}

/*!
 * @brief This function returns the value of member emergency_brake_enable
 * @return Value of member emergency_brake_enable
 */
int8_t ros2_interface::msg::ControlCommand::emergency_brake_enable() const
{
    return m_emergency_brake_enable;
}

/*!
 * @brief This function returns a reference to member emergency_brake_enable
 * @return Reference to member emergency_brake_enable
 */
int8_t& ros2_interface::msg::ControlCommand::emergency_brake_enable()
{
    return m_emergency_brake_enable;
}

/*!
 * @brief This function sets a value in member gear_location
 * @param _gear_location New value for member gear_location
 */
void ros2_interface::msg::ControlCommand::gear_location(
        int32_t _gear_location)
{
    m_gear_location = _gear_location;
}

/*!
 * @brief This function returns the value of member gear_location
 * @return Value of member gear_location
 */
int32_t ros2_interface::msg::ControlCommand::gear_location() const
{
    return m_gear_location;
}

/*!
 * @brief This function returns a reference to member gear_location
 * @return Reference to member gear_location
 */
int32_t& ros2_interface::msg::ControlCommand::gear_location()
{
    return m_gear_location;
}

/*!
 * @brief This function sets a value in member turn_lamp_ctrl
 * @param _turn_lamp_ctrl New value for member turn_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::turn_lamp_ctrl(
        int32_t _turn_lamp_ctrl)
{
    m_turn_lamp_ctrl = _turn_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member turn_lamp_ctrl
 * @return Value of member turn_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::turn_lamp_ctrl() const
{
    return m_turn_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member turn_lamp_ctrl
 * @return Reference to member turn_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::turn_lamp_ctrl()
{
    return m_turn_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member high_beam_ctrl
 * @param _high_beam_ctrl New value for member high_beam_ctrl
 */
void ros2_interface::msg::ControlCommand::high_beam_ctrl(
        int32_t _high_beam_ctrl)
{
    m_high_beam_ctrl = _high_beam_ctrl;
}

/*!
 * @brief This function returns the value of member high_beam_ctrl
 * @return Value of member high_beam_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::high_beam_ctrl() const
{
    return m_high_beam_ctrl;
}

/*!
 * @brief This function returns a reference to member high_beam_ctrl
 * @return Reference to member high_beam_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::high_beam_ctrl()
{
    return m_high_beam_ctrl;
}

/*!
 * @brief This function sets a value in member low_beam_ctrl
 * @param _low_beam_ctrl New value for member low_beam_ctrl
 */
void ros2_interface::msg::ControlCommand::low_beam_ctrl(
        int32_t _low_beam_ctrl)
{
    m_low_beam_ctrl = _low_beam_ctrl;
}

/*!
 * @brief This function returns the value of member low_beam_ctrl
 * @return Value of member low_beam_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::low_beam_ctrl() const
{
    return m_low_beam_ctrl;
}

/*!
 * @brief This function returns a reference to member low_beam_ctrl
 * @return Reference to member low_beam_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::low_beam_ctrl()
{
    return m_low_beam_ctrl;
}

/*!
 * @brief This function sets a value in member horn_ctrl
 * @param _horn_ctrl New value for member horn_ctrl
 */
void ros2_interface::msg::ControlCommand::horn_ctrl(
        int32_t _horn_ctrl)
{
    m_horn_ctrl = _horn_ctrl;
}

/*!
 * @brief This function returns the value of member horn_ctrl
 * @return Value of member horn_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::horn_ctrl() const
{
    return m_horn_ctrl;
}

/*!
 * @brief This function returns a reference to member horn_ctrl
 * @return Reference to member horn_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::horn_ctrl()
{
    return m_horn_ctrl;
}

/*!
 * @brief This function sets a value in member front_wiper_ctrl
 * @param _front_wiper_ctrl New value for member front_wiper_ctrl
 */
void ros2_interface::msg::ControlCommand::front_wiper_ctrl(
        int32_t _front_wiper_ctrl)
{
    m_front_wiper_ctrl = _front_wiper_ctrl;
}

/*!
 * @brief This function returns the value of member front_wiper_ctrl
 * @return Value of member front_wiper_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::front_wiper_ctrl() const
{
    return m_front_wiper_ctrl;
}

/*!
 * @brief This function returns a reference to member front_wiper_ctrl
 * @return Reference to member front_wiper_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::front_wiper_ctrl()
{
    return m_front_wiper_ctrl;
}

/*!
 * @brief This function sets a value in member rear_wiper_ctrl
 * @param _rear_wiper_ctrl New value for member rear_wiper_ctrl
 */
void ros2_interface::msg::ControlCommand::rear_wiper_ctrl(
        int32_t _rear_wiper_ctrl)
{
    m_rear_wiper_ctrl = _rear_wiper_ctrl;
}

/*!
 * @brief This function returns the value of member rear_wiper_ctrl
 * @return Value of member rear_wiper_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::rear_wiper_ctrl() const
{
    return m_rear_wiper_ctrl;
}

/*!
 * @brief This function returns a reference to member rear_wiper_ctrl
 * @return Reference to member rear_wiper_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::rear_wiper_ctrl()
{
    return m_rear_wiper_ctrl;
}

/*!
 * @brief This function sets a value in member position_lamp_ctrl
 * @param _position_lamp_ctrl New value for member position_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::position_lamp_ctrl(
        int32_t _position_lamp_ctrl)
{
    m_position_lamp_ctrl = _position_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member position_lamp_ctrl
 * @return Value of member position_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::position_lamp_ctrl() const
{
    return m_position_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member position_lamp_ctrl
 * @return Reference to member position_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::position_lamp_ctrl()
{
    return m_position_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member front_fog_lamp_ctrl
 * @param _front_fog_lamp_ctrl New value for member front_fog_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::front_fog_lamp_ctrl(
        int32_t _front_fog_lamp_ctrl)
{
    m_front_fog_lamp_ctrl = _front_fog_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member front_fog_lamp_ctrl
 * @return Value of member front_fog_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::front_fog_lamp_ctrl() const
{
    return m_front_fog_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member front_fog_lamp_ctrl
 * @return Reference to member front_fog_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::front_fog_lamp_ctrl()
{
    return m_front_fog_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member rear_fog_lamp_ctrl
 * @param _rear_fog_lamp_ctrl New value for member rear_fog_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::rear_fog_lamp_ctrl(
        int32_t _rear_fog_lamp_ctrl)
{
    m_rear_fog_lamp_ctrl = _rear_fog_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member rear_fog_lamp_ctrl
 * @return Value of member rear_fog_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::rear_fog_lamp_ctrl() const
{
    return m_rear_fog_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member rear_fog_lamp_ctrl
 * @return Reference to member rear_fog_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::rear_fog_lamp_ctrl()
{
    return m_rear_fog_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member brake_lamp_ctrl
 * @param _brake_lamp_ctrl New value for member brake_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::brake_lamp_ctrl(
        int32_t _brake_lamp_ctrl)
{
    m_brake_lamp_ctrl = _brake_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member brake_lamp_ctrl
 * @return Value of member brake_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::brake_lamp_ctrl() const
{
    return m_brake_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member brake_lamp_ctrl
 * @return Reference to member brake_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::brake_lamp_ctrl()
{
    return m_brake_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member alarm_lamp_ctrl
 * @param _alarm_lamp_ctrl New value for member alarm_lamp_ctrl
 */
void ros2_interface::msg::ControlCommand::alarm_lamp_ctrl(
        int32_t _alarm_lamp_ctrl)
{
    m_alarm_lamp_ctrl = _alarm_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member alarm_lamp_ctrl
 * @return Value of member alarm_lamp_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::alarm_lamp_ctrl() const
{
    return m_alarm_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member alarm_lamp_ctrl
 * @return Reference to member alarm_lamp_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::alarm_lamp_ctrl()
{
    return m_alarm_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member lf_door_ctrl
 * @param _lf_door_ctrl New value for member lf_door_ctrl
 */
void ros2_interface::msg::ControlCommand::lf_door_ctrl(
        int32_t _lf_door_ctrl)
{
    m_lf_door_ctrl = _lf_door_ctrl;
}

/*!
 * @brief This function returns the value of member lf_door_ctrl
 * @return Value of member lf_door_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::lf_door_ctrl() const
{
    return m_lf_door_ctrl;
}

/*!
 * @brief This function returns a reference to member lf_door_ctrl
 * @return Reference to member lf_door_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::lf_door_ctrl()
{
    return m_lf_door_ctrl;
}

/*!
 * @brief This function sets a value in member rf_door_ctrl
 * @param _rf_door_ctrl New value for member rf_door_ctrl
 */
void ros2_interface::msg::ControlCommand::rf_door_ctrl(
        int32_t _rf_door_ctrl)
{
    m_rf_door_ctrl = _rf_door_ctrl;
}

/*!
 * @brief This function returns the value of member rf_door_ctrl
 * @return Value of member rf_door_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::rf_door_ctrl() const
{
    return m_rf_door_ctrl;
}

/*!
 * @brief This function returns a reference to member rf_door_ctrl
 * @return Reference to member rf_door_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::rf_door_ctrl()
{
    return m_rf_door_ctrl;
}

/*!
 * @brief This function sets a value in member lr_door_ctrl
 * @param _lr_door_ctrl New value for member lr_door_ctrl
 */
void ros2_interface::msg::ControlCommand::lr_door_ctrl(
        int32_t _lr_door_ctrl)
{
    m_lr_door_ctrl = _lr_door_ctrl;
}

/*!
 * @brief This function returns the value of member lr_door_ctrl
 * @return Value of member lr_door_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::lr_door_ctrl() const
{
    return m_lr_door_ctrl;
}

/*!
 * @brief This function returns a reference to member lr_door_ctrl
 * @return Reference to member lr_door_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::lr_door_ctrl()
{
    return m_lr_door_ctrl;
}

/*!
 * @brief This function sets a value in member rr_door_ctrl
 * @param _rr_door_ctrl New value for member rr_door_ctrl
 */
void ros2_interface::msg::ControlCommand::rr_door_ctrl(
        int32_t _rr_door_ctrl)
{
    m_rr_door_ctrl = _rr_door_ctrl;
}

/*!
 * @brief This function returns the value of member rr_door_ctrl
 * @return Value of member rr_door_ctrl
 */
int32_t ros2_interface::msg::ControlCommand::rr_door_ctrl() const
{
    return m_rr_door_ctrl;
}

/*!
 * @brief This function returns a reference to member rr_door_ctrl
 * @return Reference to member rr_door_ctrl
 */
int32_t& ros2_interface::msg::ControlCommand::rr_door_ctrl()
{
    return m_rr_door_ctrl;
}



size_t ros2_interface::msg::ControlCommand::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ControlCommand_max_key_cdr_typesize;
}

bool ros2_interface::msg::ControlCommand::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ControlCommand::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



