// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ControlCommand.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLCOMMAND_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLCOMMAND_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(CONTROLCOMMAND_SOURCE)
#define CONTROLCOMMAND_DllAPI __declspec( dllexport )
#else
#define CONTROLCOMMAND_DllAPI __declspec( dllimport )
#endif // CONTROLCOMMAND_SOURCE
#else
#define CONTROLCOMMAND_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define CONTROLCOMMAND_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ControlCommand defined by the user in the IDL file.
         * @ingroup ControlCommand
         */
        class ControlCommand
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ControlCommand();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ControlCommand();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ControlCommand that will be copied.
             */
            eProsima_user_DllExport ControlCommand(
                    const ControlCommand& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ControlCommand that will be copied.
             */
            eProsima_user_DllExport ControlCommand(
                    ControlCommand&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ControlCommand that will be copied.
             */
            eProsima_user_DllExport ControlCommand& operator =(
                    const ControlCommand& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ControlCommand that will be copied.
             */
            eProsima_user_DllExport ControlCommand& operator =(
                    ControlCommand&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ControlCommand object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ControlCommand& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ControlCommand object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ControlCommand& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member steer_driving_mode
             * @param _steer_driving_mode New value for member steer_driving_mode
             */
            eProsima_user_DllExport void steer_driving_mode(
                    int32_t _steer_driving_mode);

            /*!
             * @brief This function returns the value of member steer_driving_mode
             * @return Value of member steer_driving_mode
             */
            eProsima_user_DllExport int32_t steer_driving_mode() const;

            /*!
             * @brief This function returns a reference to member steer_driving_mode
             * @return Reference to member steer_driving_mode
             */
            eProsima_user_DllExport int32_t& steer_driving_mode();

            /*!
             * @brief This function sets a value in member front_steering_target
             * @param _front_steering_target New value for member front_steering_target
             */
            eProsima_user_DllExport void front_steering_target(
                    double _front_steering_target);

            /*!
             * @brief This function returns the value of member front_steering_target
             * @return Value of member front_steering_target
             */
            eProsima_user_DllExport double front_steering_target() const;

            /*!
             * @brief This function returns a reference to member front_steering_target
             * @return Reference to member front_steering_target
             */
            eProsima_user_DllExport double& front_steering_target();

            /*!
             * @brief This function sets a value in member rear_steering_target
             * @param _rear_steering_target New value for member rear_steering_target
             */
            eProsima_user_DllExport void rear_steering_target(
                    double _rear_steering_target);

            /*!
             * @brief This function returns the value of member rear_steering_target
             * @return Value of member rear_steering_target
             */
            eProsima_user_DllExport double rear_steering_target() const;

            /*!
             * @brief This function returns a reference to member rear_steering_target
             * @return Reference to member rear_steering_target
             */
            eProsima_user_DllExport double& rear_steering_target();

            /*!
             * @brief This function sets a value in member front_steering_rate
             * @param _front_steering_rate New value for member front_steering_rate
             */
            eProsima_user_DllExport void front_steering_rate(
                    double _front_steering_rate);

            /*!
             * @brief This function returns the value of member front_steering_rate
             * @return Value of member front_steering_rate
             */
            eProsima_user_DllExport double front_steering_rate() const;

            /*!
             * @brief This function returns a reference to member front_steering_rate
             * @return Reference to member front_steering_rate
             */
            eProsima_user_DllExport double& front_steering_rate();

            /*!
             * @brief This function sets a value in member rear_steering_rate
             * @param _rear_steering_rate New value for member rear_steering_rate
             */
            eProsima_user_DllExport void rear_steering_rate(
                    double _rear_steering_rate);

            /*!
             * @brief This function returns the value of member rear_steering_rate
             * @return Value of member rear_steering_rate
             */
            eProsima_user_DllExport double rear_steering_rate() const;

            /*!
             * @brief This function returns a reference to member rear_steering_rate
             * @return Reference to member rear_steering_rate
             */
            eProsima_user_DllExport double& rear_steering_rate();

            /*!
             * @brief This function sets a value in member accel_driving_mode
             * @param _accel_driving_mode New value for member accel_driving_mode
             */
            eProsima_user_DllExport void accel_driving_mode(
                    int32_t _accel_driving_mode);

            /*!
             * @brief This function returns the value of member accel_driving_mode
             * @return Value of member accel_driving_mode
             */
            eProsima_user_DllExport int32_t accel_driving_mode() const;

            /*!
             * @brief This function returns a reference to member accel_driving_mode
             * @return Reference to member accel_driving_mode
             */
            eProsima_user_DllExport int32_t& accel_driving_mode();

            /*!
             * @brief This function sets a value in member accel_value
             * @param _accel_value New value for member accel_value
             */
            eProsima_user_DllExport void accel_value(
                    double _accel_value);

            /*!
             * @brief This function returns the value of member accel_value
             * @return Value of member accel_value
             */
            eProsima_user_DllExport double accel_value() const;

            /*!
             * @brief This function returns a reference to member accel_value
             * @return Reference to member accel_value
             */
            eProsima_user_DllExport double& accel_value();

            /*!
             * @brief This function sets a value in member speed
             * @param _speed New value for member speed
             */
            eProsima_user_DllExport void speed(
                    double _speed);

            /*!
             * @brief This function returns the value of member speed
             * @return Value of member speed
             */
            eProsima_user_DllExport double speed() const;

            /*!
             * @brief This function returns a reference to member speed
             * @return Reference to member speed
             */
            eProsima_user_DllExport double& speed();

            /*!
             * @brief This function sets a value in member acceleration
             * @param _acceleration New value for member acceleration
             */
            eProsima_user_DllExport void acceleration(
                    double _acceleration);

            /*!
             * @brief This function returns the value of member acceleration
             * @return Value of member acceleration
             */
            eProsima_user_DllExport double acceleration() const;

            /*!
             * @brief This function returns a reference to member acceleration
             * @return Reference to member acceleration
             */
            eProsima_user_DllExport double& acceleration();

            /*!
             * @brief This function sets a value in member brake_driving_mode
             * @param _brake_driving_mode New value for member brake_driving_mode
             */
            eProsima_user_DllExport void brake_driving_mode(
                    int32_t _brake_driving_mode);

            /*!
             * @brief This function returns the value of member brake_driving_mode
             * @return Value of member brake_driving_mode
             */
            eProsima_user_DllExport int32_t brake_driving_mode() const;

            /*!
             * @brief This function returns a reference to member brake_driving_mode
             * @return Reference to member brake_driving_mode
             */
            eProsima_user_DllExport int32_t& brake_driving_mode();

            /*!
             * @brief This function sets a value in member brake_value
             * @param _brake_value New value for member brake_value
             */
            eProsima_user_DllExport void brake_value(
                    double _brake_value);

            /*!
             * @brief This function returns the value of member brake_value
             * @return Value of member brake_value
             */
            eProsima_user_DllExport double brake_value() const;

            /*!
             * @brief This function returns a reference to member brake_value
             * @return Reference to member brake_value
             */
            eProsima_user_DllExport double& brake_value();

            /*!
             * @brief This function sets a value in member backup_brake_driving_mode
             * @param _backup_brake_driving_mode New value for member backup_brake_driving_mode
             */
            eProsima_user_DllExport void backup_brake_driving_mode(
                    int32_t _backup_brake_driving_mode);

            /*!
             * @brief This function returns the value of member backup_brake_driving_mode
             * @return Value of member backup_brake_driving_mode
             */
            eProsima_user_DllExport int32_t backup_brake_driving_mode() const;

            /*!
             * @brief This function returns a reference to member backup_brake_driving_mode
             * @return Reference to member backup_brake_driving_mode
             */
            eProsima_user_DllExport int32_t& backup_brake_driving_mode();

            /*!
             * @brief This function sets a value in member backup_brake_value
             * @param _backup_brake_value New value for member backup_brake_value
             */
            eProsima_user_DllExport void backup_brake_value(
                    double _backup_brake_value);

            /*!
             * @brief This function returns the value of member backup_brake_value
             * @return Value of member backup_brake_value
             */
            eProsima_user_DllExport double backup_brake_value() const;

            /*!
             * @brief This function returns a reference to member backup_brake_value
             * @return Reference to member backup_brake_value
             */
            eProsima_user_DllExport double& backup_brake_value();

            /*!
             * @brief This function sets a value in member epb_driving_mode
             * @param _epb_driving_mode New value for member epb_driving_mode
             */
            eProsima_user_DllExport void epb_driving_mode(
                    int32_t _epb_driving_mode);

            /*!
             * @brief This function returns the value of member epb_driving_mode
             * @return Value of member epb_driving_mode
             */
            eProsima_user_DllExport int32_t epb_driving_mode() const;

            /*!
             * @brief This function returns a reference to member epb_driving_mode
             * @return Reference to member epb_driving_mode
             */
            eProsima_user_DllExport int32_t& epb_driving_mode();

            /*!
             * @brief This function sets a value in member epb_level
             * @param _epb_level New value for member epb_level
             */
            eProsima_user_DllExport void epb_level(
                    int32_t _epb_level);

            /*!
             * @brief This function returns the value of member epb_level
             * @return Value of member epb_level
             */
            eProsima_user_DllExport int32_t epb_level() const;

            /*!
             * @brief This function returns a reference to member epb_level
             * @return Reference to member epb_level
             */
            eProsima_user_DllExport int32_t& epb_level();

            /*!
             * @brief This function sets a value in member gear_driving_mode
             * @param _gear_driving_mode New value for member gear_driving_mode
             */
            eProsima_user_DllExport void gear_driving_mode(
                    int32_t _gear_driving_mode);

            /*!
             * @brief This function returns the value of member gear_driving_mode
             * @return Value of member gear_driving_mode
             */
            eProsima_user_DllExport int32_t gear_driving_mode() const;

            /*!
             * @brief This function returns a reference to member gear_driving_mode
             * @return Reference to member gear_driving_mode
             */
            eProsima_user_DllExport int32_t& gear_driving_mode();

            /*!
             * @brief This function sets a value in member emergency_brake_enable
             * @param _emergency_brake_enable New value for member emergency_brake_enable
             */
            eProsima_user_DllExport void emergency_brake_enable(
                    int8_t _emergency_brake_enable);

            /*!
             * @brief This function returns the value of member emergency_brake_enable
             * @return Value of member emergency_brake_enable
             */
            eProsima_user_DllExport int8_t emergency_brake_enable() const;

            /*!
             * @brief This function returns a reference to member emergency_brake_enable
             * @return Reference to member emergency_brake_enable
             */
            eProsima_user_DllExport int8_t& emergency_brake_enable();

            /*!
             * @brief This function sets a value in member gear_location
             * @param _gear_location New value for member gear_location
             */
            eProsima_user_DllExport void gear_location(
                    int32_t _gear_location);

            /*!
             * @brief This function returns the value of member gear_location
             * @return Value of member gear_location
             */
            eProsima_user_DllExport int32_t gear_location() const;

            /*!
             * @brief This function returns a reference to member gear_location
             * @return Reference to member gear_location
             */
            eProsima_user_DllExport int32_t& gear_location();

            /*!
             * @brief This function sets a value in member turn_lamp_ctrl
             * @param _turn_lamp_ctrl New value for member turn_lamp_ctrl
             */
            eProsima_user_DllExport void turn_lamp_ctrl(
                    int32_t _turn_lamp_ctrl);

            /*!
             * @brief This function returns the value of member turn_lamp_ctrl
             * @return Value of member turn_lamp_ctrl
             */
            eProsima_user_DllExport int32_t turn_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member turn_lamp_ctrl
             * @return Reference to member turn_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& turn_lamp_ctrl();

            /*!
             * @brief This function sets a value in member high_beam_ctrl
             * @param _high_beam_ctrl New value for member high_beam_ctrl
             */
            eProsima_user_DllExport void high_beam_ctrl(
                    int32_t _high_beam_ctrl);

            /*!
             * @brief This function returns the value of member high_beam_ctrl
             * @return Value of member high_beam_ctrl
             */
            eProsima_user_DllExport int32_t high_beam_ctrl() const;

            /*!
             * @brief This function returns a reference to member high_beam_ctrl
             * @return Reference to member high_beam_ctrl
             */
            eProsima_user_DllExport int32_t& high_beam_ctrl();

            /*!
             * @brief This function sets a value in member low_beam_ctrl
             * @param _low_beam_ctrl New value for member low_beam_ctrl
             */
            eProsima_user_DllExport void low_beam_ctrl(
                    int32_t _low_beam_ctrl);

            /*!
             * @brief This function returns the value of member low_beam_ctrl
             * @return Value of member low_beam_ctrl
             */
            eProsima_user_DllExport int32_t low_beam_ctrl() const;

            /*!
             * @brief This function returns a reference to member low_beam_ctrl
             * @return Reference to member low_beam_ctrl
             */
            eProsima_user_DllExport int32_t& low_beam_ctrl();

            /*!
             * @brief This function sets a value in member horn_ctrl
             * @param _horn_ctrl New value for member horn_ctrl
             */
            eProsima_user_DllExport void horn_ctrl(
                    int32_t _horn_ctrl);

            /*!
             * @brief This function returns the value of member horn_ctrl
             * @return Value of member horn_ctrl
             */
            eProsima_user_DllExport int32_t horn_ctrl() const;

            /*!
             * @brief This function returns a reference to member horn_ctrl
             * @return Reference to member horn_ctrl
             */
            eProsima_user_DllExport int32_t& horn_ctrl();

            /*!
             * @brief This function sets a value in member front_wiper_ctrl
             * @param _front_wiper_ctrl New value for member front_wiper_ctrl
             */
            eProsima_user_DllExport void front_wiper_ctrl(
                    int32_t _front_wiper_ctrl);

            /*!
             * @brief This function returns the value of member front_wiper_ctrl
             * @return Value of member front_wiper_ctrl
             */
            eProsima_user_DllExport int32_t front_wiper_ctrl() const;

            /*!
             * @brief This function returns a reference to member front_wiper_ctrl
             * @return Reference to member front_wiper_ctrl
             */
            eProsima_user_DllExport int32_t& front_wiper_ctrl();

            /*!
             * @brief This function sets a value in member rear_wiper_ctrl
             * @param _rear_wiper_ctrl New value for member rear_wiper_ctrl
             */
            eProsima_user_DllExport void rear_wiper_ctrl(
                    int32_t _rear_wiper_ctrl);

            /*!
             * @brief This function returns the value of member rear_wiper_ctrl
             * @return Value of member rear_wiper_ctrl
             */
            eProsima_user_DllExport int32_t rear_wiper_ctrl() const;

            /*!
             * @brief This function returns a reference to member rear_wiper_ctrl
             * @return Reference to member rear_wiper_ctrl
             */
            eProsima_user_DllExport int32_t& rear_wiper_ctrl();

            /*!
             * @brief This function sets a value in member position_lamp_ctrl
             * @param _position_lamp_ctrl New value for member position_lamp_ctrl
             */
            eProsima_user_DllExport void position_lamp_ctrl(
                    int32_t _position_lamp_ctrl);

            /*!
             * @brief This function returns the value of member position_lamp_ctrl
             * @return Value of member position_lamp_ctrl
             */
            eProsima_user_DllExport int32_t position_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member position_lamp_ctrl
             * @return Reference to member position_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& position_lamp_ctrl();

            /*!
             * @brief This function sets a value in member front_fog_lamp_ctrl
             * @param _front_fog_lamp_ctrl New value for member front_fog_lamp_ctrl
             */
            eProsima_user_DllExport void front_fog_lamp_ctrl(
                    int32_t _front_fog_lamp_ctrl);

            /*!
             * @brief This function returns the value of member front_fog_lamp_ctrl
             * @return Value of member front_fog_lamp_ctrl
             */
            eProsima_user_DllExport int32_t front_fog_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member front_fog_lamp_ctrl
             * @return Reference to member front_fog_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& front_fog_lamp_ctrl();

            /*!
             * @brief This function sets a value in member rear_fog_lamp_ctrl
             * @param _rear_fog_lamp_ctrl New value for member rear_fog_lamp_ctrl
             */
            eProsima_user_DllExport void rear_fog_lamp_ctrl(
                    int32_t _rear_fog_lamp_ctrl);

            /*!
             * @brief This function returns the value of member rear_fog_lamp_ctrl
             * @return Value of member rear_fog_lamp_ctrl
             */
            eProsima_user_DllExport int32_t rear_fog_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member rear_fog_lamp_ctrl
             * @return Reference to member rear_fog_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& rear_fog_lamp_ctrl();

            /*!
             * @brief This function sets a value in member brake_lamp_ctrl
             * @param _brake_lamp_ctrl New value for member brake_lamp_ctrl
             */
            eProsima_user_DllExport void brake_lamp_ctrl(
                    int32_t _brake_lamp_ctrl);

            /*!
             * @brief This function returns the value of member brake_lamp_ctrl
             * @return Value of member brake_lamp_ctrl
             */
            eProsima_user_DllExport int32_t brake_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member brake_lamp_ctrl
             * @return Reference to member brake_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& brake_lamp_ctrl();

            /*!
             * @brief This function sets a value in member alarm_lamp_ctrl
             * @param _alarm_lamp_ctrl New value for member alarm_lamp_ctrl
             */
            eProsima_user_DllExport void alarm_lamp_ctrl(
                    int32_t _alarm_lamp_ctrl);

            /*!
             * @brief This function returns the value of member alarm_lamp_ctrl
             * @return Value of member alarm_lamp_ctrl
             */
            eProsima_user_DllExport int32_t alarm_lamp_ctrl() const;

            /*!
             * @brief This function returns a reference to member alarm_lamp_ctrl
             * @return Reference to member alarm_lamp_ctrl
             */
            eProsima_user_DllExport int32_t& alarm_lamp_ctrl();

            /*!
             * @brief This function sets a value in member lf_door_ctrl
             * @param _lf_door_ctrl New value for member lf_door_ctrl
             */
            eProsima_user_DllExport void lf_door_ctrl(
                    int32_t _lf_door_ctrl);

            /*!
             * @brief This function returns the value of member lf_door_ctrl
             * @return Value of member lf_door_ctrl
             */
            eProsima_user_DllExport int32_t lf_door_ctrl() const;

            /*!
             * @brief This function returns a reference to member lf_door_ctrl
             * @return Reference to member lf_door_ctrl
             */
            eProsima_user_DllExport int32_t& lf_door_ctrl();

            /*!
             * @brief This function sets a value in member rf_door_ctrl
             * @param _rf_door_ctrl New value for member rf_door_ctrl
             */
            eProsima_user_DllExport void rf_door_ctrl(
                    int32_t _rf_door_ctrl);

            /*!
             * @brief This function returns the value of member rf_door_ctrl
             * @return Value of member rf_door_ctrl
             */
            eProsima_user_DllExport int32_t rf_door_ctrl() const;

            /*!
             * @brief This function returns a reference to member rf_door_ctrl
             * @return Reference to member rf_door_ctrl
             */
            eProsima_user_DllExport int32_t& rf_door_ctrl();

            /*!
             * @brief This function sets a value in member lr_door_ctrl
             * @param _lr_door_ctrl New value for member lr_door_ctrl
             */
            eProsima_user_DllExport void lr_door_ctrl(
                    int32_t _lr_door_ctrl);

            /*!
             * @brief This function returns the value of member lr_door_ctrl
             * @return Value of member lr_door_ctrl
             */
            eProsima_user_DllExport int32_t lr_door_ctrl() const;

            /*!
             * @brief This function returns a reference to member lr_door_ctrl
             * @return Reference to member lr_door_ctrl
             */
            eProsima_user_DllExport int32_t& lr_door_ctrl();

            /*!
             * @brief This function sets a value in member rr_door_ctrl
             * @param _rr_door_ctrl New value for member rr_door_ctrl
             */
            eProsima_user_DllExport void rr_door_ctrl(
                    int32_t _rr_door_ctrl);

            /*!
             * @brief This function returns the value of member rr_door_ctrl
             * @return Value of member rr_door_ctrl
             */
            eProsima_user_DllExport int32_t rr_door_ctrl() const;

            /*!
             * @brief This function returns a reference to member rr_door_ctrl
             * @return Reference to member rr_door_ctrl
             */
            eProsima_user_DllExport int32_t& rr_door_ctrl();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ControlCommand& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_steer_driving_mode;
            double m_front_steering_target;
            double m_rear_steering_target;
            double m_front_steering_rate;
            double m_rear_steering_rate;
            int32_t m_accel_driving_mode;
            double m_accel_value;
            double m_speed;
            double m_acceleration;
            int32_t m_brake_driving_mode;
            double m_brake_value;
            int32_t m_backup_brake_driving_mode;
            double m_backup_brake_value;
            int32_t m_epb_driving_mode;
            int32_t m_epb_level;
            int32_t m_gear_driving_mode;
            int8_t m_emergency_brake_enable;
            int32_t m_gear_location;
            int32_t m_turn_lamp_ctrl;
            int32_t m_high_beam_ctrl;
            int32_t m_low_beam_ctrl;
            int32_t m_horn_ctrl;
            int32_t m_front_wiper_ctrl;
            int32_t m_rear_wiper_ctrl;
            int32_t m_position_lamp_ctrl;
            int32_t m_front_fog_lamp_ctrl;
            int32_t m_rear_fog_lamp_ctrl;
            int32_t m_brake_lamp_ctrl;
            int32_t m_alarm_lamp_ctrl;
            int32_t m_lf_door_ctrl;
            int32_t m_rf_door_ctrl;
            int32_t m_lr_door_ctrl;
            int32_t m_rr_door_ctrl;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_CONTROLCOMMAND_H_

