// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file DrivableRegion.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "DrivableRegion.h"
#include "DrivableRegionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Polygon3D_max_cdr_typesize 2408ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_DrivableRegion_max_cdr_typesize 241080ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_DrivableRegion_max_key_cdr_typesize 0ULL;

ros2_interface::msg::DrivableRegion::DrivableRegion()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::Polygon3D> m_drivable_region


    // Just to register all known types
    registerDrivableRegionTypes();
}

ros2_interface::msg::DrivableRegion::~DrivableRegion()
{


}

ros2_interface::msg::DrivableRegion::DrivableRegion(
        const DrivableRegion& x)
{
    m_header = x.m_header;
    m_drivable_region = x.m_drivable_region;
}

ros2_interface::msg::DrivableRegion::DrivableRegion(
        DrivableRegion&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_drivable_region = std::move(x.m_drivable_region);
}

ros2_interface::msg::DrivableRegion& ros2_interface::msg::DrivableRegion::operator =(
        const DrivableRegion& x)
{

    m_header = x.m_header;
    m_drivable_region = x.m_drivable_region;

    return *this;
}

ros2_interface::msg::DrivableRegion& ros2_interface::msg::DrivableRegion::operator =(
        DrivableRegion&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_drivable_region = std::move(x.m_drivable_region);

    return *this;
}

bool ros2_interface::msg::DrivableRegion::operator ==(
        const DrivableRegion& x) const
{

    return (m_header == x.m_header && m_drivable_region == x.m_drivable_region);
}

bool ros2_interface::msg::DrivableRegion::operator !=(
        const DrivableRegion& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::DrivableRegion::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_DrivableRegion_max_cdr_typesize;
}

size_t ros2_interface::msg::DrivableRegion::getCdrSerializedSize(
        const ros2_interface::msg::DrivableRegion& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.drivable_region().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Polygon3D::getCdrSerializedSize(data.drivable_region().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::DrivableRegion::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_drivable_region;

}

void ros2_interface::msg::DrivableRegion::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_drivable_region;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::DrivableRegion::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::DrivableRegion::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::DrivableRegion::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::DrivableRegion::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member drivable_region
 * @param _drivable_region New value to be copied in member drivable_region
 */
void ros2_interface::msg::DrivableRegion::drivable_region(
        const std::vector<ros2_interface::msg::Polygon3D>& _drivable_region)
{
    m_drivable_region = _drivable_region;
}

/*!
 * @brief This function moves the value in member drivable_region
 * @param _drivable_region New value to be moved in member drivable_region
 */
void ros2_interface::msg::DrivableRegion::drivable_region(
        std::vector<ros2_interface::msg::Polygon3D>&& _drivable_region)
{
    m_drivable_region = std::move(_drivable_region);
}

/*!
 * @brief This function returns a constant reference to member drivable_region
 * @return Constant reference to member drivable_region
 */
const std::vector<ros2_interface::msg::Polygon3D>& ros2_interface::msg::DrivableRegion::drivable_region() const
{
    return m_drivable_region;
}

/*!
 * @brief This function returns a reference to member drivable_region
 * @return Reference to member drivable_region
 */
std::vector<ros2_interface::msg::Polygon3D>& ros2_interface::msg::DrivableRegion::drivable_region()
{
    return m_drivable_region;
}


size_t ros2_interface::msg::DrivableRegion::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_DrivableRegion_max_key_cdr_typesize;
}

bool ros2_interface::msg::DrivableRegion::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::DrivableRegion::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



