// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file EStop.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "EStop.h"
#include "EStopTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_EStop_max_cdr_typesize 264ULL;
#define ros2_interface_msg_EStop_max_key_cdr_typesize 0ULL;

ros2_interface::msg::EStop::EStop()
{
    // boolean m_is_estop
    m_is_estop = false;
    // string m_reason
    m_reason ="";

    // Just to register all known types
    registerEStopTypes();
}

ros2_interface::msg::EStop::~EStop()
{


}

ros2_interface::msg::EStop::EStop(
        const EStop& x)
{
    m_is_estop = x.m_is_estop;
    m_reason = x.m_reason;
}

ros2_interface::msg::EStop::EStop(
        EStop&& x) noexcept 
{
    m_is_estop = x.m_is_estop;
    m_reason = std::move(x.m_reason);
}

ros2_interface::msg::EStop& ros2_interface::msg::EStop::operator =(
        const EStop& x)
{

    m_is_estop = x.m_is_estop;
    m_reason = x.m_reason;

    return *this;
}

ros2_interface::msg::EStop& ros2_interface::msg::EStop::operator =(
        EStop&& x) noexcept
{

    m_is_estop = x.m_is_estop;
    m_reason = std::move(x.m_reason);

    return *this;
}

bool ros2_interface::msg::EStop::operator ==(
        const EStop& x) const
{

    return (m_is_estop == x.m_is_estop && m_reason == x.m_reason);
}

bool ros2_interface::msg::EStop::operator !=(
        const EStop& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::EStop::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_EStop_max_cdr_typesize;
}

size_t ros2_interface::msg::EStop::getCdrSerializedSize(
        const ros2_interface::msg::EStop& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.reason().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::EStop::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_is_estop;
    scdr << m_reason.c_str();

}

void ros2_interface::msg::EStop::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_is_estop;
    dcdr >> m_reason;
}

/*!
 * @brief This function sets a value in member is_estop
 * @param _is_estop New value for member is_estop
 */
void ros2_interface::msg::EStop::is_estop(
        bool _is_estop)
{
    m_is_estop = _is_estop;
}

/*!
 * @brief This function returns the value of member is_estop
 * @return Value of member is_estop
 */
bool ros2_interface::msg::EStop::is_estop() const
{
    return m_is_estop;
}

/*!
 * @brief This function returns a reference to member is_estop
 * @return Reference to member is_estop
 */
bool& ros2_interface::msg::EStop::is_estop()
{
    return m_is_estop;
}

/*!
 * @brief This function copies the value in member reason
 * @param _reason New value to be copied in member reason
 */
void ros2_interface::msg::EStop::reason(
        const std::string& _reason)
{
    m_reason = _reason;
}

/*!
 * @brief This function moves the value in member reason
 * @param _reason New value to be moved in member reason
 */
void ros2_interface::msg::EStop::reason(
        std::string&& _reason)
{
    m_reason = std::move(_reason);
}

/*!
 * @brief This function returns a constant reference to member reason
 * @return Constant reference to member reason
 */
const std::string& ros2_interface::msg::EStop::reason() const
{
    return m_reason;
}

/*!
 * @brief This function returns a reference to member reason
 * @return Reference to member reason
 */
std::string& ros2_interface::msg::EStop::reason()
{
    return m_reason;
}


size_t ros2_interface::msg::EStop::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_EStop_max_key_cdr_typesize;
}

bool ros2_interface::msg::EStop::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::EStop::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



