// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file EndPoints.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "EndPoints.h"
#include "EndPointsTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_EndPoints_max_cdr_typesize 32ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_EndPoints_max_key_cdr_typesize 0ULL;

ros2_interface::msg::EndPoints::EndPoints()
{
    // ros2_interface::msg::Point2D m_start

    // ros2_interface::msg::Point2D m_end


    // Just to register all known types
    registerEndPointsTypes();
}

ros2_interface::msg::EndPoints::~EndPoints()
{


}

ros2_interface::msg::EndPoints::EndPoints(
        const EndPoints& x)
{
    m_start = x.m_start;
    m_end = x.m_end;
}

ros2_interface::msg::EndPoints::EndPoints(
        EndPoints&& x) noexcept 
{
    m_start = std::move(x.m_start);
    m_end = std::move(x.m_end);
}

ros2_interface::msg::EndPoints& ros2_interface::msg::EndPoints::operator =(
        const EndPoints& x)
{

    m_start = x.m_start;
    m_end = x.m_end;

    return *this;
}

ros2_interface::msg::EndPoints& ros2_interface::msg::EndPoints::operator =(
        EndPoints&& x) noexcept
{

    m_start = std::move(x.m_start);
    m_end = std::move(x.m_end);

    return *this;
}

bool ros2_interface::msg::EndPoints::operator ==(
        const EndPoints& x) const
{

    return (m_start == x.m_start && m_end == x.m_end);
}

bool ros2_interface::msg::EndPoints::operator !=(
        const EndPoints& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::EndPoints::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_EndPoints_max_cdr_typesize;
}

size_t ros2_interface::msg::EndPoints::getCdrSerializedSize(
        const ros2_interface::msg::EndPoints& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.start(), current_alignment);
    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.end(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::EndPoints::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_start;
    scdr << m_end;

}

void ros2_interface::msg::EndPoints::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_start;
    dcdr >> m_end;
}

/*!
 * @brief This function copies the value in member start
 * @param _start New value to be copied in member start
 */
void ros2_interface::msg::EndPoints::start(
        const ros2_interface::msg::Point2D& _start)
{
    m_start = _start;
}

/*!
 * @brief This function moves the value in member start
 * @param _start New value to be moved in member start
 */
void ros2_interface::msg::EndPoints::start(
        ros2_interface::msg::Point2D&& _start)
{
    m_start = std::move(_start);
}

/*!
 * @brief This function returns a constant reference to member start
 * @return Constant reference to member start
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::EndPoints::start() const
{
    return m_start;
}

/*!
 * @brief This function returns a reference to member start
 * @return Reference to member start
 */
ros2_interface::msg::Point2D& ros2_interface::msg::EndPoints::start()
{
    return m_start;
}
/*!
 * @brief This function copies the value in member end
 * @param _end New value to be copied in member end
 */
void ros2_interface::msg::EndPoints::end(
        const ros2_interface::msg::Point2D& _end)
{
    m_end = _end;
}

/*!
 * @brief This function moves the value in member end
 * @param _end New value to be moved in member end
 */
void ros2_interface::msg::EndPoints::end(
        ros2_interface::msg::Point2D&& _end)
{
    m_end = std::move(_end);
}

/*!
 * @brief This function returns a constant reference to member end
 * @return Constant reference to member end
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::EndPoints::end() const
{
    return m_end;
}

/*!
 * @brief This function returns a reference to member end
 * @return Reference to member end
 */
ros2_interface::msg::Point2D& ros2_interface::msg::EndPoints::end()
{
    return m_end;
}


size_t ros2_interface::msg::EndPoints::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_EndPoints_max_key_cdr_typesize;
}

bool ros2_interface::msg::EndPoints::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::EndPoints::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



