// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file EndPointsTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "EndPoints.h"
#include "EndPointsTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerEndPointsTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::EndPoints", ros2_interface::msg::GetEndPointsIdentifier(true),
                        ros2_interface::msg::GetEndPointsObject(true));
                factory->add_type_object("ros2_interface::msg::EndPoints", ros2_interface::msg::GetEndPointsIdentifier(false),
                        ros2_interface::msg::GetEndPointsObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetEndPointsIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("EndPoints", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetEndPointsObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("EndPoints", complete);
        }

        const TypeObject* GetEndPointsObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("EndPoints", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteEndPointsObject();
            }
            //else
            return GetMinimalEndPointsObject();
        }

        const TypeObject* GetMinimalEndPointsObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("EndPoints", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_start;
            mst_start.common().member_id(memberId++);
            mst_start.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_start.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_start.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_start.common().member_flags().IS_OPTIONAL(false);
            mst_start.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_start.common().member_flags().IS_KEY(false);
            mst_start.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_start.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 start_hash("start");
            for(int i = 0; i < 4; ++i)
            {
                mst_start.detail().name_hash()[i] = start_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_start);

            MinimalStructMember mst_end;
            mst_end.common().member_id(memberId++);
            mst_end.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_end.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_end.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_end.common().member_flags().IS_OPTIONAL(false);
            mst_end.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_end.common().member_flags().IS_KEY(false);
            mst_end.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_end.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 end_hash("end");
            for(int i = 0; i < 4; ++i)
            {
                mst_end.detail().name_hash()[i] = end_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_end);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("EndPoints", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("EndPoints", false);
        }

        const TypeObject* GetCompleteEndPointsObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("EndPoints", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_start;
            cst_start.common().member_id(memberId++);
            cst_start.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_start.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_start.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_start.common().member_flags().IS_OPTIONAL(false);
            cst_start.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_start.common().member_flags().IS_KEY(false);
            cst_start.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_start.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_start.detail().name("start");

            type_object->complete().struct_type().member_seq().emplace_back(cst_start);

            CompleteStructMember cst_end;
            cst_end.common().member_id(memberId++);
            cst_end.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_end.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_end.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_end.common().member_flags().IS_OPTIONAL(false);
            cst_end.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_end.common().member_flags().IS_KEY(false);
            cst_end.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_end.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_end.detail().name("end");

            type_object->complete().struct_type().member_seq().emplace_back(cst_end);


            // Header
            type_object->complete().struct_type().header().detail().type_name("EndPoints");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("EndPoints", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("EndPoints", true);
        }

    } // namespace msg
} // namespace ros2_interface