// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Event.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Event.h"
#include "EventTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Event_max_cdr_typesize 276ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Event_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Event::Event()
{
    // ros2_interface::msg::Time m_timestamp

    // unsigned long long m_code
    m_code = 0;
    // string m_reason
    m_reason ="";

    // Just to register all known types
    registerEventTypes();
}

ros2_interface::msg::Event::~Event()
{



}

ros2_interface::msg::Event::Event(
        const Event& x)
{
    m_timestamp = x.m_timestamp;
    m_code = x.m_code;
    m_reason = x.m_reason;
}

ros2_interface::msg::Event::Event(
        Event&& x) noexcept 
{
    m_timestamp = std::move(x.m_timestamp);
    m_code = x.m_code;
    m_reason = std::move(x.m_reason);
}

ros2_interface::msg::Event& ros2_interface::msg::Event::operator =(
        const Event& x)
{

    m_timestamp = x.m_timestamp;
    m_code = x.m_code;
    m_reason = x.m_reason;

    return *this;
}

ros2_interface::msg::Event& ros2_interface::msg::Event::operator =(
        Event&& x) noexcept
{

    m_timestamp = std::move(x.m_timestamp);
    m_code = x.m_code;
    m_reason = std::move(x.m_reason);

    return *this;
}

bool ros2_interface::msg::Event::operator ==(
        const Event& x) const
{

    return (m_timestamp == x.m_timestamp && m_code == x.m_code && m_reason == x.m_reason);
}

bool ros2_interface::msg::Event::operator !=(
        const Event& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Event::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Event_max_cdr_typesize;
}

size_t ros2_interface::msg::Event::getCdrSerializedSize(
        const ros2_interface::msg::Event& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.timestamp(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.reason().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Event::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_timestamp;
    scdr << m_code;
    scdr << m_reason.c_str();

}

void ros2_interface::msg::Event::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_timestamp;
    dcdr >> m_code;
    dcdr >> m_reason;
}

/*!
 * @brief This function copies the value in member timestamp
 * @param _timestamp New value to be copied in member timestamp
 */
void ros2_interface::msg::Event::timestamp(
        const ros2_interface::msg::Time& _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function moves the value in member timestamp
 * @param _timestamp New value to be moved in member timestamp
 */
void ros2_interface::msg::Event::timestamp(
        ros2_interface::msg::Time&& _timestamp)
{
    m_timestamp = std::move(_timestamp);
}

/*!
 * @brief This function returns a constant reference to member timestamp
 * @return Constant reference to member timestamp
 */
const ros2_interface::msg::Time& ros2_interface::msg::Event::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
ros2_interface::msg::Time& ros2_interface::msg::Event::timestamp()
{
    return m_timestamp;
}
/*!
 * @brief This function sets a value in member code
 * @param _code New value for member code
 */
void ros2_interface::msg::Event::code(
        uint64_t _code)
{
    m_code = _code;
}

/*!
 * @brief This function returns the value of member code
 * @return Value of member code
 */
uint64_t ros2_interface::msg::Event::code() const
{
    return m_code;
}

/*!
 * @brief This function returns a reference to member code
 * @return Reference to member code
 */
uint64_t& ros2_interface::msg::Event::code()
{
    return m_code;
}

/*!
 * @brief This function copies the value in member reason
 * @param _reason New value to be copied in member reason
 */
void ros2_interface::msg::Event::reason(
        const std::string& _reason)
{
    m_reason = _reason;
}

/*!
 * @brief This function moves the value in member reason
 * @param _reason New value to be moved in member reason
 */
void ros2_interface::msg::Event::reason(
        std::string&& _reason)
{
    m_reason = std::move(_reason);
}

/*!
 * @brief This function returns a constant reference to member reason
 * @return Constant reference to member reason
 */
const std::string& ros2_interface::msg::Event::reason() const
{
    return m_reason;
}

/*!
 * @brief This function returns a reference to member reason
 * @return Reference to member reason
 */
std::string& ros2_interface::msg::Event::reason()
{
    return m_reason;
}


size_t ros2_interface::msg::Event::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Event_max_key_cdr_typesize;
}

bool ros2_interface::msg::Event::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Event::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



