// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Events.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Events.h"
#include "EventsTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Events_max_cdr_typesize 28276ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Event_max_cdr_typesize 276ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Events_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Event_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Events::Events()
{
    // ros2_interface::msg::Header m_header

    // long m_version
    m_version = 0;
    // sequence<ros2_interface::msg::Event> m_events


    // Just to register all known types
    registerEventsTypes();
}

ros2_interface::msg::Events::~Events()
{



}

ros2_interface::msg::Events::Events(
        const Events& x)
{
    m_header = x.m_header;
    m_version = x.m_version;
    m_events = x.m_events;
}

ros2_interface::msg::Events::Events(
        Events&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_version = x.m_version;
    m_events = std::move(x.m_events);
}

ros2_interface::msg::Events& ros2_interface::msg::Events::operator =(
        const Events& x)
{

    m_header = x.m_header;
    m_version = x.m_version;
    m_events = x.m_events;

    return *this;
}

ros2_interface::msg::Events& ros2_interface::msg::Events::operator =(
        Events&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_version = x.m_version;
    m_events = std::move(x.m_events);

    return *this;
}

bool ros2_interface::msg::Events::operator ==(
        const Events& x) const
{

    return (m_header == x.m_header && m_version == x.m_version && m_events == x.m_events);
}

bool ros2_interface::msg::Events::operator !=(
        const Events& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Events::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Events_max_cdr_typesize;
}

size_t ros2_interface::msg::Events::getCdrSerializedSize(
        const ros2_interface::msg::Events& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.events().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Event::getCdrSerializedSize(data.events().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Events::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_version;
    scdr << m_events;

}

void ros2_interface::msg::Events::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_version;
    dcdr >> m_events;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Events::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Events::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Events::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Events::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member version
 * @param _version New value for member version
 */
void ros2_interface::msg::Events::version(
        int32_t _version)
{
    m_version = _version;
}

/*!
 * @brief This function returns the value of member version
 * @return Value of member version
 */
int32_t ros2_interface::msg::Events::version() const
{
    return m_version;
}

/*!
 * @brief This function returns a reference to member version
 * @return Reference to member version
 */
int32_t& ros2_interface::msg::Events::version()
{
    return m_version;
}

/*!
 * @brief This function copies the value in member events
 * @param _events New value to be copied in member events
 */
void ros2_interface::msg::Events::events(
        const std::vector<ros2_interface::msg::Event>& _events)
{
    m_events = _events;
}

/*!
 * @brief This function moves the value in member events
 * @param _events New value to be moved in member events
 */
void ros2_interface::msg::Events::events(
        std::vector<ros2_interface::msg::Event>&& _events)
{
    m_events = std::move(_events);
}

/*!
 * @brief This function returns a constant reference to member events
 * @return Constant reference to member events
 */
const std::vector<ros2_interface::msg::Event>& ros2_interface::msg::Events::events() const
{
    return m_events;
}

/*!
 * @brief This function returns a reference to member events
 * @return Reference to member events
 */
std::vector<ros2_interface::msg::Event>& ros2_interface::msg::Events::events()
{
    return m_events;
}


size_t ros2_interface::msg::Events::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Events_max_key_cdr_typesize;
}

bool ros2_interface::msg::Events::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Events::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



