// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Fault.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_FAULT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_FAULT_H_

#include "Time.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(FAULT_SOURCE)
#define FAULT_DllAPI __declspec( dllexport )
#else
#define FAULT_DllAPI __declspec( dllimport )
#endif // FAULT_SOURCE
#else
#define FAULT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define FAULT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Fault defined by the user in the IDL file.
         * @ingroup Fault
         */
        class Fault
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Fault();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Fault();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Fault that will be copied.
             */
            eProsima_user_DllExport Fault(
                    const Fault& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Fault that will be copied.
             */
            eProsima_user_DllExport Fault(
                    Fault&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Fault that will be copied.
             */
            eProsima_user_DllExport Fault& operator =(
                    const Fault& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Fault that will be copied.
             */
            eProsima_user_DllExport Fault& operator =(
                    Fault&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Fault object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Fault& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Fault object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Fault& x) const;

            /*!
             * @brief This function copies the value in member timestamp
             * @param _timestamp New value to be copied in member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    const ros2_interface::msg::Time& _timestamp);

            /*!
             * @brief This function moves the value in member timestamp
             * @param _timestamp New value to be moved in member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    ros2_interface::msg::Time&& _timestamp);

            /*!
             * @brief This function returns a constant reference to member timestamp
             * @return Constant reference to member timestamp
             */
            eProsima_user_DllExport const ros2_interface::msg::Time& timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport ros2_interface::msg::Time& timestamp();
            /*!
             * @brief This function sets a value in member code
             * @param _code New value for member code
             */
            eProsima_user_DllExport void code(
                    uint64_t _code);

            /*!
             * @brief This function returns the value of member code
             * @return Value of member code
             */
            eProsima_user_DllExport uint64_t code() const;

            /*!
             * @brief This function returns a reference to member code
             * @return Reference to member code
             */
            eProsima_user_DllExport uint64_t& code();

            /*!
             * @brief This function copies the value in member reason
             * @param _reason New value to be copied in member reason
             */
            eProsima_user_DllExport void reason(
                    const std::string& _reason);

            /*!
             * @brief This function moves the value in member reason
             * @param _reason New value to be moved in member reason
             */
            eProsima_user_DllExport void reason(
                    std::string&& _reason);

            /*!
             * @brief This function returns a constant reference to member reason
             * @return Constant reference to member reason
             */
            eProsima_user_DllExport const std::string& reason() const;

            /*!
             * @brief This function returns a reference to member reason
             * @return Reference to member reason
             */
            eProsima_user_DllExport std::string& reason();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Fault& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Time m_timestamp;
            uint64_t m_code;
            std::string m_reason;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_FAULT_H_

