// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file FaultTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Fault.h"
#include "FaultTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerFaultTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Fault", ros2_interface::msg::GetFaultIdentifier(true),
                        ros2_interface::msg::GetFaultObject(true));
                factory->add_type_object("ros2_interface::msg::Fault", ros2_interface::msg::GetFaultIdentifier(false),
                        ros2_interface::msg::GetFaultObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetFaultIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Fault", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetFaultObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Fault", complete);
        }

        const TypeObject* GetFaultObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Fault", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteFaultObject();
            }
            //else
            return GetMinimalFaultObject();
        }

        const TypeObject* GetMinimalFaultObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Fault", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_code;
            mst_code.common().member_id(memberId++);
            mst_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_code.common().member_flags().IS_OPTIONAL(false);
            mst_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_code.common().member_flags().IS_KEY(false);
            mst_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint64_t", false));

            MD5 code_hash("code");
            for(int i = 0; i < 4; ++i)
            {
                mst_code.detail().name_hash()[i] = code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_code);

            MinimalStructMember mst_reason;
            mst_reason.common().member_id(memberId++);
            mst_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_reason.common().member_flags().IS_OPTIONAL(false);
            mst_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_reason.common().member_flags().IS_KEY(false);
            mst_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 reason_hash("reason");
            for(int i = 0; i < 4; ++i)
            {
                mst_reason.detail().name_hash()[i] = reason_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_reason);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Fault", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Fault", false);
        }

        const TypeObject* GetCompleteFaultObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Fault", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_code;
            cst_code.common().member_id(memberId++);
            cst_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_code.common().member_flags().IS_OPTIONAL(false);
            cst_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_code.common().member_flags().IS_KEY(false);
            cst_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint64_t", false));

            cst_code.detail().name("code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_code);

            CompleteStructMember cst_reason;
            cst_reason.common().member_id(memberId++);
            cst_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_reason.common().member_flags().IS_OPTIONAL(false);
            cst_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_reason.common().member_flags().IS_KEY(false);
            cst_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_reason.detail().name("reason");

            type_object->complete().struct_type().member_seq().emplace_back(cst_reason);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Fault");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Fault", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Fault", true);
        }

    } // namespace msg
} // namespace ros2_interface