// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Faults.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Faults.h"
#include "FaultsTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Faults_max_cdr_typesize 28276ULL;
#define ros2_interface_msg_Fault_max_cdr_typesize 276ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Faults_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Fault_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Faults::Faults()
{
    // ros2_interface::msg::Header m_header

    // long m_version
    m_version = 0;
    // sequence<ros2_interface::msg::Fault> m_faults


    // Just to register all known types
    registerFaultsTypes();
}

ros2_interface::msg::Faults::~Faults()
{



}

ros2_interface::msg::Faults::Faults(
        const Faults& x)
{
    m_header = x.m_header;
    m_version = x.m_version;
    m_faults = x.m_faults;
}

ros2_interface::msg::Faults::Faults(
        Faults&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_version = x.m_version;
    m_faults = std::move(x.m_faults);
}

ros2_interface::msg::Faults& ros2_interface::msg::Faults::operator =(
        const Faults& x)
{

    m_header = x.m_header;
    m_version = x.m_version;
    m_faults = x.m_faults;

    return *this;
}

ros2_interface::msg::Faults& ros2_interface::msg::Faults::operator =(
        Faults&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_version = x.m_version;
    m_faults = std::move(x.m_faults);

    return *this;
}

bool ros2_interface::msg::Faults::operator ==(
        const Faults& x) const
{

    return (m_header == x.m_header && m_version == x.m_version && m_faults == x.m_faults);
}

bool ros2_interface::msg::Faults::operator !=(
        const Faults& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Faults::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Faults_max_cdr_typesize;
}

size_t ros2_interface::msg::Faults::getCdrSerializedSize(
        const ros2_interface::msg::Faults& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.faults().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Fault::getCdrSerializedSize(data.faults().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Faults::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_version;
    scdr << m_faults;

}

void ros2_interface::msg::Faults::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_version;
    dcdr >> m_faults;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Faults::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Faults::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Faults::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Faults::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member version
 * @param _version New value for member version
 */
void ros2_interface::msg::Faults::version(
        int32_t _version)
{
    m_version = _version;
}

/*!
 * @brief This function returns the value of member version
 * @return Value of member version
 */
int32_t ros2_interface::msg::Faults::version() const
{
    return m_version;
}

/*!
 * @brief This function returns a reference to member version
 * @return Reference to member version
 */
int32_t& ros2_interface::msg::Faults::version()
{
    return m_version;
}

/*!
 * @brief This function copies the value in member faults
 * @param _faults New value to be copied in member faults
 */
void ros2_interface::msg::Faults::faults(
        const std::vector<ros2_interface::msg::Fault>& _faults)
{
    m_faults = _faults;
}

/*!
 * @brief This function moves the value in member faults
 * @param _faults New value to be moved in member faults
 */
void ros2_interface::msg::Faults::faults(
        std::vector<ros2_interface::msg::Fault>&& _faults)
{
    m_faults = std::move(_faults);
}

/*!
 * @brief This function returns a constant reference to member faults
 * @return Constant reference to member faults
 */
const std::vector<ros2_interface::msg::Fault>& ros2_interface::msg::Faults::faults() const
{
    return m_faults;
}

/*!
 * @brief This function returns a reference to member faults
 * @return Reference to member faults
 */
std::vector<ros2_interface::msg::Fault>& ros2_interface::msg::Faults::faults()
{
    return m_faults;
}


size_t ros2_interface::msg::Faults::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Faults_max_key_cdr_typesize;
}

bool ros2_interface::msg::Faults::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Faults::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



