// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file FreeSpace.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "FreeSpace.h"
#include "FreeSpaceTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Polygon2D_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_FreeSpace_max_cdr_typesize 161085ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_FreeSpace_max_key_cdr_typesize 0ULL;

ros2_interface::msg::FreeSpace::FreeSpace()
{
    // ros2_interface::msg::Header m_header

    // long m_sensor_id
    m_sensor_id = 0;
    // sequence<ros2_interface::msg::Polygon2D> m_freespace_region

    // long m_error_code
    m_error_code = 0;
    // boolean m_is_valid
    m_is_valid = false;

    // Just to register all known types
    registerFreeSpaceTypes();
}

ros2_interface::msg::FreeSpace::~FreeSpace()
{





}

ros2_interface::msg::FreeSpace::FreeSpace(
        const FreeSpace& x)
{
    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_freespace_region = x.m_freespace_region;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::FreeSpace::FreeSpace(
        FreeSpace&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_freespace_region = std::move(x.m_freespace_region);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::FreeSpace& ros2_interface::msg::FreeSpace::operator =(
        const FreeSpace& x)
{

    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_freespace_region = x.m_freespace_region;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;

    return *this;
}

ros2_interface::msg::FreeSpace& ros2_interface::msg::FreeSpace::operator =(
        FreeSpace&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_freespace_region = std::move(x.m_freespace_region);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;

    return *this;
}

bool ros2_interface::msg::FreeSpace::operator ==(
        const FreeSpace& x) const
{

    return (m_header == x.m_header && m_sensor_id == x.m_sensor_id && m_freespace_region == x.m_freespace_region && m_error_code == x.m_error_code && m_is_valid == x.m_is_valid);
}

bool ros2_interface::msg::FreeSpace::operator !=(
        const FreeSpace& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::FreeSpace::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_FreeSpace_max_cdr_typesize;
}

size_t ros2_interface::msg::FreeSpace::getCdrSerializedSize(
        const ros2_interface::msg::FreeSpace& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.freespace_region().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Polygon2D::getCdrSerializedSize(data.freespace_region().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::FreeSpace::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_sensor_id;
    scdr << m_freespace_region;
    scdr << m_error_code;
    scdr << m_is_valid;

}

void ros2_interface::msg::FreeSpace::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_sensor_id;
    dcdr >> m_freespace_region;
    dcdr >> m_error_code;
    dcdr >> m_is_valid;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::FreeSpace::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::FreeSpace::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::FreeSpace::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::FreeSpace::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member sensor_id
 * @param _sensor_id New value for member sensor_id
 */
void ros2_interface::msg::FreeSpace::sensor_id(
        int32_t _sensor_id)
{
    m_sensor_id = _sensor_id;
}

/*!
 * @brief This function returns the value of member sensor_id
 * @return Value of member sensor_id
 */
int32_t ros2_interface::msg::FreeSpace::sensor_id() const
{
    return m_sensor_id;
}

/*!
 * @brief This function returns a reference to member sensor_id
 * @return Reference to member sensor_id
 */
int32_t& ros2_interface::msg::FreeSpace::sensor_id()
{
    return m_sensor_id;
}

/*!
 * @brief This function copies the value in member freespace_region
 * @param _freespace_region New value to be copied in member freespace_region
 */
void ros2_interface::msg::FreeSpace::freespace_region(
        const std::vector<ros2_interface::msg::Polygon2D>& _freespace_region)
{
    m_freespace_region = _freespace_region;
}

/*!
 * @brief This function moves the value in member freespace_region
 * @param _freespace_region New value to be moved in member freespace_region
 */
void ros2_interface::msg::FreeSpace::freespace_region(
        std::vector<ros2_interface::msg::Polygon2D>&& _freespace_region)
{
    m_freespace_region = std::move(_freespace_region);
}

/*!
 * @brief This function returns a constant reference to member freespace_region
 * @return Constant reference to member freespace_region
 */
const std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::FreeSpace::freespace_region() const
{
    return m_freespace_region;
}

/*!
 * @brief This function returns a reference to member freespace_region
 * @return Reference to member freespace_region
 */
std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::FreeSpace::freespace_region()
{
    return m_freespace_region;
}
/*!
 * @brief This function sets a value in member error_code
 * @param _error_code New value for member error_code
 */
void ros2_interface::msg::FreeSpace::error_code(
        int32_t _error_code)
{
    m_error_code = _error_code;
}

/*!
 * @brief This function returns the value of member error_code
 * @return Value of member error_code
 */
int32_t ros2_interface::msg::FreeSpace::error_code() const
{
    return m_error_code;
}

/*!
 * @brief This function returns a reference to member error_code
 * @return Reference to member error_code
 */
int32_t& ros2_interface::msg::FreeSpace::error_code()
{
    return m_error_code;
}

/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::FreeSpace::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::FreeSpace::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::FreeSpace::is_valid()
{
    return m_is_valid;
}



size_t ros2_interface::msg::FreeSpace::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_FreeSpace_max_key_cdr_typesize;
}

bool ros2_interface::msg::FreeSpace::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::FreeSpace::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



