// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file FreeSpaceTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "FreeSpace.h"
#include "FreeSpaceTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerFreeSpaceTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(true),
                        ros2_interface::msg::GetPolygon2DObject(true));
                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(false),
                        ros2_interface::msg::GetPolygon2DObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::FreeSpace", ros2_interface::msg::GetFreeSpaceIdentifier(true),
                        ros2_interface::msg::GetFreeSpaceObject(true));
                factory->add_type_object("ros2_interface::msg::FreeSpace", ros2_interface::msg::GetFreeSpaceIdentifier(false),
                        ros2_interface::msg::GetFreeSpaceObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetFreeSpaceIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("FreeSpace", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetFreeSpaceObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("FreeSpace", complete);
        }

        const TypeObject* GetFreeSpaceObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FreeSpace", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteFreeSpaceObject();
            }
            //else
            return GetMinimalFreeSpaceObject();
        }

        const TypeObject* GetMinimalFreeSpaceObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FreeSpace", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_sensor_id;
            mst_sensor_id.common().member_id(memberId++);
            mst_sensor_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sensor_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sensor_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sensor_id.common().member_flags().IS_OPTIONAL(false);
            mst_sensor_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sensor_id.common().member_flags().IS_KEY(false);
            mst_sensor_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sensor_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sensor_id_hash("sensor_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_sensor_id.detail().name_hash()[i] = sensor_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sensor_id);

            MinimalStructMember mst_freespace_region;
            mst_freespace_region.common().member_id(memberId++);
            mst_freespace_region.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_freespace_region.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_freespace_region.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_freespace_region.common().member_flags().IS_OPTIONAL(false);
            mst_freespace_region.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_freespace_region.common().member_flags().IS_KEY(false);
            mst_freespace_region.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_freespace_region.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, false));


            MD5 freespace_region_hash("freespace_region");
            for(int i = 0; i < 4; ++i)
            {
                mst_freespace_region.detail().name_hash()[i] = freespace_region_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_freespace_region);

            MinimalStructMember mst_error_code;
            mst_error_code.common().member_id(memberId++);
            mst_error_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_error_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_error_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_error_code.common().member_flags().IS_OPTIONAL(false);
            mst_error_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_error_code.common().member_flags().IS_KEY(false);
            mst_error_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_error_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 error_code_hash("error_code");
            for(int i = 0; i < 4; ++i)
            {
                mst_error_code.detail().name_hash()[i] = error_code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_error_code);

            MinimalStructMember mst_is_valid;
            mst_is_valid.common().member_id(memberId++);
            mst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_valid.common().member_flags().IS_KEY(false);
            mst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_valid_hash("is_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_valid.detail().name_hash()[i] = is_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_valid);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("FreeSpace", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("FreeSpace", false);
        }

        const TypeObject* GetCompleteFreeSpaceObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FreeSpace", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_sensor_id;
            cst_sensor_id.common().member_id(memberId++);
            cst_sensor_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sensor_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sensor_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sensor_id.common().member_flags().IS_OPTIONAL(false);
            cst_sensor_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sensor_id.common().member_flags().IS_KEY(false);
            cst_sensor_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sensor_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sensor_id.detail().name("sensor_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sensor_id);

            CompleteStructMember cst_freespace_region;
            cst_freespace_region.common().member_id(memberId++);
            cst_freespace_region.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_freespace_region.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_freespace_region.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_freespace_region.common().member_flags().IS_OPTIONAL(false);
            cst_freespace_region.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_freespace_region.common().member_flags().IS_KEY(false);
            cst_freespace_region.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_freespace_region.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, true));


            cst_freespace_region.detail().name("freespace_region");

            type_object->complete().struct_type().member_seq().emplace_back(cst_freespace_region);

            CompleteStructMember cst_error_code;
            cst_error_code.common().member_id(memberId++);
            cst_error_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_error_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_error_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_error_code.common().member_flags().IS_OPTIONAL(false);
            cst_error_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_error_code.common().member_flags().IS_KEY(false);
            cst_error_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_error_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_error_code.detail().name("error_code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_error_code);

            CompleteStructMember cst_is_valid;
            cst_is_valid.common().member_id(memberId++);
            cst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_valid.common().member_flags().IS_KEY(false);
            cst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_valid.detail().name("is_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_valid);


            // Header
            type_object->complete().struct_type().header().detail().type_name("FreeSpace");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("FreeSpace", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("FreeSpace", true);
        }

    } // namespace msg
} // namespace ros2_interface