// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file FrenetFramePoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "FrenetFramePoint.h"
#include "FrenetFramePointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_FrenetFramePoint_max_cdr_typesize 32ULL;
#define ros2_interface_msg_FrenetFramePoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::FrenetFramePoint::FrenetFramePoint()
{
    // double m_s
    m_s = 0.0;
    // double m_l
    m_l = 0.0;
    // double m_dl
    m_dl = 0.0;
    // double m_ddl
    m_ddl = 0.0;

    // Just to register all known types
    registerFrenetFramePointTypes();
}

ros2_interface::msg::FrenetFramePoint::~FrenetFramePoint()
{




}

ros2_interface::msg::FrenetFramePoint::FrenetFramePoint(
        const FrenetFramePoint& x)
{
    m_s = x.m_s;
    m_l = x.m_l;
    m_dl = x.m_dl;
    m_ddl = x.m_ddl;
}

ros2_interface::msg::FrenetFramePoint::FrenetFramePoint(
        FrenetFramePoint&& x) noexcept 
{
    m_s = x.m_s;
    m_l = x.m_l;
    m_dl = x.m_dl;
    m_ddl = x.m_ddl;
}

ros2_interface::msg::FrenetFramePoint& ros2_interface::msg::FrenetFramePoint::operator =(
        const FrenetFramePoint& x)
{

    m_s = x.m_s;
    m_l = x.m_l;
    m_dl = x.m_dl;
    m_ddl = x.m_ddl;

    return *this;
}

ros2_interface::msg::FrenetFramePoint& ros2_interface::msg::FrenetFramePoint::operator =(
        FrenetFramePoint&& x) noexcept
{

    m_s = x.m_s;
    m_l = x.m_l;
    m_dl = x.m_dl;
    m_ddl = x.m_ddl;

    return *this;
}

bool ros2_interface::msg::FrenetFramePoint::operator ==(
        const FrenetFramePoint& x) const
{

    return (m_s == x.m_s && m_l == x.m_l && m_dl == x.m_dl && m_ddl == x.m_ddl);
}

bool ros2_interface::msg::FrenetFramePoint::operator !=(
        const FrenetFramePoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::FrenetFramePoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_FrenetFramePoint_max_cdr_typesize;
}

size_t ros2_interface::msg::FrenetFramePoint::getCdrSerializedSize(
        const ros2_interface::msg::FrenetFramePoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::FrenetFramePoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_s;
    scdr << m_l;
    scdr << m_dl;
    scdr << m_ddl;

}

void ros2_interface::msg::FrenetFramePoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_s;
    dcdr >> m_l;
    dcdr >> m_dl;
    dcdr >> m_ddl;
}

/*!
 * @brief This function sets a value in member s
 * @param _s New value for member s
 */
void ros2_interface::msg::FrenetFramePoint::s(
        double _s)
{
    m_s = _s;
}

/*!
 * @brief This function returns the value of member s
 * @return Value of member s
 */
double ros2_interface::msg::FrenetFramePoint::s() const
{
    return m_s;
}

/*!
 * @brief This function returns a reference to member s
 * @return Reference to member s
 */
double& ros2_interface::msg::FrenetFramePoint::s()
{
    return m_s;
}

/*!
 * @brief This function sets a value in member l
 * @param _l New value for member l
 */
void ros2_interface::msg::FrenetFramePoint::l(
        double _l)
{
    m_l = _l;
}

/*!
 * @brief This function returns the value of member l
 * @return Value of member l
 */
double ros2_interface::msg::FrenetFramePoint::l() const
{
    return m_l;
}

/*!
 * @brief This function returns a reference to member l
 * @return Reference to member l
 */
double& ros2_interface::msg::FrenetFramePoint::l()
{
    return m_l;
}

/*!
 * @brief This function sets a value in member dl
 * @param _dl New value for member dl
 */
void ros2_interface::msg::FrenetFramePoint::dl(
        double _dl)
{
    m_dl = _dl;
}

/*!
 * @brief This function returns the value of member dl
 * @return Value of member dl
 */
double ros2_interface::msg::FrenetFramePoint::dl() const
{
    return m_dl;
}

/*!
 * @brief This function returns a reference to member dl
 * @return Reference to member dl
 */
double& ros2_interface::msg::FrenetFramePoint::dl()
{
    return m_dl;
}

/*!
 * @brief This function sets a value in member ddl
 * @param _ddl New value for member ddl
 */
void ros2_interface::msg::FrenetFramePoint::ddl(
        double _ddl)
{
    m_ddl = _ddl;
}

/*!
 * @brief This function returns the value of member ddl
 * @return Value of member ddl
 */
double ros2_interface::msg::FrenetFramePoint::ddl() const
{
    return m_ddl;
}

/*!
 * @brief This function returns a reference to member ddl
 * @return Reference to member ddl
 */
double& ros2_interface::msg::FrenetFramePoint::ddl()
{
    return m_ddl;
}



size_t ros2_interface::msg::FrenetFramePoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_FrenetFramePoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::FrenetFramePoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::FrenetFramePoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



