// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file FrenetFramePointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "FrenetFramePoint.h"
#include "FrenetFramePointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerFrenetFramePointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::FrenetFramePoint", ros2_interface::msg::GetFrenetFramePointIdentifier(true),
                        ros2_interface::msg::GetFrenetFramePointObject(true));
                factory->add_type_object("ros2_interface::msg::FrenetFramePoint", ros2_interface::msg::GetFrenetFramePointIdentifier(false),
                        ros2_interface::msg::GetFrenetFramePointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetFrenetFramePointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("FrenetFramePoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetFrenetFramePointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("FrenetFramePoint", complete);
        }

        const TypeObject* GetFrenetFramePointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FrenetFramePoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteFrenetFramePointObject();
            }
            //else
            return GetMinimalFrenetFramePointObject();
        }

        const TypeObject* GetMinimalFrenetFramePointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FrenetFramePoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_s;
            mst_s.common().member_id(memberId++);
            mst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_s.common().member_flags().IS_OPTIONAL(false);
            mst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_s.common().member_flags().IS_KEY(false);
            mst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 s_hash("s");
            for(int i = 0; i < 4; ++i)
            {
                mst_s.detail().name_hash()[i] = s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_s);

            MinimalStructMember mst_l;
            mst_l.common().member_id(memberId++);
            mst_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_l.common().member_flags().IS_OPTIONAL(false);
            mst_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_l.common().member_flags().IS_KEY(false);
            mst_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 l_hash("l");
            for(int i = 0; i < 4; ++i)
            {
                mst_l.detail().name_hash()[i] = l_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_l);

            MinimalStructMember mst_dl;
            mst_dl.common().member_id(memberId++);
            mst_dl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_dl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_dl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_dl.common().member_flags().IS_OPTIONAL(false);
            mst_dl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_dl.common().member_flags().IS_KEY(false);
            mst_dl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_dl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 dl_hash("dl");
            for(int i = 0; i < 4; ++i)
            {
                mst_dl.detail().name_hash()[i] = dl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_dl);

            MinimalStructMember mst_ddl;
            mst_ddl.common().member_id(memberId++);
            mst_ddl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ddl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ddl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ddl.common().member_flags().IS_OPTIONAL(false);
            mst_ddl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ddl.common().member_flags().IS_KEY(false);
            mst_ddl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ddl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ddl_hash("ddl");
            for(int i = 0; i < 4; ++i)
            {
                mst_ddl.detail().name_hash()[i] = ddl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ddl);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("FrenetFramePoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("FrenetFramePoint", false);
        }

        const TypeObject* GetCompleteFrenetFramePointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("FrenetFramePoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_s;
            cst_s.common().member_id(memberId++);
            cst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_s.common().member_flags().IS_OPTIONAL(false);
            cst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_s.common().member_flags().IS_KEY(false);
            cst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_s.detail().name("s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_s);

            CompleteStructMember cst_l;
            cst_l.common().member_id(memberId++);
            cst_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_l.common().member_flags().IS_OPTIONAL(false);
            cst_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_l.common().member_flags().IS_KEY(false);
            cst_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_l.detail().name("l");

            type_object->complete().struct_type().member_seq().emplace_back(cst_l);

            CompleteStructMember cst_dl;
            cst_dl.common().member_id(memberId++);
            cst_dl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_dl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_dl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_dl.common().member_flags().IS_OPTIONAL(false);
            cst_dl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_dl.common().member_flags().IS_KEY(false);
            cst_dl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_dl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_dl.detail().name("dl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_dl);

            CompleteStructMember cst_ddl;
            cst_ddl.common().member_id(memberId++);
            cst_ddl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ddl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ddl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ddl.common().member_flags().IS_OPTIONAL(false);
            cst_ddl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ddl.common().member_flags().IS_KEY(false);
            cst_ddl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ddl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ddl.detail().name("ddl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ddl);


            // Header
            type_object->complete().struct_type().header().detail().type_name("FrenetFramePoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("FrenetFramePoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("FrenetFramePoint", true);
        }

    } // namespace msg
} // namespace ros2_interface