// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GaussianInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "GaussianInfo.h"
#include "GaussianInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_GaussianInfo_max_cdr_typesize 56ULL;
#define ros2_interface_msg_GaussianInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::GaussianInfo::GaussianInfo()
{
    // double m_sigma_x
    m_sigma_x = 0.0;
    // double m_sigma_y
    m_sigma_y = 0.0;
    // double m_correlation
    m_correlation = 0.0;
    // double m_area_probability
    m_area_probability = 0.0;
    // double m_ellipse_a
    m_ellipse_a = 0.0;
    // double m_ellipse_b
    m_ellipse_b = 0.0;
    // double m_theta_a
    m_theta_a = 0.0;

    // Just to register all known types
    registerGaussianInfoTypes();
}

ros2_interface::msg::GaussianInfo::~GaussianInfo()
{







}

ros2_interface::msg::GaussianInfo::GaussianInfo(
        const GaussianInfo& x)
{
    m_sigma_x = x.m_sigma_x;
    m_sigma_y = x.m_sigma_y;
    m_correlation = x.m_correlation;
    m_area_probability = x.m_area_probability;
    m_ellipse_a = x.m_ellipse_a;
    m_ellipse_b = x.m_ellipse_b;
    m_theta_a = x.m_theta_a;
}

ros2_interface::msg::GaussianInfo::GaussianInfo(
        GaussianInfo&& x) noexcept 
{
    m_sigma_x = x.m_sigma_x;
    m_sigma_y = x.m_sigma_y;
    m_correlation = x.m_correlation;
    m_area_probability = x.m_area_probability;
    m_ellipse_a = x.m_ellipse_a;
    m_ellipse_b = x.m_ellipse_b;
    m_theta_a = x.m_theta_a;
}

ros2_interface::msg::GaussianInfo& ros2_interface::msg::GaussianInfo::operator =(
        const GaussianInfo& x)
{

    m_sigma_x = x.m_sigma_x;
    m_sigma_y = x.m_sigma_y;
    m_correlation = x.m_correlation;
    m_area_probability = x.m_area_probability;
    m_ellipse_a = x.m_ellipse_a;
    m_ellipse_b = x.m_ellipse_b;
    m_theta_a = x.m_theta_a;

    return *this;
}

ros2_interface::msg::GaussianInfo& ros2_interface::msg::GaussianInfo::operator =(
        GaussianInfo&& x) noexcept
{

    m_sigma_x = x.m_sigma_x;
    m_sigma_y = x.m_sigma_y;
    m_correlation = x.m_correlation;
    m_area_probability = x.m_area_probability;
    m_ellipse_a = x.m_ellipse_a;
    m_ellipse_b = x.m_ellipse_b;
    m_theta_a = x.m_theta_a;

    return *this;
}

bool ros2_interface::msg::GaussianInfo::operator ==(
        const GaussianInfo& x) const
{

    return (m_sigma_x == x.m_sigma_x && m_sigma_y == x.m_sigma_y && m_correlation == x.m_correlation && m_area_probability == x.m_area_probability && m_ellipse_a == x.m_ellipse_a && m_ellipse_b == x.m_ellipse_b && m_theta_a == x.m_theta_a);
}

bool ros2_interface::msg::GaussianInfo::operator !=(
        const GaussianInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::GaussianInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_GaussianInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::GaussianInfo::getCdrSerializedSize(
        const ros2_interface::msg::GaussianInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::GaussianInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_sigma_x;
    scdr << m_sigma_y;
    scdr << m_correlation;
    scdr << m_area_probability;
    scdr << m_ellipse_a;
    scdr << m_ellipse_b;
    scdr << m_theta_a;

}

void ros2_interface::msg::GaussianInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_sigma_x;
    dcdr >> m_sigma_y;
    dcdr >> m_correlation;
    dcdr >> m_area_probability;
    dcdr >> m_ellipse_a;
    dcdr >> m_ellipse_b;
    dcdr >> m_theta_a;
}

/*!
 * @brief This function sets a value in member sigma_x
 * @param _sigma_x New value for member sigma_x
 */
void ros2_interface::msg::GaussianInfo::sigma_x(
        double _sigma_x)
{
    m_sigma_x = _sigma_x;
}

/*!
 * @brief This function returns the value of member sigma_x
 * @return Value of member sigma_x
 */
double ros2_interface::msg::GaussianInfo::sigma_x() const
{
    return m_sigma_x;
}

/*!
 * @brief This function returns a reference to member sigma_x
 * @return Reference to member sigma_x
 */
double& ros2_interface::msg::GaussianInfo::sigma_x()
{
    return m_sigma_x;
}

/*!
 * @brief This function sets a value in member sigma_y
 * @param _sigma_y New value for member sigma_y
 */
void ros2_interface::msg::GaussianInfo::sigma_y(
        double _sigma_y)
{
    m_sigma_y = _sigma_y;
}

/*!
 * @brief This function returns the value of member sigma_y
 * @return Value of member sigma_y
 */
double ros2_interface::msg::GaussianInfo::sigma_y() const
{
    return m_sigma_y;
}

/*!
 * @brief This function returns a reference to member sigma_y
 * @return Reference to member sigma_y
 */
double& ros2_interface::msg::GaussianInfo::sigma_y()
{
    return m_sigma_y;
}

/*!
 * @brief This function sets a value in member correlation
 * @param _correlation New value for member correlation
 */
void ros2_interface::msg::GaussianInfo::correlation(
        double _correlation)
{
    m_correlation = _correlation;
}

/*!
 * @brief This function returns the value of member correlation
 * @return Value of member correlation
 */
double ros2_interface::msg::GaussianInfo::correlation() const
{
    return m_correlation;
}

/*!
 * @brief This function returns a reference to member correlation
 * @return Reference to member correlation
 */
double& ros2_interface::msg::GaussianInfo::correlation()
{
    return m_correlation;
}

/*!
 * @brief This function sets a value in member area_probability
 * @param _area_probability New value for member area_probability
 */
void ros2_interface::msg::GaussianInfo::area_probability(
        double _area_probability)
{
    m_area_probability = _area_probability;
}

/*!
 * @brief This function returns the value of member area_probability
 * @return Value of member area_probability
 */
double ros2_interface::msg::GaussianInfo::area_probability() const
{
    return m_area_probability;
}

/*!
 * @brief This function returns a reference to member area_probability
 * @return Reference to member area_probability
 */
double& ros2_interface::msg::GaussianInfo::area_probability()
{
    return m_area_probability;
}

/*!
 * @brief This function sets a value in member ellipse_a
 * @param _ellipse_a New value for member ellipse_a
 */
void ros2_interface::msg::GaussianInfo::ellipse_a(
        double _ellipse_a)
{
    m_ellipse_a = _ellipse_a;
}

/*!
 * @brief This function returns the value of member ellipse_a
 * @return Value of member ellipse_a
 */
double ros2_interface::msg::GaussianInfo::ellipse_a() const
{
    return m_ellipse_a;
}

/*!
 * @brief This function returns a reference to member ellipse_a
 * @return Reference to member ellipse_a
 */
double& ros2_interface::msg::GaussianInfo::ellipse_a()
{
    return m_ellipse_a;
}

/*!
 * @brief This function sets a value in member ellipse_b
 * @param _ellipse_b New value for member ellipse_b
 */
void ros2_interface::msg::GaussianInfo::ellipse_b(
        double _ellipse_b)
{
    m_ellipse_b = _ellipse_b;
}

/*!
 * @brief This function returns the value of member ellipse_b
 * @return Value of member ellipse_b
 */
double ros2_interface::msg::GaussianInfo::ellipse_b() const
{
    return m_ellipse_b;
}

/*!
 * @brief This function returns a reference to member ellipse_b
 * @return Reference to member ellipse_b
 */
double& ros2_interface::msg::GaussianInfo::ellipse_b()
{
    return m_ellipse_b;
}

/*!
 * @brief This function sets a value in member theta_a
 * @param _theta_a New value for member theta_a
 */
void ros2_interface::msg::GaussianInfo::theta_a(
        double _theta_a)
{
    m_theta_a = _theta_a;
}

/*!
 * @brief This function returns the value of member theta_a
 * @return Value of member theta_a
 */
double ros2_interface::msg::GaussianInfo::theta_a() const
{
    return m_theta_a;
}

/*!
 * @brief This function returns a reference to member theta_a
 * @return Reference to member theta_a
 */
double& ros2_interface::msg::GaussianInfo::theta_a()
{
    return m_theta_a;
}



size_t ros2_interface::msg::GaussianInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_GaussianInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::GaussianInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::GaussianInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



