// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GaussianInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GAUSSIANINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GAUSSIANINFO_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(GAUSSIANINFO_SOURCE)
#define GAUSSIANINFO_DllAPI __declspec( dllexport )
#else
#define GAUSSIANINFO_DllAPI __declspec( dllimport )
#endif // GAUSSIANINFO_SOURCE
#else
#define GAUSSIANINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define GAUSSIANINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure GaussianInfo defined by the user in the IDL file.
         * @ingroup GaussianInfo
         */
        class GaussianInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport GaussianInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~GaussianInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::GaussianInfo that will be copied.
             */
            eProsima_user_DllExport GaussianInfo(
                    const GaussianInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::GaussianInfo that will be copied.
             */
            eProsima_user_DllExport GaussianInfo(
                    GaussianInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::GaussianInfo that will be copied.
             */
            eProsima_user_DllExport GaussianInfo& operator =(
                    const GaussianInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::GaussianInfo that will be copied.
             */
            eProsima_user_DllExport GaussianInfo& operator =(
                    GaussianInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::GaussianInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const GaussianInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::GaussianInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const GaussianInfo& x) const;

            /*!
             * @brief This function sets a value in member sigma_x
             * @param _sigma_x New value for member sigma_x
             */
            eProsima_user_DllExport void sigma_x(
                    double _sigma_x);

            /*!
             * @brief This function returns the value of member sigma_x
             * @return Value of member sigma_x
             */
            eProsima_user_DllExport double sigma_x() const;

            /*!
             * @brief This function returns a reference to member sigma_x
             * @return Reference to member sigma_x
             */
            eProsima_user_DllExport double& sigma_x();

            /*!
             * @brief This function sets a value in member sigma_y
             * @param _sigma_y New value for member sigma_y
             */
            eProsima_user_DllExport void sigma_y(
                    double _sigma_y);

            /*!
             * @brief This function returns the value of member sigma_y
             * @return Value of member sigma_y
             */
            eProsima_user_DllExport double sigma_y() const;

            /*!
             * @brief This function returns a reference to member sigma_y
             * @return Reference to member sigma_y
             */
            eProsima_user_DllExport double& sigma_y();

            /*!
             * @brief This function sets a value in member correlation
             * @param _correlation New value for member correlation
             */
            eProsima_user_DllExport void correlation(
                    double _correlation);

            /*!
             * @brief This function returns the value of member correlation
             * @return Value of member correlation
             */
            eProsima_user_DllExport double correlation() const;

            /*!
             * @brief This function returns a reference to member correlation
             * @return Reference to member correlation
             */
            eProsima_user_DllExport double& correlation();

            /*!
             * @brief This function sets a value in member area_probability
             * @param _area_probability New value for member area_probability
             */
            eProsima_user_DllExport void area_probability(
                    double _area_probability);

            /*!
             * @brief This function returns the value of member area_probability
             * @return Value of member area_probability
             */
            eProsima_user_DllExport double area_probability() const;

            /*!
             * @brief This function returns a reference to member area_probability
             * @return Reference to member area_probability
             */
            eProsima_user_DllExport double& area_probability();

            /*!
             * @brief This function sets a value in member ellipse_a
             * @param _ellipse_a New value for member ellipse_a
             */
            eProsima_user_DllExport void ellipse_a(
                    double _ellipse_a);

            /*!
             * @brief This function returns the value of member ellipse_a
             * @return Value of member ellipse_a
             */
            eProsima_user_DllExport double ellipse_a() const;

            /*!
             * @brief This function returns a reference to member ellipse_a
             * @return Reference to member ellipse_a
             */
            eProsima_user_DllExport double& ellipse_a();

            /*!
             * @brief This function sets a value in member ellipse_b
             * @param _ellipse_b New value for member ellipse_b
             */
            eProsima_user_DllExport void ellipse_b(
                    double _ellipse_b);

            /*!
             * @brief This function returns the value of member ellipse_b
             * @return Value of member ellipse_b
             */
            eProsima_user_DllExport double ellipse_b() const;

            /*!
             * @brief This function returns a reference to member ellipse_b
             * @return Reference to member ellipse_b
             */
            eProsima_user_DllExport double& ellipse_b();

            /*!
             * @brief This function sets a value in member theta_a
             * @param _theta_a New value for member theta_a
             */
            eProsima_user_DllExport void theta_a(
                    double _theta_a);

            /*!
             * @brief This function returns the value of member theta_a
             * @return Value of member theta_a
             */
            eProsima_user_DllExport double theta_a() const;

            /*!
             * @brief This function returns a reference to member theta_a
             * @return Reference to member theta_a
             */
            eProsima_user_DllExport double& theta_a();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::GaussianInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_sigma_x;
            double m_sigma_y;
            double m_correlation;
            double m_area_probability;
            double m_ellipse_a;
            double m_ellipse_b;
            double m_theta_a;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GAUSSIANINFO_H_

