// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GaussianInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "GaussianInfo.h"
#include "GaussianInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerGaussianInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::GaussianInfo", ros2_interface::msg::GetGaussianInfoIdentifier(true),
                        ros2_interface::msg::GetGaussianInfoObject(true));
                factory->add_type_object("ros2_interface::msg::GaussianInfo", ros2_interface::msg::GetGaussianInfoIdentifier(false),
                        ros2_interface::msg::GetGaussianInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetGaussianInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("GaussianInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetGaussianInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("GaussianInfo", complete);
        }

        const TypeObject* GetGaussianInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GaussianInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteGaussianInfoObject();
            }
            //else
            return GetMinimalGaussianInfoObject();
        }

        const TypeObject* GetMinimalGaussianInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GaussianInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_sigma_x;
            mst_sigma_x.common().member_id(memberId++);
            mst_sigma_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sigma_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sigma_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sigma_x.common().member_flags().IS_OPTIONAL(false);
            mst_sigma_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sigma_x.common().member_flags().IS_KEY(false);
            mst_sigma_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sigma_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 sigma_x_hash("sigma_x");
            for(int i = 0; i < 4; ++i)
            {
                mst_sigma_x.detail().name_hash()[i] = sigma_x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sigma_x);

            MinimalStructMember mst_sigma_y;
            mst_sigma_y.common().member_id(memberId++);
            mst_sigma_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sigma_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sigma_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sigma_y.common().member_flags().IS_OPTIONAL(false);
            mst_sigma_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sigma_y.common().member_flags().IS_KEY(false);
            mst_sigma_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sigma_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 sigma_y_hash("sigma_y");
            for(int i = 0; i < 4; ++i)
            {
                mst_sigma_y.detail().name_hash()[i] = sigma_y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sigma_y);

            MinimalStructMember mst_correlation;
            mst_correlation.common().member_id(memberId++);
            mst_correlation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_correlation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_correlation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_correlation.common().member_flags().IS_OPTIONAL(false);
            mst_correlation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_correlation.common().member_flags().IS_KEY(false);
            mst_correlation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_correlation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 correlation_hash("correlation");
            for(int i = 0; i < 4; ++i)
            {
                mst_correlation.detail().name_hash()[i] = correlation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_correlation);

            MinimalStructMember mst_area_probability;
            mst_area_probability.common().member_id(memberId++);
            mst_area_probability.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_area_probability.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_area_probability.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_area_probability.common().member_flags().IS_OPTIONAL(false);
            mst_area_probability.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_area_probability.common().member_flags().IS_KEY(false);
            mst_area_probability.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_area_probability.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 area_probability_hash("area_probability");
            for(int i = 0; i < 4; ++i)
            {
                mst_area_probability.detail().name_hash()[i] = area_probability_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_area_probability);

            MinimalStructMember mst_ellipse_a;
            mst_ellipse_a.common().member_id(memberId++);
            mst_ellipse_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ellipse_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ellipse_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ellipse_a.common().member_flags().IS_OPTIONAL(false);
            mst_ellipse_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ellipse_a.common().member_flags().IS_KEY(false);
            mst_ellipse_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ellipse_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ellipse_a_hash("ellipse_a");
            for(int i = 0; i < 4; ++i)
            {
                mst_ellipse_a.detail().name_hash()[i] = ellipse_a_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ellipse_a);

            MinimalStructMember mst_ellipse_b;
            mst_ellipse_b.common().member_id(memberId++);
            mst_ellipse_b.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ellipse_b.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ellipse_b.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ellipse_b.common().member_flags().IS_OPTIONAL(false);
            mst_ellipse_b.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ellipse_b.common().member_flags().IS_KEY(false);
            mst_ellipse_b.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ellipse_b.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ellipse_b_hash("ellipse_b");
            for(int i = 0; i < 4; ++i)
            {
                mst_ellipse_b.detail().name_hash()[i] = ellipse_b_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ellipse_b);

            MinimalStructMember mst_theta_a;
            mst_theta_a.common().member_id(memberId++);
            mst_theta_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_a.common().member_flags().IS_OPTIONAL(false);
            mst_theta_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_a.common().member_flags().IS_KEY(false);
            mst_theta_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_a_hash("theta_a");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_a.detail().name_hash()[i] = theta_a_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_a);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("GaussianInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("GaussianInfo", false);
        }

        const TypeObject* GetCompleteGaussianInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GaussianInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_sigma_x;
            cst_sigma_x.common().member_id(memberId++);
            cst_sigma_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sigma_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sigma_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sigma_x.common().member_flags().IS_OPTIONAL(false);
            cst_sigma_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sigma_x.common().member_flags().IS_KEY(false);
            cst_sigma_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sigma_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_sigma_x.detail().name("sigma_x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sigma_x);

            CompleteStructMember cst_sigma_y;
            cst_sigma_y.common().member_id(memberId++);
            cst_sigma_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sigma_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sigma_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sigma_y.common().member_flags().IS_OPTIONAL(false);
            cst_sigma_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sigma_y.common().member_flags().IS_KEY(false);
            cst_sigma_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sigma_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_sigma_y.detail().name("sigma_y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sigma_y);

            CompleteStructMember cst_correlation;
            cst_correlation.common().member_id(memberId++);
            cst_correlation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_correlation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_correlation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_correlation.common().member_flags().IS_OPTIONAL(false);
            cst_correlation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_correlation.common().member_flags().IS_KEY(false);
            cst_correlation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_correlation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_correlation.detail().name("correlation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_correlation);

            CompleteStructMember cst_area_probability;
            cst_area_probability.common().member_id(memberId++);
            cst_area_probability.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_area_probability.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_area_probability.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_area_probability.common().member_flags().IS_OPTIONAL(false);
            cst_area_probability.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_area_probability.common().member_flags().IS_KEY(false);
            cst_area_probability.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_area_probability.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_area_probability.detail().name("area_probability");

            type_object->complete().struct_type().member_seq().emplace_back(cst_area_probability);

            CompleteStructMember cst_ellipse_a;
            cst_ellipse_a.common().member_id(memberId++);
            cst_ellipse_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ellipse_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ellipse_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ellipse_a.common().member_flags().IS_OPTIONAL(false);
            cst_ellipse_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ellipse_a.common().member_flags().IS_KEY(false);
            cst_ellipse_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ellipse_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ellipse_a.detail().name("ellipse_a");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ellipse_a);

            CompleteStructMember cst_ellipse_b;
            cst_ellipse_b.common().member_id(memberId++);
            cst_ellipse_b.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ellipse_b.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ellipse_b.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ellipse_b.common().member_flags().IS_OPTIONAL(false);
            cst_ellipse_b.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ellipse_b.common().member_flags().IS_KEY(false);
            cst_ellipse_b.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ellipse_b.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ellipse_b.detail().name("ellipse_b");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ellipse_b);

            CompleteStructMember cst_theta_a;
            cst_theta_a.common().member_id(memberId++);
            cst_theta_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_a.common().member_flags().IS_OPTIONAL(false);
            cst_theta_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_a.common().member_flags().IS_KEY(false);
            cst_theta_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_a.detail().name("theta_a");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_a);


            // Header
            type_object->complete().struct_type().header().detail().type_name("GaussianInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("GaussianInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("GaussianInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface