// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GlobalRouteMsg.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "GlobalRouteMsg.h"
#include "GlobalRouteMsgTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_LaneletInfo_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_GlobalRouteMsg_max_cdr_typesize 3504ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LaneletInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_GlobalRouteMsg_max_key_cdr_typesize 0ULL;

ros2_interface::msg::GlobalRouteMsg::GlobalRouteMsg()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::LaneletInfo> m_route

    // ros2_interface::msg::LaneletInfo m_current_lanelet

    // double m_total_mileage
    m_total_mileage = 0.0;
    // double m_cur_mileage
    m_cur_mileage = 0.0;
    // sequence<ros2_interface::msg::LaneletInfo> m_cur_slice


    // Just to register all known types
    registerGlobalRouteMsgTypes();
}

ros2_interface::msg::GlobalRouteMsg::~GlobalRouteMsg()
{






}

ros2_interface::msg::GlobalRouteMsg::GlobalRouteMsg(
        const GlobalRouteMsg& x)
{
    m_header = x.m_header;
    m_route = x.m_route;
    m_current_lanelet = x.m_current_lanelet;
    m_total_mileage = x.m_total_mileage;
    m_cur_mileage = x.m_cur_mileage;
    m_cur_slice = x.m_cur_slice;
}

ros2_interface::msg::GlobalRouteMsg::GlobalRouteMsg(
        GlobalRouteMsg&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_route = std::move(x.m_route);
    m_current_lanelet = std::move(x.m_current_lanelet);
    m_total_mileage = x.m_total_mileage;
    m_cur_mileage = x.m_cur_mileage;
    m_cur_slice = std::move(x.m_cur_slice);
}

ros2_interface::msg::GlobalRouteMsg& ros2_interface::msg::GlobalRouteMsg::operator =(
        const GlobalRouteMsg& x)
{

    m_header = x.m_header;
    m_route = x.m_route;
    m_current_lanelet = x.m_current_lanelet;
    m_total_mileage = x.m_total_mileage;
    m_cur_mileage = x.m_cur_mileage;
    m_cur_slice = x.m_cur_slice;

    return *this;
}

ros2_interface::msg::GlobalRouteMsg& ros2_interface::msg::GlobalRouteMsg::operator =(
        GlobalRouteMsg&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_route = std::move(x.m_route);
    m_current_lanelet = std::move(x.m_current_lanelet);
    m_total_mileage = x.m_total_mileage;
    m_cur_mileage = x.m_cur_mileage;
    m_cur_slice = std::move(x.m_cur_slice);

    return *this;
}

bool ros2_interface::msg::GlobalRouteMsg::operator ==(
        const GlobalRouteMsg& x) const
{

    return (m_header == x.m_header && m_route == x.m_route && m_current_lanelet == x.m_current_lanelet && m_total_mileage == x.m_total_mileage && m_cur_mileage == x.m_cur_mileage && m_cur_slice == x.m_cur_slice);
}

bool ros2_interface::msg::GlobalRouteMsg::operator !=(
        const GlobalRouteMsg& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::GlobalRouteMsg::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_GlobalRouteMsg_max_cdr_typesize;
}

size_t ros2_interface::msg::GlobalRouteMsg::getCdrSerializedSize(
        const ros2_interface::msg::GlobalRouteMsg& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.route().size(); ++a)
    {
        current_alignment += ros2_interface::msg::LaneletInfo::getCdrSerializedSize(data.route().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::LaneletInfo::getCdrSerializedSize(data.current_lanelet(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.cur_slice().size(); ++a)
    {
        current_alignment += ros2_interface::msg::LaneletInfo::getCdrSerializedSize(data.cur_slice().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::GlobalRouteMsg::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_route;
    scdr << m_current_lanelet;
    scdr << m_total_mileage;
    scdr << m_cur_mileage;
    scdr << m_cur_slice;

}

void ros2_interface::msg::GlobalRouteMsg::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_route;
    dcdr >> m_current_lanelet;
    dcdr >> m_total_mileage;
    dcdr >> m_cur_mileage;
    dcdr >> m_cur_slice;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::GlobalRouteMsg::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::GlobalRouteMsg::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::GlobalRouteMsg::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::GlobalRouteMsg::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member route
 * @param _route New value to be copied in member route
 */
void ros2_interface::msg::GlobalRouteMsg::route(
        const std::vector<ros2_interface::msg::LaneletInfo>& _route)
{
    m_route = _route;
}

/*!
 * @brief This function moves the value in member route
 * @param _route New value to be moved in member route
 */
void ros2_interface::msg::GlobalRouteMsg::route(
        std::vector<ros2_interface::msg::LaneletInfo>&& _route)
{
    m_route = std::move(_route);
}

/*!
 * @brief This function returns a constant reference to member route
 * @return Constant reference to member route
 */
const std::vector<ros2_interface::msg::LaneletInfo>& ros2_interface::msg::GlobalRouteMsg::route() const
{
    return m_route;
}

/*!
 * @brief This function returns a reference to member route
 * @return Reference to member route
 */
std::vector<ros2_interface::msg::LaneletInfo>& ros2_interface::msg::GlobalRouteMsg::route()
{
    return m_route;
}
/*!
 * @brief This function copies the value in member current_lanelet
 * @param _current_lanelet New value to be copied in member current_lanelet
 */
void ros2_interface::msg::GlobalRouteMsg::current_lanelet(
        const ros2_interface::msg::LaneletInfo& _current_lanelet)
{
    m_current_lanelet = _current_lanelet;
}

/*!
 * @brief This function moves the value in member current_lanelet
 * @param _current_lanelet New value to be moved in member current_lanelet
 */
void ros2_interface::msg::GlobalRouteMsg::current_lanelet(
        ros2_interface::msg::LaneletInfo&& _current_lanelet)
{
    m_current_lanelet = std::move(_current_lanelet);
}

/*!
 * @brief This function returns a constant reference to member current_lanelet
 * @return Constant reference to member current_lanelet
 */
const ros2_interface::msg::LaneletInfo& ros2_interface::msg::GlobalRouteMsg::current_lanelet() const
{
    return m_current_lanelet;
}

/*!
 * @brief This function returns a reference to member current_lanelet
 * @return Reference to member current_lanelet
 */
ros2_interface::msg::LaneletInfo& ros2_interface::msg::GlobalRouteMsg::current_lanelet()
{
    return m_current_lanelet;
}
/*!
 * @brief This function sets a value in member total_mileage
 * @param _total_mileage New value for member total_mileage
 */
void ros2_interface::msg::GlobalRouteMsg::total_mileage(
        double _total_mileage)
{
    m_total_mileage = _total_mileage;
}

/*!
 * @brief This function returns the value of member total_mileage
 * @return Value of member total_mileage
 */
double ros2_interface::msg::GlobalRouteMsg::total_mileage() const
{
    return m_total_mileage;
}

/*!
 * @brief This function returns a reference to member total_mileage
 * @return Reference to member total_mileage
 */
double& ros2_interface::msg::GlobalRouteMsg::total_mileage()
{
    return m_total_mileage;
}

/*!
 * @brief This function sets a value in member cur_mileage
 * @param _cur_mileage New value for member cur_mileage
 */
void ros2_interface::msg::GlobalRouteMsg::cur_mileage(
        double _cur_mileage)
{
    m_cur_mileage = _cur_mileage;
}

/*!
 * @brief This function returns the value of member cur_mileage
 * @return Value of member cur_mileage
 */
double ros2_interface::msg::GlobalRouteMsg::cur_mileage() const
{
    return m_cur_mileage;
}

/*!
 * @brief This function returns a reference to member cur_mileage
 * @return Reference to member cur_mileage
 */
double& ros2_interface::msg::GlobalRouteMsg::cur_mileage()
{
    return m_cur_mileage;
}

/*!
 * @brief This function copies the value in member cur_slice
 * @param _cur_slice New value to be copied in member cur_slice
 */
void ros2_interface::msg::GlobalRouteMsg::cur_slice(
        const std::vector<ros2_interface::msg::LaneletInfo>& _cur_slice)
{
    m_cur_slice = _cur_slice;
}

/*!
 * @brief This function moves the value in member cur_slice
 * @param _cur_slice New value to be moved in member cur_slice
 */
void ros2_interface::msg::GlobalRouteMsg::cur_slice(
        std::vector<ros2_interface::msg::LaneletInfo>&& _cur_slice)
{
    m_cur_slice = std::move(_cur_slice);
}

/*!
 * @brief This function returns a constant reference to member cur_slice
 * @return Constant reference to member cur_slice
 */
const std::vector<ros2_interface::msg::LaneletInfo>& ros2_interface::msg::GlobalRouteMsg::cur_slice() const
{
    return m_cur_slice;
}

/*!
 * @brief This function returns a reference to member cur_slice
 * @return Reference to member cur_slice
 */
std::vector<ros2_interface::msg::LaneletInfo>& ros2_interface::msg::GlobalRouteMsg::cur_slice()
{
    return m_cur_slice;
}


size_t ros2_interface::msg::GlobalRouteMsg::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_GlobalRouteMsg_max_key_cdr_typesize;
}

bool ros2_interface::msg::GlobalRouteMsg::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::GlobalRouteMsg::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



