// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GlobalRouteMsg.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GLOBALROUTEMSG_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GLOBALROUTEMSG_H_

#include "Header.h"
#include "LaneletInfo.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(GLOBALROUTEMSG_SOURCE)
#define GLOBALROUTEMSG_DllAPI __declspec( dllexport )
#else
#define GLOBALROUTEMSG_DllAPI __declspec( dllimport )
#endif // GLOBALROUTEMSG_SOURCE
#else
#define GLOBALROUTEMSG_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define GLOBALROUTEMSG_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure GlobalRouteMsg defined by the user in the IDL file.
         * @ingroup GlobalRouteMsg
         */
        class GlobalRouteMsg
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport GlobalRouteMsg();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~GlobalRouteMsg();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::GlobalRouteMsg that will be copied.
             */
            eProsima_user_DllExport GlobalRouteMsg(
                    const GlobalRouteMsg& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::GlobalRouteMsg that will be copied.
             */
            eProsima_user_DllExport GlobalRouteMsg(
                    GlobalRouteMsg&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::GlobalRouteMsg that will be copied.
             */
            eProsima_user_DllExport GlobalRouteMsg& operator =(
                    const GlobalRouteMsg& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::GlobalRouteMsg that will be copied.
             */
            eProsima_user_DllExport GlobalRouteMsg& operator =(
                    GlobalRouteMsg&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::GlobalRouteMsg object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const GlobalRouteMsg& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::GlobalRouteMsg object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const GlobalRouteMsg& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member route
             * @param _route New value to be copied in member route
             */
            eProsima_user_DllExport void route(
                    const std::vector<ros2_interface::msg::LaneletInfo>& _route);

            /*!
             * @brief This function moves the value in member route
             * @param _route New value to be moved in member route
             */
            eProsima_user_DllExport void route(
                    std::vector<ros2_interface::msg::LaneletInfo>&& _route);

            /*!
             * @brief This function returns a constant reference to member route
             * @return Constant reference to member route
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::LaneletInfo>& route() const;

            /*!
             * @brief This function returns a reference to member route
             * @return Reference to member route
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::LaneletInfo>& route();
            /*!
             * @brief This function copies the value in member current_lanelet
             * @param _current_lanelet New value to be copied in member current_lanelet
             */
            eProsima_user_DllExport void current_lanelet(
                    const ros2_interface::msg::LaneletInfo& _current_lanelet);

            /*!
             * @brief This function moves the value in member current_lanelet
             * @param _current_lanelet New value to be moved in member current_lanelet
             */
            eProsima_user_DllExport void current_lanelet(
                    ros2_interface::msg::LaneletInfo&& _current_lanelet);

            /*!
             * @brief This function returns a constant reference to member current_lanelet
             * @return Constant reference to member current_lanelet
             */
            eProsima_user_DllExport const ros2_interface::msg::LaneletInfo& current_lanelet() const;

            /*!
             * @brief This function returns a reference to member current_lanelet
             * @return Reference to member current_lanelet
             */
            eProsima_user_DllExport ros2_interface::msg::LaneletInfo& current_lanelet();
            /*!
             * @brief This function sets a value in member total_mileage
             * @param _total_mileage New value for member total_mileage
             */
            eProsima_user_DllExport void total_mileage(
                    double _total_mileage);

            /*!
             * @brief This function returns the value of member total_mileage
             * @return Value of member total_mileage
             */
            eProsima_user_DllExport double total_mileage() const;

            /*!
             * @brief This function returns a reference to member total_mileage
             * @return Reference to member total_mileage
             */
            eProsima_user_DllExport double& total_mileage();

            /*!
             * @brief This function sets a value in member cur_mileage
             * @param _cur_mileage New value for member cur_mileage
             */
            eProsima_user_DllExport void cur_mileage(
                    double _cur_mileage);

            /*!
             * @brief This function returns the value of member cur_mileage
             * @return Value of member cur_mileage
             */
            eProsima_user_DllExport double cur_mileage() const;

            /*!
             * @brief This function returns a reference to member cur_mileage
             * @return Reference to member cur_mileage
             */
            eProsima_user_DllExport double& cur_mileage();

            /*!
             * @brief This function copies the value in member cur_slice
             * @param _cur_slice New value to be copied in member cur_slice
             */
            eProsima_user_DllExport void cur_slice(
                    const std::vector<ros2_interface::msg::LaneletInfo>& _cur_slice);

            /*!
             * @brief This function moves the value in member cur_slice
             * @param _cur_slice New value to be moved in member cur_slice
             */
            eProsima_user_DllExport void cur_slice(
                    std::vector<ros2_interface::msg::LaneletInfo>&& _cur_slice);

            /*!
             * @brief This function returns a constant reference to member cur_slice
             * @return Constant reference to member cur_slice
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::LaneletInfo>& cur_slice() const;

            /*!
             * @brief This function returns a reference to member cur_slice
             * @return Reference to member cur_slice
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::LaneletInfo>& cur_slice();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::GlobalRouteMsg& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::vector<ros2_interface::msg::LaneletInfo> m_route;
            ros2_interface::msg::LaneletInfo m_current_lanelet;
            double m_total_mileage;
            double m_cur_mileage;
            std::vector<ros2_interface::msg::LaneletInfo> m_cur_slice;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GLOBALROUTEMSG_H_

