// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GlobalRouteMsgTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "GlobalRouteMsg.h"
#include "GlobalRouteMsgTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerGlobalRouteMsgTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::LaneletInfo", ros2_interface::msg::GetLaneletInfoIdentifier(true),
                        ros2_interface::msg::GetLaneletInfoObject(true));
                factory->add_type_object("ros2_interface::msg::LaneletInfo", ros2_interface::msg::GetLaneletInfoIdentifier(false),
                        ros2_interface::msg::GetLaneletInfoObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::GlobalRouteMsg", ros2_interface::msg::GetGlobalRouteMsgIdentifier(true),
                        ros2_interface::msg::GetGlobalRouteMsgObject(true));
                factory->add_type_object("ros2_interface::msg::GlobalRouteMsg", ros2_interface::msg::GetGlobalRouteMsgIdentifier(false),
                        ros2_interface::msg::GetGlobalRouteMsgObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetGlobalRouteMsgIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("GlobalRouteMsg", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetGlobalRouteMsgObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("GlobalRouteMsg", complete);
        }

        const TypeObject* GetGlobalRouteMsgObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GlobalRouteMsg", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteGlobalRouteMsgObject();
            }
            //else
            return GetMinimalGlobalRouteMsgObject();
        }

        const TypeObject* GetMinimalGlobalRouteMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GlobalRouteMsg", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_route;
            mst_route.common().member_id(memberId++);
            mst_route.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_route.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_route.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_route.common().member_flags().IS_OPTIONAL(false);
            mst_route.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_route.common().member_flags().IS_KEY(false);
            mst_route.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_route.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneletInfo", 100, false));


            MD5 route_hash("route");
            for(int i = 0; i < 4; ++i)
            {
                mst_route.detail().name_hash()[i] = route_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_route);

            MinimalStructMember mst_current_lanelet;
            mst_current_lanelet.common().member_id(memberId++);
            mst_current_lanelet.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_current_lanelet.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_current_lanelet.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_current_lanelet.common().member_flags().IS_OPTIONAL(false);
            mst_current_lanelet.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_current_lanelet.common().member_flags().IS_KEY(false);
            mst_current_lanelet.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_current_lanelet.common().member_type_id(*ros2_interface::msg::GetLaneletInfoIdentifier(false));
            MD5 current_lanelet_hash("current_lanelet");
            for(int i = 0; i < 4; ++i)
            {
                mst_current_lanelet.detail().name_hash()[i] = current_lanelet_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_current_lanelet);

            MinimalStructMember mst_total_mileage;
            mst_total_mileage.common().member_id(memberId++);
            mst_total_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_total_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_total_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_total_mileage.common().member_flags().IS_OPTIONAL(false);
            mst_total_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_total_mileage.common().member_flags().IS_KEY(false);
            mst_total_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_total_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 total_mileage_hash("total_mileage");
            for(int i = 0; i < 4; ++i)
            {
                mst_total_mileage.detail().name_hash()[i] = total_mileage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_total_mileage);

            MinimalStructMember mst_cur_mileage;
            mst_cur_mileage.common().member_id(memberId++);
            mst_cur_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cur_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cur_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cur_mileage.common().member_flags().IS_OPTIONAL(false);
            mst_cur_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cur_mileage.common().member_flags().IS_KEY(false);
            mst_cur_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cur_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cur_mileage_hash("cur_mileage");
            for(int i = 0; i < 4; ++i)
            {
                mst_cur_mileage.detail().name_hash()[i] = cur_mileage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cur_mileage);

            MinimalStructMember mst_cur_slice;
            mst_cur_slice.common().member_id(memberId++);
            mst_cur_slice.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cur_slice.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cur_slice.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cur_slice.common().member_flags().IS_OPTIONAL(false);
            mst_cur_slice.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cur_slice.common().member_flags().IS_KEY(false);
            mst_cur_slice.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cur_slice.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneletInfo", 100, false));


            MD5 cur_slice_hash("cur_slice");
            for(int i = 0; i < 4; ++i)
            {
                mst_cur_slice.detail().name_hash()[i] = cur_slice_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cur_slice);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("GlobalRouteMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("GlobalRouteMsg", false);
        }

        const TypeObject* GetCompleteGlobalRouteMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("GlobalRouteMsg", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_route;
            cst_route.common().member_id(memberId++);
            cst_route.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_route.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_route.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_route.common().member_flags().IS_OPTIONAL(false);
            cst_route.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_route.common().member_flags().IS_KEY(false);
            cst_route.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_route.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneletInfo", 100, true));


            cst_route.detail().name("route");

            type_object->complete().struct_type().member_seq().emplace_back(cst_route);

            CompleteStructMember cst_current_lanelet;
            cst_current_lanelet.common().member_id(memberId++);
            cst_current_lanelet.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_current_lanelet.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_current_lanelet.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_current_lanelet.common().member_flags().IS_OPTIONAL(false);
            cst_current_lanelet.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_current_lanelet.common().member_flags().IS_KEY(false);
            cst_current_lanelet.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_current_lanelet.common().member_type_id(*ros2_interface::msg::GetLaneletInfoIdentifier(true));
            cst_current_lanelet.detail().name("current_lanelet");

            type_object->complete().struct_type().member_seq().emplace_back(cst_current_lanelet);

            CompleteStructMember cst_total_mileage;
            cst_total_mileage.common().member_id(memberId++);
            cst_total_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_total_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_total_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_total_mileage.common().member_flags().IS_OPTIONAL(false);
            cst_total_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_total_mileage.common().member_flags().IS_KEY(false);
            cst_total_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_total_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_total_mileage.detail().name("total_mileage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_total_mileage);

            CompleteStructMember cst_cur_mileage;
            cst_cur_mileage.common().member_id(memberId++);
            cst_cur_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cur_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cur_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cur_mileage.common().member_flags().IS_OPTIONAL(false);
            cst_cur_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cur_mileage.common().member_flags().IS_KEY(false);
            cst_cur_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cur_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cur_mileage.detail().name("cur_mileage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cur_mileage);

            CompleteStructMember cst_cur_slice;
            cst_cur_slice.common().member_id(memberId++);
            cst_cur_slice.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cur_slice.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cur_slice.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cur_slice.common().member_flags().IS_OPTIONAL(false);
            cst_cur_slice.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cur_slice.common().member_flags().IS_KEY(false);
            cst_cur_slice.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cur_slice.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneletInfo", 100, true));


            cst_cur_slice.detail().name("cur_slice");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cur_slice);


            // Header
            type_object->complete().struct_type().header().detail().type_name("GlobalRouteMsg");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("GlobalRouteMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("GlobalRouteMsg", true);
        }

    } // namespace msg
} // namespace ros2_interface