// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Gnss.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GNSS_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GNSS_H_

#include "Header.h"
#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(GNSS_SOURCE)
#define GNSS_DllAPI __declspec( dllexport )
#else
#define GNSS_DllAPI __declspec( dllimport )
#endif // GNSS_SOURCE
#else
#define GNSS_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define GNSS_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Gnss defined by the user in the IDL file.
         * @ingroup Gnss
         */
        class Gnss
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Gnss();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Gnss();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Gnss that will be copied.
             */
            eProsima_user_DllExport Gnss(
                    const Gnss& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Gnss that will be copied.
             */
            eProsima_user_DllExport Gnss(
                    Gnss&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Gnss that will be copied.
             */
            eProsima_user_DllExport Gnss& operator =(
                    const Gnss& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Gnss that will be copied.
             */
            eProsima_user_DllExport Gnss& operator =(
                    Gnss&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Gnss object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Gnss& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Gnss object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Gnss& x) const;

            /*!
             * @brief This function sets a value in member is_valid
             * @param _is_valid New value for member is_valid
             */
            eProsima_user_DllExport void is_valid(
                    bool _is_valid);

            /*!
             * @brief This function returns the value of member is_valid
             * @return Value of member is_valid
             */
            eProsima_user_DllExport bool is_valid() const;

            /*!
             * @brief This function returns a reference to member is_valid
             * @return Reference to member is_valid
             */
            eProsima_user_DllExport bool& is_valid();

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member latitude
             * @param _latitude New value for member latitude
             */
            eProsima_user_DllExport void latitude(
                    double _latitude);

            /*!
             * @brief This function returns the value of member latitude
             * @return Value of member latitude
             */
            eProsima_user_DllExport double latitude() const;

            /*!
             * @brief This function returns a reference to member latitude
             * @return Reference to member latitude
             */
            eProsima_user_DllExport double& latitude();

            /*!
             * @brief This function sets a value in member longitude
             * @param _longitude New value for member longitude
             */
            eProsima_user_DllExport void longitude(
                    double _longitude);

            /*!
             * @brief This function returns the value of member longitude
             * @return Value of member longitude
             */
            eProsima_user_DllExport double longitude() const;

            /*!
             * @brief This function returns a reference to member longitude
             * @return Reference to member longitude
             */
            eProsima_user_DllExport double& longitude();

            /*!
             * @brief This function sets a value in member elevation
             * @param _elevation New value for member elevation
             */
            eProsima_user_DllExport void elevation(
                    double _elevation);

            /*!
             * @brief This function returns the value of member elevation
             * @return Value of member elevation
             */
            eProsima_user_DllExport double elevation() const;

            /*!
             * @brief This function returns a reference to member elevation
             * @return Reference to member elevation
             */
            eProsima_user_DllExport double& elevation();

            /*!
             * @brief This function copies the value in member utm_position
             * @param _utm_position New value to be copied in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    const ros2_interface::msg::Point3D& _utm_position);

            /*!
             * @brief This function moves the value in member utm_position
             * @param _utm_position New value to be moved in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    ros2_interface::msg::Point3D&& _utm_position);

            /*!
             * @brief This function returns a constant reference to member utm_position
             * @return Constant reference to member utm_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& utm_position() const;

            /*!
             * @brief This function returns a reference to member utm_position
             * @return Reference to member utm_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& utm_position();
            /*!
             * @brief This function sets a value in member utm_zone_num
             * @param _utm_zone_num New value for member utm_zone_num
             */
            eProsima_user_DllExport void utm_zone_num(
                    int32_t _utm_zone_num);

            /*!
             * @brief This function returns the value of member utm_zone_num
             * @return Value of member utm_zone_num
             */
            eProsima_user_DllExport int32_t utm_zone_num() const;

            /*!
             * @brief This function returns a reference to member utm_zone_num
             * @return Reference to member utm_zone_num
             */
            eProsima_user_DllExport int32_t& utm_zone_num();

            /*!
             * @brief This function sets a value in member utm_zone_char
             * @param _utm_zone_char New value for member utm_zone_char
             */
            eProsima_user_DllExport void utm_zone_char(
                    uint8_t _utm_zone_char);

            /*!
             * @brief This function returns the value of member utm_zone_char
             * @return Value of member utm_zone_char
             */
            eProsima_user_DllExport uint8_t utm_zone_char() const;

            /*!
             * @brief This function returns a reference to member utm_zone_char
             * @return Reference to member utm_zone_char
             */
            eProsima_user_DllExport uint8_t& utm_zone_char();

            /*!
             * @brief This function copies the value in member attitude
             * @param _attitude New value to be copied in member attitude
             */
            eProsima_user_DllExport void attitude(
                    const ros2_interface::msg::Point3D& _attitude);

            /*!
             * @brief This function moves the value in member attitude
             * @param _attitude New value to be moved in member attitude
             */
            eProsima_user_DllExport void attitude(
                    ros2_interface::msg::Point3D&& _attitude);

            /*!
             * @brief This function returns a constant reference to member attitude
             * @return Constant reference to member attitude
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& attitude() const;

            /*!
             * @brief This function returns a reference to member attitude
             * @return Reference to member attitude
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& attitude();
            /*!
             * @brief This function copies the value in member sd_position
             * @param _sd_position New value to be copied in member sd_position
             */
            eProsima_user_DllExport void sd_position(
                    const ros2_interface::msg::Point3D& _sd_position);

            /*!
             * @brief This function moves the value in member sd_position
             * @param _sd_position New value to be moved in member sd_position
             */
            eProsima_user_DllExport void sd_position(
                    ros2_interface::msg::Point3D&& _sd_position);

            /*!
             * @brief This function returns a constant reference to member sd_position
             * @return Constant reference to member sd_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& sd_position() const;

            /*!
             * @brief This function returns a reference to member sd_position
             * @return Reference to member sd_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& sd_position();
            /*!
             * @brief This function copies the value in member sd_velocity
             * @param _sd_velocity New value to be copied in member sd_velocity
             */
            eProsima_user_DllExport void sd_velocity(
                    const ros2_interface::msg::Point3D& _sd_velocity);

            /*!
             * @brief This function moves the value in member sd_velocity
             * @param _sd_velocity New value to be moved in member sd_velocity
             */
            eProsima_user_DllExport void sd_velocity(
                    ros2_interface::msg::Point3D&& _sd_velocity);

            /*!
             * @brief This function returns a constant reference to member sd_velocity
             * @return Constant reference to member sd_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& sd_velocity() const;

            /*!
             * @brief This function returns a reference to member sd_velocity
             * @return Reference to member sd_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& sd_velocity();
            /*!
             * @brief This function copies the value in member sd_attitude
             * @param _sd_attitude New value to be copied in member sd_attitude
             */
            eProsima_user_DllExport void sd_attitude(
                    const ros2_interface::msg::Point3D& _sd_attitude);

            /*!
             * @brief This function moves the value in member sd_attitude
             * @param _sd_attitude New value to be moved in member sd_attitude
             */
            eProsima_user_DllExport void sd_attitude(
                    ros2_interface::msg::Point3D&& _sd_attitude);

            /*!
             * @brief This function returns a constant reference to member sd_attitude
             * @return Constant reference to member sd_attitude
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& sd_attitude() const;

            /*!
             * @brief This function returns a reference to member sd_attitude
             * @return Reference to member sd_attitude
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& sd_attitude();
            /*!
             * @brief This function sets a value in member second
             * @param _second New value for member second
             */
            eProsima_user_DllExport void second(
                    double _second);

            /*!
             * @brief This function returns the value of member second
             * @return Value of member second
             */
            eProsima_user_DllExport double second() const;

            /*!
             * @brief This function returns a reference to member second
             * @return Reference to member second
             */
            eProsima_user_DllExport double& second();

            /*!
             * @brief This function sets a value in member sat_use_num
             * @param _sat_use_num New value for member sat_use_num
             */
            eProsima_user_DllExport void sat_use_num(
                    int32_t _sat_use_num);

            /*!
             * @brief This function returns the value of member sat_use_num
             * @return Value of member sat_use_num
             */
            eProsima_user_DllExport int32_t sat_use_num() const;

            /*!
             * @brief This function returns a reference to member sat_use_num
             * @return Reference to member sat_use_num
             */
            eProsima_user_DllExport int32_t& sat_use_num();

            /*!
             * @brief This function sets a value in member sat_in_view_num
             * @param _sat_in_view_num New value for member sat_in_view_num
             */
            eProsima_user_DllExport void sat_in_view_num(
                    int32_t _sat_in_view_num);

            /*!
             * @brief This function returns the value of member sat_in_view_num
             * @return Value of member sat_in_view_num
             */
            eProsima_user_DllExport int32_t sat_in_view_num() const;

            /*!
             * @brief This function returns a reference to member sat_in_view_num
             * @return Reference to member sat_in_view_num
             */
            eProsima_user_DllExport int32_t& sat_in_view_num();

            /*!
             * @brief This function sets a value in member solution_status
             * @param _solution_status New value for member solution_status
             */
            eProsima_user_DllExport void solution_status(
                    uint16_t _solution_status);

            /*!
             * @brief This function returns the value of member solution_status
             * @return Value of member solution_status
             */
            eProsima_user_DllExport uint16_t solution_status() const;

            /*!
             * @brief This function returns a reference to member solution_status
             * @return Reference to member solution_status
             */
            eProsima_user_DllExport uint16_t& solution_status();

            /*!
             * @brief This function sets a value in member position_type
             * @param _position_type New value for member position_type
             */
            eProsima_user_DllExport void position_type(
                    uint16_t _position_type);

            /*!
             * @brief This function returns the value of member position_type
             * @return Value of member position_type
             */
            eProsima_user_DllExport uint16_t position_type() const;

            /*!
             * @brief This function returns a reference to member position_type
             * @return Reference to member position_type
             */
            eProsima_user_DllExport uint16_t& position_type();

            /*!
             * @brief This function copies the value in member linear_velocity
             * @param _linear_velocity New value to be copied in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    const ros2_interface::msg::Point3D& _linear_velocity);

            /*!
             * @brief This function moves the value in member linear_velocity
             * @param _linear_velocity New value to be moved in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    ros2_interface::msg::Point3D&& _linear_velocity);

            /*!
             * @brief This function returns a constant reference to member linear_velocity
             * @return Constant reference to member linear_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_velocity() const;

            /*!
             * @brief This function returns a reference to member linear_velocity
             * @return Reference to member linear_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_velocity();
            /*!
             * @brief This function copies the value in member attitude_dual
             * @param _attitude_dual New value to be copied in member attitude_dual
             */
            eProsima_user_DllExport void attitude_dual(
                    const ros2_interface::msg::Point3D& _attitude_dual);

            /*!
             * @brief This function moves the value in member attitude_dual
             * @param _attitude_dual New value to be moved in member attitude_dual
             */
            eProsima_user_DllExport void attitude_dual(
                    ros2_interface::msg::Point3D&& _attitude_dual);

            /*!
             * @brief This function returns a constant reference to member attitude_dual
             * @return Constant reference to member attitude_dual
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& attitude_dual() const;

            /*!
             * @brief This function returns a reference to member attitude_dual
             * @return Reference to member attitude_dual
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& attitude_dual();
            /*!
             * @brief This function copies the value in member sd_angle_dual
             * @param _sd_angle_dual New value to be copied in member sd_angle_dual
             */
            eProsima_user_DllExport void sd_angle_dual(
                    const ros2_interface::msg::Point3D& _sd_angle_dual);

            /*!
             * @brief This function moves the value in member sd_angle_dual
             * @param _sd_angle_dual New value to be moved in member sd_angle_dual
             */
            eProsima_user_DllExport void sd_angle_dual(
                    ros2_interface::msg::Point3D&& _sd_angle_dual);

            /*!
             * @brief This function returns a constant reference to member sd_angle_dual
             * @return Constant reference to member sd_angle_dual
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& sd_angle_dual() const;

            /*!
             * @brief This function returns a reference to member sd_angle_dual
             * @return Reference to member sd_angle_dual
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& sd_angle_dual();
            /*!
             * @brief This function sets a value in member base_line_length_dual
             * @param _base_line_length_dual New value for member base_line_length_dual
             */
            eProsima_user_DllExport void base_line_length_dual(
                    double _base_line_length_dual);

            /*!
             * @brief This function returns the value of member base_line_length_dual
             * @return Value of member base_line_length_dual
             */
            eProsima_user_DllExport double base_line_length_dual() const;

            /*!
             * @brief This function returns a reference to member base_line_length_dual
             * @return Reference to member base_line_length_dual
             */
            eProsima_user_DllExport double& base_line_length_dual();

            /*!
             * @brief This function sets a value in member solution_status_dual
             * @param _solution_status_dual New value for member solution_status_dual
             */
            eProsima_user_DllExport void solution_status_dual(
                    int32_t _solution_status_dual);

            /*!
             * @brief This function returns the value of member solution_status_dual
             * @return Value of member solution_status_dual
             */
            eProsima_user_DllExport int32_t solution_status_dual() const;

            /*!
             * @brief This function returns a reference to member solution_status_dual
             * @return Reference to member solution_status_dual
             */
            eProsima_user_DllExport int32_t& solution_status_dual();

            /*!
             * @brief This function sets a value in member position_type_dual
             * @param _position_type_dual New value for member position_type_dual
             */
            eProsima_user_DllExport void position_type_dual(
                    int32_t _position_type_dual);

            /*!
             * @brief This function returns the value of member position_type_dual
             * @return Value of member position_type_dual
             */
            eProsima_user_DllExport int32_t position_type_dual() const;

            /*!
             * @brief This function returns a reference to member position_type_dual
             * @return Reference to member position_type_dual
             */
            eProsima_user_DllExport int32_t& position_type_dual();

            /*!
             * @brief This function sets a value in member solution_source_dual
             * @param _solution_source_dual New value for member solution_source_dual
             */
            eProsima_user_DllExport void solution_source_dual(
                    int32_t _solution_source_dual);

            /*!
             * @brief This function returns the value of member solution_source_dual
             * @return Value of member solution_source_dual
             */
            eProsima_user_DllExport int32_t solution_source_dual() const;

            /*!
             * @brief This function returns a reference to member solution_source_dual
             * @return Reference to member solution_source_dual
             */
            eProsima_user_DllExport int32_t& solution_source_dual();

            /*!
             * @brief This function sets a value in member cep68
             * @param _cep68 New value for member cep68
             */
            eProsima_user_DllExport void cep68(
                    double _cep68);

            /*!
             * @brief This function returns the value of member cep68
             * @return Value of member cep68
             */
            eProsima_user_DllExport double cep68() const;

            /*!
             * @brief This function returns a reference to member cep68
             * @return Reference to member cep68
             */
            eProsima_user_DllExport double& cep68();

            /*!
             * @brief This function sets a value in member cep95
             * @param _cep95 New value for member cep95
             */
            eProsima_user_DllExport void cep95(
                    double _cep95);

            /*!
             * @brief This function returns the value of member cep95
             * @return Value of member cep95
             */
            eProsima_user_DllExport double cep95() const;

            /*!
             * @brief This function returns a reference to member cep95
             * @return Reference to member cep95
             */
            eProsima_user_DllExport double& cep95();

            /*!
             * @brief This function sets a value in member p_dop
             * @param _p_dop New value for member p_dop
             */
            eProsima_user_DllExport void p_dop(
                    double _p_dop);

            /*!
             * @brief This function returns the value of member p_dop
             * @return Value of member p_dop
             */
            eProsima_user_DllExport double p_dop() const;

            /*!
             * @brief This function returns a reference to member p_dop
             * @return Reference to member p_dop
             */
            eProsima_user_DllExport double& p_dop();

            /*!
             * @brief This function sets a value in member h_dop
             * @param _h_dop New value for member h_dop
             */
            eProsima_user_DllExport void h_dop(
                    double _h_dop);

            /*!
             * @brief This function returns the value of member h_dop
             * @return Value of member h_dop
             */
            eProsima_user_DllExport double h_dop() const;

            /*!
             * @brief This function returns a reference to member h_dop
             * @return Reference to member h_dop
             */
            eProsima_user_DllExport double& h_dop();

            /*!
             * @brief This function sets a value in member v_dop
             * @param _v_dop New value for member v_dop
             */
            eProsima_user_DllExport void v_dop(
                    double _v_dop);

            /*!
             * @brief This function returns the value of member v_dop
             * @return Value of member v_dop
             */
            eProsima_user_DllExport double v_dop() const;

            /*!
             * @brief This function returns a reference to member v_dop
             * @return Reference to member v_dop
             */
            eProsima_user_DllExport double& v_dop();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Gnss& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            bool m_is_valid;
            ros2_interface::msg::Header m_header;
            double m_latitude;
            double m_longitude;
            double m_elevation;
            ros2_interface::msg::Point3D m_utm_position;
            int32_t m_utm_zone_num;
            uint8_t m_utm_zone_char;
            ros2_interface::msg::Point3D m_attitude;
            ros2_interface::msg::Point3D m_sd_position;
            ros2_interface::msg::Point3D m_sd_velocity;
            ros2_interface::msg::Point3D m_sd_attitude;
            double m_second;
            int32_t m_sat_use_num;
            int32_t m_sat_in_view_num;
            uint16_t m_solution_status;
            uint16_t m_position_type;
            ros2_interface::msg::Point3D m_linear_velocity;
            ros2_interface::msg::Point3D m_attitude_dual;
            ros2_interface::msg::Point3D m_sd_angle_dual;
            double m_base_line_length_dual;
            int32_t m_solution_status_dual;
            int32_t m_position_type_dual;
            int32_t m_solution_source_dual;
            double m_cep68;
            double m_cep95;
            double m_p_dop;
            double m_h_dop;
            double m_v_dop;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GNSS_H_

