// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file GnssTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Gnss.h"
#include "GnssTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerGnssTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Gnss", ros2_interface::msg::GetGnssIdentifier(true),
                        ros2_interface::msg::GetGnssObject(true));
                factory->add_type_object("ros2_interface::msg::Gnss", ros2_interface::msg::GetGnssIdentifier(false),
                        ros2_interface::msg::GetGnssObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetGnssIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Gnss", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetGnssObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Gnss", complete);
        }

        const TypeObject* GetGnssObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Gnss", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteGnssObject();
            }
            //else
            return GetMinimalGnssObject();
        }

        const TypeObject* GetMinimalGnssObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Gnss", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_is_valid;
            mst_is_valid.common().member_id(memberId++);
            mst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_valid.common().member_flags().IS_KEY(false);
            mst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_valid_hash("is_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_valid.detail().name_hash()[i] = is_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_valid);

            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_latitude;
            mst_latitude.common().member_id(memberId++);
            mst_latitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_latitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_latitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_latitude.common().member_flags().IS_OPTIONAL(false);
            mst_latitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_latitude.common().member_flags().IS_KEY(false);
            mst_latitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_latitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 latitude_hash("latitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_latitude.detail().name_hash()[i] = latitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_latitude);

            MinimalStructMember mst_longitude;
            mst_longitude.common().member_id(memberId++);
            mst_longitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_longitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_longitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_longitude.common().member_flags().IS_OPTIONAL(false);
            mst_longitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_longitude.common().member_flags().IS_KEY(false);
            mst_longitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_longitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 longitude_hash("longitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_longitude.detail().name_hash()[i] = longitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_longitude);

            MinimalStructMember mst_elevation;
            mst_elevation.common().member_id(memberId++);
            mst_elevation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_elevation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_elevation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_elevation.common().member_flags().IS_OPTIONAL(false);
            mst_elevation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_elevation.common().member_flags().IS_KEY(false);
            mst_elevation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_elevation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 elevation_hash("elevation");
            for(int i = 0; i < 4; ++i)
            {
                mst_elevation.detail().name_hash()[i] = elevation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_elevation);

            MinimalStructMember mst_utm_position;
            mst_utm_position.common().member_id(memberId++);
            mst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_position.common().member_flags().IS_OPTIONAL(false);
            mst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_position.common().member_flags().IS_KEY(false);
            mst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 utm_position_hash("utm_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_position.detail().name_hash()[i] = utm_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_position);

            MinimalStructMember mst_utm_zone_num;
            mst_utm_zone_num.common().member_id(memberId++);
            mst_utm_zone_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_zone_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_zone_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_zone_num.common().member_flags().IS_OPTIONAL(false);
            mst_utm_zone_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_zone_num.common().member_flags().IS_KEY(false);
            mst_utm_zone_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_zone_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 utm_zone_num_hash("utm_zone_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_zone_num.detail().name_hash()[i] = utm_zone_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_zone_num);

            MinimalStructMember mst_utm_zone_char;
            mst_utm_zone_char.common().member_id(memberId++);
            mst_utm_zone_char.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_zone_char.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_zone_char.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_zone_char.common().member_flags().IS_OPTIONAL(false);
            mst_utm_zone_char.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_zone_char.common().member_flags().IS_KEY(false);
            mst_utm_zone_char.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_zone_char.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 utm_zone_char_hash("utm_zone_char");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_zone_char.detail().name_hash()[i] = utm_zone_char_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_zone_char);

            MinimalStructMember mst_attitude;
            mst_attitude.common().member_id(memberId++);
            mst_attitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_attitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_attitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_attitude.common().member_flags().IS_OPTIONAL(false);
            mst_attitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_attitude.common().member_flags().IS_KEY(false);
            mst_attitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_attitude.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 attitude_hash("attitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_attitude.detail().name_hash()[i] = attitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_attitude);

            MinimalStructMember mst_sd_position;
            mst_sd_position.common().member_id(memberId++);
            mst_sd_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sd_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sd_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sd_position.common().member_flags().IS_OPTIONAL(false);
            mst_sd_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sd_position.common().member_flags().IS_KEY(false);
            mst_sd_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sd_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 sd_position_hash("sd_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_sd_position.detail().name_hash()[i] = sd_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sd_position);

            MinimalStructMember mst_sd_velocity;
            mst_sd_velocity.common().member_id(memberId++);
            mst_sd_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sd_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sd_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sd_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_sd_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sd_velocity.common().member_flags().IS_KEY(false);
            mst_sd_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sd_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 sd_velocity_hash("sd_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_sd_velocity.detail().name_hash()[i] = sd_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sd_velocity);

            MinimalStructMember mst_sd_attitude;
            mst_sd_attitude.common().member_id(memberId++);
            mst_sd_attitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sd_attitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sd_attitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sd_attitude.common().member_flags().IS_OPTIONAL(false);
            mst_sd_attitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sd_attitude.common().member_flags().IS_KEY(false);
            mst_sd_attitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sd_attitude.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 sd_attitude_hash("sd_attitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_sd_attitude.detail().name_hash()[i] = sd_attitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sd_attitude);

            MinimalStructMember mst_second;
            mst_second.common().member_id(memberId++);
            mst_second.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_second.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_second.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_second.common().member_flags().IS_OPTIONAL(false);
            mst_second.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_second.common().member_flags().IS_KEY(false);
            mst_second.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_second.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 second_hash("second");
            for(int i = 0; i < 4; ++i)
            {
                mst_second.detail().name_hash()[i] = second_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_second);

            MinimalStructMember mst_sat_use_num;
            mst_sat_use_num.common().member_id(memberId++);
            mst_sat_use_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sat_use_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sat_use_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sat_use_num.common().member_flags().IS_OPTIONAL(false);
            mst_sat_use_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sat_use_num.common().member_flags().IS_KEY(false);
            mst_sat_use_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sat_use_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sat_use_num_hash("sat_use_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_sat_use_num.detail().name_hash()[i] = sat_use_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sat_use_num);

            MinimalStructMember mst_sat_in_view_num;
            mst_sat_in_view_num.common().member_id(memberId++);
            mst_sat_in_view_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sat_in_view_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sat_in_view_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sat_in_view_num.common().member_flags().IS_OPTIONAL(false);
            mst_sat_in_view_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sat_in_view_num.common().member_flags().IS_KEY(false);
            mst_sat_in_view_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sat_in_view_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sat_in_view_num_hash("sat_in_view_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_sat_in_view_num.detail().name_hash()[i] = sat_in_view_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sat_in_view_num);

            MinimalStructMember mst_solution_status;
            mst_solution_status.common().member_id(memberId++);
            mst_solution_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_solution_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_solution_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_solution_status.common().member_flags().IS_OPTIONAL(false);
            mst_solution_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_solution_status.common().member_flags().IS_KEY(false);
            mst_solution_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_solution_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint16_t", false));

            MD5 solution_status_hash("solution_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_solution_status.detail().name_hash()[i] = solution_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_solution_status);

            MinimalStructMember mst_position_type;
            mst_position_type.common().member_id(memberId++);
            mst_position_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_type.common().member_flags().IS_OPTIONAL(false);
            mst_position_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_type.common().member_flags().IS_KEY(false);
            mst_position_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint16_t", false));

            MD5 position_type_hash("position_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_type.detail().name_hash()[i] = position_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_type);

            MinimalStructMember mst_linear_velocity;
            mst_linear_velocity.common().member_id(memberId++);
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity.common().member_flags().IS_KEY(false);
            mst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_velocity_hash("linear_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity.detail().name_hash()[i] = linear_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity);

            MinimalStructMember mst_attitude_dual;
            mst_attitude_dual.common().member_id(memberId++);
            mst_attitude_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_attitude_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_attitude_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_attitude_dual.common().member_flags().IS_OPTIONAL(false);
            mst_attitude_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_attitude_dual.common().member_flags().IS_KEY(false);
            mst_attitude_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_attitude_dual.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 attitude_dual_hash("attitude_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_attitude_dual.detail().name_hash()[i] = attitude_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_attitude_dual);

            MinimalStructMember mst_sd_angle_dual;
            mst_sd_angle_dual.common().member_id(memberId++);
            mst_sd_angle_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sd_angle_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sd_angle_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sd_angle_dual.common().member_flags().IS_OPTIONAL(false);
            mst_sd_angle_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sd_angle_dual.common().member_flags().IS_KEY(false);
            mst_sd_angle_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sd_angle_dual.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 sd_angle_dual_hash("sd_angle_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_sd_angle_dual.detail().name_hash()[i] = sd_angle_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sd_angle_dual);

            MinimalStructMember mst_base_line_length_dual;
            mst_base_line_length_dual.common().member_id(memberId++);
            mst_base_line_length_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_base_line_length_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_base_line_length_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_base_line_length_dual.common().member_flags().IS_OPTIONAL(false);
            mst_base_line_length_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_base_line_length_dual.common().member_flags().IS_KEY(false);
            mst_base_line_length_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_base_line_length_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 base_line_length_dual_hash("base_line_length_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_base_line_length_dual.detail().name_hash()[i] = base_line_length_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_base_line_length_dual);

            MinimalStructMember mst_solution_status_dual;
            mst_solution_status_dual.common().member_id(memberId++);
            mst_solution_status_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_solution_status_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_solution_status_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_solution_status_dual.common().member_flags().IS_OPTIONAL(false);
            mst_solution_status_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_solution_status_dual.common().member_flags().IS_KEY(false);
            mst_solution_status_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_solution_status_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 solution_status_dual_hash("solution_status_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_solution_status_dual.detail().name_hash()[i] = solution_status_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_solution_status_dual);

            MinimalStructMember mst_position_type_dual;
            mst_position_type_dual.common().member_id(memberId++);
            mst_position_type_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_type_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_type_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_type_dual.common().member_flags().IS_OPTIONAL(false);
            mst_position_type_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_type_dual.common().member_flags().IS_KEY(false);
            mst_position_type_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_type_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 position_type_dual_hash("position_type_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_type_dual.detail().name_hash()[i] = position_type_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_type_dual);

            MinimalStructMember mst_solution_source_dual;
            mst_solution_source_dual.common().member_id(memberId++);
            mst_solution_source_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_solution_source_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_solution_source_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_solution_source_dual.common().member_flags().IS_OPTIONAL(false);
            mst_solution_source_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_solution_source_dual.common().member_flags().IS_KEY(false);
            mst_solution_source_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_solution_source_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 solution_source_dual_hash("solution_source_dual");
            for(int i = 0; i < 4; ++i)
            {
                mst_solution_source_dual.detail().name_hash()[i] = solution_source_dual_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_solution_source_dual);

            MinimalStructMember mst_cep68;
            mst_cep68.common().member_id(memberId++);
            mst_cep68.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cep68.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cep68.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cep68.common().member_flags().IS_OPTIONAL(false);
            mst_cep68.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cep68.common().member_flags().IS_KEY(false);
            mst_cep68.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cep68.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cep68_hash("cep68");
            for(int i = 0; i < 4; ++i)
            {
                mst_cep68.detail().name_hash()[i] = cep68_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cep68);

            MinimalStructMember mst_cep95;
            mst_cep95.common().member_id(memberId++);
            mst_cep95.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cep95.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cep95.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cep95.common().member_flags().IS_OPTIONAL(false);
            mst_cep95.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cep95.common().member_flags().IS_KEY(false);
            mst_cep95.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cep95.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cep95_hash("cep95");
            for(int i = 0; i < 4; ++i)
            {
                mst_cep95.detail().name_hash()[i] = cep95_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cep95);

            MinimalStructMember mst_p_dop;
            mst_p_dop.common().member_id(memberId++);
            mst_p_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_p_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_p_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_p_dop.common().member_flags().IS_OPTIONAL(false);
            mst_p_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_p_dop.common().member_flags().IS_KEY(false);
            mst_p_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_p_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 p_dop_hash("p_dop");
            for(int i = 0; i < 4; ++i)
            {
                mst_p_dop.detail().name_hash()[i] = p_dop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_p_dop);

            MinimalStructMember mst_h_dop;
            mst_h_dop.common().member_id(memberId++);
            mst_h_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_h_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_h_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_h_dop.common().member_flags().IS_OPTIONAL(false);
            mst_h_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_h_dop.common().member_flags().IS_KEY(false);
            mst_h_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_h_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 h_dop_hash("h_dop");
            for(int i = 0; i < 4; ++i)
            {
                mst_h_dop.detail().name_hash()[i] = h_dop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_h_dop);

            MinimalStructMember mst_v_dop;
            mst_v_dop.common().member_id(memberId++);
            mst_v_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_v_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_v_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_v_dop.common().member_flags().IS_OPTIONAL(false);
            mst_v_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_v_dop.common().member_flags().IS_KEY(false);
            mst_v_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_v_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 v_dop_hash("v_dop");
            for(int i = 0; i < 4; ++i)
            {
                mst_v_dop.detail().name_hash()[i] = v_dop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_v_dop);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Gnss", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Gnss", false);
        }

        const TypeObject* GetCompleteGnssObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Gnss", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_is_valid;
            cst_is_valid.common().member_id(memberId++);
            cst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_valid.common().member_flags().IS_KEY(false);
            cst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_valid.detail().name("is_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_valid);

            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_latitude;
            cst_latitude.common().member_id(memberId++);
            cst_latitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_latitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_latitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_latitude.common().member_flags().IS_OPTIONAL(false);
            cst_latitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_latitude.common().member_flags().IS_KEY(false);
            cst_latitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_latitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_latitude.detail().name("latitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_latitude);

            CompleteStructMember cst_longitude;
            cst_longitude.common().member_id(memberId++);
            cst_longitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_longitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_longitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_longitude.common().member_flags().IS_OPTIONAL(false);
            cst_longitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_longitude.common().member_flags().IS_KEY(false);
            cst_longitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_longitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_longitude.detail().name("longitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_longitude);

            CompleteStructMember cst_elevation;
            cst_elevation.common().member_id(memberId++);
            cst_elevation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_elevation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_elevation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_elevation.common().member_flags().IS_OPTIONAL(false);
            cst_elevation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_elevation.common().member_flags().IS_KEY(false);
            cst_elevation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_elevation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_elevation.detail().name("elevation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_elevation);

            CompleteStructMember cst_utm_position;
            cst_utm_position.common().member_id(memberId++);
            cst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_position.common().member_flags().IS_OPTIONAL(false);
            cst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_position.common().member_flags().IS_KEY(false);
            cst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_utm_position.detail().name("utm_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_position);

            CompleteStructMember cst_utm_zone_num;
            cst_utm_zone_num.common().member_id(memberId++);
            cst_utm_zone_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_zone_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_zone_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_zone_num.common().member_flags().IS_OPTIONAL(false);
            cst_utm_zone_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_zone_num.common().member_flags().IS_KEY(false);
            cst_utm_zone_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_zone_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_utm_zone_num.detail().name("utm_zone_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_zone_num);

            CompleteStructMember cst_utm_zone_char;
            cst_utm_zone_char.common().member_id(memberId++);
            cst_utm_zone_char.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_zone_char.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_zone_char.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_zone_char.common().member_flags().IS_OPTIONAL(false);
            cst_utm_zone_char.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_zone_char.common().member_flags().IS_KEY(false);
            cst_utm_zone_char.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_zone_char.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_utm_zone_char.detail().name("utm_zone_char");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_zone_char);

            CompleteStructMember cst_attitude;
            cst_attitude.common().member_id(memberId++);
            cst_attitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_attitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_attitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_attitude.common().member_flags().IS_OPTIONAL(false);
            cst_attitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_attitude.common().member_flags().IS_KEY(false);
            cst_attitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_attitude.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_attitude.detail().name("attitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_attitude);

            CompleteStructMember cst_sd_position;
            cst_sd_position.common().member_id(memberId++);
            cst_sd_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sd_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sd_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sd_position.common().member_flags().IS_OPTIONAL(false);
            cst_sd_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sd_position.common().member_flags().IS_KEY(false);
            cst_sd_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sd_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_sd_position.detail().name("sd_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sd_position);

            CompleteStructMember cst_sd_velocity;
            cst_sd_velocity.common().member_id(memberId++);
            cst_sd_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sd_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sd_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sd_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_sd_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sd_velocity.common().member_flags().IS_KEY(false);
            cst_sd_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sd_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_sd_velocity.detail().name("sd_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sd_velocity);

            CompleteStructMember cst_sd_attitude;
            cst_sd_attitude.common().member_id(memberId++);
            cst_sd_attitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sd_attitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sd_attitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sd_attitude.common().member_flags().IS_OPTIONAL(false);
            cst_sd_attitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sd_attitude.common().member_flags().IS_KEY(false);
            cst_sd_attitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sd_attitude.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_sd_attitude.detail().name("sd_attitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sd_attitude);

            CompleteStructMember cst_second;
            cst_second.common().member_id(memberId++);
            cst_second.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_second.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_second.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_second.common().member_flags().IS_OPTIONAL(false);
            cst_second.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_second.common().member_flags().IS_KEY(false);
            cst_second.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_second.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_second.detail().name("second");

            type_object->complete().struct_type().member_seq().emplace_back(cst_second);

            CompleteStructMember cst_sat_use_num;
            cst_sat_use_num.common().member_id(memberId++);
            cst_sat_use_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sat_use_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sat_use_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sat_use_num.common().member_flags().IS_OPTIONAL(false);
            cst_sat_use_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sat_use_num.common().member_flags().IS_KEY(false);
            cst_sat_use_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sat_use_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sat_use_num.detail().name("sat_use_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sat_use_num);

            CompleteStructMember cst_sat_in_view_num;
            cst_sat_in_view_num.common().member_id(memberId++);
            cst_sat_in_view_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sat_in_view_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sat_in_view_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sat_in_view_num.common().member_flags().IS_OPTIONAL(false);
            cst_sat_in_view_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sat_in_view_num.common().member_flags().IS_KEY(false);
            cst_sat_in_view_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sat_in_view_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sat_in_view_num.detail().name("sat_in_view_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sat_in_view_num);

            CompleteStructMember cst_solution_status;
            cst_solution_status.common().member_id(memberId++);
            cst_solution_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_solution_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_solution_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_solution_status.common().member_flags().IS_OPTIONAL(false);
            cst_solution_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_solution_status.common().member_flags().IS_KEY(false);
            cst_solution_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_solution_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint16_t", false));

            cst_solution_status.detail().name("solution_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_solution_status);

            CompleteStructMember cst_position_type;
            cst_position_type.common().member_id(memberId++);
            cst_position_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_type.common().member_flags().IS_OPTIONAL(false);
            cst_position_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_type.common().member_flags().IS_KEY(false);
            cst_position_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint16_t", false));

            cst_position_type.detail().name("position_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_type);

            CompleteStructMember cst_linear_velocity;
            cst_linear_velocity.common().member_id(memberId++);
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity.common().member_flags().IS_KEY(false);
            cst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_velocity.detail().name("linear_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity);

            CompleteStructMember cst_attitude_dual;
            cst_attitude_dual.common().member_id(memberId++);
            cst_attitude_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_attitude_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_attitude_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_attitude_dual.common().member_flags().IS_OPTIONAL(false);
            cst_attitude_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_attitude_dual.common().member_flags().IS_KEY(false);
            cst_attitude_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_attitude_dual.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_attitude_dual.detail().name("attitude_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_attitude_dual);

            CompleteStructMember cst_sd_angle_dual;
            cst_sd_angle_dual.common().member_id(memberId++);
            cst_sd_angle_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sd_angle_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sd_angle_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sd_angle_dual.common().member_flags().IS_OPTIONAL(false);
            cst_sd_angle_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sd_angle_dual.common().member_flags().IS_KEY(false);
            cst_sd_angle_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sd_angle_dual.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_sd_angle_dual.detail().name("sd_angle_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sd_angle_dual);

            CompleteStructMember cst_base_line_length_dual;
            cst_base_line_length_dual.common().member_id(memberId++);
            cst_base_line_length_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_base_line_length_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_base_line_length_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_base_line_length_dual.common().member_flags().IS_OPTIONAL(false);
            cst_base_line_length_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_base_line_length_dual.common().member_flags().IS_KEY(false);
            cst_base_line_length_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_base_line_length_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_base_line_length_dual.detail().name("base_line_length_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_base_line_length_dual);

            CompleteStructMember cst_solution_status_dual;
            cst_solution_status_dual.common().member_id(memberId++);
            cst_solution_status_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_solution_status_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_solution_status_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_solution_status_dual.common().member_flags().IS_OPTIONAL(false);
            cst_solution_status_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_solution_status_dual.common().member_flags().IS_KEY(false);
            cst_solution_status_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_solution_status_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_solution_status_dual.detail().name("solution_status_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_solution_status_dual);

            CompleteStructMember cst_position_type_dual;
            cst_position_type_dual.common().member_id(memberId++);
            cst_position_type_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_type_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_type_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_type_dual.common().member_flags().IS_OPTIONAL(false);
            cst_position_type_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_type_dual.common().member_flags().IS_KEY(false);
            cst_position_type_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_type_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_position_type_dual.detail().name("position_type_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_type_dual);

            CompleteStructMember cst_solution_source_dual;
            cst_solution_source_dual.common().member_id(memberId++);
            cst_solution_source_dual.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_solution_source_dual.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_solution_source_dual.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_solution_source_dual.common().member_flags().IS_OPTIONAL(false);
            cst_solution_source_dual.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_solution_source_dual.common().member_flags().IS_KEY(false);
            cst_solution_source_dual.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_solution_source_dual.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_solution_source_dual.detail().name("solution_source_dual");

            type_object->complete().struct_type().member_seq().emplace_back(cst_solution_source_dual);

            CompleteStructMember cst_cep68;
            cst_cep68.common().member_id(memberId++);
            cst_cep68.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cep68.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cep68.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cep68.common().member_flags().IS_OPTIONAL(false);
            cst_cep68.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cep68.common().member_flags().IS_KEY(false);
            cst_cep68.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cep68.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cep68.detail().name("cep68");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cep68);

            CompleteStructMember cst_cep95;
            cst_cep95.common().member_id(memberId++);
            cst_cep95.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cep95.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cep95.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cep95.common().member_flags().IS_OPTIONAL(false);
            cst_cep95.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cep95.common().member_flags().IS_KEY(false);
            cst_cep95.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cep95.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cep95.detail().name("cep95");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cep95);

            CompleteStructMember cst_p_dop;
            cst_p_dop.common().member_id(memberId++);
            cst_p_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_p_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_p_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_p_dop.common().member_flags().IS_OPTIONAL(false);
            cst_p_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_p_dop.common().member_flags().IS_KEY(false);
            cst_p_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_p_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_p_dop.detail().name("p_dop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_p_dop);

            CompleteStructMember cst_h_dop;
            cst_h_dop.common().member_id(memberId++);
            cst_h_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_h_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_h_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_h_dop.common().member_flags().IS_OPTIONAL(false);
            cst_h_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_h_dop.common().member_flags().IS_KEY(false);
            cst_h_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_h_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_h_dop.detail().name("h_dop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_h_dop);

            CompleteStructMember cst_v_dop;
            cst_v_dop.common().member_id(memberId++);
            cst_v_dop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_v_dop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_v_dop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_v_dop.common().member_flags().IS_OPTIONAL(false);
            cst_v_dop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_v_dop.common().member_flags().IS_KEY(false);
            cst_v_dop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_v_dop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_v_dop.detail().name("v_dop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_v_dop);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Gnss");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Gnss", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Gnss", true);
        }

    } // namespace msg
} // namespace ros2_interface