// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Grid.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Grid.h"
#include "GridTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_SLPoint_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Grid_max_cdr_typesize 52ULL;
#define ros2_interface_msg_SLPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Grid_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Grid::Grid()
{
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // ros2_interface::msg::SLPoint m_sl_point

    // double m_yaw
    m_yaw = 0.0;
    // double m_potential
    m_potential = 0.0;
    // long m_region_id
    m_region_id = 0;

    // Just to register all known types
    registerGridTypes();
}

ros2_interface::msg::Grid::~Grid()
{






}

ros2_interface::msg::Grid::Grid(
        const Grid& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_sl_point = x.m_sl_point;
    m_yaw = x.m_yaw;
    m_potential = x.m_potential;
    m_region_id = x.m_region_id;
}

ros2_interface::msg::Grid::Grid(
        Grid&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_sl_point = std::move(x.m_sl_point);
    m_yaw = x.m_yaw;
    m_potential = x.m_potential;
    m_region_id = x.m_region_id;
}

ros2_interface::msg::Grid& ros2_interface::msg::Grid::operator =(
        const Grid& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_sl_point = x.m_sl_point;
    m_yaw = x.m_yaw;
    m_potential = x.m_potential;
    m_region_id = x.m_region_id;

    return *this;
}

ros2_interface::msg::Grid& ros2_interface::msg::Grid::operator =(
        Grid&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_sl_point = std::move(x.m_sl_point);
    m_yaw = x.m_yaw;
    m_potential = x.m_potential;
    m_region_id = x.m_region_id;

    return *this;
}

bool ros2_interface::msg::Grid::operator ==(
        const Grid& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_sl_point == x.m_sl_point && m_yaw == x.m_yaw && m_potential == x.m_potential && m_region_id == x.m_region_id);
}

bool ros2_interface::msg::Grid::operator !=(
        const Grid& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Grid::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Grid_max_cdr_typesize;
}

size_t ros2_interface::msg::Grid::getCdrSerializedSize(
        const ros2_interface::msg::Grid& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::SLPoint::getCdrSerializedSize(data.sl_point(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Grid::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_sl_point;
    scdr << m_yaw;
    scdr << m_potential;
    scdr << m_region_id;

}

void ros2_interface::msg::Grid::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_sl_point;
    dcdr >> m_yaw;
    dcdr >> m_potential;
    dcdr >> m_region_id;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::Grid::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::Grid::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::Grid::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::Grid::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::Grid::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::Grid::y()
{
    return m_y;
}

/*!
 * @brief This function copies the value in member sl_point
 * @param _sl_point New value to be copied in member sl_point
 */
void ros2_interface::msg::Grid::sl_point(
        const ros2_interface::msg::SLPoint& _sl_point)
{
    m_sl_point = _sl_point;
}

/*!
 * @brief This function moves the value in member sl_point
 * @param _sl_point New value to be moved in member sl_point
 */
void ros2_interface::msg::Grid::sl_point(
        ros2_interface::msg::SLPoint&& _sl_point)
{
    m_sl_point = std::move(_sl_point);
}

/*!
 * @brief This function returns a constant reference to member sl_point
 * @return Constant reference to member sl_point
 */
const ros2_interface::msg::SLPoint& ros2_interface::msg::Grid::sl_point() const
{
    return m_sl_point;
}

/*!
 * @brief This function returns a reference to member sl_point
 * @return Reference to member sl_point
 */
ros2_interface::msg::SLPoint& ros2_interface::msg::Grid::sl_point()
{
    return m_sl_point;
}
/*!
 * @brief This function sets a value in member yaw
 * @param _yaw New value for member yaw
 */
void ros2_interface::msg::Grid::yaw(
        double _yaw)
{
    m_yaw = _yaw;
}

/*!
 * @brief This function returns the value of member yaw
 * @return Value of member yaw
 */
double ros2_interface::msg::Grid::yaw() const
{
    return m_yaw;
}

/*!
 * @brief This function returns a reference to member yaw
 * @return Reference to member yaw
 */
double& ros2_interface::msg::Grid::yaw()
{
    return m_yaw;
}

/*!
 * @brief This function sets a value in member potential
 * @param _potential New value for member potential
 */
void ros2_interface::msg::Grid::potential(
        double _potential)
{
    m_potential = _potential;
}

/*!
 * @brief This function returns the value of member potential
 * @return Value of member potential
 */
double ros2_interface::msg::Grid::potential() const
{
    return m_potential;
}

/*!
 * @brief This function returns a reference to member potential
 * @return Reference to member potential
 */
double& ros2_interface::msg::Grid::potential()
{
    return m_potential;
}

/*!
 * @brief This function sets a value in member region_id
 * @param _region_id New value for member region_id
 */
void ros2_interface::msg::Grid::region_id(
        int32_t _region_id)
{
    m_region_id = _region_id;
}

/*!
 * @brief This function returns the value of member region_id
 * @return Value of member region_id
 */
int32_t ros2_interface::msg::Grid::region_id() const
{
    return m_region_id;
}

/*!
 * @brief This function returns a reference to member region_id
 * @return Reference to member region_id
 */
int32_t& ros2_interface::msg::Grid::region_id()
{
    return m_region_id;
}



size_t ros2_interface::msg::Grid::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Grid_max_key_cdr_typesize;
}

bool ros2_interface::msg::Grid::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Grid::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



