// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Grid.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GRID_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GRID_H_

#include "SLPoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(GRID_SOURCE)
#define GRID_DllAPI __declspec( dllexport )
#else
#define GRID_DllAPI __declspec( dllimport )
#endif // GRID_SOURCE
#else
#define GRID_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define GRID_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Grid defined by the user in the IDL file.
         * @ingroup Grid
         */
        class Grid
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Grid();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Grid();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Grid that will be copied.
             */
            eProsima_user_DllExport Grid(
                    const Grid& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Grid that will be copied.
             */
            eProsima_user_DllExport Grid(
                    Grid&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Grid that will be copied.
             */
            eProsima_user_DllExport Grid& operator =(
                    const Grid& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Grid that will be copied.
             */
            eProsima_user_DllExport Grid& operator =(
                    Grid&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Grid object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Grid& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Grid object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Grid& x) const;

            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    double _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport double x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport double& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    double _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport double y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport double& y();

            /*!
             * @brief This function copies the value in member sl_point
             * @param _sl_point New value to be copied in member sl_point
             */
            eProsima_user_DllExport void sl_point(
                    const ros2_interface::msg::SLPoint& _sl_point);

            /*!
             * @brief This function moves the value in member sl_point
             * @param _sl_point New value to be moved in member sl_point
             */
            eProsima_user_DllExport void sl_point(
                    ros2_interface::msg::SLPoint&& _sl_point);

            /*!
             * @brief This function returns a constant reference to member sl_point
             * @return Constant reference to member sl_point
             */
            eProsima_user_DllExport const ros2_interface::msg::SLPoint& sl_point() const;

            /*!
             * @brief This function returns a reference to member sl_point
             * @return Reference to member sl_point
             */
            eProsima_user_DllExport ros2_interface::msg::SLPoint& sl_point();
            /*!
             * @brief This function sets a value in member yaw
             * @param _yaw New value for member yaw
             */
            eProsima_user_DllExport void yaw(
                    double _yaw);

            /*!
             * @brief This function returns the value of member yaw
             * @return Value of member yaw
             */
            eProsima_user_DllExport double yaw() const;

            /*!
             * @brief This function returns a reference to member yaw
             * @return Reference to member yaw
             */
            eProsima_user_DllExport double& yaw();

            /*!
             * @brief This function sets a value in member potential
             * @param _potential New value for member potential
             */
            eProsima_user_DllExport void potential(
                    double _potential);

            /*!
             * @brief This function returns the value of member potential
             * @return Value of member potential
             */
            eProsima_user_DllExport double potential() const;

            /*!
             * @brief This function returns a reference to member potential
             * @return Reference to member potential
             */
            eProsima_user_DllExport double& potential();

            /*!
             * @brief This function sets a value in member region_id
             * @param _region_id New value for member region_id
             */
            eProsima_user_DllExport void region_id(
                    int32_t _region_id);

            /*!
             * @brief This function returns the value of member region_id
             * @return Value of member region_id
             */
            eProsima_user_DllExport int32_t region_id() const;

            /*!
             * @brief This function returns a reference to member region_id
             * @return Reference to member region_id
             */
            eProsima_user_DllExport int32_t& region_id();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Grid& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_x;
            double m_y;
            ros2_interface::msg::SLPoint m_sl_point;
            double m_yaw;
            double m_potential;
            int32_t m_region_id;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_GRID_H_

