// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIObstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "HMIObstacle.h"
#include "HMIObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_HMIObstacle_max_cdr_typesize 121ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_HMIObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::HMIObstacle::HMIObstacle()
{
    // long m_id
    m_id = 0;
    // ros2_interface::msg::Point3D m_center_pos_vehicle

    // ros2_interface::msg::Point3D m_center_pos_abs

    // double m_theta_vehicle
    m_theta_vehicle = 0.0;
    // double m_theta_abs
    m_theta_abs = 0.0;
    // double m_length
    m_length = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_height
    m_height = 0.0;
    // long m_type
    m_type = 0;
    // double m_confidence
    m_confidence = 0.0;
    // long m_confidence_type
    m_confidence_type = 0;
    // long m_sub_type
    m_sub_type = 0;
    // uint8 m_cipv_flag
    m_cipv_flag = 0;

    // Just to register all known types
    registerHMIObstacleTypes();
}

ros2_interface::msg::HMIObstacle::~HMIObstacle()
{













}

ros2_interface::msg::HMIObstacle::HMIObstacle(
        const HMIObstacle& x)
{
    m_id = x.m_id;
    m_center_pos_vehicle = x.m_center_pos_vehicle;
    m_center_pos_abs = x.m_center_pos_abs;
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_sub_type = x.m_sub_type;
    m_cipv_flag = x.m_cipv_flag;
}

ros2_interface::msg::HMIObstacle::HMIObstacle(
        HMIObstacle&& x) noexcept 
{
    m_id = x.m_id;
    m_center_pos_vehicle = std::move(x.m_center_pos_vehicle);
    m_center_pos_abs = std::move(x.m_center_pos_abs);
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_sub_type = x.m_sub_type;
    m_cipv_flag = x.m_cipv_flag;
}

ros2_interface::msg::HMIObstacle& ros2_interface::msg::HMIObstacle::operator =(
        const HMIObstacle& x)
{

    m_id = x.m_id;
    m_center_pos_vehicle = x.m_center_pos_vehicle;
    m_center_pos_abs = x.m_center_pos_abs;
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_sub_type = x.m_sub_type;
    m_cipv_flag = x.m_cipv_flag;

    return *this;
}

ros2_interface::msg::HMIObstacle& ros2_interface::msg::HMIObstacle::operator =(
        HMIObstacle&& x) noexcept
{

    m_id = x.m_id;
    m_center_pos_vehicle = std::move(x.m_center_pos_vehicle);
    m_center_pos_abs = std::move(x.m_center_pos_abs);
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_sub_type = x.m_sub_type;
    m_cipv_flag = x.m_cipv_flag;

    return *this;
}

bool ros2_interface::msg::HMIObstacle::operator ==(
        const HMIObstacle& x) const
{

    return (m_id == x.m_id && m_center_pos_vehicle == x.m_center_pos_vehicle && m_center_pos_abs == x.m_center_pos_abs && m_theta_vehicle == x.m_theta_vehicle && m_theta_abs == x.m_theta_abs && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_type == x.m_type && m_confidence == x.m_confidence && m_confidence_type == x.m_confidence_type && m_sub_type == x.m_sub_type && m_cipv_flag == x.m_cipv_flag);
}

bool ros2_interface::msg::HMIObstacle::operator !=(
        const HMIObstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::HMIObstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIObstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::HMIObstacle::getCdrSerializedSize(
        const ros2_interface::msg::HMIObstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.center_pos_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.center_pos_abs(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::HMIObstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_id;
    scdr << m_center_pos_vehicle;
    scdr << m_center_pos_abs;
    scdr << m_theta_vehicle;
    scdr << m_theta_abs;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_type;
    scdr << m_confidence;
    scdr << m_confidence_type;
    scdr << m_sub_type;
    scdr << m_cipv_flag;

}

void ros2_interface::msg::HMIObstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_id;
    dcdr >> m_center_pos_vehicle;
    dcdr >> m_center_pos_abs;
    dcdr >> m_theta_vehicle;
    dcdr >> m_theta_abs;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_type;
    dcdr >> m_confidence;
    dcdr >> m_confidence_type;
    dcdr >> m_sub_type;
    dcdr >> m_cipv_flag;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::HMIObstacle::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::HMIObstacle::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::HMIObstacle::id()
{
    return m_id;
}

/*!
 * @brief This function copies the value in member center_pos_vehicle
 * @param _center_pos_vehicle New value to be copied in member center_pos_vehicle
 */
void ros2_interface::msg::HMIObstacle::center_pos_vehicle(
        const ros2_interface::msg::Point3D& _center_pos_vehicle)
{
    m_center_pos_vehicle = _center_pos_vehicle;
}

/*!
 * @brief This function moves the value in member center_pos_vehicle
 * @param _center_pos_vehicle New value to be moved in member center_pos_vehicle
 */
void ros2_interface::msg::HMIObstacle::center_pos_vehicle(
        ros2_interface::msg::Point3D&& _center_pos_vehicle)
{
    m_center_pos_vehicle = std::move(_center_pos_vehicle);
}

/*!
 * @brief This function returns a constant reference to member center_pos_vehicle
 * @return Constant reference to member center_pos_vehicle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::HMIObstacle::center_pos_vehicle() const
{
    return m_center_pos_vehicle;
}

/*!
 * @brief This function returns a reference to member center_pos_vehicle
 * @return Reference to member center_pos_vehicle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::HMIObstacle::center_pos_vehicle()
{
    return m_center_pos_vehicle;
}
/*!
 * @brief This function copies the value in member center_pos_abs
 * @param _center_pos_abs New value to be copied in member center_pos_abs
 */
void ros2_interface::msg::HMIObstacle::center_pos_abs(
        const ros2_interface::msg::Point3D& _center_pos_abs)
{
    m_center_pos_abs = _center_pos_abs;
}

/*!
 * @brief This function moves the value in member center_pos_abs
 * @param _center_pos_abs New value to be moved in member center_pos_abs
 */
void ros2_interface::msg::HMIObstacle::center_pos_abs(
        ros2_interface::msg::Point3D&& _center_pos_abs)
{
    m_center_pos_abs = std::move(_center_pos_abs);
}

/*!
 * @brief This function returns a constant reference to member center_pos_abs
 * @return Constant reference to member center_pos_abs
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::HMIObstacle::center_pos_abs() const
{
    return m_center_pos_abs;
}

/*!
 * @brief This function returns a reference to member center_pos_abs
 * @return Reference to member center_pos_abs
 */
ros2_interface::msg::Point3D& ros2_interface::msg::HMIObstacle::center_pos_abs()
{
    return m_center_pos_abs;
}
/*!
 * @brief This function sets a value in member theta_vehicle
 * @param _theta_vehicle New value for member theta_vehicle
 */
void ros2_interface::msg::HMIObstacle::theta_vehicle(
        double _theta_vehicle)
{
    m_theta_vehicle = _theta_vehicle;
}

/*!
 * @brief This function returns the value of member theta_vehicle
 * @return Value of member theta_vehicle
 */
double ros2_interface::msg::HMIObstacle::theta_vehicle() const
{
    return m_theta_vehicle;
}

/*!
 * @brief This function returns a reference to member theta_vehicle
 * @return Reference to member theta_vehicle
 */
double& ros2_interface::msg::HMIObstacle::theta_vehicle()
{
    return m_theta_vehicle;
}

/*!
 * @brief This function sets a value in member theta_abs
 * @param _theta_abs New value for member theta_abs
 */
void ros2_interface::msg::HMIObstacle::theta_abs(
        double _theta_abs)
{
    m_theta_abs = _theta_abs;
}

/*!
 * @brief This function returns the value of member theta_abs
 * @return Value of member theta_abs
 */
double ros2_interface::msg::HMIObstacle::theta_abs() const
{
    return m_theta_abs;
}

/*!
 * @brief This function returns a reference to member theta_abs
 * @return Reference to member theta_abs
 */
double& ros2_interface::msg::HMIObstacle::theta_abs()
{
    return m_theta_abs;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::HMIObstacle::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::HMIObstacle::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::HMIObstacle::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::HMIObstacle::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::HMIObstacle::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::HMIObstacle::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::HMIObstacle::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::HMIObstacle::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::HMIObstacle::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::HMIObstacle::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::HMIObstacle::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::HMIObstacle::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::HMIObstacle::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::HMIObstacle::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::HMIObstacle::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function sets a value in member confidence_type
 * @param _confidence_type New value for member confidence_type
 */
void ros2_interface::msg::HMIObstacle::confidence_type(
        int32_t _confidence_type)
{
    m_confidence_type = _confidence_type;
}

/*!
 * @brief This function returns the value of member confidence_type
 * @return Value of member confidence_type
 */
int32_t ros2_interface::msg::HMIObstacle::confidence_type() const
{
    return m_confidence_type;
}

/*!
 * @brief This function returns a reference to member confidence_type
 * @return Reference to member confidence_type
 */
int32_t& ros2_interface::msg::HMIObstacle::confidence_type()
{
    return m_confidence_type;
}

/*!
 * @brief This function sets a value in member sub_type
 * @param _sub_type New value for member sub_type
 */
void ros2_interface::msg::HMIObstacle::sub_type(
        int32_t _sub_type)
{
    m_sub_type = _sub_type;
}

/*!
 * @brief This function returns the value of member sub_type
 * @return Value of member sub_type
 */
int32_t ros2_interface::msg::HMIObstacle::sub_type() const
{
    return m_sub_type;
}

/*!
 * @brief This function returns a reference to member sub_type
 * @return Reference to member sub_type
 */
int32_t& ros2_interface::msg::HMIObstacle::sub_type()
{
    return m_sub_type;
}

/*!
 * @brief This function sets a value in member cipv_flag
 * @param _cipv_flag New value for member cipv_flag
 */
void ros2_interface::msg::HMIObstacle::cipv_flag(
        uint8_t _cipv_flag)
{
    m_cipv_flag = _cipv_flag;
}

/*!
 * @brief This function returns the value of member cipv_flag
 * @return Value of member cipv_flag
 */
uint8_t ros2_interface::msg::HMIObstacle::cipv_flag() const
{
    return m_cipv_flag;
}

/*!
 * @brief This function returns a reference to member cipv_flag
 * @return Reference to member cipv_flag
 */
uint8_t& ros2_interface::msg::HMIObstacle::cipv_flag()
{
    return m_cipv_flag;
}



size_t ros2_interface::msg::HMIObstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIObstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::HMIObstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::HMIObstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



