// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIObstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIOBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIOBSTACLE_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(HMIOBSTACLE_SOURCE)
#define HMIOBSTACLE_DllAPI __declspec( dllexport )
#else
#define HMIOBSTACLE_DllAPI __declspec( dllimport )
#endif // HMIOBSTACLE_SOURCE
#else
#define HMIOBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define HMIOBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure HMIObstacle defined by the user in the IDL file.
         * @ingroup HMIObstacle
         */
        class HMIObstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport HMIObstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~HMIObstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::HMIObstacle that will be copied.
             */
            eProsima_user_DllExport HMIObstacle(
                    const HMIObstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::HMIObstacle that will be copied.
             */
            eProsima_user_DllExport HMIObstacle(
                    HMIObstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::HMIObstacle that will be copied.
             */
            eProsima_user_DllExport HMIObstacle& operator =(
                    const HMIObstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::HMIObstacle that will be copied.
             */
            eProsima_user_DllExport HMIObstacle& operator =(
                    HMIObstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HMIObstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const HMIObstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HMIObstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const HMIObstacle& x) const;

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function copies the value in member center_pos_vehicle
             * @param _center_pos_vehicle New value to be copied in member center_pos_vehicle
             */
            eProsima_user_DllExport void center_pos_vehicle(
                    const ros2_interface::msg::Point3D& _center_pos_vehicle);

            /*!
             * @brief This function moves the value in member center_pos_vehicle
             * @param _center_pos_vehicle New value to be moved in member center_pos_vehicle
             */
            eProsima_user_DllExport void center_pos_vehicle(
                    ros2_interface::msg::Point3D&& _center_pos_vehicle);

            /*!
             * @brief This function returns a constant reference to member center_pos_vehicle
             * @return Constant reference to member center_pos_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& center_pos_vehicle() const;

            /*!
             * @brief This function returns a reference to member center_pos_vehicle
             * @return Reference to member center_pos_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& center_pos_vehicle();
            /*!
             * @brief This function copies the value in member center_pos_abs
             * @param _center_pos_abs New value to be copied in member center_pos_abs
             */
            eProsima_user_DllExport void center_pos_abs(
                    const ros2_interface::msg::Point3D& _center_pos_abs);

            /*!
             * @brief This function moves the value in member center_pos_abs
             * @param _center_pos_abs New value to be moved in member center_pos_abs
             */
            eProsima_user_DllExport void center_pos_abs(
                    ros2_interface::msg::Point3D&& _center_pos_abs);

            /*!
             * @brief This function returns a constant reference to member center_pos_abs
             * @return Constant reference to member center_pos_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& center_pos_abs() const;

            /*!
             * @brief This function returns a reference to member center_pos_abs
             * @return Reference to member center_pos_abs
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& center_pos_abs();
            /*!
             * @brief This function sets a value in member theta_vehicle
             * @param _theta_vehicle New value for member theta_vehicle
             */
            eProsima_user_DllExport void theta_vehicle(
                    double _theta_vehicle);

            /*!
             * @brief This function returns the value of member theta_vehicle
             * @return Value of member theta_vehicle
             */
            eProsima_user_DllExport double theta_vehicle() const;

            /*!
             * @brief This function returns a reference to member theta_vehicle
             * @return Reference to member theta_vehicle
             */
            eProsima_user_DllExport double& theta_vehicle();

            /*!
             * @brief This function sets a value in member theta_abs
             * @param _theta_abs New value for member theta_abs
             */
            eProsima_user_DllExport void theta_abs(
                    double _theta_abs);

            /*!
             * @brief This function returns the value of member theta_abs
             * @return Value of member theta_abs
             */
            eProsima_user_DllExport double theta_abs() const;

            /*!
             * @brief This function returns a reference to member theta_abs
             * @return Reference to member theta_abs
             */
            eProsima_user_DllExport double& theta_abs();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function sets a value in member confidence_type
             * @param _confidence_type New value for member confidence_type
             */
            eProsima_user_DllExport void confidence_type(
                    int32_t _confidence_type);

            /*!
             * @brief This function returns the value of member confidence_type
             * @return Value of member confidence_type
             */
            eProsima_user_DllExport int32_t confidence_type() const;

            /*!
             * @brief This function returns a reference to member confidence_type
             * @return Reference to member confidence_type
             */
            eProsima_user_DllExport int32_t& confidence_type();

            /*!
             * @brief This function sets a value in member sub_type
             * @param _sub_type New value for member sub_type
             */
            eProsima_user_DllExport void sub_type(
                    int32_t _sub_type);

            /*!
             * @brief This function returns the value of member sub_type
             * @return Value of member sub_type
             */
            eProsima_user_DllExport int32_t sub_type() const;

            /*!
             * @brief This function returns a reference to member sub_type
             * @return Reference to member sub_type
             */
            eProsima_user_DllExport int32_t& sub_type();

            /*!
             * @brief This function sets a value in member cipv_flag
             * @param _cipv_flag New value for member cipv_flag
             */
            eProsima_user_DllExport void cipv_flag(
                    uint8_t _cipv_flag);

            /*!
             * @brief This function returns the value of member cipv_flag
             * @return Value of member cipv_flag
             */
            eProsima_user_DllExport uint8_t cipv_flag() const;

            /*!
             * @brief This function returns a reference to member cipv_flag
             * @return Reference to member cipv_flag
             */
            eProsima_user_DllExport uint8_t& cipv_flag();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::HMIObstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_id;
            ros2_interface::msg::Point3D m_center_pos_vehicle;
            ros2_interface::msg::Point3D m_center_pos_abs;
            double m_theta_vehicle;
            double m_theta_abs;
            double m_length;
            double m_width;
            double m_height;
            int32_t m_type;
            double m_confidence;
            int32_t m_confidence_type;
            int32_t m_sub_type;
            uint8_t m_cipv_flag;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIOBSTACLE_H_

