// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIObstacleList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "HMIObstacleList.h"
#include "HMIObstacleListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_HMIObstacleList_max_cdr_typesize 12296ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_HMIObstacle_max_cdr_typesize 121ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_HMIObstacleList_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_HMIObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::HMIObstacleList::HMIObstacleList()
{
    // ros2_interface::msg::Header m_header

    // long m_sensor_id
    m_sensor_id = 0;
    // sequence<ros2_interface::msg::HMIObstacle> m_obstacle

    // long m_error_code
    m_error_code = 0;
    // boolean m_is_valid
    m_is_valid = false;
    // long m_change_origin_flag
    m_change_origin_flag = 0;

    // Just to register all known types
    registerHMIObstacleListTypes();
}

ros2_interface::msg::HMIObstacleList::~HMIObstacleList()
{






}

ros2_interface::msg::HMIObstacleList::HMIObstacleList(
        const HMIObstacleList& x)
{
    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_obstacle = x.m_obstacle;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
    m_change_origin_flag = x.m_change_origin_flag;
}

ros2_interface::msg::HMIObstacleList::HMIObstacleList(
        HMIObstacleList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_obstacle = std::move(x.m_obstacle);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
    m_change_origin_flag = x.m_change_origin_flag;
}

ros2_interface::msg::HMIObstacleList& ros2_interface::msg::HMIObstacleList::operator =(
        const HMIObstacleList& x)
{

    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_obstacle = x.m_obstacle;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
    m_change_origin_flag = x.m_change_origin_flag;

    return *this;
}

ros2_interface::msg::HMIObstacleList& ros2_interface::msg::HMIObstacleList::operator =(
        HMIObstacleList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_obstacle = std::move(x.m_obstacle);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
    m_change_origin_flag = x.m_change_origin_flag;

    return *this;
}

bool ros2_interface::msg::HMIObstacleList::operator ==(
        const HMIObstacleList& x) const
{

    return (m_header == x.m_header && m_sensor_id == x.m_sensor_id && m_obstacle == x.m_obstacle && m_error_code == x.m_error_code && m_is_valid == x.m_is_valid && m_change_origin_flag == x.m_change_origin_flag);
}

bool ros2_interface::msg::HMIObstacleList::operator !=(
        const HMIObstacleList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::HMIObstacleList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIObstacleList_max_cdr_typesize;
}

size_t ros2_interface::msg::HMIObstacleList::getCdrSerializedSize(
        const ros2_interface::msg::HMIObstacleList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.obstacle().size(); ++a)
    {
        current_alignment += ros2_interface::msg::HMIObstacle::getCdrSerializedSize(data.obstacle().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::HMIObstacleList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_sensor_id;
    scdr << m_obstacle;
    scdr << m_error_code;
    scdr << m_is_valid;
    scdr << m_change_origin_flag;

}

void ros2_interface::msg::HMIObstacleList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_sensor_id;
    dcdr >> m_obstacle;
    dcdr >> m_error_code;
    dcdr >> m_is_valid;
    dcdr >> m_change_origin_flag;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::HMIObstacleList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::HMIObstacleList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::HMIObstacleList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::HMIObstacleList::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member sensor_id
 * @param _sensor_id New value for member sensor_id
 */
void ros2_interface::msg::HMIObstacleList::sensor_id(
        int32_t _sensor_id)
{
    m_sensor_id = _sensor_id;
}

/*!
 * @brief This function returns the value of member sensor_id
 * @return Value of member sensor_id
 */
int32_t ros2_interface::msg::HMIObstacleList::sensor_id() const
{
    return m_sensor_id;
}

/*!
 * @brief This function returns a reference to member sensor_id
 * @return Reference to member sensor_id
 */
int32_t& ros2_interface::msg::HMIObstacleList::sensor_id()
{
    return m_sensor_id;
}

/*!
 * @brief This function copies the value in member obstacle
 * @param _obstacle New value to be copied in member obstacle
 */
void ros2_interface::msg::HMIObstacleList::obstacle(
        const std::vector<ros2_interface::msg::HMIObstacle>& _obstacle)
{
    m_obstacle = _obstacle;
}

/*!
 * @brief This function moves the value in member obstacle
 * @param _obstacle New value to be moved in member obstacle
 */
void ros2_interface::msg::HMIObstacleList::obstacle(
        std::vector<ros2_interface::msg::HMIObstacle>&& _obstacle)
{
    m_obstacle = std::move(_obstacle);
}

/*!
 * @brief This function returns a constant reference to member obstacle
 * @return Constant reference to member obstacle
 */
const std::vector<ros2_interface::msg::HMIObstacle>& ros2_interface::msg::HMIObstacleList::obstacle() const
{
    return m_obstacle;
}

/*!
 * @brief This function returns a reference to member obstacle
 * @return Reference to member obstacle
 */
std::vector<ros2_interface::msg::HMIObstacle>& ros2_interface::msg::HMIObstacleList::obstacle()
{
    return m_obstacle;
}
/*!
 * @brief This function sets a value in member error_code
 * @param _error_code New value for member error_code
 */
void ros2_interface::msg::HMIObstacleList::error_code(
        int32_t _error_code)
{
    m_error_code = _error_code;
}

/*!
 * @brief This function returns the value of member error_code
 * @return Value of member error_code
 */
int32_t ros2_interface::msg::HMIObstacleList::error_code() const
{
    return m_error_code;
}

/*!
 * @brief This function returns a reference to member error_code
 * @return Reference to member error_code
 */
int32_t& ros2_interface::msg::HMIObstacleList::error_code()
{
    return m_error_code;
}

/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::HMIObstacleList::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::HMIObstacleList::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::HMIObstacleList::is_valid()
{
    return m_is_valid;
}

/*!
 * @brief This function sets a value in member change_origin_flag
 * @param _change_origin_flag New value for member change_origin_flag
 */
void ros2_interface::msg::HMIObstacleList::change_origin_flag(
        int32_t _change_origin_flag)
{
    m_change_origin_flag = _change_origin_flag;
}

/*!
 * @brief This function returns the value of member change_origin_flag
 * @return Value of member change_origin_flag
 */
int32_t ros2_interface::msg::HMIObstacleList::change_origin_flag() const
{
    return m_change_origin_flag;
}

/*!
 * @brief This function returns a reference to member change_origin_flag
 * @return Reference to member change_origin_flag
 */
int32_t& ros2_interface::msg::HMIObstacleList::change_origin_flag()
{
    return m_change_origin_flag;
}



size_t ros2_interface::msg::HMIObstacleList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIObstacleList_max_key_cdr_typesize;
}

bool ros2_interface::msg::HMIObstacleList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::HMIObstacleList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



