// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIObstacleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "HMIObstacle.h"
#include "HMIObstacleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerHMIObstacleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::HMIObstacle", ros2_interface::msg::GetHMIObstacleIdentifier(true),
                        ros2_interface::msg::GetHMIObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::HMIObstacle", ros2_interface::msg::GetHMIObstacleIdentifier(false),
                        ros2_interface::msg::GetHMIObstacleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetHMIObstacleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("HMIObstacle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetHMIObstacleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("HMIObstacle", complete);
        }

        const TypeObject* GetHMIObstacleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIObstacle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteHMIObstacleObject();
            }
            //else
            return GetMinimalHMIObstacleObject();
        }

        const TypeObject* GetMinimalHMIObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIObstacle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_center_pos_vehicle;
            mst_center_pos_vehicle.common().member_id(memberId++);
            mst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_center_pos_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_center_pos_vehicle.common().member_flags().IS_KEY(false);
            mst_center_pos_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_center_pos_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 center_pos_vehicle_hash("center_pos_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_center_pos_vehicle.detail().name_hash()[i] = center_pos_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_center_pos_vehicle);

            MinimalStructMember mst_center_pos_abs;
            mst_center_pos_abs.common().member_id(memberId++);
            mst_center_pos_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_center_pos_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_center_pos_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_center_pos_abs.common().member_flags().IS_OPTIONAL(false);
            mst_center_pos_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_center_pos_abs.common().member_flags().IS_KEY(false);
            mst_center_pos_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_center_pos_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 center_pos_abs_hash("center_pos_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_center_pos_abs.detail().name_hash()[i] = center_pos_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_center_pos_abs);

            MinimalStructMember mst_theta_vehicle;
            mst_theta_vehicle.common().member_id(memberId++);
            mst_theta_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_theta_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_vehicle.common().member_flags().IS_KEY(false);
            mst_theta_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_vehicle_hash("theta_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_vehicle.detail().name_hash()[i] = theta_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_vehicle);

            MinimalStructMember mst_theta_abs;
            mst_theta_abs.common().member_id(memberId++);
            mst_theta_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_abs.common().member_flags().IS_OPTIONAL(false);
            mst_theta_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_abs.common().member_flags().IS_KEY(false);
            mst_theta_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_abs_hash("theta_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_abs.detail().name_hash()[i] = theta_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_abs);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_confidence_type;
            mst_confidence_type.common().member_id(memberId++);
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            mst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence_type.common().member_flags().IS_KEY(false);
            mst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 confidence_type_hash("confidence_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence_type.detail().name_hash()[i] = confidence_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence_type);

            MinimalStructMember mst_sub_type;
            mst_sub_type.common().member_id(memberId++);
            mst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sub_type.common().member_flags().IS_OPTIONAL(false);
            mst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sub_type.common().member_flags().IS_KEY(false);
            mst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sub_type_hash("sub_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_sub_type.detail().name_hash()[i] = sub_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sub_type);

            MinimalStructMember mst_cipv_flag;
            mst_cipv_flag.common().member_id(memberId++);
            mst_cipv_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cipv_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cipv_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cipv_flag.common().member_flags().IS_OPTIONAL(false);
            mst_cipv_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cipv_flag.common().member_flags().IS_KEY(false);
            mst_cipv_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cipv_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 cipv_flag_hash("cipv_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_cipv_flag.detail().name_hash()[i] = cipv_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cipv_flag);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HMIObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HMIObstacle", false);
        }

        const TypeObject* GetCompleteHMIObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIObstacle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_center_pos_vehicle;
            cst_center_pos_vehicle.common().member_id(memberId++);
            cst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_center_pos_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_center_pos_vehicle.common().member_flags().IS_KEY(false);
            cst_center_pos_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_center_pos_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_center_pos_vehicle.detail().name("center_pos_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_center_pos_vehicle);

            CompleteStructMember cst_center_pos_abs;
            cst_center_pos_abs.common().member_id(memberId++);
            cst_center_pos_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_center_pos_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_center_pos_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_center_pos_abs.common().member_flags().IS_OPTIONAL(false);
            cst_center_pos_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_center_pos_abs.common().member_flags().IS_KEY(false);
            cst_center_pos_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_center_pos_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_center_pos_abs.detail().name("center_pos_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_center_pos_abs);

            CompleteStructMember cst_theta_vehicle;
            cst_theta_vehicle.common().member_id(memberId++);
            cst_theta_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_theta_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_vehicle.common().member_flags().IS_KEY(false);
            cst_theta_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_vehicle.detail().name("theta_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_vehicle);

            CompleteStructMember cst_theta_abs;
            cst_theta_abs.common().member_id(memberId++);
            cst_theta_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_abs.common().member_flags().IS_OPTIONAL(false);
            cst_theta_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_abs.common().member_flags().IS_KEY(false);
            cst_theta_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_abs.detail().name("theta_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_abs);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_confidence_type;
            cst_confidence_type.common().member_id(memberId++);
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            cst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence_type.common().member_flags().IS_KEY(false);
            cst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_confidence_type.detail().name("confidence_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence_type);

            CompleteStructMember cst_sub_type;
            cst_sub_type.common().member_id(memberId++);
            cst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sub_type.common().member_flags().IS_OPTIONAL(false);
            cst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sub_type.common().member_flags().IS_KEY(false);
            cst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sub_type.detail().name("sub_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sub_type);

            CompleteStructMember cst_cipv_flag;
            cst_cipv_flag.common().member_id(memberId++);
            cst_cipv_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cipv_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cipv_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cipv_flag.common().member_flags().IS_OPTIONAL(false);
            cst_cipv_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cipv_flag.common().member_flags().IS_KEY(false);
            cst_cipv_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cipv_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_cipv_flag.detail().name("cipv_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cipv_flag);


            // Header
            type_object->complete().struct_type().header().detail().type_name("HMIObstacle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HMIObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HMIObstacle", true);
        }

    } // namespace msg
} // namespace ros2_interface