// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIVehicleMsg.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "HMIVehicleMsg.h"
#include "HMIVehicleMsgTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_HMIVehicleMsg_max_cdr_typesize 416ULL;
#define ros2_interface_msg_PointENU_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_PointLLH_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_HMIVehicleMsg_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointENU_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointLLH_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::HMIVehicleMsg::HMIVehicleMsg()
{
    // ros2_interface::msg::Header m_header

    // long m_driving_mode
    m_driving_mode = 0;
    // long m_gear_location
    m_gear_location = 0;
    // double m_steering_value
    m_steering_value = 0.0;
    // double m_accel_value
    m_accel_value = 0.0;
    // double m_brake_value
    m_brake_value = 0.0;
    // double m_speed_mps
    m_speed_mps = 0.0;
    // ros2_interface::msg::PointLLH m_position

    // ros2_interface::msg::PointENU m_utm_position

    // double m_pitch
    m_pitch = 0.0;
    // double m_roll
    m_roll = 0.0;
    // double m_heading
    m_heading = 0.0;
    // long m_rtk_flag
    m_rtk_flag = 0;
    // double m_origin_lat
    m_origin_lat = 0.0;
    // double m_origin_lon
    m_origin_lon = 0.0;
    // double m_current_ins_yaw
    m_current_ins_yaw = 0.0;

    // Just to register all known types
    registerHMIVehicleMsgTypes();
}

ros2_interface::msg::HMIVehicleMsg::~HMIVehicleMsg()
{
















}

ros2_interface::msg::HMIVehicleMsg::HMIVehicleMsg(
        const HMIVehicleMsg& x)
{
    m_header = x.m_header;
    m_driving_mode = x.m_driving_mode;
    m_gear_location = x.m_gear_location;
    m_steering_value = x.m_steering_value;
    m_accel_value = x.m_accel_value;
    m_brake_value = x.m_brake_value;
    m_speed_mps = x.m_speed_mps;
    m_position = x.m_position;
    m_utm_position = x.m_utm_position;
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_rtk_flag = x.m_rtk_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_current_ins_yaw = x.m_current_ins_yaw;
}

ros2_interface::msg::HMIVehicleMsg::HMIVehicleMsg(
        HMIVehicleMsg&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_driving_mode = x.m_driving_mode;
    m_gear_location = x.m_gear_location;
    m_steering_value = x.m_steering_value;
    m_accel_value = x.m_accel_value;
    m_brake_value = x.m_brake_value;
    m_speed_mps = x.m_speed_mps;
    m_position = std::move(x.m_position);
    m_utm_position = std::move(x.m_utm_position);
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_rtk_flag = x.m_rtk_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_current_ins_yaw = x.m_current_ins_yaw;
}

ros2_interface::msg::HMIVehicleMsg& ros2_interface::msg::HMIVehicleMsg::operator =(
        const HMIVehicleMsg& x)
{

    m_header = x.m_header;
    m_driving_mode = x.m_driving_mode;
    m_gear_location = x.m_gear_location;
    m_steering_value = x.m_steering_value;
    m_accel_value = x.m_accel_value;
    m_brake_value = x.m_brake_value;
    m_speed_mps = x.m_speed_mps;
    m_position = x.m_position;
    m_utm_position = x.m_utm_position;
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_rtk_flag = x.m_rtk_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_current_ins_yaw = x.m_current_ins_yaw;

    return *this;
}

ros2_interface::msg::HMIVehicleMsg& ros2_interface::msg::HMIVehicleMsg::operator =(
        HMIVehicleMsg&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_driving_mode = x.m_driving_mode;
    m_gear_location = x.m_gear_location;
    m_steering_value = x.m_steering_value;
    m_accel_value = x.m_accel_value;
    m_brake_value = x.m_brake_value;
    m_speed_mps = x.m_speed_mps;
    m_position = std::move(x.m_position);
    m_utm_position = std::move(x.m_utm_position);
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_rtk_flag = x.m_rtk_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_current_ins_yaw = x.m_current_ins_yaw;

    return *this;
}

bool ros2_interface::msg::HMIVehicleMsg::operator ==(
        const HMIVehicleMsg& x) const
{

    return (m_header == x.m_header && m_driving_mode == x.m_driving_mode && m_gear_location == x.m_gear_location && m_steering_value == x.m_steering_value && m_accel_value == x.m_accel_value && m_brake_value == x.m_brake_value && m_speed_mps == x.m_speed_mps && m_position == x.m_position && m_utm_position == x.m_utm_position && m_pitch == x.m_pitch && m_roll == x.m_roll && m_heading == x.m_heading && m_rtk_flag == x.m_rtk_flag && m_origin_lat == x.m_origin_lat && m_origin_lon == x.m_origin_lon && m_current_ins_yaw == x.m_current_ins_yaw);
}

bool ros2_interface::msg::HMIVehicleMsg::operator !=(
        const HMIVehicleMsg& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::HMIVehicleMsg::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIVehicleMsg_max_cdr_typesize;
}

size_t ros2_interface::msg::HMIVehicleMsg::getCdrSerializedSize(
        const ros2_interface::msg::HMIVehicleMsg& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::PointLLH::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += ros2_interface::msg::PointENU::getCdrSerializedSize(data.utm_position(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::HMIVehicleMsg::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_driving_mode;
    scdr << m_gear_location;
    scdr << m_steering_value;
    scdr << m_accel_value;
    scdr << m_brake_value;
    scdr << m_speed_mps;
    scdr << m_position;
    scdr << m_utm_position;
    scdr << m_pitch;
    scdr << m_roll;
    scdr << m_heading;
    scdr << m_rtk_flag;
    scdr << m_origin_lat;
    scdr << m_origin_lon;
    scdr << m_current_ins_yaw;

}

void ros2_interface::msg::HMIVehicleMsg::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_driving_mode;
    dcdr >> m_gear_location;
    dcdr >> m_steering_value;
    dcdr >> m_accel_value;
    dcdr >> m_brake_value;
    dcdr >> m_speed_mps;
    dcdr >> m_position;
    dcdr >> m_utm_position;
    dcdr >> m_pitch;
    dcdr >> m_roll;
    dcdr >> m_heading;
    dcdr >> m_rtk_flag;
    dcdr >> m_origin_lat;
    dcdr >> m_origin_lon;
    dcdr >> m_current_ins_yaw;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::HMIVehicleMsg::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::HMIVehicleMsg::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::HMIVehicleMsg::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::HMIVehicleMsg::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member driving_mode
 * @param _driving_mode New value for member driving_mode
 */
void ros2_interface::msg::HMIVehicleMsg::driving_mode(
        int32_t _driving_mode)
{
    m_driving_mode = _driving_mode;
}

/*!
 * @brief This function returns the value of member driving_mode
 * @return Value of member driving_mode
 */
int32_t ros2_interface::msg::HMIVehicleMsg::driving_mode() const
{
    return m_driving_mode;
}

/*!
 * @brief This function returns a reference to member driving_mode
 * @return Reference to member driving_mode
 */
int32_t& ros2_interface::msg::HMIVehicleMsg::driving_mode()
{
    return m_driving_mode;
}

/*!
 * @brief This function sets a value in member gear_location
 * @param _gear_location New value for member gear_location
 */
void ros2_interface::msg::HMIVehicleMsg::gear_location(
        int32_t _gear_location)
{
    m_gear_location = _gear_location;
}

/*!
 * @brief This function returns the value of member gear_location
 * @return Value of member gear_location
 */
int32_t ros2_interface::msg::HMIVehicleMsg::gear_location() const
{
    return m_gear_location;
}

/*!
 * @brief This function returns a reference to member gear_location
 * @return Reference to member gear_location
 */
int32_t& ros2_interface::msg::HMIVehicleMsg::gear_location()
{
    return m_gear_location;
}

/*!
 * @brief This function sets a value in member steering_value
 * @param _steering_value New value for member steering_value
 */
void ros2_interface::msg::HMIVehicleMsg::steering_value(
        double _steering_value)
{
    m_steering_value = _steering_value;
}

/*!
 * @brief This function returns the value of member steering_value
 * @return Value of member steering_value
 */
double ros2_interface::msg::HMIVehicleMsg::steering_value() const
{
    return m_steering_value;
}

/*!
 * @brief This function returns a reference to member steering_value
 * @return Reference to member steering_value
 */
double& ros2_interface::msg::HMIVehicleMsg::steering_value()
{
    return m_steering_value;
}

/*!
 * @brief This function sets a value in member accel_value
 * @param _accel_value New value for member accel_value
 */
void ros2_interface::msg::HMIVehicleMsg::accel_value(
        double _accel_value)
{
    m_accel_value = _accel_value;
}

/*!
 * @brief This function returns the value of member accel_value
 * @return Value of member accel_value
 */
double ros2_interface::msg::HMIVehicleMsg::accel_value() const
{
    return m_accel_value;
}

/*!
 * @brief This function returns a reference to member accel_value
 * @return Reference to member accel_value
 */
double& ros2_interface::msg::HMIVehicleMsg::accel_value()
{
    return m_accel_value;
}

/*!
 * @brief This function sets a value in member brake_value
 * @param _brake_value New value for member brake_value
 */
void ros2_interface::msg::HMIVehicleMsg::brake_value(
        double _brake_value)
{
    m_brake_value = _brake_value;
}

/*!
 * @brief This function returns the value of member brake_value
 * @return Value of member brake_value
 */
double ros2_interface::msg::HMIVehicleMsg::brake_value() const
{
    return m_brake_value;
}

/*!
 * @brief This function returns a reference to member brake_value
 * @return Reference to member brake_value
 */
double& ros2_interface::msg::HMIVehicleMsg::brake_value()
{
    return m_brake_value;
}

/*!
 * @brief This function sets a value in member speed_mps
 * @param _speed_mps New value for member speed_mps
 */
void ros2_interface::msg::HMIVehicleMsg::speed_mps(
        double _speed_mps)
{
    m_speed_mps = _speed_mps;
}

/*!
 * @brief This function returns the value of member speed_mps
 * @return Value of member speed_mps
 */
double ros2_interface::msg::HMIVehicleMsg::speed_mps() const
{
    return m_speed_mps;
}

/*!
 * @brief This function returns a reference to member speed_mps
 * @return Reference to member speed_mps
 */
double& ros2_interface::msg::HMIVehicleMsg::speed_mps()
{
    return m_speed_mps;
}

/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::HMIVehicleMsg::position(
        const ros2_interface::msg::PointLLH& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::HMIVehicleMsg::position(
        ros2_interface::msg::PointLLH&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::PointLLH& ros2_interface::msg::HMIVehicleMsg::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::PointLLH& ros2_interface::msg::HMIVehicleMsg::position()
{
    return m_position;
}
/*!
 * @brief This function copies the value in member utm_position
 * @param _utm_position New value to be copied in member utm_position
 */
void ros2_interface::msg::HMIVehicleMsg::utm_position(
        const ros2_interface::msg::PointENU& _utm_position)
{
    m_utm_position = _utm_position;
}

/*!
 * @brief This function moves the value in member utm_position
 * @param _utm_position New value to be moved in member utm_position
 */
void ros2_interface::msg::HMIVehicleMsg::utm_position(
        ros2_interface::msg::PointENU&& _utm_position)
{
    m_utm_position = std::move(_utm_position);
}

/*!
 * @brief This function returns a constant reference to member utm_position
 * @return Constant reference to member utm_position
 */
const ros2_interface::msg::PointENU& ros2_interface::msg::HMIVehicleMsg::utm_position() const
{
    return m_utm_position;
}

/*!
 * @brief This function returns a reference to member utm_position
 * @return Reference to member utm_position
 */
ros2_interface::msg::PointENU& ros2_interface::msg::HMIVehicleMsg::utm_position()
{
    return m_utm_position;
}
/*!
 * @brief This function sets a value in member pitch
 * @param _pitch New value for member pitch
 */
void ros2_interface::msg::HMIVehicleMsg::pitch(
        double _pitch)
{
    m_pitch = _pitch;
}

/*!
 * @brief This function returns the value of member pitch
 * @return Value of member pitch
 */
double ros2_interface::msg::HMIVehicleMsg::pitch() const
{
    return m_pitch;
}

/*!
 * @brief This function returns a reference to member pitch
 * @return Reference to member pitch
 */
double& ros2_interface::msg::HMIVehicleMsg::pitch()
{
    return m_pitch;
}

/*!
 * @brief This function sets a value in member roll
 * @param _roll New value for member roll
 */
void ros2_interface::msg::HMIVehicleMsg::roll(
        double _roll)
{
    m_roll = _roll;
}

/*!
 * @brief This function returns the value of member roll
 * @return Value of member roll
 */
double ros2_interface::msg::HMIVehicleMsg::roll() const
{
    return m_roll;
}

/*!
 * @brief This function returns a reference to member roll
 * @return Reference to member roll
 */
double& ros2_interface::msg::HMIVehicleMsg::roll()
{
    return m_roll;
}

/*!
 * @brief This function sets a value in member heading
 * @param _heading New value for member heading
 */
void ros2_interface::msg::HMIVehicleMsg::heading(
        double _heading)
{
    m_heading = _heading;
}

/*!
 * @brief This function returns the value of member heading
 * @return Value of member heading
 */
double ros2_interface::msg::HMIVehicleMsg::heading() const
{
    return m_heading;
}

/*!
 * @brief This function returns a reference to member heading
 * @return Reference to member heading
 */
double& ros2_interface::msg::HMIVehicleMsg::heading()
{
    return m_heading;
}

/*!
 * @brief This function sets a value in member rtk_flag
 * @param _rtk_flag New value for member rtk_flag
 */
void ros2_interface::msg::HMIVehicleMsg::rtk_flag(
        int32_t _rtk_flag)
{
    m_rtk_flag = _rtk_flag;
}

/*!
 * @brief This function returns the value of member rtk_flag
 * @return Value of member rtk_flag
 */
int32_t ros2_interface::msg::HMIVehicleMsg::rtk_flag() const
{
    return m_rtk_flag;
}

/*!
 * @brief This function returns a reference to member rtk_flag
 * @return Reference to member rtk_flag
 */
int32_t& ros2_interface::msg::HMIVehicleMsg::rtk_flag()
{
    return m_rtk_flag;
}

/*!
 * @brief This function sets a value in member origin_lat
 * @param _origin_lat New value for member origin_lat
 */
void ros2_interface::msg::HMIVehicleMsg::origin_lat(
        double _origin_lat)
{
    m_origin_lat = _origin_lat;
}

/*!
 * @brief This function returns the value of member origin_lat
 * @return Value of member origin_lat
 */
double ros2_interface::msg::HMIVehicleMsg::origin_lat() const
{
    return m_origin_lat;
}

/*!
 * @brief This function returns a reference to member origin_lat
 * @return Reference to member origin_lat
 */
double& ros2_interface::msg::HMIVehicleMsg::origin_lat()
{
    return m_origin_lat;
}

/*!
 * @brief This function sets a value in member origin_lon
 * @param _origin_lon New value for member origin_lon
 */
void ros2_interface::msg::HMIVehicleMsg::origin_lon(
        double _origin_lon)
{
    m_origin_lon = _origin_lon;
}

/*!
 * @brief This function returns the value of member origin_lon
 * @return Value of member origin_lon
 */
double ros2_interface::msg::HMIVehicleMsg::origin_lon() const
{
    return m_origin_lon;
}

/*!
 * @brief This function returns a reference to member origin_lon
 * @return Reference to member origin_lon
 */
double& ros2_interface::msg::HMIVehicleMsg::origin_lon()
{
    return m_origin_lon;
}

/*!
 * @brief This function sets a value in member current_ins_yaw
 * @param _current_ins_yaw New value for member current_ins_yaw
 */
void ros2_interface::msg::HMIVehicleMsg::current_ins_yaw(
        double _current_ins_yaw)
{
    m_current_ins_yaw = _current_ins_yaw;
}

/*!
 * @brief This function returns the value of member current_ins_yaw
 * @return Value of member current_ins_yaw
 */
double ros2_interface::msg::HMIVehicleMsg::current_ins_yaw() const
{
    return m_current_ins_yaw;
}

/*!
 * @brief This function returns a reference to member current_ins_yaw
 * @return Reference to member current_ins_yaw
 */
double& ros2_interface::msg::HMIVehicleMsg::current_ins_yaw()
{
    return m_current_ins_yaw;
}



size_t ros2_interface::msg::HMIVehicleMsg::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HMIVehicleMsg_max_key_cdr_typesize;
}

bool ros2_interface::msg::HMIVehicleMsg::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::HMIVehicleMsg::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



