// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIVehicleMsg.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIVEHICLEMSG_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIVEHICLEMSG_H_

#include "Header.h"
#include "PointLLH.h"
#include "PointENU.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(HMIVEHICLEMSG_SOURCE)
#define HMIVEHICLEMSG_DllAPI __declspec( dllexport )
#else
#define HMIVEHICLEMSG_DllAPI __declspec( dllimport )
#endif // HMIVEHICLEMSG_SOURCE
#else
#define HMIVEHICLEMSG_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define HMIVEHICLEMSG_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure HMIVehicleMsg defined by the user in the IDL file.
         * @ingroup HMIVehicleMsg
         */
        class HMIVehicleMsg
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport HMIVehicleMsg();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~HMIVehicleMsg();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::HMIVehicleMsg that will be copied.
             */
            eProsima_user_DllExport HMIVehicleMsg(
                    const HMIVehicleMsg& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::HMIVehicleMsg that will be copied.
             */
            eProsima_user_DllExport HMIVehicleMsg(
                    HMIVehicleMsg&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::HMIVehicleMsg that will be copied.
             */
            eProsima_user_DllExport HMIVehicleMsg& operator =(
                    const HMIVehicleMsg& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::HMIVehicleMsg that will be copied.
             */
            eProsima_user_DllExport HMIVehicleMsg& operator =(
                    HMIVehicleMsg&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HMIVehicleMsg object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const HMIVehicleMsg& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HMIVehicleMsg object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const HMIVehicleMsg& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member driving_mode
             * @param _driving_mode New value for member driving_mode
             */
            eProsima_user_DllExport void driving_mode(
                    int32_t _driving_mode);

            /*!
             * @brief This function returns the value of member driving_mode
             * @return Value of member driving_mode
             */
            eProsima_user_DllExport int32_t driving_mode() const;

            /*!
             * @brief This function returns a reference to member driving_mode
             * @return Reference to member driving_mode
             */
            eProsima_user_DllExport int32_t& driving_mode();

            /*!
             * @brief This function sets a value in member gear_location
             * @param _gear_location New value for member gear_location
             */
            eProsima_user_DllExport void gear_location(
                    int32_t _gear_location);

            /*!
             * @brief This function returns the value of member gear_location
             * @return Value of member gear_location
             */
            eProsima_user_DllExport int32_t gear_location() const;

            /*!
             * @brief This function returns a reference to member gear_location
             * @return Reference to member gear_location
             */
            eProsima_user_DllExport int32_t& gear_location();

            /*!
             * @brief This function sets a value in member steering_value
             * @param _steering_value New value for member steering_value
             */
            eProsima_user_DllExport void steering_value(
                    double _steering_value);

            /*!
             * @brief This function returns the value of member steering_value
             * @return Value of member steering_value
             */
            eProsima_user_DllExport double steering_value() const;

            /*!
             * @brief This function returns a reference to member steering_value
             * @return Reference to member steering_value
             */
            eProsima_user_DllExport double& steering_value();

            /*!
             * @brief This function sets a value in member accel_value
             * @param _accel_value New value for member accel_value
             */
            eProsima_user_DllExport void accel_value(
                    double _accel_value);

            /*!
             * @brief This function returns the value of member accel_value
             * @return Value of member accel_value
             */
            eProsima_user_DllExport double accel_value() const;

            /*!
             * @brief This function returns a reference to member accel_value
             * @return Reference to member accel_value
             */
            eProsima_user_DllExport double& accel_value();

            /*!
             * @brief This function sets a value in member brake_value
             * @param _brake_value New value for member brake_value
             */
            eProsima_user_DllExport void brake_value(
                    double _brake_value);

            /*!
             * @brief This function returns the value of member brake_value
             * @return Value of member brake_value
             */
            eProsima_user_DllExport double brake_value() const;

            /*!
             * @brief This function returns a reference to member brake_value
             * @return Reference to member brake_value
             */
            eProsima_user_DllExport double& brake_value();

            /*!
             * @brief This function sets a value in member speed_mps
             * @param _speed_mps New value for member speed_mps
             */
            eProsima_user_DllExport void speed_mps(
                    double _speed_mps);

            /*!
             * @brief This function returns the value of member speed_mps
             * @return Value of member speed_mps
             */
            eProsima_user_DllExport double speed_mps() const;

            /*!
             * @brief This function returns a reference to member speed_mps
             * @return Reference to member speed_mps
             */
            eProsima_user_DllExport double& speed_mps();

            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::PointLLH& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::PointLLH&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::PointLLH& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::PointLLH& position();
            /*!
             * @brief This function copies the value in member utm_position
             * @param _utm_position New value to be copied in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    const ros2_interface::msg::PointENU& _utm_position);

            /*!
             * @brief This function moves the value in member utm_position
             * @param _utm_position New value to be moved in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    ros2_interface::msg::PointENU&& _utm_position);

            /*!
             * @brief This function returns a constant reference to member utm_position
             * @return Constant reference to member utm_position
             */
            eProsima_user_DllExport const ros2_interface::msg::PointENU& utm_position() const;

            /*!
             * @brief This function returns a reference to member utm_position
             * @return Reference to member utm_position
             */
            eProsima_user_DllExport ros2_interface::msg::PointENU& utm_position();
            /*!
             * @brief This function sets a value in member pitch
             * @param _pitch New value for member pitch
             */
            eProsima_user_DllExport void pitch(
                    double _pitch);

            /*!
             * @brief This function returns the value of member pitch
             * @return Value of member pitch
             */
            eProsima_user_DllExport double pitch() const;

            /*!
             * @brief This function returns a reference to member pitch
             * @return Reference to member pitch
             */
            eProsima_user_DllExport double& pitch();

            /*!
             * @brief This function sets a value in member roll
             * @param _roll New value for member roll
             */
            eProsima_user_DllExport void roll(
                    double _roll);

            /*!
             * @brief This function returns the value of member roll
             * @return Value of member roll
             */
            eProsima_user_DllExport double roll() const;

            /*!
             * @brief This function returns a reference to member roll
             * @return Reference to member roll
             */
            eProsima_user_DllExport double& roll();

            /*!
             * @brief This function sets a value in member heading
             * @param _heading New value for member heading
             */
            eProsima_user_DllExport void heading(
                    double _heading);

            /*!
             * @brief This function returns the value of member heading
             * @return Value of member heading
             */
            eProsima_user_DllExport double heading() const;

            /*!
             * @brief This function returns a reference to member heading
             * @return Reference to member heading
             */
            eProsima_user_DllExport double& heading();

            /*!
             * @brief This function sets a value in member rtk_flag
             * @param _rtk_flag New value for member rtk_flag
             */
            eProsima_user_DllExport void rtk_flag(
                    int32_t _rtk_flag);

            /*!
             * @brief This function returns the value of member rtk_flag
             * @return Value of member rtk_flag
             */
            eProsima_user_DllExport int32_t rtk_flag() const;

            /*!
             * @brief This function returns a reference to member rtk_flag
             * @return Reference to member rtk_flag
             */
            eProsima_user_DllExport int32_t& rtk_flag();

            /*!
             * @brief This function sets a value in member origin_lat
             * @param _origin_lat New value for member origin_lat
             */
            eProsima_user_DllExport void origin_lat(
                    double _origin_lat);

            /*!
             * @brief This function returns the value of member origin_lat
             * @return Value of member origin_lat
             */
            eProsima_user_DllExport double origin_lat() const;

            /*!
             * @brief This function returns a reference to member origin_lat
             * @return Reference to member origin_lat
             */
            eProsima_user_DllExport double& origin_lat();

            /*!
             * @brief This function sets a value in member origin_lon
             * @param _origin_lon New value for member origin_lon
             */
            eProsima_user_DllExport void origin_lon(
                    double _origin_lon);

            /*!
             * @brief This function returns the value of member origin_lon
             * @return Value of member origin_lon
             */
            eProsima_user_DllExport double origin_lon() const;

            /*!
             * @brief This function returns a reference to member origin_lon
             * @return Reference to member origin_lon
             */
            eProsima_user_DllExport double& origin_lon();

            /*!
             * @brief This function sets a value in member current_ins_yaw
             * @param _current_ins_yaw New value for member current_ins_yaw
             */
            eProsima_user_DllExport void current_ins_yaw(
                    double _current_ins_yaw);

            /*!
             * @brief This function returns the value of member current_ins_yaw
             * @return Value of member current_ins_yaw
             */
            eProsima_user_DllExport double current_ins_yaw() const;

            /*!
             * @brief This function returns a reference to member current_ins_yaw
             * @return Reference to member current_ins_yaw
             */
            eProsima_user_DllExport double& current_ins_yaw();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::HMIVehicleMsg& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_driving_mode;
            int32_t m_gear_location;
            double m_steering_value;
            double m_accel_value;
            double m_brake_value;
            double m_speed_mps;
            ros2_interface::msg::PointLLH m_position;
            ros2_interface::msg::PointENU m_utm_position;
            double m_pitch;
            double m_roll;
            double m_heading;
            int32_t m_rtk_flag;
            double m_origin_lat;
            double m_origin_lon;
            double m_current_ins_yaw;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HMIVEHICLEMSG_H_

