// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HMIVehicleMsgTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "HMIVehicleMsg.h"
#include "HMIVehicleMsgTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerHMIVehicleMsgTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(true),
                        ros2_interface::msg::GetPointLLHObject(true));
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(false),
                        ros2_interface::msg::GetPointLLHObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(true),
                        ros2_interface::msg::GetPointENUObject(true));
                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(false),
                        ros2_interface::msg::GetPointENUObject(false));



                factory->add_type_object("ros2_interface::msg::HMIVehicleMsg", ros2_interface::msg::GetHMIVehicleMsgIdentifier(true),
                        ros2_interface::msg::GetHMIVehicleMsgObject(true));
                factory->add_type_object("ros2_interface::msg::HMIVehicleMsg", ros2_interface::msg::GetHMIVehicleMsgIdentifier(false),
                        ros2_interface::msg::GetHMIVehicleMsgObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetHMIVehicleMsgIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("HMIVehicleMsg", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetHMIVehicleMsgObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("HMIVehicleMsg", complete);
        }

        const TypeObject* GetHMIVehicleMsgObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIVehicleMsg", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteHMIVehicleMsgObject();
            }
            //else
            return GetMinimalHMIVehicleMsgObject();
        }

        const TypeObject* GetMinimalHMIVehicleMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIVehicleMsg", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_driving_mode;
            mst_driving_mode.common().member_id(memberId++);
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_mode.common().member_flags().IS_KEY(false);
            mst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 driving_mode_hash("driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_mode.detail().name_hash()[i] = driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_mode);

            MinimalStructMember mst_gear_location;
            mst_gear_location.common().member_id(memberId++);
            mst_gear_location.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_location.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_location.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_location.common().member_flags().IS_OPTIONAL(false);
            mst_gear_location.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_location.common().member_flags().IS_KEY(false);
            mst_gear_location.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_location.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_location_hash("gear_location");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_location.detail().name_hash()[i] = gear_location_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_location);

            MinimalStructMember mst_steering_value;
            mst_steering_value.common().member_id(memberId++);
            mst_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_value.common().member_flags().IS_KEY(false);
            mst_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steering_value_hash("steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_value.detail().name_hash()[i] = steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_value);

            MinimalStructMember mst_accel_value;
            mst_accel_value.common().member_id(memberId++);
            mst_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_value.common().member_flags().IS_OPTIONAL(false);
            mst_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_value.common().member_flags().IS_KEY(false);
            mst_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 accel_value_hash("accel_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_value.detail().name_hash()[i] = accel_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_value);

            MinimalStructMember mst_brake_value;
            mst_brake_value.common().member_id(memberId++);
            mst_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_value.common().member_flags().IS_OPTIONAL(false);
            mst_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_value.common().member_flags().IS_KEY(false);
            mst_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_value_hash("brake_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_value.detail().name_hash()[i] = brake_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_value);

            MinimalStructMember mst_speed_mps;
            mst_speed_mps.common().member_id(memberId++);
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            mst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_mps.common().member_flags().IS_KEY(false);
            mst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_mps_hash("speed_mps");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_mps.detail().name_hash()[i] = speed_mps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_mps);

            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPointLLHIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_utm_position;
            mst_utm_position.common().member_id(memberId++);
            mst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_position.common().member_flags().IS_OPTIONAL(false);
            mst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_position.common().member_flags().IS_KEY(false);
            mst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(false));
            MD5 utm_position_hash("utm_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_position.detail().name_hash()[i] = utm_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_position);

            MinimalStructMember mst_pitch;
            mst_pitch.common().member_id(memberId++);
            mst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pitch.common().member_flags().IS_OPTIONAL(false);
            mst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pitch.common().member_flags().IS_KEY(false);
            mst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 pitch_hash("pitch");
            for(int i = 0; i < 4; ++i)
            {
                mst_pitch.detail().name_hash()[i] = pitch_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pitch);

            MinimalStructMember mst_roll;
            mst_roll.common().member_id(memberId++);
            mst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_roll.common().member_flags().IS_OPTIONAL(false);
            mst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_roll.common().member_flags().IS_KEY(false);
            mst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 roll_hash("roll");
            for(int i = 0; i < 4; ++i)
            {
                mst_roll.detail().name_hash()[i] = roll_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_roll);

            MinimalStructMember mst_heading;
            mst_heading.common().member_id(memberId++);
            mst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading.common().member_flags().IS_OPTIONAL(false);
            mst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading.common().member_flags().IS_KEY(false);
            mst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_hash("heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading.detail().name_hash()[i] = heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading);

            MinimalStructMember mst_rtk_flag;
            mst_rtk_flag.common().member_id(memberId++);
            mst_rtk_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rtk_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rtk_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rtk_flag.common().member_flags().IS_OPTIONAL(false);
            mst_rtk_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rtk_flag.common().member_flags().IS_KEY(false);
            mst_rtk_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rtk_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rtk_flag_hash("rtk_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_rtk_flag.detail().name_hash()[i] = rtk_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rtk_flag);

            MinimalStructMember mst_origin_lat;
            mst_origin_lat.common().member_id(memberId++);
            mst_origin_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_origin_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_origin_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_origin_lat.common().member_flags().IS_OPTIONAL(false);
            mst_origin_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_origin_lat.common().member_flags().IS_KEY(false);
            mst_origin_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_origin_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 origin_lat_hash("origin_lat");
            for(int i = 0; i < 4; ++i)
            {
                mst_origin_lat.detail().name_hash()[i] = origin_lat_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_origin_lat);

            MinimalStructMember mst_origin_lon;
            mst_origin_lon.common().member_id(memberId++);
            mst_origin_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_origin_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_origin_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_origin_lon.common().member_flags().IS_OPTIONAL(false);
            mst_origin_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_origin_lon.common().member_flags().IS_KEY(false);
            mst_origin_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_origin_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 origin_lon_hash("origin_lon");
            for(int i = 0; i < 4; ++i)
            {
                mst_origin_lon.detail().name_hash()[i] = origin_lon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_origin_lon);

            MinimalStructMember mst_current_ins_yaw;
            mst_current_ins_yaw.common().member_id(memberId++);
            mst_current_ins_yaw.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_current_ins_yaw.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_current_ins_yaw.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_current_ins_yaw.common().member_flags().IS_OPTIONAL(false);
            mst_current_ins_yaw.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_current_ins_yaw.common().member_flags().IS_KEY(false);
            mst_current_ins_yaw.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_current_ins_yaw.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 current_ins_yaw_hash("current_ins_yaw");
            for(int i = 0; i < 4; ++i)
            {
                mst_current_ins_yaw.detail().name_hash()[i] = current_ins_yaw_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_current_ins_yaw);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HMIVehicleMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HMIVehicleMsg", false);
        }

        const TypeObject* GetCompleteHMIVehicleMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HMIVehicleMsg", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_driving_mode;
            cst_driving_mode.common().member_id(memberId++);
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_mode.common().member_flags().IS_KEY(false);
            cst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_driving_mode.detail().name("driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_mode);

            CompleteStructMember cst_gear_location;
            cst_gear_location.common().member_id(memberId++);
            cst_gear_location.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_location.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_location.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_location.common().member_flags().IS_OPTIONAL(false);
            cst_gear_location.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_location.common().member_flags().IS_KEY(false);
            cst_gear_location.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_location.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_location.detail().name("gear_location");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_location);

            CompleteStructMember cst_steering_value;
            cst_steering_value.common().member_id(memberId++);
            cst_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_value.common().member_flags().IS_KEY(false);
            cst_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steering_value.detail().name("steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_value);

            CompleteStructMember cst_accel_value;
            cst_accel_value.common().member_id(memberId++);
            cst_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_value.common().member_flags().IS_OPTIONAL(false);
            cst_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_value.common().member_flags().IS_KEY(false);
            cst_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_accel_value.detail().name("accel_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_value);

            CompleteStructMember cst_brake_value;
            cst_brake_value.common().member_id(memberId++);
            cst_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_value.common().member_flags().IS_OPTIONAL(false);
            cst_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_value.common().member_flags().IS_KEY(false);
            cst_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_value.detail().name("brake_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_value);

            CompleteStructMember cst_speed_mps;
            cst_speed_mps.common().member_id(memberId++);
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            cst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_mps.common().member_flags().IS_KEY(false);
            cst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_mps.detail().name("speed_mps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_mps);

            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPointLLHIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_utm_position;
            cst_utm_position.common().member_id(memberId++);
            cst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_position.common().member_flags().IS_OPTIONAL(false);
            cst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_position.common().member_flags().IS_KEY(false);
            cst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(true));
            cst_utm_position.detail().name("utm_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_position);

            CompleteStructMember cst_pitch;
            cst_pitch.common().member_id(memberId++);
            cst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pitch.common().member_flags().IS_OPTIONAL(false);
            cst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pitch.common().member_flags().IS_KEY(false);
            cst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_pitch.detail().name("pitch");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pitch);

            CompleteStructMember cst_roll;
            cst_roll.common().member_id(memberId++);
            cst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_roll.common().member_flags().IS_OPTIONAL(false);
            cst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_roll.common().member_flags().IS_KEY(false);
            cst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_roll.detail().name("roll");

            type_object->complete().struct_type().member_seq().emplace_back(cst_roll);

            CompleteStructMember cst_heading;
            cst_heading.common().member_id(memberId++);
            cst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading.common().member_flags().IS_OPTIONAL(false);
            cst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading.common().member_flags().IS_KEY(false);
            cst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading.detail().name("heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading);

            CompleteStructMember cst_rtk_flag;
            cst_rtk_flag.common().member_id(memberId++);
            cst_rtk_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rtk_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rtk_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rtk_flag.common().member_flags().IS_OPTIONAL(false);
            cst_rtk_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rtk_flag.common().member_flags().IS_KEY(false);
            cst_rtk_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rtk_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rtk_flag.detail().name("rtk_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rtk_flag);

            CompleteStructMember cst_origin_lat;
            cst_origin_lat.common().member_id(memberId++);
            cst_origin_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_origin_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_origin_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_origin_lat.common().member_flags().IS_OPTIONAL(false);
            cst_origin_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_origin_lat.common().member_flags().IS_KEY(false);
            cst_origin_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_origin_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_origin_lat.detail().name("origin_lat");

            type_object->complete().struct_type().member_seq().emplace_back(cst_origin_lat);

            CompleteStructMember cst_origin_lon;
            cst_origin_lon.common().member_id(memberId++);
            cst_origin_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_origin_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_origin_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_origin_lon.common().member_flags().IS_OPTIONAL(false);
            cst_origin_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_origin_lon.common().member_flags().IS_KEY(false);
            cst_origin_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_origin_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_origin_lon.detail().name("origin_lon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_origin_lon);

            CompleteStructMember cst_current_ins_yaw;
            cst_current_ins_yaw.common().member_id(memberId++);
            cst_current_ins_yaw.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_current_ins_yaw.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_current_ins_yaw.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_current_ins_yaw.common().member_flags().IS_OPTIONAL(false);
            cst_current_ins_yaw.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_current_ins_yaw.common().member_flags().IS_KEY(false);
            cst_current_ins_yaw.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_current_ins_yaw.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_current_ins_yaw.detail().name("current_ins_yaw");

            type_object->complete().struct_type().member_seq().emplace_back(cst_current_ins_yaw);


            // Header
            type_object->complete().struct_type().header().detail().type_name("HMIVehicleMsg");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HMIVehicleMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HMIVehicleMsg", true);
        }

    } // namespace msg
} // namespace ros2_interface