// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HolisticPathPrediction.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "HolisticPathPrediction.h"
#include "HolisticPathPredictionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_LaneLineCubicCurve_max_cdr_typesize 48ULL;
#define ros2_interface_msg_HolisticPathPrediction_max_cdr_typesize 72ULL;
#define ros2_interface_msg_LaneLineCubicCurve_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_HolisticPathPrediction_max_key_cdr_typesize 0ULL;

ros2_interface::msg::HolisticPathPrediction::HolisticPathPrediction()
{
    // ros2_interface::msg::LaneLineCubicCurve m_hpp

    // long m_planning_source
    m_planning_source = 0;
    // double m_ego_lane_width
    m_ego_lane_width = 0.0;
    // double m_confidence
    m_confidence = 0.0;

    // Just to register all known types
    registerHolisticPathPredictionTypes();
}

ros2_interface::msg::HolisticPathPrediction::~HolisticPathPrediction()
{




}

ros2_interface::msg::HolisticPathPrediction::HolisticPathPrediction(
        const HolisticPathPrediction& x)
{
    m_hpp = x.m_hpp;
    m_planning_source = x.m_planning_source;
    m_ego_lane_width = x.m_ego_lane_width;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::HolisticPathPrediction::HolisticPathPrediction(
        HolisticPathPrediction&& x) noexcept 
{
    m_hpp = std::move(x.m_hpp);
    m_planning_source = x.m_planning_source;
    m_ego_lane_width = x.m_ego_lane_width;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::HolisticPathPrediction& ros2_interface::msg::HolisticPathPrediction::operator =(
        const HolisticPathPrediction& x)
{

    m_hpp = x.m_hpp;
    m_planning_source = x.m_planning_source;
    m_ego_lane_width = x.m_ego_lane_width;
    m_confidence = x.m_confidence;

    return *this;
}

ros2_interface::msg::HolisticPathPrediction& ros2_interface::msg::HolisticPathPrediction::operator =(
        HolisticPathPrediction&& x) noexcept
{

    m_hpp = std::move(x.m_hpp);
    m_planning_source = x.m_planning_source;
    m_ego_lane_width = x.m_ego_lane_width;
    m_confidence = x.m_confidence;

    return *this;
}

bool ros2_interface::msg::HolisticPathPrediction::operator ==(
        const HolisticPathPrediction& x) const
{

    return (m_hpp == x.m_hpp && m_planning_source == x.m_planning_source && m_ego_lane_width == x.m_ego_lane_width && m_confidence == x.m_confidence);
}

bool ros2_interface::msg::HolisticPathPrediction::operator !=(
        const HolisticPathPrediction& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::HolisticPathPrediction::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HolisticPathPrediction_max_cdr_typesize;
}

size_t ros2_interface::msg::HolisticPathPrediction::getCdrSerializedSize(
        const ros2_interface::msg::HolisticPathPrediction& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::LaneLineCubicCurve::getCdrSerializedSize(data.hpp(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::HolisticPathPrediction::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_hpp;
    scdr << m_planning_source;
    scdr << m_ego_lane_width;
    scdr << m_confidence;

}

void ros2_interface::msg::HolisticPathPrediction::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_hpp;
    dcdr >> m_planning_source;
    dcdr >> m_ego_lane_width;
    dcdr >> m_confidence;
}

/*!
 * @brief This function copies the value in member hpp
 * @param _hpp New value to be copied in member hpp
 */
void ros2_interface::msg::HolisticPathPrediction::hpp(
        const ros2_interface::msg::LaneLineCubicCurve& _hpp)
{
    m_hpp = _hpp;
}

/*!
 * @brief This function moves the value in member hpp
 * @param _hpp New value to be moved in member hpp
 */
void ros2_interface::msg::HolisticPathPrediction::hpp(
        ros2_interface::msg::LaneLineCubicCurve&& _hpp)
{
    m_hpp = std::move(_hpp);
}

/*!
 * @brief This function returns a constant reference to member hpp
 * @return Constant reference to member hpp
 */
const ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::HolisticPathPrediction::hpp() const
{
    return m_hpp;
}

/*!
 * @brief This function returns a reference to member hpp
 * @return Reference to member hpp
 */
ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::HolisticPathPrediction::hpp()
{
    return m_hpp;
}
/*!
 * @brief This function sets a value in member planning_source
 * @param _planning_source New value for member planning_source
 */
void ros2_interface::msg::HolisticPathPrediction::planning_source(
        int32_t _planning_source)
{
    m_planning_source = _planning_source;
}

/*!
 * @brief This function returns the value of member planning_source
 * @return Value of member planning_source
 */
int32_t ros2_interface::msg::HolisticPathPrediction::planning_source() const
{
    return m_planning_source;
}

/*!
 * @brief This function returns a reference to member planning_source
 * @return Reference to member planning_source
 */
int32_t& ros2_interface::msg::HolisticPathPrediction::planning_source()
{
    return m_planning_source;
}

/*!
 * @brief This function sets a value in member ego_lane_width
 * @param _ego_lane_width New value for member ego_lane_width
 */
void ros2_interface::msg::HolisticPathPrediction::ego_lane_width(
        double _ego_lane_width)
{
    m_ego_lane_width = _ego_lane_width;
}

/*!
 * @brief This function returns the value of member ego_lane_width
 * @return Value of member ego_lane_width
 */
double ros2_interface::msg::HolisticPathPrediction::ego_lane_width() const
{
    return m_ego_lane_width;
}

/*!
 * @brief This function returns a reference to member ego_lane_width
 * @return Reference to member ego_lane_width
 */
double& ros2_interface::msg::HolisticPathPrediction::ego_lane_width()
{
    return m_ego_lane_width;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::HolisticPathPrediction::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::HolisticPathPrediction::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::HolisticPathPrediction::confidence()
{
    return m_confidence;
}



size_t ros2_interface::msg::HolisticPathPrediction::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_HolisticPathPrediction_max_key_cdr_typesize;
}

bool ros2_interface::msg::HolisticPathPrediction::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::HolisticPathPrediction::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



