// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HolisticPathPrediction.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HOLISTICPATHPREDICTION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HOLISTICPATHPREDICTION_H_

#include "LaneLineCubicCurve.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(HOLISTICPATHPREDICTION_SOURCE)
#define HOLISTICPATHPREDICTION_DllAPI __declspec( dllexport )
#else
#define HOLISTICPATHPREDICTION_DllAPI __declspec( dllimport )
#endif // HOLISTICPATHPREDICTION_SOURCE
#else
#define HOLISTICPATHPREDICTION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define HOLISTICPATHPREDICTION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure HolisticPathPrediction defined by the user in the IDL file.
         * @ingroup HolisticPathPrediction
         */
        class HolisticPathPrediction
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport HolisticPathPrediction();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~HolisticPathPrediction();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::HolisticPathPrediction that will be copied.
             */
            eProsima_user_DllExport HolisticPathPrediction(
                    const HolisticPathPrediction& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::HolisticPathPrediction that will be copied.
             */
            eProsima_user_DllExport HolisticPathPrediction(
                    HolisticPathPrediction&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::HolisticPathPrediction that will be copied.
             */
            eProsima_user_DllExport HolisticPathPrediction& operator =(
                    const HolisticPathPrediction& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::HolisticPathPrediction that will be copied.
             */
            eProsima_user_DllExport HolisticPathPrediction& operator =(
                    HolisticPathPrediction&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HolisticPathPrediction object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const HolisticPathPrediction& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::HolisticPathPrediction object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const HolisticPathPrediction& x) const;

            /*!
             * @brief This function copies the value in member hpp
             * @param _hpp New value to be copied in member hpp
             */
            eProsima_user_DllExport void hpp(
                    const ros2_interface::msg::LaneLineCubicCurve& _hpp);

            /*!
             * @brief This function moves the value in member hpp
             * @param _hpp New value to be moved in member hpp
             */
            eProsima_user_DllExport void hpp(
                    ros2_interface::msg::LaneLineCubicCurve&& _hpp);

            /*!
             * @brief This function returns a constant reference to member hpp
             * @return Constant reference to member hpp
             */
            eProsima_user_DllExport const ros2_interface::msg::LaneLineCubicCurve& hpp() const;

            /*!
             * @brief This function returns a reference to member hpp
             * @return Reference to member hpp
             */
            eProsima_user_DllExport ros2_interface::msg::LaneLineCubicCurve& hpp();
            /*!
             * @brief This function sets a value in member planning_source
             * @param _planning_source New value for member planning_source
             */
            eProsima_user_DllExport void planning_source(
                    int32_t _planning_source);

            /*!
             * @brief This function returns the value of member planning_source
             * @return Value of member planning_source
             */
            eProsima_user_DllExport int32_t planning_source() const;

            /*!
             * @brief This function returns a reference to member planning_source
             * @return Reference to member planning_source
             */
            eProsima_user_DllExport int32_t& planning_source();

            /*!
             * @brief This function sets a value in member ego_lane_width
             * @param _ego_lane_width New value for member ego_lane_width
             */
            eProsima_user_DllExport void ego_lane_width(
                    double _ego_lane_width);

            /*!
             * @brief This function returns the value of member ego_lane_width
             * @return Value of member ego_lane_width
             */
            eProsima_user_DllExport double ego_lane_width() const;

            /*!
             * @brief This function returns a reference to member ego_lane_width
             * @return Reference to member ego_lane_width
             */
            eProsima_user_DllExport double& ego_lane_width();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::HolisticPathPrediction& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::LaneLineCubicCurve m_hpp;
            int32_t m_planning_source;
            double m_ego_lane_width;
            double m_confidence;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_HOLISTICPATHPREDICTION_H_

