// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file HolisticPathPredictionTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "HolisticPathPrediction.h"
#include "HolisticPathPredictionTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerHolisticPathPredictionTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(true));
                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(false));



                factory->add_type_object("ros2_interface::msg::HolisticPathPrediction", ros2_interface::msg::GetHolisticPathPredictionIdentifier(true),
                        ros2_interface::msg::GetHolisticPathPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::HolisticPathPrediction", ros2_interface::msg::GetHolisticPathPredictionIdentifier(false),
                        ros2_interface::msg::GetHolisticPathPredictionObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetHolisticPathPredictionIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("HolisticPathPrediction", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetHolisticPathPredictionObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("HolisticPathPrediction", complete);
        }

        const TypeObject* GetHolisticPathPredictionObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HolisticPathPrediction", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteHolisticPathPredictionObject();
            }
            //else
            return GetMinimalHolisticPathPredictionObject();
        }

        const TypeObject* GetMinimalHolisticPathPredictionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HolisticPathPrediction", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_hpp;
            mst_hpp.common().member_id(memberId++);
            mst_hpp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hpp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hpp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hpp.common().member_flags().IS_OPTIONAL(false);
            mst_hpp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hpp.common().member_flags().IS_KEY(false);
            mst_hpp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hpp.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false));
            MD5 hpp_hash("hpp");
            for(int i = 0; i < 4; ++i)
            {
                mst_hpp.detail().name_hash()[i] = hpp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hpp);

            MinimalStructMember mst_planning_source;
            mst_planning_source.common().member_id(memberId++);
            mst_planning_source.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_planning_source.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_planning_source.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_planning_source.common().member_flags().IS_OPTIONAL(false);
            mst_planning_source.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_planning_source.common().member_flags().IS_KEY(false);
            mst_planning_source.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_planning_source.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 planning_source_hash("planning_source");
            for(int i = 0; i < 4; ++i)
            {
                mst_planning_source.detail().name_hash()[i] = planning_source_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_planning_source);

            MinimalStructMember mst_ego_lane_width;
            mst_ego_lane_width.common().member_id(memberId++);
            mst_ego_lane_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ego_lane_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ego_lane_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ego_lane_width.common().member_flags().IS_OPTIONAL(false);
            mst_ego_lane_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ego_lane_width.common().member_flags().IS_KEY(false);
            mst_ego_lane_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ego_lane_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ego_lane_width_hash("ego_lane_width");
            for(int i = 0; i < 4; ++i)
            {
                mst_ego_lane_width.detail().name_hash()[i] = ego_lane_width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ego_lane_width);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HolisticPathPrediction", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HolisticPathPrediction", false);
        }

        const TypeObject* GetCompleteHolisticPathPredictionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("HolisticPathPrediction", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_hpp;
            cst_hpp.common().member_id(memberId++);
            cst_hpp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hpp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hpp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hpp.common().member_flags().IS_OPTIONAL(false);
            cst_hpp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hpp.common().member_flags().IS_KEY(false);
            cst_hpp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hpp.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true));
            cst_hpp.detail().name("hpp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hpp);

            CompleteStructMember cst_planning_source;
            cst_planning_source.common().member_id(memberId++);
            cst_planning_source.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_planning_source.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_planning_source.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_planning_source.common().member_flags().IS_OPTIONAL(false);
            cst_planning_source.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_planning_source.common().member_flags().IS_KEY(false);
            cst_planning_source.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_planning_source.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_planning_source.detail().name("planning_source");

            type_object->complete().struct_type().member_seq().emplace_back(cst_planning_source);

            CompleteStructMember cst_ego_lane_width;
            cst_ego_lane_width.common().member_id(memberId++);
            cst_ego_lane_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ego_lane_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ego_lane_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ego_lane_width.common().member_flags().IS_OPTIONAL(false);
            cst_ego_lane_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ego_lane_width.common().member_flags().IS_KEY(false);
            cst_ego_lane_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ego_lane_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ego_lane_width.detail().name("ego_lane_width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ego_lane_width);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);


            // Header
            type_object->complete().struct_type().header().detail().type_name("HolisticPathPrediction");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("HolisticPathPrediction", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("HolisticPathPrediction", true);
        }

    } // namespace msg
} // namespace ros2_interface