// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ImageKeyPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ImageKeyPoint.h"
#include "ImageKeyPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ImageKeyPoint_max_cdr_typesize 24ULL;
#define ros2_interface_msg_ImageKeyPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ImageKeyPoint::ImageKeyPoint()
{
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_confidence
    m_confidence = 0.0;

    // Just to register all known types
    registerImageKeyPointTypes();
}

ros2_interface::msg::ImageKeyPoint::~ImageKeyPoint()
{



}

ros2_interface::msg::ImageKeyPoint::ImageKeyPoint(
        const ImageKeyPoint& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::ImageKeyPoint::ImageKeyPoint(
        ImageKeyPoint&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::ImageKeyPoint& ros2_interface::msg::ImageKeyPoint::operator =(
        const ImageKeyPoint& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_confidence = x.m_confidence;

    return *this;
}

ros2_interface::msg::ImageKeyPoint& ros2_interface::msg::ImageKeyPoint::operator =(
        ImageKeyPoint&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_confidence = x.m_confidence;

    return *this;
}

bool ros2_interface::msg::ImageKeyPoint::operator ==(
        const ImageKeyPoint& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_confidence == x.m_confidence);
}

bool ros2_interface::msg::ImageKeyPoint::operator !=(
        const ImageKeyPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ImageKeyPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ImageKeyPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::ImageKeyPoint::getCdrSerializedSize(
        const ros2_interface::msg::ImageKeyPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ImageKeyPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_confidence;

}

void ros2_interface::msg::ImageKeyPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_confidence;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::ImageKeyPoint::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::ImageKeyPoint::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::ImageKeyPoint::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::ImageKeyPoint::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::ImageKeyPoint::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::ImageKeyPoint::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::ImageKeyPoint::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::ImageKeyPoint::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::ImageKeyPoint::confidence()
{
    return m_confidence;
}



size_t ros2_interface::msg::ImageKeyPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ImageKeyPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::ImageKeyPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ImageKeyPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



