// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ImageRect.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ImageRect.h"
#include "ImageRectTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ImageRect_max_cdr_typesize 16ULL;
#define ros2_interface_msg_ImageRect_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ImageRect::ImageRect()
{
    // long m_x
    m_x = 0;
    // long m_y
    m_y = 0;
    // long m_width
    m_width = 0;
    // long m_height
    m_height = 0;

    // Just to register all known types
    registerImageRectTypes();
}

ros2_interface::msg::ImageRect::~ImageRect()
{




}

ros2_interface::msg::ImageRect::ImageRect(
        const ImageRect& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
}

ros2_interface::msg::ImageRect::ImageRect(
        ImageRect&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
}

ros2_interface::msg::ImageRect& ros2_interface::msg::ImageRect::operator =(
        const ImageRect& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;

    return *this;
}

ros2_interface::msg::ImageRect& ros2_interface::msg::ImageRect::operator =(
        ImageRect&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;

    return *this;
}

bool ros2_interface::msg::ImageRect::operator ==(
        const ImageRect& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_width == x.m_width && m_height == x.m_height);
}

bool ros2_interface::msg::ImageRect::operator !=(
        const ImageRect& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ImageRect::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ImageRect_max_cdr_typesize;
}

size_t ros2_interface::msg::ImageRect::getCdrSerializedSize(
        const ros2_interface::msg::ImageRect& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ImageRect::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_width;
    scdr << m_height;

}

void ros2_interface::msg::ImageRect::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_width;
    dcdr >> m_height;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::ImageRect::x(
        int32_t _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
int32_t ros2_interface::msg::ImageRect::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
int32_t& ros2_interface::msg::ImageRect::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::ImageRect::y(
        int32_t _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
int32_t ros2_interface::msg::ImageRect::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
int32_t& ros2_interface::msg::ImageRect::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::ImageRect::width(
        int32_t _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
int32_t ros2_interface::msg::ImageRect::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
int32_t& ros2_interface::msg::ImageRect::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::ImageRect::height(
        int32_t _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
int32_t ros2_interface::msg::ImageRect::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
int32_t& ros2_interface::msg::ImageRect::height()
{
    return m_height;
}



size_t ros2_interface::msg::ImageRect::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ImageRect_max_key_cdr_typesize;
}

bool ros2_interface::msg::ImageRect::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ImageRect::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



