// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Imu.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Imu.h"
#include "ImuTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Quaternion_max_cdr_typesize 32ULL;
#define ros2_interface_msg_Imu_max_cdr_typesize 2784ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Quaternion_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Imu_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Imu::Imu()
{
    // ros2_interface::msg::Header m_header

    // boolean m_is_valid
    m_is_valid = false;
    // ros2_interface::msg::Quaternion m_orientation

    // sequence<double> m_orientation_covariance

    // ros2_interface::msg::Point3D m_angular_velocity

    // sequence<double> m_angular_velocity_covariance

    // ros2_interface::msg::Point3D m_linear_acceleration

    // sequence<double> m_linear_acceleration_covariance


    // Just to register all known types
    registerImuTypes();
}

ros2_interface::msg::Imu::~Imu()
{








}

ros2_interface::msg::Imu::Imu(
        const Imu& x)
{
    m_header = x.m_header;
    m_is_valid = x.m_is_valid;
    m_orientation = x.m_orientation;
    m_orientation_covariance = x.m_orientation_covariance;
    m_angular_velocity = x.m_angular_velocity;
    m_angular_velocity_covariance = x.m_angular_velocity_covariance;
    m_linear_acceleration = x.m_linear_acceleration;
    m_linear_acceleration_covariance = x.m_linear_acceleration_covariance;
}

ros2_interface::msg::Imu::Imu(
        Imu&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_is_valid = x.m_is_valid;
    m_orientation = std::move(x.m_orientation);
    m_orientation_covariance = std::move(x.m_orientation_covariance);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_angular_velocity_covariance = std::move(x.m_angular_velocity_covariance);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_linear_acceleration_covariance = std::move(x.m_linear_acceleration_covariance);
}

ros2_interface::msg::Imu& ros2_interface::msg::Imu::operator =(
        const Imu& x)
{

    m_header = x.m_header;
    m_is_valid = x.m_is_valid;
    m_orientation = x.m_orientation;
    m_orientation_covariance = x.m_orientation_covariance;
    m_angular_velocity = x.m_angular_velocity;
    m_angular_velocity_covariance = x.m_angular_velocity_covariance;
    m_linear_acceleration = x.m_linear_acceleration;
    m_linear_acceleration_covariance = x.m_linear_acceleration_covariance;

    return *this;
}

ros2_interface::msg::Imu& ros2_interface::msg::Imu::operator =(
        Imu&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_is_valid = x.m_is_valid;
    m_orientation = std::move(x.m_orientation);
    m_orientation_covariance = std::move(x.m_orientation_covariance);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_angular_velocity_covariance = std::move(x.m_angular_velocity_covariance);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_linear_acceleration_covariance = std::move(x.m_linear_acceleration_covariance);

    return *this;
}

bool ros2_interface::msg::Imu::operator ==(
        const Imu& x) const
{

    return (m_header == x.m_header && m_is_valid == x.m_is_valid && m_orientation == x.m_orientation && m_orientation_covariance == x.m_orientation_covariance && m_angular_velocity == x.m_angular_velocity && m_angular_velocity_covariance == x.m_angular_velocity_covariance && m_linear_acceleration == x.m_linear_acceleration && m_linear_acceleration_covariance == x.m_linear_acceleration_covariance);
}

bool ros2_interface::msg::Imu::operator !=(
        const Imu& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Imu::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Imu_max_cdr_typesize;
}

size_t ros2_interface::msg::Imu::getCdrSerializedSize(
        const ros2_interface::msg::Imu& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += ros2_interface::msg::Quaternion::getCdrSerializedSize(data.orientation(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.orientation_covariance().size() > 0)
    {
        current_alignment += (data.orientation_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.angular_velocity_covariance().size() > 0)
    {
        current_alignment += (data.angular_velocity_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.linear_acceleration_covariance().size() > 0)
    {
        current_alignment += (data.linear_acceleration_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }




    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Imu::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_is_valid;
    scdr << m_orientation;
    scdr << m_orientation_covariance;
    scdr << m_angular_velocity;
    scdr << m_angular_velocity_covariance;
    scdr << m_linear_acceleration;
    scdr << m_linear_acceleration_covariance;

}

void ros2_interface::msg::Imu::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_is_valid;
    dcdr >> m_orientation;
    dcdr >> m_orientation_covariance;
    dcdr >> m_angular_velocity;
    dcdr >> m_angular_velocity_covariance;
    dcdr >> m_linear_acceleration;
    dcdr >> m_linear_acceleration_covariance;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Imu::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Imu::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Imu::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Imu::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::Imu::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::Imu::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::Imu::is_valid()
{
    return m_is_valid;
}

/*!
 * @brief This function copies the value in member orientation
 * @param _orientation New value to be copied in member orientation
 */
void ros2_interface::msg::Imu::orientation(
        const ros2_interface::msg::Quaternion& _orientation)
{
    m_orientation = _orientation;
}

/*!
 * @brief This function moves the value in member orientation
 * @param _orientation New value to be moved in member orientation
 */
void ros2_interface::msg::Imu::orientation(
        ros2_interface::msg::Quaternion&& _orientation)
{
    m_orientation = std::move(_orientation);
}

/*!
 * @brief This function returns a constant reference to member orientation
 * @return Constant reference to member orientation
 */
const ros2_interface::msg::Quaternion& ros2_interface::msg::Imu::orientation() const
{
    return m_orientation;
}

/*!
 * @brief This function returns a reference to member orientation
 * @return Reference to member orientation
 */
ros2_interface::msg::Quaternion& ros2_interface::msg::Imu::orientation()
{
    return m_orientation;
}
/*!
 * @brief This function copies the value in member orientation_covariance
 * @param _orientation_covariance New value to be copied in member orientation_covariance
 */
void ros2_interface::msg::Imu::orientation_covariance(
        const std::vector<double>& _orientation_covariance)
{
    m_orientation_covariance = _orientation_covariance;
}

/*!
 * @brief This function moves the value in member orientation_covariance
 * @param _orientation_covariance New value to be moved in member orientation_covariance
 */
void ros2_interface::msg::Imu::orientation_covariance(
        std::vector<double>&& _orientation_covariance)
{
    m_orientation_covariance = std::move(_orientation_covariance);
}

/*!
 * @brief This function returns a constant reference to member orientation_covariance
 * @return Constant reference to member orientation_covariance
 */
const std::vector<double>& ros2_interface::msg::Imu::orientation_covariance() const
{
    return m_orientation_covariance;
}

/*!
 * @brief This function returns a reference to member orientation_covariance
 * @return Reference to member orientation_covariance
 */
std::vector<double>& ros2_interface::msg::Imu::orientation_covariance()
{
    return m_orientation_covariance;
}
/*!
 * @brief This function copies the value in member angular_velocity
 * @param _angular_velocity New value to be copied in member angular_velocity
 */
void ros2_interface::msg::Imu::angular_velocity(
        const ros2_interface::msg::Point3D& _angular_velocity)
{
    m_angular_velocity = _angular_velocity;
}

/*!
 * @brief This function moves the value in member angular_velocity
 * @param _angular_velocity New value to be moved in member angular_velocity
 */
void ros2_interface::msg::Imu::angular_velocity(
        ros2_interface::msg::Point3D&& _angular_velocity)
{
    m_angular_velocity = std::move(_angular_velocity);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity
 * @return Constant reference to member angular_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Imu::angular_velocity() const
{
    return m_angular_velocity;
}

/*!
 * @brief This function returns a reference to member angular_velocity
 * @return Reference to member angular_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Imu::angular_velocity()
{
    return m_angular_velocity;
}
/*!
 * @brief This function copies the value in member angular_velocity_covariance
 * @param _angular_velocity_covariance New value to be copied in member angular_velocity_covariance
 */
void ros2_interface::msg::Imu::angular_velocity_covariance(
        const std::vector<double>& _angular_velocity_covariance)
{
    m_angular_velocity_covariance = _angular_velocity_covariance;
}

/*!
 * @brief This function moves the value in member angular_velocity_covariance
 * @param _angular_velocity_covariance New value to be moved in member angular_velocity_covariance
 */
void ros2_interface::msg::Imu::angular_velocity_covariance(
        std::vector<double>&& _angular_velocity_covariance)
{
    m_angular_velocity_covariance = std::move(_angular_velocity_covariance);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity_covariance
 * @return Constant reference to member angular_velocity_covariance
 */
const std::vector<double>& ros2_interface::msg::Imu::angular_velocity_covariance() const
{
    return m_angular_velocity_covariance;
}

/*!
 * @brief This function returns a reference to member angular_velocity_covariance
 * @return Reference to member angular_velocity_covariance
 */
std::vector<double>& ros2_interface::msg::Imu::angular_velocity_covariance()
{
    return m_angular_velocity_covariance;
}
/*!
 * @brief This function copies the value in member linear_acceleration
 * @param _linear_acceleration New value to be copied in member linear_acceleration
 */
void ros2_interface::msg::Imu::linear_acceleration(
        const ros2_interface::msg::Point3D& _linear_acceleration)
{
    m_linear_acceleration = _linear_acceleration;
}

/*!
 * @brief This function moves the value in member linear_acceleration
 * @param _linear_acceleration New value to be moved in member linear_acceleration
 */
void ros2_interface::msg::Imu::linear_acceleration(
        ros2_interface::msg::Point3D&& _linear_acceleration)
{
    m_linear_acceleration = std::move(_linear_acceleration);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration
 * @return Constant reference to member linear_acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Imu::linear_acceleration() const
{
    return m_linear_acceleration;
}

/*!
 * @brief This function returns a reference to member linear_acceleration
 * @return Reference to member linear_acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Imu::linear_acceleration()
{
    return m_linear_acceleration;
}
/*!
 * @brief This function copies the value in member linear_acceleration_covariance
 * @param _linear_acceleration_covariance New value to be copied in member linear_acceleration_covariance
 */
void ros2_interface::msg::Imu::linear_acceleration_covariance(
        const std::vector<double>& _linear_acceleration_covariance)
{
    m_linear_acceleration_covariance = _linear_acceleration_covariance;
}

/*!
 * @brief This function moves the value in member linear_acceleration_covariance
 * @param _linear_acceleration_covariance New value to be moved in member linear_acceleration_covariance
 */
void ros2_interface::msg::Imu::linear_acceleration_covariance(
        std::vector<double>&& _linear_acceleration_covariance)
{
    m_linear_acceleration_covariance = std::move(_linear_acceleration_covariance);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration_covariance
 * @return Constant reference to member linear_acceleration_covariance
 */
const std::vector<double>& ros2_interface::msg::Imu::linear_acceleration_covariance() const
{
    return m_linear_acceleration_covariance;
}

/*!
 * @brief This function returns a reference to member linear_acceleration_covariance
 * @return Reference to member linear_acceleration_covariance
 */
std::vector<double>& ros2_interface::msg::Imu::linear_acceleration_covariance()
{
    return m_linear_acceleration_covariance;
}


size_t ros2_interface::msg::Imu::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Imu_max_key_cdr_typesize;
}

bool ros2_interface::msg::Imu::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Imu::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



