// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ImuTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Imu.h"
#include "ImuTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerImuTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(true),
                        ros2_interface::msg::GetQuaternionObject(true));
                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(false),
                        ros2_interface::msg::GetQuaternionObject(false));



                factory->add_type_object("ros2_interface::msg::Imu", ros2_interface::msg::GetImuIdentifier(true),
                        ros2_interface::msg::GetImuObject(true));
                factory->add_type_object("ros2_interface::msg::Imu", ros2_interface::msg::GetImuIdentifier(false),
                        ros2_interface::msg::GetImuObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetImuIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Imu", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetImuObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Imu", complete);
        }

        const TypeObject* GetImuObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Imu", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteImuObject();
            }
            //else
            return GetMinimalImuObject();
        }

        const TypeObject* GetMinimalImuObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Imu", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_is_valid;
            mst_is_valid.common().member_id(memberId++);
            mst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_valid.common().member_flags().IS_KEY(false);
            mst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_valid_hash("is_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_valid.detail().name_hash()[i] = is_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_valid);

            MinimalStructMember mst_orientation;
            mst_orientation.common().member_id(memberId++);
            mst_orientation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_orientation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_orientation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_orientation.common().member_flags().IS_OPTIONAL(false);
            mst_orientation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_orientation.common().member_flags().IS_KEY(false);
            mst_orientation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_orientation.common().member_type_id(*ros2_interface::msg::GetQuaternionIdentifier(false));
            MD5 orientation_hash("orientation");
            for(int i = 0; i < 4; ++i)
            {
                mst_orientation.detail().name_hash()[i] = orientation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_orientation);

            MinimalStructMember mst_orientation_covariance;
            mst_orientation_covariance.common().member_id(memberId++);
            mst_orientation_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_orientation_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_orientation_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_orientation_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_orientation_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_orientation_covariance.common().member_flags().IS_KEY(false);
            mst_orientation_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_orientation_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 orientation_covariance_hash("orientation_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_orientation_covariance.detail().name_hash()[i] = orientation_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_orientation_covariance);

            MinimalStructMember mst_angular_velocity;
            mst_angular_velocity.common().member_id(memberId++);
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity.common().member_flags().IS_KEY(false);
            mst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_hash("angular_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity.detail().name_hash()[i] = angular_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity);

            MinimalStructMember mst_angular_velocity_covariance;
            mst_angular_velocity_covariance.common().member_id(memberId++);
            mst_angular_velocity_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity_covariance.common().member_flags().IS_KEY(false);
            mst_angular_velocity_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 angular_velocity_covariance_hash("angular_velocity_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity_covariance.detail().name_hash()[i] = angular_velocity_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity_covariance);

            MinimalStructMember mst_linear_acceleration;
            mst_linear_acceleration.common().member_id(memberId++);
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration.common().member_flags().IS_KEY(false);
            mst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_hash("linear_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration.detail().name_hash()[i] = linear_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration);

            MinimalStructMember mst_linear_acceleration_covariance;
            mst_linear_acceleration_covariance.common().member_id(memberId++);
            mst_linear_acceleration_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration_covariance.common().member_flags().IS_KEY(false);
            mst_linear_acceleration_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 linear_acceleration_covariance_hash("linear_acceleration_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration_covariance.detail().name_hash()[i] = linear_acceleration_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration_covariance);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Imu", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Imu", false);
        }

        const TypeObject* GetCompleteImuObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Imu", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_is_valid;
            cst_is_valid.common().member_id(memberId++);
            cst_is_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_valid.common().member_flags().IS_KEY(false);
            cst_is_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_valid.detail().name("is_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_valid);

            CompleteStructMember cst_orientation;
            cst_orientation.common().member_id(memberId++);
            cst_orientation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_orientation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_orientation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_orientation.common().member_flags().IS_OPTIONAL(false);
            cst_orientation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_orientation.common().member_flags().IS_KEY(false);
            cst_orientation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_orientation.common().member_type_id(*ros2_interface::msg::GetQuaternionIdentifier(true));
            cst_orientation.detail().name("orientation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_orientation);

            CompleteStructMember cst_orientation_covariance;
            cst_orientation_covariance.common().member_id(memberId++);
            cst_orientation_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_orientation_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_orientation_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_orientation_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_orientation_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_orientation_covariance.common().member_flags().IS_KEY(false);
            cst_orientation_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_orientation_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_orientation_covariance.detail().name("orientation_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_orientation_covariance);

            CompleteStructMember cst_angular_velocity;
            cst_angular_velocity.common().member_id(memberId++);
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity.common().member_flags().IS_KEY(false);
            cst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity.detail().name("angular_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity);

            CompleteStructMember cst_angular_velocity_covariance;
            cst_angular_velocity_covariance.common().member_id(memberId++);
            cst_angular_velocity_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity_covariance.common().member_flags().IS_KEY(false);
            cst_angular_velocity_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_angular_velocity_covariance.detail().name("angular_velocity_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity_covariance);

            CompleteStructMember cst_linear_acceleration;
            cst_linear_acceleration.common().member_id(memberId++);
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration.common().member_flags().IS_KEY(false);
            cst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration.detail().name("linear_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration);

            CompleteStructMember cst_linear_acceleration_covariance;
            cst_linear_acceleration_covariance.common().member_id(memberId++);
            cst_linear_acceleration_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration_covariance.common().member_flags().IS_KEY(false);
            cst_linear_acceleration_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_linear_acceleration_covariance.detail().name("linear_acceleration_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration_covariance);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Imu");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Imu", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Imu", true);
        }

    } // namespace msg
} // namespace ros2_interface