// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Ins.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Ins.h"
#include "InsTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Ins_max_cdr_typesize 648ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Ins_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Ins::Ins()
{
    // ros2_interface::msg::Header m_header

    // boolean m_is_valid
    m_is_valid = false;
    // double m_latitude
    m_latitude = 0.0;
    // double m_longitude
    m_longitude = 0.0;
    // double m_elevation
    m_elevation = 0.0;
    // ros2_interface::msg::Point3D m_utm_position

    // long m_utm_zone_mumber
    m_utm_zone_mumber = 0;
    // uint8 m_utm_zone_char
    m_utm_zone_char = 0;
    // ros2_interface::msg::Point3D m_attitude

    // ros2_interface::msg::Point3D m_linear_velocity

    // ros2_interface::msg::Point3D m_sd_position

    // ros2_interface::msg::Point3D m_sd_attitude

    // ros2_interface::msg::Point3D m_sd_velocity

    // double m_cep68
    m_cep68 = 0.0;
    // double m_cep95
    m_cep95 = 0.0;
    // double m_second
    m_second = 0.0;
    // long m_sat_use_num
    m_sat_use_num = 0;
    // long m_sat_in_view_num
    m_sat_in_view_num = 0;
    // unsigned short m_solution_status
    m_solution_status = 0;
    // unsigned short m_position_type
    m_position_type = 0;
    // double m_p_dop
    m_p_dop = 0.0;
    // double m_h_dop
    m_h_dop = 0.0;
    // double m_v_dop
    m_v_dop = 0.0;
    // ros2_interface::msg::Point3D m_attitude_dual

    // ros2_interface::msg::Point3D m_sd_angle_dual

    // double m_base_line_length_dual
    m_base_line_length_dual = 0.0;
    // long m_solution_status_dual
    m_solution_status_dual = 0;
    // long m_position_type_dual
    m_position_type_dual = 0;
    // long m_solution_source_dual
    m_solution_source_dual = 0;
    // unsigned long m_aoc
    m_aoc = 0;
    // unsigned long m_rtk_baseline
    m_rtk_baseline = 0;
    // ros2_interface::msg::Point3D m_angular_velocity

    // ros2_interface::msg::Point3D m_acceleration


    // Just to register all known types
    registerInsTypes();
}

ros2_interface::msg::Ins::~Ins()
{

































}

ros2_interface::msg::Ins::Ins(
        const Ins& x)
{
    m_header = x.m_header;
    m_is_valid = x.m_is_valid;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_elevation = x.m_elevation;
    m_utm_position = x.m_utm_position;
    m_utm_zone_mumber = x.m_utm_zone_mumber;
    m_utm_zone_char = x.m_utm_zone_char;
    m_attitude = x.m_attitude;
    m_linear_velocity = x.m_linear_velocity;
    m_sd_position = x.m_sd_position;
    m_sd_attitude = x.m_sd_attitude;
    m_sd_velocity = x.m_sd_velocity;
    m_cep68 = x.m_cep68;
    m_cep95 = x.m_cep95;
    m_second = x.m_second;
    m_sat_use_num = x.m_sat_use_num;
    m_sat_in_view_num = x.m_sat_in_view_num;
    m_solution_status = x.m_solution_status;
    m_position_type = x.m_position_type;
    m_p_dop = x.m_p_dop;
    m_h_dop = x.m_h_dop;
    m_v_dop = x.m_v_dop;
    m_attitude_dual = x.m_attitude_dual;
    m_sd_angle_dual = x.m_sd_angle_dual;
    m_base_line_length_dual = x.m_base_line_length_dual;
    m_solution_status_dual = x.m_solution_status_dual;
    m_position_type_dual = x.m_position_type_dual;
    m_solution_source_dual = x.m_solution_source_dual;
    m_aoc = x.m_aoc;
    m_rtk_baseline = x.m_rtk_baseline;
    m_angular_velocity = x.m_angular_velocity;
    m_acceleration = x.m_acceleration;
}

ros2_interface::msg::Ins::Ins(
        Ins&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_is_valid = x.m_is_valid;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_elevation = x.m_elevation;
    m_utm_position = std::move(x.m_utm_position);
    m_utm_zone_mumber = x.m_utm_zone_mumber;
    m_utm_zone_char = x.m_utm_zone_char;
    m_attitude = std::move(x.m_attitude);
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_sd_position = std::move(x.m_sd_position);
    m_sd_attitude = std::move(x.m_sd_attitude);
    m_sd_velocity = std::move(x.m_sd_velocity);
    m_cep68 = x.m_cep68;
    m_cep95 = x.m_cep95;
    m_second = x.m_second;
    m_sat_use_num = x.m_sat_use_num;
    m_sat_in_view_num = x.m_sat_in_view_num;
    m_solution_status = x.m_solution_status;
    m_position_type = x.m_position_type;
    m_p_dop = x.m_p_dop;
    m_h_dop = x.m_h_dop;
    m_v_dop = x.m_v_dop;
    m_attitude_dual = std::move(x.m_attitude_dual);
    m_sd_angle_dual = std::move(x.m_sd_angle_dual);
    m_base_line_length_dual = x.m_base_line_length_dual;
    m_solution_status_dual = x.m_solution_status_dual;
    m_position_type_dual = x.m_position_type_dual;
    m_solution_source_dual = x.m_solution_source_dual;
    m_aoc = x.m_aoc;
    m_rtk_baseline = x.m_rtk_baseline;
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_acceleration = std::move(x.m_acceleration);
}

ros2_interface::msg::Ins& ros2_interface::msg::Ins::operator =(
        const Ins& x)
{

    m_header = x.m_header;
    m_is_valid = x.m_is_valid;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_elevation = x.m_elevation;
    m_utm_position = x.m_utm_position;
    m_utm_zone_mumber = x.m_utm_zone_mumber;
    m_utm_zone_char = x.m_utm_zone_char;
    m_attitude = x.m_attitude;
    m_linear_velocity = x.m_linear_velocity;
    m_sd_position = x.m_sd_position;
    m_sd_attitude = x.m_sd_attitude;
    m_sd_velocity = x.m_sd_velocity;
    m_cep68 = x.m_cep68;
    m_cep95 = x.m_cep95;
    m_second = x.m_second;
    m_sat_use_num = x.m_sat_use_num;
    m_sat_in_view_num = x.m_sat_in_view_num;
    m_solution_status = x.m_solution_status;
    m_position_type = x.m_position_type;
    m_p_dop = x.m_p_dop;
    m_h_dop = x.m_h_dop;
    m_v_dop = x.m_v_dop;
    m_attitude_dual = x.m_attitude_dual;
    m_sd_angle_dual = x.m_sd_angle_dual;
    m_base_line_length_dual = x.m_base_line_length_dual;
    m_solution_status_dual = x.m_solution_status_dual;
    m_position_type_dual = x.m_position_type_dual;
    m_solution_source_dual = x.m_solution_source_dual;
    m_aoc = x.m_aoc;
    m_rtk_baseline = x.m_rtk_baseline;
    m_angular_velocity = x.m_angular_velocity;
    m_acceleration = x.m_acceleration;

    return *this;
}

ros2_interface::msg::Ins& ros2_interface::msg::Ins::operator =(
        Ins&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_is_valid = x.m_is_valid;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_elevation = x.m_elevation;
    m_utm_position = std::move(x.m_utm_position);
    m_utm_zone_mumber = x.m_utm_zone_mumber;
    m_utm_zone_char = x.m_utm_zone_char;
    m_attitude = std::move(x.m_attitude);
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_sd_position = std::move(x.m_sd_position);
    m_sd_attitude = std::move(x.m_sd_attitude);
    m_sd_velocity = std::move(x.m_sd_velocity);
    m_cep68 = x.m_cep68;
    m_cep95 = x.m_cep95;
    m_second = x.m_second;
    m_sat_use_num = x.m_sat_use_num;
    m_sat_in_view_num = x.m_sat_in_view_num;
    m_solution_status = x.m_solution_status;
    m_position_type = x.m_position_type;
    m_p_dop = x.m_p_dop;
    m_h_dop = x.m_h_dop;
    m_v_dop = x.m_v_dop;
    m_attitude_dual = std::move(x.m_attitude_dual);
    m_sd_angle_dual = std::move(x.m_sd_angle_dual);
    m_base_line_length_dual = x.m_base_line_length_dual;
    m_solution_status_dual = x.m_solution_status_dual;
    m_position_type_dual = x.m_position_type_dual;
    m_solution_source_dual = x.m_solution_source_dual;
    m_aoc = x.m_aoc;
    m_rtk_baseline = x.m_rtk_baseline;
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_acceleration = std::move(x.m_acceleration);

    return *this;
}

bool ros2_interface::msg::Ins::operator ==(
        const Ins& x) const
{

    return (m_header == x.m_header && m_is_valid == x.m_is_valid && m_latitude == x.m_latitude && m_longitude == x.m_longitude && m_elevation == x.m_elevation && m_utm_position == x.m_utm_position && m_utm_zone_mumber == x.m_utm_zone_mumber && m_utm_zone_char == x.m_utm_zone_char && m_attitude == x.m_attitude && m_linear_velocity == x.m_linear_velocity && m_sd_position == x.m_sd_position && m_sd_attitude == x.m_sd_attitude && m_sd_velocity == x.m_sd_velocity && m_cep68 == x.m_cep68 && m_cep95 == x.m_cep95 && m_second == x.m_second && m_sat_use_num == x.m_sat_use_num && m_sat_in_view_num == x.m_sat_in_view_num && m_solution_status == x.m_solution_status && m_position_type == x.m_position_type && m_p_dop == x.m_p_dop && m_h_dop == x.m_h_dop && m_v_dop == x.m_v_dop && m_attitude_dual == x.m_attitude_dual && m_sd_angle_dual == x.m_sd_angle_dual && m_base_line_length_dual == x.m_base_line_length_dual && m_solution_status_dual == x.m_solution_status_dual && m_position_type_dual == x.m_position_type_dual && m_solution_source_dual == x.m_solution_source_dual && m_aoc == x.m_aoc && m_rtk_baseline == x.m_rtk_baseline && m_angular_velocity == x.m_angular_velocity && m_acceleration == x.m_acceleration);
}

bool ros2_interface::msg::Ins::operator !=(
        const Ins& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Ins::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Ins_max_cdr_typesize;
}

size_t ros2_interface::msg::Ins::getCdrSerializedSize(
        const ros2_interface::msg::Ins& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.utm_position(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.attitude(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.sd_position(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.sd_attitude(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.sd_velocity(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.attitude_dual(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.sd_angle_dual(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.acceleration(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Ins::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_is_valid;
    scdr << m_latitude;
    scdr << m_longitude;
    scdr << m_elevation;
    scdr << m_utm_position;
    scdr << m_utm_zone_mumber;
    scdr << m_utm_zone_char;
    scdr << m_attitude;
    scdr << m_linear_velocity;
    scdr << m_sd_position;
    scdr << m_sd_attitude;
    scdr << m_sd_velocity;
    scdr << m_cep68;
    scdr << m_cep95;
    scdr << m_second;
    scdr << m_sat_use_num;
    scdr << m_sat_in_view_num;
    scdr << m_solution_status;
    scdr << m_position_type;
    scdr << m_p_dop;
    scdr << m_h_dop;
    scdr << m_v_dop;
    scdr << m_attitude_dual;
    scdr << m_sd_angle_dual;
    scdr << m_base_line_length_dual;
    scdr << m_solution_status_dual;
    scdr << m_position_type_dual;
    scdr << m_solution_source_dual;
    scdr << m_aoc;
    scdr << m_rtk_baseline;
    scdr << m_angular_velocity;
    scdr << m_acceleration;

}

void ros2_interface::msg::Ins::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_is_valid;
    dcdr >> m_latitude;
    dcdr >> m_longitude;
    dcdr >> m_elevation;
    dcdr >> m_utm_position;
    dcdr >> m_utm_zone_mumber;
    dcdr >> m_utm_zone_char;
    dcdr >> m_attitude;
    dcdr >> m_linear_velocity;
    dcdr >> m_sd_position;
    dcdr >> m_sd_attitude;
    dcdr >> m_sd_velocity;
    dcdr >> m_cep68;
    dcdr >> m_cep95;
    dcdr >> m_second;
    dcdr >> m_sat_use_num;
    dcdr >> m_sat_in_view_num;
    dcdr >> m_solution_status;
    dcdr >> m_position_type;
    dcdr >> m_p_dop;
    dcdr >> m_h_dop;
    dcdr >> m_v_dop;
    dcdr >> m_attitude_dual;
    dcdr >> m_sd_angle_dual;
    dcdr >> m_base_line_length_dual;
    dcdr >> m_solution_status_dual;
    dcdr >> m_position_type_dual;
    dcdr >> m_solution_source_dual;
    dcdr >> m_aoc;
    dcdr >> m_rtk_baseline;
    dcdr >> m_angular_velocity;
    dcdr >> m_acceleration;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Ins::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Ins::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Ins::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Ins::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::Ins::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::Ins::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::Ins::is_valid()
{
    return m_is_valid;
}

/*!
 * @brief This function sets a value in member latitude
 * @param _latitude New value for member latitude
 */
void ros2_interface::msg::Ins::latitude(
        double _latitude)
{
    m_latitude = _latitude;
}

/*!
 * @brief This function returns the value of member latitude
 * @return Value of member latitude
 */
double ros2_interface::msg::Ins::latitude() const
{
    return m_latitude;
}

/*!
 * @brief This function returns a reference to member latitude
 * @return Reference to member latitude
 */
double& ros2_interface::msg::Ins::latitude()
{
    return m_latitude;
}

/*!
 * @brief This function sets a value in member longitude
 * @param _longitude New value for member longitude
 */
void ros2_interface::msg::Ins::longitude(
        double _longitude)
{
    m_longitude = _longitude;
}

/*!
 * @brief This function returns the value of member longitude
 * @return Value of member longitude
 */
double ros2_interface::msg::Ins::longitude() const
{
    return m_longitude;
}

/*!
 * @brief This function returns a reference to member longitude
 * @return Reference to member longitude
 */
double& ros2_interface::msg::Ins::longitude()
{
    return m_longitude;
}

/*!
 * @brief This function sets a value in member elevation
 * @param _elevation New value for member elevation
 */
void ros2_interface::msg::Ins::elevation(
        double _elevation)
{
    m_elevation = _elevation;
}

/*!
 * @brief This function returns the value of member elevation
 * @return Value of member elevation
 */
double ros2_interface::msg::Ins::elevation() const
{
    return m_elevation;
}

/*!
 * @brief This function returns a reference to member elevation
 * @return Reference to member elevation
 */
double& ros2_interface::msg::Ins::elevation()
{
    return m_elevation;
}

/*!
 * @brief This function copies the value in member utm_position
 * @param _utm_position New value to be copied in member utm_position
 */
void ros2_interface::msg::Ins::utm_position(
        const ros2_interface::msg::Point3D& _utm_position)
{
    m_utm_position = _utm_position;
}

/*!
 * @brief This function moves the value in member utm_position
 * @param _utm_position New value to be moved in member utm_position
 */
void ros2_interface::msg::Ins::utm_position(
        ros2_interface::msg::Point3D&& _utm_position)
{
    m_utm_position = std::move(_utm_position);
}

/*!
 * @brief This function returns a constant reference to member utm_position
 * @return Constant reference to member utm_position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::utm_position() const
{
    return m_utm_position;
}

/*!
 * @brief This function returns a reference to member utm_position
 * @return Reference to member utm_position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::utm_position()
{
    return m_utm_position;
}
/*!
 * @brief This function sets a value in member utm_zone_mumber
 * @param _utm_zone_mumber New value for member utm_zone_mumber
 */
void ros2_interface::msg::Ins::utm_zone_mumber(
        int32_t _utm_zone_mumber)
{
    m_utm_zone_mumber = _utm_zone_mumber;
}

/*!
 * @brief This function returns the value of member utm_zone_mumber
 * @return Value of member utm_zone_mumber
 */
int32_t ros2_interface::msg::Ins::utm_zone_mumber() const
{
    return m_utm_zone_mumber;
}

/*!
 * @brief This function returns a reference to member utm_zone_mumber
 * @return Reference to member utm_zone_mumber
 */
int32_t& ros2_interface::msg::Ins::utm_zone_mumber()
{
    return m_utm_zone_mumber;
}

/*!
 * @brief This function sets a value in member utm_zone_char
 * @param _utm_zone_char New value for member utm_zone_char
 */
void ros2_interface::msg::Ins::utm_zone_char(
        uint8_t _utm_zone_char)
{
    m_utm_zone_char = _utm_zone_char;
}

/*!
 * @brief This function returns the value of member utm_zone_char
 * @return Value of member utm_zone_char
 */
uint8_t ros2_interface::msg::Ins::utm_zone_char() const
{
    return m_utm_zone_char;
}

/*!
 * @brief This function returns a reference to member utm_zone_char
 * @return Reference to member utm_zone_char
 */
uint8_t& ros2_interface::msg::Ins::utm_zone_char()
{
    return m_utm_zone_char;
}

/*!
 * @brief This function copies the value in member attitude
 * @param _attitude New value to be copied in member attitude
 */
void ros2_interface::msg::Ins::attitude(
        const ros2_interface::msg::Point3D& _attitude)
{
    m_attitude = _attitude;
}

/*!
 * @brief This function moves the value in member attitude
 * @param _attitude New value to be moved in member attitude
 */
void ros2_interface::msg::Ins::attitude(
        ros2_interface::msg::Point3D&& _attitude)
{
    m_attitude = std::move(_attitude);
}

/*!
 * @brief This function returns a constant reference to member attitude
 * @return Constant reference to member attitude
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::attitude() const
{
    return m_attitude;
}

/*!
 * @brief This function returns a reference to member attitude
 * @return Reference to member attitude
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::attitude()
{
    return m_attitude;
}
/*!
 * @brief This function copies the value in member linear_velocity
 * @param _linear_velocity New value to be copied in member linear_velocity
 */
void ros2_interface::msg::Ins::linear_velocity(
        const ros2_interface::msg::Point3D& _linear_velocity)
{
    m_linear_velocity = _linear_velocity;
}

/*!
 * @brief This function moves the value in member linear_velocity
 * @param _linear_velocity New value to be moved in member linear_velocity
 */
void ros2_interface::msg::Ins::linear_velocity(
        ros2_interface::msg::Point3D&& _linear_velocity)
{
    m_linear_velocity = std::move(_linear_velocity);
}

/*!
 * @brief This function returns a constant reference to member linear_velocity
 * @return Constant reference to member linear_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::linear_velocity() const
{
    return m_linear_velocity;
}

/*!
 * @brief This function returns a reference to member linear_velocity
 * @return Reference to member linear_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::linear_velocity()
{
    return m_linear_velocity;
}
/*!
 * @brief This function copies the value in member sd_position
 * @param _sd_position New value to be copied in member sd_position
 */
void ros2_interface::msg::Ins::sd_position(
        const ros2_interface::msg::Point3D& _sd_position)
{
    m_sd_position = _sd_position;
}

/*!
 * @brief This function moves the value in member sd_position
 * @param _sd_position New value to be moved in member sd_position
 */
void ros2_interface::msg::Ins::sd_position(
        ros2_interface::msg::Point3D&& _sd_position)
{
    m_sd_position = std::move(_sd_position);
}

/*!
 * @brief This function returns a constant reference to member sd_position
 * @return Constant reference to member sd_position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_position() const
{
    return m_sd_position;
}

/*!
 * @brief This function returns a reference to member sd_position
 * @return Reference to member sd_position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_position()
{
    return m_sd_position;
}
/*!
 * @brief This function copies the value in member sd_attitude
 * @param _sd_attitude New value to be copied in member sd_attitude
 */
void ros2_interface::msg::Ins::sd_attitude(
        const ros2_interface::msg::Point3D& _sd_attitude)
{
    m_sd_attitude = _sd_attitude;
}

/*!
 * @brief This function moves the value in member sd_attitude
 * @param _sd_attitude New value to be moved in member sd_attitude
 */
void ros2_interface::msg::Ins::sd_attitude(
        ros2_interface::msg::Point3D&& _sd_attitude)
{
    m_sd_attitude = std::move(_sd_attitude);
}

/*!
 * @brief This function returns a constant reference to member sd_attitude
 * @return Constant reference to member sd_attitude
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_attitude() const
{
    return m_sd_attitude;
}

/*!
 * @brief This function returns a reference to member sd_attitude
 * @return Reference to member sd_attitude
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_attitude()
{
    return m_sd_attitude;
}
/*!
 * @brief This function copies the value in member sd_velocity
 * @param _sd_velocity New value to be copied in member sd_velocity
 */
void ros2_interface::msg::Ins::sd_velocity(
        const ros2_interface::msg::Point3D& _sd_velocity)
{
    m_sd_velocity = _sd_velocity;
}

/*!
 * @brief This function moves the value in member sd_velocity
 * @param _sd_velocity New value to be moved in member sd_velocity
 */
void ros2_interface::msg::Ins::sd_velocity(
        ros2_interface::msg::Point3D&& _sd_velocity)
{
    m_sd_velocity = std::move(_sd_velocity);
}

/*!
 * @brief This function returns a constant reference to member sd_velocity
 * @return Constant reference to member sd_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_velocity() const
{
    return m_sd_velocity;
}

/*!
 * @brief This function returns a reference to member sd_velocity
 * @return Reference to member sd_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_velocity()
{
    return m_sd_velocity;
}
/*!
 * @brief This function sets a value in member cep68
 * @param _cep68 New value for member cep68
 */
void ros2_interface::msg::Ins::cep68(
        double _cep68)
{
    m_cep68 = _cep68;
}

/*!
 * @brief This function returns the value of member cep68
 * @return Value of member cep68
 */
double ros2_interface::msg::Ins::cep68() const
{
    return m_cep68;
}

/*!
 * @brief This function returns a reference to member cep68
 * @return Reference to member cep68
 */
double& ros2_interface::msg::Ins::cep68()
{
    return m_cep68;
}

/*!
 * @brief This function sets a value in member cep95
 * @param _cep95 New value for member cep95
 */
void ros2_interface::msg::Ins::cep95(
        double _cep95)
{
    m_cep95 = _cep95;
}

/*!
 * @brief This function returns the value of member cep95
 * @return Value of member cep95
 */
double ros2_interface::msg::Ins::cep95() const
{
    return m_cep95;
}

/*!
 * @brief This function returns a reference to member cep95
 * @return Reference to member cep95
 */
double& ros2_interface::msg::Ins::cep95()
{
    return m_cep95;
}

/*!
 * @brief This function sets a value in member second
 * @param _second New value for member second
 */
void ros2_interface::msg::Ins::second(
        double _second)
{
    m_second = _second;
}

/*!
 * @brief This function returns the value of member second
 * @return Value of member second
 */
double ros2_interface::msg::Ins::second() const
{
    return m_second;
}

/*!
 * @brief This function returns a reference to member second
 * @return Reference to member second
 */
double& ros2_interface::msg::Ins::second()
{
    return m_second;
}

/*!
 * @brief This function sets a value in member sat_use_num
 * @param _sat_use_num New value for member sat_use_num
 */
void ros2_interface::msg::Ins::sat_use_num(
        int32_t _sat_use_num)
{
    m_sat_use_num = _sat_use_num;
}

/*!
 * @brief This function returns the value of member sat_use_num
 * @return Value of member sat_use_num
 */
int32_t ros2_interface::msg::Ins::sat_use_num() const
{
    return m_sat_use_num;
}

/*!
 * @brief This function returns a reference to member sat_use_num
 * @return Reference to member sat_use_num
 */
int32_t& ros2_interface::msg::Ins::sat_use_num()
{
    return m_sat_use_num;
}

/*!
 * @brief This function sets a value in member sat_in_view_num
 * @param _sat_in_view_num New value for member sat_in_view_num
 */
void ros2_interface::msg::Ins::sat_in_view_num(
        int32_t _sat_in_view_num)
{
    m_sat_in_view_num = _sat_in_view_num;
}

/*!
 * @brief This function returns the value of member sat_in_view_num
 * @return Value of member sat_in_view_num
 */
int32_t ros2_interface::msg::Ins::sat_in_view_num() const
{
    return m_sat_in_view_num;
}

/*!
 * @brief This function returns a reference to member sat_in_view_num
 * @return Reference to member sat_in_view_num
 */
int32_t& ros2_interface::msg::Ins::sat_in_view_num()
{
    return m_sat_in_view_num;
}

/*!
 * @brief This function sets a value in member solution_status
 * @param _solution_status New value for member solution_status
 */
void ros2_interface::msg::Ins::solution_status(
        uint16_t _solution_status)
{
    m_solution_status = _solution_status;
}

/*!
 * @brief This function returns the value of member solution_status
 * @return Value of member solution_status
 */
uint16_t ros2_interface::msg::Ins::solution_status() const
{
    return m_solution_status;
}

/*!
 * @brief This function returns a reference to member solution_status
 * @return Reference to member solution_status
 */
uint16_t& ros2_interface::msg::Ins::solution_status()
{
    return m_solution_status;
}

/*!
 * @brief This function sets a value in member position_type
 * @param _position_type New value for member position_type
 */
void ros2_interface::msg::Ins::position_type(
        uint16_t _position_type)
{
    m_position_type = _position_type;
}

/*!
 * @brief This function returns the value of member position_type
 * @return Value of member position_type
 */
uint16_t ros2_interface::msg::Ins::position_type() const
{
    return m_position_type;
}

/*!
 * @brief This function returns a reference to member position_type
 * @return Reference to member position_type
 */
uint16_t& ros2_interface::msg::Ins::position_type()
{
    return m_position_type;
}

/*!
 * @brief This function sets a value in member p_dop
 * @param _p_dop New value for member p_dop
 */
void ros2_interface::msg::Ins::p_dop(
        double _p_dop)
{
    m_p_dop = _p_dop;
}

/*!
 * @brief This function returns the value of member p_dop
 * @return Value of member p_dop
 */
double ros2_interface::msg::Ins::p_dop() const
{
    return m_p_dop;
}

/*!
 * @brief This function returns a reference to member p_dop
 * @return Reference to member p_dop
 */
double& ros2_interface::msg::Ins::p_dop()
{
    return m_p_dop;
}

/*!
 * @brief This function sets a value in member h_dop
 * @param _h_dop New value for member h_dop
 */
void ros2_interface::msg::Ins::h_dop(
        double _h_dop)
{
    m_h_dop = _h_dop;
}

/*!
 * @brief This function returns the value of member h_dop
 * @return Value of member h_dop
 */
double ros2_interface::msg::Ins::h_dop() const
{
    return m_h_dop;
}

/*!
 * @brief This function returns a reference to member h_dop
 * @return Reference to member h_dop
 */
double& ros2_interface::msg::Ins::h_dop()
{
    return m_h_dop;
}

/*!
 * @brief This function sets a value in member v_dop
 * @param _v_dop New value for member v_dop
 */
void ros2_interface::msg::Ins::v_dop(
        double _v_dop)
{
    m_v_dop = _v_dop;
}

/*!
 * @brief This function returns the value of member v_dop
 * @return Value of member v_dop
 */
double ros2_interface::msg::Ins::v_dop() const
{
    return m_v_dop;
}

/*!
 * @brief This function returns a reference to member v_dop
 * @return Reference to member v_dop
 */
double& ros2_interface::msg::Ins::v_dop()
{
    return m_v_dop;
}

/*!
 * @brief This function copies the value in member attitude_dual
 * @param _attitude_dual New value to be copied in member attitude_dual
 */
void ros2_interface::msg::Ins::attitude_dual(
        const ros2_interface::msg::Point3D& _attitude_dual)
{
    m_attitude_dual = _attitude_dual;
}

/*!
 * @brief This function moves the value in member attitude_dual
 * @param _attitude_dual New value to be moved in member attitude_dual
 */
void ros2_interface::msg::Ins::attitude_dual(
        ros2_interface::msg::Point3D&& _attitude_dual)
{
    m_attitude_dual = std::move(_attitude_dual);
}

/*!
 * @brief This function returns a constant reference to member attitude_dual
 * @return Constant reference to member attitude_dual
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::attitude_dual() const
{
    return m_attitude_dual;
}

/*!
 * @brief This function returns a reference to member attitude_dual
 * @return Reference to member attitude_dual
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::attitude_dual()
{
    return m_attitude_dual;
}
/*!
 * @brief This function copies the value in member sd_angle_dual
 * @param _sd_angle_dual New value to be copied in member sd_angle_dual
 */
void ros2_interface::msg::Ins::sd_angle_dual(
        const ros2_interface::msg::Point3D& _sd_angle_dual)
{
    m_sd_angle_dual = _sd_angle_dual;
}

/*!
 * @brief This function moves the value in member sd_angle_dual
 * @param _sd_angle_dual New value to be moved in member sd_angle_dual
 */
void ros2_interface::msg::Ins::sd_angle_dual(
        ros2_interface::msg::Point3D&& _sd_angle_dual)
{
    m_sd_angle_dual = std::move(_sd_angle_dual);
}

/*!
 * @brief This function returns a constant reference to member sd_angle_dual
 * @return Constant reference to member sd_angle_dual
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_angle_dual() const
{
    return m_sd_angle_dual;
}

/*!
 * @brief This function returns a reference to member sd_angle_dual
 * @return Reference to member sd_angle_dual
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::sd_angle_dual()
{
    return m_sd_angle_dual;
}
/*!
 * @brief This function sets a value in member base_line_length_dual
 * @param _base_line_length_dual New value for member base_line_length_dual
 */
void ros2_interface::msg::Ins::base_line_length_dual(
        double _base_line_length_dual)
{
    m_base_line_length_dual = _base_line_length_dual;
}

/*!
 * @brief This function returns the value of member base_line_length_dual
 * @return Value of member base_line_length_dual
 */
double ros2_interface::msg::Ins::base_line_length_dual() const
{
    return m_base_line_length_dual;
}

/*!
 * @brief This function returns a reference to member base_line_length_dual
 * @return Reference to member base_line_length_dual
 */
double& ros2_interface::msg::Ins::base_line_length_dual()
{
    return m_base_line_length_dual;
}

/*!
 * @brief This function sets a value in member solution_status_dual
 * @param _solution_status_dual New value for member solution_status_dual
 */
void ros2_interface::msg::Ins::solution_status_dual(
        int32_t _solution_status_dual)
{
    m_solution_status_dual = _solution_status_dual;
}

/*!
 * @brief This function returns the value of member solution_status_dual
 * @return Value of member solution_status_dual
 */
int32_t ros2_interface::msg::Ins::solution_status_dual() const
{
    return m_solution_status_dual;
}

/*!
 * @brief This function returns a reference to member solution_status_dual
 * @return Reference to member solution_status_dual
 */
int32_t& ros2_interface::msg::Ins::solution_status_dual()
{
    return m_solution_status_dual;
}

/*!
 * @brief This function sets a value in member position_type_dual
 * @param _position_type_dual New value for member position_type_dual
 */
void ros2_interface::msg::Ins::position_type_dual(
        int32_t _position_type_dual)
{
    m_position_type_dual = _position_type_dual;
}

/*!
 * @brief This function returns the value of member position_type_dual
 * @return Value of member position_type_dual
 */
int32_t ros2_interface::msg::Ins::position_type_dual() const
{
    return m_position_type_dual;
}

/*!
 * @brief This function returns a reference to member position_type_dual
 * @return Reference to member position_type_dual
 */
int32_t& ros2_interface::msg::Ins::position_type_dual()
{
    return m_position_type_dual;
}

/*!
 * @brief This function sets a value in member solution_source_dual
 * @param _solution_source_dual New value for member solution_source_dual
 */
void ros2_interface::msg::Ins::solution_source_dual(
        int32_t _solution_source_dual)
{
    m_solution_source_dual = _solution_source_dual;
}

/*!
 * @brief This function returns the value of member solution_source_dual
 * @return Value of member solution_source_dual
 */
int32_t ros2_interface::msg::Ins::solution_source_dual() const
{
    return m_solution_source_dual;
}

/*!
 * @brief This function returns a reference to member solution_source_dual
 * @return Reference to member solution_source_dual
 */
int32_t& ros2_interface::msg::Ins::solution_source_dual()
{
    return m_solution_source_dual;
}

/*!
 * @brief This function sets a value in member aoc
 * @param _aoc New value for member aoc
 */
void ros2_interface::msg::Ins::aoc(
        uint32_t _aoc)
{
    m_aoc = _aoc;
}

/*!
 * @brief This function returns the value of member aoc
 * @return Value of member aoc
 */
uint32_t ros2_interface::msg::Ins::aoc() const
{
    return m_aoc;
}

/*!
 * @brief This function returns a reference to member aoc
 * @return Reference to member aoc
 */
uint32_t& ros2_interface::msg::Ins::aoc()
{
    return m_aoc;
}

/*!
 * @brief This function sets a value in member rtk_baseline
 * @param _rtk_baseline New value for member rtk_baseline
 */
void ros2_interface::msg::Ins::rtk_baseline(
        uint32_t _rtk_baseline)
{
    m_rtk_baseline = _rtk_baseline;
}

/*!
 * @brief This function returns the value of member rtk_baseline
 * @return Value of member rtk_baseline
 */
uint32_t ros2_interface::msg::Ins::rtk_baseline() const
{
    return m_rtk_baseline;
}

/*!
 * @brief This function returns a reference to member rtk_baseline
 * @return Reference to member rtk_baseline
 */
uint32_t& ros2_interface::msg::Ins::rtk_baseline()
{
    return m_rtk_baseline;
}

/*!
 * @brief This function copies the value in member angular_velocity
 * @param _angular_velocity New value to be copied in member angular_velocity
 */
void ros2_interface::msg::Ins::angular_velocity(
        const ros2_interface::msg::Point3D& _angular_velocity)
{
    m_angular_velocity = _angular_velocity;
}

/*!
 * @brief This function moves the value in member angular_velocity
 * @param _angular_velocity New value to be moved in member angular_velocity
 */
void ros2_interface::msg::Ins::angular_velocity(
        ros2_interface::msg::Point3D&& _angular_velocity)
{
    m_angular_velocity = std::move(_angular_velocity);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity
 * @return Constant reference to member angular_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::angular_velocity() const
{
    return m_angular_velocity;
}

/*!
 * @brief This function returns a reference to member angular_velocity
 * @return Reference to member angular_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::angular_velocity()
{
    return m_angular_velocity;
}
/*!
 * @brief This function copies the value in member acceleration
 * @param _acceleration New value to be copied in member acceleration
 */
void ros2_interface::msg::Ins::acceleration(
        const ros2_interface::msg::Point3D& _acceleration)
{
    m_acceleration = _acceleration;
}

/*!
 * @brief This function moves the value in member acceleration
 * @param _acceleration New value to be moved in member acceleration
 */
void ros2_interface::msg::Ins::acceleration(
        ros2_interface::msg::Point3D&& _acceleration)
{
    m_acceleration = std::move(_acceleration);
}

/*!
 * @brief This function returns a constant reference to member acceleration
 * @return Constant reference to member acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Ins::acceleration() const
{
    return m_acceleration;
}

/*!
 * @brief This function returns a reference to member acceleration
 * @return Reference to member acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Ins::acceleration()
{
    return m_acceleration;
}


size_t ros2_interface::msg::Ins::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Ins_max_key_cdr_typesize;
}

bool ros2_interface::msg::Ins::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Ins::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



