// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file JunctionInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "JunctionInfo.h"
#include "JunctionInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_JunctionInfo_max_cdr_typesize 2456ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_JunctionInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::JunctionInfo::JunctionInfo()
{
    // long m_id
    m_id = 0;
    // long m_light_flag
    m_light_flag = 0;
    // long m_light_color
    m_light_color = 0;
    // double m_light_remain_time
    m_light_remain_time = 0.0;
    // double m_distance_to_stop
    m_distance_to_stop = 0.0;
    // long m_direction_flag
    m_direction_flag = 0;
    // long m_direction
    m_direction = 0;
    // double m_distance_to_junction
    m_distance_to_junction = 0.0;
    // sequence<ros2_interface::msg::Point3D> m_stop_line


    // Just to register all known types
    registerJunctionInfoTypes();
}

ros2_interface::msg::JunctionInfo::~JunctionInfo()
{









}

ros2_interface::msg::JunctionInfo::JunctionInfo(
        const JunctionInfo& x)
{
    m_id = x.m_id;
    m_light_flag = x.m_light_flag;
    m_light_color = x.m_light_color;
    m_light_remain_time = x.m_light_remain_time;
    m_distance_to_stop = x.m_distance_to_stop;
    m_direction_flag = x.m_direction_flag;
    m_direction = x.m_direction;
    m_distance_to_junction = x.m_distance_to_junction;
    m_stop_line = x.m_stop_line;
}

ros2_interface::msg::JunctionInfo::JunctionInfo(
        JunctionInfo&& x) noexcept 
{
    m_id = x.m_id;
    m_light_flag = x.m_light_flag;
    m_light_color = x.m_light_color;
    m_light_remain_time = x.m_light_remain_time;
    m_distance_to_stop = x.m_distance_to_stop;
    m_direction_flag = x.m_direction_flag;
    m_direction = x.m_direction;
    m_distance_to_junction = x.m_distance_to_junction;
    m_stop_line = std::move(x.m_stop_line);
}

ros2_interface::msg::JunctionInfo& ros2_interface::msg::JunctionInfo::operator =(
        const JunctionInfo& x)
{

    m_id = x.m_id;
    m_light_flag = x.m_light_flag;
    m_light_color = x.m_light_color;
    m_light_remain_time = x.m_light_remain_time;
    m_distance_to_stop = x.m_distance_to_stop;
    m_direction_flag = x.m_direction_flag;
    m_direction = x.m_direction;
    m_distance_to_junction = x.m_distance_to_junction;
    m_stop_line = x.m_stop_line;

    return *this;
}

ros2_interface::msg::JunctionInfo& ros2_interface::msg::JunctionInfo::operator =(
        JunctionInfo&& x) noexcept
{

    m_id = x.m_id;
    m_light_flag = x.m_light_flag;
    m_light_color = x.m_light_color;
    m_light_remain_time = x.m_light_remain_time;
    m_distance_to_stop = x.m_distance_to_stop;
    m_direction_flag = x.m_direction_flag;
    m_direction = x.m_direction;
    m_distance_to_junction = x.m_distance_to_junction;
    m_stop_line = std::move(x.m_stop_line);

    return *this;
}

bool ros2_interface::msg::JunctionInfo::operator ==(
        const JunctionInfo& x) const
{

    return (m_id == x.m_id && m_light_flag == x.m_light_flag && m_light_color == x.m_light_color && m_light_remain_time == x.m_light_remain_time && m_distance_to_stop == x.m_distance_to_stop && m_direction_flag == x.m_direction_flag && m_direction == x.m_direction && m_distance_to_junction == x.m_distance_to_junction && m_stop_line == x.m_stop_line);
}

bool ros2_interface::msg::JunctionInfo::operator !=(
        const JunctionInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::JunctionInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_JunctionInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::JunctionInfo::getCdrSerializedSize(
        const ros2_interface::msg::JunctionInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.stop_line().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.stop_line().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::JunctionInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_id;
    scdr << m_light_flag;
    scdr << m_light_color;
    scdr << m_light_remain_time;
    scdr << m_distance_to_stop;
    scdr << m_direction_flag;
    scdr << m_direction;
    scdr << m_distance_to_junction;
    scdr << m_stop_line;

}

void ros2_interface::msg::JunctionInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_id;
    dcdr >> m_light_flag;
    dcdr >> m_light_color;
    dcdr >> m_light_remain_time;
    dcdr >> m_distance_to_stop;
    dcdr >> m_direction_flag;
    dcdr >> m_direction;
    dcdr >> m_distance_to_junction;
    dcdr >> m_stop_line;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::JunctionInfo::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::JunctionInfo::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::JunctionInfo::id()
{
    return m_id;
}

/*!
 * @brief This function sets a value in member light_flag
 * @param _light_flag New value for member light_flag
 */
void ros2_interface::msg::JunctionInfo::light_flag(
        int32_t _light_flag)
{
    m_light_flag = _light_flag;
}

/*!
 * @brief This function returns the value of member light_flag
 * @return Value of member light_flag
 */
int32_t ros2_interface::msg::JunctionInfo::light_flag() const
{
    return m_light_flag;
}

/*!
 * @brief This function returns a reference to member light_flag
 * @return Reference to member light_flag
 */
int32_t& ros2_interface::msg::JunctionInfo::light_flag()
{
    return m_light_flag;
}

/*!
 * @brief This function sets a value in member light_color
 * @param _light_color New value for member light_color
 */
void ros2_interface::msg::JunctionInfo::light_color(
        int32_t _light_color)
{
    m_light_color = _light_color;
}

/*!
 * @brief This function returns the value of member light_color
 * @return Value of member light_color
 */
int32_t ros2_interface::msg::JunctionInfo::light_color() const
{
    return m_light_color;
}

/*!
 * @brief This function returns a reference to member light_color
 * @return Reference to member light_color
 */
int32_t& ros2_interface::msg::JunctionInfo::light_color()
{
    return m_light_color;
}

/*!
 * @brief This function sets a value in member light_remain_time
 * @param _light_remain_time New value for member light_remain_time
 */
void ros2_interface::msg::JunctionInfo::light_remain_time(
        double _light_remain_time)
{
    m_light_remain_time = _light_remain_time;
}

/*!
 * @brief This function returns the value of member light_remain_time
 * @return Value of member light_remain_time
 */
double ros2_interface::msg::JunctionInfo::light_remain_time() const
{
    return m_light_remain_time;
}

/*!
 * @brief This function returns a reference to member light_remain_time
 * @return Reference to member light_remain_time
 */
double& ros2_interface::msg::JunctionInfo::light_remain_time()
{
    return m_light_remain_time;
}

/*!
 * @brief This function sets a value in member distance_to_stop
 * @param _distance_to_stop New value for member distance_to_stop
 */
void ros2_interface::msg::JunctionInfo::distance_to_stop(
        double _distance_to_stop)
{
    m_distance_to_stop = _distance_to_stop;
}

/*!
 * @brief This function returns the value of member distance_to_stop
 * @return Value of member distance_to_stop
 */
double ros2_interface::msg::JunctionInfo::distance_to_stop() const
{
    return m_distance_to_stop;
}

/*!
 * @brief This function returns a reference to member distance_to_stop
 * @return Reference to member distance_to_stop
 */
double& ros2_interface::msg::JunctionInfo::distance_to_stop()
{
    return m_distance_to_stop;
}

/*!
 * @brief This function sets a value in member direction_flag
 * @param _direction_flag New value for member direction_flag
 */
void ros2_interface::msg::JunctionInfo::direction_flag(
        int32_t _direction_flag)
{
    m_direction_flag = _direction_flag;
}

/*!
 * @brief This function returns the value of member direction_flag
 * @return Value of member direction_flag
 */
int32_t ros2_interface::msg::JunctionInfo::direction_flag() const
{
    return m_direction_flag;
}

/*!
 * @brief This function returns a reference to member direction_flag
 * @return Reference to member direction_flag
 */
int32_t& ros2_interface::msg::JunctionInfo::direction_flag()
{
    return m_direction_flag;
}

/*!
 * @brief This function sets a value in member direction
 * @param _direction New value for member direction
 */
void ros2_interface::msg::JunctionInfo::direction(
        int32_t _direction)
{
    m_direction = _direction;
}

/*!
 * @brief This function returns the value of member direction
 * @return Value of member direction
 */
int32_t ros2_interface::msg::JunctionInfo::direction() const
{
    return m_direction;
}

/*!
 * @brief This function returns a reference to member direction
 * @return Reference to member direction
 */
int32_t& ros2_interface::msg::JunctionInfo::direction()
{
    return m_direction;
}

/*!
 * @brief This function sets a value in member distance_to_junction
 * @param _distance_to_junction New value for member distance_to_junction
 */
void ros2_interface::msg::JunctionInfo::distance_to_junction(
        double _distance_to_junction)
{
    m_distance_to_junction = _distance_to_junction;
}

/*!
 * @brief This function returns the value of member distance_to_junction
 * @return Value of member distance_to_junction
 */
double ros2_interface::msg::JunctionInfo::distance_to_junction() const
{
    return m_distance_to_junction;
}

/*!
 * @brief This function returns a reference to member distance_to_junction
 * @return Reference to member distance_to_junction
 */
double& ros2_interface::msg::JunctionInfo::distance_to_junction()
{
    return m_distance_to_junction;
}

/*!
 * @brief This function copies the value in member stop_line
 * @param _stop_line New value to be copied in member stop_line
 */
void ros2_interface::msg::JunctionInfo::stop_line(
        const std::vector<ros2_interface::msg::Point3D>& _stop_line)
{
    m_stop_line = _stop_line;
}

/*!
 * @brief This function moves the value in member stop_line
 * @param _stop_line New value to be moved in member stop_line
 */
void ros2_interface::msg::JunctionInfo::stop_line(
        std::vector<ros2_interface::msg::Point3D>&& _stop_line)
{
    m_stop_line = std::move(_stop_line);
}

/*!
 * @brief This function returns a constant reference to member stop_line
 * @return Constant reference to member stop_line
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::JunctionInfo::stop_line() const
{
    return m_stop_line;
}

/*!
 * @brief This function returns a reference to member stop_line
 * @return Reference to member stop_line
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::JunctionInfo::stop_line()
{
    return m_stop_line;
}


size_t ros2_interface::msg::JunctionInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_JunctionInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::JunctionInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::JunctionInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



