// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file JunctionInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_JUNCTIONINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_JUNCTIONINFO_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(JUNCTIONINFO_SOURCE)
#define JUNCTIONINFO_DllAPI __declspec( dllexport )
#else
#define JUNCTIONINFO_DllAPI __declspec( dllimport )
#endif // JUNCTIONINFO_SOURCE
#else
#define JUNCTIONINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define JUNCTIONINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure JunctionInfo defined by the user in the IDL file.
         * @ingroup JunctionInfo
         */
        class JunctionInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport JunctionInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~JunctionInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::JunctionInfo that will be copied.
             */
            eProsima_user_DllExport JunctionInfo(
                    const JunctionInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::JunctionInfo that will be copied.
             */
            eProsima_user_DllExport JunctionInfo(
                    JunctionInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::JunctionInfo that will be copied.
             */
            eProsima_user_DllExport JunctionInfo& operator =(
                    const JunctionInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::JunctionInfo that will be copied.
             */
            eProsima_user_DllExport JunctionInfo& operator =(
                    JunctionInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::JunctionInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const JunctionInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::JunctionInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const JunctionInfo& x) const;

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function sets a value in member light_flag
             * @param _light_flag New value for member light_flag
             */
            eProsima_user_DllExport void light_flag(
                    int32_t _light_flag);

            /*!
             * @brief This function returns the value of member light_flag
             * @return Value of member light_flag
             */
            eProsima_user_DllExport int32_t light_flag() const;

            /*!
             * @brief This function returns a reference to member light_flag
             * @return Reference to member light_flag
             */
            eProsima_user_DllExport int32_t& light_flag();

            /*!
             * @brief This function sets a value in member light_color
             * @param _light_color New value for member light_color
             */
            eProsima_user_DllExport void light_color(
                    int32_t _light_color);

            /*!
             * @brief This function returns the value of member light_color
             * @return Value of member light_color
             */
            eProsima_user_DllExport int32_t light_color() const;

            /*!
             * @brief This function returns a reference to member light_color
             * @return Reference to member light_color
             */
            eProsima_user_DllExport int32_t& light_color();

            /*!
             * @brief This function sets a value in member light_remain_time
             * @param _light_remain_time New value for member light_remain_time
             */
            eProsima_user_DllExport void light_remain_time(
                    double _light_remain_time);

            /*!
             * @brief This function returns the value of member light_remain_time
             * @return Value of member light_remain_time
             */
            eProsima_user_DllExport double light_remain_time() const;

            /*!
             * @brief This function returns a reference to member light_remain_time
             * @return Reference to member light_remain_time
             */
            eProsima_user_DllExport double& light_remain_time();

            /*!
             * @brief This function sets a value in member distance_to_stop
             * @param _distance_to_stop New value for member distance_to_stop
             */
            eProsima_user_DllExport void distance_to_stop(
                    double _distance_to_stop);

            /*!
             * @brief This function returns the value of member distance_to_stop
             * @return Value of member distance_to_stop
             */
            eProsima_user_DllExport double distance_to_stop() const;

            /*!
             * @brief This function returns a reference to member distance_to_stop
             * @return Reference to member distance_to_stop
             */
            eProsima_user_DllExport double& distance_to_stop();

            /*!
             * @brief This function sets a value in member direction_flag
             * @param _direction_flag New value for member direction_flag
             */
            eProsima_user_DllExport void direction_flag(
                    int32_t _direction_flag);

            /*!
             * @brief This function returns the value of member direction_flag
             * @return Value of member direction_flag
             */
            eProsima_user_DllExport int32_t direction_flag() const;

            /*!
             * @brief This function returns a reference to member direction_flag
             * @return Reference to member direction_flag
             */
            eProsima_user_DllExport int32_t& direction_flag();

            /*!
             * @brief This function sets a value in member direction
             * @param _direction New value for member direction
             */
            eProsima_user_DllExport void direction(
                    int32_t _direction);

            /*!
             * @brief This function returns the value of member direction
             * @return Value of member direction
             */
            eProsima_user_DllExport int32_t direction() const;

            /*!
             * @brief This function returns a reference to member direction
             * @return Reference to member direction
             */
            eProsima_user_DllExport int32_t& direction();

            /*!
             * @brief This function sets a value in member distance_to_junction
             * @param _distance_to_junction New value for member distance_to_junction
             */
            eProsima_user_DllExport void distance_to_junction(
                    double _distance_to_junction);

            /*!
             * @brief This function returns the value of member distance_to_junction
             * @return Value of member distance_to_junction
             */
            eProsima_user_DllExport double distance_to_junction() const;

            /*!
             * @brief This function returns a reference to member distance_to_junction
             * @return Reference to member distance_to_junction
             */
            eProsima_user_DllExport double& distance_to_junction();

            /*!
             * @brief This function copies the value in member stop_line
             * @param _stop_line New value to be copied in member stop_line
             */
            eProsima_user_DllExport void stop_line(
                    const std::vector<ros2_interface::msg::Point3D>& _stop_line);

            /*!
             * @brief This function moves the value in member stop_line
             * @param _stop_line New value to be moved in member stop_line
             */
            eProsima_user_DllExport void stop_line(
                    std::vector<ros2_interface::msg::Point3D>&& _stop_line);

            /*!
             * @brief This function returns a constant reference to member stop_line
             * @return Constant reference to member stop_line
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& stop_line() const;

            /*!
             * @brief This function returns a reference to member stop_line
             * @return Reference to member stop_line
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& stop_line();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::JunctionInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_id;
            int32_t m_light_flag;
            int32_t m_light_color;
            double m_light_remain_time;
            double m_distance_to_stop;
            int32_t m_direction_flag;
            int32_t m_direction;
            double m_distance_to_junction;
            std::vector<ros2_interface::msg::Point3D> m_stop_line;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_JUNCTIONINFO_H_

