// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file JunctionInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "JunctionInfo.h"
#include "JunctionInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerJunctionInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::JunctionInfo", ros2_interface::msg::GetJunctionInfoIdentifier(true),
                        ros2_interface::msg::GetJunctionInfoObject(true));
                factory->add_type_object("ros2_interface::msg::JunctionInfo", ros2_interface::msg::GetJunctionInfoIdentifier(false),
                        ros2_interface::msg::GetJunctionInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetJunctionInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("JunctionInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetJunctionInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("JunctionInfo", complete);
        }

        const TypeObject* GetJunctionInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("JunctionInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteJunctionInfoObject();
            }
            //else
            return GetMinimalJunctionInfoObject();
        }

        const TypeObject* GetMinimalJunctionInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("JunctionInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_light_flag;
            mst_light_flag.common().member_id(memberId++);
            mst_light_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_light_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_light_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_light_flag.common().member_flags().IS_OPTIONAL(false);
            mst_light_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_light_flag.common().member_flags().IS_KEY(false);
            mst_light_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_light_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 light_flag_hash("light_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_light_flag.detail().name_hash()[i] = light_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_light_flag);

            MinimalStructMember mst_light_color;
            mst_light_color.common().member_id(memberId++);
            mst_light_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_light_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_light_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_light_color.common().member_flags().IS_OPTIONAL(false);
            mst_light_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_light_color.common().member_flags().IS_KEY(false);
            mst_light_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_light_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 light_color_hash("light_color");
            for(int i = 0; i < 4; ++i)
            {
                mst_light_color.detail().name_hash()[i] = light_color_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_light_color);

            MinimalStructMember mst_light_remain_time;
            mst_light_remain_time.common().member_id(memberId++);
            mst_light_remain_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_light_remain_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_light_remain_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_light_remain_time.common().member_flags().IS_OPTIONAL(false);
            mst_light_remain_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_light_remain_time.common().member_flags().IS_KEY(false);
            mst_light_remain_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_light_remain_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 light_remain_time_hash("light_remain_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_light_remain_time.detail().name_hash()[i] = light_remain_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_light_remain_time);

            MinimalStructMember mst_distance_to_stop;
            mst_distance_to_stop.common().member_id(memberId++);
            mst_distance_to_stop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_distance_to_stop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_distance_to_stop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_distance_to_stop.common().member_flags().IS_OPTIONAL(false);
            mst_distance_to_stop.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_distance_to_stop.common().member_flags().IS_KEY(false);
            mst_distance_to_stop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_distance_to_stop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 distance_to_stop_hash("distance_to_stop");
            for(int i = 0; i < 4; ++i)
            {
                mst_distance_to_stop.detail().name_hash()[i] = distance_to_stop_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_distance_to_stop);

            MinimalStructMember mst_direction_flag;
            mst_direction_flag.common().member_id(memberId++);
            mst_direction_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_direction_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_direction_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_direction_flag.common().member_flags().IS_OPTIONAL(false);
            mst_direction_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_direction_flag.common().member_flags().IS_KEY(false);
            mst_direction_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_direction_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 direction_flag_hash("direction_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_direction_flag.detail().name_hash()[i] = direction_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_direction_flag);

            MinimalStructMember mst_direction;
            mst_direction.common().member_id(memberId++);
            mst_direction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_direction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_direction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_direction.common().member_flags().IS_OPTIONAL(false);
            mst_direction.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_direction.common().member_flags().IS_KEY(false);
            mst_direction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_direction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 direction_hash("direction");
            for(int i = 0; i < 4; ++i)
            {
                mst_direction.detail().name_hash()[i] = direction_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_direction);

            MinimalStructMember mst_distance_to_junction;
            mst_distance_to_junction.common().member_id(memberId++);
            mst_distance_to_junction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_distance_to_junction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_distance_to_junction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_distance_to_junction.common().member_flags().IS_OPTIONAL(false);
            mst_distance_to_junction.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_distance_to_junction.common().member_flags().IS_KEY(false);
            mst_distance_to_junction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_distance_to_junction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 distance_to_junction_hash("distance_to_junction");
            for(int i = 0; i < 4; ++i)
            {
                mst_distance_to_junction.detail().name_hash()[i] = distance_to_junction_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_distance_to_junction);

            MinimalStructMember mst_stop_line;
            mst_stop_line.common().member_id(memberId++);
            mst_stop_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_stop_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_stop_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_stop_line.common().member_flags().IS_OPTIONAL(false);
            mst_stop_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_stop_line.common().member_flags().IS_KEY(false);
            mst_stop_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_stop_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 stop_line_hash("stop_line");
            for(int i = 0; i < 4; ++i)
            {
                mst_stop_line.detail().name_hash()[i] = stop_line_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_stop_line);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("JunctionInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("JunctionInfo", false);
        }

        const TypeObject* GetCompleteJunctionInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("JunctionInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_light_flag;
            cst_light_flag.common().member_id(memberId++);
            cst_light_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_light_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_light_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_light_flag.common().member_flags().IS_OPTIONAL(false);
            cst_light_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_light_flag.common().member_flags().IS_KEY(false);
            cst_light_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_light_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_light_flag.detail().name("light_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_light_flag);

            CompleteStructMember cst_light_color;
            cst_light_color.common().member_id(memberId++);
            cst_light_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_light_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_light_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_light_color.common().member_flags().IS_OPTIONAL(false);
            cst_light_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_light_color.common().member_flags().IS_KEY(false);
            cst_light_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_light_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_light_color.detail().name("light_color");

            type_object->complete().struct_type().member_seq().emplace_back(cst_light_color);

            CompleteStructMember cst_light_remain_time;
            cst_light_remain_time.common().member_id(memberId++);
            cst_light_remain_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_light_remain_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_light_remain_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_light_remain_time.common().member_flags().IS_OPTIONAL(false);
            cst_light_remain_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_light_remain_time.common().member_flags().IS_KEY(false);
            cst_light_remain_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_light_remain_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_light_remain_time.detail().name("light_remain_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_light_remain_time);

            CompleteStructMember cst_distance_to_stop;
            cst_distance_to_stop.common().member_id(memberId++);
            cst_distance_to_stop.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_distance_to_stop.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_distance_to_stop.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_distance_to_stop.common().member_flags().IS_OPTIONAL(false);
            cst_distance_to_stop.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_distance_to_stop.common().member_flags().IS_KEY(false);
            cst_distance_to_stop.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_distance_to_stop.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_distance_to_stop.detail().name("distance_to_stop");

            type_object->complete().struct_type().member_seq().emplace_back(cst_distance_to_stop);

            CompleteStructMember cst_direction_flag;
            cst_direction_flag.common().member_id(memberId++);
            cst_direction_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_direction_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_direction_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_direction_flag.common().member_flags().IS_OPTIONAL(false);
            cst_direction_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_direction_flag.common().member_flags().IS_KEY(false);
            cst_direction_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_direction_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_direction_flag.detail().name("direction_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_direction_flag);

            CompleteStructMember cst_direction;
            cst_direction.common().member_id(memberId++);
            cst_direction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_direction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_direction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_direction.common().member_flags().IS_OPTIONAL(false);
            cst_direction.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_direction.common().member_flags().IS_KEY(false);
            cst_direction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_direction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_direction.detail().name("direction");

            type_object->complete().struct_type().member_seq().emplace_back(cst_direction);

            CompleteStructMember cst_distance_to_junction;
            cst_distance_to_junction.common().member_id(memberId++);
            cst_distance_to_junction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_distance_to_junction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_distance_to_junction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_distance_to_junction.common().member_flags().IS_OPTIONAL(false);
            cst_distance_to_junction.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_distance_to_junction.common().member_flags().IS_KEY(false);
            cst_distance_to_junction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_distance_to_junction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_distance_to_junction.detail().name("distance_to_junction");

            type_object->complete().struct_type().member_seq().emplace_back(cst_distance_to_junction);

            CompleteStructMember cst_stop_line;
            cst_stop_line.common().member_id(memberId++);
            cst_stop_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_stop_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_stop_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_stop_line.common().member_flags().IS_OPTIONAL(false);
            cst_stop_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_stop_line.common().member_flags().IS_KEY(false);
            cst_stop_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_stop_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_stop_line.detail().name("stop_line");

            type_object->complete().struct_type().member_seq().emplace_back(cst_stop_line);


            // Header
            type_object->complete().struct_type().header().detail().type_name("JunctionInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("JunctionInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("JunctionInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface