// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file KeyPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "KeyPoint.h"
#include "KeyPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_KeyPoint_max_cdr_typesize 300ULL;
#define ros2_interface_msg_KeyPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::KeyPoint::KeyPoint()
{
    // short m_id
    m_id = 0;
    // double m_latitude
    m_latitude = 0.0;
    // double m_longitude
    m_longitude = 0.0;
    // double m_ele
    m_ele = 0.0;
    // double m_heading
    m_heading = 0.0;
    // string m_name
    m_name ="";

    // Just to register all known types
    registerKeyPointTypes();
}

ros2_interface::msg::KeyPoint::~KeyPoint()
{






}

ros2_interface::msg::KeyPoint::KeyPoint(
        const KeyPoint& x)
{
    m_id = x.m_id;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_ele = x.m_ele;
    m_heading = x.m_heading;
    m_name = x.m_name;
}

ros2_interface::msg::KeyPoint::KeyPoint(
        KeyPoint&& x) noexcept 
{
    m_id = x.m_id;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_ele = x.m_ele;
    m_heading = x.m_heading;
    m_name = std::move(x.m_name);
}

ros2_interface::msg::KeyPoint& ros2_interface::msg::KeyPoint::operator =(
        const KeyPoint& x)
{

    m_id = x.m_id;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_ele = x.m_ele;
    m_heading = x.m_heading;
    m_name = x.m_name;

    return *this;
}

ros2_interface::msg::KeyPoint& ros2_interface::msg::KeyPoint::operator =(
        KeyPoint&& x) noexcept
{

    m_id = x.m_id;
    m_latitude = x.m_latitude;
    m_longitude = x.m_longitude;
    m_ele = x.m_ele;
    m_heading = x.m_heading;
    m_name = std::move(x.m_name);

    return *this;
}

bool ros2_interface::msg::KeyPoint::operator ==(
        const KeyPoint& x) const
{

    return (m_id == x.m_id && m_latitude == x.m_latitude && m_longitude == x.m_longitude && m_ele == x.m_ele && m_heading == x.m_heading && m_name == x.m_name);
}

bool ros2_interface::msg::KeyPoint::operator !=(
        const KeyPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::KeyPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_KeyPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::KeyPoint::getCdrSerializedSize(
        const ros2_interface::msg::KeyPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::KeyPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_id;
    scdr << m_latitude;
    scdr << m_longitude;
    scdr << m_ele;
    scdr << m_heading;
    scdr << m_name.c_str();

}

void ros2_interface::msg::KeyPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_id;
    dcdr >> m_latitude;
    dcdr >> m_longitude;
    dcdr >> m_ele;
    dcdr >> m_heading;
    dcdr >> m_name;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::KeyPoint::id(
        int16_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int16_t ros2_interface::msg::KeyPoint::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int16_t& ros2_interface::msg::KeyPoint::id()
{
    return m_id;
}

/*!
 * @brief This function sets a value in member latitude
 * @param _latitude New value for member latitude
 */
void ros2_interface::msg::KeyPoint::latitude(
        double _latitude)
{
    m_latitude = _latitude;
}

/*!
 * @brief This function returns the value of member latitude
 * @return Value of member latitude
 */
double ros2_interface::msg::KeyPoint::latitude() const
{
    return m_latitude;
}

/*!
 * @brief This function returns a reference to member latitude
 * @return Reference to member latitude
 */
double& ros2_interface::msg::KeyPoint::latitude()
{
    return m_latitude;
}

/*!
 * @brief This function sets a value in member longitude
 * @param _longitude New value for member longitude
 */
void ros2_interface::msg::KeyPoint::longitude(
        double _longitude)
{
    m_longitude = _longitude;
}

/*!
 * @brief This function returns the value of member longitude
 * @return Value of member longitude
 */
double ros2_interface::msg::KeyPoint::longitude() const
{
    return m_longitude;
}

/*!
 * @brief This function returns a reference to member longitude
 * @return Reference to member longitude
 */
double& ros2_interface::msg::KeyPoint::longitude()
{
    return m_longitude;
}

/*!
 * @brief This function sets a value in member ele
 * @param _ele New value for member ele
 */
void ros2_interface::msg::KeyPoint::ele(
        double _ele)
{
    m_ele = _ele;
}

/*!
 * @brief This function returns the value of member ele
 * @return Value of member ele
 */
double ros2_interface::msg::KeyPoint::ele() const
{
    return m_ele;
}

/*!
 * @brief This function returns a reference to member ele
 * @return Reference to member ele
 */
double& ros2_interface::msg::KeyPoint::ele()
{
    return m_ele;
}

/*!
 * @brief This function sets a value in member heading
 * @param _heading New value for member heading
 */
void ros2_interface::msg::KeyPoint::heading(
        double _heading)
{
    m_heading = _heading;
}

/*!
 * @brief This function returns the value of member heading
 * @return Value of member heading
 */
double ros2_interface::msg::KeyPoint::heading() const
{
    return m_heading;
}

/*!
 * @brief This function returns a reference to member heading
 * @return Reference to member heading
 */
double& ros2_interface::msg::KeyPoint::heading()
{
    return m_heading;
}

/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::KeyPoint::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::KeyPoint::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::KeyPoint::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::KeyPoint::name()
{
    return m_name;
}


size_t ros2_interface::msg::KeyPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_KeyPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::KeyPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::KeyPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



