// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file KeyPoint.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_KEYPOINT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_KEYPOINT_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(KEYPOINT_SOURCE)
#define KEYPOINT_DllAPI __declspec( dllexport )
#else
#define KEYPOINT_DllAPI __declspec( dllimport )
#endif // KEYPOINT_SOURCE
#else
#define KEYPOINT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define KEYPOINT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure KeyPoint defined by the user in the IDL file.
         * @ingroup KeyPoint
         */
        class KeyPoint
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport KeyPoint();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~KeyPoint();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::KeyPoint that will be copied.
             */
            eProsima_user_DllExport KeyPoint(
                    const KeyPoint& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::KeyPoint that will be copied.
             */
            eProsima_user_DllExport KeyPoint(
                    KeyPoint&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::KeyPoint that will be copied.
             */
            eProsima_user_DllExport KeyPoint& operator =(
                    const KeyPoint& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::KeyPoint that will be copied.
             */
            eProsima_user_DllExport KeyPoint& operator =(
                    KeyPoint&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::KeyPoint object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const KeyPoint& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::KeyPoint object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const KeyPoint& x) const;

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int16_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int16_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int16_t& id();

            /*!
             * @brief This function sets a value in member latitude
             * @param _latitude New value for member latitude
             */
            eProsima_user_DllExport void latitude(
                    double _latitude);

            /*!
             * @brief This function returns the value of member latitude
             * @return Value of member latitude
             */
            eProsima_user_DllExport double latitude() const;

            /*!
             * @brief This function returns a reference to member latitude
             * @return Reference to member latitude
             */
            eProsima_user_DllExport double& latitude();

            /*!
             * @brief This function sets a value in member longitude
             * @param _longitude New value for member longitude
             */
            eProsima_user_DllExport void longitude(
                    double _longitude);

            /*!
             * @brief This function returns the value of member longitude
             * @return Value of member longitude
             */
            eProsima_user_DllExport double longitude() const;

            /*!
             * @brief This function returns a reference to member longitude
             * @return Reference to member longitude
             */
            eProsima_user_DllExport double& longitude();

            /*!
             * @brief This function sets a value in member ele
             * @param _ele New value for member ele
             */
            eProsima_user_DllExport void ele(
                    double _ele);

            /*!
             * @brief This function returns the value of member ele
             * @return Value of member ele
             */
            eProsima_user_DllExport double ele() const;

            /*!
             * @brief This function returns a reference to member ele
             * @return Reference to member ele
             */
            eProsima_user_DllExport double& ele();

            /*!
             * @brief This function sets a value in member heading
             * @param _heading New value for member heading
             */
            eProsima_user_DllExport void heading(
                    double _heading);

            /*!
             * @brief This function returns the value of member heading
             * @return Value of member heading
             */
            eProsima_user_DllExport double heading() const;

            /*!
             * @brief This function returns a reference to member heading
             * @return Reference to member heading
             */
            eProsima_user_DllExport double& heading();

            /*!
             * @brief This function copies the value in member name
             * @param _name New value to be copied in member name
             */
            eProsima_user_DllExport void name(
                    const std::string& _name);

            /*!
             * @brief This function moves the value in member name
             * @param _name New value to be moved in member name
             */
            eProsima_user_DllExport void name(
                    std::string&& _name);

            /*!
             * @brief This function returns a constant reference to member name
             * @return Constant reference to member name
             */
            eProsima_user_DllExport const std::string& name() const;

            /*!
             * @brief This function returns a reference to member name
             * @return Reference to member name
             */
            eProsima_user_DllExport std::string& name();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::KeyPoint& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int16_t m_id;
            double m_latitude;
            double m_longitude;
            double m_ele;
            double m_heading;
            std::string m_name;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_KEYPOINT_H_

