// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file KeyPointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "KeyPoint.h"
#include "KeyPointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerKeyPointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::KeyPoint", ros2_interface::msg::GetKeyPointIdentifier(true),
                        ros2_interface::msg::GetKeyPointObject(true));
                factory->add_type_object("ros2_interface::msg::KeyPoint", ros2_interface::msg::GetKeyPointIdentifier(false),
                        ros2_interface::msg::GetKeyPointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetKeyPointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("KeyPoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetKeyPointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("KeyPoint", complete);
        }

        const TypeObject* GetKeyPointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("KeyPoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteKeyPointObject();
            }
            //else
            return GetMinimalKeyPointObject();
        }

        const TypeObject* GetMinimalKeyPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("KeyPoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_latitude;
            mst_latitude.common().member_id(memberId++);
            mst_latitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_latitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_latitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_latitude.common().member_flags().IS_OPTIONAL(false);
            mst_latitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_latitude.common().member_flags().IS_KEY(false);
            mst_latitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_latitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 latitude_hash("latitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_latitude.detail().name_hash()[i] = latitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_latitude);

            MinimalStructMember mst_longitude;
            mst_longitude.common().member_id(memberId++);
            mst_longitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_longitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_longitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_longitude.common().member_flags().IS_OPTIONAL(false);
            mst_longitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_longitude.common().member_flags().IS_KEY(false);
            mst_longitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_longitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 longitude_hash("longitude");
            for(int i = 0; i < 4; ++i)
            {
                mst_longitude.detail().name_hash()[i] = longitude_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_longitude);

            MinimalStructMember mst_ele;
            mst_ele.common().member_id(memberId++);
            mst_ele.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ele.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ele.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ele.common().member_flags().IS_OPTIONAL(false);
            mst_ele.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ele.common().member_flags().IS_KEY(false);
            mst_ele.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ele.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ele_hash("ele");
            for(int i = 0; i < 4; ++i)
            {
                mst_ele.detail().name_hash()[i] = ele_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ele);

            MinimalStructMember mst_heading;
            mst_heading.common().member_id(memberId++);
            mst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading.common().member_flags().IS_OPTIONAL(false);
            mst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading.common().member_flags().IS_KEY(false);
            mst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_hash("heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading.detail().name_hash()[i] = heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading);

            MinimalStructMember mst_name;
            mst_name.common().member_id(memberId++);
            mst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_name.common().member_flags().IS_OPTIONAL(false);
            mst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_name.common().member_flags().IS_KEY(false);
            mst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 name_hash("name");
            for(int i = 0; i < 4; ++i)
            {
                mst_name.detail().name_hash()[i] = name_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_name);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("KeyPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("KeyPoint", false);
        }

        const TypeObject* GetCompleteKeyPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("KeyPoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_latitude;
            cst_latitude.common().member_id(memberId++);
            cst_latitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_latitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_latitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_latitude.common().member_flags().IS_OPTIONAL(false);
            cst_latitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_latitude.common().member_flags().IS_KEY(false);
            cst_latitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_latitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_latitude.detail().name("latitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_latitude);

            CompleteStructMember cst_longitude;
            cst_longitude.common().member_id(memberId++);
            cst_longitude.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_longitude.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_longitude.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_longitude.common().member_flags().IS_OPTIONAL(false);
            cst_longitude.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_longitude.common().member_flags().IS_KEY(false);
            cst_longitude.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_longitude.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_longitude.detail().name("longitude");

            type_object->complete().struct_type().member_seq().emplace_back(cst_longitude);

            CompleteStructMember cst_ele;
            cst_ele.common().member_id(memberId++);
            cst_ele.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ele.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ele.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ele.common().member_flags().IS_OPTIONAL(false);
            cst_ele.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ele.common().member_flags().IS_KEY(false);
            cst_ele.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ele.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ele.detail().name("ele");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ele);

            CompleteStructMember cst_heading;
            cst_heading.common().member_id(memberId++);
            cst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading.common().member_flags().IS_OPTIONAL(false);
            cst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading.common().member_flags().IS_KEY(false);
            cst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading.detail().name("heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading);

            CompleteStructMember cst_name;
            cst_name.common().member_id(memberId++);
            cst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_name.common().member_flags().IS_OPTIONAL(false);
            cst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_name.common().member_flags().IS_KEY(false);
            cst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_name.detail().name("name");

            type_object->complete().struct_type().member_seq().emplace_back(cst_name);


            // Header
            type_object->complete().struct_type().header().detail().type_name("KeyPoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("KeyPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("KeyPoint", true);
        }

    } // namespace msg
} // namespace ros2_interface