// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LaneInfo.h"
#include "LaneInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_LaneInfo_max_cdr_typesize 7208ULL;
#define ros2_interface_msg_LanePoint_max_cdr_typesize 72ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LaneInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LanePoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LaneInfo::LaneInfo()
{
    // int8 m_priority
    m_priority = 0;
    // int8 m_global_id
    m_global_id = 0;
    // int8 m_type
    m_type = 0;
    // sequence<ros2_interface::msg::LanePoint> m_lane_points


    // Just to register all known types
    registerLaneInfoTypes();
}

ros2_interface::msg::LaneInfo::~LaneInfo()
{




}

ros2_interface::msg::LaneInfo::LaneInfo(
        const LaneInfo& x)
{
    m_priority = x.m_priority;
    m_global_id = x.m_global_id;
    m_type = x.m_type;
    m_lane_points = x.m_lane_points;
}

ros2_interface::msg::LaneInfo::LaneInfo(
        LaneInfo&& x) noexcept 
{
    m_priority = x.m_priority;
    m_global_id = x.m_global_id;
    m_type = x.m_type;
    m_lane_points = std::move(x.m_lane_points);
}

ros2_interface::msg::LaneInfo& ros2_interface::msg::LaneInfo::operator =(
        const LaneInfo& x)
{

    m_priority = x.m_priority;
    m_global_id = x.m_global_id;
    m_type = x.m_type;
    m_lane_points = x.m_lane_points;

    return *this;
}

ros2_interface::msg::LaneInfo& ros2_interface::msg::LaneInfo::operator =(
        LaneInfo&& x) noexcept
{

    m_priority = x.m_priority;
    m_global_id = x.m_global_id;
    m_type = x.m_type;
    m_lane_points = std::move(x.m_lane_points);

    return *this;
}

bool ros2_interface::msg::LaneInfo::operator ==(
        const LaneInfo& x) const
{

    return (m_priority == x.m_priority && m_global_id == x.m_global_id && m_type == x.m_type && m_lane_points == x.m_lane_points);
}

bool ros2_interface::msg::LaneInfo::operator !=(
        const LaneInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LaneInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::LaneInfo::getCdrSerializedSize(
        const ros2_interface::msg::LaneInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.lane_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::LanePoint::getCdrSerializedSize(data.lane_points().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LaneInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_priority;
    scdr << m_global_id;
    scdr << m_type;
    scdr << m_lane_points;

}

void ros2_interface::msg::LaneInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_priority;
    dcdr >> m_global_id;
    dcdr >> m_type;
    dcdr >> m_lane_points;
}

/*!
 * @brief This function sets a value in member priority
 * @param _priority New value for member priority
 */
void ros2_interface::msg::LaneInfo::priority(
        int8_t _priority)
{
    m_priority = _priority;
}

/*!
 * @brief This function returns the value of member priority
 * @return Value of member priority
 */
int8_t ros2_interface::msg::LaneInfo::priority() const
{
    return m_priority;
}

/*!
 * @brief This function returns a reference to member priority
 * @return Reference to member priority
 */
int8_t& ros2_interface::msg::LaneInfo::priority()
{
    return m_priority;
}

/*!
 * @brief This function sets a value in member global_id
 * @param _global_id New value for member global_id
 */
void ros2_interface::msg::LaneInfo::global_id(
        int8_t _global_id)
{
    m_global_id = _global_id;
}

/*!
 * @brief This function returns the value of member global_id
 * @return Value of member global_id
 */
int8_t ros2_interface::msg::LaneInfo::global_id() const
{
    return m_global_id;
}

/*!
 * @brief This function returns a reference to member global_id
 * @return Reference to member global_id
 */
int8_t& ros2_interface::msg::LaneInfo::global_id()
{
    return m_global_id;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::LaneInfo::type(
        int8_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int8_t ros2_interface::msg::LaneInfo::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int8_t& ros2_interface::msg::LaneInfo::type()
{
    return m_type;
}

/*!
 * @brief This function copies the value in member lane_points
 * @param _lane_points New value to be copied in member lane_points
 */
void ros2_interface::msg::LaneInfo::lane_points(
        const std::vector<ros2_interface::msg::LanePoint>& _lane_points)
{
    m_lane_points = _lane_points;
}

/*!
 * @brief This function moves the value in member lane_points
 * @param _lane_points New value to be moved in member lane_points
 */
void ros2_interface::msg::LaneInfo::lane_points(
        std::vector<ros2_interface::msg::LanePoint>&& _lane_points)
{
    m_lane_points = std::move(_lane_points);
}

/*!
 * @brief This function returns a constant reference to member lane_points
 * @return Constant reference to member lane_points
 */
const std::vector<ros2_interface::msg::LanePoint>& ros2_interface::msg::LaneInfo::lane_points() const
{
    return m_lane_points;
}

/*!
 * @brief This function returns a reference to member lane_points
 * @return Reference to member lane_points
 */
std::vector<ros2_interface::msg::LanePoint>& ros2_interface::msg::LaneInfo::lane_points()
{
    return m_lane_points;
}


size_t ros2_interface::msg::LaneInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::LaneInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LaneInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



