// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEINFO_H_

#include "LanePoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(LANEINFO_SOURCE)
#define LANEINFO_DllAPI __declspec( dllexport )
#else
#define LANEINFO_DllAPI __declspec( dllimport )
#endif // LANEINFO_SOURCE
#else
#define LANEINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define LANEINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure LaneInfo defined by the user in the IDL file.
         * @ingroup LaneInfo
         */
        class LaneInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport LaneInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~LaneInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::LaneInfo that will be copied.
             */
            eProsima_user_DllExport LaneInfo(
                    const LaneInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::LaneInfo that will be copied.
             */
            eProsima_user_DllExport LaneInfo(
                    LaneInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::LaneInfo that will be copied.
             */
            eProsima_user_DllExport LaneInfo& operator =(
                    const LaneInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::LaneInfo that will be copied.
             */
            eProsima_user_DllExport LaneInfo& operator =(
                    LaneInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LaneInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const LaneInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LaneInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const LaneInfo& x) const;

            /*!
             * @brief This function sets a value in member priority
             * @param _priority New value for member priority
             */
            eProsima_user_DllExport void priority(
                    int8_t _priority);

            /*!
             * @brief This function returns the value of member priority
             * @return Value of member priority
             */
            eProsima_user_DllExport int8_t priority() const;

            /*!
             * @brief This function returns a reference to member priority
             * @return Reference to member priority
             */
            eProsima_user_DllExport int8_t& priority();

            /*!
             * @brief This function sets a value in member global_id
             * @param _global_id New value for member global_id
             */
            eProsima_user_DllExport void global_id(
                    int8_t _global_id);

            /*!
             * @brief This function returns the value of member global_id
             * @return Value of member global_id
             */
            eProsima_user_DllExport int8_t global_id() const;

            /*!
             * @brief This function returns a reference to member global_id
             * @return Reference to member global_id
             */
            eProsima_user_DllExport int8_t& global_id();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int8_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int8_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int8_t& type();

            /*!
             * @brief This function copies the value in member lane_points
             * @param _lane_points New value to be copied in member lane_points
             */
            eProsima_user_DllExport void lane_points(
                    const std::vector<ros2_interface::msg::LanePoint>& _lane_points);

            /*!
             * @brief This function moves the value in member lane_points
             * @param _lane_points New value to be moved in member lane_points
             */
            eProsima_user_DllExport void lane_points(
                    std::vector<ros2_interface::msg::LanePoint>&& _lane_points);

            /*!
             * @brief This function returns a constant reference to member lane_points
             * @return Constant reference to member lane_points
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::LanePoint>& lane_points() const;

            /*!
             * @brief This function returns a reference to member lane_points
             * @return Reference to member lane_points
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::LanePoint>& lane_points();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::LaneInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int8_t m_priority;
            int8_t m_global_id;
            int8_t m_type;
            std::vector<ros2_interface::msg::LanePoint> m_lane_points;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEINFO_H_

