// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "LaneInfo.h"
#include "LaneInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLaneInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(true),
                        ros2_interface::msg::GetLanePointObject(true));
                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(false),
                        ros2_interface::msg::GetLanePointObject(false));



                factory->add_type_object("ros2_interface::msg::LaneInfo", ros2_interface::msg::GetLaneInfoIdentifier(true),
                        ros2_interface::msg::GetLaneInfoObject(true));
                factory->add_type_object("ros2_interface::msg::LaneInfo", ros2_interface::msg::GetLaneInfoIdentifier(false),
                        ros2_interface::msg::GetLaneInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLaneInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("LaneInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLaneInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("LaneInfo", complete);
        }

        const TypeObject* GetLaneInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLaneInfoObject();
            }
            //else
            return GetMinimalLaneInfoObject();
        }

        const TypeObject* GetMinimalLaneInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_priority;
            mst_priority.common().member_id(memberId++);
            mst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_priority.common().member_flags().IS_OPTIONAL(false);
            mst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_priority.common().member_flags().IS_KEY(false);
            mst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_priority.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 priority_hash("priority");
            for(int i = 0; i < 4; ++i)
            {
                mst_priority.detail().name_hash()[i] = priority_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_priority);

            MinimalStructMember mst_global_id;
            mst_global_id.common().member_id(memberId++);
            mst_global_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_global_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_global_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_global_id.common().member_flags().IS_OPTIONAL(false);
            mst_global_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_global_id.common().member_flags().IS_KEY(false);
            mst_global_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_global_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 global_id_hash("global_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_global_id.detail().name_hash()[i] = global_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_global_id);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_lane_points;
            mst_lane_points.common().member_id(memberId++);
            mst_lane_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_points.common().member_flags().IS_OPTIONAL(false);
            mst_lane_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_points.common().member_flags().IS_KEY(false);
            mst_lane_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LanePoint", 100, false));


            MD5 lane_points_hash("lane_points");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_points.detail().name_hash()[i] = lane_points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_points);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneInfo", false);
        }

        const TypeObject* GetCompleteLaneInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_priority;
            cst_priority.common().member_id(memberId++);
            cst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_priority.common().member_flags().IS_OPTIONAL(false);
            cst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_priority.common().member_flags().IS_KEY(false);
            cst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_priority.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_priority.detail().name("priority");

            type_object->complete().struct_type().member_seq().emplace_back(cst_priority);

            CompleteStructMember cst_global_id;
            cst_global_id.common().member_id(memberId++);
            cst_global_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_global_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_global_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_global_id.common().member_flags().IS_OPTIONAL(false);
            cst_global_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_global_id.common().member_flags().IS_KEY(false);
            cst_global_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_global_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_global_id.detail().name("global_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_global_id);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_lane_points;
            cst_lane_points.common().member_id(memberId++);
            cst_lane_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_points.common().member_flags().IS_OPTIONAL(false);
            cst_lane_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_points.common().member_flags().IS_KEY(false);
            cst_lane_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LanePoint", 100, true));


            cst_lane_points.detail().name("lane_points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_points);


            // Header
            type_object->complete().struct_type().header().detail().type_name("LaneInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface