// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneLine.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LaneLine.h"
#include "LaneLineTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_LaneLineCubicCurve_max_cdr_typesize 48ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_EndPoints_max_cdr_typesize 32ULL;
#define ros2_interface_msg_LaneLine_max_cdr_typesize 8260ULL;
#define ros2_interface_msg_LaneLineCubicCurve_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_EndPoints_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LaneLine_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LaneLine::LaneLine()
{
    // long m_lane_type
    m_lane_type = 0;
    // long m_lane_color
    m_lane_color = 0;
    // long m_pos_type
    m_pos_type = 0;
    // ros2_interface::msg::LaneLineCubicCurve m_curve_vehicle

    // ros2_interface::msg::LaneLineCubicCurve m_curve_image

    // ros2_interface::msg::LaneLineCubicCurve m_curve_abs

    // sequence<ros2_interface::msg::Point3D> m_pts_vehicle

    // sequence<ros2_interface::msg::Point2D> m_pts_image

    // sequence<ros2_interface::msg::Point3D> m_pts_abs

    // ros2_interface::msg::EndPoints m_image_end_point

    // sequence<ros2_interface::msg::Point2D> m_pts_key

    // uint8 m_hd_lane_id
    m_hd_lane_id = 0;
    // uint8 m_lane_id
    m_lane_id = 0;
    // double m_confidence
    m_confidence = 0.0;
    // long m_lane_quality
    m_lane_quality = 0;
    // long m_fused_lane_type
    m_fused_lane_type = 0;
    // long m_use_type
    m_use_type = 0;
    // ros2_interface::msg::Time m_create_time


    // Just to register all known types
    registerLaneLineTypes();
}

ros2_interface::msg::LaneLine::~LaneLine()
{


















}

ros2_interface::msg::LaneLine::LaneLine(
        const LaneLine& x)
{
    m_lane_type = x.m_lane_type;
    m_lane_color = x.m_lane_color;
    m_pos_type = x.m_pos_type;
    m_curve_vehicle = x.m_curve_vehicle;
    m_curve_image = x.m_curve_image;
    m_curve_abs = x.m_curve_abs;
    m_pts_vehicle = x.m_pts_vehicle;
    m_pts_image = x.m_pts_image;
    m_pts_abs = x.m_pts_abs;
    m_image_end_point = x.m_image_end_point;
    m_pts_key = x.m_pts_key;
    m_hd_lane_id = x.m_hd_lane_id;
    m_lane_id = x.m_lane_id;
    m_confidence = x.m_confidence;
    m_lane_quality = x.m_lane_quality;
    m_fused_lane_type = x.m_fused_lane_type;
    m_use_type = x.m_use_type;
    m_create_time = x.m_create_time;
}

ros2_interface::msg::LaneLine::LaneLine(
        LaneLine&& x) noexcept 
{
    m_lane_type = x.m_lane_type;
    m_lane_color = x.m_lane_color;
    m_pos_type = x.m_pos_type;
    m_curve_vehicle = std::move(x.m_curve_vehicle);
    m_curve_image = std::move(x.m_curve_image);
    m_curve_abs = std::move(x.m_curve_abs);
    m_pts_vehicle = std::move(x.m_pts_vehicle);
    m_pts_image = std::move(x.m_pts_image);
    m_pts_abs = std::move(x.m_pts_abs);
    m_image_end_point = std::move(x.m_image_end_point);
    m_pts_key = std::move(x.m_pts_key);
    m_hd_lane_id = x.m_hd_lane_id;
    m_lane_id = x.m_lane_id;
    m_confidence = x.m_confidence;
    m_lane_quality = x.m_lane_quality;
    m_fused_lane_type = x.m_fused_lane_type;
    m_use_type = x.m_use_type;
    m_create_time = std::move(x.m_create_time);
}

ros2_interface::msg::LaneLine& ros2_interface::msg::LaneLine::operator =(
        const LaneLine& x)
{

    m_lane_type = x.m_lane_type;
    m_lane_color = x.m_lane_color;
    m_pos_type = x.m_pos_type;
    m_curve_vehicle = x.m_curve_vehicle;
    m_curve_image = x.m_curve_image;
    m_curve_abs = x.m_curve_abs;
    m_pts_vehicle = x.m_pts_vehicle;
    m_pts_image = x.m_pts_image;
    m_pts_abs = x.m_pts_abs;
    m_image_end_point = x.m_image_end_point;
    m_pts_key = x.m_pts_key;
    m_hd_lane_id = x.m_hd_lane_id;
    m_lane_id = x.m_lane_id;
    m_confidence = x.m_confidence;
    m_lane_quality = x.m_lane_quality;
    m_fused_lane_type = x.m_fused_lane_type;
    m_use_type = x.m_use_type;
    m_create_time = x.m_create_time;

    return *this;
}

ros2_interface::msg::LaneLine& ros2_interface::msg::LaneLine::operator =(
        LaneLine&& x) noexcept
{

    m_lane_type = x.m_lane_type;
    m_lane_color = x.m_lane_color;
    m_pos_type = x.m_pos_type;
    m_curve_vehicle = std::move(x.m_curve_vehicle);
    m_curve_image = std::move(x.m_curve_image);
    m_curve_abs = std::move(x.m_curve_abs);
    m_pts_vehicle = std::move(x.m_pts_vehicle);
    m_pts_image = std::move(x.m_pts_image);
    m_pts_abs = std::move(x.m_pts_abs);
    m_image_end_point = std::move(x.m_image_end_point);
    m_pts_key = std::move(x.m_pts_key);
    m_hd_lane_id = x.m_hd_lane_id;
    m_lane_id = x.m_lane_id;
    m_confidence = x.m_confidence;
    m_lane_quality = x.m_lane_quality;
    m_fused_lane_type = x.m_fused_lane_type;
    m_use_type = x.m_use_type;
    m_create_time = std::move(x.m_create_time);

    return *this;
}

bool ros2_interface::msg::LaneLine::operator ==(
        const LaneLine& x) const
{

    return (m_lane_type == x.m_lane_type && m_lane_color == x.m_lane_color && m_pos_type == x.m_pos_type && m_curve_vehicle == x.m_curve_vehicle && m_curve_image == x.m_curve_image && m_curve_abs == x.m_curve_abs && m_pts_vehicle == x.m_pts_vehicle && m_pts_image == x.m_pts_image && m_pts_abs == x.m_pts_abs && m_image_end_point == x.m_image_end_point && m_pts_key == x.m_pts_key && m_hd_lane_id == x.m_hd_lane_id && m_lane_id == x.m_lane_id && m_confidence == x.m_confidence && m_lane_quality == x.m_lane_quality && m_fused_lane_type == x.m_fused_lane_type && m_use_type == x.m_use_type && m_create_time == x.m_create_time);
}

bool ros2_interface::msg::LaneLine::operator !=(
        const LaneLine& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LaneLine::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneLine_max_cdr_typesize;
}

size_t ros2_interface::msg::LaneLine::getCdrSerializedSize(
        const ros2_interface::msg::LaneLine& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::LaneLineCubicCurve::getCdrSerializedSize(data.curve_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::LaneLineCubicCurve::getCdrSerializedSize(data.curve_image(), current_alignment);
    current_alignment += ros2_interface::msg::LaneLineCubicCurve::getCdrSerializedSize(data.curve_abs(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.pts_vehicle().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.pts_vehicle().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.pts_image().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.pts_image().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.pts_abs().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.pts_abs().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::EndPoints::getCdrSerializedSize(data.image_end_point(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.pts_key().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.pts_key().at(a), current_alignment);}

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.create_time(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LaneLine::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_lane_type;
    scdr << m_lane_color;
    scdr << m_pos_type;
    scdr << m_curve_vehicle;
    scdr << m_curve_image;
    scdr << m_curve_abs;
    scdr << m_pts_vehicle;
    scdr << m_pts_image;
    scdr << m_pts_abs;
    scdr << m_image_end_point;
    scdr << m_pts_key;
    scdr << m_hd_lane_id;
    scdr << m_lane_id;
    scdr << m_confidence;
    scdr << m_lane_quality;
    scdr << m_fused_lane_type;
    scdr << m_use_type;
    scdr << m_create_time;

}

void ros2_interface::msg::LaneLine::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_lane_type;
    dcdr >> m_lane_color;
    dcdr >> m_pos_type;
    dcdr >> m_curve_vehicle;
    dcdr >> m_curve_image;
    dcdr >> m_curve_abs;
    dcdr >> m_pts_vehicle;
    dcdr >> m_pts_image;
    dcdr >> m_pts_abs;
    dcdr >> m_image_end_point;
    dcdr >> m_pts_key;
    dcdr >> m_hd_lane_id;
    dcdr >> m_lane_id;
    dcdr >> m_confidence;
    dcdr >> m_lane_quality;
    dcdr >> m_fused_lane_type;
    dcdr >> m_use_type;
    dcdr >> m_create_time;
}

/*!
 * @brief This function sets a value in member lane_type
 * @param _lane_type New value for member lane_type
 */
void ros2_interface::msg::LaneLine::lane_type(
        int32_t _lane_type)
{
    m_lane_type = _lane_type;
}

/*!
 * @brief This function returns the value of member lane_type
 * @return Value of member lane_type
 */
int32_t ros2_interface::msg::LaneLine::lane_type() const
{
    return m_lane_type;
}

/*!
 * @brief This function returns a reference to member lane_type
 * @return Reference to member lane_type
 */
int32_t& ros2_interface::msg::LaneLine::lane_type()
{
    return m_lane_type;
}

/*!
 * @brief This function sets a value in member lane_color
 * @param _lane_color New value for member lane_color
 */
void ros2_interface::msg::LaneLine::lane_color(
        int32_t _lane_color)
{
    m_lane_color = _lane_color;
}

/*!
 * @brief This function returns the value of member lane_color
 * @return Value of member lane_color
 */
int32_t ros2_interface::msg::LaneLine::lane_color() const
{
    return m_lane_color;
}

/*!
 * @brief This function returns a reference to member lane_color
 * @return Reference to member lane_color
 */
int32_t& ros2_interface::msg::LaneLine::lane_color()
{
    return m_lane_color;
}

/*!
 * @brief This function sets a value in member pos_type
 * @param _pos_type New value for member pos_type
 */
void ros2_interface::msg::LaneLine::pos_type(
        int32_t _pos_type)
{
    m_pos_type = _pos_type;
}

/*!
 * @brief This function returns the value of member pos_type
 * @return Value of member pos_type
 */
int32_t ros2_interface::msg::LaneLine::pos_type() const
{
    return m_pos_type;
}

/*!
 * @brief This function returns a reference to member pos_type
 * @return Reference to member pos_type
 */
int32_t& ros2_interface::msg::LaneLine::pos_type()
{
    return m_pos_type;
}

/*!
 * @brief This function copies the value in member curve_vehicle
 * @param _curve_vehicle New value to be copied in member curve_vehicle
 */
void ros2_interface::msg::LaneLine::curve_vehicle(
        const ros2_interface::msg::LaneLineCubicCurve& _curve_vehicle)
{
    m_curve_vehicle = _curve_vehicle;
}

/*!
 * @brief This function moves the value in member curve_vehicle
 * @param _curve_vehicle New value to be moved in member curve_vehicle
 */
void ros2_interface::msg::LaneLine::curve_vehicle(
        ros2_interface::msg::LaneLineCubicCurve&& _curve_vehicle)
{
    m_curve_vehicle = std::move(_curve_vehicle);
}

/*!
 * @brief This function returns a constant reference to member curve_vehicle
 * @return Constant reference to member curve_vehicle
 */
const ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_vehicle() const
{
    return m_curve_vehicle;
}

/*!
 * @brief This function returns a reference to member curve_vehicle
 * @return Reference to member curve_vehicle
 */
ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_vehicle()
{
    return m_curve_vehicle;
}
/*!
 * @brief This function copies the value in member curve_image
 * @param _curve_image New value to be copied in member curve_image
 */
void ros2_interface::msg::LaneLine::curve_image(
        const ros2_interface::msg::LaneLineCubicCurve& _curve_image)
{
    m_curve_image = _curve_image;
}

/*!
 * @brief This function moves the value in member curve_image
 * @param _curve_image New value to be moved in member curve_image
 */
void ros2_interface::msg::LaneLine::curve_image(
        ros2_interface::msg::LaneLineCubicCurve&& _curve_image)
{
    m_curve_image = std::move(_curve_image);
}

/*!
 * @brief This function returns a constant reference to member curve_image
 * @return Constant reference to member curve_image
 */
const ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_image() const
{
    return m_curve_image;
}

/*!
 * @brief This function returns a reference to member curve_image
 * @return Reference to member curve_image
 */
ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_image()
{
    return m_curve_image;
}
/*!
 * @brief This function copies the value in member curve_abs
 * @param _curve_abs New value to be copied in member curve_abs
 */
void ros2_interface::msg::LaneLine::curve_abs(
        const ros2_interface::msg::LaneLineCubicCurve& _curve_abs)
{
    m_curve_abs = _curve_abs;
}

/*!
 * @brief This function moves the value in member curve_abs
 * @param _curve_abs New value to be moved in member curve_abs
 */
void ros2_interface::msg::LaneLine::curve_abs(
        ros2_interface::msg::LaneLineCubicCurve&& _curve_abs)
{
    m_curve_abs = std::move(_curve_abs);
}

/*!
 * @brief This function returns a constant reference to member curve_abs
 * @return Constant reference to member curve_abs
 */
const ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_abs() const
{
    return m_curve_abs;
}

/*!
 * @brief This function returns a reference to member curve_abs
 * @return Reference to member curve_abs
 */
ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLine::curve_abs()
{
    return m_curve_abs;
}
/*!
 * @brief This function copies the value in member pts_vehicle
 * @param _pts_vehicle New value to be copied in member pts_vehicle
 */
void ros2_interface::msg::LaneLine::pts_vehicle(
        const std::vector<ros2_interface::msg::Point3D>& _pts_vehicle)
{
    m_pts_vehicle = _pts_vehicle;
}

/*!
 * @brief This function moves the value in member pts_vehicle
 * @param _pts_vehicle New value to be moved in member pts_vehicle
 */
void ros2_interface::msg::LaneLine::pts_vehicle(
        std::vector<ros2_interface::msg::Point3D>&& _pts_vehicle)
{
    m_pts_vehicle = std::move(_pts_vehicle);
}

/*!
 * @brief This function returns a constant reference to member pts_vehicle
 * @return Constant reference to member pts_vehicle
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::LaneLine::pts_vehicle() const
{
    return m_pts_vehicle;
}

/*!
 * @brief This function returns a reference to member pts_vehicle
 * @return Reference to member pts_vehicle
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::LaneLine::pts_vehicle()
{
    return m_pts_vehicle;
}
/*!
 * @brief This function copies the value in member pts_image
 * @param _pts_image New value to be copied in member pts_image
 */
void ros2_interface::msg::LaneLine::pts_image(
        const std::vector<ros2_interface::msg::Point2D>& _pts_image)
{
    m_pts_image = _pts_image;
}

/*!
 * @brief This function moves the value in member pts_image
 * @param _pts_image New value to be moved in member pts_image
 */
void ros2_interface::msg::LaneLine::pts_image(
        std::vector<ros2_interface::msg::Point2D>&& _pts_image)
{
    m_pts_image = std::move(_pts_image);
}

/*!
 * @brief This function returns a constant reference to member pts_image
 * @return Constant reference to member pts_image
 */
const std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::LaneLine::pts_image() const
{
    return m_pts_image;
}

/*!
 * @brief This function returns a reference to member pts_image
 * @return Reference to member pts_image
 */
std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::LaneLine::pts_image()
{
    return m_pts_image;
}
/*!
 * @brief This function copies the value in member pts_abs
 * @param _pts_abs New value to be copied in member pts_abs
 */
void ros2_interface::msg::LaneLine::pts_abs(
        const std::vector<ros2_interface::msg::Point3D>& _pts_abs)
{
    m_pts_abs = _pts_abs;
}

/*!
 * @brief This function moves the value in member pts_abs
 * @param _pts_abs New value to be moved in member pts_abs
 */
void ros2_interface::msg::LaneLine::pts_abs(
        std::vector<ros2_interface::msg::Point3D>&& _pts_abs)
{
    m_pts_abs = std::move(_pts_abs);
}

/*!
 * @brief This function returns a constant reference to member pts_abs
 * @return Constant reference to member pts_abs
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::LaneLine::pts_abs() const
{
    return m_pts_abs;
}

/*!
 * @brief This function returns a reference to member pts_abs
 * @return Reference to member pts_abs
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::LaneLine::pts_abs()
{
    return m_pts_abs;
}
/*!
 * @brief This function copies the value in member image_end_point
 * @param _image_end_point New value to be copied in member image_end_point
 */
void ros2_interface::msg::LaneLine::image_end_point(
        const ros2_interface::msg::EndPoints& _image_end_point)
{
    m_image_end_point = _image_end_point;
}

/*!
 * @brief This function moves the value in member image_end_point
 * @param _image_end_point New value to be moved in member image_end_point
 */
void ros2_interface::msg::LaneLine::image_end_point(
        ros2_interface::msg::EndPoints&& _image_end_point)
{
    m_image_end_point = std::move(_image_end_point);
}

/*!
 * @brief This function returns a constant reference to member image_end_point
 * @return Constant reference to member image_end_point
 */
const ros2_interface::msg::EndPoints& ros2_interface::msg::LaneLine::image_end_point() const
{
    return m_image_end_point;
}

/*!
 * @brief This function returns a reference to member image_end_point
 * @return Reference to member image_end_point
 */
ros2_interface::msg::EndPoints& ros2_interface::msg::LaneLine::image_end_point()
{
    return m_image_end_point;
}
/*!
 * @brief This function copies the value in member pts_key
 * @param _pts_key New value to be copied in member pts_key
 */
void ros2_interface::msg::LaneLine::pts_key(
        const std::vector<ros2_interface::msg::Point2D>& _pts_key)
{
    m_pts_key = _pts_key;
}

/*!
 * @brief This function moves the value in member pts_key
 * @param _pts_key New value to be moved in member pts_key
 */
void ros2_interface::msg::LaneLine::pts_key(
        std::vector<ros2_interface::msg::Point2D>&& _pts_key)
{
    m_pts_key = std::move(_pts_key);
}

/*!
 * @brief This function returns a constant reference to member pts_key
 * @return Constant reference to member pts_key
 */
const std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::LaneLine::pts_key() const
{
    return m_pts_key;
}

/*!
 * @brief This function returns a reference to member pts_key
 * @return Reference to member pts_key
 */
std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::LaneLine::pts_key()
{
    return m_pts_key;
}
/*!
 * @brief This function sets a value in member hd_lane_id
 * @param _hd_lane_id New value for member hd_lane_id
 */
void ros2_interface::msg::LaneLine::hd_lane_id(
        uint8_t _hd_lane_id)
{
    m_hd_lane_id = _hd_lane_id;
}

/*!
 * @brief This function returns the value of member hd_lane_id
 * @return Value of member hd_lane_id
 */
uint8_t ros2_interface::msg::LaneLine::hd_lane_id() const
{
    return m_hd_lane_id;
}

/*!
 * @brief This function returns a reference to member hd_lane_id
 * @return Reference to member hd_lane_id
 */
uint8_t& ros2_interface::msg::LaneLine::hd_lane_id()
{
    return m_hd_lane_id;
}

/*!
 * @brief This function sets a value in member lane_id
 * @param _lane_id New value for member lane_id
 */
void ros2_interface::msg::LaneLine::lane_id(
        uint8_t _lane_id)
{
    m_lane_id = _lane_id;
}

/*!
 * @brief This function returns the value of member lane_id
 * @return Value of member lane_id
 */
uint8_t ros2_interface::msg::LaneLine::lane_id() const
{
    return m_lane_id;
}

/*!
 * @brief This function returns a reference to member lane_id
 * @return Reference to member lane_id
 */
uint8_t& ros2_interface::msg::LaneLine::lane_id()
{
    return m_lane_id;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::LaneLine::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::LaneLine::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::LaneLine::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function sets a value in member lane_quality
 * @param _lane_quality New value for member lane_quality
 */
void ros2_interface::msg::LaneLine::lane_quality(
        int32_t _lane_quality)
{
    m_lane_quality = _lane_quality;
}

/*!
 * @brief This function returns the value of member lane_quality
 * @return Value of member lane_quality
 */
int32_t ros2_interface::msg::LaneLine::lane_quality() const
{
    return m_lane_quality;
}

/*!
 * @brief This function returns a reference to member lane_quality
 * @return Reference to member lane_quality
 */
int32_t& ros2_interface::msg::LaneLine::lane_quality()
{
    return m_lane_quality;
}

/*!
 * @brief This function sets a value in member fused_lane_type
 * @param _fused_lane_type New value for member fused_lane_type
 */
void ros2_interface::msg::LaneLine::fused_lane_type(
        int32_t _fused_lane_type)
{
    m_fused_lane_type = _fused_lane_type;
}

/*!
 * @brief This function returns the value of member fused_lane_type
 * @return Value of member fused_lane_type
 */
int32_t ros2_interface::msg::LaneLine::fused_lane_type() const
{
    return m_fused_lane_type;
}

/*!
 * @brief This function returns a reference to member fused_lane_type
 * @return Reference to member fused_lane_type
 */
int32_t& ros2_interface::msg::LaneLine::fused_lane_type()
{
    return m_fused_lane_type;
}

/*!
 * @brief This function sets a value in member use_type
 * @param _use_type New value for member use_type
 */
void ros2_interface::msg::LaneLine::use_type(
        int32_t _use_type)
{
    m_use_type = _use_type;
}

/*!
 * @brief This function returns the value of member use_type
 * @return Value of member use_type
 */
int32_t ros2_interface::msg::LaneLine::use_type() const
{
    return m_use_type;
}

/*!
 * @brief This function returns a reference to member use_type
 * @return Reference to member use_type
 */
int32_t& ros2_interface::msg::LaneLine::use_type()
{
    return m_use_type;
}

/*!
 * @brief This function copies the value in member create_time
 * @param _create_time New value to be copied in member create_time
 */
void ros2_interface::msg::LaneLine::create_time(
        const ros2_interface::msg::Time& _create_time)
{
    m_create_time = _create_time;
}

/*!
 * @brief This function moves the value in member create_time
 * @param _create_time New value to be moved in member create_time
 */
void ros2_interface::msg::LaneLine::create_time(
        ros2_interface::msg::Time&& _create_time)
{
    m_create_time = std::move(_create_time);
}

/*!
 * @brief This function returns a constant reference to member create_time
 * @return Constant reference to member create_time
 */
const ros2_interface::msg::Time& ros2_interface::msg::LaneLine::create_time() const
{
    return m_create_time;
}

/*!
 * @brief This function returns a reference to member create_time
 * @return Reference to member create_time
 */
ros2_interface::msg::Time& ros2_interface::msg::LaneLine::create_time()
{
    return m_create_time;
}


size_t ros2_interface::msg::LaneLine::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneLine_max_key_cdr_typesize;
}

bool ros2_interface::msg::LaneLine::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LaneLine::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



