// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneLine.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANELINE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANELINE_H_

#include "LaneLineCubicCurve.h"
#include "Point3D.h"
#include "Time.h"
#include "EndPoints.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(LANELINE_SOURCE)
#define LANELINE_DllAPI __declspec( dllexport )
#else
#define LANELINE_DllAPI __declspec( dllimport )
#endif // LANELINE_SOURCE
#else
#define LANELINE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define LANELINE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure LaneLine defined by the user in the IDL file.
         * @ingroup LaneLine
         */
        class LaneLine
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport LaneLine();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~LaneLine();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::LaneLine that will be copied.
             */
            eProsima_user_DllExport LaneLine(
                    const LaneLine& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::LaneLine that will be copied.
             */
            eProsima_user_DllExport LaneLine(
                    LaneLine&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::LaneLine that will be copied.
             */
            eProsima_user_DllExport LaneLine& operator =(
                    const LaneLine& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::LaneLine that will be copied.
             */
            eProsima_user_DllExport LaneLine& operator =(
                    LaneLine&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LaneLine object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const LaneLine& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LaneLine object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const LaneLine& x) const;

            /*!
             * @brief This function sets a value in member lane_type
             * @param _lane_type New value for member lane_type
             */
            eProsima_user_DllExport void lane_type(
                    int32_t _lane_type);

            /*!
             * @brief This function returns the value of member lane_type
             * @return Value of member lane_type
             */
            eProsima_user_DllExport int32_t lane_type() const;

            /*!
             * @brief This function returns a reference to member lane_type
             * @return Reference to member lane_type
             */
            eProsima_user_DllExport int32_t& lane_type();

            /*!
             * @brief This function sets a value in member lane_color
             * @param _lane_color New value for member lane_color
             */
            eProsima_user_DllExport void lane_color(
                    int32_t _lane_color);

            /*!
             * @brief This function returns the value of member lane_color
             * @return Value of member lane_color
             */
            eProsima_user_DllExport int32_t lane_color() const;

            /*!
             * @brief This function returns a reference to member lane_color
             * @return Reference to member lane_color
             */
            eProsima_user_DllExport int32_t& lane_color();

            /*!
             * @brief This function sets a value in member pos_type
             * @param _pos_type New value for member pos_type
             */
            eProsima_user_DllExport void pos_type(
                    int32_t _pos_type);

            /*!
             * @brief This function returns the value of member pos_type
             * @return Value of member pos_type
             */
            eProsima_user_DllExport int32_t pos_type() const;

            /*!
             * @brief This function returns a reference to member pos_type
             * @return Reference to member pos_type
             */
            eProsima_user_DllExport int32_t& pos_type();

            /*!
             * @brief This function copies the value in member curve_vehicle
             * @param _curve_vehicle New value to be copied in member curve_vehicle
             */
            eProsima_user_DllExport void curve_vehicle(
                    const ros2_interface::msg::LaneLineCubicCurve& _curve_vehicle);

            /*!
             * @brief This function moves the value in member curve_vehicle
             * @param _curve_vehicle New value to be moved in member curve_vehicle
             */
            eProsima_user_DllExport void curve_vehicle(
                    ros2_interface::msg::LaneLineCubicCurve&& _curve_vehicle);

            /*!
             * @brief This function returns a constant reference to member curve_vehicle
             * @return Constant reference to member curve_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::LaneLineCubicCurve& curve_vehicle() const;

            /*!
             * @brief This function returns a reference to member curve_vehicle
             * @return Reference to member curve_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::LaneLineCubicCurve& curve_vehicle();
            /*!
             * @brief This function copies the value in member curve_image
             * @param _curve_image New value to be copied in member curve_image
             */
            eProsima_user_DllExport void curve_image(
                    const ros2_interface::msg::LaneLineCubicCurve& _curve_image);

            /*!
             * @brief This function moves the value in member curve_image
             * @param _curve_image New value to be moved in member curve_image
             */
            eProsima_user_DllExport void curve_image(
                    ros2_interface::msg::LaneLineCubicCurve&& _curve_image);

            /*!
             * @brief This function returns a constant reference to member curve_image
             * @return Constant reference to member curve_image
             */
            eProsima_user_DllExport const ros2_interface::msg::LaneLineCubicCurve& curve_image() const;

            /*!
             * @brief This function returns a reference to member curve_image
             * @return Reference to member curve_image
             */
            eProsima_user_DllExport ros2_interface::msg::LaneLineCubicCurve& curve_image();
            /*!
             * @brief This function copies the value in member curve_abs
             * @param _curve_abs New value to be copied in member curve_abs
             */
            eProsima_user_DllExport void curve_abs(
                    const ros2_interface::msg::LaneLineCubicCurve& _curve_abs);

            /*!
             * @brief This function moves the value in member curve_abs
             * @param _curve_abs New value to be moved in member curve_abs
             */
            eProsima_user_DllExport void curve_abs(
                    ros2_interface::msg::LaneLineCubicCurve&& _curve_abs);

            /*!
             * @brief This function returns a constant reference to member curve_abs
             * @return Constant reference to member curve_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::LaneLineCubicCurve& curve_abs() const;

            /*!
             * @brief This function returns a reference to member curve_abs
             * @return Reference to member curve_abs
             */
            eProsima_user_DllExport ros2_interface::msg::LaneLineCubicCurve& curve_abs();
            /*!
             * @brief This function copies the value in member pts_vehicle
             * @param _pts_vehicle New value to be copied in member pts_vehicle
             */
            eProsima_user_DllExport void pts_vehicle(
                    const std::vector<ros2_interface::msg::Point3D>& _pts_vehicle);

            /*!
             * @brief This function moves the value in member pts_vehicle
             * @param _pts_vehicle New value to be moved in member pts_vehicle
             */
            eProsima_user_DllExport void pts_vehicle(
                    std::vector<ros2_interface::msg::Point3D>&& _pts_vehicle);

            /*!
             * @brief This function returns a constant reference to member pts_vehicle
             * @return Constant reference to member pts_vehicle
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& pts_vehicle() const;

            /*!
             * @brief This function returns a reference to member pts_vehicle
             * @return Reference to member pts_vehicle
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& pts_vehicle();
            /*!
             * @brief This function copies the value in member pts_image
             * @param _pts_image New value to be copied in member pts_image
             */
            eProsima_user_DllExport void pts_image(
                    const std::vector<ros2_interface::msg::Point2D>& _pts_image);

            /*!
             * @brief This function moves the value in member pts_image
             * @param _pts_image New value to be moved in member pts_image
             */
            eProsima_user_DllExport void pts_image(
                    std::vector<ros2_interface::msg::Point2D>&& _pts_image);

            /*!
             * @brief This function returns a constant reference to member pts_image
             * @return Constant reference to member pts_image
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point2D>& pts_image() const;

            /*!
             * @brief This function returns a reference to member pts_image
             * @return Reference to member pts_image
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point2D>& pts_image();
            /*!
             * @brief This function copies the value in member pts_abs
             * @param _pts_abs New value to be copied in member pts_abs
             */
            eProsima_user_DllExport void pts_abs(
                    const std::vector<ros2_interface::msg::Point3D>& _pts_abs);

            /*!
             * @brief This function moves the value in member pts_abs
             * @param _pts_abs New value to be moved in member pts_abs
             */
            eProsima_user_DllExport void pts_abs(
                    std::vector<ros2_interface::msg::Point3D>&& _pts_abs);

            /*!
             * @brief This function returns a constant reference to member pts_abs
             * @return Constant reference to member pts_abs
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& pts_abs() const;

            /*!
             * @brief This function returns a reference to member pts_abs
             * @return Reference to member pts_abs
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& pts_abs();
            /*!
             * @brief This function copies the value in member image_end_point
             * @param _image_end_point New value to be copied in member image_end_point
             */
            eProsima_user_DllExport void image_end_point(
                    const ros2_interface::msg::EndPoints& _image_end_point);

            /*!
             * @brief This function moves the value in member image_end_point
             * @param _image_end_point New value to be moved in member image_end_point
             */
            eProsima_user_DllExport void image_end_point(
                    ros2_interface::msg::EndPoints&& _image_end_point);

            /*!
             * @brief This function returns a constant reference to member image_end_point
             * @return Constant reference to member image_end_point
             */
            eProsima_user_DllExport const ros2_interface::msg::EndPoints& image_end_point() const;

            /*!
             * @brief This function returns a reference to member image_end_point
             * @return Reference to member image_end_point
             */
            eProsima_user_DllExport ros2_interface::msg::EndPoints& image_end_point();
            /*!
             * @brief This function copies the value in member pts_key
             * @param _pts_key New value to be copied in member pts_key
             */
            eProsima_user_DllExport void pts_key(
                    const std::vector<ros2_interface::msg::Point2D>& _pts_key);

            /*!
             * @brief This function moves the value in member pts_key
             * @param _pts_key New value to be moved in member pts_key
             */
            eProsima_user_DllExport void pts_key(
                    std::vector<ros2_interface::msg::Point2D>&& _pts_key);

            /*!
             * @brief This function returns a constant reference to member pts_key
             * @return Constant reference to member pts_key
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point2D>& pts_key() const;

            /*!
             * @brief This function returns a reference to member pts_key
             * @return Reference to member pts_key
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point2D>& pts_key();
            /*!
             * @brief This function sets a value in member hd_lane_id
             * @param _hd_lane_id New value for member hd_lane_id
             */
            eProsima_user_DllExport void hd_lane_id(
                    uint8_t _hd_lane_id);

            /*!
             * @brief This function returns the value of member hd_lane_id
             * @return Value of member hd_lane_id
             */
            eProsima_user_DllExport uint8_t hd_lane_id() const;

            /*!
             * @brief This function returns a reference to member hd_lane_id
             * @return Reference to member hd_lane_id
             */
            eProsima_user_DllExport uint8_t& hd_lane_id();

            /*!
             * @brief This function sets a value in member lane_id
             * @param _lane_id New value for member lane_id
             */
            eProsima_user_DllExport void lane_id(
                    uint8_t _lane_id);

            /*!
             * @brief This function returns the value of member lane_id
             * @return Value of member lane_id
             */
            eProsima_user_DllExport uint8_t lane_id() const;

            /*!
             * @brief This function returns a reference to member lane_id
             * @return Reference to member lane_id
             */
            eProsima_user_DllExport uint8_t& lane_id();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function sets a value in member lane_quality
             * @param _lane_quality New value for member lane_quality
             */
            eProsima_user_DllExport void lane_quality(
                    int32_t _lane_quality);

            /*!
             * @brief This function returns the value of member lane_quality
             * @return Value of member lane_quality
             */
            eProsima_user_DllExport int32_t lane_quality() const;

            /*!
             * @brief This function returns a reference to member lane_quality
             * @return Reference to member lane_quality
             */
            eProsima_user_DllExport int32_t& lane_quality();

            /*!
             * @brief This function sets a value in member fused_lane_type
             * @param _fused_lane_type New value for member fused_lane_type
             */
            eProsima_user_DllExport void fused_lane_type(
                    int32_t _fused_lane_type);

            /*!
             * @brief This function returns the value of member fused_lane_type
             * @return Value of member fused_lane_type
             */
            eProsima_user_DllExport int32_t fused_lane_type() const;

            /*!
             * @brief This function returns a reference to member fused_lane_type
             * @return Reference to member fused_lane_type
             */
            eProsima_user_DllExport int32_t& fused_lane_type();

            /*!
             * @brief This function sets a value in member use_type
             * @param _use_type New value for member use_type
             */
            eProsima_user_DllExport void use_type(
                    int32_t _use_type);

            /*!
             * @brief This function returns the value of member use_type
             * @return Value of member use_type
             */
            eProsima_user_DllExport int32_t use_type() const;

            /*!
             * @brief This function returns a reference to member use_type
             * @return Reference to member use_type
             */
            eProsima_user_DllExport int32_t& use_type();

            /*!
             * @brief This function copies the value in member create_time
             * @param _create_time New value to be copied in member create_time
             */
            eProsima_user_DllExport void create_time(
                    const ros2_interface::msg::Time& _create_time);

            /*!
             * @brief This function moves the value in member create_time
             * @param _create_time New value to be moved in member create_time
             */
            eProsima_user_DllExport void create_time(
                    ros2_interface::msg::Time&& _create_time);

            /*!
             * @brief This function returns a constant reference to member create_time
             * @return Constant reference to member create_time
             */
            eProsima_user_DllExport const ros2_interface::msg::Time& create_time() const;

            /*!
             * @brief This function returns a reference to member create_time
             * @return Reference to member create_time
             */
            eProsima_user_DllExport ros2_interface::msg::Time& create_time();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::LaneLine& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_lane_type;
            int32_t m_lane_color;
            int32_t m_pos_type;
            ros2_interface::msg::LaneLineCubicCurve m_curve_vehicle;
            ros2_interface::msg::LaneLineCubicCurve m_curve_image;
            ros2_interface::msg::LaneLineCubicCurve m_curve_abs;
            std::vector<ros2_interface::msg::Point3D> m_pts_vehicle;
            std::vector<ros2_interface::msg::Point2D> m_pts_image;
            std::vector<ros2_interface::msg::Point3D> m_pts_abs;
            ros2_interface::msg::EndPoints m_image_end_point;
            std::vector<ros2_interface::msg::Point2D> m_pts_key;
            uint8_t m_hd_lane_id;
            uint8_t m_lane_id;
            double m_confidence;
            int32_t m_lane_quality;
            int32_t m_fused_lane_type;
            int32_t m_use_type;
            ros2_interface::msg::Time m_create_time;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANELINE_H_

