// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneLineCubicCurve.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LaneLineCubicCurve.h"
#include "LaneLineCubicCurveTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_LaneLineCubicCurve_max_cdr_typesize 48ULL;
#define ros2_interface_msg_LaneLineCubicCurve_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LaneLineCubicCurve::LaneLineCubicCurve()
{
    // double m_start_x
    m_start_x = 0.0;
    // double m_end_x
    m_end_x = 0.0;
    // double m_a
    m_a = 0.0;
    // double m_b
    m_b = 0.0;
    // double m_c
    m_c = 0.0;
    // double m_d
    m_d = 0.0;

    // Just to register all known types
    registerLaneLineCubicCurveTypes();
}

ros2_interface::msg::LaneLineCubicCurve::~LaneLineCubicCurve()
{






}

ros2_interface::msg::LaneLineCubicCurve::LaneLineCubicCurve(
        const LaneLineCubicCurve& x)
{
    m_start_x = x.m_start_x;
    m_end_x = x.m_end_x;
    m_a = x.m_a;
    m_b = x.m_b;
    m_c = x.m_c;
    m_d = x.m_d;
}

ros2_interface::msg::LaneLineCubicCurve::LaneLineCubicCurve(
        LaneLineCubicCurve&& x) noexcept 
{
    m_start_x = x.m_start_x;
    m_end_x = x.m_end_x;
    m_a = x.m_a;
    m_b = x.m_b;
    m_c = x.m_c;
    m_d = x.m_d;
}

ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLineCubicCurve::operator =(
        const LaneLineCubicCurve& x)
{

    m_start_x = x.m_start_x;
    m_end_x = x.m_end_x;
    m_a = x.m_a;
    m_b = x.m_b;
    m_c = x.m_c;
    m_d = x.m_d;

    return *this;
}

ros2_interface::msg::LaneLineCubicCurve& ros2_interface::msg::LaneLineCubicCurve::operator =(
        LaneLineCubicCurve&& x) noexcept
{

    m_start_x = x.m_start_x;
    m_end_x = x.m_end_x;
    m_a = x.m_a;
    m_b = x.m_b;
    m_c = x.m_c;
    m_d = x.m_d;

    return *this;
}

bool ros2_interface::msg::LaneLineCubicCurve::operator ==(
        const LaneLineCubicCurve& x) const
{

    return (m_start_x == x.m_start_x && m_end_x == x.m_end_x && m_a == x.m_a && m_b == x.m_b && m_c == x.m_c && m_d == x.m_d);
}

bool ros2_interface::msg::LaneLineCubicCurve::operator !=(
        const LaneLineCubicCurve& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LaneLineCubicCurve::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneLineCubicCurve_max_cdr_typesize;
}

size_t ros2_interface::msg::LaneLineCubicCurve::getCdrSerializedSize(
        const ros2_interface::msg::LaneLineCubicCurve& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LaneLineCubicCurve::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_start_x;
    scdr << m_end_x;
    scdr << m_a;
    scdr << m_b;
    scdr << m_c;
    scdr << m_d;

}

void ros2_interface::msg::LaneLineCubicCurve::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_start_x;
    dcdr >> m_end_x;
    dcdr >> m_a;
    dcdr >> m_b;
    dcdr >> m_c;
    dcdr >> m_d;
}

/*!
 * @brief This function sets a value in member start_x
 * @param _start_x New value for member start_x
 */
void ros2_interface::msg::LaneLineCubicCurve::start_x(
        double _start_x)
{
    m_start_x = _start_x;
}

/*!
 * @brief This function returns the value of member start_x
 * @return Value of member start_x
 */
double ros2_interface::msg::LaneLineCubicCurve::start_x() const
{
    return m_start_x;
}

/*!
 * @brief This function returns a reference to member start_x
 * @return Reference to member start_x
 */
double& ros2_interface::msg::LaneLineCubicCurve::start_x()
{
    return m_start_x;
}

/*!
 * @brief This function sets a value in member end_x
 * @param _end_x New value for member end_x
 */
void ros2_interface::msg::LaneLineCubicCurve::end_x(
        double _end_x)
{
    m_end_x = _end_x;
}

/*!
 * @brief This function returns the value of member end_x
 * @return Value of member end_x
 */
double ros2_interface::msg::LaneLineCubicCurve::end_x() const
{
    return m_end_x;
}

/*!
 * @brief This function returns a reference to member end_x
 * @return Reference to member end_x
 */
double& ros2_interface::msg::LaneLineCubicCurve::end_x()
{
    return m_end_x;
}

/*!
 * @brief This function sets a value in member a
 * @param _a New value for member a
 */
void ros2_interface::msg::LaneLineCubicCurve::a(
        double _a)
{
    m_a = _a;
}

/*!
 * @brief This function returns the value of member a
 * @return Value of member a
 */
double ros2_interface::msg::LaneLineCubicCurve::a() const
{
    return m_a;
}

/*!
 * @brief This function returns a reference to member a
 * @return Reference to member a
 */
double& ros2_interface::msg::LaneLineCubicCurve::a()
{
    return m_a;
}

/*!
 * @brief This function sets a value in member b
 * @param _b New value for member b
 */
void ros2_interface::msg::LaneLineCubicCurve::b(
        double _b)
{
    m_b = _b;
}

/*!
 * @brief This function returns the value of member b
 * @return Value of member b
 */
double ros2_interface::msg::LaneLineCubicCurve::b() const
{
    return m_b;
}

/*!
 * @brief This function returns a reference to member b
 * @return Reference to member b
 */
double& ros2_interface::msg::LaneLineCubicCurve::b()
{
    return m_b;
}

/*!
 * @brief This function sets a value in member c
 * @param _c New value for member c
 */
void ros2_interface::msg::LaneLineCubicCurve::c(
        double _c)
{
    m_c = _c;
}

/*!
 * @brief This function returns the value of member c
 * @return Value of member c
 */
double ros2_interface::msg::LaneLineCubicCurve::c() const
{
    return m_c;
}

/*!
 * @brief This function returns a reference to member c
 * @return Reference to member c
 */
double& ros2_interface::msg::LaneLineCubicCurve::c()
{
    return m_c;
}

/*!
 * @brief This function sets a value in member d
 * @param _d New value for member d
 */
void ros2_interface::msg::LaneLineCubicCurve::d(
        double _d)
{
    m_d = _d;
}

/*!
 * @brief This function returns the value of member d
 * @return Value of member d
 */
double ros2_interface::msg::LaneLineCubicCurve::d() const
{
    return m_d;
}

/*!
 * @brief This function returns a reference to member d
 * @return Reference to member d
 */
double& ros2_interface::msg::LaneLineCubicCurve::d()
{
    return m_d;
}



size_t ros2_interface::msg::LaneLineCubicCurve::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneLineCubicCurve_max_key_cdr_typesize;
}

bool ros2_interface::msg::LaneLineCubicCurve::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LaneLineCubicCurve::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



