// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneLineCubicCurveTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "LaneLineCubicCurve.h"
#include "LaneLineCubicCurveTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLaneLineCubicCurveTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(true));
                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLaneLineCubicCurveIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("LaneLineCubicCurve", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLaneLineCubicCurveObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("LaneLineCubicCurve", complete);
        }

        const TypeObject* GetLaneLineCubicCurveObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLineCubicCurve", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLaneLineCubicCurveObject();
            }
            //else
            return GetMinimalLaneLineCubicCurveObject();
        }

        const TypeObject* GetMinimalLaneLineCubicCurveObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLineCubicCurve", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_start_x;
            mst_start_x.common().member_id(memberId++);
            mst_start_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_start_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_start_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_start_x.common().member_flags().IS_OPTIONAL(false);
            mst_start_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_start_x.common().member_flags().IS_KEY(false);
            mst_start_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_start_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 start_x_hash("start_x");
            for(int i = 0; i < 4; ++i)
            {
                mst_start_x.detail().name_hash()[i] = start_x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_start_x);

            MinimalStructMember mst_end_x;
            mst_end_x.common().member_id(memberId++);
            mst_end_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_end_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_end_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_end_x.common().member_flags().IS_OPTIONAL(false);
            mst_end_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_end_x.common().member_flags().IS_KEY(false);
            mst_end_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_end_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 end_x_hash("end_x");
            for(int i = 0; i < 4; ++i)
            {
                mst_end_x.detail().name_hash()[i] = end_x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_end_x);

            MinimalStructMember mst_a;
            mst_a.common().member_id(memberId++);
            mst_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a.common().member_flags().IS_OPTIONAL(false);
            mst_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a.common().member_flags().IS_KEY(false);
            mst_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a_hash("a");
            for(int i = 0; i < 4; ++i)
            {
                mst_a.detail().name_hash()[i] = a_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a);

            MinimalStructMember mst_b;
            mst_b.common().member_id(memberId++);
            mst_b.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_b.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_b.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_b.common().member_flags().IS_OPTIONAL(false);
            mst_b.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_b.common().member_flags().IS_KEY(false);
            mst_b.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_b.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 b_hash("b");
            for(int i = 0; i < 4; ++i)
            {
                mst_b.detail().name_hash()[i] = b_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_b);

            MinimalStructMember mst_c;
            mst_c.common().member_id(memberId++);
            mst_c.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_c.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_c.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_c.common().member_flags().IS_OPTIONAL(false);
            mst_c.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_c.common().member_flags().IS_KEY(false);
            mst_c.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_c.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 c_hash("c");
            for(int i = 0; i < 4; ++i)
            {
                mst_c.detail().name_hash()[i] = c_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_c);

            MinimalStructMember mst_d;
            mst_d.common().member_id(memberId++);
            mst_d.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_d.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_d.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_d.common().member_flags().IS_OPTIONAL(false);
            mst_d.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_d.common().member_flags().IS_KEY(false);
            mst_d.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_d.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 d_hash("d");
            for(int i = 0; i < 4; ++i)
            {
                mst_d.detail().name_hash()[i] = d_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_d);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneLineCubicCurve", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneLineCubicCurve", false);
        }

        const TypeObject* GetCompleteLaneLineCubicCurveObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLineCubicCurve", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_start_x;
            cst_start_x.common().member_id(memberId++);
            cst_start_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_start_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_start_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_start_x.common().member_flags().IS_OPTIONAL(false);
            cst_start_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_start_x.common().member_flags().IS_KEY(false);
            cst_start_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_start_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_start_x.detail().name("start_x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_start_x);

            CompleteStructMember cst_end_x;
            cst_end_x.common().member_id(memberId++);
            cst_end_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_end_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_end_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_end_x.common().member_flags().IS_OPTIONAL(false);
            cst_end_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_end_x.common().member_flags().IS_KEY(false);
            cst_end_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_end_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_end_x.detail().name("end_x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_end_x);

            CompleteStructMember cst_a;
            cst_a.common().member_id(memberId++);
            cst_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a.common().member_flags().IS_OPTIONAL(false);
            cst_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a.common().member_flags().IS_KEY(false);
            cst_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a.detail().name("a");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a);

            CompleteStructMember cst_b;
            cst_b.common().member_id(memberId++);
            cst_b.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_b.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_b.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_b.common().member_flags().IS_OPTIONAL(false);
            cst_b.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_b.common().member_flags().IS_KEY(false);
            cst_b.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_b.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_b.detail().name("b");

            type_object->complete().struct_type().member_seq().emplace_back(cst_b);

            CompleteStructMember cst_c;
            cst_c.common().member_id(memberId++);
            cst_c.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_c.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_c.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_c.common().member_flags().IS_OPTIONAL(false);
            cst_c.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_c.common().member_flags().IS_KEY(false);
            cst_c.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_c.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_c.detail().name("c");

            type_object->complete().struct_type().member_seq().emplace_back(cst_c);

            CompleteStructMember cst_d;
            cst_d.common().member_id(memberId++);
            cst_d.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_d.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_d.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_d.common().member_flags().IS_OPTIONAL(false);
            cst_d.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_d.common().member_flags().IS_KEY(false);
            cst_d.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_d.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_d.detail().name("d");

            type_object->complete().struct_type().member_seq().emplace_back(cst_d);


            // Header
            type_object->complete().struct_type().header().detail().type_name("LaneLineCubicCurve");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneLineCubicCurve", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneLineCubicCurve", true);
        }

    } // namespace msg
} // namespace ros2_interface