// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneLineTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "LaneLine.h"
#include "LaneLineTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLaneLineTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::EndPoints", ros2_interface::msg::GetEndPointsIdentifier(true),
                        ros2_interface::msg::GetEndPointsObject(true));
                factory->add_type_object("ros2_interface::msg::EndPoints", ros2_interface::msg::GetEndPointsIdentifier(false),
                        ros2_interface::msg::GetEndPointsObject(false));



                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(true));
                factory->add_type_object("ros2_interface::msg::LaneLineCubicCurve", ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false),
                        ros2_interface::msg::GetLaneLineCubicCurveObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::LaneLine", ros2_interface::msg::GetLaneLineIdentifier(true),
                        ros2_interface::msg::GetLaneLineObject(true));
                factory->add_type_object("ros2_interface::msg::LaneLine", ros2_interface::msg::GetLaneLineIdentifier(false),
                        ros2_interface::msg::GetLaneLineObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLaneLineIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("LaneLine", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLaneLineObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("LaneLine", complete);
        }

        const TypeObject* GetLaneLineObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLine", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLaneLineObject();
            }
            //else
            return GetMinimalLaneLineObject();
        }

        const TypeObject* GetMinimalLaneLineObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLine", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_lane_type;
            mst_lane_type.common().member_id(memberId++);
            mst_lane_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_type.common().member_flags().IS_OPTIONAL(false);
            mst_lane_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_type.common().member_flags().IS_KEY(false);
            mst_lane_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lane_type_hash("lane_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_type.detail().name_hash()[i] = lane_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_type);

            MinimalStructMember mst_lane_color;
            mst_lane_color.common().member_id(memberId++);
            mst_lane_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_color.common().member_flags().IS_OPTIONAL(false);
            mst_lane_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_color.common().member_flags().IS_KEY(false);
            mst_lane_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lane_color_hash("lane_color");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_color.detail().name_hash()[i] = lane_color_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_color);

            MinimalStructMember mst_pos_type;
            mst_pos_type.common().member_id(memberId++);
            mst_pos_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pos_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pos_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pos_type.common().member_flags().IS_OPTIONAL(false);
            mst_pos_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pos_type.common().member_flags().IS_KEY(false);
            mst_pos_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pos_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 pos_type_hash("pos_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_pos_type.detail().name_hash()[i] = pos_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pos_type);

            MinimalStructMember mst_curve_vehicle;
            mst_curve_vehicle.common().member_id(memberId++);
            mst_curve_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_curve_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_curve_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_curve_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_curve_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_curve_vehicle.common().member_flags().IS_KEY(false);
            mst_curve_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_curve_vehicle.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false));
            MD5 curve_vehicle_hash("curve_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_curve_vehicle.detail().name_hash()[i] = curve_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_curve_vehicle);

            MinimalStructMember mst_curve_image;
            mst_curve_image.common().member_id(memberId++);
            mst_curve_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_curve_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_curve_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_curve_image.common().member_flags().IS_OPTIONAL(false);
            mst_curve_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_curve_image.common().member_flags().IS_KEY(false);
            mst_curve_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_curve_image.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false));
            MD5 curve_image_hash("curve_image");
            for(int i = 0; i < 4; ++i)
            {
                mst_curve_image.detail().name_hash()[i] = curve_image_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_curve_image);

            MinimalStructMember mst_curve_abs;
            mst_curve_abs.common().member_id(memberId++);
            mst_curve_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_curve_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_curve_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_curve_abs.common().member_flags().IS_OPTIONAL(false);
            mst_curve_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_curve_abs.common().member_flags().IS_KEY(false);
            mst_curve_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_curve_abs.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(false));
            MD5 curve_abs_hash("curve_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_curve_abs.detail().name_hash()[i] = curve_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_curve_abs);

            MinimalStructMember mst_pts_vehicle;
            mst_pts_vehicle.common().member_id(memberId++);
            mst_pts_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pts_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pts_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pts_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_pts_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pts_vehicle.common().member_flags().IS_KEY(false);
            mst_pts_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pts_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 pts_vehicle_hash("pts_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_pts_vehicle.detail().name_hash()[i] = pts_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pts_vehicle);

            MinimalStructMember mst_pts_image;
            mst_pts_image.common().member_id(memberId++);
            mst_pts_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pts_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pts_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pts_image.common().member_flags().IS_OPTIONAL(false);
            mst_pts_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pts_image.common().member_flags().IS_KEY(false);
            mst_pts_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pts_image.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2D", 100, false));


            MD5 pts_image_hash("pts_image");
            for(int i = 0; i < 4; ++i)
            {
                mst_pts_image.detail().name_hash()[i] = pts_image_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pts_image);

            MinimalStructMember mst_pts_abs;
            mst_pts_abs.common().member_id(memberId++);
            mst_pts_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pts_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pts_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pts_abs.common().member_flags().IS_OPTIONAL(false);
            mst_pts_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pts_abs.common().member_flags().IS_KEY(false);
            mst_pts_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pts_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 pts_abs_hash("pts_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_pts_abs.detail().name_hash()[i] = pts_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pts_abs);

            MinimalStructMember mst_image_end_point;
            mst_image_end_point.common().member_id(memberId++);
            mst_image_end_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_image_end_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_image_end_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_image_end_point.common().member_flags().IS_OPTIONAL(false);
            mst_image_end_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_image_end_point.common().member_flags().IS_KEY(false);
            mst_image_end_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_image_end_point.common().member_type_id(*ros2_interface::msg::GetEndPointsIdentifier(false));
            MD5 image_end_point_hash("image_end_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_image_end_point.detail().name_hash()[i] = image_end_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_image_end_point);

            MinimalStructMember mst_pts_key;
            mst_pts_key.common().member_id(memberId++);
            mst_pts_key.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pts_key.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pts_key.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pts_key.common().member_flags().IS_OPTIONAL(false);
            mst_pts_key.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pts_key.common().member_flags().IS_KEY(false);
            mst_pts_key.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pts_key.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2D", 100, false));


            MD5 pts_key_hash("pts_key");
            for(int i = 0; i < 4; ++i)
            {
                mst_pts_key.detail().name_hash()[i] = pts_key_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pts_key);

            MinimalStructMember mst_hd_lane_id;
            mst_hd_lane_id.common().member_id(memberId++);
            mst_hd_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hd_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hd_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hd_lane_id.common().member_flags().IS_OPTIONAL(false);
            mst_hd_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hd_lane_id.common().member_flags().IS_KEY(false);
            mst_hd_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hd_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 hd_lane_id_hash("hd_lane_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_hd_lane_id.detail().name_hash()[i] = hd_lane_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hd_lane_id);

            MinimalStructMember mst_lane_id;
            mst_lane_id.common().member_id(memberId++);
            mst_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_id.common().member_flags().IS_OPTIONAL(false);
            mst_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_id.common().member_flags().IS_KEY(false);
            mst_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 lane_id_hash("lane_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_id.detail().name_hash()[i] = lane_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_id);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_lane_quality;
            mst_lane_quality.common().member_id(memberId++);
            mst_lane_quality.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_quality.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_quality.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_quality.common().member_flags().IS_OPTIONAL(false);
            mst_lane_quality.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_quality.common().member_flags().IS_KEY(false);
            mst_lane_quality.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_quality.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lane_quality_hash("lane_quality");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_quality.detail().name_hash()[i] = lane_quality_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_quality);

            MinimalStructMember mst_fused_lane_type;
            mst_fused_lane_type.common().member_id(memberId++);
            mst_fused_lane_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_fused_lane_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_fused_lane_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_fused_lane_type.common().member_flags().IS_OPTIONAL(false);
            mst_fused_lane_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_fused_lane_type.common().member_flags().IS_KEY(false);
            mst_fused_lane_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_fused_lane_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 fused_lane_type_hash("fused_lane_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_fused_lane_type.detail().name_hash()[i] = fused_lane_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_fused_lane_type);

            MinimalStructMember mst_use_type;
            mst_use_type.common().member_id(memberId++);
            mst_use_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_use_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_use_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_use_type.common().member_flags().IS_OPTIONAL(false);
            mst_use_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_use_type.common().member_flags().IS_KEY(false);
            mst_use_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_use_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 use_type_hash("use_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_use_type.detail().name_hash()[i] = use_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_use_type);

            MinimalStructMember mst_create_time;
            mst_create_time.common().member_id(memberId++);
            mst_create_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_create_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_create_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_create_time.common().member_flags().IS_OPTIONAL(false);
            mst_create_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_create_time.common().member_flags().IS_KEY(false);
            mst_create_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_create_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 create_time_hash("create_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_create_time.detail().name_hash()[i] = create_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_create_time);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneLine", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneLine", false);
        }

        const TypeObject* GetCompleteLaneLineObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneLine", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_lane_type;
            cst_lane_type.common().member_id(memberId++);
            cst_lane_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_type.common().member_flags().IS_OPTIONAL(false);
            cst_lane_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_type.common().member_flags().IS_KEY(false);
            cst_lane_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lane_type.detail().name("lane_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_type);

            CompleteStructMember cst_lane_color;
            cst_lane_color.common().member_id(memberId++);
            cst_lane_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_color.common().member_flags().IS_OPTIONAL(false);
            cst_lane_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_color.common().member_flags().IS_KEY(false);
            cst_lane_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lane_color.detail().name("lane_color");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_color);

            CompleteStructMember cst_pos_type;
            cst_pos_type.common().member_id(memberId++);
            cst_pos_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pos_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pos_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pos_type.common().member_flags().IS_OPTIONAL(false);
            cst_pos_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pos_type.common().member_flags().IS_KEY(false);
            cst_pos_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pos_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_pos_type.detail().name("pos_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pos_type);

            CompleteStructMember cst_curve_vehicle;
            cst_curve_vehicle.common().member_id(memberId++);
            cst_curve_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_curve_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_curve_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_curve_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_curve_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_curve_vehicle.common().member_flags().IS_KEY(false);
            cst_curve_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_curve_vehicle.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true));
            cst_curve_vehicle.detail().name("curve_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_curve_vehicle);

            CompleteStructMember cst_curve_image;
            cst_curve_image.common().member_id(memberId++);
            cst_curve_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_curve_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_curve_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_curve_image.common().member_flags().IS_OPTIONAL(false);
            cst_curve_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_curve_image.common().member_flags().IS_KEY(false);
            cst_curve_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_curve_image.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true));
            cst_curve_image.detail().name("curve_image");

            type_object->complete().struct_type().member_seq().emplace_back(cst_curve_image);

            CompleteStructMember cst_curve_abs;
            cst_curve_abs.common().member_id(memberId++);
            cst_curve_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_curve_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_curve_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_curve_abs.common().member_flags().IS_OPTIONAL(false);
            cst_curve_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_curve_abs.common().member_flags().IS_KEY(false);
            cst_curve_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_curve_abs.common().member_type_id(*ros2_interface::msg::GetLaneLineCubicCurveIdentifier(true));
            cst_curve_abs.detail().name("curve_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_curve_abs);

            CompleteStructMember cst_pts_vehicle;
            cst_pts_vehicle.common().member_id(memberId++);
            cst_pts_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pts_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pts_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pts_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_pts_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pts_vehicle.common().member_flags().IS_KEY(false);
            cst_pts_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pts_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_pts_vehicle.detail().name("pts_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pts_vehicle);

            CompleteStructMember cst_pts_image;
            cst_pts_image.common().member_id(memberId++);
            cst_pts_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pts_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pts_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pts_image.common().member_flags().IS_OPTIONAL(false);
            cst_pts_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pts_image.common().member_flags().IS_KEY(false);
            cst_pts_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pts_image.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2D", 100, true));


            cst_pts_image.detail().name("pts_image");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pts_image);

            CompleteStructMember cst_pts_abs;
            cst_pts_abs.common().member_id(memberId++);
            cst_pts_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pts_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pts_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pts_abs.common().member_flags().IS_OPTIONAL(false);
            cst_pts_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pts_abs.common().member_flags().IS_KEY(false);
            cst_pts_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pts_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_pts_abs.detail().name("pts_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pts_abs);

            CompleteStructMember cst_image_end_point;
            cst_image_end_point.common().member_id(memberId++);
            cst_image_end_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_image_end_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_image_end_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_image_end_point.common().member_flags().IS_OPTIONAL(false);
            cst_image_end_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_image_end_point.common().member_flags().IS_KEY(false);
            cst_image_end_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_image_end_point.common().member_type_id(*ros2_interface::msg::GetEndPointsIdentifier(true));
            cst_image_end_point.detail().name("image_end_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_image_end_point);

            CompleteStructMember cst_pts_key;
            cst_pts_key.common().member_id(memberId++);
            cst_pts_key.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pts_key.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pts_key.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pts_key.common().member_flags().IS_OPTIONAL(false);
            cst_pts_key.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pts_key.common().member_flags().IS_KEY(false);
            cst_pts_key.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pts_key.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2D", 100, true));


            cst_pts_key.detail().name("pts_key");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pts_key);

            CompleteStructMember cst_hd_lane_id;
            cst_hd_lane_id.common().member_id(memberId++);
            cst_hd_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hd_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hd_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hd_lane_id.common().member_flags().IS_OPTIONAL(false);
            cst_hd_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hd_lane_id.common().member_flags().IS_KEY(false);
            cst_hd_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hd_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_hd_lane_id.detail().name("hd_lane_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hd_lane_id);

            CompleteStructMember cst_lane_id;
            cst_lane_id.common().member_id(memberId++);
            cst_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_id.common().member_flags().IS_OPTIONAL(false);
            cst_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_id.common().member_flags().IS_KEY(false);
            cst_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_lane_id.detail().name("lane_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_id);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_lane_quality;
            cst_lane_quality.common().member_id(memberId++);
            cst_lane_quality.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_quality.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_quality.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_quality.common().member_flags().IS_OPTIONAL(false);
            cst_lane_quality.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_quality.common().member_flags().IS_KEY(false);
            cst_lane_quality.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_quality.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lane_quality.detail().name("lane_quality");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_quality);

            CompleteStructMember cst_fused_lane_type;
            cst_fused_lane_type.common().member_id(memberId++);
            cst_fused_lane_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_fused_lane_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_fused_lane_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_fused_lane_type.common().member_flags().IS_OPTIONAL(false);
            cst_fused_lane_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_fused_lane_type.common().member_flags().IS_KEY(false);
            cst_fused_lane_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_fused_lane_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_fused_lane_type.detail().name("fused_lane_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_fused_lane_type);

            CompleteStructMember cst_use_type;
            cst_use_type.common().member_id(memberId++);
            cst_use_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_use_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_use_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_use_type.common().member_flags().IS_OPTIONAL(false);
            cst_use_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_use_type.common().member_flags().IS_KEY(false);
            cst_use_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_use_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_use_type.detail().name("use_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_use_type);

            CompleteStructMember cst_create_time;
            cst_create_time.common().member_id(memberId++);
            cst_create_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_create_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_create_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_create_time.common().member_flags().IS_OPTIONAL(false);
            cst_create_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_create_time.common().member_flags().IS_KEY(false);
            cst_create_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_create_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_create_time.detail().name("create_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_create_time);


            // Header
            type_object->complete().struct_type().header().detail().type_name("LaneLine");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneLine", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneLine", true);
        }

    } // namespace msg
} // namespace ros2_interface