// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LanePoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LanePoint.h"
#include "LanePointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_LanePoint_max_cdr_typesize 72ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LanePoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LanePoint::LanePoint()
{
    // ros2_interface::msg::Point3D m_point

    // double m_theta
    m_theta = 0.0;
    // double m_mileage
    m_mileage = 0.0;
    // double m_limit_speed
    m_limit_speed = 0.0;
    // double m_left_road_width
    m_left_road_width = 0.0;
    // double m_right_road_width
    m_right_road_width = 0.0;
    // long m_left_line_type
    m_left_line_type = 0;
    // long m_right_line_type
    m_right_line_type = 0;

    // Just to register all known types
    registerLanePointTypes();
}

ros2_interface::msg::LanePoint::~LanePoint()
{








}

ros2_interface::msg::LanePoint::LanePoint(
        const LanePoint& x)
{
    m_point = x.m_point;
    m_theta = x.m_theta;
    m_mileage = x.m_mileage;
    m_limit_speed = x.m_limit_speed;
    m_left_road_width = x.m_left_road_width;
    m_right_road_width = x.m_right_road_width;
    m_left_line_type = x.m_left_line_type;
    m_right_line_type = x.m_right_line_type;
}

ros2_interface::msg::LanePoint::LanePoint(
        LanePoint&& x) noexcept 
{
    m_point = std::move(x.m_point);
    m_theta = x.m_theta;
    m_mileage = x.m_mileage;
    m_limit_speed = x.m_limit_speed;
    m_left_road_width = x.m_left_road_width;
    m_right_road_width = x.m_right_road_width;
    m_left_line_type = x.m_left_line_type;
    m_right_line_type = x.m_right_line_type;
}

ros2_interface::msg::LanePoint& ros2_interface::msg::LanePoint::operator =(
        const LanePoint& x)
{

    m_point = x.m_point;
    m_theta = x.m_theta;
    m_mileage = x.m_mileage;
    m_limit_speed = x.m_limit_speed;
    m_left_road_width = x.m_left_road_width;
    m_right_road_width = x.m_right_road_width;
    m_left_line_type = x.m_left_line_type;
    m_right_line_type = x.m_right_line_type;

    return *this;
}

ros2_interface::msg::LanePoint& ros2_interface::msg::LanePoint::operator =(
        LanePoint&& x) noexcept
{

    m_point = std::move(x.m_point);
    m_theta = x.m_theta;
    m_mileage = x.m_mileage;
    m_limit_speed = x.m_limit_speed;
    m_left_road_width = x.m_left_road_width;
    m_right_road_width = x.m_right_road_width;
    m_left_line_type = x.m_left_line_type;
    m_right_line_type = x.m_right_line_type;

    return *this;
}

bool ros2_interface::msg::LanePoint::operator ==(
        const LanePoint& x) const
{

    return (m_point == x.m_point && m_theta == x.m_theta && m_mileage == x.m_mileage && m_limit_speed == x.m_limit_speed && m_left_road_width == x.m_left_road_width && m_right_road_width == x.m_right_road_width && m_left_line_type == x.m_left_line_type && m_right_line_type == x.m_right_line_type);
}

bool ros2_interface::msg::LanePoint::operator !=(
        const LanePoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LanePoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LanePoint_max_cdr_typesize;
}

size_t ros2_interface::msg::LanePoint::getCdrSerializedSize(
        const ros2_interface::msg::LanePoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.point(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LanePoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_point;
    scdr << m_theta;
    scdr << m_mileage;
    scdr << m_limit_speed;
    scdr << m_left_road_width;
    scdr << m_right_road_width;
    scdr << m_left_line_type;
    scdr << m_right_line_type;

}

void ros2_interface::msg::LanePoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_point;
    dcdr >> m_theta;
    dcdr >> m_mileage;
    dcdr >> m_limit_speed;
    dcdr >> m_left_road_width;
    dcdr >> m_right_road_width;
    dcdr >> m_left_line_type;
    dcdr >> m_right_line_type;
}

/*!
 * @brief This function copies the value in member point
 * @param _point New value to be copied in member point
 */
void ros2_interface::msg::LanePoint::point(
        const ros2_interface::msg::Point3D& _point)
{
    m_point = _point;
}

/*!
 * @brief This function moves the value in member point
 * @param _point New value to be moved in member point
 */
void ros2_interface::msg::LanePoint::point(
        ros2_interface::msg::Point3D&& _point)
{
    m_point = std::move(_point);
}

/*!
 * @brief This function returns a constant reference to member point
 * @return Constant reference to member point
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::LanePoint::point() const
{
    return m_point;
}

/*!
 * @brief This function returns a reference to member point
 * @return Reference to member point
 */
ros2_interface::msg::Point3D& ros2_interface::msg::LanePoint::point()
{
    return m_point;
}
/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::LanePoint::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::LanePoint::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::LanePoint::theta()
{
    return m_theta;
}

/*!
 * @brief This function sets a value in member mileage
 * @param _mileage New value for member mileage
 */
void ros2_interface::msg::LanePoint::mileage(
        double _mileage)
{
    m_mileage = _mileage;
}

/*!
 * @brief This function returns the value of member mileage
 * @return Value of member mileage
 */
double ros2_interface::msg::LanePoint::mileage() const
{
    return m_mileage;
}

/*!
 * @brief This function returns a reference to member mileage
 * @return Reference to member mileage
 */
double& ros2_interface::msg::LanePoint::mileage()
{
    return m_mileage;
}

/*!
 * @brief This function sets a value in member limit_speed
 * @param _limit_speed New value for member limit_speed
 */
void ros2_interface::msg::LanePoint::limit_speed(
        double _limit_speed)
{
    m_limit_speed = _limit_speed;
}

/*!
 * @brief This function returns the value of member limit_speed
 * @return Value of member limit_speed
 */
double ros2_interface::msg::LanePoint::limit_speed() const
{
    return m_limit_speed;
}

/*!
 * @brief This function returns a reference to member limit_speed
 * @return Reference to member limit_speed
 */
double& ros2_interface::msg::LanePoint::limit_speed()
{
    return m_limit_speed;
}

/*!
 * @brief This function sets a value in member left_road_width
 * @param _left_road_width New value for member left_road_width
 */
void ros2_interface::msg::LanePoint::left_road_width(
        double _left_road_width)
{
    m_left_road_width = _left_road_width;
}

/*!
 * @brief This function returns the value of member left_road_width
 * @return Value of member left_road_width
 */
double ros2_interface::msg::LanePoint::left_road_width() const
{
    return m_left_road_width;
}

/*!
 * @brief This function returns a reference to member left_road_width
 * @return Reference to member left_road_width
 */
double& ros2_interface::msg::LanePoint::left_road_width()
{
    return m_left_road_width;
}

/*!
 * @brief This function sets a value in member right_road_width
 * @param _right_road_width New value for member right_road_width
 */
void ros2_interface::msg::LanePoint::right_road_width(
        double _right_road_width)
{
    m_right_road_width = _right_road_width;
}

/*!
 * @brief This function returns the value of member right_road_width
 * @return Value of member right_road_width
 */
double ros2_interface::msg::LanePoint::right_road_width() const
{
    return m_right_road_width;
}

/*!
 * @brief This function returns a reference to member right_road_width
 * @return Reference to member right_road_width
 */
double& ros2_interface::msg::LanePoint::right_road_width()
{
    return m_right_road_width;
}

/*!
 * @brief This function sets a value in member left_line_type
 * @param _left_line_type New value for member left_line_type
 */
void ros2_interface::msg::LanePoint::left_line_type(
        int32_t _left_line_type)
{
    m_left_line_type = _left_line_type;
}

/*!
 * @brief This function returns the value of member left_line_type
 * @return Value of member left_line_type
 */
int32_t ros2_interface::msg::LanePoint::left_line_type() const
{
    return m_left_line_type;
}

/*!
 * @brief This function returns a reference to member left_line_type
 * @return Reference to member left_line_type
 */
int32_t& ros2_interface::msg::LanePoint::left_line_type()
{
    return m_left_line_type;
}

/*!
 * @brief This function sets a value in member right_line_type
 * @param _right_line_type New value for member right_line_type
 */
void ros2_interface::msg::LanePoint::right_line_type(
        int32_t _right_line_type)
{
    m_right_line_type = _right_line_type;
}

/*!
 * @brief This function returns the value of member right_line_type
 * @return Value of member right_line_type
 */
int32_t ros2_interface::msg::LanePoint::right_line_type() const
{
    return m_right_line_type;
}

/*!
 * @brief This function returns a reference to member right_line_type
 * @return Reference to member right_line_type
 */
int32_t& ros2_interface::msg::LanePoint::right_line_type()
{
    return m_right_line_type;
}



size_t ros2_interface::msg::LanePoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LanePoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::LanePoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LanePoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



