// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LanePoint.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEPOINT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEPOINT_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(LANEPOINT_SOURCE)
#define LANEPOINT_DllAPI __declspec( dllexport )
#else
#define LANEPOINT_DllAPI __declspec( dllimport )
#endif // LANEPOINT_SOURCE
#else
#define LANEPOINT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define LANEPOINT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure LanePoint defined by the user in the IDL file.
         * @ingroup LanePoint
         */
        class LanePoint
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport LanePoint();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~LanePoint();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::LanePoint that will be copied.
             */
            eProsima_user_DllExport LanePoint(
                    const LanePoint& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::LanePoint that will be copied.
             */
            eProsima_user_DllExport LanePoint(
                    LanePoint&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::LanePoint that will be copied.
             */
            eProsima_user_DllExport LanePoint& operator =(
                    const LanePoint& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::LanePoint that will be copied.
             */
            eProsima_user_DllExport LanePoint& operator =(
                    LanePoint&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LanePoint object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const LanePoint& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LanePoint object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const LanePoint& x) const;

            /*!
             * @brief This function copies the value in member point
             * @param _point New value to be copied in member point
             */
            eProsima_user_DllExport void point(
                    const ros2_interface::msg::Point3D& _point);

            /*!
             * @brief This function moves the value in member point
             * @param _point New value to be moved in member point
             */
            eProsima_user_DllExport void point(
                    ros2_interface::msg::Point3D&& _point);

            /*!
             * @brief This function returns a constant reference to member point
             * @return Constant reference to member point
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& point() const;

            /*!
             * @brief This function returns a reference to member point
             * @return Reference to member point
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& point();
            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function sets a value in member mileage
             * @param _mileage New value for member mileage
             */
            eProsima_user_DllExport void mileage(
                    double _mileage);

            /*!
             * @brief This function returns the value of member mileage
             * @return Value of member mileage
             */
            eProsima_user_DllExport double mileage() const;

            /*!
             * @brief This function returns a reference to member mileage
             * @return Reference to member mileage
             */
            eProsima_user_DllExport double& mileage();

            /*!
             * @brief This function sets a value in member limit_speed
             * @param _limit_speed New value for member limit_speed
             */
            eProsima_user_DllExport void limit_speed(
                    double _limit_speed);

            /*!
             * @brief This function returns the value of member limit_speed
             * @return Value of member limit_speed
             */
            eProsima_user_DllExport double limit_speed() const;

            /*!
             * @brief This function returns a reference to member limit_speed
             * @return Reference to member limit_speed
             */
            eProsima_user_DllExport double& limit_speed();

            /*!
             * @brief This function sets a value in member left_road_width
             * @param _left_road_width New value for member left_road_width
             */
            eProsima_user_DllExport void left_road_width(
                    double _left_road_width);

            /*!
             * @brief This function returns the value of member left_road_width
             * @return Value of member left_road_width
             */
            eProsima_user_DllExport double left_road_width() const;

            /*!
             * @brief This function returns a reference to member left_road_width
             * @return Reference to member left_road_width
             */
            eProsima_user_DllExport double& left_road_width();

            /*!
             * @brief This function sets a value in member right_road_width
             * @param _right_road_width New value for member right_road_width
             */
            eProsima_user_DllExport void right_road_width(
                    double _right_road_width);

            /*!
             * @brief This function returns the value of member right_road_width
             * @return Value of member right_road_width
             */
            eProsima_user_DllExport double right_road_width() const;

            /*!
             * @brief This function returns a reference to member right_road_width
             * @return Reference to member right_road_width
             */
            eProsima_user_DllExport double& right_road_width();

            /*!
             * @brief This function sets a value in member left_line_type
             * @param _left_line_type New value for member left_line_type
             */
            eProsima_user_DllExport void left_line_type(
                    int32_t _left_line_type);

            /*!
             * @brief This function returns the value of member left_line_type
             * @return Value of member left_line_type
             */
            eProsima_user_DllExport int32_t left_line_type() const;

            /*!
             * @brief This function returns a reference to member left_line_type
             * @return Reference to member left_line_type
             */
            eProsima_user_DllExport int32_t& left_line_type();

            /*!
             * @brief This function sets a value in member right_line_type
             * @param _right_line_type New value for member right_line_type
             */
            eProsima_user_DllExport void right_line_type(
                    int32_t _right_line_type);

            /*!
             * @brief This function returns the value of member right_line_type
             * @return Value of member right_line_type
             */
            eProsima_user_DllExport int32_t right_line_type() const;

            /*!
             * @brief This function returns a reference to member right_line_type
             * @return Reference to member right_line_type
             */
            eProsima_user_DllExport int32_t& right_line_type();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::LanePoint& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Point3D m_point;
            double m_theta;
            double m_mileage;
            double m_limit_speed;
            double m_left_road_width;
            double m_right_road_width;
            int32_t m_left_line_type;
            int32_t m_right_line_type;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LANEPOINT_H_

