// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LanePointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "LanePoint.h"
#include "LanePointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLanePointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(true),
                        ros2_interface::msg::GetLanePointObject(true));
                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(false),
                        ros2_interface::msg::GetLanePointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLanePointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("LanePoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLanePointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("LanePoint", complete);
        }

        const TypeObject* GetLanePointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LanePoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLanePointObject();
            }
            //else
            return GetMinimalLanePointObject();
        }

        const TypeObject* GetMinimalLanePointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LanePoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_point;
            mst_point.common().member_id(memberId++);
            mst_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_point.common().member_flags().IS_OPTIONAL(false);
            mst_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_point.common().member_flags().IS_KEY(false);
            mst_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 point_hash("point");
            for(int i = 0; i < 4; ++i)
            {
                mst_point.detail().name_hash()[i] = point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_point);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_mileage;
            mst_mileage.common().member_id(memberId++);
            mst_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_mileage.common().member_flags().IS_OPTIONAL(false);
            mst_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_mileage.common().member_flags().IS_KEY(false);
            mst_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 mileage_hash("mileage");
            for(int i = 0; i < 4; ++i)
            {
                mst_mileage.detail().name_hash()[i] = mileage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_mileage);

            MinimalStructMember mst_limit_speed;
            mst_limit_speed.common().member_id(memberId++);
            mst_limit_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_limit_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_limit_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_limit_speed.common().member_flags().IS_OPTIONAL(false);
            mst_limit_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_limit_speed.common().member_flags().IS_KEY(false);
            mst_limit_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_limit_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 limit_speed_hash("limit_speed");
            for(int i = 0; i < 4; ++i)
            {
                mst_limit_speed.detail().name_hash()[i] = limit_speed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_limit_speed);

            MinimalStructMember mst_left_road_width;
            mst_left_road_width.common().member_id(memberId++);
            mst_left_road_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_left_road_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_left_road_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_left_road_width.common().member_flags().IS_OPTIONAL(false);
            mst_left_road_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_left_road_width.common().member_flags().IS_KEY(false);
            mst_left_road_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_left_road_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 left_road_width_hash("left_road_width");
            for(int i = 0; i < 4; ++i)
            {
                mst_left_road_width.detail().name_hash()[i] = left_road_width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_left_road_width);

            MinimalStructMember mst_right_road_width;
            mst_right_road_width.common().member_id(memberId++);
            mst_right_road_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_right_road_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_right_road_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_right_road_width.common().member_flags().IS_OPTIONAL(false);
            mst_right_road_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_right_road_width.common().member_flags().IS_KEY(false);
            mst_right_road_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_right_road_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 right_road_width_hash("right_road_width");
            for(int i = 0; i < 4; ++i)
            {
                mst_right_road_width.detail().name_hash()[i] = right_road_width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_right_road_width);

            MinimalStructMember mst_left_line_type;
            mst_left_line_type.common().member_id(memberId++);
            mst_left_line_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_left_line_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_left_line_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_left_line_type.common().member_flags().IS_OPTIONAL(false);
            mst_left_line_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_left_line_type.common().member_flags().IS_KEY(false);
            mst_left_line_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_left_line_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 left_line_type_hash("left_line_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_left_line_type.detail().name_hash()[i] = left_line_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_left_line_type);

            MinimalStructMember mst_right_line_type;
            mst_right_line_type.common().member_id(memberId++);
            mst_right_line_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_right_line_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_right_line_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_right_line_type.common().member_flags().IS_OPTIONAL(false);
            mst_right_line_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_right_line_type.common().member_flags().IS_KEY(false);
            mst_right_line_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_right_line_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 right_line_type_hash("right_line_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_right_line_type.detail().name_hash()[i] = right_line_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_right_line_type);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LanePoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LanePoint", false);
        }

        const TypeObject* GetCompleteLanePointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LanePoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_point;
            cst_point.common().member_id(memberId++);
            cst_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_point.common().member_flags().IS_OPTIONAL(false);
            cst_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_point.common().member_flags().IS_KEY(false);
            cst_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_point.detail().name("point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_point);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_mileage;
            cst_mileage.common().member_id(memberId++);
            cst_mileage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_mileage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_mileage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_mileage.common().member_flags().IS_OPTIONAL(false);
            cst_mileage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_mileage.common().member_flags().IS_KEY(false);
            cst_mileage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_mileage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_mileage.detail().name("mileage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_mileage);

            CompleteStructMember cst_limit_speed;
            cst_limit_speed.common().member_id(memberId++);
            cst_limit_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_limit_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_limit_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_limit_speed.common().member_flags().IS_OPTIONAL(false);
            cst_limit_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_limit_speed.common().member_flags().IS_KEY(false);
            cst_limit_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_limit_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_limit_speed.detail().name("limit_speed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_limit_speed);

            CompleteStructMember cst_left_road_width;
            cst_left_road_width.common().member_id(memberId++);
            cst_left_road_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_left_road_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_left_road_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_left_road_width.common().member_flags().IS_OPTIONAL(false);
            cst_left_road_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_left_road_width.common().member_flags().IS_KEY(false);
            cst_left_road_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_left_road_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_left_road_width.detail().name("left_road_width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_left_road_width);

            CompleteStructMember cst_right_road_width;
            cst_right_road_width.common().member_id(memberId++);
            cst_right_road_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_right_road_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_right_road_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_right_road_width.common().member_flags().IS_OPTIONAL(false);
            cst_right_road_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_right_road_width.common().member_flags().IS_KEY(false);
            cst_right_road_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_right_road_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_right_road_width.detail().name("right_road_width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_right_road_width);

            CompleteStructMember cst_left_line_type;
            cst_left_line_type.common().member_id(memberId++);
            cst_left_line_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_left_line_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_left_line_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_left_line_type.common().member_flags().IS_OPTIONAL(false);
            cst_left_line_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_left_line_type.common().member_flags().IS_KEY(false);
            cst_left_line_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_left_line_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_left_line_type.detail().name("left_line_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_left_line_type);

            CompleteStructMember cst_right_line_type;
            cst_right_line_type.common().member_id(memberId++);
            cst_right_line_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_right_line_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_right_line_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_right_line_type.common().member_flags().IS_OPTIONAL(false);
            cst_right_line_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_right_line_type.common().member_flags().IS_KEY(false);
            cst_right_line_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_right_line_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_right_line_type.detail().name("right_line_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_right_line_type);


            // Header
            type_object->complete().struct_type().header().detail().type_name("LanePoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LanePoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LanePoint", true);
        }

    } // namespace msg
} // namespace ros2_interface