// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneletInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LaneletInfo.h"
#include "LaneletInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_LaneletInfo_max_cdr_typesize 16ULL;
#define ros2_interface_msg_LaneletInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LaneletInfo::LaneletInfo()
{
    // long m_lanelet_id
    m_lanelet_id = 0;
    // double m_length
    m_length = 0.0;

    // Just to register all known types
    registerLaneletInfoTypes();
}

ros2_interface::msg::LaneletInfo::~LaneletInfo()
{


}

ros2_interface::msg::LaneletInfo::LaneletInfo(
        const LaneletInfo& x)
{
    m_lanelet_id = x.m_lanelet_id;
    m_length = x.m_length;
}

ros2_interface::msg::LaneletInfo::LaneletInfo(
        LaneletInfo&& x) noexcept 
{
    m_lanelet_id = x.m_lanelet_id;
    m_length = x.m_length;
}

ros2_interface::msg::LaneletInfo& ros2_interface::msg::LaneletInfo::operator =(
        const LaneletInfo& x)
{

    m_lanelet_id = x.m_lanelet_id;
    m_length = x.m_length;

    return *this;
}

ros2_interface::msg::LaneletInfo& ros2_interface::msg::LaneletInfo::operator =(
        LaneletInfo&& x) noexcept
{

    m_lanelet_id = x.m_lanelet_id;
    m_length = x.m_length;

    return *this;
}

bool ros2_interface::msg::LaneletInfo::operator ==(
        const LaneletInfo& x) const
{

    return (m_lanelet_id == x.m_lanelet_id && m_length == x.m_length);
}

bool ros2_interface::msg::LaneletInfo::operator !=(
        const LaneletInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LaneletInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneletInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::LaneletInfo::getCdrSerializedSize(
        const ros2_interface::msg::LaneletInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LaneletInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_lanelet_id;
    scdr << m_length;

}

void ros2_interface::msg::LaneletInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_lanelet_id;
    dcdr >> m_length;
}

/*!
 * @brief This function sets a value in member lanelet_id
 * @param _lanelet_id New value for member lanelet_id
 */
void ros2_interface::msg::LaneletInfo::lanelet_id(
        int32_t _lanelet_id)
{
    m_lanelet_id = _lanelet_id;
}

/*!
 * @brief This function returns the value of member lanelet_id
 * @return Value of member lanelet_id
 */
int32_t ros2_interface::msg::LaneletInfo::lanelet_id() const
{
    return m_lanelet_id;
}

/*!
 * @brief This function returns a reference to member lanelet_id
 * @return Reference to member lanelet_id
 */
int32_t& ros2_interface::msg::LaneletInfo::lanelet_id()
{
    return m_lanelet_id;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::LaneletInfo::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::LaneletInfo::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::LaneletInfo::length()
{
    return m_length;
}



size_t ros2_interface::msg::LaneletInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LaneletInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::LaneletInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LaneletInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



