// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LaneletInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "LaneletInfo.h"
#include "LaneletInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLaneletInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::LaneletInfo", ros2_interface::msg::GetLaneletInfoIdentifier(true),
                        ros2_interface::msg::GetLaneletInfoObject(true));
                factory->add_type_object("ros2_interface::msg::LaneletInfo", ros2_interface::msg::GetLaneletInfoIdentifier(false),
                        ros2_interface::msg::GetLaneletInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLaneletInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("LaneletInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLaneletInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("LaneletInfo", complete);
        }

        const TypeObject* GetLaneletInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneletInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLaneletInfoObject();
            }
            //else
            return GetMinimalLaneletInfoObject();
        }

        const TypeObject* GetMinimalLaneletInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneletInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_lanelet_id;
            mst_lanelet_id.common().member_id(memberId++);
            mst_lanelet_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lanelet_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lanelet_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lanelet_id.common().member_flags().IS_OPTIONAL(false);
            mst_lanelet_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lanelet_id.common().member_flags().IS_KEY(false);
            mst_lanelet_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lanelet_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lanelet_id_hash("lanelet_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_lanelet_id.detail().name_hash()[i] = lanelet_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lanelet_id);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneletInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneletInfo", false);
        }

        const TypeObject* GetCompleteLaneletInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("LaneletInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_lanelet_id;
            cst_lanelet_id.common().member_id(memberId++);
            cst_lanelet_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lanelet_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lanelet_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lanelet_id.common().member_flags().IS_OPTIONAL(false);
            cst_lanelet_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lanelet_id.common().member_flags().IS_KEY(false);
            cst_lanelet_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lanelet_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lanelet_id.detail().name("lanelet_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lanelet_id);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);


            // Header
            type_object->complete().struct_type().header().detail().type_name("LaneletInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("LaneletInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("LaneletInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface