// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LimitSpeedInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "LimitSpeedInfo.h"
#include "LimitSpeedInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_LimitSpeedInfo_max_cdr_typesize 24ULL;
#define ros2_interface_msg_LimitSpeedInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::LimitSpeedInfo::LimitSpeedInfo()
{
    // long m_limitspeed_valid_flag
    m_limitspeed_valid_flag = 0;
    // double m_limit_speed
    m_limit_speed = 0.0;
    // double m_limit_distance
    m_limit_distance = 0.0;

    // Just to register all known types
    registerLimitSpeedInfoTypes();
}

ros2_interface::msg::LimitSpeedInfo::~LimitSpeedInfo()
{



}

ros2_interface::msg::LimitSpeedInfo::LimitSpeedInfo(
        const LimitSpeedInfo& x)
{
    m_limitspeed_valid_flag = x.m_limitspeed_valid_flag;
    m_limit_speed = x.m_limit_speed;
    m_limit_distance = x.m_limit_distance;
}

ros2_interface::msg::LimitSpeedInfo::LimitSpeedInfo(
        LimitSpeedInfo&& x) noexcept 
{
    m_limitspeed_valid_flag = x.m_limitspeed_valid_flag;
    m_limit_speed = x.m_limit_speed;
    m_limit_distance = x.m_limit_distance;
}

ros2_interface::msg::LimitSpeedInfo& ros2_interface::msg::LimitSpeedInfo::operator =(
        const LimitSpeedInfo& x)
{

    m_limitspeed_valid_flag = x.m_limitspeed_valid_flag;
    m_limit_speed = x.m_limit_speed;
    m_limit_distance = x.m_limit_distance;

    return *this;
}

ros2_interface::msg::LimitSpeedInfo& ros2_interface::msg::LimitSpeedInfo::operator =(
        LimitSpeedInfo&& x) noexcept
{

    m_limitspeed_valid_flag = x.m_limitspeed_valid_flag;
    m_limit_speed = x.m_limit_speed;
    m_limit_distance = x.m_limit_distance;

    return *this;
}

bool ros2_interface::msg::LimitSpeedInfo::operator ==(
        const LimitSpeedInfo& x) const
{

    return (m_limitspeed_valid_flag == x.m_limitspeed_valid_flag && m_limit_speed == x.m_limit_speed && m_limit_distance == x.m_limit_distance);
}

bool ros2_interface::msg::LimitSpeedInfo::operator !=(
        const LimitSpeedInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::LimitSpeedInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LimitSpeedInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::LimitSpeedInfo::getCdrSerializedSize(
        const ros2_interface::msg::LimitSpeedInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::LimitSpeedInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_limitspeed_valid_flag;
    scdr << m_limit_speed;
    scdr << m_limit_distance;

}

void ros2_interface::msg::LimitSpeedInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_limitspeed_valid_flag;
    dcdr >> m_limit_speed;
    dcdr >> m_limit_distance;
}

/*!
 * @brief This function sets a value in member limitspeed_valid_flag
 * @param _limitspeed_valid_flag New value for member limitspeed_valid_flag
 */
void ros2_interface::msg::LimitSpeedInfo::limitspeed_valid_flag(
        int32_t _limitspeed_valid_flag)
{
    m_limitspeed_valid_flag = _limitspeed_valid_flag;
}

/*!
 * @brief This function returns the value of member limitspeed_valid_flag
 * @return Value of member limitspeed_valid_flag
 */
int32_t ros2_interface::msg::LimitSpeedInfo::limitspeed_valid_flag() const
{
    return m_limitspeed_valid_flag;
}

/*!
 * @brief This function returns a reference to member limitspeed_valid_flag
 * @return Reference to member limitspeed_valid_flag
 */
int32_t& ros2_interface::msg::LimitSpeedInfo::limitspeed_valid_flag()
{
    return m_limitspeed_valid_flag;
}

/*!
 * @brief This function sets a value in member limit_speed
 * @param _limit_speed New value for member limit_speed
 */
void ros2_interface::msg::LimitSpeedInfo::limit_speed(
        double _limit_speed)
{
    m_limit_speed = _limit_speed;
}

/*!
 * @brief This function returns the value of member limit_speed
 * @return Value of member limit_speed
 */
double ros2_interface::msg::LimitSpeedInfo::limit_speed() const
{
    return m_limit_speed;
}

/*!
 * @brief This function returns a reference to member limit_speed
 * @return Reference to member limit_speed
 */
double& ros2_interface::msg::LimitSpeedInfo::limit_speed()
{
    return m_limit_speed;
}

/*!
 * @brief This function sets a value in member limit_distance
 * @param _limit_distance New value for member limit_distance
 */
void ros2_interface::msg::LimitSpeedInfo::limit_distance(
        double _limit_distance)
{
    m_limit_distance = _limit_distance;
}

/*!
 * @brief This function returns the value of member limit_distance
 * @return Value of member limit_distance
 */
double ros2_interface::msg::LimitSpeedInfo::limit_distance() const
{
    return m_limit_distance;
}

/*!
 * @brief This function returns a reference to member limit_distance
 * @return Reference to member limit_distance
 */
double& ros2_interface::msg::LimitSpeedInfo::limit_distance()
{
    return m_limit_distance;
}



size_t ros2_interface::msg::LimitSpeedInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_LimitSpeedInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::LimitSpeedInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::LimitSpeedInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



