// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LimitSpeedInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LIMITSPEEDINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LIMITSPEEDINFO_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(LIMITSPEEDINFO_SOURCE)
#define LIMITSPEEDINFO_DllAPI __declspec( dllexport )
#else
#define LIMITSPEEDINFO_DllAPI __declspec( dllimport )
#endif // LIMITSPEEDINFO_SOURCE
#else
#define LIMITSPEEDINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define LIMITSPEEDINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure LimitSpeedInfo defined by the user in the IDL file.
         * @ingroup LimitSpeedInfo
         */
        class LimitSpeedInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport LimitSpeedInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~LimitSpeedInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::LimitSpeedInfo that will be copied.
             */
            eProsima_user_DllExport LimitSpeedInfo(
                    const LimitSpeedInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::LimitSpeedInfo that will be copied.
             */
            eProsima_user_DllExport LimitSpeedInfo(
                    LimitSpeedInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::LimitSpeedInfo that will be copied.
             */
            eProsima_user_DllExport LimitSpeedInfo& operator =(
                    const LimitSpeedInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::LimitSpeedInfo that will be copied.
             */
            eProsima_user_DllExport LimitSpeedInfo& operator =(
                    LimitSpeedInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LimitSpeedInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const LimitSpeedInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::LimitSpeedInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const LimitSpeedInfo& x) const;

            /*!
             * @brief This function sets a value in member limitspeed_valid_flag
             * @param _limitspeed_valid_flag New value for member limitspeed_valid_flag
             */
            eProsima_user_DllExport void limitspeed_valid_flag(
                    int32_t _limitspeed_valid_flag);

            /*!
             * @brief This function returns the value of member limitspeed_valid_flag
             * @return Value of member limitspeed_valid_flag
             */
            eProsima_user_DllExport int32_t limitspeed_valid_flag() const;

            /*!
             * @brief This function returns a reference to member limitspeed_valid_flag
             * @return Reference to member limitspeed_valid_flag
             */
            eProsima_user_DllExport int32_t& limitspeed_valid_flag();

            /*!
             * @brief This function sets a value in member limit_speed
             * @param _limit_speed New value for member limit_speed
             */
            eProsima_user_DllExport void limit_speed(
                    double _limit_speed);

            /*!
             * @brief This function returns the value of member limit_speed
             * @return Value of member limit_speed
             */
            eProsima_user_DllExport double limit_speed() const;

            /*!
             * @brief This function returns a reference to member limit_speed
             * @return Reference to member limit_speed
             */
            eProsima_user_DllExport double& limit_speed();

            /*!
             * @brief This function sets a value in member limit_distance
             * @param _limit_distance New value for member limit_distance
             */
            eProsima_user_DllExport void limit_distance(
                    double _limit_distance);

            /*!
             * @brief This function returns the value of member limit_distance
             * @return Value of member limit_distance
             */
            eProsima_user_DllExport double limit_distance() const;

            /*!
             * @brief This function returns a reference to member limit_distance
             * @return Reference to member limit_distance
             */
            eProsima_user_DllExport double& limit_distance();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::LimitSpeedInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_limitspeed_valid_flag;
            double m_limit_speed;
            double m_limit_distance;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LIMITSPEEDINFO_H_

