// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Location.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Location.h"
#include "LocationTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_PointENU_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_PointLLH_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Location_max_cdr_typesize 608ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointENU_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointLLH_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Location_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Location::Location()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::PointLLH m_position

    // double m_pitch
    m_pitch = 0.0;
    // double m_roll
    m_roll = 0.0;
    // double m_heading
    m_heading = 0.0;
    // ros2_interface::msg::Point3D m_linear_velocity

    // ros2_interface::msg::Point3D m_linear_acceleration

    // ros2_interface::msg::Point3D m_angular_velocity

    // long m_rtk_flag
    m_rtk_flag = 0;
    // long m_coortype
    m_coortype = 0;
    // long m_odom_type
    m_odom_type = 0;
    // long m_auxiliary_type
    m_auxiliary_type = 0;
    // long m_location_valid_flag
    m_location_valid_flag = 0;
    // double m_origin_lat
    m_origin_lat = 0.0;
    // double m_origin_lon
    m_origin_lon = 0.0;
    // ros2_interface::msg::PointENU m_utm_position

    // long m_change_origin_flag
    m_change_origin_flag = 0;
    // ros2_interface::msg::PointENU m_utm_position_next

    // ros2_interface::msg::Point3D m_position_std_dev

    // ros2_interface::msg::Point3D m_orientation_std_dev

    // ros2_interface::msg::Point3D m_linear_velocity_std_dev

    // ros2_interface::msg::Point3D m_linear_acceleration_std_dev

    // ros2_interface::msg::Point3D m_angular_velocity_std_dev


    // Just to register all known types
    registerLocationTypes();
}

ros2_interface::msg::Location::~Location()
{























}

ros2_interface::msg::Location::Location(
        const Location& x)
{
    m_header = x.m_header;
    m_position = x.m_position;
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_linear_velocity = x.m_linear_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_angular_velocity = x.m_angular_velocity;
    m_rtk_flag = x.m_rtk_flag;
    m_coortype = x.m_coortype;
    m_odom_type = x.m_odom_type;
    m_auxiliary_type = x.m_auxiliary_type;
    m_location_valid_flag = x.m_location_valid_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_utm_position = x.m_utm_position;
    m_change_origin_flag = x.m_change_origin_flag;
    m_utm_position_next = x.m_utm_position_next;
    m_position_std_dev = x.m_position_std_dev;
    m_orientation_std_dev = x.m_orientation_std_dev;
    m_linear_velocity_std_dev = x.m_linear_velocity_std_dev;
    m_linear_acceleration_std_dev = x.m_linear_acceleration_std_dev;
    m_angular_velocity_std_dev = x.m_angular_velocity_std_dev;
}

ros2_interface::msg::Location::Location(
        Location&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_position = std::move(x.m_position);
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_rtk_flag = x.m_rtk_flag;
    m_coortype = x.m_coortype;
    m_odom_type = x.m_odom_type;
    m_auxiliary_type = x.m_auxiliary_type;
    m_location_valid_flag = x.m_location_valid_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_utm_position = std::move(x.m_utm_position);
    m_change_origin_flag = x.m_change_origin_flag;
    m_utm_position_next = std::move(x.m_utm_position_next);
    m_position_std_dev = std::move(x.m_position_std_dev);
    m_orientation_std_dev = std::move(x.m_orientation_std_dev);
    m_linear_velocity_std_dev = std::move(x.m_linear_velocity_std_dev);
    m_linear_acceleration_std_dev = std::move(x.m_linear_acceleration_std_dev);
    m_angular_velocity_std_dev = std::move(x.m_angular_velocity_std_dev);
}

ros2_interface::msg::Location& ros2_interface::msg::Location::operator =(
        const Location& x)
{

    m_header = x.m_header;
    m_position = x.m_position;
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_linear_velocity = x.m_linear_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_angular_velocity = x.m_angular_velocity;
    m_rtk_flag = x.m_rtk_flag;
    m_coortype = x.m_coortype;
    m_odom_type = x.m_odom_type;
    m_auxiliary_type = x.m_auxiliary_type;
    m_location_valid_flag = x.m_location_valid_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_utm_position = x.m_utm_position;
    m_change_origin_flag = x.m_change_origin_flag;
    m_utm_position_next = x.m_utm_position_next;
    m_position_std_dev = x.m_position_std_dev;
    m_orientation_std_dev = x.m_orientation_std_dev;
    m_linear_velocity_std_dev = x.m_linear_velocity_std_dev;
    m_linear_acceleration_std_dev = x.m_linear_acceleration_std_dev;
    m_angular_velocity_std_dev = x.m_angular_velocity_std_dev;

    return *this;
}

ros2_interface::msg::Location& ros2_interface::msg::Location::operator =(
        Location&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_position = std::move(x.m_position);
    m_pitch = x.m_pitch;
    m_roll = x.m_roll;
    m_heading = x.m_heading;
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_rtk_flag = x.m_rtk_flag;
    m_coortype = x.m_coortype;
    m_odom_type = x.m_odom_type;
    m_auxiliary_type = x.m_auxiliary_type;
    m_location_valid_flag = x.m_location_valid_flag;
    m_origin_lat = x.m_origin_lat;
    m_origin_lon = x.m_origin_lon;
    m_utm_position = std::move(x.m_utm_position);
    m_change_origin_flag = x.m_change_origin_flag;
    m_utm_position_next = std::move(x.m_utm_position_next);
    m_position_std_dev = std::move(x.m_position_std_dev);
    m_orientation_std_dev = std::move(x.m_orientation_std_dev);
    m_linear_velocity_std_dev = std::move(x.m_linear_velocity_std_dev);
    m_linear_acceleration_std_dev = std::move(x.m_linear_acceleration_std_dev);
    m_angular_velocity_std_dev = std::move(x.m_angular_velocity_std_dev);

    return *this;
}

bool ros2_interface::msg::Location::operator ==(
        const Location& x) const
{

    return (m_header == x.m_header && m_position == x.m_position && m_pitch == x.m_pitch && m_roll == x.m_roll && m_heading == x.m_heading && m_linear_velocity == x.m_linear_velocity && m_linear_acceleration == x.m_linear_acceleration && m_angular_velocity == x.m_angular_velocity && m_rtk_flag == x.m_rtk_flag && m_coortype == x.m_coortype && m_odom_type == x.m_odom_type && m_auxiliary_type == x.m_auxiliary_type && m_location_valid_flag == x.m_location_valid_flag && m_origin_lat == x.m_origin_lat && m_origin_lon == x.m_origin_lon && m_utm_position == x.m_utm_position && m_change_origin_flag == x.m_change_origin_flag && m_utm_position_next == x.m_utm_position_next && m_position_std_dev == x.m_position_std_dev && m_orientation_std_dev == x.m_orientation_std_dev && m_linear_velocity_std_dev == x.m_linear_velocity_std_dev && m_linear_acceleration_std_dev == x.m_linear_acceleration_std_dev && m_angular_velocity_std_dev == x.m_angular_velocity_std_dev);
}

bool ros2_interface::msg::Location::operator !=(
        const Location& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Location::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Location_max_cdr_typesize;
}

size_t ros2_interface::msg::Location::getCdrSerializedSize(
        const ros2_interface::msg::Location& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::PointLLH::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::PointENU::getCdrSerializedSize(data.utm_position(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::PointENU::getCdrSerializedSize(data.utm_position_next(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.position_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.orientation_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_velocity_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity_std_dev(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Location::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_position;
    scdr << m_pitch;
    scdr << m_roll;
    scdr << m_heading;
    scdr << m_linear_velocity;
    scdr << m_linear_acceleration;
    scdr << m_angular_velocity;
    scdr << m_rtk_flag;
    scdr << m_coortype;
    scdr << m_odom_type;
    scdr << m_auxiliary_type;
    scdr << m_location_valid_flag;
    scdr << m_origin_lat;
    scdr << m_origin_lon;
    scdr << m_utm_position;
    scdr << m_change_origin_flag;
    scdr << m_utm_position_next;
    scdr << m_position_std_dev;
    scdr << m_orientation_std_dev;
    scdr << m_linear_velocity_std_dev;
    scdr << m_linear_acceleration_std_dev;
    scdr << m_angular_velocity_std_dev;

}

void ros2_interface::msg::Location::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_position;
    dcdr >> m_pitch;
    dcdr >> m_roll;
    dcdr >> m_heading;
    dcdr >> m_linear_velocity;
    dcdr >> m_linear_acceleration;
    dcdr >> m_angular_velocity;
    dcdr >> m_rtk_flag;
    dcdr >> m_coortype;
    dcdr >> m_odom_type;
    dcdr >> m_auxiliary_type;
    dcdr >> m_location_valid_flag;
    dcdr >> m_origin_lat;
    dcdr >> m_origin_lon;
    dcdr >> m_utm_position;
    dcdr >> m_change_origin_flag;
    dcdr >> m_utm_position_next;
    dcdr >> m_position_std_dev;
    dcdr >> m_orientation_std_dev;
    dcdr >> m_linear_velocity_std_dev;
    dcdr >> m_linear_acceleration_std_dev;
    dcdr >> m_angular_velocity_std_dev;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Location::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Location::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Location::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Location::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::Location::position(
        const ros2_interface::msg::PointLLH& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::Location::position(
        ros2_interface::msg::PointLLH&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::PointLLH& ros2_interface::msg::Location::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::PointLLH& ros2_interface::msg::Location::position()
{
    return m_position;
}
/*!
 * @brief This function sets a value in member pitch
 * @param _pitch New value for member pitch
 */
void ros2_interface::msg::Location::pitch(
        double _pitch)
{
    m_pitch = _pitch;
}

/*!
 * @brief This function returns the value of member pitch
 * @return Value of member pitch
 */
double ros2_interface::msg::Location::pitch() const
{
    return m_pitch;
}

/*!
 * @brief This function returns a reference to member pitch
 * @return Reference to member pitch
 */
double& ros2_interface::msg::Location::pitch()
{
    return m_pitch;
}

/*!
 * @brief This function sets a value in member roll
 * @param _roll New value for member roll
 */
void ros2_interface::msg::Location::roll(
        double _roll)
{
    m_roll = _roll;
}

/*!
 * @brief This function returns the value of member roll
 * @return Value of member roll
 */
double ros2_interface::msg::Location::roll() const
{
    return m_roll;
}

/*!
 * @brief This function returns a reference to member roll
 * @return Reference to member roll
 */
double& ros2_interface::msg::Location::roll()
{
    return m_roll;
}

/*!
 * @brief This function sets a value in member heading
 * @param _heading New value for member heading
 */
void ros2_interface::msg::Location::heading(
        double _heading)
{
    m_heading = _heading;
}

/*!
 * @brief This function returns the value of member heading
 * @return Value of member heading
 */
double ros2_interface::msg::Location::heading() const
{
    return m_heading;
}

/*!
 * @brief This function returns a reference to member heading
 * @return Reference to member heading
 */
double& ros2_interface::msg::Location::heading()
{
    return m_heading;
}

/*!
 * @brief This function copies the value in member linear_velocity
 * @param _linear_velocity New value to be copied in member linear_velocity
 */
void ros2_interface::msg::Location::linear_velocity(
        const ros2_interface::msg::Point3D& _linear_velocity)
{
    m_linear_velocity = _linear_velocity;
}

/*!
 * @brief This function moves the value in member linear_velocity
 * @param _linear_velocity New value to be moved in member linear_velocity
 */
void ros2_interface::msg::Location::linear_velocity(
        ros2_interface::msg::Point3D&& _linear_velocity)
{
    m_linear_velocity = std::move(_linear_velocity);
}

/*!
 * @brief This function returns a constant reference to member linear_velocity
 * @return Constant reference to member linear_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_velocity() const
{
    return m_linear_velocity;
}

/*!
 * @brief This function returns a reference to member linear_velocity
 * @return Reference to member linear_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_velocity()
{
    return m_linear_velocity;
}
/*!
 * @brief This function copies the value in member linear_acceleration
 * @param _linear_acceleration New value to be copied in member linear_acceleration
 */
void ros2_interface::msg::Location::linear_acceleration(
        const ros2_interface::msg::Point3D& _linear_acceleration)
{
    m_linear_acceleration = _linear_acceleration;
}

/*!
 * @brief This function moves the value in member linear_acceleration
 * @param _linear_acceleration New value to be moved in member linear_acceleration
 */
void ros2_interface::msg::Location::linear_acceleration(
        ros2_interface::msg::Point3D&& _linear_acceleration)
{
    m_linear_acceleration = std::move(_linear_acceleration);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration
 * @return Constant reference to member linear_acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_acceleration() const
{
    return m_linear_acceleration;
}

/*!
 * @brief This function returns a reference to member linear_acceleration
 * @return Reference to member linear_acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_acceleration()
{
    return m_linear_acceleration;
}
/*!
 * @brief This function copies the value in member angular_velocity
 * @param _angular_velocity New value to be copied in member angular_velocity
 */
void ros2_interface::msg::Location::angular_velocity(
        const ros2_interface::msg::Point3D& _angular_velocity)
{
    m_angular_velocity = _angular_velocity;
}

/*!
 * @brief This function moves the value in member angular_velocity
 * @param _angular_velocity New value to be moved in member angular_velocity
 */
void ros2_interface::msg::Location::angular_velocity(
        ros2_interface::msg::Point3D&& _angular_velocity)
{
    m_angular_velocity = std::move(_angular_velocity);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity
 * @return Constant reference to member angular_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::angular_velocity() const
{
    return m_angular_velocity;
}

/*!
 * @brief This function returns a reference to member angular_velocity
 * @return Reference to member angular_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::angular_velocity()
{
    return m_angular_velocity;
}
/*!
 * @brief This function sets a value in member rtk_flag
 * @param _rtk_flag New value for member rtk_flag
 */
void ros2_interface::msg::Location::rtk_flag(
        int32_t _rtk_flag)
{
    m_rtk_flag = _rtk_flag;
}

/*!
 * @brief This function returns the value of member rtk_flag
 * @return Value of member rtk_flag
 */
int32_t ros2_interface::msg::Location::rtk_flag() const
{
    return m_rtk_flag;
}

/*!
 * @brief This function returns a reference to member rtk_flag
 * @return Reference to member rtk_flag
 */
int32_t& ros2_interface::msg::Location::rtk_flag()
{
    return m_rtk_flag;
}

/*!
 * @brief This function sets a value in member coortype
 * @param _coortype New value for member coortype
 */
void ros2_interface::msg::Location::coortype(
        int32_t _coortype)
{
    m_coortype = _coortype;
}

/*!
 * @brief This function returns the value of member coortype
 * @return Value of member coortype
 */
int32_t ros2_interface::msg::Location::coortype() const
{
    return m_coortype;
}

/*!
 * @brief This function returns a reference to member coortype
 * @return Reference to member coortype
 */
int32_t& ros2_interface::msg::Location::coortype()
{
    return m_coortype;
}

/*!
 * @brief This function sets a value in member odom_type
 * @param _odom_type New value for member odom_type
 */
void ros2_interface::msg::Location::odom_type(
        int32_t _odom_type)
{
    m_odom_type = _odom_type;
}

/*!
 * @brief This function returns the value of member odom_type
 * @return Value of member odom_type
 */
int32_t ros2_interface::msg::Location::odom_type() const
{
    return m_odom_type;
}

/*!
 * @brief This function returns a reference to member odom_type
 * @return Reference to member odom_type
 */
int32_t& ros2_interface::msg::Location::odom_type()
{
    return m_odom_type;
}

/*!
 * @brief This function sets a value in member auxiliary_type
 * @param _auxiliary_type New value for member auxiliary_type
 */
void ros2_interface::msg::Location::auxiliary_type(
        int32_t _auxiliary_type)
{
    m_auxiliary_type = _auxiliary_type;
}

/*!
 * @brief This function returns the value of member auxiliary_type
 * @return Value of member auxiliary_type
 */
int32_t ros2_interface::msg::Location::auxiliary_type() const
{
    return m_auxiliary_type;
}

/*!
 * @brief This function returns a reference to member auxiliary_type
 * @return Reference to member auxiliary_type
 */
int32_t& ros2_interface::msg::Location::auxiliary_type()
{
    return m_auxiliary_type;
}

/*!
 * @brief This function sets a value in member location_valid_flag
 * @param _location_valid_flag New value for member location_valid_flag
 */
void ros2_interface::msg::Location::location_valid_flag(
        int32_t _location_valid_flag)
{
    m_location_valid_flag = _location_valid_flag;
}

/*!
 * @brief This function returns the value of member location_valid_flag
 * @return Value of member location_valid_flag
 */
int32_t ros2_interface::msg::Location::location_valid_flag() const
{
    return m_location_valid_flag;
}

/*!
 * @brief This function returns a reference to member location_valid_flag
 * @return Reference to member location_valid_flag
 */
int32_t& ros2_interface::msg::Location::location_valid_flag()
{
    return m_location_valid_flag;
}

/*!
 * @brief This function sets a value in member origin_lat
 * @param _origin_lat New value for member origin_lat
 */
void ros2_interface::msg::Location::origin_lat(
        double _origin_lat)
{
    m_origin_lat = _origin_lat;
}

/*!
 * @brief This function returns the value of member origin_lat
 * @return Value of member origin_lat
 */
double ros2_interface::msg::Location::origin_lat() const
{
    return m_origin_lat;
}

/*!
 * @brief This function returns a reference to member origin_lat
 * @return Reference to member origin_lat
 */
double& ros2_interface::msg::Location::origin_lat()
{
    return m_origin_lat;
}

/*!
 * @brief This function sets a value in member origin_lon
 * @param _origin_lon New value for member origin_lon
 */
void ros2_interface::msg::Location::origin_lon(
        double _origin_lon)
{
    m_origin_lon = _origin_lon;
}

/*!
 * @brief This function returns the value of member origin_lon
 * @return Value of member origin_lon
 */
double ros2_interface::msg::Location::origin_lon() const
{
    return m_origin_lon;
}

/*!
 * @brief This function returns a reference to member origin_lon
 * @return Reference to member origin_lon
 */
double& ros2_interface::msg::Location::origin_lon()
{
    return m_origin_lon;
}

/*!
 * @brief This function copies the value in member utm_position
 * @param _utm_position New value to be copied in member utm_position
 */
void ros2_interface::msg::Location::utm_position(
        const ros2_interface::msg::PointENU& _utm_position)
{
    m_utm_position = _utm_position;
}

/*!
 * @brief This function moves the value in member utm_position
 * @param _utm_position New value to be moved in member utm_position
 */
void ros2_interface::msg::Location::utm_position(
        ros2_interface::msg::PointENU&& _utm_position)
{
    m_utm_position = std::move(_utm_position);
}

/*!
 * @brief This function returns a constant reference to member utm_position
 * @return Constant reference to member utm_position
 */
const ros2_interface::msg::PointENU& ros2_interface::msg::Location::utm_position() const
{
    return m_utm_position;
}

/*!
 * @brief This function returns a reference to member utm_position
 * @return Reference to member utm_position
 */
ros2_interface::msg::PointENU& ros2_interface::msg::Location::utm_position()
{
    return m_utm_position;
}
/*!
 * @brief This function sets a value in member change_origin_flag
 * @param _change_origin_flag New value for member change_origin_flag
 */
void ros2_interface::msg::Location::change_origin_flag(
        int32_t _change_origin_flag)
{
    m_change_origin_flag = _change_origin_flag;
}

/*!
 * @brief This function returns the value of member change_origin_flag
 * @return Value of member change_origin_flag
 */
int32_t ros2_interface::msg::Location::change_origin_flag() const
{
    return m_change_origin_flag;
}

/*!
 * @brief This function returns a reference to member change_origin_flag
 * @return Reference to member change_origin_flag
 */
int32_t& ros2_interface::msg::Location::change_origin_flag()
{
    return m_change_origin_flag;
}

/*!
 * @brief This function copies the value in member utm_position_next
 * @param _utm_position_next New value to be copied in member utm_position_next
 */
void ros2_interface::msg::Location::utm_position_next(
        const ros2_interface::msg::PointENU& _utm_position_next)
{
    m_utm_position_next = _utm_position_next;
}

/*!
 * @brief This function moves the value in member utm_position_next
 * @param _utm_position_next New value to be moved in member utm_position_next
 */
void ros2_interface::msg::Location::utm_position_next(
        ros2_interface::msg::PointENU&& _utm_position_next)
{
    m_utm_position_next = std::move(_utm_position_next);
}

/*!
 * @brief This function returns a constant reference to member utm_position_next
 * @return Constant reference to member utm_position_next
 */
const ros2_interface::msg::PointENU& ros2_interface::msg::Location::utm_position_next() const
{
    return m_utm_position_next;
}

/*!
 * @brief This function returns a reference to member utm_position_next
 * @return Reference to member utm_position_next
 */
ros2_interface::msg::PointENU& ros2_interface::msg::Location::utm_position_next()
{
    return m_utm_position_next;
}
/*!
 * @brief This function copies the value in member position_std_dev
 * @param _position_std_dev New value to be copied in member position_std_dev
 */
void ros2_interface::msg::Location::position_std_dev(
        const ros2_interface::msg::Point3D& _position_std_dev)
{
    m_position_std_dev = _position_std_dev;
}

/*!
 * @brief This function moves the value in member position_std_dev
 * @param _position_std_dev New value to be moved in member position_std_dev
 */
void ros2_interface::msg::Location::position_std_dev(
        ros2_interface::msg::Point3D&& _position_std_dev)
{
    m_position_std_dev = std::move(_position_std_dev);
}

/*!
 * @brief This function returns a constant reference to member position_std_dev
 * @return Constant reference to member position_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::position_std_dev() const
{
    return m_position_std_dev;
}

/*!
 * @brief This function returns a reference to member position_std_dev
 * @return Reference to member position_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::position_std_dev()
{
    return m_position_std_dev;
}
/*!
 * @brief This function copies the value in member orientation_std_dev
 * @param _orientation_std_dev New value to be copied in member orientation_std_dev
 */
void ros2_interface::msg::Location::orientation_std_dev(
        const ros2_interface::msg::Point3D& _orientation_std_dev)
{
    m_orientation_std_dev = _orientation_std_dev;
}

/*!
 * @brief This function moves the value in member orientation_std_dev
 * @param _orientation_std_dev New value to be moved in member orientation_std_dev
 */
void ros2_interface::msg::Location::orientation_std_dev(
        ros2_interface::msg::Point3D&& _orientation_std_dev)
{
    m_orientation_std_dev = std::move(_orientation_std_dev);
}

/*!
 * @brief This function returns a constant reference to member orientation_std_dev
 * @return Constant reference to member orientation_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::orientation_std_dev() const
{
    return m_orientation_std_dev;
}

/*!
 * @brief This function returns a reference to member orientation_std_dev
 * @return Reference to member orientation_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::orientation_std_dev()
{
    return m_orientation_std_dev;
}
/*!
 * @brief This function copies the value in member linear_velocity_std_dev
 * @param _linear_velocity_std_dev New value to be copied in member linear_velocity_std_dev
 */
void ros2_interface::msg::Location::linear_velocity_std_dev(
        const ros2_interface::msg::Point3D& _linear_velocity_std_dev)
{
    m_linear_velocity_std_dev = _linear_velocity_std_dev;
}

/*!
 * @brief This function moves the value in member linear_velocity_std_dev
 * @param _linear_velocity_std_dev New value to be moved in member linear_velocity_std_dev
 */
void ros2_interface::msg::Location::linear_velocity_std_dev(
        ros2_interface::msg::Point3D&& _linear_velocity_std_dev)
{
    m_linear_velocity_std_dev = std::move(_linear_velocity_std_dev);
}

/*!
 * @brief This function returns a constant reference to member linear_velocity_std_dev
 * @return Constant reference to member linear_velocity_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_velocity_std_dev() const
{
    return m_linear_velocity_std_dev;
}

/*!
 * @brief This function returns a reference to member linear_velocity_std_dev
 * @return Reference to member linear_velocity_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_velocity_std_dev()
{
    return m_linear_velocity_std_dev;
}
/*!
 * @brief This function copies the value in member linear_acceleration_std_dev
 * @param _linear_acceleration_std_dev New value to be copied in member linear_acceleration_std_dev
 */
void ros2_interface::msg::Location::linear_acceleration_std_dev(
        const ros2_interface::msg::Point3D& _linear_acceleration_std_dev)
{
    m_linear_acceleration_std_dev = _linear_acceleration_std_dev;
}

/*!
 * @brief This function moves the value in member linear_acceleration_std_dev
 * @param _linear_acceleration_std_dev New value to be moved in member linear_acceleration_std_dev
 */
void ros2_interface::msg::Location::linear_acceleration_std_dev(
        ros2_interface::msg::Point3D&& _linear_acceleration_std_dev)
{
    m_linear_acceleration_std_dev = std::move(_linear_acceleration_std_dev);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration_std_dev
 * @return Constant reference to member linear_acceleration_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_acceleration_std_dev() const
{
    return m_linear_acceleration_std_dev;
}

/*!
 * @brief This function returns a reference to member linear_acceleration_std_dev
 * @return Reference to member linear_acceleration_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::linear_acceleration_std_dev()
{
    return m_linear_acceleration_std_dev;
}
/*!
 * @brief This function copies the value in member angular_velocity_std_dev
 * @param _angular_velocity_std_dev New value to be copied in member angular_velocity_std_dev
 */
void ros2_interface::msg::Location::angular_velocity_std_dev(
        const ros2_interface::msg::Point3D& _angular_velocity_std_dev)
{
    m_angular_velocity_std_dev = _angular_velocity_std_dev;
}

/*!
 * @brief This function moves the value in member angular_velocity_std_dev
 * @param _angular_velocity_std_dev New value to be moved in member angular_velocity_std_dev
 */
void ros2_interface::msg::Location::angular_velocity_std_dev(
        ros2_interface::msg::Point3D&& _angular_velocity_std_dev)
{
    m_angular_velocity_std_dev = std::move(_angular_velocity_std_dev);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity_std_dev
 * @return Constant reference to member angular_velocity_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Location::angular_velocity_std_dev() const
{
    return m_angular_velocity_std_dev;
}

/*!
 * @brief This function returns a reference to member angular_velocity_std_dev
 * @return Reference to member angular_velocity_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Location::angular_velocity_std_dev()
{
    return m_angular_velocity_std_dev;
}


size_t ros2_interface::msg::Location::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Location_max_key_cdr_typesize;
}

bool ros2_interface::msg::Location::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Location::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



