// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Location.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LOCATION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LOCATION_H_

#include "Header.h"
#include "Point3D.h"
#include "PointLLH.h"
#include "PointENU.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(LOCATION_SOURCE)
#define LOCATION_DllAPI __declspec( dllexport )
#else
#define LOCATION_DllAPI __declspec( dllimport )
#endif // LOCATION_SOURCE
#else
#define LOCATION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define LOCATION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Location defined by the user in the IDL file.
         * @ingroup Location
         */
        class Location
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Location();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Location();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Location that will be copied.
             */
            eProsima_user_DllExport Location(
                    const Location& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Location that will be copied.
             */
            eProsima_user_DllExport Location(
                    Location&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Location that will be copied.
             */
            eProsima_user_DllExport Location& operator =(
                    const Location& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Location that will be copied.
             */
            eProsima_user_DllExport Location& operator =(
                    Location&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Location object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Location& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Location object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Location& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::PointLLH& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::PointLLH&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::PointLLH& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::PointLLH& position();
            /*!
             * @brief This function sets a value in member pitch
             * @param _pitch New value for member pitch
             */
            eProsima_user_DllExport void pitch(
                    double _pitch);

            /*!
             * @brief This function returns the value of member pitch
             * @return Value of member pitch
             */
            eProsima_user_DllExport double pitch() const;

            /*!
             * @brief This function returns a reference to member pitch
             * @return Reference to member pitch
             */
            eProsima_user_DllExport double& pitch();

            /*!
             * @brief This function sets a value in member roll
             * @param _roll New value for member roll
             */
            eProsima_user_DllExport void roll(
                    double _roll);

            /*!
             * @brief This function returns the value of member roll
             * @return Value of member roll
             */
            eProsima_user_DllExport double roll() const;

            /*!
             * @brief This function returns a reference to member roll
             * @return Reference to member roll
             */
            eProsima_user_DllExport double& roll();

            /*!
             * @brief This function sets a value in member heading
             * @param _heading New value for member heading
             */
            eProsima_user_DllExport void heading(
                    double _heading);

            /*!
             * @brief This function returns the value of member heading
             * @return Value of member heading
             */
            eProsima_user_DllExport double heading() const;

            /*!
             * @brief This function returns a reference to member heading
             * @return Reference to member heading
             */
            eProsima_user_DllExport double& heading();

            /*!
             * @brief This function copies the value in member linear_velocity
             * @param _linear_velocity New value to be copied in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    const ros2_interface::msg::Point3D& _linear_velocity);

            /*!
             * @brief This function moves the value in member linear_velocity
             * @param _linear_velocity New value to be moved in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    ros2_interface::msg::Point3D&& _linear_velocity);

            /*!
             * @brief This function returns a constant reference to member linear_velocity
             * @return Constant reference to member linear_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_velocity() const;

            /*!
             * @brief This function returns a reference to member linear_velocity
             * @return Reference to member linear_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_velocity();
            /*!
             * @brief This function copies the value in member linear_acceleration
             * @param _linear_acceleration New value to be copied in member linear_acceleration
             */
            eProsima_user_DllExport void linear_acceleration(
                    const ros2_interface::msg::Point3D& _linear_acceleration);

            /*!
             * @brief This function moves the value in member linear_acceleration
             * @param _linear_acceleration New value to be moved in member linear_acceleration
             */
            eProsima_user_DllExport void linear_acceleration(
                    ros2_interface::msg::Point3D&& _linear_acceleration);

            /*!
             * @brief This function returns a constant reference to member linear_acceleration
             * @return Constant reference to member linear_acceleration
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_acceleration() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration
             * @return Reference to member linear_acceleration
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_acceleration();
            /*!
             * @brief This function copies the value in member angular_velocity
             * @param _angular_velocity New value to be copied in member angular_velocity
             */
            eProsima_user_DllExport void angular_velocity(
                    const ros2_interface::msg::Point3D& _angular_velocity);

            /*!
             * @brief This function moves the value in member angular_velocity
             * @param _angular_velocity New value to be moved in member angular_velocity
             */
            eProsima_user_DllExport void angular_velocity(
                    ros2_interface::msg::Point3D&& _angular_velocity);

            /*!
             * @brief This function returns a constant reference to member angular_velocity
             * @return Constant reference to member angular_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular_velocity() const;

            /*!
             * @brief This function returns a reference to member angular_velocity
             * @return Reference to member angular_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular_velocity();
            /*!
             * @brief This function sets a value in member rtk_flag
             * @param _rtk_flag New value for member rtk_flag
             */
            eProsima_user_DllExport void rtk_flag(
                    int32_t _rtk_flag);

            /*!
             * @brief This function returns the value of member rtk_flag
             * @return Value of member rtk_flag
             */
            eProsima_user_DllExport int32_t rtk_flag() const;

            /*!
             * @brief This function returns a reference to member rtk_flag
             * @return Reference to member rtk_flag
             */
            eProsima_user_DllExport int32_t& rtk_flag();

            /*!
             * @brief This function sets a value in member coortype
             * @param _coortype New value for member coortype
             */
            eProsima_user_DllExport void coortype(
                    int32_t _coortype);

            /*!
             * @brief This function returns the value of member coortype
             * @return Value of member coortype
             */
            eProsima_user_DllExport int32_t coortype() const;

            /*!
             * @brief This function returns a reference to member coortype
             * @return Reference to member coortype
             */
            eProsima_user_DllExport int32_t& coortype();

            /*!
             * @brief This function sets a value in member odom_type
             * @param _odom_type New value for member odom_type
             */
            eProsima_user_DllExport void odom_type(
                    int32_t _odom_type);

            /*!
             * @brief This function returns the value of member odom_type
             * @return Value of member odom_type
             */
            eProsima_user_DllExport int32_t odom_type() const;

            /*!
             * @brief This function returns a reference to member odom_type
             * @return Reference to member odom_type
             */
            eProsima_user_DllExport int32_t& odom_type();

            /*!
             * @brief This function sets a value in member auxiliary_type
             * @param _auxiliary_type New value for member auxiliary_type
             */
            eProsima_user_DllExport void auxiliary_type(
                    int32_t _auxiliary_type);

            /*!
             * @brief This function returns the value of member auxiliary_type
             * @return Value of member auxiliary_type
             */
            eProsima_user_DllExport int32_t auxiliary_type() const;

            /*!
             * @brief This function returns a reference to member auxiliary_type
             * @return Reference to member auxiliary_type
             */
            eProsima_user_DllExport int32_t& auxiliary_type();

            /*!
             * @brief This function sets a value in member location_valid_flag
             * @param _location_valid_flag New value for member location_valid_flag
             */
            eProsima_user_DllExport void location_valid_flag(
                    int32_t _location_valid_flag);

            /*!
             * @brief This function returns the value of member location_valid_flag
             * @return Value of member location_valid_flag
             */
            eProsima_user_DllExport int32_t location_valid_flag() const;

            /*!
             * @brief This function returns a reference to member location_valid_flag
             * @return Reference to member location_valid_flag
             */
            eProsima_user_DllExport int32_t& location_valid_flag();

            /*!
             * @brief This function sets a value in member origin_lat
             * @param _origin_lat New value for member origin_lat
             */
            eProsima_user_DllExport void origin_lat(
                    double _origin_lat);

            /*!
             * @brief This function returns the value of member origin_lat
             * @return Value of member origin_lat
             */
            eProsima_user_DllExport double origin_lat() const;

            /*!
             * @brief This function returns a reference to member origin_lat
             * @return Reference to member origin_lat
             */
            eProsima_user_DllExport double& origin_lat();

            /*!
             * @brief This function sets a value in member origin_lon
             * @param _origin_lon New value for member origin_lon
             */
            eProsima_user_DllExport void origin_lon(
                    double _origin_lon);

            /*!
             * @brief This function returns the value of member origin_lon
             * @return Value of member origin_lon
             */
            eProsima_user_DllExport double origin_lon() const;

            /*!
             * @brief This function returns a reference to member origin_lon
             * @return Reference to member origin_lon
             */
            eProsima_user_DllExport double& origin_lon();

            /*!
             * @brief This function copies the value in member utm_position
             * @param _utm_position New value to be copied in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    const ros2_interface::msg::PointENU& _utm_position);

            /*!
             * @brief This function moves the value in member utm_position
             * @param _utm_position New value to be moved in member utm_position
             */
            eProsima_user_DllExport void utm_position(
                    ros2_interface::msg::PointENU&& _utm_position);

            /*!
             * @brief This function returns a constant reference to member utm_position
             * @return Constant reference to member utm_position
             */
            eProsima_user_DllExport const ros2_interface::msg::PointENU& utm_position() const;

            /*!
             * @brief This function returns a reference to member utm_position
             * @return Reference to member utm_position
             */
            eProsima_user_DllExport ros2_interface::msg::PointENU& utm_position();
            /*!
             * @brief This function sets a value in member change_origin_flag
             * @param _change_origin_flag New value for member change_origin_flag
             */
            eProsima_user_DllExport void change_origin_flag(
                    int32_t _change_origin_flag);

            /*!
             * @brief This function returns the value of member change_origin_flag
             * @return Value of member change_origin_flag
             */
            eProsima_user_DllExport int32_t change_origin_flag() const;

            /*!
             * @brief This function returns a reference to member change_origin_flag
             * @return Reference to member change_origin_flag
             */
            eProsima_user_DllExport int32_t& change_origin_flag();

            /*!
             * @brief This function copies the value in member utm_position_next
             * @param _utm_position_next New value to be copied in member utm_position_next
             */
            eProsima_user_DllExport void utm_position_next(
                    const ros2_interface::msg::PointENU& _utm_position_next);

            /*!
             * @brief This function moves the value in member utm_position_next
             * @param _utm_position_next New value to be moved in member utm_position_next
             */
            eProsima_user_DllExport void utm_position_next(
                    ros2_interface::msg::PointENU&& _utm_position_next);

            /*!
             * @brief This function returns a constant reference to member utm_position_next
             * @return Constant reference to member utm_position_next
             */
            eProsima_user_DllExport const ros2_interface::msg::PointENU& utm_position_next() const;

            /*!
             * @brief This function returns a reference to member utm_position_next
             * @return Reference to member utm_position_next
             */
            eProsima_user_DllExport ros2_interface::msg::PointENU& utm_position_next();
            /*!
             * @brief This function copies the value in member position_std_dev
             * @param _position_std_dev New value to be copied in member position_std_dev
             */
            eProsima_user_DllExport void position_std_dev(
                    const ros2_interface::msg::Point3D& _position_std_dev);

            /*!
             * @brief This function moves the value in member position_std_dev
             * @param _position_std_dev New value to be moved in member position_std_dev
             */
            eProsima_user_DllExport void position_std_dev(
                    ros2_interface::msg::Point3D&& _position_std_dev);

            /*!
             * @brief This function returns a constant reference to member position_std_dev
             * @return Constant reference to member position_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& position_std_dev() const;

            /*!
             * @brief This function returns a reference to member position_std_dev
             * @return Reference to member position_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& position_std_dev();
            /*!
             * @brief This function copies the value in member orientation_std_dev
             * @param _orientation_std_dev New value to be copied in member orientation_std_dev
             */
            eProsima_user_DllExport void orientation_std_dev(
                    const ros2_interface::msg::Point3D& _orientation_std_dev);

            /*!
             * @brief This function moves the value in member orientation_std_dev
             * @param _orientation_std_dev New value to be moved in member orientation_std_dev
             */
            eProsima_user_DllExport void orientation_std_dev(
                    ros2_interface::msg::Point3D&& _orientation_std_dev);

            /*!
             * @brief This function returns a constant reference to member orientation_std_dev
             * @return Constant reference to member orientation_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& orientation_std_dev() const;

            /*!
             * @brief This function returns a reference to member orientation_std_dev
             * @return Reference to member orientation_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& orientation_std_dev();
            /*!
             * @brief This function copies the value in member linear_velocity_std_dev
             * @param _linear_velocity_std_dev New value to be copied in member linear_velocity_std_dev
             */
            eProsima_user_DllExport void linear_velocity_std_dev(
                    const ros2_interface::msg::Point3D& _linear_velocity_std_dev);

            /*!
             * @brief This function moves the value in member linear_velocity_std_dev
             * @param _linear_velocity_std_dev New value to be moved in member linear_velocity_std_dev
             */
            eProsima_user_DllExport void linear_velocity_std_dev(
                    ros2_interface::msg::Point3D&& _linear_velocity_std_dev);

            /*!
             * @brief This function returns a constant reference to member linear_velocity_std_dev
             * @return Constant reference to member linear_velocity_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_velocity_std_dev() const;

            /*!
             * @brief This function returns a reference to member linear_velocity_std_dev
             * @return Reference to member linear_velocity_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_velocity_std_dev();
            /*!
             * @brief This function copies the value in member linear_acceleration_std_dev
             * @param _linear_acceleration_std_dev New value to be copied in member linear_acceleration_std_dev
             */
            eProsima_user_DllExport void linear_acceleration_std_dev(
                    const ros2_interface::msg::Point3D& _linear_acceleration_std_dev);

            /*!
             * @brief This function moves the value in member linear_acceleration_std_dev
             * @param _linear_acceleration_std_dev New value to be moved in member linear_acceleration_std_dev
             */
            eProsima_user_DllExport void linear_acceleration_std_dev(
                    ros2_interface::msg::Point3D&& _linear_acceleration_std_dev);

            /*!
             * @brief This function returns a constant reference to member linear_acceleration_std_dev
             * @return Constant reference to member linear_acceleration_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_acceleration_std_dev() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration_std_dev
             * @return Reference to member linear_acceleration_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_acceleration_std_dev();
            /*!
             * @brief This function copies the value in member angular_velocity_std_dev
             * @param _angular_velocity_std_dev New value to be copied in member angular_velocity_std_dev
             */
            eProsima_user_DllExport void angular_velocity_std_dev(
                    const ros2_interface::msg::Point3D& _angular_velocity_std_dev);

            /*!
             * @brief This function moves the value in member angular_velocity_std_dev
             * @param _angular_velocity_std_dev New value to be moved in member angular_velocity_std_dev
             */
            eProsima_user_DllExport void angular_velocity_std_dev(
                    ros2_interface::msg::Point3D&& _angular_velocity_std_dev);

            /*!
             * @brief This function returns a constant reference to member angular_velocity_std_dev
             * @return Constant reference to member angular_velocity_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular_velocity_std_dev() const;

            /*!
             * @brief This function returns a reference to member angular_velocity_std_dev
             * @return Reference to member angular_velocity_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular_velocity_std_dev();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Location& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            ros2_interface::msg::PointLLH m_position;
            double m_pitch;
            double m_roll;
            double m_heading;
            ros2_interface::msg::Point3D m_linear_velocity;
            ros2_interface::msg::Point3D m_linear_acceleration;
            ros2_interface::msg::Point3D m_angular_velocity;
            int32_t m_rtk_flag;
            int32_t m_coortype;
            int32_t m_odom_type;
            int32_t m_auxiliary_type;
            int32_t m_location_valid_flag;
            double m_origin_lat;
            double m_origin_lon;
            ros2_interface::msg::PointENU m_utm_position;
            int32_t m_change_origin_flag;
            ros2_interface::msg::PointENU m_utm_position_next;
            ros2_interface::msg::Point3D m_position_std_dev;
            ros2_interface::msg::Point3D m_orientation_std_dev;
            ros2_interface::msg::Point3D m_linear_velocity_std_dev;
            ros2_interface::msg::Point3D m_linear_acceleration_std_dev;
            ros2_interface::msg::Point3D m_angular_velocity_std_dev;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_LOCATION_H_

