// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LocationTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Location.h"
#include "LocationTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLocationTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(true),
                        ros2_interface::msg::GetPointLLHObject(true));
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(false),
                        ros2_interface::msg::GetPointLLHObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(true),
                        ros2_interface::msg::GetPointENUObject(true));
                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(false),
                        ros2_interface::msg::GetPointENUObject(false));



                factory->add_type_object("ros2_interface::msg::Location", ros2_interface::msg::GetLocationIdentifier(true),
                        ros2_interface::msg::GetLocationObject(true));
                factory->add_type_object("ros2_interface::msg::Location", ros2_interface::msg::GetLocationIdentifier(false),
                        ros2_interface::msg::GetLocationObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLocationIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Location", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLocationObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Location", complete);
        }

        const TypeObject* GetLocationObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Location", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLocationObject();
            }
            //else
            return GetMinimalLocationObject();
        }

        const TypeObject* GetMinimalLocationObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Location", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPointLLHIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_pitch;
            mst_pitch.common().member_id(memberId++);
            mst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pitch.common().member_flags().IS_OPTIONAL(false);
            mst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pitch.common().member_flags().IS_KEY(false);
            mst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 pitch_hash("pitch");
            for(int i = 0; i < 4; ++i)
            {
                mst_pitch.detail().name_hash()[i] = pitch_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pitch);

            MinimalStructMember mst_roll;
            mst_roll.common().member_id(memberId++);
            mst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_roll.common().member_flags().IS_OPTIONAL(false);
            mst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_roll.common().member_flags().IS_KEY(false);
            mst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 roll_hash("roll");
            for(int i = 0; i < 4; ++i)
            {
                mst_roll.detail().name_hash()[i] = roll_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_roll);

            MinimalStructMember mst_heading;
            mst_heading.common().member_id(memberId++);
            mst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading.common().member_flags().IS_OPTIONAL(false);
            mst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading.common().member_flags().IS_KEY(false);
            mst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_hash("heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading.detail().name_hash()[i] = heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading);

            MinimalStructMember mst_linear_velocity;
            mst_linear_velocity.common().member_id(memberId++);
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity.common().member_flags().IS_KEY(false);
            mst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_velocity_hash("linear_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity.detail().name_hash()[i] = linear_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity);

            MinimalStructMember mst_linear_acceleration;
            mst_linear_acceleration.common().member_id(memberId++);
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration.common().member_flags().IS_KEY(false);
            mst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_hash("linear_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration.detail().name_hash()[i] = linear_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration);

            MinimalStructMember mst_angular_velocity;
            mst_angular_velocity.common().member_id(memberId++);
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity.common().member_flags().IS_KEY(false);
            mst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_hash("angular_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity.detail().name_hash()[i] = angular_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity);

            MinimalStructMember mst_rtk_flag;
            mst_rtk_flag.common().member_id(memberId++);
            mst_rtk_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rtk_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rtk_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rtk_flag.common().member_flags().IS_OPTIONAL(false);
            mst_rtk_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rtk_flag.common().member_flags().IS_KEY(false);
            mst_rtk_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rtk_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rtk_flag_hash("rtk_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_rtk_flag.detail().name_hash()[i] = rtk_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rtk_flag);

            MinimalStructMember mst_coortype;
            mst_coortype.common().member_id(memberId++);
            mst_coortype.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_coortype.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_coortype.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_coortype.common().member_flags().IS_OPTIONAL(false);
            mst_coortype.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_coortype.common().member_flags().IS_KEY(false);
            mst_coortype.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_coortype.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 coortype_hash("coortype");
            for(int i = 0; i < 4; ++i)
            {
                mst_coortype.detail().name_hash()[i] = coortype_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_coortype);

            MinimalStructMember mst_odom_type;
            mst_odom_type.common().member_id(memberId++);
            mst_odom_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_odom_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_odom_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_odom_type.common().member_flags().IS_OPTIONAL(false);
            mst_odom_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_odom_type.common().member_flags().IS_KEY(false);
            mst_odom_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_odom_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 odom_type_hash("odom_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_odom_type.detail().name_hash()[i] = odom_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_odom_type);

            MinimalStructMember mst_auxiliary_type;
            mst_auxiliary_type.common().member_id(memberId++);
            mst_auxiliary_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_auxiliary_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_auxiliary_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_auxiliary_type.common().member_flags().IS_OPTIONAL(false);
            mst_auxiliary_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_auxiliary_type.common().member_flags().IS_KEY(false);
            mst_auxiliary_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_auxiliary_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 auxiliary_type_hash("auxiliary_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_auxiliary_type.detail().name_hash()[i] = auxiliary_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_auxiliary_type);

            MinimalStructMember mst_location_valid_flag;
            mst_location_valid_flag.common().member_id(memberId++);
            mst_location_valid_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_location_valid_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_location_valid_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_location_valid_flag.common().member_flags().IS_OPTIONAL(false);
            mst_location_valid_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_location_valid_flag.common().member_flags().IS_KEY(false);
            mst_location_valid_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_location_valid_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 location_valid_flag_hash("location_valid_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_location_valid_flag.detail().name_hash()[i] = location_valid_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_location_valid_flag);

            MinimalStructMember mst_origin_lat;
            mst_origin_lat.common().member_id(memberId++);
            mst_origin_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_origin_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_origin_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_origin_lat.common().member_flags().IS_OPTIONAL(false);
            mst_origin_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_origin_lat.common().member_flags().IS_KEY(false);
            mst_origin_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_origin_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 origin_lat_hash("origin_lat");
            for(int i = 0; i < 4; ++i)
            {
                mst_origin_lat.detail().name_hash()[i] = origin_lat_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_origin_lat);

            MinimalStructMember mst_origin_lon;
            mst_origin_lon.common().member_id(memberId++);
            mst_origin_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_origin_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_origin_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_origin_lon.common().member_flags().IS_OPTIONAL(false);
            mst_origin_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_origin_lon.common().member_flags().IS_KEY(false);
            mst_origin_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_origin_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 origin_lon_hash("origin_lon");
            for(int i = 0; i < 4; ++i)
            {
                mst_origin_lon.detail().name_hash()[i] = origin_lon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_origin_lon);

            MinimalStructMember mst_utm_position;
            mst_utm_position.common().member_id(memberId++);
            mst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_position.common().member_flags().IS_OPTIONAL(false);
            mst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_position.common().member_flags().IS_KEY(false);
            mst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(false));
            MD5 utm_position_hash("utm_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_position.detail().name_hash()[i] = utm_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_position);

            MinimalStructMember mst_change_origin_flag;
            mst_change_origin_flag.common().member_id(memberId++);
            mst_change_origin_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_change_origin_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_change_origin_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_change_origin_flag.common().member_flags().IS_OPTIONAL(false);
            mst_change_origin_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_change_origin_flag.common().member_flags().IS_KEY(false);
            mst_change_origin_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_change_origin_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 change_origin_flag_hash("change_origin_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_change_origin_flag.detail().name_hash()[i] = change_origin_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_change_origin_flag);

            MinimalStructMember mst_utm_position_next;
            mst_utm_position_next.common().member_id(memberId++);
            mst_utm_position_next.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_utm_position_next.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_utm_position_next.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_utm_position_next.common().member_flags().IS_OPTIONAL(false);
            mst_utm_position_next.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_utm_position_next.common().member_flags().IS_KEY(false);
            mst_utm_position_next.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_utm_position_next.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(false));
            MD5 utm_position_next_hash("utm_position_next");
            for(int i = 0; i < 4; ++i)
            {
                mst_utm_position_next.detail().name_hash()[i] = utm_position_next_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_utm_position_next);

            MinimalStructMember mst_position_std_dev;
            mst_position_std_dev.common().member_id(memberId++);
            mst_position_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_position_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_std_dev.common().member_flags().IS_KEY(false);
            mst_position_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 position_std_dev_hash("position_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_std_dev.detail().name_hash()[i] = position_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_std_dev);

            MinimalStructMember mst_orientation_std_dev;
            mst_orientation_std_dev.common().member_id(memberId++);
            mst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_orientation_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_orientation_std_dev.common().member_flags().IS_KEY(false);
            mst_orientation_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_orientation_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 orientation_std_dev_hash("orientation_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_orientation_std_dev.detail().name_hash()[i] = orientation_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_orientation_std_dev);

            MinimalStructMember mst_linear_velocity_std_dev;
            mst_linear_velocity_std_dev.common().member_id(memberId++);
            mst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_KEY(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_velocity_std_dev_hash("linear_velocity_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity_std_dev.detail().name_hash()[i] = linear_velocity_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity_std_dev);

            MinimalStructMember mst_linear_acceleration_std_dev;
            mst_linear_acceleration_std_dev.common().member_id(memberId++);
            mst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_KEY(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_std_dev_hash("linear_acceleration_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration_std_dev.detail().name_hash()[i] = linear_acceleration_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration_std_dev);

            MinimalStructMember mst_angular_velocity_std_dev;
            mst_angular_velocity_std_dev.common().member_id(memberId++);
            mst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_KEY(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_std_dev_hash("angular_velocity_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity_std_dev.detail().name_hash()[i] = angular_velocity_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity_std_dev);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Location", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Location", false);
        }

        const TypeObject* GetCompleteLocationObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Location", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPointLLHIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_pitch;
            cst_pitch.common().member_id(memberId++);
            cst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pitch.common().member_flags().IS_OPTIONAL(false);
            cst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pitch.common().member_flags().IS_KEY(false);
            cst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_pitch.detail().name("pitch");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pitch);

            CompleteStructMember cst_roll;
            cst_roll.common().member_id(memberId++);
            cst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_roll.common().member_flags().IS_OPTIONAL(false);
            cst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_roll.common().member_flags().IS_KEY(false);
            cst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_roll.detail().name("roll");

            type_object->complete().struct_type().member_seq().emplace_back(cst_roll);

            CompleteStructMember cst_heading;
            cst_heading.common().member_id(memberId++);
            cst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading.common().member_flags().IS_OPTIONAL(false);
            cst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading.common().member_flags().IS_KEY(false);
            cst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading.detail().name("heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading);

            CompleteStructMember cst_linear_velocity;
            cst_linear_velocity.common().member_id(memberId++);
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity.common().member_flags().IS_KEY(false);
            cst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_velocity.detail().name("linear_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity);

            CompleteStructMember cst_linear_acceleration;
            cst_linear_acceleration.common().member_id(memberId++);
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration.common().member_flags().IS_KEY(false);
            cst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration.detail().name("linear_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration);

            CompleteStructMember cst_angular_velocity;
            cst_angular_velocity.common().member_id(memberId++);
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity.common().member_flags().IS_KEY(false);
            cst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity.detail().name("angular_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity);

            CompleteStructMember cst_rtk_flag;
            cst_rtk_flag.common().member_id(memberId++);
            cst_rtk_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rtk_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rtk_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rtk_flag.common().member_flags().IS_OPTIONAL(false);
            cst_rtk_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rtk_flag.common().member_flags().IS_KEY(false);
            cst_rtk_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rtk_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rtk_flag.detail().name("rtk_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rtk_flag);

            CompleteStructMember cst_coortype;
            cst_coortype.common().member_id(memberId++);
            cst_coortype.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_coortype.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_coortype.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_coortype.common().member_flags().IS_OPTIONAL(false);
            cst_coortype.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_coortype.common().member_flags().IS_KEY(false);
            cst_coortype.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_coortype.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_coortype.detail().name("coortype");

            type_object->complete().struct_type().member_seq().emplace_back(cst_coortype);

            CompleteStructMember cst_odom_type;
            cst_odom_type.common().member_id(memberId++);
            cst_odom_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_odom_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_odom_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_odom_type.common().member_flags().IS_OPTIONAL(false);
            cst_odom_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_odom_type.common().member_flags().IS_KEY(false);
            cst_odom_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_odom_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_odom_type.detail().name("odom_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_odom_type);

            CompleteStructMember cst_auxiliary_type;
            cst_auxiliary_type.common().member_id(memberId++);
            cst_auxiliary_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_auxiliary_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_auxiliary_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_auxiliary_type.common().member_flags().IS_OPTIONAL(false);
            cst_auxiliary_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_auxiliary_type.common().member_flags().IS_KEY(false);
            cst_auxiliary_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_auxiliary_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_auxiliary_type.detail().name("auxiliary_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_auxiliary_type);

            CompleteStructMember cst_location_valid_flag;
            cst_location_valid_flag.common().member_id(memberId++);
            cst_location_valid_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_location_valid_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_location_valid_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_location_valid_flag.common().member_flags().IS_OPTIONAL(false);
            cst_location_valid_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_location_valid_flag.common().member_flags().IS_KEY(false);
            cst_location_valid_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_location_valid_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_location_valid_flag.detail().name("location_valid_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_location_valid_flag);

            CompleteStructMember cst_origin_lat;
            cst_origin_lat.common().member_id(memberId++);
            cst_origin_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_origin_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_origin_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_origin_lat.common().member_flags().IS_OPTIONAL(false);
            cst_origin_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_origin_lat.common().member_flags().IS_KEY(false);
            cst_origin_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_origin_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_origin_lat.detail().name("origin_lat");

            type_object->complete().struct_type().member_seq().emplace_back(cst_origin_lat);

            CompleteStructMember cst_origin_lon;
            cst_origin_lon.common().member_id(memberId++);
            cst_origin_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_origin_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_origin_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_origin_lon.common().member_flags().IS_OPTIONAL(false);
            cst_origin_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_origin_lon.common().member_flags().IS_KEY(false);
            cst_origin_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_origin_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_origin_lon.detail().name("origin_lon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_origin_lon);

            CompleteStructMember cst_utm_position;
            cst_utm_position.common().member_id(memberId++);
            cst_utm_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_position.common().member_flags().IS_OPTIONAL(false);
            cst_utm_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_position.common().member_flags().IS_KEY(false);
            cst_utm_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(true));
            cst_utm_position.detail().name("utm_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_position);

            CompleteStructMember cst_change_origin_flag;
            cst_change_origin_flag.common().member_id(memberId++);
            cst_change_origin_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_change_origin_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_change_origin_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_change_origin_flag.common().member_flags().IS_OPTIONAL(false);
            cst_change_origin_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_change_origin_flag.common().member_flags().IS_KEY(false);
            cst_change_origin_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_change_origin_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_change_origin_flag.detail().name("change_origin_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_change_origin_flag);

            CompleteStructMember cst_utm_position_next;
            cst_utm_position_next.common().member_id(memberId++);
            cst_utm_position_next.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_utm_position_next.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_utm_position_next.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_utm_position_next.common().member_flags().IS_OPTIONAL(false);
            cst_utm_position_next.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_utm_position_next.common().member_flags().IS_KEY(false);
            cst_utm_position_next.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_utm_position_next.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(true));
            cst_utm_position_next.detail().name("utm_position_next");

            type_object->complete().struct_type().member_seq().emplace_back(cst_utm_position_next);

            CompleteStructMember cst_position_std_dev;
            cst_position_std_dev.common().member_id(memberId++);
            cst_position_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_position_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_std_dev.common().member_flags().IS_KEY(false);
            cst_position_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_position_std_dev.detail().name("position_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_std_dev);

            CompleteStructMember cst_orientation_std_dev;
            cst_orientation_std_dev.common().member_id(memberId++);
            cst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_orientation_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_orientation_std_dev.common().member_flags().IS_KEY(false);
            cst_orientation_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_orientation_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_orientation_std_dev.detail().name("orientation_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_orientation_std_dev);

            CompleteStructMember cst_linear_velocity_std_dev;
            cst_linear_velocity_std_dev.common().member_id(memberId++);
            cst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_KEY(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_velocity_std_dev.detail().name("linear_velocity_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity_std_dev);

            CompleteStructMember cst_linear_acceleration_std_dev;
            cst_linear_acceleration_std_dev.common().member_id(memberId++);
            cst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_KEY(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration_std_dev.detail().name("linear_acceleration_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration_std_dev);

            CompleteStructMember cst_angular_velocity_std_dev;
            cst_angular_velocity_std_dev.common().member_id(memberId++);
            cst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_KEY(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity_std_dev.detail().name("angular_velocity_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity_std_dev);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Location");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Location", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Location", true);
        }

    } // namespace msg
} // namespace ros2_interface