// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file LogTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Log.h"
#include "LogTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerLogTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Log", ros2_interface::msg::GetLogIdentifier(true),
                        ros2_interface::msg::GetLogObject(true));
                factory->add_type_object("ros2_interface::msg::Log", ros2_interface::msg::GetLogIdentifier(false),
                        ros2_interface::msg::GetLogObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetLogIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Log", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetLogObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Log", complete);
        }

        const TypeObject* GetLogObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Log", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteLogObject();
            }
            //else
            return GetMinimalLogObject();
        }

        const TypeObject* GetMinimalLogObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Log", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_stamp;
            mst_stamp.common().member_id(memberId++);
            mst_stamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_stamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_stamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_stamp.common().member_flags().IS_OPTIONAL(false);
            mst_stamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_stamp.common().member_flags().IS_KEY(false);
            mst_stamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_stamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 stamp_hash("stamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_stamp.detail().name_hash()[i] = stamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_stamp);

            MinimalStructMember mst_level;
            mst_level.common().member_id(memberId++);
            mst_level.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_level.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_level.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_level.common().member_flags().IS_OPTIONAL(false);
            mst_level.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_level.common().member_flags().IS_KEY(false);
            mst_level.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_level.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 level_hash("level");
            for(int i = 0; i < 4; ++i)
            {
                mst_level.detail().name_hash()[i] = level_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_level);

            MinimalStructMember mst_name;
            mst_name.common().member_id(memberId++);
            mst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_name.common().member_flags().IS_OPTIONAL(false);
            mst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_name.common().member_flags().IS_KEY(false);
            mst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 name_hash("name");
            for(int i = 0; i < 4; ++i)
            {
                mst_name.detail().name_hash()[i] = name_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_name);

            MinimalStructMember mst_msg;
            mst_msg.common().member_id(memberId++);
            mst_msg.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_msg.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_msg.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_msg.common().member_flags().IS_OPTIONAL(false);
            mst_msg.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_msg.common().member_flags().IS_KEY(false);
            mst_msg.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_msg.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 msg_hash("msg");
            for(int i = 0; i < 4; ++i)
            {
                mst_msg.detail().name_hash()[i] = msg_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_msg);

            MinimalStructMember mst_file;
            mst_file.common().member_id(memberId++);
            mst_file.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_file.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_file.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_file.common().member_flags().IS_OPTIONAL(false);
            mst_file.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_file.common().member_flags().IS_KEY(false);
            mst_file.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_file.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 file_hash("file");
            for(int i = 0; i < 4; ++i)
            {
                mst_file.detail().name_hash()[i] = file_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_file);

            MinimalStructMember mst_function;
            mst_function.common().member_id(memberId++);
            mst_function.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_function.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_function.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_function.common().member_flags().IS_OPTIONAL(false);
            mst_function.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_function.common().member_flags().IS_KEY(false);
            mst_function.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_function.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 function_hash("function");
            for(int i = 0; i < 4; ++i)
            {
                mst_function.detail().name_hash()[i] = function_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_function);

            MinimalStructMember mst_line;
            mst_line.common().member_id(memberId++);
            mst_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_line.common().member_flags().IS_OPTIONAL(false);
            mst_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_line.common().member_flags().IS_KEY(false);
            mst_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 line_hash("line");
            for(int i = 0; i < 4; ++i)
            {
                mst_line.detail().name_hash()[i] = line_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_line);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Log", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Log", false);
        }

        const TypeObject* GetCompleteLogObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Log", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_stamp;
            cst_stamp.common().member_id(memberId++);
            cst_stamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_stamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_stamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_stamp.common().member_flags().IS_OPTIONAL(false);
            cst_stamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_stamp.common().member_flags().IS_KEY(false);
            cst_stamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_stamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_stamp.detail().name("stamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_stamp);

            CompleteStructMember cst_level;
            cst_level.common().member_id(memberId++);
            cst_level.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_level.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_level.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_level.common().member_flags().IS_OPTIONAL(false);
            cst_level.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_level.common().member_flags().IS_KEY(false);
            cst_level.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_level.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_level.detail().name("level");

            type_object->complete().struct_type().member_seq().emplace_back(cst_level);

            CompleteStructMember cst_name;
            cst_name.common().member_id(memberId++);
            cst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_name.common().member_flags().IS_OPTIONAL(false);
            cst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_name.common().member_flags().IS_KEY(false);
            cst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_name.detail().name("name");

            type_object->complete().struct_type().member_seq().emplace_back(cst_name);

            CompleteStructMember cst_msg;
            cst_msg.common().member_id(memberId++);
            cst_msg.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_msg.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_msg.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_msg.common().member_flags().IS_OPTIONAL(false);
            cst_msg.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_msg.common().member_flags().IS_KEY(false);
            cst_msg.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_msg.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_msg.detail().name("msg");

            type_object->complete().struct_type().member_seq().emplace_back(cst_msg);

            CompleteStructMember cst_file;
            cst_file.common().member_id(memberId++);
            cst_file.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_file.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_file.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_file.common().member_flags().IS_OPTIONAL(false);
            cst_file.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_file.common().member_flags().IS_KEY(false);
            cst_file.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_file.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_file.detail().name("file");

            type_object->complete().struct_type().member_seq().emplace_back(cst_file);

            CompleteStructMember cst_function;
            cst_function.common().member_id(memberId++);
            cst_function.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_function.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_function.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_function.common().member_flags().IS_OPTIONAL(false);
            cst_function.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_function.common().member_flags().IS_KEY(false);
            cst_function.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_function.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_function.detail().name("function");

            type_object->complete().struct_type().member_seq().emplace_back(cst_function);

            CompleteStructMember cst_line;
            cst_line.common().member_id(memberId++);
            cst_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_line.common().member_flags().IS_OPTIONAL(false);
            cst_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_line.common().member_flags().IS_KEY(false);
            cst_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_line.detail().name("line");

            type_object->complete().struct_type().member_seq().emplace_back(cst_line);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Log");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Log", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Log", true);
        }

    } // namespace msg
} // namespace ros2_interface