// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Matrix3D.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Matrix3D.h"
#include "Matrix3DTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Matrix3D_max_cdr_typesize 72ULL;
#define ros2_interface_msg_Matrix3D_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Matrix3D::Matrix3D()
{
    // double m_a00
    m_a00 = 0.0;
    // double m_a01
    m_a01 = 0.0;
    // double m_a02
    m_a02 = 0.0;
    // double m_a10
    m_a10 = 0.0;
    // double m_a11
    m_a11 = 0.0;
    // double m_a12
    m_a12 = 0.0;
    // double m_a20
    m_a20 = 0.0;
    // double m_a21
    m_a21 = 0.0;
    // double m_a22
    m_a22 = 0.0;

    // Just to register all known types
    registerMatrix3DTypes();
}

ros2_interface::msg::Matrix3D::~Matrix3D()
{









}

ros2_interface::msg::Matrix3D::Matrix3D(
        const Matrix3D& x)
{
    m_a00 = x.m_a00;
    m_a01 = x.m_a01;
    m_a02 = x.m_a02;
    m_a10 = x.m_a10;
    m_a11 = x.m_a11;
    m_a12 = x.m_a12;
    m_a20 = x.m_a20;
    m_a21 = x.m_a21;
    m_a22 = x.m_a22;
}

ros2_interface::msg::Matrix3D::Matrix3D(
        Matrix3D&& x) noexcept 
{
    m_a00 = x.m_a00;
    m_a01 = x.m_a01;
    m_a02 = x.m_a02;
    m_a10 = x.m_a10;
    m_a11 = x.m_a11;
    m_a12 = x.m_a12;
    m_a20 = x.m_a20;
    m_a21 = x.m_a21;
    m_a22 = x.m_a22;
}

ros2_interface::msg::Matrix3D& ros2_interface::msg::Matrix3D::operator =(
        const Matrix3D& x)
{

    m_a00 = x.m_a00;
    m_a01 = x.m_a01;
    m_a02 = x.m_a02;
    m_a10 = x.m_a10;
    m_a11 = x.m_a11;
    m_a12 = x.m_a12;
    m_a20 = x.m_a20;
    m_a21 = x.m_a21;
    m_a22 = x.m_a22;

    return *this;
}

ros2_interface::msg::Matrix3D& ros2_interface::msg::Matrix3D::operator =(
        Matrix3D&& x) noexcept
{

    m_a00 = x.m_a00;
    m_a01 = x.m_a01;
    m_a02 = x.m_a02;
    m_a10 = x.m_a10;
    m_a11 = x.m_a11;
    m_a12 = x.m_a12;
    m_a20 = x.m_a20;
    m_a21 = x.m_a21;
    m_a22 = x.m_a22;

    return *this;
}

bool ros2_interface::msg::Matrix3D::operator ==(
        const Matrix3D& x) const
{

    return (m_a00 == x.m_a00 && m_a01 == x.m_a01 && m_a02 == x.m_a02 && m_a10 == x.m_a10 && m_a11 == x.m_a11 && m_a12 == x.m_a12 && m_a20 == x.m_a20 && m_a21 == x.m_a21 && m_a22 == x.m_a22);
}

bool ros2_interface::msg::Matrix3D::operator !=(
        const Matrix3D& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Matrix3D::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Matrix3D_max_cdr_typesize;
}

size_t ros2_interface::msg::Matrix3D::getCdrSerializedSize(
        const ros2_interface::msg::Matrix3D& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Matrix3D::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_a00;
    scdr << m_a01;
    scdr << m_a02;
    scdr << m_a10;
    scdr << m_a11;
    scdr << m_a12;
    scdr << m_a20;
    scdr << m_a21;
    scdr << m_a22;

}

void ros2_interface::msg::Matrix3D::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_a00;
    dcdr >> m_a01;
    dcdr >> m_a02;
    dcdr >> m_a10;
    dcdr >> m_a11;
    dcdr >> m_a12;
    dcdr >> m_a20;
    dcdr >> m_a21;
    dcdr >> m_a22;
}

/*!
 * @brief This function sets a value in member a00
 * @param _a00 New value for member a00
 */
void ros2_interface::msg::Matrix3D::a00(
        double _a00)
{
    m_a00 = _a00;
}

/*!
 * @brief This function returns the value of member a00
 * @return Value of member a00
 */
double ros2_interface::msg::Matrix3D::a00() const
{
    return m_a00;
}

/*!
 * @brief This function returns a reference to member a00
 * @return Reference to member a00
 */
double& ros2_interface::msg::Matrix3D::a00()
{
    return m_a00;
}

/*!
 * @brief This function sets a value in member a01
 * @param _a01 New value for member a01
 */
void ros2_interface::msg::Matrix3D::a01(
        double _a01)
{
    m_a01 = _a01;
}

/*!
 * @brief This function returns the value of member a01
 * @return Value of member a01
 */
double ros2_interface::msg::Matrix3D::a01() const
{
    return m_a01;
}

/*!
 * @brief This function returns a reference to member a01
 * @return Reference to member a01
 */
double& ros2_interface::msg::Matrix3D::a01()
{
    return m_a01;
}

/*!
 * @brief This function sets a value in member a02
 * @param _a02 New value for member a02
 */
void ros2_interface::msg::Matrix3D::a02(
        double _a02)
{
    m_a02 = _a02;
}

/*!
 * @brief This function returns the value of member a02
 * @return Value of member a02
 */
double ros2_interface::msg::Matrix3D::a02() const
{
    return m_a02;
}

/*!
 * @brief This function returns a reference to member a02
 * @return Reference to member a02
 */
double& ros2_interface::msg::Matrix3D::a02()
{
    return m_a02;
}

/*!
 * @brief This function sets a value in member a10
 * @param _a10 New value for member a10
 */
void ros2_interface::msg::Matrix3D::a10(
        double _a10)
{
    m_a10 = _a10;
}

/*!
 * @brief This function returns the value of member a10
 * @return Value of member a10
 */
double ros2_interface::msg::Matrix3D::a10() const
{
    return m_a10;
}

/*!
 * @brief This function returns a reference to member a10
 * @return Reference to member a10
 */
double& ros2_interface::msg::Matrix3D::a10()
{
    return m_a10;
}

/*!
 * @brief This function sets a value in member a11
 * @param _a11 New value for member a11
 */
void ros2_interface::msg::Matrix3D::a11(
        double _a11)
{
    m_a11 = _a11;
}

/*!
 * @brief This function returns the value of member a11
 * @return Value of member a11
 */
double ros2_interface::msg::Matrix3D::a11() const
{
    return m_a11;
}

/*!
 * @brief This function returns a reference to member a11
 * @return Reference to member a11
 */
double& ros2_interface::msg::Matrix3D::a11()
{
    return m_a11;
}

/*!
 * @brief This function sets a value in member a12
 * @param _a12 New value for member a12
 */
void ros2_interface::msg::Matrix3D::a12(
        double _a12)
{
    m_a12 = _a12;
}

/*!
 * @brief This function returns the value of member a12
 * @return Value of member a12
 */
double ros2_interface::msg::Matrix3D::a12() const
{
    return m_a12;
}

/*!
 * @brief This function returns a reference to member a12
 * @return Reference to member a12
 */
double& ros2_interface::msg::Matrix3D::a12()
{
    return m_a12;
}

/*!
 * @brief This function sets a value in member a20
 * @param _a20 New value for member a20
 */
void ros2_interface::msg::Matrix3D::a20(
        double _a20)
{
    m_a20 = _a20;
}

/*!
 * @brief This function returns the value of member a20
 * @return Value of member a20
 */
double ros2_interface::msg::Matrix3D::a20() const
{
    return m_a20;
}

/*!
 * @brief This function returns a reference to member a20
 * @return Reference to member a20
 */
double& ros2_interface::msg::Matrix3D::a20()
{
    return m_a20;
}

/*!
 * @brief This function sets a value in member a21
 * @param _a21 New value for member a21
 */
void ros2_interface::msg::Matrix3D::a21(
        double _a21)
{
    m_a21 = _a21;
}

/*!
 * @brief This function returns the value of member a21
 * @return Value of member a21
 */
double ros2_interface::msg::Matrix3D::a21() const
{
    return m_a21;
}

/*!
 * @brief This function returns a reference to member a21
 * @return Reference to member a21
 */
double& ros2_interface::msg::Matrix3D::a21()
{
    return m_a21;
}

/*!
 * @brief This function sets a value in member a22
 * @param _a22 New value for member a22
 */
void ros2_interface::msg::Matrix3D::a22(
        double _a22)
{
    m_a22 = _a22;
}

/*!
 * @brief This function returns the value of member a22
 * @return Value of member a22
 */
double ros2_interface::msg::Matrix3D::a22() const
{
    return m_a22;
}

/*!
 * @brief This function returns a reference to member a22
 * @return Reference to member a22
 */
double& ros2_interface::msg::Matrix3D::a22()
{
    return m_a22;
}



size_t ros2_interface::msg::Matrix3D::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Matrix3D_max_key_cdr_typesize;
}

bool ros2_interface::msg::Matrix3D::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Matrix3D::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



