// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Matrix3D.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_MATRIX3D_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_MATRIX3D_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(MATRIX3D_SOURCE)
#define MATRIX3D_DllAPI __declspec( dllexport )
#else
#define MATRIX3D_DllAPI __declspec( dllimport )
#endif // MATRIX3D_SOURCE
#else
#define MATRIX3D_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define MATRIX3D_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Matrix3D defined by the user in the IDL file.
         * @ingroup Matrix3D
         */
        class Matrix3D
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Matrix3D();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Matrix3D();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Matrix3D that will be copied.
             */
            eProsima_user_DllExport Matrix3D(
                    const Matrix3D& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Matrix3D that will be copied.
             */
            eProsima_user_DllExport Matrix3D(
                    Matrix3D&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Matrix3D that will be copied.
             */
            eProsima_user_DllExport Matrix3D& operator =(
                    const Matrix3D& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Matrix3D that will be copied.
             */
            eProsima_user_DllExport Matrix3D& operator =(
                    Matrix3D&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Matrix3D object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Matrix3D& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Matrix3D object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Matrix3D& x) const;

            /*!
             * @brief This function sets a value in member a00
             * @param _a00 New value for member a00
             */
            eProsima_user_DllExport void a00(
                    double _a00);

            /*!
             * @brief This function returns the value of member a00
             * @return Value of member a00
             */
            eProsima_user_DllExport double a00() const;

            /*!
             * @brief This function returns a reference to member a00
             * @return Reference to member a00
             */
            eProsima_user_DllExport double& a00();

            /*!
             * @brief This function sets a value in member a01
             * @param _a01 New value for member a01
             */
            eProsima_user_DllExport void a01(
                    double _a01);

            /*!
             * @brief This function returns the value of member a01
             * @return Value of member a01
             */
            eProsima_user_DllExport double a01() const;

            /*!
             * @brief This function returns a reference to member a01
             * @return Reference to member a01
             */
            eProsima_user_DllExport double& a01();

            /*!
             * @brief This function sets a value in member a02
             * @param _a02 New value for member a02
             */
            eProsima_user_DllExport void a02(
                    double _a02);

            /*!
             * @brief This function returns the value of member a02
             * @return Value of member a02
             */
            eProsima_user_DllExport double a02() const;

            /*!
             * @brief This function returns a reference to member a02
             * @return Reference to member a02
             */
            eProsima_user_DllExport double& a02();

            /*!
             * @brief This function sets a value in member a10
             * @param _a10 New value for member a10
             */
            eProsima_user_DllExport void a10(
                    double _a10);

            /*!
             * @brief This function returns the value of member a10
             * @return Value of member a10
             */
            eProsima_user_DllExport double a10() const;

            /*!
             * @brief This function returns a reference to member a10
             * @return Reference to member a10
             */
            eProsima_user_DllExport double& a10();

            /*!
             * @brief This function sets a value in member a11
             * @param _a11 New value for member a11
             */
            eProsima_user_DllExport void a11(
                    double _a11);

            /*!
             * @brief This function returns the value of member a11
             * @return Value of member a11
             */
            eProsima_user_DllExport double a11() const;

            /*!
             * @brief This function returns a reference to member a11
             * @return Reference to member a11
             */
            eProsima_user_DllExport double& a11();

            /*!
             * @brief This function sets a value in member a12
             * @param _a12 New value for member a12
             */
            eProsima_user_DllExport void a12(
                    double _a12);

            /*!
             * @brief This function returns the value of member a12
             * @return Value of member a12
             */
            eProsima_user_DllExport double a12() const;

            /*!
             * @brief This function returns a reference to member a12
             * @return Reference to member a12
             */
            eProsima_user_DllExport double& a12();

            /*!
             * @brief This function sets a value in member a20
             * @param _a20 New value for member a20
             */
            eProsima_user_DllExport void a20(
                    double _a20);

            /*!
             * @brief This function returns the value of member a20
             * @return Value of member a20
             */
            eProsima_user_DllExport double a20() const;

            /*!
             * @brief This function returns a reference to member a20
             * @return Reference to member a20
             */
            eProsima_user_DllExport double& a20();

            /*!
             * @brief This function sets a value in member a21
             * @param _a21 New value for member a21
             */
            eProsima_user_DllExport void a21(
                    double _a21);

            /*!
             * @brief This function returns the value of member a21
             * @return Value of member a21
             */
            eProsima_user_DllExport double a21() const;

            /*!
             * @brief This function returns a reference to member a21
             * @return Reference to member a21
             */
            eProsima_user_DllExport double& a21();

            /*!
             * @brief This function sets a value in member a22
             * @param _a22 New value for member a22
             */
            eProsima_user_DllExport void a22(
                    double _a22);

            /*!
             * @brief This function returns the value of member a22
             * @return Value of member a22
             */
            eProsima_user_DllExport double a22() const;

            /*!
             * @brief This function returns a reference to member a22
             * @return Reference to member a22
             */
            eProsima_user_DllExport double& a22();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Matrix3D& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_a00;
            double m_a01;
            double m_a02;
            double m_a10;
            double m_a11;
            double m_a12;
            double m_a20;
            double m_a21;
            double m_a22;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_MATRIX3D_H_

