// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Matrix3DTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Matrix3D.h"
#include "Matrix3DTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerMatrix3DTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Matrix3D", ros2_interface::msg::GetMatrix3DIdentifier(true),
                        ros2_interface::msg::GetMatrix3DObject(true));
                factory->add_type_object("ros2_interface::msg::Matrix3D", ros2_interface::msg::GetMatrix3DIdentifier(false),
                        ros2_interface::msg::GetMatrix3DObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetMatrix3DIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Matrix3D", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetMatrix3DObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Matrix3D", complete);
        }

        const TypeObject* GetMatrix3DObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Matrix3D", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteMatrix3DObject();
            }
            //else
            return GetMinimalMatrix3DObject();
        }

        const TypeObject* GetMinimalMatrix3DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Matrix3D", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_a00;
            mst_a00.common().member_id(memberId++);
            mst_a00.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a00.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a00.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a00.common().member_flags().IS_OPTIONAL(false);
            mst_a00.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a00.common().member_flags().IS_KEY(false);
            mst_a00.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a00.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a00_hash("a00");
            for(int i = 0; i < 4; ++i)
            {
                mst_a00.detail().name_hash()[i] = a00_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a00);

            MinimalStructMember mst_a01;
            mst_a01.common().member_id(memberId++);
            mst_a01.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a01.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a01.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a01.common().member_flags().IS_OPTIONAL(false);
            mst_a01.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a01.common().member_flags().IS_KEY(false);
            mst_a01.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a01.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a01_hash("a01");
            for(int i = 0; i < 4; ++i)
            {
                mst_a01.detail().name_hash()[i] = a01_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a01);

            MinimalStructMember mst_a02;
            mst_a02.common().member_id(memberId++);
            mst_a02.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a02.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a02.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a02.common().member_flags().IS_OPTIONAL(false);
            mst_a02.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a02.common().member_flags().IS_KEY(false);
            mst_a02.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a02.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a02_hash("a02");
            for(int i = 0; i < 4; ++i)
            {
                mst_a02.detail().name_hash()[i] = a02_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a02);

            MinimalStructMember mst_a10;
            mst_a10.common().member_id(memberId++);
            mst_a10.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a10.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a10.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a10.common().member_flags().IS_OPTIONAL(false);
            mst_a10.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a10.common().member_flags().IS_KEY(false);
            mst_a10.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a10.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a10_hash("a10");
            for(int i = 0; i < 4; ++i)
            {
                mst_a10.detail().name_hash()[i] = a10_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a10);

            MinimalStructMember mst_a11;
            mst_a11.common().member_id(memberId++);
            mst_a11.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a11.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a11.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a11.common().member_flags().IS_OPTIONAL(false);
            mst_a11.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a11.common().member_flags().IS_KEY(false);
            mst_a11.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a11.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a11_hash("a11");
            for(int i = 0; i < 4; ++i)
            {
                mst_a11.detail().name_hash()[i] = a11_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a11);

            MinimalStructMember mst_a12;
            mst_a12.common().member_id(memberId++);
            mst_a12.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a12.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a12.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a12.common().member_flags().IS_OPTIONAL(false);
            mst_a12.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a12.common().member_flags().IS_KEY(false);
            mst_a12.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a12.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a12_hash("a12");
            for(int i = 0; i < 4; ++i)
            {
                mst_a12.detail().name_hash()[i] = a12_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a12);

            MinimalStructMember mst_a20;
            mst_a20.common().member_id(memberId++);
            mst_a20.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a20.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a20.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a20.common().member_flags().IS_OPTIONAL(false);
            mst_a20.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a20.common().member_flags().IS_KEY(false);
            mst_a20.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a20.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a20_hash("a20");
            for(int i = 0; i < 4; ++i)
            {
                mst_a20.detail().name_hash()[i] = a20_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a20);

            MinimalStructMember mst_a21;
            mst_a21.common().member_id(memberId++);
            mst_a21.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a21.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a21.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a21.common().member_flags().IS_OPTIONAL(false);
            mst_a21.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a21.common().member_flags().IS_KEY(false);
            mst_a21.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a21.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a21_hash("a21");
            for(int i = 0; i < 4; ++i)
            {
                mst_a21.detail().name_hash()[i] = a21_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a21);

            MinimalStructMember mst_a22;
            mst_a22.common().member_id(memberId++);
            mst_a22.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a22.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a22.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a22.common().member_flags().IS_OPTIONAL(false);
            mst_a22.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a22.common().member_flags().IS_KEY(false);
            mst_a22.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a22.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a22_hash("a22");
            for(int i = 0; i < 4; ++i)
            {
                mst_a22.detail().name_hash()[i] = a22_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a22);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Matrix3D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Matrix3D", false);
        }

        const TypeObject* GetCompleteMatrix3DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Matrix3D", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_a00;
            cst_a00.common().member_id(memberId++);
            cst_a00.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a00.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a00.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a00.common().member_flags().IS_OPTIONAL(false);
            cst_a00.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a00.common().member_flags().IS_KEY(false);
            cst_a00.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a00.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a00.detail().name("a00");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a00);

            CompleteStructMember cst_a01;
            cst_a01.common().member_id(memberId++);
            cst_a01.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a01.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a01.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a01.common().member_flags().IS_OPTIONAL(false);
            cst_a01.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a01.common().member_flags().IS_KEY(false);
            cst_a01.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a01.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a01.detail().name("a01");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a01);

            CompleteStructMember cst_a02;
            cst_a02.common().member_id(memberId++);
            cst_a02.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a02.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a02.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a02.common().member_flags().IS_OPTIONAL(false);
            cst_a02.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a02.common().member_flags().IS_KEY(false);
            cst_a02.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a02.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a02.detail().name("a02");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a02);

            CompleteStructMember cst_a10;
            cst_a10.common().member_id(memberId++);
            cst_a10.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a10.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a10.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a10.common().member_flags().IS_OPTIONAL(false);
            cst_a10.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a10.common().member_flags().IS_KEY(false);
            cst_a10.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a10.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a10.detail().name("a10");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a10);

            CompleteStructMember cst_a11;
            cst_a11.common().member_id(memberId++);
            cst_a11.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a11.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a11.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a11.common().member_flags().IS_OPTIONAL(false);
            cst_a11.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a11.common().member_flags().IS_KEY(false);
            cst_a11.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a11.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a11.detail().name("a11");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a11);

            CompleteStructMember cst_a12;
            cst_a12.common().member_id(memberId++);
            cst_a12.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a12.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a12.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a12.common().member_flags().IS_OPTIONAL(false);
            cst_a12.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a12.common().member_flags().IS_KEY(false);
            cst_a12.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a12.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a12.detail().name("a12");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a12);

            CompleteStructMember cst_a20;
            cst_a20.common().member_id(memberId++);
            cst_a20.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a20.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a20.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a20.common().member_flags().IS_OPTIONAL(false);
            cst_a20.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a20.common().member_flags().IS_KEY(false);
            cst_a20.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a20.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a20.detail().name("a20");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a20);

            CompleteStructMember cst_a21;
            cst_a21.common().member_id(memberId++);
            cst_a21.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a21.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a21.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a21.common().member_flags().IS_OPTIONAL(false);
            cst_a21.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a21.common().member_flags().IS_KEY(false);
            cst_a21.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a21.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a21.detail().name("a21");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a21);

            CompleteStructMember cst_a22;
            cst_a22.common().member_id(memberId++);
            cst_a22.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a22.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a22.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a22.common().member_flags().IS_OPTIONAL(false);
            cst_a22.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a22.common().member_flags().IS_KEY(false);
            cst_a22.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a22.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a22.detail().name("a22");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a22);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Matrix3D");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Matrix3D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Matrix3D", true);
        }

    } // namespace msg
} // namespace ros2_interface