// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Message.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Message.h"
#include "MessageTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Message_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Message_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Message::Message()
{
    // long m_code
    m_code = 0;
    // long m_value
    m_value = 0;

    // Just to register all known types
    registerMessageTypes();
}

ros2_interface::msg::Message::~Message()
{


}

ros2_interface::msg::Message::Message(
        const Message& x)
{
    m_code = x.m_code;
    m_value = x.m_value;
}

ros2_interface::msg::Message::Message(
        Message&& x) noexcept 
{
    m_code = x.m_code;
    m_value = x.m_value;
}

ros2_interface::msg::Message& ros2_interface::msg::Message::operator =(
        const Message& x)
{

    m_code = x.m_code;
    m_value = x.m_value;

    return *this;
}

ros2_interface::msg::Message& ros2_interface::msg::Message::operator =(
        Message&& x) noexcept
{

    m_code = x.m_code;
    m_value = x.m_value;

    return *this;
}

bool ros2_interface::msg::Message::operator ==(
        const Message& x) const
{

    return (m_code == x.m_code && m_value == x.m_value);
}

bool ros2_interface::msg::Message::operator !=(
        const Message& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Message::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Message_max_cdr_typesize;
}

size_t ros2_interface::msg::Message::getCdrSerializedSize(
        const ros2_interface::msg::Message& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Message::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_code;
    scdr << m_value;

}

void ros2_interface::msg::Message::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_code;
    dcdr >> m_value;
}

/*!
 * @brief This function sets a value in member code
 * @param _code New value for member code
 */
void ros2_interface::msg::Message::code(
        int32_t _code)
{
    m_code = _code;
}

/*!
 * @brief This function returns the value of member code
 * @return Value of member code
 */
int32_t ros2_interface::msg::Message::code() const
{
    return m_code;
}

/*!
 * @brief This function returns a reference to member code
 * @return Reference to member code
 */
int32_t& ros2_interface::msg::Message::code()
{
    return m_code;
}

/*!
 * @brief This function sets a value in member value
 * @param _value New value for member value
 */
void ros2_interface::msg::Message::value(
        int32_t _value)
{
    m_value = _value;
}

/*!
 * @brief This function returns the value of member value
 * @return Value of member value
 */
int32_t ros2_interface::msg::Message::value() const
{
    return m_value;
}

/*!
 * @brief This function returns a reference to member value
 * @return Reference to member value
 */
int32_t& ros2_interface::msg::Message::value()
{
    return m_value;
}



size_t ros2_interface::msg::Message::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Message_max_key_cdr_typesize;
}

bool ros2_interface::msg::Message::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Message::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



