// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ModuleStatus.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ModuleStatus.h"
#include "ModuleStatusTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Message_max_cdr_typesize 8ULL;
#define ros2_interface_msg_ModuleStatus_max_cdr_typesize 1344ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Message_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ModuleStatus_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ModuleStatus::ModuleStatus()
{
    // ros2_interface::msg::Header m_header

    // string m_name
    m_name ="";
    // int8 m_self_id
    m_self_id = 0;
    // long m_status
    m_status = 0;
    // sequence<ros2_interface::msg::Message> m_messages


    // Just to register all known types
    registerModuleStatusTypes();
}

ros2_interface::msg::ModuleStatus::~ModuleStatus()
{





}

ros2_interface::msg::ModuleStatus::ModuleStatus(
        const ModuleStatus& x)
{
    m_header = x.m_header;
    m_name = x.m_name;
    m_self_id = x.m_self_id;
    m_status = x.m_status;
    m_messages = x.m_messages;
}

ros2_interface::msg::ModuleStatus::ModuleStatus(
        ModuleStatus&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_name = std::move(x.m_name);
    m_self_id = x.m_self_id;
    m_status = x.m_status;
    m_messages = std::move(x.m_messages);
}

ros2_interface::msg::ModuleStatus& ros2_interface::msg::ModuleStatus::operator =(
        const ModuleStatus& x)
{

    m_header = x.m_header;
    m_name = x.m_name;
    m_self_id = x.m_self_id;
    m_status = x.m_status;
    m_messages = x.m_messages;

    return *this;
}

ros2_interface::msg::ModuleStatus& ros2_interface::msg::ModuleStatus::operator =(
        ModuleStatus&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_name = std::move(x.m_name);
    m_self_id = x.m_self_id;
    m_status = x.m_status;
    m_messages = std::move(x.m_messages);

    return *this;
}

bool ros2_interface::msg::ModuleStatus::operator ==(
        const ModuleStatus& x) const
{

    return (m_header == x.m_header && m_name == x.m_name && m_self_id == x.m_self_id && m_status == x.m_status && m_messages == x.m_messages);
}

bool ros2_interface::msg::ModuleStatus::operator !=(
        const ModuleStatus& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ModuleStatus::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ModuleStatus_max_cdr_typesize;
}

size_t ros2_interface::msg::ModuleStatus::getCdrSerializedSize(
        const ros2_interface::msg::ModuleStatus& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.messages().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Message::getCdrSerializedSize(data.messages().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ModuleStatus::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_name.c_str();
    scdr << m_self_id;
    scdr << m_status;
    scdr << m_messages;

}

void ros2_interface::msg::ModuleStatus::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_name;
    dcdr >> m_self_id;
    dcdr >> m_status;
    dcdr >> m_messages;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ModuleStatus::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ModuleStatus::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ModuleStatus::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ModuleStatus::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::ModuleStatus::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::ModuleStatus::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::ModuleStatus::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::ModuleStatus::name()
{
    return m_name;
}
/*!
 * @brief This function sets a value in member self_id
 * @param _self_id New value for member self_id
 */
void ros2_interface::msg::ModuleStatus::self_id(
        int8_t _self_id)
{
    m_self_id = _self_id;
}

/*!
 * @brief This function returns the value of member self_id
 * @return Value of member self_id
 */
int8_t ros2_interface::msg::ModuleStatus::self_id() const
{
    return m_self_id;
}

/*!
 * @brief This function returns a reference to member self_id
 * @return Reference to member self_id
 */
int8_t& ros2_interface::msg::ModuleStatus::self_id()
{
    return m_self_id;
}

/*!
 * @brief This function sets a value in member status
 * @param _status New value for member status
 */
void ros2_interface::msg::ModuleStatus::status(
        int32_t _status)
{
    m_status = _status;
}

/*!
 * @brief This function returns the value of member status
 * @return Value of member status
 */
int32_t ros2_interface::msg::ModuleStatus::status() const
{
    return m_status;
}

/*!
 * @brief This function returns a reference to member status
 * @return Reference to member status
 */
int32_t& ros2_interface::msg::ModuleStatus::status()
{
    return m_status;
}

/*!
 * @brief This function copies the value in member messages
 * @param _messages New value to be copied in member messages
 */
void ros2_interface::msg::ModuleStatus::messages(
        const std::vector<ros2_interface::msg::Message>& _messages)
{
    m_messages = _messages;
}

/*!
 * @brief This function moves the value in member messages
 * @param _messages New value to be moved in member messages
 */
void ros2_interface::msg::ModuleStatus::messages(
        std::vector<ros2_interface::msg::Message>&& _messages)
{
    m_messages = std::move(_messages);
}

/*!
 * @brief This function returns a constant reference to member messages
 * @return Constant reference to member messages
 */
const std::vector<ros2_interface::msg::Message>& ros2_interface::msg::ModuleStatus::messages() const
{
    return m_messages;
}

/*!
 * @brief This function returns a reference to member messages
 * @return Reference to member messages
 */
std::vector<ros2_interface::msg::Message>& ros2_interface::msg::ModuleStatus::messages()
{
    return m_messages;
}


size_t ros2_interface::msg::ModuleStatus::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ModuleStatus_max_key_cdr_typesize;
}

bool ros2_interface::msg::ModuleStatus::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ModuleStatus::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



