// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Obstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Obstacle.h"
#include "ObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ImageKeyPoint_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_Obstacle_max_cdr_typesize 1536488ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_cdr_typesize 15212ULL;
#define ros2_interface_msg_BBox2D_max_cdr_typesize 8ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_ObstacleIntent_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ImageKeyPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Obstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_BBox2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstacleIntent_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Obstacle::Obstacle()
{
    // ros2_interface::msg::Time m_timestamp

    // long m_id
    m_id = 0;
    // double m_existence_prob
    m_existence_prob = 0.0;
    // ros2_interface::msg::Time m_create_time

    // ros2_interface::msg::Time m_last_updated_time

    // ros2_interface::msg::Point3D m_center_pos_vehicle

    // ros2_interface::msg::Point3D m_center_pos_abs

    // double m_theta_vehicle
    m_theta_vehicle = 0.0;
    // double m_theta_abs
    m_theta_abs = 0.0;
    // ros2_interface::msg::Point3D m_velocity_vehicle

    // ros2_interface::msg::Point3D m_velocity_abs

    // double m_range_vehicle
    m_range_vehicle = 0.0;
    // double m_range_abs
    m_range_abs = 0.0;
    // double m_length
    m_length = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_height
    m_height = 0.0;
    // sequence<ros2_interface::msg::ImageKeyPoint> m_image_key_points

    // sequence<ros2_interface::msg::Point3D> m_polygon_point_abs

    // sequence<ros2_interface::msg::Point3D> m_polygon_point_vehicle

    // double m_tracking_time
    m_tracking_time = 0.0;
    // long m_type
    m_type = 0;
    // double m_confidence
    m_confidence = 0.0;
    // long m_confidence_type
    m_confidence_type = 0;
    // sequence<ros2_interface::msg::Point3D> m_drops

    // ros2_interface::msg::Point3D m_acceleration_vehicle

    // ros2_interface::msg::Point3D m_acceleration_abs

    // ros2_interface::msg::Point2D m_anchor_point_image

    // ros2_interface::msg::Point3D m_anchor_point_vehicle

    // ros2_interface::msg::Point3D m_anchor_point_abs

    // ros2_interface::msg::BBox2D m_bbox2d

    // ros2_interface::msg::BBox2D m_bbox2d_rear

    // long m_sub_type
    m_sub_type = 0;
    // double m_height_above_ground
    m_height_above_ground = 0.0;
    // sequence<double> m_position_abs_covariance

    // sequence<double> m_velocity_abs_covariance

    // sequence<double> m_acceleration_abs_covariance

    // double m_theta_abs_covariance
    m_theta_abs_covariance = 0.0;
    // sequence<double> m_position_vehicle_covariance

    // sequence<double> m_velocity_vehicle_covariance

    // sequence<double> m_acceleration_vehicle_covariance

    // double m_theta_vehicle_covariance
    m_theta_vehicle_covariance = 0.0;
    // uint8 m_cipv_flag
    m_cipv_flag = 0;
    // long m_lane_position
    m_lane_position = 0;
    // double m_pihp_percentage
    m_pihp_percentage = 0.0;
    // long m_blinker_flag
    m_blinker_flag = 0;
    // long m_fusion_type
    m_fusion_type = 0;
    // uint8 m_sensor_pos_id
    m_sensor_pos_id = 0;
    // sequence<ros2_interface::msg::TrajectoryInPrediction> m_predict_trajectories

    // ros2_interface::msg::ObstacleIntent m_intent


    // Just to register all known types
    registerObstacleTypes();
}

ros2_interface::msg::Obstacle::~Obstacle()
{

















































}

ros2_interface::msg::Obstacle::Obstacle(
        const Obstacle& x)
{
    m_timestamp = x.m_timestamp;
    m_id = x.m_id;
    m_existence_prob = x.m_existence_prob;
    m_create_time = x.m_create_time;
    m_last_updated_time = x.m_last_updated_time;
    m_center_pos_vehicle = x.m_center_pos_vehicle;
    m_center_pos_abs = x.m_center_pos_abs;
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_velocity_vehicle = x.m_velocity_vehicle;
    m_velocity_abs = x.m_velocity_abs;
    m_range_vehicle = x.m_range_vehicle;
    m_range_abs = x.m_range_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_image_key_points = x.m_image_key_points;
    m_polygon_point_abs = x.m_polygon_point_abs;
    m_polygon_point_vehicle = x.m_polygon_point_vehicle;
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_drops = x.m_drops;
    m_acceleration_vehicle = x.m_acceleration_vehicle;
    m_acceleration_abs = x.m_acceleration_abs;
    m_anchor_point_image = x.m_anchor_point_image;
    m_anchor_point_vehicle = x.m_anchor_point_vehicle;
    m_anchor_point_abs = x.m_anchor_point_abs;
    m_bbox2d = x.m_bbox2d;
    m_bbox2d_rear = x.m_bbox2d_rear;
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_abs_covariance = x.m_position_abs_covariance;
    m_velocity_abs_covariance = x.m_velocity_abs_covariance;
    m_acceleration_abs_covariance = x.m_acceleration_abs_covariance;
    m_theta_abs_covariance = x.m_theta_abs_covariance;
    m_position_vehicle_covariance = x.m_position_vehicle_covariance;
    m_velocity_vehicle_covariance = x.m_velocity_vehicle_covariance;
    m_acceleration_vehicle_covariance = x.m_acceleration_vehicle_covariance;
    m_theta_vehicle_covariance = x.m_theta_vehicle_covariance;
    m_cipv_flag = x.m_cipv_flag;
    m_lane_position = x.m_lane_position;
    m_pihp_percentage = x.m_pihp_percentage;
    m_blinker_flag = x.m_blinker_flag;
    m_fusion_type = x.m_fusion_type;
    m_sensor_pos_id = x.m_sensor_pos_id;
    m_predict_trajectories = x.m_predict_trajectories;
    m_intent = x.m_intent;
}

ros2_interface::msg::Obstacle::Obstacle(
        Obstacle&& x) noexcept 
{
    m_timestamp = std::move(x.m_timestamp);
    m_id = x.m_id;
    m_existence_prob = x.m_existence_prob;
    m_create_time = std::move(x.m_create_time);
    m_last_updated_time = std::move(x.m_last_updated_time);
    m_center_pos_vehicle = std::move(x.m_center_pos_vehicle);
    m_center_pos_abs = std::move(x.m_center_pos_abs);
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_velocity_vehicle = std::move(x.m_velocity_vehicle);
    m_velocity_abs = std::move(x.m_velocity_abs);
    m_range_vehicle = x.m_range_vehicle;
    m_range_abs = x.m_range_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_image_key_points = std::move(x.m_image_key_points);
    m_polygon_point_abs = std::move(x.m_polygon_point_abs);
    m_polygon_point_vehicle = std::move(x.m_polygon_point_vehicle);
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_drops = std::move(x.m_drops);
    m_acceleration_vehicle = std::move(x.m_acceleration_vehicle);
    m_acceleration_abs = std::move(x.m_acceleration_abs);
    m_anchor_point_image = std::move(x.m_anchor_point_image);
    m_anchor_point_vehicle = std::move(x.m_anchor_point_vehicle);
    m_anchor_point_abs = std::move(x.m_anchor_point_abs);
    m_bbox2d = std::move(x.m_bbox2d);
    m_bbox2d_rear = std::move(x.m_bbox2d_rear);
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_abs_covariance = std::move(x.m_position_abs_covariance);
    m_velocity_abs_covariance = std::move(x.m_velocity_abs_covariance);
    m_acceleration_abs_covariance = std::move(x.m_acceleration_abs_covariance);
    m_theta_abs_covariance = x.m_theta_abs_covariance;
    m_position_vehicle_covariance = std::move(x.m_position_vehicle_covariance);
    m_velocity_vehicle_covariance = std::move(x.m_velocity_vehicle_covariance);
    m_acceleration_vehicle_covariance = std::move(x.m_acceleration_vehicle_covariance);
    m_theta_vehicle_covariance = x.m_theta_vehicle_covariance;
    m_cipv_flag = x.m_cipv_flag;
    m_lane_position = x.m_lane_position;
    m_pihp_percentage = x.m_pihp_percentage;
    m_blinker_flag = x.m_blinker_flag;
    m_fusion_type = x.m_fusion_type;
    m_sensor_pos_id = x.m_sensor_pos_id;
    m_predict_trajectories = std::move(x.m_predict_trajectories);
    m_intent = std::move(x.m_intent);
}

ros2_interface::msg::Obstacle& ros2_interface::msg::Obstacle::operator =(
        const Obstacle& x)
{

    m_timestamp = x.m_timestamp;
    m_id = x.m_id;
    m_existence_prob = x.m_existence_prob;
    m_create_time = x.m_create_time;
    m_last_updated_time = x.m_last_updated_time;
    m_center_pos_vehicle = x.m_center_pos_vehicle;
    m_center_pos_abs = x.m_center_pos_abs;
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_velocity_vehicle = x.m_velocity_vehicle;
    m_velocity_abs = x.m_velocity_abs;
    m_range_vehicle = x.m_range_vehicle;
    m_range_abs = x.m_range_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_image_key_points = x.m_image_key_points;
    m_polygon_point_abs = x.m_polygon_point_abs;
    m_polygon_point_vehicle = x.m_polygon_point_vehicle;
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_drops = x.m_drops;
    m_acceleration_vehicle = x.m_acceleration_vehicle;
    m_acceleration_abs = x.m_acceleration_abs;
    m_anchor_point_image = x.m_anchor_point_image;
    m_anchor_point_vehicle = x.m_anchor_point_vehicle;
    m_anchor_point_abs = x.m_anchor_point_abs;
    m_bbox2d = x.m_bbox2d;
    m_bbox2d_rear = x.m_bbox2d_rear;
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_abs_covariance = x.m_position_abs_covariance;
    m_velocity_abs_covariance = x.m_velocity_abs_covariance;
    m_acceleration_abs_covariance = x.m_acceleration_abs_covariance;
    m_theta_abs_covariance = x.m_theta_abs_covariance;
    m_position_vehicle_covariance = x.m_position_vehicle_covariance;
    m_velocity_vehicle_covariance = x.m_velocity_vehicle_covariance;
    m_acceleration_vehicle_covariance = x.m_acceleration_vehicle_covariance;
    m_theta_vehicle_covariance = x.m_theta_vehicle_covariance;
    m_cipv_flag = x.m_cipv_flag;
    m_lane_position = x.m_lane_position;
    m_pihp_percentage = x.m_pihp_percentage;
    m_blinker_flag = x.m_blinker_flag;
    m_fusion_type = x.m_fusion_type;
    m_sensor_pos_id = x.m_sensor_pos_id;
    m_predict_trajectories = x.m_predict_trajectories;
    m_intent = x.m_intent;

    return *this;
}

ros2_interface::msg::Obstacle& ros2_interface::msg::Obstacle::operator =(
        Obstacle&& x) noexcept
{

    m_timestamp = std::move(x.m_timestamp);
    m_id = x.m_id;
    m_existence_prob = x.m_existence_prob;
    m_create_time = std::move(x.m_create_time);
    m_last_updated_time = std::move(x.m_last_updated_time);
    m_center_pos_vehicle = std::move(x.m_center_pos_vehicle);
    m_center_pos_abs = std::move(x.m_center_pos_abs);
    m_theta_vehicle = x.m_theta_vehicle;
    m_theta_abs = x.m_theta_abs;
    m_velocity_vehicle = std::move(x.m_velocity_vehicle);
    m_velocity_abs = std::move(x.m_velocity_abs);
    m_range_vehicle = x.m_range_vehicle;
    m_range_abs = x.m_range_abs;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_image_key_points = std::move(x.m_image_key_points);
    m_polygon_point_abs = std::move(x.m_polygon_point_abs);
    m_polygon_point_vehicle = std::move(x.m_polygon_point_vehicle);
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_confidence_type = x.m_confidence_type;
    m_drops = std::move(x.m_drops);
    m_acceleration_vehicle = std::move(x.m_acceleration_vehicle);
    m_acceleration_abs = std::move(x.m_acceleration_abs);
    m_anchor_point_image = std::move(x.m_anchor_point_image);
    m_anchor_point_vehicle = std::move(x.m_anchor_point_vehicle);
    m_anchor_point_abs = std::move(x.m_anchor_point_abs);
    m_bbox2d = std::move(x.m_bbox2d);
    m_bbox2d_rear = std::move(x.m_bbox2d_rear);
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_abs_covariance = std::move(x.m_position_abs_covariance);
    m_velocity_abs_covariance = std::move(x.m_velocity_abs_covariance);
    m_acceleration_abs_covariance = std::move(x.m_acceleration_abs_covariance);
    m_theta_abs_covariance = x.m_theta_abs_covariance;
    m_position_vehicle_covariance = std::move(x.m_position_vehicle_covariance);
    m_velocity_vehicle_covariance = std::move(x.m_velocity_vehicle_covariance);
    m_acceleration_vehicle_covariance = std::move(x.m_acceleration_vehicle_covariance);
    m_theta_vehicle_covariance = x.m_theta_vehicle_covariance;
    m_cipv_flag = x.m_cipv_flag;
    m_lane_position = x.m_lane_position;
    m_pihp_percentage = x.m_pihp_percentage;
    m_blinker_flag = x.m_blinker_flag;
    m_fusion_type = x.m_fusion_type;
    m_sensor_pos_id = x.m_sensor_pos_id;
    m_predict_trajectories = std::move(x.m_predict_trajectories);
    m_intent = std::move(x.m_intent);

    return *this;
}

bool ros2_interface::msg::Obstacle::operator ==(
        const Obstacle& x) const
{

    return (m_timestamp == x.m_timestamp && m_id == x.m_id && m_existence_prob == x.m_existence_prob && m_create_time == x.m_create_time && m_last_updated_time == x.m_last_updated_time && m_center_pos_vehicle == x.m_center_pos_vehicle && m_center_pos_abs == x.m_center_pos_abs && m_theta_vehicle == x.m_theta_vehicle && m_theta_abs == x.m_theta_abs && m_velocity_vehicle == x.m_velocity_vehicle && m_velocity_abs == x.m_velocity_abs && m_range_vehicle == x.m_range_vehicle && m_range_abs == x.m_range_abs && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_image_key_points == x.m_image_key_points && m_polygon_point_abs == x.m_polygon_point_abs && m_polygon_point_vehicle == x.m_polygon_point_vehicle && m_tracking_time == x.m_tracking_time && m_type == x.m_type && m_confidence == x.m_confidence && m_confidence_type == x.m_confidence_type && m_drops == x.m_drops && m_acceleration_vehicle == x.m_acceleration_vehicle && m_acceleration_abs == x.m_acceleration_abs && m_anchor_point_image == x.m_anchor_point_image && m_anchor_point_vehicle == x.m_anchor_point_vehicle && m_anchor_point_abs == x.m_anchor_point_abs && m_bbox2d == x.m_bbox2d && m_bbox2d_rear == x.m_bbox2d_rear && m_sub_type == x.m_sub_type && m_height_above_ground == x.m_height_above_ground && m_position_abs_covariance == x.m_position_abs_covariance && m_velocity_abs_covariance == x.m_velocity_abs_covariance && m_acceleration_abs_covariance == x.m_acceleration_abs_covariance && m_theta_abs_covariance == x.m_theta_abs_covariance && m_position_vehicle_covariance == x.m_position_vehicle_covariance && m_velocity_vehicle_covariance == x.m_velocity_vehicle_covariance && m_acceleration_vehicle_covariance == x.m_acceleration_vehicle_covariance && m_theta_vehicle_covariance == x.m_theta_vehicle_covariance && m_cipv_flag == x.m_cipv_flag && m_lane_position == x.m_lane_position && m_pihp_percentage == x.m_pihp_percentage && m_blinker_flag == x.m_blinker_flag && m_fusion_type == x.m_fusion_type && m_sensor_pos_id == x.m_sensor_pos_id && m_predict_trajectories == x.m_predict_trajectories && m_intent == x.m_intent);
}

bool ros2_interface::msg::Obstacle::operator !=(
        const Obstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Obstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Obstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::Obstacle::getCdrSerializedSize(
        const ros2_interface::msg::Obstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.timestamp(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.create_time(), current_alignment);
    current_alignment += ros2_interface::msg::Time::getCdrSerializedSize(data.last_updated_time(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.center_pos_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.center_pos_abs(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.velocity_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.velocity_abs(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.image_key_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::ImageKeyPoint::getCdrSerializedSize(data.image_key_points().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.polygon_point_abs().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.polygon_point_abs().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.polygon_point_vehicle().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.polygon_point_vehicle().at(a), current_alignment);}

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.drops().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.drops().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.acceleration_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.acceleration_abs(), current_alignment);
    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.anchor_point_image(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.anchor_point_vehicle(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.anchor_point_abs(), current_alignment);
    current_alignment += ros2_interface::msg::BBox2D::getCdrSerializedSize(data.bbox2d(), current_alignment);
    current_alignment += ros2_interface::msg::BBox2D::getCdrSerializedSize(data.bbox2d_rear(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.position_abs_covariance().size() > 0)
    {
        current_alignment += (data.position_abs_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.velocity_abs_covariance().size() > 0)
    {
        current_alignment += (data.velocity_abs_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.acceleration_abs_covariance().size() > 0)
    {
        current_alignment += (data.acceleration_abs_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.position_vehicle_covariance().size() > 0)
    {
        current_alignment += (data.position_vehicle_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.velocity_vehicle_covariance().size() > 0)
    {
        current_alignment += (data.velocity_vehicle_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.acceleration_vehicle_covariance().size() > 0)
    {
        current_alignment += (data.acceleration_vehicle_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.predict_trajectories().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryInPrediction::getCdrSerializedSize(data.predict_trajectories().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::ObstacleIntent::getCdrSerializedSize(data.intent(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Obstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_timestamp;
    scdr << m_id;
    scdr << m_existence_prob;
    scdr << m_create_time;
    scdr << m_last_updated_time;
    scdr << m_center_pos_vehicle;
    scdr << m_center_pos_abs;
    scdr << m_theta_vehicle;
    scdr << m_theta_abs;
    scdr << m_velocity_vehicle;
    scdr << m_velocity_abs;
    scdr << m_range_vehicle;
    scdr << m_range_abs;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_image_key_points;
    scdr << m_polygon_point_abs;
    scdr << m_polygon_point_vehicle;
    scdr << m_tracking_time;
    scdr << m_type;
    scdr << m_confidence;
    scdr << m_confidence_type;
    scdr << m_drops;
    scdr << m_acceleration_vehicle;
    scdr << m_acceleration_abs;
    scdr << m_anchor_point_image;
    scdr << m_anchor_point_vehicle;
    scdr << m_anchor_point_abs;
    scdr << m_bbox2d;
    scdr << m_bbox2d_rear;
    scdr << m_sub_type;
    scdr << m_height_above_ground;
    scdr << m_position_abs_covariance;
    scdr << m_velocity_abs_covariance;
    scdr << m_acceleration_abs_covariance;
    scdr << m_theta_abs_covariance;
    scdr << m_position_vehicle_covariance;
    scdr << m_velocity_vehicle_covariance;
    scdr << m_acceleration_vehicle_covariance;
    scdr << m_theta_vehicle_covariance;
    scdr << m_cipv_flag;
    scdr << m_lane_position;
    scdr << m_pihp_percentage;
    scdr << m_blinker_flag;
    scdr << m_fusion_type;
    scdr << m_sensor_pos_id;
    scdr << m_predict_trajectories;
    scdr << m_intent;

}

void ros2_interface::msg::Obstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_timestamp;
    dcdr >> m_id;
    dcdr >> m_existence_prob;
    dcdr >> m_create_time;
    dcdr >> m_last_updated_time;
    dcdr >> m_center_pos_vehicle;
    dcdr >> m_center_pos_abs;
    dcdr >> m_theta_vehicle;
    dcdr >> m_theta_abs;
    dcdr >> m_velocity_vehicle;
    dcdr >> m_velocity_abs;
    dcdr >> m_range_vehicle;
    dcdr >> m_range_abs;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_image_key_points;
    dcdr >> m_polygon_point_abs;
    dcdr >> m_polygon_point_vehicle;
    dcdr >> m_tracking_time;
    dcdr >> m_type;
    dcdr >> m_confidence;
    dcdr >> m_confidence_type;
    dcdr >> m_drops;
    dcdr >> m_acceleration_vehicle;
    dcdr >> m_acceleration_abs;
    dcdr >> m_anchor_point_image;
    dcdr >> m_anchor_point_vehicle;
    dcdr >> m_anchor_point_abs;
    dcdr >> m_bbox2d;
    dcdr >> m_bbox2d_rear;
    dcdr >> m_sub_type;
    dcdr >> m_height_above_ground;
    dcdr >> m_position_abs_covariance;
    dcdr >> m_velocity_abs_covariance;
    dcdr >> m_acceleration_abs_covariance;
    dcdr >> m_theta_abs_covariance;
    dcdr >> m_position_vehicle_covariance;
    dcdr >> m_velocity_vehicle_covariance;
    dcdr >> m_acceleration_vehicle_covariance;
    dcdr >> m_theta_vehicle_covariance;
    dcdr >> m_cipv_flag;
    dcdr >> m_lane_position;
    dcdr >> m_pihp_percentage;
    dcdr >> m_blinker_flag;
    dcdr >> m_fusion_type;
    dcdr >> m_sensor_pos_id;
    dcdr >> m_predict_trajectories;
    dcdr >> m_intent;
}

/*!
 * @brief This function copies the value in member timestamp
 * @param _timestamp New value to be copied in member timestamp
 */
void ros2_interface::msg::Obstacle::timestamp(
        const ros2_interface::msg::Time& _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function moves the value in member timestamp
 * @param _timestamp New value to be moved in member timestamp
 */
void ros2_interface::msg::Obstacle::timestamp(
        ros2_interface::msg::Time&& _timestamp)
{
    m_timestamp = std::move(_timestamp);
}

/*!
 * @brief This function returns a constant reference to member timestamp
 * @return Constant reference to member timestamp
 */
const ros2_interface::msg::Time& ros2_interface::msg::Obstacle::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
ros2_interface::msg::Time& ros2_interface::msg::Obstacle::timestamp()
{
    return m_timestamp;
}
/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::Obstacle::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::Obstacle::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::Obstacle::id()
{
    return m_id;
}

/*!
 * @brief This function sets a value in member existence_prob
 * @param _existence_prob New value for member existence_prob
 */
void ros2_interface::msg::Obstacle::existence_prob(
        double _existence_prob)
{
    m_existence_prob = _existence_prob;
}

/*!
 * @brief This function returns the value of member existence_prob
 * @return Value of member existence_prob
 */
double ros2_interface::msg::Obstacle::existence_prob() const
{
    return m_existence_prob;
}

/*!
 * @brief This function returns a reference to member existence_prob
 * @return Reference to member existence_prob
 */
double& ros2_interface::msg::Obstacle::existence_prob()
{
    return m_existence_prob;
}

/*!
 * @brief This function copies the value in member create_time
 * @param _create_time New value to be copied in member create_time
 */
void ros2_interface::msg::Obstacle::create_time(
        const ros2_interface::msg::Time& _create_time)
{
    m_create_time = _create_time;
}

/*!
 * @brief This function moves the value in member create_time
 * @param _create_time New value to be moved in member create_time
 */
void ros2_interface::msg::Obstacle::create_time(
        ros2_interface::msg::Time&& _create_time)
{
    m_create_time = std::move(_create_time);
}

/*!
 * @brief This function returns a constant reference to member create_time
 * @return Constant reference to member create_time
 */
const ros2_interface::msg::Time& ros2_interface::msg::Obstacle::create_time() const
{
    return m_create_time;
}

/*!
 * @brief This function returns a reference to member create_time
 * @return Reference to member create_time
 */
ros2_interface::msg::Time& ros2_interface::msg::Obstacle::create_time()
{
    return m_create_time;
}
/*!
 * @brief This function copies the value in member last_updated_time
 * @param _last_updated_time New value to be copied in member last_updated_time
 */
void ros2_interface::msg::Obstacle::last_updated_time(
        const ros2_interface::msg::Time& _last_updated_time)
{
    m_last_updated_time = _last_updated_time;
}

/*!
 * @brief This function moves the value in member last_updated_time
 * @param _last_updated_time New value to be moved in member last_updated_time
 */
void ros2_interface::msg::Obstacle::last_updated_time(
        ros2_interface::msg::Time&& _last_updated_time)
{
    m_last_updated_time = std::move(_last_updated_time);
}

/*!
 * @brief This function returns a constant reference to member last_updated_time
 * @return Constant reference to member last_updated_time
 */
const ros2_interface::msg::Time& ros2_interface::msg::Obstacle::last_updated_time() const
{
    return m_last_updated_time;
}

/*!
 * @brief This function returns a reference to member last_updated_time
 * @return Reference to member last_updated_time
 */
ros2_interface::msg::Time& ros2_interface::msg::Obstacle::last_updated_time()
{
    return m_last_updated_time;
}
/*!
 * @brief This function copies the value in member center_pos_vehicle
 * @param _center_pos_vehicle New value to be copied in member center_pos_vehicle
 */
void ros2_interface::msg::Obstacle::center_pos_vehicle(
        const ros2_interface::msg::Point3D& _center_pos_vehicle)
{
    m_center_pos_vehicle = _center_pos_vehicle;
}

/*!
 * @brief This function moves the value in member center_pos_vehicle
 * @param _center_pos_vehicle New value to be moved in member center_pos_vehicle
 */
void ros2_interface::msg::Obstacle::center_pos_vehicle(
        ros2_interface::msg::Point3D&& _center_pos_vehicle)
{
    m_center_pos_vehicle = std::move(_center_pos_vehicle);
}

/*!
 * @brief This function returns a constant reference to member center_pos_vehicle
 * @return Constant reference to member center_pos_vehicle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::center_pos_vehicle() const
{
    return m_center_pos_vehicle;
}

/*!
 * @brief This function returns a reference to member center_pos_vehicle
 * @return Reference to member center_pos_vehicle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::center_pos_vehicle()
{
    return m_center_pos_vehicle;
}
/*!
 * @brief This function copies the value in member center_pos_abs
 * @param _center_pos_abs New value to be copied in member center_pos_abs
 */
void ros2_interface::msg::Obstacle::center_pos_abs(
        const ros2_interface::msg::Point3D& _center_pos_abs)
{
    m_center_pos_abs = _center_pos_abs;
}

/*!
 * @brief This function moves the value in member center_pos_abs
 * @param _center_pos_abs New value to be moved in member center_pos_abs
 */
void ros2_interface::msg::Obstacle::center_pos_abs(
        ros2_interface::msg::Point3D&& _center_pos_abs)
{
    m_center_pos_abs = std::move(_center_pos_abs);
}

/*!
 * @brief This function returns a constant reference to member center_pos_abs
 * @return Constant reference to member center_pos_abs
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::center_pos_abs() const
{
    return m_center_pos_abs;
}

/*!
 * @brief This function returns a reference to member center_pos_abs
 * @return Reference to member center_pos_abs
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::center_pos_abs()
{
    return m_center_pos_abs;
}
/*!
 * @brief This function sets a value in member theta_vehicle
 * @param _theta_vehicle New value for member theta_vehicle
 */
void ros2_interface::msg::Obstacle::theta_vehicle(
        double _theta_vehicle)
{
    m_theta_vehicle = _theta_vehicle;
}

/*!
 * @brief This function returns the value of member theta_vehicle
 * @return Value of member theta_vehicle
 */
double ros2_interface::msg::Obstacle::theta_vehicle() const
{
    return m_theta_vehicle;
}

/*!
 * @brief This function returns a reference to member theta_vehicle
 * @return Reference to member theta_vehicle
 */
double& ros2_interface::msg::Obstacle::theta_vehicle()
{
    return m_theta_vehicle;
}

/*!
 * @brief This function sets a value in member theta_abs
 * @param _theta_abs New value for member theta_abs
 */
void ros2_interface::msg::Obstacle::theta_abs(
        double _theta_abs)
{
    m_theta_abs = _theta_abs;
}

/*!
 * @brief This function returns the value of member theta_abs
 * @return Value of member theta_abs
 */
double ros2_interface::msg::Obstacle::theta_abs() const
{
    return m_theta_abs;
}

/*!
 * @brief This function returns a reference to member theta_abs
 * @return Reference to member theta_abs
 */
double& ros2_interface::msg::Obstacle::theta_abs()
{
    return m_theta_abs;
}

/*!
 * @brief This function copies the value in member velocity_vehicle
 * @param _velocity_vehicle New value to be copied in member velocity_vehicle
 */
void ros2_interface::msg::Obstacle::velocity_vehicle(
        const ros2_interface::msg::Point3D& _velocity_vehicle)
{
    m_velocity_vehicle = _velocity_vehicle;
}

/*!
 * @brief This function moves the value in member velocity_vehicle
 * @param _velocity_vehicle New value to be moved in member velocity_vehicle
 */
void ros2_interface::msg::Obstacle::velocity_vehicle(
        ros2_interface::msg::Point3D&& _velocity_vehicle)
{
    m_velocity_vehicle = std::move(_velocity_vehicle);
}

/*!
 * @brief This function returns a constant reference to member velocity_vehicle
 * @return Constant reference to member velocity_vehicle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::velocity_vehicle() const
{
    return m_velocity_vehicle;
}

/*!
 * @brief This function returns a reference to member velocity_vehicle
 * @return Reference to member velocity_vehicle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::velocity_vehicle()
{
    return m_velocity_vehicle;
}
/*!
 * @brief This function copies the value in member velocity_abs
 * @param _velocity_abs New value to be copied in member velocity_abs
 */
void ros2_interface::msg::Obstacle::velocity_abs(
        const ros2_interface::msg::Point3D& _velocity_abs)
{
    m_velocity_abs = _velocity_abs;
}

/*!
 * @brief This function moves the value in member velocity_abs
 * @param _velocity_abs New value to be moved in member velocity_abs
 */
void ros2_interface::msg::Obstacle::velocity_abs(
        ros2_interface::msg::Point3D&& _velocity_abs)
{
    m_velocity_abs = std::move(_velocity_abs);
}

/*!
 * @brief This function returns a constant reference to member velocity_abs
 * @return Constant reference to member velocity_abs
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::velocity_abs() const
{
    return m_velocity_abs;
}

/*!
 * @brief This function returns a reference to member velocity_abs
 * @return Reference to member velocity_abs
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::velocity_abs()
{
    return m_velocity_abs;
}
/*!
 * @brief This function sets a value in member range_vehicle
 * @param _range_vehicle New value for member range_vehicle
 */
void ros2_interface::msg::Obstacle::range_vehicle(
        double _range_vehicle)
{
    m_range_vehicle = _range_vehicle;
}

/*!
 * @brief This function returns the value of member range_vehicle
 * @return Value of member range_vehicle
 */
double ros2_interface::msg::Obstacle::range_vehicle() const
{
    return m_range_vehicle;
}

/*!
 * @brief This function returns a reference to member range_vehicle
 * @return Reference to member range_vehicle
 */
double& ros2_interface::msg::Obstacle::range_vehicle()
{
    return m_range_vehicle;
}

/*!
 * @brief This function sets a value in member range_abs
 * @param _range_abs New value for member range_abs
 */
void ros2_interface::msg::Obstacle::range_abs(
        double _range_abs)
{
    m_range_abs = _range_abs;
}

/*!
 * @brief This function returns the value of member range_abs
 * @return Value of member range_abs
 */
double ros2_interface::msg::Obstacle::range_abs() const
{
    return m_range_abs;
}

/*!
 * @brief This function returns a reference to member range_abs
 * @return Reference to member range_abs
 */
double& ros2_interface::msg::Obstacle::range_abs()
{
    return m_range_abs;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::Obstacle::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::Obstacle::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::Obstacle::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::Obstacle::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::Obstacle::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::Obstacle::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::Obstacle::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::Obstacle::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::Obstacle::height()
{
    return m_height;
}

/*!
 * @brief This function copies the value in member image_key_points
 * @param _image_key_points New value to be copied in member image_key_points
 */
void ros2_interface::msg::Obstacle::image_key_points(
        const std::vector<ros2_interface::msg::ImageKeyPoint>& _image_key_points)
{
    m_image_key_points = _image_key_points;
}

/*!
 * @brief This function moves the value in member image_key_points
 * @param _image_key_points New value to be moved in member image_key_points
 */
void ros2_interface::msg::Obstacle::image_key_points(
        std::vector<ros2_interface::msg::ImageKeyPoint>&& _image_key_points)
{
    m_image_key_points = std::move(_image_key_points);
}

/*!
 * @brief This function returns a constant reference to member image_key_points
 * @return Constant reference to member image_key_points
 */
const std::vector<ros2_interface::msg::ImageKeyPoint>& ros2_interface::msg::Obstacle::image_key_points() const
{
    return m_image_key_points;
}

/*!
 * @brief This function returns a reference to member image_key_points
 * @return Reference to member image_key_points
 */
std::vector<ros2_interface::msg::ImageKeyPoint>& ros2_interface::msg::Obstacle::image_key_points()
{
    return m_image_key_points;
}
/*!
 * @brief This function copies the value in member polygon_point_abs
 * @param _polygon_point_abs New value to be copied in member polygon_point_abs
 */
void ros2_interface::msg::Obstacle::polygon_point_abs(
        const std::vector<ros2_interface::msg::Point3D>& _polygon_point_abs)
{
    m_polygon_point_abs = _polygon_point_abs;
}

/*!
 * @brief This function moves the value in member polygon_point_abs
 * @param _polygon_point_abs New value to be moved in member polygon_point_abs
 */
void ros2_interface::msg::Obstacle::polygon_point_abs(
        std::vector<ros2_interface::msg::Point3D>&& _polygon_point_abs)
{
    m_polygon_point_abs = std::move(_polygon_point_abs);
}

/*!
 * @brief This function returns a constant reference to member polygon_point_abs
 * @return Constant reference to member polygon_point_abs
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::polygon_point_abs() const
{
    return m_polygon_point_abs;
}

/*!
 * @brief This function returns a reference to member polygon_point_abs
 * @return Reference to member polygon_point_abs
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::polygon_point_abs()
{
    return m_polygon_point_abs;
}
/*!
 * @brief This function copies the value in member polygon_point_vehicle
 * @param _polygon_point_vehicle New value to be copied in member polygon_point_vehicle
 */
void ros2_interface::msg::Obstacle::polygon_point_vehicle(
        const std::vector<ros2_interface::msg::Point3D>& _polygon_point_vehicle)
{
    m_polygon_point_vehicle = _polygon_point_vehicle;
}

/*!
 * @brief This function moves the value in member polygon_point_vehicle
 * @param _polygon_point_vehicle New value to be moved in member polygon_point_vehicle
 */
void ros2_interface::msg::Obstacle::polygon_point_vehicle(
        std::vector<ros2_interface::msg::Point3D>&& _polygon_point_vehicle)
{
    m_polygon_point_vehicle = std::move(_polygon_point_vehicle);
}

/*!
 * @brief This function returns a constant reference to member polygon_point_vehicle
 * @return Constant reference to member polygon_point_vehicle
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::polygon_point_vehicle() const
{
    return m_polygon_point_vehicle;
}

/*!
 * @brief This function returns a reference to member polygon_point_vehicle
 * @return Reference to member polygon_point_vehicle
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::polygon_point_vehicle()
{
    return m_polygon_point_vehicle;
}
/*!
 * @brief This function sets a value in member tracking_time
 * @param _tracking_time New value for member tracking_time
 */
void ros2_interface::msg::Obstacle::tracking_time(
        double _tracking_time)
{
    m_tracking_time = _tracking_time;
}

/*!
 * @brief This function returns the value of member tracking_time
 * @return Value of member tracking_time
 */
double ros2_interface::msg::Obstacle::tracking_time() const
{
    return m_tracking_time;
}

/*!
 * @brief This function returns a reference to member tracking_time
 * @return Reference to member tracking_time
 */
double& ros2_interface::msg::Obstacle::tracking_time()
{
    return m_tracking_time;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::Obstacle::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::Obstacle::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::Obstacle::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::Obstacle::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::Obstacle::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::Obstacle::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function sets a value in member confidence_type
 * @param _confidence_type New value for member confidence_type
 */
void ros2_interface::msg::Obstacle::confidence_type(
        int32_t _confidence_type)
{
    m_confidence_type = _confidence_type;
}

/*!
 * @brief This function returns the value of member confidence_type
 * @return Value of member confidence_type
 */
int32_t ros2_interface::msg::Obstacle::confidence_type() const
{
    return m_confidence_type;
}

/*!
 * @brief This function returns a reference to member confidence_type
 * @return Reference to member confidence_type
 */
int32_t& ros2_interface::msg::Obstacle::confidence_type()
{
    return m_confidence_type;
}

/*!
 * @brief This function copies the value in member drops
 * @param _drops New value to be copied in member drops
 */
void ros2_interface::msg::Obstacle::drops(
        const std::vector<ros2_interface::msg::Point3D>& _drops)
{
    m_drops = _drops;
}

/*!
 * @brief This function moves the value in member drops
 * @param _drops New value to be moved in member drops
 */
void ros2_interface::msg::Obstacle::drops(
        std::vector<ros2_interface::msg::Point3D>&& _drops)
{
    m_drops = std::move(_drops);
}

/*!
 * @brief This function returns a constant reference to member drops
 * @return Constant reference to member drops
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::drops() const
{
    return m_drops;
}

/*!
 * @brief This function returns a reference to member drops
 * @return Reference to member drops
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Obstacle::drops()
{
    return m_drops;
}
/*!
 * @brief This function copies the value in member acceleration_vehicle
 * @param _acceleration_vehicle New value to be copied in member acceleration_vehicle
 */
void ros2_interface::msg::Obstacle::acceleration_vehicle(
        const ros2_interface::msg::Point3D& _acceleration_vehicle)
{
    m_acceleration_vehicle = _acceleration_vehicle;
}

/*!
 * @brief This function moves the value in member acceleration_vehicle
 * @param _acceleration_vehicle New value to be moved in member acceleration_vehicle
 */
void ros2_interface::msg::Obstacle::acceleration_vehicle(
        ros2_interface::msg::Point3D&& _acceleration_vehicle)
{
    m_acceleration_vehicle = std::move(_acceleration_vehicle);
}

/*!
 * @brief This function returns a constant reference to member acceleration_vehicle
 * @return Constant reference to member acceleration_vehicle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::acceleration_vehicle() const
{
    return m_acceleration_vehicle;
}

/*!
 * @brief This function returns a reference to member acceleration_vehicle
 * @return Reference to member acceleration_vehicle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::acceleration_vehicle()
{
    return m_acceleration_vehicle;
}
/*!
 * @brief This function copies the value in member acceleration_abs
 * @param _acceleration_abs New value to be copied in member acceleration_abs
 */
void ros2_interface::msg::Obstacle::acceleration_abs(
        const ros2_interface::msg::Point3D& _acceleration_abs)
{
    m_acceleration_abs = _acceleration_abs;
}

/*!
 * @brief This function moves the value in member acceleration_abs
 * @param _acceleration_abs New value to be moved in member acceleration_abs
 */
void ros2_interface::msg::Obstacle::acceleration_abs(
        ros2_interface::msg::Point3D&& _acceleration_abs)
{
    m_acceleration_abs = std::move(_acceleration_abs);
}

/*!
 * @brief This function returns a constant reference to member acceleration_abs
 * @return Constant reference to member acceleration_abs
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::acceleration_abs() const
{
    return m_acceleration_abs;
}

/*!
 * @brief This function returns a reference to member acceleration_abs
 * @return Reference to member acceleration_abs
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::acceleration_abs()
{
    return m_acceleration_abs;
}
/*!
 * @brief This function copies the value in member anchor_point_image
 * @param _anchor_point_image New value to be copied in member anchor_point_image
 */
void ros2_interface::msg::Obstacle::anchor_point_image(
        const ros2_interface::msg::Point2D& _anchor_point_image)
{
    m_anchor_point_image = _anchor_point_image;
}

/*!
 * @brief This function moves the value in member anchor_point_image
 * @param _anchor_point_image New value to be moved in member anchor_point_image
 */
void ros2_interface::msg::Obstacle::anchor_point_image(
        ros2_interface::msg::Point2D&& _anchor_point_image)
{
    m_anchor_point_image = std::move(_anchor_point_image);
}

/*!
 * @brief This function returns a constant reference to member anchor_point_image
 * @return Constant reference to member anchor_point_image
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::Obstacle::anchor_point_image() const
{
    return m_anchor_point_image;
}

/*!
 * @brief This function returns a reference to member anchor_point_image
 * @return Reference to member anchor_point_image
 */
ros2_interface::msg::Point2D& ros2_interface::msg::Obstacle::anchor_point_image()
{
    return m_anchor_point_image;
}
/*!
 * @brief This function copies the value in member anchor_point_vehicle
 * @param _anchor_point_vehicle New value to be copied in member anchor_point_vehicle
 */
void ros2_interface::msg::Obstacle::anchor_point_vehicle(
        const ros2_interface::msg::Point3D& _anchor_point_vehicle)
{
    m_anchor_point_vehicle = _anchor_point_vehicle;
}

/*!
 * @brief This function moves the value in member anchor_point_vehicle
 * @param _anchor_point_vehicle New value to be moved in member anchor_point_vehicle
 */
void ros2_interface::msg::Obstacle::anchor_point_vehicle(
        ros2_interface::msg::Point3D&& _anchor_point_vehicle)
{
    m_anchor_point_vehicle = std::move(_anchor_point_vehicle);
}

/*!
 * @brief This function returns a constant reference to member anchor_point_vehicle
 * @return Constant reference to member anchor_point_vehicle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::anchor_point_vehicle() const
{
    return m_anchor_point_vehicle;
}

/*!
 * @brief This function returns a reference to member anchor_point_vehicle
 * @return Reference to member anchor_point_vehicle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::anchor_point_vehicle()
{
    return m_anchor_point_vehicle;
}
/*!
 * @brief This function copies the value in member anchor_point_abs
 * @param _anchor_point_abs New value to be copied in member anchor_point_abs
 */
void ros2_interface::msg::Obstacle::anchor_point_abs(
        const ros2_interface::msg::Point3D& _anchor_point_abs)
{
    m_anchor_point_abs = _anchor_point_abs;
}

/*!
 * @brief This function moves the value in member anchor_point_abs
 * @param _anchor_point_abs New value to be moved in member anchor_point_abs
 */
void ros2_interface::msg::Obstacle::anchor_point_abs(
        ros2_interface::msg::Point3D&& _anchor_point_abs)
{
    m_anchor_point_abs = std::move(_anchor_point_abs);
}

/*!
 * @brief This function returns a constant reference to member anchor_point_abs
 * @return Constant reference to member anchor_point_abs
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::anchor_point_abs() const
{
    return m_anchor_point_abs;
}

/*!
 * @brief This function returns a reference to member anchor_point_abs
 * @return Reference to member anchor_point_abs
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Obstacle::anchor_point_abs()
{
    return m_anchor_point_abs;
}
/*!
 * @brief This function copies the value in member bbox2d
 * @param _bbox2d New value to be copied in member bbox2d
 */
void ros2_interface::msg::Obstacle::bbox2d(
        const ros2_interface::msg::BBox2D& _bbox2d)
{
    m_bbox2d = _bbox2d;
}

/*!
 * @brief This function moves the value in member bbox2d
 * @param _bbox2d New value to be moved in member bbox2d
 */
void ros2_interface::msg::Obstacle::bbox2d(
        ros2_interface::msg::BBox2D&& _bbox2d)
{
    m_bbox2d = std::move(_bbox2d);
}

/*!
 * @brief This function returns a constant reference to member bbox2d
 * @return Constant reference to member bbox2d
 */
const ros2_interface::msg::BBox2D& ros2_interface::msg::Obstacle::bbox2d() const
{
    return m_bbox2d;
}

/*!
 * @brief This function returns a reference to member bbox2d
 * @return Reference to member bbox2d
 */
ros2_interface::msg::BBox2D& ros2_interface::msg::Obstacle::bbox2d()
{
    return m_bbox2d;
}
/*!
 * @brief This function copies the value in member bbox2d_rear
 * @param _bbox2d_rear New value to be copied in member bbox2d_rear
 */
void ros2_interface::msg::Obstacle::bbox2d_rear(
        const ros2_interface::msg::BBox2D& _bbox2d_rear)
{
    m_bbox2d_rear = _bbox2d_rear;
}

/*!
 * @brief This function moves the value in member bbox2d_rear
 * @param _bbox2d_rear New value to be moved in member bbox2d_rear
 */
void ros2_interface::msg::Obstacle::bbox2d_rear(
        ros2_interface::msg::BBox2D&& _bbox2d_rear)
{
    m_bbox2d_rear = std::move(_bbox2d_rear);
}

/*!
 * @brief This function returns a constant reference to member bbox2d_rear
 * @return Constant reference to member bbox2d_rear
 */
const ros2_interface::msg::BBox2D& ros2_interface::msg::Obstacle::bbox2d_rear() const
{
    return m_bbox2d_rear;
}

/*!
 * @brief This function returns a reference to member bbox2d_rear
 * @return Reference to member bbox2d_rear
 */
ros2_interface::msg::BBox2D& ros2_interface::msg::Obstacle::bbox2d_rear()
{
    return m_bbox2d_rear;
}
/*!
 * @brief This function sets a value in member sub_type
 * @param _sub_type New value for member sub_type
 */
void ros2_interface::msg::Obstacle::sub_type(
        int32_t _sub_type)
{
    m_sub_type = _sub_type;
}

/*!
 * @brief This function returns the value of member sub_type
 * @return Value of member sub_type
 */
int32_t ros2_interface::msg::Obstacle::sub_type() const
{
    return m_sub_type;
}

/*!
 * @brief This function returns a reference to member sub_type
 * @return Reference to member sub_type
 */
int32_t& ros2_interface::msg::Obstacle::sub_type()
{
    return m_sub_type;
}

/*!
 * @brief This function sets a value in member height_above_ground
 * @param _height_above_ground New value for member height_above_ground
 */
void ros2_interface::msg::Obstacle::height_above_ground(
        double _height_above_ground)
{
    m_height_above_ground = _height_above_ground;
}

/*!
 * @brief This function returns the value of member height_above_ground
 * @return Value of member height_above_ground
 */
double ros2_interface::msg::Obstacle::height_above_ground() const
{
    return m_height_above_ground;
}

/*!
 * @brief This function returns a reference to member height_above_ground
 * @return Reference to member height_above_ground
 */
double& ros2_interface::msg::Obstacle::height_above_ground()
{
    return m_height_above_ground;
}

/*!
 * @brief This function copies the value in member position_abs_covariance
 * @param _position_abs_covariance New value to be copied in member position_abs_covariance
 */
void ros2_interface::msg::Obstacle::position_abs_covariance(
        const std::vector<double>& _position_abs_covariance)
{
    m_position_abs_covariance = _position_abs_covariance;
}

/*!
 * @brief This function moves the value in member position_abs_covariance
 * @param _position_abs_covariance New value to be moved in member position_abs_covariance
 */
void ros2_interface::msg::Obstacle::position_abs_covariance(
        std::vector<double>&& _position_abs_covariance)
{
    m_position_abs_covariance = std::move(_position_abs_covariance);
}

/*!
 * @brief This function returns a constant reference to member position_abs_covariance
 * @return Constant reference to member position_abs_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::position_abs_covariance() const
{
    return m_position_abs_covariance;
}

/*!
 * @brief This function returns a reference to member position_abs_covariance
 * @return Reference to member position_abs_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::position_abs_covariance()
{
    return m_position_abs_covariance;
}
/*!
 * @brief This function copies the value in member velocity_abs_covariance
 * @param _velocity_abs_covariance New value to be copied in member velocity_abs_covariance
 */
void ros2_interface::msg::Obstacle::velocity_abs_covariance(
        const std::vector<double>& _velocity_abs_covariance)
{
    m_velocity_abs_covariance = _velocity_abs_covariance;
}

/*!
 * @brief This function moves the value in member velocity_abs_covariance
 * @param _velocity_abs_covariance New value to be moved in member velocity_abs_covariance
 */
void ros2_interface::msg::Obstacle::velocity_abs_covariance(
        std::vector<double>&& _velocity_abs_covariance)
{
    m_velocity_abs_covariance = std::move(_velocity_abs_covariance);
}

/*!
 * @brief This function returns a constant reference to member velocity_abs_covariance
 * @return Constant reference to member velocity_abs_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::velocity_abs_covariance() const
{
    return m_velocity_abs_covariance;
}

/*!
 * @brief This function returns a reference to member velocity_abs_covariance
 * @return Reference to member velocity_abs_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::velocity_abs_covariance()
{
    return m_velocity_abs_covariance;
}
/*!
 * @brief This function copies the value in member acceleration_abs_covariance
 * @param _acceleration_abs_covariance New value to be copied in member acceleration_abs_covariance
 */
void ros2_interface::msg::Obstacle::acceleration_abs_covariance(
        const std::vector<double>& _acceleration_abs_covariance)
{
    m_acceleration_abs_covariance = _acceleration_abs_covariance;
}

/*!
 * @brief This function moves the value in member acceleration_abs_covariance
 * @param _acceleration_abs_covariance New value to be moved in member acceleration_abs_covariance
 */
void ros2_interface::msg::Obstacle::acceleration_abs_covariance(
        std::vector<double>&& _acceleration_abs_covariance)
{
    m_acceleration_abs_covariance = std::move(_acceleration_abs_covariance);
}

/*!
 * @brief This function returns a constant reference to member acceleration_abs_covariance
 * @return Constant reference to member acceleration_abs_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::acceleration_abs_covariance() const
{
    return m_acceleration_abs_covariance;
}

/*!
 * @brief This function returns a reference to member acceleration_abs_covariance
 * @return Reference to member acceleration_abs_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::acceleration_abs_covariance()
{
    return m_acceleration_abs_covariance;
}
/*!
 * @brief This function sets a value in member theta_abs_covariance
 * @param _theta_abs_covariance New value for member theta_abs_covariance
 */
void ros2_interface::msg::Obstacle::theta_abs_covariance(
        double _theta_abs_covariance)
{
    m_theta_abs_covariance = _theta_abs_covariance;
}

/*!
 * @brief This function returns the value of member theta_abs_covariance
 * @return Value of member theta_abs_covariance
 */
double ros2_interface::msg::Obstacle::theta_abs_covariance() const
{
    return m_theta_abs_covariance;
}

/*!
 * @brief This function returns a reference to member theta_abs_covariance
 * @return Reference to member theta_abs_covariance
 */
double& ros2_interface::msg::Obstacle::theta_abs_covariance()
{
    return m_theta_abs_covariance;
}

/*!
 * @brief This function copies the value in member position_vehicle_covariance
 * @param _position_vehicle_covariance New value to be copied in member position_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::position_vehicle_covariance(
        const std::vector<double>& _position_vehicle_covariance)
{
    m_position_vehicle_covariance = _position_vehicle_covariance;
}

/*!
 * @brief This function moves the value in member position_vehicle_covariance
 * @param _position_vehicle_covariance New value to be moved in member position_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::position_vehicle_covariance(
        std::vector<double>&& _position_vehicle_covariance)
{
    m_position_vehicle_covariance = std::move(_position_vehicle_covariance);
}

/*!
 * @brief This function returns a constant reference to member position_vehicle_covariance
 * @return Constant reference to member position_vehicle_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::position_vehicle_covariance() const
{
    return m_position_vehicle_covariance;
}

/*!
 * @brief This function returns a reference to member position_vehicle_covariance
 * @return Reference to member position_vehicle_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::position_vehicle_covariance()
{
    return m_position_vehicle_covariance;
}
/*!
 * @brief This function copies the value in member velocity_vehicle_covariance
 * @param _velocity_vehicle_covariance New value to be copied in member velocity_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::velocity_vehicle_covariance(
        const std::vector<double>& _velocity_vehicle_covariance)
{
    m_velocity_vehicle_covariance = _velocity_vehicle_covariance;
}

/*!
 * @brief This function moves the value in member velocity_vehicle_covariance
 * @param _velocity_vehicle_covariance New value to be moved in member velocity_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::velocity_vehicle_covariance(
        std::vector<double>&& _velocity_vehicle_covariance)
{
    m_velocity_vehicle_covariance = std::move(_velocity_vehicle_covariance);
}

/*!
 * @brief This function returns a constant reference to member velocity_vehicle_covariance
 * @return Constant reference to member velocity_vehicle_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::velocity_vehicle_covariance() const
{
    return m_velocity_vehicle_covariance;
}

/*!
 * @brief This function returns a reference to member velocity_vehicle_covariance
 * @return Reference to member velocity_vehicle_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::velocity_vehicle_covariance()
{
    return m_velocity_vehicle_covariance;
}
/*!
 * @brief This function copies the value in member acceleration_vehicle_covariance
 * @param _acceleration_vehicle_covariance New value to be copied in member acceleration_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::acceleration_vehicle_covariance(
        const std::vector<double>& _acceleration_vehicle_covariance)
{
    m_acceleration_vehicle_covariance = _acceleration_vehicle_covariance;
}

/*!
 * @brief This function moves the value in member acceleration_vehicle_covariance
 * @param _acceleration_vehicle_covariance New value to be moved in member acceleration_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::acceleration_vehicle_covariance(
        std::vector<double>&& _acceleration_vehicle_covariance)
{
    m_acceleration_vehicle_covariance = std::move(_acceleration_vehicle_covariance);
}

/*!
 * @brief This function returns a constant reference to member acceleration_vehicle_covariance
 * @return Constant reference to member acceleration_vehicle_covariance
 */
const std::vector<double>& ros2_interface::msg::Obstacle::acceleration_vehicle_covariance() const
{
    return m_acceleration_vehicle_covariance;
}

/*!
 * @brief This function returns a reference to member acceleration_vehicle_covariance
 * @return Reference to member acceleration_vehicle_covariance
 */
std::vector<double>& ros2_interface::msg::Obstacle::acceleration_vehicle_covariance()
{
    return m_acceleration_vehicle_covariance;
}
/*!
 * @brief This function sets a value in member theta_vehicle_covariance
 * @param _theta_vehicle_covariance New value for member theta_vehicle_covariance
 */
void ros2_interface::msg::Obstacle::theta_vehicle_covariance(
        double _theta_vehicle_covariance)
{
    m_theta_vehicle_covariance = _theta_vehicle_covariance;
}

/*!
 * @brief This function returns the value of member theta_vehicle_covariance
 * @return Value of member theta_vehicle_covariance
 */
double ros2_interface::msg::Obstacle::theta_vehicle_covariance() const
{
    return m_theta_vehicle_covariance;
}

/*!
 * @brief This function returns a reference to member theta_vehicle_covariance
 * @return Reference to member theta_vehicle_covariance
 */
double& ros2_interface::msg::Obstacle::theta_vehicle_covariance()
{
    return m_theta_vehicle_covariance;
}

/*!
 * @brief This function sets a value in member cipv_flag
 * @param _cipv_flag New value for member cipv_flag
 */
void ros2_interface::msg::Obstacle::cipv_flag(
        uint8_t _cipv_flag)
{
    m_cipv_flag = _cipv_flag;
}

/*!
 * @brief This function returns the value of member cipv_flag
 * @return Value of member cipv_flag
 */
uint8_t ros2_interface::msg::Obstacle::cipv_flag() const
{
    return m_cipv_flag;
}

/*!
 * @brief This function returns a reference to member cipv_flag
 * @return Reference to member cipv_flag
 */
uint8_t& ros2_interface::msg::Obstacle::cipv_flag()
{
    return m_cipv_flag;
}

/*!
 * @brief This function sets a value in member lane_position
 * @param _lane_position New value for member lane_position
 */
void ros2_interface::msg::Obstacle::lane_position(
        int32_t _lane_position)
{
    m_lane_position = _lane_position;
}

/*!
 * @brief This function returns the value of member lane_position
 * @return Value of member lane_position
 */
int32_t ros2_interface::msg::Obstacle::lane_position() const
{
    return m_lane_position;
}

/*!
 * @brief This function returns a reference to member lane_position
 * @return Reference to member lane_position
 */
int32_t& ros2_interface::msg::Obstacle::lane_position()
{
    return m_lane_position;
}

/*!
 * @brief This function sets a value in member pihp_percentage
 * @param _pihp_percentage New value for member pihp_percentage
 */
void ros2_interface::msg::Obstacle::pihp_percentage(
        double _pihp_percentage)
{
    m_pihp_percentage = _pihp_percentage;
}

/*!
 * @brief This function returns the value of member pihp_percentage
 * @return Value of member pihp_percentage
 */
double ros2_interface::msg::Obstacle::pihp_percentage() const
{
    return m_pihp_percentage;
}

/*!
 * @brief This function returns a reference to member pihp_percentage
 * @return Reference to member pihp_percentage
 */
double& ros2_interface::msg::Obstacle::pihp_percentage()
{
    return m_pihp_percentage;
}

/*!
 * @brief This function sets a value in member blinker_flag
 * @param _blinker_flag New value for member blinker_flag
 */
void ros2_interface::msg::Obstacle::blinker_flag(
        int32_t _blinker_flag)
{
    m_blinker_flag = _blinker_flag;
}

/*!
 * @brief This function returns the value of member blinker_flag
 * @return Value of member blinker_flag
 */
int32_t ros2_interface::msg::Obstacle::blinker_flag() const
{
    return m_blinker_flag;
}

/*!
 * @brief This function returns a reference to member blinker_flag
 * @return Reference to member blinker_flag
 */
int32_t& ros2_interface::msg::Obstacle::blinker_flag()
{
    return m_blinker_flag;
}

/*!
 * @brief This function sets a value in member fusion_type
 * @param _fusion_type New value for member fusion_type
 */
void ros2_interface::msg::Obstacle::fusion_type(
        int32_t _fusion_type)
{
    m_fusion_type = _fusion_type;
}

/*!
 * @brief This function returns the value of member fusion_type
 * @return Value of member fusion_type
 */
int32_t ros2_interface::msg::Obstacle::fusion_type() const
{
    return m_fusion_type;
}

/*!
 * @brief This function returns a reference to member fusion_type
 * @return Reference to member fusion_type
 */
int32_t& ros2_interface::msg::Obstacle::fusion_type()
{
    return m_fusion_type;
}

/*!
 * @brief This function sets a value in member sensor_pos_id
 * @param _sensor_pos_id New value for member sensor_pos_id
 */
void ros2_interface::msg::Obstacle::sensor_pos_id(
        uint8_t _sensor_pos_id)
{
    m_sensor_pos_id = _sensor_pos_id;
}

/*!
 * @brief This function returns the value of member sensor_pos_id
 * @return Value of member sensor_pos_id
 */
uint8_t ros2_interface::msg::Obstacle::sensor_pos_id() const
{
    return m_sensor_pos_id;
}

/*!
 * @brief This function returns a reference to member sensor_pos_id
 * @return Reference to member sensor_pos_id
 */
uint8_t& ros2_interface::msg::Obstacle::sensor_pos_id()
{
    return m_sensor_pos_id;
}

/*!
 * @brief This function copies the value in member predict_trajectories
 * @param _predict_trajectories New value to be copied in member predict_trajectories
 */
void ros2_interface::msg::Obstacle::predict_trajectories(
        const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _predict_trajectories)
{
    m_predict_trajectories = _predict_trajectories;
}

/*!
 * @brief This function moves the value in member predict_trajectories
 * @param _predict_trajectories New value to be moved in member predict_trajectories
 */
void ros2_interface::msg::Obstacle::predict_trajectories(
        std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _predict_trajectories)
{
    m_predict_trajectories = std::move(_predict_trajectories);
}

/*!
 * @brief This function returns a constant reference to member predict_trajectories
 * @return Constant reference to member predict_trajectories
 */
const std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::Obstacle::predict_trajectories() const
{
    return m_predict_trajectories;
}

/*!
 * @brief This function returns a reference to member predict_trajectories
 * @return Reference to member predict_trajectories
 */
std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::Obstacle::predict_trajectories()
{
    return m_predict_trajectories;
}
/*!
 * @brief This function copies the value in member intent
 * @param _intent New value to be copied in member intent
 */
void ros2_interface::msg::Obstacle::intent(
        const ros2_interface::msg::ObstacleIntent& _intent)
{
    m_intent = _intent;
}

/*!
 * @brief This function moves the value in member intent
 * @param _intent New value to be moved in member intent
 */
void ros2_interface::msg::Obstacle::intent(
        ros2_interface::msg::ObstacleIntent&& _intent)
{
    m_intent = std::move(_intent);
}

/*!
 * @brief This function returns a constant reference to member intent
 * @return Constant reference to member intent
 */
const ros2_interface::msg::ObstacleIntent& ros2_interface::msg::Obstacle::intent() const
{
    return m_intent;
}

/*!
 * @brief This function returns a reference to member intent
 * @return Reference to member intent
 */
ros2_interface::msg::ObstacleIntent& ros2_interface::msg::Obstacle::intent()
{
    return m_intent;
}


size_t ros2_interface::msg::Obstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Obstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::Obstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Obstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



