// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Obstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLE_H_

#include "TrajectoryInPrediction.h"
#include "Point2D.h"
#include "ObstacleIntent.h"
#include "Point3D.h"
#include "Time.h"
#include "ImageKeyPoint.h"
#include "BBox2D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(OBSTACLE_SOURCE)
#define OBSTACLE_DllAPI __declspec( dllexport )
#else
#define OBSTACLE_DllAPI __declspec( dllimport )
#endif // OBSTACLE_SOURCE
#else
#define OBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define OBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Obstacle defined by the user in the IDL file.
         * @ingroup Obstacle
         */
        class Obstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Obstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Obstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Obstacle that will be copied.
             */
            eProsima_user_DllExport Obstacle(
                    const Obstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Obstacle that will be copied.
             */
            eProsima_user_DllExport Obstacle(
                    Obstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Obstacle that will be copied.
             */
            eProsima_user_DllExport Obstacle& operator =(
                    const Obstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Obstacle that will be copied.
             */
            eProsima_user_DllExport Obstacle& operator =(
                    Obstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Obstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Obstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Obstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Obstacle& x) const;

            /*!
             * @brief This function copies the value in member timestamp
             * @param _timestamp New value to be copied in member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    const ros2_interface::msg::Time& _timestamp);

            /*!
             * @brief This function moves the value in member timestamp
             * @param _timestamp New value to be moved in member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    ros2_interface::msg::Time&& _timestamp);

            /*!
             * @brief This function returns a constant reference to member timestamp
             * @return Constant reference to member timestamp
             */
            eProsima_user_DllExport const ros2_interface::msg::Time& timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport ros2_interface::msg::Time& timestamp();
            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function sets a value in member existence_prob
             * @param _existence_prob New value for member existence_prob
             */
            eProsima_user_DllExport void existence_prob(
                    double _existence_prob);

            /*!
             * @brief This function returns the value of member existence_prob
             * @return Value of member existence_prob
             */
            eProsima_user_DllExport double existence_prob() const;

            /*!
             * @brief This function returns a reference to member existence_prob
             * @return Reference to member existence_prob
             */
            eProsima_user_DllExport double& existence_prob();

            /*!
             * @brief This function copies the value in member create_time
             * @param _create_time New value to be copied in member create_time
             */
            eProsima_user_DllExport void create_time(
                    const ros2_interface::msg::Time& _create_time);

            /*!
             * @brief This function moves the value in member create_time
             * @param _create_time New value to be moved in member create_time
             */
            eProsima_user_DllExport void create_time(
                    ros2_interface::msg::Time&& _create_time);

            /*!
             * @brief This function returns a constant reference to member create_time
             * @return Constant reference to member create_time
             */
            eProsima_user_DllExport const ros2_interface::msg::Time& create_time() const;

            /*!
             * @brief This function returns a reference to member create_time
             * @return Reference to member create_time
             */
            eProsima_user_DllExport ros2_interface::msg::Time& create_time();
            /*!
             * @brief This function copies the value in member last_updated_time
             * @param _last_updated_time New value to be copied in member last_updated_time
             */
            eProsima_user_DllExport void last_updated_time(
                    const ros2_interface::msg::Time& _last_updated_time);

            /*!
             * @brief This function moves the value in member last_updated_time
             * @param _last_updated_time New value to be moved in member last_updated_time
             */
            eProsima_user_DllExport void last_updated_time(
                    ros2_interface::msg::Time&& _last_updated_time);

            /*!
             * @brief This function returns a constant reference to member last_updated_time
             * @return Constant reference to member last_updated_time
             */
            eProsima_user_DllExport const ros2_interface::msg::Time& last_updated_time() const;

            /*!
             * @brief This function returns a reference to member last_updated_time
             * @return Reference to member last_updated_time
             */
            eProsima_user_DllExport ros2_interface::msg::Time& last_updated_time();
            /*!
             * @brief This function copies the value in member center_pos_vehicle
             * @param _center_pos_vehicle New value to be copied in member center_pos_vehicle
             */
            eProsima_user_DllExport void center_pos_vehicle(
                    const ros2_interface::msg::Point3D& _center_pos_vehicle);

            /*!
             * @brief This function moves the value in member center_pos_vehicle
             * @param _center_pos_vehicle New value to be moved in member center_pos_vehicle
             */
            eProsima_user_DllExport void center_pos_vehicle(
                    ros2_interface::msg::Point3D&& _center_pos_vehicle);

            /*!
             * @brief This function returns a constant reference to member center_pos_vehicle
             * @return Constant reference to member center_pos_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& center_pos_vehicle() const;

            /*!
             * @brief This function returns a reference to member center_pos_vehicle
             * @return Reference to member center_pos_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& center_pos_vehicle();
            /*!
             * @brief This function copies the value in member center_pos_abs
             * @param _center_pos_abs New value to be copied in member center_pos_abs
             */
            eProsima_user_DllExport void center_pos_abs(
                    const ros2_interface::msg::Point3D& _center_pos_abs);

            /*!
             * @brief This function moves the value in member center_pos_abs
             * @param _center_pos_abs New value to be moved in member center_pos_abs
             */
            eProsima_user_DllExport void center_pos_abs(
                    ros2_interface::msg::Point3D&& _center_pos_abs);

            /*!
             * @brief This function returns a constant reference to member center_pos_abs
             * @return Constant reference to member center_pos_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& center_pos_abs() const;

            /*!
             * @brief This function returns a reference to member center_pos_abs
             * @return Reference to member center_pos_abs
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& center_pos_abs();
            /*!
             * @brief This function sets a value in member theta_vehicle
             * @param _theta_vehicle New value for member theta_vehicle
             */
            eProsima_user_DllExport void theta_vehicle(
                    double _theta_vehicle);

            /*!
             * @brief This function returns the value of member theta_vehicle
             * @return Value of member theta_vehicle
             */
            eProsima_user_DllExport double theta_vehicle() const;

            /*!
             * @brief This function returns a reference to member theta_vehicle
             * @return Reference to member theta_vehicle
             */
            eProsima_user_DllExport double& theta_vehicle();

            /*!
             * @brief This function sets a value in member theta_abs
             * @param _theta_abs New value for member theta_abs
             */
            eProsima_user_DllExport void theta_abs(
                    double _theta_abs);

            /*!
             * @brief This function returns the value of member theta_abs
             * @return Value of member theta_abs
             */
            eProsima_user_DllExport double theta_abs() const;

            /*!
             * @brief This function returns a reference to member theta_abs
             * @return Reference to member theta_abs
             */
            eProsima_user_DllExport double& theta_abs();

            /*!
             * @brief This function copies the value in member velocity_vehicle
             * @param _velocity_vehicle New value to be copied in member velocity_vehicle
             */
            eProsima_user_DllExport void velocity_vehicle(
                    const ros2_interface::msg::Point3D& _velocity_vehicle);

            /*!
             * @brief This function moves the value in member velocity_vehicle
             * @param _velocity_vehicle New value to be moved in member velocity_vehicle
             */
            eProsima_user_DllExport void velocity_vehicle(
                    ros2_interface::msg::Point3D&& _velocity_vehicle);

            /*!
             * @brief This function returns a constant reference to member velocity_vehicle
             * @return Constant reference to member velocity_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& velocity_vehicle() const;

            /*!
             * @brief This function returns a reference to member velocity_vehicle
             * @return Reference to member velocity_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& velocity_vehicle();
            /*!
             * @brief This function copies the value in member velocity_abs
             * @param _velocity_abs New value to be copied in member velocity_abs
             */
            eProsima_user_DllExport void velocity_abs(
                    const ros2_interface::msg::Point3D& _velocity_abs);

            /*!
             * @brief This function moves the value in member velocity_abs
             * @param _velocity_abs New value to be moved in member velocity_abs
             */
            eProsima_user_DllExport void velocity_abs(
                    ros2_interface::msg::Point3D&& _velocity_abs);

            /*!
             * @brief This function returns a constant reference to member velocity_abs
             * @return Constant reference to member velocity_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& velocity_abs() const;

            /*!
             * @brief This function returns a reference to member velocity_abs
             * @return Reference to member velocity_abs
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& velocity_abs();
            /*!
             * @brief This function sets a value in member range_vehicle
             * @param _range_vehicle New value for member range_vehicle
             */
            eProsima_user_DllExport void range_vehicle(
                    double _range_vehicle);

            /*!
             * @brief This function returns the value of member range_vehicle
             * @return Value of member range_vehicle
             */
            eProsima_user_DllExport double range_vehicle() const;

            /*!
             * @brief This function returns a reference to member range_vehicle
             * @return Reference to member range_vehicle
             */
            eProsima_user_DllExport double& range_vehicle();

            /*!
             * @brief This function sets a value in member range_abs
             * @param _range_abs New value for member range_abs
             */
            eProsima_user_DllExport void range_abs(
                    double _range_abs);

            /*!
             * @brief This function returns the value of member range_abs
             * @return Value of member range_abs
             */
            eProsima_user_DllExport double range_abs() const;

            /*!
             * @brief This function returns a reference to member range_abs
             * @return Reference to member range_abs
             */
            eProsima_user_DllExport double& range_abs();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function copies the value in member image_key_points
             * @param _image_key_points New value to be copied in member image_key_points
             */
            eProsima_user_DllExport void image_key_points(
                    const std::vector<ros2_interface::msg::ImageKeyPoint>& _image_key_points);

            /*!
             * @brief This function moves the value in member image_key_points
             * @param _image_key_points New value to be moved in member image_key_points
             */
            eProsima_user_DllExport void image_key_points(
                    std::vector<ros2_interface::msg::ImageKeyPoint>&& _image_key_points);

            /*!
             * @brief This function returns a constant reference to member image_key_points
             * @return Constant reference to member image_key_points
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::ImageKeyPoint>& image_key_points() const;

            /*!
             * @brief This function returns a reference to member image_key_points
             * @return Reference to member image_key_points
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::ImageKeyPoint>& image_key_points();
            /*!
             * @brief This function copies the value in member polygon_point_abs
             * @param _polygon_point_abs New value to be copied in member polygon_point_abs
             */
            eProsima_user_DllExport void polygon_point_abs(
                    const std::vector<ros2_interface::msg::Point3D>& _polygon_point_abs);

            /*!
             * @brief This function moves the value in member polygon_point_abs
             * @param _polygon_point_abs New value to be moved in member polygon_point_abs
             */
            eProsima_user_DllExport void polygon_point_abs(
                    std::vector<ros2_interface::msg::Point3D>&& _polygon_point_abs);

            /*!
             * @brief This function returns a constant reference to member polygon_point_abs
             * @return Constant reference to member polygon_point_abs
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& polygon_point_abs() const;

            /*!
             * @brief This function returns a reference to member polygon_point_abs
             * @return Reference to member polygon_point_abs
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& polygon_point_abs();
            /*!
             * @brief This function copies the value in member polygon_point_vehicle
             * @param _polygon_point_vehicle New value to be copied in member polygon_point_vehicle
             */
            eProsima_user_DllExport void polygon_point_vehicle(
                    const std::vector<ros2_interface::msg::Point3D>& _polygon_point_vehicle);

            /*!
             * @brief This function moves the value in member polygon_point_vehicle
             * @param _polygon_point_vehicle New value to be moved in member polygon_point_vehicle
             */
            eProsima_user_DllExport void polygon_point_vehicle(
                    std::vector<ros2_interface::msg::Point3D>&& _polygon_point_vehicle);

            /*!
             * @brief This function returns a constant reference to member polygon_point_vehicle
             * @return Constant reference to member polygon_point_vehicle
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& polygon_point_vehicle() const;

            /*!
             * @brief This function returns a reference to member polygon_point_vehicle
             * @return Reference to member polygon_point_vehicle
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& polygon_point_vehicle();
            /*!
             * @brief This function sets a value in member tracking_time
             * @param _tracking_time New value for member tracking_time
             */
            eProsima_user_DllExport void tracking_time(
                    double _tracking_time);

            /*!
             * @brief This function returns the value of member tracking_time
             * @return Value of member tracking_time
             */
            eProsima_user_DllExport double tracking_time() const;

            /*!
             * @brief This function returns a reference to member tracking_time
             * @return Reference to member tracking_time
             */
            eProsima_user_DllExport double& tracking_time();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function sets a value in member confidence_type
             * @param _confidence_type New value for member confidence_type
             */
            eProsima_user_DllExport void confidence_type(
                    int32_t _confidence_type);

            /*!
             * @brief This function returns the value of member confidence_type
             * @return Value of member confidence_type
             */
            eProsima_user_DllExport int32_t confidence_type() const;

            /*!
             * @brief This function returns a reference to member confidence_type
             * @return Reference to member confidence_type
             */
            eProsima_user_DllExport int32_t& confidence_type();

            /*!
             * @brief This function copies the value in member drops
             * @param _drops New value to be copied in member drops
             */
            eProsima_user_DllExport void drops(
                    const std::vector<ros2_interface::msg::Point3D>& _drops);

            /*!
             * @brief This function moves the value in member drops
             * @param _drops New value to be moved in member drops
             */
            eProsima_user_DllExport void drops(
                    std::vector<ros2_interface::msg::Point3D>&& _drops);

            /*!
             * @brief This function returns a constant reference to member drops
             * @return Constant reference to member drops
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& drops() const;

            /*!
             * @brief This function returns a reference to member drops
             * @return Reference to member drops
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& drops();
            /*!
             * @brief This function copies the value in member acceleration_vehicle
             * @param _acceleration_vehicle New value to be copied in member acceleration_vehicle
             */
            eProsima_user_DllExport void acceleration_vehicle(
                    const ros2_interface::msg::Point3D& _acceleration_vehicle);

            /*!
             * @brief This function moves the value in member acceleration_vehicle
             * @param _acceleration_vehicle New value to be moved in member acceleration_vehicle
             */
            eProsima_user_DllExport void acceleration_vehicle(
                    ros2_interface::msg::Point3D&& _acceleration_vehicle);

            /*!
             * @brief This function returns a constant reference to member acceleration_vehicle
             * @return Constant reference to member acceleration_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& acceleration_vehicle() const;

            /*!
             * @brief This function returns a reference to member acceleration_vehicle
             * @return Reference to member acceleration_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& acceleration_vehicle();
            /*!
             * @brief This function copies the value in member acceleration_abs
             * @param _acceleration_abs New value to be copied in member acceleration_abs
             */
            eProsima_user_DllExport void acceleration_abs(
                    const ros2_interface::msg::Point3D& _acceleration_abs);

            /*!
             * @brief This function moves the value in member acceleration_abs
             * @param _acceleration_abs New value to be moved in member acceleration_abs
             */
            eProsima_user_DllExport void acceleration_abs(
                    ros2_interface::msg::Point3D&& _acceleration_abs);

            /*!
             * @brief This function returns a constant reference to member acceleration_abs
             * @return Constant reference to member acceleration_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& acceleration_abs() const;

            /*!
             * @brief This function returns a reference to member acceleration_abs
             * @return Reference to member acceleration_abs
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& acceleration_abs();
            /*!
             * @brief This function copies the value in member anchor_point_image
             * @param _anchor_point_image New value to be copied in member anchor_point_image
             */
            eProsima_user_DllExport void anchor_point_image(
                    const ros2_interface::msg::Point2D& _anchor_point_image);

            /*!
             * @brief This function moves the value in member anchor_point_image
             * @param _anchor_point_image New value to be moved in member anchor_point_image
             */
            eProsima_user_DllExport void anchor_point_image(
                    ros2_interface::msg::Point2D&& _anchor_point_image);

            /*!
             * @brief This function returns a constant reference to member anchor_point_image
             * @return Constant reference to member anchor_point_image
             */
            eProsima_user_DllExport const ros2_interface::msg::Point2D& anchor_point_image() const;

            /*!
             * @brief This function returns a reference to member anchor_point_image
             * @return Reference to member anchor_point_image
             */
            eProsima_user_DllExport ros2_interface::msg::Point2D& anchor_point_image();
            /*!
             * @brief This function copies the value in member anchor_point_vehicle
             * @param _anchor_point_vehicle New value to be copied in member anchor_point_vehicle
             */
            eProsima_user_DllExport void anchor_point_vehicle(
                    const ros2_interface::msg::Point3D& _anchor_point_vehicle);

            /*!
             * @brief This function moves the value in member anchor_point_vehicle
             * @param _anchor_point_vehicle New value to be moved in member anchor_point_vehicle
             */
            eProsima_user_DllExport void anchor_point_vehicle(
                    ros2_interface::msg::Point3D&& _anchor_point_vehicle);

            /*!
             * @brief This function returns a constant reference to member anchor_point_vehicle
             * @return Constant reference to member anchor_point_vehicle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& anchor_point_vehicle() const;

            /*!
             * @brief This function returns a reference to member anchor_point_vehicle
             * @return Reference to member anchor_point_vehicle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& anchor_point_vehicle();
            /*!
             * @brief This function copies the value in member anchor_point_abs
             * @param _anchor_point_abs New value to be copied in member anchor_point_abs
             */
            eProsima_user_DllExport void anchor_point_abs(
                    const ros2_interface::msg::Point3D& _anchor_point_abs);

            /*!
             * @brief This function moves the value in member anchor_point_abs
             * @param _anchor_point_abs New value to be moved in member anchor_point_abs
             */
            eProsima_user_DllExport void anchor_point_abs(
                    ros2_interface::msg::Point3D&& _anchor_point_abs);

            /*!
             * @brief This function returns a constant reference to member anchor_point_abs
             * @return Constant reference to member anchor_point_abs
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& anchor_point_abs() const;

            /*!
             * @brief This function returns a reference to member anchor_point_abs
             * @return Reference to member anchor_point_abs
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& anchor_point_abs();
            /*!
             * @brief This function copies the value in member bbox2d
             * @param _bbox2d New value to be copied in member bbox2d
             */
            eProsima_user_DllExport void bbox2d(
                    const ros2_interface::msg::BBox2D& _bbox2d);

            /*!
             * @brief This function moves the value in member bbox2d
             * @param _bbox2d New value to be moved in member bbox2d
             */
            eProsima_user_DllExport void bbox2d(
                    ros2_interface::msg::BBox2D&& _bbox2d);

            /*!
             * @brief This function returns a constant reference to member bbox2d
             * @return Constant reference to member bbox2d
             */
            eProsima_user_DllExport const ros2_interface::msg::BBox2D& bbox2d() const;

            /*!
             * @brief This function returns a reference to member bbox2d
             * @return Reference to member bbox2d
             */
            eProsima_user_DllExport ros2_interface::msg::BBox2D& bbox2d();
            /*!
             * @brief This function copies the value in member bbox2d_rear
             * @param _bbox2d_rear New value to be copied in member bbox2d_rear
             */
            eProsima_user_DllExport void bbox2d_rear(
                    const ros2_interface::msg::BBox2D& _bbox2d_rear);

            /*!
             * @brief This function moves the value in member bbox2d_rear
             * @param _bbox2d_rear New value to be moved in member bbox2d_rear
             */
            eProsima_user_DllExport void bbox2d_rear(
                    ros2_interface::msg::BBox2D&& _bbox2d_rear);

            /*!
             * @brief This function returns a constant reference to member bbox2d_rear
             * @return Constant reference to member bbox2d_rear
             */
            eProsima_user_DllExport const ros2_interface::msg::BBox2D& bbox2d_rear() const;

            /*!
             * @brief This function returns a reference to member bbox2d_rear
             * @return Reference to member bbox2d_rear
             */
            eProsima_user_DllExport ros2_interface::msg::BBox2D& bbox2d_rear();
            /*!
             * @brief This function sets a value in member sub_type
             * @param _sub_type New value for member sub_type
             */
            eProsima_user_DllExport void sub_type(
                    int32_t _sub_type);

            /*!
             * @brief This function returns the value of member sub_type
             * @return Value of member sub_type
             */
            eProsima_user_DllExport int32_t sub_type() const;

            /*!
             * @brief This function returns a reference to member sub_type
             * @return Reference to member sub_type
             */
            eProsima_user_DllExport int32_t& sub_type();

            /*!
             * @brief This function sets a value in member height_above_ground
             * @param _height_above_ground New value for member height_above_ground
             */
            eProsima_user_DllExport void height_above_ground(
                    double _height_above_ground);

            /*!
             * @brief This function returns the value of member height_above_ground
             * @return Value of member height_above_ground
             */
            eProsima_user_DllExport double height_above_ground() const;

            /*!
             * @brief This function returns a reference to member height_above_ground
             * @return Reference to member height_above_ground
             */
            eProsima_user_DllExport double& height_above_ground();

            /*!
             * @brief This function copies the value in member position_abs_covariance
             * @param _position_abs_covariance New value to be copied in member position_abs_covariance
             */
            eProsima_user_DllExport void position_abs_covariance(
                    const std::vector<double>& _position_abs_covariance);

            /*!
             * @brief This function moves the value in member position_abs_covariance
             * @param _position_abs_covariance New value to be moved in member position_abs_covariance
             */
            eProsima_user_DllExport void position_abs_covariance(
                    std::vector<double>&& _position_abs_covariance);

            /*!
             * @brief This function returns a constant reference to member position_abs_covariance
             * @return Constant reference to member position_abs_covariance
             */
            eProsima_user_DllExport const std::vector<double>& position_abs_covariance() const;

            /*!
             * @brief This function returns a reference to member position_abs_covariance
             * @return Reference to member position_abs_covariance
             */
            eProsima_user_DllExport std::vector<double>& position_abs_covariance();
            /*!
             * @brief This function copies the value in member velocity_abs_covariance
             * @param _velocity_abs_covariance New value to be copied in member velocity_abs_covariance
             */
            eProsima_user_DllExport void velocity_abs_covariance(
                    const std::vector<double>& _velocity_abs_covariance);

            /*!
             * @brief This function moves the value in member velocity_abs_covariance
             * @param _velocity_abs_covariance New value to be moved in member velocity_abs_covariance
             */
            eProsima_user_DllExport void velocity_abs_covariance(
                    std::vector<double>&& _velocity_abs_covariance);

            /*!
             * @brief This function returns a constant reference to member velocity_abs_covariance
             * @return Constant reference to member velocity_abs_covariance
             */
            eProsima_user_DllExport const std::vector<double>& velocity_abs_covariance() const;

            /*!
             * @brief This function returns a reference to member velocity_abs_covariance
             * @return Reference to member velocity_abs_covariance
             */
            eProsima_user_DllExport std::vector<double>& velocity_abs_covariance();
            /*!
             * @brief This function copies the value in member acceleration_abs_covariance
             * @param _acceleration_abs_covariance New value to be copied in member acceleration_abs_covariance
             */
            eProsima_user_DllExport void acceleration_abs_covariance(
                    const std::vector<double>& _acceleration_abs_covariance);

            /*!
             * @brief This function moves the value in member acceleration_abs_covariance
             * @param _acceleration_abs_covariance New value to be moved in member acceleration_abs_covariance
             */
            eProsima_user_DllExport void acceleration_abs_covariance(
                    std::vector<double>&& _acceleration_abs_covariance);

            /*!
             * @brief This function returns a constant reference to member acceleration_abs_covariance
             * @return Constant reference to member acceleration_abs_covariance
             */
            eProsima_user_DllExport const std::vector<double>& acceleration_abs_covariance() const;

            /*!
             * @brief This function returns a reference to member acceleration_abs_covariance
             * @return Reference to member acceleration_abs_covariance
             */
            eProsima_user_DllExport std::vector<double>& acceleration_abs_covariance();
            /*!
             * @brief This function sets a value in member theta_abs_covariance
             * @param _theta_abs_covariance New value for member theta_abs_covariance
             */
            eProsima_user_DllExport void theta_abs_covariance(
                    double _theta_abs_covariance);

            /*!
             * @brief This function returns the value of member theta_abs_covariance
             * @return Value of member theta_abs_covariance
             */
            eProsima_user_DllExport double theta_abs_covariance() const;

            /*!
             * @brief This function returns a reference to member theta_abs_covariance
             * @return Reference to member theta_abs_covariance
             */
            eProsima_user_DllExport double& theta_abs_covariance();

            /*!
             * @brief This function copies the value in member position_vehicle_covariance
             * @param _position_vehicle_covariance New value to be copied in member position_vehicle_covariance
             */
            eProsima_user_DllExport void position_vehicle_covariance(
                    const std::vector<double>& _position_vehicle_covariance);

            /*!
             * @brief This function moves the value in member position_vehicle_covariance
             * @param _position_vehicle_covariance New value to be moved in member position_vehicle_covariance
             */
            eProsima_user_DllExport void position_vehicle_covariance(
                    std::vector<double>&& _position_vehicle_covariance);

            /*!
             * @brief This function returns a constant reference to member position_vehicle_covariance
             * @return Constant reference to member position_vehicle_covariance
             */
            eProsima_user_DllExport const std::vector<double>& position_vehicle_covariance() const;

            /*!
             * @brief This function returns a reference to member position_vehicle_covariance
             * @return Reference to member position_vehicle_covariance
             */
            eProsima_user_DllExport std::vector<double>& position_vehicle_covariance();
            /*!
             * @brief This function copies the value in member velocity_vehicle_covariance
             * @param _velocity_vehicle_covariance New value to be copied in member velocity_vehicle_covariance
             */
            eProsima_user_DllExport void velocity_vehicle_covariance(
                    const std::vector<double>& _velocity_vehicle_covariance);

            /*!
             * @brief This function moves the value in member velocity_vehicle_covariance
             * @param _velocity_vehicle_covariance New value to be moved in member velocity_vehicle_covariance
             */
            eProsima_user_DllExport void velocity_vehicle_covariance(
                    std::vector<double>&& _velocity_vehicle_covariance);

            /*!
             * @brief This function returns a constant reference to member velocity_vehicle_covariance
             * @return Constant reference to member velocity_vehicle_covariance
             */
            eProsima_user_DllExport const std::vector<double>& velocity_vehicle_covariance() const;

            /*!
             * @brief This function returns a reference to member velocity_vehicle_covariance
             * @return Reference to member velocity_vehicle_covariance
             */
            eProsima_user_DllExport std::vector<double>& velocity_vehicle_covariance();
            /*!
             * @brief This function copies the value in member acceleration_vehicle_covariance
             * @param _acceleration_vehicle_covariance New value to be copied in member acceleration_vehicle_covariance
             */
            eProsima_user_DllExport void acceleration_vehicle_covariance(
                    const std::vector<double>& _acceleration_vehicle_covariance);

            /*!
             * @brief This function moves the value in member acceleration_vehicle_covariance
             * @param _acceleration_vehicle_covariance New value to be moved in member acceleration_vehicle_covariance
             */
            eProsima_user_DllExport void acceleration_vehicle_covariance(
                    std::vector<double>&& _acceleration_vehicle_covariance);

            /*!
             * @brief This function returns a constant reference to member acceleration_vehicle_covariance
             * @return Constant reference to member acceleration_vehicle_covariance
             */
            eProsima_user_DllExport const std::vector<double>& acceleration_vehicle_covariance() const;

            /*!
             * @brief This function returns a reference to member acceleration_vehicle_covariance
             * @return Reference to member acceleration_vehicle_covariance
             */
            eProsima_user_DllExport std::vector<double>& acceleration_vehicle_covariance();
            /*!
             * @brief This function sets a value in member theta_vehicle_covariance
             * @param _theta_vehicle_covariance New value for member theta_vehicle_covariance
             */
            eProsima_user_DllExport void theta_vehicle_covariance(
                    double _theta_vehicle_covariance);

            /*!
             * @brief This function returns the value of member theta_vehicle_covariance
             * @return Value of member theta_vehicle_covariance
             */
            eProsima_user_DllExport double theta_vehicle_covariance() const;

            /*!
             * @brief This function returns a reference to member theta_vehicle_covariance
             * @return Reference to member theta_vehicle_covariance
             */
            eProsima_user_DllExport double& theta_vehicle_covariance();

            /*!
             * @brief This function sets a value in member cipv_flag
             * @param _cipv_flag New value for member cipv_flag
             */
            eProsima_user_DllExport void cipv_flag(
                    uint8_t _cipv_flag);

            /*!
             * @brief This function returns the value of member cipv_flag
             * @return Value of member cipv_flag
             */
            eProsima_user_DllExport uint8_t cipv_flag() const;

            /*!
             * @brief This function returns a reference to member cipv_flag
             * @return Reference to member cipv_flag
             */
            eProsima_user_DllExport uint8_t& cipv_flag();

            /*!
             * @brief This function sets a value in member lane_position
             * @param _lane_position New value for member lane_position
             */
            eProsima_user_DllExport void lane_position(
                    int32_t _lane_position);

            /*!
             * @brief This function returns the value of member lane_position
             * @return Value of member lane_position
             */
            eProsima_user_DllExport int32_t lane_position() const;

            /*!
             * @brief This function returns a reference to member lane_position
             * @return Reference to member lane_position
             */
            eProsima_user_DllExport int32_t& lane_position();

            /*!
             * @brief This function sets a value in member pihp_percentage
             * @param _pihp_percentage New value for member pihp_percentage
             */
            eProsima_user_DllExport void pihp_percentage(
                    double _pihp_percentage);

            /*!
             * @brief This function returns the value of member pihp_percentage
             * @return Value of member pihp_percentage
             */
            eProsima_user_DllExport double pihp_percentage() const;

            /*!
             * @brief This function returns a reference to member pihp_percentage
             * @return Reference to member pihp_percentage
             */
            eProsima_user_DllExport double& pihp_percentage();

            /*!
             * @brief This function sets a value in member blinker_flag
             * @param _blinker_flag New value for member blinker_flag
             */
            eProsima_user_DllExport void blinker_flag(
                    int32_t _blinker_flag);

            /*!
             * @brief This function returns the value of member blinker_flag
             * @return Value of member blinker_flag
             */
            eProsima_user_DllExport int32_t blinker_flag() const;

            /*!
             * @brief This function returns a reference to member blinker_flag
             * @return Reference to member blinker_flag
             */
            eProsima_user_DllExport int32_t& blinker_flag();

            /*!
             * @brief This function sets a value in member fusion_type
             * @param _fusion_type New value for member fusion_type
             */
            eProsima_user_DllExport void fusion_type(
                    int32_t _fusion_type);

            /*!
             * @brief This function returns the value of member fusion_type
             * @return Value of member fusion_type
             */
            eProsima_user_DllExport int32_t fusion_type() const;

            /*!
             * @brief This function returns a reference to member fusion_type
             * @return Reference to member fusion_type
             */
            eProsima_user_DllExport int32_t& fusion_type();

            /*!
             * @brief This function sets a value in member sensor_pos_id
             * @param _sensor_pos_id New value for member sensor_pos_id
             */
            eProsima_user_DllExport void sensor_pos_id(
                    uint8_t _sensor_pos_id);

            /*!
             * @brief This function returns the value of member sensor_pos_id
             * @return Value of member sensor_pos_id
             */
            eProsima_user_DllExport uint8_t sensor_pos_id() const;

            /*!
             * @brief This function returns a reference to member sensor_pos_id
             * @return Reference to member sensor_pos_id
             */
            eProsima_user_DllExport uint8_t& sensor_pos_id();

            /*!
             * @brief This function copies the value in member predict_trajectories
             * @param _predict_trajectories New value to be copied in member predict_trajectories
             */
            eProsima_user_DllExport void predict_trajectories(
                    const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _predict_trajectories);

            /*!
             * @brief This function moves the value in member predict_trajectories
             * @param _predict_trajectories New value to be moved in member predict_trajectories
             */
            eProsima_user_DllExport void predict_trajectories(
                    std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _predict_trajectories);

            /*!
             * @brief This function returns a constant reference to member predict_trajectories
             * @return Constant reference to member predict_trajectories
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryInPrediction>& predict_trajectories() const;

            /*!
             * @brief This function returns a reference to member predict_trajectories
             * @return Reference to member predict_trajectories
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryInPrediction>& predict_trajectories();
            /*!
             * @brief This function copies the value in member intent
             * @param _intent New value to be copied in member intent
             */
            eProsima_user_DllExport void intent(
                    const ros2_interface::msg::ObstacleIntent& _intent);

            /*!
             * @brief This function moves the value in member intent
             * @param _intent New value to be moved in member intent
             */
            eProsima_user_DllExport void intent(
                    ros2_interface::msg::ObstacleIntent&& _intent);

            /*!
             * @brief This function returns a constant reference to member intent
             * @return Constant reference to member intent
             */
            eProsima_user_DllExport const ros2_interface::msg::ObstacleIntent& intent() const;

            /*!
             * @brief This function returns a reference to member intent
             * @return Reference to member intent
             */
            eProsima_user_DllExport ros2_interface::msg::ObstacleIntent& intent();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Obstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Time m_timestamp;
            int32_t m_id;
            double m_existence_prob;
            ros2_interface::msg::Time m_create_time;
            ros2_interface::msg::Time m_last_updated_time;
            ros2_interface::msg::Point3D m_center_pos_vehicle;
            ros2_interface::msg::Point3D m_center_pos_abs;
            double m_theta_vehicle;
            double m_theta_abs;
            ros2_interface::msg::Point3D m_velocity_vehicle;
            ros2_interface::msg::Point3D m_velocity_abs;
            double m_range_vehicle;
            double m_range_abs;
            double m_length;
            double m_width;
            double m_height;
            std::vector<ros2_interface::msg::ImageKeyPoint> m_image_key_points;
            std::vector<ros2_interface::msg::Point3D> m_polygon_point_abs;
            std::vector<ros2_interface::msg::Point3D> m_polygon_point_vehicle;
            double m_tracking_time;
            int32_t m_type;
            double m_confidence;
            int32_t m_confidence_type;
            std::vector<ros2_interface::msg::Point3D> m_drops;
            ros2_interface::msg::Point3D m_acceleration_vehicle;
            ros2_interface::msg::Point3D m_acceleration_abs;
            ros2_interface::msg::Point2D m_anchor_point_image;
            ros2_interface::msg::Point3D m_anchor_point_vehicle;
            ros2_interface::msg::Point3D m_anchor_point_abs;
            ros2_interface::msg::BBox2D m_bbox2d;
            ros2_interface::msg::BBox2D m_bbox2d_rear;
            int32_t m_sub_type;
            double m_height_above_ground;
            std::vector<double> m_position_abs_covariance;
            std::vector<double> m_velocity_abs_covariance;
            std::vector<double> m_acceleration_abs_covariance;
            double m_theta_abs_covariance;
            std::vector<double> m_position_vehicle_covariance;
            std::vector<double> m_velocity_vehicle_covariance;
            std::vector<double> m_acceleration_vehicle_covariance;
            double m_theta_vehicle_covariance;
            uint8_t m_cipv_flag;
            int32_t m_lane_position;
            double m_pihp_percentage;
            int32_t m_blinker_flag;
            int32_t m_fusion_type;
            uint8_t m_sensor_pos_id;
            std::vector<ros2_interface::msg::TrajectoryInPrediction> m_predict_trajectories;
            ros2_interface::msg::ObstacleIntent m_intent;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLE_H_

