// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleFeature.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObstacleFeature.h"
#include "ObstacleFeatureTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_TrajectoryPointInPrediction_max_cdr_typesize 112ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_ObstacleFeature_max_cdr_typesize 1547568ULL;
#define ros2_interface_msg_ObstaclePriority_max_cdr_typesize 4ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_cdr_typesize 15212ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_PredictionTrajectoryPoint_max_cdr_typesize 32ULL;
#define ros2_interface_msg_TrajectoryPointInPrediction_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstacleFeature_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstaclePriority_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PredictionTrajectoryPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObstacleFeature::ObstacleFeature()
{
    // long m_obstacle_id
    m_obstacle_id = 0;
    // ros2_interface::msg::Point3D m_polygon_point

    // ros2_interface::msg::Point3D m_position

    // ros2_interface::msg::Point3D m_front_position

    // ros2_interface::msg::Point3D m_velocity

    // ros2_interface::msg::Point3D m_raw_velocity

    // ros2_interface::msg::Point3D m_acceleration

    // double m_velocity_heading
    m_velocity_heading = 0.0;
    // double m_speed
    m_speed = 0.0;
    // double m_acc
    m_acc = 0.0;
    // double m_theta
    m_theta = 0.0;
    // double m_length
    m_length = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_height
    m_height = 0.0;
    // double m_tracking_time
    m_tracking_time = 0.0;
    // double m_timestamp
    m_timestamp = 0.0;
    // ros2_interface::msg::Point3D m_t_position

    // ros2_interface::msg::Point3D m_t_velocity

    // double m_t_velocity_heading
    m_t_velocity_heading = 0.0;
    // double m_t_speed
    m_t_speed = 0.0;
    // ros2_interface::msg::Point3D m_t_acceleration

    // double m_t_acc
    m_t_acc = 0.0;
    // boolean m_is_still
    m_is_still = false;
    // long m_type
    m_type = 0;
    // double m_label_update_time_delta
    m_label_update_time_delta = 0.0;
    // ros2_interface::msg::ObstaclePriority m_priority

    // boolean m_is_near_junction
    m_is_near_junction = false;
    // sequence<ros2_interface::msg::PredictionTrajectoryPoint> m_future_trajectory_points

    // sequence<ros2_interface::msg::TrajectoryPointInPrediction> m_short_term_predicted_trajectory_points

    // sequence<ros2_interface::msg::TrajectoryInPrediction> m_predicted_trajectory

    // sequence<ros2_interface::msg::TrajectoryPointInPrediction> m_adc_trajectory_point


    // Just to register all known types
    registerObstacleFeatureTypes();
}

ros2_interface::msg::ObstacleFeature::~ObstacleFeature()
{































}

ros2_interface::msg::ObstacleFeature::ObstacleFeature(
        const ObstacleFeature& x)
{
    m_obstacle_id = x.m_obstacle_id;
    m_polygon_point = x.m_polygon_point;
    m_position = x.m_position;
    m_front_position = x.m_front_position;
    m_velocity = x.m_velocity;
    m_raw_velocity = x.m_raw_velocity;
    m_acceleration = x.m_acceleration;
    m_velocity_heading = x.m_velocity_heading;
    m_speed = x.m_speed;
    m_acc = x.m_acc;
    m_theta = x.m_theta;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_tracking_time = x.m_tracking_time;
    m_timestamp = x.m_timestamp;
    m_t_position = x.m_t_position;
    m_t_velocity = x.m_t_velocity;
    m_t_velocity_heading = x.m_t_velocity_heading;
    m_t_speed = x.m_t_speed;
    m_t_acceleration = x.m_t_acceleration;
    m_t_acc = x.m_t_acc;
    m_is_still = x.m_is_still;
    m_type = x.m_type;
    m_label_update_time_delta = x.m_label_update_time_delta;
    m_priority = x.m_priority;
    m_is_near_junction = x.m_is_near_junction;
    m_future_trajectory_points = x.m_future_trajectory_points;
    m_short_term_predicted_trajectory_points = x.m_short_term_predicted_trajectory_points;
    m_predicted_trajectory = x.m_predicted_trajectory;
    m_adc_trajectory_point = x.m_adc_trajectory_point;
}

ros2_interface::msg::ObstacleFeature::ObstacleFeature(
        ObstacleFeature&& x) noexcept 
{
    m_obstacle_id = x.m_obstacle_id;
    m_polygon_point = std::move(x.m_polygon_point);
    m_position = std::move(x.m_position);
    m_front_position = std::move(x.m_front_position);
    m_velocity = std::move(x.m_velocity);
    m_raw_velocity = std::move(x.m_raw_velocity);
    m_acceleration = std::move(x.m_acceleration);
    m_velocity_heading = x.m_velocity_heading;
    m_speed = x.m_speed;
    m_acc = x.m_acc;
    m_theta = x.m_theta;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_tracking_time = x.m_tracking_time;
    m_timestamp = x.m_timestamp;
    m_t_position = std::move(x.m_t_position);
    m_t_velocity = std::move(x.m_t_velocity);
    m_t_velocity_heading = x.m_t_velocity_heading;
    m_t_speed = x.m_t_speed;
    m_t_acceleration = std::move(x.m_t_acceleration);
    m_t_acc = x.m_t_acc;
    m_is_still = x.m_is_still;
    m_type = x.m_type;
    m_label_update_time_delta = x.m_label_update_time_delta;
    m_priority = std::move(x.m_priority);
    m_is_near_junction = x.m_is_near_junction;
    m_future_trajectory_points = std::move(x.m_future_trajectory_points);
    m_short_term_predicted_trajectory_points = std::move(x.m_short_term_predicted_trajectory_points);
    m_predicted_trajectory = std::move(x.m_predicted_trajectory);
    m_adc_trajectory_point = std::move(x.m_adc_trajectory_point);
}

ros2_interface::msg::ObstacleFeature& ros2_interface::msg::ObstacleFeature::operator =(
        const ObstacleFeature& x)
{

    m_obstacle_id = x.m_obstacle_id;
    m_polygon_point = x.m_polygon_point;
    m_position = x.m_position;
    m_front_position = x.m_front_position;
    m_velocity = x.m_velocity;
    m_raw_velocity = x.m_raw_velocity;
    m_acceleration = x.m_acceleration;
    m_velocity_heading = x.m_velocity_heading;
    m_speed = x.m_speed;
    m_acc = x.m_acc;
    m_theta = x.m_theta;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_tracking_time = x.m_tracking_time;
    m_timestamp = x.m_timestamp;
    m_t_position = x.m_t_position;
    m_t_velocity = x.m_t_velocity;
    m_t_velocity_heading = x.m_t_velocity_heading;
    m_t_speed = x.m_t_speed;
    m_t_acceleration = x.m_t_acceleration;
    m_t_acc = x.m_t_acc;
    m_is_still = x.m_is_still;
    m_type = x.m_type;
    m_label_update_time_delta = x.m_label_update_time_delta;
    m_priority = x.m_priority;
    m_is_near_junction = x.m_is_near_junction;
    m_future_trajectory_points = x.m_future_trajectory_points;
    m_short_term_predicted_trajectory_points = x.m_short_term_predicted_trajectory_points;
    m_predicted_trajectory = x.m_predicted_trajectory;
    m_adc_trajectory_point = x.m_adc_trajectory_point;

    return *this;
}

ros2_interface::msg::ObstacleFeature& ros2_interface::msg::ObstacleFeature::operator =(
        ObstacleFeature&& x) noexcept
{

    m_obstacle_id = x.m_obstacle_id;
    m_polygon_point = std::move(x.m_polygon_point);
    m_position = std::move(x.m_position);
    m_front_position = std::move(x.m_front_position);
    m_velocity = std::move(x.m_velocity);
    m_raw_velocity = std::move(x.m_raw_velocity);
    m_acceleration = std::move(x.m_acceleration);
    m_velocity_heading = x.m_velocity_heading;
    m_speed = x.m_speed;
    m_acc = x.m_acc;
    m_theta = x.m_theta;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_tracking_time = x.m_tracking_time;
    m_timestamp = x.m_timestamp;
    m_t_position = std::move(x.m_t_position);
    m_t_velocity = std::move(x.m_t_velocity);
    m_t_velocity_heading = x.m_t_velocity_heading;
    m_t_speed = x.m_t_speed;
    m_t_acceleration = std::move(x.m_t_acceleration);
    m_t_acc = x.m_t_acc;
    m_is_still = x.m_is_still;
    m_type = x.m_type;
    m_label_update_time_delta = x.m_label_update_time_delta;
    m_priority = std::move(x.m_priority);
    m_is_near_junction = x.m_is_near_junction;
    m_future_trajectory_points = std::move(x.m_future_trajectory_points);
    m_short_term_predicted_trajectory_points = std::move(x.m_short_term_predicted_trajectory_points);
    m_predicted_trajectory = std::move(x.m_predicted_trajectory);
    m_adc_trajectory_point = std::move(x.m_adc_trajectory_point);

    return *this;
}

bool ros2_interface::msg::ObstacleFeature::operator ==(
        const ObstacleFeature& x) const
{

    return (m_obstacle_id == x.m_obstacle_id && m_polygon_point == x.m_polygon_point && m_position == x.m_position && m_front_position == x.m_front_position && m_velocity == x.m_velocity && m_raw_velocity == x.m_raw_velocity && m_acceleration == x.m_acceleration && m_velocity_heading == x.m_velocity_heading && m_speed == x.m_speed && m_acc == x.m_acc && m_theta == x.m_theta && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_tracking_time == x.m_tracking_time && m_timestamp == x.m_timestamp && m_t_position == x.m_t_position && m_t_velocity == x.m_t_velocity && m_t_velocity_heading == x.m_t_velocity_heading && m_t_speed == x.m_t_speed && m_t_acceleration == x.m_t_acceleration && m_t_acc == x.m_t_acc && m_is_still == x.m_is_still && m_type == x.m_type && m_label_update_time_delta == x.m_label_update_time_delta && m_priority == x.m_priority && m_is_near_junction == x.m_is_near_junction && m_future_trajectory_points == x.m_future_trajectory_points && m_short_term_predicted_trajectory_points == x.m_short_term_predicted_trajectory_points && m_predicted_trajectory == x.m_predicted_trajectory && m_adc_trajectory_point == x.m_adc_trajectory_point);
}

bool ros2_interface::msg::ObstacleFeature::operator !=(
        const ObstacleFeature& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObstacleFeature::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleFeature_max_cdr_typesize;
}

size_t ros2_interface::msg::ObstacleFeature::getCdrSerializedSize(
        const ros2_interface::msg::ObstacleFeature& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.polygon_point(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.front_position(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.raw_velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.acceleration(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.t_position(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.t_velocity(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.t_acceleration(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::ObstaclePriority::getCdrSerializedSize(data.priority(), current_alignment);
    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.future_trajectory_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::PredictionTrajectoryPoint::getCdrSerializedSize(data.future_trajectory_points().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.short_term_predicted_trajectory_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryPointInPrediction::getCdrSerializedSize(data.short_term_predicted_trajectory_points().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.predicted_trajectory().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryInPrediction::getCdrSerializedSize(data.predicted_trajectory().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.adc_trajectory_point().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryPointInPrediction::getCdrSerializedSize(data.adc_trajectory_point().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObstacleFeature::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_obstacle_id;
    scdr << m_polygon_point;
    scdr << m_position;
    scdr << m_front_position;
    scdr << m_velocity;
    scdr << m_raw_velocity;
    scdr << m_acceleration;
    scdr << m_velocity_heading;
    scdr << m_speed;
    scdr << m_acc;
    scdr << m_theta;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_tracking_time;
    scdr << m_timestamp;
    scdr << m_t_position;
    scdr << m_t_velocity;
    scdr << m_t_velocity_heading;
    scdr << m_t_speed;
    scdr << m_t_acceleration;
    scdr << m_t_acc;
    scdr << m_is_still;
    scdr << m_type;
    scdr << m_label_update_time_delta;
    scdr << m_priority;
    scdr << m_is_near_junction;
    scdr << m_future_trajectory_points;
    scdr << m_short_term_predicted_trajectory_points;
    scdr << m_predicted_trajectory;
    scdr << m_adc_trajectory_point;

}

void ros2_interface::msg::ObstacleFeature::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_obstacle_id;
    dcdr >> m_polygon_point;
    dcdr >> m_position;
    dcdr >> m_front_position;
    dcdr >> m_velocity;
    dcdr >> m_raw_velocity;
    dcdr >> m_acceleration;
    dcdr >> m_velocity_heading;
    dcdr >> m_speed;
    dcdr >> m_acc;
    dcdr >> m_theta;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_tracking_time;
    dcdr >> m_timestamp;
    dcdr >> m_t_position;
    dcdr >> m_t_velocity;
    dcdr >> m_t_velocity_heading;
    dcdr >> m_t_speed;
    dcdr >> m_t_acceleration;
    dcdr >> m_t_acc;
    dcdr >> m_is_still;
    dcdr >> m_type;
    dcdr >> m_label_update_time_delta;
    dcdr >> m_priority;
    dcdr >> m_is_near_junction;
    dcdr >> m_future_trajectory_points;
    dcdr >> m_short_term_predicted_trajectory_points;
    dcdr >> m_predicted_trajectory;
    dcdr >> m_adc_trajectory_point;
}

/*!
 * @brief This function sets a value in member obstacle_id
 * @param _obstacle_id New value for member obstacle_id
 */
void ros2_interface::msg::ObstacleFeature::obstacle_id(
        int32_t _obstacle_id)
{
    m_obstacle_id = _obstacle_id;
}

/*!
 * @brief This function returns the value of member obstacle_id
 * @return Value of member obstacle_id
 */
int32_t ros2_interface::msg::ObstacleFeature::obstacle_id() const
{
    return m_obstacle_id;
}

/*!
 * @brief This function returns a reference to member obstacle_id
 * @return Reference to member obstacle_id
 */
int32_t& ros2_interface::msg::ObstacleFeature::obstacle_id()
{
    return m_obstacle_id;
}

/*!
 * @brief This function copies the value in member polygon_point
 * @param _polygon_point New value to be copied in member polygon_point
 */
void ros2_interface::msg::ObstacleFeature::polygon_point(
        const ros2_interface::msg::Point3D& _polygon_point)
{
    m_polygon_point = _polygon_point;
}

/*!
 * @brief This function moves the value in member polygon_point
 * @param _polygon_point New value to be moved in member polygon_point
 */
void ros2_interface::msg::ObstacleFeature::polygon_point(
        ros2_interface::msg::Point3D&& _polygon_point)
{
    m_polygon_point = std::move(_polygon_point);
}

/*!
 * @brief This function returns a constant reference to member polygon_point
 * @return Constant reference to member polygon_point
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::polygon_point() const
{
    return m_polygon_point;
}

/*!
 * @brief This function returns a reference to member polygon_point
 * @return Reference to member polygon_point
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::polygon_point()
{
    return m_polygon_point;
}
/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::ObstacleFeature::position(
        const ros2_interface::msg::Point3D& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::ObstacleFeature::position(
        ros2_interface::msg::Point3D&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::position()
{
    return m_position;
}
/*!
 * @brief This function copies the value in member front_position
 * @param _front_position New value to be copied in member front_position
 */
void ros2_interface::msg::ObstacleFeature::front_position(
        const ros2_interface::msg::Point3D& _front_position)
{
    m_front_position = _front_position;
}

/*!
 * @brief This function moves the value in member front_position
 * @param _front_position New value to be moved in member front_position
 */
void ros2_interface::msg::ObstacleFeature::front_position(
        ros2_interface::msg::Point3D&& _front_position)
{
    m_front_position = std::move(_front_position);
}

/*!
 * @brief This function returns a constant reference to member front_position
 * @return Constant reference to member front_position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::front_position() const
{
    return m_front_position;
}

/*!
 * @brief This function returns a reference to member front_position
 * @return Reference to member front_position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::front_position()
{
    return m_front_position;
}
/*!
 * @brief This function copies the value in member velocity
 * @param _velocity New value to be copied in member velocity
 */
void ros2_interface::msg::ObstacleFeature::velocity(
        const ros2_interface::msg::Point3D& _velocity)
{
    m_velocity = _velocity;
}

/*!
 * @brief This function moves the value in member velocity
 * @param _velocity New value to be moved in member velocity
 */
void ros2_interface::msg::ObstacleFeature::velocity(
        ros2_interface::msg::Point3D&& _velocity)
{
    m_velocity = std::move(_velocity);
}

/*!
 * @brief This function returns a constant reference to member velocity
 * @return Constant reference to member velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::velocity() const
{
    return m_velocity;
}

/*!
 * @brief This function returns a reference to member velocity
 * @return Reference to member velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::velocity()
{
    return m_velocity;
}
/*!
 * @brief This function copies the value in member raw_velocity
 * @param _raw_velocity New value to be copied in member raw_velocity
 */
void ros2_interface::msg::ObstacleFeature::raw_velocity(
        const ros2_interface::msg::Point3D& _raw_velocity)
{
    m_raw_velocity = _raw_velocity;
}

/*!
 * @brief This function moves the value in member raw_velocity
 * @param _raw_velocity New value to be moved in member raw_velocity
 */
void ros2_interface::msg::ObstacleFeature::raw_velocity(
        ros2_interface::msg::Point3D&& _raw_velocity)
{
    m_raw_velocity = std::move(_raw_velocity);
}

/*!
 * @brief This function returns a constant reference to member raw_velocity
 * @return Constant reference to member raw_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::raw_velocity() const
{
    return m_raw_velocity;
}

/*!
 * @brief This function returns a reference to member raw_velocity
 * @return Reference to member raw_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::raw_velocity()
{
    return m_raw_velocity;
}
/*!
 * @brief This function copies the value in member acceleration
 * @param _acceleration New value to be copied in member acceleration
 */
void ros2_interface::msg::ObstacleFeature::acceleration(
        const ros2_interface::msg::Point3D& _acceleration)
{
    m_acceleration = _acceleration;
}

/*!
 * @brief This function moves the value in member acceleration
 * @param _acceleration New value to be moved in member acceleration
 */
void ros2_interface::msg::ObstacleFeature::acceleration(
        ros2_interface::msg::Point3D&& _acceleration)
{
    m_acceleration = std::move(_acceleration);
}

/*!
 * @brief This function returns a constant reference to member acceleration
 * @return Constant reference to member acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::acceleration() const
{
    return m_acceleration;
}

/*!
 * @brief This function returns a reference to member acceleration
 * @return Reference to member acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::acceleration()
{
    return m_acceleration;
}
/*!
 * @brief This function sets a value in member velocity_heading
 * @param _velocity_heading New value for member velocity_heading
 */
void ros2_interface::msg::ObstacleFeature::velocity_heading(
        double _velocity_heading)
{
    m_velocity_heading = _velocity_heading;
}

/*!
 * @brief This function returns the value of member velocity_heading
 * @return Value of member velocity_heading
 */
double ros2_interface::msg::ObstacleFeature::velocity_heading() const
{
    return m_velocity_heading;
}

/*!
 * @brief This function returns a reference to member velocity_heading
 * @return Reference to member velocity_heading
 */
double& ros2_interface::msg::ObstacleFeature::velocity_heading()
{
    return m_velocity_heading;
}

/*!
 * @brief This function sets a value in member speed
 * @param _speed New value for member speed
 */
void ros2_interface::msg::ObstacleFeature::speed(
        double _speed)
{
    m_speed = _speed;
}

/*!
 * @brief This function returns the value of member speed
 * @return Value of member speed
 */
double ros2_interface::msg::ObstacleFeature::speed() const
{
    return m_speed;
}

/*!
 * @brief This function returns a reference to member speed
 * @return Reference to member speed
 */
double& ros2_interface::msg::ObstacleFeature::speed()
{
    return m_speed;
}

/*!
 * @brief This function sets a value in member acc
 * @param _acc New value for member acc
 */
void ros2_interface::msg::ObstacleFeature::acc(
        double _acc)
{
    m_acc = _acc;
}

/*!
 * @brief This function returns the value of member acc
 * @return Value of member acc
 */
double ros2_interface::msg::ObstacleFeature::acc() const
{
    return m_acc;
}

/*!
 * @brief This function returns a reference to member acc
 * @return Reference to member acc
 */
double& ros2_interface::msg::ObstacleFeature::acc()
{
    return m_acc;
}

/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::ObstacleFeature::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::ObstacleFeature::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::ObstacleFeature::theta()
{
    return m_theta;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::ObstacleFeature::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::ObstacleFeature::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::ObstacleFeature::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::ObstacleFeature::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::ObstacleFeature::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::ObstacleFeature::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::ObstacleFeature::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::ObstacleFeature::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::ObstacleFeature::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member tracking_time
 * @param _tracking_time New value for member tracking_time
 */
void ros2_interface::msg::ObstacleFeature::tracking_time(
        double _tracking_time)
{
    m_tracking_time = _tracking_time;
}

/*!
 * @brief This function returns the value of member tracking_time
 * @return Value of member tracking_time
 */
double ros2_interface::msg::ObstacleFeature::tracking_time() const
{
    return m_tracking_time;
}

/*!
 * @brief This function returns a reference to member tracking_time
 * @return Reference to member tracking_time
 */
double& ros2_interface::msg::ObstacleFeature::tracking_time()
{
    return m_tracking_time;
}

/*!
 * @brief This function sets a value in member timestamp
 * @param _timestamp New value for member timestamp
 */
void ros2_interface::msg::ObstacleFeature::timestamp(
        double _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function returns the value of member timestamp
 * @return Value of member timestamp
 */
double ros2_interface::msg::ObstacleFeature::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
double& ros2_interface::msg::ObstacleFeature::timestamp()
{
    return m_timestamp;
}

/*!
 * @brief This function copies the value in member t_position
 * @param _t_position New value to be copied in member t_position
 */
void ros2_interface::msg::ObstacleFeature::t_position(
        const ros2_interface::msg::Point3D& _t_position)
{
    m_t_position = _t_position;
}

/*!
 * @brief This function moves the value in member t_position
 * @param _t_position New value to be moved in member t_position
 */
void ros2_interface::msg::ObstacleFeature::t_position(
        ros2_interface::msg::Point3D&& _t_position)
{
    m_t_position = std::move(_t_position);
}

/*!
 * @brief This function returns a constant reference to member t_position
 * @return Constant reference to member t_position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_position() const
{
    return m_t_position;
}

/*!
 * @brief This function returns a reference to member t_position
 * @return Reference to member t_position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_position()
{
    return m_t_position;
}
/*!
 * @brief This function copies the value in member t_velocity
 * @param _t_velocity New value to be copied in member t_velocity
 */
void ros2_interface::msg::ObstacleFeature::t_velocity(
        const ros2_interface::msg::Point3D& _t_velocity)
{
    m_t_velocity = _t_velocity;
}

/*!
 * @brief This function moves the value in member t_velocity
 * @param _t_velocity New value to be moved in member t_velocity
 */
void ros2_interface::msg::ObstacleFeature::t_velocity(
        ros2_interface::msg::Point3D&& _t_velocity)
{
    m_t_velocity = std::move(_t_velocity);
}

/*!
 * @brief This function returns a constant reference to member t_velocity
 * @return Constant reference to member t_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_velocity() const
{
    return m_t_velocity;
}

/*!
 * @brief This function returns a reference to member t_velocity
 * @return Reference to member t_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_velocity()
{
    return m_t_velocity;
}
/*!
 * @brief This function sets a value in member t_velocity_heading
 * @param _t_velocity_heading New value for member t_velocity_heading
 */
void ros2_interface::msg::ObstacleFeature::t_velocity_heading(
        double _t_velocity_heading)
{
    m_t_velocity_heading = _t_velocity_heading;
}

/*!
 * @brief This function returns the value of member t_velocity_heading
 * @return Value of member t_velocity_heading
 */
double ros2_interface::msg::ObstacleFeature::t_velocity_heading() const
{
    return m_t_velocity_heading;
}

/*!
 * @brief This function returns a reference to member t_velocity_heading
 * @return Reference to member t_velocity_heading
 */
double& ros2_interface::msg::ObstacleFeature::t_velocity_heading()
{
    return m_t_velocity_heading;
}

/*!
 * @brief This function sets a value in member t_speed
 * @param _t_speed New value for member t_speed
 */
void ros2_interface::msg::ObstacleFeature::t_speed(
        double _t_speed)
{
    m_t_speed = _t_speed;
}

/*!
 * @brief This function returns the value of member t_speed
 * @return Value of member t_speed
 */
double ros2_interface::msg::ObstacleFeature::t_speed() const
{
    return m_t_speed;
}

/*!
 * @brief This function returns a reference to member t_speed
 * @return Reference to member t_speed
 */
double& ros2_interface::msg::ObstacleFeature::t_speed()
{
    return m_t_speed;
}

/*!
 * @brief This function copies the value in member t_acceleration
 * @param _t_acceleration New value to be copied in member t_acceleration
 */
void ros2_interface::msg::ObstacleFeature::t_acceleration(
        const ros2_interface::msg::Point3D& _t_acceleration)
{
    m_t_acceleration = _t_acceleration;
}

/*!
 * @brief This function moves the value in member t_acceleration
 * @param _t_acceleration New value to be moved in member t_acceleration
 */
void ros2_interface::msg::ObstacleFeature::t_acceleration(
        ros2_interface::msg::Point3D&& _t_acceleration)
{
    m_t_acceleration = std::move(_t_acceleration);
}

/*!
 * @brief This function returns a constant reference to member t_acceleration
 * @return Constant reference to member t_acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_acceleration() const
{
    return m_t_acceleration;
}

/*!
 * @brief This function returns a reference to member t_acceleration
 * @return Reference to member t_acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ObstacleFeature::t_acceleration()
{
    return m_t_acceleration;
}
/*!
 * @brief This function sets a value in member t_acc
 * @param _t_acc New value for member t_acc
 */
void ros2_interface::msg::ObstacleFeature::t_acc(
        double _t_acc)
{
    m_t_acc = _t_acc;
}

/*!
 * @brief This function returns the value of member t_acc
 * @return Value of member t_acc
 */
double ros2_interface::msg::ObstacleFeature::t_acc() const
{
    return m_t_acc;
}

/*!
 * @brief This function returns a reference to member t_acc
 * @return Reference to member t_acc
 */
double& ros2_interface::msg::ObstacleFeature::t_acc()
{
    return m_t_acc;
}

/*!
 * @brief This function sets a value in member is_still
 * @param _is_still New value for member is_still
 */
void ros2_interface::msg::ObstacleFeature::is_still(
        bool _is_still)
{
    m_is_still = _is_still;
}

/*!
 * @brief This function returns the value of member is_still
 * @return Value of member is_still
 */
bool ros2_interface::msg::ObstacleFeature::is_still() const
{
    return m_is_still;
}

/*!
 * @brief This function returns a reference to member is_still
 * @return Reference to member is_still
 */
bool& ros2_interface::msg::ObstacleFeature::is_still()
{
    return m_is_still;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::ObstacleFeature::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::ObstacleFeature::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::ObstacleFeature::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member label_update_time_delta
 * @param _label_update_time_delta New value for member label_update_time_delta
 */
void ros2_interface::msg::ObstacleFeature::label_update_time_delta(
        double _label_update_time_delta)
{
    m_label_update_time_delta = _label_update_time_delta;
}

/*!
 * @brief This function returns the value of member label_update_time_delta
 * @return Value of member label_update_time_delta
 */
double ros2_interface::msg::ObstacleFeature::label_update_time_delta() const
{
    return m_label_update_time_delta;
}

/*!
 * @brief This function returns a reference to member label_update_time_delta
 * @return Reference to member label_update_time_delta
 */
double& ros2_interface::msg::ObstacleFeature::label_update_time_delta()
{
    return m_label_update_time_delta;
}

/*!
 * @brief This function copies the value in member priority
 * @param _priority New value to be copied in member priority
 */
void ros2_interface::msg::ObstacleFeature::priority(
        const ros2_interface::msg::ObstaclePriority& _priority)
{
    m_priority = _priority;
}

/*!
 * @brief This function moves the value in member priority
 * @param _priority New value to be moved in member priority
 */
void ros2_interface::msg::ObstacleFeature::priority(
        ros2_interface::msg::ObstaclePriority&& _priority)
{
    m_priority = std::move(_priority);
}

/*!
 * @brief This function returns a constant reference to member priority
 * @return Constant reference to member priority
 */
const ros2_interface::msg::ObstaclePriority& ros2_interface::msg::ObstacleFeature::priority() const
{
    return m_priority;
}

/*!
 * @brief This function returns a reference to member priority
 * @return Reference to member priority
 */
ros2_interface::msg::ObstaclePriority& ros2_interface::msg::ObstacleFeature::priority()
{
    return m_priority;
}
/*!
 * @brief This function sets a value in member is_near_junction
 * @param _is_near_junction New value for member is_near_junction
 */
void ros2_interface::msg::ObstacleFeature::is_near_junction(
        bool _is_near_junction)
{
    m_is_near_junction = _is_near_junction;
}

/*!
 * @brief This function returns the value of member is_near_junction
 * @return Value of member is_near_junction
 */
bool ros2_interface::msg::ObstacleFeature::is_near_junction() const
{
    return m_is_near_junction;
}

/*!
 * @brief This function returns a reference to member is_near_junction
 * @return Reference to member is_near_junction
 */
bool& ros2_interface::msg::ObstacleFeature::is_near_junction()
{
    return m_is_near_junction;
}

/*!
 * @brief This function copies the value in member future_trajectory_points
 * @param _future_trajectory_points New value to be copied in member future_trajectory_points
 */
void ros2_interface::msg::ObstacleFeature::future_trajectory_points(
        const std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& _future_trajectory_points)
{
    m_future_trajectory_points = _future_trajectory_points;
}

/*!
 * @brief This function moves the value in member future_trajectory_points
 * @param _future_trajectory_points New value to be moved in member future_trajectory_points
 */
void ros2_interface::msg::ObstacleFeature::future_trajectory_points(
        std::vector<ros2_interface::msg::PredictionTrajectoryPoint>&& _future_trajectory_points)
{
    m_future_trajectory_points = std::move(_future_trajectory_points);
}

/*!
 * @brief This function returns a constant reference to member future_trajectory_points
 * @return Constant reference to member future_trajectory_points
 */
const std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& ros2_interface::msg::ObstacleFeature::future_trajectory_points() const
{
    return m_future_trajectory_points;
}

/*!
 * @brief This function returns a reference to member future_trajectory_points
 * @return Reference to member future_trajectory_points
 */
std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& ros2_interface::msg::ObstacleFeature::future_trajectory_points()
{
    return m_future_trajectory_points;
}
/*!
 * @brief This function copies the value in member short_term_predicted_trajectory_points
 * @param _short_term_predicted_trajectory_points New value to be copied in member short_term_predicted_trajectory_points
 */
void ros2_interface::msg::ObstacleFeature::short_term_predicted_trajectory_points(
        const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& _short_term_predicted_trajectory_points)
{
    m_short_term_predicted_trajectory_points = _short_term_predicted_trajectory_points;
}

/*!
 * @brief This function moves the value in member short_term_predicted_trajectory_points
 * @param _short_term_predicted_trajectory_points New value to be moved in member short_term_predicted_trajectory_points
 */
void ros2_interface::msg::ObstacleFeature::short_term_predicted_trajectory_points(
        std::vector<ros2_interface::msg::TrajectoryPointInPrediction>&& _short_term_predicted_trajectory_points)
{
    m_short_term_predicted_trajectory_points = std::move(_short_term_predicted_trajectory_points);
}

/*!
 * @brief This function returns a constant reference to member short_term_predicted_trajectory_points
 * @return Constant reference to member short_term_predicted_trajectory_points
 */
const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& ros2_interface::msg::ObstacleFeature::short_term_predicted_trajectory_points() const
{
    return m_short_term_predicted_trajectory_points;
}

/*!
 * @brief This function returns a reference to member short_term_predicted_trajectory_points
 * @return Reference to member short_term_predicted_trajectory_points
 */
std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& ros2_interface::msg::ObstacleFeature::short_term_predicted_trajectory_points()
{
    return m_short_term_predicted_trajectory_points;
}
/*!
 * @brief This function copies the value in member predicted_trajectory
 * @param _predicted_trajectory New value to be copied in member predicted_trajectory
 */
void ros2_interface::msg::ObstacleFeature::predicted_trajectory(
        const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _predicted_trajectory)
{
    m_predicted_trajectory = _predicted_trajectory;
}

/*!
 * @brief This function moves the value in member predicted_trajectory
 * @param _predicted_trajectory New value to be moved in member predicted_trajectory
 */
void ros2_interface::msg::ObstacleFeature::predicted_trajectory(
        std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _predicted_trajectory)
{
    m_predicted_trajectory = std::move(_predicted_trajectory);
}

/*!
 * @brief This function returns a constant reference to member predicted_trajectory
 * @return Constant reference to member predicted_trajectory
 */
const std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::ObstacleFeature::predicted_trajectory() const
{
    return m_predicted_trajectory;
}

/*!
 * @brief This function returns a reference to member predicted_trajectory
 * @return Reference to member predicted_trajectory
 */
std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::ObstacleFeature::predicted_trajectory()
{
    return m_predicted_trajectory;
}
/*!
 * @brief This function copies the value in member adc_trajectory_point
 * @param _adc_trajectory_point New value to be copied in member adc_trajectory_point
 */
void ros2_interface::msg::ObstacleFeature::adc_trajectory_point(
        const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& _adc_trajectory_point)
{
    m_adc_trajectory_point = _adc_trajectory_point;
}

/*!
 * @brief This function moves the value in member adc_trajectory_point
 * @param _adc_trajectory_point New value to be moved in member adc_trajectory_point
 */
void ros2_interface::msg::ObstacleFeature::adc_trajectory_point(
        std::vector<ros2_interface::msg::TrajectoryPointInPrediction>&& _adc_trajectory_point)
{
    m_adc_trajectory_point = std::move(_adc_trajectory_point);
}

/*!
 * @brief This function returns a constant reference to member adc_trajectory_point
 * @return Constant reference to member adc_trajectory_point
 */
const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& ros2_interface::msg::ObstacleFeature::adc_trajectory_point() const
{
    return m_adc_trajectory_point;
}

/*!
 * @brief This function returns a reference to member adc_trajectory_point
 * @return Reference to member adc_trajectory_point
 */
std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& ros2_interface::msg::ObstacleFeature::adc_trajectory_point()
{
    return m_adc_trajectory_point;
}


size_t ros2_interface::msg::ObstacleFeature::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleFeature_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObstacleFeature::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObstacleFeature::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



