// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleFeature.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLEFEATURE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLEFEATURE_H_

#include "ObstaclePriority.h"
#include "TrajectoryPointInPrediction.h"
#include "TrajectoryInPrediction.h"
#include "PredictionTrajectoryPoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(OBSTACLEFEATURE_SOURCE)
#define OBSTACLEFEATURE_DllAPI __declspec( dllexport )
#else
#define OBSTACLEFEATURE_DllAPI __declspec( dllimport )
#endif // OBSTACLEFEATURE_SOURCE
#else
#define OBSTACLEFEATURE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define OBSTACLEFEATURE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ObstacleFeature defined by the user in the IDL file.
         * @ingroup ObstacleFeature
         */
        class ObstacleFeature
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ObstacleFeature();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ObstacleFeature();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ObstacleFeature that will be copied.
             */
            eProsima_user_DllExport ObstacleFeature(
                    const ObstacleFeature& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ObstacleFeature that will be copied.
             */
            eProsima_user_DllExport ObstacleFeature(
                    ObstacleFeature&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ObstacleFeature that will be copied.
             */
            eProsima_user_DllExport ObstacleFeature& operator =(
                    const ObstacleFeature& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ObstacleFeature that will be copied.
             */
            eProsima_user_DllExport ObstacleFeature& operator =(
                    ObstacleFeature&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ObstacleFeature object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ObstacleFeature& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ObstacleFeature object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ObstacleFeature& x) const;

            /*!
             * @brief This function sets a value in member obstacle_id
             * @param _obstacle_id New value for member obstacle_id
             */
            eProsima_user_DllExport void obstacle_id(
                    int32_t _obstacle_id);

            /*!
             * @brief This function returns the value of member obstacle_id
             * @return Value of member obstacle_id
             */
            eProsima_user_DllExport int32_t obstacle_id() const;

            /*!
             * @brief This function returns a reference to member obstacle_id
             * @return Reference to member obstacle_id
             */
            eProsima_user_DllExport int32_t& obstacle_id();

            /*!
             * @brief This function copies the value in member polygon_point
             * @param _polygon_point New value to be copied in member polygon_point
             */
            eProsima_user_DllExport void polygon_point(
                    const ros2_interface::msg::Point3D& _polygon_point);

            /*!
             * @brief This function moves the value in member polygon_point
             * @param _polygon_point New value to be moved in member polygon_point
             */
            eProsima_user_DllExport void polygon_point(
                    ros2_interface::msg::Point3D&& _polygon_point);

            /*!
             * @brief This function returns a constant reference to member polygon_point
             * @return Constant reference to member polygon_point
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& polygon_point() const;

            /*!
             * @brief This function returns a reference to member polygon_point
             * @return Reference to member polygon_point
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& polygon_point();
            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::Point3D& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::Point3D&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& position();
            /*!
             * @brief This function copies the value in member front_position
             * @param _front_position New value to be copied in member front_position
             */
            eProsima_user_DllExport void front_position(
                    const ros2_interface::msg::Point3D& _front_position);

            /*!
             * @brief This function moves the value in member front_position
             * @param _front_position New value to be moved in member front_position
             */
            eProsima_user_DllExport void front_position(
                    ros2_interface::msg::Point3D&& _front_position);

            /*!
             * @brief This function returns a constant reference to member front_position
             * @return Constant reference to member front_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& front_position() const;

            /*!
             * @brief This function returns a reference to member front_position
             * @return Reference to member front_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& front_position();
            /*!
             * @brief This function copies the value in member velocity
             * @param _velocity New value to be copied in member velocity
             */
            eProsima_user_DllExport void velocity(
                    const ros2_interface::msg::Point3D& _velocity);

            /*!
             * @brief This function moves the value in member velocity
             * @param _velocity New value to be moved in member velocity
             */
            eProsima_user_DllExport void velocity(
                    ros2_interface::msg::Point3D&& _velocity);

            /*!
             * @brief This function returns a constant reference to member velocity
             * @return Constant reference to member velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& velocity() const;

            /*!
             * @brief This function returns a reference to member velocity
             * @return Reference to member velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& velocity();
            /*!
             * @brief This function copies the value in member raw_velocity
             * @param _raw_velocity New value to be copied in member raw_velocity
             */
            eProsima_user_DllExport void raw_velocity(
                    const ros2_interface::msg::Point3D& _raw_velocity);

            /*!
             * @brief This function moves the value in member raw_velocity
             * @param _raw_velocity New value to be moved in member raw_velocity
             */
            eProsima_user_DllExport void raw_velocity(
                    ros2_interface::msg::Point3D&& _raw_velocity);

            /*!
             * @brief This function returns a constant reference to member raw_velocity
             * @return Constant reference to member raw_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& raw_velocity() const;

            /*!
             * @brief This function returns a reference to member raw_velocity
             * @return Reference to member raw_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& raw_velocity();
            /*!
             * @brief This function copies the value in member acceleration
             * @param _acceleration New value to be copied in member acceleration
             */
            eProsima_user_DllExport void acceleration(
                    const ros2_interface::msg::Point3D& _acceleration);

            /*!
             * @brief This function moves the value in member acceleration
             * @param _acceleration New value to be moved in member acceleration
             */
            eProsima_user_DllExport void acceleration(
                    ros2_interface::msg::Point3D&& _acceleration);

            /*!
             * @brief This function returns a constant reference to member acceleration
             * @return Constant reference to member acceleration
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& acceleration() const;

            /*!
             * @brief This function returns a reference to member acceleration
             * @return Reference to member acceleration
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& acceleration();
            /*!
             * @brief This function sets a value in member velocity_heading
             * @param _velocity_heading New value for member velocity_heading
             */
            eProsima_user_DllExport void velocity_heading(
                    double _velocity_heading);

            /*!
             * @brief This function returns the value of member velocity_heading
             * @return Value of member velocity_heading
             */
            eProsima_user_DllExport double velocity_heading() const;

            /*!
             * @brief This function returns a reference to member velocity_heading
             * @return Reference to member velocity_heading
             */
            eProsima_user_DllExport double& velocity_heading();

            /*!
             * @brief This function sets a value in member speed
             * @param _speed New value for member speed
             */
            eProsima_user_DllExport void speed(
                    double _speed);

            /*!
             * @brief This function returns the value of member speed
             * @return Value of member speed
             */
            eProsima_user_DllExport double speed() const;

            /*!
             * @brief This function returns a reference to member speed
             * @return Reference to member speed
             */
            eProsima_user_DllExport double& speed();

            /*!
             * @brief This function sets a value in member acc
             * @param _acc New value for member acc
             */
            eProsima_user_DllExport void acc(
                    double _acc);

            /*!
             * @brief This function returns the value of member acc
             * @return Value of member acc
             */
            eProsima_user_DllExport double acc() const;

            /*!
             * @brief This function returns a reference to member acc
             * @return Reference to member acc
             */
            eProsima_user_DllExport double& acc();

            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function sets a value in member tracking_time
             * @param _tracking_time New value for member tracking_time
             */
            eProsima_user_DllExport void tracking_time(
                    double _tracking_time);

            /*!
             * @brief This function returns the value of member tracking_time
             * @return Value of member tracking_time
             */
            eProsima_user_DllExport double tracking_time() const;

            /*!
             * @brief This function returns a reference to member tracking_time
             * @return Reference to member tracking_time
             */
            eProsima_user_DllExport double& tracking_time();

            /*!
             * @brief This function sets a value in member timestamp
             * @param _timestamp New value for member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    double _timestamp);

            /*!
             * @brief This function returns the value of member timestamp
             * @return Value of member timestamp
             */
            eProsima_user_DllExport double timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport double& timestamp();

            /*!
             * @brief This function copies the value in member t_position
             * @param _t_position New value to be copied in member t_position
             */
            eProsima_user_DllExport void t_position(
                    const ros2_interface::msg::Point3D& _t_position);

            /*!
             * @brief This function moves the value in member t_position
             * @param _t_position New value to be moved in member t_position
             */
            eProsima_user_DllExport void t_position(
                    ros2_interface::msg::Point3D&& _t_position);

            /*!
             * @brief This function returns a constant reference to member t_position
             * @return Constant reference to member t_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& t_position() const;

            /*!
             * @brief This function returns a reference to member t_position
             * @return Reference to member t_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& t_position();
            /*!
             * @brief This function copies the value in member t_velocity
             * @param _t_velocity New value to be copied in member t_velocity
             */
            eProsima_user_DllExport void t_velocity(
                    const ros2_interface::msg::Point3D& _t_velocity);

            /*!
             * @brief This function moves the value in member t_velocity
             * @param _t_velocity New value to be moved in member t_velocity
             */
            eProsima_user_DllExport void t_velocity(
                    ros2_interface::msg::Point3D&& _t_velocity);

            /*!
             * @brief This function returns a constant reference to member t_velocity
             * @return Constant reference to member t_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& t_velocity() const;

            /*!
             * @brief This function returns a reference to member t_velocity
             * @return Reference to member t_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& t_velocity();
            /*!
             * @brief This function sets a value in member t_velocity_heading
             * @param _t_velocity_heading New value for member t_velocity_heading
             */
            eProsima_user_DllExport void t_velocity_heading(
                    double _t_velocity_heading);

            /*!
             * @brief This function returns the value of member t_velocity_heading
             * @return Value of member t_velocity_heading
             */
            eProsima_user_DllExport double t_velocity_heading() const;

            /*!
             * @brief This function returns a reference to member t_velocity_heading
             * @return Reference to member t_velocity_heading
             */
            eProsima_user_DllExport double& t_velocity_heading();

            /*!
             * @brief This function sets a value in member t_speed
             * @param _t_speed New value for member t_speed
             */
            eProsima_user_DllExport void t_speed(
                    double _t_speed);

            /*!
             * @brief This function returns the value of member t_speed
             * @return Value of member t_speed
             */
            eProsima_user_DllExport double t_speed() const;

            /*!
             * @brief This function returns a reference to member t_speed
             * @return Reference to member t_speed
             */
            eProsima_user_DllExport double& t_speed();

            /*!
             * @brief This function copies the value in member t_acceleration
             * @param _t_acceleration New value to be copied in member t_acceleration
             */
            eProsima_user_DllExport void t_acceleration(
                    const ros2_interface::msg::Point3D& _t_acceleration);

            /*!
             * @brief This function moves the value in member t_acceleration
             * @param _t_acceleration New value to be moved in member t_acceleration
             */
            eProsima_user_DllExport void t_acceleration(
                    ros2_interface::msg::Point3D&& _t_acceleration);

            /*!
             * @brief This function returns a constant reference to member t_acceleration
             * @return Constant reference to member t_acceleration
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& t_acceleration() const;

            /*!
             * @brief This function returns a reference to member t_acceleration
             * @return Reference to member t_acceleration
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& t_acceleration();
            /*!
             * @brief This function sets a value in member t_acc
             * @param _t_acc New value for member t_acc
             */
            eProsima_user_DllExport void t_acc(
                    double _t_acc);

            /*!
             * @brief This function returns the value of member t_acc
             * @return Value of member t_acc
             */
            eProsima_user_DllExport double t_acc() const;

            /*!
             * @brief This function returns a reference to member t_acc
             * @return Reference to member t_acc
             */
            eProsima_user_DllExport double& t_acc();

            /*!
             * @brief This function sets a value in member is_still
             * @param _is_still New value for member is_still
             */
            eProsima_user_DllExport void is_still(
                    bool _is_still);

            /*!
             * @brief This function returns the value of member is_still
             * @return Value of member is_still
             */
            eProsima_user_DllExport bool is_still() const;

            /*!
             * @brief This function returns a reference to member is_still
             * @return Reference to member is_still
             */
            eProsima_user_DllExport bool& is_still();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();

            /*!
             * @brief This function sets a value in member label_update_time_delta
             * @param _label_update_time_delta New value for member label_update_time_delta
             */
            eProsima_user_DllExport void label_update_time_delta(
                    double _label_update_time_delta);

            /*!
             * @brief This function returns the value of member label_update_time_delta
             * @return Value of member label_update_time_delta
             */
            eProsima_user_DllExport double label_update_time_delta() const;

            /*!
             * @brief This function returns a reference to member label_update_time_delta
             * @return Reference to member label_update_time_delta
             */
            eProsima_user_DllExport double& label_update_time_delta();

            /*!
             * @brief This function copies the value in member priority
             * @param _priority New value to be copied in member priority
             */
            eProsima_user_DllExport void priority(
                    const ros2_interface::msg::ObstaclePriority& _priority);

            /*!
             * @brief This function moves the value in member priority
             * @param _priority New value to be moved in member priority
             */
            eProsima_user_DllExport void priority(
                    ros2_interface::msg::ObstaclePriority&& _priority);

            /*!
             * @brief This function returns a constant reference to member priority
             * @return Constant reference to member priority
             */
            eProsima_user_DllExport const ros2_interface::msg::ObstaclePriority& priority() const;

            /*!
             * @brief This function returns a reference to member priority
             * @return Reference to member priority
             */
            eProsima_user_DllExport ros2_interface::msg::ObstaclePriority& priority();
            /*!
             * @brief This function sets a value in member is_near_junction
             * @param _is_near_junction New value for member is_near_junction
             */
            eProsima_user_DllExport void is_near_junction(
                    bool _is_near_junction);

            /*!
             * @brief This function returns the value of member is_near_junction
             * @return Value of member is_near_junction
             */
            eProsima_user_DllExport bool is_near_junction() const;

            /*!
             * @brief This function returns a reference to member is_near_junction
             * @return Reference to member is_near_junction
             */
            eProsima_user_DllExport bool& is_near_junction();

            /*!
             * @brief This function copies the value in member future_trajectory_points
             * @param _future_trajectory_points New value to be copied in member future_trajectory_points
             */
            eProsima_user_DllExport void future_trajectory_points(
                    const std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& _future_trajectory_points);

            /*!
             * @brief This function moves the value in member future_trajectory_points
             * @param _future_trajectory_points New value to be moved in member future_trajectory_points
             */
            eProsima_user_DllExport void future_trajectory_points(
                    std::vector<ros2_interface::msg::PredictionTrajectoryPoint>&& _future_trajectory_points);

            /*!
             * @brief This function returns a constant reference to member future_trajectory_points
             * @return Constant reference to member future_trajectory_points
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& future_trajectory_points() const;

            /*!
             * @brief This function returns a reference to member future_trajectory_points
             * @return Reference to member future_trajectory_points
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::PredictionTrajectoryPoint>& future_trajectory_points();
            /*!
             * @brief This function copies the value in member short_term_predicted_trajectory_points
             * @param _short_term_predicted_trajectory_points New value to be copied in member short_term_predicted_trajectory_points
             */
            eProsima_user_DllExport void short_term_predicted_trajectory_points(
                    const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& _short_term_predicted_trajectory_points);

            /*!
             * @brief This function moves the value in member short_term_predicted_trajectory_points
             * @param _short_term_predicted_trajectory_points New value to be moved in member short_term_predicted_trajectory_points
             */
            eProsima_user_DllExport void short_term_predicted_trajectory_points(
                    std::vector<ros2_interface::msg::TrajectoryPointInPrediction>&& _short_term_predicted_trajectory_points);

            /*!
             * @brief This function returns a constant reference to member short_term_predicted_trajectory_points
             * @return Constant reference to member short_term_predicted_trajectory_points
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& short_term_predicted_trajectory_points() const;

            /*!
             * @brief This function returns a reference to member short_term_predicted_trajectory_points
             * @return Reference to member short_term_predicted_trajectory_points
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& short_term_predicted_trajectory_points();
            /*!
             * @brief This function copies the value in member predicted_trajectory
             * @param _predicted_trajectory New value to be copied in member predicted_trajectory
             */
            eProsima_user_DllExport void predicted_trajectory(
                    const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _predicted_trajectory);

            /*!
             * @brief This function moves the value in member predicted_trajectory
             * @param _predicted_trajectory New value to be moved in member predicted_trajectory
             */
            eProsima_user_DllExport void predicted_trajectory(
                    std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _predicted_trajectory);

            /*!
             * @brief This function returns a constant reference to member predicted_trajectory
             * @return Constant reference to member predicted_trajectory
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryInPrediction>& predicted_trajectory() const;

            /*!
             * @brief This function returns a reference to member predicted_trajectory
             * @return Reference to member predicted_trajectory
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryInPrediction>& predicted_trajectory();
            /*!
             * @brief This function copies the value in member adc_trajectory_point
             * @param _adc_trajectory_point New value to be copied in member adc_trajectory_point
             */
            eProsima_user_DllExport void adc_trajectory_point(
                    const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& _adc_trajectory_point);

            /*!
             * @brief This function moves the value in member adc_trajectory_point
             * @param _adc_trajectory_point New value to be moved in member adc_trajectory_point
             */
            eProsima_user_DllExport void adc_trajectory_point(
                    std::vector<ros2_interface::msg::TrajectoryPointInPrediction>&& _adc_trajectory_point);

            /*!
             * @brief This function returns a constant reference to member adc_trajectory_point
             * @return Constant reference to member adc_trajectory_point
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& adc_trajectory_point() const;

            /*!
             * @brief This function returns a reference to member adc_trajectory_point
             * @return Reference to member adc_trajectory_point
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryPointInPrediction>& adc_trajectory_point();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ObstacleFeature& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_obstacle_id;
            ros2_interface::msg::Point3D m_polygon_point;
            ros2_interface::msg::Point3D m_position;
            ros2_interface::msg::Point3D m_front_position;
            ros2_interface::msg::Point3D m_velocity;
            ros2_interface::msg::Point3D m_raw_velocity;
            ros2_interface::msg::Point3D m_acceleration;
            double m_velocity_heading;
            double m_speed;
            double m_acc;
            double m_theta;
            double m_length;
            double m_width;
            double m_height;
            double m_tracking_time;
            double m_timestamp;
            ros2_interface::msg::Point3D m_t_position;
            ros2_interface::msg::Point3D m_t_velocity;
            double m_t_velocity_heading;
            double m_t_speed;
            ros2_interface::msg::Point3D m_t_acceleration;
            double m_t_acc;
            bool m_is_still;
            int32_t m_type;
            double m_label_update_time_delta;
            ros2_interface::msg::ObstaclePriority m_priority;
            bool m_is_near_junction;
            std::vector<ros2_interface::msg::PredictionTrajectoryPoint> m_future_trajectory_points;
            std::vector<ros2_interface::msg::TrajectoryPointInPrediction> m_short_term_predicted_trajectory_points;
            std::vector<ros2_interface::msg::TrajectoryInPrediction> m_predicted_trajectory;
            std::vector<ros2_interface::msg::TrajectoryPointInPrediction> m_adc_trajectory_point;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBSTACLEFEATURE_H_

