// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleFeatureTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "ObstacleFeature.h"
#include "ObstacleFeatureTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerObstacleFeatureTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(true),
                        ros2_interface::msg::GetObstaclePriorityObject(true));
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(false),
                        ros2_interface::msg::GetObstaclePriorityObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPointInPrediction", ros2_interface::msg::GetTrajectoryPointInPredictionIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointInPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPointInPrediction", ros2_interface::msg::GetTrajectoryPointInPredictionIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointInPredictionObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PredictionTrajectoryPoint", ros2_interface::msg::GetPredictionTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetPredictionTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::PredictionTrajectoryPoint", ros2_interface::msg::GetPredictionTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetPredictionTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(true),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(false),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleFeature", ros2_interface::msg::GetObstacleFeatureIdentifier(true),
                        ros2_interface::msg::GetObstacleFeatureObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleFeature", ros2_interface::msg::GetObstacleFeatureIdentifier(false),
                        ros2_interface::msg::GetObstacleFeatureObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetObstacleFeatureIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("ObstacleFeature", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetObstacleFeatureObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("ObstacleFeature", complete);
        }

        const TypeObject* GetObstacleFeatureObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObstacleFeature", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteObstacleFeatureObject();
            }
            //else
            return GetMinimalObstacleFeatureObject();
        }

        const TypeObject* GetMinimalObstacleFeatureObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObstacleFeature", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_obstacle_id;
            mst_obstacle_id.common().member_id(memberId++);
            mst_obstacle_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_obstacle_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_obstacle_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_obstacle_id.common().member_flags().IS_OPTIONAL(false);
            mst_obstacle_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_obstacle_id.common().member_flags().IS_KEY(false);
            mst_obstacle_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_obstacle_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 obstacle_id_hash("obstacle_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_obstacle_id.detail().name_hash()[i] = obstacle_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_obstacle_id);

            MinimalStructMember mst_polygon_point;
            mst_polygon_point.common().member_id(memberId++);
            mst_polygon_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_polygon_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_polygon_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_polygon_point.common().member_flags().IS_OPTIONAL(false);
            mst_polygon_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_polygon_point.common().member_flags().IS_KEY(false);
            mst_polygon_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_polygon_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 polygon_point_hash("polygon_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_polygon_point.detail().name_hash()[i] = polygon_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_polygon_point);

            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_front_position;
            mst_front_position.common().member_id(memberId++);
            mst_front_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_position.common().member_flags().IS_OPTIONAL(false);
            mst_front_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_position.common().member_flags().IS_KEY(false);
            mst_front_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 front_position_hash("front_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_position.detail().name_hash()[i] = front_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_position);

            MinimalStructMember mst_velocity;
            mst_velocity.common().member_id(memberId++);
            mst_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity.common().member_flags().IS_KEY(false);
            mst_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 velocity_hash("velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity.detail().name_hash()[i] = velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity);

            MinimalStructMember mst_raw_velocity;
            mst_raw_velocity.common().member_id(memberId++);
            mst_raw_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_raw_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_raw_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_raw_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_raw_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_raw_velocity.common().member_flags().IS_KEY(false);
            mst_raw_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_raw_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 raw_velocity_hash("raw_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_raw_velocity.detail().name_hash()[i] = raw_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_raw_velocity);

            MinimalStructMember mst_acceleration;
            mst_acceleration.common().member_id(memberId++);
            mst_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration.common().member_flags().IS_KEY(false);
            mst_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 acceleration_hash("acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration.detail().name_hash()[i] = acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration);

            MinimalStructMember mst_velocity_heading;
            mst_velocity_heading.common().member_id(memberId++);
            mst_velocity_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_heading.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_heading.common().member_flags().IS_KEY(false);
            mst_velocity_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 velocity_heading_hash("velocity_heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_heading.detail().name_hash()[i] = velocity_heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_heading);

            MinimalStructMember mst_speed;
            mst_speed.common().member_id(memberId++);
            mst_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed.common().member_flags().IS_OPTIONAL(false);
            mst_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed.common().member_flags().IS_KEY(false);
            mst_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_hash("speed");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed.detail().name_hash()[i] = speed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed);

            MinimalStructMember mst_acc;
            mst_acc.common().member_id(memberId++);
            mst_acc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc.common().member_flags().IS_OPTIONAL(false);
            mst_acc.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc.common().member_flags().IS_KEY(false);
            mst_acc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_hash("acc");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc.detail().name_hash()[i] = acc_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_tracking_time;
            mst_tracking_time.common().member_id(memberId++);
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            mst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tracking_time.common().member_flags().IS_KEY(false);
            mst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tracking_time_hash("tracking_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_tracking_time.detail().name_hash()[i] = tracking_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tracking_time);

            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_t_position;
            mst_t_position.common().member_id(memberId++);
            mst_t_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_position.common().member_flags().IS_OPTIONAL(false);
            mst_t_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_position.common().member_flags().IS_KEY(false);
            mst_t_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 t_position_hash("t_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_position.detail().name_hash()[i] = t_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_position);

            MinimalStructMember mst_t_velocity;
            mst_t_velocity.common().member_id(memberId++);
            mst_t_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_t_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_velocity.common().member_flags().IS_KEY(false);
            mst_t_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 t_velocity_hash("t_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_velocity.detail().name_hash()[i] = t_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_velocity);

            MinimalStructMember mst_t_velocity_heading;
            mst_t_velocity_heading.common().member_id(memberId++);
            mst_t_velocity_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_velocity_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_velocity_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_velocity_heading.common().member_flags().IS_OPTIONAL(false);
            mst_t_velocity_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_velocity_heading.common().member_flags().IS_KEY(false);
            mst_t_velocity_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_velocity_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 t_velocity_heading_hash("t_velocity_heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_velocity_heading.detail().name_hash()[i] = t_velocity_heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_velocity_heading);

            MinimalStructMember mst_t_speed;
            mst_t_speed.common().member_id(memberId++);
            mst_t_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_speed.common().member_flags().IS_OPTIONAL(false);
            mst_t_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_speed.common().member_flags().IS_KEY(false);
            mst_t_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 t_speed_hash("t_speed");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_speed.detail().name_hash()[i] = t_speed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_speed);

            MinimalStructMember mst_t_acceleration;
            mst_t_acceleration.common().member_id(memberId++);
            mst_t_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_t_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_acceleration.common().member_flags().IS_KEY(false);
            mst_t_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 t_acceleration_hash("t_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_acceleration.detail().name_hash()[i] = t_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_acceleration);

            MinimalStructMember mst_t_acc;
            mst_t_acc.common().member_id(memberId++);
            mst_t_acc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t_acc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t_acc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t_acc.common().member_flags().IS_OPTIONAL(false);
            mst_t_acc.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t_acc.common().member_flags().IS_KEY(false);
            mst_t_acc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t_acc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 t_acc_hash("t_acc");
            for(int i = 0; i < 4; ++i)
            {
                mst_t_acc.detail().name_hash()[i] = t_acc_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t_acc);

            MinimalStructMember mst_is_still;
            mst_is_still.common().member_id(memberId++);
            mst_is_still.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_still.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_still.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_still.common().member_flags().IS_OPTIONAL(false);
            mst_is_still.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_still.common().member_flags().IS_KEY(false);
            mst_is_still.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_still.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_still_hash("is_still");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_still.detail().name_hash()[i] = is_still_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_still);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_label_update_time_delta;
            mst_label_update_time_delta.common().member_id(memberId++);
            mst_label_update_time_delta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_label_update_time_delta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_label_update_time_delta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_label_update_time_delta.common().member_flags().IS_OPTIONAL(false);
            mst_label_update_time_delta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_label_update_time_delta.common().member_flags().IS_KEY(false);
            mst_label_update_time_delta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_label_update_time_delta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 label_update_time_delta_hash("label_update_time_delta");
            for(int i = 0; i < 4; ++i)
            {
                mst_label_update_time_delta.detail().name_hash()[i] = label_update_time_delta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_label_update_time_delta);

            MinimalStructMember mst_priority;
            mst_priority.common().member_id(memberId++);
            mst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_priority.common().member_flags().IS_OPTIONAL(false);
            mst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_priority.common().member_flags().IS_KEY(false);
            mst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_priority.common().member_type_id(*ros2_interface::msg::GetObstaclePriorityIdentifier(false));
            MD5 priority_hash("priority");
            for(int i = 0; i < 4; ++i)
            {
                mst_priority.detail().name_hash()[i] = priority_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_priority);

            MinimalStructMember mst_is_near_junction;
            mst_is_near_junction.common().member_id(memberId++);
            mst_is_near_junction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_near_junction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_near_junction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_near_junction.common().member_flags().IS_OPTIONAL(false);
            mst_is_near_junction.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_near_junction.common().member_flags().IS_KEY(false);
            mst_is_near_junction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_near_junction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_near_junction_hash("is_near_junction");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_near_junction.detail().name_hash()[i] = is_near_junction_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_near_junction);

            MinimalStructMember mst_future_trajectory_points;
            mst_future_trajectory_points.common().member_id(memberId++);
            mst_future_trajectory_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_future_trajectory_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_future_trajectory_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_future_trajectory_points.common().member_flags().IS_OPTIONAL(false);
            mst_future_trajectory_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_future_trajectory_points.common().member_flags().IS_KEY(false);
            mst_future_trajectory_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_future_trajectory_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PredictionTrajectoryPoint", 100, false));


            MD5 future_trajectory_points_hash("future_trajectory_points");
            for(int i = 0; i < 4; ++i)
            {
                mst_future_trajectory_points.detail().name_hash()[i] = future_trajectory_points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_future_trajectory_points);

            MinimalStructMember mst_short_term_predicted_trajectory_points;
            mst_short_term_predicted_trajectory_points.common().member_id(memberId++);
            mst_short_term_predicted_trajectory_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_short_term_predicted_trajectory_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_short_term_predicted_trajectory_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_short_term_predicted_trajectory_points.common().member_flags().IS_OPTIONAL(false);
            mst_short_term_predicted_trajectory_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_short_term_predicted_trajectory_points.common().member_flags().IS_KEY(false);
            mst_short_term_predicted_trajectory_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_short_term_predicted_trajectory_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPointInPrediction", 100, false));


            MD5 short_term_predicted_trajectory_points_hash("short_term_predicted_trajectory_points");
            for(int i = 0; i < 4; ++i)
            {
                mst_short_term_predicted_trajectory_points.detail().name_hash()[i] = short_term_predicted_trajectory_points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_short_term_predicted_trajectory_points);

            MinimalStructMember mst_predicted_trajectory;
            mst_predicted_trajectory.common().member_id(memberId++);
            mst_predicted_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_predicted_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_predicted_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_predicted_trajectory.common().member_flags().IS_OPTIONAL(false);
            mst_predicted_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_predicted_trajectory.common().member_flags().IS_KEY(false);
            mst_predicted_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_predicted_trajectory.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, false));


            MD5 predicted_trajectory_hash("predicted_trajectory");
            for(int i = 0; i < 4; ++i)
            {
                mst_predicted_trajectory.detail().name_hash()[i] = predicted_trajectory_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_predicted_trajectory);

            MinimalStructMember mst_adc_trajectory_point;
            mst_adc_trajectory_point.common().member_id(memberId++);
            mst_adc_trajectory_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_adc_trajectory_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_adc_trajectory_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_adc_trajectory_point.common().member_flags().IS_OPTIONAL(false);
            mst_adc_trajectory_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_adc_trajectory_point.common().member_flags().IS_KEY(false);
            mst_adc_trajectory_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_adc_trajectory_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPointInPrediction", 100, false));


            MD5 adc_trajectory_point_hash("adc_trajectory_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_adc_trajectory_point.detail().name_hash()[i] = adc_trajectory_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_adc_trajectory_point);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ObstacleFeature", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ObstacleFeature", false);
        }

        const TypeObject* GetCompleteObstacleFeatureObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObstacleFeature", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_obstacle_id;
            cst_obstacle_id.common().member_id(memberId++);
            cst_obstacle_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_obstacle_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_obstacle_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_obstacle_id.common().member_flags().IS_OPTIONAL(false);
            cst_obstacle_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_obstacle_id.common().member_flags().IS_KEY(false);
            cst_obstacle_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_obstacle_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_obstacle_id.detail().name("obstacle_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_obstacle_id);

            CompleteStructMember cst_polygon_point;
            cst_polygon_point.common().member_id(memberId++);
            cst_polygon_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_polygon_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_polygon_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_polygon_point.common().member_flags().IS_OPTIONAL(false);
            cst_polygon_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_polygon_point.common().member_flags().IS_KEY(false);
            cst_polygon_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_polygon_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_polygon_point.detail().name("polygon_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_polygon_point);

            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_front_position;
            cst_front_position.common().member_id(memberId++);
            cst_front_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_position.common().member_flags().IS_OPTIONAL(false);
            cst_front_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_position.common().member_flags().IS_KEY(false);
            cst_front_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_front_position.detail().name("front_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_position);

            CompleteStructMember cst_velocity;
            cst_velocity.common().member_id(memberId++);
            cst_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity.common().member_flags().IS_KEY(false);
            cst_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_velocity.detail().name("velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity);

            CompleteStructMember cst_raw_velocity;
            cst_raw_velocity.common().member_id(memberId++);
            cst_raw_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_raw_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_raw_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_raw_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_raw_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_raw_velocity.common().member_flags().IS_KEY(false);
            cst_raw_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_raw_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_raw_velocity.detail().name("raw_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_raw_velocity);

            CompleteStructMember cst_acceleration;
            cst_acceleration.common().member_id(memberId++);
            cst_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration.common().member_flags().IS_KEY(false);
            cst_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_acceleration.detail().name("acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration);

            CompleteStructMember cst_velocity_heading;
            cst_velocity_heading.common().member_id(memberId++);
            cst_velocity_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_heading.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_heading.common().member_flags().IS_KEY(false);
            cst_velocity_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_velocity_heading.detail().name("velocity_heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_heading);

            CompleteStructMember cst_speed;
            cst_speed.common().member_id(memberId++);
            cst_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed.common().member_flags().IS_OPTIONAL(false);
            cst_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed.common().member_flags().IS_KEY(false);
            cst_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed.detail().name("speed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed);

            CompleteStructMember cst_acc;
            cst_acc.common().member_id(memberId++);
            cst_acc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc.common().member_flags().IS_OPTIONAL(false);
            cst_acc.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc.common().member_flags().IS_KEY(false);
            cst_acc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc.detail().name("acc");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_tracking_time;
            cst_tracking_time.common().member_id(memberId++);
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            cst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tracking_time.common().member_flags().IS_KEY(false);
            cst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tracking_time.detail().name("tracking_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tracking_time);

            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_t_position;
            cst_t_position.common().member_id(memberId++);
            cst_t_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_position.common().member_flags().IS_OPTIONAL(false);
            cst_t_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_position.common().member_flags().IS_KEY(false);
            cst_t_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_t_position.detail().name("t_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_position);

            CompleteStructMember cst_t_velocity;
            cst_t_velocity.common().member_id(memberId++);
            cst_t_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_t_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_velocity.common().member_flags().IS_KEY(false);
            cst_t_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_t_velocity.detail().name("t_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_velocity);

            CompleteStructMember cst_t_velocity_heading;
            cst_t_velocity_heading.common().member_id(memberId++);
            cst_t_velocity_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_velocity_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_velocity_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_velocity_heading.common().member_flags().IS_OPTIONAL(false);
            cst_t_velocity_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_velocity_heading.common().member_flags().IS_KEY(false);
            cst_t_velocity_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_velocity_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_t_velocity_heading.detail().name("t_velocity_heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_velocity_heading);

            CompleteStructMember cst_t_speed;
            cst_t_speed.common().member_id(memberId++);
            cst_t_speed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_speed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_speed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_speed.common().member_flags().IS_OPTIONAL(false);
            cst_t_speed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_speed.common().member_flags().IS_KEY(false);
            cst_t_speed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_speed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_t_speed.detail().name("t_speed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_speed);

            CompleteStructMember cst_t_acceleration;
            cst_t_acceleration.common().member_id(memberId++);
            cst_t_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_t_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_acceleration.common().member_flags().IS_KEY(false);
            cst_t_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_t_acceleration.detail().name("t_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_acceleration);

            CompleteStructMember cst_t_acc;
            cst_t_acc.common().member_id(memberId++);
            cst_t_acc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t_acc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t_acc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t_acc.common().member_flags().IS_OPTIONAL(false);
            cst_t_acc.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t_acc.common().member_flags().IS_KEY(false);
            cst_t_acc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t_acc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_t_acc.detail().name("t_acc");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t_acc);

            CompleteStructMember cst_is_still;
            cst_is_still.common().member_id(memberId++);
            cst_is_still.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_still.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_still.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_still.common().member_flags().IS_OPTIONAL(false);
            cst_is_still.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_still.common().member_flags().IS_KEY(false);
            cst_is_still.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_still.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_still.detail().name("is_still");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_still);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_label_update_time_delta;
            cst_label_update_time_delta.common().member_id(memberId++);
            cst_label_update_time_delta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_label_update_time_delta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_label_update_time_delta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_label_update_time_delta.common().member_flags().IS_OPTIONAL(false);
            cst_label_update_time_delta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_label_update_time_delta.common().member_flags().IS_KEY(false);
            cst_label_update_time_delta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_label_update_time_delta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_label_update_time_delta.detail().name("label_update_time_delta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_label_update_time_delta);

            CompleteStructMember cst_priority;
            cst_priority.common().member_id(memberId++);
            cst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_priority.common().member_flags().IS_OPTIONAL(false);
            cst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_priority.common().member_flags().IS_KEY(false);
            cst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_priority.common().member_type_id(*ros2_interface::msg::GetObstaclePriorityIdentifier(true));
            cst_priority.detail().name("priority");

            type_object->complete().struct_type().member_seq().emplace_back(cst_priority);

            CompleteStructMember cst_is_near_junction;
            cst_is_near_junction.common().member_id(memberId++);
            cst_is_near_junction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_near_junction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_near_junction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_near_junction.common().member_flags().IS_OPTIONAL(false);
            cst_is_near_junction.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_near_junction.common().member_flags().IS_KEY(false);
            cst_is_near_junction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_near_junction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_near_junction.detail().name("is_near_junction");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_near_junction);

            CompleteStructMember cst_future_trajectory_points;
            cst_future_trajectory_points.common().member_id(memberId++);
            cst_future_trajectory_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_future_trajectory_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_future_trajectory_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_future_trajectory_points.common().member_flags().IS_OPTIONAL(false);
            cst_future_trajectory_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_future_trajectory_points.common().member_flags().IS_KEY(false);
            cst_future_trajectory_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_future_trajectory_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PredictionTrajectoryPoint", 100, true));


            cst_future_trajectory_points.detail().name("future_trajectory_points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_future_trajectory_points);

            CompleteStructMember cst_short_term_predicted_trajectory_points;
            cst_short_term_predicted_trajectory_points.common().member_id(memberId++);
            cst_short_term_predicted_trajectory_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_short_term_predicted_trajectory_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_short_term_predicted_trajectory_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_short_term_predicted_trajectory_points.common().member_flags().IS_OPTIONAL(false);
            cst_short_term_predicted_trajectory_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_short_term_predicted_trajectory_points.common().member_flags().IS_KEY(false);
            cst_short_term_predicted_trajectory_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_short_term_predicted_trajectory_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPointInPrediction", 100, true));


            cst_short_term_predicted_trajectory_points.detail().name("short_term_predicted_trajectory_points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_short_term_predicted_trajectory_points);

            CompleteStructMember cst_predicted_trajectory;
            cst_predicted_trajectory.common().member_id(memberId++);
            cst_predicted_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_predicted_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_predicted_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_predicted_trajectory.common().member_flags().IS_OPTIONAL(false);
            cst_predicted_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_predicted_trajectory.common().member_flags().IS_KEY(false);
            cst_predicted_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_predicted_trajectory.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, true));


            cst_predicted_trajectory.detail().name("predicted_trajectory");

            type_object->complete().struct_type().member_seq().emplace_back(cst_predicted_trajectory);

            CompleteStructMember cst_adc_trajectory_point;
            cst_adc_trajectory_point.common().member_id(memberId++);
            cst_adc_trajectory_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_adc_trajectory_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_adc_trajectory_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_adc_trajectory_point.common().member_flags().IS_OPTIONAL(false);
            cst_adc_trajectory_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_adc_trajectory_point.common().member_flags().IS_KEY(false);
            cst_adc_trajectory_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_adc_trajectory_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPointInPrediction", 100, true));


            cst_adc_trajectory_point.detail().name("adc_trajectory_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_adc_trajectory_point);


            // Header
            type_object->complete().struct_type().header().detail().type_name("ObstacleFeature");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ObstacleFeature", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ObstacleFeature", true);
        }

    } // namespace msg
} // namespace ros2_interface