// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleIntent.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObstacleIntent.h"
#include "ObstacleIntentTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObstacleIntent_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ObstacleIntent_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObstacleIntent::ObstacleIntent()
{
    // long m_type
    m_type = 0;

    // Just to register all known types
    registerObstacleIntentTypes();
}

ros2_interface::msg::ObstacleIntent::~ObstacleIntent()
{
}

ros2_interface::msg::ObstacleIntent::ObstacleIntent(
        const ObstacleIntent& x)
{
    m_type = x.m_type;
}

ros2_interface::msg::ObstacleIntent::ObstacleIntent(
        ObstacleIntent&& x) noexcept 
{
    m_type = x.m_type;
}

ros2_interface::msg::ObstacleIntent& ros2_interface::msg::ObstacleIntent::operator =(
        const ObstacleIntent& x)
{

    m_type = x.m_type;

    return *this;
}

ros2_interface::msg::ObstacleIntent& ros2_interface::msg::ObstacleIntent::operator =(
        ObstacleIntent&& x) noexcept
{

    m_type = x.m_type;

    return *this;
}

bool ros2_interface::msg::ObstacleIntent::operator ==(
        const ObstacleIntent& x) const
{

    return (m_type == x.m_type);
}

bool ros2_interface::msg::ObstacleIntent::operator !=(
        const ObstacleIntent& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObstacleIntent::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleIntent_max_cdr_typesize;
}

size_t ros2_interface::msg::ObstacleIntent::getCdrSerializedSize(
        const ros2_interface::msg::ObstacleIntent& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObstacleIntent::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_type;

}

void ros2_interface::msg::ObstacleIntent::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_type;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::ObstacleIntent::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::ObstacleIntent::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::ObstacleIntent::type()
{
    return m_type;
}



size_t ros2_interface::msg::ObstacleIntent::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleIntent_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObstacleIntent::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObstacleIntent::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



