// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleInteractiveTag.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObstacleInteractiveTag.h"
#include "ObstacleInteractiveTagTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObstacleInteractiveTag_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ObstacleInteractiveTag_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObstacleInteractiveTag::ObstacleInteractiveTag()
{
    // long m_interactive_tag
    m_interactive_tag = 0;

    // Just to register all known types
    registerObstacleInteractiveTagTypes();
}

ros2_interface::msg::ObstacleInteractiveTag::~ObstacleInteractiveTag()
{
}

ros2_interface::msg::ObstacleInteractiveTag::ObstacleInteractiveTag(
        const ObstacleInteractiveTag& x)
{
    m_interactive_tag = x.m_interactive_tag;
}

ros2_interface::msg::ObstacleInteractiveTag::ObstacleInteractiveTag(
        ObstacleInteractiveTag&& x) noexcept 
{
    m_interactive_tag = x.m_interactive_tag;
}

ros2_interface::msg::ObstacleInteractiveTag& ros2_interface::msg::ObstacleInteractiveTag::operator =(
        const ObstacleInteractiveTag& x)
{

    m_interactive_tag = x.m_interactive_tag;

    return *this;
}

ros2_interface::msg::ObstacleInteractiveTag& ros2_interface::msg::ObstacleInteractiveTag::operator =(
        ObstacleInteractiveTag&& x) noexcept
{

    m_interactive_tag = x.m_interactive_tag;

    return *this;
}

bool ros2_interface::msg::ObstacleInteractiveTag::operator ==(
        const ObstacleInteractiveTag& x) const
{

    return (m_interactive_tag == x.m_interactive_tag);
}

bool ros2_interface::msg::ObstacleInteractiveTag::operator !=(
        const ObstacleInteractiveTag& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObstacleInteractiveTag::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleInteractiveTag_max_cdr_typesize;
}

size_t ros2_interface::msg::ObstacleInteractiveTag::getCdrSerializedSize(
        const ros2_interface::msg::ObstacleInteractiveTag& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObstacleInteractiveTag::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_interactive_tag;

}

void ros2_interface::msg::ObstacleInteractiveTag::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_interactive_tag;
}

/*!
 * @brief This function sets a value in member interactive_tag
 * @param _interactive_tag New value for member interactive_tag
 */
void ros2_interface::msg::ObstacleInteractiveTag::interactive_tag(
        int32_t _interactive_tag)
{
    m_interactive_tag = _interactive_tag;
}

/*!
 * @brief This function returns the value of member interactive_tag
 * @return Value of member interactive_tag
 */
int32_t ros2_interface::msg::ObstacleInteractiveTag::interactive_tag() const
{
    return m_interactive_tag;
}

/*!
 * @brief This function returns a reference to member interactive_tag
 * @return Reference to member interactive_tag
 */
int32_t& ros2_interface::msg::ObstacleInteractiveTag::interactive_tag()
{
    return m_interactive_tag;
}



size_t ros2_interface::msg::ObstacleInteractiveTag::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstacleInteractiveTag_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObstacleInteractiveTag::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObstacleInteractiveTag::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



