// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstaclePriority.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObstaclePriority.h"
#include "ObstaclePriorityTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObstaclePriority_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ObstaclePriority_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObstaclePriority::ObstaclePriority()
{
    // long m_priority
    m_priority = 0;

    // Just to register all known types
    registerObstaclePriorityTypes();
}

ros2_interface::msg::ObstaclePriority::~ObstaclePriority()
{
}

ros2_interface::msg::ObstaclePriority::ObstaclePriority(
        const ObstaclePriority& x)
{
    m_priority = x.m_priority;
}

ros2_interface::msg::ObstaclePriority::ObstaclePriority(
        ObstaclePriority&& x) noexcept 
{
    m_priority = x.m_priority;
}

ros2_interface::msg::ObstaclePriority& ros2_interface::msg::ObstaclePriority::operator =(
        const ObstaclePriority& x)
{

    m_priority = x.m_priority;

    return *this;
}

ros2_interface::msg::ObstaclePriority& ros2_interface::msg::ObstaclePriority::operator =(
        ObstaclePriority&& x) noexcept
{

    m_priority = x.m_priority;

    return *this;
}

bool ros2_interface::msg::ObstaclePriority::operator ==(
        const ObstaclePriority& x) const
{

    return (m_priority == x.m_priority);
}

bool ros2_interface::msg::ObstaclePriority::operator !=(
        const ObstaclePriority& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObstaclePriority::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstaclePriority_max_cdr_typesize;
}

size_t ros2_interface::msg::ObstaclePriority::getCdrSerializedSize(
        const ros2_interface::msg::ObstaclePriority& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObstaclePriority::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_priority;

}

void ros2_interface::msg::ObstaclePriority::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_priority;
}

/*!
 * @brief This function sets a value in member priority
 * @param _priority New value for member priority
 */
void ros2_interface::msg::ObstaclePriority::priority(
        int32_t _priority)
{
    m_priority = _priority;
}

/*!
 * @brief This function returns the value of member priority
 * @return Value of member priority
 */
int32_t ros2_interface::msg::ObstaclePriority::priority() const
{
    return m_priority;
}

/*!
 * @brief This function returns a reference to member priority
 * @return Reference to member priority
 */
int32_t& ros2_interface::msg::ObstaclePriority::priority()
{
    return m_priority;
}



size_t ros2_interface::msg::ObstaclePriority::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObstaclePriority_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObstaclePriority::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObstaclePriority::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



