// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObstacleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Obstacle.h"
#include "ObstacleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerObstacleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::ImageKeyPoint", ros2_interface::msg::GetImageKeyPointIdentifier(true),
                        ros2_interface::msg::GetImageKeyPointObject(true));
                factory->add_type_object("ros2_interface::msg::ImageKeyPoint", ros2_interface::msg::GetImageKeyPointIdentifier(false),
                        ros2_interface::msg::GetImageKeyPointObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(true),
                        ros2_interface::msg::GetObstacleIntentObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(false),
                        ros2_interface::msg::GetObstacleIntentObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::BBox2D", ros2_interface::msg::GetBBox2DIdentifier(true),
                        ros2_interface::msg::GetBBox2DObject(true));
                factory->add_type_object("ros2_interface::msg::BBox2D", ros2_interface::msg::GetBBox2DIdentifier(false),
                        ros2_interface::msg::GetBBox2DObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(true),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(false),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::Obstacle", ros2_interface::msg::GetObstacleIdentifier(true),
                        ros2_interface::msg::GetObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::Obstacle", ros2_interface::msg::GetObstacleIdentifier(false),
                        ros2_interface::msg::GetObstacleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetObstacleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Obstacle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetObstacleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Obstacle", complete);
        }

        const TypeObject* GetObstacleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Obstacle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteObstacleObject();
            }
            //else
            return GetMinimalObstacleObject();
        }

        const TypeObject* GetMinimalObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Obstacle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_existence_prob;
            mst_existence_prob.common().member_id(memberId++);
            mst_existence_prob.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_existence_prob.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_existence_prob.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_existence_prob.common().member_flags().IS_OPTIONAL(false);
            mst_existence_prob.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_existence_prob.common().member_flags().IS_KEY(false);
            mst_existence_prob.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_existence_prob.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 existence_prob_hash("existence_prob");
            for(int i = 0; i < 4; ++i)
            {
                mst_existence_prob.detail().name_hash()[i] = existence_prob_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_existence_prob);

            MinimalStructMember mst_create_time;
            mst_create_time.common().member_id(memberId++);
            mst_create_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_create_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_create_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_create_time.common().member_flags().IS_OPTIONAL(false);
            mst_create_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_create_time.common().member_flags().IS_KEY(false);
            mst_create_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_create_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 create_time_hash("create_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_create_time.detail().name_hash()[i] = create_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_create_time);

            MinimalStructMember mst_last_updated_time;
            mst_last_updated_time.common().member_id(memberId++);
            mst_last_updated_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_last_updated_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_last_updated_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_last_updated_time.common().member_flags().IS_OPTIONAL(false);
            mst_last_updated_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_last_updated_time.common().member_flags().IS_KEY(false);
            mst_last_updated_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_last_updated_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(false));
            MD5 last_updated_time_hash("last_updated_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_last_updated_time.detail().name_hash()[i] = last_updated_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_last_updated_time);

            MinimalStructMember mst_center_pos_vehicle;
            mst_center_pos_vehicle.common().member_id(memberId++);
            mst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_center_pos_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_center_pos_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_center_pos_vehicle.common().member_flags().IS_KEY(false);
            mst_center_pos_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_center_pos_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 center_pos_vehicle_hash("center_pos_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_center_pos_vehicle.detail().name_hash()[i] = center_pos_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_center_pos_vehicle);

            MinimalStructMember mst_center_pos_abs;
            mst_center_pos_abs.common().member_id(memberId++);
            mst_center_pos_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_center_pos_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_center_pos_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_center_pos_abs.common().member_flags().IS_OPTIONAL(false);
            mst_center_pos_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_center_pos_abs.common().member_flags().IS_KEY(false);
            mst_center_pos_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_center_pos_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 center_pos_abs_hash("center_pos_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_center_pos_abs.detail().name_hash()[i] = center_pos_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_center_pos_abs);

            MinimalStructMember mst_theta_vehicle;
            mst_theta_vehicle.common().member_id(memberId++);
            mst_theta_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_theta_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_vehicle.common().member_flags().IS_KEY(false);
            mst_theta_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_vehicle_hash("theta_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_vehicle.detail().name_hash()[i] = theta_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_vehicle);

            MinimalStructMember mst_theta_abs;
            mst_theta_abs.common().member_id(memberId++);
            mst_theta_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_abs.common().member_flags().IS_OPTIONAL(false);
            mst_theta_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_abs.common().member_flags().IS_KEY(false);
            mst_theta_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_abs_hash("theta_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_abs.detail().name_hash()[i] = theta_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_abs);

            MinimalStructMember mst_velocity_vehicle;
            mst_velocity_vehicle.common().member_id(memberId++);
            mst_velocity_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_vehicle.common().member_flags().IS_KEY(false);
            mst_velocity_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 velocity_vehicle_hash("velocity_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_vehicle.detail().name_hash()[i] = velocity_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_vehicle);

            MinimalStructMember mst_velocity_abs;
            mst_velocity_abs.common().member_id(memberId++);
            mst_velocity_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_abs.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_abs.common().member_flags().IS_KEY(false);
            mst_velocity_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 velocity_abs_hash("velocity_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_abs.detail().name_hash()[i] = velocity_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_abs);

            MinimalStructMember mst_range_vehicle;
            mst_range_vehicle.common().member_id(memberId++);
            mst_range_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_range_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_range_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_range_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_range_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_range_vehicle.common().member_flags().IS_KEY(false);
            mst_range_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_range_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 range_vehicle_hash("range_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_range_vehicle.detail().name_hash()[i] = range_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_range_vehicle);

            MinimalStructMember mst_range_abs;
            mst_range_abs.common().member_id(memberId++);
            mst_range_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_range_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_range_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_range_abs.common().member_flags().IS_OPTIONAL(false);
            mst_range_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_range_abs.common().member_flags().IS_KEY(false);
            mst_range_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_range_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 range_abs_hash("range_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_range_abs.detail().name_hash()[i] = range_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_range_abs);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_image_key_points;
            mst_image_key_points.common().member_id(memberId++);
            mst_image_key_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_image_key_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_image_key_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_image_key_points.common().member_flags().IS_OPTIONAL(false);
            mst_image_key_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_image_key_points.common().member_flags().IS_KEY(false);
            mst_image_key_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_image_key_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ImageKeyPoint", 100, false));


            MD5 image_key_points_hash("image_key_points");
            for(int i = 0; i < 4; ++i)
            {
                mst_image_key_points.detail().name_hash()[i] = image_key_points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_image_key_points);

            MinimalStructMember mst_polygon_point_abs;
            mst_polygon_point_abs.common().member_id(memberId++);
            mst_polygon_point_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_polygon_point_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_polygon_point_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_polygon_point_abs.common().member_flags().IS_OPTIONAL(false);
            mst_polygon_point_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_polygon_point_abs.common().member_flags().IS_KEY(false);
            mst_polygon_point_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_polygon_point_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 polygon_point_abs_hash("polygon_point_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_polygon_point_abs.detail().name_hash()[i] = polygon_point_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_polygon_point_abs);

            MinimalStructMember mst_polygon_point_vehicle;
            mst_polygon_point_vehicle.common().member_id(memberId++);
            mst_polygon_point_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_polygon_point_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_polygon_point_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_polygon_point_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_polygon_point_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_polygon_point_vehicle.common().member_flags().IS_KEY(false);
            mst_polygon_point_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_polygon_point_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 polygon_point_vehicle_hash("polygon_point_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_polygon_point_vehicle.detail().name_hash()[i] = polygon_point_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_polygon_point_vehicle);

            MinimalStructMember mst_tracking_time;
            mst_tracking_time.common().member_id(memberId++);
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            mst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tracking_time.common().member_flags().IS_KEY(false);
            mst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tracking_time_hash("tracking_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_tracking_time.detail().name_hash()[i] = tracking_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tracking_time);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_confidence_type;
            mst_confidence_type.common().member_id(memberId++);
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            mst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence_type.common().member_flags().IS_KEY(false);
            mst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 confidence_type_hash("confidence_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence_type.detail().name_hash()[i] = confidence_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence_type);

            MinimalStructMember mst_drops;
            mst_drops.common().member_id(memberId++);
            mst_drops.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_drops.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_drops.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_drops.common().member_flags().IS_OPTIONAL(false);
            mst_drops.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_drops.common().member_flags().IS_KEY(false);
            mst_drops.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_drops.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 drops_hash("drops");
            for(int i = 0; i < 4; ++i)
            {
                mst_drops.detail().name_hash()[i] = drops_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_drops);

            MinimalStructMember mst_acceleration_vehicle;
            mst_acceleration_vehicle.common().member_id(memberId++);
            mst_acceleration_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_vehicle.common().member_flags().IS_KEY(false);
            mst_acceleration_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 acceleration_vehicle_hash("acceleration_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_vehicle.detail().name_hash()[i] = acceleration_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_vehicle);

            MinimalStructMember mst_acceleration_abs;
            mst_acceleration_abs.common().member_id(memberId++);
            mst_acceleration_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_abs.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_abs.common().member_flags().IS_KEY(false);
            mst_acceleration_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 acceleration_abs_hash("acceleration_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_abs.detail().name_hash()[i] = acceleration_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_abs);

            MinimalStructMember mst_anchor_point_image;
            mst_anchor_point_image.common().member_id(memberId++);
            mst_anchor_point_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_anchor_point_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_anchor_point_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_anchor_point_image.common().member_flags().IS_OPTIONAL(false);
            mst_anchor_point_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_anchor_point_image.common().member_flags().IS_KEY(false);
            mst_anchor_point_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_anchor_point_image.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 anchor_point_image_hash("anchor_point_image");
            for(int i = 0; i < 4; ++i)
            {
                mst_anchor_point_image.detail().name_hash()[i] = anchor_point_image_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_anchor_point_image);

            MinimalStructMember mst_anchor_point_vehicle;
            mst_anchor_point_vehicle.common().member_id(memberId++);
            mst_anchor_point_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_anchor_point_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_anchor_point_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_anchor_point_vehicle.common().member_flags().IS_OPTIONAL(false);
            mst_anchor_point_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_anchor_point_vehicle.common().member_flags().IS_KEY(false);
            mst_anchor_point_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_anchor_point_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 anchor_point_vehicle_hash("anchor_point_vehicle");
            for(int i = 0; i < 4; ++i)
            {
                mst_anchor_point_vehicle.detail().name_hash()[i] = anchor_point_vehicle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_anchor_point_vehicle);

            MinimalStructMember mst_anchor_point_abs;
            mst_anchor_point_abs.common().member_id(memberId++);
            mst_anchor_point_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_anchor_point_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_anchor_point_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_anchor_point_abs.common().member_flags().IS_OPTIONAL(false);
            mst_anchor_point_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_anchor_point_abs.common().member_flags().IS_KEY(false);
            mst_anchor_point_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_anchor_point_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 anchor_point_abs_hash("anchor_point_abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_anchor_point_abs.detail().name_hash()[i] = anchor_point_abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_anchor_point_abs);

            MinimalStructMember mst_bbox2d;
            mst_bbox2d.common().member_id(memberId++);
            mst_bbox2d.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_bbox2d.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_bbox2d.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_bbox2d.common().member_flags().IS_OPTIONAL(false);
            mst_bbox2d.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_bbox2d.common().member_flags().IS_KEY(false);
            mst_bbox2d.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_bbox2d.common().member_type_id(*ros2_interface::msg::GetBBox2DIdentifier(false));
            MD5 bbox2d_hash("bbox2d");
            for(int i = 0; i < 4; ++i)
            {
                mst_bbox2d.detail().name_hash()[i] = bbox2d_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_bbox2d);

            MinimalStructMember mst_bbox2d_rear;
            mst_bbox2d_rear.common().member_id(memberId++);
            mst_bbox2d_rear.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_bbox2d_rear.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_bbox2d_rear.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_bbox2d_rear.common().member_flags().IS_OPTIONAL(false);
            mst_bbox2d_rear.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_bbox2d_rear.common().member_flags().IS_KEY(false);
            mst_bbox2d_rear.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_bbox2d_rear.common().member_type_id(*ros2_interface::msg::GetBBox2DIdentifier(false));
            MD5 bbox2d_rear_hash("bbox2d_rear");
            for(int i = 0; i < 4; ++i)
            {
                mst_bbox2d_rear.detail().name_hash()[i] = bbox2d_rear_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_bbox2d_rear);

            MinimalStructMember mst_sub_type;
            mst_sub_type.common().member_id(memberId++);
            mst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sub_type.common().member_flags().IS_OPTIONAL(false);
            mst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sub_type.common().member_flags().IS_KEY(false);
            mst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sub_type_hash("sub_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_sub_type.detail().name_hash()[i] = sub_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sub_type);

            MinimalStructMember mst_height_above_ground;
            mst_height_above_ground.common().member_id(memberId++);
            mst_height_above_ground.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height_above_ground.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height_above_ground.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height_above_ground.common().member_flags().IS_OPTIONAL(false);
            mst_height_above_ground.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height_above_ground.common().member_flags().IS_KEY(false);
            mst_height_above_ground.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height_above_ground.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_above_ground_hash("height_above_ground");
            for(int i = 0; i < 4; ++i)
            {
                mst_height_above_ground.detail().name_hash()[i] = height_above_ground_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height_above_ground);

            MinimalStructMember mst_position_abs_covariance;
            mst_position_abs_covariance.common().member_id(memberId++);
            mst_position_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_position_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_abs_covariance.common().member_flags().IS_KEY(false);
            mst_position_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 position_abs_covariance_hash("position_abs_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_abs_covariance.detail().name_hash()[i] = position_abs_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_abs_covariance);

            MinimalStructMember mst_velocity_abs_covariance;
            mst_velocity_abs_covariance.common().member_id(memberId++);
            mst_velocity_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_abs_covariance.common().member_flags().IS_KEY(false);
            mst_velocity_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 velocity_abs_covariance_hash("velocity_abs_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_abs_covariance.detail().name_hash()[i] = velocity_abs_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_abs_covariance);

            MinimalStructMember mst_acceleration_abs_covariance;
            mst_acceleration_abs_covariance.common().member_id(memberId++);
            mst_acceleration_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_abs_covariance.common().member_flags().IS_KEY(false);
            mst_acceleration_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 acceleration_abs_covariance_hash("acceleration_abs_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_abs_covariance.detail().name_hash()[i] = acceleration_abs_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_abs_covariance);

            MinimalStructMember mst_theta_abs_covariance;
            mst_theta_abs_covariance.common().member_id(memberId++);
            mst_theta_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_theta_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_abs_covariance.common().member_flags().IS_KEY(false);
            mst_theta_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_abs_covariance_hash("theta_abs_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_abs_covariance.detail().name_hash()[i] = theta_abs_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_abs_covariance);

            MinimalStructMember mst_position_vehicle_covariance;
            mst_position_vehicle_covariance.common().member_id(memberId++);
            mst_position_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_position_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_vehicle_covariance.common().member_flags().IS_KEY(false);
            mst_position_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 position_vehicle_covariance_hash("position_vehicle_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_vehicle_covariance.detail().name_hash()[i] = position_vehicle_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_vehicle_covariance);

            MinimalStructMember mst_velocity_vehicle_covariance;
            mst_velocity_vehicle_covariance.common().member_id(memberId++);
            mst_velocity_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_vehicle_covariance.common().member_flags().IS_KEY(false);
            mst_velocity_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 velocity_vehicle_covariance_hash("velocity_vehicle_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_vehicle_covariance.detail().name_hash()[i] = velocity_vehicle_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_vehicle_covariance);

            MinimalStructMember mst_acceleration_vehicle_covariance;
            mst_acceleration_vehicle_covariance.common().member_id(memberId++);
            mst_acceleration_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_vehicle_covariance.common().member_flags().IS_KEY(false);
            mst_acceleration_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 acceleration_vehicle_covariance_hash("acceleration_vehicle_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_vehicle_covariance.detail().name_hash()[i] = acceleration_vehicle_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_vehicle_covariance);

            MinimalStructMember mst_theta_vehicle_covariance;
            mst_theta_vehicle_covariance.common().member_id(memberId++);
            mst_theta_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_theta_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta_vehicle_covariance.common().member_flags().IS_KEY(false);
            mst_theta_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_vehicle_covariance_hash("theta_vehicle_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta_vehicle_covariance.detail().name_hash()[i] = theta_vehicle_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta_vehicle_covariance);

            MinimalStructMember mst_cipv_flag;
            mst_cipv_flag.common().member_id(memberId++);
            mst_cipv_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cipv_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cipv_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cipv_flag.common().member_flags().IS_OPTIONAL(false);
            mst_cipv_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cipv_flag.common().member_flags().IS_KEY(false);
            mst_cipv_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cipv_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 cipv_flag_hash("cipv_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_cipv_flag.detail().name_hash()[i] = cipv_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cipv_flag);

            MinimalStructMember mst_lane_position;
            mst_lane_position.common().member_id(memberId++);
            mst_lane_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_position.common().member_flags().IS_OPTIONAL(false);
            mst_lane_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_position.common().member_flags().IS_KEY(false);
            mst_lane_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_position.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lane_position_hash("lane_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_position.detail().name_hash()[i] = lane_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_position);

            MinimalStructMember mst_pihp_percentage;
            mst_pihp_percentage.common().member_id(memberId++);
            mst_pihp_percentage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pihp_percentage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pihp_percentage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pihp_percentage.common().member_flags().IS_OPTIONAL(false);
            mst_pihp_percentage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pihp_percentage.common().member_flags().IS_KEY(false);
            mst_pihp_percentage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pihp_percentage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 pihp_percentage_hash("pihp_percentage");
            for(int i = 0; i < 4; ++i)
            {
                mst_pihp_percentage.detail().name_hash()[i] = pihp_percentage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pihp_percentage);

            MinimalStructMember mst_blinker_flag;
            mst_blinker_flag.common().member_id(memberId++);
            mst_blinker_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_blinker_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_blinker_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_blinker_flag.common().member_flags().IS_OPTIONAL(false);
            mst_blinker_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_blinker_flag.common().member_flags().IS_KEY(false);
            mst_blinker_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_blinker_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 blinker_flag_hash("blinker_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_blinker_flag.detail().name_hash()[i] = blinker_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_blinker_flag);

            MinimalStructMember mst_fusion_type;
            mst_fusion_type.common().member_id(memberId++);
            mst_fusion_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_fusion_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_fusion_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_fusion_type.common().member_flags().IS_OPTIONAL(false);
            mst_fusion_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_fusion_type.common().member_flags().IS_KEY(false);
            mst_fusion_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_fusion_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 fusion_type_hash("fusion_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_fusion_type.detail().name_hash()[i] = fusion_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_fusion_type);

            MinimalStructMember mst_sensor_pos_id;
            mst_sensor_pos_id.common().member_id(memberId++);
            mst_sensor_pos_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sensor_pos_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sensor_pos_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sensor_pos_id.common().member_flags().IS_OPTIONAL(false);
            mst_sensor_pos_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sensor_pos_id.common().member_flags().IS_KEY(false);
            mst_sensor_pos_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sensor_pos_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 sensor_pos_id_hash("sensor_pos_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_sensor_pos_id.detail().name_hash()[i] = sensor_pos_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sensor_pos_id);

            MinimalStructMember mst_predict_trajectories;
            mst_predict_trajectories.common().member_id(memberId++);
            mst_predict_trajectories.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_predict_trajectories.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_predict_trajectories.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_predict_trajectories.common().member_flags().IS_OPTIONAL(false);
            mst_predict_trajectories.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_predict_trajectories.common().member_flags().IS_KEY(false);
            mst_predict_trajectories.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_predict_trajectories.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, false));


            MD5 predict_trajectories_hash("predict_trajectories");
            for(int i = 0; i < 4; ++i)
            {
                mst_predict_trajectories.detail().name_hash()[i] = predict_trajectories_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_predict_trajectories);

            MinimalStructMember mst_intent;
            mst_intent.common().member_id(memberId++);
            mst_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_intent.common().member_flags().IS_OPTIONAL(false);
            mst_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_intent.common().member_flags().IS_KEY(false);
            mst_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_intent.common().member_type_id(*ros2_interface::msg::GetObstacleIntentIdentifier(false));
            MD5 intent_hash("intent");
            for(int i = 0; i < 4; ++i)
            {
                mst_intent.detail().name_hash()[i] = intent_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_intent);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Obstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Obstacle", false);
        }

        const TypeObject* GetCompleteObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Obstacle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_existence_prob;
            cst_existence_prob.common().member_id(memberId++);
            cst_existence_prob.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_existence_prob.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_existence_prob.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_existence_prob.common().member_flags().IS_OPTIONAL(false);
            cst_existence_prob.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_existence_prob.common().member_flags().IS_KEY(false);
            cst_existence_prob.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_existence_prob.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_existence_prob.detail().name("existence_prob");

            type_object->complete().struct_type().member_seq().emplace_back(cst_existence_prob);

            CompleteStructMember cst_create_time;
            cst_create_time.common().member_id(memberId++);
            cst_create_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_create_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_create_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_create_time.common().member_flags().IS_OPTIONAL(false);
            cst_create_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_create_time.common().member_flags().IS_KEY(false);
            cst_create_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_create_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_create_time.detail().name("create_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_create_time);

            CompleteStructMember cst_last_updated_time;
            cst_last_updated_time.common().member_id(memberId++);
            cst_last_updated_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_last_updated_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_last_updated_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_last_updated_time.common().member_flags().IS_OPTIONAL(false);
            cst_last_updated_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_last_updated_time.common().member_flags().IS_KEY(false);
            cst_last_updated_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_last_updated_time.common().member_type_id(*ros2_interface::msg::GetTimeIdentifier(true));
            cst_last_updated_time.detail().name("last_updated_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_last_updated_time);

            CompleteStructMember cst_center_pos_vehicle;
            cst_center_pos_vehicle.common().member_id(memberId++);
            cst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_center_pos_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_center_pos_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_center_pos_vehicle.common().member_flags().IS_KEY(false);
            cst_center_pos_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_center_pos_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_center_pos_vehicle.detail().name("center_pos_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_center_pos_vehicle);

            CompleteStructMember cst_center_pos_abs;
            cst_center_pos_abs.common().member_id(memberId++);
            cst_center_pos_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_center_pos_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_center_pos_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_center_pos_abs.common().member_flags().IS_OPTIONAL(false);
            cst_center_pos_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_center_pos_abs.common().member_flags().IS_KEY(false);
            cst_center_pos_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_center_pos_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_center_pos_abs.detail().name("center_pos_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_center_pos_abs);

            CompleteStructMember cst_theta_vehicle;
            cst_theta_vehicle.common().member_id(memberId++);
            cst_theta_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_theta_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_vehicle.common().member_flags().IS_KEY(false);
            cst_theta_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_vehicle.detail().name("theta_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_vehicle);

            CompleteStructMember cst_theta_abs;
            cst_theta_abs.common().member_id(memberId++);
            cst_theta_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_abs.common().member_flags().IS_OPTIONAL(false);
            cst_theta_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_abs.common().member_flags().IS_KEY(false);
            cst_theta_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_abs.detail().name("theta_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_abs);

            CompleteStructMember cst_velocity_vehicle;
            cst_velocity_vehicle.common().member_id(memberId++);
            cst_velocity_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_vehicle.common().member_flags().IS_KEY(false);
            cst_velocity_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_velocity_vehicle.detail().name("velocity_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_vehicle);

            CompleteStructMember cst_velocity_abs;
            cst_velocity_abs.common().member_id(memberId++);
            cst_velocity_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_abs.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_abs.common().member_flags().IS_KEY(false);
            cst_velocity_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_velocity_abs.detail().name("velocity_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_abs);

            CompleteStructMember cst_range_vehicle;
            cst_range_vehicle.common().member_id(memberId++);
            cst_range_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_range_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_range_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_range_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_range_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_range_vehicle.common().member_flags().IS_KEY(false);
            cst_range_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_range_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_range_vehicle.detail().name("range_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_range_vehicle);

            CompleteStructMember cst_range_abs;
            cst_range_abs.common().member_id(memberId++);
            cst_range_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_range_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_range_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_range_abs.common().member_flags().IS_OPTIONAL(false);
            cst_range_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_range_abs.common().member_flags().IS_KEY(false);
            cst_range_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_range_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_range_abs.detail().name("range_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_range_abs);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_image_key_points;
            cst_image_key_points.common().member_id(memberId++);
            cst_image_key_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_image_key_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_image_key_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_image_key_points.common().member_flags().IS_OPTIONAL(false);
            cst_image_key_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_image_key_points.common().member_flags().IS_KEY(false);
            cst_image_key_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_image_key_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ImageKeyPoint", 100, true));


            cst_image_key_points.detail().name("image_key_points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_image_key_points);

            CompleteStructMember cst_polygon_point_abs;
            cst_polygon_point_abs.common().member_id(memberId++);
            cst_polygon_point_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_polygon_point_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_polygon_point_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_polygon_point_abs.common().member_flags().IS_OPTIONAL(false);
            cst_polygon_point_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_polygon_point_abs.common().member_flags().IS_KEY(false);
            cst_polygon_point_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_polygon_point_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_polygon_point_abs.detail().name("polygon_point_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_polygon_point_abs);

            CompleteStructMember cst_polygon_point_vehicle;
            cst_polygon_point_vehicle.common().member_id(memberId++);
            cst_polygon_point_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_polygon_point_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_polygon_point_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_polygon_point_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_polygon_point_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_polygon_point_vehicle.common().member_flags().IS_KEY(false);
            cst_polygon_point_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_polygon_point_vehicle.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_polygon_point_vehicle.detail().name("polygon_point_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_polygon_point_vehicle);

            CompleteStructMember cst_tracking_time;
            cst_tracking_time.common().member_id(memberId++);
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            cst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tracking_time.common().member_flags().IS_KEY(false);
            cst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tracking_time.detail().name("tracking_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tracking_time);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_confidence_type;
            cst_confidence_type.common().member_id(memberId++);
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            cst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence_type.common().member_flags().IS_KEY(false);
            cst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_confidence_type.detail().name("confidence_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence_type);

            CompleteStructMember cst_drops;
            cst_drops.common().member_id(memberId++);
            cst_drops.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_drops.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_drops.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_drops.common().member_flags().IS_OPTIONAL(false);
            cst_drops.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_drops.common().member_flags().IS_KEY(false);
            cst_drops.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_drops.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_drops.detail().name("drops");

            type_object->complete().struct_type().member_seq().emplace_back(cst_drops);

            CompleteStructMember cst_acceleration_vehicle;
            cst_acceleration_vehicle.common().member_id(memberId++);
            cst_acceleration_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_vehicle.common().member_flags().IS_KEY(false);
            cst_acceleration_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_acceleration_vehicle.detail().name("acceleration_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_vehicle);

            CompleteStructMember cst_acceleration_abs;
            cst_acceleration_abs.common().member_id(memberId++);
            cst_acceleration_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_abs.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_abs.common().member_flags().IS_KEY(false);
            cst_acceleration_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_acceleration_abs.detail().name("acceleration_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_abs);

            CompleteStructMember cst_anchor_point_image;
            cst_anchor_point_image.common().member_id(memberId++);
            cst_anchor_point_image.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_anchor_point_image.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_anchor_point_image.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_anchor_point_image.common().member_flags().IS_OPTIONAL(false);
            cst_anchor_point_image.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_anchor_point_image.common().member_flags().IS_KEY(false);
            cst_anchor_point_image.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_anchor_point_image.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_anchor_point_image.detail().name("anchor_point_image");

            type_object->complete().struct_type().member_seq().emplace_back(cst_anchor_point_image);

            CompleteStructMember cst_anchor_point_vehicle;
            cst_anchor_point_vehicle.common().member_id(memberId++);
            cst_anchor_point_vehicle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_anchor_point_vehicle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_anchor_point_vehicle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_anchor_point_vehicle.common().member_flags().IS_OPTIONAL(false);
            cst_anchor_point_vehicle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_anchor_point_vehicle.common().member_flags().IS_KEY(false);
            cst_anchor_point_vehicle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_anchor_point_vehicle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_anchor_point_vehicle.detail().name("anchor_point_vehicle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_anchor_point_vehicle);

            CompleteStructMember cst_anchor_point_abs;
            cst_anchor_point_abs.common().member_id(memberId++);
            cst_anchor_point_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_anchor_point_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_anchor_point_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_anchor_point_abs.common().member_flags().IS_OPTIONAL(false);
            cst_anchor_point_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_anchor_point_abs.common().member_flags().IS_KEY(false);
            cst_anchor_point_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_anchor_point_abs.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_anchor_point_abs.detail().name("anchor_point_abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_anchor_point_abs);

            CompleteStructMember cst_bbox2d;
            cst_bbox2d.common().member_id(memberId++);
            cst_bbox2d.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_bbox2d.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_bbox2d.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_bbox2d.common().member_flags().IS_OPTIONAL(false);
            cst_bbox2d.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_bbox2d.common().member_flags().IS_KEY(false);
            cst_bbox2d.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_bbox2d.common().member_type_id(*ros2_interface::msg::GetBBox2DIdentifier(true));
            cst_bbox2d.detail().name("bbox2d");

            type_object->complete().struct_type().member_seq().emplace_back(cst_bbox2d);

            CompleteStructMember cst_bbox2d_rear;
            cst_bbox2d_rear.common().member_id(memberId++);
            cst_bbox2d_rear.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_bbox2d_rear.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_bbox2d_rear.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_bbox2d_rear.common().member_flags().IS_OPTIONAL(false);
            cst_bbox2d_rear.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_bbox2d_rear.common().member_flags().IS_KEY(false);
            cst_bbox2d_rear.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_bbox2d_rear.common().member_type_id(*ros2_interface::msg::GetBBox2DIdentifier(true));
            cst_bbox2d_rear.detail().name("bbox2d_rear");

            type_object->complete().struct_type().member_seq().emplace_back(cst_bbox2d_rear);

            CompleteStructMember cst_sub_type;
            cst_sub_type.common().member_id(memberId++);
            cst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sub_type.common().member_flags().IS_OPTIONAL(false);
            cst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sub_type.common().member_flags().IS_KEY(false);
            cst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sub_type.detail().name("sub_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sub_type);

            CompleteStructMember cst_height_above_ground;
            cst_height_above_ground.common().member_id(memberId++);
            cst_height_above_ground.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height_above_ground.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height_above_ground.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height_above_ground.common().member_flags().IS_OPTIONAL(false);
            cst_height_above_ground.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height_above_ground.common().member_flags().IS_KEY(false);
            cst_height_above_ground.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height_above_ground.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height_above_ground.detail().name("height_above_ground");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height_above_ground);

            CompleteStructMember cst_position_abs_covariance;
            cst_position_abs_covariance.common().member_id(memberId++);
            cst_position_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_position_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_abs_covariance.common().member_flags().IS_KEY(false);
            cst_position_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_position_abs_covariance.detail().name("position_abs_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_abs_covariance);

            CompleteStructMember cst_velocity_abs_covariance;
            cst_velocity_abs_covariance.common().member_id(memberId++);
            cst_velocity_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_abs_covariance.common().member_flags().IS_KEY(false);
            cst_velocity_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_velocity_abs_covariance.detail().name("velocity_abs_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_abs_covariance);

            CompleteStructMember cst_acceleration_abs_covariance;
            cst_acceleration_abs_covariance.common().member_id(memberId++);
            cst_acceleration_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_abs_covariance.common().member_flags().IS_KEY(false);
            cst_acceleration_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_acceleration_abs_covariance.detail().name("acceleration_abs_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_abs_covariance);

            CompleteStructMember cst_theta_abs_covariance;
            cst_theta_abs_covariance.common().member_id(memberId++);
            cst_theta_abs_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_abs_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_abs_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_abs_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_theta_abs_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_abs_covariance.common().member_flags().IS_KEY(false);
            cst_theta_abs_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_abs_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_abs_covariance.detail().name("theta_abs_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_abs_covariance);

            CompleteStructMember cst_position_vehicle_covariance;
            cst_position_vehicle_covariance.common().member_id(memberId++);
            cst_position_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_position_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_vehicle_covariance.common().member_flags().IS_KEY(false);
            cst_position_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_position_vehicle_covariance.detail().name("position_vehicle_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_vehicle_covariance);

            CompleteStructMember cst_velocity_vehicle_covariance;
            cst_velocity_vehicle_covariance.common().member_id(memberId++);
            cst_velocity_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_vehicle_covariance.common().member_flags().IS_KEY(false);
            cst_velocity_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_velocity_vehicle_covariance.detail().name("velocity_vehicle_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_vehicle_covariance);

            CompleteStructMember cst_acceleration_vehicle_covariance;
            cst_acceleration_vehicle_covariance.common().member_id(memberId++);
            cst_acceleration_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_vehicle_covariance.common().member_flags().IS_KEY(false);
            cst_acceleration_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_acceleration_vehicle_covariance.detail().name("acceleration_vehicle_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_vehicle_covariance);

            CompleteStructMember cst_theta_vehicle_covariance;
            cst_theta_vehicle_covariance.common().member_id(memberId++);
            cst_theta_vehicle_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta_vehicle_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta_vehicle_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta_vehicle_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_theta_vehicle_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta_vehicle_covariance.common().member_flags().IS_KEY(false);
            cst_theta_vehicle_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta_vehicle_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta_vehicle_covariance.detail().name("theta_vehicle_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta_vehicle_covariance);

            CompleteStructMember cst_cipv_flag;
            cst_cipv_flag.common().member_id(memberId++);
            cst_cipv_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cipv_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cipv_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cipv_flag.common().member_flags().IS_OPTIONAL(false);
            cst_cipv_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cipv_flag.common().member_flags().IS_KEY(false);
            cst_cipv_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cipv_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_cipv_flag.detail().name("cipv_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cipv_flag);

            CompleteStructMember cst_lane_position;
            cst_lane_position.common().member_id(memberId++);
            cst_lane_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_position.common().member_flags().IS_OPTIONAL(false);
            cst_lane_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_position.common().member_flags().IS_KEY(false);
            cst_lane_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_position.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lane_position.detail().name("lane_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_position);

            CompleteStructMember cst_pihp_percentage;
            cst_pihp_percentage.common().member_id(memberId++);
            cst_pihp_percentage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pihp_percentage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pihp_percentage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pihp_percentage.common().member_flags().IS_OPTIONAL(false);
            cst_pihp_percentage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pihp_percentage.common().member_flags().IS_KEY(false);
            cst_pihp_percentage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pihp_percentage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_pihp_percentage.detail().name("pihp_percentage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pihp_percentage);

            CompleteStructMember cst_blinker_flag;
            cst_blinker_flag.common().member_id(memberId++);
            cst_blinker_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_blinker_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_blinker_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_blinker_flag.common().member_flags().IS_OPTIONAL(false);
            cst_blinker_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_blinker_flag.common().member_flags().IS_KEY(false);
            cst_blinker_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_blinker_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_blinker_flag.detail().name("blinker_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_blinker_flag);

            CompleteStructMember cst_fusion_type;
            cst_fusion_type.common().member_id(memberId++);
            cst_fusion_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_fusion_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_fusion_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_fusion_type.common().member_flags().IS_OPTIONAL(false);
            cst_fusion_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_fusion_type.common().member_flags().IS_KEY(false);
            cst_fusion_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_fusion_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_fusion_type.detail().name("fusion_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_fusion_type);

            CompleteStructMember cst_sensor_pos_id;
            cst_sensor_pos_id.common().member_id(memberId++);
            cst_sensor_pos_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sensor_pos_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sensor_pos_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sensor_pos_id.common().member_flags().IS_OPTIONAL(false);
            cst_sensor_pos_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sensor_pos_id.common().member_flags().IS_KEY(false);
            cst_sensor_pos_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sensor_pos_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_sensor_pos_id.detail().name("sensor_pos_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sensor_pos_id);

            CompleteStructMember cst_predict_trajectories;
            cst_predict_trajectories.common().member_id(memberId++);
            cst_predict_trajectories.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_predict_trajectories.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_predict_trajectories.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_predict_trajectories.common().member_flags().IS_OPTIONAL(false);
            cst_predict_trajectories.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_predict_trajectories.common().member_flags().IS_KEY(false);
            cst_predict_trajectories.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_predict_trajectories.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, true));


            cst_predict_trajectories.detail().name("predict_trajectories");

            type_object->complete().struct_type().member_seq().emplace_back(cst_predict_trajectories);

            CompleteStructMember cst_intent;
            cst_intent.common().member_id(memberId++);
            cst_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_intent.common().member_flags().IS_OPTIONAL(false);
            cst_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_intent.common().member_flags().IS_KEY(false);
            cst_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_intent.common().member_type_id(*ros2_interface::msg::GetObstacleIntentIdentifier(true));
            cst_intent.detail().name("intent");

            type_object->complete().struct_type().member_seq().emplace_back(cst_intent);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Obstacle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Obstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Obstacle", true);
        }

    } // namespace msg
} // namespace ros2_interface