// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObuCmd.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObuCmd.h"
#include "ObuCmdTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObuCmd_max_cdr_typesize 8ULL;
#define ros2_interface_msg_ObuCmd_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObuCmd::ObuCmd()
{
    // long m_code
    m_code = 0;
    // long m_val
    m_val = 0;

    // Just to register all known types
    registerObuCmdTypes();
}

ros2_interface::msg::ObuCmd::~ObuCmd()
{


}

ros2_interface::msg::ObuCmd::ObuCmd(
        const ObuCmd& x)
{
    m_code = x.m_code;
    m_val = x.m_val;
}

ros2_interface::msg::ObuCmd::ObuCmd(
        ObuCmd&& x) noexcept 
{
    m_code = x.m_code;
    m_val = x.m_val;
}

ros2_interface::msg::ObuCmd& ros2_interface::msg::ObuCmd::operator =(
        const ObuCmd& x)
{

    m_code = x.m_code;
    m_val = x.m_val;

    return *this;
}

ros2_interface::msg::ObuCmd& ros2_interface::msg::ObuCmd::operator =(
        ObuCmd&& x) noexcept
{

    m_code = x.m_code;
    m_val = x.m_val;

    return *this;
}

bool ros2_interface::msg::ObuCmd::operator ==(
        const ObuCmd& x) const
{

    return (m_code == x.m_code && m_val == x.m_val);
}

bool ros2_interface::msg::ObuCmd::operator !=(
        const ObuCmd& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObuCmd::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObuCmd_max_cdr_typesize;
}

size_t ros2_interface::msg::ObuCmd::getCdrSerializedSize(
        const ros2_interface::msg::ObuCmd& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObuCmd::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_code;
    scdr << m_val;

}

void ros2_interface::msg::ObuCmd::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_code;
    dcdr >> m_val;
}

/*!
 * @brief This function sets a value in member code
 * @param _code New value for member code
 */
void ros2_interface::msg::ObuCmd::code(
        int32_t _code)
{
    m_code = _code;
}

/*!
 * @brief This function returns the value of member code
 * @return Value of member code
 */
int32_t ros2_interface::msg::ObuCmd::code() const
{
    return m_code;
}

/*!
 * @brief This function returns a reference to member code
 * @return Reference to member code
 */
int32_t& ros2_interface::msg::ObuCmd::code()
{
    return m_code;
}

/*!
 * @brief This function sets a value in member val
 * @param _val New value for member val
 */
void ros2_interface::msg::ObuCmd::val(
        int32_t _val)
{
    m_val = _val;
}

/*!
 * @brief This function returns the value of member val
 * @return Value of member val
 */
int32_t ros2_interface::msg::ObuCmd::val() const
{
    return m_val;
}

/*!
 * @brief This function returns a reference to member val
 * @return Reference to member val
 */
int32_t& ros2_interface::msg::ObuCmd::val()
{
    return m_val;
}



size_t ros2_interface::msg::ObuCmd::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObuCmd_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObuCmd::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObuCmd::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



