// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObuCmdMsg.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ObuCmdMsg.h"
#include "ObuCmdMsgTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ObuCmd_max_cdr_typesize 8ULL;
#define ros2_interface_msg_ObuCmdMsg_max_cdr_typesize 1340ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObuCmd_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObuCmdMsg_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ObuCmdMsg::ObuCmdMsg()
{
    // ros2_interface::msg::Header m_header

    // long m_id
    m_id = 0;
    // string m_name
    m_name ="";
    // sequence<ros2_interface::msg::ObuCmd> m_obu_cmd_list


    // Just to register all known types
    registerObuCmdMsgTypes();
}

ros2_interface::msg::ObuCmdMsg::~ObuCmdMsg()
{




}

ros2_interface::msg::ObuCmdMsg::ObuCmdMsg(
        const ObuCmdMsg& x)
{
    m_header = x.m_header;
    m_id = x.m_id;
    m_name = x.m_name;
    m_obu_cmd_list = x.m_obu_cmd_list;
}

ros2_interface::msg::ObuCmdMsg::ObuCmdMsg(
        ObuCmdMsg&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_id = x.m_id;
    m_name = std::move(x.m_name);
    m_obu_cmd_list = std::move(x.m_obu_cmd_list);
}

ros2_interface::msg::ObuCmdMsg& ros2_interface::msg::ObuCmdMsg::operator =(
        const ObuCmdMsg& x)
{

    m_header = x.m_header;
    m_id = x.m_id;
    m_name = x.m_name;
    m_obu_cmd_list = x.m_obu_cmd_list;

    return *this;
}

ros2_interface::msg::ObuCmdMsg& ros2_interface::msg::ObuCmdMsg::operator =(
        ObuCmdMsg&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_id = x.m_id;
    m_name = std::move(x.m_name);
    m_obu_cmd_list = std::move(x.m_obu_cmd_list);

    return *this;
}

bool ros2_interface::msg::ObuCmdMsg::operator ==(
        const ObuCmdMsg& x) const
{

    return (m_header == x.m_header && m_id == x.m_id && m_name == x.m_name && m_obu_cmd_list == x.m_obu_cmd_list);
}

bool ros2_interface::msg::ObuCmdMsg::operator !=(
        const ObuCmdMsg& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ObuCmdMsg::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObuCmdMsg_max_cdr_typesize;
}

size_t ros2_interface::msg::ObuCmdMsg::getCdrSerializedSize(
        const ros2_interface::msg::ObuCmdMsg& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.obu_cmd_list().size(); ++a)
    {
        current_alignment += ros2_interface::msg::ObuCmd::getCdrSerializedSize(data.obu_cmd_list().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ObuCmdMsg::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_id;
    scdr << m_name.c_str();
    scdr << m_obu_cmd_list;

}

void ros2_interface::msg::ObuCmdMsg::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_id;
    dcdr >> m_name;
    dcdr >> m_obu_cmd_list;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ObuCmdMsg::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ObuCmdMsg::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ObuCmdMsg::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ObuCmdMsg::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::ObuCmdMsg::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::ObuCmdMsg::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::ObuCmdMsg::id()
{
    return m_id;
}

/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::ObuCmdMsg::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::ObuCmdMsg::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::ObuCmdMsg::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::ObuCmdMsg::name()
{
    return m_name;
}
/*!
 * @brief This function copies the value in member obu_cmd_list
 * @param _obu_cmd_list New value to be copied in member obu_cmd_list
 */
void ros2_interface::msg::ObuCmdMsg::obu_cmd_list(
        const std::vector<ros2_interface::msg::ObuCmd>& _obu_cmd_list)
{
    m_obu_cmd_list = _obu_cmd_list;
}

/*!
 * @brief This function moves the value in member obu_cmd_list
 * @param _obu_cmd_list New value to be moved in member obu_cmd_list
 */
void ros2_interface::msg::ObuCmdMsg::obu_cmd_list(
        std::vector<ros2_interface::msg::ObuCmd>&& _obu_cmd_list)
{
    m_obu_cmd_list = std::move(_obu_cmd_list);
}

/*!
 * @brief This function returns a constant reference to member obu_cmd_list
 * @return Constant reference to member obu_cmd_list
 */
const std::vector<ros2_interface::msg::ObuCmd>& ros2_interface::msg::ObuCmdMsg::obu_cmd_list() const
{
    return m_obu_cmd_list;
}

/*!
 * @brief This function returns a reference to member obu_cmd_list
 * @return Reference to member obu_cmd_list
 */
std::vector<ros2_interface::msg::ObuCmd>& ros2_interface::msg::ObuCmdMsg::obu_cmd_list()
{
    return m_obu_cmd_list;
}


size_t ros2_interface::msg::ObuCmdMsg::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ObuCmdMsg_max_key_cdr_typesize;
}

bool ros2_interface::msg::ObuCmdMsg::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ObuCmdMsg::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



