// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObuCmdMsg.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBUCMDMSG_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBUCMDMSG_H_

#include "ObuCmd.h"
#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(OBUCMDMSG_SOURCE)
#define OBUCMDMSG_DllAPI __declspec( dllexport )
#else
#define OBUCMDMSG_DllAPI __declspec( dllimport )
#endif // OBUCMDMSG_SOURCE
#else
#define OBUCMDMSG_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define OBUCMDMSG_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ObuCmdMsg defined by the user in the IDL file.
         * @ingroup ObuCmdMsg
         */
        class ObuCmdMsg
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ObuCmdMsg();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ObuCmdMsg();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ObuCmdMsg that will be copied.
             */
            eProsima_user_DllExport ObuCmdMsg(
                    const ObuCmdMsg& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ObuCmdMsg that will be copied.
             */
            eProsima_user_DllExport ObuCmdMsg(
                    ObuCmdMsg&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ObuCmdMsg that will be copied.
             */
            eProsima_user_DllExport ObuCmdMsg& operator =(
                    const ObuCmdMsg& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ObuCmdMsg that will be copied.
             */
            eProsima_user_DllExport ObuCmdMsg& operator =(
                    ObuCmdMsg&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ObuCmdMsg object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ObuCmdMsg& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ObuCmdMsg object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ObuCmdMsg& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function copies the value in member name
             * @param _name New value to be copied in member name
             */
            eProsima_user_DllExport void name(
                    const std::string& _name);

            /*!
             * @brief This function moves the value in member name
             * @param _name New value to be moved in member name
             */
            eProsima_user_DllExport void name(
                    std::string&& _name);

            /*!
             * @brief This function returns a constant reference to member name
             * @return Constant reference to member name
             */
            eProsima_user_DllExport const std::string& name() const;

            /*!
             * @brief This function returns a reference to member name
             * @return Reference to member name
             */
            eProsima_user_DllExport std::string& name();
            /*!
             * @brief This function copies the value in member obu_cmd_list
             * @param _obu_cmd_list New value to be copied in member obu_cmd_list
             */
            eProsima_user_DllExport void obu_cmd_list(
                    const std::vector<ros2_interface::msg::ObuCmd>& _obu_cmd_list);

            /*!
             * @brief This function moves the value in member obu_cmd_list
             * @param _obu_cmd_list New value to be moved in member obu_cmd_list
             */
            eProsima_user_DllExport void obu_cmd_list(
                    std::vector<ros2_interface::msg::ObuCmd>&& _obu_cmd_list);

            /*!
             * @brief This function returns a constant reference to member obu_cmd_list
             * @return Constant reference to member obu_cmd_list
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::ObuCmd>& obu_cmd_list() const;

            /*!
             * @brief This function returns a reference to member obu_cmd_list
             * @return Reference to member obu_cmd_list
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::ObuCmd>& obu_cmd_list();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ObuCmdMsg& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_id;
            std::string m_name;
            std::vector<ros2_interface::msg::ObuCmd> m_obu_cmd_list;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_OBUCMDMSG_H_

