// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ObuCmdMsgTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "ObuCmdMsg.h"
#include "ObuCmdMsgTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerObuCmdMsgTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::ObuCmd", ros2_interface::msg::GetObuCmdIdentifier(true),
                        ros2_interface::msg::GetObuCmdObject(true));
                factory->add_type_object("ros2_interface::msg::ObuCmd", ros2_interface::msg::GetObuCmdIdentifier(false),
                        ros2_interface::msg::GetObuCmdObject(false));



                factory->add_type_object("ros2_interface::msg::ObuCmdMsg", ros2_interface::msg::GetObuCmdMsgIdentifier(true),
                        ros2_interface::msg::GetObuCmdMsgObject(true));
                factory->add_type_object("ros2_interface::msg::ObuCmdMsg", ros2_interface::msg::GetObuCmdMsgIdentifier(false),
                        ros2_interface::msg::GetObuCmdMsgObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetObuCmdMsgIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("ObuCmdMsg", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetObuCmdMsgObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("ObuCmdMsg", complete);
        }

        const TypeObject* GetObuCmdMsgObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObuCmdMsg", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteObuCmdMsgObject();
            }
            //else
            return GetMinimalObuCmdMsgObject();
        }

        const TypeObject* GetMinimalObuCmdMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObuCmdMsg", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_name;
            mst_name.common().member_id(memberId++);
            mst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_name.common().member_flags().IS_OPTIONAL(false);
            mst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_name.common().member_flags().IS_KEY(false);
            mst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 name_hash("name");
            for(int i = 0; i < 4; ++i)
            {
                mst_name.detail().name_hash()[i] = name_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_name);

            MinimalStructMember mst_obu_cmd_list;
            mst_obu_cmd_list.common().member_id(memberId++);
            mst_obu_cmd_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_obu_cmd_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_obu_cmd_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_obu_cmd_list.common().member_flags().IS_OPTIONAL(false);
            mst_obu_cmd_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_obu_cmd_list.common().member_flags().IS_KEY(false);
            mst_obu_cmd_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_obu_cmd_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ObuCmd", 100, false));


            MD5 obu_cmd_list_hash("obu_cmd_list");
            for(int i = 0; i < 4; ++i)
            {
                mst_obu_cmd_list.detail().name_hash()[i] = obu_cmd_list_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_obu_cmd_list);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ObuCmdMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ObuCmdMsg", false);
        }

        const TypeObject* GetCompleteObuCmdMsgObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ObuCmdMsg", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_name;
            cst_name.common().member_id(memberId++);
            cst_name.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_name.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_name.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_name.common().member_flags().IS_OPTIONAL(false);
            cst_name.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_name.common().member_flags().IS_KEY(false);
            cst_name.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_name.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_name.detail().name("name");

            type_object->complete().struct_type().member_seq().emplace_back(cst_name);

            CompleteStructMember cst_obu_cmd_list;
            cst_obu_cmd_list.common().member_id(memberId++);
            cst_obu_cmd_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_obu_cmd_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_obu_cmd_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_obu_cmd_list.common().member_flags().IS_OPTIONAL(false);
            cst_obu_cmd_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_obu_cmd_list.common().member_flags().IS_KEY(false);
            cst_obu_cmd_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_obu_cmd_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::ObuCmd", 100, true));


            cst_obu_cmd_list.detail().name("obu_cmd_list");

            type_object->complete().struct_type().member_seq().emplace_back(cst_obu_cmd_list);


            // Header
            type_object->complete().struct_type().header().detail().type_name("ObuCmdMsg");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ObuCmdMsg", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ObuCmdMsg", true);
        }

    } // namespace msg
} // namespace ros2_interface