// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Odometry.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Odometry.h"
#include "OdometryTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Quaternion_max_cdr_typesize 32ULL;
#define ros2_interface_msg_PointENU_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Odometry_max_cdr_typesize 1136ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Quaternion_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointENU_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Odometry_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Odometry::Odometry()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::PointENU m_position

    // ros2_interface::msg::Quaternion m_orientation

    // sequence<double> m_covariance


    // Just to register all known types
    registerOdometryTypes();
}

ros2_interface::msg::Odometry::~Odometry()
{




}

ros2_interface::msg::Odometry::Odometry(
        const Odometry& x)
{
    m_header = x.m_header;
    m_position = x.m_position;
    m_orientation = x.m_orientation;
    m_covariance = x.m_covariance;
}

ros2_interface::msg::Odometry::Odometry(
        Odometry&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_position = std::move(x.m_position);
    m_orientation = std::move(x.m_orientation);
    m_covariance = std::move(x.m_covariance);
}

ros2_interface::msg::Odometry& ros2_interface::msg::Odometry::operator =(
        const Odometry& x)
{

    m_header = x.m_header;
    m_position = x.m_position;
    m_orientation = x.m_orientation;
    m_covariance = x.m_covariance;

    return *this;
}

ros2_interface::msg::Odometry& ros2_interface::msg::Odometry::operator =(
        Odometry&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_position = std::move(x.m_position);
    m_orientation = std::move(x.m_orientation);
    m_covariance = std::move(x.m_covariance);

    return *this;
}

bool ros2_interface::msg::Odometry::operator ==(
        const Odometry& x) const
{

    return (m_header == x.m_header && m_position == x.m_position && m_orientation == x.m_orientation && m_covariance == x.m_covariance);
}

bool ros2_interface::msg::Odometry::operator !=(
        const Odometry& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Odometry::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Odometry_max_cdr_typesize;
}

size_t ros2_interface::msg::Odometry::getCdrSerializedSize(
        const ros2_interface::msg::Odometry& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::PointENU::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += ros2_interface::msg::Quaternion::getCdrSerializedSize(data.orientation(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.covariance().size() > 0)
    {
        current_alignment += (data.covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }




    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Odometry::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_position;
    scdr << m_orientation;
    scdr << m_covariance;

}

void ros2_interface::msg::Odometry::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_position;
    dcdr >> m_orientation;
    dcdr >> m_covariance;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Odometry::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Odometry::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Odometry::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Odometry::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::Odometry::position(
        const ros2_interface::msg::PointENU& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::Odometry::position(
        ros2_interface::msg::PointENU&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::PointENU& ros2_interface::msg::Odometry::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::PointENU& ros2_interface::msg::Odometry::position()
{
    return m_position;
}
/*!
 * @brief This function copies the value in member orientation
 * @param _orientation New value to be copied in member orientation
 */
void ros2_interface::msg::Odometry::orientation(
        const ros2_interface::msg::Quaternion& _orientation)
{
    m_orientation = _orientation;
}

/*!
 * @brief This function moves the value in member orientation
 * @param _orientation New value to be moved in member orientation
 */
void ros2_interface::msg::Odometry::orientation(
        ros2_interface::msg::Quaternion&& _orientation)
{
    m_orientation = std::move(_orientation);
}

/*!
 * @brief This function returns a constant reference to member orientation
 * @return Constant reference to member orientation
 */
const ros2_interface::msg::Quaternion& ros2_interface::msg::Odometry::orientation() const
{
    return m_orientation;
}

/*!
 * @brief This function returns a reference to member orientation
 * @return Reference to member orientation
 */
ros2_interface::msg::Quaternion& ros2_interface::msg::Odometry::orientation()
{
    return m_orientation;
}
/*!
 * @brief This function copies the value in member covariance
 * @param _covariance New value to be copied in member covariance
 */
void ros2_interface::msg::Odometry::covariance(
        const std::vector<double>& _covariance)
{
    m_covariance = _covariance;
}

/*!
 * @brief This function moves the value in member covariance
 * @param _covariance New value to be moved in member covariance
 */
void ros2_interface::msg::Odometry::covariance(
        std::vector<double>&& _covariance)
{
    m_covariance = std::move(_covariance);
}

/*!
 * @brief This function returns a constant reference to member covariance
 * @return Constant reference to member covariance
 */
const std::vector<double>& ros2_interface::msg::Odometry::covariance() const
{
    return m_covariance;
}

/*!
 * @brief This function returns a reference to member covariance
 * @return Reference to member covariance
 */
std::vector<double>& ros2_interface::msg::Odometry::covariance()
{
    return m_covariance;
}


size_t ros2_interface::msg::Odometry::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Odometry_max_key_cdr_typesize;
}

bool ros2_interface::msg::Odometry::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Odometry::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



