// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PadMessage.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PadMessage.h"
#include "PadMessageTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_PadMessage_max_cdr_typesize 260ULL;
#define ros2_interface_msg_PadMessage_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PadMessage::PadMessage()
{
    // string m_cmd
    m_cmd ="";

    // Just to register all known types
    registerPadMessageTypes();
}

ros2_interface::msg::PadMessage::~PadMessage()
{
}

ros2_interface::msg::PadMessage::PadMessage(
        const PadMessage& x)
{
    m_cmd = x.m_cmd;
}

ros2_interface::msg::PadMessage::PadMessage(
        PadMessage&& x) noexcept 
{
    m_cmd = std::move(x.m_cmd);
}

ros2_interface::msg::PadMessage& ros2_interface::msg::PadMessage::operator =(
        const PadMessage& x)
{

    m_cmd = x.m_cmd;

    return *this;
}

ros2_interface::msg::PadMessage& ros2_interface::msg::PadMessage::operator =(
        PadMessage&& x) noexcept
{

    m_cmd = std::move(x.m_cmd);

    return *this;
}

bool ros2_interface::msg::PadMessage::operator ==(
        const PadMessage& x) const
{

    return (m_cmd == x.m_cmd);
}

bool ros2_interface::msg::PadMessage::operator !=(
        const PadMessage& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PadMessage::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PadMessage_max_cdr_typesize;
}

size_t ros2_interface::msg::PadMessage::getCdrSerializedSize(
        const ros2_interface::msg::PadMessage& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.cmd().size() + 1;

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PadMessage::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_cmd.c_str();

}

void ros2_interface::msg::PadMessage::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_cmd;}

/*!
 * @brief This function copies the value in member cmd
 * @param _cmd New value to be copied in member cmd
 */
void ros2_interface::msg::PadMessage::cmd(
        const std::string& _cmd)
{
    m_cmd = _cmd;
}

/*!
 * @brief This function moves the value in member cmd
 * @param _cmd New value to be moved in member cmd
 */
void ros2_interface::msg::PadMessage::cmd(
        std::string&& _cmd)
{
    m_cmd = std::move(_cmd);
}

/*!
 * @brief This function returns a constant reference to member cmd
 * @return Constant reference to member cmd
 */
const std::string& ros2_interface::msg::PadMessage::cmd() const
{
    return m_cmd;
}

/*!
 * @brief This function returns a reference to member cmd
 * @return Reference to member cmd
 */
std::string& ros2_interface::msg::PadMessage::cmd()
{
    return m_cmd;
}


size_t ros2_interface::msg::PadMessage::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PadMessage_max_key_cdr_typesize;
}

bool ros2_interface::msg::PadMessage::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PadMessage::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



