// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PadMessage.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PADMESSAGE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PADMESSAGE_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PADMESSAGE_SOURCE)
#define PADMESSAGE_DllAPI __declspec( dllexport )
#else
#define PADMESSAGE_DllAPI __declspec( dllimport )
#endif // PADMESSAGE_SOURCE
#else
#define PADMESSAGE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PADMESSAGE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PadMessage defined by the user in the IDL file.
         * @ingroup PadMessage
         */
        class PadMessage
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PadMessage();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PadMessage();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PadMessage that will be copied.
             */
            eProsima_user_DllExport PadMessage(
                    const PadMessage& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PadMessage that will be copied.
             */
            eProsima_user_DllExport PadMessage(
                    PadMessage&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PadMessage that will be copied.
             */
            eProsima_user_DllExport PadMessage& operator =(
                    const PadMessage& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PadMessage that will be copied.
             */
            eProsima_user_DllExport PadMessage& operator =(
                    PadMessage&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PadMessage object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PadMessage& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PadMessage object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PadMessage& x) const;

            /*!
             * @brief This function copies the value in member cmd
             * @param _cmd New value to be copied in member cmd
             */
            eProsima_user_DllExport void cmd(
                    const std::string& _cmd);

            /*!
             * @brief This function moves the value in member cmd
             * @param _cmd New value to be moved in member cmd
             */
            eProsima_user_DllExport void cmd(
                    std::string&& _cmd);

            /*!
             * @brief This function returns a constant reference to member cmd
             * @return Constant reference to member cmd
             */
            eProsima_user_DllExport const std::string& cmd() const;

            /*!
             * @brief This function returns a reference to member cmd
             * @return Reference to member cmd
             */
            eProsima_user_DllExport std::string& cmd();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PadMessage& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::string m_cmd;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PADMESSAGE_H_

