// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ParkingInfo.h"
#include "ParkingInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Polygon3D_max_cdr_typesize 2408ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ParkingInfo_max_cdr_typesize 2760ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ParkingInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ParkingInfo::ParkingInfo()
{
    // ros2_interface::msg::Header m_header

    // long m_parking_space_id
    m_parking_space_id = 0;
    // long m_parking_type
    m_parking_type = 0;
    // boolean m_is_parking_enable
    m_is_parking_enable = false;
    // double m_confidence
    m_confidence = 0.0;
    // ros2_interface::msg::Point3D m_center_point_of_parking

    // double m_theta
    m_theta = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_length
    m_length = 0.0;
    // double m_yaw_offset
    m_yaw_offset = 0.0;
    // ros2_interface::msg::Polygon3D m_polygon


    // Just to register all known types
    registerParkingInfoTypes();
}

ros2_interface::msg::ParkingInfo::~ParkingInfo()
{











}

ros2_interface::msg::ParkingInfo::ParkingInfo(
        const ParkingInfo& x)
{
    m_header = x.m_header;
    m_parking_space_id = x.m_parking_space_id;
    m_parking_type = x.m_parking_type;
    m_is_parking_enable = x.m_is_parking_enable;
    m_confidence = x.m_confidence;
    m_center_point_of_parking = x.m_center_point_of_parking;
    m_theta = x.m_theta;
    m_width = x.m_width;
    m_length = x.m_length;
    m_yaw_offset = x.m_yaw_offset;
    m_polygon = x.m_polygon;
}

ros2_interface::msg::ParkingInfo::ParkingInfo(
        ParkingInfo&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_parking_space_id = x.m_parking_space_id;
    m_parking_type = x.m_parking_type;
    m_is_parking_enable = x.m_is_parking_enable;
    m_confidence = x.m_confidence;
    m_center_point_of_parking = std::move(x.m_center_point_of_parking);
    m_theta = x.m_theta;
    m_width = x.m_width;
    m_length = x.m_length;
    m_yaw_offset = x.m_yaw_offset;
    m_polygon = std::move(x.m_polygon);
}

ros2_interface::msg::ParkingInfo& ros2_interface::msg::ParkingInfo::operator =(
        const ParkingInfo& x)
{

    m_header = x.m_header;
    m_parking_space_id = x.m_parking_space_id;
    m_parking_type = x.m_parking_type;
    m_is_parking_enable = x.m_is_parking_enable;
    m_confidence = x.m_confidence;
    m_center_point_of_parking = x.m_center_point_of_parking;
    m_theta = x.m_theta;
    m_width = x.m_width;
    m_length = x.m_length;
    m_yaw_offset = x.m_yaw_offset;
    m_polygon = x.m_polygon;

    return *this;
}

ros2_interface::msg::ParkingInfo& ros2_interface::msg::ParkingInfo::operator =(
        ParkingInfo&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_parking_space_id = x.m_parking_space_id;
    m_parking_type = x.m_parking_type;
    m_is_parking_enable = x.m_is_parking_enable;
    m_confidence = x.m_confidence;
    m_center_point_of_parking = std::move(x.m_center_point_of_parking);
    m_theta = x.m_theta;
    m_width = x.m_width;
    m_length = x.m_length;
    m_yaw_offset = x.m_yaw_offset;
    m_polygon = std::move(x.m_polygon);

    return *this;
}

bool ros2_interface::msg::ParkingInfo::operator ==(
        const ParkingInfo& x) const
{

    return (m_header == x.m_header && m_parking_space_id == x.m_parking_space_id && m_parking_type == x.m_parking_type && m_is_parking_enable == x.m_is_parking_enable && m_confidence == x.m_confidence && m_center_point_of_parking == x.m_center_point_of_parking && m_theta == x.m_theta && m_width == x.m_width && m_length == x.m_length && m_yaw_offset == x.m_yaw_offset && m_polygon == x.m_polygon);
}

bool ros2_interface::msg::ParkingInfo::operator !=(
        const ParkingInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ParkingInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::ParkingInfo::getCdrSerializedSize(
        const ros2_interface::msg::ParkingInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.center_point_of_parking(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Polygon3D::getCdrSerializedSize(data.polygon(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ParkingInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_parking_space_id;
    scdr << m_parking_type;
    scdr << m_is_parking_enable;
    scdr << m_confidence;
    scdr << m_center_point_of_parking;
    scdr << m_theta;
    scdr << m_width;
    scdr << m_length;
    scdr << m_yaw_offset;
    scdr << m_polygon;

}

void ros2_interface::msg::ParkingInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_parking_space_id;
    dcdr >> m_parking_type;
    dcdr >> m_is_parking_enable;
    dcdr >> m_confidence;
    dcdr >> m_center_point_of_parking;
    dcdr >> m_theta;
    dcdr >> m_width;
    dcdr >> m_length;
    dcdr >> m_yaw_offset;
    dcdr >> m_polygon;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ParkingInfo::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ParkingInfo::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ParkingInfo::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ParkingInfo::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member parking_space_id
 * @param _parking_space_id New value for member parking_space_id
 */
void ros2_interface::msg::ParkingInfo::parking_space_id(
        int32_t _parking_space_id)
{
    m_parking_space_id = _parking_space_id;
}

/*!
 * @brief This function returns the value of member parking_space_id
 * @return Value of member parking_space_id
 */
int32_t ros2_interface::msg::ParkingInfo::parking_space_id() const
{
    return m_parking_space_id;
}

/*!
 * @brief This function returns a reference to member parking_space_id
 * @return Reference to member parking_space_id
 */
int32_t& ros2_interface::msg::ParkingInfo::parking_space_id()
{
    return m_parking_space_id;
}

/*!
 * @brief This function sets a value in member parking_type
 * @param _parking_type New value for member parking_type
 */
void ros2_interface::msg::ParkingInfo::parking_type(
        int32_t _parking_type)
{
    m_parking_type = _parking_type;
}

/*!
 * @brief This function returns the value of member parking_type
 * @return Value of member parking_type
 */
int32_t ros2_interface::msg::ParkingInfo::parking_type() const
{
    return m_parking_type;
}

/*!
 * @brief This function returns a reference to member parking_type
 * @return Reference to member parking_type
 */
int32_t& ros2_interface::msg::ParkingInfo::parking_type()
{
    return m_parking_type;
}

/*!
 * @brief This function sets a value in member is_parking_enable
 * @param _is_parking_enable New value for member is_parking_enable
 */
void ros2_interface::msg::ParkingInfo::is_parking_enable(
        bool _is_parking_enable)
{
    m_is_parking_enable = _is_parking_enable;
}

/*!
 * @brief This function returns the value of member is_parking_enable
 * @return Value of member is_parking_enable
 */
bool ros2_interface::msg::ParkingInfo::is_parking_enable() const
{
    return m_is_parking_enable;
}

/*!
 * @brief This function returns a reference to member is_parking_enable
 * @return Reference to member is_parking_enable
 */
bool& ros2_interface::msg::ParkingInfo::is_parking_enable()
{
    return m_is_parking_enable;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::ParkingInfo::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::ParkingInfo::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::ParkingInfo::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function copies the value in member center_point_of_parking
 * @param _center_point_of_parking New value to be copied in member center_point_of_parking
 */
void ros2_interface::msg::ParkingInfo::center_point_of_parking(
        const ros2_interface::msg::Point3D& _center_point_of_parking)
{
    m_center_point_of_parking = _center_point_of_parking;
}

/*!
 * @brief This function moves the value in member center_point_of_parking
 * @param _center_point_of_parking New value to be moved in member center_point_of_parking
 */
void ros2_interface::msg::ParkingInfo::center_point_of_parking(
        ros2_interface::msg::Point3D&& _center_point_of_parking)
{
    m_center_point_of_parking = std::move(_center_point_of_parking);
}

/*!
 * @brief This function returns a constant reference to member center_point_of_parking
 * @return Constant reference to member center_point_of_parking
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ParkingInfo::center_point_of_parking() const
{
    return m_center_point_of_parking;
}

/*!
 * @brief This function returns a reference to member center_point_of_parking
 * @return Reference to member center_point_of_parking
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ParkingInfo::center_point_of_parking()
{
    return m_center_point_of_parking;
}
/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::ParkingInfo::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::ParkingInfo::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::ParkingInfo::theta()
{
    return m_theta;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::ParkingInfo::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::ParkingInfo::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::ParkingInfo::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::ParkingInfo::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::ParkingInfo::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::ParkingInfo::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member yaw_offset
 * @param _yaw_offset New value for member yaw_offset
 */
void ros2_interface::msg::ParkingInfo::yaw_offset(
        double _yaw_offset)
{
    m_yaw_offset = _yaw_offset;
}

/*!
 * @brief This function returns the value of member yaw_offset
 * @return Value of member yaw_offset
 */
double ros2_interface::msg::ParkingInfo::yaw_offset() const
{
    return m_yaw_offset;
}

/*!
 * @brief This function returns a reference to member yaw_offset
 * @return Reference to member yaw_offset
 */
double& ros2_interface::msg::ParkingInfo::yaw_offset()
{
    return m_yaw_offset;
}

/*!
 * @brief This function copies the value in member polygon
 * @param _polygon New value to be copied in member polygon
 */
void ros2_interface::msg::ParkingInfo::polygon(
        const ros2_interface::msg::Polygon3D& _polygon)
{
    m_polygon = _polygon;
}

/*!
 * @brief This function moves the value in member polygon
 * @param _polygon New value to be moved in member polygon
 */
void ros2_interface::msg::ParkingInfo::polygon(
        ros2_interface::msg::Polygon3D&& _polygon)
{
    m_polygon = std::move(_polygon);
}

/*!
 * @brief This function returns a constant reference to member polygon
 * @return Constant reference to member polygon
 */
const ros2_interface::msg::Polygon3D& ros2_interface::msg::ParkingInfo::polygon() const
{
    return m_polygon;
}

/*!
 * @brief This function returns a reference to member polygon
 * @return Reference to member polygon
 */
ros2_interface::msg::Polygon3D& ros2_interface::msg::ParkingInfo::polygon()
{
    return m_polygon;
}


size_t ros2_interface::msg::ParkingInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::ParkingInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ParkingInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



