// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingInfoList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ParkingInfoList.h"
#include "ParkingInfoListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Polygon3D_max_cdr_typesize 2408ULL;
#define ros2_interface_msg_ParkingInfoList_max_cdr_typesize 276277ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ParkingInfo_max_cdr_typesize 2760ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ParkingInfoList_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ParkingInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ParkingInfoList::ParkingInfoList()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::ParkingInfo> m_parking_info

    // long m_error_code
    m_error_code = 0;
    // boolean m_is_valid
    m_is_valid = false;

    // Just to register all known types
    registerParkingInfoListTypes();
}

ros2_interface::msg::ParkingInfoList::~ParkingInfoList()
{




}

ros2_interface::msg::ParkingInfoList::ParkingInfoList(
        const ParkingInfoList& x)
{
    m_header = x.m_header;
    m_parking_info = x.m_parking_info;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::ParkingInfoList::ParkingInfoList(
        ParkingInfoList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_parking_info = std::move(x.m_parking_info);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::ParkingInfoList& ros2_interface::msg::ParkingInfoList::operator =(
        const ParkingInfoList& x)
{

    m_header = x.m_header;
    m_parking_info = x.m_parking_info;
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;

    return *this;
}

ros2_interface::msg::ParkingInfoList& ros2_interface::msg::ParkingInfoList::operator =(
        ParkingInfoList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_parking_info = std::move(x.m_parking_info);
    m_error_code = x.m_error_code;
    m_is_valid = x.m_is_valid;

    return *this;
}

bool ros2_interface::msg::ParkingInfoList::operator ==(
        const ParkingInfoList& x) const
{

    return (m_header == x.m_header && m_parking_info == x.m_parking_info && m_error_code == x.m_error_code && m_is_valid == x.m_is_valid);
}

bool ros2_interface::msg::ParkingInfoList::operator !=(
        const ParkingInfoList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ParkingInfoList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingInfoList_max_cdr_typesize;
}

size_t ros2_interface::msg::ParkingInfoList::getCdrSerializedSize(
        const ros2_interface::msg::ParkingInfoList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.parking_info().size(); ++a)
    {
        current_alignment += ros2_interface::msg::ParkingInfo::getCdrSerializedSize(data.parking_info().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ParkingInfoList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_parking_info;
    scdr << m_error_code;
    scdr << m_is_valid;

}

void ros2_interface::msg::ParkingInfoList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_parking_info;
    dcdr >> m_error_code;
    dcdr >> m_is_valid;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ParkingInfoList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ParkingInfoList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ParkingInfoList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ParkingInfoList::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member parking_info
 * @param _parking_info New value to be copied in member parking_info
 */
void ros2_interface::msg::ParkingInfoList::parking_info(
        const std::vector<ros2_interface::msg::ParkingInfo>& _parking_info)
{
    m_parking_info = _parking_info;
}

/*!
 * @brief This function moves the value in member parking_info
 * @param _parking_info New value to be moved in member parking_info
 */
void ros2_interface::msg::ParkingInfoList::parking_info(
        std::vector<ros2_interface::msg::ParkingInfo>&& _parking_info)
{
    m_parking_info = std::move(_parking_info);
}

/*!
 * @brief This function returns a constant reference to member parking_info
 * @return Constant reference to member parking_info
 */
const std::vector<ros2_interface::msg::ParkingInfo>& ros2_interface::msg::ParkingInfoList::parking_info() const
{
    return m_parking_info;
}

/*!
 * @brief This function returns a reference to member parking_info
 * @return Reference to member parking_info
 */
std::vector<ros2_interface::msg::ParkingInfo>& ros2_interface::msg::ParkingInfoList::parking_info()
{
    return m_parking_info;
}
/*!
 * @brief This function sets a value in member error_code
 * @param _error_code New value for member error_code
 */
void ros2_interface::msg::ParkingInfoList::error_code(
        int32_t _error_code)
{
    m_error_code = _error_code;
}

/*!
 * @brief This function returns the value of member error_code
 * @return Value of member error_code
 */
int32_t ros2_interface::msg::ParkingInfoList::error_code() const
{
    return m_error_code;
}

/*!
 * @brief This function returns a reference to member error_code
 * @return Reference to member error_code
 */
int32_t& ros2_interface::msg::ParkingInfoList::error_code()
{
    return m_error_code;
}

/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::ParkingInfoList::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::ParkingInfoList::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::ParkingInfoList::is_valid()
{
    return m_is_valid;
}



size_t ros2_interface::msg::ParkingInfoList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingInfoList_max_key_cdr_typesize;
}

bool ros2_interface::msg::ParkingInfoList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ParkingInfoList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



