// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingInfoList.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGINFOLIST_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGINFOLIST_H_

#include "ParkingInfo.h"
#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PARKINGINFOLIST_SOURCE)
#define PARKINGINFOLIST_DllAPI __declspec( dllexport )
#else
#define PARKINGINFOLIST_DllAPI __declspec( dllimport )
#endif // PARKINGINFOLIST_SOURCE
#else
#define PARKINGINFOLIST_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PARKINGINFOLIST_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ParkingInfoList defined by the user in the IDL file.
         * @ingroup ParkingInfoList
         */
        class ParkingInfoList
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ParkingInfoList();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ParkingInfoList();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingInfoList that will be copied.
             */
            eProsima_user_DllExport ParkingInfoList(
                    const ParkingInfoList& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingInfoList that will be copied.
             */
            eProsima_user_DllExport ParkingInfoList(
                    ParkingInfoList&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingInfoList that will be copied.
             */
            eProsima_user_DllExport ParkingInfoList& operator =(
                    const ParkingInfoList& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingInfoList that will be copied.
             */
            eProsima_user_DllExport ParkingInfoList& operator =(
                    ParkingInfoList&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingInfoList object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ParkingInfoList& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingInfoList object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ParkingInfoList& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member parking_info
             * @param _parking_info New value to be copied in member parking_info
             */
            eProsima_user_DllExport void parking_info(
                    const std::vector<ros2_interface::msg::ParkingInfo>& _parking_info);

            /*!
             * @brief This function moves the value in member parking_info
             * @param _parking_info New value to be moved in member parking_info
             */
            eProsima_user_DllExport void parking_info(
                    std::vector<ros2_interface::msg::ParkingInfo>&& _parking_info);

            /*!
             * @brief This function returns a constant reference to member parking_info
             * @return Constant reference to member parking_info
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::ParkingInfo>& parking_info() const;

            /*!
             * @brief This function returns a reference to member parking_info
             * @return Reference to member parking_info
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::ParkingInfo>& parking_info();
            /*!
             * @brief This function sets a value in member error_code
             * @param _error_code New value for member error_code
             */
            eProsima_user_DllExport void error_code(
                    int32_t _error_code);

            /*!
             * @brief This function returns the value of member error_code
             * @return Value of member error_code
             */
            eProsima_user_DllExport int32_t error_code() const;

            /*!
             * @brief This function returns a reference to member error_code
             * @return Reference to member error_code
             */
            eProsima_user_DllExport int32_t& error_code();

            /*!
             * @brief This function sets a value in member is_valid
             * @param _is_valid New value for member is_valid
             */
            eProsima_user_DllExport void is_valid(
                    bool _is_valid);

            /*!
             * @brief This function returns the value of member is_valid
             * @return Value of member is_valid
             */
            eProsima_user_DllExport bool is_valid() const;

            /*!
             * @brief This function returns a reference to member is_valid
             * @return Reference to member is_valid
             */
            eProsima_user_DllExport bool& is_valid();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ParkingInfoList& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::vector<ros2_interface::msg::ParkingInfo> m_parking_info;
            int32_t m_error_code;
            bool m_is_valid;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGINFOLIST_H_

