// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingOutInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ParkingOutInfo.h"
#include "ParkingOutInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_ParkingOutInfo_max_cdr_typesize 320ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ParkingOutInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ParkingOutInfo::ParkingOutInfo()
{
    // ros2_interface::msg::Header m_header

    // long m_parking_out_id
    m_parking_out_id = 0;
    // long m_parking_direction_type
    m_parking_direction_type = 0;
    // boolean m_is_parking_out_enable
    m_is_parking_out_enable = false;
    // ros2_interface::msg::Point3D m_parking_out_point

    // double m_theta
    m_theta = 0.0;

    // Just to register all known types
    registerParkingOutInfoTypes();
}

ros2_interface::msg::ParkingOutInfo::~ParkingOutInfo()
{






}

ros2_interface::msg::ParkingOutInfo::ParkingOutInfo(
        const ParkingOutInfo& x)
{
    m_header = x.m_header;
    m_parking_out_id = x.m_parking_out_id;
    m_parking_direction_type = x.m_parking_direction_type;
    m_is_parking_out_enable = x.m_is_parking_out_enable;
    m_parking_out_point = x.m_parking_out_point;
    m_theta = x.m_theta;
}

ros2_interface::msg::ParkingOutInfo::ParkingOutInfo(
        ParkingOutInfo&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_parking_out_id = x.m_parking_out_id;
    m_parking_direction_type = x.m_parking_direction_type;
    m_is_parking_out_enable = x.m_is_parking_out_enable;
    m_parking_out_point = std::move(x.m_parking_out_point);
    m_theta = x.m_theta;
}

ros2_interface::msg::ParkingOutInfo& ros2_interface::msg::ParkingOutInfo::operator =(
        const ParkingOutInfo& x)
{

    m_header = x.m_header;
    m_parking_out_id = x.m_parking_out_id;
    m_parking_direction_type = x.m_parking_direction_type;
    m_is_parking_out_enable = x.m_is_parking_out_enable;
    m_parking_out_point = x.m_parking_out_point;
    m_theta = x.m_theta;

    return *this;
}

ros2_interface::msg::ParkingOutInfo& ros2_interface::msg::ParkingOutInfo::operator =(
        ParkingOutInfo&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_parking_out_id = x.m_parking_out_id;
    m_parking_direction_type = x.m_parking_direction_type;
    m_is_parking_out_enable = x.m_is_parking_out_enable;
    m_parking_out_point = std::move(x.m_parking_out_point);
    m_theta = x.m_theta;

    return *this;
}

bool ros2_interface::msg::ParkingOutInfo::operator ==(
        const ParkingOutInfo& x) const
{

    return (m_header == x.m_header && m_parking_out_id == x.m_parking_out_id && m_parking_direction_type == x.m_parking_direction_type && m_is_parking_out_enable == x.m_is_parking_out_enable && m_parking_out_point == x.m_parking_out_point && m_theta == x.m_theta);
}

bool ros2_interface::msg::ParkingOutInfo::operator !=(
        const ParkingOutInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ParkingOutInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingOutInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::ParkingOutInfo::getCdrSerializedSize(
        const ros2_interface::msg::ParkingOutInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.parking_out_point(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ParkingOutInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_parking_out_id;
    scdr << m_parking_direction_type;
    scdr << m_is_parking_out_enable;
    scdr << m_parking_out_point;
    scdr << m_theta;

}

void ros2_interface::msg::ParkingOutInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_parking_out_id;
    dcdr >> m_parking_direction_type;
    dcdr >> m_is_parking_out_enable;
    dcdr >> m_parking_out_point;
    dcdr >> m_theta;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ParkingOutInfo::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ParkingOutInfo::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ParkingOutInfo::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ParkingOutInfo::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member parking_out_id
 * @param _parking_out_id New value for member parking_out_id
 */
void ros2_interface::msg::ParkingOutInfo::parking_out_id(
        int32_t _parking_out_id)
{
    m_parking_out_id = _parking_out_id;
}

/*!
 * @brief This function returns the value of member parking_out_id
 * @return Value of member parking_out_id
 */
int32_t ros2_interface::msg::ParkingOutInfo::parking_out_id() const
{
    return m_parking_out_id;
}

/*!
 * @brief This function returns a reference to member parking_out_id
 * @return Reference to member parking_out_id
 */
int32_t& ros2_interface::msg::ParkingOutInfo::parking_out_id()
{
    return m_parking_out_id;
}

/*!
 * @brief This function sets a value in member parking_direction_type
 * @param _parking_direction_type New value for member parking_direction_type
 */
void ros2_interface::msg::ParkingOutInfo::parking_direction_type(
        int32_t _parking_direction_type)
{
    m_parking_direction_type = _parking_direction_type;
}

/*!
 * @brief This function returns the value of member parking_direction_type
 * @return Value of member parking_direction_type
 */
int32_t ros2_interface::msg::ParkingOutInfo::parking_direction_type() const
{
    return m_parking_direction_type;
}

/*!
 * @brief This function returns a reference to member parking_direction_type
 * @return Reference to member parking_direction_type
 */
int32_t& ros2_interface::msg::ParkingOutInfo::parking_direction_type()
{
    return m_parking_direction_type;
}

/*!
 * @brief This function sets a value in member is_parking_out_enable
 * @param _is_parking_out_enable New value for member is_parking_out_enable
 */
void ros2_interface::msg::ParkingOutInfo::is_parking_out_enable(
        bool _is_parking_out_enable)
{
    m_is_parking_out_enable = _is_parking_out_enable;
}

/*!
 * @brief This function returns the value of member is_parking_out_enable
 * @return Value of member is_parking_out_enable
 */
bool ros2_interface::msg::ParkingOutInfo::is_parking_out_enable() const
{
    return m_is_parking_out_enable;
}

/*!
 * @brief This function returns a reference to member is_parking_out_enable
 * @return Reference to member is_parking_out_enable
 */
bool& ros2_interface::msg::ParkingOutInfo::is_parking_out_enable()
{
    return m_is_parking_out_enable;
}

/*!
 * @brief This function copies the value in member parking_out_point
 * @param _parking_out_point New value to be copied in member parking_out_point
 */
void ros2_interface::msg::ParkingOutInfo::parking_out_point(
        const ros2_interface::msg::Point3D& _parking_out_point)
{
    m_parking_out_point = _parking_out_point;
}

/*!
 * @brief This function moves the value in member parking_out_point
 * @param _parking_out_point New value to be moved in member parking_out_point
 */
void ros2_interface::msg::ParkingOutInfo::parking_out_point(
        ros2_interface::msg::Point3D&& _parking_out_point)
{
    m_parking_out_point = std::move(_parking_out_point);
}

/*!
 * @brief This function returns a constant reference to member parking_out_point
 * @return Constant reference to member parking_out_point
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::ParkingOutInfo::parking_out_point() const
{
    return m_parking_out_point;
}

/*!
 * @brief This function returns a reference to member parking_out_point
 * @return Reference to member parking_out_point
 */
ros2_interface::msg::Point3D& ros2_interface::msg::ParkingOutInfo::parking_out_point()
{
    return m_parking_out_point;
}
/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::ParkingOutInfo::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::ParkingOutInfo::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::ParkingOutInfo::theta()
{
    return m_theta;
}



size_t ros2_interface::msg::ParkingOutInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingOutInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::ParkingOutInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ParkingOutInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



