// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingOutInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGOUTINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGOUTINFO_H_

#include "Header.h"
#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PARKINGOUTINFO_SOURCE)
#define PARKINGOUTINFO_DllAPI __declspec( dllexport )
#else
#define PARKINGOUTINFO_DllAPI __declspec( dllimport )
#endif // PARKINGOUTINFO_SOURCE
#else
#define PARKINGOUTINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PARKINGOUTINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ParkingOutInfo defined by the user in the IDL file.
         * @ingroup ParkingOutInfo
         */
        class ParkingOutInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ParkingOutInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ParkingOutInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingOutInfo that will be copied.
             */
            eProsima_user_DllExport ParkingOutInfo(
                    const ParkingOutInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingOutInfo that will be copied.
             */
            eProsima_user_DllExport ParkingOutInfo(
                    ParkingOutInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingOutInfo that will be copied.
             */
            eProsima_user_DllExport ParkingOutInfo& operator =(
                    const ParkingOutInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingOutInfo that will be copied.
             */
            eProsima_user_DllExport ParkingOutInfo& operator =(
                    ParkingOutInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingOutInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ParkingOutInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingOutInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ParkingOutInfo& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member parking_out_id
             * @param _parking_out_id New value for member parking_out_id
             */
            eProsima_user_DllExport void parking_out_id(
                    int32_t _parking_out_id);

            /*!
             * @brief This function returns the value of member parking_out_id
             * @return Value of member parking_out_id
             */
            eProsima_user_DllExport int32_t parking_out_id() const;

            /*!
             * @brief This function returns a reference to member parking_out_id
             * @return Reference to member parking_out_id
             */
            eProsima_user_DllExport int32_t& parking_out_id();

            /*!
             * @brief This function sets a value in member parking_direction_type
             * @param _parking_direction_type New value for member parking_direction_type
             */
            eProsima_user_DllExport void parking_direction_type(
                    int32_t _parking_direction_type);

            /*!
             * @brief This function returns the value of member parking_direction_type
             * @return Value of member parking_direction_type
             */
            eProsima_user_DllExport int32_t parking_direction_type() const;

            /*!
             * @brief This function returns a reference to member parking_direction_type
             * @return Reference to member parking_direction_type
             */
            eProsima_user_DllExport int32_t& parking_direction_type();

            /*!
             * @brief This function sets a value in member is_parking_out_enable
             * @param _is_parking_out_enable New value for member is_parking_out_enable
             */
            eProsima_user_DllExport void is_parking_out_enable(
                    bool _is_parking_out_enable);

            /*!
             * @brief This function returns the value of member is_parking_out_enable
             * @return Value of member is_parking_out_enable
             */
            eProsima_user_DllExport bool is_parking_out_enable() const;

            /*!
             * @brief This function returns a reference to member is_parking_out_enable
             * @return Reference to member is_parking_out_enable
             */
            eProsima_user_DllExport bool& is_parking_out_enable();

            /*!
             * @brief This function copies the value in member parking_out_point
             * @param _parking_out_point New value to be copied in member parking_out_point
             */
            eProsima_user_DllExport void parking_out_point(
                    const ros2_interface::msg::Point3D& _parking_out_point);

            /*!
             * @brief This function moves the value in member parking_out_point
             * @param _parking_out_point New value to be moved in member parking_out_point
             */
            eProsima_user_DllExport void parking_out_point(
                    ros2_interface::msg::Point3D&& _parking_out_point);

            /*!
             * @brief This function returns a constant reference to member parking_out_point
             * @return Constant reference to member parking_out_point
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& parking_out_point() const;

            /*!
             * @brief This function returns a reference to member parking_out_point
             * @return Reference to member parking_out_point
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& parking_out_point();
            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ParkingOutInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_parking_out_id;
            int32_t m_parking_direction_type;
            bool m_is_parking_out_enable;
            ros2_interface::msg::Point3D m_parking_out_point;
            double m_theta;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGOUTINFO_H_

