// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingOutInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "ParkingOutInfo.h"
#include "ParkingOutInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerParkingOutInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::ParkingOutInfo", ros2_interface::msg::GetParkingOutInfoIdentifier(true),
                        ros2_interface::msg::GetParkingOutInfoObject(true));
                factory->add_type_object("ros2_interface::msg::ParkingOutInfo", ros2_interface::msg::GetParkingOutInfoIdentifier(false),
                        ros2_interface::msg::GetParkingOutInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetParkingOutInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("ParkingOutInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetParkingOutInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("ParkingOutInfo", complete);
        }

        const TypeObject* GetParkingOutInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingOutInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteParkingOutInfoObject();
            }
            //else
            return GetMinimalParkingOutInfoObject();
        }

        const TypeObject* GetMinimalParkingOutInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingOutInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_parking_out_id;
            mst_parking_out_id.common().member_id(memberId++);
            mst_parking_out_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_out_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_out_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_out_id.common().member_flags().IS_OPTIONAL(false);
            mst_parking_out_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_out_id.common().member_flags().IS_KEY(false);
            mst_parking_out_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_out_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_out_id_hash("parking_out_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_out_id.detail().name_hash()[i] = parking_out_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_out_id);

            MinimalStructMember mst_parking_direction_type;
            mst_parking_direction_type.common().member_id(memberId++);
            mst_parking_direction_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_direction_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_direction_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_direction_type.common().member_flags().IS_OPTIONAL(false);
            mst_parking_direction_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_direction_type.common().member_flags().IS_KEY(false);
            mst_parking_direction_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_direction_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_direction_type_hash("parking_direction_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_direction_type.detail().name_hash()[i] = parking_direction_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_direction_type);

            MinimalStructMember mst_is_parking_out_enable;
            mst_is_parking_out_enable.common().member_id(memberId++);
            mst_is_parking_out_enable.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_parking_out_enable.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_parking_out_enable.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_parking_out_enable.common().member_flags().IS_OPTIONAL(false);
            mst_is_parking_out_enable.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_parking_out_enable.common().member_flags().IS_KEY(false);
            mst_is_parking_out_enable.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_parking_out_enable.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_parking_out_enable_hash("is_parking_out_enable");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_parking_out_enable.detail().name_hash()[i] = is_parking_out_enable_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_parking_out_enable);

            MinimalStructMember mst_parking_out_point;
            mst_parking_out_point.common().member_id(memberId++);
            mst_parking_out_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_out_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_out_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_out_point.common().member_flags().IS_OPTIONAL(false);
            mst_parking_out_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_out_point.common().member_flags().IS_KEY(false);
            mst_parking_out_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_out_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 parking_out_point_hash("parking_out_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_out_point.detail().name_hash()[i] = parking_out_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_out_point);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ParkingOutInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ParkingOutInfo", false);
        }

        const TypeObject* GetCompleteParkingOutInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingOutInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_parking_out_id;
            cst_parking_out_id.common().member_id(memberId++);
            cst_parking_out_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_out_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_out_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_out_id.common().member_flags().IS_OPTIONAL(false);
            cst_parking_out_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_out_id.common().member_flags().IS_KEY(false);
            cst_parking_out_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_out_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_out_id.detail().name("parking_out_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_out_id);

            CompleteStructMember cst_parking_direction_type;
            cst_parking_direction_type.common().member_id(memberId++);
            cst_parking_direction_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_direction_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_direction_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_direction_type.common().member_flags().IS_OPTIONAL(false);
            cst_parking_direction_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_direction_type.common().member_flags().IS_KEY(false);
            cst_parking_direction_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_direction_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_direction_type.detail().name("parking_direction_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_direction_type);

            CompleteStructMember cst_is_parking_out_enable;
            cst_is_parking_out_enable.common().member_id(memberId++);
            cst_is_parking_out_enable.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_parking_out_enable.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_parking_out_enable.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_parking_out_enable.common().member_flags().IS_OPTIONAL(false);
            cst_is_parking_out_enable.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_parking_out_enable.common().member_flags().IS_KEY(false);
            cst_is_parking_out_enable.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_parking_out_enable.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_parking_out_enable.detail().name("is_parking_out_enable");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_parking_out_enable);

            CompleteStructMember cst_parking_out_point;
            cst_parking_out_point.common().member_id(memberId++);
            cst_parking_out_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_out_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_out_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_out_point.common().member_flags().IS_OPTIONAL(false);
            cst_parking_out_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_out_point.common().member_flags().IS_KEY(false);
            cst_parking_out_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_out_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_parking_out_point.detail().name("parking_out_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_out_point);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);


            // Header
            type_object->complete().struct_type().header().detail().type_name("ParkingOutInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ParkingOutInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ParkingOutInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface