// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingStateDisplay.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "ParkingStateDisplay.h"
#include "ParkingStateDisplayTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ParkingStateDisplay_max_cdr_typesize 300ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ParkingStateDisplay_max_key_cdr_typesize 0ULL;

ros2_interface::msg::ParkingStateDisplay::ParkingStateDisplay()
{
    // ros2_interface::msg::Header m_header

    // long m_parking_type
    m_parking_type = 0;
    // long m_moves_counter
    m_moves_counter = 0;
    // double m_remian_distance
    m_remian_distance = 0.0;
    // double m_distance_to_leader_obj
    m_distance_to_leader_obj = 0.0;
    // long m_state
    m_state = 0;

    // Just to register all known types
    registerParkingStateDisplayTypes();
}

ros2_interface::msg::ParkingStateDisplay::~ParkingStateDisplay()
{






}

ros2_interface::msg::ParkingStateDisplay::ParkingStateDisplay(
        const ParkingStateDisplay& x)
{
    m_header = x.m_header;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remian_distance = x.m_remian_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;
}

ros2_interface::msg::ParkingStateDisplay::ParkingStateDisplay(
        ParkingStateDisplay&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remian_distance = x.m_remian_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;
}

ros2_interface::msg::ParkingStateDisplay& ros2_interface::msg::ParkingStateDisplay::operator =(
        const ParkingStateDisplay& x)
{

    m_header = x.m_header;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remian_distance = x.m_remian_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;

    return *this;
}

ros2_interface::msg::ParkingStateDisplay& ros2_interface::msg::ParkingStateDisplay::operator =(
        ParkingStateDisplay&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remian_distance = x.m_remian_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;

    return *this;
}

bool ros2_interface::msg::ParkingStateDisplay::operator ==(
        const ParkingStateDisplay& x) const
{

    return (m_header == x.m_header && m_parking_type == x.m_parking_type && m_moves_counter == x.m_moves_counter && m_remian_distance == x.m_remian_distance && m_distance_to_leader_obj == x.m_distance_to_leader_obj && m_state == x.m_state);
}

bool ros2_interface::msg::ParkingStateDisplay::operator !=(
        const ParkingStateDisplay& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::ParkingStateDisplay::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingStateDisplay_max_cdr_typesize;
}

size_t ros2_interface::msg::ParkingStateDisplay::getCdrSerializedSize(
        const ros2_interface::msg::ParkingStateDisplay& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::ParkingStateDisplay::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_parking_type;
    scdr << m_moves_counter;
    scdr << m_remian_distance;
    scdr << m_distance_to_leader_obj;
    scdr << m_state;

}

void ros2_interface::msg::ParkingStateDisplay::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_parking_type;
    dcdr >> m_moves_counter;
    dcdr >> m_remian_distance;
    dcdr >> m_distance_to_leader_obj;
    dcdr >> m_state;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::ParkingStateDisplay::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::ParkingStateDisplay::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::ParkingStateDisplay::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::ParkingStateDisplay::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member parking_type
 * @param _parking_type New value for member parking_type
 */
void ros2_interface::msg::ParkingStateDisplay::parking_type(
        int32_t _parking_type)
{
    m_parking_type = _parking_type;
}

/*!
 * @brief This function returns the value of member parking_type
 * @return Value of member parking_type
 */
int32_t ros2_interface::msg::ParkingStateDisplay::parking_type() const
{
    return m_parking_type;
}

/*!
 * @brief This function returns a reference to member parking_type
 * @return Reference to member parking_type
 */
int32_t& ros2_interface::msg::ParkingStateDisplay::parking_type()
{
    return m_parking_type;
}

/*!
 * @brief This function sets a value in member moves_counter
 * @param _moves_counter New value for member moves_counter
 */
void ros2_interface::msg::ParkingStateDisplay::moves_counter(
        int32_t _moves_counter)
{
    m_moves_counter = _moves_counter;
}

/*!
 * @brief This function returns the value of member moves_counter
 * @return Value of member moves_counter
 */
int32_t ros2_interface::msg::ParkingStateDisplay::moves_counter() const
{
    return m_moves_counter;
}

/*!
 * @brief This function returns a reference to member moves_counter
 * @return Reference to member moves_counter
 */
int32_t& ros2_interface::msg::ParkingStateDisplay::moves_counter()
{
    return m_moves_counter;
}

/*!
 * @brief This function sets a value in member remian_distance
 * @param _remian_distance New value for member remian_distance
 */
void ros2_interface::msg::ParkingStateDisplay::remian_distance(
        double _remian_distance)
{
    m_remian_distance = _remian_distance;
}

/*!
 * @brief This function returns the value of member remian_distance
 * @return Value of member remian_distance
 */
double ros2_interface::msg::ParkingStateDisplay::remian_distance() const
{
    return m_remian_distance;
}

/*!
 * @brief This function returns a reference to member remian_distance
 * @return Reference to member remian_distance
 */
double& ros2_interface::msg::ParkingStateDisplay::remian_distance()
{
    return m_remian_distance;
}

/*!
 * @brief This function sets a value in member distance_to_leader_obj
 * @param _distance_to_leader_obj New value for member distance_to_leader_obj
 */
void ros2_interface::msg::ParkingStateDisplay::distance_to_leader_obj(
        double _distance_to_leader_obj)
{
    m_distance_to_leader_obj = _distance_to_leader_obj;
}

/*!
 * @brief This function returns the value of member distance_to_leader_obj
 * @return Value of member distance_to_leader_obj
 */
double ros2_interface::msg::ParkingStateDisplay::distance_to_leader_obj() const
{
    return m_distance_to_leader_obj;
}

/*!
 * @brief This function returns a reference to member distance_to_leader_obj
 * @return Reference to member distance_to_leader_obj
 */
double& ros2_interface::msg::ParkingStateDisplay::distance_to_leader_obj()
{
    return m_distance_to_leader_obj;
}

/*!
 * @brief This function sets a value in member state
 * @param _state New value for member state
 */
void ros2_interface::msg::ParkingStateDisplay::state(
        int32_t _state)
{
    m_state = _state;
}

/*!
 * @brief This function returns the value of member state
 * @return Value of member state
 */
int32_t ros2_interface::msg::ParkingStateDisplay::state() const
{
    return m_state;
}

/*!
 * @brief This function returns a reference to member state
 * @return Reference to member state
 */
int32_t& ros2_interface::msg::ParkingStateDisplay::state()
{
    return m_state;
}



size_t ros2_interface::msg::ParkingStateDisplay::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_ParkingStateDisplay_max_key_cdr_typesize;
}

bool ros2_interface::msg::ParkingStateDisplay::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::ParkingStateDisplay::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



