// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingStateDisplay.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGSTATEDISPLAY_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGSTATEDISPLAY_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PARKINGSTATEDISPLAY_SOURCE)
#define PARKINGSTATEDISPLAY_DllAPI __declspec( dllexport )
#else
#define PARKINGSTATEDISPLAY_DllAPI __declspec( dllimport )
#endif // PARKINGSTATEDISPLAY_SOURCE
#else
#define PARKINGSTATEDISPLAY_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PARKINGSTATEDISPLAY_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure ParkingStateDisplay defined by the user in the IDL file.
         * @ingroup ParkingStateDisplay
         */
        class ParkingStateDisplay
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport ParkingStateDisplay();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~ParkingStateDisplay();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingStateDisplay that will be copied.
             */
            eProsima_user_DllExport ParkingStateDisplay(
                    const ParkingStateDisplay& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::ParkingStateDisplay that will be copied.
             */
            eProsima_user_DllExport ParkingStateDisplay(
                    ParkingStateDisplay&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingStateDisplay that will be copied.
             */
            eProsima_user_DllExport ParkingStateDisplay& operator =(
                    const ParkingStateDisplay& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::ParkingStateDisplay that will be copied.
             */
            eProsima_user_DllExport ParkingStateDisplay& operator =(
                    ParkingStateDisplay&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingStateDisplay object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const ParkingStateDisplay& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::ParkingStateDisplay object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const ParkingStateDisplay& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member parking_type
             * @param _parking_type New value for member parking_type
             */
            eProsima_user_DllExport void parking_type(
                    int32_t _parking_type);

            /*!
             * @brief This function returns the value of member parking_type
             * @return Value of member parking_type
             */
            eProsima_user_DllExport int32_t parking_type() const;

            /*!
             * @brief This function returns a reference to member parking_type
             * @return Reference to member parking_type
             */
            eProsima_user_DllExport int32_t& parking_type();

            /*!
             * @brief This function sets a value in member moves_counter
             * @param _moves_counter New value for member moves_counter
             */
            eProsima_user_DllExport void moves_counter(
                    int32_t _moves_counter);

            /*!
             * @brief This function returns the value of member moves_counter
             * @return Value of member moves_counter
             */
            eProsima_user_DllExport int32_t moves_counter() const;

            /*!
             * @brief This function returns a reference to member moves_counter
             * @return Reference to member moves_counter
             */
            eProsima_user_DllExport int32_t& moves_counter();

            /*!
             * @brief This function sets a value in member remian_distance
             * @param _remian_distance New value for member remian_distance
             */
            eProsima_user_DllExport void remian_distance(
                    double _remian_distance);

            /*!
             * @brief This function returns the value of member remian_distance
             * @return Value of member remian_distance
             */
            eProsima_user_DllExport double remian_distance() const;

            /*!
             * @brief This function returns a reference to member remian_distance
             * @return Reference to member remian_distance
             */
            eProsima_user_DllExport double& remian_distance();

            /*!
             * @brief This function sets a value in member distance_to_leader_obj
             * @param _distance_to_leader_obj New value for member distance_to_leader_obj
             */
            eProsima_user_DllExport void distance_to_leader_obj(
                    double _distance_to_leader_obj);

            /*!
             * @brief This function returns the value of member distance_to_leader_obj
             * @return Value of member distance_to_leader_obj
             */
            eProsima_user_DllExport double distance_to_leader_obj() const;

            /*!
             * @brief This function returns a reference to member distance_to_leader_obj
             * @return Reference to member distance_to_leader_obj
             */
            eProsima_user_DllExport double& distance_to_leader_obj();

            /*!
             * @brief This function sets a value in member state
             * @param _state New value for member state
             */
            eProsima_user_DllExport void state(
                    int32_t _state);

            /*!
             * @brief This function returns the value of member state
             * @return Value of member state
             */
            eProsima_user_DllExport int32_t state() const;

            /*!
             * @brief This function returns a reference to member state
             * @return Reference to member state
             */
            eProsima_user_DllExport int32_t& state();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::ParkingStateDisplay& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_parking_type;
            int32_t m_moves_counter;
            double m_remian_distance;
            double m_distance_to_leader_obj;
            int32_t m_state;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PARKINGSTATEDISPLAY_H_

