// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ParkingStateDisplayTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "ParkingStateDisplay.h"
#include "ParkingStateDisplayTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerParkingStateDisplayTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::ParkingStateDisplay", ros2_interface::msg::GetParkingStateDisplayIdentifier(true),
                        ros2_interface::msg::GetParkingStateDisplayObject(true));
                factory->add_type_object("ros2_interface::msg::ParkingStateDisplay", ros2_interface::msg::GetParkingStateDisplayIdentifier(false),
                        ros2_interface::msg::GetParkingStateDisplayObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetParkingStateDisplayIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("ParkingStateDisplay", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetParkingStateDisplayObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("ParkingStateDisplay", complete);
        }

        const TypeObject* GetParkingStateDisplayObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingStateDisplay", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteParkingStateDisplayObject();
            }
            //else
            return GetMinimalParkingStateDisplayObject();
        }

        const TypeObject* GetMinimalParkingStateDisplayObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingStateDisplay", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_parking_type;
            mst_parking_type.common().member_id(memberId++);
            mst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_type.common().member_flags().IS_OPTIONAL(false);
            mst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_type.common().member_flags().IS_KEY(false);
            mst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_type_hash("parking_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_type.detail().name_hash()[i] = parking_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_type);

            MinimalStructMember mst_moves_counter;
            mst_moves_counter.common().member_id(memberId++);
            mst_moves_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moves_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moves_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moves_counter.common().member_flags().IS_OPTIONAL(false);
            mst_moves_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moves_counter.common().member_flags().IS_KEY(false);
            mst_moves_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moves_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moves_counter_hash("moves_counter");
            for(int i = 0; i < 4; ++i)
            {
                mst_moves_counter.detail().name_hash()[i] = moves_counter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moves_counter);

            MinimalStructMember mst_remian_distance;
            mst_remian_distance.common().member_id(memberId++);
            mst_remian_distance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_remian_distance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_remian_distance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_remian_distance.common().member_flags().IS_OPTIONAL(false);
            mst_remian_distance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_remian_distance.common().member_flags().IS_KEY(false);
            mst_remian_distance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_remian_distance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 remian_distance_hash("remian_distance");
            for(int i = 0; i < 4; ++i)
            {
                mst_remian_distance.detail().name_hash()[i] = remian_distance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_remian_distance);

            MinimalStructMember mst_distance_to_leader_obj;
            mst_distance_to_leader_obj.common().member_id(memberId++);
            mst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().IS_OPTIONAL(false);
            mst_distance_to_leader_obj.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_distance_to_leader_obj.common().member_flags().IS_KEY(false);
            mst_distance_to_leader_obj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_distance_to_leader_obj.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 distance_to_leader_obj_hash("distance_to_leader_obj");
            for(int i = 0; i < 4; ++i)
            {
                mst_distance_to_leader_obj.detail().name_hash()[i] = distance_to_leader_obj_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_distance_to_leader_obj);

            MinimalStructMember mst_state;
            mst_state.common().member_id(memberId++);
            mst_state.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_state.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_state.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_state.common().member_flags().IS_OPTIONAL(false);
            mst_state.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_state.common().member_flags().IS_KEY(false);
            mst_state.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_state.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 state_hash("state");
            for(int i = 0; i < 4; ++i)
            {
                mst_state.detail().name_hash()[i] = state_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_state);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ParkingStateDisplay", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ParkingStateDisplay", false);
        }

        const TypeObject* GetCompleteParkingStateDisplayObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("ParkingStateDisplay", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_parking_type;
            cst_parking_type.common().member_id(memberId++);
            cst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_type.common().member_flags().IS_OPTIONAL(false);
            cst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_type.common().member_flags().IS_KEY(false);
            cst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_type.detail().name("parking_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_type);

            CompleteStructMember cst_moves_counter;
            cst_moves_counter.common().member_id(memberId++);
            cst_moves_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moves_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moves_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moves_counter.common().member_flags().IS_OPTIONAL(false);
            cst_moves_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moves_counter.common().member_flags().IS_KEY(false);
            cst_moves_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moves_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moves_counter.detail().name("moves_counter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moves_counter);

            CompleteStructMember cst_remian_distance;
            cst_remian_distance.common().member_id(memberId++);
            cst_remian_distance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_remian_distance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_remian_distance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_remian_distance.common().member_flags().IS_OPTIONAL(false);
            cst_remian_distance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_remian_distance.common().member_flags().IS_KEY(false);
            cst_remian_distance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_remian_distance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_remian_distance.detail().name("remian_distance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_remian_distance);

            CompleteStructMember cst_distance_to_leader_obj;
            cst_distance_to_leader_obj.common().member_id(memberId++);
            cst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().IS_OPTIONAL(false);
            cst_distance_to_leader_obj.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_distance_to_leader_obj.common().member_flags().IS_KEY(false);
            cst_distance_to_leader_obj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_distance_to_leader_obj.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_distance_to_leader_obj.detail().name("distance_to_leader_obj");

            type_object->complete().struct_type().member_seq().emplace_back(cst_distance_to_leader_obj);

            CompleteStructMember cst_state;
            cst_state.common().member_id(memberId++);
            cst_state.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_state.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_state.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_state.common().member_flags().IS_OPTIONAL(false);
            cst_state.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_state.common().member_flags().IS_KEY(false);
            cst_state.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_state.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_state.detail().name("state");

            type_object->complete().struct_type().member_seq().emplace_back(cst_state);


            // Header
            type_object->complete().struct_type().header().detail().type_name("ParkingStateDisplay");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("ParkingStateDisplay", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("ParkingStateDisplay", true);
        }

    } // namespace msg
} // namespace ros2_interface