// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Path.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Path.h"
#include "PathTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Path_max_cdr_typesize 9064ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_Path_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Path::Path()
{
    // string m_name
    m_name ="";
    // sequence<ros2_interface::msg::PathPoint> m_path_points


    // Just to register all known types
    registerPathTypes();
}

ros2_interface::msg::Path::~Path()
{


}

ros2_interface::msg::Path::Path(
        const Path& x)
{
    m_name = x.m_name;
    m_path_points = x.m_path_points;
}

ros2_interface::msg::Path::Path(
        Path&& x) noexcept 
{
    m_name = std::move(x.m_name);
    m_path_points = std::move(x.m_path_points);
}

ros2_interface::msg::Path& ros2_interface::msg::Path::operator =(
        const Path& x)
{

    m_name = x.m_name;
    m_path_points = x.m_path_points;

    return *this;
}

ros2_interface::msg::Path& ros2_interface::msg::Path::operator =(
        Path&& x) noexcept
{

    m_name = std::move(x.m_name);
    m_path_points = std::move(x.m_path_points);

    return *this;
}

bool ros2_interface::msg::Path::operator ==(
        const Path& x) const
{

    return (m_name == x.m_name && m_path_points == x.m_path_points);
}

bool ros2_interface::msg::Path::operator !=(
        const Path& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Path::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Path_max_cdr_typesize;
}

size_t ros2_interface::msg::Path::getCdrSerializedSize(
        const ros2_interface::msg::Path& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.path_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::PathPoint::getCdrSerializedSize(data.path_points().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Path::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_name.c_str();
    scdr << m_path_points;

}

void ros2_interface::msg::Path::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_name;
    dcdr >> m_path_points;
}

/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::Path::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::Path::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::Path::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::Path::name()
{
    return m_name;
}
/*!
 * @brief This function copies the value in member path_points
 * @param _path_points New value to be copied in member path_points
 */
void ros2_interface::msg::Path::path_points(
        const std::vector<ros2_interface::msg::PathPoint>& _path_points)
{
    m_path_points = _path_points;
}

/*!
 * @brief This function moves the value in member path_points
 * @param _path_points New value to be moved in member path_points
 */
void ros2_interface::msg::Path::path_points(
        std::vector<ros2_interface::msg::PathPoint>&& _path_points)
{
    m_path_points = std::move(_path_points);
}

/*!
 * @brief This function returns a constant reference to member path_points
 * @return Constant reference to member path_points
 */
const std::vector<ros2_interface::msg::PathPoint>& ros2_interface::msg::Path::path_points() const
{
    return m_path_points;
}

/*!
 * @brief This function returns a reference to member path_points
 * @return Reference to member path_points
 */
std::vector<ros2_interface::msg::PathPoint>& ros2_interface::msg::Path::path_points()
{
    return m_path_points;
}


size_t ros2_interface::msg::Path::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Path_max_key_cdr_typesize;
}

bool ros2_interface::msg::Path::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Path::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



