// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PathPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PathPoint.h"
#include "PathPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PathPoint::PathPoint()
{
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_z
    m_z = 0.0;
    // double m_theta
    m_theta = 0.0;
    // double m_kappa
    m_kappa = 0.0;
    // double m_s
    m_s = 0.0;
    // double m_dkappa
    m_dkappa = 0.0;
    // double m_ddkappa
    m_ddkappa = 0.0;
    // double m_lane_id
    m_lane_id = 0.0;
    // double m_x_derivative
    m_x_derivative = 0.0;
    // double m_y_derivative
    m_y_derivative = 0.0;

    // Just to register all known types
    registerPathPointTypes();
}

ros2_interface::msg::PathPoint::~PathPoint()
{











}

ros2_interface::msg::PathPoint::PathPoint(
        const PathPoint& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
    m_kappa = x.m_kappa;
    m_s = x.m_s;
    m_dkappa = x.m_dkappa;
    m_ddkappa = x.m_ddkappa;
    m_lane_id = x.m_lane_id;
    m_x_derivative = x.m_x_derivative;
    m_y_derivative = x.m_y_derivative;
}

ros2_interface::msg::PathPoint::PathPoint(
        PathPoint&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
    m_kappa = x.m_kappa;
    m_s = x.m_s;
    m_dkappa = x.m_dkappa;
    m_ddkappa = x.m_ddkappa;
    m_lane_id = x.m_lane_id;
    m_x_derivative = x.m_x_derivative;
    m_y_derivative = x.m_y_derivative;
}

ros2_interface::msg::PathPoint& ros2_interface::msg::PathPoint::operator =(
        const PathPoint& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
    m_kappa = x.m_kappa;
    m_s = x.m_s;
    m_dkappa = x.m_dkappa;
    m_ddkappa = x.m_ddkappa;
    m_lane_id = x.m_lane_id;
    m_x_derivative = x.m_x_derivative;
    m_y_derivative = x.m_y_derivative;

    return *this;
}

ros2_interface::msg::PathPoint& ros2_interface::msg::PathPoint::operator =(
        PathPoint&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
    m_kappa = x.m_kappa;
    m_s = x.m_s;
    m_dkappa = x.m_dkappa;
    m_ddkappa = x.m_ddkappa;
    m_lane_id = x.m_lane_id;
    m_x_derivative = x.m_x_derivative;
    m_y_derivative = x.m_y_derivative;

    return *this;
}

bool ros2_interface::msg::PathPoint::operator ==(
        const PathPoint& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_z == x.m_z && m_theta == x.m_theta && m_kappa == x.m_kappa && m_s == x.m_s && m_dkappa == x.m_dkappa && m_ddkappa == x.m_ddkappa && m_lane_id == x.m_lane_id && m_x_derivative == x.m_x_derivative && m_y_derivative == x.m_y_derivative);
}

bool ros2_interface::msg::PathPoint::operator !=(
        const PathPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PathPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PathPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::PathPoint::getCdrSerializedSize(
        const ros2_interface::msg::PathPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PathPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_z;
    scdr << m_theta;
    scdr << m_kappa;
    scdr << m_s;
    scdr << m_dkappa;
    scdr << m_ddkappa;
    scdr << m_lane_id;
    scdr << m_x_derivative;
    scdr << m_y_derivative;

}

void ros2_interface::msg::PathPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_z;
    dcdr >> m_theta;
    dcdr >> m_kappa;
    dcdr >> m_s;
    dcdr >> m_dkappa;
    dcdr >> m_ddkappa;
    dcdr >> m_lane_id;
    dcdr >> m_x_derivative;
    dcdr >> m_y_derivative;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::PathPoint::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::PathPoint::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::PathPoint::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::PathPoint::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::PathPoint::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::PathPoint::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member z
 * @param _z New value for member z
 */
void ros2_interface::msg::PathPoint::z(
        double _z)
{
    m_z = _z;
}

/*!
 * @brief This function returns the value of member z
 * @return Value of member z
 */
double ros2_interface::msg::PathPoint::z() const
{
    return m_z;
}

/*!
 * @brief This function returns a reference to member z
 * @return Reference to member z
 */
double& ros2_interface::msg::PathPoint::z()
{
    return m_z;
}

/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::PathPoint::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::PathPoint::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::PathPoint::theta()
{
    return m_theta;
}

/*!
 * @brief This function sets a value in member kappa
 * @param _kappa New value for member kappa
 */
void ros2_interface::msg::PathPoint::kappa(
        double _kappa)
{
    m_kappa = _kappa;
}

/*!
 * @brief This function returns the value of member kappa
 * @return Value of member kappa
 */
double ros2_interface::msg::PathPoint::kappa() const
{
    return m_kappa;
}

/*!
 * @brief This function returns a reference to member kappa
 * @return Reference to member kappa
 */
double& ros2_interface::msg::PathPoint::kappa()
{
    return m_kappa;
}

/*!
 * @brief This function sets a value in member s
 * @param _s New value for member s
 */
void ros2_interface::msg::PathPoint::s(
        double _s)
{
    m_s = _s;
}

/*!
 * @brief This function returns the value of member s
 * @return Value of member s
 */
double ros2_interface::msg::PathPoint::s() const
{
    return m_s;
}

/*!
 * @brief This function returns a reference to member s
 * @return Reference to member s
 */
double& ros2_interface::msg::PathPoint::s()
{
    return m_s;
}

/*!
 * @brief This function sets a value in member dkappa
 * @param _dkappa New value for member dkappa
 */
void ros2_interface::msg::PathPoint::dkappa(
        double _dkappa)
{
    m_dkappa = _dkappa;
}

/*!
 * @brief This function returns the value of member dkappa
 * @return Value of member dkappa
 */
double ros2_interface::msg::PathPoint::dkappa() const
{
    return m_dkappa;
}

/*!
 * @brief This function returns a reference to member dkappa
 * @return Reference to member dkappa
 */
double& ros2_interface::msg::PathPoint::dkappa()
{
    return m_dkappa;
}

/*!
 * @brief This function sets a value in member ddkappa
 * @param _ddkappa New value for member ddkappa
 */
void ros2_interface::msg::PathPoint::ddkappa(
        double _ddkappa)
{
    m_ddkappa = _ddkappa;
}

/*!
 * @brief This function returns the value of member ddkappa
 * @return Value of member ddkappa
 */
double ros2_interface::msg::PathPoint::ddkappa() const
{
    return m_ddkappa;
}

/*!
 * @brief This function returns a reference to member ddkappa
 * @return Reference to member ddkappa
 */
double& ros2_interface::msg::PathPoint::ddkappa()
{
    return m_ddkappa;
}

/*!
 * @brief This function sets a value in member lane_id
 * @param _lane_id New value for member lane_id
 */
void ros2_interface::msg::PathPoint::lane_id(
        double _lane_id)
{
    m_lane_id = _lane_id;
}

/*!
 * @brief This function returns the value of member lane_id
 * @return Value of member lane_id
 */
double ros2_interface::msg::PathPoint::lane_id() const
{
    return m_lane_id;
}

/*!
 * @brief This function returns a reference to member lane_id
 * @return Reference to member lane_id
 */
double& ros2_interface::msg::PathPoint::lane_id()
{
    return m_lane_id;
}

/*!
 * @brief This function sets a value in member x_derivative
 * @param _x_derivative New value for member x_derivative
 */
void ros2_interface::msg::PathPoint::x_derivative(
        double _x_derivative)
{
    m_x_derivative = _x_derivative;
}

/*!
 * @brief This function returns the value of member x_derivative
 * @return Value of member x_derivative
 */
double ros2_interface::msg::PathPoint::x_derivative() const
{
    return m_x_derivative;
}

/*!
 * @brief This function returns a reference to member x_derivative
 * @return Reference to member x_derivative
 */
double& ros2_interface::msg::PathPoint::x_derivative()
{
    return m_x_derivative;
}

/*!
 * @brief This function sets a value in member y_derivative
 * @param _y_derivative New value for member y_derivative
 */
void ros2_interface::msg::PathPoint::y_derivative(
        double _y_derivative)
{
    m_y_derivative = _y_derivative;
}

/*!
 * @brief This function returns the value of member y_derivative
 * @return Value of member y_derivative
 */
double ros2_interface::msg::PathPoint::y_derivative() const
{
    return m_y_derivative;
}

/*!
 * @brief This function returns a reference to member y_derivative
 * @return Reference to member y_derivative
 */
double& ros2_interface::msg::PathPoint::y_derivative()
{
    return m_y_derivative;
}



size_t ros2_interface::msg::PathPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PathPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::PathPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PathPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



