// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PathPoint.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PATHPOINT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PATHPOINT_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PATHPOINT_SOURCE)
#define PATHPOINT_DllAPI __declspec( dllexport )
#else
#define PATHPOINT_DllAPI __declspec( dllimport )
#endif // PATHPOINT_SOURCE
#else
#define PATHPOINT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PATHPOINT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PathPoint defined by the user in the IDL file.
         * @ingroup PathPoint
         */
        class PathPoint
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PathPoint();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PathPoint();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PathPoint that will be copied.
             */
            eProsima_user_DllExport PathPoint(
                    const PathPoint& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PathPoint that will be copied.
             */
            eProsima_user_DllExport PathPoint(
                    PathPoint&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PathPoint that will be copied.
             */
            eProsima_user_DllExport PathPoint& operator =(
                    const PathPoint& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PathPoint that will be copied.
             */
            eProsima_user_DllExport PathPoint& operator =(
                    PathPoint&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PathPoint object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PathPoint& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PathPoint object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PathPoint& x) const;

            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    double _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport double x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport double& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    double _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport double y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport double& y();

            /*!
             * @brief This function sets a value in member z
             * @param _z New value for member z
             */
            eProsima_user_DllExport void z(
                    double _z);

            /*!
             * @brief This function returns the value of member z
             * @return Value of member z
             */
            eProsima_user_DllExport double z() const;

            /*!
             * @brief This function returns a reference to member z
             * @return Reference to member z
             */
            eProsima_user_DllExport double& z();

            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function sets a value in member kappa
             * @param _kappa New value for member kappa
             */
            eProsima_user_DllExport void kappa(
                    double _kappa);

            /*!
             * @brief This function returns the value of member kappa
             * @return Value of member kappa
             */
            eProsima_user_DllExport double kappa() const;

            /*!
             * @brief This function returns a reference to member kappa
             * @return Reference to member kappa
             */
            eProsima_user_DllExport double& kappa();

            /*!
             * @brief This function sets a value in member s
             * @param _s New value for member s
             */
            eProsima_user_DllExport void s(
                    double _s);

            /*!
             * @brief This function returns the value of member s
             * @return Value of member s
             */
            eProsima_user_DllExport double s() const;

            /*!
             * @brief This function returns a reference to member s
             * @return Reference to member s
             */
            eProsima_user_DllExport double& s();

            /*!
             * @brief This function sets a value in member dkappa
             * @param _dkappa New value for member dkappa
             */
            eProsima_user_DllExport void dkappa(
                    double _dkappa);

            /*!
             * @brief This function returns the value of member dkappa
             * @return Value of member dkappa
             */
            eProsima_user_DllExport double dkappa() const;

            /*!
             * @brief This function returns a reference to member dkappa
             * @return Reference to member dkappa
             */
            eProsima_user_DllExport double& dkappa();

            /*!
             * @brief This function sets a value in member ddkappa
             * @param _ddkappa New value for member ddkappa
             */
            eProsima_user_DllExport void ddkappa(
                    double _ddkappa);

            /*!
             * @brief This function returns the value of member ddkappa
             * @return Value of member ddkappa
             */
            eProsima_user_DllExport double ddkappa() const;

            /*!
             * @brief This function returns a reference to member ddkappa
             * @return Reference to member ddkappa
             */
            eProsima_user_DllExport double& ddkappa();

            /*!
             * @brief This function sets a value in member lane_id
             * @param _lane_id New value for member lane_id
             */
            eProsima_user_DllExport void lane_id(
                    double _lane_id);

            /*!
             * @brief This function returns the value of member lane_id
             * @return Value of member lane_id
             */
            eProsima_user_DllExport double lane_id() const;

            /*!
             * @brief This function returns a reference to member lane_id
             * @return Reference to member lane_id
             */
            eProsima_user_DllExport double& lane_id();

            /*!
             * @brief This function sets a value in member x_derivative
             * @param _x_derivative New value for member x_derivative
             */
            eProsima_user_DllExport void x_derivative(
                    double _x_derivative);

            /*!
             * @brief This function returns the value of member x_derivative
             * @return Value of member x_derivative
             */
            eProsima_user_DllExport double x_derivative() const;

            /*!
             * @brief This function returns a reference to member x_derivative
             * @return Reference to member x_derivative
             */
            eProsima_user_DllExport double& x_derivative();

            /*!
             * @brief This function sets a value in member y_derivative
             * @param _y_derivative New value for member y_derivative
             */
            eProsima_user_DllExport void y_derivative(
                    double _y_derivative);

            /*!
             * @brief This function returns the value of member y_derivative
             * @return Value of member y_derivative
             */
            eProsima_user_DllExport double y_derivative() const;

            /*!
             * @brief This function returns a reference to member y_derivative
             * @return Reference to member y_derivative
             */
            eProsima_user_DllExport double& y_derivative();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PathPoint& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_x;
            double m_y;
            double m_z;
            double m_theta;
            double m_kappa;
            double m_s;
            double m_dkappa;
            double m_ddkappa;
            double m_lane_id;
            double m_x_derivative;
            double m_y_derivative;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PATHPOINT_H_

