// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PathPointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PathPoint.h"
#include "PathPointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPathPointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPathPointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PathPoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPathPointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PathPoint", complete);
        }

        const TypeObject* GetPathPointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PathPoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePathPointObject();
            }
            //else
            return GetMinimalPathPointObject();
        }

        const TypeObject* GetMinimalPathPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PathPoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_x;
            mst_x.common().member_id(memberId++);
            mst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_x.common().member_flags().IS_OPTIONAL(false);
            mst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_x.common().member_flags().IS_KEY(false);
            mst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 x_hash("x");
            for(int i = 0; i < 4; ++i)
            {
                mst_x.detail().name_hash()[i] = x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_x);

            MinimalStructMember mst_y;
            mst_y.common().member_id(memberId++);
            mst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_y.common().member_flags().IS_OPTIONAL(false);
            mst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_y.common().member_flags().IS_KEY(false);
            mst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 y_hash("y");
            for(int i = 0; i < 4; ++i)
            {
                mst_y.detail().name_hash()[i] = y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_y);

            MinimalStructMember mst_z;
            mst_z.common().member_id(memberId++);
            mst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_z.common().member_flags().IS_OPTIONAL(false);
            mst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_z.common().member_flags().IS_KEY(false);
            mst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 z_hash("z");
            for(int i = 0; i < 4; ++i)
            {
                mst_z.detail().name_hash()[i] = z_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_z);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_kappa;
            mst_kappa.common().member_id(memberId++);
            mst_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_kappa.common().member_flags().IS_OPTIONAL(false);
            mst_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_kappa.common().member_flags().IS_KEY(false);
            mst_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 kappa_hash("kappa");
            for(int i = 0; i < 4; ++i)
            {
                mst_kappa.detail().name_hash()[i] = kappa_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_kappa);

            MinimalStructMember mst_s;
            mst_s.common().member_id(memberId++);
            mst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_s.common().member_flags().IS_OPTIONAL(false);
            mst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_s.common().member_flags().IS_KEY(false);
            mst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 s_hash("s");
            for(int i = 0; i < 4; ++i)
            {
                mst_s.detail().name_hash()[i] = s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_s);

            MinimalStructMember mst_dkappa;
            mst_dkappa.common().member_id(memberId++);
            mst_dkappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_dkappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_dkappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_dkappa.common().member_flags().IS_OPTIONAL(false);
            mst_dkappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_dkappa.common().member_flags().IS_KEY(false);
            mst_dkappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_dkappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 dkappa_hash("dkappa");
            for(int i = 0; i < 4; ++i)
            {
                mst_dkappa.detail().name_hash()[i] = dkappa_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_dkappa);

            MinimalStructMember mst_ddkappa;
            mst_ddkappa.common().member_id(memberId++);
            mst_ddkappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ddkappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ddkappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ddkappa.common().member_flags().IS_OPTIONAL(false);
            mst_ddkappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ddkappa.common().member_flags().IS_KEY(false);
            mst_ddkappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ddkappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ddkappa_hash("ddkappa");
            for(int i = 0; i < 4; ++i)
            {
                mst_ddkappa.detail().name_hash()[i] = ddkappa_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ddkappa);

            MinimalStructMember mst_lane_id;
            mst_lane_id.common().member_id(memberId++);
            mst_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_id.common().member_flags().IS_OPTIONAL(false);
            mst_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_id.common().member_flags().IS_KEY(false);
            mst_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lane_id_hash("lane_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_id.detail().name_hash()[i] = lane_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_id);

            MinimalStructMember mst_x_derivative;
            mst_x_derivative.common().member_id(memberId++);
            mst_x_derivative.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_x_derivative.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_x_derivative.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_x_derivative.common().member_flags().IS_OPTIONAL(false);
            mst_x_derivative.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_x_derivative.common().member_flags().IS_KEY(false);
            mst_x_derivative.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_x_derivative.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 x_derivative_hash("x_derivative");
            for(int i = 0; i < 4; ++i)
            {
                mst_x_derivative.detail().name_hash()[i] = x_derivative_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_x_derivative);

            MinimalStructMember mst_y_derivative;
            mst_y_derivative.common().member_id(memberId++);
            mst_y_derivative.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_y_derivative.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_y_derivative.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_y_derivative.common().member_flags().IS_OPTIONAL(false);
            mst_y_derivative.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_y_derivative.common().member_flags().IS_KEY(false);
            mst_y_derivative.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_y_derivative.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 y_derivative_hash("y_derivative");
            for(int i = 0; i < 4; ++i)
            {
                mst_y_derivative.detail().name_hash()[i] = y_derivative_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_y_derivative);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PathPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PathPoint", false);
        }

        const TypeObject* GetCompletePathPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PathPoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_x;
            cst_x.common().member_id(memberId++);
            cst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_x.common().member_flags().IS_OPTIONAL(false);
            cst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_x.common().member_flags().IS_KEY(false);
            cst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_x.detail().name("x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_x);

            CompleteStructMember cst_y;
            cst_y.common().member_id(memberId++);
            cst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_y.common().member_flags().IS_OPTIONAL(false);
            cst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_y.common().member_flags().IS_KEY(false);
            cst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_y.detail().name("y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_y);

            CompleteStructMember cst_z;
            cst_z.common().member_id(memberId++);
            cst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_z.common().member_flags().IS_OPTIONAL(false);
            cst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_z.common().member_flags().IS_KEY(false);
            cst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_z.detail().name("z");

            type_object->complete().struct_type().member_seq().emplace_back(cst_z);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_kappa;
            cst_kappa.common().member_id(memberId++);
            cst_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_kappa.common().member_flags().IS_OPTIONAL(false);
            cst_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_kappa.common().member_flags().IS_KEY(false);
            cst_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_kappa.detail().name("kappa");

            type_object->complete().struct_type().member_seq().emplace_back(cst_kappa);

            CompleteStructMember cst_s;
            cst_s.common().member_id(memberId++);
            cst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_s.common().member_flags().IS_OPTIONAL(false);
            cst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_s.common().member_flags().IS_KEY(false);
            cst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_s.detail().name("s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_s);

            CompleteStructMember cst_dkappa;
            cst_dkappa.common().member_id(memberId++);
            cst_dkappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_dkappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_dkappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_dkappa.common().member_flags().IS_OPTIONAL(false);
            cst_dkappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_dkappa.common().member_flags().IS_KEY(false);
            cst_dkappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_dkappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_dkappa.detail().name("dkappa");

            type_object->complete().struct_type().member_seq().emplace_back(cst_dkappa);

            CompleteStructMember cst_ddkappa;
            cst_ddkappa.common().member_id(memberId++);
            cst_ddkappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ddkappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ddkappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ddkappa.common().member_flags().IS_OPTIONAL(false);
            cst_ddkappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ddkappa.common().member_flags().IS_KEY(false);
            cst_ddkappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ddkappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ddkappa.detail().name("ddkappa");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ddkappa);

            CompleteStructMember cst_lane_id;
            cst_lane_id.common().member_id(memberId++);
            cst_lane_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_id.common().member_flags().IS_OPTIONAL(false);
            cst_lane_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_id.common().member_flags().IS_KEY(false);
            cst_lane_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lane_id.detail().name("lane_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_id);

            CompleteStructMember cst_x_derivative;
            cst_x_derivative.common().member_id(memberId++);
            cst_x_derivative.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_x_derivative.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_x_derivative.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_x_derivative.common().member_flags().IS_OPTIONAL(false);
            cst_x_derivative.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_x_derivative.common().member_flags().IS_KEY(false);
            cst_x_derivative.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_x_derivative.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_x_derivative.detail().name("x_derivative");

            type_object->complete().struct_type().member_seq().emplace_back(cst_x_derivative);

            CompleteStructMember cst_y_derivative;
            cst_y_derivative.common().member_id(memberId++);
            cst_y_derivative.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_y_derivative.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_y_derivative.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_y_derivative.common().member_flags().IS_OPTIONAL(false);
            cst_y_derivative.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_y_derivative.common().member_flags().IS_KEY(false);
            cst_y_derivative.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_y_derivative.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_y_derivative.detail().name("y_derivative");

            type_object->complete().struct_type().member_seq().emplace_back(cst_y_derivative);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PathPoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PathPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PathPoint", true);
        }

    } // namespace msg
} // namespace ros2_interface