// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Pavementype.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Pavementype.h"
#include "PavementypeTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Pavementype_max_cdr_typesize 288ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Pavementype_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Pavementype::Pavementype()
{
    // ros2_interface::msg::Header m_header

    // long m_type
    m_type = 0;
    // double m_confidence
    m_confidence = 0.0;

    // Just to register all known types
    registerPavementypeTypes();
}

ros2_interface::msg::Pavementype::~Pavementype()
{



}

ros2_interface::msg::Pavementype::Pavementype(
        const Pavementype& x)
{
    m_header = x.m_header;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::Pavementype::Pavementype(
        Pavementype&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_type = x.m_type;
    m_confidence = x.m_confidence;
}

ros2_interface::msg::Pavementype& ros2_interface::msg::Pavementype::operator =(
        const Pavementype& x)
{

    m_header = x.m_header;
    m_type = x.m_type;
    m_confidence = x.m_confidence;

    return *this;
}

ros2_interface::msg::Pavementype& ros2_interface::msg::Pavementype::operator =(
        Pavementype&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_type = x.m_type;
    m_confidence = x.m_confidence;

    return *this;
}

bool ros2_interface::msg::Pavementype::operator ==(
        const Pavementype& x) const
{

    return (m_header == x.m_header && m_type == x.m_type && m_confidence == x.m_confidence);
}

bool ros2_interface::msg::Pavementype::operator !=(
        const Pavementype& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Pavementype::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Pavementype_max_cdr_typesize;
}

size_t ros2_interface::msg::Pavementype::getCdrSerializedSize(
        const ros2_interface::msg::Pavementype& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Pavementype::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_type;
    scdr << m_confidence;

}

void ros2_interface::msg::Pavementype::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_type;
    dcdr >> m_confidence;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Pavementype::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Pavementype::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Pavementype::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Pavementype::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::Pavementype::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::Pavementype::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::Pavementype::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::Pavementype::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::Pavementype::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::Pavementype::confidence()
{
    return m_confidence;
}



size_t ros2_interface::msg::Pavementype::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Pavementype_max_key_cdr_typesize;
}

bool ros2_interface::msg::Pavementype::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Pavementype::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



