// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PerceptionObstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PerceptionObstacle.h"
#include "PerceptionObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_PerceptionObstacle_max_cdr_typesize 7457ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PerceptionObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PerceptionObstacle::PerceptionObstacle()
{
    // long m_id
    m_id = 0;
    // ros2_interface::msg::Point3D m_position

    // double m_theta
    m_theta = 0.0;
    // ros2_interface::msg::Point3D m_velocity

    // double m_length
    m_length = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_height
    m_height = 0.0;
    // sequence<ros2_interface::msg::Point3D> m_polygon_point

    // double m_tracking_time
    m_tracking_time = 0.0;
    // long m_type
    m_type = 0;
    // long m_lane_position
    m_lane_position = 0;
    // double m_confidence
    m_confidence = 0.0;
    // double m_timestamp
    m_timestamp = 0.0;
    // uint8 m_confidence_type
    m_confidence_type = 0;
    // ros2_interface::msg::Point3D m_drops

    // ros2_interface::msg::Point3D m_acceleration

    // ros2_interface::msg::Point3D m_anchor_point

    // sequence<ros2_interface::msg::Point3D> m_bounding_box

    // long m_sub_type
    m_sub_type = 0;
    // double m_height_above_ground
    m_height_above_ground = 0.0;
    // sequence<double> m_position_covariance

    // sequence<double> m_velocity_covariance

    // sequence<double> m_acceleration_covariance

    // uint8 m_light_status
    m_light_status = 0;

    // Just to register all known types
    registerPerceptionObstacleTypes();
}

ros2_interface::msg::PerceptionObstacle::~PerceptionObstacle()
{
























}

ros2_interface::msg::PerceptionObstacle::PerceptionObstacle(
        const PerceptionObstacle& x)
{
    m_id = x.m_id;
    m_position = x.m_position;
    m_theta = x.m_theta;
    m_velocity = x.m_velocity;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_polygon_point = x.m_polygon_point;
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_lane_position = x.m_lane_position;
    m_confidence = x.m_confidence;
    m_timestamp = x.m_timestamp;
    m_confidence_type = x.m_confidence_type;
    m_drops = x.m_drops;
    m_acceleration = x.m_acceleration;
    m_anchor_point = x.m_anchor_point;
    m_bounding_box = x.m_bounding_box;
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_covariance = x.m_position_covariance;
    m_velocity_covariance = x.m_velocity_covariance;
    m_acceleration_covariance = x.m_acceleration_covariance;
    m_light_status = x.m_light_status;
}

ros2_interface::msg::PerceptionObstacle::PerceptionObstacle(
        PerceptionObstacle&& x) noexcept 
{
    m_id = x.m_id;
    m_position = std::move(x.m_position);
    m_theta = x.m_theta;
    m_velocity = std::move(x.m_velocity);
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_polygon_point = std::move(x.m_polygon_point);
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_lane_position = x.m_lane_position;
    m_confidence = x.m_confidence;
    m_timestamp = x.m_timestamp;
    m_confidence_type = x.m_confidence_type;
    m_drops = std::move(x.m_drops);
    m_acceleration = std::move(x.m_acceleration);
    m_anchor_point = std::move(x.m_anchor_point);
    m_bounding_box = std::move(x.m_bounding_box);
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_covariance = std::move(x.m_position_covariance);
    m_velocity_covariance = std::move(x.m_velocity_covariance);
    m_acceleration_covariance = std::move(x.m_acceleration_covariance);
    m_light_status = x.m_light_status;
}

ros2_interface::msg::PerceptionObstacle& ros2_interface::msg::PerceptionObstacle::operator =(
        const PerceptionObstacle& x)
{

    m_id = x.m_id;
    m_position = x.m_position;
    m_theta = x.m_theta;
    m_velocity = x.m_velocity;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_polygon_point = x.m_polygon_point;
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_lane_position = x.m_lane_position;
    m_confidence = x.m_confidence;
    m_timestamp = x.m_timestamp;
    m_confidence_type = x.m_confidence_type;
    m_drops = x.m_drops;
    m_acceleration = x.m_acceleration;
    m_anchor_point = x.m_anchor_point;
    m_bounding_box = x.m_bounding_box;
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_covariance = x.m_position_covariance;
    m_velocity_covariance = x.m_velocity_covariance;
    m_acceleration_covariance = x.m_acceleration_covariance;
    m_light_status = x.m_light_status;

    return *this;
}

ros2_interface::msg::PerceptionObstacle& ros2_interface::msg::PerceptionObstacle::operator =(
        PerceptionObstacle&& x) noexcept
{

    m_id = x.m_id;
    m_position = std::move(x.m_position);
    m_theta = x.m_theta;
    m_velocity = std::move(x.m_velocity);
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_polygon_point = std::move(x.m_polygon_point);
    m_tracking_time = x.m_tracking_time;
    m_type = x.m_type;
    m_lane_position = x.m_lane_position;
    m_confidence = x.m_confidence;
    m_timestamp = x.m_timestamp;
    m_confidence_type = x.m_confidence_type;
    m_drops = std::move(x.m_drops);
    m_acceleration = std::move(x.m_acceleration);
    m_anchor_point = std::move(x.m_anchor_point);
    m_bounding_box = std::move(x.m_bounding_box);
    m_sub_type = x.m_sub_type;
    m_height_above_ground = x.m_height_above_ground;
    m_position_covariance = std::move(x.m_position_covariance);
    m_velocity_covariance = std::move(x.m_velocity_covariance);
    m_acceleration_covariance = std::move(x.m_acceleration_covariance);
    m_light_status = x.m_light_status;

    return *this;
}

bool ros2_interface::msg::PerceptionObstacle::operator ==(
        const PerceptionObstacle& x) const
{

    return (m_id == x.m_id && m_position == x.m_position && m_theta == x.m_theta && m_velocity == x.m_velocity && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_polygon_point == x.m_polygon_point && m_tracking_time == x.m_tracking_time && m_type == x.m_type && m_lane_position == x.m_lane_position && m_confidence == x.m_confidence && m_timestamp == x.m_timestamp && m_confidence_type == x.m_confidence_type && m_drops == x.m_drops && m_acceleration == x.m_acceleration && m_anchor_point == x.m_anchor_point && m_bounding_box == x.m_bounding_box && m_sub_type == x.m_sub_type && m_height_above_ground == x.m_height_above_ground && m_position_covariance == x.m_position_covariance && m_velocity_covariance == x.m_velocity_covariance && m_acceleration_covariance == x.m_acceleration_covariance && m_light_status == x.m_light_status);
}

bool ros2_interface::msg::PerceptionObstacle::operator !=(
        const PerceptionObstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PerceptionObstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PerceptionObstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::PerceptionObstacle::getCdrSerializedSize(
        const ros2_interface::msg::PerceptionObstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.velocity(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.polygon_point().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.polygon_point().at(a), current_alignment);}

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.drops(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.acceleration(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.anchor_point(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.bounding_box().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.bounding_box().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.position_covariance().size() > 0)
    {
        current_alignment += (data.position_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.velocity_covariance().size() > 0)
    {
        current_alignment += (data.velocity_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.acceleration_covariance().size() > 0)
    {
        current_alignment += (data.acceleration_covariance().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PerceptionObstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_id;
    scdr << m_position;
    scdr << m_theta;
    scdr << m_velocity;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_polygon_point;
    scdr << m_tracking_time;
    scdr << m_type;
    scdr << m_lane_position;
    scdr << m_confidence;
    scdr << m_timestamp;
    scdr << m_confidence_type;
    scdr << m_drops;
    scdr << m_acceleration;
    scdr << m_anchor_point;
    scdr << m_bounding_box;
    scdr << m_sub_type;
    scdr << m_height_above_ground;
    scdr << m_position_covariance;
    scdr << m_velocity_covariance;
    scdr << m_acceleration_covariance;
    scdr << m_light_status;

}

void ros2_interface::msg::PerceptionObstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_id;
    dcdr >> m_position;
    dcdr >> m_theta;
    dcdr >> m_velocity;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_polygon_point;
    dcdr >> m_tracking_time;
    dcdr >> m_type;
    dcdr >> m_lane_position;
    dcdr >> m_confidence;
    dcdr >> m_timestamp;
    dcdr >> m_confidence_type;
    dcdr >> m_drops;
    dcdr >> m_acceleration;
    dcdr >> m_anchor_point;
    dcdr >> m_bounding_box;
    dcdr >> m_sub_type;
    dcdr >> m_height_above_ground;
    dcdr >> m_position_covariance;
    dcdr >> m_velocity_covariance;
    dcdr >> m_acceleration_covariance;
    dcdr >> m_light_status;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::PerceptionObstacle::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::PerceptionObstacle::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::PerceptionObstacle::id()
{
    return m_id;
}

/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::PerceptionObstacle::position(
        const ros2_interface::msg::Point3D& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::PerceptionObstacle::position(
        ros2_interface::msg::Point3D&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::position()
{
    return m_position;
}
/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::PerceptionObstacle::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::PerceptionObstacle::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::PerceptionObstacle::theta()
{
    return m_theta;
}

/*!
 * @brief This function copies the value in member velocity
 * @param _velocity New value to be copied in member velocity
 */
void ros2_interface::msg::PerceptionObstacle::velocity(
        const ros2_interface::msg::Point3D& _velocity)
{
    m_velocity = _velocity;
}

/*!
 * @brief This function moves the value in member velocity
 * @param _velocity New value to be moved in member velocity
 */
void ros2_interface::msg::PerceptionObstacle::velocity(
        ros2_interface::msg::Point3D&& _velocity)
{
    m_velocity = std::move(_velocity);
}

/*!
 * @brief This function returns a constant reference to member velocity
 * @return Constant reference to member velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::velocity() const
{
    return m_velocity;
}

/*!
 * @brief This function returns a reference to member velocity
 * @return Reference to member velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::velocity()
{
    return m_velocity;
}
/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::PerceptionObstacle::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::PerceptionObstacle::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::PerceptionObstacle::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::PerceptionObstacle::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::PerceptionObstacle::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::PerceptionObstacle::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::PerceptionObstacle::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::PerceptionObstacle::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::PerceptionObstacle::height()
{
    return m_height;
}

/*!
 * @brief This function copies the value in member polygon_point
 * @param _polygon_point New value to be copied in member polygon_point
 */
void ros2_interface::msg::PerceptionObstacle::polygon_point(
        const std::vector<ros2_interface::msg::Point3D>& _polygon_point)
{
    m_polygon_point = _polygon_point;
}

/*!
 * @brief This function moves the value in member polygon_point
 * @param _polygon_point New value to be moved in member polygon_point
 */
void ros2_interface::msg::PerceptionObstacle::polygon_point(
        std::vector<ros2_interface::msg::Point3D>&& _polygon_point)
{
    m_polygon_point = std::move(_polygon_point);
}

/*!
 * @brief This function returns a constant reference to member polygon_point
 * @return Constant reference to member polygon_point
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::PerceptionObstacle::polygon_point() const
{
    return m_polygon_point;
}

/*!
 * @brief This function returns a reference to member polygon_point
 * @return Reference to member polygon_point
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::PerceptionObstacle::polygon_point()
{
    return m_polygon_point;
}
/*!
 * @brief This function sets a value in member tracking_time
 * @param _tracking_time New value for member tracking_time
 */
void ros2_interface::msg::PerceptionObstacle::tracking_time(
        double _tracking_time)
{
    m_tracking_time = _tracking_time;
}

/*!
 * @brief This function returns the value of member tracking_time
 * @return Value of member tracking_time
 */
double ros2_interface::msg::PerceptionObstacle::tracking_time() const
{
    return m_tracking_time;
}

/*!
 * @brief This function returns a reference to member tracking_time
 * @return Reference to member tracking_time
 */
double& ros2_interface::msg::PerceptionObstacle::tracking_time()
{
    return m_tracking_time;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::PerceptionObstacle::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::PerceptionObstacle::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::PerceptionObstacle::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member lane_position
 * @param _lane_position New value for member lane_position
 */
void ros2_interface::msg::PerceptionObstacle::lane_position(
        int32_t _lane_position)
{
    m_lane_position = _lane_position;
}

/*!
 * @brief This function returns the value of member lane_position
 * @return Value of member lane_position
 */
int32_t ros2_interface::msg::PerceptionObstacle::lane_position() const
{
    return m_lane_position;
}

/*!
 * @brief This function returns a reference to member lane_position
 * @return Reference to member lane_position
 */
int32_t& ros2_interface::msg::PerceptionObstacle::lane_position()
{
    return m_lane_position;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::PerceptionObstacle::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::PerceptionObstacle::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::PerceptionObstacle::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function sets a value in member timestamp
 * @param _timestamp New value for member timestamp
 */
void ros2_interface::msg::PerceptionObstacle::timestamp(
        double _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function returns the value of member timestamp
 * @return Value of member timestamp
 */
double ros2_interface::msg::PerceptionObstacle::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
double& ros2_interface::msg::PerceptionObstacle::timestamp()
{
    return m_timestamp;
}

/*!
 * @brief This function sets a value in member confidence_type
 * @param _confidence_type New value for member confidence_type
 */
void ros2_interface::msg::PerceptionObstacle::confidence_type(
        uint8_t _confidence_type)
{
    m_confidence_type = _confidence_type;
}

/*!
 * @brief This function returns the value of member confidence_type
 * @return Value of member confidence_type
 */
uint8_t ros2_interface::msg::PerceptionObstacle::confidence_type() const
{
    return m_confidence_type;
}

/*!
 * @brief This function returns a reference to member confidence_type
 * @return Reference to member confidence_type
 */
uint8_t& ros2_interface::msg::PerceptionObstacle::confidence_type()
{
    return m_confidence_type;
}

/*!
 * @brief This function copies the value in member drops
 * @param _drops New value to be copied in member drops
 */
void ros2_interface::msg::PerceptionObstacle::drops(
        const ros2_interface::msg::Point3D& _drops)
{
    m_drops = _drops;
}

/*!
 * @brief This function moves the value in member drops
 * @param _drops New value to be moved in member drops
 */
void ros2_interface::msg::PerceptionObstacle::drops(
        ros2_interface::msg::Point3D&& _drops)
{
    m_drops = std::move(_drops);
}

/*!
 * @brief This function returns a constant reference to member drops
 * @return Constant reference to member drops
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::drops() const
{
    return m_drops;
}

/*!
 * @brief This function returns a reference to member drops
 * @return Reference to member drops
 */
ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::drops()
{
    return m_drops;
}
/*!
 * @brief This function copies the value in member acceleration
 * @param _acceleration New value to be copied in member acceleration
 */
void ros2_interface::msg::PerceptionObstacle::acceleration(
        const ros2_interface::msg::Point3D& _acceleration)
{
    m_acceleration = _acceleration;
}

/*!
 * @brief This function moves the value in member acceleration
 * @param _acceleration New value to be moved in member acceleration
 */
void ros2_interface::msg::PerceptionObstacle::acceleration(
        ros2_interface::msg::Point3D&& _acceleration)
{
    m_acceleration = std::move(_acceleration);
}

/*!
 * @brief This function returns a constant reference to member acceleration
 * @return Constant reference to member acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::acceleration() const
{
    return m_acceleration;
}

/*!
 * @brief This function returns a reference to member acceleration
 * @return Reference to member acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::acceleration()
{
    return m_acceleration;
}
/*!
 * @brief This function copies the value in member anchor_point
 * @param _anchor_point New value to be copied in member anchor_point
 */
void ros2_interface::msg::PerceptionObstacle::anchor_point(
        const ros2_interface::msg::Point3D& _anchor_point)
{
    m_anchor_point = _anchor_point;
}

/*!
 * @brief This function moves the value in member anchor_point
 * @param _anchor_point New value to be moved in member anchor_point
 */
void ros2_interface::msg::PerceptionObstacle::anchor_point(
        ros2_interface::msg::Point3D&& _anchor_point)
{
    m_anchor_point = std::move(_anchor_point);
}

/*!
 * @brief This function returns a constant reference to member anchor_point
 * @return Constant reference to member anchor_point
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::anchor_point() const
{
    return m_anchor_point;
}

/*!
 * @brief This function returns a reference to member anchor_point
 * @return Reference to member anchor_point
 */
ros2_interface::msg::Point3D& ros2_interface::msg::PerceptionObstacle::anchor_point()
{
    return m_anchor_point;
}
/*!
 * @brief This function copies the value in member bounding_box
 * @param _bounding_box New value to be copied in member bounding_box
 */
void ros2_interface::msg::PerceptionObstacle::bounding_box(
        const std::vector<ros2_interface::msg::Point3D>& _bounding_box)
{
    m_bounding_box = _bounding_box;
}

/*!
 * @brief This function moves the value in member bounding_box
 * @param _bounding_box New value to be moved in member bounding_box
 */
void ros2_interface::msg::PerceptionObstacle::bounding_box(
        std::vector<ros2_interface::msg::Point3D>&& _bounding_box)
{
    m_bounding_box = std::move(_bounding_box);
}

/*!
 * @brief This function returns a constant reference to member bounding_box
 * @return Constant reference to member bounding_box
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::PerceptionObstacle::bounding_box() const
{
    return m_bounding_box;
}

/*!
 * @brief This function returns a reference to member bounding_box
 * @return Reference to member bounding_box
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::PerceptionObstacle::bounding_box()
{
    return m_bounding_box;
}
/*!
 * @brief This function sets a value in member sub_type
 * @param _sub_type New value for member sub_type
 */
void ros2_interface::msg::PerceptionObstacle::sub_type(
        int32_t _sub_type)
{
    m_sub_type = _sub_type;
}

/*!
 * @brief This function returns the value of member sub_type
 * @return Value of member sub_type
 */
int32_t ros2_interface::msg::PerceptionObstacle::sub_type() const
{
    return m_sub_type;
}

/*!
 * @brief This function returns a reference to member sub_type
 * @return Reference to member sub_type
 */
int32_t& ros2_interface::msg::PerceptionObstacle::sub_type()
{
    return m_sub_type;
}

/*!
 * @brief This function sets a value in member height_above_ground
 * @param _height_above_ground New value for member height_above_ground
 */
void ros2_interface::msg::PerceptionObstacle::height_above_ground(
        double _height_above_ground)
{
    m_height_above_ground = _height_above_ground;
}

/*!
 * @brief This function returns the value of member height_above_ground
 * @return Value of member height_above_ground
 */
double ros2_interface::msg::PerceptionObstacle::height_above_ground() const
{
    return m_height_above_ground;
}

/*!
 * @brief This function returns a reference to member height_above_ground
 * @return Reference to member height_above_ground
 */
double& ros2_interface::msg::PerceptionObstacle::height_above_ground()
{
    return m_height_above_ground;
}

/*!
 * @brief This function copies the value in member position_covariance
 * @param _position_covariance New value to be copied in member position_covariance
 */
void ros2_interface::msg::PerceptionObstacle::position_covariance(
        const std::vector<double>& _position_covariance)
{
    m_position_covariance = _position_covariance;
}

/*!
 * @brief This function moves the value in member position_covariance
 * @param _position_covariance New value to be moved in member position_covariance
 */
void ros2_interface::msg::PerceptionObstacle::position_covariance(
        std::vector<double>&& _position_covariance)
{
    m_position_covariance = std::move(_position_covariance);
}

/*!
 * @brief This function returns a constant reference to member position_covariance
 * @return Constant reference to member position_covariance
 */
const std::vector<double>& ros2_interface::msg::PerceptionObstacle::position_covariance() const
{
    return m_position_covariance;
}

/*!
 * @brief This function returns a reference to member position_covariance
 * @return Reference to member position_covariance
 */
std::vector<double>& ros2_interface::msg::PerceptionObstacle::position_covariance()
{
    return m_position_covariance;
}
/*!
 * @brief This function copies the value in member velocity_covariance
 * @param _velocity_covariance New value to be copied in member velocity_covariance
 */
void ros2_interface::msg::PerceptionObstacle::velocity_covariance(
        const std::vector<double>& _velocity_covariance)
{
    m_velocity_covariance = _velocity_covariance;
}

/*!
 * @brief This function moves the value in member velocity_covariance
 * @param _velocity_covariance New value to be moved in member velocity_covariance
 */
void ros2_interface::msg::PerceptionObstacle::velocity_covariance(
        std::vector<double>&& _velocity_covariance)
{
    m_velocity_covariance = std::move(_velocity_covariance);
}

/*!
 * @brief This function returns a constant reference to member velocity_covariance
 * @return Constant reference to member velocity_covariance
 */
const std::vector<double>& ros2_interface::msg::PerceptionObstacle::velocity_covariance() const
{
    return m_velocity_covariance;
}

/*!
 * @brief This function returns a reference to member velocity_covariance
 * @return Reference to member velocity_covariance
 */
std::vector<double>& ros2_interface::msg::PerceptionObstacle::velocity_covariance()
{
    return m_velocity_covariance;
}
/*!
 * @brief This function copies the value in member acceleration_covariance
 * @param _acceleration_covariance New value to be copied in member acceleration_covariance
 */
void ros2_interface::msg::PerceptionObstacle::acceleration_covariance(
        const std::vector<double>& _acceleration_covariance)
{
    m_acceleration_covariance = _acceleration_covariance;
}

/*!
 * @brief This function moves the value in member acceleration_covariance
 * @param _acceleration_covariance New value to be moved in member acceleration_covariance
 */
void ros2_interface::msg::PerceptionObstacle::acceleration_covariance(
        std::vector<double>&& _acceleration_covariance)
{
    m_acceleration_covariance = std::move(_acceleration_covariance);
}

/*!
 * @brief This function returns a constant reference to member acceleration_covariance
 * @return Constant reference to member acceleration_covariance
 */
const std::vector<double>& ros2_interface::msg::PerceptionObstacle::acceleration_covariance() const
{
    return m_acceleration_covariance;
}

/*!
 * @brief This function returns a reference to member acceleration_covariance
 * @return Reference to member acceleration_covariance
 */
std::vector<double>& ros2_interface::msg::PerceptionObstacle::acceleration_covariance()
{
    return m_acceleration_covariance;
}
/*!
 * @brief This function sets a value in member light_status
 * @param _light_status New value for member light_status
 */
void ros2_interface::msg::PerceptionObstacle::light_status(
        uint8_t _light_status)
{
    m_light_status = _light_status;
}

/*!
 * @brief This function returns the value of member light_status
 * @return Value of member light_status
 */
uint8_t ros2_interface::msg::PerceptionObstacle::light_status() const
{
    return m_light_status;
}

/*!
 * @brief This function returns a reference to member light_status
 * @return Reference to member light_status
 */
uint8_t& ros2_interface::msg::PerceptionObstacle::light_status()
{
    return m_light_status;
}



size_t ros2_interface::msg::PerceptionObstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PerceptionObstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::PerceptionObstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PerceptionObstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



