// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PerceptionObstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PERCEPTIONOBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PERCEPTIONOBSTACLE_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PERCEPTIONOBSTACLE_SOURCE)
#define PERCEPTIONOBSTACLE_DllAPI __declspec( dllexport )
#else
#define PERCEPTIONOBSTACLE_DllAPI __declspec( dllimport )
#endif // PERCEPTIONOBSTACLE_SOURCE
#else
#define PERCEPTIONOBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PERCEPTIONOBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PerceptionObstacle defined by the user in the IDL file.
         * @ingroup PerceptionObstacle
         */
        class PerceptionObstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PerceptionObstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PerceptionObstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PerceptionObstacle that will be copied.
             */
            eProsima_user_DllExport PerceptionObstacle(
                    const PerceptionObstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PerceptionObstacle that will be copied.
             */
            eProsima_user_DllExport PerceptionObstacle(
                    PerceptionObstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PerceptionObstacle that will be copied.
             */
            eProsima_user_DllExport PerceptionObstacle& operator =(
                    const PerceptionObstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PerceptionObstacle that will be copied.
             */
            eProsima_user_DllExport PerceptionObstacle& operator =(
                    PerceptionObstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PerceptionObstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PerceptionObstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PerceptionObstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PerceptionObstacle& x) const;

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::Point3D& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::Point3D&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& position();
            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function copies the value in member velocity
             * @param _velocity New value to be copied in member velocity
             */
            eProsima_user_DllExport void velocity(
                    const ros2_interface::msg::Point3D& _velocity);

            /*!
             * @brief This function moves the value in member velocity
             * @param _velocity New value to be moved in member velocity
             */
            eProsima_user_DllExport void velocity(
                    ros2_interface::msg::Point3D&& _velocity);

            /*!
             * @brief This function returns a constant reference to member velocity
             * @return Constant reference to member velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& velocity() const;

            /*!
             * @brief This function returns a reference to member velocity
             * @return Reference to member velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& velocity();
            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function copies the value in member polygon_point
             * @param _polygon_point New value to be copied in member polygon_point
             */
            eProsima_user_DllExport void polygon_point(
                    const std::vector<ros2_interface::msg::Point3D>& _polygon_point);

            /*!
             * @brief This function moves the value in member polygon_point
             * @param _polygon_point New value to be moved in member polygon_point
             */
            eProsima_user_DllExport void polygon_point(
                    std::vector<ros2_interface::msg::Point3D>&& _polygon_point);

            /*!
             * @brief This function returns a constant reference to member polygon_point
             * @return Constant reference to member polygon_point
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& polygon_point() const;

            /*!
             * @brief This function returns a reference to member polygon_point
             * @return Reference to member polygon_point
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& polygon_point();
            /*!
             * @brief This function sets a value in member tracking_time
             * @param _tracking_time New value for member tracking_time
             */
            eProsima_user_DllExport void tracking_time(
                    double _tracking_time);

            /*!
             * @brief This function returns the value of member tracking_time
             * @return Value of member tracking_time
             */
            eProsima_user_DllExport double tracking_time() const;

            /*!
             * @brief This function returns a reference to member tracking_time
             * @return Reference to member tracking_time
             */
            eProsima_user_DllExport double& tracking_time();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();

            /*!
             * @brief This function sets a value in member lane_position
             * @param _lane_position New value for member lane_position
             */
            eProsima_user_DllExport void lane_position(
                    int32_t _lane_position);

            /*!
             * @brief This function returns the value of member lane_position
             * @return Value of member lane_position
             */
            eProsima_user_DllExport int32_t lane_position() const;

            /*!
             * @brief This function returns a reference to member lane_position
             * @return Reference to member lane_position
             */
            eProsima_user_DllExport int32_t& lane_position();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function sets a value in member timestamp
             * @param _timestamp New value for member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    double _timestamp);

            /*!
             * @brief This function returns the value of member timestamp
             * @return Value of member timestamp
             */
            eProsima_user_DllExport double timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport double& timestamp();

            /*!
             * @brief This function sets a value in member confidence_type
             * @param _confidence_type New value for member confidence_type
             */
            eProsima_user_DllExport void confidence_type(
                    uint8_t _confidence_type);

            /*!
             * @brief This function returns the value of member confidence_type
             * @return Value of member confidence_type
             */
            eProsima_user_DllExport uint8_t confidence_type() const;

            /*!
             * @brief This function returns a reference to member confidence_type
             * @return Reference to member confidence_type
             */
            eProsima_user_DllExport uint8_t& confidence_type();

            /*!
             * @brief This function copies the value in member drops
             * @param _drops New value to be copied in member drops
             */
            eProsima_user_DllExport void drops(
                    const ros2_interface::msg::Point3D& _drops);

            /*!
             * @brief This function moves the value in member drops
             * @param _drops New value to be moved in member drops
             */
            eProsima_user_DllExport void drops(
                    ros2_interface::msg::Point3D&& _drops);

            /*!
             * @brief This function returns a constant reference to member drops
             * @return Constant reference to member drops
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& drops() const;

            /*!
             * @brief This function returns a reference to member drops
             * @return Reference to member drops
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& drops();
            /*!
             * @brief This function copies the value in member acceleration
             * @param _acceleration New value to be copied in member acceleration
             */
            eProsima_user_DllExport void acceleration(
                    const ros2_interface::msg::Point3D& _acceleration);

            /*!
             * @brief This function moves the value in member acceleration
             * @param _acceleration New value to be moved in member acceleration
             */
            eProsima_user_DllExport void acceleration(
                    ros2_interface::msg::Point3D&& _acceleration);

            /*!
             * @brief This function returns a constant reference to member acceleration
             * @return Constant reference to member acceleration
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& acceleration() const;

            /*!
             * @brief This function returns a reference to member acceleration
             * @return Reference to member acceleration
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& acceleration();
            /*!
             * @brief This function copies the value in member anchor_point
             * @param _anchor_point New value to be copied in member anchor_point
             */
            eProsima_user_DllExport void anchor_point(
                    const ros2_interface::msg::Point3D& _anchor_point);

            /*!
             * @brief This function moves the value in member anchor_point
             * @param _anchor_point New value to be moved in member anchor_point
             */
            eProsima_user_DllExport void anchor_point(
                    ros2_interface::msg::Point3D&& _anchor_point);

            /*!
             * @brief This function returns a constant reference to member anchor_point
             * @return Constant reference to member anchor_point
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& anchor_point() const;

            /*!
             * @brief This function returns a reference to member anchor_point
             * @return Reference to member anchor_point
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& anchor_point();
            /*!
             * @brief This function copies the value in member bounding_box
             * @param _bounding_box New value to be copied in member bounding_box
             */
            eProsima_user_DllExport void bounding_box(
                    const std::vector<ros2_interface::msg::Point3D>& _bounding_box);

            /*!
             * @brief This function moves the value in member bounding_box
             * @param _bounding_box New value to be moved in member bounding_box
             */
            eProsima_user_DllExport void bounding_box(
                    std::vector<ros2_interface::msg::Point3D>&& _bounding_box);

            /*!
             * @brief This function returns a constant reference to member bounding_box
             * @return Constant reference to member bounding_box
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& bounding_box() const;

            /*!
             * @brief This function returns a reference to member bounding_box
             * @return Reference to member bounding_box
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& bounding_box();
            /*!
             * @brief This function sets a value in member sub_type
             * @param _sub_type New value for member sub_type
             */
            eProsima_user_DllExport void sub_type(
                    int32_t _sub_type);

            /*!
             * @brief This function returns the value of member sub_type
             * @return Value of member sub_type
             */
            eProsima_user_DllExport int32_t sub_type() const;

            /*!
             * @brief This function returns a reference to member sub_type
             * @return Reference to member sub_type
             */
            eProsima_user_DllExport int32_t& sub_type();

            /*!
             * @brief This function sets a value in member height_above_ground
             * @param _height_above_ground New value for member height_above_ground
             */
            eProsima_user_DllExport void height_above_ground(
                    double _height_above_ground);

            /*!
             * @brief This function returns the value of member height_above_ground
             * @return Value of member height_above_ground
             */
            eProsima_user_DllExport double height_above_ground() const;

            /*!
             * @brief This function returns a reference to member height_above_ground
             * @return Reference to member height_above_ground
             */
            eProsima_user_DllExport double& height_above_ground();

            /*!
             * @brief This function copies the value in member position_covariance
             * @param _position_covariance New value to be copied in member position_covariance
             */
            eProsima_user_DllExport void position_covariance(
                    const std::vector<double>& _position_covariance);

            /*!
             * @brief This function moves the value in member position_covariance
             * @param _position_covariance New value to be moved in member position_covariance
             */
            eProsima_user_DllExport void position_covariance(
                    std::vector<double>&& _position_covariance);

            /*!
             * @brief This function returns a constant reference to member position_covariance
             * @return Constant reference to member position_covariance
             */
            eProsima_user_DllExport const std::vector<double>& position_covariance() const;

            /*!
             * @brief This function returns a reference to member position_covariance
             * @return Reference to member position_covariance
             */
            eProsima_user_DllExport std::vector<double>& position_covariance();
            /*!
             * @brief This function copies the value in member velocity_covariance
             * @param _velocity_covariance New value to be copied in member velocity_covariance
             */
            eProsima_user_DllExport void velocity_covariance(
                    const std::vector<double>& _velocity_covariance);

            /*!
             * @brief This function moves the value in member velocity_covariance
             * @param _velocity_covariance New value to be moved in member velocity_covariance
             */
            eProsima_user_DllExport void velocity_covariance(
                    std::vector<double>&& _velocity_covariance);

            /*!
             * @brief This function returns a constant reference to member velocity_covariance
             * @return Constant reference to member velocity_covariance
             */
            eProsima_user_DllExport const std::vector<double>& velocity_covariance() const;

            /*!
             * @brief This function returns a reference to member velocity_covariance
             * @return Reference to member velocity_covariance
             */
            eProsima_user_DllExport std::vector<double>& velocity_covariance();
            /*!
             * @brief This function copies the value in member acceleration_covariance
             * @param _acceleration_covariance New value to be copied in member acceleration_covariance
             */
            eProsima_user_DllExport void acceleration_covariance(
                    const std::vector<double>& _acceleration_covariance);

            /*!
             * @brief This function moves the value in member acceleration_covariance
             * @param _acceleration_covariance New value to be moved in member acceleration_covariance
             */
            eProsima_user_DllExport void acceleration_covariance(
                    std::vector<double>&& _acceleration_covariance);

            /*!
             * @brief This function returns a constant reference to member acceleration_covariance
             * @return Constant reference to member acceleration_covariance
             */
            eProsima_user_DllExport const std::vector<double>& acceleration_covariance() const;

            /*!
             * @brief This function returns a reference to member acceleration_covariance
             * @return Reference to member acceleration_covariance
             */
            eProsima_user_DllExport std::vector<double>& acceleration_covariance();
            /*!
             * @brief This function sets a value in member light_status
             * @param _light_status New value for member light_status
             */
            eProsima_user_DllExport void light_status(
                    uint8_t _light_status);

            /*!
             * @brief This function returns the value of member light_status
             * @return Value of member light_status
             */
            eProsima_user_DllExport uint8_t light_status() const;

            /*!
             * @brief This function returns a reference to member light_status
             * @return Reference to member light_status
             */
            eProsima_user_DllExport uint8_t& light_status();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PerceptionObstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_id;
            ros2_interface::msg::Point3D m_position;
            double m_theta;
            ros2_interface::msg::Point3D m_velocity;
            double m_length;
            double m_width;
            double m_height;
            std::vector<ros2_interface::msg::Point3D> m_polygon_point;
            double m_tracking_time;
            int32_t m_type;
            int32_t m_lane_position;
            double m_confidence;
            double m_timestamp;
            uint8_t m_confidence_type;
            ros2_interface::msg::Point3D m_drops;
            ros2_interface::msg::Point3D m_acceleration;
            ros2_interface::msg::Point3D m_anchor_point;
            std::vector<ros2_interface::msg::Point3D> m_bounding_box;
            int32_t m_sub_type;
            double m_height_above_ground;
            std::vector<double> m_position_covariance;
            std::vector<double> m_velocity_covariance;
            std::vector<double> m_acceleration_covariance;
            uint8_t m_light_status;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PERCEPTIONOBSTACLE_H_

