// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PerceptionObstacleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PerceptionObstacle.h"
#include "PerceptionObstacleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPerceptionObstacleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(true),
                        ros2_interface::msg::GetPerceptionObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(false),
                        ros2_interface::msg::GetPerceptionObstacleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPerceptionObstacleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PerceptionObstacle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPerceptionObstacleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PerceptionObstacle", complete);
        }

        const TypeObject* GetPerceptionObstacleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PerceptionObstacle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePerceptionObstacleObject();
            }
            //else
            return GetMinimalPerceptionObstacleObject();
        }

        const TypeObject* GetMinimalPerceptionObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PerceptionObstacle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_velocity;
            mst_velocity.common().member_id(memberId++);
            mst_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity.common().member_flags().IS_KEY(false);
            mst_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 velocity_hash("velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity.detail().name_hash()[i] = velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_polygon_point;
            mst_polygon_point.common().member_id(memberId++);
            mst_polygon_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_polygon_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_polygon_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_polygon_point.common().member_flags().IS_OPTIONAL(false);
            mst_polygon_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_polygon_point.common().member_flags().IS_KEY(false);
            mst_polygon_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_polygon_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 polygon_point_hash("polygon_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_polygon_point.detail().name_hash()[i] = polygon_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_polygon_point);

            MinimalStructMember mst_tracking_time;
            mst_tracking_time.common().member_id(memberId++);
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            mst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tracking_time.common().member_flags().IS_KEY(false);
            mst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tracking_time_hash("tracking_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_tracking_time.detail().name_hash()[i] = tracking_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tracking_time);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_lane_position;
            mst_lane_position.common().member_id(memberId++);
            mst_lane_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_position.common().member_flags().IS_OPTIONAL(false);
            mst_lane_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_position.common().member_flags().IS_KEY(false);
            mst_lane_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_position.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lane_position_hash("lane_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_position.detail().name_hash()[i] = lane_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_position);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_confidence_type;
            mst_confidence_type.common().member_id(memberId++);
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            mst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence_type.common().member_flags().IS_KEY(false);
            mst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 confidence_type_hash("confidence_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence_type.detail().name_hash()[i] = confidence_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence_type);

            MinimalStructMember mst_drops;
            mst_drops.common().member_id(memberId++);
            mst_drops.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_drops.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_drops.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_drops.common().member_flags().IS_OPTIONAL(false);
            mst_drops.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_drops.common().member_flags().IS_KEY(false);
            mst_drops.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_drops.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 drops_hash("drops");
            for(int i = 0; i < 4; ++i)
            {
                mst_drops.detail().name_hash()[i] = drops_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_drops);

            MinimalStructMember mst_acceleration;
            mst_acceleration.common().member_id(memberId++);
            mst_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration.common().member_flags().IS_KEY(false);
            mst_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 acceleration_hash("acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration.detail().name_hash()[i] = acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration);

            MinimalStructMember mst_anchor_point;
            mst_anchor_point.common().member_id(memberId++);
            mst_anchor_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_anchor_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_anchor_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_anchor_point.common().member_flags().IS_OPTIONAL(false);
            mst_anchor_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_anchor_point.common().member_flags().IS_KEY(false);
            mst_anchor_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_anchor_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 anchor_point_hash("anchor_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_anchor_point.detail().name_hash()[i] = anchor_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_anchor_point);

            MinimalStructMember mst_bounding_box;
            mst_bounding_box.common().member_id(memberId++);
            mst_bounding_box.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_bounding_box.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_bounding_box.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_bounding_box.common().member_flags().IS_OPTIONAL(false);
            mst_bounding_box.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_bounding_box.common().member_flags().IS_KEY(false);
            mst_bounding_box.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_bounding_box.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 bounding_box_hash("bounding_box");
            for(int i = 0; i < 4; ++i)
            {
                mst_bounding_box.detail().name_hash()[i] = bounding_box_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_bounding_box);

            MinimalStructMember mst_sub_type;
            mst_sub_type.common().member_id(memberId++);
            mst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sub_type.common().member_flags().IS_OPTIONAL(false);
            mst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sub_type.common().member_flags().IS_KEY(false);
            mst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sub_type_hash("sub_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_sub_type.detail().name_hash()[i] = sub_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sub_type);

            MinimalStructMember mst_height_above_ground;
            mst_height_above_ground.common().member_id(memberId++);
            mst_height_above_ground.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height_above_ground.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height_above_ground.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height_above_ground.common().member_flags().IS_OPTIONAL(false);
            mst_height_above_ground.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height_above_ground.common().member_flags().IS_KEY(false);
            mst_height_above_ground.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height_above_ground.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_above_ground_hash("height_above_ground");
            for(int i = 0; i < 4; ++i)
            {
                mst_height_above_ground.detail().name_hash()[i] = height_above_ground_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height_above_ground);

            MinimalStructMember mst_position_covariance;
            mst_position_covariance.common().member_id(memberId++);
            mst_position_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_position_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_covariance.common().member_flags().IS_KEY(false);
            mst_position_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 position_covariance_hash("position_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_covariance.detail().name_hash()[i] = position_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_covariance);

            MinimalStructMember mst_velocity_covariance;
            mst_velocity_covariance.common().member_id(memberId++);
            mst_velocity_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_velocity_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_velocity_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_velocity_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_velocity_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_velocity_covariance.common().member_flags().IS_KEY(false);
            mst_velocity_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_velocity_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 velocity_covariance_hash("velocity_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_velocity_covariance.detail().name_hash()[i] = velocity_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_velocity_covariance);

            MinimalStructMember mst_acceleration_covariance;
            mst_acceleration_covariance.common().member_id(memberId++);
            mst_acceleration_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_covariance.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_covariance.common().member_flags().IS_KEY(false);
            mst_acceleration_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 acceleration_covariance_hash("acceleration_covariance");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_covariance.detail().name_hash()[i] = acceleration_covariance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_covariance);

            MinimalStructMember mst_light_status;
            mst_light_status.common().member_id(memberId++);
            mst_light_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_light_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_light_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_light_status.common().member_flags().IS_OPTIONAL(false);
            mst_light_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_light_status.common().member_flags().IS_KEY(false);
            mst_light_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_light_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 light_status_hash("light_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_light_status.detail().name_hash()[i] = light_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_light_status);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PerceptionObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PerceptionObstacle", false);
        }

        const TypeObject* GetCompletePerceptionObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PerceptionObstacle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_velocity;
            cst_velocity.common().member_id(memberId++);
            cst_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity.common().member_flags().IS_KEY(false);
            cst_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_velocity.detail().name("velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_polygon_point;
            cst_polygon_point.common().member_id(memberId++);
            cst_polygon_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_polygon_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_polygon_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_polygon_point.common().member_flags().IS_OPTIONAL(false);
            cst_polygon_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_polygon_point.common().member_flags().IS_KEY(false);
            cst_polygon_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_polygon_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_polygon_point.detail().name("polygon_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_polygon_point);

            CompleteStructMember cst_tracking_time;
            cst_tracking_time.common().member_id(memberId++);
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            cst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tracking_time.common().member_flags().IS_KEY(false);
            cst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tracking_time.detail().name("tracking_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tracking_time);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_lane_position;
            cst_lane_position.common().member_id(memberId++);
            cst_lane_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_position.common().member_flags().IS_OPTIONAL(false);
            cst_lane_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_position.common().member_flags().IS_KEY(false);
            cst_lane_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_position.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lane_position.detail().name("lane_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_position);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_confidence_type;
            cst_confidence_type.common().member_id(memberId++);
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence_type.common().member_flags().IS_OPTIONAL(false);
            cst_confidence_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence_type.common().member_flags().IS_KEY(false);
            cst_confidence_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_confidence_type.detail().name("confidence_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence_type);

            CompleteStructMember cst_drops;
            cst_drops.common().member_id(memberId++);
            cst_drops.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_drops.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_drops.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_drops.common().member_flags().IS_OPTIONAL(false);
            cst_drops.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_drops.common().member_flags().IS_KEY(false);
            cst_drops.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_drops.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_drops.detail().name("drops");

            type_object->complete().struct_type().member_seq().emplace_back(cst_drops);

            CompleteStructMember cst_acceleration;
            cst_acceleration.common().member_id(memberId++);
            cst_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration.common().member_flags().IS_KEY(false);
            cst_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_acceleration.detail().name("acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration);

            CompleteStructMember cst_anchor_point;
            cst_anchor_point.common().member_id(memberId++);
            cst_anchor_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_anchor_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_anchor_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_anchor_point.common().member_flags().IS_OPTIONAL(false);
            cst_anchor_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_anchor_point.common().member_flags().IS_KEY(false);
            cst_anchor_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_anchor_point.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_anchor_point.detail().name("anchor_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_anchor_point);

            CompleteStructMember cst_bounding_box;
            cst_bounding_box.common().member_id(memberId++);
            cst_bounding_box.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_bounding_box.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_bounding_box.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_bounding_box.common().member_flags().IS_OPTIONAL(false);
            cst_bounding_box.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_bounding_box.common().member_flags().IS_KEY(false);
            cst_bounding_box.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_bounding_box.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_bounding_box.detail().name("bounding_box");

            type_object->complete().struct_type().member_seq().emplace_back(cst_bounding_box);

            CompleteStructMember cst_sub_type;
            cst_sub_type.common().member_id(memberId++);
            cst_sub_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sub_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sub_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sub_type.common().member_flags().IS_OPTIONAL(false);
            cst_sub_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sub_type.common().member_flags().IS_KEY(false);
            cst_sub_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sub_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sub_type.detail().name("sub_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sub_type);

            CompleteStructMember cst_height_above_ground;
            cst_height_above_ground.common().member_id(memberId++);
            cst_height_above_ground.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height_above_ground.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height_above_ground.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height_above_ground.common().member_flags().IS_OPTIONAL(false);
            cst_height_above_ground.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height_above_ground.common().member_flags().IS_KEY(false);
            cst_height_above_ground.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height_above_ground.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height_above_ground.detail().name("height_above_ground");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height_above_ground);

            CompleteStructMember cst_position_covariance;
            cst_position_covariance.common().member_id(memberId++);
            cst_position_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_position_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_covariance.common().member_flags().IS_KEY(false);
            cst_position_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_position_covariance.detail().name("position_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_covariance);

            CompleteStructMember cst_velocity_covariance;
            cst_velocity_covariance.common().member_id(memberId++);
            cst_velocity_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_velocity_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_velocity_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_velocity_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_velocity_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_velocity_covariance.common().member_flags().IS_KEY(false);
            cst_velocity_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_velocity_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_velocity_covariance.detail().name("velocity_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_velocity_covariance);

            CompleteStructMember cst_acceleration_covariance;
            cst_acceleration_covariance.common().member_id(memberId++);
            cst_acceleration_covariance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_covariance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_covariance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_covariance.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_covariance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_covariance.common().member_flags().IS_KEY(false);
            cst_acceleration_covariance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_covariance.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_acceleration_covariance.detail().name("acceleration_covariance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_covariance);

            CompleteStructMember cst_light_status;
            cst_light_status.common().member_id(memberId++);
            cst_light_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_light_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_light_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_light_status.common().member_flags().IS_OPTIONAL(false);
            cst_light_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_light_status.common().member_flags().IS_KEY(false);
            cst_light_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_light_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_light_status.detail().name("light_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_light_status);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PerceptionObstacle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PerceptionObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PerceptionObstacle", true);
        }

    } // namespace msg
} // namespace ros2_interface