// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningAnalysis.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PlanningAnalysis.h"
#include "PlanningAnalysisTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Polygon2D_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_TimeConsume_max_cdr_typesize 272ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_PlanningParkingDebug_max_cdr_typesize 2130036ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_PlanningAnalysis_max_cdr_typesize 2157560ULL;
#define ros2_interface_msg_Trajectory_max_cdr_typesize 15460ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_Point2dList_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TimeConsume_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PlanningParkingDebug_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PlanningAnalysis_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Trajectory_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point2dList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PlanningAnalysis::PlanningAnalysis()
{
    // ros2_interface::msg::Header m_header

    // double m_frame_update_time
    m_frame_update_time = 0.0;
    // double m_generator_time
    m_generator_time = 0.0;
    // sequence<ros2_interface::msg::TimeConsume> m_evaluator_time

    // double m_selector_time
    m_selector_time = 0.0;
    // ros2_interface::msg::PlanningParkingDebug m_planning_parking_debug

    // double m_dis_to_center_line
    m_dis_to_center_line = 0.0;
    // double m_diff_to_velocity
    m_diff_to_velocity = 0.0;
    // double m_referencline_kappa
    m_referencline_kappa = 0.0;

    // Just to register all known types
    registerPlanningAnalysisTypes();
}

ros2_interface::msg::PlanningAnalysis::~PlanningAnalysis()
{









}

ros2_interface::msg::PlanningAnalysis::PlanningAnalysis(
        const PlanningAnalysis& x)
{
    m_header = x.m_header;
    m_frame_update_time = x.m_frame_update_time;
    m_generator_time = x.m_generator_time;
    m_evaluator_time = x.m_evaluator_time;
    m_selector_time = x.m_selector_time;
    m_planning_parking_debug = x.m_planning_parking_debug;
    m_dis_to_center_line = x.m_dis_to_center_line;
    m_diff_to_velocity = x.m_diff_to_velocity;
    m_referencline_kappa = x.m_referencline_kappa;
}

ros2_interface::msg::PlanningAnalysis::PlanningAnalysis(
        PlanningAnalysis&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_frame_update_time = x.m_frame_update_time;
    m_generator_time = x.m_generator_time;
    m_evaluator_time = std::move(x.m_evaluator_time);
    m_selector_time = x.m_selector_time;
    m_planning_parking_debug = std::move(x.m_planning_parking_debug);
    m_dis_to_center_line = x.m_dis_to_center_line;
    m_diff_to_velocity = x.m_diff_to_velocity;
    m_referencline_kappa = x.m_referencline_kappa;
}

ros2_interface::msg::PlanningAnalysis& ros2_interface::msg::PlanningAnalysis::operator =(
        const PlanningAnalysis& x)
{

    m_header = x.m_header;
    m_frame_update_time = x.m_frame_update_time;
    m_generator_time = x.m_generator_time;
    m_evaluator_time = x.m_evaluator_time;
    m_selector_time = x.m_selector_time;
    m_planning_parking_debug = x.m_planning_parking_debug;
    m_dis_to_center_line = x.m_dis_to_center_line;
    m_diff_to_velocity = x.m_diff_to_velocity;
    m_referencline_kappa = x.m_referencline_kappa;

    return *this;
}

ros2_interface::msg::PlanningAnalysis& ros2_interface::msg::PlanningAnalysis::operator =(
        PlanningAnalysis&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_frame_update_time = x.m_frame_update_time;
    m_generator_time = x.m_generator_time;
    m_evaluator_time = std::move(x.m_evaluator_time);
    m_selector_time = x.m_selector_time;
    m_planning_parking_debug = std::move(x.m_planning_parking_debug);
    m_dis_to_center_line = x.m_dis_to_center_line;
    m_diff_to_velocity = x.m_diff_to_velocity;
    m_referencline_kappa = x.m_referencline_kappa;

    return *this;
}

bool ros2_interface::msg::PlanningAnalysis::operator ==(
        const PlanningAnalysis& x) const
{

    return (m_header == x.m_header && m_frame_update_time == x.m_frame_update_time && m_generator_time == x.m_generator_time && m_evaluator_time == x.m_evaluator_time && m_selector_time == x.m_selector_time && m_planning_parking_debug == x.m_planning_parking_debug && m_dis_to_center_line == x.m_dis_to_center_line && m_diff_to_velocity == x.m_diff_to_velocity && m_referencline_kappa == x.m_referencline_kappa);
}

bool ros2_interface::msg::PlanningAnalysis::operator !=(
        const PlanningAnalysis& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PlanningAnalysis::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningAnalysis_max_cdr_typesize;
}

size_t ros2_interface::msg::PlanningAnalysis::getCdrSerializedSize(
        const ros2_interface::msg::PlanningAnalysis& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.evaluator_time().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TimeConsume::getCdrSerializedSize(data.evaluator_time().at(a), current_alignment);}

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::PlanningParkingDebug::getCdrSerializedSize(data.planning_parking_debug(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PlanningAnalysis::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_frame_update_time;
    scdr << m_generator_time;
    scdr << m_evaluator_time;
    scdr << m_selector_time;
    scdr << m_planning_parking_debug;
    scdr << m_dis_to_center_line;
    scdr << m_diff_to_velocity;
    scdr << m_referencline_kappa;

}

void ros2_interface::msg::PlanningAnalysis::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_frame_update_time;
    dcdr >> m_generator_time;
    dcdr >> m_evaluator_time;
    dcdr >> m_selector_time;
    dcdr >> m_planning_parking_debug;
    dcdr >> m_dis_to_center_line;
    dcdr >> m_diff_to_velocity;
    dcdr >> m_referencline_kappa;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::PlanningAnalysis::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::PlanningAnalysis::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::PlanningAnalysis::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::PlanningAnalysis::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member frame_update_time
 * @param _frame_update_time New value for member frame_update_time
 */
void ros2_interface::msg::PlanningAnalysis::frame_update_time(
        double _frame_update_time)
{
    m_frame_update_time = _frame_update_time;
}

/*!
 * @brief This function returns the value of member frame_update_time
 * @return Value of member frame_update_time
 */
double ros2_interface::msg::PlanningAnalysis::frame_update_time() const
{
    return m_frame_update_time;
}

/*!
 * @brief This function returns a reference to member frame_update_time
 * @return Reference to member frame_update_time
 */
double& ros2_interface::msg::PlanningAnalysis::frame_update_time()
{
    return m_frame_update_time;
}

/*!
 * @brief This function sets a value in member generator_time
 * @param _generator_time New value for member generator_time
 */
void ros2_interface::msg::PlanningAnalysis::generator_time(
        double _generator_time)
{
    m_generator_time = _generator_time;
}

/*!
 * @brief This function returns the value of member generator_time
 * @return Value of member generator_time
 */
double ros2_interface::msg::PlanningAnalysis::generator_time() const
{
    return m_generator_time;
}

/*!
 * @brief This function returns a reference to member generator_time
 * @return Reference to member generator_time
 */
double& ros2_interface::msg::PlanningAnalysis::generator_time()
{
    return m_generator_time;
}

/*!
 * @brief This function copies the value in member evaluator_time
 * @param _evaluator_time New value to be copied in member evaluator_time
 */
void ros2_interface::msg::PlanningAnalysis::evaluator_time(
        const std::vector<ros2_interface::msg::TimeConsume>& _evaluator_time)
{
    m_evaluator_time = _evaluator_time;
}

/*!
 * @brief This function moves the value in member evaluator_time
 * @param _evaluator_time New value to be moved in member evaluator_time
 */
void ros2_interface::msg::PlanningAnalysis::evaluator_time(
        std::vector<ros2_interface::msg::TimeConsume>&& _evaluator_time)
{
    m_evaluator_time = std::move(_evaluator_time);
}

/*!
 * @brief This function returns a constant reference to member evaluator_time
 * @return Constant reference to member evaluator_time
 */
const std::vector<ros2_interface::msg::TimeConsume>& ros2_interface::msg::PlanningAnalysis::evaluator_time() const
{
    return m_evaluator_time;
}

/*!
 * @brief This function returns a reference to member evaluator_time
 * @return Reference to member evaluator_time
 */
std::vector<ros2_interface::msg::TimeConsume>& ros2_interface::msg::PlanningAnalysis::evaluator_time()
{
    return m_evaluator_time;
}
/*!
 * @brief This function sets a value in member selector_time
 * @param _selector_time New value for member selector_time
 */
void ros2_interface::msg::PlanningAnalysis::selector_time(
        double _selector_time)
{
    m_selector_time = _selector_time;
}

/*!
 * @brief This function returns the value of member selector_time
 * @return Value of member selector_time
 */
double ros2_interface::msg::PlanningAnalysis::selector_time() const
{
    return m_selector_time;
}

/*!
 * @brief This function returns a reference to member selector_time
 * @return Reference to member selector_time
 */
double& ros2_interface::msg::PlanningAnalysis::selector_time()
{
    return m_selector_time;
}

/*!
 * @brief This function copies the value in member planning_parking_debug
 * @param _planning_parking_debug New value to be copied in member planning_parking_debug
 */
void ros2_interface::msg::PlanningAnalysis::planning_parking_debug(
        const ros2_interface::msg::PlanningParkingDebug& _planning_parking_debug)
{
    m_planning_parking_debug = _planning_parking_debug;
}

/*!
 * @brief This function moves the value in member planning_parking_debug
 * @param _planning_parking_debug New value to be moved in member planning_parking_debug
 */
void ros2_interface::msg::PlanningAnalysis::planning_parking_debug(
        ros2_interface::msg::PlanningParkingDebug&& _planning_parking_debug)
{
    m_planning_parking_debug = std::move(_planning_parking_debug);
}

/*!
 * @brief This function returns a constant reference to member planning_parking_debug
 * @return Constant reference to member planning_parking_debug
 */
const ros2_interface::msg::PlanningParkingDebug& ros2_interface::msg::PlanningAnalysis::planning_parking_debug() const
{
    return m_planning_parking_debug;
}

/*!
 * @brief This function returns a reference to member planning_parking_debug
 * @return Reference to member planning_parking_debug
 */
ros2_interface::msg::PlanningParkingDebug& ros2_interface::msg::PlanningAnalysis::planning_parking_debug()
{
    return m_planning_parking_debug;
}
/*!
 * @brief This function sets a value in member dis_to_center_line
 * @param _dis_to_center_line New value for member dis_to_center_line
 */
void ros2_interface::msg::PlanningAnalysis::dis_to_center_line(
        double _dis_to_center_line)
{
    m_dis_to_center_line = _dis_to_center_line;
}

/*!
 * @brief This function returns the value of member dis_to_center_line
 * @return Value of member dis_to_center_line
 */
double ros2_interface::msg::PlanningAnalysis::dis_to_center_line() const
{
    return m_dis_to_center_line;
}

/*!
 * @brief This function returns a reference to member dis_to_center_line
 * @return Reference to member dis_to_center_line
 */
double& ros2_interface::msg::PlanningAnalysis::dis_to_center_line()
{
    return m_dis_to_center_line;
}

/*!
 * @brief This function sets a value in member diff_to_velocity
 * @param _diff_to_velocity New value for member diff_to_velocity
 */
void ros2_interface::msg::PlanningAnalysis::diff_to_velocity(
        double _diff_to_velocity)
{
    m_diff_to_velocity = _diff_to_velocity;
}

/*!
 * @brief This function returns the value of member diff_to_velocity
 * @return Value of member diff_to_velocity
 */
double ros2_interface::msg::PlanningAnalysis::diff_to_velocity() const
{
    return m_diff_to_velocity;
}

/*!
 * @brief This function returns a reference to member diff_to_velocity
 * @return Reference to member diff_to_velocity
 */
double& ros2_interface::msg::PlanningAnalysis::diff_to_velocity()
{
    return m_diff_to_velocity;
}

/*!
 * @brief This function sets a value in member referencline_kappa
 * @param _referencline_kappa New value for member referencline_kappa
 */
void ros2_interface::msg::PlanningAnalysis::referencline_kappa(
        double _referencline_kappa)
{
    m_referencline_kappa = _referencline_kappa;
}

/*!
 * @brief This function returns the value of member referencline_kappa
 * @return Value of member referencline_kappa
 */
double ros2_interface::msg::PlanningAnalysis::referencline_kappa() const
{
    return m_referencline_kappa;
}

/*!
 * @brief This function returns a reference to member referencline_kappa
 * @return Reference to member referencline_kappa
 */
double& ros2_interface::msg::PlanningAnalysis::referencline_kappa()
{
    return m_referencline_kappa;
}



size_t ros2_interface::msg::PlanningAnalysis::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningAnalysis_max_key_cdr_typesize;
}

bool ros2_interface::msg::PlanningAnalysis::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PlanningAnalysis::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



