// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningAnalysis.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGANALYSIS_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGANALYSIS_H_

#include "PlanningParkingDebug.h"
#include "Header.h"
#include "TimeConsume.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PLANNINGANALYSIS_SOURCE)
#define PLANNINGANALYSIS_DllAPI __declspec( dllexport )
#else
#define PLANNINGANALYSIS_DllAPI __declspec( dllimport )
#endif // PLANNINGANALYSIS_SOURCE
#else
#define PLANNINGANALYSIS_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PLANNINGANALYSIS_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PlanningAnalysis defined by the user in the IDL file.
         * @ingroup PlanningAnalysis
         */
        class PlanningAnalysis
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PlanningAnalysis();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PlanningAnalysis();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PlanningAnalysis that will be copied.
             */
            eProsima_user_DllExport PlanningAnalysis(
                    const PlanningAnalysis& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PlanningAnalysis that will be copied.
             */
            eProsima_user_DllExport PlanningAnalysis(
                    PlanningAnalysis&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PlanningAnalysis that will be copied.
             */
            eProsima_user_DllExport PlanningAnalysis& operator =(
                    const PlanningAnalysis& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PlanningAnalysis that will be copied.
             */
            eProsima_user_DllExport PlanningAnalysis& operator =(
                    PlanningAnalysis&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PlanningAnalysis object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PlanningAnalysis& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PlanningAnalysis object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PlanningAnalysis& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member frame_update_time
             * @param _frame_update_time New value for member frame_update_time
             */
            eProsima_user_DllExport void frame_update_time(
                    double _frame_update_time);

            /*!
             * @brief This function returns the value of member frame_update_time
             * @return Value of member frame_update_time
             */
            eProsima_user_DllExport double frame_update_time() const;

            /*!
             * @brief This function returns a reference to member frame_update_time
             * @return Reference to member frame_update_time
             */
            eProsima_user_DllExport double& frame_update_time();

            /*!
             * @brief This function sets a value in member generator_time
             * @param _generator_time New value for member generator_time
             */
            eProsima_user_DllExport void generator_time(
                    double _generator_time);

            /*!
             * @brief This function returns the value of member generator_time
             * @return Value of member generator_time
             */
            eProsima_user_DllExport double generator_time() const;

            /*!
             * @brief This function returns a reference to member generator_time
             * @return Reference to member generator_time
             */
            eProsima_user_DllExport double& generator_time();

            /*!
             * @brief This function copies the value in member evaluator_time
             * @param _evaluator_time New value to be copied in member evaluator_time
             */
            eProsima_user_DllExport void evaluator_time(
                    const std::vector<ros2_interface::msg::TimeConsume>& _evaluator_time);

            /*!
             * @brief This function moves the value in member evaluator_time
             * @param _evaluator_time New value to be moved in member evaluator_time
             */
            eProsima_user_DllExport void evaluator_time(
                    std::vector<ros2_interface::msg::TimeConsume>&& _evaluator_time);

            /*!
             * @brief This function returns a constant reference to member evaluator_time
             * @return Constant reference to member evaluator_time
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TimeConsume>& evaluator_time() const;

            /*!
             * @brief This function returns a reference to member evaluator_time
             * @return Reference to member evaluator_time
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TimeConsume>& evaluator_time();
            /*!
             * @brief This function sets a value in member selector_time
             * @param _selector_time New value for member selector_time
             */
            eProsima_user_DllExport void selector_time(
                    double _selector_time);

            /*!
             * @brief This function returns the value of member selector_time
             * @return Value of member selector_time
             */
            eProsima_user_DllExport double selector_time() const;

            /*!
             * @brief This function returns a reference to member selector_time
             * @return Reference to member selector_time
             */
            eProsima_user_DllExport double& selector_time();

            /*!
             * @brief This function copies the value in member planning_parking_debug
             * @param _planning_parking_debug New value to be copied in member planning_parking_debug
             */
            eProsima_user_DllExport void planning_parking_debug(
                    const ros2_interface::msg::PlanningParkingDebug& _planning_parking_debug);

            /*!
             * @brief This function moves the value in member planning_parking_debug
             * @param _planning_parking_debug New value to be moved in member planning_parking_debug
             */
            eProsima_user_DllExport void planning_parking_debug(
                    ros2_interface::msg::PlanningParkingDebug&& _planning_parking_debug);

            /*!
             * @brief This function returns a constant reference to member planning_parking_debug
             * @return Constant reference to member planning_parking_debug
             */
            eProsima_user_DllExport const ros2_interface::msg::PlanningParkingDebug& planning_parking_debug() const;

            /*!
             * @brief This function returns a reference to member planning_parking_debug
             * @return Reference to member planning_parking_debug
             */
            eProsima_user_DllExport ros2_interface::msg::PlanningParkingDebug& planning_parking_debug();
            /*!
             * @brief This function sets a value in member dis_to_center_line
             * @param _dis_to_center_line New value for member dis_to_center_line
             */
            eProsima_user_DllExport void dis_to_center_line(
                    double _dis_to_center_line);

            /*!
             * @brief This function returns the value of member dis_to_center_line
             * @return Value of member dis_to_center_line
             */
            eProsima_user_DllExport double dis_to_center_line() const;

            /*!
             * @brief This function returns a reference to member dis_to_center_line
             * @return Reference to member dis_to_center_line
             */
            eProsima_user_DllExport double& dis_to_center_line();

            /*!
             * @brief This function sets a value in member diff_to_velocity
             * @param _diff_to_velocity New value for member diff_to_velocity
             */
            eProsima_user_DllExport void diff_to_velocity(
                    double _diff_to_velocity);

            /*!
             * @brief This function returns the value of member diff_to_velocity
             * @return Value of member diff_to_velocity
             */
            eProsima_user_DllExport double diff_to_velocity() const;

            /*!
             * @brief This function returns a reference to member diff_to_velocity
             * @return Reference to member diff_to_velocity
             */
            eProsima_user_DllExport double& diff_to_velocity();

            /*!
             * @brief This function sets a value in member referencline_kappa
             * @param _referencline_kappa New value for member referencline_kappa
             */
            eProsima_user_DllExport void referencline_kappa(
                    double _referencline_kappa);

            /*!
             * @brief This function returns the value of member referencline_kappa
             * @return Value of member referencline_kappa
             */
            eProsima_user_DllExport double referencline_kappa() const;

            /*!
             * @brief This function returns a reference to member referencline_kappa
             * @return Reference to member referencline_kappa
             */
            eProsima_user_DllExport double& referencline_kappa();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PlanningAnalysis& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            double m_frame_update_time;
            double m_generator_time;
            std::vector<ros2_interface::msg::TimeConsume> m_evaluator_time;
            double m_selector_time;
            ros2_interface::msg::PlanningParkingDebug m_planning_parking_debug;
            double m_dis_to_center_line;
            double m_diff_to_velocity;
            double m_referencline_kappa;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGANALYSIS_H_

