// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningAnalysisTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PlanningAnalysis.h"
#include "PlanningAnalysisTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPlanningAnalysisTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::TimeConsume", ros2_interface::msg::GetTimeConsumeIdentifier(true),
                        ros2_interface::msg::GetTimeConsumeObject(true));
                factory->add_type_object("ros2_interface::msg::TimeConsume", ros2_interface::msg::GetTimeConsumeIdentifier(false),
                        ros2_interface::msg::GetTimeConsumeObject(false));



                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(true),
                        ros2_interface::msg::GetPolygon2DObject(true));
                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(false),
                        ros2_interface::msg::GetPolygon2DObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::Trajectory", ros2_interface::msg::GetTrajectoryIdentifier(true),
                        ros2_interface::msg::GetTrajectoryObject(true));
                factory->add_type_object("ros2_interface::msg::Trajectory", ros2_interface::msg::GetTrajectoryIdentifier(false),
                        ros2_interface::msg::GetTrajectoryObject(false));



                factory->add_type_object("ros2_interface::msg::Point2dList", ros2_interface::msg::GetPoint2dListIdentifier(true),
                        ros2_interface::msg::GetPoint2dListObject(true));
                factory->add_type_object("ros2_interface::msg::Point2dList", ros2_interface::msg::GetPoint2dListIdentifier(false),
                        ros2_interface::msg::GetPoint2dListObject(false));



                factory->add_type_object("ros2_interface::msg::PlanningParkingDebug", ros2_interface::msg::GetPlanningParkingDebugIdentifier(true),
                        ros2_interface::msg::GetPlanningParkingDebugObject(true));
                factory->add_type_object("ros2_interface::msg::PlanningParkingDebug", ros2_interface::msg::GetPlanningParkingDebugIdentifier(false),
                        ros2_interface::msg::GetPlanningParkingDebugObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::PlanningAnalysis", ros2_interface::msg::GetPlanningAnalysisIdentifier(true),
                        ros2_interface::msg::GetPlanningAnalysisObject(true));
                factory->add_type_object("ros2_interface::msg::PlanningAnalysis", ros2_interface::msg::GetPlanningAnalysisIdentifier(false),
                        ros2_interface::msg::GetPlanningAnalysisObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPlanningAnalysisIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PlanningAnalysis", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPlanningAnalysisObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PlanningAnalysis", complete);
        }

        const TypeObject* GetPlanningAnalysisObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningAnalysis", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePlanningAnalysisObject();
            }
            //else
            return GetMinimalPlanningAnalysisObject();
        }

        const TypeObject* GetMinimalPlanningAnalysisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningAnalysis", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_frame_update_time;
            mst_frame_update_time.common().member_id(memberId++);
            mst_frame_update_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_frame_update_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_frame_update_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_frame_update_time.common().member_flags().IS_OPTIONAL(false);
            mst_frame_update_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_frame_update_time.common().member_flags().IS_KEY(false);
            mst_frame_update_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_frame_update_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 frame_update_time_hash("frame_update_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_frame_update_time.detail().name_hash()[i] = frame_update_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_frame_update_time);

            MinimalStructMember mst_generator_time;
            mst_generator_time.common().member_id(memberId++);
            mst_generator_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_generator_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_generator_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_generator_time.common().member_flags().IS_OPTIONAL(false);
            mst_generator_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_generator_time.common().member_flags().IS_KEY(false);
            mst_generator_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_generator_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 generator_time_hash("generator_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_generator_time.detail().name_hash()[i] = generator_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_generator_time);

            MinimalStructMember mst_evaluator_time;
            mst_evaluator_time.common().member_id(memberId++);
            mst_evaluator_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_evaluator_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_evaluator_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_evaluator_time.common().member_flags().IS_OPTIONAL(false);
            mst_evaluator_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_evaluator_time.common().member_flags().IS_KEY(false);
            mst_evaluator_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_evaluator_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TimeConsume", 100, false));


            MD5 evaluator_time_hash("evaluator_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_evaluator_time.detail().name_hash()[i] = evaluator_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_evaluator_time);

            MinimalStructMember mst_selector_time;
            mst_selector_time.common().member_id(memberId++);
            mst_selector_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_selector_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_selector_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_selector_time.common().member_flags().IS_OPTIONAL(false);
            mst_selector_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_selector_time.common().member_flags().IS_KEY(false);
            mst_selector_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_selector_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 selector_time_hash("selector_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_selector_time.detail().name_hash()[i] = selector_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_selector_time);

            MinimalStructMember mst_planning_parking_debug;
            mst_planning_parking_debug.common().member_id(memberId++);
            mst_planning_parking_debug.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_planning_parking_debug.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_planning_parking_debug.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_planning_parking_debug.common().member_flags().IS_OPTIONAL(false);
            mst_planning_parking_debug.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_planning_parking_debug.common().member_flags().IS_KEY(false);
            mst_planning_parking_debug.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_planning_parking_debug.common().member_type_id(*ros2_interface::msg::GetPlanningParkingDebugIdentifier(false));
            MD5 planning_parking_debug_hash("planning_parking_debug");
            for(int i = 0; i < 4; ++i)
            {
                mst_planning_parking_debug.detail().name_hash()[i] = planning_parking_debug_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_planning_parking_debug);

            MinimalStructMember mst_dis_to_center_line;
            mst_dis_to_center_line.common().member_id(memberId++);
            mst_dis_to_center_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_dis_to_center_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_dis_to_center_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_dis_to_center_line.common().member_flags().IS_OPTIONAL(false);
            mst_dis_to_center_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_dis_to_center_line.common().member_flags().IS_KEY(false);
            mst_dis_to_center_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_dis_to_center_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 dis_to_center_line_hash("dis_to_center_line");
            for(int i = 0; i < 4; ++i)
            {
                mst_dis_to_center_line.detail().name_hash()[i] = dis_to_center_line_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_dis_to_center_line);

            MinimalStructMember mst_diff_to_velocity;
            mst_diff_to_velocity.common().member_id(memberId++);
            mst_diff_to_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_diff_to_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_diff_to_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_diff_to_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_diff_to_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_diff_to_velocity.common().member_flags().IS_KEY(false);
            mst_diff_to_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_diff_to_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 diff_to_velocity_hash("diff_to_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_diff_to_velocity.detail().name_hash()[i] = diff_to_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_diff_to_velocity);

            MinimalStructMember mst_referencline_kappa;
            mst_referencline_kappa.common().member_id(memberId++);
            mst_referencline_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_referencline_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_referencline_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_referencline_kappa.common().member_flags().IS_OPTIONAL(false);
            mst_referencline_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_referencline_kappa.common().member_flags().IS_KEY(false);
            mst_referencline_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_referencline_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 referencline_kappa_hash("referencline_kappa");
            for(int i = 0; i < 4; ++i)
            {
                mst_referencline_kappa.detail().name_hash()[i] = referencline_kappa_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_referencline_kappa);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningAnalysis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningAnalysis", false);
        }

        const TypeObject* GetCompletePlanningAnalysisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningAnalysis", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_frame_update_time;
            cst_frame_update_time.common().member_id(memberId++);
            cst_frame_update_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_frame_update_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_frame_update_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_frame_update_time.common().member_flags().IS_OPTIONAL(false);
            cst_frame_update_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_frame_update_time.common().member_flags().IS_KEY(false);
            cst_frame_update_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_frame_update_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_frame_update_time.detail().name("frame_update_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_frame_update_time);

            CompleteStructMember cst_generator_time;
            cst_generator_time.common().member_id(memberId++);
            cst_generator_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_generator_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_generator_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_generator_time.common().member_flags().IS_OPTIONAL(false);
            cst_generator_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_generator_time.common().member_flags().IS_KEY(false);
            cst_generator_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_generator_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_generator_time.detail().name("generator_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_generator_time);

            CompleteStructMember cst_evaluator_time;
            cst_evaluator_time.common().member_id(memberId++);
            cst_evaluator_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_evaluator_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_evaluator_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_evaluator_time.common().member_flags().IS_OPTIONAL(false);
            cst_evaluator_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_evaluator_time.common().member_flags().IS_KEY(false);
            cst_evaluator_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_evaluator_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TimeConsume", 100, true));


            cst_evaluator_time.detail().name("evaluator_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_evaluator_time);

            CompleteStructMember cst_selector_time;
            cst_selector_time.common().member_id(memberId++);
            cst_selector_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_selector_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_selector_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_selector_time.common().member_flags().IS_OPTIONAL(false);
            cst_selector_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_selector_time.common().member_flags().IS_KEY(false);
            cst_selector_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_selector_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_selector_time.detail().name("selector_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_selector_time);

            CompleteStructMember cst_planning_parking_debug;
            cst_planning_parking_debug.common().member_id(memberId++);
            cst_planning_parking_debug.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_planning_parking_debug.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_planning_parking_debug.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_planning_parking_debug.common().member_flags().IS_OPTIONAL(false);
            cst_planning_parking_debug.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_planning_parking_debug.common().member_flags().IS_KEY(false);
            cst_planning_parking_debug.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_planning_parking_debug.common().member_type_id(*ros2_interface::msg::GetPlanningParkingDebugIdentifier(true));
            cst_planning_parking_debug.detail().name("planning_parking_debug");

            type_object->complete().struct_type().member_seq().emplace_back(cst_planning_parking_debug);

            CompleteStructMember cst_dis_to_center_line;
            cst_dis_to_center_line.common().member_id(memberId++);
            cst_dis_to_center_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_dis_to_center_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_dis_to_center_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_dis_to_center_line.common().member_flags().IS_OPTIONAL(false);
            cst_dis_to_center_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_dis_to_center_line.common().member_flags().IS_KEY(false);
            cst_dis_to_center_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_dis_to_center_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_dis_to_center_line.detail().name("dis_to_center_line");

            type_object->complete().struct_type().member_seq().emplace_back(cst_dis_to_center_line);

            CompleteStructMember cst_diff_to_velocity;
            cst_diff_to_velocity.common().member_id(memberId++);
            cst_diff_to_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_diff_to_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_diff_to_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_diff_to_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_diff_to_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_diff_to_velocity.common().member_flags().IS_KEY(false);
            cst_diff_to_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_diff_to_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_diff_to_velocity.detail().name("diff_to_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_diff_to_velocity);

            CompleteStructMember cst_referencline_kappa;
            cst_referencline_kappa.common().member_id(memberId++);
            cst_referencline_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_referencline_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_referencline_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_referencline_kappa.common().member_flags().IS_OPTIONAL(false);
            cst_referencline_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_referencline_kappa.common().member_flags().IS_KEY(false);
            cst_referencline_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_referencline_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_referencline_kappa.detail().name("referencline_kappa");

            type_object->complete().struct_type().member_seq().emplace_back(cst_referencline_kappa);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PlanningAnalysis");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningAnalysis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningAnalysis", true);
        }

    } // namespace msg
} // namespace ros2_interface