// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningCmd.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PlanningCmd.h"
#include "PlanningCmdTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_PlanningCmd_max_cdr_typesize 332ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PlanningCmd_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PlanningCmd::PlanningCmd()
{
    // ros2_interface::msg::Header m_header

    // long m_turn_lamp_ctrl
    m_turn_lamp_ctrl = 0;
    // long m_high_beam_ctrl
    m_high_beam_ctrl = 0;
    // long m_low_beam_ctrl
    m_low_beam_ctrl = 0;
    // long m_horn_ctrl
    m_horn_ctrl = 0;
    // long m_front_wiper_ctrl
    m_front_wiper_ctrl = 0;
    // long m_rear_wiper_ctrl
    m_rear_wiper_ctrl = 0;
    // long m_position_lamp_ctrl
    m_position_lamp_ctrl = 0;
    // long m_front_fog_lamp_ctrl
    m_front_fog_lamp_ctrl = 0;
    // long m_rear_fog_lamp_ctrl
    m_rear_fog_lamp_ctrl = 0;
    // long m_brake_lamp_ctrl
    m_brake_lamp_ctrl = 0;
    // long m_alarm_lamp_ctrl
    m_alarm_lamp_ctrl = 0;
    // long m_lf_door_ctrl
    m_lf_door_ctrl = 0;
    // long m_rf_door_ctrl
    m_rf_door_ctrl = 0;
    // long m_lr_door_ctrl
    m_lr_door_ctrl = 0;
    // long m_rr_door_ctrl
    m_rr_door_ctrl = 0;

    // Just to register all known types
    registerPlanningCmdTypes();
}

ros2_interface::msg::PlanningCmd::~PlanningCmd()
{
















}

ros2_interface::msg::PlanningCmd::PlanningCmd(
        const PlanningCmd& x)
{
    m_header = x.m_header;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;
}

ros2_interface::msg::PlanningCmd::PlanningCmd(
        PlanningCmd&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;
}

ros2_interface::msg::PlanningCmd& ros2_interface::msg::PlanningCmd::operator =(
        const PlanningCmd& x)
{

    m_header = x.m_header;
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;

    return *this;
}

ros2_interface::msg::PlanningCmd& ros2_interface::msg::PlanningCmd::operator =(
        PlanningCmd&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_turn_lamp_ctrl = x.m_turn_lamp_ctrl;
    m_high_beam_ctrl = x.m_high_beam_ctrl;
    m_low_beam_ctrl = x.m_low_beam_ctrl;
    m_horn_ctrl = x.m_horn_ctrl;
    m_front_wiper_ctrl = x.m_front_wiper_ctrl;
    m_rear_wiper_ctrl = x.m_rear_wiper_ctrl;
    m_position_lamp_ctrl = x.m_position_lamp_ctrl;
    m_front_fog_lamp_ctrl = x.m_front_fog_lamp_ctrl;
    m_rear_fog_lamp_ctrl = x.m_rear_fog_lamp_ctrl;
    m_brake_lamp_ctrl = x.m_brake_lamp_ctrl;
    m_alarm_lamp_ctrl = x.m_alarm_lamp_ctrl;
    m_lf_door_ctrl = x.m_lf_door_ctrl;
    m_rf_door_ctrl = x.m_rf_door_ctrl;
    m_lr_door_ctrl = x.m_lr_door_ctrl;
    m_rr_door_ctrl = x.m_rr_door_ctrl;

    return *this;
}

bool ros2_interface::msg::PlanningCmd::operator ==(
        const PlanningCmd& x) const
{

    return (m_header == x.m_header && m_turn_lamp_ctrl == x.m_turn_lamp_ctrl && m_high_beam_ctrl == x.m_high_beam_ctrl && m_low_beam_ctrl == x.m_low_beam_ctrl && m_horn_ctrl == x.m_horn_ctrl && m_front_wiper_ctrl == x.m_front_wiper_ctrl && m_rear_wiper_ctrl == x.m_rear_wiper_ctrl && m_position_lamp_ctrl == x.m_position_lamp_ctrl && m_front_fog_lamp_ctrl == x.m_front_fog_lamp_ctrl && m_rear_fog_lamp_ctrl == x.m_rear_fog_lamp_ctrl && m_brake_lamp_ctrl == x.m_brake_lamp_ctrl && m_alarm_lamp_ctrl == x.m_alarm_lamp_ctrl && m_lf_door_ctrl == x.m_lf_door_ctrl && m_rf_door_ctrl == x.m_rf_door_ctrl && m_lr_door_ctrl == x.m_lr_door_ctrl && m_rr_door_ctrl == x.m_rr_door_ctrl);
}

bool ros2_interface::msg::PlanningCmd::operator !=(
        const PlanningCmd& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PlanningCmd::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningCmd_max_cdr_typesize;
}

size_t ros2_interface::msg::PlanningCmd::getCdrSerializedSize(
        const ros2_interface::msg::PlanningCmd& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PlanningCmd::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_turn_lamp_ctrl;
    scdr << m_high_beam_ctrl;
    scdr << m_low_beam_ctrl;
    scdr << m_horn_ctrl;
    scdr << m_front_wiper_ctrl;
    scdr << m_rear_wiper_ctrl;
    scdr << m_position_lamp_ctrl;
    scdr << m_front_fog_lamp_ctrl;
    scdr << m_rear_fog_lamp_ctrl;
    scdr << m_brake_lamp_ctrl;
    scdr << m_alarm_lamp_ctrl;
    scdr << m_lf_door_ctrl;
    scdr << m_rf_door_ctrl;
    scdr << m_lr_door_ctrl;
    scdr << m_rr_door_ctrl;

}

void ros2_interface::msg::PlanningCmd::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_turn_lamp_ctrl;
    dcdr >> m_high_beam_ctrl;
    dcdr >> m_low_beam_ctrl;
    dcdr >> m_horn_ctrl;
    dcdr >> m_front_wiper_ctrl;
    dcdr >> m_rear_wiper_ctrl;
    dcdr >> m_position_lamp_ctrl;
    dcdr >> m_front_fog_lamp_ctrl;
    dcdr >> m_rear_fog_lamp_ctrl;
    dcdr >> m_brake_lamp_ctrl;
    dcdr >> m_alarm_lamp_ctrl;
    dcdr >> m_lf_door_ctrl;
    dcdr >> m_rf_door_ctrl;
    dcdr >> m_lr_door_ctrl;
    dcdr >> m_rr_door_ctrl;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::PlanningCmd::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::PlanningCmd::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::PlanningCmd::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::PlanningCmd::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member turn_lamp_ctrl
 * @param _turn_lamp_ctrl New value for member turn_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::turn_lamp_ctrl(
        int32_t _turn_lamp_ctrl)
{
    m_turn_lamp_ctrl = _turn_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member turn_lamp_ctrl
 * @return Value of member turn_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::turn_lamp_ctrl() const
{
    return m_turn_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member turn_lamp_ctrl
 * @return Reference to member turn_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::turn_lamp_ctrl()
{
    return m_turn_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member high_beam_ctrl
 * @param _high_beam_ctrl New value for member high_beam_ctrl
 */
void ros2_interface::msg::PlanningCmd::high_beam_ctrl(
        int32_t _high_beam_ctrl)
{
    m_high_beam_ctrl = _high_beam_ctrl;
}

/*!
 * @brief This function returns the value of member high_beam_ctrl
 * @return Value of member high_beam_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::high_beam_ctrl() const
{
    return m_high_beam_ctrl;
}

/*!
 * @brief This function returns a reference to member high_beam_ctrl
 * @return Reference to member high_beam_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::high_beam_ctrl()
{
    return m_high_beam_ctrl;
}

/*!
 * @brief This function sets a value in member low_beam_ctrl
 * @param _low_beam_ctrl New value for member low_beam_ctrl
 */
void ros2_interface::msg::PlanningCmd::low_beam_ctrl(
        int32_t _low_beam_ctrl)
{
    m_low_beam_ctrl = _low_beam_ctrl;
}

/*!
 * @brief This function returns the value of member low_beam_ctrl
 * @return Value of member low_beam_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::low_beam_ctrl() const
{
    return m_low_beam_ctrl;
}

/*!
 * @brief This function returns a reference to member low_beam_ctrl
 * @return Reference to member low_beam_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::low_beam_ctrl()
{
    return m_low_beam_ctrl;
}

/*!
 * @brief This function sets a value in member horn_ctrl
 * @param _horn_ctrl New value for member horn_ctrl
 */
void ros2_interface::msg::PlanningCmd::horn_ctrl(
        int32_t _horn_ctrl)
{
    m_horn_ctrl = _horn_ctrl;
}

/*!
 * @brief This function returns the value of member horn_ctrl
 * @return Value of member horn_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::horn_ctrl() const
{
    return m_horn_ctrl;
}

/*!
 * @brief This function returns a reference to member horn_ctrl
 * @return Reference to member horn_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::horn_ctrl()
{
    return m_horn_ctrl;
}

/*!
 * @brief This function sets a value in member front_wiper_ctrl
 * @param _front_wiper_ctrl New value for member front_wiper_ctrl
 */
void ros2_interface::msg::PlanningCmd::front_wiper_ctrl(
        int32_t _front_wiper_ctrl)
{
    m_front_wiper_ctrl = _front_wiper_ctrl;
}

/*!
 * @brief This function returns the value of member front_wiper_ctrl
 * @return Value of member front_wiper_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::front_wiper_ctrl() const
{
    return m_front_wiper_ctrl;
}

/*!
 * @brief This function returns a reference to member front_wiper_ctrl
 * @return Reference to member front_wiper_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::front_wiper_ctrl()
{
    return m_front_wiper_ctrl;
}

/*!
 * @brief This function sets a value in member rear_wiper_ctrl
 * @param _rear_wiper_ctrl New value for member rear_wiper_ctrl
 */
void ros2_interface::msg::PlanningCmd::rear_wiper_ctrl(
        int32_t _rear_wiper_ctrl)
{
    m_rear_wiper_ctrl = _rear_wiper_ctrl;
}

/*!
 * @brief This function returns the value of member rear_wiper_ctrl
 * @return Value of member rear_wiper_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::rear_wiper_ctrl() const
{
    return m_rear_wiper_ctrl;
}

/*!
 * @brief This function returns a reference to member rear_wiper_ctrl
 * @return Reference to member rear_wiper_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::rear_wiper_ctrl()
{
    return m_rear_wiper_ctrl;
}

/*!
 * @brief This function sets a value in member position_lamp_ctrl
 * @param _position_lamp_ctrl New value for member position_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::position_lamp_ctrl(
        int32_t _position_lamp_ctrl)
{
    m_position_lamp_ctrl = _position_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member position_lamp_ctrl
 * @return Value of member position_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::position_lamp_ctrl() const
{
    return m_position_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member position_lamp_ctrl
 * @return Reference to member position_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::position_lamp_ctrl()
{
    return m_position_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member front_fog_lamp_ctrl
 * @param _front_fog_lamp_ctrl New value for member front_fog_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::front_fog_lamp_ctrl(
        int32_t _front_fog_lamp_ctrl)
{
    m_front_fog_lamp_ctrl = _front_fog_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member front_fog_lamp_ctrl
 * @return Value of member front_fog_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::front_fog_lamp_ctrl() const
{
    return m_front_fog_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member front_fog_lamp_ctrl
 * @return Reference to member front_fog_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::front_fog_lamp_ctrl()
{
    return m_front_fog_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member rear_fog_lamp_ctrl
 * @param _rear_fog_lamp_ctrl New value for member rear_fog_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::rear_fog_lamp_ctrl(
        int32_t _rear_fog_lamp_ctrl)
{
    m_rear_fog_lamp_ctrl = _rear_fog_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member rear_fog_lamp_ctrl
 * @return Value of member rear_fog_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::rear_fog_lamp_ctrl() const
{
    return m_rear_fog_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member rear_fog_lamp_ctrl
 * @return Reference to member rear_fog_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::rear_fog_lamp_ctrl()
{
    return m_rear_fog_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member brake_lamp_ctrl
 * @param _brake_lamp_ctrl New value for member brake_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::brake_lamp_ctrl(
        int32_t _brake_lamp_ctrl)
{
    m_brake_lamp_ctrl = _brake_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member brake_lamp_ctrl
 * @return Value of member brake_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::brake_lamp_ctrl() const
{
    return m_brake_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member brake_lamp_ctrl
 * @return Reference to member brake_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::brake_lamp_ctrl()
{
    return m_brake_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member alarm_lamp_ctrl
 * @param _alarm_lamp_ctrl New value for member alarm_lamp_ctrl
 */
void ros2_interface::msg::PlanningCmd::alarm_lamp_ctrl(
        int32_t _alarm_lamp_ctrl)
{
    m_alarm_lamp_ctrl = _alarm_lamp_ctrl;
}

/*!
 * @brief This function returns the value of member alarm_lamp_ctrl
 * @return Value of member alarm_lamp_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::alarm_lamp_ctrl() const
{
    return m_alarm_lamp_ctrl;
}

/*!
 * @brief This function returns a reference to member alarm_lamp_ctrl
 * @return Reference to member alarm_lamp_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::alarm_lamp_ctrl()
{
    return m_alarm_lamp_ctrl;
}

/*!
 * @brief This function sets a value in member lf_door_ctrl
 * @param _lf_door_ctrl New value for member lf_door_ctrl
 */
void ros2_interface::msg::PlanningCmd::lf_door_ctrl(
        int32_t _lf_door_ctrl)
{
    m_lf_door_ctrl = _lf_door_ctrl;
}

/*!
 * @brief This function returns the value of member lf_door_ctrl
 * @return Value of member lf_door_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::lf_door_ctrl() const
{
    return m_lf_door_ctrl;
}

/*!
 * @brief This function returns a reference to member lf_door_ctrl
 * @return Reference to member lf_door_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::lf_door_ctrl()
{
    return m_lf_door_ctrl;
}

/*!
 * @brief This function sets a value in member rf_door_ctrl
 * @param _rf_door_ctrl New value for member rf_door_ctrl
 */
void ros2_interface::msg::PlanningCmd::rf_door_ctrl(
        int32_t _rf_door_ctrl)
{
    m_rf_door_ctrl = _rf_door_ctrl;
}

/*!
 * @brief This function returns the value of member rf_door_ctrl
 * @return Value of member rf_door_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::rf_door_ctrl() const
{
    return m_rf_door_ctrl;
}

/*!
 * @brief This function returns a reference to member rf_door_ctrl
 * @return Reference to member rf_door_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::rf_door_ctrl()
{
    return m_rf_door_ctrl;
}

/*!
 * @brief This function sets a value in member lr_door_ctrl
 * @param _lr_door_ctrl New value for member lr_door_ctrl
 */
void ros2_interface::msg::PlanningCmd::lr_door_ctrl(
        int32_t _lr_door_ctrl)
{
    m_lr_door_ctrl = _lr_door_ctrl;
}

/*!
 * @brief This function returns the value of member lr_door_ctrl
 * @return Value of member lr_door_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::lr_door_ctrl() const
{
    return m_lr_door_ctrl;
}

/*!
 * @brief This function returns a reference to member lr_door_ctrl
 * @return Reference to member lr_door_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::lr_door_ctrl()
{
    return m_lr_door_ctrl;
}

/*!
 * @brief This function sets a value in member rr_door_ctrl
 * @param _rr_door_ctrl New value for member rr_door_ctrl
 */
void ros2_interface::msg::PlanningCmd::rr_door_ctrl(
        int32_t _rr_door_ctrl)
{
    m_rr_door_ctrl = _rr_door_ctrl;
}

/*!
 * @brief This function returns the value of member rr_door_ctrl
 * @return Value of member rr_door_ctrl
 */
int32_t ros2_interface::msg::PlanningCmd::rr_door_ctrl() const
{
    return m_rr_door_ctrl;
}

/*!
 * @brief This function returns a reference to member rr_door_ctrl
 * @return Reference to member rr_door_ctrl
 */
int32_t& ros2_interface::msg::PlanningCmd::rr_door_ctrl()
{
    return m_rr_door_ctrl;
}



size_t ros2_interface::msg::PlanningCmd::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningCmd_max_key_cdr_typesize;
}

bool ros2_interface::msg::PlanningCmd::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PlanningCmd::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



