// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningCmdTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PlanningCmd.h"
#include "PlanningCmdTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPlanningCmdTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::PlanningCmd", ros2_interface::msg::GetPlanningCmdIdentifier(true),
                        ros2_interface::msg::GetPlanningCmdObject(true));
                factory->add_type_object("ros2_interface::msg::PlanningCmd", ros2_interface::msg::GetPlanningCmdIdentifier(false),
                        ros2_interface::msg::GetPlanningCmdObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPlanningCmdIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PlanningCmd", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPlanningCmdObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PlanningCmd", complete);
        }

        const TypeObject* GetPlanningCmdObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningCmd", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePlanningCmdObject();
            }
            //else
            return GetMinimalPlanningCmdObject();
        }

        const TypeObject* GetMinimalPlanningCmdObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningCmd", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_turn_lamp_ctrl;
            mst_turn_lamp_ctrl.common().member_id(memberId++);
            mst_turn_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_turn_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_turn_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_turn_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_turn_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_turn_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_turn_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_turn_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 turn_lamp_ctrl_hash("turn_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_turn_lamp_ctrl.detail().name_hash()[i] = turn_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_turn_lamp_ctrl);

            MinimalStructMember mst_high_beam_ctrl;
            mst_high_beam_ctrl.common().member_id(memberId++);
            mst_high_beam_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_high_beam_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_high_beam_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_high_beam_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_high_beam_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_high_beam_ctrl.common().member_flags().IS_KEY(false);
            mst_high_beam_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_high_beam_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 high_beam_ctrl_hash("high_beam_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_high_beam_ctrl.detail().name_hash()[i] = high_beam_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_high_beam_ctrl);

            MinimalStructMember mst_low_beam_ctrl;
            mst_low_beam_ctrl.common().member_id(memberId++);
            mst_low_beam_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_low_beam_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_low_beam_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_low_beam_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_low_beam_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_low_beam_ctrl.common().member_flags().IS_KEY(false);
            mst_low_beam_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_low_beam_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 low_beam_ctrl_hash("low_beam_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_low_beam_ctrl.detail().name_hash()[i] = low_beam_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_low_beam_ctrl);

            MinimalStructMember mst_horn_ctrl;
            mst_horn_ctrl.common().member_id(memberId++);
            mst_horn_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_horn_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_horn_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_horn_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_horn_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_horn_ctrl.common().member_flags().IS_KEY(false);
            mst_horn_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_horn_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 horn_ctrl_hash("horn_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_horn_ctrl.detail().name_hash()[i] = horn_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_horn_ctrl);

            MinimalStructMember mst_front_wiper_ctrl;
            mst_front_wiper_ctrl.common().member_id(memberId++);
            mst_front_wiper_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_wiper_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_wiper_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_wiper_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_front_wiper_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_wiper_ctrl.common().member_flags().IS_KEY(false);
            mst_front_wiper_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_wiper_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 front_wiper_ctrl_hash("front_wiper_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_wiper_ctrl.detail().name_hash()[i] = front_wiper_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_wiper_ctrl);

            MinimalStructMember mst_rear_wiper_ctrl;
            mst_rear_wiper_ctrl.common().member_id(memberId++);
            mst_rear_wiper_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_wiper_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_wiper_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_wiper_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_rear_wiper_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_wiper_ctrl.common().member_flags().IS_KEY(false);
            mst_rear_wiper_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_wiper_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rear_wiper_ctrl_hash("rear_wiper_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_wiper_ctrl.detail().name_hash()[i] = rear_wiper_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_wiper_ctrl);

            MinimalStructMember mst_position_lamp_ctrl;
            mst_position_lamp_ctrl.common().member_id(memberId++);
            mst_position_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_position_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_position_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 position_lamp_ctrl_hash("position_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_lamp_ctrl.detail().name_hash()[i] = position_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_lamp_ctrl);

            MinimalStructMember mst_front_fog_lamp_ctrl;
            mst_front_fog_lamp_ctrl.common().member_id(memberId++);
            mst_front_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_fog_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_fog_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_front_fog_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_fog_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_front_fog_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_fog_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 front_fog_lamp_ctrl_hash("front_fog_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_fog_lamp_ctrl.detail().name_hash()[i] = front_fog_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_fog_lamp_ctrl);

            MinimalStructMember mst_rear_fog_lamp_ctrl;
            mst_rear_fog_lamp_ctrl.common().member_id(memberId++);
            mst_rear_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_fog_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_fog_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_rear_fog_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_fog_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_rear_fog_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_fog_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rear_fog_lamp_ctrl_hash("rear_fog_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_fog_lamp_ctrl.detail().name_hash()[i] = rear_fog_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_fog_lamp_ctrl);

            MinimalStructMember mst_brake_lamp_ctrl;
            mst_brake_lamp_ctrl.common().member_id(memberId++);
            mst_brake_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_brake_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_brake_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_lamp_ctrl_hash("brake_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_lamp_ctrl.detail().name_hash()[i] = brake_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_lamp_ctrl);

            MinimalStructMember mst_alarm_lamp_ctrl;
            mst_alarm_lamp_ctrl.common().member_id(memberId++);
            mst_alarm_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_alarm_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_alarm_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_alarm_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_alarm_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_alarm_lamp_ctrl.common().member_flags().IS_KEY(false);
            mst_alarm_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_alarm_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 alarm_lamp_ctrl_hash("alarm_lamp_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_alarm_lamp_ctrl.detail().name_hash()[i] = alarm_lamp_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_alarm_lamp_ctrl);

            MinimalStructMember mst_lf_door_ctrl;
            mst_lf_door_ctrl.common().member_id(memberId++);
            mst_lf_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lf_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lf_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lf_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_lf_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lf_door_ctrl.common().member_flags().IS_KEY(false);
            mst_lf_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lf_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lf_door_ctrl_hash("lf_door_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_lf_door_ctrl.detail().name_hash()[i] = lf_door_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lf_door_ctrl);

            MinimalStructMember mst_rf_door_ctrl;
            mst_rf_door_ctrl.common().member_id(memberId++);
            mst_rf_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rf_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rf_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rf_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_rf_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rf_door_ctrl.common().member_flags().IS_KEY(false);
            mst_rf_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rf_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rf_door_ctrl_hash("rf_door_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_rf_door_ctrl.detail().name_hash()[i] = rf_door_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rf_door_ctrl);

            MinimalStructMember mst_lr_door_ctrl;
            mst_lr_door_ctrl.common().member_id(memberId++);
            mst_lr_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lr_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lr_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lr_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_lr_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lr_door_ctrl.common().member_flags().IS_KEY(false);
            mst_lr_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lr_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lr_door_ctrl_hash("lr_door_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_lr_door_ctrl.detail().name_hash()[i] = lr_door_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lr_door_ctrl);

            MinimalStructMember mst_rr_door_ctrl;
            mst_rr_door_ctrl.common().member_id(memberId++);
            mst_rr_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rr_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rr_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rr_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            mst_rr_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rr_door_ctrl.common().member_flags().IS_KEY(false);
            mst_rr_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rr_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rr_door_ctrl_hash("rr_door_ctrl");
            for(int i = 0; i < 4; ++i)
            {
                mst_rr_door_ctrl.detail().name_hash()[i] = rr_door_ctrl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rr_door_ctrl);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningCmd", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningCmd", false);
        }

        const TypeObject* GetCompletePlanningCmdObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningCmd", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_turn_lamp_ctrl;
            cst_turn_lamp_ctrl.common().member_id(memberId++);
            cst_turn_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_turn_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_turn_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_turn_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_turn_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_turn_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_turn_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_turn_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_turn_lamp_ctrl.detail().name("turn_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_turn_lamp_ctrl);

            CompleteStructMember cst_high_beam_ctrl;
            cst_high_beam_ctrl.common().member_id(memberId++);
            cst_high_beam_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_high_beam_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_high_beam_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_high_beam_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_high_beam_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_high_beam_ctrl.common().member_flags().IS_KEY(false);
            cst_high_beam_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_high_beam_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_high_beam_ctrl.detail().name("high_beam_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_high_beam_ctrl);

            CompleteStructMember cst_low_beam_ctrl;
            cst_low_beam_ctrl.common().member_id(memberId++);
            cst_low_beam_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_low_beam_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_low_beam_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_low_beam_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_low_beam_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_low_beam_ctrl.common().member_flags().IS_KEY(false);
            cst_low_beam_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_low_beam_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_low_beam_ctrl.detail().name("low_beam_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_low_beam_ctrl);

            CompleteStructMember cst_horn_ctrl;
            cst_horn_ctrl.common().member_id(memberId++);
            cst_horn_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_horn_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_horn_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_horn_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_horn_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_horn_ctrl.common().member_flags().IS_KEY(false);
            cst_horn_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_horn_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_horn_ctrl.detail().name("horn_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_horn_ctrl);

            CompleteStructMember cst_front_wiper_ctrl;
            cst_front_wiper_ctrl.common().member_id(memberId++);
            cst_front_wiper_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_wiper_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_wiper_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_wiper_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_front_wiper_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_wiper_ctrl.common().member_flags().IS_KEY(false);
            cst_front_wiper_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_wiper_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_front_wiper_ctrl.detail().name("front_wiper_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_wiper_ctrl);

            CompleteStructMember cst_rear_wiper_ctrl;
            cst_rear_wiper_ctrl.common().member_id(memberId++);
            cst_rear_wiper_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_wiper_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_wiper_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_wiper_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_rear_wiper_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_wiper_ctrl.common().member_flags().IS_KEY(false);
            cst_rear_wiper_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_wiper_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rear_wiper_ctrl.detail().name("rear_wiper_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_wiper_ctrl);

            CompleteStructMember cst_position_lamp_ctrl;
            cst_position_lamp_ctrl.common().member_id(memberId++);
            cst_position_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_position_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_position_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_position_lamp_ctrl.detail().name("position_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_lamp_ctrl);

            CompleteStructMember cst_front_fog_lamp_ctrl;
            cst_front_fog_lamp_ctrl.common().member_id(memberId++);
            cst_front_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_fog_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_fog_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_front_fog_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_fog_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_front_fog_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_fog_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_front_fog_lamp_ctrl.detail().name("front_fog_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_fog_lamp_ctrl);

            CompleteStructMember cst_rear_fog_lamp_ctrl;
            cst_rear_fog_lamp_ctrl.common().member_id(memberId++);
            cst_rear_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_fog_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_fog_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_fog_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_rear_fog_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_fog_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_rear_fog_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_fog_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rear_fog_lamp_ctrl.detail().name("rear_fog_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_fog_lamp_ctrl);

            CompleteStructMember cst_brake_lamp_ctrl;
            cst_brake_lamp_ctrl.common().member_id(memberId++);
            cst_brake_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_brake_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_brake_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_lamp_ctrl.detail().name("brake_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_lamp_ctrl);

            CompleteStructMember cst_alarm_lamp_ctrl;
            cst_alarm_lamp_ctrl.common().member_id(memberId++);
            cst_alarm_lamp_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_alarm_lamp_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_alarm_lamp_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_alarm_lamp_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_alarm_lamp_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_alarm_lamp_ctrl.common().member_flags().IS_KEY(false);
            cst_alarm_lamp_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_alarm_lamp_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_alarm_lamp_ctrl.detail().name("alarm_lamp_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_alarm_lamp_ctrl);

            CompleteStructMember cst_lf_door_ctrl;
            cst_lf_door_ctrl.common().member_id(memberId++);
            cst_lf_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lf_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lf_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lf_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_lf_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lf_door_ctrl.common().member_flags().IS_KEY(false);
            cst_lf_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lf_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lf_door_ctrl.detail().name("lf_door_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lf_door_ctrl);

            CompleteStructMember cst_rf_door_ctrl;
            cst_rf_door_ctrl.common().member_id(memberId++);
            cst_rf_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rf_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rf_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rf_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_rf_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rf_door_ctrl.common().member_flags().IS_KEY(false);
            cst_rf_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rf_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rf_door_ctrl.detail().name("rf_door_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rf_door_ctrl);

            CompleteStructMember cst_lr_door_ctrl;
            cst_lr_door_ctrl.common().member_id(memberId++);
            cst_lr_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lr_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lr_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lr_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_lr_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lr_door_ctrl.common().member_flags().IS_KEY(false);
            cst_lr_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lr_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lr_door_ctrl.detail().name("lr_door_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lr_door_ctrl);

            CompleteStructMember cst_rr_door_ctrl;
            cst_rr_door_ctrl.common().member_id(memberId++);
            cst_rr_door_ctrl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rr_door_ctrl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rr_door_ctrl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rr_door_ctrl.common().member_flags().IS_OPTIONAL(false);
            cst_rr_door_ctrl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rr_door_ctrl.common().member_flags().IS_KEY(false);
            cst_rr_door_ctrl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rr_door_ctrl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rr_door_ctrl.detail().name("rr_door_ctrl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rr_door_ctrl);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PlanningCmd");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningCmd", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningCmd", true);
        }

    } // namespace msg
} // namespace ros2_interface