// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningParkingDebug.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PlanningParkingDebug.h"
#include "PlanningParkingDebugTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Polygon2D_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_PlanningParkingDebug_max_cdr_typesize 2130036ULL;
#define ros2_interface_msg_Trajectory_max_cdr_typesize 15460ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_Point2dList_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PlanningParkingDebug_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Trajectory_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point2dList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PlanningParkingDebug::PlanningParkingDebug()
{
    // sequence<ros2_interface::msg::Polygon2D> m_vehicle_preiew_polygon

    // sequence<ros2_interface::msg::Polygon2D> m_obstacles_polygon

    // sequence<ros2_interface::msg::PathPoint> m_path_points

    // double m_lat_error
    m_lat_error = 0.0;
    // double m_lon_error
    m_lon_error = 0.0;
    // double m_yaw_error
    m_yaw_error = 0.0;
    // sequence<ros2_interface::msg::Point2dList> m_obstacles_vec

    // sequence<ros2_interface::msg::TrajectoryPoint> m_warm_start_traj

    // sequence<ros2_interface::msg::TrajectoryPoint> m_smoothed_traj_stage1

    // sequence<ros2_interface::msg::TrajectoryPoint> m_smoothed_traj_stage2

    // ros2_interface::msg::Trajectory m_reference_line

    // sequence<ros2_interface::msg::Trajectory> m_trajectory_array

    // ros2_interface::msg::Trajectory m_optimal_coarse_trajectory

    // ros2_interface::msg::Trajectory m_optimal_smooth_trajectory

    // double m_hybrid_a_star_map_time
    m_hybrid_a_star_map_time = 0.0;
    // double m_hybrid_a_star_heuristic_time
    m_hybrid_a_star_heuristic_time = 0.0;
    // double m_hybrid_a_star_rs_time
    m_hybrid_a_star_rs_time = 0.0;
    // double m_hybrid_a_star_total_time
    m_hybrid_a_star_total_time = 0.0;
    // double m_ias_collision_avoidance_time
    m_ias_collision_avoidance_time = 0.0;
    // double m_ias_path_smooth_time
    m_ias_path_smooth_time = 0.0;
    // double m_ias_speed_smooth_time
    m_ias_speed_smooth_time = 0.0;
    // double m_ias_total_time
    m_ias_total_time = 0.0;
    // double m_samping_trajectory_time
    m_samping_trajectory_time = 0.0;
    // boolean m_is_replan
    m_is_replan = false;
    // string m_replan_reason
    m_replan_reason ="";
    // double m_replan_time
    m_replan_time = 0.0;
    // long m_replan_num
    m_replan_num = 0;
    // long m_optimizer_thread_counter
    m_optimizer_thread_counter = 0;
    // long m_replan_by_context_update_counter
    m_replan_by_context_update_counter = 0;
    // long m_replan_by_large_error_counter
    m_replan_by_large_error_counter = 0;
    // long m_parking_type
    m_parking_type = 0;
    // long m_moves_counter
    m_moves_counter = 0;
    // double m_remain_distance
    m_remain_distance = 0.0;
    // double m_distance_to_leader_obj
    m_distance_to_leader_obj = 0.0;
    // long m_state
    m_state = 0;

    // Just to register all known types
    registerPlanningParkingDebugTypes();
}

ros2_interface::msg::PlanningParkingDebug::~PlanningParkingDebug()
{



































}

ros2_interface::msg::PlanningParkingDebug::PlanningParkingDebug(
        const PlanningParkingDebug& x)
{
    m_vehicle_preiew_polygon = x.m_vehicle_preiew_polygon;
    m_obstacles_polygon = x.m_obstacles_polygon;
    m_path_points = x.m_path_points;
    m_lat_error = x.m_lat_error;
    m_lon_error = x.m_lon_error;
    m_yaw_error = x.m_yaw_error;
    m_obstacles_vec = x.m_obstacles_vec;
    m_warm_start_traj = x.m_warm_start_traj;
    m_smoothed_traj_stage1 = x.m_smoothed_traj_stage1;
    m_smoothed_traj_stage2 = x.m_smoothed_traj_stage2;
    m_reference_line = x.m_reference_line;
    m_trajectory_array = x.m_trajectory_array;
    m_optimal_coarse_trajectory = x.m_optimal_coarse_trajectory;
    m_optimal_smooth_trajectory = x.m_optimal_smooth_trajectory;
    m_hybrid_a_star_map_time = x.m_hybrid_a_star_map_time;
    m_hybrid_a_star_heuristic_time = x.m_hybrid_a_star_heuristic_time;
    m_hybrid_a_star_rs_time = x.m_hybrid_a_star_rs_time;
    m_hybrid_a_star_total_time = x.m_hybrid_a_star_total_time;
    m_ias_collision_avoidance_time = x.m_ias_collision_avoidance_time;
    m_ias_path_smooth_time = x.m_ias_path_smooth_time;
    m_ias_speed_smooth_time = x.m_ias_speed_smooth_time;
    m_ias_total_time = x.m_ias_total_time;
    m_samping_trajectory_time = x.m_samping_trajectory_time;
    m_is_replan = x.m_is_replan;
    m_replan_reason = x.m_replan_reason;
    m_replan_time = x.m_replan_time;
    m_replan_num = x.m_replan_num;
    m_optimizer_thread_counter = x.m_optimizer_thread_counter;
    m_replan_by_context_update_counter = x.m_replan_by_context_update_counter;
    m_replan_by_large_error_counter = x.m_replan_by_large_error_counter;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remain_distance = x.m_remain_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;
}

ros2_interface::msg::PlanningParkingDebug::PlanningParkingDebug(
        PlanningParkingDebug&& x) noexcept 
{
    m_vehicle_preiew_polygon = std::move(x.m_vehicle_preiew_polygon);
    m_obstacles_polygon = std::move(x.m_obstacles_polygon);
    m_path_points = std::move(x.m_path_points);
    m_lat_error = x.m_lat_error;
    m_lon_error = x.m_lon_error;
    m_yaw_error = x.m_yaw_error;
    m_obstacles_vec = std::move(x.m_obstacles_vec);
    m_warm_start_traj = std::move(x.m_warm_start_traj);
    m_smoothed_traj_stage1 = std::move(x.m_smoothed_traj_stage1);
    m_smoothed_traj_stage2 = std::move(x.m_smoothed_traj_stage2);
    m_reference_line = std::move(x.m_reference_line);
    m_trajectory_array = std::move(x.m_trajectory_array);
    m_optimal_coarse_trajectory = std::move(x.m_optimal_coarse_trajectory);
    m_optimal_smooth_trajectory = std::move(x.m_optimal_smooth_trajectory);
    m_hybrid_a_star_map_time = x.m_hybrid_a_star_map_time;
    m_hybrid_a_star_heuristic_time = x.m_hybrid_a_star_heuristic_time;
    m_hybrid_a_star_rs_time = x.m_hybrid_a_star_rs_time;
    m_hybrid_a_star_total_time = x.m_hybrid_a_star_total_time;
    m_ias_collision_avoidance_time = x.m_ias_collision_avoidance_time;
    m_ias_path_smooth_time = x.m_ias_path_smooth_time;
    m_ias_speed_smooth_time = x.m_ias_speed_smooth_time;
    m_ias_total_time = x.m_ias_total_time;
    m_samping_trajectory_time = x.m_samping_trajectory_time;
    m_is_replan = x.m_is_replan;
    m_replan_reason = std::move(x.m_replan_reason);
    m_replan_time = x.m_replan_time;
    m_replan_num = x.m_replan_num;
    m_optimizer_thread_counter = x.m_optimizer_thread_counter;
    m_replan_by_context_update_counter = x.m_replan_by_context_update_counter;
    m_replan_by_large_error_counter = x.m_replan_by_large_error_counter;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remain_distance = x.m_remain_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;
}

ros2_interface::msg::PlanningParkingDebug& ros2_interface::msg::PlanningParkingDebug::operator =(
        const PlanningParkingDebug& x)
{

    m_vehicle_preiew_polygon = x.m_vehicle_preiew_polygon;
    m_obstacles_polygon = x.m_obstacles_polygon;
    m_path_points = x.m_path_points;
    m_lat_error = x.m_lat_error;
    m_lon_error = x.m_lon_error;
    m_yaw_error = x.m_yaw_error;
    m_obstacles_vec = x.m_obstacles_vec;
    m_warm_start_traj = x.m_warm_start_traj;
    m_smoothed_traj_stage1 = x.m_smoothed_traj_stage1;
    m_smoothed_traj_stage2 = x.m_smoothed_traj_stage2;
    m_reference_line = x.m_reference_line;
    m_trajectory_array = x.m_trajectory_array;
    m_optimal_coarse_trajectory = x.m_optimal_coarse_trajectory;
    m_optimal_smooth_trajectory = x.m_optimal_smooth_trajectory;
    m_hybrid_a_star_map_time = x.m_hybrid_a_star_map_time;
    m_hybrid_a_star_heuristic_time = x.m_hybrid_a_star_heuristic_time;
    m_hybrid_a_star_rs_time = x.m_hybrid_a_star_rs_time;
    m_hybrid_a_star_total_time = x.m_hybrid_a_star_total_time;
    m_ias_collision_avoidance_time = x.m_ias_collision_avoidance_time;
    m_ias_path_smooth_time = x.m_ias_path_smooth_time;
    m_ias_speed_smooth_time = x.m_ias_speed_smooth_time;
    m_ias_total_time = x.m_ias_total_time;
    m_samping_trajectory_time = x.m_samping_trajectory_time;
    m_is_replan = x.m_is_replan;
    m_replan_reason = x.m_replan_reason;
    m_replan_time = x.m_replan_time;
    m_replan_num = x.m_replan_num;
    m_optimizer_thread_counter = x.m_optimizer_thread_counter;
    m_replan_by_context_update_counter = x.m_replan_by_context_update_counter;
    m_replan_by_large_error_counter = x.m_replan_by_large_error_counter;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remain_distance = x.m_remain_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;

    return *this;
}

ros2_interface::msg::PlanningParkingDebug& ros2_interface::msg::PlanningParkingDebug::operator =(
        PlanningParkingDebug&& x) noexcept
{

    m_vehicle_preiew_polygon = std::move(x.m_vehicle_preiew_polygon);
    m_obstacles_polygon = std::move(x.m_obstacles_polygon);
    m_path_points = std::move(x.m_path_points);
    m_lat_error = x.m_lat_error;
    m_lon_error = x.m_lon_error;
    m_yaw_error = x.m_yaw_error;
    m_obstacles_vec = std::move(x.m_obstacles_vec);
    m_warm_start_traj = std::move(x.m_warm_start_traj);
    m_smoothed_traj_stage1 = std::move(x.m_smoothed_traj_stage1);
    m_smoothed_traj_stage2 = std::move(x.m_smoothed_traj_stage2);
    m_reference_line = std::move(x.m_reference_line);
    m_trajectory_array = std::move(x.m_trajectory_array);
    m_optimal_coarse_trajectory = std::move(x.m_optimal_coarse_trajectory);
    m_optimal_smooth_trajectory = std::move(x.m_optimal_smooth_trajectory);
    m_hybrid_a_star_map_time = x.m_hybrid_a_star_map_time;
    m_hybrid_a_star_heuristic_time = x.m_hybrid_a_star_heuristic_time;
    m_hybrid_a_star_rs_time = x.m_hybrid_a_star_rs_time;
    m_hybrid_a_star_total_time = x.m_hybrid_a_star_total_time;
    m_ias_collision_avoidance_time = x.m_ias_collision_avoidance_time;
    m_ias_path_smooth_time = x.m_ias_path_smooth_time;
    m_ias_speed_smooth_time = x.m_ias_speed_smooth_time;
    m_ias_total_time = x.m_ias_total_time;
    m_samping_trajectory_time = x.m_samping_trajectory_time;
    m_is_replan = x.m_is_replan;
    m_replan_reason = std::move(x.m_replan_reason);
    m_replan_time = x.m_replan_time;
    m_replan_num = x.m_replan_num;
    m_optimizer_thread_counter = x.m_optimizer_thread_counter;
    m_replan_by_context_update_counter = x.m_replan_by_context_update_counter;
    m_replan_by_large_error_counter = x.m_replan_by_large_error_counter;
    m_parking_type = x.m_parking_type;
    m_moves_counter = x.m_moves_counter;
    m_remain_distance = x.m_remain_distance;
    m_distance_to_leader_obj = x.m_distance_to_leader_obj;
    m_state = x.m_state;

    return *this;
}

bool ros2_interface::msg::PlanningParkingDebug::operator ==(
        const PlanningParkingDebug& x) const
{

    return (m_vehicle_preiew_polygon == x.m_vehicle_preiew_polygon && m_obstacles_polygon == x.m_obstacles_polygon && m_path_points == x.m_path_points && m_lat_error == x.m_lat_error && m_lon_error == x.m_lon_error && m_yaw_error == x.m_yaw_error && m_obstacles_vec == x.m_obstacles_vec && m_warm_start_traj == x.m_warm_start_traj && m_smoothed_traj_stage1 == x.m_smoothed_traj_stage1 && m_smoothed_traj_stage2 == x.m_smoothed_traj_stage2 && m_reference_line == x.m_reference_line && m_trajectory_array == x.m_trajectory_array && m_optimal_coarse_trajectory == x.m_optimal_coarse_trajectory && m_optimal_smooth_trajectory == x.m_optimal_smooth_trajectory && m_hybrid_a_star_map_time == x.m_hybrid_a_star_map_time && m_hybrid_a_star_heuristic_time == x.m_hybrid_a_star_heuristic_time && m_hybrid_a_star_rs_time == x.m_hybrid_a_star_rs_time && m_hybrid_a_star_total_time == x.m_hybrid_a_star_total_time && m_ias_collision_avoidance_time == x.m_ias_collision_avoidance_time && m_ias_path_smooth_time == x.m_ias_path_smooth_time && m_ias_speed_smooth_time == x.m_ias_speed_smooth_time && m_ias_total_time == x.m_ias_total_time && m_samping_trajectory_time == x.m_samping_trajectory_time && m_is_replan == x.m_is_replan && m_replan_reason == x.m_replan_reason && m_replan_time == x.m_replan_time && m_replan_num == x.m_replan_num && m_optimizer_thread_counter == x.m_optimizer_thread_counter && m_replan_by_context_update_counter == x.m_replan_by_context_update_counter && m_replan_by_large_error_counter == x.m_replan_by_large_error_counter && m_parking_type == x.m_parking_type && m_moves_counter == x.m_moves_counter && m_remain_distance == x.m_remain_distance && m_distance_to_leader_obj == x.m_distance_to_leader_obj && m_state == x.m_state);
}

bool ros2_interface::msg::PlanningParkingDebug::operator !=(
        const PlanningParkingDebug& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PlanningParkingDebug::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningParkingDebug_max_cdr_typesize;
}

size_t ros2_interface::msg::PlanningParkingDebug::getCdrSerializedSize(
        const ros2_interface::msg::PlanningParkingDebug& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.vehicle_preiew_polygon().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Polygon2D::getCdrSerializedSize(data.vehicle_preiew_polygon().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.obstacles_polygon().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Polygon2D::getCdrSerializedSize(data.obstacles_polygon().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.path_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::PathPoint::getCdrSerializedSize(data.path_points().at(a), current_alignment);}

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.obstacles_vec().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point2dList::getCdrSerializedSize(data.obstacles_vec().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.warm_start_traj().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryPoint::getCdrSerializedSize(data.warm_start_traj().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.smoothed_traj_stage1().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryPoint::getCdrSerializedSize(data.smoothed_traj_stage1().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.smoothed_traj_stage2().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryPoint::getCdrSerializedSize(data.smoothed_traj_stage2().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::Trajectory::getCdrSerializedSize(data.reference_line(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.trajectory_array().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Trajectory::getCdrSerializedSize(data.trajectory_array().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::Trajectory::getCdrSerializedSize(data.optimal_coarse_trajectory(), current_alignment);
    current_alignment += ros2_interface::msg::Trajectory::getCdrSerializedSize(data.optimal_smooth_trajectory(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.replan_reason().size() + 1;

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PlanningParkingDebug::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_vehicle_preiew_polygon;
    scdr << m_obstacles_polygon;
    scdr << m_path_points;
    scdr << m_lat_error;
    scdr << m_lon_error;
    scdr << m_yaw_error;
    scdr << m_obstacles_vec;
    scdr << m_warm_start_traj;
    scdr << m_smoothed_traj_stage1;
    scdr << m_smoothed_traj_stage2;
    scdr << m_reference_line;
    scdr << m_trajectory_array;
    scdr << m_optimal_coarse_trajectory;
    scdr << m_optimal_smooth_trajectory;
    scdr << m_hybrid_a_star_map_time;
    scdr << m_hybrid_a_star_heuristic_time;
    scdr << m_hybrid_a_star_rs_time;
    scdr << m_hybrid_a_star_total_time;
    scdr << m_ias_collision_avoidance_time;
    scdr << m_ias_path_smooth_time;
    scdr << m_ias_speed_smooth_time;
    scdr << m_ias_total_time;
    scdr << m_samping_trajectory_time;
    scdr << m_is_replan;
    scdr << m_replan_reason.c_str();
    scdr << m_replan_time;
    scdr << m_replan_num;
    scdr << m_optimizer_thread_counter;
    scdr << m_replan_by_context_update_counter;
    scdr << m_replan_by_large_error_counter;
    scdr << m_parking_type;
    scdr << m_moves_counter;
    scdr << m_remain_distance;
    scdr << m_distance_to_leader_obj;
    scdr << m_state;

}

void ros2_interface::msg::PlanningParkingDebug::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_vehicle_preiew_polygon;
    dcdr >> m_obstacles_polygon;
    dcdr >> m_path_points;
    dcdr >> m_lat_error;
    dcdr >> m_lon_error;
    dcdr >> m_yaw_error;
    dcdr >> m_obstacles_vec;
    dcdr >> m_warm_start_traj;
    dcdr >> m_smoothed_traj_stage1;
    dcdr >> m_smoothed_traj_stage2;
    dcdr >> m_reference_line;
    dcdr >> m_trajectory_array;
    dcdr >> m_optimal_coarse_trajectory;
    dcdr >> m_optimal_smooth_trajectory;
    dcdr >> m_hybrid_a_star_map_time;
    dcdr >> m_hybrid_a_star_heuristic_time;
    dcdr >> m_hybrid_a_star_rs_time;
    dcdr >> m_hybrid_a_star_total_time;
    dcdr >> m_ias_collision_avoidance_time;
    dcdr >> m_ias_path_smooth_time;
    dcdr >> m_ias_speed_smooth_time;
    dcdr >> m_ias_total_time;
    dcdr >> m_samping_trajectory_time;
    dcdr >> m_is_replan;
    dcdr >> m_replan_reason;
    dcdr >> m_replan_time;
    dcdr >> m_replan_num;
    dcdr >> m_optimizer_thread_counter;
    dcdr >> m_replan_by_context_update_counter;
    dcdr >> m_replan_by_large_error_counter;
    dcdr >> m_parking_type;
    dcdr >> m_moves_counter;
    dcdr >> m_remain_distance;
    dcdr >> m_distance_to_leader_obj;
    dcdr >> m_state;
}

/*!
 * @brief This function copies the value in member vehicle_preiew_polygon
 * @param _vehicle_preiew_polygon New value to be copied in member vehicle_preiew_polygon
 */
void ros2_interface::msg::PlanningParkingDebug::vehicle_preiew_polygon(
        const std::vector<ros2_interface::msg::Polygon2D>& _vehicle_preiew_polygon)
{
    m_vehicle_preiew_polygon = _vehicle_preiew_polygon;
}

/*!
 * @brief This function moves the value in member vehicle_preiew_polygon
 * @param _vehicle_preiew_polygon New value to be moved in member vehicle_preiew_polygon
 */
void ros2_interface::msg::PlanningParkingDebug::vehicle_preiew_polygon(
        std::vector<ros2_interface::msg::Polygon2D>&& _vehicle_preiew_polygon)
{
    m_vehicle_preiew_polygon = std::move(_vehicle_preiew_polygon);
}

/*!
 * @brief This function returns a constant reference to member vehicle_preiew_polygon
 * @return Constant reference to member vehicle_preiew_polygon
 */
const std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::PlanningParkingDebug::vehicle_preiew_polygon() const
{
    return m_vehicle_preiew_polygon;
}

/*!
 * @brief This function returns a reference to member vehicle_preiew_polygon
 * @return Reference to member vehicle_preiew_polygon
 */
std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::PlanningParkingDebug::vehicle_preiew_polygon()
{
    return m_vehicle_preiew_polygon;
}
/*!
 * @brief This function copies the value in member obstacles_polygon
 * @param _obstacles_polygon New value to be copied in member obstacles_polygon
 */
void ros2_interface::msg::PlanningParkingDebug::obstacles_polygon(
        const std::vector<ros2_interface::msg::Polygon2D>& _obstacles_polygon)
{
    m_obstacles_polygon = _obstacles_polygon;
}

/*!
 * @brief This function moves the value in member obstacles_polygon
 * @param _obstacles_polygon New value to be moved in member obstacles_polygon
 */
void ros2_interface::msg::PlanningParkingDebug::obstacles_polygon(
        std::vector<ros2_interface::msg::Polygon2D>&& _obstacles_polygon)
{
    m_obstacles_polygon = std::move(_obstacles_polygon);
}

/*!
 * @brief This function returns a constant reference to member obstacles_polygon
 * @return Constant reference to member obstacles_polygon
 */
const std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::PlanningParkingDebug::obstacles_polygon() const
{
    return m_obstacles_polygon;
}

/*!
 * @brief This function returns a reference to member obstacles_polygon
 * @return Reference to member obstacles_polygon
 */
std::vector<ros2_interface::msg::Polygon2D>& ros2_interface::msg::PlanningParkingDebug::obstacles_polygon()
{
    return m_obstacles_polygon;
}
/*!
 * @brief This function copies the value in member path_points
 * @param _path_points New value to be copied in member path_points
 */
void ros2_interface::msg::PlanningParkingDebug::path_points(
        const std::vector<ros2_interface::msg::PathPoint>& _path_points)
{
    m_path_points = _path_points;
}

/*!
 * @brief This function moves the value in member path_points
 * @param _path_points New value to be moved in member path_points
 */
void ros2_interface::msg::PlanningParkingDebug::path_points(
        std::vector<ros2_interface::msg::PathPoint>&& _path_points)
{
    m_path_points = std::move(_path_points);
}

/*!
 * @brief This function returns a constant reference to member path_points
 * @return Constant reference to member path_points
 */
const std::vector<ros2_interface::msg::PathPoint>& ros2_interface::msg::PlanningParkingDebug::path_points() const
{
    return m_path_points;
}

/*!
 * @brief This function returns a reference to member path_points
 * @return Reference to member path_points
 */
std::vector<ros2_interface::msg::PathPoint>& ros2_interface::msg::PlanningParkingDebug::path_points()
{
    return m_path_points;
}
/*!
 * @brief This function sets a value in member lat_error
 * @param _lat_error New value for member lat_error
 */
void ros2_interface::msg::PlanningParkingDebug::lat_error(
        double _lat_error)
{
    m_lat_error = _lat_error;
}

/*!
 * @brief This function returns the value of member lat_error
 * @return Value of member lat_error
 */
double ros2_interface::msg::PlanningParkingDebug::lat_error() const
{
    return m_lat_error;
}

/*!
 * @brief This function returns a reference to member lat_error
 * @return Reference to member lat_error
 */
double& ros2_interface::msg::PlanningParkingDebug::lat_error()
{
    return m_lat_error;
}

/*!
 * @brief This function sets a value in member lon_error
 * @param _lon_error New value for member lon_error
 */
void ros2_interface::msg::PlanningParkingDebug::lon_error(
        double _lon_error)
{
    m_lon_error = _lon_error;
}

/*!
 * @brief This function returns the value of member lon_error
 * @return Value of member lon_error
 */
double ros2_interface::msg::PlanningParkingDebug::lon_error() const
{
    return m_lon_error;
}

/*!
 * @brief This function returns a reference to member lon_error
 * @return Reference to member lon_error
 */
double& ros2_interface::msg::PlanningParkingDebug::lon_error()
{
    return m_lon_error;
}

/*!
 * @brief This function sets a value in member yaw_error
 * @param _yaw_error New value for member yaw_error
 */
void ros2_interface::msg::PlanningParkingDebug::yaw_error(
        double _yaw_error)
{
    m_yaw_error = _yaw_error;
}

/*!
 * @brief This function returns the value of member yaw_error
 * @return Value of member yaw_error
 */
double ros2_interface::msg::PlanningParkingDebug::yaw_error() const
{
    return m_yaw_error;
}

/*!
 * @brief This function returns a reference to member yaw_error
 * @return Reference to member yaw_error
 */
double& ros2_interface::msg::PlanningParkingDebug::yaw_error()
{
    return m_yaw_error;
}

/*!
 * @brief This function copies the value in member obstacles_vec
 * @param _obstacles_vec New value to be copied in member obstacles_vec
 */
void ros2_interface::msg::PlanningParkingDebug::obstacles_vec(
        const std::vector<ros2_interface::msg::Point2dList>& _obstacles_vec)
{
    m_obstacles_vec = _obstacles_vec;
}

/*!
 * @brief This function moves the value in member obstacles_vec
 * @param _obstacles_vec New value to be moved in member obstacles_vec
 */
void ros2_interface::msg::PlanningParkingDebug::obstacles_vec(
        std::vector<ros2_interface::msg::Point2dList>&& _obstacles_vec)
{
    m_obstacles_vec = std::move(_obstacles_vec);
}

/*!
 * @brief This function returns a constant reference to member obstacles_vec
 * @return Constant reference to member obstacles_vec
 */
const std::vector<ros2_interface::msg::Point2dList>& ros2_interface::msg::PlanningParkingDebug::obstacles_vec() const
{
    return m_obstacles_vec;
}

/*!
 * @brief This function returns a reference to member obstacles_vec
 * @return Reference to member obstacles_vec
 */
std::vector<ros2_interface::msg::Point2dList>& ros2_interface::msg::PlanningParkingDebug::obstacles_vec()
{
    return m_obstacles_vec;
}
/*!
 * @brief This function copies the value in member warm_start_traj
 * @param _warm_start_traj New value to be copied in member warm_start_traj
 */
void ros2_interface::msg::PlanningParkingDebug::warm_start_traj(
        const std::vector<ros2_interface::msg::TrajectoryPoint>& _warm_start_traj)
{
    m_warm_start_traj = _warm_start_traj;
}

/*!
 * @brief This function moves the value in member warm_start_traj
 * @param _warm_start_traj New value to be moved in member warm_start_traj
 */
void ros2_interface::msg::PlanningParkingDebug::warm_start_traj(
        std::vector<ros2_interface::msg::TrajectoryPoint>&& _warm_start_traj)
{
    m_warm_start_traj = std::move(_warm_start_traj);
}

/*!
 * @brief This function returns a constant reference to member warm_start_traj
 * @return Constant reference to member warm_start_traj
 */
const std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::warm_start_traj() const
{
    return m_warm_start_traj;
}

/*!
 * @brief This function returns a reference to member warm_start_traj
 * @return Reference to member warm_start_traj
 */
std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::warm_start_traj()
{
    return m_warm_start_traj;
}
/*!
 * @brief This function copies the value in member smoothed_traj_stage1
 * @param _smoothed_traj_stage1 New value to be copied in member smoothed_traj_stage1
 */
void ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage1(
        const std::vector<ros2_interface::msg::TrajectoryPoint>& _smoothed_traj_stage1)
{
    m_smoothed_traj_stage1 = _smoothed_traj_stage1;
}

/*!
 * @brief This function moves the value in member smoothed_traj_stage1
 * @param _smoothed_traj_stage1 New value to be moved in member smoothed_traj_stage1
 */
void ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage1(
        std::vector<ros2_interface::msg::TrajectoryPoint>&& _smoothed_traj_stage1)
{
    m_smoothed_traj_stage1 = std::move(_smoothed_traj_stage1);
}

/*!
 * @brief This function returns a constant reference to member smoothed_traj_stage1
 * @return Constant reference to member smoothed_traj_stage1
 */
const std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage1() const
{
    return m_smoothed_traj_stage1;
}

/*!
 * @brief This function returns a reference to member smoothed_traj_stage1
 * @return Reference to member smoothed_traj_stage1
 */
std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage1()
{
    return m_smoothed_traj_stage1;
}
/*!
 * @brief This function copies the value in member smoothed_traj_stage2
 * @param _smoothed_traj_stage2 New value to be copied in member smoothed_traj_stage2
 */
void ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage2(
        const std::vector<ros2_interface::msg::TrajectoryPoint>& _smoothed_traj_stage2)
{
    m_smoothed_traj_stage2 = _smoothed_traj_stage2;
}

/*!
 * @brief This function moves the value in member smoothed_traj_stage2
 * @param _smoothed_traj_stage2 New value to be moved in member smoothed_traj_stage2
 */
void ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage2(
        std::vector<ros2_interface::msg::TrajectoryPoint>&& _smoothed_traj_stage2)
{
    m_smoothed_traj_stage2 = std::move(_smoothed_traj_stage2);
}

/*!
 * @brief This function returns a constant reference to member smoothed_traj_stage2
 * @return Constant reference to member smoothed_traj_stage2
 */
const std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage2() const
{
    return m_smoothed_traj_stage2;
}

/*!
 * @brief This function returns a reference to member smoothed_traj_stage2
 * @return Reference to member smoothed_traj_stage2
 */
std::vector<ros2_interface::msg::TrajectoryPoint>& ros2_interface::msg::PlanningParkingDebug::smoothed_traj_stage2()
{
    return m_smoothed_traj_stage2;
}
/*!
 * @brief This function copies the value in member reference_line
 * @param _reference_line New value to be copied in member reference_line
 */
void ros2_interface::msg::PlanningParkingDebug::reference_line(
        const ros2_interface::msg::Trajectory& _reference_line)
{
    m_reference_line = _reference_line;
}

/*!
 * @brief This function moves the value in member reference_line
 * @param _reference_line New value to be moved in member reference_line
 */
void ros2_interface::msg::PlanningParkingDebug::reference_line(
        ros2_interface::msg::Trajectory&& _reference_line)
{
    m_reference_line = std::move(_reference_line);
}

/*!
 * @brief This function returns a constant reference to member reference_line
 * @return Constant reference to member reference_line
 */
const ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::reference_line() const
{
    return m_reference_line;
}

/*!
 * @brief This function returns a reference to member reference_line
 * @return Reference to member reference_line
 */
ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::reference_line()
{
    return m_reference_line;
}
/*!
 * @brief This function copies the value in member trajectory_array
 * @param _trajectory_array New value to be copied in member trajectory_array
 */
void ros2_interface::msg::PlanningParkingDebug::trajectory_array(
        const std::vector<ros2_interface::msg::Trajectory>& _trajectory_array)
{
    m_trajectory_array = _trajectory_array;
}

/*!
 * @brief This function moves the value in member trajectory_array
 * @param _trajectory_array New value to be moved in member trajectory_array
 */
void ros2_interface::msg::PlanningParkingDebug::trajectory_array(
        std::vector<ros2_interface::msg::Trajectory>&& _trajectory_array)
{
    m_trajectory_array = std::move(_trajectory_array);
}

/*!
 * @brief This function returns a constant reference to member trajectory_array
 * @return Constant reference to member trajectory_array
 */
const std::vector<ros2_interface::msg::Trajectory>& ros2_interface::msg::PlanningParkingDebug::trajectory_array() const
{
    return m_trajectory_array;
}

/*!
 * @brief This function returns a reference to member trajectory_array
 * @return Reference to member trajectory_array
 */
std::vector<ros2_interface::msg::Trajectory>& ros2_interface::msg::PlanningParkingDebug::trajectory_array()
{
    return m_trajectory_array;
}
/*!
 * @brief This function copies the value in member optimal_coarse_trajectory
 * @param _optimal_coarse_trajectory New value to be copied in member optimal_coarse_trajectory
 */
void ros2_interface::msg::PlanningParkingDebug::optimal_coarse_trajectory(
        const ros2_interface::msg::Trajectory& _optimal_coarse_trajectory)
{
    m_optimal_coarse_trajectory = _optimal_coarse_trajectory;
}

/*!
 * @brief This function moves the value in member optimal_coarse_trajectory
 * @param _optimal_coarse_trajectory New value to be moved in member optimal_coarse_trajectory
 */
void ros2_interface::msg::PlanningParkingDebug::optimal_coarse_trajectory(
        ros2_interface::msg::Trajectory&& _optimal_coarse_trajectory)
{
    m_optimal_coarse_trajectory = std::move(_optimal_coarse_trajectory);
}

/*!
 * @brief This function returns a constant reference to member optimal_coarse_trajectory
 * @return Constant reference to member optimal_coarse_trajectory
 */
const ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::optimal_coarse_trajectory() const
{
    return m_optimal_coarse_trajectory;
}

/*!
 * @brief This function returns a reference to member optimal_coarse_trajectory
 * @return Reference to member optimal_coarse_trajectory
 */
ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::optimal_coarse_trajectory()
{
    return m_optimal_coarse_trajectory;
}
/*!
 * @brief This function copies the value in member optimal_smooth_trajectory
 * @param _optimal_smooth_trajectory New value to be copied in member optimal_smooth_trajectory
 */
void ros2_interface::msg::PlanningParkingDebug::optimal_smooth_trajectory(
        const ros2_interface::msg::Trajectory& _optimal_smooth_trajectory)
{
    m_optimal_smooth_trajectory = _optimal_smooth_trajectory;
}

/*!
 * @brief This function moves the value in member optimal_smooth_trajectory
 * @param _optimal_smooth_trajectory New value to be moved in member optimal_smooth_trajectory
 */
void ros2_interface::msg::PlanningParkingDebug::optimal_smooth_trajectory(
        ros2_interface::msg::Trajectory&& _optimal_smooth_trajectory)
{
    m_optimal_smooth_trajectory = std::move(_optimal_smooth_trajectory);
}

/*!
 * @brief This function returns a constant reference to member optimal_smooth_trajectory
 * @return Constant reference to member optimal_smooth_trajectory
 */
const ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::optimal_smooth_trajectory() const
{
    return m_optimal_smooth_trajectory;
}

/*!
 * @brief This function returns a reference to member optimal_smooth_trajectory
 * @return Reference to member optimal_smooth_trajectory
 */
ros2_interface::msg::Trajectory& ros2_interface::msg::PlanningParkingDebug::optimal_smooth_trajectory()
{
    return m_optimal_smooth_trajectory;
}
/*!
 * @brief This function sets a value in member hybrid_a_star_map_time
 * @param _hybrid_a_star_map_time New value for member hybrid_a_star_map_time
 */
void ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_map_time(
        double _hybrid_a_star_map_time)
{
    m_hybrid_a_star_map_time = _hybrid_a_star_map_time;
}

/*!
 * @brief This function returns the value of member hybrid_a_star_map_time
 * @return Value of member hybrid_a_star_map_time
 */
double ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_map_time() const
{
    return m_hybrid_a_star_map_time;
}

/*!
 * @brief This function returns a reference to member hybrid_a_star_map_time
 * @return Reference to member hybrid_a_star_map_time
 */
double& ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_map_time()
{
    return m_hybrid_a_star_map_time;
}

/*!
 * @brief This function sets a value in member hybrid_a_star_heuristic_time
 * @param _hybrid_a_star_heuristic_time New value for member hybrid_a_star_heuristic_time
 */
void ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_heuristic_time(
        double _hybrid_a_star_heuristic_time)
{
    m_hybrid_a_star_heuristic_time = _hybrid_a_star_heuristic_time;
}

/*!
 * @brief This function returns the value of member hybrid_a_star_heuristic_time
 * @return Value of member hybrid_a_star_heuristic_time
 */
double ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_heuristic_time() const
{
    return m_hybrid_a_star_heuristic_time;
}

/*!
 * @brief This function returns a reference to member hybrid_a_star_heuristic_time
 * @return Reference to member hybrid_a_star_heuristic_time
 */
double& ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_heuristic_time()
{
    return m_hybrid_a_star_heuristic_time;
}

/*!
 * @brief This function sets a value in member hybrid_a_star_rs_time
 * @param _hybrid_a_star_rs_time New value for member hybrid_a_star_rs_time
 */
void ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_rs_time(
        double _hybrid_a_star_rs_time)
{
    m_hybrid_a_star_rs_time = _hybrid_a_star_rs_time;
}

/*!
 * @brief This function returns the value of member hybrid_a_star_rs_time
 * @return Value of member hybrid_a_star_rs_time
 */
double ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_rs_time() const
{
    return m_hybrid_a_star_rs_time;
}

/*!
 * @brief This function returns a reference to member hybrid_a_star_rs_time
 * @return Reference to member hybrid_a_star_rs_time
 */
double& ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_rs_time()
{
    return m_hybrid_a_star_rs_time;
}

/*!
 * @brief This function sets a value in member hybrid_a_star_total_time
 * @param _hybrid_a_star_total_time New value for member hybrid_a_star_total_time
 */
void ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_total_time(
        double _hybrid_a_star_total_time)
{
    m_hybrid_a_star_total_time = _hybrid_a_star_total_time;
}

/*!
 * @brief This function returns the value of member hybrid_a_star_total_time
 * @return Value of member hybrid_a_star_total_time
 */
double ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_total_time() const
{
    return m_hybrid_a_star_total_time;
}

/*!
 * @brief This function returns a reference to member hybrid_a_star_total_time
 * @return Reference to member hybrid_a_star_total_time
 */
double& ros2_interface::msg::PlanningParkingDebug::hybrid_a_star_total_time()
{
    return m_hybrid_a_star_total_time;
}

/*!
 * @brief This function sets a value in member ias_collision_avoidance_time
 * @param _ias_collision_avoidance_time New value for member ias_collision_avoidance_time
 */
void ros2_interface::msg::PlanningParkingDebug::ias_collision_avoidance_time(
        double _ias_collision_avoidance_time)
{
    m_ias_collision_avoidance_time = _ias_collision_avoidance_time;
}

/*!
 * @brief This function returns the value of member ias_collision_avoidance_time
 * @return Value of member ias_collision_avoidance_time
 */
double ros2_interface::msg::PlanningParkingDebug::ias_collision_avoidance_time() const
{
    return m_ias_collision_avoidance_time;
}

/*!
 * @brief This function returns a reference to member ias_collision_avoidance_time
 * @return Reference to member ias_collision_avoidance_time
 */
double& ros2_interface::msg::PlanningParkingDebug::ias_collision_avoidance_time()
{
    return m_ias_collision_avoidance_time;
}

/*!
 * @brief This function sets a value in member ias_path_smooth_time
 * @param _ias_path_smooth_time New value for member ias_path_smooth_time
 */
void ros2_interface::msg::PlanningParkingDebug::ias_path_smooth_time(
        double _ias_path_smooth_time)
{
    m_ias_path_smooth_time = _ias_path_smooth_time;
}

/*!
 * @brief This function returns the value of member ias_path_smooth_time
 * @return Value of member ias_path_smooth_time
 */
double ros2_interface::msg::PlanningParkingDebug::ias_path_smooth_time() const
{
    return m_ias_path_smooth_time;
}

/*!
 * @brief This function returns a reference to member ias_path_smooth_time
 * @return Reference to member ias_path_smooth_time
 */
double& ros2_interface::msg::PlanningParkingDebug::ias_path_smooth_time()
{
    return m_ias_path_smooth_time;
}

/*!
 * @brief This function sets a value in member ias_speed_smooth_time
 * @param _ias_speed_smooth_time New value for member ias_speed_smooth_time
 */
void ros2_interface::msg::PlanningParkingDebug::ias_speed_smooth_time(
        double _ias_speed_smooth_time)
{
    m_ias_speed_smooth_time = _ias_speed_smooth_time;
}

/*!
 * @brief This function returns the value of member ias_speed_smooth_time
 * @return Value of member ias_speed_smooth_time
 */
double ros2_interface::msg::PlanningParkingDebug::ias_speed_smooth_time() const
{
    return m_ias_speed_smooth_time;
}

/*!
 * @brief This function returns a reference to member ias_speed_smooth_time
 * @return Reference to member ias_speed_smooth_time
 */
double& ros2_interface::msg::PlanningParkingDebug::ias_speed_smooth_time()
{
    return m_ias_speed_smooth_time;
}

/*!
 * @brief This function sets a value in member ias_total_time
 * @param _ias_total_time New value for member ias_total_time
 */
void ros2_interface::msg::PlanningParkingDebug::ias_total_time(
        double _ias_total_time)
{
    m_ias_total_time = _ias_total_time;
}

/*!
 * @brief This function returns the value of member ias_total_time
 * @return Value of member ias_total_time
 */
double ros2_interface::msg::PlanningParkingDebug::ias_total_time() const
{
    return m_ias_total_time;
}

/*!
 * @brief This function returns a reference to member ias_total_time
 * @return Reference to member ias_total_time
 */
double& ros2_interface::msg::PlanningParkingDebug::ias_total_time()
{
    return m_ias_total_time;
}

/*!
 * @brief This function sets a value in member samping_trajectory_time
 * @param _samping_trajectory_time New value for member samping_trajectory_time
 */
void ros2_interface::msg::PlanningParkingDebug::samping_trajectory_time(
        double _samping_trajectory_time)
{
    m_samping_trajectory_time = _samping_trajectory_time;
}

/*!
 * @brief This function returns the value of member samping_trajectory_time
 * @return Value of member samping_trajectory_time
 */
double ros2_interface::msg::PlanningParkingDebug::samping_trajectory_time() const
{
    return m_samping_trajectory_time;
}

/*!
 * @brief This function returns a reference to member samping_trajectory_time
 * @return Reference to member samping_trajectory_time
 */
double& ros2_interface::msg::PlanningParkingDebug::samping_trajectory_time()
{
    return m_samping_trajectory_time;
}

/*!
 * @brief This function sets a value in member is_replan
 * @param _is_replan New value for member is_replan
 */
void ros2_interface::msg::PlanningParkingDebug::is_replan(
        bool _is_replan)
{
    m_is_replan = _is_replan;
}

/*!
 * @brief This function returns the value of member is_replan
 * @return Value of member is_replan
 */
bool ros2_interface::msg::PlanningParkingDebug::is_replan() const
{
    return m_is_replan;
}

/*!
 * @brief This function returns a reference to member is_replan
 * @return Reference to member is_replan
 */
bool& ros2_interface::msg::PlanningParkingDebug::is_replan()
{
    return m_is_replan;
}

/*!
 * @brief This function copies the value in member replan_reason
 * @param _replan_reason New value to be copied in member replan_reason
 */
void ros2_interface::msg::PlanningParkingDebug::replan_reason(
        const std::string& _replan_reason)
{
    m_replan_reason = _replan_reason;
}

/*!
 * @brief This function moves the value in member replan_reason
 * @param _replan_reason New value to be moved in member replan_reason
 */
void ros2_interface::msg::PlanningParkingDebug::replan_reason(
        std::string&& _replan_reason)
{
    m_replan_reason = std::move(_replan_reason);
}

/*!
 * @brief This function returns a constant reference to member replan_reason
 * @return Constant reference to member replan_reason
 */
const std::string& ros2_interface::msg::PlanningParkingDebug::replan_reason() const
{
    return m_replan_reason;
}

/*!
 * @brief This function returns a reference to member replan_reason
 * @return Reference to member replan_reason
 */
std::string& ros2_interface::msg::PlanningParkingDebug::replan_reason()
{
    return m_replan_reason;
}
/*!
 * @brief This function sets a value in member replan_time
 * @param _replan_time New value for member replan_time
 */
void ros2_interface::msg::PlanningParkingDebug::replan_time(
        double _replan_time)
{
    m_replan_time = _replan_time;
}

/*!
 * @brief This function returns the value of member replan_time
 * @return Value of member replan_time
 */
double ros2_interface::msg::PlanningParkingDebug::replan_time() const
{
    return m_replan_time;
}

/*!
 * @brief This function returns a reference to member replan_time
 * @return Reference to member replan_time
 */
double& ros2_interface::msg::PlanningParkingDebug::replan_time()
{
    return m_replan_time;
}

/*!
 * @brief This function sets a value in member replan_num
 * @param _replan_num New value for member replan_num
 */
void ros2_interface::msg::PlanningParkingDebug::replan_num(
        int32_t _replan_num)
{
    m_replan_num = _replan_num;
}

/*!
 * @brief This function returns the value of member replan_num
 * @return Value of member replan_num
 */
int32_t ros2_interface::msg::PlanningParkingDebug::replan_num() const
{
    return m_replan_num;
}

/*!
 * @brief This function returns a reference to member replan_num
 * @return Reference to member replan_num
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::replan_num()
{
    return m_replan_num;
}

/*!
 * @brief This function sets a value in member optimizer_thread_counter
 * @param _optimizer_thread_counter New value for member optimizer_thread_counter
 */
void ros2_interface::msg::PlanningParkingDebug::optimizer_thread_counter(
        int32_t _optimizer_thread_counter)
{
    m_optimizer_thread_counter = _optimizer_thread_counter;
}

/*!
 * @brief This function returns the value of member optimizer_thread_counter
 * @return Value of member optimizer_thread_counter
 */
int32_t ros2_interface::msg::PlanningParkingDebug::optimizer_thread_counter() const
{
    return m_optimizer_thread_counter;
}

/*!
 * @brief This function returns a reference to member optimizer_thread_counter
 * @return Reference to member optimizer_thread_counter
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::optimizer_thread_counter()
{
    return m_optimizer_thread_counter;
}

/*!
 * @brief This function sets a value in member replan_by_context_update_counter
 * @param _replan_by_context_update_counter New value for member replan_by_context_update_counter
 */
void ros2_interface::msg::PlanningParkingDebug::replan_by_context_update_counter(
        int32_t _replan_by_context_update_counter)
{
    m_replan_by_context_update_counter = _replan_by_context_update_counter;
}

/*!
 * @brief This function returns the value of member replan_by_context_update_counter
 * @return Value of member replan_by_context_update_counter
 */
int32_t ros2_interface::msg::PlanningParkingDebug::replan_by_context_update_counter() const
{
    return m_replan_by_context_update_counter;
}

/*!
 * @brief This function returns a reference to member replan_by_context_update_counter
 * @return Reference to member replan_by_context_update_counter
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::replan_by_context_update_counter()
{
    return m_replan_by_context_update_counter;
}

/*!
 * @brief This function sets a value in member replan_by_large_error_counter
 * @param _replan_by_large_error_counter New value for member replan_by_large_error_counter
 */
void ros2_interface::msg::PlanningParkingDebug::replan_by_large_error_counter(
        int32_t _replan_by_large_error_counter)
{
    m_replan_by_large_error_counter = _replan_by_large_error_counter;
}

/*!
 * @brief This function returns the value of member replan_by_large_error_counter
 * @return Value of member replan_by_large_error_counter
 */
int32_t ros2_interface::msg::PlanningParkingDebug::replan_by_large_error_counter() const
{
    return m_replan_by_large_error_counter;
}

/*!
 * @brief This function returns a reference to member replan_by_large_error_counter
 * @return Reference to member replan_by_large_error_counter
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::replan_by_large_error_counter()
{
    return m_replan_by_large_error_counter;
}

/*!
 * @brief This function sets a value in member parking_type
 * @param _parking_type New value for member parking_type
 */
void ros2_interface::msg::PlanningParkingDebug::parking_type(
        int32_t _parking_type)
{
    m_parking_type = _parking_type;
}

/*!
 * @brief This function returns the value of member parking_type
 * @return Value of member parking_type
 */
int32_t ros2_interface::msg::PlanningParkingDebug::parking_type() const
{
    return m_parking_type;
}

/*!
 * @brief This function returns a reference to member parking_type
 * @return Reference to member parking_type
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::parking_type()
{
    return m_parking_type;
}

/*!
 * @brief This function sets a value in member moves_counter
 * @param _moves_counter New value for member moves_counter
 */
void ros2_interface::msg::PlanningParkingDebug::moves_counter(
        int32_t _moves_counter)
{
    m_moves_counter = _moves_counter;
}

/*!
 * @brief This function returns the value of member moves_counter
 * @return Value of member moves_counter
 */
int32_t ros2_interface::msg::PlanningParkingDebug::moves_counter() const
{
    return m_moves_counter;
}

/*!
 * @brief This function returns a reference to member moves_counter
 * @return Reference to member moves_counter
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::moves_counter()
{
    return m_moves_counter;
}

/*!
 * @brief This function sets a value in member remain_distance
 * @param _remain_distance New value for member remain_distance
 */
void ros2_interface::msg::PlanningParkingDebug::remain_distance(
        double _remain_distance)
{
    m_remain_distance = _remain_distance;
}

/*!
 * @brief This function returns the value of member remain_distance
 * @return Value of member remain_distance
 */
double ros2_interface::msg::PlanningParkingDebug::remain_distance() const
{
    return m_remain_distance;
}

/*!
 * @brief This function returns a reference to member remain_distance
 * @return Reference to member remain_distance
 */
double& ros2_interface::msg::PlanningParkingDebug::remain_distance()
{
    return m_remain_distance;
}

/*!
 * @brief This function sets a value in member distance_to_leader_obj
 * @param _distance_to_leader_obj New value for member distance_to_leader_obj
 */
void ros2_interface::msg::PlanningParkingDebug::distance_to_leader_obj(
        double _distance_to_leader_obj)
{
    m_distance_to_leader_obj = _distance_to_leader_obj;
}

/*!
 * @brief This function returns the value of member distance_to_leader_obj
 * @return Value of member distance_to_leader_obj
 */
double ros2_interface::msg::PlanningParkingDebug::distance_to_leader_obj() const
{
    return m_distance_to_leader_obj;
}

/*!
 * @brief This function returns a reference to member distance_to_leader_obj
 * @return Reference to member distance_to_leader_obj
 */
double& ros2_interface::msg::PlanningParkingDebug::distance_to_leader_obj()
{
    return m_distance_to_leader_obj;
}

/*!
 * @brief This function sets a value in member state
 * @param _state New value for member state
 */
void ros2_interface::msg::PlanningParkingDebug::state(
        int32_t _state)
{
    m_state = _state;
}

/*!
 * @brief This function returns the value of member state
 * @return Value of member state
 */
int32_t ros2_interface::msg::PlanningParkingDebug::state() const
{
    return m_state;
}

/*!
 * @brief This function returns a reference to member state
 * @return Reference to member state
 */
int32_t& ros2_interface::msg::PlanningParkingDebug::state()
{
    return m_state;
}



size_t ros2_interface::msg::PlanningParkingDebug::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PlanningParkingDebug_max_key_cdr_typesize;
}

bool ros2_interface::msg::PlanningParkingDebug::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PlanningParkingDebug::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



