// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningParkingDebug.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGPARKINGDEBUG_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGPARKINGDEBUG_H_

#include "Trajectory.h"
#include "Polygon2D.h"
#include "Point2dList.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PLANNINGPARKINGDEBUG_SOURCE)
#define PLANNINGPARKINGDEBUG_DllAPI __declspec( dllexport )
#else
#define PLANNINGPARKINGDEBUG_DllAPI __declspec( dllimport )
#endif // PLANNINGPARKINGDEBUG_SOURCE
#else
#define PLANNINGPARKINGDEBUG_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PLANNINGPARKINGDEBUG_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PlanningParkingDebug defined by the user in the IDL file.
         * @ingroup PlanningParkingDebug
         */
        class PlanningParkingDebug
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PlanningParkingDebug();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PlanningParkingDebug();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PlanningParkingDebug that will be copied.
             */
            eProsima_user_DllExport PlanningParkingDebug(
                    const PlanningParkingDebug& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PlanningParkingDebug that will be copied.
             */
            eProsima_user_DllExport PlanningParkingDebug(
                    PlanningParkingDebug&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PlanningParkingDebug that will be copied.
             */
            eProsima_user_DllExport PlanningParkingDebug& operator =(
                    const PlanningParkingDebug& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PlanningParkingDebug that will be copied.
             */
            eProsima_user_DllExport PlanningParkingDebug& operator =(
                    PlanningParkingDebug&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PlanningParkingDebug object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PlanningParkingDebug& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PlanningParkingDebug object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PlanningParkingDebug& x) const;

            /*!
             * @brief This function copies the value in member vehicle_preiew_polygon
             * @param _vehicle_preiew_polygon New value to be copied in member vehicle_preiew_polygon
             */
            eProsima_user_DllExport void vehicle_preiew_polygon(
                    const std::vector<ros2_interface::msg::Polygon2D>& _vehicle_preiew_polygon);

            /*!
             * @brief This function moves the value in member vehicle_preiew_polygon
             * @param _vehicle_preiew_polygon New value to be moved in member vehicle_preiew_polygon
             */
            eProsima_user_DllExport void vehicle_preiew_polygon(
                    std::vector<ros2_interface::msg::Polygon2D>&& _vehicle_preiew_polygon);

            /*!
             * @brief This function returns a constant reference to member vehicle_preiew_polygon
             * @return Constant reference to member vehicle_preiew_polygon
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Polygon2D>& vehicle_preiew_polygon() const;

            /*!
             * @brief This function returns a reference to member vehicle_preiew_polygon
             * @return Reference to member vehicle_preiew_polygon
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Polygon2D>& vehicle_preiew_polygon();
            /*!
             * @brief This function copies the value in member obstacles_polygon
             * @param _obstacles_polygon New value to be copied in member obstacles_polygon
             */
            eProsima_user_DllExport void obstacles_polygon(
                    const std::vector<ros2_interface::msg::Polygon2D>& _obstacles_polygon);

            /*!
             * @brief This function moves the value in member obstacles_polygon
             * @param _obstacles_polygon New value to be moved in member obstacles_polygon
             */
            eProsima_user_DllExport void obstacles_polygon(
                    std::vector<ros2_interface::msg::Polygon2D>&& _obstacles_polygon);

            /*!
             * @brief This function returns a constant reference to member obstacles_polygon
             * @return Constant reference to member obstacles_polygon
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Polygon2D>& obstacles_polygon() const;

            /*!
             * @brief This function returns a reference to member obstacles_polygon
             * @return Reference to member obstacles_polygon
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Polygon2D>& obstacles_polygon();
            /*!
             * @brief This function copies the value in member path_points
             * @param _path_points New value to be copied in member path_points
             */
            eProsima_user_DllExport void path_points(
                    const std::vector<ros2_interface::msg::PathPoint>& _path_points);

            /*!
             * @brief This function moves the value in member path_points
             * @param _path_points New value to be moved in member path_points
             */
            eProsima_user_DllExport void path_points(
                    std::vector<ros2_interface::msg::PathPoint>&& _path_points);

            /*!
             * @brief This function returns a constant reference to member path_points
             * @return Constant reference to member path_points
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::PathPoint>& path_points() const;

            /*!
             * @brief This function returns a reference to member path_points
             * @return Reference to member path_points
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::PathPoint>& path_points();
            /*!
             * @brief This function sets a value in member lat_error
             * @param _lat_error New value for member lat_error
             */
            eProsima_user_DllExport void lat_error(
                    double _lat_error);

            /*!
             * @brief This function returns the value of member lat_error
             * @return Value of member lat_error
             */
            eProsima_user_DllExport double lat_error() const;

            /*!
             * @brief This function returns a reference to member lat_error
             * @return Reference to member lat_error
             */
            eProsima_user_DllExport double& lat_error();

            /*!
             * @brief This function sets a value in member lon_error
             * @param _lon_error New value for member lon_error
             */
            eProsima_user_DllExport void lon_error(
                    double _lon_error);

            /*!
             * @brief This function returns the value of member lon_error
             * @return Value of member lon_error
             */
            eProsima_user_DllExport double lon_error() const;

            /*!
             * @brief This function returns a reference to member lon_error
             * @return Reference to member lon_error
             */
            eProsima_user_DllExport double& lon_error();

            /*!
             * @brief This function sets a value in member yaw_error
             * @param _yaw_error New value for member yaw_error
             */
            eProsima_user_DllExport void yaw_error(
                    double _yaw_error);

            /*!
             * @brief This function returns the value of member yaw_error
             * @return Value of member yaw_error
             */
            eProsima_user_DllExport double yaw_error() const;

            /*!
             * @brief This function returns a reference to member yaw_error
             * @return Reference to member yaw_error
             */
            eProsima_user_DllExport double& yaw_error();

            /*!
             * @brief This function copies the value in member obstacles_vec
             * @param _obstacles_vec New value to be copied in member obstacles_vec
             */
            eProsima_user_DllExport void obstacles_vec(
                    const std::vector<ros2_interface::msg::Point2dList>& _obstacles_vec);

            /*!
             * @brief This function moves the value in member obstacles_vec
             * @param _obstacles_vec New value to be moved in member obstacles_vec
             */
            eProsima_user_DllExport void obstacles_vec(
                    std::vector<ros2_interface::msg::Point2dList>&& _obstacles_vec);

            /*!
             * @brief This function returns a constant reference to member obstacles_vec
             * @return Constant reference to member obstacles_vec
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point2dList>& obstacles_vec() const;

            /*!
             * @brief This function returns a reference to member obstacles_vec
             * @return Reference to member obstacles_vec
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point2dList>& obstacles_vec();
            /*!
             * @brief This function copies the value in member warm_start_traj
             * @param _warm_start_traj New value to be copied in member warm_start_traj
             */
            eProsima_user_DllExport void warm_start_traj(
                    const std::vector<ros2_interface::msg::TrajectoryPoint>& _warm_start_traj);

            /*!
             * @brief This function moves the value in member warm_start_traj
             * @param _warm_start_traj New value to be moved in member warm_start_traj
             */
            eProsima_user_DllExport void warm_start_traj(
                    std::vector<ros2_interface::msg::TrajectoryPoint>&& _warm_start_traj);

            /*!
             * @brief This function returns a constant reference to member warm_start_traj
             * @return Constant reference to member warm_start_traj
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryPoint>& warm_start_traj() const;

            /*!
             * @brief This function returns a reference to member warm_start_traj
             * @return Reference to member warm_start_traj
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryPoint>& warm_start_traj();
            /*!
             * @brief This function copies the value in member smoothed_traj_stage1
             * @param _smoothed_traj_stage1 New value to be copied in member smoothed_traj_stage1
             */
            eProsima_user_DllExport void smoothed_traj_stage1(
                    const std::vector<ros2_interface::msg::TrajectoryPoint>& _smoothed_traj_stage1);

            /*!
             * @brief This function moves the value in member smoothed_traj_stage1
             * @param _smoothed_traj_stage1 New value to be moved in member smoothed_traj_stage1
             */
            eProsima_user_DllExport void smoothed_traj_stage1(
                    std::vector<ros2_interface::msg::TrajectoryPoint>&& _smoothed_traj_stage1);

            /*!
             * @brief This function returns a constant reference to member smoothed_traj_stage1
             * @return Constant reference to member smoothed_traj_stage1
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryPoint>& smoothed_traj_stage1() const;

            /*!
             * @brief This function returns a reference to member smoothed_traj_stage1
             * @return Reference to member smoothed_traj_stage1
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryPoint>& smoothed_traj_stage1();
            /*!
             * @brief This function copies the value in member smoothed_traj_stage2
             * @param _smoothed_traj_stage2 New value to be copied in member smoothed_traj_stage2
             */
            eProsima_user_DllExport void smoothed_traj_stage2(
                    const std::vector<ros2_interface::msg::TrajectoryPoint>& _smoothed_traj_stage2);

            /*!
             * @brief This function moves the value in member smoothed_traj_stage2
             * @param _smoothed_traj_stage2 New value to be moved in member smoothed_traj_stage2
             */
            eProsima_user_DllExport void smoothed_traj_stage2(
                    std::vector<ros2_interface::msg::TrajectoryPoint>&& _smoothed_traj_stage2);

            /*!
             * @brief This function returns a constant reference to member smoothed_traj_stage2
             * @return Constant reference to member smoothed_traj_stage2
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryPoint>& smoothed_traj_stage2() const;

            /*!
             * @brief This function returns a reference to member smoothed_traj_stage2
             * @return Reference to member smoothed_traj_stage2
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryPoint>& smoothed_traj_stage2();
            /*!
             * @brief This function copies the value in member reference_line
             * @param _reference_line New value to be copied in member reference_line
             */
            eProsima_user_DllExport void reference_line(
                    const ros2_interface::msg::Trajectory& _reference_line);

            /*!
             * @brief This function moves the value in member reference_line
             * @param _reference_line New value to be moved in member reference_line
             */
            eProsima_user_DllExport void reference_line(
                    ros2_interface::msg::Trajectory&& _reference_line);

            /*!
             * @brief This function returns a constant reference to member reference_line
             * @return Constant reference to member reference_line
             */
            eProsima_user_DllExport const ros2_interface::msg::Trajectory& reference_line() const;

            /*!
             * @brief This function returns a reference to member reference_line
             * @return Reference to member reference_line
             */
            eProsima_user_DllExport ros2_interface::msg::Trajectory& reference_line();
            /*!
             * @brief This function copies the value in member trajectory_array
             * @param _trajectory_array New value to be copied in member trajectory_array
             */
            eProsima_user_DllExport void trajectory_array(
                    const std::vector<ros2_interface::msg::Trajectory>& _trajectory_array);

            /*!
             * @brief This function moves the value in member trajectory_array
             * @param _trajectory_array New value to be moved in member trajectory_array
             */
            eProsima_user_DllExport void trajectory_array(
                    std::vector<ros2_interface::msg::Trajectory>&& _trajectory_array);

            /*!
             * @brief This function returns a constant reference to member trajectory_array
             * @return Constant reference to member trajectory_array
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Trajectory>& trajectory_array() const;

            /*!
             * @brief This function returns a reference to member trajectory_array
             * @return Reference to member trajectory_array
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Trajectory>& trajectory_array();
            /*!
             * @brief This function copies the value in member optimal_coarse_trajectory
             * @param _optimal_coarse_trajectory New value to be copied in member optimal_coarse_trajectory
             */
            eProsima_user_DllExport void optimal_coarse_trajectory(
                    const ros2_interface::msg::Trajectory& _optimal_coarse_trajectory);

            /*!
             * @brief This function moves the value in member optimal_coarse_trajectory
             * @param _optimal_coarse_trajectory New value to be moved in member optimal_coarse_trajectory
             */
            eProsima_user_DllExport void optimal_coarse_trajectory(
                    ros2_interface::msg::Trajectory&& _optimal_coarse_trajectory);

            /*!
             * @brief This function returns a constant reference to member optimal_coarse_trajectory
             * @return Constant reference to member optimal_coarse_trajectory
             */
            eProsima_user_DllExport const ros2_interface::msg::Trajectory& optimal_coarse_trajectory() const;

            /*!
             * @brief This function returns a reference to member optimal_coarse_trajectory
             * @return Reference to member optimal_coarse_trajectory
             */
            eProsima_user_DllExport ros2_interface::msg::Trajectory& optimal_coarse_trajectory();
            /*!
             * @brief This function copies the value in member optimal_smooth_trajectory
             * @param _optimal_smooth_trajectory New value to be copied in member optimal_smooth_trajectory
             */
            eProsima_user_DllExport void optimal_smooth_trajectory(
                    const ros2_interface::msg::Trajectory& _optimal_smooth_trajectory);

            /*!
             * @brief This function moves the value in member optimal_smooth_trajectory
             * @param _optimal_smooth_trajectory New value to be moved in member optimal_smooth_trajectory
             */
            eProsima_user_DllExport void optimal_smooth_trajectory(
                    ros2_interface::msg::Trajectory&& _optimal_smooth_trajectory);

            /*!
             * @brief This function returns a constant reference to member optimal_smooth_trajectory
             * @return Constant reference to member optimal_smooth_trajectory
             */
            eProsima_user_DllExport const ros2_interface::msg::Trajectory& optimal_smooth_trajectory() const;

            /*!
             * @brief This function returns a reference to member optimal_smooth_trajectory
             * @return Reference to member optimal_smooth_trajectory
             */
            eProsima_user_DllExport ros2_interface::msg::Trajectory& optimal_smooth_trajectory();
            /*!
             * @brief This function sets a value in member hybrid_a_star_map_time
             * @param _hybrid_a_star_map_time New value for member hybrid_a_star_map_time
             */
            eProsima_user_DllExport void hybrid_a_star_map_time(
                    double _hybrid_a_star_map_time);

            /*!
             * @brief This function returns the value of member hybrid_a_star_map_time
             * @return Value of member hybrid_a_star_map_time
             */
            eProsima_user_DllExport double hybrid_a_star_map_time() const;

            /*!
             * @brief This function returns a reference to member hybrid_a_star_map_time
             * @return Reference to member hybrid_a_star_map_time
             */
            eProsima_user_DllExport double& hybrid_a_star_map_time();

            /*!
             * @brief This function sets a value in member hybrid_a_star_heuristic_time
             * @param _hybrid_a_star_heuristic_time New value for member hybrid_a_star_heuristic_time
             */
            eProsima_user_DllExport void hybrid_a_star_heuristic_time(
                    double _hybrid_a_star_heuristic_time);

            /*!
             * @brief This function returns the value of member hybrid_a_star_heuristic_time
             * @return Value of member hybrid_a_star_heuristic_time
             */
            eProsima_user_DllExport double hybrid_a_star_heuristic_time() const;

            /*!
             * @brief This function returns a reference to member hybrid_a_star_heuristic_time
             * @return Reference to member hybrid_a_star_heuristic_time
             */
            eProsima_user_DllExport double& hybrid_a_star_heuristic_time();

            /*!
             * @brief This function sets a value in member hybrid_a_star_rs_time
             * @param _hybrid_a_star_rs_time New value for member hybrid_a_star_rs_time
             */
            eProsima_user_DllExport void hybrid_a_star_rs_time(
                    double _hybrid_a_star_rs_time);

            /*!
             * @brief This function returns the value of member hybrid_a_star_rs_time
             * @return Value of member hybrid_a_star_rs_time
             */
            eProsima_user_DllExport double hybrid_a_star_rs_time() const;

            /*!
             * @brief This function returns a reference to member hybrid_a_star_rs_time
             * @return Reference to member hybrid_a_star_rs_time
             */
            eProsima_user_DllExport double& hybrid_a_star_rs_time();

            /*!
             * @brief This function sets a value in member hybrid_a_star_total_time
             * @param _hybrid_a_star_total_time New value for member hybrid_a_star_total_time
             */
            eProsima_user_DllExport void hybrid_a_star_total_time(
                    double _hybrid_a_star_total_time);

            /*!
             * @brief This function returns the value of member hybrid_a_star_total_time
             * @return Value of member hybrid_a_star_total_time
             */
            eProsima_user_DllExport double hybrid_a_star_total_time() const;

            /*!
             * @brief This function returns a reference to member hybrid_a_star_total_time
             * @return Reference to member hybrid_a_star_total_time
             */
            eProsima_user_DllExport double& hybrid_a_star_total_time();

            /*!
             * @brief This function sets a value in member ias_collision_avoidance_time
             * @param _ias_collision_avoidance_time New value for member ias_collision_avoidance_time
             */
            eProsima_user_DllExport void ias_collision_avoidance_time(
                    double _ias_collision_avoidance_time);

            /*!
             * @brief This function returns the value of member ias_collision_avoidance_time
             * @return Value of member ias_collision_avoidance_time
             */
            eProsima_user_DllExport double ias_collision_avoidance_time() const;

            /*!
             * @brief This function returns a reference to member ias_collision_avoidance_time
             * @return Reference to member ias_collision_avoidance_time
             */
            eProsima_user_DllExport double& ias_collision_avoidance_time();

            /*!
             * @brief This function sets a value in member ias_path_smooth_time
             * @param _ias_path_smooth_time New value for member ias_path_smooth_time
             */
            eProsima_user_DllExport void ias_path_smooth_time(
                    double _ias_path_smooth_time);

            /*!
             * @brief This function returns the value of member ias_path_smooth_time
             * @return Value of member ias_path_smooth_time
             */
            eProsima_user_DllExport double ias_path_smooth_time() const;

            /*!
             * @brief This function returns a reference to member ias_path_smooth_time
             * @return Reference to member ias_path_smooth_time
             */
            eProsima_user_DllExport double& ias_path_smooth_time();

            /*!
             * @brief This function sets a value in member ias_speed_smooth_time
             * @param _ias_speed_smooth_time New value for member ias_speed_smooth_time
             */
            eProsima_user_DllExport void ias_speed_smooth_time(
                    double _ias_speed_smooth_time);

            /*!
             * @brief This function returns the value of member ias_speed_smooth_time
             * @return Value of member ias_speed_smooth_time
             */
            eProsima_user_DllExport double ias_speed_smooth_time() const;

            /*!
             * @brief This function returns a reference to member ias_speed_smooth_time
             * @return Reference to member ias_speed_smooth_time
             */
            eProsima_user_DllExport double& ias_speed_smooth_time();

            /*!
             * @brief This function sets a value in member ias_total_time
             * @param _ias_total_time New value for member ias_total_time
             */
            eProsima_user_DllExport void ias_total_time(
                    double _ias_total_time);

            /*!
             * @brief This function returns the value of member ias_total_time
             * @return Value of member ias_total_time
             */
            eProsima_user_DllExport double ias_total_time() const;

            /*!
             * @brief This function returns a reference to member ias_total_time
             * @return Reference to member ias_total_time
             */
            eProsima_user_DllExport double& ias_total_time();

            /*!
             * @brief This function sets a value in member samping_trajectory_time
             * @param _samping_trajectory_time New value for member samping_trajectory_time
             */
            eProsima_user_DllExport void samping_trajectory_time(
                    double _samping_trajectory_time);

            /*!
             * @brief This function returns the value of member samping_trajectory_time
             * @return Value of member samping_trajectory_time
             */
            eProsima_user_DllExport double samping_trajectory_time() const;

            /*!
             * @brief This function returns a reference to member samping_trajectory_time
             * @return Reference to member samping_trajectory_time
             */
            eProsima_user_DllExport double& samping_trajectory_time();

            /*!
             * @brief This function sets a value in member is_replan
             * @param _is_replan New value for member is_replan
             */
            eProsima_user_DllExport void is_replan(
                    bool _is_replan);

            /*!
             * @brief This function returns the value of member is_replan
             * @return Value of member is_replan
             */
            eProsima_user_DllExport bool is_replan() const;

            /*!
             * @brief This function returns a reference to member is_replan
             * @return Reference to member is_replan
             */
            eProsima_user_DllExport bool& is_replan();

            /*!
             * @brief This function copies the value in member replan_reason
             * @param _replan_reason New value to be copied in member replan_reason
             */
            eProsima_user_DllExport void replan_reason(
                    const std::string& _replan_reason);

            /*!
             * @brief This function moves the value in member replan_reason
             * @param _replan_reason New value to be moved in member replan_reason
             */
            eProsima_user_DllExport void replan_reason(
                    std::string&& _replan_reason);

            /*!
             * @brief This function returns a constant reference to member replan_reason
             * @return Constant reference to member replan_reason
             */
            eProsima_user_DllExport const std::string& replan_reason() const;

            /*!
             * @brief This function returns a reference to member replan_reason
             * @return Reference to member replan_reason
             */
            eProsima_user_DllExport std::string& replan_reason();
            /*!
             * @brief This function sets a value in member replan_time
             * @param _replan_time New value for member replan_time
             */
            eProsima_user_DllExport void replan_time(
                    double _replan_time);

            /*!
             * @brief This function returns the value of member replan_time
             * @return Value of member replan_time
             */
            eProsima_user_DllExport double replan_time() const;

            /*!
             * @brief This function returns a reference to member replan_time
             * @return Reference to member replan_time
             */
            eProsima_user_DllExport double& replan_time();

            /*!
             * @brief This function sets a value in member replan_num
             * @param _replan_num New value for member replan_num
             */
            eProsima_user_DllExport void replan_num(
                    int32_t _replan_num);

            /*!
             * @brief This function returns the value of member replan_num
             * @return Value of member replan_num
             */
            eProsima_user_DllExport int32_t replan_num() const;

            /*!
             * @brief This function returns a reference to member replan_num
             * @return Reference to member replan_num
             */
            eProsima_user_DllExport int32_t& replan_num();

            /*!
             * @brief This function sets a value in member optimizer_thread_counter
             * @param _optimizer_thread_counter New value for member optimizer_thread_counter
             */
            eProsima_user_DllExport void optimizer_thread_counter(
                    int32_t _optimizer_thread_counter);

            /*!
             * @brief This function returns the value of member optimizer_thread_counter
             * @return Value of member optimizer_thread_counter
             */
            eProsima_user_DllExport int32_t optimizer_thread_counter() const;

            /*!
             * @brief This function returns a reference to member optimizer_thread_counter
             * @return Reference to member optimizer_thread_counter
             */
            eProsima_user_DllExport int32_t& optimizer_thread_counter();

            /*!
             * @brief This function sets a value in member replan_by_context_update_counter
             * @param _replan_by_context_update_counter New value for member replan_by_context_update_counter
             */
            eProsima_user_DllExport void replan_by_context_update_counter(
                    int32_t _replan_by_context_update_counter);

            /*!
             * @brief This function returns the value of member replan_by_context_update_counter
             * @return Value of member replan_by_context_update_counter
             */
            eProsima_user_DllExport int32_t replan_by_context_update_counter() const;

            /*!
             * @brief This function returns a reference to member replan_by_context_update_counter
             * @return Reference to member replan_by_context_update_counter
             */
            eProsima_user_DllExport int32_t& replan_by_context_update_counter();

            /*!
             * @brief This function sets a value in member replan_by_large_error_counter
             * @param _replan_by_large_error_counter New value for member replan_by_large_error_counter
             */
            eProsima_user_DllExport void replan_by_large_error_counter(
                    int32_t _replan_by_large_error_counter);

            /*!
             * @brief This function returns the value of member replan_by_large_error_counter
             * @return Value of member replan_by_large_error_counter
             */
            eProsima_user_DllExport int32_t replan_by_large_error_counter() const;

            /*!
             * @brief This function returns a reference to member replan_by_large_error_counter
             * @return Reference to member replan_by_large_error_counter
             */
            eProsima_user_DllExport int32_t& replan_by_large_error_counter();

            /*!
             * @brief This function sets a value in member parking_type
             * @param _parking_type New value for member parking_type
             */
            eProsima_user_DllExport void parking_type(
                    int32_t _parking_type);

            /*!
             * @brief This function returns the value of member parking_type
             * @return Value of member parking_type
             */
            eProsima_user_DllExport int32_t parking_type() const;

            /*!
             * @brief This function returns a reference to member parking_type
             * @return Reference to member parking_type
             */
            eProsima_user_DllExport int32_t& parking_type();

            /*!
             * @brief This function sets a value in member moves_counter
             * @param _moves_counter New value for member moves_counter
             */
            eProsima_user_DllExport void moves_counter(
                    int32_t _moves_counter);

            /*!
             * @brief This function returns the value of member moves_counter
             * @return Value of member moves_counter
             */
            eProsima_user_DllExport int32_t moves_counter() const;

            /*!
             * @brief This function returns a reference to member moves_counter
             * @return Reference to member moves_counter
             */
            eProsima_user_DllExport int32_t& moves_counter();

            /*!
             * @brief This function sets a value in member remain_distance
             * @param _remain_distance New value for member remain_distance
             */
            eProsima_user_DllExport void remain_distance(
                    double _remain_distance);

            /*!
             * @brief This function returns the value of member remain_distance
             * @return Value of member remain_distance
             */
            eProsima_user_DllExport double remain_distance() const;

            /*!
             * @brief This function returns a reference to member remain_distance
             * @return Reference to member remain_distance
             */
            eProsima_user_DllExport double& remain_distance();

            /*!
             * @brief This function sets a value in member distance_to_leader_obj
             * @param _distance_to_leader_obj New value for member distance_to_leader_obj
             */
            eProsima_user_DllExport void distance_to_leader_obj(
                    double _distance_to_leader_obj);

            /*!
             * @brief This function returns the value of member distance_to_leader_obj
             * @return Value of member distance_to_leader_obj
             */
            eProsima_user_DllExport double distance_to_leader_obj() const;

            /*!
             * @brief This function returns a reference to member distance_to_leader_obj
             * @return Reference to member distance_to_leader_obj
             */
            eProsima_user_DllExport double& distance_to_leader_obj();

            /*!
             * @brief This function sets a value in member state
             * @param _state New value for member state
             */
            eProsima_user_DllExport void state(
                    int32_t _state);

            /*!
             * @brief This function returns the value of member state
             * @return Value of member state
             */
            eProsima_user_DllExport int32_t state() const;

            /*!
             * @brief This function returns a reference to member state
             * @return Reference to member state
             */
            eProsima_user_DllExport int32_t& state();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PlanningParkingDebug& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::vector<ros2_interface::msg::Polygon2D> m_vehicle_preiew_polygon;
            std::vector<ros2_interface::msg::Polygon2D> m_obstacles_polygon;
            std::vector<ros2_interface::msg::PathPoint> m_path_points;
            double m_lat_error;
            double m_lon_error;
            double m_yaw_error;
            std::vector<ros2_interface::msg::Point2dList> m_obstacles_vec;
            std::vector<ros2_interface::msg::TrajectoryPoint> m_warm_start_traj;
            std::vector<ros2_interface::msg::TrajectoryPoint> m_smoothed_traj_stage1;
            std::vector<ros2_interface::msg::TrajectoryPoint> m_smoothed_traj_stage2;
            ros2_interface::msg::Trajectory m_reference_line;
            std::vector<ros2_interface::msg::Trajectory> m_trajectory_array;
            ros2_interface::msg::Trajectory m_optimal_coarse_trajectory;
            ros2_interface::msg::Trajectory m_optimal_smooth_trajectory;
            double m_hybrid_a_star_map_time;
            double m_hybrid_a_star_heuristic_time;
            double m_hybrid_a_star_rs_time;
            double m_hybrid_a_star_total_time;
            double m_ias_collision_avoidance_time;
            double m_ias_path_smooth_time;
            double m_ias_speed_smooth_time;
            double m_ias_total_time;
            double m_samping_trajectory_time;
            bool m_is_replan;
            std::string m_replan_reason;
            double m_replan_time;
            int32_t m_replan_num;
            int32_t m_optimizer_thread_counter;
            int32_t m_replan_by_context_update_counter;
            int32_t m_replan_by_large_error_counter;
            int32_t m_parking_type;
            int32_t m_moves_counter;
            double m_remain_distance;
            double m_distance_to_leader_obj;
            int32_t m_state;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PLANNINGPARKINGDEBUG_H_

