// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PlanningParkingDebugTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PlanningParkingDebug.h"
#include "PlanningParkingDebugTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPlanningParkingDebugTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(true),
                        ros2_interface::msg::GetPolygon2DObject(true));
                factory->add_type_object("ros2_interface::msg::Polygon2D", ros2_interface::msg::GetPolygon2DIdentifier(false),
                        ros2_interface::msg::GetPolygon2DObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::Trajectory", ros2_interface::msg::GetTrajectoryIdentifier(true),
                        ros2_interface::msg::GetTrajectoryObject(true));
                factory->add_type_object("ros2_interface::msg::Trajectory", ros2_interface::msg::GetTrajectoryIdentifier(false),
                        ros2_interface::msg::GetTrajectoryObject(false));



                factory->add_type_object("ros2_interface::msg::Point2dList", ros2_interface::msg::GetPoint2dListIdentifier(true),
                        ros2_interface::msg::GetPoint2dListObject(true));
                factory->add_type_object("ros2_interface::msg::Point2dList", ros2_interface::msg::GetPoint2dListIdentifier(false),
                        ros2_interface::msg::GetPoint2dListObject(false));



                factory->add_type_object("ros2_interface::msg::PlanningParkingDebug", ros2_interface::msg::GetPlanningParkingDebugIdentifier(true),
                        ros2_interface::msg::GetPlanningParkingDebugObject(true));
                factory->add_type_object("ros2_interface::msg::PlanningParkingDebug", ros2_interface::msg::GetPlanningParkingDebugIdentifier(false),
                        ros2_interface::msg::GetPlanningParkingDebugObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPlanningParkingDebugIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PlanningParkingDebug", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPlanningParkingDebugObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PlanningParkingDebug", complete);
        }

        const TypeObject* GetPlanningParkingDebugObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningParkingDebug", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePlanningParkingDebugObject();
            }
            //else
            return GetMinimalPlanningParkingDebugObject();
        }

        const TypeObject* GetMinimalPlanningParkingDebugObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningParkingDebug", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_vehicle_preiew_polygon;
            mst_vehicle_preiew_polygon.common().member_id(memberId++);
            mst_vehicle_preiew_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_vehicle_preiew_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_vehicle_preiew_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_vehicle_preiew_polygon.common().member_flags().IS_OPTIONAL(false);
            mst_vehicle_preiew_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_vehicle_preiew_polygon.common().member_flags().IS_KEY(false);
            mst_vehicle_preiew_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_vehicle_preiew_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, false));


            MD5 vehicle_preiew_polygon_hash("vehicle_preiew_polygon");
            for(int i = 0; i < 4; ++i)
            {
                mst_vehicle_preiew_polygon.detail().name_hash()[i] = vehicle_preiew_polygon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_vehicle_preiew_polygon);

            MinimalStructMember mst_obstacles_polygon;
            mst_obstacles_polygon.common().member_id(memberId++);
            mst_obstacles_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_obstacles_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_obstacles_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_obstacles_polygon.common().member_flags().IS_OPTIONAL(false);
            mst_obstacles_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_obstacles_polygon.common().member_flags().IS_KEY(false);
            mst_obstacles_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_obstacles_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, false));


            MD5 obstacles_polygon_hash("obstacles_polygon");
            for(int i = 0; i < 4; ++i)
            {
                mst_obstacles_polygon.detail().name_hash()[i] = obstacles_polygon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_obstacles_polygon);

            MinimalStructMember mst_path_points;
            mst_path_points.common().member_id(memberId++);
            mst_path_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_path_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_path_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_path_points.common().member_flags().IS_OPTIONAL(false);
            mst_path_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_path_points.common().member_flags().IS_KEY(false);
            mst_path_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_path_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PathPoint", 100, false));


            MD5 path_points_hash("path_points");
            for(int i = 0; i < 4; ++i)
            {
                mst_path_points.detail().name_hash()[i] = path_points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_path_points);

            MinimalStructMember mst_lat_error;
            mst_lat_error.common().member_id(memberId++);
            mst_lat_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lat_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lat_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lat_error.common().member_flags().IS_OPTIONAL(false);
            mst_lat_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lat_error.common().member_flags().IS_KEY(false);
            mst_lat_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lat_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lat_error_hash("lat_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_lat_error.detail().name_hash()[i] = lat_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lat_error);

            MinimalStructMember mst_lon_error;
            mst_lon_error.common().member_id(memberId++);
            mst_lon_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon_error.common().member_flags().IS_OPTIONAL(false);
            mst_lon_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon_error.common().member_flags().IS_KEY(false);
            mst_lon_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lon_error_hash("lon_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon_error.detail().name_hash()[i] = lon_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon_error);

            MinimalStructMember mst_yaw_error;
            mst_yaw_error.common().member_id(memberId++);
            mst_yaw_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_yaw_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_yaw_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_yaw_error.common().member_flags().IS_OPTIONAL(false);
            mst_yaw_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_yaw_error.common().member_flags().IS_KEY(false);
            mst_yaw_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_yaw_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 yaw_error_hash("yaw_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_yaw_error.detail().name_hash()[i] = yaw_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_yaw_error);

            MinimalStructMember mst_obstacles_vec;
            mst_obstacles_vec.common().member_id(memberId++);
            mst_obstacles_vec.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_obstacles_vec.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_obstacles_vec.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_obstacles_vec.common().member_flags().IS_OPTIONAL(false);
            mst_obstacles_vec.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_obstacles_vec.common().member_flags().IS_KEY(false);
            mst_obstacles_vec.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_obstacles_vec.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2dList", 100, false));


            MD5 obstacles_vec_hash("obstacles_vec");
            for(int i = 0; i < 4; ++i)
            {
                mst_obstacles_vec.detail().name_hash()[i] = obstacles_vec_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_obstacles_vec);

            MinimalStructMember mst_warm_start_traj;
            mst_warm_start_traj.common().member_id(memberId++);
            mst_warm_start_traj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_warm_start_traj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_warm_start_traj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_warm_start_traj.common().member_flags().IS_OPTIONAL(false);
            mst_warm_start_traj.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_warm_start_traj.common().member_flags().IS_KEY(false);
            mst_warm_start_traj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_warm_start_traj.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, false));


            MD5 warm_start_traj_hash("warm_start_traj");
            for(int i = 0; i < 4; ++i)
            {
                mst_warm_start_traj.detail().name_hash()[i] = warm_start_traj_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_warm_start_traj);

            MinimalStructMember mst_smoothed_traj_stage1;
            mst_smoothed_traj_stage1.common().member_id(memberId++);
            mst_smoothed_traj_stage1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_smoothed_traj_stage1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_smoothed_traj_stage1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_smoothed_traj_stage1.common().member_flags().IS_OPTIONAL(false);
            mst_smoothed_traj_stage1.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_smoothed_traj_stage1.common().member_flags().IS_KEY(false);
            mst_smoothed_traj_stage1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_smoothed_traj_stage1.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, false));


            MD5 smoothed_traj_stage1_hash("smoothed_traj_stage1");
            for(int i = 0; i < 4; ++i)
            {
                mst_smoothed_traj_stage1.detail().name_hash()[i] = smoothed_traj_stage1_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_smoothed_traj_stage1);

            MinimalStructMember mst_smoothed_traj_stage2;
            mst_smoothed_traj_stage2.common().member_id(memberId++);
            mst_smoothed_traj_stage2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_smoothed_traj_stage2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_smoothed_traj_stage2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_smoothed_traj_stage2.common().member_flags().IS_OPTIONAL(false);
            mst_smoothed_traj_stage2.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_smoothed_traj_stage2.common().member_flags().IS_KEY(false);
            mst_smoothed_traj_stage2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_smoothed_traj_stage2.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, false));


            MD5 smoothed_traj_stage2_hash("smoothed_traj_stage2");
            for(int i = 0; i < 4; ++i)
            {
                mst_smoothed_traj_stage2.detail().name_hash()[i] = smoothed_traj_stage2_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_smoothed_traj_stage2);

            MinimalStructMember mst_reference_line;
            mst_reference_line.common().member_id(memberId++);
            mst_reference_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_reference_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_reference_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_reference_line.common().member_flags().IS_OPTIONAL(false);
            mst_reference_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_reference_line.common().member_flags().IS_KEY(false);
            mst_reference_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_reference_line.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(false));
            MD5 reference_line_hash("reference_line");
            for(int i = 0; i < 4; ++i)
            {
                mst_reference_line.detail().name_hash()[i] = reference_line_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_reference_line);

            MinimalStructMember mst_trajectory_array;
            mst_trajectory_array.common().member_id(memberId++);
            mst_trajectory_array.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_trajectory_array.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_trajectory_array.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_trajectory_array.common().member_flags().IS_OPTIONAL(false);
            mst_trajectory_array.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_trajectory_array.common().member_flags().IS_KEY(false);
            mst_trajectory_array.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_trajectory_array.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Trajectory", 100, false));


            MD5 trajectory_array_hash("trajectory_array");
            for(int i = 0; i < 4; ++i)
            {
                mst_trajectory_array.detail().name_hash()[i] = trajectory_array_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_trajectory_array);

            MinimalStructMember mst_optimal_coarse_trajectory;
            mst_optimal_coarse_trajectory.common().member_id(memberId++);
            mst_optimal_coarse_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_optimal_coarse_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_optimal_coarse_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_optimal_coarse_trajectory.common().member_flags().IS_OPTIONAL(false);
            mst_optimal_coarse_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_optimal_coarse_trajectory.common().member_flags().IS_KEY(false);
            mst_optimal_coarse_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_optimal_coarse_trajectory.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(false));
            MD5 optimal_coarse_trajectory_hash("optimal_coarse_trajectory");
            for(int i = 0; i < 4; ++i)
            {
                mst_optimal_coarse_trajectory.detail().name_hash()[i] = optimal_coarse_trajectory_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_optimal_coarse_trajectory);

            MinimalStructMember mst_optimal_smooth_trajectory;
            mst_optimal_smooth_trajectory.common().member_id(memberId++);
            mst_optimal_smooth_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_optimal_smooth_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_optimal_smooth_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_optimal_smooth_trajectory.common().member_flags().IS_OPTIONAL(false);
            mst_optimal_smooth_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_optimal_smooth_trajectory.common().member_flags().IS_KEY(false);
            mst_optimal_smooth_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_optimal_smooth_trajectory.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(false));
            MD5 optimal_smooth_trajectory_hash("optimal_smooth_trajectory");
            for(int i = 0; i < 4; ++i)
            {
                mst_optimal_smooth_trajectory.detail().name_hash()[i] = optimal_smooth_trajectory_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_optimal_smooth_trajectory);

            MinimalStructMember mst_hybrid_a_star_map_time;
            mst_hybrid_a_star_map_time.common().member_id(memberId++);
            mst_hybrid_a_star_map_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hybrid_a_star_map_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hybrid_a_star_map_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hybrid_a_star_map_time.common().member_flags().IS_OPTIONAL(false);
            mst_hybrid_a_star_map_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hybrid_a_star_map_time.common().member_flags().IS_KEY(false);
            mst_hybrid_a_star_map_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hybrid_a_star_map_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 hybrid_a_star_map_time_hash("hybrid_a_star_map_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_hybrid_a_star_map_time.detail().name_hash()[i] = hybrid_a_star_map_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hybrid_a_star_map_time);

            MinimalStructMember mst_hybrid_a_star_heuristic_time;
            mst_hybrid_a_star_heuristic_time.common().member_id(memberId++);
            mst_hybrid_a_star_heuristic_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hybrid_a_star_heuristic_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hybrid_a_star_heuristic_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hybrid_a_star_heuristic_time.common().member_flags().IS_OPTIONAL(false);
            mst_hybrid_a_star_heuristic_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hybrid_a_star_heuristic_time.common().member_flags().IS_KEY(false);
            mst_hybrid_a_star_heuristic_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hybrid_a_star_heuristic_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 hybrid_a_star_heuristic_time_hash("hybrid_a_star_heuristic_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_hybrid_a_star_heuristic_time.detail().name_hash()[i] = hybrid_a_star_heuristic_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hybrid_a_star_heuristic_time);

            MinimalStructMember mst_hybrid_a_star_rs_time;
            mst_hybrid_a_star_rs_time.common().member_id(memberId++);
            mst_hybrid_a_star_rs_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hybrid_a_star_rs_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hybrid_a_star_rs_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hybrid_a_star_rs_time.common().member_flags().IS_OPTIONAL(false);
            mst_hybrid_a_star_rs_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hybrid_a_star_rs_time.common().member_flags().IS_KEY(false);
            mst_hybrid_a_star_rs_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hybrid_a_star_rs_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 hybrid_a_star_rs_time_hash("hybrid_a_star_rs_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_hybrid_a_star_rs_time.detail().name_hash()[i] = hybrid_a_star_rs_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hybrid_a_star_rs_time);

            MinimalStructMember mst_hybrid_a_star_total_time;
            mst_hybrid_a_star_total_time.common().member_id(memberId++);
            mst_hybrid_a_star_total_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_hybrid_a_star_total_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_hybrid_a_star_total_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_hybrid_a_star_total_time.common().member_flags().IS_OPTIONAL(false);
            mst_hybrid_a_star_total_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_hybrid_a_star_total_time.common().member_flags().IS_KEY(false);
            mst_hybrid_a_star_total_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_hybrid_a_star_total_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 hybrid_a_star_total_time_hash("hybrid_a_star_total_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_hybrid_a_star_total_time.detail().name_hash()[i] = hybrid_a_star_total_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_hybrid_a_star_total_time);

            MinimalStructMember mst_ias_collision_avoidance_time;
            mst_ias_collision_avoidance_time.common().member_id(memberId++);
            mst_ias_collision_avoidance_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ias_collision_avoidance_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ias_collision_avoidance_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ias_collision_avoidance_time.common().member_flags().IS_OPTIONAL(false);
            mst_ias_collision_avoidance_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ias_collision_avoidance_time.common().member_flags().IS_KEY(false);
            mst_ias_collision_avoidance_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ias_collision_avoidance_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ias_collision_avoidance_time_hash("ias_collision_avoidance_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_ias_collision_avoidance_time.detail().name_hash()[i] = ias_collision_avoidance_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ias_collision_avoidance_time);

            MinimalStructMember mst_ias_path_smooth_time;
            mst_ias_path_smooth_time.common().member_id(memberId++);
            mst_ias_path_smooth_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ias_path_smooth_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ias_path_smooth_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ias_path_smooth_time.common().member_flags().IS_OPTIONAL(false);
            mst_ias_path_smooth_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ias_path_smooth_time.common().member_flags().IS_KEY(false);
            mst_ias_path_smooth_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ias_path_smooth_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ias_path_smooth_time_hash("ias_path_smooth_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_ias_path_smooth_time.detail().name_hash()[i] = ias_path_smooth_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ias_path_smooth_time);

            MinimalStructMember mst_ias_speed_smooth_time;
            mst_ias_speed_smooth_time.common().member_id(memberId++);
            mst_ias_speed_smooth_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ias_speed_smooth_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ias_speed_smooth_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ias_speed_smooth_time.common().member_flags().IS_OPTIONAL(false);
            mst_ias_speed_smooth_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ias_speed_smooth_time.common().member_flags().IS_KEY(false);
            mst_ias_speed_smooth_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ias_speed_smooth_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ias_speed_smooth_time_hash("ias_speed_smooth_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_ias_speed_smooth_time.detail().name_hash()[i] = ias_speed_smooth_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ias_speed_smooth_time);

            MinimalStructMember mst_ias_total_time;
            mst_ias_total_time.common().member_id(memberId++);
            mst_ias_total_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ias_total_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ias_total_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ias_total_time.common().member_flags().IS_OPTIONAL(false);
            mst_ias_total_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ias_total_time.common().member_flags().IS_KEY(false);
            mst_ias_total_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ias_total_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ias_total_time_hash("ias_total_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_ias_total_time.detail().name_hash()[i] = ias_total_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ias_total_time);

            MinimalStructMember mst_samping_trajectory_time;
            mst_samping_trajectory_time.common().member_id(memberId++);
            mst_samping_trajectory_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_samping_trajectory_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_samping_trajectory_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_samping_trajectory_time.common().member_flags().IS_OPTIONAL(false);
            mst_samping_trajectory_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_samping_trajectory_time.common().member_flags().IS_KEY(false);
            mst_samping_trajectory_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_samping_trajectory_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 samping_trajectory_time_hash("samping_trajectory_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_samping_trajectory_time.detail().name_hash()[i] = samping_trajectory_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_samping_trajectory_time);

            MinimalStructMember mst_is_replan;
            mst_is_replan.common().member_id(memberId++);
            mst_is_replan.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_replan.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_replan.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_replan.common().member_flags().IS_OPTIONAL(false);
            mst_is_replan.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_replan.common().member_flags().IS_KEY(false);
            mst_is_replan.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_replan.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_replan_hash("is_replan");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_replan.detail().name_hash()[i] = is_replan_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_replan);

            MinimalStructMember mst_replan_reason;
            mst_replan_reason.common().member_id(memberId++);
            mst_replan_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_reason.common().member_flags().IS_OPTIONAL(false);
            mst_replan_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_reason.common().member_flags().IS_KEY(false);
            mst_replan_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 replan_reason_hash("replan_reason");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_reason.detail().name_hash()[i] = replan_reason_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_reason);

            MinimalStructMember mst_replan_time;
            mst_replan_time.common().member_id(memberId++);
            mst_replan_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_time.common().member_flags().IS_OPTIONAL(false);
            mst_replan_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_time.common().member_flags().IS_KEY(false);
            mst_replan_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 replan_time_hash("replan_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_time.detail().name_hash()[i] = replan_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_time);

            MinimalStructMember mst_replan_num;
            mst_replan_num.common().member_id(memberId++);
            mst_replan_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_num.common().member_flags().IS_OPTIONAL(false);
            mst_replan_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_num.common().member_flags().IS_KEY(false);
            mst_replan_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 replan_num_hash("replan_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_num.detail().name_hash()[i] = replan_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_num);

            MinimalStructMember mst_optimizer_thread_counter;
            mst_optimizer_thread_counter.common().member_id(memberId++);
            mst_optimizer_thread_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_optimizer_thread_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_optimizer_thread_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_optimizer_thread_counter.common().member_flags().IS_OPTIONAL(false);
            mst_optimizer_thread_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_optimizer_thread_counter.common().member_flags().IS_KEY(false);
            mst_optimizer_thread_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_optimizer_thread_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 optimizer_thread_counter_hash("optimizer_thread_counter");
            for(int i = 0; i < 4; ++i)
            {
                mst_optimizer_thread_counter.detail().name_hash()[i] = optimizer_thread_counter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_optimizer_thread_counter);

            MinimalStructMember mst_replan_by_context_update_counter;
            mst_replan_by_context_update_counter.common().member_id(memberId++);
            mst_replan_by_context_update_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_by_context_update_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_by_context_update_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_by_context_update_counter.common().member_flags().IS_OPTIONAL(false);
            mst_replan_by_context_update_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_by_context_update_counter.common().member_flags().IS_KEY(false);
            mst_replan_by_context_update_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_by_context_update_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 replan_by_context_update_counter_hash("replan_by_context_update_counter");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_by_context_update_counter.detail().name_hash()[i] = replan_by_context_update_counter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_by_context_update_counter);

            MinimalStructMember mst_replan_by_large_error_counter;
            mst_replan_by_large_error_counter.common().member_id(memberId++);
            mst_replan_by_large_error_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_by_large_error_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_by_large_error_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_by_large_error_counter.common().member_flags().IS_OPTIONAL(false);
            mst_replan_by_large_error_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_by_large_error_counter.common().member_flags().IS_KEY(false);
            mst_replan_by_large_error_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_by_large_error_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 replan_by_large_error_counter_hash("replan_by_large_error_counter");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_by_large_error_counter.detail().name_hash()[i] = replan_by_large_error_counter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_by_large_error_counter);

            MinimalStructMember mst_parking_type;
            mst_parking_type.common().member_id(memberId++);
            mst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_type.common().member_flags().IS_OPTIONAL(false);
            mst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_type.common().member_flags().IS_KEY(false);
            mst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_type_hash("parking_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_type.detail().name_hash()[i] = parking_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_type);

            MinimalStructMember mst_moves_counter;
            mst_moves_counter.common().member_id(memberId++);
            mst_moves_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moves_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moves_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moves_counter.common().member_flags().IS_OPTIONAL(false);
            mst_moves_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moves_counter.common().member_flags().IS_KEY(false);
            mst_moves_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moves_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moves_counter_hash("moves_counter");
            for(int i = 0; i < 4; ++i)
            {
                mst_moves_counter.detail().name_hash()[i] = moves_counter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moves_counter);

            MinimalStructMember mst_remain_distance;
            mst_remain_distance.common().member_id(memberId++);
            mst_remain_distance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_remain_distance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_remain_distance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_remain_distance.common().member_flags().IS_OPTIONAL(false);
            mst_remain_distance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_remain_distance.common().member_flags().IS_KEY(false);
            mst_remain_distance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_remain_distance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 remain_distance_hash("remain_distance");
            for(int i = 0; i < 4; ++i)
            {
                mst_remain_distance.detail().name_hash()[i] = remain_distance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_remain_distance);

            MinimalStructMember mst_distance_to_leader_obj;
            mst_distance_to_leader_obj.common().member_id(memberId++);
            mst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_distance_to_leader_obj.common().member_flags().IS_OPTIONAL(false);
            mst_distance_to_leader_obj.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_distance_to_leader_obj.common().member_flags().IS_KEY(false);
            mst_distance_to_leader_obj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_distance_to_leader_obj.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 distance_to_leader_obj_hash("distance_to_leader_obj");
            for(int i = 0; i < 4; ++i)
            {
                mst_distance_to_leader_obj.detail().name_hash()[i] = distance_to_leader_obj_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_distance_to_leader_obj);

            MinimalStructMember mst_state;
            mst_state.common().member_id(memberId++);
            mst_state.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_state.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_state.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_state.common().member_flags().IS_OPTIONAL(false);
            mst_state.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_state.common().member_flags().IS_KEY(false);
            mst_state.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_state.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 state_hash("state");
            for(int i = 0; i < 4; ++i)
            {
                mst_state.detail().name_hash()[i] = state_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_state);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningParkingDebug", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningParkingDebug", false);
        }

        const TypeObject* GetCompletePlanningParkingDebugObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PlanningParkingDebug", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_vehicle_preiew_polygon;
            cst_vehicle_preiew_polygon.common().member_id(memberId++);
            cst_vehicle_preiew_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_vehicle_preiew_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_vehicle_preiew_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_vehicle_preiew_polygon.common().member_flags().IS_OPTIONAL(false);
            cst_vehicle_preiew_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_vehicle_preiew_polygon.common().member_flags().IS_KEY(false);
            cst_vehicle_preiew_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_vehicle_preiew_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, true));


            cst_vehicle_preiew_polygon.detail().name("vehicle_preiew_polygon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_vehicle_preiew_polygon);

            CompleteStructMember cst_obstacles_polygon;
            cst_obstacles_polygon.common().member_id(memberId++);
            cst_obstacles_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_obstacles_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_obstacles_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_obstacles_polygon.common().member_flags().IS_OPTIONAL(false);
            cst_obstacles_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_obstacles_polygon.common().member_flags().IS_KEY(false);
            cst_obstacles_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_obstacles_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Polygon2D", 100, true));


            cst_obstacles_polygon.detail().name("obstacles_polygon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_obstacles_polygon);

            CompleteStructMember cst_path_points;
            cst_path_points.common().member_id(memberId++);
            cst_path_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_path_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_path_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_path_points.common().member_flags().IS_OPTIONAL(false);
            cst_path_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_path_points.common().member_flags().IS_KEY(false);
            cst_path_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_path_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PathPoint", 100, true));


            cst_path_points.detail().name("path_points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_path_points);

            CompleteStructMember cst_lat_error;
            cst_lat_error.common().member_id(memberId++);
            cst_lat_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lat_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lat_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lat_error.common().member_flags().IS_OPTIONAL(false);
            cst_lat_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lat_error.common().member_flags().IS_KEY(false);
            cst_lat_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lat_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lat_error.detail().name("lat_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lat_error);

            CompleteStructMember cst_lon_error;
            cst_lon_error.common().member_id(memberId++);
            cst_lon_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon_error.common().member_flags().IS_OPTIONAL(false);
            cst_lon_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon_error.common().member_flags().IS_KEY(false);
            cst_lon_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lon_error.detail().name("lon_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon_error);

            CompleteStructMember cst_yaw_error;
            cst_yaw_error.common().member_id(memberId++);
            cst_yaw_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_yaw_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_yaw_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_yaw_error.common().member_flags().IS_OPTIONAL(false);
            cst_yaw_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_yaw_error.common().member_flags().IS_KEY(false);
            cst_yaw_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_yaw_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_yaw_error.detail().name("yaw_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_yaw_error);

            CompleteStructMember cst_obstacles_vec;
            cst_obstacles_vec.common().member_id(memberId++);
            cst_obstacles_vec.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_obstacles_vec.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_obstacles_vec.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_obstacles_vec.common().member_flags().IS_OPTIONAL(false);
            cst_obstacles_vec.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_obstacles_vec.common().member_flags().IS_KEY(false);
            cst_obstacles_vec.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_obstacles_vec.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point2dList", 100, true));


            cst_obstacles_vec.detail().name("obstacles_vec");

            type_object->complete().struct_type().member_seq().emplace_back(cst_obstacles_vec);

            CompleteStructMember cst_warm_start_traj;
            cst_warm_start_traj.common().member_id(memberId++);
            cst_warm_start_traj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_warm_start_traj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_warm_start_traj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_warm_start_traj.common().member_flags().IS_OPTIONAL(false);
            cst_warm_start_traj.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_warm_start_traj.common().member_flags().IS_KEY(false);
            cst_warm_start_traj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_warm_start_traj.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, true));


            cst_warm_start_traj.detail().name("warm_start_traj");

            type_object->complete().struct_type().member_seq().emplace_back(cst_warm_start_traj);

            CompleteStructMember cst_smoothed_traj_stage1;
            cst_smoothed_traj_stage1.common().member_id(memberId++);
            cst_smoothed_traj_stage1.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_smoothed_traj_stage1.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_smoothed_traj_stage1.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_smoothed_traj_stage1.common().member_flags().IS_OPTIONAL(false);
            cst_smoothed_traj_stage1.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_smoothed_traj_stage1.common().member_flags().IS_KEY(false);
            cst_smoothed_traj_stage1.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_smoothed_traj_stage1.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, true));


            cst_smoothed_traj_stage1.detail().name("smoothed_traj_stage1");

            type_object->complete().struct_type().member_seq().emplace_back(cst_smoothed_traj_stage1);

            CompleteStructMember cst_smoothed_traj_stage2;
            cst_smoothed_traj_stage2.common().member_id(memberId++);
            cst_smoothed_traj_stage2.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_smoothed_traj_stage2.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_smoothed_traj_stage2.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_smoothed_traj_stage2.common().member_flags().IS_OPTIONAL(false);
            cst_smoothed_traj_stage2.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_smoothed_traj_stage2.common().member_flags().IS_KEY(false);
            cst_smoothed_traj_stage2.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_smoothed_traj_stage2.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryPoint", 100, true));


            cst_smoothed_traj_stage2.detail().name("smoothed_traj_stage2");

            type_object->complete().struct_type().member_seq().emplace_back(cst_smoothed_traj_stage2);

            CompleteStructMember cst_reference_line;
            cst_reference_line.common().member_id(memberId++);
            cst_reference_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_reference_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_reference_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_reference_line.common().member_flags().IS_OPTIONAL(false);
            cst_reference_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_reference_line.common().member_flags().IS_KEY(false);
            cst_reference_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_reference_line.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(true));
            cst_reference_line.detail().name("reference_line");

            type_object->complete().struct_type().member_seq().emplace_back(cst_reference_line);

            CompleteStructMember cst_trajectory_array;
            cst_trajectory_array.common().member_id(memberId++);
            cst_trajectory_array.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_trajectory_array.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_trajectory_array.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_trajectory_array.common().member_flags().IS_OPTIONAL(false);
            cst_trajectory_array.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_trajectory_array.common().member_flags().IS_KEY(false);
            cst_trajectory_array.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_trajectory_array.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Trajectory", 100, true));


            cst_trajectory_array.detail().name("trajectory_array");

            type_object->complete().struct_type().member_seq().emplace_back(cst_trajectory_array);

            CompleteStructMember cst_optimal_coarse_trajectory;
            cst_optimal_coarse_trajectory.common().member_id(memberId++);
            cst_optimal_coarse_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_optimal_coarse_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_optimal_coarse_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_optimal_coarse_trajectory.common().member_flags().IS_OPTIONAL(false);
            cst_optimal_coarse_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_optimal_coarse_trajectory.common().member_flags().IS_KEY(false);
            cst_optimal_coarse_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_optimal_coarse_trajectory.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(true));
            cst_optimal_coarse_trajectory.detail().name("optimal_coarse_trajectory");

            type_object->complete().struct_type().member_seq().emplace_back(cst_optimal_coarse_trajectory);

            CompleteStructMember cst_optimal_smooth_trajectory;
            cst_optimal_smooth_trajectory.common().member_id(memberId++);
            cst_optimal_smooth_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_optimal_smooth_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_optimal_smooth_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_optimal_smooth_trajectory.common().member_flags().IS_OPTIONAL(false);
            cst_optimal_smooth_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_optimal_smooth_trajectory.common().member_flags().IS_KEY(false);
            cst_optimal_smooth_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_optimal_smooth_trajectory.common().member_type_id(*ros2_interface::msg::GetTrajectoryIdentifier(true));
            cst_optimal_smooth_trajectory.detail().name("optimal_smooth_trajectory");

            type_object->complete().struct_type().member_seq().emplace_back(cst_optimal_smooth_trajectory);

            CompleteStructMember cst_hybrid_a_star_map_time;
            cst_hybrid_a_star_map_time.common().member_id(memberId++);
            cst_hybrid_a_star_map_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hybrid_a_star_map_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hybrid_a_star_map_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hybrid_a_star_map_time.common().member_flags().IS_OPTIONAL(false);
            cst_hybrid_a_star_map_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hybrid_a_star_map_time.common().member_flags().IS_KEY(false);
            cst_hybrid_a_star_map_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hybrid_a_star_map_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_hybrid_a_star_map_time.detail().name("hybrid_a_star_map_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hybrid_a_star_map_time);

            CompleteStructMember cst_hybrid_a_star_heuristic_time;
            cst_hybrid_a_star_heuristic_time.common().member_id(memberId++);
            cst_hybrid_a_star_heuristic_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hybrid_a_star_heuristic_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hybrid_a_star_heuristic_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hybrid_a_star_heuristic_time.common().member_flags().IS_OPTIONAL(false);
            cst_hybrid_a_star_heuristic_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hybrid_a_star_heuristic_time.common().member_flags().IS_KEY(false);
            cst_hybrid_a_star_heuristic_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hybrid_a_star_heuristic_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_hybrid_a_star_heuristic_time.detail().name("hybrid_a_star_heuristic_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hybrid_a_star_heuristic_time);

            CompleteStructMember cst_hybrid_a_star_rs_time;
            cst_hybrid_a_star_rs_time.common().member_id(memberId++);
            cst_hybrid_a_star_rs_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hybrid_a_star_rs_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hybrid_a_star_rs_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hybrid_a_star_rs_time.common().member_flags().IS_OPTIONAL(false);
            cst_hybrid_a_star_rs_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hybrid_a_star_rs_time.common().member_flags().IS_KEY(false);
            cst_hybrid_a_star_rs_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hybrid_a_star_rs_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_hybrid_a_star_rs_time.detail().name("hybrid_a_star_rs_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hybrid_a_star_rs_time);

            CompleteStructMember cst_hybrid_a_star_total_time;
            cst_hybrid_a_star_total_time.common().member_id(memberId++);
            cst_hybrid_a_star_total_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_hybrid_a_star_total_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_hybrid_a_star_total_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_hybrid_a_star_total_time.common().member_flags().IS_OPTIONAL(false);
            cst_hybrid_a_star_total_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_hybrid_a_star_total_time.common().member_flags().IS_KEY(false);
            cst_hybrid_a_star_total_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_hybrid_a_star_total_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_hybrid_a_star_total_time.detail().name("hybrid_a_star_total_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_hybrid_a_star_total_time);

            CompleteStructMember cst_ias_collision_avoidance_time;
            cst_ias_collision_avoidance_time.common().member_id(memberId++);
            cst_ias_collision_avoidance_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ias_collision_avoidance_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ias_collision_avoidance_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ias_collision_avoidance_time.common().member_flags().IS_OPTIONAL(false);
            cst_ias_collision_avoidance_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ias_collision_avoidance_time.common().member_flags().IS_KEY(false);
            cst_ias_collision_avoidance_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ias_collision_avoidance_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ias_collision_avoidance_time.detail().name("ias_collision_avoidance_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ias_collision_avoidance_time);

            CompleteStructMember cst_ias_path_smooth_time;
            cst_ias_path_smooth_time.common().member_id(memberId++);
            cst_ias_path_smooth_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ias_path_smooth_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ias_path_smooth_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ias_path_smooth_time.common().member_flags().IS_OPTIONAL(false);
            cst_ias_path_smooth_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ias_path_smooth_time.common().member_flags().IS_KEY(false);
            cst_ias_path_smooth_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ias_path_smooth_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ias_path_smooth_time.detail().name("ias_path_smooth_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ias_path_smooth_time);

            CompleteStructMember cst_ias_speed_smooth_time;
            cst_ias_speed_smooth_time.common().member_id(memberId++);
            cst_ias_speed_smooth_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ias_speed_smooth_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ias_speed_smooth_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ias_speed_smooth_time.common().member_flags().IS_OPTIONAL(false);
            cst_ias_speed_smooth_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ias_speed_smooth_time.common().member_flags().IS_KEY(false);
            cst_ias_speed_smooth_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ias_speed_smooth_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ias_speed_smooth_time.detail().name("ias_speed_smooth_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ias_speed_smooth_time);

            CompleteStructMember cst_ias_total_time;
            cst_ias_total_time.common().member_id(memberId++);
            cst_ias_total_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ias_total_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ias_total_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ias_total_time.common().member_flags().IS_OPTIONAL(false);
            cst_ias_total_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ias_total_time.common().member_flags().IS_KEY(false);
            cst_ias_total_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ias_total_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ias_total_time.detail().name("ias_total_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ias_total_time);

            CompleteStructMember cst_samping_trajectory_time;
            cst_samping_trajectory_time.common().member_id(memberId++);
            cst_samping_trajectory_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_samping_trajectory_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_samping_trajectory_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_samping_trajectory_time.common().member_flags().IS_OPTIONAL(false);
            cst_samping_trajectory_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_samping_trajectory_time.common().member_flags().IS_KEY(false);
            cst_samping_trajectory_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_samping_trajectory_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_samping_trajectory_time.detail().name("samping_trajectory_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_samping_trajectory_time);

            CompleteStructMember cst_is_replan;
            cst_is_replan.common().member_id(memberId++);
            cst_is_replan.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_replan.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_replan.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_replan.common().member_flags().IS_OPTIONAL(false);
            cst_is_replan.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_replan.common().member_flags().IS_KEY(false);
            cst_is_replan.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_replan.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_replan.detail().name("is_replan");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_replan);

            CompleteStructMember cst_replan_reason;
            cst_replan_reason.common().member_id(memberId++);
            cst_replan_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_reason.common().member_flags().IS_OPTIONAL(false);
            cst_replan_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_reason.common().member_flags().IS_KEY(false);
            cst_replan_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_replan_reason.detail().name("replan_reason");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_reason);

            CompleteStructMember cst_replan_time;
            cst_replan_time.common().member_id(memberId++);
            cst_replan_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_time.common().member_flags().IS_OPTIONAL(false);
            cst_replan_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_time.common().member_flags().IS_KEY(false);
            cst_replan_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_replan_time.detail().name("replan_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_time);

            CompleteStructMember cst_replan_num;
            cst_replan_num.common().member_id(memberId++);
            cst_replan_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_num.common().member_flags().IS_OPTIONAL(false);
            cst_replan_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_num.common().member_flags().IS_KEY(false);
            cst_replan_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_replan_num.detail().name("replan_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_num);

            CompleteStructMember cst_optimizer_thread_counter;
            cst_optimizer_thread_counter.common().member_id(memberId++);
            cst_optimizer_thread_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_optimizer_thread_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_optimizer_thread_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_optimizer_thread_counter.common().member_flags().IS_OPTIONAL(false);
            cst_optimizer_thread_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_optimizer_thread_counter.common().member_flags().IS_KEY(false);
            cst_optimizer_thread_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_optimizer_thread_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_optimizer_thread_counter.detail().name("optimizer_thread_counter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_optimizer_thread_counter);

            CompleteStructMember cst_replan_by_context_update_counter;
            cst_replan_by_context_update_counter.common().member_id(memberId++);
            cst_replan_by_context_update_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_by_context_update_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_by_context_update_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_by_context_update_counter.common().member_flags().IS_OPTIONAL(false);
            cst_replan_by_context_update_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_by_context_update_counter.common().member_flags().IS_KEY(false);
            cst_replan_by_context_update_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_by_context_update_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_replan_by_context_update_counter.detail().name("replan_by_context_update_counter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_by_context_update_counter);

            CompleteStructMember cst_replan_by_large_error_counter;
            cst_replan_by_large_error_counter.common().member_id(memberId++);
            cst_replan_by_large_error_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_by_large_error_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_by_large_error_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_by_large_error_counter.common().member_flags().IS_OPTIONAL(false);
            cst_replan_by_large_error_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_by_large_error_counter.common().member_flags().IS_KEY(false);
            cst_replan_by_large_error_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_by_large_error_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_replan_by_large_error_counter.detail().name("replan_by_large_error_counter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_by_large_error_counter);

            CompleteStructMember cst_parking_type;
            cst_parking_type.common().member_id(memberId++);
            cst_parking_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_type.common().member_flags().IS_OPTIONAL(false);
            cst_parking_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_type.common().member_flags().IS_KEY(false);
            cst_parking_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_type.detail().name("parking_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_type);

            CompleteStructMember cst_moves_counter;
            cst_moves_counter.common().member_id(memberId++);
            cst_moves_counter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moves_counter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moves_counter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moves_counter.common().member_flags().IS_OPTIONAL(false);
            cst_moves_counter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moves_counter.common().member_flags().IS_KEY(false);
            cst_moves_counter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moves_counter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moves_counter.detail().name("moves_counter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moves_counter);

            CompleteStructMember cst_remain_distance;
            cst_remain_distance.common().member_id(memberId++);
            cst_remain_distance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_remain_distance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_remain_distance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_remain_distance.common().member_flags().IS_OPTIONAL(false);
            cst_remain_distance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_remain_distance.common().member_flags().IS_KEY(false);
            cst_remain_distance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_remain_distance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_remain_distance.detail().name("remain_distance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_remain_distance);

            CompleteStructMember cst_distance_to_leader_obj;
            cst_distance_to_leader_obj.common().member_id(memberId++);
            cst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_distance_to_leader_obj.common().member_flags().IS_OPTIONAL(false);
            cst_distance_to_leader_obj.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_distance_to_leader_obj.common().member_flags().IS_KEY(false);
            cst_distance_to_leader_obj.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_distance_to_leader_obj.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_distance_to_leader_obj.detail().name("distance_to_leader_obj");

            type_object->complete().struct_type().member_seq().emplace_back(cst_distance_to_leader_obj);

            CompleteStructMember cst_state;
            cst_state.common().member_id(memberId++);
            cst_state.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_state.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_state.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_state.common().member_flags().IS_OPTIONAL(false);
            cst_state.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_state.common().member_flags().IS_KEY(false);
            cst_state.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_state.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_state.detail().name("state");

            type_object->complete().struct_type().member_seq().emplace_back(cst_state);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PlanningParkingDebug");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PlanningParkingDebug", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PlanningParkingDebug", true);
        }

    } // namespace msg
} // namespace ros2_interface