// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Point2dList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Point2dList.h"
#include "Point2dListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Point2dList_max_cdr_typesize 1608ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point2dList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Point2dList::Point2dList()
{
    // sequence<ros2_interface::msg::Point2D> m_point2d_list


    // Just to register all known types
    registerPoint2dListTypes();
}

ros2_interface::msg::Point2dList::~Point2dList()
{
}

ros2_interface::msg::Point2dList::Point2dList(
        const Point2dList& x)
{
    m_point2d_list = x.m_point2d_list;
}

ros2_interface::msg::Point2dList::Point2dList(
        Point2dList&& x) noexcept 
{
    m_point2d_list = std::move(x.m_point2d_list);
}

ros2_interface::msg::Point2dList& ros2_interface::msg::Point2dList::operator =(
        const Point2dList& x)
{

    m_point2d_list = x.m_point2d_list;

    return *this;
}

ros2_interface::msg::Point2dList& ros2_interface::msg::Point2dList::operator =(
        Point2dList&& x) noexcept
{

    m_point2d_list = std::move(x.m_point2d_list);

    return *this;
}

bool ros2_interface::msg::Point2dList::operator ==(
        const Point2dList& x) const
{

    return (m_point2d_list == x.m_point2d_list);
}

bool ros2_interface::msg::Point2dList::operator !=(
        const Point2dList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Point2dList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Point2dList_max_cdr_typesize;
}

size_t ros2_interface::msg::Point2dList::getCdrSerializedSize(
        const ros2_interface::msg::Point2dList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.point2d_list().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.point2d_list().at(a), current_alignment);}

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Point2dList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_point2d_list;
}

void ros2_interface::msg::Point2dList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_point2d_list;}

/*!
 * @brief This function copies the value in member point2d_list
 * @param _point2d_list New value to be copied in member point2d_list
 */
void ros2_interface::msg::Point2dList::point2d_list(
        const std::vector<ros2_interface::msg::Point2D>& _point2d_list)
{
    m_point2d_list = _point2d_list;
}

/*!
 * @brief This function moves the value in member point2d_list
 * @param _point2d_list New value to be moved in member point2d_list
 */
void ros2_interface::msg::Point2dList::point2d_list(
        std::vector<ros2_interface::msg::Point2D>&& _point2d_list)
{
    m_point2d_list = std::move(_point2d_list);
}

/*!
 * @brief This function returns a constant reference to member point2d_list
 * @return Constant reference to member point2d_list
 */
const std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::Point2dList::point2d_list() const
{
    return m_point2d_list;
}

/*!
 * @brief This function returns a reference to member point2d_list
 * @return Reference to member point2d_list
 */
std::vector<ros2_interface::msg::Point2D>& ros2_interface::msg::Point2dList::point2d_list()
{
    return m_point2d_list;
}


size_t ros2_interface::msg::Point2dList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Point2dList_max_key_cdr_typesize;
}

bool ros2_interface::msg::Point2dList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Point2dList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



