// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointBasic.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PointBasic.h"
#include "PointBasicTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_PointBasic_max_cdr_typesize 32ULL;
#define ros2_interface_msg_PointBasic_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PointBasic::PointBasic()
{
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_z
    m_z = 0.0;
    // double m_theta
    m_theta = 0.0;

    // Just to register all known types
    registerPointBasicTypes();
}

ros2_interface::msg::PointBasic::~PointBasic()
{




}

ros2_interface::msg::PointBasic::PointBasic(
        const PointBasic& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
}

ros2_interface::msg::PointBasic::PointBasic(
        PointBasic&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;
}

ros2_interface::msg::PointBasic& ros2_interface::msg::PointBasic::operator =(
        const PointBasic& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;

    return *this;
}

ros2_interface::msg::PointBasic& ros2_interface::msg::PointBasic::operator =(
        PointBasic&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_theta = x.m_theta;

    return *this;
}

bool ros2_interface::msg::PointBasic::operator ==(
        const PointBasic& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_z == x.m_z && m_theta == x.m_theta);
}

bool ros2_interface::msg::PointBasic::operator !=(
        const PointBasic& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PointBasic::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointBasic_max_cdr_typesize;
}

size_t ros2_interface::msg::PointBasic::getCdrSerializedSize(
        const ros2_interface::msg::PointBasic& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PointBasic::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_z;
    scdr << m_theta;

}

void ros2_interface::msg::PointBasic::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_z;
    dcdr >> m_theta;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::PointBasic::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::PointBasic::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::PointBasic::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::PointBasic::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::PointBasic::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::PointBasic::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member z
 * @param _z New value for member z
 */
void ros2_interface::msg::PointBasic::z(
        double _z)
{
    m_z = _z;
}

/*!
 * @brief This function returns the value of member z
 * @return Value of member z
 */
double ros2_interface::msg::PointBasic::z() const
{
    return m_z;
}

/*!
 * @brief This function returns a reference to member z
 * @return Reference to member z
 */
double& ros2_interface::msg::PointBasic::z()
{
    return m_z;
}

/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::PointBasic::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::PointBasic::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::PointBasic::theta()
{
    return m_theta;
}



size_t ros2_interface::msg::PointBasic::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointBasic_max_key_cdr_typesize;
}

bool ros2_interface::msg::PointBasic::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PointBasic::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



