// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointCloud.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PointCloud.h"
#include "PointCloudTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_PointXYZIRT_max_cdr_typesize 40ULL;
#define ros2_interface_msg_PointCloud_max_cdr_typesize 4560ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointXYZIRT_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointCloud_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PointCloud::PointCloud()
{
    // ros2_interface::msg::Header m_header

    // string m_frame_id
    m_frame_id ="";
    // boolean m_is_dense
    m_is_dense = false;
    // sequence<ros2_interface::msg::PointXYZIRT> m_point

    // double m_measurement_time
    m_measurement_time = 0.0;
    // unsigned long m_width
    m_width = 0;
    // unsigned long m_height
    m_height = 0;

    // Just to register all known types
    registerPointCloudTypes();
}

ros2_interface::msg::PointCloud::~PointCloud()
{







}

ros2_interface::msg::PointCloud::PointCloud(
        const PointCloud& x)
{
    m_header = x.m_header;
    m_frame_id = x.m_frame_id;
    m_is_dense = x.m_is_dense;
    m_point = x.m_point;
    m_measurement_time = x.m_measurement_time;
    m_width = x.m_width;
    m_height = x.m_height;
}

ros2_interface::msg::PointCloud::PointCloud(
        PointCloud&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_frame_id = std::move(x.m_frame_id);
    m_is_dense = x.m_is_dense;
    m_point = std::move(x.m_point);
    m_measurement_time = x.m_measurement_time;
    m_width = x.m_width;
    m_height = x.m_height;
}

ros2_interface::msg::PointCloud& ros2_interface::msg::PointCloud::operator =(
        const PointCloud& x)
{

    m_header = x.m_header;
    m_frame_id = x.m_frame_id;
    m_is_dense = x.m_is_dense;
    m_point = x.m_point;
    m_measurement_time = x.m_measurement_time;
    m_width = x.m_width;
    m_height = x.m_height;

    return *this;
}

ros2_interface::msg::PointCloud& ros2_interface::msg::PointCloud::operator =(
        PointCloud&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_frame_id = std::move(x.m_frame_id);
    m_is_dense = x.m_is_dense;
    m_point = std::move(x.m_point);
    m_measurement_time = x.m_measurement_time;
    m_width = x.m_width;
    m_height = x.m_height;

    return *this;
}

bool ros2_interface::msg::PointCloud::operator ==(
        const PointCloud& x) const
{

    return (m_header == x.m_header && m_frame_id == x.m_frame_id && m_is_dense == x.m_is_dense && m_point == x.m_point && m_measurement_time == x.m_measurement_time && m_width == x.m_width && m_height == x.m_height);
}

bool ros2_interface::msg::PointCloud::operator !=(
        const PointCloud& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PointCloud::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointCloud_max_cdr_typesize;
}

size_t ros2_interface::msg::PointCloud::getCdrSerializedSize(
        const ros2_interface::msg::PointCloud& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.frame_id().size() + 1;

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.point().size(); ++a)
    {
        current_alignment += ros2_interface::msg::PointXYZIRT::getCdrSerializedSize(data.point().at(a), current_alignment);}

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PointCloud::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_frame_id.c_str();
    scdr << m_is_dense;
    scdr << m_point;
    scdr << m_measurement_time;
    scdr << m_width;
    scdr << m_height;

}

void ros2_interface::msg::PointCloud::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_frame_id;
    dcdr >> m_is_dense;
    dcdr >> m_point;
    dcdr >> m_measurement_time;
    dcdr >> m_width;
    dcdr >> m_height;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::PointCloud::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::PointCloud::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::PointCloud::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::PointCloud::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member frame_id
 * @param _frame_id New value to be copied in member frame_id
 */
void ros2_interface::msg::PointCloud::frame_id(
        const std::string& _frame_id)
{
    m_frame_id = _frame_id;
}

/*!
 * @brief This function moves the value in member frame_id
 * @param _frame_id New value to be moved in member frame_id
 */
void ros2_interface::msg::PointCloud::frame_id(
        std::string&& _frame_id)
{
    m_frame_id = std::move(_frame_id);
}

/*!
 * @brief This function returns a constant reference to member frame_id
 * @return Constant reference to member frame_id
 */
const std::string& ros2_interface::msg::PointCloud::frame_id() const
{
    return m_frame_id;
}

/*!
 * @brief This function returns a reference to member frame_id
 * @return Reference to member frame_id
 */
std::string& ros2_interface::msg::PointCloud::frame_id()
{
    return m_frame_id;
}
/*!
 * @brief This function sets a value in member is_dense
 * @param _is_dense New value for member is_dense
 */
void ros2_interface::msg::PointCloud::is_dense(
        bool _is_dense)
{
    m_is_dense = _is_dense;
}

/*!
 * @brief This function returns the value of member is_dense
 * @return Value of member is_dense
 */
bool ros2_interface::msg::PointCloud::is_dense() const
{
    return m_is_dense;
}

/*!
 * @brief This function returns a reference to member is_dense
 * @return Reference to member is_dense
 */
bool& ros2_interface::msg::PointCloud::is_dense()
{
    return m_is_dense;
}

/*!
 * @brief This function copies the value in member point
 * @param _point New value to be copied in member point
 */
void ros2_interface::msg::PointCloud::point(
        const std::vector<ros2_interface::msg::PointXYZIRT>& _point)
{
    m_point = _point;
}

/*!
 * @brief This function moves the value in member point
 * @param _point New value to be moved in member point
 */
void ros2_interface::msg::PointCloud::point(
        std::vector<ros2_interface::msg::PointXYZIRT>&& _point)
{
    m_point = std::move(_point);
}

/*!
 * @brief This function returns a constant reference to member point
 * @return Constant reference to member point
 */
const std::vector<ros2_interface::msg::PointXYZIRT>& ros2_interface::msg::PointCloud::point() const
{
    return m_point;
}

/*!
 * @brief This function returns a reference to member point
 * @return Reference to member point
 */
std::vector<ros2_interface::msg::PointXYZIRT>& ros2_interface::msg::PointCloud::point()
{
    return m_point;
}
/*!
 * @brief This function sets a value in member measurement_time
 * @param _measurement_time New value for member measurement_time
 */
void ros2_interface::msg::PointCloud::measurement_time(
        double _measurement_time)
{
    m_measurement_time = _measurement_time;
}

/*!
 * @brief This function returns the value of member measurement_time
 * @return Value of member measurement_time
 */
double ros2_interface::msg::PointCloud::measurement_time() const
{
    return m_measurement_time;
}

/*!
 * @brief This function returns a reference to member measurement_time
 * @return Reference to member measurement_time
 */
double& ros2_interface::msg::PointCloud::measurement_time()
{
    return m_measurement_time;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::PointCloud::width(
        uint32_t _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
uint32_t ros2_interface::msg::PointCloud::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
uint32_t& ros2_interface::msg::PointCloud::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::PointCloud::height(
        uint32_t _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
uint32_t ros2_interface::msg::PointCloud::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
uint32_t& ros2_interface::msg::PointCloud::height()
{
    return m_height;
}



size_t ros2_interface::msg::PointCloud::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointCloud_max_key_cdr_typesize;
}

bool ros2_interface::msg::PointCloud::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PointCloud::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



