// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointCloud.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTCLOUD_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTCLOUD_H_

#include "PointXYZIRT.h"
#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(POINTCLOUD_SOURCE)
#define POINTCLOUD_DllAPI __declspec( dllexport )
#else
#define POINTCLOUD_DllAPI __declspec( dllimport )
#endif // POINTCLOUD_SOURCE
#else
#define POINTCLOUD_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define POINTCLOUD_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PointCloud defined by the user in the IDL file.
         * @ingroup PointCloud
         */
        class PointCloud
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PointCloud();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PointCloud();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PointCloud that will be copied.
             */
            eProsima_user_DllExport PointCloud(
                    const PointCloud& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PointCloud that will be copied.
             */
            eProsima_user_DllExport PointCloud(
                    PointCloud&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PointCloud that will be copied.
             */
            eProsima_user_DllExport PointCloud& operator =(
                    const PointCloud& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PointCloud that will be copied.
             */
            eProsima_user_DllExport PointCloud& operator =(
                    PointCloud&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointCloud object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PointCloud& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointCloud object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PointCloud& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member frame_id
             * @param _frame_id New value to be copied in member frame_id
             */
            eProsima_user_DllExport void frame_id(
                    const std::string& _frame_id);

            /*!
             * @brief This function moves the value in member frame_id
             * @param _frame_id New value to be moved in member frame_id
             */
            eProsima_user_DllExport void frame_id(
                    std::string&& _frame_id);

            /*!
             * @brief This function returns a constant reference to member frame_id
             * @return Constant reference to member frame_id
             */
            eProsima_user_DllExport const std::string& frame_id() const;

            /*!
             * @brief This function returns a reference to member frame_id
             * @return Reference to member frame_id
             */
            eProsima_user_DllExport std::string& frame_id();
            /*!
             * @brief This function sets a value in member is_dense
             * @param _is_dense New value for member is_dense
             */
            eProsima_user_DllExport void is_dense(
                    bool _is_dense);

            /*!
             * @brief This function returns the value of member is_dense
             * @return Value of member is_dense
             */
            eProsima_user_DllExport bool is_dense() const;

            /*!
             * @brief This function returns a reference to member is_dense
             * @return Reference to member is_dense
             */
            eProsima_user_DllExport bool& is_dense();

            /*!
             * @brief This function copies the value in member point
             * @param _point New value to be copied in member point
             */
            eProsima_user_DllExport void point(
                    const std::vector<ros2_interface::msg::PointXYZIRT>& _point);

            /*!
             * @brief This function moves the value in member point
             * @param _point New value to be moved in member point
             */
            eProsima_user_DllExport void point(
                    std::vector<ros2_interface::msg::PointXYZIRT>&& _point);

            /*!
             * @brief This function returns a constant reference to member point
             * @return Constant reference to member point
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::PointXYZIRT>& point() const;

            /*!
             * @brief This function returns a reference to member point
             * @return Reference to member point
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::PointXYZIRT>& point();
            /*!
             * @brief This function sets a value in member measurement_time
             * @param _measurement_time New value for member measurement_time
             */
            eProsima_user_DllExport void measurement_time(
                    double _measurement_time);

            /*!
             * @brief This function returns the value of member measurement_time
             * @return Value of member measurement_time
             */
            eProsima_user_DllExport double measurement_time() const;

            /*!
             * @brief This function returns a reference to member measurement_time
             * @return Reference to member measurement_time
             */
            eProsima_user_DllExport double& measurement_time();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    uint32_t _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport uint32_t width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport uint32_t& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    uint32_t _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport uint32_t height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport uint32_t& height();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PointCloud& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::string m_frame_id;
            bool m_is_dense;
            std::vector<ros2_interface::msg::PointXYZIRT> m_point;
            double m_measurement_time;
            uint32_t m_width;
            uint32_t m_height;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTCLOUD_H_

