// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointCloudTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PointCloud.h"
#include "PointCloudTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPointCloudTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PointXYZIRT", ros2_interface::msg::GetPointXYZIRTIdentifier(true),
                        ros2_interface::msg::GetPointXYZIRTObject(true));
                factory->add_type_object("ros2_interface::msg::PointXYZIRT", ros2_interface::msg::GetPointXYZIRTIdentifier(false),
                        ros2_interface::msg::GetPointXYZIRTObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::PointCloud", ros2_interface::msg::GetPointCloudIdentifier(true),
                        ros2_interface::msg::GetPointCloudObject(true));
                factory->add_type_object("ros2_interface::msg::PointCloud", ros2_interface::msg::GetPointCloudIdentifier(false),
                        ros2_interface::msg::GetPointCloudObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPointCloudIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PointCloud", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPointCloudObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PointCloud", complete);
        }

        const TypeObject* GetPointCloudObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointCloud", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePointCloudObject();
            }
            //else
            return GetMinimalPointCloudObject();
        }

        const TypeObject* GetMinimalPointCloudObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointCloud", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_frame_id;
            mst_frame_id.common().member_id(memberId++);
            mst_frame_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_frame_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_frame_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_frame_id.common().member_flags().IS_OPTIONAL(false);
            mst_frame_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_frame_id.common().member_flags().IS_KEY(false);
            mst_frame_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_frame_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 frame_id_hash("frame_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_frame_id.detail().name_hash()[i] = frame_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_frame_id);

            MinimalStructMember mst_is_dense;
            mst_is_dense.common().member_id(memberId++);
            mst_is_dense.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_dense.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_dense.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_dense.common().member_flags().IS_OPTIONAL(false);
            mst_is_dense.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_dense.common().member_flags().IS_KEY(false);
            mst_is_dense.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_dense.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_dense_hash("is_dense");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_dense.detail().name_hash()[i] = is_dense_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_dense);

            MinimalStructMember mst_point;
            mst_point.common().member_id(memberId++);
            mst_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_point.common().member_flags().IS_OPTIONAL(false);
            mst_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_point.common().member_flags().IS_KEY(false);
            mst_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PointXYZIRT", 100, false));


            MD5 point_hash("point");
            for(int i = 0; i < 4; ++i)
            {
                mst_point.detail().name_hash()[i] = point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_point);

            MinimalStructMember mst_measurement_time;
            mst_measurement_time.common().member_id(memberId++);
            mst_measurement_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_measurement_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_measurement_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_measurement_time.common().member_flags().IS_OPTIONAL(false);
            mst_measurement_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_measurement_time.common().member_flags().IS_KEY(false);
            mst_measurement_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_measurement_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 measurement_time_hash("measurement_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_measurement_time.detail().name_hash()[i] = measurement_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_measurement_time);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PointCloud", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PointCloud", false);
        }

        const TypeObject* GetCompletePointCloudObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointCloud", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_frame_id;
            cst_frame_id.common().member_id(memberId++);
            cst_frame_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_frame_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_frame_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_frame_id.common().member_flags().IS_OPTIONAL(false);
            cst_frame_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_frame_id.common().member_flags().IS_KEY(false);
            cst_frame_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_frame_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_frame_id.detail().name("frame_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_frame_id);

            CompleteStructMember cst_is_dense;
            cst_is_dense.common().member_id(memberId++);
            cst_is_dense.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_dense.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_dense.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_dense.common().member_flags().IS_OPTIONAL(false);
            cst_is_dense.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_dense.common().member_flags().IS_KEY(false);
            cst_is_dense.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_dense.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_dense.detail().name("is_dense");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_dense);

            CompleteStructMember cst_point;
            cst_point.common().member_id(memberId++);
            cst_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_point.common().member_flags().IS_OPTIONAL(false);
            cst_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_point.common().member_flags().IS_KEY(false);
            cst_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PointXYZIRT", 100, true));


            cst_point.detail().name("point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_point);

            CompleteStructMember cst_measurement_time;
            cst_measurement_time.common().member_id(memberId++);
            cst_measurement_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_measurement_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_measurement_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_measurement_time.common().member_flags().IS_OPTIONAL(false);
            cst_measurement_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_measurement_time.common().member_flags().IS_KEY(false);
            cst_measurement_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_measurement_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_measurement_time.detail().name("measurement_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_measurement_time);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PointCloud");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PointCloud", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PointCloud", true);
        }

    } // namespace msg
} // namespace ros2_interface