// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointLLH.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PointLLH.h"
#include "PointLLHTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_PointLLH_max_cdr_typesize 24ULL;
#define ros2_interface_msg_PointLLH_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PointLLH::PointLLH()
{
    // double m_lon
    m_lon = 0.0;
    // double m_lat
    m_lat = 0.0;
    // double m_height
    m_height = 0.0;

    // Just to register all known types
    registerPointLLHTypes();
}

ros2_interface::msg::PointLLH::~PointLLH()
{



}

ros2_interface::msg::PointLLH::PointLLH(
        const PointLLH& x)
{
    m_lon = x.m_lon;
    m_lat = x.m_lat;
    m_height = x.m_height;
}

ros2_interface::msg::PointLLH::PointLLH(
        PointLLH&& x) noexcept 
{
    m_lon = x.m_lon;
    m_lat = x.m_lat;
    m_height = x.m_height;
}

ros2_interface::msg::PointLLH& ros2_interface::msg::PointLLH::operator =(
        const PointLLH& x)
{

    m_lon = x.m_lon;
    m_lat = x.m_lat;
    m_height = x.m_height;

    return *this;
}

ros2_interface::msg::PointLLH& ros2_interface::msg::PointLLH::operator =(
        PointLLH&& x) noexcept
{

    m_lon = x.m_lon;
    m_lat = x.m_lat;
    m_height = x.m_height;

    return *this;
}

bool ros2_interface::msg::PointLLH::operator ==(
        const PointLLH& x) const
{

    return (m_lon == x.m_lon && m_lat == x.m_lat && m_height == x.m_height);
}

bool ros2_interface::msg::PointLLH::operator !=(
        const PointLLH& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PointLLH::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointLLH_max_cdr_typesize;
}

size_t ros2_interface::msg::PointLLH::getCdrSerializedSize(
        const ros2_interface::msg::PointLLH& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PointLLH::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_lon;
    scdr << m_lat;
    scdr << m_height;

}

void ros2_interface::msg::PointLLH::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_lon;
    dcdr >> m_lat;
    dcdr >> m_height;
}

/*!
 * @brief This function sets a value in member lon
 * @param _lon New value for member lon
 */
void ros2_interface::msg::PointLLH::lon(
        double _lon)
{
    m_lon = _lon;
}

/*!
 * @brief This function returns the value of member lon
 * @return Value of member lon
 */
double ros2_interface::msg::PointLLH::lon() const
{
    return m_lon;
}

/*!
 * @brief This function returns a reference to member lon
 * @return Reference to member lon
 */
double& ros2_interface::msg::PointLLH::lon()
{
    return m_lon;
}

/*!
 * @brief This function sets a value in member lat
 * @param _lat New value for member lat
 */
void ros2_interface::msg::PointLLH::lat(
        double _lat)
{
    m_lat = _lat;
}

/*!
 * @brief This function returns the value of member lat
 * @return Value of member lat
 */
double ros2_interface::msg::PointLLH::lat() const
{
    return m_lat;
}

/*!
 * @brief This function returns a reference to member lat
 * @return Reference to member lat
 */
double& ros2_interface::msg::PointLLH::lat()
{
    return m_lat;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::PointLLH::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::PointLLH::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::PointLLH::height()
{
    return m_height;
}



size_t ros2_interface::msg::PointLLH::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointLLH_max_key_cdr_typesize;
}

bool ros2_interface::msg::PointLLH::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PointLLH::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



