// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointLLH.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTLLH_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTLLH_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(POINTLLH_SOURCE)
#define POINTLLH_DllAPI __declspec( dllexport )
#else
#define POINTLLH_DllAPI __declspec( dllimport )
#endif // POINTLLH_SOURCE
#else
#define POINTLLH_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define POINTLLH_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PointLLH defined by the user in the IDL file.
         * @ingroup PointLLH
         */
        class PointLLH
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PointLLH();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PointLLH();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PointLLH that will be copied.
             */
            eProsima_user_DllExport PointLLH(
                    const PointLLH& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PointLLH that will be copied.
             */
            eProsima_user_DllExport PointLLH(
                    PointLLH&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PointLLH that will be copied.
             */
            eProsima_user_DllExport PointLLH& operator =(
                    const PointLLH& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PointLLH that will be copied.
             */
            eProsima_user_DllExport PointLLH& operator =(
                    PointLLH&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointLLH object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PointLLH& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointLLH object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PointLLH& x) const;

            /*!
             * @brief This function sets a value in member lon
             * @param _lon New value for member lon
             */
            eProsima_user_DllExport void lon(
                    double _lon);

            /*!
             * @brief This function returns the value of member lon
             * @return Value of member lon
             */
            eProsima_user_DllExport double lon() const;

            /*!
             * @brief This function returns a reference to member lon
             * @return Reference to member lon
             */
            eProsima_user_DllExport double& lon();

            /*!
             * @brief This function sets a value in member lat
             * @param _lat New value for member lat
             */
            eProsima_user_DllExport void lat(
                    double _lat);

            /*!
             * @brief This function returns the value of member lat
             * @return Value of member lat
             */
            eProsima_user_DllExport double lat() const;

            /*!
             * @brief This function returns a reference to member lat
             * @return Reference to member lat
             */
            eProsima_user_DllExport double& lat();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PointLLH& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_lon;
            double m_lat;
            double m_height;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTLLH_H_

