// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointLLHTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PointLLH.h"
#include "PointLLHTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPointLLHTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(true),
                        ros2_interface::msg::GetPointLLHObject(true));
                factory->add_type_object("ros2_interface::msg::PointLLH", ros2_interface::msg::GetPointLLHIdentifier(false),
                        ros2_interface::msg::GetPointLLHObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPointLLHIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PointLLH", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPointLLHObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PointLLH", complete);
        }

        const TypeObject* GetPointLLHObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointLLH", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePointLLHObject();
            }
            //else
            return GetMinimalPointLLHObject();
        }

        const TypeObject* GetMinimalPointLLHObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointLLH", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_lon;
            mst_lon.common().member_id(memberId++);
            mst_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lon.common().member_flags().IS_OPTIONAL(false);
            mst_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lon.common().member_flags().IS_KEY(false);
            mst_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lon_hash("lon");
            for(int i = 0; i < 4; ++i)
            {
                mst_lon.detail().name_hash()[i] = lon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lon);

            MinimalStructMember mst_lat;
            mst_lat.common().member_id(memberId++);
            mst_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lat.common().member_flags().IS_OPTIONAL(false);
            mst_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lat.common().member_flags().IS_KEY(false);
            mst_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lat_hash("lat");
            for(int i = 0; i < 4; ++i)
            {
                mst_lat.detail().name_hash()[i] = lat_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lat);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PointLLH", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PointLLH", false);
        }

        const TypeObject* GetCompletePointLLHObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PointLLH", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_lon;
            cst_lon.common().member_id(memberId++);
            cst_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lon.common().member_flags().IS_OPTIONAL(false);
            cst_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lon.common().member_flags().IS_KEY(false);
            cst_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lon.detail().name("lon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lon);

            CompleteStructMember cst_lat;
            cst_lat.common().member_id(memberId++);
            cst_lat.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lat.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lat.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lat.common().member_flags().IS_OPTIONAL(false);
            cst_lat.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lat.common().member_flags().IS_KEY(false);
            cst_lat.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lat.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lat.detail().name("lat");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lat);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PointLLH");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PointLLH", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PointLLH", true);
        }

    } // namespace msg
} // namespace ros2_interface