// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointXYZIRT.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PointXYZIRT.h"
#include "PointXYZIRTTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_PointXYZIRT_max_cdr_typesize 40ULL;
#define ros2_interface_msg_PointXYZIRT_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PointXYZIRT::PointXYZIRT()
{
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_z
    m_z = 0.0;
    // unsigned long m_intensity
    m_intensity = 0;
    // uint8 m_ring_id
    m_ring_id = 0;
    // unsigned long long m_timestamp
    m_timestamp = 0;

    // Just to register all known types
    registerPointXYZIRTTypes();
}

ros2_interface::msg::PointXYZIRT::~PointXYZIRT()
{






}

ros2_interface::msg::PointXYZIRT::PointXYZIRT(
        const PointXYZIRT& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_intensity = x.m_intensity;
    m_ring_id = x.m_ring_id;
    m_timestamp = x.m_timestamp;
}

ros2_interface::msg::PointXYZIRT::PointXYZIRT(
        PointXYZIRT&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_intensity = x.m_intensity;
    m_ring_id = x.m_ring_id;
    m_timestamp = x.m_timestamp;
}

ros2_interface::msg::PointXYZIRT& ros2_interface::msg::PointXYZIRT::operator =(
        const PointXYZIRT& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_intensity = x.m_intensity;
    m_ring_id = x.m_ring_id;
    m_timestamp = x.m_timestamp;

    return *this;
}

ros2_interface::msg::PointXYZIRT& ros2_interface::msg::PointXYZIRT::operator =(
        PointXYZIRT&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_intensity = x.m_intensity;
    m_ring_id = x.m_ring_id;
    m_timestamp = x.m_timestamp;

    return *this;
}

bool ros2_interface::msg::PointXYZIRT::operator ==(
        const PointXYZIRT& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_z == x.m_z && m_intensity == x.m_intensity && m_ring_id == x.m_ring_id && m_timestamp == x.m_timestamp);
}

bool ros2_interface::msg::PointXYZIRT::operator !=(
        const PointXYZIRT& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PointXYZIRT::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointXYZIRT_max_cdr_typesize;
}

size_t ros2_interface::msg::PointXYZIRT::getCdrSerializedSize(
        const ros2_interface::msg::PointXYZIRT& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PointXYZIRT::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_z;
    scdr << m_intensity;
    scdr << m_ring_id;
    scdr << m_timestamp;

}

void ros2_interface::msg::PointXYZIRT::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_z;
    dcdr >> m_intensity;
    dcdr >> m_ring_id;
    dcdr >> m_timestamp;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::PointXYZIRT::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::PointXYZIRT::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::PointXYZIRT::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::PointXYZIRT::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::PointXYZIRT::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::PointXYZIRT::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member z
 * @param _z New value for member z
 */
void ros2_interface::msg::PointXYZIRT::z(
        double _z)
{
    m_z = _z;
}

/*!
 * @brief This function returns the value of member z
 * @return Value of member z
 */
double ros2_interface::msg::PointXYZIRT::z() const
{
    return m_z;
}

/*!
 * @brief This function returns a reference to member z
 * @return Reference to member z
 */
double& ros2_interface::msg::PointXYZIRT::z()
{
    return m_z;
}

/*!
 * @brief This function sets a value in member intensity
 * @param _intensity New value for member intensity
 */
void ros2_interface::msg::PointXYZIRT::intensity(
        uint32_t _intensity)
{
    m_intensity = _intensity;
}

/*!
 * @brief This function returns the value of member intensity
 * @return Value of member intensity
 */
uint32_t ros2_interface::msg::PointXYZIRT::intensity() const
{
    return m_intensity;
}

/*!
 * @brief This function returns a reference to member intensity
 * @return Reference to member intensity
 */
uint32_t& ros2_interface::msg::PointXYZIRT::intensity()
{
    return m_intensity;
}

/*!
 * @brief This function sets a value in member ring_id
 * @param _ring_id New value for member ring_id
 */
void ros2_interface::msg::PointXYZIRT::ring_id(
        uint8_t _ring_id)
{
    m_ring_id = _ring_id;
}

/*!
 * @brief This function returns the value of member ring_id
 * @return Value of member ring_id
 */
uint8_t ros2_interface::msg::PointXYZIRT::ring_id() const
{
    return m_ring_id;
}

/*!
 * @brief This function returns a reference to member ring_id
 * @return Reference to member ring_id
 */
uint8_t& ros2_interface::msg::PointXYZIRT::ring_id()
{
    return m_ring_id;
}

/*!
 * @brief This function sets a value in member timestamp
 * @param _timestamp New value for member timestamp
 */
void ros2_interface::msg::PointXYZIRT::timestamp(
        uint64_t _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function returns the value of member timestamp
 * @return Value of member timestamp
 */
uint64_t ros2_interface::msg::PointXYZIRT::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
uint64_t& ros2_interface::msg::PointXYZIRT::timestamp()
{
    return m_timestamp;
}



size_t ros2_interface::msg::PointXYZIRT::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PointXYZIRT_max_key_cdr_typesize;
}

bool ros2_interface::msg::PointXYZIRT::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PointXYZIRT::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



