// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PointXYZIRT.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTXYZIRT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTXYZIRT_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(POINTXYZIRT_SOURCE)
#define POINTXYZIRT_DllAPI __declspec( dllexport )
#else
#define POINTXYZIRT_DllAPI __declspec( dllimport )
#endif // POINTXYZIRT_SOURCE
#else
#define POINTXYZIRT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define POINTXYZIRT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PointXYZIRT defined by the user in the IDL file.
         * @ingroup PointXYZIRT
         */
        class PointXYZIRT
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PointXYZIRT();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PointXYZIRT();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PointXYZIRT that will be copied.
             */
            eProsima_user_DllExport PointXYZIRT(
                    const PointXYZIRT& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PointXYZIRT that will be copied.
             */
            eProsima_user_DllExport PointXYZIRT(
                    PointXYZIRT&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PointXYZIRT that will be copied.
             */
            eProsima_user_DllExport PointXYZIRT& operator =(
                    const PointXYZIRT& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PointXYZIRT that will be copied.
             */
            eProsima_user_DllExport PointXYZIRT& operator =(
                    PointXYZIRT&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointXYZIRT object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PointXYZIRT& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PointXYZIRT object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PointXYZIRT& x) const;

            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    double _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport double x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport double& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    double _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport double y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport double& y();

            /*!
             * @brief This function sets a value in member z
             * @param _z New value for member z
             */
            eProsima_user_DllExport void z(
                    double _z);

            /*!
             * @brief This function returns the value of member z
             * @return Value of member z
             */
            eProsima_user_DllExport double z() const;

            /*!
             * @brief This function returns a reference to member z
             * @return Reference to member z
             */
            eProsima_user_DllExport double& z();

            /*!
             * @brief This function sets a value in member intensity
             * @param _intensity New value for member intensity
             */
            eProsima_user_DllExport void intensity(
                    uint32_t _intensity);

            /*!
             * @brief This function returns the value of member intensity
             * @return Value of member intensity
             */
            eProsima_user_DllExport uint32_t intensity() const;

            /*!
             * @brief This function returns a reference to member intensity
             * @return Reference to member intensity
             */
            eProsima_user_DllExport uint32_t& intensity();

            /*!
             * @brief This function sets a value in member ring_id
             * @param _ring_id New value for member ring_id
             */
            eProsima_user_DllExport void ring_id(
                    uint8_t _ring_id);

            /*!
             * @brief This function returns the value of member ring_id
             * @return Value of member ring_id
             */
            eProsima_user_DllExport uint8_t ring_id() const;

            /*!
             * @brief This function returns a reference to member ring_id
             * @return Reference to member ring_id
             */
            eProsima_user_DllExport uint8_t& ring_id();

            /*!
             * @brief This function sets a value in member timestamp
             * @param _timestamp New value for member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    uint64_t _timestamp);

            /*!
             * @brief This function returns the value of member timestamp
             * @return Value of member timestamp
             */
            eProsima_user_DllExport uint64_t timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport uint64_t& timestamp();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PointXYZIRT& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_x;
            double m_y;
            double m_z;
            uint32_t m_intensity;
            uint8_t m_ring_id;
            uint64_t m_timestamp;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POINTXYZIRT_H_

