// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Polygon3D.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Polygon3D.h"
#include "Polygon3DTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Polygon3D_max_cdr_typesize 2408ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Polygon3D_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Polygon3D::Polygon3D()
{
    // long m_coordinate_system
    m_coordinate_system = 0;
    // sequence<ros2_interface::msg::Point3D> m_points


    // Just to register all known types
    registerPolygon3DTypes();
}

ros2_interface::msg::Polygon3D::~Polygon3D()
{


}

ros2_interface::msg::Polygon3D::Polygon3D(
        const Polygon3D& x)
{
    m_coordinate_system = x.m_coordinate_system;
    m_points = x.m_points;
}

ros2_interface::msg::Polygon3D::Polygon3D(
        Polygon3D&& x) noexcept 
{
    m_coordinate_system = x.m_coordinate_system;
    m_points = std::move(x.m_points);
}

ros2_interface::msg::Polygon3D& ros2_interface::msg::Polygon3D::operator =(
        const Polygon3D& x)
{

    m_coordinate_system = x.m_coordinate_system;
    m_points = x.m_points;

    return *this;
}

ros2_interface::msg::Polygon3D& ros2_interface::msg::Polygon3D::operator =(
        Polygon3D&& x) noexcept
{

    m_coordinate_system = x.m_coordinate_system;
    m_points = std::move(x.m_points);

    return *this;
}

bool ros2_interface::msg::Polygon3D::operator ==(
        const Polygon3D& x) const
{

    return (m_coordinate_system == x.m_coordinate_system && m_points == x.m_points);
}

bool ros2_interface::msg::Polygon3D::operator !=(
        const Polygon3D& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Polygon3D::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Polygon3D_max_cdr_typesize;
}

size_t ros2_interface::msg::Polygon3D::getCdrSerializedSize(
        const ros2_interface::msg::Polygon3D& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.points().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Polygon3D::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_coordinate_system;
    scdr << m_points;

}

void ros2_interface::msg::Polygon3D::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_coordinate_system;
    dcdr >> m_points;
}

/*!
 * @brief This function sets a value in member coordinate_system
 * @param _coordinate_system New value for member coordinate_system
 */
void ros2_interface::msg::Polygon3D::coordinate_system(
        int32_t _coordinate_system)
{
    m_coordinate_system = _coordinate_system;
}

/*!
 * @brief This function returns the value of member coordinate_system
 * @return Value of member coordinate_system
 */
int32_t ros2_interface::msg::Polygon3D::coordinate_system() const
{
    return m_coordinate_system;
}

/*!
 * @brief This function returns a reference to member coordinate_system
 * @return Reference to member coordinate_system
 */
int32_t& ros2_interface::msg::Polygon3D::coordinate_system()
{
    return m_coordinate_system;
}

/*!
 * @brief This function copies the value in member points
 * @param _points New value to be copied in member points
 */
void ros2_interface::msg::Polygon3D::points(
        const std::vector<ros2_interface::msg::Point3D>& _points)
{
    m_points = _points;
}

/*!
 * @brief This function moves the value in member points
 * @param _points New value to be moved in member points
 */
void ros2_interface::msg::Polygon3D::points(
        std::vector<ros2_interface::msg::Point3D>&& _points)
{
    m_points = std::move(_points);
}

/*!
 * @brief This function returns a constant reference to member points
 * @return Constant reference to member points
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Polygon3D::points() const
{
    return m_points;
}

/*!
 * @brief This function returns a reference to member points
 * @return Reference to member points
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Polygon3D::points()
{
    return m_points;
}


size_t ros2_interface::msg::Polygon3D::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Polygon3D_max_key_cdr_typesize;
}

bool ros2_interface::msg::Polygon3D::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Polygon3D::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



