// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Polygon3DTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Polygon3D.h"
#include "Polygon3DTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPolygon3DTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Polygon3D", ros2_interface::msg::GetPolygon3DIdentifier(true),
                        ros2_interface::msg::GetPolygon3DObject(true));
                factory->add_type_object("ros2_interface::msg::Polygon3D", ros2_interface::msg::GetPolygon3DIdentifier(false),
                        ros2_interface::msg::GetPolygon3DObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPolygon3DIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Polygon3D", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPolygon3DObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Polygon3D", complete);
        }

        const TypeObject* GetPolygon3DObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Polygon3D", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePolygon3DObject();
            }
            //else
            return GetMinimalPolygon3DObject();
        }

        const TypeObject* GetMinimalPolygon3DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Polygon3D", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_coordinate_system;
            mst_coordinate_system.common().member_id(memberId++);
            mst_coordinate_system.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_coordinate_system.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_coordinate_system.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_coordinate_system.common().member_flags().IS_OPTIONAL(false);
            mst_coordinate_system.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_coordinate_system.common().member_flags().IS_KEY(false);
            mst_coordinate_system.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_coordinate_system.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 coordinate_system_hash("coordinate_system");
            for(int i = 0; i < 4; ++i)
            {
                mst_coordinate_system.detail().name_hash()[i] = coordinate_system_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_coordinate_system);

            MinimalStructMember mst_points;
            mst_points.common().member_id(memberId++);
            mst_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_points.common().member_flags().IS_OPTIONAL(false);
            mst_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_points.common().member_flags().IS_KEY(false);
            mst_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 points_hash("points");
            for(int i = 0; i < 4; ++i)
            {
                mst_points.detail().name_hash()[i] = points_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_points);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Polygon3D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Polygon3D", false);
        }

        const TypeObject* GetCompletePolygon3DObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Polygon3D", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_coordinate_system;
            cst_coordinate_system.common().member_id(memberId++);
            cst_coordinate_system.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_coordinate_system.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_coordinate_system.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_coordinate_system.common().member_flags().IS_OPTIONAL(false);
            cst_coordinate_system.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_coordinate_system.common().member_flags().IS_KEY(false);
            cst_coordinate_system.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_coordinate_system.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_coordinate_system.detail().name("coordinate_system");

            type_object->complete().struct_type().member_seq().emplace_back(cst_coordinate_system);

            CompleteStructMember cst_points;
            cst_points.common().member_id(memberId++);
            cst_points.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_points.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_points.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_points.common().member_flags().IS_OPTIONAL(false);
            cst_points.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_points.common().member_flags().IS_KEY(false);
            cst_points.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_points.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_points.detail().name("points");

            type_object->complete().struct_type().member_seq().emplace_back(cst_points);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Polygon3D");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Polygon3D", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Polygon3D", true);
        }

    } // namespace msg
} // namespace ros2_interface