// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Pose.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Pose.h"
#include "PoseTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Quaternion_max_cdr_typesize 32ULL;
#define ros2_interface_msg_PointENU_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Pose_max_cdr_typesize 208ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Quaternion_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointENU_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Pose_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Pose::Pose()
{
    // ros2_interface::msg::PointENU m_position

    // ros2_interface::msg::Quaternion m_orientation

    // ros2_interface::msg::Point3D m_linear_velocity

    // ros2_interface::msg::Point3D m_linear_acceleration

    // ros2_interface::msg::Point3D m_angular_velocity

    // double m_heading
    m_heading = 0.0;
    // ros2_interface::msg::Point3D m_linear_acceleration_vrf

    // ros2_interface::msg::Point3D m_angular_velocity_vrf

    // ros2_interface::msg::Point3D m_euler_angles


    // Just to register all known types
    registerPoseTypes();
}

ros2_interface::msg::Pose::~Pose()
{









}

ros2_interface::msg::Pose::Pose(
        const Pose& x)
{
    m_position = x.m_position;
    m_orientation = x.m_orientation;
    m_linear_velocity = x.m_linear_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_angular_velocity = x.m_angular_velocity;
    m_heading = x.m_heading;
    m_linear_acceleration_vrf = x.m_linear_acceleration_vrf;
    m_angular_velocity_vrf = x.m_angular_velocity_vrf;
    m_euler_angles = x.m_euler_angles;
}

ros2_interface::msg::Pose::Pose(
        Pose&& x) noexcept 
{
    m_position = std::move(x.m_position);
    m_orientation = std::move(x.m_orientation);
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_heading = x.m_heading;
    m_linear_acceleration_vrf = std::move(x.m_linear_acceleration_vrf);
    m_angular_velocity_vrf = std::move(x.m_angular_velocity_vrf);
    m_euler_angles = std::move(x.m_euler_angles);
}

ros2_interface::msg::Pose& ros2_interface::msg::Pose::operator =(
        const Pose& x)
{

    m_position = x.m_position;
    m_orientation = x.m_orientation;
    m_linear_velocity = x.m_linear_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_angular_velocity = x.m_angular_velocity;
    m_heading = x.m_heading;
    m_linear_acceleration_vrf = x.m_linear_acceleration_vrf;
    m_angular_velocity_vrf = x.m_angular_velocity_vrf;
    m_euler_angles = x.m_euler_angles;

    return *this;
}

ros2_interface::msg::Pose& ros2_interface::msg::Pose::operator =(
        Pose&& x) noexcept
{

    m_position = std::move(x.m_position);
    m_orientation = std::move(x.m_orientation);
    m_linear_velocity = std::move(x.m_linear_velocity);
    m_linear_acceleration = std::move(x.m_linear_acceleration);
    m_angular_velocity = std::move(x.m_angular_velocity);
    m_heading = x.m_heading;
    m_linear_acceleration_vrf = std::move(x.m_linear_acceleration_vrf);
    m_angular_velocity_vrf = std::move(x.m_angular_velocity_vrf);
    m_euler_angles = std::move(x.m_euler_angles);

    return *this;
}

bool ros2_interface::msg::Pose::operator ==(
        const Pose& x) const
{

    return (m_position == x.m_position && m_orientation == x.m_orientation && m_linear_velocity == x.m_linear_velocity && m_linear_acceleration == x.m_linear_acceleration && m_angular_velocity == x.m_angular_velocity && m_heading == x.m_heading && m_linear_acceleration_vrf == x.m_linear_acceleration_vrf && m_angular_velocity_vrf == x.m_angular_velocity_vrf && m_euler_angles == x.m_euler_angles);
}

bool ros2_interface::msg::Pose::operator !=(
        const Pose& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Pose::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Pose_max_cdr_typesize;
}

size_t ros2_interface::msg::Pose::getCdrSerializedSize(
        const ros2_interface::msg::Pose& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::PointENU::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += ros2_interface::msg::Quaternion::getCdrSerializedSize(data.orientation(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_velocity(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration_vrf(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity_vrf(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.euler_angles(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Pose::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_position;
    scdr << m_orientation;
    scdr << m_linear_velocity;
    scdr << m_linear_acceleration;
    scdr << m_angular_velocity;
    scdr << m_heading;
    scdr << m_linear_acceleration_vrf;
    scdr << m_angular_velocity_vrf;
    scdr << m_euler_angles;

}

void ros2_interface::msg::Pose::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_position;
    dcdr >> m_orientation;
    dcdr >> m_linear_velocity;
    dcdr >> m_linear_acceleration;
    dcdr >> m_angular_velocity;
    dcdr >> m_heading;
    dcdr >> m_linear_acceleration_vrf;
    dcdr >> m_angular_velocity_vrf;
    dcdr >> m_euler_angles;
}

/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::Pose::position(
        const ros2_interface::msg::PointENU& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::Pose::position(
        ros2_interface::msg::PointENU&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::PointENU& ros2_interface::msg::Pose::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::PointENU& ros2_interface::msg::Pose::position()
{
    return m_position;
}
/*!
 * @brief This function copies the value in member orientation
 * @param _orientation New value to be copied in member orientation
 */
void ros2_interface::msg::Pose::orientation(
        const ros2_interface::msg::Quaternion& _orientation)
{
    m_orientation = _orientation;
}

/*!
 * @brief This function moves the value in member orientation
 * @param _orientation New value to be moved in member orientation
 */
void ros2_interface::msg::Pose::orientation(
        ros2_interface::msg::Quaternion&& _orientation)
{
    m_orientation = std::move(_orientation);
}

/*!
 * @brief This function returns a constant reference to member orientation
 * @return Constant reference to member orientation
 */
const ros2_interface::msg::Quaternion& ros2_interface::msg::Pose::orientation() const
{
    return m_orientation;
}

/*!
 * @brief This function returns a reference to member orientation
 * @return Reference to member orientation
 */
ros2_interface::msg::Quaternion& ros2_interface::msg::Pose::orientation()
{
    return m_orientation;
}
/*!
 * @brief This function copies the value in member linear_velocity
 * @param _linear_velocity New value to be copied in member linear_velocity
 */
void ros2_interface::msg::Pose::linear_velocity(
        const ros2_interface::msg::Point3D& _linear_velocity)
{
    m_linear_velocity = _linear_velocity;
}

/*!
 * @brief This function moves the value in member linear_velocity
 * @param _linear_velocity New value to be moved in member linear_velocity
 */
void ros2_interface::msg::Pose::linear_velocity(
        ros2_interface::msg::Point3D&& _linear_velocity)
{
    m_linear_velocity = std::move(_linear_velocity);
}

/*!
 * @brief This function returns a constant reference to member linear_velocity
 * @return Constant reference to member linear_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_velocity() const
{
    return m_linear_velocity;
}

/*!
 * @brief This function returns a reference to member linear_velocity
 * @return Reference to member linear_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_velocity()
{
    return m_linear_velocity;
}
/*!
 * @brief This function copies the value in member linear_acceleration
 * @param _linear_acceleration New value to be copied in member linear_acceleration
 */
void ros2_interface::msg::Pose::linear_acceleration(
        const ros2_interface::msg::Point3D& _linear_acceleration)
{
    m_linear_acceleration = _linear_acceleration;
}

/*!
 * @brief This function moves the value in member linear_acceleration
 * @param _linear_acceleration New value to be moved in member linear_acceleration
 */
void ros2_interface::msg::Pose::linear_acceleration(
        ros2_interface::msg::Point3D&& _linear_acceleration)
{
    m_linear_acceleration = std::move(_linear_acceleration);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration
 * @return Constant reference to member linear_acceleration
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_acceleration() const
{
    return m_linear_acceleration;
}

/*!
 * @brief This function returns a reference to member linear_acceleration
 * @return Reference to member linear_acceleration
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_acceleration()
{
    return m_linear_acceleration;
}
/*!
 * @brief This function copies the value in member angular_velocity
 * @param _angular_velocity New value to be copied in member angular_velocity
 */
void ros2_interface::msg::Pose::angular_velocity(
        const ros2_interface::msg::Point3D& _angular_velocity)
{
    m_angular_velocity = _angular_velocity;
}

/*!
 * @brief This function moves the value in member angular_velocity
 * @param _angular_velocity New value to be moved in member angular_velocity
 */
void ros2_interface::msg::Pose::angular_velocity(
        ros2_interface::msg::Point3D&& _angular_velocity)
{
    m_angular_velocity = std::move(_angular_velocity);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity
 * @return Constant reference to member angular_velocity
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::angular_velocity() const
{
    return m_angular_velocity;
}

/*!
 * @brief This function returns a reference to member angular_velocity
 * @return Reference to member angular_velocity
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::angular_velocity()
{
    return m_angular_velocity;
}
/*!
 * @brief This function sets a value in member heading
 * @param _heading New value for member heading
 */
void ros2_interface::msg::Pose::heading(
        double _heading)
{
    m_heading = _heading;
}

/*!
 * @brief This function returns the value of member heading
 * @return Value of member heading
 */
double ros2_interface::msg::Pose::heading() const
{
    return m_heading;
}

/*!
 * @brief This function returns a reference to member heading
 * @return Reference to member heading
 */
double& ros2_interface::msg::Pose::heading()
{
    return m_heading;
}

/*!
 * @brief This function copies the value in member linear_acceleration_vrf
 * @param _linear_acceleration_vrf New value to be copied in member linear_acceleration_vrf
 */
void ros2_interface::msg::Pose::linear_acceleration_vrf(
        const ros2_interface::msg::Point3D& _linear_acceleration_vrf)
{
    m_linear_acceleration_vrf = _linear_acceleration_vrf;
}

/*!
 * @brief This function moves the value in member linear_acceleration_vrf
 * @param _linear_acceleration_vrf New value to be moved in member linear_acceleration_vrf
 */
void ros2_interface::msg::Pose::linear_acceleration_vrf(
        ros2_interface::msg::Point3D&& _linear_acceleration_vrf)
{
    m_linear_acceleration_vrf = std::move(_linear_acceleration_vrf);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration_vrf
 * @return Constant reference to member linear_acceleration_vrf
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_acceleration_vrf() const
{
    return m_linear_acceleration_vrf;
}

/*!
 * @brief This function returns a reference to member linear_acceleration_vrf
 * @return Reference to member linear_acceleration_vrf
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::linear_acceleration_vrf()
{
    return m_linear_acceleration_vrf;
}
/*!
 * @brief This function copies the value in member angular_velocity_vrf
 * @param _angular_velocity_vrf New value to be copied in member angular_velocity_vrf
 */
void ros2_interface::msg::Pose::angular_velocity_vrf(
        const ros2_interface::msg::Point3D& _angular_velocity_vrf)
{
    m_angular_velocity_vrf = _angular_velocity_vrf;
}

/*!
 * @brief This function moves the value in member angular_velocity_vrf
 * @param _angular_velocity_vrf New value to be moved in member angular_velocity_vrf
 */
void ros2_interface::msg::Pose::angular_velocity_vrf(
        ros2_interface::msg::Point3D&& _angular_velocity_vrf)
{
    m_angular_velocity_vrf = std::move(_angular_velocity_vrf);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity_vrf
 * @return Constant reference to member angular_velocity_vrf
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::angular_velocity_vrf() const
{
    return m_angular_velocity_vrf;
}

/*!
 * @brief This function returns a reference to member angular_velocity_vrf
 * @return Reference to member angular_velocity_vrf
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::angular_velocity_vrf()
{
    return m_angular_velocity_vrf;
}
/*!
 * @brief This function copies the value in member euler_angles
 * @param _euler_angles New value to be copied in member euler_angles
 */
void ros2_interface::msg::Pose::euler_angles(
        const ros2_interface::msg::Point3D& _euler_angles)
{
    m_euler_angles = _euler_angles;
}

/*!
 * @brief This function moves the value in member euler_angles
 * @param _euler_angles New value to be moved in member euler_angles
 */
void ros2_interface::msg::Pose::euler_angles(
        ros2_interface::msg::Point3D&& _euler_angles)
{
    m_euler_angles = std::move(_euler_angles);
}

/*!
 * @brief This function returns a constant reference to member euler_angles
 * @return Constant reference to member euler_angles
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Pose::euler_angles() const
{
    return m_euler_angles;
}

/*!
 * @brief This function returns a reference to member euler_angles
 * @return Reference to member euler_angles
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Pose::euler_angles()
{
    return m_euler_angles;
}


size_t ros2_interface::msg::Pose::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Pose_max_key_cdr_typesize;
}

bool ros2_interface::msg::Pose::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Pose::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



