// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Pose.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POSE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POSE_H_

#include "Quaternion.h"
#include "Point3D.h"
#include "PointENU.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(POSE_SOURCE)
#define POSE_DllAPI __declspec( dllexport )
#else
#define POSE_DllAPI __declspec( dllimport )
#endif // POSE_SOURCE
#else
#define POSE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define POSE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Pose defined by the user in the IDL file.
         * @ingroup Pose
         */
        class Pose
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Pose();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Pose();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Pose that will be copied.
             */
            eProsima_user_DllExport Pose(
                    const Pose& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Pose that will be copied.
             */
            eProsima_user_DllExport Pose(
                    Pose&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Pose that will be copied.
             */
            eProsima_user_DllExport Pose& operator =(
                    const Pose& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Pose that will be copied.
             */
            eProsima_user_DllExport Pose& operator =(
                    Pose&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Pose object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Pose& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Pose object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Pose& x) const;

            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::PointENU& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::PointENU&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::PointENU& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::PointENU& position();
            /*!
             * @brief This function copies the value in member orientation
             * @param _orientation New value to be copied in member orientation
             */
            eProsima_user_DllExport void orientation(
                    const ros2_interface::msg::Quaternion& _orientation);

            /*!
             * @brief This function moves the value in member orientation
             * @param _orientation New value to be moved in member orientation
             */
            eProsima_user_DllExport void orientation(
                    ros2_interface::msg::Quaternion&& _orientation);

            /*!
             * @brief This function returns a constant reference to member orientation
             * @return Constant reference to member orientation
             */
            eProsima_user_DllExport const ros2_interface::msg::Quaternion& orientation() const;

            /*!
             * @brief This function returns a reference to member orientation
             * @return Reference to member orientation
             */
            eProsima_user_DllExport ros2_interface::msg::Quaternion& orientation();
            /*!
             * @brief This function copies the value in member linear_velocity
             * @param _linear_velocity New value to be copied in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    const ros2_interface::msg::Point3D& _linear_velocity);

            /*!
             * @brief This function moves the value in member linear_velocity
             * @param _linear_velocity New value to be moved in member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    ros2_interface::msg::Point3D&& _linear_velocity);

            /*!
             * @brief This function returns a constant reference to member linear_velocity
             * @return Constant reference to member linear_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_velocity() const;

            /*!
             * @brief This function returns a reference to member linear_velocity
             * @return Reference to member linear_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_velocity();
            /*!
             * @brief This function copies the value in member linear_acceleration
             * @param _linear_acceleration New value to be copied in member linear_acceleration
             */
            eProsima_user_DllExport void linear_acceleration(
                    const ros2_interface::msg::Point3D& _linear_acceleration);

            /*!
             * @brief This function moves the value in member linear_acceleration
             * @param _linear_acceleration New value to be moved in member linear_acceleration
             */
            eProsima_user_DllExport void linear_acceleration(
                    ros2_interface::msg::Point3D&& _linear_acceleration);

            /*!
             * @brief This function returns a constant reference to member linear_acceleration
             * @return Constant reference to member linear_acceleration
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_acceleration() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration
             * @return Reference to member linear_acceleration
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_acceleration();
            /*!
             * @brief This function copies the value in member angular_velocity
             * @param _angular_velocity New value to be copied in member angular_velocity
             */
            eProsima_user_DllExport void angular_velocity(
                    const ros2_interface::msg::Point3D& _angular_velocity);

            /*!
             * @brief This function moves the value in member angular_velocity
             * @param _angular_velocity New value to be moved in member angular_velocity
             */
            eProsima_user_DllExport void angular_velocity(
                    ros2_interface::msg::Point3D&& _angular_velocity);

            /*!
             * @brief This function returns a constant reference to member angular_velocity
             * @return Constant reference to member angular_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular_velocity() const;

            /*!
             * @brief This function returns a reference to member angular_velocity
             * @return Reference to member angular_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular_velocity();
            /*!
             * @brief This function sets a value in member heading
             * @param _heading New value for member heading
             */
            eProsima_user_DllExport void heading(
                    double _heading);

            /*!
             * @brief This function returns the value of member heading
             * @return Value of member heading
             */
            eProsima_user_DllExport double heading() const;

            /*!
             * @brief This function returns a reference to member heading
             * @return Reference to member heading
             */
            eProsima_user_DllExport double& heading();

            /*!
             * @brief This function copies the value in member linear_acceleration_vrf
             * @param _linear_acceleration_vrf New value to be copied in member linear_acceleration_vrf
             */
            eProsima_user_DllExport void linear_acceleration_vrf(
                    const ros2_interface::msg::Point3D& _linear_acceleration_vrf);

            /*!
             * @brief This function moves the value in member linear_acceleration_vrf
             * @param _linear_acceleration_vrf New value to be moved in member linear_acceleration_vrf
             */
            eProsima_user_DllExport void linear_acceleration_vrf(
                    ros2_interface::msg::Point3D&& _linear_acceleration_vrf);

            /*!
             * @brief This function returns a constant reference to member linear_acceleration_vrf
             * @return Constant reference to member linear_acceleration_vrf
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_acceleration_vrf() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration_vrf
             * @return Reference to member linear_acceleration_vrf
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_acceleration_vrf();
            /*!
             * @brief This function copies the value in member angular_velocity_vrf
             * @param _angular_velocity_vrf New value to be copied in member angular_velocity_vrf
             */
            eProsima_user_DllExport void angular_velocity_vrf(
                    const ros2_interface::msg::Point3D& _angular_velocity_vrf);

            /*!
             * @brief This function moves the value in member angular_velocity_vrf
             * @param _angular_velocity_vrf New value to be moved in member angular_velocity_vrf
             */
            eProsima_user_DllExport void angular_velocity_vrf(
                    ros2_interface::msg::Point3D&& _angular_velocity_vrf);

            /*!
             * @brief This function returns a constant reference to member angular_velocity_vrf
             * @return Constant reference to member angular_velocity_vrf
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular_velocity_vrf() const;

            /*!
             * @brief This function returns a reference to member angular_velocity_vrf
             * @return Reference to member angular_velocity_vrf
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular_velocity_vrf();
            /*!
             * @brief This function copies the value in member euler_angles
             * @param _euler_angles New value to be copied in member euler_angles
             */
            eProsima_user_DllExport void euler_angles(
                    const ros2_interface::msg::Point3D& _euler_angles);

            /*!
             * @brief This function moves the value in member euler_angles
             * @param _euler_angles New value to be moved in member euler_angles
             */
            eProsima_user_DllExport void euler_angles(
                    ros2_interface::msg::Point3D&& _euler_angles);

            /*!
             * @brief This function returns a constant reference to member euler_angles
             * @return Constant reference to member euler_angles
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& euler_angles() const;

            /*!
             * @brief This function returns a reference to member euler_angles
             * @return Reference to member euler_angles
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& euler_angles();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Pose& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::PointENU m_position;
            ros2_interface::msg::Quaternion m_orientation;
            ros2_interface::msg::Point3D m_linear_velocity;
            ros2_interface::msg::Point3D m_linear_acceleration;
            ros2_interface::msg::Point3D m_angular_velocity;
            double m_heading;
            ros2_interface::msg::Point3D m_linear_acceleration_vrf;
            ros2_interface::msg::Point3D m_angular_velocity_vrf;
            ros2_interface::msg::Point3D m_euler_angles;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_POSE_H_

