// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PoseTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Pose.h"
#include "PoseTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPoseTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(true),
                        ros2_interface::msg::GetPointENUObject(true));
                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(false),
                        ros2_interface::msg::GetPointENUObject(false));



                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(true),
                        ros2_interface::msg::GetQuaternionObject(true));
                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(false),
                        ros2_interface::msg::GetQuaternionObject(false));



                factory->add_type_object("ros2_interface::msg::Pose", ros2_interface::msg::GetPoseIdentifier(true),
                        ros2_interface::msg::GetPoseObject(true));
                factory->add_type_object("ros2_interface::msg::Pose", ros2_interface::msg::GetPoseIdentifier(false),
                        ros2_interface::msg::GetPoseObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPoseIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Pose", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPoseObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Pose", complete);
        }

        const TypeObject* GetPoseObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Pose", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePoseObject();
            }
            //else
            return GetMinimalPoseObject();
        }

        const TypeObject* GetMinimalPoseObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Pose", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_orientation;
            mst_orientation.common().member_id(memberId++);
            mst_orientation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_orientation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_orientation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_orientation.common().member_flags().IS_OPTIONAL(false);
            mst_orientation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_orientation.common().member_flags().IS_KEY(false);
            mst_orientation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_orientation.common().member_type_id(*ros2_interface::msg::GetQuaternionIdentifier(false));
            MD5 orientation_hash("orientation");
            for(int i = 0; i < 4; ++i)
            {
                mst_orientation.detail().name_hash()[i] = orientation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_orientation);

            MinimalStructMember mst_linear_velocity;
            mst_linear_velocity.common().member_id(memberId++);
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity.common().member_flags().IS_KEY(false);
            mst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_velocity_hash("linear_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity.detail().name_hash()[i] = linear_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity);

            MinimalStructMember mst_linear_acceleration;
            mst_linear_acceleration.common().member_id(memberId++);
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration.common().member_flags().IS_KEY(false);
            mst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_hash("linear_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration.detail().name_hash()[i] = linear_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration);

            MinimalStructMember mst_angular_velocity;
            mst_angular_velocity.common().member_id(memberId++);
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity.common().member_flags().IS_KEY(false);
            mst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_hash("angular_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity.detail().name_hash()[i] = angular_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity);

            MinimalStructMember mst_heading;
            mst_heading.common().member_id(memberId++);
            mst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading.common().member_flags().IS_OPTIONAL(false);
            mst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading.common().member_flags().IS_KEY(false);
            mst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_hash("heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading.detail().name_hash()[i] = heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading);

            MinimalStructMember mst_linear_acceleration_vrf;
            mst_linear_acceleration_vrf.common().member_id(memberId++);
            mst_linear_acceleration_vrf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration_vrf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration_vrf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration_vrf.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration_vrf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration_vrf.common().member_flags().IS_KEY(false);
            mst_linear_acceleration_vrf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration_vrf.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_vrf_hash("linear_acceleration_vrf");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration_vrf.detail().name_hash()[i] = linear_acceleration_vrf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration_vrf);

            MinimalStructMember mst_angular_velocity_vrf;
            mst_angular_velocity_vrf.common().member_id(memberId++);
            mst_angular_velocity_vrf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity_vrf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity_vrf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity_vrf.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity_vrf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity_vrf.common().member_flags().IS_KEY(false);
            mst_angular_velocity_vrf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity_vrf.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_vrf_hash("angular_velocity_vrf");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity_vrf.detail().name_hash()[i] = angular_velocity_vrf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity_vrf);

            MinimalStructMember mst_euler_angles;
            mst_euler_angles.common().member_id(memberId++);
            mst_euler_angles.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_euler_angles.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_euler_angles.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_euler_angles.common().member_flags().IS_OPTIONAL(false);
            mst_euler_angles.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_euler_angles.common().member_flags().IS_KEY(false);
            mst_euler_angles.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_euler_angles.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 euler_angles_hash("euler_angles");
            for(int i = 0; i < 4; ++i)
            {
                mst_euler_angles.detail().name_hash()[i] = euler_angles_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_euler_angles);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Pose", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Pose", false);
        }

        const TypeObject* GetCompletePoseObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Pose", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPointENUIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_orientation;
            cst_orientation.common().member_id(memberId++);
            cst_orientation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_orientation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_orientation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_orientation.common().member_flags().IS_OPTIONAL(false);
            cst_orientation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_orientation.common().member_flags().IS_KEY(false);
            cst_orientation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_orientation.common().member_type_id(*ros2_interface::msg::GetQuaternionIdentifier(true));
            cst_orientation.detail().name("orientation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_orientation);

            CompleteStructMember cst_linear_velocity;
            cst_linear_velocity.common().member_id(memberId++);
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity.common().member_flags().IS_KEY(false);
            cst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_velocity.detail().name("linear_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity);

            CompleteStructMember cst_linear_acceleration;
            cst_linear_acceleration.common().member_id(memberId++);
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration.common().member_flags().IS_KEY(false);
            cst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration.detail().name("linear_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration);

            CompleteStructMember cst_angular_velocity;
            cst_angular_velocity.common().member_id(memberId++);
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity.common().member_flags().IS_KEY(false);
            cst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity.detail().name("angular_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity);

            CompleteStructMember cst_heading;
            cst_heading.common().member_id(memberId++);
            cst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading.common().member_flags().IS_OPTIONAL(false);
            cst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading.common().member_flags().IS_KEY(false);
            cst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading.detail().name("heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading);

            CompleteStructMember cst_linear_acceleration_vrf;
            cst_linear_acceleration_vrf.common().member_id(memberId++);
            cst_linear_acceleration_vrf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration_vrf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration_vrf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration_vrf.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration_vrf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration_vrf.common().member_flags().IS_KEY(false);
            cst_linear_acceleration_vrf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration_vrf.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration_vrf.detail().name("linear_acceleration_vrf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration_vrf);

            CompleteStructMember cst_angular_velocity_vrf;
            cst_angular_velocity_vrf.common().member_id(memberId++);
            cst_angular_velocity_vrf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity_vrf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity_vrf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity_vrf.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity_vrf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity_vrf.common().member_flags().IS_KEY(false);
            cst_angular_velocity_vrf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity_vrf.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity_vrf.detail().name("angular_velocity_vrf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity_vrf);

            CompleteStructMember cst_euler_angles;
            cst_euler_angles.common().member_id(memberId++);
            cst_euler_angles.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_euler_angles.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_euler_angles.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_euler_angles.common().member_flags().IS_OPTIONAL(false);
            cst_euler_angles.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_euler_angles.common().member_flags().IS_KEY(false);
            cst_euler_angles.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_euler_angles.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_euler_angles.detail().name("euler_angles");

            type_object->complete().struct_type().member_seq().emplace_back(cst_euler_angles);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Pose");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Pose", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Pose", true);
        }

    } // namespace msg
} // namespace ros2_interface