// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PredictionObstacle.h"
#include "PredictionObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObstacleInteractiveTag_max_cdr_typesize 4ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_ObstaclePriority_max_cdr_typesize 4ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_cdr_typesize 15212ULL;
#define ros2_interface_msg_PredictionObstacle_max_cdr_typesize 1529097ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_PerceptionObstacle_max_cdr_typesize 7457ULL;
#define ros2_interface_msg_ObstacleIntent_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ObstacleInteractiveTag_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstaclePriority_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PredictionObstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PerceptionObstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstacleIntent_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PredictionObstacle::PredictionObstacle()
{
    // ros2_interface::msg::PerceptionObstacle m_perception_obstacle

    // double m_timestamp
    m_timestamp = 0.0;
    // double m_predicted_period
    m_predicted_period = 0.0;
    // sequence<ros2_interface::msg::TrajectoryInPrediction> m_trajectory

    // ros2_interface::msg::ObstacleIntent m_intent

    // ros2_interface::msg::ObstaclePriority m_priority

    // ros2_interface::msg::ObstacleInteractiveTag m_interactive_tag

    // boolean m_is_static
    m_is_static = false;

    // Just to register all known types
    registerPredictionObstacleTypes();
}

ros2_interface::msg::PredictionObstacle::~PredictionObstacle()
{








}

ros2_interface::msg::PredictionObstacle::PredictionObstacle(
        const PredictionObstacle& x)
{
    m_perception_obstacle = x.m_perception_obstacle;
    m_timestamp = x.m_timestamp;
    m_predicted_period = x.m_predicted_period;
    m_trajectory = x.m_trajectory;
    m_intent = x.m_intent;
    m_priority = x.m_priority;
    m_interactive_tag = x.m_interactive_tag;
    m_is_static = x.m_is_static;
}

ros2_interface::msg::PredictionObstacle::PredictionObstacle(
        PredictionObstacle&& x) noexcept 
{
    m_perception_obstacle = std::move(x.m_perception_obstacle);
    m_timestamp = x.m_timestamp;
    m_predicted_period = x.m_predicted_period;
    m_trajectory = std::move(x.m_trajectory);
    m_intent = std::move(x.m_intent);
    m_priority = std::move(x.m_priority);
    m_interactive_tag = std::move(x.m_interactive_tag);
    m_is_static = x.m_is_static;
}

ros2_interface::msg::PredictionObstacle& ros2_interface::msg::PredictionObstacle::operator =(
        const PredictionObstacle& x)
{

    m_perception_obstacle = x.m_perception_obstacle;
    m_timestamp = x.m_timestamp;
    m_predicted_period = x.m_predicted_period;
    m_trajectory = x.m_trajectory;
    m_intent = x.m_intent;
    m_priority = x.m_priority;
    m_interactive_tag = x.m_interactive_tag;
    m_is_static = x.m_is_static;

    return *this;
}

ros2_interface::msg::PredictionObstacle& ros2_interface::msg::PredictionObstacle::operator =(
        PredictionObstacle&& x) noexcept
{

    m_perception_obstacle = std::move(x.m_perception_obstacle);
    m_timestamp = x.m_timestamp;
    m_predicted_period = x.m_predicted_period;
    m_trajectory = std::move(x.m_trajectory);
    m_intent = std::move(x.m_intent);
    m_priority = std::move(x.m_priority);
    m_interactive_tag = std::move(x.m_interactive_tag);
    m_is_static = x.m_is_static;

    return *this;
}

bool ros2_interface::msg::PredictionObstacle::operator ==(
        const PredictionObstacle& x) const
{

    return (m_perception_obstacle == x.m_perception_obstacle && m_timestamp == x.m_timestamp && m_predicted_period == x.m_predicted_period && m_trajectory == x.m_trajectory && m_intent == x.m_intent && m_priority == x.m_priority && m_interactive_tag == x.m_interactive_tag && m_is_static == x.m_is_static);
}

bool ros2_interface::msg::PredictionObstacle::operator !=(
        const PredictionObstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PredictionObstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PredictionObstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::PredictionObstacle::getCdrSerializedSize(
        const ros2_interface::msg::PredictionObstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::PerceptionObstacle::getCdrSerializedSize(data.perception_obstacle(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.trajectory().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrajectoryInPrediction::getCdrSerializedSize(data.trajectory().at(a), current_alignment);}

    current_alignment += ros2_interface::msg::ObstacleIntent::getCdrSerializedSize(data.intent(), current_alignment);
    current_alignment += ros2_interface::msg::ObstaclePriority::getCdrSerializedSize(data.priority(), current_alignment);
    current_alignment += ros2_interface::msg::ObstacleInteractiveTag::getCdrSerializedSize(data.interactive_tag(), current_alignment);
    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PredictionObstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_perception_obstacle;
    scdr << m_timestamp;
    scdr << m_predicted_period;
    scdr << m_trajectory;
    scdr << m_intent;
    scdr << m_priority;
    scdr << m_interactive_tag;
    scdr << m_is_static;

}

void ros2_interface::msg::PredictionObstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_perception_obstacle;
    dcdr >> m_timestamp;
    dcdr >> m_predicted_period;
    dcdr >> m_trajectory;
    dcdr >> m_intent;
    dcdr >> m_priority;
    dcdr >> m_interactive_tag;
    dcdr >> m_is_static;
}

/*!
 * @brief This function copies the value in member perception_obstacle
 * @param _perception_obstacle New value to be copied in member perception_obstacle
 */
void ros2_interface::msg::PredictionObstacle::perception_obstacle(
        const ros2_interface::msg::PerceptionObstacle& _perception_obstacle)
{
    m_perception_obstacle = _perception_obstacle;
}

/*!
 * @brief This function moves the value in member perception_obstacle
 * @param _perception_obstacle New value to be moved in member perception_obstacle
 */
void ros2_interface::msg::PredictionObstacle::perception_obstacle(
        ros2_interface::msg::PerceptionObstacle&& _perception_obstacle)
{
    m_perception_obstacle = std::move(_perception_obstacle);
}

/*!
 * @brief This function returns a constant reference to member perception_obstacle
 * @return Constant reference to member perception_obstacle
 */
const ros2_interface::msg::PerceptionObstacle& ros2_interface::msg::PredictionObstacle::perception_obstacle() const
{
    return m_perception_obstacle;
}

/*!
 * @brief This function returns a reference to member perception_obstacle
 * @return Reference to member perception_obstacle
 */
ros2_interface::msg::PerceptionObstacle& ros2_interface::msg::PredictionObstacle::perception_obstacle()
{
    return m_perception_obstacle;
}
/*!
 * @brief This function sets a value in member timestamp
 * @param _timestamp New value for member timestamp
 */
void ros2_interface::msg::PredictionObstacle::timestamp(
        double _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function returns the value of member timestamp
 * @return Value of member timestamp
 */
double ros2_interface::msg::PredictionObstacle::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
double& ros2_interface::msg::PredictionObstacle::timestamp()
{
    return m_timestamp;
}

/*!
 * @brief This function sets a value in member predicted_period
 * @param _predicted_period New value for member predicted_period
 */
void ros2_interface::msg::PredictionObstacle::predicted_period(
        double _predicted_period)
{
    m_predicted_period = _predicted_period;
}

/*!
 * @brief This function returns the value of member predicted_period
 * @return Value of member predicted_period
 */
double ros2_interface::msg::PredictionObstacle::predicted_period() const
{
    return m_predicted_period;
}

/*!
 * @brief This function returns a reference to member predicted_period
 * @return Reference to member predicted_period
 */
double& ros2_interface::msg::PredictionObstacle::predicted_period()
{
    return m_predicted_period;
}

/*!
 * @brief This function copies the value in member trajectory
 * @param _trajectory New value to be copied in member trajectory
 */
void ros2_interface::msg::PredictionObstacle::trajectory(
        const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _trajectory)
{
    m_trajectory = _trajectory;
}

/*!
 * @brief This function moves the value in member trajectory
 * @param _trajectory New value to be moved in member trajectory
 */
void ros2_interface::msg::PredictionObstacle::trajectory(
        std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _trajectory)
{
    m_trajectory = std::move(_trajectory);
}

/*!
 * @brief This function returns a constant reference to member trajectory
 * @return Constant reference to member trajectory
 */
const std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::PredictionObstacle::trajectory() const
{
    return m_trajectory;
}

/*!
 * @brief This function returns a reference to member trajectory
 * @return Reference to member trajectory
 */
std::vector<ros2_interface::msg::TrajectoryInPrediction>& ros2_interface::msg::PredictionObstacle::trajectory()
{
    return m_trajectory;
}
/*!
 * @brief This function copies the value in member intent
 * @param _intent New value to be copied in member intent
 */
void ros2_interface::msg::PredictionObstacle::intent(
        const ros2_interface::msg::ObstacleIntent& _intent)
{
    m_intent = _intent;
}

/*!
 * @brief This function moves the value in member intent
 * @param _intent New value to be moved in member intent
 */
void ros2_interface::msg::PredictionObstacle::intent(
        ros2_interface::msg::ObstacleIntent&& _intent)
{
    m_intent = std::move(_intent);
}

/*!
 * @brief This function returns a constant reference to member intent
 * @return Constant reference to member intent
 */
const ros2_interface::msg::ObstacleIntent& ros2_interface::msg::PredictionObstacle::intent() const
{
    return m_intent;
}

/*!
 * @brief This function returns a reference to member intent
 * @return Reference to member intent
 */
ros2_interface::msg::ObstacleIntent& ros2_interface::msg::PredictionObstacle::intent()
{
    return m_intent;
}
/*!
 * @brief This function copies the value in member priority
 * @param _priority New value to be copied in member priority
 */
void ros2_interface::msg::PredictionObstacle::priority(
        const ros2_interface::msg::ObstaclePriority& _priority)
{
    m_priority = _priority;
}

/*!
 * @brief This function moves the value in member priority
 * @param _priority New value to be moved in member priority
 */
void ros2_interface::msg::PredictionObstacle::priority(
        ros2_interface::msg::ObstaclePriority&& _priority)
{
    m_priority = std::move(_priority);
}

/*!
 * @brief This function returns a constant reference to member priority
 * @return Constant reference to member priority
 */
const ros2_interface::msg::ObstaclePriority& ros2_interface::msg::PredictionObstacle::priority() const
{
    return m_priority;
}

/*!
 * @brief This function returns a reference to member priority
 * @return Reference to member priority
 */
ros2_interface::msg::ObstaclePriority& ros2_interface::msg::PredictionObstacle::priority()
{
    return m_priority;
}
/*!
 * @brief This function copies the value in member interactive_tag
 * @param _interactive_tag New value to be copied in member interactive_tag
 */
void ros2_interface::msg::PredictionObstacle::interactive_tag(
        const ros2_interface::msg::ObstacleInteractiveTag& _interactive_tag)
{
    m_interactive_tag = _interactive_tag;
}

/*!
 * @brief This function moves the value in member interactive_tag
 * @param _interactive_tag New value to be moved in member interactive_tag
 */
void ros2_interface::msg::PredictionObstacle::interactive_tag(
        ros2_interface::msg::ObstacleInteractiveTag&& _interactive_tag)
{
    m_interactive_tag = std::move(_interactive_tag);
}

/*!
 * @brief This function returns a constant reference to member interactive_tag
 * @return Constant reference to member interactive_tag
 */
const ros2_interface::msg::ObstacleInteractiveTag& ros2_interface::msg::PredictionObstacle::interactive_tag() const
{
    return m_interactive_tag;
}

/*!
 * @brief This function returns a reference to member interactive_tag
 * @return Reference to member interactive_tag
 */
ros2_interface::msg::ObstacleInteractiveTag& ros2_interface::msg::PredictionObstacle::interactive_tag()
{
    return m_interactive_tag;
}
/*!
 * @brief This function sets a value in member is_static
 * @param _is_static New value for member is_static
 */
void ros2_interface::msg::PredictionObstacle::is_static(
        bool _is_static)
{
    m_is_static = _is_static;
}

/*!
 * @brief This function returns the value of member is_static
 * @return Value of member is_static
 */
bool ros2_interface::msg::PredictionObstacle::is_static() const
{
    return m_is_static;
}

/*!
 * @brief This function returns a reference to member is_static
 * @return Reference to member is_static
 */
bool& ros2_interface::msg::PredictionObstacle::is_static()
{
    return m_is_static;
}



size_t ros2_interface::msg::PredictionObstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PredictionObstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::PredictionObstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PredictionObstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



