// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLE_H_

#include "ObstaclePriority.h"
#include "ObstacleInteractiveTag.h"
#include "PerceptionObstacle.h"
#include "TrajectoryInPrediction.h"
#include "ObstacleIntent.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PREDICTIONOBSTACLE_SOURCE)
#define PREDICTIONOBSTACLE_DllAPI __declspec( dllexport )
#else
#define PREDICTIONOBSTACLE_DllAPI __declspec( dllimport )
#endif // PREDICTIONOBSTACLE_SOURCE
#else
#define PREDICTIONOBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PREDICTIONOBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PredictionObstacle defined by the user in the IDL file.
         * @ingroup PredictionObstacle
         */
        class PredictionObstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PredictionObstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PredictionObstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacle that will be copied.
             */
            eProsima_user_DllExport PredictionObstacle(
                    const PredictionObstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacle that will be copied.
             */
            eProsima_user_DllExport PredictionObstacle(
                    PredictionObstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacle that will be copied.
             */
            eProsima_user_DllExport PredictionObstacle& operator =(
                    const PredictionObstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacle that will be copied.
             */
            eProsima_user_DllExport PredictionObstacle& operator =(
                    PredictionObstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PredictionObstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PredictionObstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PredictionObstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PredictionObstacle& x) const;

            /*!
             * @brief This function copies the value in member perception_obstacle
             * @param _perception_obstacle New value to be copied in member perception_obstacle
             */
            eProsima_user_DllExport void perception_obstacle(
                    const ros2_interface::msg::PerceptionObstacle& _perception_obstacle);

            /*!
             * @brief This function moves the value in member perception_obstacle
             * @param _perception_obstacle New value to be moved in member perception_obstacle
             */
            eProsima_user_DllExport void perception_obstacle(
                    ros2_interface::msg::PerceptionObstacle&& _perception_obstacle);

            /*!
             * @brief This function returns a constant reference to member perception_obstacle
             * @return Constant reference to member perception_obstacle
             */
            eProsima_user_DllExport const ros2_interface::msg::PerceptionObstacle& perception_obstacle() const;

            /*!
             * @brief This function returns a reference to member perception_obstacle
             * @return Reference to member perception_obstacle
             */
            eProsima_user_DllExport ros2_interface::msg::PerceptionObstacle& perception_obstacle();
            /*!
             * @brief This function sets a value in member timestamp
             * @param _timestamp New value for member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    double _timestamp);

            /*!
             * @brief This function returns the value of member timestamp
             * @return Value of member timestamp
             */
            eProsima_user_DllExport double timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport double& timestamp();

            /*!
             * @brief This function sets a value in member predicted_period
             * @param _predicted_period New value for member predicted_period
             */
            eProsima_user_DllExport void predicted_period(
                    double _predicted_period);

            /*!
             * @brief This function returns the value of member predicted_period
             * @return Value of member predicted_period
             */
            eProsima_user_DllExport double predicted_period() const;

            /*!
             * @brief This function returns a reference to member predicted_period
             * @return Reference to member predicted_period
             */
            eProsima_user_DllExport double& predicted_period();

            /*!
             * @brief This function copies the value in member trajectory
             * @param _trajectory New value to be copied in member trajectory
             */
            eProsima_user_DllExport void trajectory(
                    const std::vector<ros2_interface::msg::TrajectoryInPrediction>& _trajectory);

            /*!
             * @brief This function moves the value in member trajectory
             * @param _trajectory New value to be moved in member trajectory
             */
            eProsima_user_DllExport void trajectory(
                    std::vector<ros2_interface::msg::TrajectoryInPrediction>&& _trajectory);

            /*!
             * @brief This function returns a constant reference to member trajectory
             * @return Constant reference to member trajectory
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrajectoryInPrediction>& trajectory() const;

            /*!
             * @brief This function returns a reference to member trajectory
             * @return Reference to member trajectory
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrajectoryInPrediction>& trajectory();
            /*!
             * @brief This function copies the value in member intent
             * @param _intent New value to be copied in member intent
             */
            eProsima_user_DllExport void intent(
                    const ros2_interface::msg::ObstacleIntent& _intent);

            /*!
             * @brief This function moves the value in member intent
             * @param _intent New value to be moved in member intent
             */
            eProsima_user_DllExport void intent(
                    ros2_interface::msg::ObstacleIntent&& _intent);

            /*!
             * @brief This function returns a constant reference to member intent
             * @return Constant reference to member intent
             */
            eProsima_user_DllExport const ros2_interface::msg::ObstacleIntent& intent() const;

            /*!
             * @brief This function returns a reference to member intent
             * @return Reference to member intent
             */
            eProsima_user_DllExport ros2_interface::msg::ObstacleIntent& intent();
            /*!
             * @brief This function copies the value in member priority
             * @param _priority New value to be copied in member priority
             */
            eProsima_user_DllExport void priority(
                    const ros2_interface::msg::ObstaclePriority& _priority);

            /*!
             * @brief This function moves the value in member priority
             * @param _priority New value to be moved in member priority
             */
            eProsima_user_DllExport void priority(
                    ros2_interface::msg::ObstaclePriority&& _priority);

            /*!
             * @brief This function returns a constant reference to member priority
             * @return Constant reference to member priority
             */
            eProsima_user_DllExport const ros2_interface::msg::ObstaclePriority& priority() const;

            /*!
             * @brief This function returns a reference to member priority
             * @return Reference to member priority
             */
            eProsima_user_DllExport ros2_interface::msg::ObstaclePriority& priority();
            /*!
             * @brief This function copies the value in member interactive_tag
             * @param _interactive_tag New value to be copied in member interactive_tag
             */
            eProsima_user_DllExport void interactive_tag(
                    const ros2_interface::msg::ObstacleInteractiveTag& _interactive_tag);

            /*!
             * @brief This function moves the value in member interactive_tag
             * @param _interactive_tag New value to be moved in member interactive_tag
             */
            eProsima_user_DllExport void interactive_tag(
                    ros2_interface::msg::ObstacleInteractiveTag&& _interactive_tag);

            /*!
             * @brief This function returns a constant reference to member interactive_tag
             * @return Constant reference to member interactive_tag
             */
            eProsima_user_DllExport const ros2_interface::msg::ObstacleInteractiveTag& interactive_tag() const;

            /*!
             * @brief This function returns a reference to member interactive_tag
             * @return Reference to member interactive_tag
             */
            eProsima_user_DllExport ros2_interface::msg::ObstacleInteractiveTag& interactive_tag();
            /*!
             * @brief This function sets a value in member is_static
             * @param _is_static New value for member is_static
             */
            eProsima_user_DllExport void is_static(
                    bool _is_static);

            /*!
             * @brief This function returns the value of member is_static
             * @return Value of member is_static
             */
            eProsima_user_DllExport bool is_static() const;

            /*!
             * @brief This function returns a reference to member is_static
             * @return Reference to member is_static
             */
            eProsima_user_DllExport bool& is_static();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PredictionObstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::PerceptionObstacle m_perception_obstacle;
            double m_timestamp;
            double m_predicted_period;
            std::vector<ros2_interface::msg::TrajectoryInPrediction> m_trajectory;
            ros2_interface::msg::ObstacleIntent m_intent;
            ros2_interface::msg::ObstaclePriority m_priority;
            ros2_interface::msg::ObstacleInteractiveTag m_interactive_tag;
            bool m_is_static;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLE_H_

