// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstacleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PredictionObstacle.h"
#include "PredictionObstacleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPredictionObstacleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(true),
                        ros2_interface::msg::GetObstaclePriorityObject(true));
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(false),
                        ros2_interface::msg::GetObstaclePriorityObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(true),
                        ros2_interface::msg::GetObstacleIntentObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(false),
                        ros2_interface::msg::GetObstacleIntentObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleInteractiveTag", ros2_interface::msg::GetObstacleInteractiveTagIdentifier(true),
                        ros2_interface::msg::GetObstacleInteractiveTagObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleInteractiveTag", ros2_interface::msg::GetObstacleInteractiveTagIdentifier(false),
                        ros2_interface::msg::GetObstacleInteractiveTagObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(true),
                        ros2_interface::msg::GetPerceptionObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(false),
                        ros2_interface::msg::GetPerceptionObstacleObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(true),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(false),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(false));



                factory->add_type_object("ros2_interface::msg::PredictionObstacle", ros2_interface::msg::GetPredictionObstacleIdentifier(true),
                        ros2_interface::msg::GetPredictionObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::PredictionObstacle", ros2_interface::msg::GetPredictionObstacleIdentifier(false),
                        ros2_interface::msg::GetPredictionObstacleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPredictionObstacleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PredictionObstacle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPredictionObstacleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PredictionObstacle", complete);
        }

        const TypeObject* GetPredictionObstacleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePredictionObstacleObject();
            }
            //else
            return GetMinimalPredictionObstacleObject();
        }

        const TypeObject* GetMinimalPredictionObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_perception_obstacle;
            mst_perception_obstacle.common().member_id(memberId++);
            mst_perception_obstacle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_perception_obstacle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_perception_obstacle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_perception_obstacle.common().member_flags().IS_OPTIONAL(false);
            mst_perception_obstacle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_perception_obstacle.common().member_flags().IS_KEY(false);
            mst_perception_obstacle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_perception_obstacle.common().member_type_id(*ros2_interface::msg::GetPerceptionObstacleIdentifier(false));
            MD5 perception_obstacle_hash("perception_obstacle");
            for(int i = 0; i < 4; ++i)
            {
                mst_perception_obstacle.detail().name_hash()[i] = perception_obstacle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_perception_obstacle);

            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_predicted_period;
            mst_predicted_period.common().member_id(memberId++);
            mst_predicted_period.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_predicted_period.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_predicted_period.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_predicted_period.common().member_flags().IS_OPTIONAL(false);
            mst_predicted_period.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_predicted_period.common().member_flags().IS_KEY(false);
            mst_predicted_period.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_predicted_period.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 predicted_period_hash("predicted_period");
            for(int i = 0; i < 4; ++i)
            {
                mst_predicted_period.detail().name_hash()[i] = predicted_period_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_predicted_period);

            MinimalStructMember mst_trajectory;
            mst_trajectory.common().member_id(memberId++);
            mst_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_trajectory.common().member_flags().IS_OPTIONAL(false);
            mst_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_trajectory.common().member_flags().IS_KEY(false);
            mst_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_trajectory.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, false));


            MD5 trajectory_hash("trajectory");
            for(int i = 0; i < 4; ++i)
            {
                mst_trajectory.detail().name_hash()[i] = trajectory_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_trajectory);

            MinimalStructMember mst_intent;
            mst_intent.common().member_id(memberId++);
            mst_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_intent.common().member_flags().IS_OPTIONAL(false);
            mst_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_intent.common().member_flags().IS_KEY(false);
            mst_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_intent.common().member_type_id(*ros2_interface::msg::GetObstacleIntentIdentifier(false));
            MD5 intent_hash("intent");
            for(int i = 0; i < 4; ++i)
            {
                mst_intent.detail().name_hash()[i] = intent_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_intent);

            MinimalStructMember mst_priority;
            mst_priority.common().member_id(memberId++);
            mst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_priority.common().member_flags().IS_OPTIONAL(false);
            mst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_priority.common().member_flags().IS_KEY(false);
            mst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_priority.common().member_type_id(*ros2_interface::msg::GetObstaclePriorityIdentifier(false));
            MD5 priority_hash("priority");
            for(int i = 0; i < 4; ++i)
            {
                mst_priority.detail().name_hash()[i] = priority_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_priority);

            MinimalStructMember mst_interactive_tag;
            mst_interactive_tag.common().member_id(memberId++);
            mst_interactive_tag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_interactive_tag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_interactive_tag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_interactive_tag.common().member_flags().IS_OPTIONAL(false);
            mst_interactive_tag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_interactive_tag.common().member_flags().IS_KEY(false);
            mst_interactive_tag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_interactive_tag.common().member_type_id(*ros2_interface::msg::GetObstacleInteractiveTagIdentifier(false));
            MD5 interactive_tag_hash("interactive_tag");
            for(int i = 0; i < 4; ++i)
            {
                mst_interactive_tag.detail().name_hash()[i] = interactive_tag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_interactive_tag);

            MinimalStructMember mst_is_static;
            mst_is_static.common().member_id(memberId++);
            mst_is_static.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_static.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_static.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_static.common().member_flags().IS_OPTIONAL(false);
            mst_is_static.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_static.common().member_flags().IS_KEY(false);
            mst_is_static.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_static.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_static_hash("is_static");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_static.detail().name_hash()[i] = is_static_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_static);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PredictionObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PredictionObstacle", false);
        }

        const TypeObject* GetCompletePredictionObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_perception_obstacle;
            cst_perception_obstacle.common().member_id(memberId++);
            cst_perception_obstacle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_perception_obstacle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_perception_obstacle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_perception_obstacle.common().member_flags().IS_OPTIONAL(false);
            cst_perception_obstacle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_perception_obstacle.common().member_flags().IS_KEY(false);
            cst_perception_obstacle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_perception_obstacle.common().member_type_id(*ros2_interface::msg::GetPerceptionObstacleIdentifier(true));
            cst_perception_obstacle.detail().name("perception_obstacle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_perception_obstacle);

            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_predicted_period;
            cst_predicted_period.common().member_id(memberId++);
            cst_predicted_period.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_predicted_period.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_predicted_period.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_predicted_period.common().member_flags().IS_OPTIONAL(false);
            cst_predicted_period.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_predicted_period.common().member_flags().IS_KEY(false);
            cst_predicted_period.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_predicted_period.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_predicted_period.detail().name("predicted_period");

            type_object->complete().struct_type().member_seq().emplace_back(cst_predicted_period);

            CompleteStructMember cst_trajectory;
            cst_trajectory.common().member_id(memberId++);
            cst_trajectory.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_trajectory.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_trajectory.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_trajectory.common().member_flags().IS_OPTIONAL(false);
            cst_trajectory.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_trajectory.common().member_flags().IS_KEY(false);
            cst_trajectory.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_trajectory.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrajectoryInPrediction", 100, true));


            cst_trajectory.detail().name("trajectory");

            type_object->complete().struct_type().member_seq().emplace_back(cst_trajectory);

            CompleteStructMember cst_intent;
            cst_intent.common().member_id(memberId++);
            cst_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_intent.common().member_flags().IS_OPTIONAL(false);
            cst_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_intent.common().member_flags().IS_KEY(false);
            cst_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_intent.common().member_type_id(*ros2_interface::msg::GetObstacleIntentIdentifier(true));
            cst_intent.detail().name("intent");

            type_object->complete().struct_type().member_seq().emplace_back(cst_intent);

            CompleteStructMember cst_priority;
            cst_priority.common().member_id(memberId++);
            cst_priority.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_priority.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_priority.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_priority.common().member_flags().IS_OPTIONAL(false);
            cst_priority.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_priority.common().member_flags().IS_KEY(false);
            cst_priority.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_priority.common().member_type_id(*ros2_interface::msg::GetObstaclePriorityIdentifier(true));
            cst_priority.detail().name("priority");

            type_object->complete().struct_type().member_seq().emplace_back(cst_priority);

            CompleteStructMember cst_interactive_tag;
            cst_interactive_tag.common().member_id(memberId++);
            cst_interactive_tag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_interactive_tag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_interactive_tag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_interactive_tag.common().member_flags().IS_OPTIONAL(false);
            cst_interactive_tag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_interactive_tag.common().member_flags().IS_KEY(false);
            cst_interactive_tag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_interactive_tag.common().member_type_id(*ros2_interface::msg::GetObstacleInteractiveTagIdentifier(true));
            cst_interactive_tag.detail().name("interactive_tag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_interactive_tag);

            CompleteStructMember cst_is_static;
            cst_is_static.common().member_id(memberId++);
            cst_is_static.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_static.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_static.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_static.common().member_flags().IS_OPTIONAL(false);
            cst_is_static.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_static.common().member_flags().IS_KEY(false);
            cst_is_static.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_static.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_static.detail().name("is_static");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_static);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PredictionObstacle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PredictionObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PredictionObstacle", true);
        }

    } // namespace msg
} // namespace ros2_interface