// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstacles.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "PredictionObstacles.h"
#include "PredictionObstaclesTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_ObstacleInteractiveTag_max_cdr_typesize 4ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_PredictionObstacles_max_cdr_typesize 152909904ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_ObstaclePriority_max_cdr_typesize 4ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_cdr_typesize 15212ULL;
#define ros2_interface_msg_PredictionObstacle_max_cdr_typesize 1529097ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_PerceptionObstacle_max_cdr_typesize 7457ULL;
#define ros2_interface_msg_ObstacleIntent_max_cdr_typesize 4ULL;
#define ros2_interface_msg_ObstacleInteractiveTag_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PredictionObstacles_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstaclePriority_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryInPrediction_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PredictionObstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PerceptionObstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_ObstacleIntent_max_key_cdr_typesize 0ULL;

ros2_interface::msg::PredictionObstacles::PredictionObstacles()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::PredictionObstacle> m_prediction_obstacles

    // long m_change_origin_flag
    m_change_origin_flag = 0;
    // double m_start_timestamp
    m_start_timestamp = 0.0;
    // double m_end_timestamp
    m_end_timestamp = 0.0;
    // long m_self_intent
    m_self_intent = 0;
    // long m_scenario
    m_scenario = 0;

    // Just to register all known types
    registerPredictionObstaclesTypes();
}

ros2_interface::msg::PredictionObstacles::~PredictionObstacles()
{







}

ros2_interface::msg::PredictionObstacles::PredictionObstacles(
        const PredictionObstacles& x)
{
    m_header = x.m_header;
    m_prediction_obstacles = x.m_prediction_obstacles;
    m_change_origin_flag = x.m_change_origin_flag;
    m_start_timestamp = x.m_start_timestamp;
    m_end_timestamp = x.m_end_timestamp;
    m_self_intent = x.m_self_intent;
    m_scenario = x.m_scenario;
}

ros2_interface::msg::PredictionObstacles::PredictionObstacles(
        PredictionObstacles&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_prediction_obstacles = std::move(x.m_prediction_obstacles);
    m_change_origin_flag = x.m_change_origin_flag;
    m_start_timestamp = x.m_start_timestamp;
    m_end_timestamp = x.m_end_timestamp;
    m_self_intent = x.m_self_intent;
    m_scenario = x.m_scenario;
}

ros2_interface::msg::PredictionObstacles& ros2_interface::msg::PredictionObstacles::operator =(
        const PredictionObstacles& x)
{

    m_header = x.m_header;
    m_prediction_obstacles = x.m_prediction_obstacles;
    m_change_origin_flag = x.m_change_origin_flag;
    m_start_timestamp = x.m_start_timestamp;
    m_end_timestamp = x.m_end_timestamp;
    m_self_intent = x.m_self_intent;
    m_scenario = x.m_scenario;

    return *this;
}

ros2_interface::msg::PredictionObstacles& ros2_interface::msg::PredictionObstacles::operator =(
        PredictionObstacles&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_prediction_obstacles = std::move(x.m_prediction_obstacles);
    m_change_origin_flag = x.m_change_origin_flag;
    m_start_timestamp = x.m_start_timestamp;
    m_end_timestamp = x.m_end_timestamp;
    m_self_intent = x.m_self_intent;
    m_scenario = x.m_scenario;

    return *this;
}

bool ros2_interface::msg::PredictionObstacles::operator ==(
        const PredictionObstacles& x) const
{

    return (m_header == x.m_header && m_prediction_obstacles == x.m_prediction_obstacles && m_change_origin_flag == x.m_change_origin_flag && m_start_timestamp == x.m_start_timestamp && m_end_timestamp == x.m_end_timestamp && m_self_intent == x.m_self_intent && m_scenario == x.m_scenario);
}

bool ros2_interface::msg::PredictionObstacles::operator !=(
        const PredictionObstacles& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::PredictionObstacles::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PredictionObstacles_max_cdr_typesize;
}

size_t ros2_interface::msg::PredictionObstacles::getCdrSerializedSize(
        const ros2_interface::msg::PredictionObstacles& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.prediction_obstacles().size(); ++a)
    {
        current_alignment += ros2_interface::msg::PredictionObstacle::getCdrSerializedSize(data.prediction_obstacles().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::PredictionObstacles::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_prediction_obstacles;
    scdr << m_change_origin_flag;
    scdr << m_start_timestamp;
    scdr << m_end_timestamp;
    scdr << m_self_intent;
    scdr << m_scenario;

}

void ros2_interface::msg::PredictionObstacles::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_prediction_obstacles;
    dcdr >> m_change_origin_flag;
    dcdr >> m_start_timestamp;
    dcdr >> m_end_timestamp;
    dcdr >> m_self_intent;
    dcdr >> m_scenario;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::PredictionObstacles::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::PredictionObstacles::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::PredictionObstacles::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::PredictionObstacles::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member prediction_obstacles
 * @param _prediction_obstacles New value to be copied in member prediction_obstacles
 */
void ros2_interface::msg::PredictionObstacles::prediction_obstacles(
        const std::vector<ros2_interface::msg::PredictionObstacle>& _prediction_obstacles)
{
    m_prediction_obstacles = _prediction_obstacles;
}

/*!
 * @brief This function moves the value in member prediction_obstacles
 * @param _prediction_obstacles New value to be moved in member prediction_obstacles
 */
void ros2_interface::msg::PredictionObstacles::prediction_obstacles(
        std::vector<ros2_interface::msg::PredictionObstacle>&& _prediction_obstacles)
{
    m_prediction_obstacles = std::move(_prediction_obstacles);
}

/*!
 * @brief This function returns a constant reference to member prediction_obstacles
 * @return Constant reference to member prediction_obstacles
 */
const std::vector<ros2_interface::msg::PredictionObstacle>& ros2_interface::msg::PredictionObstacles::prediction_obstacles() const
{
    return m_prediction_obstacles;
}

/*!
 * @brief This function returns a reference to member prediction_obstacles
 * @return Reference to member prediction_obstacles
 */
std::vector<ros2_interface::msg::PredictionObstacle>& ros2_interface::msg::PredictionObstacles::prediction_obstacles()
{
    return m_prediction_obstacles;
}
/*!
 * @brief This function sets a value in member change_origin_flag
 * @param _change_origin_flag New value for member change_origin_flag
 */
void ros2_interface::msg::PredictionObstacles::change_origin_flag(
        int32_t _change_origin_flag)
{
    m_change_origin_flag = _change_origin_flag;
}

/*!
 * @brief This function returns the value of member change_origin_flag
 * @return Value of member change_origin_flag
 */
int32_t ros2_interface::msg::PredictionObstacles::change_origin_flag() const
{
    return m_change_origin_flag;
}

/*!
 * @brief This function returns a reference to member change_origin_flag
 * @return Reference to member change_origin_flag
 */
int32_t& ros2_interface::msg::PredictionObstacles::change_origin_flag()
{
    return m_change_origin_flag;
}

/*!
 * @brief This function sets a value in member start_timestamp
 * @param _start_timestamp New value for member start_timestamp
 */
void ros2_interface::msg::PredictionObstacles::start_timestamp(
        double _start_timestamp)
{
    m_start_timestamp = _start_timestamp;
}

/*!
 * @brief This function returns the value of member start_timestamp
 * @return Value of member start_timestamp
 */
double ros2_interface::msg::PredictionObstacles::start_timestamp() const
{
    return m_start_timestamp;
}

/*!
 * @brief This function returns a reference to member start_timestamp
 * @return Reference to member start_timestamp
 */
double& ros2_interface::msg::PredictionObstacles::start_timestamp()
{
    return m_start_timestamp;
}

/*!
 * @brief This function sets a value in member end_timestamp
 * @param _end_timestamp New value for member end_timestamp
 */
void ros2_interface::msg::PredictionObstacles::end_timestamp(
        double _end_timestamp)
{
    m_end_timestamp = _end_timestamp;
}

/*!
 * @brief This function returns the value of member end_timestamp
 * @return Value of member end_timestamp
 */
double ros2_interface::msg::PredictionObstacles::end_timestamp() const
{
    return m_end_timestamp;
}

/*!
 * @brief This function returns a reference to member end_timestamp
 * @return Reference to member end_timestamp
 */
double& ros2_interface::msg::PredictionObstacles::end_timestamp()
{
    return m_end_timestamp;
}

/*!
 * @brief This function sets a value in member self_intent
 * @param _self_intent New value for member self_intent
 */
void ros2_interface::msg::PredictionObstacles::self_intent(
        int32_t _self_intent)
{
    m_self_intent = _self_intent;
}

/*!
 * @brief This function returns the value of member self_intent
 * @return Value of member self_intent
 */
int32_t ros2_interface::msg::PredictionObstacles::self_intent() const
{
    return m_self_intent;
}

/*!
 * @brief This function returns a reference to member self_intent
 * @return Reference to member self_intent
 */
int32_t& ros2_interface::msg::PredictionObstacles::self_intent()
{
    return m_self_intent;
}

/*!
 * @brief This function sets a value in member scenario
 * @param _scenario New value for member scenario
 */
void ros2_interface::msg::PredictionObstacles::scenario(
        int32_t _scenario)
{
    m_scenario = _scenario;
}

/*!
 * @brief This function returns the value of member scenario
 * @return Value of member scenario
 */
int32_t ros2_interface::msg::PredictionObstacles::scenario() const
{
    return m_scenario;
}

/*!
 * @brief This function returns a reference to member scenario
 * @return Reference to member scenario
 */
int32_t& ros2_interface::msg::PredictionObstacles::scenario()
{
    return m_scenario;
}



size_t ros2_interface::msg::PredictionObstacles::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_PredictionObstacles_max_key_cdr_typesize;
}

bool ros2_interface::msg::PredictionObstacles::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::PredictionObstacles::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



