// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstacles.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLES_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLES_H_

#include "Header.h"
#include "PredictionObstacle.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(PREDICTIONOBSTACLES_SOURCE)
#define PREDICTIONOBSTACLES_DllAPI __declspec( dllexport )
#else
#define PREDICTIONOBSTACLES_DllAPI __declspec( dllimport )
#endif // PREDICTIONOBSTACLES_SOURCE
#else
#define PREDICTIONOBSTACLES_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define PREDICTIONOBSTACLES_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure PredictionObstacles defined by the user in the IDL file.
         * @ingroup PredictionObstacles
         */
        class PredictionObstacles
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport PredictionObstacles();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~PredictionObstacles();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacles that will be copied.
             */
            eProsima_user_DllExport PredictionObstacles(
                    const PredictionObstacles& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacles that will be copied.
             */
            eProsima_user_DllExport PredictionObstacles(
                    PredictionObstacles&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacles that will be copied.
             */
            eProsima_user_DllExport PredictionObstacles& operator =(
                    const PredictionObstacles& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::PredictionObstacles that will be copied.
             */
            eProsima_user_DllExport PredictionObstacles& operator =(
                    PredictionObstacles&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PredictionObstacles object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const PredictionObstacles& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::PredictionObstacles object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const PredictionObstacles& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member prediction_obstacles
             * @param _prediction_obstacles New value to be copied in member prediction_obstacles
             */
            eProsima_user_DllExport void prediction_obstacles(
                    const std::vector<ros2_interface::msg::PredictionObstacle>& _prediction_obstacles);

            /*!
             * @brief This function moves the value in member prediction_obstacles
             * @param _prediction_obstacles New value to be moved in member prediction_obstacles
             */
            eProsima_user_DllExport void prediction_obstacles(
                    std::vector<ros2_interface::msg::PredictionObstacle>&& _prediction_obstacles);

            /*!
             * @brief This function returns a constant reference to member prediction_obstacles
             * @return Constant reference to member prediction_obstacles
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::PredictionObstacle>& prediction_obstacles() const;

            /*!
             * @brief This function returns a reference to member prediction_obstacles
             * @return Reference to member prediction_obstacles
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::PredictionObstacle>& prediction_obstacles();
            /*!
             * @brief This function sets a value in member change_origin_flag
             * @param _change_origin_flag New value for member change_origin_flag
             */
            eProsima_user_DllExport void change_origin_flag(
                    int32_t _change_origin_flag);

            /*!
             * @brief This function returns the value of member change_origin_flag
             * @return Value of member change_origin_flag
             */
            eProsima_user_DllExport int32_t change_origin_flag() const;

            /*!
             * @brief This function returns a reference to member change_origin_flag
             * @return Reference to member change_origin_flag
             */
            eProsima_user_DllExport int32_t& change_origin_flag();

            /*!
             * @brief This function sets a value in member start_timestamp
             * @param _start_timestamp New value for member start_timestamp
             */
            eProsima_user_DllExport void start_timestamp(
                    double _start_timestamp);

            /*!
             * @brief This function returns the value of member start_timestamp
             * @return Value of member start_timestamp
             */
            eProsima_user_DllExport double start_timestamp() const;

            /*!
             * @brief This function returns a reference to member start_timestamp
             * @return Reference to member start_timestamp
             */
            eProsima_user_DllExport double& start_timestamp();

            /*!
             * @brief This function sets a value in member end_timestamp
             * @param _end_timestamp New value for member end_timestamp
             */
            eProsima_user_DllExport void end_timestamp(
                    double _end_timestamp);

            /*!
             * @brief This function returns the value of member end_timestamp
             * @return Value of member end_timestamp
             */
            eProsima_user_DllExport double end_timestamp() const;

            /*!
             * @brief This function returns a reference to member end_timestamp
             * @return Reference to member end_timestamp
             */
            eProsima_user_DllExport double& end_timestamp();

            /*!
             * @brief This function sets a value in member self_intent
             * @param _self_intent New value for member self_intent
             */
            eProsima_user_DllExport void self_intent(
                    int32_t _self_intent);

            /*!
             * @brief This function returns the value of member self_intent
             * @return Value of member self_intent
             */
            eProsima_user_DllExport int32_t self_intent() const;

            /*!
             * @brief This function returns a reference to member self_intent
             * @return Reference to member self_intent
             */
            eProsima_user_DllExport int32_t& self_intent();

            /*!
             * @brief This function sets a value in member scenario
             * @param _scenario New value for member scenario
             */
            eProsima_user_DllExport void scenario(
                    int32_t _scenario);

            /*!
             * @brief This function returns the value of member scenario
             * @return Value of member scenario
             */
            eProsima_user_DllExport int32_t scenario() const;

            /*!
             * @brief This function returns a reference to member scenario
             * @return Reference to member scenario
             */
            eProsima_user_DllExport int32_t& scenario();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::PredictionObstacles& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::vector<ros2_interface::msg::PredictionObstacle> m_prediction_obstacles;
            int32_t m_change_origin_flag;
            double m_start_timestamp;
            double m_end_timestamp;
            int32_t m_self_intent;
            int32_t m_scenario;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_PREDICTIONOBSTACLES_H_

