// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file PredictionObstaclesTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "PredictionObstacles.h"
#include "PredictionObstaclesTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerPredictionObstaclesTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(true),
                        ros2_interface::msg::GetObstaclePriorityObject(true));
                factory->add_type_object("ros2_interface::msg::ObstaclePriority", ros2_interface::msg::GetObstaclePriorityIdentifier(false),
                        ros2_interface::msg::GetObstaclePriorityObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(true),
                        ros2_interface::msg::GetObstacleIntentObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleIntent", ros2_interface::msg::GetObstacleIntentIdentifier(false),
                        ros2_interface::msg::GetObstacleIntentObject(false));



                factory->add_type_object("ros2_interface::msg::ObstacleInteractiveTag", ros2_interface::msg::GetObstacleInteractiveTagIdentifier(true),
                        ros2_interface::msg::GetObstacleInteractiveTagObject(true));
                factory->add_type_object("ros2_interface::msg::ObstacleInteractiveTag", ros2_interface::msg::GetObstacleInteractiveTagIdentifier(false),
                        ros2_interface::msg::GetObstacleInteractiveTagObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(true),
                        ros2_interface::msg::GetPerceptionObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::PerceptionObstacle", ros2_interface::msg::GetPerceptionObstacleIdentifier(false),
                        ros2_interface::msg::GetPerceptionObstacleObject(false));



                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(true),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryInPrediction", ros2_interface::msg::GetTrajectoryInPredictionIdentifier(false),
                        ros2_interface::msg::GetTrajectoryInPredictionObject(false));



                factory->add_type_object("ros2_interface::msg::PredictionObstacle", ros2_interface::msg::GetPredictionObstacleIdentifier(true),
                        ros2_interface::msg::GetPredictionObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::PredictionObstacle", ros2_interface::msg::GetPredictionObstacleIdentifier(false),
                        ros2_interface::msg::GetPredictionObstacleObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::PredictionObstacles", ros2_interface::msg::GetPredictionObstaclesIdentifier(true),
                        ros2_interface::msg::GetPredictionObstaclesObject(true));
                factory->add_type_object("ros2_interface::msg::PredictionObstacles", ros2_interface::msg::GetPredictionObstaclesIdentifier(false),
                        ros2_interface::msg::GetPredictionObstaclesObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetPredictionObstaclesIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("PredictionObstacles", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetPredictionObstaclesObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("PredictionObstacles", complete);
        }

        const TypeObject* GetPredictionObstaclesObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacles", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompletePredictionObstaclesObject();
            }
            //else
            return GetMinimalPredictionObstaclesObject();
        }

        const TypeObject* GetMinimalPredictionObstaclesObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacles", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_prediction_obstacles;
            mst_prediction_obstacles.common().member_id(memberId++);
            mst_prediction_obstacles.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_prediction_obstacles.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_prediction_obstacles.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_prediction_obstacles.common().member_flags().IS_OPTIONAL(false);
            mst_prediction_obstacles.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_prediction_obstacles.common().member_flags().IS_KEY(false);
            mst_prediction_obstacles.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_prediction_obstacles.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PredictionObstacle", 100, false));


            MD5 prediction_obstacles_hash("prediction_obstacles");
            for(int i = 0; i < 4; ++i)
            {
                mst_prediction_obstacles.detail().name_hash()[i] = prediction_obstacles_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_prediction_obstacles);

            MinimalStructMember mst_change_origin_flag;
            mst_change_origin_flag.common().member_id(memberId++);
            mst_change_origin_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_change_origin_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_change_origin_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_change_origin_flag.common().member_flags().IS_OPTIONAL(false);
            mst_change_origin_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_change_origin_flag.common().member_flags().IS_KEY(false);
            mst_change_origin_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_change_origin_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 change_origin_flag_hash("change_origin_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_change_origin_flag.detail().name_hash()[i] = change_origin_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_change_origin_flag);

            MinimalStructMember mst_start_timestamp;
            mst_start_timestamp.common().member_id(memberId++);
            mst_start_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_start_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_start_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_start_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_start_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_start_timestamp.common().member_flags().IS_KEY(false);
            mst_start_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_start_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 start_timestamp_hash("start_timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_start_timestamp.detail().name_hash()[i] = start_timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_start_timestamp);

            MinimalStructMember mst_end_timestamp;
            mst_end_timestamp.common().member_id(memberId++);
            mst_end_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_end_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_end_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_end_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_end_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_end_timestamp.common().member_flags().IS_KEY(false);
            mst_end_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_end_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 end_timestamp_hash("end_timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_end_timestamp.detail().name_hash()[i] = end_timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_end_timestamp);

            MinimalStructMember mst_self_intent;
            mst_self_intent.common().member_id(memberId++);
            mst_self_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_self_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_self_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_self_intent.common().member_flags().IS_OPTIONAL(false);
            mst_self_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_self_intent.common().member_flags().IS_KEY(false);
            mst_self_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_self_intent.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 self_intent_hash("self_intent");
            for(int i = 0; i < 4; ++i)
            {
                mst_self_intent.detail().name_hash()[i] = self_intent_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_self_intent);

            MinimalStructMember mst_scenario;
            mst_scenario.common().member_id(memberId++);
            mst_scenario.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_scenario.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_scenario.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_scenario.common().member_flags().IS_OPTIONAL(false);
            mst_scenario.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_scenario.common().member_flags().IS_KEY(false);
            mst_scenario.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_scenario.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 scenario_hash("scenario");
            for(int i = 0; i < 4; ++i)
            {
                mst_scenario.detail().name_hash()[i] = scenario_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_scenario);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PredictionObstacles", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PredictionObstacles", false);
        }

        const TypeObject* GetCompletePredictionObstaclesObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("PredictionObstacles", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_prediction_obstacles;
            cst_prediction_obstacles.common().member_id(memberId++);
            cst_prediction_obstacles.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_prediction_obstacles.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_prediction_obstacles.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_prediction_obstacles.common().member_flags().IS_OPTIONAL(false);
            cst_prediction_obstacles.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_prediction_obstacles.common().member_flags().IS_KEY(false);
            cst_prediction_obstacles.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_prediction_obstacles.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::PredictionObstacle", 100, true));


            cst_prediction_obstacles.detail().name("prediction_obstacles");

            type_object->complete().struct_type().member_seq().emplace_back(cst_prediction_obstacles);

            CompleteStructMember cst_change_origin_flag;
            cst_change_origin_flag.common().member_id(memberId++);
            cst_change_origin_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_change_origin_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_change_origin_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_change_origin_flag.common().member_flags().IS_OPTIONAL(false);
            cst_change_origin_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_change_origin_flag.common().member_flags().IS_KEY(false);
            cst_change_origin_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_change_origin_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_change_origin_flag.detail().name("change_origin_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_change_origin_flag);

            CompleteStructMember cst_start_timestamp;
            cst_start_timestamp.common().member_id(memberId++);
            cst_start_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_start_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_start_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_start_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_start_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_start_timestamp.common().member_flags().IS_KEY(false);
            cst_start_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_start_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_start_timestamp.detail().name("start_timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_start_timestamp);

            CompleteStructMember cst_end_timestamp;
            cst_end_timestamp.common().member_id(memberId++);
            cst_end_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_end_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_end_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_end_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_end_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_end_timestamp.common().member_flags().IS_KEY(false);
            cst_end_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_end_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_end_timestamp.detail().name("end_timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_end_timestamp);

            CompleteStructMember cst_self_intent;
            cst_self_intent.common().member_id(memberId++);
            cst_self_intent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_self_intent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_self_intent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_self_intent.common().member_flags().IS_OPTIONAL(false);
            cst_self_intent.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_self_intent.common().member_flags().IS_KEY(false);
            cst_self_intent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_self_intent.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_self_intent.detail().name("self_intent");

            type_object->complete().struct_type().member_seq().emplace_back(cst_self_intent);

            CompleteStructMember cst_scenario;
            cst_scenario.common().member_id(memberId++);
            cst_scenario.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_scenario.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_scenario.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_scenario.common().member_flags().IS_OPTIONAL(false);
            cst_scenario.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_scenario.common().member_flags().IS_KEY(false);
            cst_scenario.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_scenario.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_scenario.detail().name("scenario");

            type_object->complete().struct_type().member_seq().emplace_back(cst_scenario);


            // Header
            type_object->complete().struct_type().header().detail().type_name("PredictionObstacles");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("PredictionObstacles", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("PredictionObstacles", true);
        }

    } // namespace msg
} // namespace ros2_interface