// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Quaternion.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Quaternion.h"
#include "QuaternionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Quaternion_max_cdr_typesize 32ULL;
#define ros2_interface_msg_Quaternion_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Quaternion::Quaternion()
{
    // double m_qx
    m_qx = 0.0;
    // double m_qy
    m_qy = 0.0;
    // double m_qz
    m_qz = 0.0;
    // double m_qw
    m_qw = 0.0;

    // Just to register all known types
    registerQuaternionTypes();
}

ros2_interface::msg::Quaternion::~Quaternion()
{




}

ros2_interface::msg::Quaternion::Quaternion(
        const Quaternion& x)
{
    m_qx = x.m_qx;
    m_qy = x.m_qy;
    m_qz = x.m_qz;
    m_qw = x.m_qw;
}

ros2_interface::msg::Quaternion::Quaternion(
        Quaternion&& x) noexcept 
{
    m_qx = x.m_qx;
    m_qy = x.m_qy;
    m_qz = x.m_qz;
    m_qw = x.m_qw;
}

ros2_interface::msg::Quaternion& ros2_interface::msg::Quaternion::operator =(
        const Quaternion& x)
{

    m_qx = x.m_qx;
    m_qy = x.m_qy;
    m_qz = x.m_qz;
    m_qw = x.m_qw;

    return *this;
}

ros2_interface::msg::Quaternion& ros2_interface::msg::Quaternion::operator =(
        Quaternion&& x) noexcept
{

    m_qx = x.m_qx;
    m_qy = x.m_qy;
    m_qz = x.m_qz;
    m_qw = x.m_qw;

    return *this;
}

bool ros2_interface::msg::Quaternion::operator ==(
        const Quaternion& x) const
{

    return (m_qx == x.m_qx && m_qy == x.m_qy && m_qz == x.m_qz && m_qw == x.m_qw);
}

bool ros2_interface::msg::Quaternion::operator !=(
        const Quaternion& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Quaternion::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Quaternion_max_cdr_typesize;
}

size_t ros2_interface::msg::Quaternion::getCdrSerializedSize(
        const ros2_interface::msg::Quaternion& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Quaternion::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_qx;
    scdr << m_qy;
    scdr << m_qz;
    scdr << m_qw;

}

void ros2_interface::msg::Quaternion::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_qx;
    dcdr >> m_qy;
    dcdr >> m_qz;
    dcdr >> m_qw;
}

/*!
 * @brief This function sets a value in member qx
 * @param _qx New value for member qx
 */
void ros2_interface::msg::Quaternion::qx(
        double _qx)
{
    m_qx = _qx;
}

/*!
 * @brief This function returns the value of member qx
 * @return Value of member qx
 */
double ros2_interface::msg::Quaternion::qx() const
{
    return m_qx;
}

/*!
 * @brief This function returns a reference to member qx
 * @return Reference to member qx
 */
double& ros2_interface::msg::Quaternion::qx()
{
    return m_qx;
}

/*!
 * @brief This function sets a value in member qy
 * @param _qy New value for member qy
 */
void ros2_interface::msg::Quaternion::qy(
        double _qy)
{
    m_qy = _qy;
}

/*!
 * @brief This function returns the value of member qy
 * @return Value of member qy
 */
double ros2_interface::msg::Quaternion::qy() const
{
    return m_qy;
}

/*!
 * @brief This function returns a reference to member qy
 * @return Reference to member qy
 */
double& ros2_interface::msg::Quaternion::qy()
{
    return m_qy;
}

/*!
 * @brief This function sets a value in member qz
 * @param _qz New value for member qz
 */
void ros2_interface::msg::Quaternion::qz(
        double _qz)
{
    m_qz = _qz;
}

/*!
 * @brief This function returns the value of member qz
 * @return Value of member qz
 */
double ros2_interface::msg::Quaternion::qz() const
{
    return m_qz;
}

/*!
 * @brief This function returns a reference to member qz
 * @return Reference to member qz
 */
double& ros2_interface::msg::Quaternion::qz()
{
    return m_qz;
}

/*!
 * @brief This function sets a value in member qw
 * @param _qw New value for member qw
 */
void ros2_interface::msg::Quaternion::qw(
        double _qw)
{
    m_qw = _qw;
}

/*!
 * @brief This function returns the value of member qw
 * @return Value of member qw
 */
double ros2_interface::msg::Quaternion::qw() const
{
    return m_qw;
}

/*!
 * @brief This function returns a reference to member qw
 * @return Reference to member qw
 */
double& ros2_interface::msg::Quaternion::qw()
{
    return m_qw;
}



size_t ros2_interface::msg::Quaternion::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Quaternion_max_key_cdr_typesize;
}

bool ros2_interface::msg::Quaternion::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Quaternion::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



