// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Quaternion.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_QUATERNION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_QUATERNION_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(QUATERNION_SOURCE)
#define QUATERNION_DllAPI __declspec( dllexport )
#else
#define QUATERNION_DllAPI __declspec( dllimport )
#endif // QUATERNION_SOURCE
#else
#define QUATERNION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define QUATERNION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Quaternion defined by the user in the IDL file.
         * @ingroup Quaternion
         */
        class Quaternion
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Quaternion();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Quaternion();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Quaternion that will be copied.
             */
            eProsima_user_DllExport Quaternion(
                    const Quaternion& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Quaternion that will be copied.
             */
            eProsima_user_DllExport Quaternion(
                    Quaternion&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Quaternion that will be copied.
             */
            eProsima_user_DllExport Quaternion& operator =(
                    const Quaternion& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Quaternion that will be copied.
             */
            eProsima_user_DllExport Quaternion& operator =(
                    Quaternion&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Quaternion object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Quaternion& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Quaternion object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Quaternion& x) const;

            /*!
             * @brief This function sets a value in member qx
             * @param _qx New value for member qx
             */
            eProsima_user_DllExport void qx(
                    double _qx);

            /*!
             * @brief This function returns the value of member qx
             * @return Value of member qx
             */
            eProsima_user_DllExport double qx() const;

            /*!
             * @brief This function returns a reference to member qx
             * @return Reference to member qx
             */
            eProsima_user_DllExport double& qx();

            /*!
             * @brief This function sets a value in member qy
             * @param _qy New value for member qy
             */
            eProsima_user_DllExport void qy(
                    double _qy);

            /*!
             * @brief This function returns the value of member qy
             * @return Value of member qy
             */
            eProsima_user_DllExport double qy() const;

            /*!
             * @brief This function returns a reference to member qy
             * @return Reference to member qy
             */
            eProsima_user_DllExport double& qy();

            /*!
             * @brief This function sets a value in member qz
             * @param _qz New value for member qz
             */
            eProsima_user_DllExport void qz(
                    double _qz);

            /*!
             * @brief This function returns the value of member qz
             * @return Value of member qz
             */
            eProsima_user_DllExport double qz() const;

            /*!
             * @brief This function returns a reference to member qz
             * @return Reference to member qz
             */
            eProsima_user_DllExport double& qz();

            /*!
             * @brief This function sets a value in member qw
             * @param _qw New value for member qw
             */
            eProsima_user_DllExport void qw(
                    double _qw);

            /*!
             * @brief This function returns the value of member qw
             * @return Value of member qw
             */
            eProsima_user_DllExport double qw() const;

            /*!
             * @brief This function returns a reference to member qw
             * @return Reference to member qw
             */
            eProsima_user_DllExport double& qw();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Quaternion& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_qx;
            double m_qy;
            double m_qz;
            double m_qw;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_QUATERNION_H_

