// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RSSInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RSSInfo.h"
#include "RSSInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_RSSInfo_max_cdr_typesize 72ULL;
#define ros2_interface_msg_RSSInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RSSInfo::RSSInfo()
{
    // boolean m_is_rss_safe
    m_is_rss_safe = false;
    // double m_cur_dist_lon
    m_cur_dist_lon = 0.0;
    // double m_rss_safe_dist_lon
    m_rss_safe_dist_lon = 0.0;
    // double m_acc_lon_range_minimum
    m_acc_lon_range_minimum = 0.0;
    // double m_acc_lon_range_maximum
    m_acc_lon_range_maximum = 0.0;
    // double m_acc_lat_left_range_minimum
    m_acc_lat_left_range_minimum = 0.0;
    // double m_acc_lat_left_range_maximum
    m_acc_lat_left_range_maximum = 0.0;
    // double m_acc_lat_right_range_minimum
    m_acc_lat_right_range_minimum = 0.0;
    // double m_acc_lat_right_range_maximum
    m_acc_lat_right_range_maximum = 0.0;

    // Just to register all known types
    registerRSSInfoTypes();
}

ros2_interface::msg::RSSInfo::~RSSInfo()
{









}

ros2_interface::msg::RSSInfo::RSSInfo(
        const RSSInfo& x)
{
    m_is_rss_safe = x.m_is_rss_safe;
    m_cur_dist_lon = x.m_cur_dist_lon;
    m_rss_safe_dist_lon = x.m_rss_safe_dist_lon;
    m_acc_lon_range_minimum = x.m_acc_lon_range_minimum;
    m_acc_lon_range_maximum = x.m_acc_lon_range_maximum;
    m_acc_lat_left_range_minimum = x.m_acc_lat_left_range_minimum;
    m_acc_lat_left_range_maximum = x.m_acc_lat_left_range_maximum;
    m_acc_lat_right_range_minimum = x.m_acc_lat_right_range_minimum;
    m_acc_lat_right_range_maximum = x.m_acc_lat_right_range_maximum;
}

ros2_interface::msg::RSSInfo::RSSInfo(
        RSSInfo&& x) noexcept 
{
    m_is_rss_safe = x.m_is_rss_safe;
    m_cur_dist_lon = x.m_cur_dist_lon;
    m_rss_safe_dist_lon = x.m_rss_safe_dist_lon;
    m_acc_lon_range_minimum = x.m_acc_lon_range_minimum;
    m_acc_lon_range_maximum = x.m_acc_lon_range_maximum;
    m_acc_lat_left_range_minimum = x.m_acc_lat_left_range_minimum;
    m_acc_lat_left_range_maximum = x.m_acc_lat_left_range_maximum;
    m_acc_lat_right_range_minimum = x.m_acc_lat_right_range_minimum;
    m_acc_lat_right_range_maximum = x.m_acc_lat_right_range_maximum;
}

ros2_interface::msg::RSSInfo& ros2_interface::msg::RSSInfo::operator =(
        const RSSInfo& x)
{

    m_is_rss_safe = x.m_is_rss_safe;
    m_cur_dist_lon = x.m_cur_dist_lon;
    m_rss_safe_dist_lon = x.m_rss_safe_dist_lon;
    m_acc_lon_range_minimum = x.m_acc_lon_range_minimum;
    m_acc_lon_range_maximum = x.m_acc_lon_range_maximum;
    m_acc_lat_left_range_minimum = x.m_acc_lat_left_range_minimum;
    m_acc_lat_left_range_maximum = x.m_acc_lat_left_range_maximum;
    m_acc_lat_right_range_minimum = x.m_acc_lat_right_range_minimum;
    m_acc_lat_right_range_maximum = x.m_acc_lat_right_range_maximum;

    return *this;
}

ros2_interface::msg::RSSInfo& ros2_interface::msg::RSSInfo::operator =(
        RSSInfo&& x) noexcept
{

    m_is_rss_safe = x.m_is_rss_safe;
    m_cur_dist_lon = x.m_cur_dist_lon;
    m_rss_safe_dist_lon = x.m_rss_safe_dist_lon;
    m_acc_lon_range_minimum = x.m_acc_lon_range_minimum;
    m_acc_lon_range_maximum = x.m_acc_lon_range_maximum;
    m_acc_lat_left_range_minimum = x.m_acc_lat_left_range_minimum;
    m_acc_lat_left_range_maximum = x.m_acc_lat_left_range_maximum;
    m_acc_lat_right_range_minimum = x.m_acc_lat_right_range_minimum;
    m_acc_lat_right_range_maximum = x.m_acc_lat_right_range_maximum;

    return *this;
}

bool ros2_interface::msg::RSSInfo::operator ==(
        const RSSInfo& x) const
{

    return (m_is_rss_safe == x.m_is_rss_safe && m_cur_dist_lon == x.m_cur_dist_lon && m_rss_safe_dist_lon == x.m_rss_safe_dist_lon && m_acc_lon_range_minimum == x.m_acc_lon_range_minimum && m_acc_lon_range_maximum == x.m_acc_lon_range_maximum && m_acc_lat_left_range_minimum == x.m_acc_lat_left_range_minimum && m_acc_lat_left_range_maximum == x.m_acc_lat_left_range_maximum && m_acc_lat_right_range_minimum == x.m_acc_lat_right_range_minimum && m_acc_lat_right_range_maximum == x.m_acc_lat_right_range_maximum);
}

bool ros2_interface::msg::RSSInfo::operator !=(
        const RSSInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RSSInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RSSInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::RSSInfo::getCdrSerializedSize(
        const ros2_interface::msg::RSSInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RSSInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_is_rss_safe;
    scdr << m_cur_dist_lon;
    scdr << m_rss_safe_dist_lon;
    scdr << m_acc_lon_range_minimum;
    scdr << m_acc_lon_range_maximum;
    scdr << m_acc_lat_left_range_minimum;
    scdr << m_acc_lat_left_range_maximum;
    scdr << m_acc_lat_right_range_minimum;
    scdr << m_acc_lat_right_range_maximum;

}

void ros2_interface::msg::RSSInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_is_rss_safe;
    dcdr >> m_cur_dist_lon;
    dcdr >> m_rss_safe_dist_lon;
    dcdr >> m_acc_lon_range_minimum;
    dcdr >> m_acc_lon_range_maximum;
    dcdr >> m_acc_lat_left_range_minimum;
    dcdr >> m_acc_lat_left_range_maximum;
    dcdr >> m_acc_lat_right_range_minimum;
    dcdr >> m_acc_lat_right_range_maximum;
}

/*!
 * @brief This function sets a value in member is_rss_safe
 * @param _is_rss_safe New value for member is_rss_safe
 */
void ros2_interface::msg::RSSInfo::is_rss_safe(
        bool _is_rss_safe)
{
    m_is_rss_safe = _is_rss_safe;
}

/*!
 * @brief This function returns the value of member is_rss_safe
 * @return Value of member is_rss_safe
 */
bool ros2_interface::msg::RSSInfo::is_rss_safe() const
{
    return m_is_rss_safe;
}

/*!
 * @brief This function returns a reference to member is_rss_safe
 * @return Reference to member is_rss_safe
 */
bool& ros2_interface::msg::RSSInfo::is_rss_safe()
{
    return m_is_rss_safe;
}

/*!
 * @brief This function sets a value in member cur_dist_lon
 * @param _cur_dist_lon New value for member cur_dist_lon
 */
void ros2_interface::msg::RSSInfo::cur_dist_lon(
        double _cur_dist_lon)
{
    m_cur_dist_lon = _cur_dist_lon;
}

/*!
 * @brief This function returns the value of member cur_dist_lon
 * @return Value of member cur_dist_lon
 */
double ros2_interface::msg::RSSInfo::cur_dist_lon() const
{
    return m_cur_dist_lon;
}

/*!
 * @brief This function returns a reference to member cur_dist_lon
 * @return Reference to member cur_dist_lon
 */
double& ros2_interface::msg::RSSInfo::cur_dist_lon()
{
    return m_cur_dist_lon;
}

/*!
 * @brief This function sets a value in member rss_safe_dist_lon
 * @param _rss_safe_dist_lon New value for member rss_safe_dist_lon
 */
void ros2_interface::msg::RSSInfo::rss_safe_dist_lon(
        double _rss_safe_dist_lon)
{
    m_rss_safe_dist_lon = _rss_safe_dist_lon;
}

/*!
 * @brief This function returns the value of member rss_safe_dist_lon
 * @return Value of member rss_safe_dist_lon
 */
double ros2_interface::msg::RSSInfo::rss_safe_dist_lon() const
{
    return m_rss_safe_dist_lon;
}

/*!
 * @brief This function returns a reference to member rss_safe_dist_lon
 * @return Reference to member rss_safe_dist_lon
 */
double& ros2_interface::msg::RSSInfo::rss_safe_dist_lon()
{
    return m_rss_safe_dist_lon;
}

/*!
 * @brief This function sets a value in member acc_lon_range_minimum
 * @param _acc_lon_range_minimum New value for member acc_lon_range_minimum
 */
void ros2_interface::msg::RSSInfo::acc_lon_range_minimum(
        double _acc_lon_range_minimum)
{
    m_acc_lon_range_minimum = _acc_lon_range_minimum;
}

/*!
 * @brief This function returns the value of member acc_lon_range_minimum
 * @return Value of member acc_lon_range_minimum
 */
double ros2_interface::msg::RSSInfo::acc_lon_range_minimum() const
{
    return m_acc_lon_range_minimum;
}

/*!
 * @brief This function returns a reference to member acc_lon_range_minimum
 * @return Reference to member acc_lon_range_minimum
 */
double& ros2_interface::msg::RSSInfo::acc_lon_range_minimum()
{
    return m_acc_lon_range_minimum;
}

/*!
 * @brief This function sets a value in member acc_lon_range_maximum
 * @param _acc_lon_range_maximum New value for member acc_lon_range_maximum
 */
void ros2_interface::msg::RSSInfo::acc_lon_range_maximum(
        double _acc_lon_range_maximum)
{
    m_acc_lon_range_maximum = _acc_lon_range_maximum;
}

/*!
 * @brief This function returns the value of member acc_lon_range_maximum
 * @return Value of member acc_lon_range_maximum
 */
double ros2_interface::msg::RSSInfo::acc_lon_range_maximum() const
{
    return m_acc_lon_range_maximum;
}

/*!
 * @brief This function returns a reference to member acc_lon_range_maximum
 * @return Reference to member acc_lon_range_maximum
 */
double& ros2_interface::msg::RSSInfo::acc_lon_range_maximum()
{
    return m_acc_lon_range_maximum;
}

/*!
 * @brief This function sets a value in member acc_lat_left_range_minimum
 * @param _acc_lat_left_range_minimum New value for member acc_lat_left_range_minimum
 */
void ros2_interface::msg::RSSInfo::acc_lat_left_range_minimum(
        double _acc_lat_left_range_minimum)
{
    m_acc_lat_left_range_minimum = _acc_lat_left_range_minimum;
}

/*!
 * @brief This function returns the value of member acc_lat_left_range_minimum
 * @return Value of member acc_lat_left_range_minimum
 */
double ros2_interface::msg::RSSInfo::acc_lat_left_range_minimum() const
{
    return m_acc_lat_left_range_minimum;
}

/*!
 * @brief This function returns a reference to member acc_lat_left_range_minimum
 * @return Reference to member acc_lat_left_range_minimum
 */
double& ros2_interface::msg::RSSInfo::acc_lat_left_range_minimum()
{
    return m_acc_lat_left_range_minimum;
}

/*!
 * @brief This function sets a value in member acc_lat_left_range_maximum
 * @param _acc_lat_left_range_maximum New value for member acc_lat_left_range_maximum
 */
void ros2_interface::msg::RSSInfo::acc_lat_left_range_maximum(
        double _acc_lat_left_range_maximum)
{
    m_acc_lat_left_range_maximum = _acc_lat_left_range_maximum;
}

/*!
 * @brief This function returns the value of member acc_lat_left_range_maximum
 * @return Value of member acc_lat_left_range_maximum
 */
double ros2_interface::msg::RSSInfo::acc_lat_left_range_maximum() const
{
    return m_acc_lat_left_range_maximum;
}

/*!
 * @brief This function returns a reference to member acc_lat_left_range_maximum
 * @return Reference to member acc_lat_left_range_maximum
 */
double& ros2_interface::msg::RSSInfo::acc_lat_left_range_maximum()
{
    return m_acc_lat_left_range_maximum;
}

/*!
 * @brief This function sets a value in member acc_lat_right_range_minimum
 * @param _acc_lat_right_range_minimum New value for member acc_lat_right_range_minimum
 */
void ros2_interface::msg::RSSInfo::acc_lat_right_range_minimum(
        double _acc_lat_right_range_minimum)
{
    m_acc_lat_right_range_minimum = _acc_lat_right_range_minimum;
}

/*!
 * @brief This function returns the value of member acc_lat_right_range_minimum
 * @return Value of member acc_lat_right_range_minimum
 */
double ros2_interface::msg::RSSInfo::acc_lat_right_range_minimum() const
{
    return m_acc_lat_right_range_minimum;
}

/*!
 * @brief This function returns a reference to member acc_lat_right_range_minimum
 * @return Reference to member acc_lat_right_range_minimum
 */
double& ros2_interface::msg::RSSInfo::acc_lat_right_range_minimum()
{
    return m_acc_lat_right_range_minimum;
}

/*!
 * @brief This function sets a value in member acc_lat_right_range_maximum
 * @param _acc_lat_right_range_maximum New value for member acc_lat_right_range_maximum
 */
void ros2_interface::msg::RSSInfo::acc_lat_right_range_maximum(
        double _acc_lat_right_range_maximum)
{
    m_acc_lat_right_range_maximum = _acc_lat_right_range_maximum;
}

/*!
 * @brief This function returns the value of member acc_lat_right_range_maximum
 * @return Value of member acc_lat_right_range_maximum
 */
double ros2_interface::msg::RSSInfo::acc_lat_right_range_maximum() const
{
    return m_acc_lat_right_range_maximum;
}

/*!
 * @brief This function returns a reference to member acc_lat_right_range_maximum
 * @return Reference to member acc_lat_right_range_maximum
 */
double& ros2_interface::msg::RSSInfo::acc_lat_right_range_maximum()
{
    return m_acc_lat_right_range_maximum;
}



size_t ros2_interface::msg::RSSInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RSSInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::RSSInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RSSInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



