// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RSSInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RSSINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RSSINFO_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(RSSINFO_SOURCE)
#define RSSINFO_DllAPI __declspec( dllexport )
#else
#define RSSINFO_DllAPI __declspec( dllimport )
#endif // RSSINFO_SOURCE
#else
#define RSSINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define RSSINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RSSInfo defined by the user in the IDL file.
         * @ingroup RSSInfo
         */
        class RSSInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RSSInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RSSInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RSSInfo that will be copied.
             */
            eProsima_user_DllExport RSSInfo(
                    const RSSInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RSSInfo that will be copied.
             */
            eProsima_user_DllExport RSSInfo(
                    RSSInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RSSInfo that will be copied.
             */
            eProsima_user_DllExport RSSInfo& operator =(
                    const RSSInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RSSInfo that will be copied.
             */
            eProsima_user_DllExport RSSInfo& operator =(
                    RSSInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RSSInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RSSInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RSSInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RSSInfo& x) const;

            /*!
             * @brief This function sets a value in member is_rss_safe
             * @param _is_rss_safe New value for member is_rss_safe
             */
            eProsima_user_DllExport void is_rss_safe(
                    bool _is_rss_safe);

            /*!
             * @brief This function returns the value of member is_rss_safe
             * @return Value of member is_rss_safe
             */
            eProsima_user_DllExport bool is_rss_safe() const;

            /*!
             * @brief This function returns a reference to member is_rss_safe
             * @return Reference to member is_rss_safe
             */
            eProsima_user_DllExport bool& is_rss_safe();

            /*!
             * @brief This function sets a value in member cur_dist_lon
             * @param _cur_dist_lon New value for member cur_dist_lon
             */
            eProsima_user_DllExport void cur_dist_lon(
                    double _cur_dist_lon);

            /*!
             * @brief This function returns the value of member cur_dist_lon
             * @return Value of member cur_dist_lon
             */
            eProsima_user_DllExport double cur_dist_lon() const;

            /*!
             * @brief This function returns a reference to member cur_dist_lon
             * @return Reference to member cur_dist_lon
             */
            eProsima_user_DllExport double& cur_dist_lon();

            /*!
             * @brief This function sets a value in member rss_safe_dist_lon
             * @param _rss_safe_dist_lon New value for member rss_safe_dist_lon
             */
            eProsima_user_DllExport void rss_safe_dist_lon(
                    double _rss_safe_dist_lon);

            /*!
             * @brief This function returns the value of member rss_safe_dist_lon
             * @return Value of member rss_safe_dist_lon
             */
            eProsima_user_DllExport double rss_safe_dist_lon() const;

            /*!
             * @brief This function returns a reference to member rss_safe_dist_lon
             * @return Reference to member rss_safe_dist_lon
             */
            eProsima_user_DllExport double& rss_safe_dist_lon();

            /*!
             * @brief This function sets a value in member acc_lon_range_minimum
             * @param _acc_lon_range_minimum New value for member acc_lon_range_minimum
             */
            eProsima_user_DllExport void acc_lon_range_minimum(
                    double _acc_lon_range_minimum);

            /*!
             * @brief This function returns the value of member acc_lon_range_minimum
             * @return Value of member acc_lon_range_minimum
             */
            eProsima_user_DllExport double acc_lon_range_minimum() const;

            /*!
             * @brief This function returns a reference to member acc_lon_range_minimum
             * @return Reference to member acc_lon_range_minimum
             */
            eProsima_user_DllExport double& acc_lon_range_minimum();

            /*!
             * @brief This function sets a value in member acc_lon_range_maximum
             * @param _acc_lon_range_maximum New value for member acc_lon_range_maximum
             */
            eProsima_user_DllExport void acc_lon_range_maximum(
                    double _acc_lon_range_maximum);

            /*!
             * @brief This function returns the value of member acc_lon_range_maximum
             * @return Value of member acc_lon_range_maximum
             */
            eProsima_user_DllExport double acc_lon_range_maximum() const;

            /*!
             * @brief This function returns a reference to member acc_lon_range_maximum
             * @return Reference to member acc_lon_range_maximum
             */
            eProsima_user_DllExport double& acc_lon_range_maximum();

            /*!
             * @brief This function sets a value in member acc_lat_left_range_minimum
             * @param _acc_lat_left_range_minimum New value for member acc_lat_left_range_minimum
             */
            eProsima_user_DllExport void acc_lat_left_range_minimum(
                    double _acc_lat_left_range_minimum);

            /*!
             * @brief This function returns the value of member acc_lat_left_range_minimum
             * @return Value of member acc_lat_left_range_minimum
             */
            eProsima_user_DllExport double acc_lat_left_range_minimum() const;

            /*!
             * @brief This function returns a reference to member acc_lat_left_range_minimum
             * @return Reference to member acc_lat_left_range_minimum
             */
            eProsima_user_DllExport double& acc_lat_left_range_minimum();

            /*!
             * @brief This function sets a value in member acc_lat_left_range_maximum
             * @param _acc_lat_left_range_maximum New value for member acc_lat_left_range_maximum
             */
            eProsima_user_DllExport void acc_lat_left_range_maximum(
                    double _acc_lat_left_range_maximum);

            /*!
             * @brief This function returns the value of member acc_lat_left_range_maximum
             * @return Value of member acc_lat_left_range_maximum
             */
            eProsima_user_DllExport double acc_lat_left_range_maximum() const;

            /*!
             * @brief This function returns a reference to member acc_lat_left_range_maximum
             * @return Reference to member acc_lat_left_range_maximum
             */
            eProsima_user_DllExport double& acc_lat_left_range_maximum();

            /*!
             * @brief This function sets a value in member acc_lat_right_range_minimum
             * @param _acc_lat_right_range_minimum New value for member acc_lat_right_range_minimum
             */
            eProsima_user_DllExport void acc_lat_right_range_minimum(
                    double _acc_lat_right_range_minimum);

            /*!
             * @brief This function returns the value of member acc_lat_right_range_minimum
             * @return Value of member acc_lat_right_range_minimum
             */
            eProsima_user_DllExport double acc_lat_right_range_minimum() const;

            /*!
             * @brief This function returns a reference to member acc_lat_right_range_minimum
             * @return Reference to member acc_lat_right_range_minimum
             */
            eProsima_user_DllExport double& acc_lat_right_range_minimum();

            /*!
             * @brief This function sets a value in member acc_lat_right_range_maximum
             * @param _acc_lat_right_range_maximum New value for member acc_lat_right_range_maximum
             */
            eProsima_user_DllExport void acc_lat_right_range_maximum(
                    double _acc_lat_right_range_maximum);

            /*!
             * @brief This function returns the value of member acc_lat_right_range_maximum
             * @return Value of member acc_lat_right_range_maximum
             */
            eProsima_user_DllExport double acc_lat_right_range_maximum() const;

            /*!
             * @brief This function returns a reference to member acc_lat_right_range_maximum
             * @return Reference to member acc_lat_right_range_maximum
             */
            eProsima_user_DllExport double& acc_lat_right_range_maximum();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RSSInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            bool m_is_rss_safe;
            double m_cur_dist_lon;
            double m_rss_safe_dist_lon;
            double m_acc_lon_range_minimum;
            double m_acc_lon_range_maximum;
            double m_acc_lat_left_range_minimum;
            double m_acc_lat_left_range_maximum;
            double m_acc_lat_right_range_minimum;
            double m_acc_lat_right_range_maximum;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RSSINFO_H_

