// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RSSInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "RSSInfo.h"
#include "RSSInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRSSInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::RSSInfo", ros2_interface::msg::GetRSSInfoIdentifier(true),
                        ros2_interface::msg::GetRSSInfoObject(true));
                factory->add_type_object("ros2_interface::msg::RSSInfo", ros2_interface::msg::GetRSSInfoIdentifier(false),
                        ros2_interface::msg::GetRSSInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRSSInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("RSSInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRSSInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("RSSInfo", complete);
        }

        const TypeObject* GetRSSInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RSSInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRSSInfoObject();
            }
            //else
            return GetMinimalRSSInfoObject();
        }

        const TypeObject* GetMinimalRSSInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RSSInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_is_rss_safe;
            mst_is_rss_safe.common().member_id(memberId++);
            mst_is_rss_safe.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_rss_safe.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_rss_safe.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_rss_safe.common().member_flags().IS_OPTIONAL(false);
            mst_is_rss_safe.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_rss_safe.common().member_flags().IS_KEY(false);
            mst_is_rss_safe.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_rss_safe.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_rss_safe_hash("is_rss_safe");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_rss_safe.detail().name_hash()[i] = is_rss_safe_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_rss_safe);

            MinimalStructMember mst_cur_dist_lon;
            mst_cur_dist_lon.common().member_id(memberId++);
            mst_cur_dist_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cur_dist_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cur_dist_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cur_dist_lon.common().member_flags().IS_OPTIONAL(false);
            mst_cur_dist_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cur_dist_lon.common().member_flags().IS_KEY(false);
            mst_cur_dist_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cur_dist_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cur_dist_lon_hash("cur_dist_lon");
            for(int i = 0; i < 4; ++i)
            {
                mst_cur_dist_lon.detail().name_hash()[i] = cur_dist_lon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cur_dist_lon);

            MinimalStructMember mst_rss_safe_dist_lon;
            mst_rss_safe_dist_lon.common().member_id(memberId++);
            mst_rss_safe_dist_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rss_safe_dist_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rss_safe_dist_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rss_safe_dist_lon.common().member_flags().IS_OPTIONAL(false);
            mst_rss_safe_dist_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rss_safe_dist_lon.common().member_flags().IS_KEY(false);
            mst_rss_safe_dist_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rss_safe_dist_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rss_safe_dist_lon_hash("rss_safe_dist_lon");
            for(int i = 0; i < 4; ++i)
            {
                mst_rss_safe_dist_lon.detail().name_hash()[i] = rss_safe_dist_lon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rss_safe_dist_lon);

            MinimalStructMember mst_acc_lon_range_minimum;
            mst_acc_lon_range_minimum.common().member_id(memberId++);
            mst_acc_lon_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lon_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lon_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lon_range_minimum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lon_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lon_range_minimum.common().member_flags().IS_KEY(false);
            mst_acc_lon_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lon_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lon_range_minimum_hash("acc_lon_range_minimum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lon_range_minimum.detail().name_hash()[i] = acc_lon_range_minimum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lon_range_minimum);

            MinimalStructMember mst_acc_lon_range_maximum;
            mst_acc_lon_range_maximum.common().member_id(memberId++);
            mst_acc_lon_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lon_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lon_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lon_range_maximum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lon_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lon_range_maximum.common().member_flags().IS_KEY(false);
            mst_acc_lon_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lon_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lon_range_maximum_hash("acc_lon_range_maximum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lon_range_maximum.detail().name_hash()[i] = acc_lon_range_maximum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lon_range_maximum);

            MinimalStructMember mst_acc_lat_left_range_minimum;
            mst_acc_lat_left_range_minimum.common().member_id(memberId++);
            mst_acc_lat_left_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lat_left_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lat_left_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lat_left_range_minimum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lat_left_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lat_left_range_minimum.common().member_flags().IS_KEY(false);
            mst_acc_lat_left_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lat_left_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lat_left_range_minimum_hash("acc_lat_left_range_minimum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lat_left_range_minimum.detail().name_hash()[i] = acc_lat_left_range_minimum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lat_left_range_minimum);

            MinimalStructMember mst_acc_lat_left_range_maximum;
            mst_acc_lat_left_range_maximum.common().member_id(memberId++);
            mst_acc_lat_left_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lat_left_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lat_left_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lat_left_range_maximum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lat_left_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lat_left_range_maximum.common().member_flags().IS_KEY(false);
            mst_acc_lat_left_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lat_left_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lat_left_range_maximum_hash("acc_lat_left_range_maximum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lat_left_range_maximum.detail().name_hash()[i] = acc_lat_left_range_maximum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lat_left_range_maximum);

            MinimalStructMember mst_acc_lat_right_range_minimum;
            mst_acc_lat_right_range_minimum.common().member_id(memberId++);
            mst_acc_lat_right_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lat_right_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lat_right_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lat_right_range_minimum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lat_right_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lat_right_range_minimum.common().member_flags().IS_KEY(false);
            mst_acc_lat_right_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lat_right_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lat_right_range_minimum_hash("acc_lat_right_range_minimum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lat_right_range_minimum.detail().name_hash()[i] = acc_lat_right_range_minimum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lat_right_range_minimum);

            MinimalStructMember mst_acc_lat_right_range_maximum;
            mst_acc_lat_right_range_maximum.common().member_id(memberId++);
            mst_acc_lat_right_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acc_lat_right_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acc_lat_right_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acc_lat_right_range_maximum.common().member_flags().IS_OPTIONAL(false);
            mst_acc_lat_right_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acc_lat_right_range_maximum.common().member_flags().IS_KEY(false);
            mst_acc_lat_right_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acc_lat_right_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acc_lat_right_range_maximum_hash("acc_lat_right_range_maximum");
            for(int i = 0; i < 4; ++i)
            {
                mst_acc_lat_right_range_maximum.detail().name_hash()[i] = acc_lat_right_range_maximum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acc_lat_right_range_maximum);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RSSInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RSSInfo", false);
        }

        const TypeObject* GetCompleteRSSInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RSSInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_is_rss_safe;
            cst_is_rss_safe.common().member_id(memberId++);
            cst_is_rss_safe.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_rss_safe.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_rss_safe.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_rss_safe.common().member_flags().IS_OPTIONAL(false);
            cst_is_rss_safe.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_rss_safe.common().member_flags().IS_KEY(false);
            cst_is_rss_safe.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_rss_safe.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_rss_safe.detail().name("is_rss_safe");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_rss_safe);

            CompleteStructMember cst_cur_dist_lon;
            cst_cur_dist_lon.common().member_id(memberId++);
            cst_cur_dist_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cur_dist_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cur_dist_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cur_dist_lon.common().member_flags().IS_OPTIONAL(false);
            cst_cur_dist_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cur_dist_lon.common().member_flags().IS_KEY(false);
            cst_cur_dist_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cur_dist_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cur_dist_lon.detail().name("cur_dist_lon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cur_dist_lon);

            CompleteStructMember cst_rss_safe_dist_lon;
            cst_rss_safe_dist_lon.common().member_id(memberId++);
            cst_rss_safe_dist_lon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rss_safe_dist_lon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rss_safe_dist_lon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rss_safe_dist_lon.common().member_flags().IS_OPTIONAL(false);
            cst_rss_safe_dist_lon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rss_safe_dist_lon.common().member_flags().IS_KEY(false);
            cst_rss_safe_dist_lon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rss_safe_dist_lon.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rss_safe_dist_lon.detail().name("rss_safe_dist_lon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rss_safe_dist_lon);

            CompleteStructMember cst_acc_lon_range_minimum;
            cst_acc_lon_range_minimum.common().member_id(memberId++);
            cst_acc_lon_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lon_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lon_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lon_range_minimum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lon_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lon_range_minimum.common().member_flags().IS_KEY(false);
            cst_acc_lon_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lon_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lon_range_minimum.detail().name("acc_lon_range_minimum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lon_range_minimum);

            CompleteStructMember cst_acc_lon_range_maximum;
            cst_acc_lon_range_maximum.common().member_id(memberId++);
            cst_acc_lon_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lon_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lon_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lon_range_maximum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lon_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lon_range_maximum.common().member_flags().IS_KEY(false);
            cst_acc_lon_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lon_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lon_range_maximum.detail().name("acc_lon_range_maximum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lon_range_maximum);

            CompleteStructMember cst_acc_lat_left_range_minimum;
            cst_acc_lat_left_range_minimum.common().member_id(memberId++);
            cst_acc_lat_left_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lat_left_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lat_left_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lat_left_range_minimum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lat_left_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lat_left_range_minimum.common().member_flags().IS_KEY(false);
            cst_acc_lat_left_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lat_left_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lat_left_range_minimum.detail().name("acc_lat_left_range_minimum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lat_left_range_minimum);

            CompleteStructMember cst_acc_lat_left_range_maximum;
            cst_acc_lat_left_range_maximum.common().member_id(memberId++);
            cst_acc_lat_left_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lat_left_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lat_left_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lat_left_range_maximum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lat_left_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lat_left_range_maximum.common().member_flags().IS_KEY(false);
            cst_acc_lat_left_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lat_left_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lat_left_range_maximum.detail().name("acc_lat_left_range_maximum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lat_left_range_maximum);

            CompleteStructMember cst_acc_lat_right_range_minimum;
            cst_acc_lat_right_range_minimum.common().member_id(memberId++);
            cst_acc_lat_right_range_minimum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lat_right_range_minimum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lat_right_range_minimum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lat_right_range_minimum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lat_right_range_minimum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lat_right_range_minimum.common().member_flags().IS_KEY(false);
            cst_acc_lat_right_range_minimum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lat_right_range_minimum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lat_right_range_minimum.detail().name("acc_lat_right_range_minimum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lat_right_range_minimum);

            CompleteStructMember cst_acc_lat_right_range_maximum;
            cst_acc_lat_right_range_maximum.common().member_id(memberId++);
            cst_acc_lat_right_range_maximum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acc_lat_right_range_maximum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acc_lat_right_range_maximum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acc_lat_right_range_maximum.common().member_flags().IS_OPTIONAL(false);
            cst_acc_lat_right_range_maximum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acc_lat_right_range_maximum.common().member_flags().IS_KEY(false);
            cst_acc_lat_right_range_maximum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acc_lat_right_range_maximum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acc_lat_right_range_maximum.detail().name("acc_lat_right_range_maximum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acc_lat_right_range_maximum);


            // Header
            type_object->complete().struct_type().header().detail().type_name("RSSInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RSSInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RSSInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface