// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RadarObstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RadarObstacle.h"
#include "RadarObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_RadarObstacle_max_cdr_typesize 128ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RadarObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RadarObstacle::RadarObstacle()
{
    // long m_id
    m_id = 0;
    // ros2_interface::msg::Point2D m_relative_position

    // ros2_interface::msg::Point2D m_relative_velocity

    // double m_rcs
    m_rcs = 0.0;
    // long m_moving_status
    m_moving_status = 0;
    // double m_width
    m_width = 0.0;
    // double m_length
    m_length = 0.0;
    // double m_height
    m_height = 0.0;
    // double m_theta
    m_theta = 0.0;
    // ros2_interface::msg::Point2D m_absolute_position

    // ros2_interface::msg::Point2D m_absolute_velocity

    // long m_count
    m_count = 0;
    // long m_moving_frames_count
    m_moving_frames_count = 0;

    // Just to register all known types
    registerRadarObstacleTypes();
}

ros2_interface::msg::RadarObstacle::~RadarObstacle()
{













}

ros2_interface::msg::RadarObstacle::RadarObstacle(
        const RadarObstacle& x)
{
    m_id = x.m_id;
    m_relative_position = x.m_relative_position;
    m_relative_velocity = x.m_relative_velocity;
    m_rcs = x.m_rcs;
    m_moving_status = x.m_moving_status;
    m_width = x.m_width;
    m_length = x.m_length;
    m_height = x.m_height;
    m_theta = x.m_theta;
    m_absolute_position = x.m_absolute_position;
    m_absolute_velocity = x.m_absolute_velocity;
    m_count = x.m_count;
    m_moving_frames_count = x.m_moving_frames_count;
}

ros2_interface::msg::RadarObstacle::RadarObstacle(
        RadarObstacle&& x) noexcept 
{
    m_id = x.m_id;
    m_relative_position = std::move(x.m_relative_position);
    m_relative_velocity = std::move(x.m_relative_velocity);
    m_rcs = x.m_rcs;
    m_moving_status = x.m_moving_status;
    m_width = x.m_width;
    m_length = x.m_length;
    m_height = x.m_height;
    m_theta = x.m_theta;
    m_absolute_position = std::move(x.m_absolute_position);
    m_absolute_velocity = std::move(x.m_absolute_velocity);
    m_count = x.m_count;
    m_moving_frames_count = x.m_moving_frames_count;
}

ros2_interface::msg::RadarObstacle& ros2_interface::msg::RadarObstacle::operator =(
        const RadarObstacle& x)
{

    m_id = x.m_id;
    m_relative_position = x.m_relative_position;
    m_relative_velocity = x.m_relative_velocity;
    m_rcs = x.m_rcs;
    m_moving_status = x.m_moving_status;
    m_width = x.m_width;
    m_length = x.m_length;
    m_height = x.m_height;
    m_theta = x.m_theta;
    m_absolute_position = x.m_absolute_position;
    m_absolute_velocity = x.m_absolute_velocity;
    m_count = x.m_count;
    m_moving_frames_count = x.m_moving_frames_count;

    return *this;
}

ros2_interface::msg::RadarObstacle& ros2_interface::msg::RadarObstacle::operator =(
        RadarObstacle&& x) noexcept
{

    m_id = x.m_id;
    m_relative_position = std::move(x.m_relative_position);
    m_relative_velocity = std::move(x.m_relative_velocity);
    m_rcs = x.m_rcs;
    m_moving_status = x.m_moving_status;
    m_width = x.m_width;
    m_length = x.m_length;
    m_height = x.m_height;
    m_theta = x.m_theta;
    m_absolute_position = std::move(x.m_absolute_position);
    m_absolute_velocity = std::move(x.m_absolute_velocity);
    m_count = x.m_count;
    m_moving_frames_count = x.m_moving_frames_count;

    return *this;
}

bool ros2_interface::msg::RadarObstacle::operator ==(
        const RadarObstacle& x) const
{

    return (m_id == x.m_id && m_relative_position == x.m_relative_position && m_relative_velocity == x.m_relative_velocity && m_rcs == x.m_rcs && m_moving_status == x.m_moving_status && m_width == x.m_width && m_length == x.m_length && m_height == x.m_height && m_theta == x.m_theta && m_absolute_position == x.m_absolute_position && m_absolute_velocity == x.m_absolute_velocity && m_count == x.m_count && m_moving_frames_count == x.m_moving_frames_count);
}

bool ros2_interface::msg::RadarObstacle::operator !=(
        const RadarObstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RadarObstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RadarObstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::RadarObstacle::getCdrSerializedSize(
        const ros2_interface::msg::RadarObstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.relative_position(), current_alignment);
    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.relative_velocity(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.absolute_position(), current_alignment);
    current_alignment += ros2_interface::msg::Point2D::getCdrSerializedSize(data.absolute_velocity(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RadarObstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_id;
    scdr << m_relative_position;
    scdr << m_relative_velocity;
    scdr << m_rcs;
    scdr << m_moving_status;
    scdr << m_width;
    scdr << m_length;
    scdr << m_height;
    scdr << m_theta;
    scdr << m_absolute_position;
    scdr << m_absolute_velocity;
    scdr << m_count;
    scdr << m_moving_frames_count;

}

void ros2_interface::msg::RadarObstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_id;
    dcdr >> m_relative_position;
    dcdr >> m_relative_velocity;
    dcdr >> m_rcs;
    dcdr >> m_moving_status;
    dcdr >> m_width;
    dcdr >> m_length;
    dcdr >> m_height;
    dcdr >> m_theta;
    dcdr >> m_absolute_position;
    dcdr >> m_absolute_velocity;
    dcdr >> m_count;
    dcdr >> m_moving_frames_count;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::RadarObstacle::id(
        int32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
int32_t ros2_interface::msg::RadarObstacle::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
int32_t& ros2_interface::msg::RadarObstacle::id()
{
    return m_id;
}

/*!
 * @brief This function copies the value in member relative_position
 * @param _relative_position New value to be copied in member relative_position
 */
void ros2_interface::msg::RadarObstacle::relative_position(
        const ros2_interface::msg::Point2D& _relative_position)
{
    m_relative_position = _relative_position;
}

/*!
 * @brief This function moves the value in member relative_position
 * @param _relative_position New value to be moved in member relative_position
 */
void ros2_interface::msg::RadarObstacle::relative_position(
        ros2_interface::msg::Point2D&& _relative_position)
{
    m_relative_position = std::move(_relative_position);
}

/*!
 * @brief This function returns a constant reference to member relative_position
 * @return Constant reference to member relative_position
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::relative_position() const
{
    return m_relative_position;
}

/*!
 * @brief This function returns a reference to member relative_position
 * @return Reference to member relative_position
 */
ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::relative_position()
{
    return m_relative_position;
}
/*!
 * @brief This function copies the value in member relative_velocity
 * @param _relative_velocity New value to be copied in member relative_velocity
 */
void ros2_interface::msg::RadarObstacle::relative_velocity(
        const ros2_interface::msg::Point2D& _relative_velocity)
{
    m_relative_velocity = _relative_velocity;
}

/*!
 * @brief This function moves the value in member relative_velocity
 * @param _relative_velocity New value to be moved in member relative_velocity
 */
void ros2_interface::msg::RadarObstacle::relative_velocity(
        ros2_interface::msg::Point2D&& _relative_velocity)
{
    m_relative_velocity = std::move(_relative_velocity);
}

/*!
 * @brief This function returns a constant reference to member relative_velocity
 * @return Constant reference to member relative_velocity
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::relative_velocity() const
{
    return m_relative_velocity;
}

/*!
 * @brief This function returns a reference to member relative_velocity
 * @return Reference to member relative_velocity
 */
ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::relative_velocity()
{
    return m_relative_velocity;
}
/*!
 * @brief This function sets a value in member rcs
 * @param _rcs New value for member rcs
 */
void ros2_interface::msg::RadarObstacle::rcs(
        double _rcs)
{
    m_rcs = _rcs;
}

/*!
 * @brief This function returns the value of member rcs
 * @return Value of member rcs
 */
double ros2_interface::msg::RadarObstacle::rcs() const
{
    return m_rcs;
}

/*!
 * @brief This function returns a reference to member rcs
 * @return Reference to member rcs
 */
double& ros2_interface::msg::RadarObstacle::rcs()
{
    return m_rcs;
}

/*!
 * @brief This function sets a value in member moving_status
 * @param _moving_status New value for member moving_status
 */
void ros2_interface::msg::RadarObstacle::moving_status(
        int32_t _moving_status)
{
    m_moving_status = _moving_status;
}

/*!
 * @brief This function returns the value of member moving_status
 * @return Value of member moving_status
 */
int32_t ros2_interface::msg::RadarObstacle::moving_status() const
{
    return m_moving_status;
}

/*!
 * @brief This function returns a reference to member moving_status
 * @return Reference to member moving_status
 */
int32_t& ros2_interface::msg::RadarObstacle::moving_status()
{
    return m_moving_status;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::RadarObstacle::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::RadarObstacle::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::RadarObstacle::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::RadarObstacle::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::RadarObstacle::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::RadarObstacle::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::RadarObstacle::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::RadarObstacle::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::RadarObstacle::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::RadarObstacle::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::RadarObstacle::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::RadarObstacle::theta()
{
    return m_theta;
}

/*!
 * @brief This function copies the value in member absolute_position
 * @param _absolute_position New value to be copied in member absolute_position
 */
void ros2_interface::msg::RadarObstacle::absolute_position(
        const ros2_interface::msg::Point2D& _absolute_position)
{
    m_absolute_position = _absolute_position;
}

/*!
 * @brief This function moves the value in member absolute_position
 * @param _absolute_position New value to be moved in member absolute_position
 */
void ros2_interface::msg::RadarObstacle::absolute_position(
        ros2_interface::msg::Point2D&& _absolute_position)
{
    m_absolute_position = std::move(_absolute_position);
}

/*!
 * @brief This function returns a constant reference to member absolute_position
 * @return Constant reference to member absolute_position
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::absolute_position() const
{
    return m_absolute_position;
}

/*!
 * @brief This function returns a reference to member absolute_position
 * @return Reference to member absolute_position
 */
ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::absolute_position()
{
    return m_absolute_position;
}
/*!
 * @brief This function copies the value in member absolute_velocity
 * @param _absolute_velocity New value to be copied in member absolute_velocity
 */
void ros2_interface::msg::RadarObstacle::absolute_velocity(
        const ros2_interface::msg::Point2D& _absolute_velocity)
{
    m_absolute_velocity = _absolute_velocity;
}

/*!
 * @brief This function moves the value in member absolute_velocity
 * @param _absolute_velocity New value to be moved in member absolute_velocity
 */
void ros2_interface::msg::RadarObstacle::absolute_velocity(
        ros2_interface::msg::Point2D&& _absolute_velocity)
{
    m_absolute_velocity = std::move(_absolute_velocity);
}

/*!
 * @brief This function returns a constant reference to member absolute_velocity
 * @return Constant reference to member absolute_velocity
 */
const ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::absolute_velocity() const
{
    return m_absolute_velocity;
}

/*!
 * @brief This function returns a reference to member absolute_velocity
 * @return Reference to member absolute_velocity
 */
ros2_interface::msg::Point2D& ros2_interface::msg::RadarObstacle::absolute_velocity()
{
    return m_absolute_velocity;
}
/*!
 * @brief This function sets a value in member count
 * @param _count New value for member count
 */
void ros2_interface::msg::RadarObstacle::count(
        int32_t _count)
{
    m_count = _count;
}

/*!
 * @brief This function returns the value of member count
 * @return Value of member count
 */
int32_t ros2_interface::msg::RadarObstacle::count() const
{
    return m_count;
}

/*!
 * @brief This function returns a reference to member count
 * @return Reference to member count
 */
int32_t& ros2_interface::msg::RadarObstacle::count()
{
    return m_count;
}

/*!
 * @brief This function sets a value in member moving_frames_count
 * @param _moving_frames_count New value for member moving_frames_count
 */
void ros2_interface::msg::RadarObstacle::moving_frames_count(
        int32_t _moving_frames_count)
{
    m_moving_frames_count = _moving_frames_count;
}

/*!
 * @brief This function returns the value of member moving_frames_count
 * @return Value of member moving_frames_count
 */
int32_t ros2_interface::msg::RadarObstacle::moving_frames_count() const
{
    return m_moving_frames_count;
}

/*!
 * @brief This function returns a reference to member moving_frames_count
 * @return Reference to member moving_frames_count
 */
int32_t& ros2_interface::msg::RadarObstacle::moving_frames_count()
{
    return m_moving_frames_count;
}



size_t ros2_interface::msg::RadarObstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RadarObstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::RadarObstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RadarObstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



