// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RadarObstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RADAROBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RADAROBSTACLE_H_

#include "Point2D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(RADAROBSTACLE_SOURCE)
#define RADAROBSTACLE_DllAPI __declspec( dllexport )
#else
#define RADAROBSTACLE_DllAPI __declspec( dllimport )
#endif // RADAROBSTACLE_SOURCE
#else
#define RADAROBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define RADAROBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RadarObstacle defined by the user in the IDL file.
         * @ingroup RadarObstacle
         */
        class RadarObstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RadarObstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RadarObstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RadarObstacle that will be copied.
             */
            eProsima_user_DllExport RadarObstacle(
                    const RadarObstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RadarObstacle that will be copied.
             */
            eProsima_user_DllExport RadarObstacle(
                    RadarObstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RadarObstacle that will be copied.
             */
            eProsima_user_DllExport RadarObstacle& operator =(
                    const RadarObstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RadarObstacle that will be copied.
             */
            eProsima_user_DllExport RadarObstacle& operator =(
                    RadarObstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RadarObstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RadarObstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RadarObstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RadarObstacle& x) const;

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    int32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport int32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport int32_t& id();

            /*!
             * @brief This function copies the value in member relative_position
             * @param _relative_position New value to be copied in member relative_position
             */
            eProsima_user_DllExport void relative_position(
                    const ros2_interface::msg::Point2D& _relative_position);

            /*!
             * @brief This function moves the value in member relative_position
             * @param _relative_position New value to be moved in member relative_position
             */
            eProsima_user_DllExport void relative_position(
                    ros2_interface::msg::Point2D&& _relative_position);

            /*!
             * @brief This function returns a constant reference to member relative_position
             * @return Constant reference to member relative_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point2D& relative_position() const;

            /*!
             * @brief This function returns a reference to member relative_position
             * @return Reference to member relative_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point2D& relative_position();
            /*!
             * @brief This function copies the value in member relative_velocity
             * @param _relative_velocity New value to be copied in member relative_velocity
             */
            eProsima_user_DllExport void relative_velocity(
                    const ros2_interface::msg::Point2D& _relative_velocity);

            /*!
             * @brief This function moves the value in member relative_velocity
             * @param _relative_velocity New value to be moved in member relative_velocity
             */
            eProsima_user_DllExport void relative_velocity(
                    ros2_interface::msg::Point2D&& _relative_velocity);

            /*!
             * @brief This function returns a constant reference to member relative_velocity
             * @return Constant reference to member relative_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point2D& relative_velocity() const;

            /*!
             * @brief This function returns a reference to member relative_velocity
             * @return Reference to member relative_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point2D& relative_velocity();
            /*!
             * @brief This function sets a value in member rcs
             * @param _rcs New value for member rcs
             */
            eProsima_user_DllExport void rcs(
                    double _rcs);

            /*!
             * @brief This function returns the value of member rcs
             * @return Value of member rcs
             */
            eProsima_user_DllExport double rcs() const;

            /*!
             * @brief This function returns a reference to member rcs
             * @return Reference to member rcs
             */
            eProsima_user_DllExport double& rcs();

            /*!
             * @brief This function sets a value in member moving_status
             * @param _moving_status New value for member moving_status
             */
            eProsima_user_DllExport void moving_status(
                    int32_t _moving_status);

            /*!
             * @brief This function returns the value of member moving_status
             * @return Value of member moving_status
             */
            eProsima_user_DllExport int32_t moving_status() const;

            /*!
             * @brief This function returns a reference to member moving_status
             * @return Reference to member moving_status
             */
            eProsima_user_DllExport int32_t& moving_status();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function sets a value in member theta
             * @param _theta New value for member theta
             */
            eProsima_user_DllExport void theta(
                    double _theta);

            /*!
             * @brief This function returns the value of member theta
             * @return Value of member theta
             */
            eProsima_user_DllExport double theta() const;

            /*!
             * @brief This function returns a reference to member theta
             * @return Reference to member theta
             */
            eProsima_user_DllExport double& theta();

            /*!
             * @brief This function copies the value in member absolute_position
             * @param _absolute_position New value to be copied in member absolute_position
             */
            eProsima_user_DllExport void absolute_position(
                    const ros2_interface::msg::Point2D& _absolute_position);

            /*!
             * @brief This function moves the value in member absolute_position
             * @param _absolute_position New value to be moved in member absolute_position
             */
            eProsima_user_DllExport void absolute_position(
                    ros2_interface::msg::Point2D&& _absolute_position);

            /*!
             * @brief This function returns a constant reference to member absolute_position
             * @return Constant reference to member absolute_position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point2D& absolute_position() const;

            /*!
             * @brief This function returns a reference to member absolute_position
             * @return Reference to member absolute_position
             */
            eProsima_user_DllExport ros2_interface::msg::Point2D& absolute_position();
            /*!
             * @brief This function copies the value in member absolute_velocity
             * @param _absolute_velocity New value to be copied in member absolute_velocity
             */
            eProsima_user_DllExport void absolute_velocity(
                    const ros2_interface::msg::Point2D& _absolute_velocity);

            /*!
             * @brief This function moves the value in member absolute_velocity
             * @param _absolute_velocity New value to be moved in member absolute_velocity
             */
            eProsima_user_DllExport void absolute_velocity(
                    ros2_interface::msg::Point2D&& _absolute_velocity);

            /*!
             * @brief This function returns a constant reference to member absolute_velocity
             * @return Constant reference to member absolute_velocity
             */
            eProsima_user_DllExport const ros2_interface::msg::Point2D& absolute_velocity() const;

            /*!
             * @brief This function returns a reference to member absolute_velocity
             * @return Reference to member absolute_velocity
             */
            eProsima_user_DllExport ros2_interface::msg::Point2D& absolute_velocity();
            /*!
             * @brief This function sets a value in member count
             * @param _count New value for member count
             */
            eProsima_user_DllExport void count(
                    int32_t _count);

            /*!
             * @brief This function returns the value of member count
             * @return Value of member count
             */
            eProsima_user_DllExport int32_t count() const;

            /*!
             * @brief This function returns a reference to member count
             * @return Reference to member count
             */
            eProsima_user_DllExport int32_t& count();

            /*!
             * @brief This function sets a value in member moving_frames_count
             * @param _moving_frames_count New value for member moving_frames_count
             */
            eProsima_user_DllExport void moving_frames_count(
                    int32_t _moving_frames_count);

            /*!
             * @brief This function returns the value of member moving_frames_count
             * @return Value of member moving_frames_count
             */
            eProsima_user_DllExport int32_t moving_frames_count() const;

            /*!
             * @brief This function returns a reference to member moving_frames_count
             * @return Reference to member moving_frames_count
             */
            eProsima_user_DllExport int32_t& moving_frames_count();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RadarObstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_id;
            ros2_interface::msg::Point2D m_relative_position;
            ros2_interface::msg::Point2D m_relative_velocity;
            double m_rcs;
            int32_t m_moving_status;
            double m_width;
            double m_length;
            double m_height;
            double m_theta;
            ros2_interface::msg::Point2D m_absolute_position;
            ros2_interface::msg::Point2D m_absolute_velocity;
            int32_t m_count;
            int32_t m_moving_frames_count;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_RADAROBSTACLE_H_

