// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RadarObstacleList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RadarObstacleList.h"
#include "RadarObstacleListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point2D_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_RadarObstacle_max_cdr_typesize 128ULL;
#define ros2_interface_msg_RadarObstacleList_max_cdr_typesize 13072ULL;
#define ros2_interface_msg_Point2D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RadarObstacle_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RadarObstacleList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RadarObstacleList::RadarObstacleList()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::RadarObstacle> m_radar_obstacle


    // Just to register all known types
    registerRadarObstacleListTypes();
}

ros2_interface::msg::RadarObstacleList::~RadarObstacleList()
{


}

ros2_interface::msg::RadarObstacleList::RadarObstacleList(
        const RadarObstacleList& x)
{
    m_header = x.m_header;
    m_radar_obstacle = x.m_radar_obstacle;
}

ros2_interface::msg::RadarObstacleList::RadarObstacleList(
        RadarObstacleList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_radar_obstacle = std::move(x.m_radar_obstacle);
}

ros2_interface::msg::RadarObstacleList& ros2_interface::msg::RadarObstacleList::operator =(
        const RadarObstacleList& x)
{

    m_header = x.m_header;
    m_radar_obstacle = x.m_radar_obstacle;

    return *this;
}

ros2_interface::msg::RadarObstacleList& ros2_interface::msg::RadarObstacleList::operator =(
        RadarObstacleList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_radar_obstacle = std::move(x.m_radar_obstacle);

    return *this;
}

bool ros2_interface::msg::RadarObstacleList::operator ==(
        const RadarObstacleList& x) const
{

    return (m_header == x.m_header && m_radar_obstacle == x.m_radar_obstacle);
}

bool ros2_interface::msg::RadarObstacleList::operator !=(
        const RadarObstacleList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RadarObstacleList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RadarObstacleList_max_cdr_typesize;
}

size_t ros2_interface::msg::RadarObstacleList::getCdrSerializedSize(
        const ros2_interface::msg::RadarObstacleList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.radar_obstacle().size(); ++a)
    {
        current_alignment += ros2_interface::msg::RadarObstacle::getCdrSerializedSize(data.radar_obstacle().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RadarObstacleList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_radar_obstacle;

}

void ros2_interface::msg::RadarObstacleList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_radar_obstacle;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::RadarObstacleList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::RadarObstacleList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::RadarObstacleList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::RadarObstacleList::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member radar_obstacle
 * @param _radar_obstacle New value to be copied in member radar_obstacle
 */
void ros2_interface::msg::RadarObstacleList::radar_obstacle(
        const std::vector<ros2_interface::msg::RadarObstacle>& _radar_obstacle)
{
    m_radar_obstacle = _radar_obstacle;
}

/*!
 * @brief This function moves the value in member radar_obstacle
 * @param _radar_obstacle New value to be moved in member radar_obstacle
 */
void ros2_interface::msg::RadarObstacleList::radar_obstacle(
        std::vector<ros2_interface::msg::RadarObstacle>&& _radar_obstacle)
{
    m_radar_obstacle = std::move(_radar_obstacle);
}

/*!
 * @brief This function returns a constant reference to member radar_obstacle
 * @return Constant reference to member radar_obstacle
 */
const std::vector<ros2_interface::msg::RadarObstacle>& ros2_interface::msg::RadarObstacleList::radar_obstacle() const
{
    return m_radar_obstacle;
}

/*!
 * @brief This function returns a reference to member radar_obstacle
 * @return Reference to member radar_obstacle
 */
std::vector<ros2_interface::msg::RadarObstacle>& ros2_interface::msg::RadarObstacleList::radar_obstacle()
{
    return m_radar_obstacle;
}


size_t ros2_interface::msg::RadarObstacleList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RadarObstacleList_max_key_cdr_typesize;
}

bool ros2_interface::msg::RadarObstacleList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RadarObstacleList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



