// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RadarObstacleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "RadarObstacle.h"
#include "RadarObstacleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRadarObstacleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(true),
                        ros2_interface::msg::GetPoint2DObject(true));
                factory->add_type_object("ros2_interface::msg::Point2D", ros2_interface::msg::GetPoint2DIdentifier(false),
                        ros2_interface::msg::GetPoint2DObject(false));



                factory->add_type_object("ros2_interface::msg::RadarObstacle", ros2_interface::msg::GetRadarObstacleIdentifier(true),
                        ros2_interface::msg::GetRadarObstacleObject(true));
                factory->add_type_object("ros2_interface::msg::RadarObstacle", ros2_interface::msg::GetRadarObstacleIdentifier(false),
                        ros2_interface::msg::GetRadarObstacleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRadarObstacleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("RadarObstacle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRadarObstacleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("RadarObstacle", complete);
        }

        const TypeObject* GetRadarObstacleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RadarObstacle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRadarObstacleObject();
            }
            //else
            return GetMinimalRadarObstacleObject();
        }

        const TypeObject* GetMinimalRadarObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RadarObstacle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_relative_position;
            mst_relative_position.common().member_id(memberId++);
            mst_relative_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_relative_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_relative_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_relative_position.common().member_flags().IS_OPTIONAL(false);
            mst_relative_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_relative_position.common().member_flags().IS_KEY(false);
            mst_relative_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_relative_position.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 relative_position_hash("relative_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_relative_position.detail().name_hash()[i] = relative_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_relative_position);

            MinimalStructMember mst_relative_velocity;
            mst_relative_velocity.common().member_id(memberId++);
            mst_relative_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_relative_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_relative_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_relative_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_relative_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_relative_velocity.common().member_flags().IS_KEY(false);
            mst_relative_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_relative_velocity.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 relative_velocity_hash("relative_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_relative_velocity.detail().name_hash()[i] = relative_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_relative_velocity);

            MinimalStructMember mst_rcs;
            mst_rcs.common().member_id(memberId++);
            mst_rcs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rcs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rcs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rcs.common().member_flags().IS_OPTIONAL(false);
            mst_rcs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rcs.common().member_flags().IS_KEY(false);
            mst_rcs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rcs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rcs_hash("rcs");
            for(int i = 0; i < 4; ++i)
            {
                mst_rcs.detail().name_hash()[i] = rcs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rcs);

            MinimalStructMember mst_moving_status;
            mst_moving_status.common().member_id(memberId++);
            mst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moving_status.common().member_flags().IS_OPTIONAL(false);
            mst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moving_status.common().member_flags().IS_KEY(false);
            mst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moving_status_hash("moving_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_moving_status.detail().name_hash()[i] = moving_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moving_status);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_theta;
            mst_theta.common().member_id(memberId++);
            mst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_theta.common().member_flags().IS_OPTIONAL(false);
            mst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_theta.common().member_flags().IS_KEY(false);
            mst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 theta_hash("theta");
            for(int i = 0; i < 4; ++i)
            {
                mst_theta.detail().name_hash()[i] = theta_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_theta);

            MinimalStructMember mst_absolute_position;
            mst_absolute_position.common().member_id(memberId++);
            mst_absolute_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_absolute_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_absolute_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_absolute_position.common().member_flags().IS_OPTIONAL(false);
            mst_absolute_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_absolute_position.common().member_flags().IS_KEY(false);
            mst_absolute_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_absolute_position.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 absolute_position_hash("absolute_position");
            for(int i = 0; i < 4; ++i)
            {
                mst_absolute_position.detail().name_hash()[i] = absolute_position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_absolute_position);

            MinimalStructMember mst_absolute_velocity;
            mst_absolute_velocity.common().member_id(memberId++);
            mst_absolute_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_absolute_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_absolute_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_absolute_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_absolute_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_absolute_velocity.common().member_flags().IS_KEY(false);
            mst_absolute_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_absolute_velocity.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(false));
            MD5 absolute_velocity_hash("absolute_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_absolute_velocity.detail().name_hash()[i] = absolute_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_absolute_velocity);

            MinimalStructMember mst_count;
            mst_count.common().member_id(memberId++);
            mst_count.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_count.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_count.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_count.common().member_flags().IS_OPTIONAL(false);
            mst_count.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_count.common().member_flags().IS_KEY(false);
            mst_count.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_count.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 count_hash("count");
            for(int i = 0; i < 4; ++i)
            {
                mst_count.detail().name_hash()[i] = count_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_count);

            MinimalStructMember mst_moving_frames_count;
            mst_moving_frames_count.common().member_id(memberId++);
            mst_moving_frames_count.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moving_frames_count.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moving_frames_count.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moving_frames_count.common().member_flags().IS_OPTIONAL(false);
            mst_moving_frames_count.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moving_frames_count.common().member_flags().IS_KEY(false);
            mst_moving_frames_count.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moving_frames_count.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moving_frames_count_hash("moving_frames_count");
            for(int i = 0; i < 4; ++i)
            {
                mst_moving_frames_count.detail().name_hash()[i] = moving_frames_count_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moving_frames_count);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RadarObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RadarObstacle", false);
        }

        const TypeObject* GetCompleteRadarObstacleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RadarObstacle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_relative_position;
            cst_relative_position.common().member_id(memberId++);
            cst_relative_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_relative_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_relative_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_relative_position.common().member_flags().IS_OPTIONAL(false);
            cst_relative_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_relative_position.common().member_flags().IS_KEY(false);
            cst_relative_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_relative_position.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_relative_position.detail().name("relative_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_relative_position);

            CompleteStructMember cst_relative_velocity;
            cst_relative_velocity.common().member_id(memberId++);
            cst_relative_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_relative_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_relative_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_relative_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_relative_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_relative_velocity.common().member_flags().IS_KEY(false);
            cst_relative_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_relative_velocity.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_relative_velocity.detail().name("relative_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_relative_velocity);

            CompleteStructMember cst_rcs;
            cst_rcs.common().member_id(memberId++);
            cst_rcs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rcs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rcs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rcs.common().member_flags().IS_OPTIONAL(false);
            cst_rcs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rcs.common().member_flags().IS_KEY(false);
            cst_rcs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rcs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rcs.detail().name("rcs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rcs);

            CompleteStructMember cst_moving_status;
            cst_moving_status.common().member_id(memberId++);
            cst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moving_status.common().member_flags().IS_OPTIONAL(false);
            cst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moving_status.common().member_flags().IS_KEY(false);
            cst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moving_status.detail().name("moving_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moving_status);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_theta;
            cst_theta.common().member_id(memberId++);
            cst_theta.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_theta.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_theta.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_theta.common().member_flags().IS_OPTIONAL(false);
            cst_theta.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_theta.common().member_flags().IS_KEY(false);
            cst_theta.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_theta.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_theta.detail().name("theta");

            type_object->complete().struct_type().member_seq().emplace_back(cst_theta);

            CompleteStructMember cst_absolute_position;
            cst_absolute_position.common().member_id(memberId++);
            cst_absolute_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_absolute_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_absolute_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_absolute_position.common().member_flags().IS_OPTIONAL(false);
            cst_absolute_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_absolute_position.common().member_flags().IS_KEY(false);
            cst_absolute_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_absolute_position.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_absolute_position.detail().name("absolute_position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_absolute_position);

            CompleteStructMember cst_absolute_velocity;
            cst_absolute_velocity.common().member_id(memberId++);
            cst_absolute_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_absolute_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_absolute_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_absolute_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_absolute_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_absolute_velocity.common().member_flags().IS_KEY(false);
            cst_absolute_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_absolute_velocity.common().member_type_id(*ros2_interface::msg::GetPoint2DIdentifier(true));
            cst_absolute_velocity.detail().name("absolute_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_absolute_velocity);

            CompleteStructMember cst_count;
            cst_count.common().member_id(memberId++);
            cst_count.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_count.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_count.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_count.common().member_flags().IS_OPTIONAL(false);
            cst_count.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_count.common().member_flags().IS_KEY(false);
            cst_count.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_count.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_count.detail().name("count");

            type_object->complete().struct_type().member_seq().emplace_back(cst_count);

            CompleteStructMember cst_moving_frames_count;
            cst_moving_frames_count.common().member_id(memberId++);
            cst_moving_frames_count.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moving_frames_count.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moving_frames_count.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moving_frames_count.common().member_flags().IS_OPTIONAL(false);
            cst_moving_frames_count.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moving_frames_count.common().member_flags().IS_KEY(false);
            cst_moving_frames_count.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moving_frames_count.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moving_frames_count.detail().name("moving_frames_count");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moving_frames_count);


            // Header
            type_object->complete().struct_type().header().detail().type_name("RadarObstacle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RadarObstacle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RadarObstacle", true);
        }

    } // namespace msg
} // namespace ros2_interface