// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Region.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Region.h"
#include "RegionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Region_max_cdr_typesize 2424ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Region_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Region::Region()
{
    // long m_name_region
    m_name_region = 0;
    // double m_score
    m_score = 0.0;
    // long m_rank_risk
    m_rank_risk = 0;
    // sequence<ros2_interface::msg::Point3D> m_region_polygon


    // Just to register all known types
    registerRegionTypes();
}

ros2_interface::msg::Region::~Region()
{




}

ros2_interface::msg::Region::Region(
        const Region& x)
{
    m_name_region = x.m_name_region;
    m_score = x.m_score;
    m_rank_risk = x.m_rank_risk;
    m_region_polygon = x.m_region_polygon;
}

ros2_interface::msg::Region::Region(
        Region&& x) noexcept 
{
    m_name_region = x.m_name_region;
    m_score = x.m_score;
    m_rank_risk = x.m_rank_risk;
    m_region_polygon = std::move(x.m_region_polygon);
}

ros2_interface::msg::Region& ros2_interface::msg::Region::operator =(
        const Region& x)
{

    m_name_region = x.m_name_region;
    m_score = x.m_score;
    m_rank_risk = x.m_rank_risk;
    m_region_polygon = x.m_region_polygon;

    return *this;
}

ros2_interface::msg::Region& ros2_interface::msg::Region::operator =(
        Region&& x) noexcept
{

    m_name_region = x.m_name_region;
    m_score = x.m_score;
    m_rank_risk = x.m_rank_risk;
    m_region_polygon = std::move(x.m_region_polygon);

    return *this;
}

bool ros2_interface::msg::Region::operator ==(
        const Region& x) const
{

    return (m_name_region == x.m_name_region && m_score == x.m_score && m_rank_risk == x.m_rank_risk && m_region_polygon == x.m_region_polygon);
}

bool ros2_interface::msg::Region::operator !=(
        const Region& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Region::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Region_max_cdr_typesize;
}

size_t ros2_interface::msg::Region::getCdrSerializedSize(
        const ros2_interface::msg::Region& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.region_polygon().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.region_polygon().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Region::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_name_region;
    scdr << m_score;
    scdr << m_rank_risk;
    scdr << m_region_polygon;

}

void ros2_interface::msg::Region::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_name_region;
    dcdr >> m_score;
    dcdr >> m_rank_risk;
    dcdr >> m_region_polygon;
}

/*!
 * @brief This function sets a value in member name_region
 * @param _name_region New value for member name_region
 */
void ros2_interface::msg::Region::name_region(
        int32_t _name_region)
{
    m_name_region = _name_region;
}

/*!
 * @brief This function returns the value of member name_region
 * @return Value of member name_region
 */
int32_t ros2_interface::msg::Region::name_region() const
{
    return m_name_region;
}

/*!
 * @brief This function returns a reference to member name_region
 * @return Reference to member name_region
 */
int32_t& ros2_interface::msg::Region::name_region()
{
    return m_name_region;
}

/*!
 * @brief This function sets a value in member score
 * @param _score New value for member score
 */
void ros2_interface::msg::Region::score(
        double _score)
{
    m_score = _score;
}

/*!
 * @brief This function returns the value of member score
 * @return Value of member score
 */
double ros2_interface::msg::Region::score() const
{
    return m_score;
}

/*!
 * @brief This function returns a reference to member score
 * @return Reference to member score
 */
double& ros2_interface::msg::Region::score()
{
    return m_score;
}

/*!
 * @brief This function sets a value in member rank_risk
 * @param _rank_risk New value for member rank_risk
 */
void ros2_interface::msg::Region::rank_risk(
        int32_t _rank_risk)
{
    m_rank_risk = _rank_risk;
}

/*!
 * @brief This function returns the value of member rank_risk
 * @return Value of member rank_risk
 */
int32_t ros2_interface::msg::Region::rank_risk() const
{
    return m_rank_risk;
}

/*!
 * @brief This function returns a reference to member rank_risk
 * @return Reference to member rank_risk
 */
int32_t& ros2_interface::msg::Region::rank_risk()
{
    return m_rank_risk;
}

/*!
 * @brief This function copies the value in member region_polygon
 * @param _region_polygon New value to be copied in member region_polygon
 */
void ros2_interface::msg::Region::region_polygon(
        const std::vector<ros2_interface::msg::Point3D>& _region_polygon)
{
    m_region_polygon = _region_polygon;
}

/*!
 * @brief This function moves the value in member region_polygon
 * @param _region_polygon New value to be moved in member region_polygon
 */
void ros2_interface::msg::Region::region_polygon(
        std::vector<ros2_interface::msg::Point3D>&& _region_polygon)
{
    m_region_polygon = std::move(_region_polygon);
}

/*!
 * @brief This function returns a constant reference to member region_polygon
 * @return Constant reference to member region_polygon
 */
const std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Region::region_polygon() const
{
    return m_region_polygon;
}

/*!
 * @brief This function returns a reference to member region_polygon
 * @return Reference to member region_polygon
 */
std::vector<ros2_interface::msg::Point3D>& ros2_interface::msg::Region::region_polygon()
{
    return m_region_polygon;
}


size_t ros2_interface::msg::Region::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Region_max_key_cdr_typesize;
}

bool ros2_interface::msg::Region::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Region::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



