// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Region.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_REGION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_REGION_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(REGION_SOURCE)
#define REGION_DllAPI __declspec( dllexport )
#else
#define REGION_DllAPI __declspec( dllimport )
#endif // REGION_SOURCE
#else
#define REGION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define REGION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Region defined by the user in the IDL file.
         * @ingroup Region
         */
        class Region
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Region();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Region();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Region that will be copied.
             */
            eProsima_user_DllExport Region(
                    const Region& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Region that will be copied.
             */
            eProsima_user_DllExport Region(
                    Region&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Region that will be copied.
             */
            eProsima_user_DllExport Region& operator =(
                    const Region& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Region that will be copied.
             */
            eProsima_user_DllExport Region& operator =(
                    Region&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Region object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Region& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Region object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Region& x) const;

            /*!
             * @brief This function sets a value in member name_region
             * @param _name_region New value for member name_region
             */
            eProsima_user_DllExport void name_region(
                    int32_t _name_region);

            /*!
             * @brief This function returns the value of member name_region
             * @return Value of member name_region
             */
            eProsima_user_DllExport int32_t name_region() const;

            /*!
             * @brief This function returns a reference to member name_region
             * @return Reference to member name_region
             */
            eProsima_user_DllExport int32_t& name_region();

            /*!
             * @brief This function sets a value in member score
             * @param _score New value for member score
             */
            eProsima_user_DllExport void score(
                    double _score);

            /*!
             * @brief This function returns the value of member score
             * @return Value of member score
             */
            eProsima_user_DllExport double score() const;

            /*!
             * @brief This function returns a reference to member score
             * @return Reference to member score
             */
            eProsima_user_DllExport double& score();

            /*!
             * @brief This function sets a value in member rank_risk
             * @param _rank_risk New value for member rank_risk
             */
            eProsima_user_DllExport void rank_risk(
                    int32_t _rank_risk);

            /*!
             * @brief This function returns the value of member rank_risk
             * @return Value of member rank_risk
             */
            eProsima_user_DllExport int32_t rank_risk() const;

            /*!
             * @brief This function returns a reference to member rank_risk
             * @return Reference to member rank_risk
             */
            eProsima_user_DllExport int32_t& rank_risk();

            /*!
             * @brief This function copies the value in member region_polygon
             * @param _region_polygon New value to be copied in member region_polygon
             */
            eProsima_user_DllExport void region_polygon(
                    const std::vector<ros2_interface::msg::Point3D>& _region_polygon);

            /*!
             * @brief This function moves the value in member region_polygon
             * @param _region_polygon New value to be moved in member region_polygon
             */
            eProsima_user_DllExport void region_polygon(
                    std::vector<ros2_interface::msg::Point3D>&& _region_polygon);

            /*!
             * @brief This function returns a constant reference to member region_polygon
             * @return Constant reference to member region_polygon
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Point3D>& region_polygon() const;

            /*!
             * @brief This function returns a reference to member region_polygon
             * @return Reference to member region_polygon
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Point3D>& region_polygon();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Region& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_name_region;
            double m_score;
            int32_t m_rank_risk;
            std::vector<ros2_interface::msg::Point3D> m_region_polygon;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_REGION_H_

