// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RegionTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Region.h"
#include "RegionTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRegionTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Region", ros2_interface::msg::GetRegionIdentifier(true),
                        ros2_interface::msg::GetRegionObject(true));
                factory->add_type_object("ros2_interface::msg::Region", ros2_interface::msg::GetRegionIdentifier(false),
                        ros2_interface::msg::GetRegionObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRegionIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Region", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRegionObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Region", complete);
        }

        const TypeObject* GetRegionObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Region", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRegionObject();
            }
            //else
            return GetMinimalRegionObject();
        }

        const TypeObject* GetMinimalRegionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Region", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_name_region;
            mst_name_region.common().member_id(memberId++);
            mst_name_region.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_name_region.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_name_region.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_name_region.common().member_flags().IS_OPTIONAL(false);
            mst_name_region.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_name_region.common().member_flags().IS_KEY(false);
            mst_name_region.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_name_region.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 name_region_hash("name_region");
            for(int i = 0; i < 4; ++i)
            {
                mst_name_region.detail().name_hash()[i] = name_region_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_name_region);

            MinimalStructMember mst_score;
            mst_score.common().member_id(memberId++);
            mst_score.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_score.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_score.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_score.common().member_flags().IS_OPTIONAL(false);
            mst_score.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_score.common().member_flags().IS_KEY(false);
            mst_score.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_score.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 score_hash("score");
            for(int i = 0; i < 4; ++i)
            {
                mst_score.detail().name_hash()[i] = score_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_score);

            MinimalStructMember mst_rank_risk;
            mst_rank_risk.common().member_id(memberId++);
            mst_rank_risk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rank_risk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rank_risk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rank_risk.common().member_flags().IS_OPTIONAL(false);
            mst_rank_risk.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rank_risk.common().member_flags().IS_KEY(false);
            mst_rank_risk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rank_risk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rank_risk_hash("rank_risk");
            for(int i = 0; i < 4; ++i)
            {
                mst_rank_risk.detail().name_hash()[i] = rank_risk_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rank_risk);

            MinimalStructMember mst_region_polygon;
            mst_region_polygon.common().member_id(memberId++);
            mst_region_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_region_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_region_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_region_polygon.common().member_flags().IS_OPTIONAL(false);
            mst_region_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_region_polygon.common().member_flags().IS_KEY(false);
            mst_region_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_region_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, false));


            MD5 region_polygon_hash("region_polygon");
            for(int i = 0; i < 4; ++i)
            {
                mst_region_polygon.detail().name_hash()[i] = region_polygon_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_region_polygon);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Region", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Region", false);
        }

        const TypeObject* GetCompleteRegionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Region", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_name_region;
            cst_name_region.common().member_id(memberId++);
            cst_name_region.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_name_region.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_name_region.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_name_region.common().member_flags().IS_OPTIONAL(false);
            cst_name_region.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_name_region.common().member_flags().IS_KEY(false);
            cst_name_region.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_name_region.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_name_region.detail().name("name_region");

            type_object->complete().struct_type().member_seq().emplace_back(cst_name_region);

            CompleteStructMember cst_score;
            cst_score.common().member_id(memberId++);
            cst_score.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_score.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_score.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_score.common().member_flags().IS_OPTIONAL(false);
            cst_score.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_score.common().member_flags().IS_KEY(false);
            cst_score.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_score.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_score.detail().name("score");

            type_object->complete().struct_type().member_seq().emplace_back(cst_score);

            CompleteStructMember cst_rank_risk;
            cst_rank_risk.common().member_id(memberId++);
            cst_rank_risk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rank_risk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rank_risk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rank_risk.common().member_flags().IS_OPTIONAL(false);
            cst_rank_risk.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rank_risk.common().member_flags().IS_KEY(false);
            cst_rank_risk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rank_risk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rank_risk.detail().name("rank_risk");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rank_risk);

            CompleteStructMember cst_region_polygon;
            cst_region_polygon.common().member_id(memberId++);
            cst_region_polygon.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_region_polygon.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_region_polygon.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_region_polygon.common().member_flags().IS_OPTIONAL(false);
            cst_region_polygon.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_region_polygon.common().member_flags().IS_KEY(false);
            cst_region_polygon.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_region_polygon.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::Point3D", 100, true));


            cst_region_polygon.detail().name("region_polygon");

            type_object->complete().struct_type().member_seq().emplace_back(cst_region_polygon);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Region");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Region", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Region", true);
        }

    } // namespace msg
} // namespace ros2_interface