// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoadMark.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RoadMark.h"
#include "RoadMarkTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_RoadMark_max_cdr_typesize 52ULL;
#define ros2_interface_msg_RoadMark_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RoadMark::RoadMark()
{
    // double m_longitude_dist
    m_longitude_dist = 0.0;
    // double m_lateral_dist
    m_lateral_dist = 0.0;
    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_z
    m_z = 0.0;
    // double m_confidence
    m_confidence = 0.0;
    // long m_type
    m_type = 0;

    // Just to register all known types
    registerRoadMarkTypes();
}

ros2_interface::msg::RoadMark::~RoadMark()
{







}

ros2_interface::msg::RoadMark::RoadMark(
        const RoadMark& x)
{
    m_longitude_dist = x.m_longitude_dist;
    m_lateral_dist = x.m_lateral_dist;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_confidence = x.m_confidence;
    m_type = x.m_type;
}

ros2_interface::msg::RoadMark::RoadMark(
        RoadMark&& x) noexcept 
{
    m_longitude_dist = x.m_longitude_dist;
    m_lateral_dist = x.m_lateral_dist;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_confidence = x.m_confidence;
    m_type = x.m_type;
}

ros2_interface::msg::RoadMark& ros2_interface::msg::RoadMark::operator =(
        const RoadMark& x)
{

    m_longitude_dist = x.m_longitude_dist;
    m_lateral_dist = x.m_lateral_dist;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_confidence = x.m_confidence;
    m_type = x.m_type;

    return *this;
}

ros2_interface::msg::RoadMark& ros2_interface::msg::RoadMark::operator =(
        RoadMark&& x) noexcept
{

    m_longitude_dist = x.m_longitude_dist;
    m_lateral_dist = x.m_lateral_dist;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_confidence = x.m_confidence;
    m_type = x.m_type;

    return *this;
}

bool ros2_interface::msg::RoadMark::operator ==(
        const RoadMark& x) const
{

    return (m_longitude_dist == x.m_longitude_dist && m_lateral_dist == x.m_lateral_dist && m_x == x.m_x && m_y == x.m_y && m_z == x.m_z && m_confidence == x.m_confidence && m_type == x.m_type);
}

bool ros2_interface::msg::RoadMark::operator !=(
        const RoadMark& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RoadMark::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoadMark_max_cdr_typesize;
}

size_t ros2_interface::msg::RoadMark::getCdrSerializedSize(
        const ros2_interface::msg::RoadMark& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RoadMark::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_longitude_dist;
    scdr << m_lateral_dist;
    scdr << m_x;
    scdr << m_y;
    scdr << m_z;
    scdr << m_confidence;
    scdr << m_type;

}

void ros2_interface::msg::RoadMark::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_longitude_dist;
    dcdr >> m_lateral_dist;
    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_z;
    dcdr >> m_confidence;
    dcdr >> m_type;
}

/*!
 * @brief This function sets a value in member longitude_dist
 * @param _longitude_dist New value for member longitude_dist
 */
void ros2_interface::msg::RoadMark::longitude_dist(
        double _longitude_dist)
{
    m_longitude_dist = _longitude_dist;
}

/*!
 * @brief This function returns the value of member longitude_dist
 * @return Value of member longitude_dist
 */
double ros2_interface::msg::RoadMark::longitude_dist() const
{
    return m_longitude_dist;
}

/*!
 * @brief This function returns a reference to member longitude_dist
 * @return Reference to member longitude_dist
 */
double& ros2_interface::msg::RoadMark::longitude_dist()
{
    return m_longitude_dist;
}

/*!
 * @brief This function sets a value in member lateral_dist
 * @param _lateral_dist New value for member lateral_dist
 */
void ros2_interface::msg::RoadMark::lateral_dist(
        double _lateral_dist)
{
    m_lateral_dist = _lateral_dist;
}

/*!
 * @brief This function returns the value of member lateral_dist
 * @return Value of member lateral_dist
 */
double ros2_interface::msg::RoadMark::lateral_dist() const
{
    return m_lateral_dist;
}

/*!
 * @brief This function returns a reference to member lateral_dist
 * @return Reference to member lateral_dist
 */
double& ros2_interface::msg::RoadMark::lateral_dist()
{
    return m_lateral_dist;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::RoadMark::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::RoadMark::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::RoadMark::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::RoadMark::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::RoadMark::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::RoadMark::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member z
 * @param _z New value for member z
 */
void ros2_interface::msg::RoadMark::z(
        double _z)
{
    m_z = _z;
}

/*!
 * @brief This function returns the value of member z
 * @return Value of member z
 */
double ros2_interface::msg::RoadMark::z() const
{
    return m_z;
}

/*!
 * @brief This function returns a reference to member z
 * @return Reference to member z
 */
double& ros2_interface::msg::RoadMark::z()
{
    return m_z;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::RoadMark::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::RoadMark::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::RoadMark::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::RoadMark::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::RoadMark::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::RoadMark::type()
{
    return m_type;
}



size_t ros2_interface::msg::RoadMark::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoadMark_max_key_cdr_typesize;
}

bool ros2_interface::msg::RoadMark::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RoadMark::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



