// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoadMark.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROADMARK_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROADMARK_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(ROADMARK_SOURCE)
#define ROADMARK_DllAPI __declspec( dllexport )
#else
#define ROADMARK_DllAPI __declspec( dllimport )
#endif // ROADMARK_SOURCE
#else
#define ROADMARK_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define ROADMARK_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RoadMark defined by the user in the IDL file.
         * @ingroup RoadMark
         */
        class RoadMark
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RoadMark();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RoadMark();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RoadMark that will be copied.
             */
            eProsima_user_DllExport RoadMark(
                    const RoadMark& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RoadMark that will be copied.
             */
            eProsima_user_DllExport RoadMark(
                    RoadMark&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RoadMark that will be copied.
             */
            eProsima_user_DllExport RoadMark& operator =(
                    const RoadMark& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RoadMark that will be copied.
             */
            eProsima_user_DllExport RoadMark& operator =(
                    RoadMark&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoadMark object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RoadMark& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoadMark object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RoadMark& x) const;

            /*!
             * @brief This function sets a value in member longitude_dist
             * @param _longitude_dist New value for member longitude_dist
             */
            eProsima_user_DllExport void longitude_dist(
                    double _longitude_dist);

            /*!
             * @brief This function returns the value of member longitude_dist
             * @return Value of member longitude_dist
             */
            eProsima_user_DllExport double longitude_dist() const;

            /*!
             * @brief This function returns a reference to member longitude_dist
             * @return Reference to member longitude_dist
             */
            eProsima_user_DllExport double& longitude_dist();

            /*!
             * @brief This function sets a value in member lateral_dist
             * @param _lateral_dist New value for member lateral_dist
             */
            eProsima_user_DllExport void lateral_dist(
                    double _lateral_dist);

            /*!
             * @brief This function returns the value of member lateral_dist
             * @return Value of member lateral_dist
             */
            eProsima_user_DllExport double lateral_dist() const;

            /*!
             * @brief This function returns a reference to member lateral_dist
             * @return Reference to member lateral_dist
             */
            eProsima_user_DllExport double& lateral_dist();

            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    double _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport double x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport double& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    double _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport double y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport double& y();

            /*!
             * @brief This function sets a value in member z
             * @param _z New value for member z
             */
            eProsima_user_DllExport void z(
                    double _z);

            /*!
             * @brief This function returns the value of member z
             * @return Value of member z
             */
            eProsima_user_DllExport double z() const;

            /*!
             * @brief This function returns a reference to member z
             * @return Reference to member z
             */
            eProsima_user_DllExport double& z();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RoadMark& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_longitude_dist;
            double m_lateral_dist;
            double m_x;
            double m_y;
            double m_z;
            double m_confidence;
            int32_t m_type;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROADMARK_H_

