// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoadMarkList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RoadMarkList.h"
#include "RoadMarkListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_RoadMark_max_cdr_typesize 52ULL;
#define ros2_interface_msg_RoadMarkList_max_cdr_typesize 5885ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RoadMark_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RoadMarkList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RoadMarkList::RoadMarkList()
{
    // ros2_interface::msg::Header m_header

    // long m_sensor_id
    m_sensor_id = 0;
    // uint8 m_sensor_status
    m_sensor_status = 0;
    // sequence<ros2_interface::msg::RoadMark> m_roadmarks

    // boolean m_is_valid
    m_is_valid = false;

    // Just to register all known types
    registerRoadMarkListTypes();
}

ros2_interface::msg::RoadMarkList::~RoadMarkList()
{





}

ros2_interface::msg::RoadMarkList::RoadMarkList(
        const RoadMarkList& x)
{
    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_sensor_status = x.m_sensor_status;
    m_roadmarks = x.m_roadmarks;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::RoadMarkList::RoadMarkList(
        RoadMarkList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_sensor_status = x.m_sensor_status;
    m_roadmarks = std::move(x.m_roadmarks);
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::RoadMarkList& ros2_interface::msg::RoadMarkList::operator =(
        const RoadMarkList& x)
{

    m_header = x.m_header;
    m_sensor_id = x.m_sensor_id;
    m_sensor_status = x.m_sensor_status;
    m_roadmarks = x.m_roadmarks;
    m_is_valid = x.m_is_valid;

    return *this;
}

ros2_interface::msg::RoadMarkList& ros2_interface::msg::RoadMarkList::operator =(
        RoadMarkList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_sensor_id = x.m_sensor_id;
    m_sensor_status = x.m_sensor_status;
    m_roadmarks = std::move(x.m_roadmarks);
    m_is_valid = x.m_is_valid;

    return *this;
}

bool ros2_interface::msg::RoadMarkList::operator ==(
        const RoadMarkList& x) const
{

    return (m_header == x.m_header && m_sensor_id == x.m_sensor_id && m_sensor_status == x.m_sensor_status && m_roadmarks == x.m_roadmarks && m_is_valid == x.m_is_valid);
}

bool ros2_interface::msg::RoadMarkList::operator !=(
        const RoadMarkList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RoadMarkList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoadMarkList_max_cdr_typesize;
}

size_t ros2_interface::msg::RoadMarkList::getCdrSerializedSize(
        const ros2_interface::msg::RoadMarkList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.roadmarks().size(); ++a)
    {
        current_alignment += ros2_interface::msg::RoadMark::getCdrSerializedSize(data.roadmarks().at(a), current_alignment);}

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RoadMarkList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_sensor_id;
    scdr << m_sensor_status;
    scdr << m_roadmarks;
    scdr << m_is_valid;

}

void ros2_interface::msg::RoadMarkList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_sensor_id;
    dcdr >> m_sensor_status;
    dcdr >> m_roadmarks;
    dcdr >> m_is_valid;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::RoadMarkList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::RoadMarkList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::RoadMarkList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::RoadMarkList::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member sensor_id
 * @param _sensor_id New value for member sensor_id
 */
void ros2_interface::msg::RoadMarkList::sensor_id(
        int32_t _sensor_id)
{
    m_sensor_id = _sensor_id;
}

/*!
 * @brief This function returns the value of member sensor_id
 * @return Value of member sensor_id
 */
int32_t ros2_interface::msg::RoadMarkList::sensor_id() const
{
    return m_sensor_id;
}

/*!
 * @brief This function returns a reference to member sensor_id
 * @return Reference to member sensor_id
 */
int32_t& ros2_interface::msg::RoadMarkList::sensor_id()
{
    return m_sensor_id;
}

/*!
 * @brief This function sets a value in member sensor_status
 * @param _sensor_status New value for member sensor_status
 */
void ros2_interface::msg::RoadMarkList::sensor_status(
        uint8_t _sensor_status)
{
    m_sensor_status = _sensor_status;
}

/*!
 * @brief This function returns the value of member sensor_status
 * @return Value of member sensor_status
 */
uint8_t ros2_interface::msg::RoadMarkList::sensor_status() const
{
    return m_sensor_status;
}

/*!
 * @brief This function returns a reference to member sensor_status
 * @return Reference to member sensor_status
 */
uint8_t& ros2_interface::msg::RoadMarkList::sensor_status()
{
    return m_sensor_status;
}

/*!
 * @brief This function copies the value in member roadmarks
 * @param _roadmarks New value to be copied in member roadmarks
 */
void ros2_interface::msg::RoadMarkList::roadmarks(
        const std::vector<ros2_interface::msg::RoadMark>& _roadmarks)
{
    m_roadmarks = _roadmarks;
}

/*!
 * @brief This function moves the value in member roadmarks
 * @param _roadmarks New value to be moved in member roadmarks
 */
void ros2_interface::msg::RoadMarkList::roadmarks(
        std::vector<ros2_interface::msg::RoadMark>&& _roadmarks)
{
    m_roadmarks = std::move(_roadmarks);
}

/*!
 * @brief This function returns a constant reference to member roadmarks
 * @return Constant reference to member roadmarks
 */
const std::vector<ros2_interface::msg::RoadMark>& ros2_interface::msg::RoadMarkList::roadmarks() const
{
    return m_roadmarks;
}

/*!
 * @brief This function returns a reference to member roadmarks
 * @return Reference to member roadmarks
 */
std::vector<ros2_interface::msg::RoadMark>& ros2_interface::msg::RoadMarkList::roadmarks()
{
    return m_roadmarks;
}
/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::RoadMarkList::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::RoadMarkList::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::RoadMarkList::is_valid()
{
    return m_is_valid;
}



size_t ros2_interface::msg::RoadMarkList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoadMarkList_max_key_cdr_typesize;
}

bool ros2_interface::msg::RoadMarkList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RoadMarkList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



