// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoadMarkTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "RoadMark.h"
#include "RoadMarkTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRoadMarkTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::RoadMark", ros2_interface::msg::GetRoadMarkIdentifier(true),
                        ros2_interface::msg::GetRoadMarkObject(true));
                factory->add_type_object("ros2_interface::msg::RoadMark", ros2_interface::msg::GetRoadMarkIdentifier(false),
                        ros2_interface::msg::GetRoadMarkObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRoadMarkIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("RoadMark", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRoadMarkObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("RoadMark", complete);
        }

        const TypeObject* GetRoadMarkObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoadMark", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRoadMarkObject();
            }
            //else
            return GetMinimalRoadMarkObject();
        }

        const TypeObject* GetMinimalRoadMarkObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoadMark", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_longitude_dist;
            mst_longitude_dist.common().member_id(memberId++);
            mst_longitude_dist.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_longitude_dist.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_longitude_dist.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_longitude_dist.common().member_flags().IS_OPTIONAL(false);
            mst_longitude_dist.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_longitude_dist.common().member_flags().IS_KEY(false);
            mst_longitude_dist.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_longitude_dist.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 longitude_dist_hash("longitude_dist");
            for(int i = 0; i < 4; ++i)
            {
                mst_longitude_dist.detail().name_hash()[i] = longitude_dist_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_longitude_dist);

            MinimalStructMember mst_lateral_dist;
            mst_lateral_dist.common().member_id(memberId++);
            mst_lateral_dist.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lateral_dist.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lateral_dist.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lateral_dist.common().member_flags().IS_OPTIONAL(false);
            mst_lateral_dist.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lateral_dist.common().member_flags().IS_KEY(false);
            mst_lateral_dist.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lateral_dist.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lateral_dist_hash("lateral_dist");
            for(int i = 0; i < 4; ++i)
            {
                mst_lateral_dist.detail().name_hash()[i] = lateral_dist_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lateral_dist);

            MinimalStructMember mst_x;
            mst_x.common().member_id(memberId++);
            mst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_x.common().member_flags().IS_OPTIONAL(false);
            mst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_x.common().member_flags().IS_KEY(false);
            mst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 x_hash("x");
            for(int i = 0; i < 4; ++i)
            {
                mst_x.detail().name_hash()[i] = x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_x);

            MinimalStructMember mst_y;
            mst_y.common().member_id(memberId++);
            mst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_y.common().member_flags().IS_OPTIONAL(false);
            mst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_y.common().member_flags().IS_KEY(false);
            mst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 y_hash("y");
            for(int i = 0; i < 4; ++i)
            {
                mst_y.detail().name_hash()[i] = y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_y);

            MinimalStructMember mst_z;
            mst_z.common().member_id(memberId++);
            mst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_z.common().member_flags().IS_OPTIONAL(false);
            mst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_z.common().member_flags().IS_KEY(false);
            mst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 z_hash("z");
            for(int i = 0; i < 4; ++i)
            {
                mst_z.detail().name_hash()[i] = z_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_z);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoadMark", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoadMark", false);
        }

        const TypeObject* GetCompleteRoadMarkObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoadMark", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_longitude_dist;
            cst_longitude_dist.common().member_id(memberId++);
            cst_longitude_dist.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_longitude_dist.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_longitude_dist.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_longitude_dist.common().member_flags().IS_OPTIONAL(false);
            cst_longitude_dist.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_longitude_dist.common().member_flags().IS_KEY(false);
            cst_longitude_dist.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_longitude_dist.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_longitude_dist.detail().name("longitude_dist");

            type_object->complete().struct_type().member_seq().emplace_back(cst_longitude_dist);

            CompleteStructMember cst_lateral_dist;
            cst_lateral_dist.common().member_id(memberId++);
            cst_lateral_dist.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lateral_dist.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lateral_dist.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lateral_dist.common().member_flags().IS_OPTIONAL(false);
            cst_lateral_dist.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lateral_dist.common().member_flags().IS_KEY(false);
            cst_lateral_dist.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lateral_dist.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lateral_dist.detail().name("lateral_dist");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lateral_dist);

            CompleteStructMember cst_x;
            cst_x.common().member_id(memberId++);
            cst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_x.common().member_flags().IS_OPTIONAL(false);
            cst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_x.common().member_flags().IS_KEY(false);
            cst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_x.detail().name("x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_x);

            CompleteStructMember cst_y;
            cst_y.common().member_id(memberId++);
            cst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_y.common().member_flags().IS_OPTIONAL(false);
            cst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_y.common().member_flags().IS_KEY(false);
            cst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_y.detail().name("y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_y);

            CompleteStructMember cst_z;
            cst_z.common().member_id(memberId++);
            cst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_z.common().member_flags().IS_OPTIONAL(false);
            cst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_z.common().member_flags().IS_KEY(false);
            cst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_z.detail().name("z");

            type_object->complete().struct_type().member_seq().emplace_back(cst_z);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);


            // Header
            type_object->complete().struct_type().header().detail().type_name("RoadMark");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoadMark", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoadMark", true);
        }

    } // namespace msg
} // namespace ros2_interface