// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RouteFusionInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RouteFusionInfo.h"
#include "RouteFusionInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_RouteFusionInfo_max_cdr_typesize 264ULL;
#define ros2_interface_msg_RouteFusionInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RouteFusionInfo::RouteFusionInfo()
{
    // long m_fusion_flag
    m_fusion_flag = 0;
    // string m_fusion_reason
    m_fusion_reason ="";

    // Just to register all known types
    registerRouteFusionInfoTypes();
}

ros2_interface::msg::RouteFusionInfo::~RouteFusionInfo()
{


}

ros2_interface::msg::RouteFusionInfo::RouteFusionInfo(
        const RouteFusionInfo& x)
{
    m_fusion_flag = x.m_fusion_flag;
    m_fusion_reason = x.m_fusion_reason;
}

ros2_interface::msg::RouteFusionInfo::RouteFusionInfo(
        RouteFusionInfo&& x) noexcept 
{
    m_fusion_flag = x.m_fusion_flag;
    m_fusion_reason = std::move(x.m_fusion_reason);
}

ros2_interface::msg::RouteFusionInfo& ros2_interface::msg::RouteFusionInfo::operator =(
        const RouteFusionInfo& x)
{

    m_fusion_flag = x.m_fusion_flag;
    m_fusion_reason = x.m_fusion_reason;

    return *this;
}

ros2_interface::msg::RouteFusionInfo& ros2_interface::msg::RouteFusionInfo::operator =(
        RouteFusionInfo&& x) noexcept
{

    m_fusion_flag = x.m_fusion_flag;
    m_fusion_reason = std::move(x.m_fusion_reason);

    return *this;
}

bool ros2_interface::msg::RouteFusionInfo::operator ==(
        const RouteFusionInfo& x) const
{

    return (m_fusion_flag == x.m_fusion_flag && m_fusion_reason == x.m_fusion_reason);
}

bool ros2_interface::msg::RouteFusionInfo::operator !=(
        const RouteFusionInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RouteFusionInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RouteFusionInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::RouteFusionInfo::getCdrSerializedSize(
        const ros2_interface::msg::RouteFusionInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.fusion_reason().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RouteFusionInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_fusion_flag;
    scdr << m_fusion_reason.c_str();

}

void ros2_interface::msg::RouteFusionInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_fusion_flag;
    dcdr >> m_fusion_reason;
}

/*!
 * @brief This function sets a value in member fusion_flag
 * @param _fusion_flag New value for member fusion_flag
 */
void ros2_interface::msg::RouteFusionInfo::fusion_flag(
        int32_t _fusion_flag)
{
    m_fusion_flag = _fusion_flag;
}

/*!
 * @brief This function returns the value of member fusion_flag
 * @return Value of member fusion_flag
 */
int32_t ros2_interface::msg::RouteFusionInfo::fusion_flag() const
{
    return m_fusion_flag;
}

/*!
 * @brief This function returns a reference to member fusion_flag
 * @return Reference to member fusion_flag
 */
int32_t& ros2_interface::msg::RouteFusionInfo::fusion_flag()
{
    return m_fusion_flag;
}

/*!
 * @brief This function copies the value in member fusion_reason
 * @param _fusion_reason New value to be copied in member fusion_reason
 */
void ros2_interface::msg::RouteFusionInfo::fusion_reason(
        const std::string& _fusion_reason)
{
    m_fusion_reason = _fusion_reason;
}

/*!
 * @brief This function moves the value in member fusion_reason
 * @param _fusion_reason New value to be moved in member fusion_reason
 */
void ros2_interface::msg::RouteFusionInfo::fusion_reason(
        std::string&& _fusion_reason)
{
    m_fusion_reason = std::move(_fusion_reason);
}

/*!
 * @brief This function returns a constant reference to member fusion_reason
 * @return Constant reference to member fusion_reason
 */
const std::string& ros2_interface::msg::RouteFusionInfo::fusion_reason() const
{
    return m_fusion_reason;
}

/*!
 * @brief This function returns a reference to member fusion_reason
 * @return Reference to member fusion_reason
 */
std::string& ros2_interface::msg::RouteFusionInfo::fusion_reason()
{
    return m_fusion_reason;
}


size_t ros2_interface::msg::RouteFusionInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RouteFusionInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::RouteFusionInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RouteFusionInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



