// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RouteFusionInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTEFUSIONINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTEFUSIONINFO_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(ROUTEFUSIONINFO_SOURCE)
#define ROUTEFUSIONINFO_DllAPI __declspec( dllexport )
#else
#define ROUTEFUSIONINFO_DllAPI __declspec( dllimport )
#endif // ROUTEFUSIONINFO_SOURCE
#else
#define ROUTEFUSIONINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define ROUTEFUSIONINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RouteFusionInfo defined by the user in the IDL file.
         * @ingroup RouteFusionInfo
         */
        class RouteFusionInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RouteFusionInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RouteFusionInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RouteFusionInfo that will be copied.
             */
            eProsima_user_DllExport RouteFusionInfo(
                    const RouteFusionInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RouteFusionInfo that will be copied.
             */
            eProsima_user_DllExport RouteFusionInfo(
                    RouteFusionInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RouteFusionInfo that will be copied.
             */
            eProsima_user_DllExport RouteFusionInfo& operator =(
                    const RouteFusionInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RouteFusionInfo that will be copied.
             */
            eProsima_user_DllExport RouteFusionInfo& operator =(
                    RouteFusionInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RouteFusionInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RouteFusionInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RouteFusionInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RouteFusionInfo& x) const;

            /*!
             * @brief This function sets a value in member fusion_flag
             * @param _fusion_flag New value for member fusion_flag
             */
            eProsima_user_DllExport void fusion_flag(
                    int32_t _fusion_flag);

            /*!
             * @brief This function returns the value of member fusion_flag
             * @return Value of member fusion_flag
             */
            eProsima_user_DllExport int32_t fusion_flag() const;

            /*!
             * @brief This function returns a reference to member fusion_flag
             * @return Reference to member fusion_flag
             */
            eProsima_user_DllExport int32_t& fusion_flag();

            /*!
             * @brief This function copies the value in member fusion_reason
             * @param _fusion_reason New value to be copied in member fusion_reason
             */
            eProsima_user_DllExport void fusion_reason(
                    const std::string& _fusion_reason);

            /*!
             * @brief This function moves the value in member fusion_reason
             * @param _fusion_reason New value to be moved in member fusion_reason
             */
            eProsima_user_DllExport void fusion_reason(
                    std::string&& _fusion_reason);

            /*!
             * @brief This function returns a constant reference to member fusion_reason
             * @return Constant reference to member fusion_reason
             */
            eProsima_user_DllExport const std::string& fusion_reason() const;

            /*!
             * @brief This function returns a reference to member fusion_reason
             * @return Reference to member fusion_reason
             */
            eProsima_user_DllExport std::string& fusion_reason();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RouteFusionInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_fusion_flag;
            std::string m_fusion_reason;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTEFUSIONINFO_H_

