// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingRequest.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RoutingRequest.h"
#include "RoutingRequestTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_KeyPoint_max_cdr_typesize 300ULL;
#define ros2_interface_msg_RoutingRequest_max_cdr_typesize 30140ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_KeyPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RoutingRequest_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RoutingRequest::RoutingRequest()
{
    // ros2_interface::msg::Header m_header

    // string m_request_source
    m_request_source ="";
    // int8 m_request_type
    m_request_type = 0;
    // short m_num_of_kp
    m_num_of_kp = 0;
    // sequence<ros2_interface::msg::KeyPoint> m_key_point_list


    // Just to register all known types
    registerRoutingRequestTypes();
}

ros2_interface::msg::RoutingRequest::~RoutingRequest()
{





}

ros2_interface::msg::RoutingRequest::RoutingRequest(
        const RoutingRequest& x)
{
    m_header = x.m_header;
    m_request_source = x.m_request_source;
    m_request_type = x.m_request_type;
    m_num_of_kp = x.m_num_of_kp;
    m_key_point_list = x.m_key_point_list;
}

ros2_interface::msg::RoutingRequest::RoutingRequest(
        RoutingRequest&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_request_source = std::move(x.m_request_source);
    m_request_type = x.m_request_type;
    m_num_of_kp = x.m_num_of_kp;
    m_key_point_list = std::move(x.m_key_point_list);
}

ros2_interface::msg::RoutingRequest& ros2_interface::msg::RoutingRequest::operator =(
        const RoutingRequest& x)
{

    m_header = x.m_header;
    m_request_source = x.m_request_source;
    m_request_type = x.m_request_type;
    m_num_of_kp = x.m_num_of_kp;
    m_key_point_list = x.m_key_point_list;

    return *this;
}

ros2_interface::msg::RoutingRequest& ros2_interface::msg::RoutingRequest::operator =(
        RoutingRequest&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_request_source = std::move(x.m_request_source);
    m_request_type = x.m_request_type;
    m_num_of_kp = x.m_num_of_kp;
    m_key_point_list = std::move(x.m_key_point_list);

    return *this;
}

bool ros2_interface::msg::RoutingRequest::operator ==(
        const RoutingRequest& x) const
{

    return (m_header == x.m_header && m_request_source == x.m_request_source && m_request_type == x.m_request_type && m_num_of_kp == x.m_num_of_kp && m_key_point_list == x.m_key_point_list);
}

bool ros2_interface::msg::RoutingRequest::operator !=(
        const RoutingRequest& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RoutingRequest::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoutingRequest_max_cdr_typesize;
}

size_t ros2_interface::msg::RoutingRequest::getCdrSerializedSize(
        const ros2_interface::msg::RoutingRequest& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.request_source().size() + 1;

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 2 + eprosima::fastcdr::Cdr::alignment(current_alignment, 2);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.key_point_list().size(); ++a)
    {
        current_alignment += ros2_interface::msg::KeyPoint::getCdrSerializedSize(data.key_point_list().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RoutingRequest::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_request_source.c_str();
    scdr << m_request_type;
    scdr << m_num_of_kp;
    scdr << m_key_point_list;

}

void ros2_interface::msg::RoutingRequest::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_request_source;
    dcdr >> m_request_type;
    dcdr >> m_num_of_kp;
    dcdr >> m_key_point_list;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::RoutingRequest::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::RoutingRequest::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::RoutingRequest::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::RoutingRequest::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member request_source
 * @param _request_source New value to be copied in member request_source
 */
void ros2_interface::msg::RoutingRequest::request_source(
        const std::string& _request_source)
{
    m_request_source = _request_source;
}

/*!
 * @brief This function moves the value in member request_source
 * @param _request_source New value to be moved in member request_source
 */
void ros2_interface::msg::RoutingRequest::request_source(
        std::string&& _request_source)
{
    m_request_source = std::move(_request_source);
}

/*!
 * @brief This function returns a constant reference to member request_source
 * @return Constant reference to member request_source
 */
const std::string& ros2_interface::msg::RoutingRequest::request_source() const
{
    return m_request_source;
}

/*!
 * @brief This function returns a reference to member request_source
 * @return Reference to member request_source
 */
std::string& ros2_interface::msg::RoutingRequest::request_source()
{
    return m_request_source;
}
/*!
 * @brief This function sets a value in member request_type
 * @param _request_type New value for member request_type
 */
void ros2_interface::msg::RoutingRequest::request_type(
        int8_t _request_type)
{
    m_request_type = _request_type;
}

/*!
 * @brief This function returns the value of member request_type
 * @return Value of member request_type
 */
int8_t ros2_interface::msg::RoutingRequest::request_type() const
{
    return m_request_type;
}

/*!
 * @brief This function returns a reference to member request_type
 * @return Reference to member request_type
 */
int8_t& ros2_interface::msg::RoutingRequest::request_type()
{
    return m_request_type;
}

/*!
 * @brief This function sets a value in member num_of_kp
 * @param _num_of_kp New value for member num_of_kp
 */
void ros2_interface::msg::RoutingRequest::num_of_kp(
        int16_t _num_of_kp)
{
    m_num_of_kp = _num_of_kp;
}

/*!
 * @brief This function returns the value of member num_of_kp
 * @return Value of member num_of_kp
 */
int16_t ros2_interface::msg::RoutingRequest::num_of_kp() const
{
    return m_num_of_kp;
}

/*!
 * @brief This function returns a reference to member num_of_kp
 * @return Reference to member num_of_kp
 */
int16_t& ros2_interface::msg::RoutingRequest::num_of_kp()
{
    return m_num_of_kp;
}

/*!
 * @brief This function copies the value in member key_point_list
 * @param _key_point_list New value to be copied in member key_point_list
 */
void ros2_interface::msg::RoutingRequest::key_point_list(
        const std::vector<ros2_interface::msg::KeyPoint>& _key_point_list)
{
    m_key_point_list = _key_point_list;
}

/*!
 * @brief This function moves the value in member key_point_list
 * @param _key_point_list New value to be moved in member key_point_list
 */
void ros2_interface::msg::RoutingRequest::key_point_list(
        std::vector<ros2_interface::msg::KeyPoint>&& _key_point_list)
{
    m_key_point_list = std::move(_key_point_list);
}

/*!
 * @brief This function returns a constant reference to member key_point_list
 * @return Constant reference to member key_point_list
 */
const std::vector<ros2_interface::msg::KeyPoint>& ros2_interface::msg::RoutingRequest::key_point_list() const
{
    return m_key_point_list;
}

/*!
 * @brief This function returns a reference to member key_point_list
 * @return Reference to member key_point_list
 */
std::vector<ros2_interface::msg::KeyPoint>& ros2_interface::msg::RoutingRequest::key_point_list()
{
    return m_key_point_list;
}


size_t ros2_interface::msg::RoutingRequest::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoutingRequest_max_key_cdr_typesize;
}

bool ros2_interface::msg::RoutingRequest::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RoutingRequest::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



