// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingRequest.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGREQUEST_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGREQUEST_H_

#include "KeyPoint.h"
#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(ROUTINGREQUEST_SOURCE)
#define ROUTINGREQUEST_DllAPI __declspec( dllexport )
#else
#define ROUTINGREQUEST_DllAPI __declspec( dllimport )
#endif // ROUTINGREQUEST_SOURCE
#else
#define ROUTINGREQUEST_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define ROUTINGREQUEST_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RoutingRequest defined by the user in the IDL file.
         * @ingroup RoutingRequest
         */
        class RoutingRequest
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RoutingRequest();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RoutingRequest();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RoutingRequest that will be copied.
             */
            eProsima_user_DllExport RoutingRequest(
                    const RoutingRequest& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RoutingRequest that will be copied.
             */
            eProsima_user_DllExport RoutingRequest(
                    RoutingRequest&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RoutingRequest that will be copied.
             */
            eProsima_user_DllExport RoutingRequest& operator =(
                    const RoutingRequest& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RoutingRequest that will be copied.
             */
            eProsima_user_DllExport RoutingRequest& operator =(
                    RoutingRequest&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoutingRequest object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RoutingRequest& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoutingRequest object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RoutingRequest& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member request_source
             * @param _request_source New value to be copied in member request_source
             */
            eProsima_user_DllExport void request_source(
                    const std::string& _request_source);

            /*!
             * @brief This function moves the value in member request_source
             * @param _request_source New value to be moved in member request_source
             */
            eProsima_user_DllExport void request_source(
                    std::string&& _request_source);

            /*!
             * @brief This function returns a constant reference to member request_source
             * @return Constant reference to member request_source
             */
            eProsima_user_DllExport const std::string& request_source() const;

            /*!
             * @brief This function returns a reference to member request_source
             * @return Reference to member request_source
             */
            eProsima_user_DllExport std::string& request_source();
            /*!
             * @brief This function sets a value in member request_type
             * @param _request_type New value for member request_type
             */
            eProsima_user_DllExport void request_type(
                    int8_t _request_type);

            /*!
             * @brief This function returns the value of member request_type
             * @return Value of member request_type
             */
            eProsima_user_DllExport int8_t request_type() const;

            /*!
             * @brief This function returns a reference to member request_type
             * @return Reference to member request_type
             */
            eProsima_user_DllExport int8_t& request_type();

            /*!
             * @brief This function sets a value in member num_of_kp
             * @param _num_of_kp New value for member num_of_kp
             */
            eProsima_user_DllExport void num_of_kp(
                    int16_t _num_of_kp);

            /*!
             * @brief This function returns the value of member num_of_kp
             * @return Value of member num_of_kp
             */
            eProsima_user_DllExport int16_t num_of_kp() const;

            /*!
             * @brief This function returns a reference to member num_of_kp
             * @return Reference to member num_of_kp
             */
            eProsima_user_DllExport int16_t& num_of_kp();

            /*!
             * @brief This function copies the value in member key_point_list
             * @param _key_point_list New value to be copied in member key_point_list
             */
            eProsima_user_DllExport void key_point_list(
                    const std::vector<ros2_interface::msg::KeyPoint>& _key_point_list);

            /*!
             * @brief This function moves the value in member key_point_list
             * @param _key_point_list New value to be moved in member key_point_list
             */
            eProsima_user_DllExport void key_point_list(
                    std::vector<ros2_interface::msg::KeyPoint>&& _key_point_list);

            /*!
             * @brief This function returns a constant reference to member key_point_list
             * @return Constant reference to member key_point_list
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::KeyPoint>& key_point_list() const;

            /*!
             * @brief This function returns a reference to member key_point_list
             * @return Reference to member key_point_list
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::KeyPoint>& key_point_list();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RoutingRequest& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::string m_request_source;
            int8_t m_request_type;
            int16_t m_num_of_kp;
            std::vector<ros2_interface::msg::KeyPoint> m_key_point_list;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGREQUEST_H_

