// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingRequestTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "RoutingRequest.h"
#include "RoutingRequestTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRoutingRequestTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::KeyPoint", ros2_interface::msg::GetKeyPointIdentifier(true),
                        ros2_interface::msg::GetKeyPointObject(true));
                factory->add_type_object("ros2_interface::msg::KeyPoint", ros2_interface::msg::GetKeyPointIdentifier(false),
                        ros2_interface::msg::GetKeyPointObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::RoutingRequest", ros2_interface::msg::GetRoutingRequestIdentifier(true),
                        ros2_interface::msg::GetRoutingRequestObject(true));
                factory->add_type_object("ros2_interface::msg::RoutingRequest", ros2_interface::msg::GetRoutingRequestIdentifier(false),
                        ros2_interface::msg::GetRoutingRequestObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRoutingRequestIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("RoutingRequest", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRoutingRequestObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("RoutingRequest", complete);
        }

        const TypeObject* GetRoutingRequestObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingRequest", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRoutingRequestObject();
            }
            //else
            return GetMinimalRoutingRequestObject();
        }

        const TypeObject* GetMinimalRoutingRequestObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingRequest", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_request_source;
            mst_request_source.common().member_id(memberId++);
            mst_request_source.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_request_source.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_request_source.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_request_source.common().member_flags().IS_OPTIONAL(false);
            mst_request_source.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_request_source.common().member_flags().IS_KEY(false);
            mst_request_source.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_request_source.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 request_source_hash("request_source");
            for(int i = 0; i < 4; ++i)
            {
                mst_request_source.detail().name_hash()[i] = request_source_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_request_source);

            MinimalStructMember mst_request_type;
            mst_request_type.common().member_id(memberId++);
            mst_request_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_request_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_request_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_request_type.common().member_flags().IS_OPTIONAL(false);
            mst_request_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_request_type.common().member_flags().IS_KEY(false);
            mst_request_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_request_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 request_type_hash("request_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_request_type.detail().name_hash()[i] = request_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_request_type);

            MinimalStructMember mst_num_of_kp;
            mst_num_of_kp.common().member_id(memberId++);
            mst_num_of_kp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_num_of_kp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_num_of_kp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_num_of_kp.common().member_flags().IS_OPTIONAL(false);
            mst_num_of_kp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_num_of_kp.common().member_flags().IS_KEY(false);
            mst_num_of_kp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_num_of_kp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            MD5 num_of_kp_hash("num_of_kp");
            for(int i = 0; i < 4; ++i)
            {
                mst_num_of_kp.detail().name_hash()[i] = num_of_kp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_num_of_kp);

            MinimalStructMember mst_key_point_list;
            mst_key_point_list.common().member_id(memberId++);
            mst_key_point_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_key_point_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_key_point_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_key_point_list.common().member_flags().IS_OPTIONAL(false);
            mst_key_point_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_key_point_list.common().member_flags().IS_KEY(false);
            mst_key_point_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_key_point_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::KeyPoint", 100, false));


            MD5 key_point_list_hash("key_point_list");
            for(int i = 0; i < 4; ++i)
            {
                mst_key_point_list.detail().name_hash()[i] = key_point_list_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_key_point_list);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoutingRequest", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoutingRequest", false);
        }

        const TypeObject* GetCompleteRoutingRequestObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingRequest", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_request_source;
            cst_request_source.common().member_id(memberId++);
            cst_request_source.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_request_source.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_request_source.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_request_source.common().member_flags().IS_OPTIONAL(false);
            cst_request_source.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_request_source.common().member_flags().IS_KEY(false);
            cst_request_source.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_request_source.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_request_source.detail().name("request_source");

            type_object->complete().struct_type().member_seq().emplace_back(cst_request_source);

            CompleteStructMember cst_request_type;
            cst_request_type.common().member_id(memberId++);
            cst_request_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_request_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_request_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_request_type.common().member_flags().IS_OPTIONAL(false);
            cst_request_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_request_type.common().member_flags().IS_KEY(false);
            cst_request_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_request_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_request_type.detail().name("request_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_request_type);

            CompleteStructMember cst_num_of_kp;
            cst_num_of_kp.common().member_id(memberId++);
            cst_num_of_kp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_num_of_kp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_num_of_kp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_num_of_kp.common().member_flags().IS_OPTIONAL(false);
            cst_num_of_kp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_num_of_kp.common().member_flags().IS_KEY(false);
            cst_num_of_kp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_num_of_kp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int16_t", false));

            cst_num_of_kp.detail().name("num_of_kp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_num_of_kp);

            CompleteStructMember cst_key_point_list;
            cst_key_point_list.common().member_id(memberId++);
            cst_key_point_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_key_point_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_key_point_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_key_point_list.common().member_flags().IS_OPTIONAL(false);
            cst_key_point_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_key_point_list.common().member_flags().IS_KEY(false);
            cst_key_point_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_key_point_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::KeyPoint", 100, true));


            cst_key_point_list.detail().name("key_point_list");

            type_object->complete().struct_type().member_seq().emplace_back(cst_key_point_list);


            // Header
            type_object->complete().struct_type().header().detail().type_name("RoutingRequest");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoutingRequest", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoutingRequest", true);
        }

    } // namespace msg
} // namespace ros2_interface