// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingResponse.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "RoutingResponse.h"
#include "RoutingResponseTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_RoutingResponse_max_cdr_typesize 721088ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_LaneInfo_max_cdr_typesize 7208ULL;
#define ros2_interface_msg_LanePoint_max_cdr_typesize 72ULL;
#define ros2_interface_msg_RoutingResponse_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LaneInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LanePoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::RoutingResponse::RoutingResponse()
{
    // ros2_interface::msg::Header m_header

    // long m_plan_status
    m_plan_status = 0;
    // long m_replan_flag
    m_replan_flag = 0;
    // long m_route_reason
    m_route_reason = 0;
    // sequence<ros2_interface::msg::LaneInfo> m_lane_list


    // Just to register all known types
    registerRoutingResponseTypes();
}

ros2_interface::msg::RoutingResponse::~RoutingResponse()
{





}

ros2_interface::msg::RoutingResponse::RoutingResponse(
        const RoutingResponse& x)
{
    m_header = x.m_header;
    m_plan_status = x.m_plan_status;
    m_replan_flag = x.m_replan_flag;
    m_route_reason = x.m_route_reason;
    m_lane_list = x.m_lane_list;
}

ros2_interface::msg::RoutingResponse::RoutingResponse(
        RoutingResponse&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_plan_status = x.m_plan_status;
    m_replan_flag = x.m_replan_flag;
    m_route_reason = x.m_route_reason;
    m_lane_list = std::move(x.m_lane_list);
}

ros2_interface::msg::RoutingResponse& ros2_interface::msg::RoutingResponse::operator =(
        const RoutingResponse& x)
{

    m_header = x.m_header;
    m_plan_status = x.m_plan_status;
    m_replan_flag = x.m_replan_flag;
    m_route_reason = x.m_route_reason;
    m_lane_list = x.m_lane_list;

    return *this;
}

ros2_interface::msg::RoutingResponse& ros2_interface::msg::RoutingResponse::operator =(
        RoutingResponse&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_plan_status = x.m_plan_status;
    m_replan_flag = x.m_replan_flag;
    m_route_reason = x.m_route_reason;
    m_lane_list = std::move(x.m_lane_list);

    return *this;
}

bool ros2_interface::msg::RoutingResponse::operator ==(
        const RoutingResponse& x) const
{

    return (m_header == x.m_header && m_plan_status == x.m_plan_status && m_replan_flag == x.m_replan_flag && m_route_reason == x.m_route_reason && m_lane_list == x.m_lane_list);
}

bool ros2_interface::msg::RoutingResponse::operator !=(
        const RoutingResponse& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::RoutingResponse::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoutingResponse_max_cdr_typesize;
}

size_t ros2_interface::msg::RoutingResponse::getCdrSerializedSize(
        const ros2_interface::msg::RoutingResponse& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.lane_list().size(); ++a)
    {
        current_alignment += ros2_interface::msg::LaneInfo::getCdrSerializedSize(data.lane_list().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::RoutingResponse::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_plan_status;
    scdr << m_replan_flag;
    scdr << m_route_reason;
    scdr << m_lane_list;

}

void ros2_interface::msg::RoutingResponse::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_plan_status;
    dcdr >> m_replan_flag;
    dcdr >> m_route_reason;
    dcdr >> m_lane_list;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::RoutingResponse::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::RoutingResponse::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::RoutingResponse::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::RoutingResponse::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member plan_status
 * @param _plan_status New value for member plan_status
 */
void ros2_interface::msg::RoutingResponse::plan_status(
        int32_t _plan_status)
{
    m_plan_status = _plan_status;
}

/*!
 * @brief This function returns the value of member plan_status
 * @return Value of member plan_status
 */
int32_t ros2_interface::msg::RoutingResponse::plan_status() const
{
    return m_plan_status;
}

/*!
 * @brief This function returns a reference to member plan_status
 * @return Reference to member plan_status
 */
int32_t& ros2_interface::msg::RoutingResponse::plan_status()
{
    return m_plan_status;
}

/*!
 * @brief This function sets a value in member replan_flag
 * @param _replan_flag New value for member replan_flag
 */
void ros2_interface::msg::RoutingResponse::replan_flag(
        int32_t _replan_flag)
{
    m_replan_flag = _replan_flag;
}

/*!
 * @brief This function returns the value of member replan_flag
 * @return Value of member replan_flag
 */
int32_t ros2_interface::msg::RoutingResponse::replan_flag() const
{
    return m_replan_flag;
}

/*!
 * @brief This function returns a reference to member replan_flag
 * @return Reference to member replan_flag
 */
int32_t& ros2_interface::msg::RoutingResponse::replan_flag()
{
    return m_replan_flag;
}

/*!
 * @brief This function sets a value in member route_reason
 * @param _route_reason New value for member route_reason
 */
void ros2_interface::msg::RoutingResponse::route_reason(
        int32_t _route_reason)
{
    m_route_reason = _route_reason;
}

/*!
 * @brief This function returns the value of member route_reason
 * @return Value of member route_reason
 */
int32_t ros2_interface::msg::RoutingResponse::route_reason() const
{
    return m_route_reason;
}

/*!
 * @brief This function returns a reference to member route_reason
 * @return Reference to member route_reason
 */
int32_t& ros2_interface::msg::RoutingResponse::route_reason()
{
    return m_route_reason;
}

/*!
 * @brief This function copies the value in member lane_list
 * @param _lane_list New value to be copied in member lane_list
 */
void ros2_interface::msg::RoutingResponse::lane_list(
        const std::vector<ros2_interface::msg::LaneInfo>& _lane_list)
{
    m_lane_list = _lane_list;
}

/*!
 * @brief This function moves the value in member lane_list
 * @param _lane_list New value to be moved in member lane_list
 */
void ros2_interface::msg::RoutingResponse::lane_list(
        std::vector<ros2_interface::msg::LaneInfo>&& _lane_list)
{
    m_lane_list = std::move(_lane_list);
}

/*!
 * @brief This function returns a constant reference to member lane_list
 * @return Constant reference to member lane_list
 */
const std::vector<ros2_interface::msg::LaneInfo>& ros2_interface::msg::RoutingResponse::lane_list() const
{
    return m_lane_list;
}

/*!
 * @brief This function returns a reference to member lane_list
 * @return Reference to member lane_list
 */
std::vector<ros2_interface::msg::LaneInfo>& ros2_interface::msg::RoutingResponse::lane_list()
{
    return m_lane_list;
}


size_t ros2_interface::msg::RoutingResponse::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_RoutingResponse_max_key_cdr_typesize;
}

bool ros2_interface::msg::RoutingResponse::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::RoutingResponse::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



