// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingResponse.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGRESPONSE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGRESPONSE_H_

#include "Header.h"
#include "LaneInfo.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(ROUTINGRESPONSE_SOURCE)
#define ROUTINGRESPONSE_DllAPI __declspec( dllexport )
#else
#define ROUTINGRESPONSE_DllAPI __declspec( dllimport )
#endif // ROUTINGRESPONSE_SOURCE
#else
#define ROUTINGRESPONSE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define ROUTINGRESPONSE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure RoutingResponse defined by the user in the IDL file.
         * @ingroup RoutingResponse
         */
        class RoutingResponse
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport RoutingResponse();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~RoutingResponse();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::RoutingResponse that will be copied.
             */
            eProsima_user_DllExport RoutingResponse(
                    const RoutingResponse& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::RoutingResponse that will be copied.
             */
            eProsima_user_DllExport RoutingResponse(
                    RoutingResponse&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::RoutingResponse that will be copied.
             */
            eProsima_user_DllExport RoutingResponse& operator =(
                    const RoutingResponse& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::RoutingResponse that will be copied.
             */
            eProsima_user_DllExport RoutingResponse& operator =(
                    RoutingResponse&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoutingResponse object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const RoutingResponse& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::RoutingResponse object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const RoutingResponse& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member plan_status
             * @param _plan_status New value for member plan_status
             */
            eProsima_user_DllExport void plan_status(
                    int32_t _plan_status);

            /*!
             * @brief This function returns the value of member plan_status
             * @return Value of member plan_status
             */
            eProsima_user_DllExport int32_t plan_status() const;

            /*!
             * @brief This function returns a reference to member plan_status
             * @return Reference to member plan_status
             */
            eProsima_user_DllExport int32_t& plan_status();

            /*!
             * @brief This function sets a value in member replan_flag
             * @param _replan_flag New value for member replan_flag
             */
            eProsima_user_DllExport void replan_flag(
                    int32_t _replan_flag);

            /*!
             * @brief This function returns the value of member replan_flag
             * @return Value of member replan_flag
             */
            eProsima_user_DllExport int32_t replan_flag() const;

            /*!
             * @brief This function returns a reference to member replan_flag
             * @return Reference to member replan_flag
             */
            eProsima_user_DllExport int32_t& replan_flag();

            /*!
             * @brief This function sets a value in member route_reason
             * @param _route_reason New value for member route_reason
             */
            eProsima_user_DllExport void route_reason(
                    int32_t _route_reason);

            /*!
             * @brief This function returns the value of member route_reason
             * @return Value of member route_reason
             */
            eProsima_user_DllExport int32_t route_reason() const;

            /*!
             * @brief This function returns a reference to member route_reason
             * @return Reference to member route_reason
             */
            eProsima_user_DllExport int32_t& route_reason();

            /*!
             * @brief This function copies the value in member lane_list
             * @param _lane_list New value to be copied in member lane_list
             */
            eProsima_user_DllExport void lane_list(
                    const std::vector<ros2_interface::msg::LaneInfo>& _lane_list);

            /*!
             * @brief This function moves the value in member lane_list
             * @param _lane_list New value to be moved in member lane_list
             */
            eProsima_user_DllExport void lane_list(
                    std::vector<ros2_interface::msg::LaneInfo>&& _lane_list);

            /*!
             * @brief This function returns a constant reference to member lane_list
             * @return Constant reference to member lane_list
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::LaneInfo>& lane_list() const;

            /*!
             * @brief This function returns a reference to member lane_list
             * @return Reference to member lane_list
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::LaneInfo>& lane_list();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::RoutingResponse& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_plan_status;
            int32_t m_replan_flag;
            int32_t m_route_reason;
            std::vector<ros2_interface::msg::LaneInfo> m_lane_list;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_ROUTINGRESPONSE_H_

