// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file RoutingResponseTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "RoutingResponse.h"
#include "RoutingResponseTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerRoutingResponseTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(true),
                        ros2_interface::msg::GetLanePointObject(true));
                factory->add_type_object("ros2_interface::msg::LanePoint", ros2_interface::msg::GetLanePointIdentifier(false),
                        ros2_interface::msg::GetLanePointObject(false));



                factory->add_type_object("ros2_interface::msg::LaneInfo", ros2_interface::msg::GetLaneInfoIdentifier(true),
                        ros2_interface::msg::GetLaneInfoObject(true));
                factory->add_type_object("ros2_interface::msg::LaneInfo", ros2_interface::msg::GetLaneInfoIdentifier(false),
                        ros2_interface::msg::GetLaneInfoObject(false));



                factory->add_type_object("ros2_interface::msg::RoutingResponse", ros2_interface::msg::GetRoutingResponseIdentifier(true),
                        ros2_interface::msg::GetRoutingResponseObject(true));
                factory->add_type_object("ros2_interface::msg::RoutingResponse", ros2_interface::msg::GetRoutingResponseIdentifier(false),
                        ros2_interface::msg::GetRoutingResponseObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetRoutingResponseIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("RoutingResponse", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetRoutingResponseObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("RoutingResponse", complete);
        }

        const TypeObject* GetRoutingResponseObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingResponse", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteRoutingResponseObject();
            }
            //else
            return GetMinimalRoutingResponseObject();
        }

        const TypeObject* GetMinimalRoutingResponseObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingResponse", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_plan_status;
            mst_plan_status.common().member_id(memberId++);
            mst_plan_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_plan_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_plan_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_plan_status.common().member_flags().IS_OPTIONAL(false);
            mst_plan_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_plan_status.common().member_flags().IS_KEY(false);
            mst_plan_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_plan_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 plan_status_hash("plan_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_plan_status.detail().name_hash()[i] = plan_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_plan_status);

            MinimalStructMember mst_replan_flag;
            mst_replan_flag.common().member_id(memberId++);
            mst_replan_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_replan_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_replan_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_replan_flag.common().member_flags().IS_OPTIONAL(false);
            mst_replan_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_replan_flag.common().member_flags().IS_KEY(false);
            mst_replan_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_replan_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 replan_flag_hash("replan_flag");
            for(int i = 0; i < 4; ++i)
            {
                mst_replan_flag.detail().name_hash()[i] = replan_flag_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_replan_flag);

            MinimalStructMember mst_route_reason;
            mst_route_reason.common().member_id(memberId++);
            mst_route_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_route_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_route_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_route_reason.common().member_flags().IS_OPTIONAL(false);
            mst_route_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_route_reason.common().member_flags().IS_KEY(false);
            mst_route_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_route_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 route_reason_hash("route_reason");
            for(int i = 0; i < 4; ++i)
            {
                mst_route_reason.detail().name_hash()[i] = route_reason_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_route_reason);

            MinimalStructMember mst_lane_list;
            mst_lane_list.common().member_id(memberId++);
            mst_lane_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lane_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lane_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lane_list.common().member_flags().IS_OPTIONAL(false);
            mst_lane_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lane_list.common().member_flags().IS_KEY(false);
            mst_lane_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lane_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneInfo", 100, false));


            MD5 lane_list_hash("lane_list");
            for(int i = 0; i < 4; ++i)
            {
                mst_lane_list.detail().name_hash()[i] = lane_list_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lane_list);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoutingResponse", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoutingResponse", false);
        }

        const TypeObject* GetCompleteRoutingResponseObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("RoutingResponse", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_plan_status;
            cst_plan_status.common().member_id(memberId++);
            cst_plan_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_plan_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_plan_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_plan_status.common().member_flags().IS_OPTIONAL(false);
            cst_plan_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_plan_status.common().member_flags().IS_KEY(false);
            cst_plan_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_plan_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_plan_status.detail().name("plan_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_plan_status);

            CompleteStructMember cst_replan_flag;
            cst_replan_flag.common().member_id(memberId++);
            cst_replan_flag.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_replan_flag.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_replan_flag.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_replan_flag.common().member_flags().IS_OPTIONAL(false);
            cst_replan_flag.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_replan_flag.common().member_flags().IS_KEY(false);
            cst_replan_flag.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_replan_flag.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_replan_flag.detail().name("replan_flag");

            type_object->complete().struct_type().member_seq().emplace_back(cst_replan_flag);

            CompleteStructMember cst_route_reason;
            cst_route_reason.common().member_id(memberId++);
            cst_route_reason.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_route_reason.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_route_reason.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_route_reason.common().member_flags().IS_OPTIONAL(false);
            cst_route_reason.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_route_reason.common().member_flags().IS_KEY(false);
            cst_route_reason.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_route_reason.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_route_reason.detail().name("route_reason");

            type_object->complete().struct_type().member_seq().emplace_back(cst_route_reason);

            CompleteStructMember cst_lane_list;
            cst_lane_list.common().member_id(memberId++);
            cst_lane_list.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lane_list.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lane_list.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lane_list.common().member_flags().IS_OPTIONAL(false);
            cst_lane_list.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lane_list.common().member_flags().IS_KEY(false);
            cst_lane_list.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lane_list.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::LaneInfo", 100, true));


            cst_lane_list.detail().name("lane_list");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lane_list);


            // Header
            type_object->complete().struct_type().header().detail().type_name("RoutingResponse");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("RoutingResponse", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("RoutingResponse", true);
        }

    } // namespace msg
} // namespace ros2_interface