// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SLBoundary.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SLBoundary.h"
#include "SLBoundaryTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_SLPoint_max_cdr_typesize 16ULL;
#define ros2_interface_msg_SLBoundary_max_cdr_typesize 1640ULL;
#define ros2_interface_msg_SLPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_SLBoundary_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SLBoundary::SLBoundary()
{
    // double m_start_s
    m_start_s = 0.0;
    // double m_end_s
    m_end_s = 0.0;
    // double m_start_l
    m_start_l = 0.0;
    // double m_end_l
    m_end_l = 0.0;
    // sequence<ros2_interface::msg::SLPoint> m_boundary_point


    // Just to register all known types
    registerSLBoundaryTypes();
}

ros2_interface::msg::SLBoundary::~SLBoundary()
{





}

ros2_interface::msg::SLBoundary::SLBoundary(
        const SLBoundary& x)
{
    m_start_s = x.m_start_s;
    m_end_s = x.m_end_s;
    m_start_l = x.m_start_l;
    m_end_l = x.m_end_l;
    m_boundary_point = x.m_boundary_point;
}

ros2_interface::msg::SLBoundary::SLBoundary(
        SLBoundary&& x) noexcept 
{
    m_start_s = x.m_start_s;
    m_end_s = x.m_end_s;
    m_start_l = x.m_start_l;
    m_end_l = x.m_end_l;
    m_boundary_point = std::move(x.m_boundary_point);
}

ros2_interface::msg::SLBoundary& ros2_interface::msg::SLBoundary::operator =(
        const SLBoundary& x)
{

    m_start_s = x.m_start_s;
    m_end_s = x.m_end_s;
    m_start_l = x.m_start_l;
    m_end_l = x.m_end_l;
    m_boundary_point = x.m_boundary_point;

    return *this;
}

ros2_interface::msg::SLBoundary& ros2_interface::msg::SLBoundary::operator =(
        SLBoundary&& x) noexcept
{

    m_start_s = x.m_start_s;
    m_end_s = x.m_end_s;
    m_start_l = x.m_start_l;
    m_end_l = x.m_end_l;
    m_boundary_point = std::move(x.m_boundary_point);

    return *this;
}

bool ros2_interface::msg::SLBoundary::operator ==(
        const SLBoundary& x) const
{

    return (m_start_s == x.m_start_s && m_end_s == x.m_end_s && m_start_l == x.m_start_l && m_end_l == x.m_end_l && m_boundary_point == x.m_boundary_point);
}

bool ros2_interface::msg::SLBoundary::operator !=(
        const SLBoundary& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SLBoundary::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SLBoundary_max_cdr_typesize;
}

size_t ros2_interface::msg::SLBoundary::getCdrSerializedSize(
        const ros2_interface::msg::SLBoundary& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.boundary_point().size(); ++a)
    {
        current_alignment += ros2_interface::msg::SLPoint::getCdrSerializedSize(data.boundary_point().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SLBoundary::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_start_s;
    scdr << m_end_s;
    scdr << m_start_l;
    scdr << m_end_l;
    scdr << m_boundary_point;

}

void ros2_interface::msg::SLBoundary::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_start_s;
    dcdr >> m_end_s;
    dcdr >> m_start_l;
    dcdr >> m_end_l;
    dcdr >> m_boundary_point;
}

/*!
 * @brief This function sets a value in member start_s
 * @param _start_s New value for member start_s
 */
void ros2_interface::msg::SLBoundary::start_s(
        double _start_s)
{
    m_start_s = _start_s;
}

/*!
 * @brief This function returns the value of member start_s
 * @return Value of member start_s
 */
double ros2_interface::msg::SLBoundary::start_s() const
{
    return m_start_s;
}

/*!
 * @brief This function returns a reference to member start_s
 * @return Reference to member start_s
 */
double& ros2_interface::msg::SLBoundary::start_s()
{
    return m_start_s;
}

/*!
 * @brief This function sets a value in member end_s
 * @param _end_s New value for member end_s
 */
void ros2_interface::msg::SLBoundary::end_s(
        double _end_s)
{
    m_end_s = _end_s;
}

/*!
 * @brief This function returns the value of member end_s
 * @return Value of member end_s
 */
double ros2_interface::msg::SLBoundary::end_s() const
{
    return m_end_s;
}

/*!
 * @brief This function returns a reference to member end_s
 * @return Reference to member end_s
 */
double& ros2_interface::msg::SLBoundary::end_s()
{
    return m_end_s;
}

/*!
 * @brief This function sets a value in member start_l
 * @param _start_l New value for member start_l
 */
void ros2_interface::msg::SLBoundary::start_l(
        double _start_l)
{
    m_start_l = _start_l;
}

/*!
 * @brief This function returns the value of member start_l
 * @return Value of member start_l
 */
double ros2_interface::msg::SLBoundary::start_l() const
{
    return m_start_l;
}

/*!
 * @brief This function returns a reference to member start_l
 * @return Reference to member start_l
 */
double& ros2_interface::msg::SLBoundary::start_l()
{
    return m_start_l;
}

/*!
 * @brief This function sets a value in member end_l
 * @param _end_l New value for member end_l
 */
void ros2_interface::msg::SLBoundary::end_l(
        double _end_l)
{
    m_end_l = _end_l;
}

/*!
 * @brief This function returns the value of member end_l
 * @return Value of member end_l
 */
double ros2_interface::msg::SLBoundary::end_l() const
{
    return m_end_l;
}

/*!
 * @brief This function returns a reference to member end_l
 * @return Reference to member end_l
 */
double& ros2_interface::msg::SLBoundary::end_l()
{
    return m_end_l;
}

/*!
 * @brief This function copies the value in member boundary_point
 * @param _boundary_point New value to be copied in member boundary_point
 */
void ros2_interface::msg::SLBoundary::boundary_point(
        const std::vector<ros2_interface::msg::SLPoint>& _boundary_point)
{
    m_boundary_point = _boundary_point;
}

/*!
 * @brief This function moves the value in member boundary_point
 * @param _boundary_point New value to be moved in member boundary_point
 */
void ros2_interface::msg::SLBoundary::boundary_point(
        std::vector<ros2_interface::msg::SLPoint>&& _boundary_point)
{
    m_boundary_point = std::move(_boundary_point);
}

/*!
 * @brief This function returns a constant reference to member boundary_point
 * @return Constant reference to member boundary_point
 */
const std::vector<ros2_interface::msg::SLPoint>& ros2_interface::msg::SLBoundary::boundary_point() const
{
    return m_boundary_point;
}

/*!
 * @brief This function returns a reference to member boundary_point
 * @return Reference to member boundary_point
 */
std::vector<ros2_interface::msg::SLPoint>& ros2_interface::msg::SLBoundary::boundary_point()
{
    return m_boundary_point;
}


size_t ros2_interface::msg::SLBoundary::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SLBoundary_max_key_cdr_typesize;
}

bool ros2_interface::msg::SLBoundary::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SLBoundary::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



