// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SLBoundary.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SLBOUNDARY_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SLBOUNDARY_H_

#include "SLPoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(SLBOUNDARY_SOURCE)
#define SLBOUNDARY_DllAPI __declspec( dllexport )
#else
#define SLBOUNDARY_DllAPI __declspec( dllimport )
#endif // SLBOUNDARY_SOURCE
#else
#define SLBOUNDARY_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define SLBOUNDARY_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure SLBoundary defined by the user in the IDL file.
         * @ingroup SLBoundary
         */
        class SLBoundary
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport SLBoundary();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~SLBoundary();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::SLBoundary that will be copied.
             */
            eProsima_user_DllExport SLBoundary(
                    const SLBoundary& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::SLBoundary that will be copied.
             */
            eProsima_user_DllExport SLBoundary(
                    SLBoundary&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::SLBoundary that will be copied.
             */
            eProsima_user_DllExport SLBoundary& operator =(
                    const SLBoundary& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::SLBoundary that will be copied.
             */
            eProsima_user_DllExport SLBoundary& operator =(
                    SLBoundary&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SLBoundary object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const SLBoundary& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SLBoundary object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const SLBoundary& x) const;

            /*!
             * @brief This function sets a value in member start_s
             * @param _start_s New value for member start_s
             */
            eProsima_user_DllExport void start_s(
                    double _start_s);

            /*!
             * @brief This function returns the value of member start_s
             * @return Value of member start_s
             */
            eProsima_user_DllExport double start_s() const;

            /*!
             * @brief This function returns a reference to member start_s
             * @return Reference to member start_s
             */
            eProsima_user_DllExport double& start_s();

            /*!
             * @brief This function sets a value in member end_s
             * @param _end_s New value for member end_s
             */
            eProsima_user_DllExport void end_s(
                    double _end_s);

            /*!
             * @brief This function returns the value of member end_s
             * @return Value of member end_s
             */
            eProsima_user_DllExport double end_s() const;

            /*!
             * @brief This function returns a reference to member end_s
             * @return Reference to member end_s
             */
            eProsima_user_DllExport double& end_s();

            /*!
             * @brief This function sets a value in member start_l
             * @param _start_l New value for member start_l
             */
            eProsima_user_DllExport void start_l(
                    double _start_l);

            /*!
             * @brief This function returns the value of member start_l
             * @return Value of member start_l
             */
            eProsima_user_DllExport double start_l() const;

            /*!
             * @brief This function returns a reference to member start_l
             * @return Reference to member start_l
             */
            eProsima_user_DllExport double& start_l();

            /*!
             * @brief This function sets a value in member end_l
             * @param _end_l New value for member end_l
             */
            eProsima_user_DllExport void end_l(
                    double _end_l);

            /*!
             * @brief This function returns the value of member end_l
             * @return Value of member end_l
             */
            eProsima_user_DllExport double end_l() const;

            /*!
             * @brief This function returns a reference to member end_l
             * @return Reference to member end_l
             */
            eProsima_user_DllExport double& end_l();

            /*!
             * @brief This function copies the value in member boundary_point
             * @param _boundary_point New value to be copied in member boundary_point
             */
            eProsima_user_DllExport void boundary_point(
                    const std::vector<ros2_interface::msg::SLPoint>& _boundary_point);

            /*!
             * @brief This function moves the value in member boundary_point
             * @param _boundary_point New value to be moved in member boundary_point
             */
            eProsima_user_DllExport void boundary_point(
                    std::vector<ros2_interface::msg::SLPoint>&& _boundary_point);

            /*!
             * @brief This function returns a constant reference to member boundary_point
             * @return Constant reference to member boundary_point
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::SLPoint>& boundary_point() const;

            /*!
             * @brief This function returns a reference to member boundary_point
             * @return Reference to member boundary_point
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::SLPoint>& boundary_point();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::SLBoundary& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_start_s;
            double m_end_s;
            double m_start_l;
            double m_end_l;
            std::vector<ros2_interface::msg::SLPoint> m_boundary_point;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SLBOUNDARY_H_

