// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SLBoundaryTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "SLBoundary.h"
#include "SLBoundaryTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerSLBoundaryTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::SLPoint", ros2_interface::msg::GetSLPointIdentifier(true),
                        ros2_interface::msg::GetSLPointObject(true));
                factory->add_type_object("ros2_interface::msg::SLPoint", ros2_interface::msg::GetSLPointIdentifier(false),
                        ros2_interface::msg::GetSLPointObject(false));



                factory->add_type_object("ros2_interface::msg::SLBoundary", ros2_interface::msg::GetSLBoundaryIdentifier(true),
                        ros2_interface::msg::GetSLBoundaryObject(true));
                factory->add_type_object("ros2_interface::msg::SLBoundary", ros2_interface::msg::GetSLBoundaryIdentifier(false),
                        ros2_interface::msg::GetSLBoundaryObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetSLBoundaryIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("SLBoundary", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetSLBoundaryObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("SLBoundary", complete);
        }

        const TypeObject* GetSLBoundaryObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SLBoundary", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteSLBoundaryObject();
            }
            //else
            return GetMinimalSLBoundaryObject();
        }

        const TypeObject* GetMinimalSLBoundaryObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SLBoundary", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_start_s;
            mst_start_s.common().member_id(memberId++);
            mst_start_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_start_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_start_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_start_s.common().member_flags().IS_OPTIONAL(false);
            mst_start_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_start_s.common().member_flags().IS_KEY(false);
            mst_start_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_start_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 start_s_hash("start_s");
            for(int i = 0; i < 4; ++i)
            {
                mst_start_s.detail().name_hash()[i] = start_s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_start_s);

            MinimalStructMember mst_end_s;
            mst_end_s.common().member_id(memberId++);
            mst_end_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_end_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_end_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_end_s.common().member_flags().IS_OPTIONAL(false);
            mst_end_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_end_s.common().member_flags().IS_KEY(false);
            mst_end_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_end_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 end_s_hash("end_s");
            for(int i = 0; i < 4; ++i)
            {
                mst_end_s.detail().name_hash()[i] = end_s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_end_s);

            MinimalStructMember mst_start_l;
            mst_start_l.common().member_id(memberId++);
            mst_start_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_start_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_start_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_start_l.common().member_flags().IS_OPTIONAL(false);
            mst_start_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_start_l.common().member_flags().IS_KEY(false);
            mst_start_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_start_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 start_l_hash("start_l");
            for(int i = 0; i < 4; ++i)
            {
                mst_start_l.detail().name_hash()[i] = start_l_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_start_l);

            MinimalStructMember mst_end_l;
            mst_end_l.common().member_id(memberId++);
            mst_end_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_end_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_end_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_end_l.common().member_flags().IS_OPTIONAL(false);
            mst_end_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_end_l.common().member_flags().IS_KEY(false);
            mst_end_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_end_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 end_l_hash("end_l");
            for(int i = 0; i < 4; ++i)
            {
                mst_end_l.detail().name_hash()[i] = end_l_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_end_l);

            MinimalStructMember mst_boundary_point;
            mst_boundary_point.common().member_id(memberId++);
            mst_boundary_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_boundary_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_boundary_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_boundary_point.common().member_flags().IS_OPTIONAL(false);
            mst_boundary_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_boundary_point.common().member_flags().IS_KEY(false);
            mst_boundary_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_boundary_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::SLPoint", 100, false));


            MD5 boundary_point_hash("boundary_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_boundary_point.detail().name_hash()[i] = boundary_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_boundary_point);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SLBoundary", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SLBoundary", false);
        }

        const TypeObject* GetCompleteSLBoundaryObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SLBoundary", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_start_s;
            cst_start_s.common().member_id(memberId++);
            cst_start_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_start_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_start_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_start_s.common().member_flags().IS_OPTIONAL(false);
            cst_start_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_start_s.common().member_flags().IS_KEY(false);
            cst_start_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_start_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_start_s.detail().name("start_s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_start_s);

            CompleteStructMember cst_end_s;
            cst_end_s.common().member_id(memberId++);
            cst_end_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_end_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_end_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_end_s.common().member_flags().IS_OPTIONAL(false);
            cst_end_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_end_s.common().member_flags().IS_KEY(false);
            cst_end_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_end_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_end_s.detail().name("end_s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_end_s);

            CompleteStructMember cst_start_l;
            cst_start_l.common().member_id(memberId++);
            cst_start_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_start_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_start_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_start_l.common().member_flags().IS_OPTIONAL(false);
            cst_start_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_start_l.common().member_flags().IS_KEY(false);
            cst_start_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_start_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_start_l.detail().name("start_l");

            type_object->complete().struct_type().member_seq().emplace_back(cst_start_l);

            CompleteStructMember cst_end_l;
            cst_end_l.common().member_id(memberId++);
            cst_end_l.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_end_l.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_end_l.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_end_l.common().member_flags().IS_OPTIONAL(false);
            cst_end_l.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_end_l.common().member_flags().IS_KEY(false);
            cst_end_l.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_end_l.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_end_l.detail().name("end_l");

            type_object->complete().struct_type().member_seq().emplace_back(cst_end_l);

            CompleteStructMember cst_boundary_point;
            cst_boundary_point.common().member_id(memberId++);
            cst_boundary_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_boundary_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_boundary_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_boundary_point.common().member_flags().IS_OPTIONAL(false);
            cst_boundary_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_boundary_point.common().member_flags().IS_KEY(false);
            cst_boundary_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_boundary_point.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::SLPoint", 100, true));


            cst_boundary_point.detail().name("boundary_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_boundary_point);


            // Header
            type_object->complete().struct_type().header().detail().type_name("SLBoundary");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SLBoundary", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SLBoundary", true);
        }

    } // namespace msg
} // namespace ros2_interface