// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SLPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SLPoint.h"
#include "SLPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_SLPoint_max_cdr_typesize 16ULL;
#define ros2_interface_msg_SLPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SLPoint::SLPoint()
{
    // double m_s
    m_s = 0.0;
    // double m_l
    m_l = 0.0;

    // Just to register all known types
    registerSLPointTypes();
}

ros2_interface::msg::SLPoint::~SLPoint()
{


}

ros2_interface::msg::SLPoint::SLPoint(
        const SLPoint& x)
{
    m_s = x.m_s;
    m_l = x.m_l;
}

ros2_interface::msg::SLPoint::SLPoint(
        SLPoint&& x) noexcept 
{
    m_s = x.m_s;
    m_l = x.m_l;
}

ros2_interface::msg::SLPoint& ros2_interface::msg::SLPoint::operator =(
        const SLPoint& x)
{

    m_s = x.m_s;
    m_l = x.m_l;

    return *this;
}

ros2_interface::msg::SLPoint& ros2_interface::msg::SLPoint::operator =(
        SLPoint&& x) noexcept
{

    m_s = x.m_s;
    m_l = x.m_l;

    return *this;
}

bool ros2_interface::msg::SLPoint::operator ==(
        const SLPoint& x) const
{

    return (m_s == x.m_s && m_l == x.m_l);
}

bool ros2_interface::msg::SLPoint::operator !=(
        const SLPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SLPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SLPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::SLPoint::getCdrSerializedSize(
        const ros2_interface::msg::SLPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SLPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_s;
    scdr << m_l;

}

void ros2_interface::msg::SLPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_s;
    dcdr >> m_l;
}

/*!
 * @brief This function sets a value in member s
 * @param _s New value for member s
 */
void ros2_interface::msg::SLPoint::s(
        double _s)
{
    m_s = _s;
}

/*!
 * @brief This function returns the value of member s
 * @return Value of member s
 */
double ros2_interface::msg::SLPoint::s() const
{
    return m_s;
}

/*!
 * @brief This function returns a reference to member s
 * @return Reference to member s
 */
double& ros2_interface::msg::SLPoint::s()
{
    return m_s;
}

/*!
 * @brief This function sets a value in member l
 * @param _l New value for member l
 */
void ros2_interface::msg::SLPoint::l(
        double _l)
{
    m_l = _l;
}

/*!
 * @brief This function returns the value of member l
 * @return Value of member l
 */
double ros2_interface::msg::SLPoint::l() const
{
    return m_l;
}

/*!
 * @brief This function returns a reference to member l
 * @return Reference to member l
 */
double& ros2_interface::msg::SLPoint::l()
{
    return m_l;
}



size_t ros2_interface::msg::SLPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SLPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::SLPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SLPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



