// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SecurityDecision.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SecurityDecision.h"
#include "SecurityDecisionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_SecurityDecision_max_cdr_typesize 352ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_WarningCommand_max_cdr_typesize 16ULL;
#define ros2_interface_msg_TrajectoryLimitCommand_max_cdr_typesize 32ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_SecurityDecision_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_WarningCommand_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryLimitCommand_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SecurityDecision::SecurityDecision()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::WarningCommand m_warning_command

    // ros2_interface::msg::WarningCommand m_motion_alarm

    // long m_brake_report
    m_brake_report = 0;
    // long m_change_lane_command
    m_change_lane_command = 0;
    // ros2_interface::msg::TrajectoryLimitCommand m_trajectory_limit_command

    // long m_park_command
    m_park_command = 0;
    // long m_drivingmode_report
    m_drivingmode_report = 0;

    // Just to register all known types
    registerSecurityDecisionTypes();
}

ros2_interface::msg::SecurityDecision::~SecurityDecision()
{








}

ros2_interface::msg::SecurityDecision::SecurityDecision(
        const SecurityDecision& x)
{
    m_header = x.m_header;
    m_warning_command = x.m_warning_command;
    m_motion_alarm = x.m_motion_alarm;
    m_brake_report = x.m_brake_report;
    m_change_lane_command = x.m_change_lane_command;
    m_trajectory_limit_command = x.m_trajectory_limit_command;
    m_park_command = x.m_park_command;
    m_drivingmode_report = x.m_drivingmode_report;
}

ros2_interface::msg::SecurityDecision::SecurityDecision(
        SecurityDecision&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_warning_command = std::move(x.m_warning_command);
    m_motion_alarm = std::move(x.m_motion_alarm);
    m_brake_report = x.m_brake_report;
    m_change_lane_command = x.m_change_lane_command;
    m_trajectory_limit_command = std::move(x.m_trajectory_limit_command);
    m_park_command = x.m_park_command;
    m_drivingmode_report = x.m_drivingmode_report;
}

ros2_interface::msg::SecurityDecision& ros2_interface::msg::SecurityDecision::operator =(
        const SecurityDecision& x)
{

    m_header = x.m_header;
    m_warning_command = x.m_warning_command;
    m_motion_alarm = x.m_motion_alarm;
    m_brake_report = x.m_brake_report;
    m_change_lane_command = x.m_change_lane_command;
    m_trajectory_limit_command = x.m_trajectory_limit_command;
    m_park_command = x.m_park_command;
    m_drivingmode_report = x.m_drivingmode_report;

    return *this;
}

ros2_interface::msg::SecurityDecision& ros2_interface::msg::SecurityDecision::operator =(
        SecurityDecision&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_warning_command = std::move(x.m_warning_command);
    m_motion_alarm = std::move(x.m_motion_alarm);
    m_brake_report = x.m_brake_report;
    m_change_lane_command = x.m_change_lane_command;
    m_trajectory_limit_command = std::move(x.m_trajectory_limit_command);
    m_park_command = x.m_park_command;
    m_drivingmode_report = x.m_drivingmode_report;

    return *this;
}

bool ros2_interface::msg::SecurityDecision::operator ==(
        const SecurityDecision& x) const
{

    return (m_header == x.m_header && m_warning_command == x.m_warning_command && m_motion_alarm == x.m_motion_alarm && m_brake_report == x.m_brake_report && m_change_lane_command == x.m_change_lane_command && m_trajectory_limit_command == x.m_trajectory_limit_command && m_park_command == x.m_park_command && m_drivingmode_report == x.m_drivingmode_report);
}

bool ros2_interface::msg::SecurityDecision::operator !=(
        const SecurityDecision& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SecurityDecision::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SecurityDecision_max_cdr_typesize;
}

size_t ros2_interface::msg::SecurityDecision::getCdrSerializedSize(
        const ros2_interface::msg::SecurityDecision& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::WarningCommand::getCdrSerializedSize(data.warning_command(), current_alignment);
    current_alignment += ros2_interface::msg::WarningCommand::getCdrSerializedSize(data.motion_alarm(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::TrajectoryLimitCommand::getCdrSerializedSize(data.trajectory_limit_command(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SecurityDecision::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_warning_command;
    scdr << m_motion_alarm;
    scdr << m_brake_report;
    scdr << m_change_lane_command;
    scdr << m_trajectory_limit_command;
    scdr << m_park_command;
    scdr << m_drivingmode_report;

}

void ros2_interface::msg::SecurityDecision::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_warning_command;
    dcdr >> m_motion_alarm;
    dcdr >> m_brake_report;
    dcdr >> m_change_lane_command;
    dcdr >> m_trajectory_limit_command;
    dcdr >> m_park_command;
    dcdr >> m_drivingmode_report;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::SecurityDecision::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::SecurityDecision::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::SecurityDecision::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::SecurityDecision::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member warning_command
 * @param _warning_command New value to be copied in member warning_command
 */
void ros2_interface::msg::SecurityDecision::warning_command(
        const ros2_interface::msg::WarningCommand& _warning_command)
{
    m_warning_command = _warning_command;
}

/*!
 * @brief This function moves the value in member warning_command
 * @param _warning_command New value to be moved in member warning_command
 */
void ros2_interface::msg::SecurityDecision::warning_command(
        ros2_interface::msg::WarningCommand&& _warning_command)
{
    m_warning_command = std::move(_warning_command);
}

/*!
 * @brief This function returns a constant reference to member warning_command
 * @return Constant reference to member warning_command
 */
const ros2_interface::msg::WarningCommand& ros2_interface::msg::SecurityDecision::warning_command() const
{
    return m_warning_command;
}

/*!
 * @brief This function returns a reference to member warning_command
 * @return Reference to member warning_command
 */
ros2_interface::msg::WarningCommand& ros2_interface::msg::SecurityDecision::warning_command()
{
    return m_warning_command;
}
/*!
 * @brief This function copies the value in member motion_alarm
 * @param _motion_alarm New value to be copied in member motion_alarm
 */
void ros2_interface::msg::SecurityDecision::motion_alarm(
        const ros2_interface::msg::WarningCommand& _motion_alarm)
{
    m_motion_alarm = _motion_alarm;
}

/*!
 * @brief This function moves the value in member motion_alarm
 * @param _motion_alarm New value to be moved in member motion_alarm
 */
void ros2_interface::msg::SecurityDecision::motion_alarm(
        ros2_interface::msg::WarningCommand&& _motion_alarm)
{
    m_motion_alarm = std::move(_motion_alarm);
}

/*!
 * @brief This function returns a constant reference to member motion_alarm
 * @return Constant reference to member motion_alarm
 */
const ros2_interface::msg::WarningCommand& ros2_interface::msg::SecurityDecision::motion_alarm() const
{
    return m_motion_alarm;
}

/*!
 * @brief This function returns a reference to member motion_alarm
 * @return Reference to member motion_alarm
 */
ros2_interface::msg::WarningCommand& ros2_interface::msg::SecurityDecision::motion_alarm()
{
    return m_motion_alarm;
}
/*!
 * @brief This function sets a value in member brake_report
 * @param _brake_report New value for member brake_report
 */
void ros2_interface::msg::SecurityDecision::brake_report(
        int32_t _brake_report)
{
    m_brake_report = _brake_report;
}

/*!
 * @brief This function returns the value of member brake_report
 * @return Value of member brake_report
 */
int32_t ros2_interface::msg::SecurityDecision::brake_report() const
{
    return m_brake_report;
}

/*!
 * @brief This function returns a reference to member brake_report
 * @return Reference to member brake_report
 */
int32_t& ros2_interface::msg::SecurityDecision::brake_report()
{
    return m_brake_report;
}

/*!
 * @brief This function sets a value in member change_lane_command
 * @param _change_lane_command New value for member change_lane_command
 */
void ros2_interface::msg::SecurityDecision::change_lane_command(
        int32_t _change_lane_command)
{
    m_change_lane_command = _change_lane_command;
}

/*!
 * @brief This function returns the value of member change_lane_command
 * @return Value of member change_lane_command
 */
int32_t ros2_interface::msg::SecurityDecision::change_lane_command() const
{
    return m_change_lane_command;
}

/*!
 * @brief This function returns a reference to member change_lane_command
 * @return Reference to member change_lane_command
 */
int32_t& ros2_interface::msg::SecurityDecision::change_lane_command()
{
    return m_change_lane_command;
}

/*!
 * @brief This function copies the value in member trajectory_limit_command
 * @param _trajectory_limit_command New value to be copied in member trajectory_limit_command
 */
void ros2_interface::msg::SecurityDecision::trajectory_limit_command(
        const ros2_interface::msg::TrajectoryLimitCommand& _trajectory_limit_command)
{
    m_trajectory_limit_command = _trajectory_limit_command;
}

/*!
 * @brief This function moves the value in member trajectory_limit_command
 * @param _trajectory_limit_command New value to be moved in member trajectory_limit_command
 */
void ros2_interface::msg::SecurityDecision::trajectory_limit_command(
        ros2_interface::msg::TrajectoryLimitCommand&& _trajectory_limit_command)
{
    m_trajectory_limit_command = std::move(_trajectory_limit_command);
}

/*!
 * @brief This function returns a constant reference to member trajectory_limit_command
 * @return Constant reference to member trajectory_limit_command
 */
const ros2_interface::msg::TrajectoryLimitCommand& ros2_interface::msg::SecurityDecision::trajectory_limit_command() const
{
    return m_trajectory_limit_command;
}

/*!
 * @brief This function returns a reference to member trajectory_limit_command
 * @return Reference to member trajectory_limit_command
 */
ros2_interface::msg::TrajectoryLimitCommand& ros2_interface::msg::SecurityDecision::trajectory_limit_command()
{
    return m_trajectory_limit_command;
}
/*!
 * @brief This function sets a value in member park_command
 * @param _park_command New value for member park_command
 */
void ros2_interface::msg::SecurityDecision::park_command(
        int32_t _park_command)
{
    m_park_command = _park_command;
}

/*!
 * @brief This function returns the value of member park_command
 * @return Value of member park_command
 */
int32_t ros2_interface::msg::SecurityDecision::park_command() const
{
    return m_park_command;
}

/*!
 * @brief This function returns a reference to member park_command
 * @return Reference to member park_command
 */
int32_t& ros2_interface::msg::SecurityDecision::park_command()
{
    return m_park_command;
}

/*!
 * @brief This function sets a value in member drivingmode_report
 * @param _drivingmode_report New value for member drivingmode_report
 */
void ros2_interface::msg::SecurityDecision::drivingmode_report(
        int32_t _drivingmode_report)
{
    m_drivingmode_report = _drivingmode_report;
}

/*!
 * @brief This function returns the value of member drivingmode_report
 * @return Value of member drivingmode_report
 */
int32_t ros2_interface::msg::SecurityDecision::drivingmode_report() const
{
    return m_drivingmode_report;
}

/*!
 * @brief This function returns a reference to member drivingmode_report
 * @return Reference to member drivingmode_report
 */
int32_t& ros2_interface::msg::SecurityDecision::drivingmode_report()
{
    return m_drivingmode_report;
}



size_t ros2_interface::msg::SecurityDecision::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SecurityDecision_max_key_cdr_typesize;
}

bool ros2_interface::msg::SecurityDecision::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SecurityDecision::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



