// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SecurityDecision.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SECURITYDECISION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SECURITYDECISION_H_

#include "Header.h"
#include "TrajectoryLimitCommand.h"
#include "WarningCommand.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(SECURITYDECISION_SOURCE)
#define SECURITYDECISION_DllAPI __declspec( dllexport )
#else
#define SECURITYDECISION_DllAPI __declspec( dllimport )
#endif // SECURITYDECISION_SOURCE
#else
#define SECURITYDECISION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define SECURITYDECISION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure SecurityDecision defined by the user in the IDL file.
         * @ingroup SecurityDecision
         */
        class SecurityDecision
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport SecurityDecision();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~SecurityDecision();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::SecurityDecision that will be copied.
             */
            eProsima_user_DllExport SecurityDecision(
                    const SecurityDecision& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::SecurityDecision that will be copied.
             */
            eProsima_user_DllExport SecurityDecision(
                    SecurityDecision&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::SecurityDecision that will be copied.
             */
            eProsima_user_DllExport SecurityDecision& operator =(
                    const SecurityDecision& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::SecurityDecision that will be copied.
             */
            eProsima_user_DllExport SecurityDecision& operator =(
                    SecurityDecision&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SecurityDecision object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const SecurityDecision& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SecurityDecision object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const SecurityDecision& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member warning_command
             * @param _warning_command New value to be copied in member warning_command
             */
            eProsima_user_DllExport void warning_command(
                    const ros2_interface::msg::WarningCommand& _warning_command);

            /*!
             * @brief This function moves the value in member warning_command
             * @param _warning_command New value to be moved in member warning_command
             */
            eProsima_user_DllExport void warning_command(
                    ros2_interface::msg::WarningCommand&& _warning_command);

            /*!
             * @brief This function returns a constant reference to member warning_command
             * @return Constant reference to member warning_command
             */
            eProsima_user_DllExport const ros2_interface::msg::WarningCommand& warning_command() const;

            /*!
             * @brief This function returns a reference to member warning_command
             * @return Reference to member warning_command
             */
            eProsima_user_DllExport ros2_interface::msg::WarningCommand& warning_command();
            /*!
             * @brief This function copies the value in member motion_alarm
             * @param _motion_alarm New value to be copied in member motion_alarm
             */
            eProsima_user_DllExport void motion_alarm(
                    const ros2_interface::msg::WarningCommand& _motion_alarm);

            /*!
             * @brief This function moves the value in member motion_alarm
             * @param _motion_alarm New value to be moved in member motion_alarm
             */
            eProsima_user_DllExport void motion_alarm(
                    ros2_interface::msg::WarningCommand&& _motion_alarm);

            /*!
             * @brief This function returns a constant reference to member motion_alarm
             * @return Constant reference to member motion_alarm
             */
            eProsima_user_DllExport const ros2_interface::msg::WarningCommand& motion_alarm() const;

            /*!
             * @brief This function returns a reference to member motion_alarm
             * @return Reference to member motion_alarm
             */
            eProsima_user_DllExport ros2_interface::msg::WarningCommand& motion_alarm();
            /*!
             * @brief This function sets a value in member brake_report
             * @param _brake_report New value for member brake_report
             */
            eProsima_user_DllExport void brake_report(
                    int32_t _brake_report);

            /*!
             * @brief This function returns the value of member brake_report
             * @return Value of member brake_report
             */
            eProsima_user_DllExport int32_t brake_report() const;

            /*!
             * @brief This function returns a reference to member brake_report
             * @return Reference to member brake_report
             */
            eProsima_user_DllExport int32_t& brake_report();

            /*!
             * @brief This function sets a value in member change_lane_command
             * @param _change_lane_command New value for member change_lane_command
             */
            eProsima_user_DllExport void change_lane_command(
                    int32_t _change_lane_command);

            /*!
             * @brief This function returns the value of member change_lane_command
             * @return Value of member change_lane_command
             */
            eProsima_user_DllExport int32_t change_lane_command() const;

            /*!
             * @brief This function returns a reference to member change_lane_command
             * @return Reference to member change_lane_command
             */
            eProsima_user_DllExport int32_t& change_lane_command();

            /*!
             * @brief This function copies the value in member trajectory_limit_command
             * @param _trajectory_limit_command New value to be copied in member trajectory_limit_command
             */
            eProsima_user_DllExport void trajectory_limit_command(
                    const ros2_interface::msg::TrajectoryLimitCommand& _trajectory_limit_command);

            /*!
             * @brief This function moves the value in member trajectory_limit_command
             * @param _trajectory_limit_command New value to be moved in member trajectory_limit_command
             */
            eProsima_user_DllExport void trajectory_limit_command(
                    ros2_interface::msg::TrajectoryLimitCommand&& _trajectory_limit_command);

            /*!
             * @brief This function returns a constant reference to member trajectory_limit_command
             * @return Constant reference to member trajectory_limit_command
             */
            eProsima_user_DllExport const ros2_interface::msg::TrajectoryLimitCommand& trajectory_limit_command() const;

            /*!
             * @brief This function returns a reference to member trajectory_limit_command
             * @return Reference to member trajectory_limit_command
             */
            eProsima_user_DllExport ros2_interface::msg::TrajectoryLimitCommand& trajectory_limit_command();
            /*!
             * @brief This function sets a value in member park_command
             * @param _park_command New value for member park_command
             */
            eProsima_user_DllExport void park_command(
                    int32_t _park_command);

            /*!
             * @brief This function returns the value of member park_command
             * @return Value of member park_command
             */
            eProsima_user_DllExport int32_t park_command() const;

            /*!
             * @brief This function returns a reference to member park_command
             * @return Reference to member park_command
             */
            eProsima_user_DllExport int32_t& park_command();

            /*!
             * @brief This function sets a value in member drivingmode_report
             * @param _drivingmode_report New value for member drivingmode_report
             */
            eProsima_user_DllExport void drivingmode_report(
                    int32_t _drivingmode_report);

            /*!
             * @brief This function returns the value of member drivingmode_report
             * @return Value of member drivingmode_report
             */
            eProsima_user_DllExport int32_t drivingmode_report() const;

            /*!
             * @brief This function returns a reference to member drivingmode_report
             * @return Reference to member drivingmode_report
             */
            eProsima_user_DllExport int32_t& drivingmode_report();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::SecurityDecision& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            ros2_interface::msg::WarningCommand m_warning_command;
            ros2_interface::msg::WarningCommand m_motion_alarm;
            int32_t m_brake_report;
            int32_t m_change_lane_command;
            ros2_interface::msg::TrajectoryLimitCommand m_trajectory_limit_command;
            int32_t m_park_command;
            int32_t m_drivingmode_report;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SECURITYDECISION_H_

