// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SecurityDecisionTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "SecurityDecision.h"
#include "SecurityDecisionTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerSecurityDecisionTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::WarningCommand", ros2_interface::msg::GetWarningCommandIdentifier(true),
                        ros2_interface::msg::GetWarningCommandObject(true));
                factory->add_type_object("ros2_interface::msg::WarningCommand", ros2_interface::msg::GetWarningCommandIdentifier(false),
                        ros2_interface::msg::GetWarningCommandObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryLimitCommand", ros2_interface::msg::GetTrajectoryLimitCommandIdentifier(true),
                        ros2_interface::msg::GetTrajectoryLimitCommandObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryLimitCommand", ros2_interface::msg::GetTrajectoryLimitCommandIdentifier(false),
                        ros2_interface::msg::GetTrajectoryLimitCommandObject(false));



                factory->add_type_object("ros2_interface::msg::SecurityDecision", ros2_interface::msg::GetSecurityDecisionIdentifier(true),
                        ros2_interface::msg::GetSecurityDecisionObject(true));
                factory->add_type_object("ros2_interface::msg::SecurityDecision", ros2_interface::msg::GetSecurityDecisionIdentifier(false),
                        ros2_interface::msg::GetSecurityDecisionObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetSecurityDecisionIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("SecurityDecision", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetSecurityDecisionObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("SecurityDecision", complete);
        }

        const TypeObject* GetSecurityDecisionObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SecurityDecision", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteSecurityDecisionObject();
            }
            //else
            return GetMinimalSecurityDecisionObject();
        }

        const TypeObject* GetMinimalSecurityDecisionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SecurityDecision", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_warning_command;
            mst_warning_command.common().member_id(memberId++);
            mst_warning_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_warning_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_warning_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_warning_command.common().member_flags().IS_OPTIONAL(false);
            mst_warning_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_warning_command.common().member_flags().IS_KEY(false);
            mst_warning_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_warning_command.common().member_type_id(*ros2_interface::msg::GetWarningCommandIdentifier(false));
            MD5 warning_command_hash("warning_command");
            for(int i = 0; i < 4; ++i)
            {
                mst_warning_command.detail().name_hash()[i] = warning_command_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_warning_command);

            MinimalStructMember mst_motion_alarm;
            mst_motion_alarm.common().member_id(memberId++);
            mst_motion_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_motion_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_motion_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_motion_alarm.common().member_flags().IS_OPTIONAL(false);
            mst_motion_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_motion_alarm.common().member_flags().IS_KEY(false);
            mst_motion_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_motion_alarm.common().member_type_id(*ros2_interface::msg::GetWarningCommandIdentifier(false));
            MD5 motion_alarm_hash("motion_alarm");
            for(int i = 0; i < 4; ++i)
            {
                mst_motion_alarm.detail().name_hash()[i] = motion_alarm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_motion_alarm);

            MinimalStructMember mst_brake_report;
            mst_brake_report.common().member_id(memberId++);
            mst_brake_report.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_report.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_report.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_report.common().member_flags().IS_OPTIONAL(false);
            mst_brake_report.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_report.common().member_flags().IS_KEY(false);
            mst_brake_report.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_report.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_report_hash("brake_report");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_report.detail().name_hash()[i] = brake_report_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_report);

            MinimalStructMember mst_change_lane_command;
            mst_change_lane_command.common().member_id(memberId++);
            mst_change_lane_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_change_lane_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_change_lane_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_change_lane_command.common().member_flags().IS_OPTIONAL(false);
            mst_change_lane_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_change_lane_command.common().member_flags().IS_KEY(false);
            mst_change_lane_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_change_lane_command.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 change_lane_command_hash("change_lane_command");
            for(int i = 0; i < 4; ++i)
            {
                mst_change_lane_command.detail().name_hash()[i] = change_lane_command_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_change_lane_command);

            MinimalStructMember mst_trajectory_limit_command;
            mst_trajectory_limit_command.common().member_id(memberId++);
            mst_trajectory_limit_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_trajectory_limit_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_trajectory_limit_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_trajectory_limit_command.common().member_flags().IS_OPTIONAL(false);
            mst_trajectory_limit_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_trajectory_limit_command.common().member_flags().IS_KEY(false);
            mst_trajectory_limit_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_trajectory_limit_command.common().member_type_id(*ros2_interface::msg::GetTrajectoryLimitCommandIdentifier(false));
            MD5 trajectory_limit_command_hash("trajectory_limit_command");
            for(int i = 0; i < 4; ++i)
            {
                mst_trajectory_limit_command.detail().name_hash()[i] = trajectory_limit_command_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_trajectory_limit_command);

            MinimalStructMember mst_park_command;
            mst_park_command.common().member_id(memberId++);
            mst_park_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_park_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_park_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_park_command.common().member_flags().IS_OPTIONAL(false);
            mst_park_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_park_command.common().member_flags().IS_KEY(false);
            mst_park_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_park_command.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 park_command_hash("park_command");
            for(int i = 0; i < 4; ++i)
            {
                mst_park_command.detail().name_hash()[i] = park_command_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_park_command);

            MinimalStructMember mst_drivingmode_report;
            mst_drivingmode_report.common().member_id(memberId++);
            mst_drivingmode_report.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_drivingmode_report.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_drivingmode_report.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_drivingmode_report.common().member_flags().IS_OPTIONAL(false);
            mst_drivingmode_report.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_drivingmode_report.common().member_flags().IS_KEY(false);
            mst_drivingmode_report.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_drivingmode_report.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 drivingmode_report_hash("drivingmode_report");
            for(int i = 0; i < 4; ++i)
            {
                mst_drivingmode_report.detail().name_hash()[i] = drivingmode_report_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_drivingmode_report);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SecurityDecision", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SecurityDecision", false);
        }

        const TypeObject* GetCompleteSecurityDecisionObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SecurityDecision", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_warning_command;
            cst_warning_command.common().member_id(memberId++);
            cst_warning_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_warning_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_warning_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_warning_command.common().member_flags().IS_OPTIONAL(false);
            cst_warning_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_warning_command.common().member_flags().IS_KEY(false);
            cst_warning_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_warning_command.common().member_type_id(*ros2_interface::msg::GetWarningCommandIdentifier(true));
            cst_warning_command.detail().name("warning_command");

            type_object->complete().struct_type().member_seq().emplace_back(cst_warning_command);

            CompleteStructMember cst_motion_alarm;
            cst_motion_alarm.common().member_id(memberId++);
            cst_motion_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_motion_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_motion_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_motion_alarm.common().member_flags().IS_OPTIONAL(false);
            cst_motion_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_motion_alarm.common().member_flags().IS_KEY(false);
            cst_motion_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_motion_alarm.common().member_type_id(*ros2_interface::msg::GetWarningCommandIdentifier(true));
            cst_motion_alarm.detail().name("motion_alarm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_motion_alarm);

            CompleteStructMember cst_brake_report;
            cst_brake_report.common().member_id(memberId++);
            cst_brake_report.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_report.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_report.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_report.common().member_flags().IS_OPTIONAL(false);
            cst_brake_report.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_report.common().member_flags().IS_KEY(false);
            cst_brake_report.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_report.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_report.detail().name("brake_report");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_report);

            CompleteStructMember cst_change_lane_command;
            cst_change_lane_command.common().member_id(memberId++);
            cst_change_lane_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_change_lane_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_change_lane_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_change_lane_command.common().member_flags().IS_OPTIONAL(false);
            cst_change_lane_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_change_lane_command.common().member_flags().IS_KEY(false);
            cst_change_lane_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_change_lane_command.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_change_lane_command.detail().name("change_lane_command");

            type_object->complete().struct_type().member_seq().emplace_back(cst_change_lane_command);

            CompleteStructMember cst_trajectory_limit_command;
            cst_trajectory_limit_command.common().member_id(memberId++);
            cst_trajectory_limit_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_trajectory_limit_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_trajectory_limit_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_trajectory_limit_command.common().member_flags().IS_OPTIONAL(false);
            cst_trajectory_limit_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_trajectory_limit_command.common().member_flags().IS_KEY(false);
            cst_trajectory_limit_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_trajectory_limit_command.common().member_type_id(*ros2_interface::msg::GetTrajectoryLimitCommandIdentifier(true));
            cst_trajectory_limit_command.detail().name("trajectory_limit_command");

            type_object->complete().struct_type().member_seq().emplace_back(cst_trajectory_limit_command);

            CompleteStructMember cst_park_command;
            cst_park_command.common().member_id(memberId++);
            cst_park_command.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_park_command.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_park_command.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_park_command.common().member_flags().IS_OPTIONAL(false);
            cst_park_command.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_park_command.common().member_flags().IS_KEY(false);
            cst_park_command.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_park_command.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_park_command.detail().name("park_command");

            type_object->complete().struct_type().member_seq().emplace_back(cst_park_command);

            CompleteStructMember cst_drivingmode_report;
            cst_drivingmode_report.common().member_id(memberId++);
            cst_drivingmode_report.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_drivingmode_report.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_drivingmode_report.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_drivingmode_report.common().member_flags().IS_OPTIONAL(false);
            cst_drivingmode_report.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_drivingmode_report.common().member_flags().IS_KEY(false);
            cst_drivingmode_report.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_drivingmode_report.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_drivingmode_report.detail().name("drivingmode_report");

            type_object->complete().struct_type().member_seq().emplace_back(cst_drivingmode_report);


            // Header
            type_object->complete().struct_type().header().detail().type_name("SecurityDecision");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SecurityDecision", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SecurityDecision", true);
        }

    } // namespace msg
} // namespace ros2_interface