// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SensorCalibrator.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SensorCalibrator.h"
#include "SensorCalibratorTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_SensorCalibrator_max_cdr_typesize 48ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_SensorCalibrator_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SensorCalibrator::SensorCalibrator()
{
    // ros2_interface::msg::Point3D m_pose

    // ros2_interface::msg::Point3D m_angle


    // Just to register all known types
    registerSensorCalibratorTypes();
}

ros2_interface::msg::SensorCalibrator::~SensorCalibrator()
{


}

ros2_interface::msg::SensorCalibrator::SensorCalibrator(
        const SensorCalibrator& x)
{
    m_pose = x.m_pose;
    m_angle = x.m_angle;
}

ros2_interface::msg::SensorCalibrator::SensorCalibrator(
        SensorCalibrator&& x) noexcept 
{
    m_pose = std::move(x.m_pose);
    m_angle = std::move(x.m_angle);
}

ros2_interface::msg::SensorCalibrator& ros2_interface::msg::SensorCalibrator::operator =(
        const SensorCalibrator& x)
{

    m_pose = x.m_pose;
    m_angle = x.m_angle;

    return *this;
}

ros2_interface::msg::SensorCalibrator& ros2_interface::msg::SensorCalibrator::operator =(
        SensorCalibrator&& x) noexcept
{

    m_pose = std::move(x.m_pose);
    m_angle = std::move(x.m_angle);

    return *this;
}

bool ros2_interface::msg::SensorCalibrator::operator ==(
        const SensorCalibrator& x) const
{

    return (m_pose == x.m_pose && m_angle == x.m_angle);
}

bool ros2_interface::msg::SensorCalibrator::operator !=(
        const SensorCalibrator& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SensorCalibrator::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SensorCalibrator_max_cdr_typesize;
}

size_t ros2_interface::msg::SensorCalibrator::getCdrSerializedSize(
        const ros2_interface::msg::SensorCalibrator& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.pose(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angle(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SensorCalibrator::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_pose;
    scdr << m_angle;

}

void ros2_interface::msg::SensorCalibrator::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_pose;
    dcdr >> m_angle;
}

/*!
 * @brief This function copies the value in member pose
 * @param _pose New value to be copied in member pose
 */
void ros2_interface::msg::SensorCalibrator::pose(
        const ros2_interface::msg::Point3D& _pose)
{
    m_pose = _pose;
}

/*!
 * @brief This function moves the value in member pose
 * @param _pose New value to be moved in member pose
 */
void ros2_interface::msg::SensorCalibrator::pose(
        ros2_interface::msg::Point3D&& _pose)
{
    m_pose = std::move(_pose);
}

/*!
 * @brief This function returns a constant reference to member pose
 * @return Constant reference to member pose
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::SensorCalibrator::pose() const
{
    return m_pose;
}

/*!
 * @brief This function returns a reference to member pose
 * @return Reference to member pose
 */
ros2_interface::msg::Point3D& ros2_interface::msg::SensorCalibrator::pose()
{
    return m_pose;
}
/*!
 * @brief This function copies the value in member angle
 * @param _angle New value to be copied in member angle
 */
void ros2_interface::msg::SensorCalibrator::angle(
        const ros2_interface::msg::Point3D& _angle)
{
    m_angle = _angle;
}

/*!
 * @brief This function moves the value in member angle
 * @param _angle New value to be moved in member angle
 */
void ros2_interface::msg::SensorCalibrator::angle(
        ros2_interface::msg::Point3D&& _angle)
{
    m_angle = std::move(_angle);
}

/*!
 * @brief This function returns a constant reference to member angle
 * @return Constant reference to member angle
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::SensorCalibrator::angle() const
{
    return m_angle;
}

/*!
 * @brief This function returns a reference to member angle
 * @return Reference to member angle
 */
ros2_interface::msg::Point3D& ros2_interface::msg::SensorCalibrator::angle()
{
    return m_angle;
}


size_t ros2_interface::msg::SensorCalibrator::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SensorCalibrator_max_key_cdr_typesize;
}

bool ros2_interface::msg::SensorCalibrator::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SensorCalibrator::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



