// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SensorCalibrator.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SENSORCALIBRATOR_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SENSORCALIBRATOR_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(SENSORCALIBRATOR_SOURCE)
#define SENSORCALIBRATOR_DllAPI __declspec( dllexport )
#else
#define SENSORCALIBRATOR_DllAPI __declspec( dllimport )
#endif // SENSORCALIBRATOR_SOURCE
#else
#define SENSORCALIBRATOR_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define SENSORCALIBRATOR_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure SensorCalibrator defined by the user in the IDL file.
         * @ingroup SensorCalibrator
         */
        class SensorCalibrator
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport SensorCalibrator();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~SensorCalibrator();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::SensorCalibrator that will be copied.
             */
            eProsima_user_DllExport SensorCalibrator(
                    const SensorCalibrator& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::SensorCalibrator that will be copied.
             */
            eProsima_user_DllExport SensorCalibrator(
                    SensorCalibrator&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::SensorCalibrator that will be copied.
             */
            eProsima_user_DllExport SensorCalibrator& operator =(
                    const SensorCalibrator& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::SensorCalibrator that will be copied.
             */
            eProsima_user_DllExport SensorCalibrator& operator =(
                    SensorCalibrator&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SensorCalibrator object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const SensorCalibrator& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SensorCalibrator object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const SensorCalibrator& x) const;

            /*!
             * @brief This function copies the value in member pose
             * @param _pose New value to be copied in member pose
             */
            eProsima_user_DllExport void pose(
                    const ros2_interface::msg::Point3D& _pose);

            /*!
             * @brief This function moves the value in member pose
             * @param _pose New value to be moved in member pose
             */
            eProsima_user_DllExport void pose(
                    ros2_interface::msg::Point3D&& _pose);

            /*!
             * @brief This function returns a constant reference to member pose
             * @return Constant reference to member pose
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& pose() const;

            /*!
             * @brief This function returns a reference to member pose
             * @return Reference to member pose
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& pose();
            /*!
             * @brief This function copies the value in member angle
             * @param _angle New value to be copied in member angle
             */
            eProsima_user_DllExport void angle(
                    const ros2_interface::msg::Point3D& _angle);

            /*!
             * @brief This function moves the value in member angle
             * @param _angle New value to be moved in member angle
             */
            eProsima_user_DllExport void angle(
                    ros2_interface::msg::Point3D&& _angle);

            /*!
             * @brief This function returns a constant reference to member angle
             * @return Constant reference to member angle
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angle() const;

            /*!
             * @brief This function returns a reference to member angle
             * @return Reference to member angle
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angle();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::SensorCalibrator& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Point3D m_pose;
            ros2_interface::msg::Point3D m_angle;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SENSORCALIBRATOR_H_

