// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SensorCalibratorTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "SensorCalibrator.h"
#include "SensorCalibratorTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerSensorCalibratorTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::SensorCalibrator", ros2_interface::msg::GetSensorCalibratorIdentifier(true),
                        ros2_interface::msg::GetSensorCalibratorObject(true));
                factory->add_type_object("ros2_interface::msg::SensorCalibrator", ros2_interface::msg::GetSensorCalibratorIdentifier(false),
                        ros2_interface::msg::GetSensorCalibratorObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetSensorCalibratorIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("SensorCalibrator", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetSensorCalibratorObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("SensorCalibrator", complete);
        }

        const TypeObject* GetSensorCalibratorObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SensorCalibrator", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteSensorCalibratorObject();
            }
            //else
            return GetMinimalSensorCalibratorObject();
        }

        const TypeObject* GetMinimalSensorCalibratorObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SensorCalibrator", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_pose;
            mst_pose.common().member_id(memberId++);
            mst_pose.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pose.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pose.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pose.common().member_flags().IS_OPTIONAL(false);
            mst_pose.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pose.common().member_flags().IS_KEY(false);
            mst_pose.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pose.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 pose_hash("pose");
            for(int i = 0; i < 4; ++i)
            {
                mst_pose.detail().name_hash()[i] = pose_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pose);

            MinimalStructMember mst_angle;
            mst_angle.common().member_id(memberId++);
            mst_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angle.common().member_flags().IS_OPTIONAL(false);
            mst_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angle.common().member_flags().IS_KEY(false);
            mst_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angle_hash("angle");
            for(int i = 0; i < 4; ++i)
            {
                mst_angle.detail().name_hash()[i] = angle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angle);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SensorCalibrator", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SensorCalibrator", false);
        }

        const TypeObject* GetCompleteSensorCalibratorObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SensorCalibrator", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_pose;
            cst_pose.common().member_id(memberId++);
            cst_pose.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pose.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pose.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pose.common().member_flags().IS_OPTIONAL(false);
            cst_pose.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pose.common().member_flags().IS_KEY(false);
            cst_pose.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pose.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_pose.detail().name("pose");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pose);

            CompleteStructMember cst_angle;
            cst_angle.common().member_id(memberId++);
            cst_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angle.common().member_flags().IS_OPTIONAL(false);
            cst_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angle.common().member_flags().IS_KEY(false);
            cst_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angle.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angle.detail().name("angle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angle);


            // Header
            type_object->complete().struct_type().header().detail().type_name("SensorCalibrator");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SensorCalibrator", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SensorCalibrator", true);
        }

    } // namespace msg
} // namespace ros2_interface