// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SotifMonitorResult.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SotifMonitorResult.h"
#include "SotifMonitorResultTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_SLPoint_max_cdr_typesize 16ULL;
#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Grid_max_cdr_typesize 52ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_SotifMonitorResult_max_cdr_typesize 248276ULL;
#define ros2_interface_msg_Region_max_cdr_typesize 2424ULL;
#define ros2_interface_msg_SLPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Grid_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_SotifMonitorResult_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Region_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SotifMonitorResult::SotifMonitorResult()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::Region> m_region_value

    // sequence<ros2_interface::msg::Grid> m_grid_map


    // Just to register all known types
    registerSotifMonitorResultTypes();
}

ros2_interface::msg::SotifMonitorResult::~SotifMonitorResult()
{



}

ros2_interface::msg::SotifMonitorResult::SotifMonitorResult(
        const SotifMonitorResult& x)
{
    m_header = x.m_header;
    m_region_value = x.m_region_value;
    m_grid_map = x.m_grid_map;
}

ros2_interface::msg::SotifMonitorResult::SotifMonitorResult(
        SotifMonitorResult&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_region_value = std::move(x.m_region_value);
    m_grid_map = std::move(x.m_grid_map);
}

ros2_interface::msg::SotifMonitorResult& ros2_interface::msg::SotifMonitorResult::operator =(
        const SotifMonitorResult& x)
{

    m_header = x.m_header;
    m_region_value = x.m_region_value;
    m_grid_map = x.m_grid_map;

    return *this;
}

ros2_interface::msg::SotifMonitorResult& ros2_interface::msg::SotifMonitorResult::operator =(
        SotifMonitorResult&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_region_value = std::move(x.m_region_value);
    m_grid_map = std::move(x.m_grid_map);

    return *this;
}

bool ros2_interface::msg::SotifMonitorResult::operator ==(
        const SotifMonitorResult& x) const
{

    return (m_header == x.m_header && m_region_value == x.m_region_value && m_grid_map == x.m_grid_map);
}

bool ros2_interface::msg::SotifMonitorResult::operator !=(
        const SotifMonitorResult& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SotifMonitorResult::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SotifMonitorResult_max_cdr_typesize;
}

size_t ros2_interface::msg::SotifMonitorResult::getCdrSerializedSize(
        const ros2_interface::msg::SotifMonitorResult& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.region_value().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Region::getCdrSerializedSize(data.region_value().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.grid_map().size(); ++a)
    {
        current_alignment += ros2_interface::msg::Grid::getCdrSerializedSize(data.grid_map().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SotifMonitorResult::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_region_value;
    scdr << m_grid_map;

}

void ros2_interface::msg::SotifMonitorResult::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_region_value;
    dcdr >> m_grid_map;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::SotifMonitorResult::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::SotifMonitorResult::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::SotifMonitorResult::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::SotifMonitorResult::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member region_value
 * @param _region_value New value to be copied in member region_value
 */
void ros2_interface::msg::SotifMonitorResult::region_value(
        const std::vector<ros2_interface::msg::Region>& _region_value)
{
    m_region_value = _region_value;
}

/*!
 * @brief This function moves the value in member region_value
 * @param _region_value New value to be moved in member region_value
 */
void ros2_interface::msg::SotifMonitorResult::region_value(
        std::vector<ros2_interface::msg::Region>&& _region_value)
{
    m_region_value = std::move(_region_value);
}

/*!
 * @brief This function returns a constant reference to member region_value
 * @return Constant reference to member region_value
 */
const std::vector<ros2_interface::msg::Region>& ros2_interface::msg::SotifMonitorResult::region_value() const
{
    return m_region_value;
}

/*!
 * @brief This function returns a reference to member region_value
 * @return Reference to member region_value
 */
std::vector<ros2_interface::msg::Region>& ros2_interface::msg::SotifMonitorResult::region_value()
{
    return m_region_value;
}
/*!
 * @brief This function copies the value in member grid_map
 * @param _grid_map New value to be copied in member grid_map
 */
void ros2_interface::msg::SotifMonitorResult::grid_map(
        const std::vector<ros2_interface::msg::Grid>& _grid_map)
{
    m_grid_map = _grid_map;
}

/*!
 * @brief This function moves the value in member grid_map
 * @param _grid_map New value to be moved in member grid_map
 */
void ros2_interface::msg::SotifMonitorResult::grid_map(
        std::vector<ros2_interface::msg::Grid>&& _grid_map)
{
    m_grid_map = std::move(_grid_map);
}

/*!
 * @brief This function returns a constant reference to member grid_map
 * @return Constant reference to member grid_map
 */
const std::vector<ros2_interface::msg::Grid>& ros2_interface::msg::SotifMonitorResult::grid_map() const
{
    return m_grid_map;
}

/*!
 * @brief This function returns a reference to member grid_map
 * @return Reference to member grid_map
 */
std::vector<ros2_interface::msg::Grid>& ros2_interface::msg::SotifMonitorResult::grid_map()
{
    return m_grid_map;
}


size_t ros2_interface::msg::SotifMonitorResult::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SotifMonitorResult_max_key_cdr_typesize;
}

bool ros2_interface::msg::SotifMonitorResult::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SotifMonitorResult::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



