// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SotifMonitorResult.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SOTIFMONITORRESULT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SOTIFMONITORRESULT_H_

#include "Header.h"
#include "Grid.h"
#include "Region.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(SOTIFMONITORRESULT_SOURCE)
#define SOTIFMONITORRESULT_DllAPI __declspec( dllexport )
#else
#define SOTIFMONITORRESULT_DllAPI __declspec( dllimport )
#endif // SOTIFMONITORRESULT_SOURCE
#else
#define SOTIFMONITORRESULT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define SOTIFMONITORRESULT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure SotifMonitorResult defined by the user in the IDL file.
         * @ingroup SotifMonitorResult
         */
        class SotifMonitorResult
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport SotifMonitorResult();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~SotifMonitorResult();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::SotifMonitorResult that will be copied.
             */
            eProsima_user_DllExport SotifMonitorResult(
                    const SotifMonitorResult& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::SotifMonitorResult that will be copied.
             */
            eProsima_user_DllExport SotifMonitorResult(
                    SotifMonitorResult&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::SotifMonitorResult that will be copied.
             */
            eProsima_user_DllExport SotifMonitorResult& operator =(
                    const SotifMonitorResult& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::SotifMonitorResult that will be copied.
             */
            eProsima_user_DllExport SotifMonitorResult& operator =(
                    SotifMonitorResult&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SotifMonitorResult object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const SotifMonitorResult& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SotifMonitorResult object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const SotifMonitorResult& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member region_value
             * @param _region_value New value to be copied in member region_value
             */
            eProsima_user_DllExport void region_value(
                    const std::vector<ros2_interface::msg::Region>& _region_value);

            /*!
             * @brief This function moves the value in member region_value
             * @param _region_value New value to be moved in member region_value
             */
            eProsima_user_DllExport void region_value(
                    std::vector<ros2_interface::msg::Region>&& _region_value);

            /*!
             * @brief This function returns a constant reference to member region_value
             * @return Constant reference to member region_value
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Region>& region_value() const;

            /*!
             * @brief This function returns a reference to member region_value
             * @return Reference to member region_value
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Region>& region_value();
            /*!
             * @brief This function copies the value in member grid_map
             * @param _grid_map New value to be copied in member grid_map
             */
            eProsima_user_DllExport void grid_map(
                    const std::vector<ros2_interface::msg::Grid>& _grid_map);

            /*!
             * @brief This function moves the value in member grid_map
             * @param _grid_map New value to be moved in member grid_map
             */
            eProsima_user_DllExport void grid_map(
                    std::vector<ros2_interface::msg::Grid>&& _grid_map);

            /*!
             * @brief This function returns a constant reference to member grid_map
             * @return Constant reference to member grid_map
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::Grid>& grid_map() const;

            /*!
             * @brief This function returns a reference to member grid_map
             * @return Reference to member grid_map
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::Grid>& grid_map();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::SotifMonitorResult& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::vector<ros2_interface::msg::Region> m_region_value;
            std::vector<ros2_interface::msg::Grid> m_grid_map;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SOTIFMONITORRESULT_H_

