// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SpeedPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "SpeedPoint.h"
#include "SpeedPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_SpeedPoint_max_cdr_typesize 40ULL;
#define ros2_interface_msg_SpeedPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::SpeedPoint::SpeedPoint()
{
    // double m_s
    m_s = 0.0;
    // double m_t
    m_t = 0.0;
    // double m_v
    m_v = 0.0;
    // double m_a
    m_a = 0.0;
    // double m_da
    m_da = 0.0;

    // Just to register all known types
    registerSpeedPointTypes();
}

ros2_interface::msg::SpeedPoint::~SpeedPoint()
{





}

ros2_interface::msg::SpeedPoint::SpeedPoint(
        const SpeedPoint& x)
{
    m_s = x.m_s;
    m_t = x.m_t;
    m_v = x.m_v;
    m_a = x.m_a;
    m_da = x.m_da;
}

ros2_interface::msg::SpeedPoint::SpeedPoint(
        SpeedPoint&& x) noexcept 
{
    m_s = x.m_s;
    m_t = x.m_t;
    m_v = x.m_v;
    m_a = x.m_a;
    m_da = x.m_da;
}

ros2_interface::msg::SpeedPoint& ros2_interface::msg::SpeedPoint::operator =(
        const SpeedPoint& x)
{

    m_s = x.m_s;
    m_t = x.m_t;
    m_v = x.m_v;
    m_a = x.m_a;
    m_da = x.m_da;

    return *this;
}

ros2_interface::msg::SpeedPoint& ros2_interface::msg::SpeedPoint::operator =(
        SpeedPoint&& x) noexcept
{

    m_s = x.m_s;
    m_t = x.m_t;
    m_v = x.m_v;
    m_a = x.m_a;
    m_da = x.m_da;

    return *this;
}

bool ros2_interface::msg::SpeedPoint::operator ==(
        const SpeedPoint& x) const
{

    return (m_s == x.m_s && m_t == x.m_t && m_v == x.m_v && m_a == x.m_a && m_da == x.m_da);
}

bool ros2_interface::msg::SpeedPoint::operator !=(
        const SpeedPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::SpeedPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SpeedPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::SpeedPoint::getCdrSerializedSize(
        const ros2_interface::msg::SpeedPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::SpeedPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_s;
    scdr << m_t;
    scdr << m_v;
    scdr << m_a;
    scdr << m_da;

}

void ros2_interface::msg::SpeedPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_s;
    dcdr >> m_t;
    dcdr >> m_v;
    dcdr >> m_a;
    dcdr >> m_da;
}

/*!
 * @brief This function sets a value in member s
 * @param _s New value for member s
 */
void ros2_interface::msg::SpeedPoint::s(
        double _s)
{
    m_s = _s;
}

/*!
 * @brief This function returns the value of member s
 * @return Value of member s
 */
double ros2_interface::msg::SpeedPoint::s() const
{
    return m_s;
}

/*!
 * @brief This function returns a reference to member s
 * @return Reference to member s
 */
double& ros2_interface::msg::SpeedPoint::s()
{
    return m_s;
}

/*!
 * @brief This function sets a value in member t
 * @param _t New value for member t
 */
void ros2_interface::msg::SpeedPoint::t(
        double _t)
{
    m_t = _t;
}

/*!
 * @brief This function returns the value of member t
 * @return Value of member t
 */
double ros2_interface::msg::SpeedPoint::t() const
{
    return m_t;
}

/*!
 * @brief This function returns a reference to member t
 * @return Reference to member t
 */
double& ros2_interface::msg::SpeedPoint::t()
{
    return m_t;
}

/*!
 * @brief This function sets a value in member v
 * @param _v New value for member v
 */
void ros2_interface::msg::SpeedPoint::v(
        double _v)
{
    m_v = _v;
}

/*!
 * @brief This function returns the value of member v
 * @return Value of member v
 */
double ros2_interface::msg::SpeedPoint::v() const
{
    return m_v;
}

/*!
 * @brief This function returns a reference to member v
 * @return Reference to member v
 */
double& ros2_interface::msg::SpeedPoint::v()
{
    return m_v;
}

/*!
 * @brief This function sets a value in member a
 * @param _a New value for member a
 */
void ros2_interface::msg::SpeedPoint::a(
        double _a)
{
    m_a = _a;
}

/*!
 * @brief This function returns the value of member a
 * @return Value of member a
 */
double ros2_interface::msg::SpeedPoint::a() const
{
    return m_a;
}

/*!
 * @brief This function returns a reference to member a
 * @return Reference to member a
 */
double& ros2_interface::msg::SpeedPoint::a()
{
    return m_a;
}

/*!
 * @brief This function sets a value in member da
 * @param _da New value for member da
 */
void ros2_interface::msg::SpeedPoint::da(
        double _da)
{
    m_da = _da;
}

/*!
 * @brief This function returns the value of member da
 * @return Value of member da
 */
double ros2_interface::msg::SpeedPoint::da() const
{
    return m_da;
}

/*!
 * @brief This function returns a reference to member da
 * @return Reference to member da
 */
double& ros2_interface::msg::SpeedPoint::da()
{
    return m_da;
}



size_t ros2_interface::msg::SpeedPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_SpeedPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::SpeedPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::SpeedPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



