// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SpeedPoint.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SPEEDPOINT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SPEEDPOINT_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(SPEEDPOINT_SOURCE)
#define SPEEDPOINT_DllAPI __declspec( dllexport )
#else
#define SPEEDPOINT_DllAPI __declspec( dllimport )
#endif // SPEEDPOINT_SOURCE
#else
#define SPEEDPOINT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define SPEEDPOINT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure SpeedPoint defined by the user in the IDL file.
         * @ingroup SpeedPoint
         */
        class SpeedPoint
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport SpeedPoint();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~SpeedPoint();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::SpeedPoint that will be copied.
             */
            eProsima_user_DllExport SpeedPoint(
                    const SpeedPoint& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::SpeedPoint that will be copied.
             */
            eProsima_user_DllExport SpeedPoint(
                    SpeedPoint&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::SpeedPoint that will be copied.
             */
            eProsima_user_DllExport SpeedPoint& operator =(
                    const SpeedPoint& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::SpeedPoint that will be copied.
             */
            eProsima_user_DllExport SpeedPoint& operator =(
                    SpeedPoint&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SpeedPoint object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const SpeedPoint& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::SpeedPoint object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const SpeedPoint& x) const;

            /*!
             * @brief This function sets a value in member s
             * @param _s New value for member s
             */
            eProsima_user_DllExport void s(
                    double _s);

            /*!
             * @brief This function returns the value of member s
             * @return Value of member s
             */
            eProsima_user_DllExport double s() const;

            /*!
             * @brief This function returns a reference to member s
             * @return Reference to member s
             */
            eProsima_user_DllExport double& s();

            /*!
             * @brief This function sets a value in member t
             * @param _t New value for member t
             */
            eProsima_user_DllExport void t(
                    double _t);

            /*!
             * @brief This function returns the value of member t
             * @return Value of member t
             */
            eProsima_user_DllExport double t() const;

            /*!
             * @brief This function returns a reference to member t
             * @return Reference to member t
             */
            eProsima_user_DllExport double& t();

            /*!
             * @brief This function sets a value in member v
             * @param _v New value for member v
             */
            eProsima_user_DllExport void v(
                    double _v);

            /*!
             * @brief This function returns the value of member v
             * @return Value of member v
             */
            eProsima_user_DllExport double v() const;

            /*!
             * @brief This function returns a reference to member v
             * @return Reference to member v
             */
            eProsima_user_DllExport double& v();

            /*!
             * @brief This function sets a value in member a
             * @param _a New value for member a
             */
            eProsima_user_DllExport void a(
                    double _a);

            /*!
             * @brief This function returns the value of member a
             * @return Value of member a
             */
            eProsima_user_DllExport double a() const;

            /*!
             * @brief This function returns a reference to member a
             * @return Reference to member a
             */
            eProsima_user_DllExport double& a();

            /*!
             * @brief This function sets a value in member da
             * @param _da New value for member da
             */
            eProsima_user_DllExport void da(
                    double _da);

            /*!
             * @brief This function returns the value of member da
             * @return Value of member da
             */
            eProsima_user_DllExport double da() const;

            /*!
             * @brief This function returns a reference to member da
             * @return Reference to member da
             */
            eProsima_user_DllExport double& da();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::SpeedPoint& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            double m_s;
            double m_t;
            double m_v;
            double m_a;
            double m_da;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_SPEEDPOINT_H_

