// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file SpeedPointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "SpeedPoint.h"
#include "SpeedPointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerSpeedPointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::SpeedPoint", ros2_interface::msg::GetSpeedPointIdentifier(true),
                        ros2_interface::msg::GetSpeedPointObject(true));
                factory->add_type_object("ros2_interface::msg::SpeedPoint", ros2_interface::msg::GetSpeedPointIdentifier(false),
                        ros2_interface::msg::GetSpeedPointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetSpeedPointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("SpeedPoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetSpeedPointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("SpeedPoint", complete);
        }

        const TypeObject* GetSpeedPointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SpeedPoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteSpeedPointObject();
            }
            //else
            return GetMinimalSpeedPointObject();
        }

        const TypeObject* GetMinimalSpeedPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SpeedPoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_s;
            mst_s.common().member_id(memberId++);
            mst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_s.common().member_flags().IS_OPTIONAL(false);
            mst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_s.common().member_flags().IS_KEY(false);
            mst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 s_hash("s");
            for(int i = 0; i < 4; ++i)
            {
                mst_s.detail().name_hash()[i] = s_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_s);

            MinimalStructMember mst_t;
            mst_t.common().member_id(memberId++);
            mst_t.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_t.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_t.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_t.common().member_flags().IS_OPTIONAL(false);
            mst_t.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_t.common().member_flags().IS_KEY(false);
            mst_t.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_t.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 t_hash("t");
            for(int i = 0; i < 4; ++i)
            {
                mst_t.detail().name_hash()[i] = t_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_t);

            MinimalStructMember mst_v;
            mst_v.common().member_id(memberId++);
            mst_v.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_v.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_v.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_v.common().member_flags().IS_OPTIONAL(false);
            mst_v.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_v.common().member_flags().IS_KEY(false);
            mst_v.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_v.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 v_hash("v");
            for(int i = 0; i < 4; ++i)
            {
                mst_v.detail().name_hash()[i] = v_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_v);

            MinimalStructMember mst_a;
            mst_a.common().member_id(memberId++);
            mst_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_a.common().member_flags().IS_OPTIONAL(false);
            mst_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_a.common().member_flags().IS_KEY(false);
            mst_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 a_hash("a");
            for(int i = 0; i < 4; ++i)
            {
                mst_a.detail().name_hash()[i] = a_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_a);

            MinimalStructMember mst_da;
            mst_da.common().member_id(memberId++);
            mst_da.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_da.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_da.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_da.common().member_flags().IS_OPTIONAL(false);
            mst_da.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_da.common().member_flags().IS_KEY(false);
            mst_da.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_da.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 da_hash("da");
            for(int i = 0; i < 4; ++i)
            {
                mst_da.detail().name_hash()[i] = da_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_da);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SpeedPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SpeedPoint", false);
        }

        const TypeObject* GetCompleteSpeedPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("SpeedPoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_s;
            cst_s.common().member_id(memberId++);
            cst_s.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_s.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_s.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_s.common().member_flags().IS_OPTIONAL(false);
            cst_s.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_s.common().member_flags().IS_KEY(false);
            cst_s.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_s.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_s.detail().name("s");

            type_object->complete().struct_type().member_seq().emplace_back(cst_s);

            CompleteStructMember cst_t;
            cst_t.common().member_id(memberId++);
            cst_t.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_t.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_t.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_t.common().member_flags().IS_OPTIONAL(false);
            cst_t.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_t.common().member_flags().IS_KEY(false);
            cst_t.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_t.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_t.detail().name("t");

            type_object->complete().struct_type().member_seq().emplace_back(cst_t);

            CompleteStructMember cst_v;
            cst_v.common().member_id(memberId++);
            cst_v.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_v.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_v.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_v.common().member_flags().IS_OPTIONAL(false);
            cst_v.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_v.common().member_flags().IS_KEY(false);
            cst_v.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_v.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_v.detail().name("v");

            type_object->complete().struct_type().member_seq().emplace_back(cst_v);

            CompleteStructMember cst_a;
            cst_a.common().member_id(memberId++);
            cst_a.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_a.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_a.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_a.common().member_flags().IS_OPTIONAL(false);
            cst_a.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_a.common().member_flags().IS_KEY(false);
            cst_a.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_a.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_a.detail().name("a");

            type_object->complete().struct_type().member_seq().emplace_back(cst_a);

            CompleteStructMember cst_da;
            cst_da.common().member_id(memberId++);
            cst_da.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_da.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_da.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_da.common().member_flags().IS_OPTIONAL(false);
            cst_da.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_da.common().member_flags().IS_KEY(false);
            cst_da.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_da.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_da.detail().name("da");

            type_object->complete().struct_type().member_seq().emplace_back(cst_da);


            // Header
            type_object->complete().struct_type().header().detail().type_name("SpeedPoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("SpeedPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("SpeedPoint", true);
        }

    } // namespace msg
} // namespace ros2_interface