// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Status.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Status.h"
#include "StatusTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Status_max_cdr_typesize 264ULL;
#define ros2_interface_msg_Status_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Status::Status()
{
    // long m_error_code
    m_error_code = 0;
    // string m_msg
    m_msg ="";

    // Just to register all known types
    registerStatusTypes();
}

ros2_interface::msg::Status::~Status()
{


}

ros2_interface::msg::Status::Status(
        const Status& x)
{
    m_error_code = x.m_error_code;
    m_msg = x.m_msg;
}

ros2_interface::msg::Status::Status(
        Status&& x) noexcept 
{
    m_error_code = x.m_error_code;
    m_msg = std::move(x.m_msg);
}

ros2_interface::msg::Status& ros2_interface::msg::Status::operator =(
        const Status& x)
{

    m_error_code = x.m_error_code;
    m_msg = x.m_msg;

    return *this;
}

ros2_interface::msg::Status& ros2_interface::msg::Status::operator =(
        Status&& x) noexcept
{

    m_error_code = x.m_error_code;
    m_msg = std::move(x.m_msg);

    return *this;
}

bool ros2_interface::msg::Status::operator ==(
        const Status& x) const
{

    return (m_error_code == x.m_error_code && m_msg == x.m_msg);
}

bool ros2_interface::msg::Status::operator !=(
        const Status& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Status::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Status_max_cdr_typesize;
}

size_t ros2_interface::msg::Status::getCdrSerializedSize(
        const ros2_interface::msg::Status& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.msg().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Status::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_error_code;
    scdr << m_msg.c_str();

}

void ros2_interface::msg::Status::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_error_code;
    dcdr >> m_msg;
}

/*!
 * @brief This function sets a value in member error_code
 * @param _error_code New value for member error_code
 */
void ros2_interface::msg::Status::error_code(
        int32_t _error_code)
{
    m_error_code = _error_code;
}

/*!
 * @brief This function returns the value of member error_code
 * @return Value of member error_code
 */
int32_t ros2_interface::msg::Status::error_code() const
{
    return m_error_code;
}

/*!
 * @brief This function returns a reference to member error_code
 * @return Reference to member error_code
 */
int32_t& ros2_interface::msg::Status::error_code()
{
    return m_error_code;
}

/*!
 * @brief This function copies the value in member msg
 * @param _msg New value to be copied in member msg
 */
void ros2_interface::msg::Status::msg(
        const std::string& _msg)
{
    m_msg = _msg;
}

/*!
 * @brief This function moves the value in member msg
 * @param _msg New value to be moved in member msg
 */
void ros2_interface::msg::Status::msg(
        std::string&& _msg)
{
    m_msg = std::move(_msg);
}

/*!
 * @brief This function returns a constant reference to member msg
 * @return Constant reference to member msg
 */
const std::string& ros2_interface::msg::Status::msg() const
{
    return m_msg;
}

/*!
 * @brief This function returns a reference to member msg
 * @return Reference to member msg
 */
std::string& ros2_interface::msg::Status::msg()
{
    return m_msg;
}


size_t ros2_interface::msg::Status::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Status_max_key_cdr_typesize;
}

bool ros2_interface::msg::Status::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Status::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



