// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file StopInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "StopInfo.h"
#include "StopInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_StopInfo_max_cdr_typesize 5080ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_StopPoint_max_cdr_typesize 48ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_StopInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_StopPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::StopInfo::StopInfo()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::StopPoint> m_stop_points


    // Just to register all known types
    registerStopInfoTypes();
}

ros2_interface::msg::StopInfo::~StopInfo()
{


}

ros2_interface::msg::StopInfo::StopInfo(
        const StopInfo& x)
{
    m_header = x.m_header;
    m_stop_points = x.m_stop_points;
}

ros2_interface::msg::StopInfo::StopInfo(
        StopInfo&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_stop_points = std::move(x.m_stop_points);
}

ros2_interface::msg::StopInfo& ros2_interface::msg::StopInfo::operator =(
        const StopInfo& x)
{

    m_header = x.m_header;
    m_stop_points = x.m_stop_points;

    return *this;
}

ros2_interface::msg::StopInfo& ros2_interface::msg::StopInfo::operator =(
        StopInfo&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_stop_points = std::move(x.m_stop_points);

    return *this;
}

bool ros2_interface::msg::StopInfo::operator ==(
        const StopInfo& x) const
{

    return (m_header == x.m_header && m_stop_points == x.m_stop_points);
}

bool ros2_interface::msg::StopInfo::operator !=(
        const StopInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::StopInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_StopInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::StopInfo::getCdrSerializedSize(
        const ros2_interface::msg::StopInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.stop_points().size(); ++a)
    {
        current_alignment += ros2_interface::msg::StopPoint::getCdrSerializedSize(data.stop_points().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::StopInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_stop_points;

}

void ros2_interface::msg::StopInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_stop_points;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::StopInfo::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::StopInfo::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::StopInfo::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::StopInfo::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member stop_points
 * @param _stop_points New value to be copied in member stop_points
 */
void ros2_interface::msg::StopInfo::stop_points(
        const std::vector<ros2_interface::msg::StopPoint>& _stop_points)
{
    m_stop_points = _stop_points;
}

/*!
 * @brief This function moves the value in member stop_points
 * @param _stop_points New value to be moved in member stop_points
 */
void ros2_interface::msg::StopInfo::stop_points(
        std::vector<ros2_interface::msg::StopPoint>&& _stop_points)
{
    m_stop_points = std::move(_stop_points);
}

/*!
 * @brief This function returns a constant reference to member stop_points
 * @return Constant reference to member stop_points
 */
const std::vector<ros2_interface::msg::StopPoint>& ros2_interface::msg::StopInfo::stop_points() const
{
    return m_stop_points;
}

/*!
 * @brief This function returns a reference to member stop_points
 * @return Reference to member stop_points
 */
std::vector<ros2_interface::msg::StopPoint>& ros2_interface::msg::StopInfo::stop_points()
{
    return m_stop_points;
}


size_t ros2_interface::msg::StopInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_StopInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::StopInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::StopInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



