// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file StopPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "StopPoint.h"
#include "StopPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_StopPoint_max_cdr_typesize 48ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_StopPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::StopPoint::StopPoint()
{
    // ros2_interface::msg::Point3D m_point

    // double m_theta
    m_theta = 0.0;
    // int8 m_type
    m_type = 0;
    // double m_stop_distance
    m_stop_distance = 0.0;

    // Just to register all known types
    registerStopPointTypes();
}

ros2_interface::msg::StopPoint::~StopPoint()
{




}

ros2_interface::msg::StopPoint::StopPoint(
        const StopPoint& x)
{
    m_point = x.m_point;
    m_theta = x.m_theta;
    m_type = x.m_type;
    m_stop_distance = x.m_stop_distance;
}

ros2_interface::msg::StopPoint::StopPoint(
        StopPoint&& x) noexcept 
{
    m_point = std::move(x.m_point);
    m_theta = x.m_theta;
    m_type = x.m_type;
    m_stop_distance = x.m_stop_distance;
}

ros2_interface::msg::StopPoint& ros2_interface::msg::StopPoint::operator =(
        const StopPoint& x)
{

    m_point = x.m_point;
    m_theta = x.m_theta;
    m_type = x.m_type;
    m_stop_distance = x.m_stop_distance;

    return *this;
}

ros2_interface::msg::StopPoint& ros2_interface::msg::StopPoint::operator =(
        StopPoint&& x) noexcept
{

    m_point = std::move(x.m_point);
    m_theta = x.m_theta;
    m_type = x.m_type;
    m_stop_distance = x.m_stop_distance;

    return *this;
}

bool ros2_interface::msg::StopPoint::operator ==(
        const StopPoint& x) const
{

    return (m_point == x.m_point && m_theta == x.m_theta && m_type == x.m_type && m_stop_distance == x.m_stop_distance);
}

bool ros2_interface::msg::StopPoint::operator !=(
        const StopPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::StopPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_StopPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::StopPoint::getCdrSerializedSize(
        const ros2_interface::msg::StopPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.point(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::StopPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_point;
    scdr << m_theta;
    scdr << m_type;
    scdr << m_stop_distance;

}

void ros2_interface::msg::StopPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_point;
    dcdr >> m_theta;
    dcdr >> m_type;
    dcdr >> m_stop_distance;
}

/*!
 * @brief This function copies the value in member point
 * @param _point New value to be copied in member point
 */
void ros2_interface::msg::StopPoint::point(
        const ros2_interface::msg::Point3D& _point)
{
    m_point = _point;
}

/*!
 * @brief This function moves the value in member point
 * @param _point New value to be moved in member point
 */
void ros2_interface::msg::StopPoint::point(
        ros2_interface::msg::Point3D&& _point)
{
    m_point = std::move(_point);
}

/*!
 * @brief This function returns a constant reference to member point
 * @return Constant reference to member point
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::StopPoint::point() const
{
    return m_point;
}

/*!
 * @brief This function returns a reference to member point
 * @return Reference to member point
 */
ros2_interface::msg::Point3D& ros2_interface::msg::StopPoint::point()
{
    return m_point;
}
/*!
 * @brief This function sets a value in member theta
 * @param _theta New value for member theta
 */
void ros2_interface::msg::StopPoint::theta(
        double _theta)
{
    m_theta = _theta;
}

/*!
 * @brief This function returns the value of member theta
 * @return Value of member theta
 */
double ros2_interface::msg::StopPoint::theta() const
{
    return m_theta;
}

/*!
 * @brief This function returns a reference to member theta
 * @return Reference to member theta
 */
double& ros2_interface::msg::StopPoint::theta()
{
    return m_theta;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::StopPoint::type(
        int8_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int8_t ros2_interface::msg::StopPoint::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int8_t& ros2_interface::msg::StopPoint::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member stop_distance
 * @param _stop_distance New value for member stop_distance
 */
void ros2_interface::msg::StopPoint::stop_distance(
        double _stop_distance)
{
    m_stop_distance = _stop_distance;
}

/*!
 * @brief This function returns the value of member stop_distance
 * @return Value of member stop_distance
 */
double ros2_interface::msg::StopPoint::stop_distance() const
{
    return m_stop_distance;
}

/*!
 * @brief This function returns a reference to member stop_distance
 * @return Reference to member stop_distance
 */
double& ros2_interface::msg::StopPoint::stop_distance()
{
    return m_stop_distance;
}



size_t ros2_interface::msg::StopPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_StopPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::StopPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::StopPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



