// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Stories.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Stories.h"
#include "StoriesTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Stories_max_cdr_typesize 260ULL;
#define ros2_interface_msg_Stories_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Stories::Stories()
{
    // string m_note
    m_note ="";

    // Just to register all known types
    registerStoriesTypes();
}

ros2_interface::msg::Stories::~Stories()
{
}

ros2_interface::msg::Stories::Stories(
        const Stories& x)
{
    m_note = x.m_note;
}

ros2_interface::msg::Stories::Stories(
        Stories&& x) noexcept 
{
    m_note = std::move(x.m_note);
}

ros2_interface::msg::Stories& ros2_interface::msg::Stories::operator =(
        const Stories& x)
{

    m_note = x.m_note;

    return *this;
}

ros2_interface::msg::Stories& ros2_interface::msg::Stories::operator =(
        Stories&& x) noexcept
{

    m_note = std::move(x.m_note);

    return *this;
}

bool ros2_interface::msg::Stories::operator ==(
        const Stories& x) const
{

    return (m_note == x.m_note);
}

bool ros2_interface::msg::Stories::operator !=(
        const Stories& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Stories::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Stories_max_cdr_typesize;
}

size_t ros2_interface::msg::Stories::getCdrSerializedSize(
        const ros2_interface::msg::Stories& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.note().size() + 1;

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Stories::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_note.c_str();

}

void ros2_interface::msg::Stories::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_note;}

/*!
 * @brief This function copies the value in member note
 * @param _note New value to be copied in member note
 */
void ros2_interface::msg::Stories::note(
        const std::string& _note)
{
    m_note = _note;
}

/*!
 * @brief This function moves the value in member note
 * @param _note New value to be moved in member note
 */
void ros2_interface::msg::Stories::note(
        std::string&& _note)
{
    m_note = std::move(_note);
}

/*!
 * @brief This function returns a constant reference to member note
 * @return Constant reference to member note
 */
const std::string& ros2_interface::msg::Stories::note() const
{
    return m_note;
}

/*!
 * @brief This function returns a reference to member note
 * @return Reference to member note
 */
std::string& ros2_interface::msg::Stories::note()
{
    return m_note;
}


size_t ros2_interface::msg::Stories::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Stories_max_key_cdr_typesize;
}

bool ros2_interface::msg::Stories::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Stories::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



