// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Time.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Time.h"
#include "TimeTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Time::Time()
{
    // unsigned long m_sec
    m_sec = 0;
    // unsigned long m_nsec
    m_nsec = 0;

    // Just to register all known types
    registerTimeTypes();
}

ros2_interface::msg::Time::~Time()
{


}

ros2_interface::msg::Time::Time(
        const Time& x)
{
    m_sec = x.m_sec;
    m_nsec = x.m_nsec;
}

ros2_interface::msg::Time::Time(
        Time&& x) noexcept 
{
    m_sec = x.m_sec;
    m_nsec = x.m_nsec;
}

ros2_interface::msg::Time& ros2_interface::msg::Time::operator =(
        const Time& x)
{

    m_sec = x.m_sec;
    m_nsec = x.m_nsec;

    return *this;
}

ros2_interface::msg::Time& ros2_interface::msg::Time::operator =(
        Time&& x) noexcept
{

    m_sec = x.m_sec;
    m_nsec = x.m_nsec;

    return *this;
}

bool ros2_interface::msg::Time::operator ==(
        const Time& x) const
{

    return (m_sec == x.m_sec && m_nsec == x.m_nsec);
}

bool ros2_interface::msg::Time::operator !=(
        const Time& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Time::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Time_max_cdr_typesize;
}

size_t ros2_interface::msg::Time::getCdrSerializedSize(
        const ros2_interface::msg::Time& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Time::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_sec;
    scdr << m_nsec;

}

void ros2_interface::msg::Time::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_sec;
    dcdr >> m_nsec;
}

/*!
 * @brief This function sets a value in member sec
 * @param _sec New value for member sec
 */
void ros2_interface::msg::Time::sec(
        uint32_t _sec)
{
    m_sec = _sec;
}

/*!
 * @brief This function returns the value of member sec
 * @return Value of member sec
 */
uint32_t ros2_interface::msg::Time::sec() const
{
    return m_sec;
}

/*!
 * @brief This function returns a reference to member sec
 * @return Reference to member sec
 */
uint32_t& ros2_interface::msg::Time::sec()
{
    return m_sec;
}

/*!
 * @brief This function sets a value in member nsec
 * @param _nsec New value for member nsec
 */
void ros2_interface::msg::Time::nsec(
        uint32_t _nsec)
{
    m_nsec = _nsec;
}

/*!
 * @brief This function returns the value of member nsec
 * @return Value of member nsec
 */
uint32_t ros2_interface::msg::Time::nsec() const
{
    return m_nsec;
}

/*!
 * @brief This function returns a reference to member nsec
 * @return Reference to member nsec
 */
uint32_t& ros2_interface::msg::Time::nsec()
{
    return m_nsec;
}



size_t ros2_interface::msg::Time::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Time_max_key_cdr_typesize;
}

bool ros2_interface::msg::Time::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Time::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



