// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TimeConsume.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TimeConsume.h"
#include "TimeConsumeTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_TimeConsume_max_cdr_typesize 272ULL;
#define ros2_interface_msg_TimeConsume_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TimeConsume::TimeConsume()
{
    // string m_name
    m_name ="";
    // double m_time_consume
    m_time_consume = 0.0;

    // Just to register all known types
    registerTimeConsumeTypes();
}

ros2_interface::msg::TimeConsume::~TimeConsume()
{


}

ros2_interface::msg::TimeConsume::TimeConsume(
        const TimeConsume& x)
{
    m_name = x.m_name;
    m_time_consume = x.m_time_consume;
}

ros2_interface::msg::TimeConsume::TimeConsume(
        TimeConsume&& x) noexcept 
{
    m_name = std::move(x.m_name);
    m_time_consume = x.m_time_consume;
}

ros2_interface::msg::TimeConsume& ros2_interface::msg::TimeConsume::operator =(
        const TimeConsume& x)
{

    m_name = x.m_name;
    m_time_consume = x.m_time_consume;

    return *this;
}

ros2_interface::msg::TimeConsume& ros2_interface::msg::TimeConsume::operator =(
        TimeConsume&& x) noexcept
{

    m_name = std::move(x.m_name);
    m_time_consume = x.m_time_consume;

    return *this;
}

bool ros2_interface::msg::TimeConsume::operator ==(
        const TimeConsume& x) const
{

    return (m_name == x.m_name && m_time_consume == x.m_time_consume);
}

bool ros2_interface::msg::TimeConsume::operator !=(
        const TimeConsume& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TimeConsume::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TimeConsume_max_cdr_typesize;
}

size_t ros2_interface::msg::TimeConsume::getCdrSerializedSize(
        const ros2_interface::msg::TimeConsume& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TimeConsume::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_name.c_str();
    scdr << m_time_consume;

}

void ros2_interface::msg::TimeConsume::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_name;
    dcdr >> m_time_consume;
}

/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::TimeConsume::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::TimeConsume::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::TimeConsume::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::TimeConsume::name()
{
    return m_name;
}
/*!
 * @brief This function sets a value in member time_consume
 * @param _time_consume New value for member time_consume
 */
void ros2_interface::msg::TimeConsume::time_consume(
        double _time_consume)
{
    m_time_consume = _time_consume;
}

/*!
 * @brief This function returns the value of member time_consume
 * @return Value of member time_consume
 */
double ros2_interface::msg::TimeConsume::time_consume() const
{
    return m_time_consume;
}

/*!
 * @brief This function returns a reference to member time_consume
 * @return Reference to member time_consume
 */
double& ros2_interface::msg::TimeConsume::time_consume()
{
    return m_time_consume;
}



size_t ros2_interface::msg::TimeConsume::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TimeConsume_max_key_cdr_typesize;
}

bool ros2_interface::msg::TimeConsume::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TimeConsume::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



