// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TimeConsume.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TIMECONSUME_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TIMECONSUME_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TIMECONSUME_SOURCE)
#define TIMECONSUME_DllAPI __declspec( dllexport )
#else
#define TIMECONSUME_DllAPI __declspec( dllimport )
#endif // TIMECONSUME_SOURCE
#else
#define TIMECONSUME_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TIMECONSUME_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TimeConsume defined by the user in the IDL file.
         * @ingroup TimeConsume
         */
        class TimeConsume
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TimeConsume();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TimeConsume();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TimeConsume that will be copied.
             */
            eProsima_user_DllExport TimeConsume(
                    const TimeConsume& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TimeConsume that will be copied.
             */
            eProsima_user_DllExport TimeConsume(
                    TimeConsume&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TimeConsume that will be copied.
             */
            eProsima_user_DllExport TimeConsume& operator =(
                    const TimeConsume& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TimeConsume that will be copied.
             */
            eProsima_user_DllExport TimeConsume& operator =(
                    TimeConsume&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TimeConsume object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TimeConsume& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TimeConsume object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TimeConsume& x) const;

            /*!
             * @brief This function copies the value in member name
             * @param _name New value to be copied in member name
             */
            eProsima_user_DllExport void name(
                    const std::string& _name);

            /*!
             * @brief This function moves the value in member name
             * @param _name New value to be moved in member name
             */
            eProsima_user_DllExport void name(
                    std::string&& _name);

            /*!
             * @brief This function returns a constant reference to member name
             * @return Constant reference to member name
             */
            eProsima_user_DllExport const std::string& name() const;

            /*!
             * @brief This function returns a reference to member name
             * @return Reference to member name
             */
            eProsima_user_DllExport std::string& name();
            /*!
             * @brief This function sets a value in member time_consume
             * @param _time_consume New value for member time_consume
             */
            eProsima_user_DllExport void time_consume(
                    double _time_consume);

            /*!
             * @brief This function returns the value of member time_consume
             * @return Value of member time_consume
             */
            eProsima_user_DllExport double time_consume() const;

            /*!
             * @brief This function returns a reference to member time_consume
             * @return Reference to member time_consume
             */
            eProsima_user_DllExport double& time_consume();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TimeConsume& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::string m_name;
            double m_time_consume;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TIMECONSUME_H_

