// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficEvents.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TrafficEvents.h"
#include "TrafficEventsTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_TrafficEvents_max_cdr_typesize 3016ULL;
#define ros2_interface_msg_JunctionInfo_max_cdr_typesize 2456ULL;
#define ros2_interface_msg_LimitSpeedInfo_max_cdr_typesize 24ULL;
#define ros2_interface_msg_RouteFusionInfo_max_cdr_typesize 264ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrafficEvents_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_JunctionInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_LimitSpeedInfo_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_RouteFusionInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TrafficEvents::TrafficEvents()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::RouteFusionInfo m_route_fusion_info

    // ros2_interface::msg::JunctionInfo m_junction_info

    // ros2_interface::msg::LimitSpeedInfo m_limit_speed_info


    // Just to register all known types
    registerTrafficEventsTypes();
}

ros2_interface::msg::TrafficEvents::~TrafficEvents()
{




}

ros2_interface::msg::TrafficEvents::TrafficEvents(
        const TrafficEvents& x)
{
    m_header = x.m_header;
    m_route_fusion_info = x.m_route_fusion_info;
    m_junction_info = x.m_junction_info;
    m_limit_speed_info = x.m_limit_speed_info;
}

ros2_interface::msg::TrafficEvents::TrafficEvents(
        TrafficEvents&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_route_fusion_info = std::move(x.m_route_fusion_info);
    m_junction_info = std::move(x.m_junction_info);
    m_limit_speed_info = std::move(x.m_limit_speed_info);
}

ros2_interface::msg::TrafficEvents& ros2_interface::msg::TrafficEvents::operator =(
        const TrafficEvents& x)
{

    m_header = x.m_header;
    m_route_fusion_info = x.m_route_fusion_info;
    m_junction_info = x.m_junction_info;
    m_limit_speed_info = x.m_limit_speed_info;

    return *this;
}

ros2_interface::msg::TrafficEvents& ros2_interface::msg::TrafficEvents::operator =(
        TrafficEvents&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_route_fusion_info = std::move(x.m_route_fusion_info);
    m_junction_info = std::move(x.m_junction_info);
    m_limit_speed_info = std::move(x.m_limit_speed_info);

    return *this;
}

bool ros2_interface::msg::TrafficEvents::operator ==(
        const TrafficEvents& x) const
{

    return (m_header == x.m_header && m_route_fusion_info == x.m_route_fusion_info && m_junction_info == x.m_junction_info && m_limit_speed_info == x.m_limit_speed_info);
}

bool ros2_interface::msg::TrafficEvents::operator !=(
        const TrafficEvents& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TrafficEvents::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficEvents_max_cdr_typesize;
}

size_t ros2_interface::msg::TrafficEvents::getCdrSerializedSize(
        const ros2_interface::msg::TrafficEvents& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::RouteFusionInfo::getCdrSerializedSize(data.route_fusion_info(), current_alignment);
    current_alignment += ros2_interface::msg::JunctionInfo::getCdrSerializedSize(data.junction_info(), current_alignment);
    current_alignment += ros2_interface::msg::LimitSpeedInfo::getCdrSerializedSize(data.limit_speed_info(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TrafficEvents::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_route_fusion_info;
    scdr << m_junction_info;
    scdr << m_limit_speed_info;

}

void ros2_interface::msg::TrafficEvents::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_route_fusion_info;
    dcdr >> m_junction_info;
    dcdr >> m_limit_speed_info;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::TrafficEvents::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::TrafficEvents::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::TrafficEvents::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::TrafficEvents::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member route_fusion_info
 * @param _route_fusion_info New value to be copied in member route_fusion_info
 */
void ros2_interface::msg::TrafficEvents::route_fusion_info(
        const ros2_interface::msg::RouteFusionInfo& _route_fusion_info)
{
    m_route_fusion_info = _route_fusion_info;
}

/*!
 * @brief This function moves the value in member route_fusion_info
 * @param _route_fusion_info New value to be moved in member route_fusion_info
 */
void ros2_interface::msg::TrafficEvents::route_fusion_info(
        ros2_interface::msg::RouteFusionInfo&& _route_fusion_info)
{
    m_route_fusion_info = std::move(_route_fusion_info);
}

/*!
 * @brief This function returns a constant reference to member route_fusion_info
 * @return Constant reference to member route_fusion_info
 */
const ros2_interface::msg::RouteFusionInfo& ros2_interface::msg::TrafficEvents::route_fusion_info() const
{
    return m_route_fusion_info;
}

/*!
 * @brief This function returns a reference to member route_fusion_info
 * @return Reference to member route_fusion_info
 */
ros2_interface::msg::RouteFusionInfo& ros2_interface::msg::TrafficEvents::route_fusion_info()
{
    return m_route_fusion_info;
}
/*!
 * @brief This function copies the value in member junction_info
 * @param _junction_info New value to be copied in member junction_info
 */
void ros2_interface::msg::TrafficEvents::junction_info(
        const ros2_interface::msg::JunctionInfo& _junction_info)
{
    m_junction_info = _junction_info;
}

/*!
 * @brief This function moves the value in member junction_info
 * @param _junction_info New value to be moved in member junction_info
 */
void ros2_interface::msg::TrafficEvents::junction_info(
        ros2_interface::msg::JunctionInfo&& _junction_info)
{
    m_junction_info = std::move(_junction_info);
}

/*!
 * @brief This function returns a constant reference to member junction_info
 * @return Constant reference to member junction_info
 */
const ros2_interface::msg::JunctionInfo& ros2_interface::msg::TrafficEvents::junction_info() const
{
    return m_junction_info;
}

/*!
 * @brief This function returns a reference to member junction_info
 * @return Reference to member junction_info
 */
ros2_interface::msg::JunctionInfo& ros2_interface::msg::TrafficEvents::junction_info()
{
    return m_junction_info;
}
/*!
 * @brief This function copies the value in member limit_speed_info
 * @param _limit_speed_info New value to be copied in member limit_speed_info
 */
void ros2_interface::msg::TrafficEvents::limit_speed_info(
        const ros2_interface::msg::LimitSpeedInfo& _limit_speed_info)
{
    m_limit_speed_info = _limit_speed_info;
}

/*!
 * @brief This function moves the value in member limit_speed_info
 * @param _limit_speed_info New value to be moved in member limit_speed_info
 */
void ros2_interface::msg::TrafficEvents::limit_speed_info(
        ros2_interface::msg::LimitSpeedInfo&& _limit_speed_info)
{
    m_limit_speed_info = std::move(_limit_speed_info);
}

/*!
 * @brief This function returns a constant reference to member limit_speed_info
 * @return Constant reference to member limit_speed_info
 */
const ros2_interface::msg::LimitSpeedInfo& ros2_interface::msg::TrafficEvents::limit_speed_info() const
{
    return m_limit_speed_info;
}

/*!
 * @brief This function returns a reference to member limit_speed_info
 * @return Reference to member limit_speed_info
 */
ros2_interface::msg::LimitSpeedInfo& ros2_interface::msg::TrafficEvents::limit_speed_info()
{
    return m_limit_speed_info;
}


size_t ros2_interface::msg::TrafficEvents::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficEvents_max_key_cdr_typesize;
}

bool ros2_interface::msg::TrafficEvents::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TrafficEvents::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



