// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficEvents.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICEVENTS_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICEVENTS_H_

#include "RouteFusionInfo.h"
#include "JunctionInfo.h"
#include "Header.h"
#include "LimitSpeedInfo.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TRAFFICEVENTS_SOURCE)
#define TRAFFICEVENTS_DllAPI __declspec( dllexport )
#else
#define TRAFFICEVENTS_DllAPI __declspec( dllimport )
#endif // TRAFFICEVENTS_SOURCE
#else
#define TRAFFICEVENTS_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TRAFFICEVENTS_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TrafficEvents defined by the user in the IDL file.
         * @ingroup TrafficEvents
         */
        class TrafficEvents
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TrafficEvents();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TrafficEvents();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficEvents that will be copied.
             */
            eProsima_user_DllExport TrafficEvents(
                    const TrafficEvents& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficEvents that will be copied.
             */
            eProsima_user_DllExport TrafficEvents(
                    TrafficEvents&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficEvents that will be copied.
             */
            eProsima_user_DllExport TrafficEvents& operator =(
                    const TrafficEvents& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficEvents that will be copied.
             */
            eProsima_user_DllExport TrafficEvents& operator =(
                    TrafficEvents&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficEvents object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TrafficEvents& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficEvents object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TrafficEvents& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member route_fusion_info
             * @param _route_fusion_info New value to be copied in member route_fusion_info
             */
            eProsima_user_DllExport void route_fusion_info(
                    const ros2_interface::msg::RouteFusionInfo& _route_fusion_info);

            /*!
             * @brief This function moves the value in member route_fusion_info
             * @param _route_fusion_info New value to be moved in member route_fusion_info
             */
            eProsima_user_DllExport void route_fusion_info(
                    ros2_interface::msg::RouteFusionInfo&& _route_fusion_info);

            /*!
             * @brief This function returns a constant reference to member route_fusion_info
             * @return Constant reference to member route_fusion_info
             */
            eProsima_user_DllExport const ros2_interface::msg::RouteFusionInfo& route_fusion_info() const;

            /*!
             * @brief This function returns a reference to member route_fusion_info
             * @return Reference to member route_fusion_info
             */
            eProsima_user_DllExport ros2_interface::msg::RouteFusionInfo& route_fusion_info();
            /*!
             * @brief This function copies the value in member junction_info
             * @param _junction_info New value to be copied in member junction_info
             */
            eProsima_user_DllExport void junction_info(
                    const ros2_interface::msg::JunctionInfo& _junction_info);

            /*!
             * @brief This function moves the value in member junction_info
             * @param _junction_info New value to be moved in member junction_info
             */
            eProsima_user_DllExport void junction_info(
                    ros2_interface::msg::JunctionInfo&& _junction_info);

            /*!
             * @brief This function returns a constant reference to member junction_info
             * @return Constant reference to member junction_info
             */
            eProsima_user_DllExport const ros2_interface::msg::JunctionInfo& junction_info() const;

            /*!
             * @brief This function returns a reference to member junction_info
             * @return Reference to member junction_info
             */
            eProsima_user_DllExport ros2_interface::msg::JunctionInfo& junction_info();
            /*!
             * @brief This function copies the value in member limit_speed_info
             * @param _limit_speed_info New value to be copied in member limit_speed_info
             */
            eProsima_user_DllExport void limit_speed_info(
                    const ros2_interface::msg::LimitSpeedInfo& _limit_speed_info);

            /*!
             * @brief This function moves the value in member limit_speed_info
             * @param _limit_speed_info New value to be moved in member limit_speed_info
             */
            eProsima_user_DllExport void limit_speed_info(
                    ros2_interface::msg::LimitSpeedInfo&& _limit_speed_info);

            /*!
             * @brief This function returns a constant reference to member limit_speed_info
             * @return Constant reference to member limit_speed_info
             */
            eProsima_user_DllExport const ros2_interface::msg::LimitSpeedInfo& limit_speed_info() const;

            /*!
             * @brief This function returns a reference to member limit_speed_info
             * @return Reference to member limit_speed_info
             */
            eProsima_user_DllExport ros2_interface::msg::LimitSpeedInfo& limit_speed_info();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TrafficEvents& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            ros2_interface::msg::RouteFusionInfo m_route_fusion_info;
            ros2_interface::msg::JunctionInfo m_junction_info;
            ros2_interface::msg::LimitSpeedInfo m_limit_speed_info;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICEVENTS_H_

