// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficEventsTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "TrafficEvents.h"
#include "TrafficEventsTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerTrafficEventsTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::JunctionInfo", ros2_interface::msg::GetJunctionInfoIdentifier(true),
                        ros2_interface::msg::GetJunctionInfoObject(true));
                factory->add_type_object("ros2_interface::msg::JunctionInfo", ros2_interface::msg::GetJunctionInfoIdentifier(false),
                        ros2_interface::msg::GetJunctionInfoObject(false));



                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::LimitSpeedInfo", ros2_interface::msg::GetLimitSpeedInfoIdentifier(true),
                        ros2_interface::msg::GetLimitSpeedInfoObject(true));
                factory->add_type_object("ros2_interface::msg::LimitSpeedInfo", ros2_interface::msg::GetLimitSpeedInfoIdentifier(false),
                        ros2_interface::msg::GetLimitSpeedInfoObject(false));



                factory->add_type_object("ros2_interface::msg::RouteFusionInfo", ros2_interface::msg::GetRouteFusionInfoIdentifier(true),
                        ros2_interface::msg::GetRouteFusionInfoObject(true));
                factory->add_type_object("ros2_interface::msg::RouteFusionInfo", ros2_interface::msg::GetRouteFusionInfoIdentifier(false),
                        ros2_interface::msg::GetRouteFusionInfoObject(false));



                factory->add_type_object("ros2_interface::msg::TrafficEvents", ros2_interface::msg::GetTrafficEventsIdentifier(true),
                        ros2_interface::msg::GetTrafficEventsObject(true));
                factory->add_type_object("ros2_interface::msg::TrafficEvents", ros2_interface::msg::GetTrafficEventsIdentifier(false),
                        ros2_interface::msg::GetTrafficEventsObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetTrafficEventsIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("TrafficEvents", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetTrafficEventsObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("TrafficEvents", complete);
        }

        const TypeObject* GetTrafficEventsObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficEvents", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteTrafficEventsObject();
            }
            //else
            return GetMinimalTrafficEventsObject();
        }

        const TypeObject* GetMinimalTrafficEventsObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficEvents", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_route_fusion_info;
            mst_route_fusion_info.common().member_id(memberId++);
            mst_route_fusion_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_route_fusion_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_route_fusion_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_route_fusion_info.common().member_flags().IS_OPTIONAL(false);
            mst_route_fusion_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_route_fusion_info.common().member_flags().IS_KEY(false);
            mst_route_fusion_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_route_fusion_info.common().member_type_id(*ros2_interface::msg::GetRouteFusionInfoIdentifier(false));
            MD5 route_fusion_info_hash("route_fusion_info");
            for(int i = 0; i < 4; ++i)
            {
                mst_route_fusion_info.detail().name_hash()[i] = route_fusion_info_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_route_fusion_info);

            MinimalStructMember mst_junction_info;
            mst_junction_info.common().member_id(memberId++);
            mst_junction_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_junction_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_junction_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_junction_info.common().member_flags().IS_OPTIONAL(false);
            mst_junction_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_junction_info.common().member_flags().IS_KEY(false);
            mst_junction_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_junction_info.common().member_type_id(*ros2_interface::msg::GetJunctionInfoIdentifier(false));
            MD5 junction_info_hash("junction_info");
            for(int i = 0; i < 4; ++i)
            {
                mst_junction_info.detail().name_hash()[i] = junction_info_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_junction_info);

            MinimalStructMember mst_limit_speed_info;
            mst_limit_speed_info.common().member_id(memberId++);
            mst_limit_speed_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_limit_speed_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_limit_speed_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_limit_speed_info.common().member_flags().IS_OPTIONAL(false);
            mst_limit_speed_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_limit_speed_info.common().member_flags().IS_KEY(false);
            mst_limit_speed_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_limit_speed_info.common().member_type_id(*ros2_interface::msg::GetLimitSpeedInfoIdentifier(false));
            MD5 limit_speed_info_hash("limit_speed_info");
            for(int i = 0; i < 4; ++i)
            {
                mst_limit_speed_info.detail().name_hash()[i] = limit_speed_info_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_limit_speed_info);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficEvents", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficEvents", false);
        }

        const TypeObject* GetCompleteTrafficEventsObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficEvents", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_route_fusion_info;
            cst_route_fusion_info.common().member_id(memberId++);
            cst_route_fusion_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_route_fusion_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_route_fusion_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_route_fusion_info.common().member_flags().IS_OPTIONAL(false);
            cst_route_fusion_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_route_fusion_info.common().member_flags().IS_KEY(false);
            cst_route_fusion_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_route_fusion_info.common().member_type_id(*ros2_interface::msg::GetRouteFusionInfoIdentifier(true));
            cst_route_fusion_info.detail().name("route_fusion_info");

            type_object->complete().struct_type().member_seq().emplace_back(cst_route_fusion_info);

            CompleteStructMember cst_junction_info;
            cst_junction_info.common().member_id(memberId++);
            cst_junction_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_junction_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_junction_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_junction_info.common().member_flags().IS_OPTIONAL(false);
            cst_junction_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_junction_info.common().member_flags().IS_KEY(false);
            cst_junction_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_junction_info.common().member_type_id(*ros2_interface::msg::GetJunctionInfoIdentifier(true));
            cst_junction_info.detail().name("junction_info");

            type_object->complete().struct_type().member_seq().emplace_back(cst_junction_info);

            CompleteStructMember cst_limit_speed_info;
            cst_limit_speed_info.common().member_id(memberId++);
            cst_limit_speed_info.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_limit_speed_info.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_limit_speed_info.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_limit_speed_info.common().member_flags().IS_OPTIONAL(false);
            cst_limit_speed_info.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_limit_speed_info.common().member_flags().IS_KEY(false);
            cst_limit_speed_info.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_limit_speed_info.common().member_type_id(*ros2_interface::msg::GetLimitSpeedInfoIdentifier(true));
            cst_limit_speed_info.detail().name("limit_speed_info");

            type_object->complete().struct_type().member_seq().emplace_back(cst_limit_speed_info);


            // Header
            type_object->complete().struct_type().header().detail().type_name("TrafficEvents");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficEvents", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficEvents", true);
        }

    } // namespace msg
} // namespace ros2_interface