// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLight.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TrafficLight.h"
#include "TrafficLightTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_TrafficLight_max_cdr_typesize 80ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrafficLight_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TrafficLight::TrafficLight()
{
    // long m_color
    m_color = 0;
    // unsigned long m_id
    m_id = 0;
    // long m_type
    m_type = 0;
    // double m_confidence
    m_confidence = 0.0;
    // ros2_interface::msg::Point3D m_position

    // double m_tracking_time
    m_tracking_time = 0.0;
    // boolean m_blink
    m_blink = false;
    // double m_blinking_time
    m_blinking_time = 0.0;
    // double m_remaining_time
    m_remaining_time = 0.0;

    // Just to register all known types
    registerTrafficLightTypes();
}

ros2_interface::msg::TrafficLight::~TrafficLight()
{









}

ros2_interface::msg::TrafficLight::TrafficLight(
        const TrafficLight& x)
{
    m_color = x.m_color;
    m_id = x.m_id;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_position = x.m_position;
    m_tracking_time = x.m_tracking_time;
    m_blink = x.m_blink;
    m_blinking_time = x.m_blinking_time;
    m_remaining_time = x.m_remaining_time;
}

ros2_interface::msg::TrafficLight::TrafficLight(
        TrafficLight&& x) noexcept 
{
    m_color = x.m_color;
    m_id = x.m_id;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_position = std::move(x.m_position);
    m_tracking_time = x.m_tracking_time;
    m_blink = x.m_blink;
    m_blinking_time = x.m_blinking_time;
    m_remaining_time = x.m_remaining_time;
}

ros2_interface::msg::TrafficLight& ros2_interface::msg::TrafficLight::operator =(
        const TrafficLight& x)
{

    m_color = x.m_color;
    m_id = x.m_id;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_position = x.m_position;
    m_tracking_time = x.m_tracking_time;
    m_blink = x.m_blink;
    m_blinking_time = x.m_blinking_time;
    m_remaining_time = x.m_remaining_time;

    return *this;
}

ros2_interface::msg::TrafficLight& ros2_interface::msg::TrafficLight::operator =(
        TrafficLight&& x) noexcept
{

    m_color = x.m_color;
    m_id = x.m_id;
    m_type = x.m_type;
    m_confidence = x.m_confidence;
    m_position = std::move(x.m_position);
    m_tracking_time = x.m_tracking_time;
    m_blink = x.m_blink;
    m_blinking_time = x.m_blinking_time;
    m_remaining_time = x.m_remaining_time;

    return *this;
}

bool ros2_interface::msg::TrafficLight::operator ==(
        const TrafficLight& x) const
{

    return (m_color == x.m_color && m_id == x.m_id && m_type == x.m_type && m_confidence == x.m_confidence && m_position == x.m_position && m_tracking_time == x.m_tracking_time && m_blink == x.m_blink && m_blinking_time == x.m_blinking_time && m_remaining_time == x.m_remaining_time);
}

bool ros2_interface::msg::TrafficLight::operator !=(
        const TrafficLight& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TrafficLight::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLight_max_cdr_typesize;
}

size_t ros2_interface::msg::TrafficLight::getCdrSerializedSize(
        const ros2_interface::msg::TrafficLight& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.position(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TrafficLight::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_color;
    scdr << m_id;
    scdr << m_type;
    scdr << m_confidence;
    scdr << m_position;
    scdr << m_tracking_time;
    scdr << m_blink;
    scdr << m_blinking_time;
    scdr << m_remaining_time;

}

void ros2_interface::msg::TrafficLight::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_color;
    dcdr >> m_id;
    dcdr >> m_type;
    dcdr >> m_confidence;
    dcdr >> m_position;
    dcdr >> m_tracking_time;
    dcdr >> m_blink;
    dcdr >> m_blinking_time;
    dcdr >> m_remaining_time;
}

/*!
 * @brief This function sets a value in member color
 * @param _color New value for member color
 */
void ros2_interface::msg::TrafficLight::color(
        int32_t _color)
{
    m_color = _color;
}

/*!
 * @brief This function returns the value of member color
 * @return Value of member color
 */
int32_t ros2_interface::msg::TrafficLight::color() const
{
    return m_color;
}

/*!
 * @brief This function returns a reference to member color
 * @return Reference to member color
 */
int32_t& ros2_interface::msg::TrafficLight::color()
{
    return m_color;
}

/*!
 * @brief This function sets a value in member id
 * @param _id New value for member id
 */
void ros2_interface::msg::TrafficLight::id(
        uint32_t _id)
{
    m_id = _id;
}

/*!
 * @brief This function returns the value of member id
 * @return Value of member id
 */
uint32_t ros2_interface::msg::TrafficLight::id() const
{
    return m_id;
}

/*!
 * @brief This function returns a reference to member id
 * @return Reference to member id
 */
uint32_t& ros2_interface::msg::TrafficLight::id()
{
    return m_id;
}

/*!
 * @brief This function sets a value in member type
 * @param _type New value for member type
 */
void ros2_interface::msg::TrafficLight::type(
        int32_t _type)
{
    m_type = _type;
}

/*!
 * @brief This function returns the value of member type
 * @return Value of member type
 */
int32_t ros2_interface::msg::TrafficLight::type() const
{
    return m_type;
}

/*!
 * @brief This function returns a reference to member type
 * @return Reference to member type
 */
int32_t& ros2_interface::msg::TrafficLight::type()
{
    return m_type;
}

/*!
 * @brief This function sets a value in member confidence
 * @param _confidence New value for member confidence
 */
void ros2_interface::msg::TrafficLight::confidence(
        double _confidence)
{
    m_confidence = _confidence;
}

/*!
 * @brief This function returns the value of member confidence
 * @return Value of member confidence
 */
double ros2_interface::msg::TrafficLight::confidence() const
{
    return m_confidence;
}

/*!
 * @brief This function returns a reference to member confidence
 * @return Reference to member confidence
 */
double& ros2_interface::msg::TrafficLight::confidence()
{
    return m_confidence;
}

/*!
 * @brief This function copies the value in member position
 * @param _position New value to be copied in member position
 */
void ros2_interface::msg::TrafficLight::position(
        const ros2_interface::msg::Point3D& _position)
{
    m_position = _position;
}

/*!
 * @brief This function moves the value in member position
 * @param _position New value to be moved in member position
 */
void ros2_interface::msg::TrafficLight::position(
        ros2_interface::msg::Point3D&& _position)
{
    m_position = std::move(_position);
}

/*!
 * @brief This function returns a constant reference to member position
 * @return Constant reference to member position
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::TrafficLight::position() const
{
    return m_position;
}

/*!
 * @brief This function returns a reference to member position
 * @return Reference to member position
 */
ros2_interface::msg::Point3D& ros2_interface::msg::TrafficLight::position()
{
    return m_position;
}
/*!
 * @brief This function sets a value in member tracking_time
 * @param _tracking_time New value for member tracking_time
 */
void ros2_interface::msg::TrafficLight::tracking_time(
        double _tracking_time)
{
    m_tracking_time = _tracking_time;
}

/*!
 * @brief This function returns the value of member tracking_time
 * @return Value of member tracking_time
 */
double ros2_interface::msg::TrafficLight::tracking_time() const
{
    return m_tracking_time;
}

/*!
 * @brief This function returns a reference to member tracking_time
 * @return Reference to member tracking_time
 */
double& ros2_interface::msg::TrafficLight::tracking_time()
{
    return m_tracking_time;
}

/*!
 * @brief This function sets a value in member blink
 * @param _blink New value for member blink
 */
void ros2_interface::msg::TrafficLight::blink(
        bool _blink)
{
    m_blink = _blink;
}

/*!
 * @brief This function returns the value of member blink
 * @return Value of member blink
 */
bool ros2_interface::msg::TrafficLight::blink() const
{
    return m_blink;
}

/*!
 * @brief This function returns a reference to member blink
 * @return Reference to member blink
 */
bool& ros2_interface::msg::TrafficLight::blink()
{
    return m_blink;
}

/*!
 * @brief This function sets a value in member blinking_time
 * @param _blinking_time New value for member blinking_time
 */
void ros2_interface::msg::TrafficLight::blinking_time(
        double _blinking_time)
{
    m_blinking_time = _blinking_time;
}

/*!
 * @brief This function returns the value of member blinking_time
 * @return Value of member blinking_time
 */
double ros2_interface::msg::TrafficLight::blinking_time() const
{
    return m_blinking_time;
}

/*!
 * @brief This function returns a reference to member blinking_time
 * @return Reference to member blinking_time
 */
double& ros2_interface::msg::TrafficLight::blinking_time()
{
    return m_blinking_time;
}

/*!
 * @brief This function sets a value in member remaining_time
 * @param _remaining_time New value for member remaining_time
 */
void ros2_interface::msg::TrafficLight::remaining_time(
        double _remaining_time)
{
    m_remaining_time = _remaining_time;
}

/*!
 * @brief This function returns the value of member remaining_time
 * @return Value of member remaining_time
 */
double ros2_interface::msg::TrafficLight::remaining_time() const
{
    return m_remaining_time;
}

/*!
 * @brief This function returns a reference to member remaining_time
 * @return Reference to member remaining_time
 */
double& ros2_interface::msg::TrafficLight::remaining_time()
{
    return m_remaining_time;
}



size_t ros2_interface::msg::TrafficLight::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLight_max_key_cdr_typesize;
}

bool ros2_interface::msg::TrafficLight::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TrafficLight::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



