// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLight.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHT_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHT_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TRAFFICLIGHT_SOURCE)
#define TRAFFICLIGHT_DllAPI __declspec( dllexport )
#else
#define TRAFFICLIGHT_DllAPI __declspec( dllimport )
#endif // TRAFFICLIGHT_SOURCE
#else
#define TRAFFICLIGHT_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TRAFFICLIGHT_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TrafficLight defined by the user in the IDL file.
         * @ingroup TrafficLight
         */
        class TrafficLight
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TrafficLight();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TrafficLight();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLight that will be copied.
             */
            eProsima_user_DllExport TrafficLight(
                    const TrafficLight& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLight that will be copied.
             */
            eProsima_user_DllExport TrafficLight(
                    TrafficLight&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLight that will be copied.
             */
            eProsima_user_DllExport TrafficLight& operator =(
                    const TrafficLight& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLight that will be copied.
             */
            eProsima_user_DllExport TrafficLight& operator =(
                    TrafficLight&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLight object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TrafficLight& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLight object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TrafficLight& x) const;

            /*!
             * @brief This function sets a value in member color
             * @param _color New value for member color
             */
            eProsima_user_DllExport void color(
                    int32_t _color);

            /*!
             * @brief This function returns the value of member color
             * @return Value of member color
             */
            eProsima_user_DllExport int32_t color() const;

            /*!
             * @brief This function returns a reference to member color
             * @return Reference to member color
             */
            eProsima_user_DllExport int32_t& color();

            /*!
             * @brief This function sets a value in member id
             * @param _id New value for member id
             */
            eProsima_user_DllExport void id(
                    uint32_t _id);

            /*!
             * @brief This function returns the value of member id
             * @return Value of member id
             */
            eProsima_user_DllExport uint32_t id() const;

            /*!
             * @brief This function returns a reference to member id
             * @return Reference to member id
             */
            eProsima_user_DllExport uint32_t& id();

            /*!
             * @brief This function sets a value in member type
             * @param _type New value for member type
             */
            eProsima_user_DllExport void type(
                    int32_t _type);

            /*!
             * @brief This function returns the value of member type
             * @return Value of member type
             */
            eProsima_user_DllExport int32_t type() const;

            /*!
             * @brief This function returns a reference to member type
             * @return Reference to member type
             */
            eProsima_user_DllExport int32_t& type();

            /*!
             * @brief This function sets a value in member confidence
             * @param _confidence New value for member confidence
             */
            eProsima_user_DllExport void confidence(
                    double _confidence);

            /*!
             * @brief This function returns the value of member confidence
             * @return Value of member confidence
             */
            eProsima_user_DllExport double confidence() const;

            /*!
             * @brief This function returns a reference to member confidence
             * @return Reference to member confidence
             */
            eProsima_user_DllExport double& confidence();

            /*!
             * @brief This function copies the value in member position
             * @param _position New value to be copied in member position
             */
            eProsima_user_DllExport void position(
                    const ros2_interface::msg::Point3D& _position);

            /*!
             * @brief This function moves the value in member position
             * @param _position New value to be moved in member position
             */
            eProsima_user_DllExport void position(
                    ros2_interface::msg::Point3D&& _position);

            /*!
             * @brief This function returns a constant reference to member position
             * @return Constant reference to member position
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& position() const;

            /*!
             * @brief This function returns a reference to member position
             * @return Reference to member position
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& position();
            /*!
             * @brief This function sets a value in member tracking_time
             * @param _tracking_time New value for member tracking_time
             */
            eProsima_user_DllExport void tracking_time(
                    double _tracking_time);

            /*!
             * @brief This function returns the value of member tracking_time
             * @return Value of member tracking_time
             */
            eProsima_user_DllExport double tracking_time() const;

            /*!
             * @brief This function returns a reference to member tracking_time
             * @return Reference to member tracking_time
             */
            eProsima_user_DllExport double& tracking_time();

            /*!
             * @brief This function sets a value in member blink
             * @param _blink New value for member blink
             */
            eProsima_user_DllExport void blink(
                    bool _blink);

            /*!
             * @brief This function returns the value of member blink
             * @return Value of member blink
             */
            eProsima_user_DllExport bool blink() const;

            /*!
             * @brief This function returns a reference to member blink
             * @return Reference to member blink
             */
            eProsima_user_DllExport bool& blink();

            /*!
             * @brief This function sets a value in member blinking_time
             * @param _blinking_time New value for member blinking_time
             */
            eProsima_user_DllExport void blinking_time(
                    double _blinking_time);

            /*!
             * @brief This function returns the value of member blinking_time
             * @return Value of member blinking_time
             */
            eProsima_user_DllExport double blinking_time() const;

            /*!
             * @brief This function returns a reference to member blinking_time
             * @return Reference to member blinking_time
             */
            eProsima_user_DllExport double& blinking_time();

            /*!
             * @brief This function sets a value in member remaining_time
             * @param _remaining_time New value for member remaining_time
             */
            eProsima_user_DllExport void remaining_time(
                    double _remaining_time);

            /*!
             * @brief This function returns the value of member remaining_time
             * @return Value of member remaining_time
             */
            eProsima_user_DllExport double remaining_time() const;

            /*!
             * @brief This function returns a reference to member remaining_time
             * @return Reference to member remaining_time
             */
            eProsima_user_DllExport double& remaining_time();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TrafficLight& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_color;
            uint32_t m_id;
            int32_t m_type;
            double m_confidence;
            ros2_interface::msg::Point3D m_position;
            double m_tracking_time;
            bool m_blink;
            double m_blinking_time;
            double m_remaining_time;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHT_H_

