// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightBox.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TrafficLightBox.h"
#include "TrafficLightBoxTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_TrafficLightBox_max_cdr_typesize 284ULL;
#define ros2_interface_msg_TrafficLightBox_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TrafficLightBox::TrafficLightBox()
{
    // long m_x
    m_x = 0;
    // long m_y
    m_y = 0;
    // long m_width
    m_width = 0;
    // long m_height
    m_height = 0;
    // long m_color
    m_color = 0;
    // boolean m_selected
    m_selected = false;
    // string m_camera_name
    m_camera_name ="";

    // Just to register all known types
    registerTrafficLightBoxTypes();
}

ros2_interface::msg::TrafficLightBox::~TrafficLightBox()
{







}

ros2_interface::msg::TrafficLightBox::TrafficLightBox(
        const TrafficLightBox& x)
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
    m_color = x.m_color;
    m_selected = x.m_selected;
    m_camera_name = x.m_camera_name;
}

ros2_interface::msg::TrafficLightBox::TrafficLightBox(
        TrafficLightBox&& x) noexcept 
{
    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
    m_color = x.m_color;
    m_selected = x.m_selected;
    m_camera_name = std::move(x.m_camera_name);
}

ros2_interface::msg::TrafficLightBox& ros2_interface::msg::TrafficLightBox::operator =(
        const TrafficLightBox& x)
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
    m_color = x.m_color;
    m_selected = x.m_selected;
    m_camera_name = x.m_camera_name;

    return *this;
}

ros2_interface::msg::TrafficLightBox& ros2_interface::msg::TrafficLightBox::operator =(
        TrafficLightBox&& x) noexcept
{

    m_x = x.m_x;
    m_y = x.m_y;
    m_width = x.m_width;
    m_height = x.m_height;
    m_color = x.m_color;
    m_selected = x.m_selected;
    m_camera_name = std::move(x.m_camera_name);

    return *this;
}

bool ros2_interface::msg::TrafficLightBox::operator ==(
        const TrafficLightBox& x) const
{

    return (m_x == x.m_x && m_y == x.m_y && m_width == x.m_width && m_height == x.m_height && m_color == x.m_color && m_selected == x.m_selected && m_camera_name == x.m_camera_name);
}

bool ros2_interface::msg::TrafficLightBox::operator !=(
        const TrafficLightBox& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TrafficLightBox::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightBox_max_cdr_typesize;
}

size_t ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(
        const ros2_interface::msg::TrafficLightBox& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.camera_name().size() + 1;


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TrafficLightBox::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_x;
    scdr << m_y;
    scdr << m_width;
    scdr << m_height;
    scdr << m_color;
    scdr << m_selected;
    scdr << m_camera_name.c_str();

}

void ros2_interface::msg::TrafficLightBox::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_color;
    dcdr >> m_selected;
    dcdr >> m_camera_name;
}

/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::TrafficLightBox::x(
        int32_t _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
int32_t ros2_interface::msg::TrafficLightBox::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
int32_t& ros2_interface::msg::TrafficLightBox::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::TrafficLightBox::y(
        int32_t _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
int32_t ros2_interface::msg::TrafficLightBox::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
int32_t& ros2_interface::msg::TrafficLightBox::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::TrafficLightBox::width(
        int32_t _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
int32_t ros2_interface::msg::TrafficLightBox::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
int32_t& ros2_interface::msg::TrafficLightBox::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::TrafficLightBox::height(
        int32_t _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
int32_t ros2_interface::msg::TrafficLightBox::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
int32_t& ros2_interface::msg::TrafficLightBox::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member color
 * @param _color New value for member color
 */
void ros2_interface::msg::TrafficLightBox::color(
        int32_t _color)
{
    m_color = _color;
}

/*!
 * @brief This function returns the value of member color
 * @return Value of member color
 */
int32_t ros2_interface::msg::TrafficLightBox::color() const
{
    return m_color;
}

/*!
 * @brief This function returns a reference to member color
 * @return Reference to member color
 */
int32_t& ros2_interface::msg::TrafficLightBox::color()
{
    return m_color;
}

/*!
 * @brief This function sets a value in member selected
 * @param _selected New value for member selected
 */
void ros2_interface::msg::TrafficLightBox::selected(
        bool _selected)
{
    m_selected = _selected;
}

/*!
 * @brief This function returns the value of member selected
 * @return Value of member selected
 */
bool ros2_interface::msg::TrafficLightBox::selected() const
{
    return m_selected;
}

/*!
 * @brief This function returns a reference to member selected
 * @return Reference to member selected
 */
bool& ros2_interface::msg::TrafficLightBox::selected()
{
    return m_selected;
}

/*!
 * @brief This function copies the value in member camera_name
 * @param _camera_name New value to be copied in member camera_name
 */
void ros2_interface::msg::TrafficLightBox::camera_name(
        const std::string& _camera_name)
{
    m_camera_name = _camera_name;
}

/*!
 * @brief This function moves the value in member camera_name
 * @param _camera_name New value to be moved in member camera_name
 */
void ros2_interface::msg::TrafficLightBox::camera_name(
        std::string&& _camera_name)
{
    m_camera_name = std::move(_camera_name);
}

/*!
 * @brief This function returns a constant reference to member camera_name
 * @return Constant reference to member camera_name
 */
const std::string& ros2_interface::msg::TrafficLightBox::camera_name() const
{
    return m_camera_name;
}

/*!
 * @brief This function returns a reference to member camera_name
 * @return Reference to member camera_name
 */
std::string& ros2_interface::msg::TrafficLightBox::camera_name()
{
    return m_camera_name;
}


size_t ros2_interface::msg::TrafficLightBox::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightBox_max_key_cdr_typesize;
}

bool ros2_interface::msg::TrafficLightBox::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TrafficLightBox::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



