// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightBox.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTBOX_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTBOX_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TRAFFICLIGHTBOX_SOURCE)
#define TRAFFICLIGHTBOX_DllAPI __declspec( dllexport )
#else
#define TRAFFICLIGHTBOX_DllAPI __declspec( dllimport )
#endif // TRAFFICLIGHTBOX_SOURCE
#else
#define TRAFFICLIGHTBOX_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TRAFFICLIGHTBOX_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TrafficLightBox defined by the user in the IDL file.
         * @ingroup TrafficLightBox
         */
        class TrafficLightBox
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TrafficLightBox();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TrafficLightBox();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightBox that will be copied.
             */
            eProsima_user_DllExport TrafficLightBox(
                    const TrafficLightBox& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightBox that will be copied.
             */
            eProsima_user_DllExport TrafficLightBox(
                    TrafficLightBox&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightBox that will be copied.
             */
            eProsima_user_DllExport TrafficLightBox& operator =(
                    const TrafficLightBox& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightBox that will be copied.
             */
            eProsima_user_DllExport TrafficLightBox& operator =(
                    TrafficLightBox&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightBox object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TrafficLightBox& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightBox object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TrafficLightBox& x) const;

            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    int32_t _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport int32_t x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport int32_t& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    int32_t _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport int32_t y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport int32_t& y();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    int32_t _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport int32_t width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport int32_t& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    int32_t _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport int32_t height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport int32_t& height();

            /*!
             * @brief This function sets a value in member color
             * @param _color New value for member color
             */
            eProsima_user_DllExport void color(
                    int32_t _color);

            /*!
             * @brief This function returns the value of member color
             * @return Value of member color
             */
            eProsima_user_DllExport int32_t color() const;

            /*!
             * @brief This function returns a reference to member color
             * @return Reference to member color
             */
            eProsima_user_DllExport int32_t& color();

            /*!
             * @brief This function sets a value in member selected
             * @param _selected New value for member selected
             */
            eProsima_user_DllExport void selected(
                    bool _selected);

            /*!
             * @brief This function returns the value of member selected
             * @return Value of member selected
             */
            eProsima_user_DllExport bool selected() const;

            /*!
             * @brief This function returns a reference to member selected
             * @return Reference to member selected
             */
            eProsima_user_DllExport bool& selected();

            /*!
             * @brief This function copies the value in member camera_name
             * @param _camera_name New value to be copied in member camera_name
             */
            eProsima_user_DllExport void camera_name(
                    const std::string& _camera_name);

            /*!
             * @brief This function moves the value in member camera_name
             * @param _camera_name New value to be moved in member camera_name
             */
            eProsima_user_DllExport void camera_name(
                    std::string&& _camera_name);

            /*!
             * @brief This function returns a constant reference to member camera_name
             * @return Constant reference to member camera_name
             */
            eProsima_user_DllExport const std::string& camera_name() const;

            /*!
             * @brief This function returns a reference to member camera_name
             * @return Reference to member camera_name
             */
            eProsima_user_DllExport std::string& camera_name();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TrafficLightBox& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_x;
            int32_t m_y;
            int32_t m_width;
            int32_t m_height;
            int32_t m_color;
            bool m_selected;
            std::string m_camera_name;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTBOX_H_

