// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightDebug.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TrafficLightDebug.h"
#include "TrafficLightDebugTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_TrafficLightDebug_max_cdr_typesize 142348ULL;
#define ros2_interface_msg_TrafficLightBox_max_cdr_typesize 284ULL;
#define ros2_interface_msg_TrafficLightDebug_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrafficLightBox_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TrafficLightDebug::TrafficLightDebug()
{
    // ros2_interface::msg::TrafficLightBox m_cropbox

    // sequence<ros2_interface::msg::TrafficLightBox> m_box

    // long m_signal_num
    m_signal_num = 0;
    // long m_valid_pos
    m_valid_pos = 0;
    // double m_ts_diff_pos
    m_ts_diff_pos = 0.0;
    // double m_ts_diff_sys
    m_ts_diff_sys = 0.0;
    // long m_project_error
    m_project_error = 0;
    // double m_distance_to_stop_line
    m_distance_to_stop_line = 0.0;
    // long m_camera_id
    m_camera_id = 0;
    // sequence<ros2_interface::msg::TrafficLightBox> m_crop_roi

    // sequence<ros2_interface::msg::TrafficLightBox> m_projected_roi

    // sequence<ros2_interface::msg::TrafficLightBox> m_rectified_roi

    // sequence<ros2_interface::msg::TrafficLightBox> m_debug_roi


    // Just to register all known types
    registerTrafficLightDebugTypes();
}

ros2_interface::msg::TrafficLightDebug::~TrafficLightDebug()
{













}

ros2_interface::msg::TrafficLightDebug::TrafficLightDebug(
        const TrafficLightDebug& x)
{
    m_cropbox = x.m_cropbox;
    m_box = x.m_box;
    m_signal_num = x.m_signal_num;
    m_valid_pos = x.m_valid_pos;
    m_ts_diff_pos = x.m_ts_diff_pos;
    m_ts_diff_sys = x.m_ts_diff_sys;
    m_project_error = x.m_project_error;
    m_distance_to_stop_line = x.m_distance_to_stop_line;
    m_camera_id = x.m_camera_id;
    m_crop_roi = x.m_crop_roi;
    m_projected_roi = x.m_projected_roi;
    m_rectified_roi = x.m_rectified_roi;
    m_debug_roi = x.m_debug_roi;
}

ros2_interface::msg::TrafficLightDebug::TrafficLightDebug(
        TrafficLightDebug&& x) noexcept 
{
    m_cropbox = std::move(x.m_cropbox);
    m_box = std::move(x.m_box);
    m_signal_num = x.m_signal_num;
    m_valid_pos = x.m_valid_pos;
    m_ts_diff_pos = x.m_ts_diff_pos;
    m_ts_diff_sys = x.m_ts_diff_sys;
    m_project_error = x.m_project_error;
    m_distance_to_stop_line = x.m_distance_to_stop_line;
    m_camera_id = x.m_camera_id;
    m_crop_roi = std::move(x.m_crop_roi);
    m_projected_roi = std::move(x.m_projected_roi);
    m_rectified_roi = std::move(x.m_rectified_roi);
    m_debug_roi = std::move(x.m_debug_roi);
}

ros2_interface::msg::TrafficLightDebug& ros2_interface::msg::TrafficLightDebug::operator =(
        const TrafficLightDebug& x)
{

    m_cropbox = x.m_cropbox;
    m_box = x.m_box;
    m_signal_num = x.m_signal_num;
    m_valid_pos = x.m_valid_pos;
    m_ts_diff_pos = x.m_ts_diff_pos;
    m_ts_diff_sys = x.m_ts_diff_sys;
    m_project_error = x.m_project_error;
    m_distance_to_stop_line = x.m_distance_to_stop_line;
    m_camera_id = x.m_camera_id;
    m_crop_roi = x.m_crop_roi;
    m_projected_roi = x.m_projected_roi;
    m_rectified_roi = x.m_rectified_roi;
    m_debug_roi = x.m_debug_roi;

    return *this;
}

ros2_interface::msg::TrafficLightDebug& ros2_interface::msg::TrafficLightDebug::operator =(
        TrafficLightDebug&& x) noexcept
{

    m_cropbox = std::move(x.m_cropbox);
    m_box = std::move(x.m_box);
    m_signal_num = x.m_signal_num;
    m_valid_pos = x.m_valid_pos;
    m_ts_diff_pos = x.m_ts_diff_pos;
    m_ts_diff_sys = x.m_ts_diff_sys;
    m_project_error = x.m_project_error;
    m_distance_to_stop_line = x.m_distance_to_stop_line;
    m_camera_id = x.m_camera_id;
    m_crop_roi = std::move(x.m_crop_roi);
    m_projected_roi = std::move(x.m_projected_roi);
    m_rectified_roi = std::move(x.m_rectified_roi);
    m_debug_roi = std::move(x.m_debug_roi);

    return *this;
}

bool ros2_interface::msg::TrafficLightDebug::operator ==(
        const TrafficLightDebug& x) const
{

    return (m_cropbox == x.m_cropbox && m_box == x.m_box && m_signal_num == x.m_signal_num && m_valid_pos == x.m_valid_pos && m_ts_diff_pos == x.m_ts_diff_pos && m_ts_diff_sys == x.m_ts_diff_sys && m_project_error == x.m_project_error && m_distance_to_stop_line == x.m_distance_to_stop_line && m_camera_id == x.m_camera_id && m_crop_roi == x.m_crop_roi && m_projected_roi == x.m_projected_roi && m_rectified_roi == x.m_rectified_roi && m_debug_roi == x.m_debug_roi);
}

bool ros2_interface::msg::TrafficLightDebug::operator !=(
        const TrafficLightDebug& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TrafficLightDebug::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightDebug_max_cdr_typesize;
}

size_t ros2_interface::msg::TrafficLightDebug::getCdrSerializedSize(
        const ros2_interface::msg::TrafficLightDebug& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.cropbox(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.box().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.box().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.crop_roi().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.crop_roi().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.projected_roi().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.projected_roi().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.rectified_roi().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.rectified_roi().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.debug_roi().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLightBox::getCdrSerializedSize(data.debug_roi().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TrafficLightDebug::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_cropbox;
    scdr << m_box;
    scdr << m_signal_num;
    scdr << m_valid_pos;
    scdr << m_ts_diff_pos;
    scdr << m_ts_diff_sys;
    scdr << m_project_error;
    scdr << m_distance_to_stop_line;
    scdr << m_camera_id;
    scdr << m_crop_roi;
    scdr << m_projected_roi;
    scdr << m_rectified_roi;
    scdr << m_debug_roi;

}

void ros2_interface::msg::TrafficLightDebug::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_cropbox;
    dcdr >> m_box;
    dcdr >> m_signal_num;
    dcdr >> m_valid_pos;
    dcdr >> m_ts_diff_pos;
    dcdr >> m_ts_diff_sys;
    dcdr >> m_project_error;
    dcdr >> m_distance_to_stop_line;
    dcdr >> m_camera_id;
    dcdr >> m_crop_roi;
    dcdr >> m_projected_roi;
    dcdr >> m_rectified_roi;
    dcdr >> m_debug_roi;
}

/*!
 * @brief This function copies the value in member cropbox
 * @param _cropbox New value to be copied in member cropbox
 */
void ros2_interface::msg::TrafficLightDebug::cropbox(
        const ros2_interface::msg::TrafficLightBox& _cropbox)
{
    m_cropbox = _cropbox;
}

/*!
 * @brief This function moves the value in member cropbox
 * @param _cropbox New value to be moved in member cropbox
 */
void ros2_interface::msg::TrafficLightDebug::cropbox(
        ros2_interface::msg::TrafficLightBox&& _cropbox)
{
    m_cropbox = std::move(_cropbox);
}

/*!
 * @brief This function returns a constant reference to member cropbox
 * @return Constant reference to member cropbox
 */
const ros2_interface::msg::TrafficLightBox& ros2_interface::msg::TrafficLightDebug::cropbox() const
{
    return m_cropbox;
}

/*!
 * @brief This function returns a reference to member cropbox
 * @return Reference to member cropbox
 */
ros2_interface::msg::TrafficLightBox& ros2_interface::msg::TrafficLightDebug::cropbox()
{
    return m_cropbox;
}
/*!
 * @brief This function copies the value in member box
 * @param _box New value to be copied in member box
 */
void ros2_interface::msg::TrafficLightDebug::box(
        const std::vector<ros2_interface::msg::TrafficLightBox>& _box)
{
    m_box = _box;
}

/*!
 * @brief This function moves the value in member box
 * @param _box New value to be moved in member box
 */
void ros2_interface::msg::TrafficLightDebug::box(
        std::vector<ros2_interface::msg::TrafficLightBox>&& _box)
{
    m_box = std::move(_box);
}

/*!
 * @brief This function returns a constant reference to member box
 * @return Constant reference to member box
 */
const std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::box() const
{
    return m_box;
}

/*!
 * @brief This function returns a reference to member box
 * @return Reference to member box
 */
std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::box()
{
    return m_box;
}
/*!
 * @brief This function sets a value in member signal_num
 * @param _signal_num New value for member signal_num
 */
void ros2_interface::msg::TrafficLightDebug::signal_num(
        int32_t _signal_num)
{
    m_signal_num = _signal_num;
}

/*!
 * @brief This function returns the value of member signal_num
 * @return Value of member signal_num
 */
int32_t ros2_interface::msg::TrafficLightDebug::signal_num() const
{
    return m_signal_num;
}

/*!
 * @brief This function returns a reference to member signal_num
 * @return Reference to member signal_num
 */
int32_t& ros2_interface::msg::TrafficLightDebug::signal_num()
{
    return m_signal_num;
}

/*!
 * @brief This function sets a value in member valid_pos
 * @param _valid_pos New value for member valid_pos
 */
void ros2_interface::msg::TrafficLightDebug::valid_pos(
        int32_t _valid_pos)
{
    m_valid_pos = _valid_pos;
}

/*!
 * @brief This function returns the value of member valid_pos
 * @return Value of member valid_pos
 */
int32_t ros2_interface::msg::TrafficLightDebug::valid_pos() const
{
    return m_valid_pos;
}

/*!
 * @brief This function returns a reference to member valid_pos
 * @return Reference to member valid_pos
 */
int32_t& ros2_interface::msg::TrafficLightDebug::valid_pos()
{
    return m_valid_pos;
}

/*!
 * @brief This function sets a value in member ts_diff_pos
 * @param _ts_diff_pos New value for member ts_diff_pos
 */
void ros2_interface::msg::TrafficLightDebug::ts_diff_pos(
        double _ts_diff_pos)
{
    m_ts_diff_pos = _ts_diff_pos;
}

/*!
 * @brief This function returns the value of member ts_diff_pos
 * @return Value of member ts_diff_pos
 */
double ros2_interface::msg::TrafficLightDebug::ts_diff_pos() const
{
    return m_ts_diff_pos;
}

/*!
 * @brief This function returns a reference to member ts_diff_pos
 * @return Reference to member ts_diff_pos
 */
double& ros2_interface::msg::TrafficLightDebug::ts_diff_pos()
{
    return m_ts_diff_pos;
}

/*!
 * @brief This function sets a value in member ts_diff_sys
 * @param _ts_diff_sys New value for member ts_diff_sys
 */
void ros2_interface::msg::TrafficLightDebug::ts_diff_sys(
        double _ts_diff_sys)
{
    m_ts_diff_sys = _ts_diff_sys;
}

/*!
 * @brief This function returns the value of member ts_diff_sys
 * @return Value of member ts_diff_sys
 */
double ros2_interface::msg::TrafficLightDebug::ts_diff_sys() const
{
    return m_ts_diff_sys;
}

/*!
 * @brief This function returns a reference to member ts_diff_sys
 * @return Reference to member ts_diff_sys
 */
double& ros2_interface::msg::TrafficLightDebug::ts_diff_sys()
{
    return m_ts_diff_sys;
}

/*!
 * @brief This function sets a value in member project_error
 * @param _project_error New value for member project_error
 */
void ros2_interface::msg::TrafficLightDebug::project_error(
        int32_t _project_error)
{
    m_project_error = _project_error;
}

/*!
 * @brief This function returns the value of member project_error
 * @return Value of member project_error
 */
int32_t ros2_interface::msg::TrafficLightDebug::project_error() const
{
    return m_project_error;
}

/*!
 * @brief This function returns a reference to member project_error
 * @return Reference to member project_error
 */
int32_t& ros2_interface::msg::TrafficLightDebug::project_error()
{
    return m_project_error;
}

/*!
 * @brief This function sets a value in member distance_to_stop_line
 * @param _distance_to_stop_line New value for member distance_to_stop_line
 */
void ros2_interface::msg::TrafficLightDebug::distance_to_stop_line(
        double _distance_to_stop_line)
{
    m_distance_to_stop_line = _distance_to_stop_line;
}

/*!
 * @brief This function returns the value of member distance_to_stop_line
 * @return Value of member distance_to_stop_line
 */
double ros2_interface::msg::TrafficLightDebug::distance_to_stop_line() const
{
    return m_distance_to_stop_line;
}

/*!
 * @brief This function returns a reference to member distance_to_stop_line
 * @return Reference to member distance_to_stop_line
 */
double& ros2_interface::msg::TrafficLightDebug::distance_to_stop_line()
{
    return m_distance_to_stop_line;
}

/*!
 * @brief This function sets a value in member camera_id
 * @param _camera_id New value for member camera_id
 */
void ros2_interface::msg::TrafficLightDebug::camera_id(
        int32_t _camera_id)
{
    m_camera_id = _camera_id;
}

/*!
 * @brief This function returns the value of member camera_id
 * @return Value of member camera_id
 */
int32_t ros2_interface::msg::TrafficLightDebug::camera_id() const
{
    return m_camera_id;
}

/*!
 * @brief This function returns a reference to member camera_id
 * @return Reference to member camera_id
 */
int32_t& ros2_interface::msg::TrafficLightDebug::camera_id()
{
    return m_camera_id;
}

/*!
 * @brief This function copies the value in member crop_roi
 * @param _crop_roi New value to be copied in member crop_roi
 */
void ros2_interface::msg::TrafficLightDebug::crop_roi(
        const std::vector<ros2_interface::msg::TrafficLightBox>& _crop_roi)
{
    m_crop_roi = _crop_roi;
}

/*!
 * @brief This function moves the value in member crop_roi
 * @param _crop_roi New value to be moved in member crop_roi
 */
void ros2_interface::msg::TrafficLightDebug::crop_roi(
        std::vector<ros2_interface::msg::TrafficLightBox>&& _crop_roi)
{
    m_crop_roi = std::move(_crop_roi);
}

/*!
 * @brief This function returns a constant reference to member crop_roi
 * @return Constant reference to member crop_roi
 */
const std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::crop_roi() const
{
    return m_crop_roi;
}

/*!
 * @brief This function returns a reference to member crop_roi
 * @return Reference to member crop_roi
 */
std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::crop_roi()
{
    return m_crop_roi;
}
/*!
 * @brief This function copies the value in member projected_roi
 * @param _projected_roi New value to be copied in member projected_roi
 */
void ros2_interface::msg::TrafficLightDebug::projected_roi(
        const std::vector<ros2_interface::msg::TrafficLightBox>& _projected_roi)
{
    m_projected_roi = _projected_roi;
}

/*!
 * @brief This function moves the value in member projected_roi
 * @param _projected_roi New value to be moved in member projected_roi
 */
void ros2_interface::msg::TrafficLightDebug::projected_roi(
        std::vector<ros2_interface::msg::TrafficLightBox>&& _projected_roi)
{
    m_projected_roi = std::move(_projected_roi);
}

/*!
 * @brief This function returns a constant reference to member projected_roi
 * @return Constant reference to member projected_roi
 */
const std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::projected_roi() const
{
    return m_projected_roi;
}

/*!
 * @brief This function returns a reference to member projected_roi
 * @return Reference to member projected_roi
 */
std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::projected_roi()
{
    return m_projected_roi;
}
/*!
 * @brief This function copies the value in member rectified_roi
 * @param _rectified_roi New value to be copied in member rectified_roi
 */
void ros2_interface::msg::TrafficLightDebug::rectified_roi(
        const std::vector<ros2_interface::msg::TrafficLightBox>& _rectified_roi)
{
    m_rectified_roi = _rectified_roi;
}

/*!
 * @brief This function moves the value in member rectified_roi
 * @param _rectified_roi New value to be moved in member rectified_roi
 */
void ros2_interface::msg::TrafficLightDebug::rectified_roi(
        std::vector<ros2_interface::msg::TrafficLightBox>&& _rectified_roi)
{
    m_rectified_roi = std::move(_rectified_roi);
}

/*!
 * @brief This function returns a constant reference to member rectified_roi
 * @return Constant reference to member rectified_roi
 */
const std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::rectified_roi() const
{
    return m_rectified_roi;
}

/*!
 * @brief This function returns a reference to member rectified_roi
 * @return Reference to member rectified_roi
 */
std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::rectified_roi()
{
    return m_rectified_roi;
}
/*!
 * @brief This function copies the value in member debug_roi
 * @param _debug_roi New value to be copied in member debug_roi
 */
void ros2_interface::msg::TrafficLightDebug::debug_roi(
        const std::vector<ros2_interface::msg::TrafficLightBox>& _debug_roi)
{
    m_debug_roi = _debug_roi;
}

/*!
 * @brief This function moves the value in member debug_roi
 * @param _debug_roi New value to be moved in member debug_roi
 */
void ros2_interface::msg::TrafficLightDebug::debug_roi(
        std::vector<ros2_interface::msg::TrafficLightBox>&& _debug_roi)
{
    m_debug_roi = std::move(_debug_roi);
}

/*!
 * @brief This function returns a constant reference to member debug_roi
 * @return Constant reference to member debug_roi
 */
const std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::debug_roi() const
{
    return m_debug_roi;
}

/*!
 * @brief This function returns a reference to member debug_roi
 * @return Reference to member debug_roi
 */
std::vector<ros2_interface::msg::TrafficLightBox>& ros2_interface::msg::TrafficLightDebug::debug_roi()
{
    return m_debug_roi;
}


size_t ros2_interface::msg::TrafficLightDebug::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightDebug_max_key_cdr_typesize;
}

bool ros2_interface::msg::TrafficLightDebug::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TrafficLightDebug::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



