// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightDebug.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTDEBUG_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTDEBUG_H_

#include "TrafficLightBox.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TRAFFICLIGHTDEBUG_SOURCE)
#define TRAFFICLIGHTDEBUG_DllAPI __declspec( dllexport )
#else
#define TRAFFICLIGHTDEBUG_DllAPI __declspec( dllimport )
#endif // TRAFFICLIGHTDEBUG_SOURCE
#else
#define TRAFFICLIGHTDEBUG_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TRAFFICLIGHTDEBUG_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TrafficLightDebug defined by the user in the IDL file.
         * @ingroup TrafficLightDebug
         */
        class TrafficLightDebug
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TrafficLightDebug();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TrafficLightDebug();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightDebug that will be copied.
             */
            eProsima_user_DllExport TrafficLightDebug(
                    const TrafficLightDebug& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightDebug that will be copied.
             */
            eProsima_user_DllExport TrafficLightDebug(
                    TrafficLightDebug&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightDebug that will be copied.
             */
            eProsima_user_DllExport TrafficLightDebug& operator =(
                    const TrafficLightDebug& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightDebug that will be copied.
             */
            eProsima_user_DllExport TrafficLightDebug& operator =(
                    TrafficLightDebug&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightDebug object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TrafficLightDebug& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightDebug object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TrafficLightDebug& x) const;

            /*!
             * @brief This function copies the value in member cropbox
             * @param _cropbox New value to be copied in member cropbox
             */
            eProsima_user_DllExport void cropbox(
                    const ros2_interface::msg::TrafficLightBox& _cropbox);

            /*!
             * @brief This function moves the value in member cropbox
             * @param _cropbox New value to be moved in member cropbox
             */
            eProsima_user_DllExport void cropbox(
                    ros2_interface::msg::TrafficLightBox&& _cropbox);

            /*!
             * @brief This function returns a constant reference to member cropbox
             * @return Constant reference to member cropbox
             */
            eProsima_user_DllExport const ros2_interface::msg::TrafficLightBox& cropbox() const;

            /*!
             * @brief This function returns a reference to member cropbox
             * @return Reference to member cropbox
             */
            eProsima_user_DllExport ros2_interface::msg::TrafficLightBox& cropbox();
            /*!
             * @brief This function copies the value in member box
             * @param _box New value to be copied in member box
             */
            eProsima_user_DllExport void box(
                    const std::vector<ros2_interface::msg::TrafficLightBox>& _box);

            /*!
             * @brief This function moves the value in member box
             * @param _box New value to be moved in member box
             */
            eProsima_user_DllExport void box(
                    std::vector<ros2_interface::msg::TrafficLightBox>&& _box);

            /*!
             * @brief This function returns a constant reference to member box
             * @return Constant reference to member box
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLightBox>& box() const;

            /*!
             * @brief This function returns a reference to member box
             * @return Reference to member box
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLightBox>& box();
            /*!
             * @brief This function sets a value in member signal_num
             * @param _signal_num New value for member signal_num
             */
            eProsima_user_DllExport void signal_num(
                    int32_t _signal_num);

            /*!
             * @brief This function returns the value of member signal_num
             * @return Value of member signal_num
             */
            eProsima_user_DllExport int32_t signal_num() const;

            /*!
             * @brief This function returns a reference to member signal_num
             * @return Reference to member signal_num
             */
            eProsima_user_DllExport int32_t& signal_num();

            /*!
             * @brief This function sets a value in member valid_pos
             * @param _valid_pos New value for member valid_pos
             */
            eProsima_user_DllExport void valid_pos(
                    int32_t _valid_pos);

            /*!
             * @brief This function returns the value of member valid_pos
             * @return Value of member valid_pos
             */
            eProsima_user_DllExport int32_t valid_pos() const;

            /*!
             * @brief This function returns a reference to member valid_pos
             * @return Reference to member valid_pos
             */
            eProsima_user_DllExport int32_t& valid_pos();

            /*!
             * @brief This function sets a value in member ts_diff_pos
             * @param _ts_diff_pos New value for member ts_diff_pos
             */
            eProsima_user_DllExport void ts_diff_pos(
                    double _ts_diff_pos);

            /*!
             * @brief This function returns the value of member ts_diff_pos
             * @return Value of member ts_diff_pos
             */
            eProsima_user_DllExport double ts_diff_pos() const;

            /*!
             * @brief This function returns a reference to member ts_diff_pos
             * @return Reference to member ts_diff_pos
             */
            eProsima_user_DllExport double& ts_diff_pos();

            /*!
             * @brief This function sets a value in member ts_diff_sys
             * @param _ts_diff_sys New value for member ts_diff_sys
             */
            eProsima_user_DllExport void ts_diff_sys(
                    double _ts_diff_sys);

            /*!
             * @brief This function returns the value of member ts_diff_sys
             * @return Value of member ts_diff_sys
             */
            eProsima_user_DllExport double ts_diff_sys() const;

            /*!
             * @brief This function returns a reference to member ts_diff_sys
             * @return Reference to member ts_diff_sys
             */
            eProsima_user_DllExport double& ts_diff_sys();

            /*!
             * @brief This function sets a value in member project_error
             * @param _project_error New value for member project_error
             */
            eProsima_user_DllExport void project_error(
                    int32_t _project_error);

            /*!
             * @brief This function returns the value of member project_error
             * @return Value of member project_error
             */
            eProsima_user_DllExport int32_t project_error() const;

            /*!
             * @brief This function returns a reference to member project_error
             * @return Reference to member project_error
             */
            eProsima_user_DllExport int32_t& project_error();

            /*!
             * @brief This function sets a value in member distance_to_stop_line
             * @param _distance_to_stop_line New value for member distance_to_stop_line
             */
            eProsima_user_DllExport void distance_to_stop_line(
                    double _distance_to_stop_line);

            /*!
             * @brief This function returns the value of member distance_to_stop_line
             * @return Value of member distance_to_stop_line
             */
            eProsima_user_DllExport double distance_to_stop_line() const;

            /*!
             * @brief This function returns a reference to member distance_to_stop_line
             * @return Reference to member distance_to_stop_line
             */
            eProsima_user_DllExport double& distance_to_stop_line();

            /*!
             * @brief This function sets a value in member camera_id
             * @param _camera_id New value for member camera_id
             */
            eProsima_user_DllExport void camera_id(
                    int32_t _camera_id);

            /*!
             * @brief This function returns the value of member camera_id
             * @return Value of member camera_id
             */
            eProsima_user_DllExport int32_t camera_id() const;

            /*!
             * @brief This function returns a reference to member camera_id
             * @return Reference to member camera_id
             */
            eProsima_user_DllExport int32_t& camera_id();

            /*!
             * @brief This function copies the value in member crop_roi
             * @param _crop_roi New value to be copied in member crop_roi
             */
            eProsima_user_DllExport void crop_roi(
                    const std::vector<ros2_interface::msg::TrafficLightBox>& _crop_roi);

            /*!
             * @brief This function moves the value in member crop_roi
             * @param _crop_roi New value to be moved in member crop_roi
             */
            eProsima_user_DllExport void crop_roi(
                    std::vector<ros2_interface::msg::TrafficLightBox>&& _crop_roi);

            /*!
             * @brief This function returns a constant reference to member crop_roi
             * @return Constant reference to member crop_roi
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLightBox>& crop_roi() const;

            /*!
             * @brief This function returns a reference to member crop_roi
             * @return Reference to member crop_roi
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLightBox>& crop_roi();
            /*!
             * @brief This function copies the value in member projected_roi
             * @param _projected_roi New value to be copied in member projected_roi
             */
            eProsima_user_DllExport void projected_roi(
                    const std::vector<ros2_interface::msg::TrafficLightBox>& _projected_roi);

            /*!
             * @brief This function moves the value in member projected_roi
             * @param _projected_roi New value to be moved in member projected_roi
             */
            eProsima_user_DllExport void projected_roi(
                    std::vector<ros2_interface::msg::TrafficLightBox>&& _projected_roi);

            /*!
             * @brief This function returns a constant reference to member projected_roi
             * @return Constant reference to member projected_roi
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLightBox>& projected_roi() const;

            /*!
             * @brief This function returns a reference to member projected_roi
             * @return Reference to member projected_roi
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLightBox>& projected_roi();
            /*!
             * @brief This function copies the value in member rectified_roi
             * @param _rectified_roi New value to be copied in member rectified_roi
             */
            eProsima_user_DllExport void rectified_roi(
                    const std::vector<ros2_interface::msg::TrafficLightBox>& _rectified_roi);

            /*!
             * @brief This function moves the value in member rectified_roi
             * @param _rectified_roi New value to be moved in member rectified_roi
             */
            eProsima_user_DllExport void rectified_roi(
                    std::vector<ros2_interface::msg::TrafficLightBox>&& _rectified_roi);

            /*!
             * @brief This function returns a constant reference to member rectified_roi
             * @return Constant reference to member rectified_roi
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLightBox>& rectified_roi() const;

            /*!
             * @brief This function returns a reference to member rectified_roi
             * @return Reference to member rectified_roi
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLightBox>& rectified_roi();
            /*!
             * @brief This function copies the value in member debug_roi
             * @param _debug_roi New value to be copied in member debug_roi
             */
            eProsima_user_DllExport void debug_roi(
                    const std::vector<ros2_interface::msg::TrafficLightBox>& _debug_roi);

            /*!
             * @brief This function moves the value in member debug_roi
             * @param _debug_roi New value to be moved in member debug_roi
             */
            eProsima_user_DllExport void debug_roi(
                    std::vector<ros2_interface::msg::TrafficLightBox>&& _debug_roi);

            /*!
             * @brief This function returns a constant reference to member debug_roi
             * @return Constant reference to member debug_roi
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLightBox>& debug_roi() const;

            /*!
             * @brief This function returns a reference to member debug_roi
             * @return Reference to member debug_roi
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLightBox>& debug_roi();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TrafficLightDebug& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::TrafficLightBox m_cropbox;
            std::vector<ros2_interface::msg::TrafficLightBox> m_box;
            int32_t m_signal_num;
            int32_t m_valid_pos;
            double m_ts_diff_pos;
            double m_ts_diff_sys;
            int32_t m_project_error;
            double m_distance_to_stop_line;
            int32_t m_camera_id;
            std::vector<ros2_interface::msg::TrafficLightBox> m_crop_roi;
            std::vector<ros2_interface::msg::TrafficLightBox> m_projected_roi;
            std::vector<ros2_interface::msg::TrafficLightBox> m_rectified_roi;
            std::vector<ros2_interface::msg::TrafficLightBox> m_debug_roi;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTDEBUG_H_

