// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightDebugTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "TrafficLightDebug.h"
#include "TrafficLightDebugTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerTrafficLightDebugTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::TrafficLightBox", ros2_interface::msg::GetTrafficLightBoxIdentifier(true),
                        ros2_interface::msg::GetTrafficLightBoxObject(true));
                factory->add_type_object("ros2_interface::msg::TrafficLightBox", ros2_interface::msg::GetTrafficLightBoxIdentifier(false),
                        ros2_interface::msg::GetTrafficLightBoxObject(false));



                factory->add_type_object("ros2_interface::msg::TrafficLightDebug", ros2_interface::msg::GetTrafficLightDebugIdentifier(true),
                        ros2_interface::msg::GetTrafficLightDebugObject(true));
                factory->add_type_object("ros2_interface::msg::TrafficLightDebug", ros2_interface::msg::GetTrafficLightDebugIdentifier(false),
                        ros2_interface::msg::GetTrafficLightDebugObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetTrafficLightDebugIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("TrafficLightDebug", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetTrafficLightDebugObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("TrafficLightDebug", complete);
        }

        const TypeObject* GetTrafficLightDebugObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLightDebug", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteTrafficLightDebugObject();
            }
            //else
            return GetMinimalTrafficLightDebugObject();
        }

        const TypeObject* GetMinimalTrafficLightDebugObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLightDebug", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_cropbox;
            mst_cropbox.common().member_id(memberId++);
            mst_cropbox.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cropbox.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cropbox.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cropbox.common().member_flags().IS_OPTIONAL(false);
            mst_cropbox.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cropbox.common().member_flags().IS_KEY(false);
            mst_cropbox.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cropbox.common().member_type_id(*ros2_interface::msg::GetTrafficLightBoxIdentifier(false));
            MD5 cropbox_hash("cropbox");
            for(int i = 0; i < 4; ++i)
            {
                mst_cropbox.detail().name_hash()[i] = cropbox_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cropbox);

            MinimalStructMember mst_box;
            mst_box.common().member_id(memberId++);
            mst_box.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_box.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_box.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_box.common().member_flags().IS_OPTIONAL(false);
            mst_box.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_box.common().member_flags().IS_KEY(false);
            mst_box.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_box.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, false));


            MD5 box_hash("box");
            for(int i = 0; i < 4; ++i)
            {
                mst_box.detail().name_hash()[i] = box_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_box);

            MinimalStructMember mst_signal_num;
            mst_signal_num.common().member_id(memberId++);
            mst_signal_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_signal_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_signal_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_signal_num.common().member_flags().IS_OPTIONAL(false);
            mst_signal_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_signal_num.common().member_flags().IS_KEY(false);
            mst_signal_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_signal_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 signal_num_hash("signal_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_signal_num.detail().name_hash()[i] = signal_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_signal_num);

            MinimalStructMember mst_valid_pos;
            mst_valid_pos.common().member_id(memberId++);
            mst_valid_pos.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_valid_pos.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_valid_pos.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_valid_pos.common().member_flags().IS_OPTIONAL(false);
            mst_valid_pos.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_valid_pos.common().member_flags().IS_KEY(false);
            mst_valid_pos.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_valid_pos.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 valid_pos_hash("valid_pos");
            for(int i = 0; i < 4; ++i)
            {
                mst_valid_pos.detail().name_hash()[i] = valid_pos_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_valid_pos);

            MinimalStructMember mst_ts_diff_pos;
            mst_ts_diff_pos.common().member_id(memberId++);
            mst_ts_diff_pos.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ts_diff_pos.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ts_diff_pos.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ts_diff_pos.common().member_flags().IS_OPTIONAL(false);
            mst_ts_diff_pos.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ts_diff_pos.common().member_flags().IS_KEY(false);
            mst_ts_diff_pos.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ts_diff_pos.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ts_diff_pos_hash("ts_diff_pos");
            for(int i = 0; i < 4; ++i)
            {
                mst_ts_diff_pos.detail().name_hash()[i] = ts_diff_pos_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ts_diff_pos);

            MinimalStructMember mst_ts_diff_sys;
            mst_ts_diff_sys.common().member_id(memberId++);
            mst_ts_diff_sys.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ts_diff_sys.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ts_diff_sys.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ts_diff_sys.common().member_flags().IS_OPTIONAL(false);
            mst_ts_diff_sys.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ts_diff_sys.common().member_flags().IS_KEY(false);
            mst_ts_diff_sys.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ts_diff_sys.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 ts_diff_sys_hash("ts_diff_sys");
            for(int i = 0; i < 4; ++i)
            {
                mst_ts_diff_sys.detail().name_hash()[i] = ts_diff_sys_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ts_diff_sys);

            MinimalStructMember mst_project_error;
            mst_project_error.common().member_id(memberId++);
            mst_project_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_project_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_project_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_project_error.common().member_flags().IS_OPTIONAL(false);
            mst_project_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_project_error.common().member_flags().IS_KEY(false);
            mst_project_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_project_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 project_error_hash("project_error");
            for(int i = 0; i < 4; ++i)
            {
                mst_project_error.detail().name_hash()[i] = project_error_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_project_error);

            MinimalStructMember mst_distance_to_stop_line;
            mst_distance_to_stop_line.common().member_id(memberId++);
            mst_distance_to_stop_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_distance_to_stop_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_distance_to_stop_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_distance_to_stop_line.common().member_flags().IS_OPTIONAL(false);
            mst_distance_to_stop_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_distance_to_stop_line.common().member_flags().IS_KEY(false);
            mst_distance_to_stop_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_distance_to_stop_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 distance_to_stop_line_hash("distance_to_stop_line");
            for(int i = 0; i < 4; ++i)
            {
                mst_distance_to_stop_line.detail().name_hash()[i] = distance_to_stop_line_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_distance_to_stop_line);

            MinimalStructMember mst_camera_id;
            mst_camera_id.common().member_id(memberId++);
            mst_camera_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_camera_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_camera_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_camera_id.common().member_flags().IS_OPTIONAL(false);
            mst_camera_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_camera_id.common().member_flags().IS_KEY(false);
            mst_camera_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_camera_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 camera_id_hash("camera_id");
            for(int i = 0; i < 4; ++i)
            {
                mst_camera_id.detail().name_hash()[i] = camera_id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_camera_id);

            MinimalStructMember mst_crop_roi;
            mst_crop_roi.common().member_id(memberId++);
            mst_crop_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_crop_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_crop_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_crop_roi.common().member_flags().IS_OPTIONAL(false);
            mst_crop_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_crop_roi.common().member_flags().IS_KEY(false);
            mst_crop_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_crop_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, false));


            MD5 crop_roi_hash("crop_roi");
            for(int i = 0; i < 4; ++i)
            {
                mst_crop_roi.detail().name_hash()[i] = crop_roi_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_crop_roi);

            MinimalStructMember mst_projected_roi;
            mst_projected_roi.common().member_id(memberId++);
            mst_projected_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_projected_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_projected_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_projected_roi.common().member_flags().IS_OPTIONAL(false);
            mst_projected_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_projected_roi.common().member_flags().IS_KEY(false);
            mst_projected_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_projected_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, false));


            MD5 projected_roi_hash("projected_roi");
            for(int i = 0; i < 4; ++i)
            {
                mst_projected_roi.detail().name_hash()[i] = projected_roi_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_projected_roi);

            MinimalStructMember mst_rectified_roi;
            mst_rectified_roi.common().member_id(memberId++);
            mst_rectified_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rectified_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rectified_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rectified_roi.common().member_flags().IS_OPTIONAL(false);
            mst_rectified_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rectified_roi.common().member_flags().IS_KEY(false);
            mst_rectified_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rectified_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, false));


            MD5 rectified_roi_hash("rectified_roi");
            for(int i = 0; i < 4; ++i)
            {
                mst_rectified_roi.detail().name_hash()[i] = rectified_roi_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rectified_roi);

            MinimalStructMember mst_debug_roi;
            mst_debug_roi.common().member_id(memberId++);
            mst_debug_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_debug_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_debug_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_debug_roi.common().member_flags().IS_OPTIONAL(false);
            mst_debug_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_debug_roi.common().member_flags().IS_KEY(false);
            mst_debug_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_debug_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, false));


            MD5 debug_roi_hash("debug_roi");
            for(int i = 0; i < 4; ++i)
            {
                mst_debug_roi.detail().name_hash()[i] = debug_roi_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_debug_roi);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficLightDebug", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficLightDebug", false);
        }

        const TypeObject* GetCompleteTrafficLightDebugObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLightDebug", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_cropbox;
            cst_cropbox.common().member_id(memberId++);
            cst_cropbox.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cropbox.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cropbox.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cropbox.common().member_flags().IS_OPTIONAL(false);
            cst_cropbox.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cropbox.common().member_flags().IS_KEY(false);
            cst_cropbox.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cropbox.common().member_type_id(*ros2_interface::msg::GetTrafficLightBoxIdentifier(true));
            cst_cropbox.detail().name("cropbox");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cropbox);

            CompleteStructMember cst_box;
            cst_box.common().member_id(memberId++);
            cst_box.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_box.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_box.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_box.common().member_flags().IS_OPTIONAL(false);
            cst_box.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_box.common().member_flags().IS_KEY(false);
            cst_box.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_box.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, true));


            cst_box.detail().name("box");

            type_object->complete().struct_type().member_seq().emplace_back(cst_box);

            CompleteStructMember cst_signal_num;
            cst_signal_num.common().member_id(memberId++);
            cst_signal_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_signal_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_signal_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_signal_num.common().member_flags().IS_OPTIONAL(false);
            cst_signal_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_signal_num.common().member_flags().IS_KEY(false);
            cst_signal_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_signal_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_signal_num.detail().name("signal_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_signal_num);

            CompleteStructMember cst_valid_pos;
            cst_valid_pos.common().member_id(memberId++);
            cst_valid_pos.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_valid_pos.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_valid_pos.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_valid_pos.common().member_flags().IS_OPTIONAL(false);
            cst_valid_pos.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_valid_pos.common().member_flags().IS_KEY(false);
            cst_valid_pos.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_valid_pos.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_valid_pos.detail().name("valid_pos");

            type_object->complete().struct_type().member_seq().emplace_back(cst_valid_pos);

            CompleteStructMember cst_ts_diff_pos;
            cst_ts_diff_pos.common().member_id(memberId++);
            cst_ts_diff_pos.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ts_diff_pos.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ts_diff_pos.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ts_diff_pos.common().member_flags().IS_OPTIONAL(false);
            cst_ts_diff_pos.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ts_diff_pos.common().member_flags().IS_KEY(false);
            cst_ts_diff_pos.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ts_diff_pos.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ts_diff_pos.detail().name("ts_diff_pos");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ts_diff_pos);

            CompleteStructMember cst_ts_diff_sys;
            cst_ts_diff_sys.common().member_id(memberId++);
            cst_ts_diff_sys.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ts_diff_sys.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ts_diff_sys.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ts_diff_sys.common().member_flags().IS_OPTIONAL(false);
            cst_ts_diff_sys.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ts_diff_sys.common().member_flags().IS_KEY(false);
            cst_ts_diff_sys.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ts_diff_sys.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_ts_diff_sys.detail().name("ts_diff_sys");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ts_diff_sys);

            CompleteStructMember cst_project_error;
            cst_project_error.common().member_id(memberId++);
            cst_project_error.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_project_error.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_project_error.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_project_error.common().member_flags().IS_OPTIONAL(false);
            cst_project_error.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_project_error.common().member_flags().IS_KEY(false);
            cst_project_error.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_project_error.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_project_error.detail().name("project_error");

            type_object->complete().struct_type().member_seq().emplace_back(cst_project_error);

            CompleteStructMember cst_distance_to_stop_line;
            cst_distance_to_stop_line.common().member_id(memberId++);
            cst_distance_to_stop_line.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_distance_to_stop_line.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_distance_to_stop_line.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_distance_to_stop_line.common().member_flags().IS_OPTIONAL(false);
            cst_distance_to_stop_line.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_distance_to_stop_line.common().member_flags().IS_KEY(false);
            cst_distance_to_stop_line.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_distance_to_stop_line.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_distance_to_stop_line.detail().name("distance_to_stop_line");

            type_object->complete().struct_type().member_seq().emplace_back(cst_distance_to_stop_line);

            CompleteStructMember cst_camera_id;
            cst_camera_id.common().member_id(memberId++);
            cst_camera_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_camera_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_camera_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_camera_id.common().member_flags().IS_OPTIONAL(false);
            cst_camera_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_camera_id.common().member_flags().IS_KEY(false);
            cst_camera_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_camera_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_camera_id.detail().name("camera_id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_camera_id);

            CompleteStructMember cst_crop_roi;
            cst_crop_roi.common().member_id(memberId++);
            cst_crop_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_crop_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_crop_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_crop_roi.common().member_flags().IS_OPTIONAL(false);
            cst_crop_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_crop_roi.common().member_flags().IS_KEY(false);
            cst_crop_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_crop_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, true));


            cst_crop_roi.detail().name("crop_roi");

            type_object->complete().struct_type().member_seq().emplace_back(cst_crop_roi);

            CompleteStructMember cst_projected_roi;
            cst_projected_roi.common().member_id(memberId++);
            cst_projected_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_projected_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_projected_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_projected_roi.common().member_flags().IS_OPTIONAL(false);
            cst_projected_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_projected_roi.common().member_flags().IS_KEY(false);
            cst_projected_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_projected_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, true));


            cst_projected_roi.detail().name("projected_roi");

            type_object->complete().struct_type().member_seq().emplace_back(cst_projected_roi);

            CompleteStructMember cst_rectified_roi;
            cst_rectified_roi.common().member_id(memberId++);
            cst_rectified_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rectified_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rectified_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rectified_roi.common().member_flags().IS_OPTIONAL(false);
            cst_rectified_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rectified_roi.common().member_flags().IS_KEY(false);
            cst_rectified_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rectified_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, true));


            cst_rectified_roi.detail().name("rectified_roi");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rectified_roi);

            CompleteStructMember cst_debug_roi;
            cst_debug_roi.common().member_id(memberId++);
            cst_debug_roi.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_debug_roi.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_debug_roi.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_debug_roi.common().member_flags().IS_OPTIONAL(false);
            cst_debug_roi.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_debug_roi.common().member_flags().IS_KEY(false);
            cst_debug_roi.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_debug_roi.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("ros2_interface::msg::TrafficLightBox", 100, true));


            cst_debug_roi.detail().name("debug_roi");

            type_object->complete().struct_type().member_seq().emplace_back(cst_debug_roi);


            // Header
            type_object->complete().struct_type().header().detail().type_name("TrafficLightDebug");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficLightDebug", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficLightDebug", true);
        }

    } // namespace msg
} // namespace ros2_interface