// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "TrafficLightList.h"
#include "TrafficLightListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_TrafficLight_max_cdr_typesize 80ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_TrafficLightList_max_cdr_typesize 8275ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrafficLight_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrafficLightList_max_key_cdr_typesize 0ULL;

ros2_interface::msg::TrafficLightList::TrafficLightList()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::TrafficLight> m_traffic_light

    // uint8 m_source
    m_source = 0;
    // uint8 m_camera_status
    m_camera_status = 0;
    // boolean m_is_valid
    m_is_valid = false;

    // Just to register all known types
    registerTrafficLightListTypes();
}

ros2_interface::msg::TrafficLightList::~TrafficLightList()
{





}

ros2_interface::msg::TrafficLightList::TrafficLightList(
        const TrafficLightList& x)
{
    m_header = x.m_header;
    m_traffic_light = x.m_traffic_light;
    m_source = x.m_source;
    m_camera_status = x.m_camera_status;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::TrafficLightList::TrafficLightList(
        TrafficLightList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_traffic_light = std::move(x.m_traffic_light);
    m_source = x.m_source;
    m_camera_status = x.m_camera_status;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::TrafficLightList& ros2_interface::msg::TrafficLightList::operator =(
        const TrafficLightList& x)
{

    m_header = x.m_header;
    m_traffic_light = x.m_traffic_light;
    m_source = x.m_source;
    m_camera_status = x.m_camera_status;
    m_is_valid = x.m_is_valid;

    return *this;
}

ros2_interface::msg::TrafficLightList& ros2_interface::msg::TrafficLightList::operator =(
        TrafficLightList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_traffic_light = std::move(x.m_traffic_light);
    m_source = x.m_source;
    m_camera_status = x.m_camera_status;
    m_is_valid = x.m_is_valid;

    return *this;
}

bool ros2_interface::msg::TrafficLightList::operator ==(
        const TrafficLightList& x) const
{

    return (m_header == x.m_header && m_traffic_light == x.m_traffic_light && m_source == x.m_source && m_camera_status == x.m_camera_status && m_is_valid == x.m_is_valid);
}

bool ros2_interface::msg::TrafficLightList::operator !=(
        const TrafficLightList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::TrafficLightList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightList_max_cdr_typesize;
}

size_t ros2_interface::msg::TrafficLightList::getCdrSerializedSize(
        const ros2_interface::msg::TrafficLightList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.traffic_light().size(); ++a)
    {
        current_alignment += ros2_interface::msg::TrafficLight::getCdrSerializedSize(data.traffic_light().at(a), current_alignment);}

    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::TrafficLightList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_traffic_light;
    scdr << m_source;
    scdr << m_camera_status;
    scdr << m_is_valid;

}

void ros2_interface::msg::TrafficLightList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_traffic_light;
    dcdr >> m_source;
    dcdr >> m_camera_status;
    dcdr >> m_is_valid;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::TrafficLightList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::TrafficLightList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::TrafficLightList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::TrafficLightList::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member traffic_light
 * @param _traffic_light New value to be copied in member traffic_light
 */
void ros2_interface::msg::TrafficLightList::traffic_light(
        const std::vector<ros2_interface::msg::TrafficLight>& _traffic_light)
{
    m_traffic_light = _traffic_light;
}

/*!
 * @brief This function moves the value in member traffic_light
 * @param _traffic_light New value to be moved in member traffic_light
 */
void ros2_interface::msg::TrafficLightList::traffic_light(
        std::vector<ros2_interface::msg::TrafficLight>&& _traffic_light)
{
    m_traffic_light = std::move(_traffic_light);
}

/*!
 * @brief This function returns a constant reference to member traffic_light
 * @return Constant reference to member traffic_light
 */
const std::vector<ros2_interface::msg::TrafficLight>& ros2_interface::msg::TrafficLightList::traffic_light() const
{
    return m_traffic_light;
}

/*!
 * @brief This function returns a reference to member traffic_light
 * @return Reference to member traffic_light
 */
std::vector<ros2_interface::msg::TrafficLight>& ros2_interface::msg::TrafficLightList::traffic_light()
{
    return m_traffic_light;
}
/*!
 * @brief This function sets a value in member source
 * @param _source New value for member source
 */
void ros2_interface::msg::TrafficLightList::source(
        uint8_t _source)
{
    m_source = _source;
}

/*!
 * @brief This function returns the value of member source
 * @return Value of member source
 */
uint8_t ros2_interface::msg::TrafficLightList::source() const
{
    return m_source;
}

/*!
 * @brief This function returns a reference to member source
 * @return Reference to member source
 */
uint8_t& ros2_interface::msg::TrafficLightList::source()
{
    return m_source;
}

/*!
 * @brief This function sets a value in member camera_status
 * @param _camera_status New value for member camera_status
 */
void ros2_interface::msg::TrafficLightList::camera_status(
        uint8_t _camera_status)
{
    m_camera_status = _camera_status;
}

/*!
 * @brief This function returns the value of member camera_status
 * @return Value of member camera_status
 */
uint8_t ros2_interface::msg::TrafficLightList::camera_status() const
{
    return m_camera_status;
}

/*!
 * @brief This function returns a reference to member camera_status
 * @return Reference to member camera_status
 */
uint8_t& ros2_interface::msg::TrafficLightList::camera_status()
{
    return m_camera_status;
}

/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::TrafficLightList::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::TrafficLightList::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::TrafficLightList::is_valid()
{
    return m_is_valid;
}



size_t ros2_interface::msg::TrafficLightList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_TrafficLightList_max_key_cdr_typesize;
}

bool ros2_interface::msg::TrafficLightList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::TrafficLightList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



