// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightList.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTLIST_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTLIST_H_

#include "Header.h"
#include "TrafficLight.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TRAFFICLIGHTLIST_SOURCE)
#define TRAFFICLIGHTLIST_DllAPI __declspec( dllexport )
#else
#define TRAFFICLIGHTLIST_DllAPI __declspec( dllimport )
#endif // TRAFFICLIGHTLIST_SOURCE
#else
#define TRAFFICLIGHTLIST_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TRAFFICLIGHTLIST_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure TrafficLightList defined by the user in the IDL file.
         * @ingroup TrafficLightList
         */
        class TrafficLightList
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport TrafficLightList();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~TrafficLightList();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightList that will be copied.
             */
            eProsima_user_DllExport TrafficLightList(
                    const TrafficLightList& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::TrafficLightList that will be copied.
             */
            eProsima_user_DllExport TrafficLightList(
                    TrafficLightList&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightList that will be copied.
             */
            eProsima_user_DllExport TrafficLightList& operator =(
                    const TrafficLightList& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::TrafficLightList that will be copied.
             */
            eProsima_user_DllExport TrafficLightList& operator =(
                    TrafficLightList&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightList object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const TrafficLightList& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::TrafficLightList object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const TrafficLightList& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member traffic_light
             * @param _traffic_light New value to be copied in member traffic_light
             */
            eProsima_user_DllExport void traffic_light(
                    const std::vector<ros2_interface::msg::TrafficLight>& _traffic_light);

            /*!
             * @brief This function moves the value in member traffic_light
             * @param _traffic_light New value to be moved in member traffic_light
             */
            eProsima_user_DllExport void traffic_light(
                    std::vector<ros2_interface::msg::TrafficLight>&& _traffic_light);

            /*!
             * @brief This function returns a constant reference to member traffic_light
             * @return Constant reference to member traffic_light
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::TrafficLight>& traffic_light() const;

            /*!
             * @brief This function returns a reference to member traffic_light
             * @return Reference to member traffic_light
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::TrafficLight>& traffic_light();
            /*!
             * @brief This function sets a value in member source
             * @param _source New value for member source
             */
            eProsima_user_DllExport void source(
                    uint8_t _source);

            /*!
             * @brief This function returns the value of member source
             * @return Value of member source
             */
            eProsima_user_DllExport uint8_t source() const;

            /*!
             * @brief This function returns a reference to member source
             * @return Reference to member source
             */
            eProsima_user_DllExport uint8_t& source();

            /*!
             * @brief This function sets a value in member camera_status
             * @param _camera_status New value for member camera_status
             */
            eProsima_user_DllExport void camera_status(
                    uint8_t _camera_status);

            /*!
             * @brief This function returns the value of member camera_status
             * @return Value of member camera_status
             */
            eProsima_user_DllExport uint8_t camera_status() const;

            /*!
             * @brief This function returns a reference to member camera_status
             * @return Reference to member camera_status
             */
            eProsima_user_DllExport uint8_t& camera_status();

            /*!
             * @brief This function sets a value in member is_valid
             * @param _is_valid New value for member is_valid
             */
            eProsima_user_DllExport void is_valid(
                    bool _is_valid);

            /*!
             * @brief This function returns the value of member is_valid
             * @return Value of member is_valid
             */
            eProsima_user_DllExport bool is_valid() const;

            /*!
             * @brief This function returns a reference to member is_valid
             * @return Reference to member is_valid
             */
            eProsima_user_DllExport bool& is_valid();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::TrafficLightList& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            std::vector<ros2_interface::msg::TrafficLight> m_traffic_light;
            uint8_t m_source;
            uint8_t m_camera_status;
            bool m_is_valid;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TRAFFICLIGHTLIST_H_

