// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file TrafficLightTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "TrafficLight.h"
#include "TrafficLightTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerTrafficLightTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::TrafficLight", ros2_interface::msg::GetTrafficLightIdentifier(true),
                        ros2_interface::msg::GetTrafficLightObject(true));
                factory->add_type_object("ros2_interface::msg::TrafficLight", ros2_interface::msg::GetTrafficLightIdentifier(false),
                        ros2_interface::msg::GetTrafficLightObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetTrafficLightIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("TrafficLight", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetTrafficLightObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("TrafficLight", complete);
        }

        const TypeObject* GetTrafficLightObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLight", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteTrafficLightObject();
            }
            //else
            return GetMinimalTrafficLightObject();
        }

        const TypeObject* GetMinimalTrafficLightObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLight", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_color;
            mst_color.common().member_id(memberId++);
            mst_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_color.common().member_flags().IS_OPTIONAL(false);
            mst_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_color.common().member_flags().IS_KEY(false);
            mst_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 color_hash("color");
            for(int i = 0; i < 4; ++i)
            {
                mst_color.detail().name_hash()[i] = color_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_color);

            MinimalStructMember mst_id;
            mst_id.common().member_id(memberId++);
            mst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_id.common().member_flags().IS_OPTIONAL(false);
            mst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_id.common().member_flags().IS_KEY(false);
            mst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 id_hash("id");
            for(int i = 0; i < 4; ++i)
            {
                mst_id.detail().name_hash()[i] = id_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_id);

            MinimalStructMember mst_type;
            mst_type.common().member_id(memberId++);
            mst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_type.common().member_flags().IS_OPTIONAL(false);
            mst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_type.common().member_flags().IS_KEY(false);
            mst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 type_hash("type");
            for(int i = 0; i < 4; ++i)
            {
                mst_type.detail().name_hash()[i] = type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_type);

            MinimalStructMember mst_confidence;
            mst_confidence.common().member_id(memberId++);
            mst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_confidence.common().member_flags().IS_OPTIONAL(false);
            mst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_confidence.common().member_flags().IS_KEY(false);
            mst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 confidence_hash("confidence");
            for(int i = 0; i < 4; ++i)
            {
                mst_confidence.detail().name_hash()[i] = confidence_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_confidence);

            MinimalStructMember mst_position;
            mst_position.common().member_id(memberId++);
            mst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position.common().member_flags().IS_OPTIONAL(false);
            mst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position.common().member_flags().IS_KEY(false);
            mst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 position_hash("position");
            for(int i = 0; i < 4; ++i)
            {
                mst_position.detail().name_hash()[i] = position_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position);

            MinimalStructMember mst_tracking_time;
            mst_tracking_time.common().member_id(memberId++);
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            mst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tracking_time.common().member_flags().IS_KEY(false);
            mst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tracking_time_hash("tracking_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_tracking_time.detail().name_hash()[i] = tracking_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tracking_time);

            MinimalStructMember mst_blink;
            mst_blink.common().member_id(memberId++);
            mst_blink.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_blink.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_blink.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_blink.common().member_flags().IS_OPTIONAL(false);
            mst_blink.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_blink.common().member_flags().IS_KEY(false);
            mst_blink.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_blink.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 blink_hash("blink");
            for(int i = 0; i < 4; ++i)
            {
                mst_blink.detail().name_hash()[i] = blink_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_blink);

            MinimalStructMember mst_blinking_time;
            mst_blinking_time.common().member_id(memberId++);
            mst_blinking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_blinking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_blinking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_blinking_time.common().member_flags().IS_OPTIONAL(false);
            mst_blinking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_blinking_time.common().member_flags().IS_KEY(false);
            mst_blinking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_blinking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 blinking_time_hash("blinking_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_blinking_time.detail().name_hash()[i] = blinking_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_blinking_time);

            MinimalStructMember mst_remaining_time;
            mst_remaining_time.common().member_id(memberId++);
            mst_remaining_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_remaining_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_remaining_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_remaining_time.common().member_flags().IS_OPTIONAL(false);
            mst_remaining_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_remaining_time.common().member_flags().IS_KEY(false);
            mst_remaining_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_remaining_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 remaining_time_hash("remaining_time");
            for(int i = 0; i < 4; ++i)
            {
                mst_remaining_time.detail().name_hash()[i] = remaining_time_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_remaining_time);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficLight", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficLight", false);
        }

        const TypeObject* GetCompleteTrafficLightObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("TrafficLight", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_color;
            cst_color.common().member_id(memberId++);
            cst_color.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_color.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_color.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_color.common().member_flags().IS_OPTIONAL(false);
            cst_color.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_color.common().member_flags().IS_KEY(false);
            cst_color.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_color.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_color.detail().name("color");

            type_object->complete().struct_type().member_seq().emplace_back(cst_color);

            CompleteStructMember cst_id;
            cst_id.common().member_id(memberId++);
            cst_id.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_id.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_id.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_id.common().member_flags().IS_OPTIONAL(false);
            cst_id.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_id.common().member_flags().IS_KEY(false);
            cst_id.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_id.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_id.detail().name("id");

            type_object->complete().struct_type().member_seq().emplace_back(cst_id);

            CompleteStructMember cst_type;
            cst_type.common().member_id(memberId++);
            cst_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_type.common().member_flags().IS_OPTIONAL(false);
            cst_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_type.common().member_flags().IS_KEY(false);
            cst_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_type.detail().name("type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_type);

            CompleteStructMember cst_confidence;
            cst_confidence.common().member_id(memberId++);
            cst_confidence.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_confidence.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_confidence.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_confidence.common().member_flags().IS_OPTIONAL(false);
            cst_confidence.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_confidence.common().member_flags().IS_KEY(false);
            cst_confidence.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_confidence.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_confidence.detail().name("confidence");

            type_object->complete().struct_type().member_seq().emplace_back(cst_confidence);

            CompleteStructMember cst_position;
            cst_position.common().member_id(memberId++);
            cst_position.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position.common().member_flags().IS_OPTIONAL(false);
            cst_position.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position.common().member_flags().IS_KEY(false);
            cst_position.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_position.detail().name("position");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position);

            CompleteStructMember cst_tracking_time;
            cst_tracking_time.common().member_id(memberId++);
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tracking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tracking_time.common().member_flags().IS_OPTIONAL(false);
            cst_tracking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tracking_time.common().member_flags().IS_KEY(false);
            cst_tracking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tracking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tracking_time.detail().name("tracking_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tracking_time);

            CompleteStructMember cst_blink;
            cst_blink.common().member_id(memberId++);
            cst_blink.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_blink.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_blink.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_blink.common().member_flags().IS_OPTIONAL(false);
            cst_blink.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_blink.common().member_flags().IS_KEY(false);
            cst_blink.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_blink.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_blink.detail().name("blink");

            type_object->complete().struct_type().member_seq().emplace_back(cst_blink);

            CompleteStructMember cst_blinking_time;
            cst_blinking_time.common().member_id(memberId++);
            cst_blinking_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_blinking_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_blinking_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_blinking_time.common().member_flags().IS_OPTIONAL(false);
            cst_blinking_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_blinking_time.common().member_flags().IS_KEY(false);
            cst_blinking_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_blinking_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_blinking_time.detail().name("blinking_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_blinking_time);

            CompleteStructMember cst_remaining_time;
            cst_remaining_time.common().member_id(memberId++);
            cst_remaining_time.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_remaining_time.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_remaining_time.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_remaining_time.common().member_flags().IS_OPTIONAL(false);
            cst_remaining_time.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_remaining_time.common().member_flags().IS_KEY(false);
            cst_remaining_time.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_remaining_time.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_remaining_time.detail().name("remaining_time");

            type_object->complete().struct_type().member_seq().emplace_back(cst_remaining_time);


            // Header
            type_object->complete().struct_type().header().detail().type_name("TrafficLight");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("TrafficLight", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("TrafficLight", true);
        }

    } // namespace msg
} // namespace ros2_interface