// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Twist.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Twist.h"
#include "TwistTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Twist_max_cdr_typesize 320ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Twist_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Twist::Twist()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::Point3D m_linear

    // ros2_interface::msg::Point3D m_angular


    // Just to register all known types
    registerTwistTypes();
}

ros2_interface::msg::Twist::~Twist()
{



}

ros2_interface::msg::Twist::Twist(
        const Twist& x)
{
    m_header = x.m_header;
    m_linear = x.m_linear;
    m_angular = x.m_angular;
}

ros2_interface::msg::Twist::Twist(
        Twist&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_linear = std::move(x.m_linear);
    m_angular = std::move(x.m_angular);
}

ros2_interface::msg::Twist& ros2_interface::msg::Twist::operator =(
        const Twist& x)
{

    m_header = x.m_header;
    m_linear = x.m_linear;
    m_angular = x.m_angular;

    return *this;
}

ros2_interface::msg::Twist& ros2_interface::msg::Twist::operator =(
        Twist&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_linear = std::move(x.m_linear);
    m_angular = std::move(x.m_angular);

    return *this;
}

bool ros2_interface::msg::Twist::operator ==(
        const Twist& x) const
{

    return (m_header == x.m_header && m_linear == x.m_linear && m_angular == x.m_angular);
}

bool ros2_interface::msg::Twist::operator !=(
        const Twist& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Twist::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Twist_max_cdr_typesize;
}

size_t ros2_interface::msg::Twist::getCdrSerializedSize(
        const ros2_interface::msg::Twist& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Twist::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_linear;
    scdr << m_angular;

}

void ros2_interface::msg::Twist::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_linear;
    dcdr >> m_angular;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Twist::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Twist::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Twist::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Twist::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member linear
 * @param _linear New value to be copied in member linear
 */
void ros2_interface::msg::Twist::linear(
        const ros2_interface::msg::Point3D& _linear)
{
    m_linear = _linear;
}

/*!
 * @brief This function moves the value in member linear
 * @param _linear New value to be moved in member linear
 */
void ros2_interface::msg::Twist::linear(
        ros2_interface::msg::Point3D&& _linear)
{
    m_linear = std::move(_linear);
}

/*!
 * @brief This function returns a constant reference to member linear
 * @return Constant reference to member linear
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Twist::linear() const
{
    return m_linear;
}

/*!
 * @brief This function returns a reference to member linear
 * @return Reference to member linear
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Twist::linear()
{
    return m_linear;
}
/*!
 * @brief This function copies the value in member angular
 * @param _angular New value to be copied in member angular
 */
void ros2_interface::msg::Twist::angular(
        const ros2_interface::msg::Point3D& _angular)
{
    m_angular = _angular;
}

/*!
 * @brief This function moves the value in member angular
 * @param _angular New value to be moved in member angular
 */
void ros2_interface::msg::Twist::angular(
        ros2_interface::msg::Point3D&& _angular)
{
    m_angular = std::move(_angular);
}

/*!
 * @brief This function returns a constant reference to member angular
 * @return Constant reference to member angular
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Twist::angular() const
{
    return m_angular;
}

/*!
 * @brief This function returns a reference to member angular
 * @return Reference to member angular
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Twist::angular()
{
    return m_angular;
}


size_t ros2_interface::msg::Twist::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Twist_max_key_cdr_typesize;
}

bool ros2_interface::msg::Twist::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Twist::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



