// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Twist.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TWIST_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TWIST_H_

#include "Header.h"
#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(TWIST_SOURCE)
#define TWIST_DllAPI __declspec( dllexport )
#else
#define TWIST_DllAPI __declspec( dllimport )
#endif // TWIST_SOURCE
#else
#define TWIST_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define TWIST_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Twist defined by the user in the IDL file.
         * @ingroup Twist
         */
        class Twist
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Twist();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Twist();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Twist that will be copied.
             */
            eProsima_user_DllExport Twist(
                    const Twist& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Twist that will be copied.
             */
            eProsima_user_DllExport Twist(
                    Twist&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Twist that will be copied.
             */
            eProsima_user_DllExport Twist& operator =(
                    const Twist& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Twist that will be copied.
             */
            eProsima_user_DllExport Twist& operator =(
                    Twist&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Twist object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Twist& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Twist object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Twist& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function copies the value in member linear
             * @param _linear New value to be copied in member linear
             */
            eProsima_user_DllExport void linear(
                    const ros2_interface::msg::Point3D& _linear);

            /*!
             * @brief This function moves the value in member linear
             * @param _linear New value to be moved in member linear
             */
            eProsima_user_DllExport void linear(
                    ros2_interface::msg::Point3D&& _linear);

            /*!
             * @brief This function returns a constant reference to member linear
             * @return Constant reference to member linear
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear() const;

            /*!
             * @brief This function returns a reference to member linear
             * @return Reference to member linear
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear();
            /*!
             * @brief This function copies the value in member angular
             * @param _angular New value to be copied in member angular
             */
            eProsima_user_DllExport void angular(
                    const ros2_interface::msg::Point3D& _angular);

            /*!
             * @brief This function moves the value in member angular
             * @param _angular New value to be moved in member angular
             */
            eProsima_user_DllExport void angular(
                    ros2_interface::msg::Point3D&& _angular);

            /*!
             * @brief This function returns a constant reference to member angular
             * @return Constant reference to member angular
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular() const;

            /*!
             * @brief This function returns a reference to member angular
             * @return Reference to member angular
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Twist& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            ros2_interface::msg::Point3D m_linear;
            ros2_interface::msg::Point3D m_angular;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_TWIST_H_

