// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Uncertainty.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Uncertainty.h"
#include "UncertaintyTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Uncertainty_max_cdr_typesize 120ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Uncertainty_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Uncertainty::Uncertainty()
{
    // ros2_interface::msg::Point3D m_position_std_dev

    // ros2_interface::msg::Point3D m_orientation_std_dev

    // ros2_interface::msg::Point3D m_linear_velocity_std_dev

    // ros2_interface::msg::Point3D m_linear_acceleration_std_dev

    // ros2_interface::msg::Point3D m_angular_velocity_std_dev


    // Just to register all known types
    registerUncertaintyTypes();
}

ros2_interface::msg::Uncertainty::~Uncertainty()
{





}

ros2_interface::msg::Uncertainty::Uncertainty(
        const Uncertainty& x)
{
    m_position_std_dev = x.m_position_std_dev;
    m_orientation_std_dev = x.m_orientation_std_dev;
    m_linear_velocity_std_dev = x.m_linear_velocity_std_dev;
    m_linear_acceleration_std_dev = x.m_linear_acceleration_std_dev;
    m_angular_velocity_std_dev = x.m_angular_velocity_std_dev;
}

ros2_interface::msg::Uncertainty::Uncertainty(
        Uncertainty&& x) noexcept 
{
    m_position_std_dev = std::move(x.m_position_std_dev);
    m_orientation_std_dev = std::move(x.m_orientation_std_dev);
    m_linear_velocity_std_dev = std::move(x.m_linear_velocity_std_dev);
    m_linear_acceleration_std_dev = std::move(x.m_linear_acceleration_std_dev);
    m_angular_velocity_std_dev = std::move(x.m_angular_velocity_std_dev);
}

ros2_interface::msg::Uncertainty& ros2_interface::msg::Uncertainty::operator =(
        const Uncertainty& x)
{

    m_position_std_dev = x.m_position_std_dev;
    m_orientation_std_dev = x.m_orientation_std_dev;
    m_linear_velocity_std_dev = x.m_linear_velocity_std_dev;
    m_linear_acceleration_std_dev = x.m_linear_acceleration_std_dev;
    m_angular_velocity_std_dev = x.m_angular_velocity_std_dev;

    return *this;
}

ros2_interface::msg::Uncertainty& ros2_interface::msg::Uncertainty::operator =(
        Uncertainty&& x) noexcept
{

    m_position_std_dev = std::move(x.m_position_std_dev);
    m_orientation_std_dev = std::move(x.m_orientation_std_dev);
    m_linear_velocity_std_dev = std::move(x.m_linear_velocity_std_dev);
    m_linear_acceleration_std_dev = std::move(x.m_linear_acceleration_std_dev);
    m_angular_velocity_std_dev = std::move(x.m_angular_velocity_std_dev);

    return *this;
}

bool ros2_interface::msg::Uncertainty::operator ==(
        const Uncertainty& x) const
{

    return (m_position_std_dev == x.m_position_std_dev && m_orientation_std_dev == x.m_orientation_std_dev && m_linear_velocity_std_dev == x.m_linear_velocity_std_dev && m_linear_acceleration_std_dev == x.m_linear_acceleration_std_dev && m_angular_velocity_std_dev == x.m_angular_velocity_std_dev);
}

bool ros2_interface::msg::Uncertainty::operator !=(
        const Uncertainty& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Uncertainty::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Uncertainty_max_cdr_typesize;
}

size_t ros2_interface::msg::Uncertainty::getCdrSerializedSize(
        const ros2_interface::msg::Uncertainty& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.position_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.orientation_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_velocity_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.linear_acceleration_std_dev(), current_alignment);
    current_alignment += ros2_interface::msg::Point3D::getCdrSerializedSize(data.angular_velocity_std_dev(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Uncertainty::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_position_std_dev;
    scdr << m_orientation_std_dev;
    scdr << m_linear_velocity_std_dev;
    scdr << m_linear_acceleration_std_dev;
    scdr << m_angular_velocity_std_dev;

}

void ros2_interface::msg::Uncertainty::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_position_std_dev;
    dcdr >> m_orientation_std_dev;
    dcdr >> m_linear_velocity_std_dev;
    dcdr >> m_linear_acceleration_std_dev;
    dcdr >> m_angular_velocity_std_dev;
}

/*!
 * @brief This function copies the value in member position_std_dev
 * @param _position_std_dev New value to be copied in member position_std_dev
 */
void ros2_interface::msg::Uncertainty::position_std_dev(
        const ros2_interface::msg::Point3D& _position_std_dev)
{
    m_position_std_dev = _position_std_dev;
}

/*!
 * @brief This function moves the value in member position_std_dev
 * @param _position_std_dev New value to be moved in member position_std_dev
 */
void ros2_interface::msg::Uncertainty::position_std_dev(
        ros2_interface::msg::Point3D&& _position_std_dev)
{
    m_position_std_dev = std::move(_position_std_dev);
}

/*!
 * @brief This function returns a constant reference to member position_std_dev
 * @return Constant reference to member position_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::position_std_dev() const
{
    return m_position_std_dev;
}

/*!
 * @brief This function returns a reference to member position_std_dev
 * @return Reference to member position_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::position_std_dev()
{
    return m_position_std_dev;
}
/*!
 * @brief This function copies the value in member orientation_std_dev
 * @param _orientation_std_dev New value to be copied in member orientation_std_dev
 */
void ros2_interface::msg::Uncertainty::orientation_std_dev(
        const ros2_interface::msg::Point3D& _orientation_std_dev)
{
    m_orientation_std_dev = _orientation_std_dev;
}

/*!
 * @brief This function moves the value in member orientation_std_dev
 * @param _orientation_std_dev New value to be moved in member orientation_std_dev
 */
void ros2_interface::msg::Uncertainty::orientation_std_dev(
        ros2_interface::msg::Point3D&& _orientation_std_dev)
{
    m_orientation_std_dev = std::move(_orientation_std_dev);
}

/*!
 * @brief This function returns a constant reference to member orientation_std_dev
 * @return Constant reference to member orientation_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::orientation_std_dev() const
{
    return m_orientation_std_dev;
}

/*!
 * @brief This function returns a reference to member orientation_std_dev
 * @return Reference to member orientation_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::orientation_std_dev()
{
    return m_orientation_std_dev;
}
/*!
 * @brief This function copies the value in member linear_velocity_std_dev
 * @param _linear_velocity_std_dev New value to be copied in member linear_velocity_std_dev
 */
void ros2_interface::msg::Uncertainty::linear_velocity_std_dev(
        const ros2_interface::msg::Point3D& _linear_velocity_std_dev)
{
    m_linear_velocity_std_dev = _linear_velocity_std_dev;
}

/*!
 * @brief This function moves the value in member linear_velocity_std_dev
 * @param _linear_velocity_std_dev New value to be moved in member linear_velocity_std_dev
 */
void ros2_interface::msg::Uncertainty::linear_velocity_std_dev(
        ros2_interface::msg::Point3D&& _linear_velocity_std_dev)
{
    m_linear_velocity_std_dev = std::move(_linear_velocity_std_dev);
}

/*!
 * @brief This function returns a constant reference to member linear_velocity_std_dev
 * @return Constant reference to member linear_velocity_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::linear_velocity_std_dev() const
{
    return m_linear_velocity_std_dev;
}

/*!
 * @brief This function returns a reference to member linear_velocity_std_dev
 * @return Reference to member linear_velocity_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::linear_velocity_std_dev()
{
    return m_linear_velocity_std_dev;
}
/*!
 * @brief This function copies the value in member linear_acceleration_std_dev
 * @param _linear_acceleration_std_dev New value to be copied in member linear_acceleration_std_dev
 */
void ros2_interface::msg::Uncertainty::linear_acceleration_std_dev(
        const ros2_interface::msg::Point3D& _linear_acceleration_std_dev)
{
    m_linear_acceleration_std_dev = _linear_acceleration_std_dev;
}

/*!
 * @brief This function moves the value in member linear_acceleration_std_dev
 * @param _linear_acceleration_std_dev New value to be moved in member linear_acceleration_std_dev
 */
void ros2_interface::msg::Uncertainty::linear_acceleration_std_dev(
        ros2_interface::msg::Point3D&& _linear_acceleration_std_dev)
{
    m_linear_acceleration_std_dev = std::move(_linear_acceleration_std_dev);
}

/*!
 * @brief This function returns a constant reference to member linear_acceleration_std_dev
 * @return Constant reference to member linear_acceleration_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::linear_acceleration_std_dev() const
{
    return m_linear_acceleration_std_dev;
}

/*!
 * @brief This function returns a reference to member linear_acceleration_std_dev
 * @return Reference to member linear_acceleration_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::linear_acceleration_std_dev()
{
    return m_linear_acceleration_std_dev;
}
/*!
 * @brief This function copies the value in member angular_velocity_std_dev
 * @param _angular_velocity_std_dev New value to be copied in member angular_velocity_std_dev
 */
void ros2_interface::msg::Uncertainty::angular_velocity_std_dev(
        const ros2_interface::msg::Point3D& _angular_velocity_std_dev)
{
    m_angular_velocity_std_dev = _angular_velocity_std_dev;
}

/*!
 * @brief This function moves the value in member angular_velocity_std_dev
 * @param _angular_velocity_std_dev New value to be moved in member angular_velocity_std_dev
 */
void ros2_interface::msg::Uncertainty::angular_velocity_std_dev(
        ros2_interface::msg::Point3D&& _angular_velocity_std_dev)
{
    m_angular_velocity_std_dev = std::move(_angular_velocity_std_dev);
}

/*!
 * @brief This function returns a constant reference to member angular_velocity_std_dev
 * @return Constant reference to member angular_velocity_std_dev
 */
const ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::angular_velocity_std_dev() const
{
    return m_angular_velocity_std_dev;
}

/*!
 * @brief This function returns a reference to member angular_velocity_std_dev
 * @return Reference to member angular_velocity_std_dev
 */
ros2_interface::msg::Point3D& ros2_interface::msg::Uncertainty::angular_velocity_std_dev()
{
    return m_angular_velocity_std_dev;
}


size_t ros2_interface::msg::Uncertainty::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Uncertainty_max_key_cdr_typesize;
}

bool ros2_interface::msg::Uncertainty::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Uncertainty::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



