// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Uncertainty.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_UNCERTAINTY_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_UNCERTAINTY_H_

#include "Point3D.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(UNCERTAINTY_SOURCE)
#define UNCERTAINTY_DllAPI __declspec( dllexport )
#else
#define UNCERTAINTY_DllAPI __declspec( dllimport )
#endif // UNCERTAINTY_SOURCE
#else
#define UNCERTAINTY_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define UNCERTAINTY_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Uncertainty defined by the user in the IDL file.
         * @ingroup Uncertainty
         */
        class Uncertainty
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Uncertainty();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Uncertainty();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Uncertainty that will be copied.
             */
            eProsima_user_DllExport Uncertainty(
                    const Uncertainty& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Uncertainty that will be copied.
             */
            eProsima_user_DllExport Uncertainty(
                    Uncertainty&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Uncertainty that will be copied.
             */
            eProsima_user_DllExport Uncertainty& operator =(
                    const Uncertainty& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Uncertainty that will be copied.
             */
            eProsima_user_DllExport Uncertainty& operator =(
                    Uncertainty&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Uncertainty object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Uncertainty& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Uncertainty object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Uncertainty& x) const;

            /*!
             * @brief This function copies the value in member position_std_dev
             * @param _position_std_dev New value to be copied in member position_std_dev
             */
            eProsima_user_DllExport void position_std_dev(
                    const ros2_interface::msg::Point3D& _position_std_dev);

            /*!
             * @brief This function moves the value in member position_std_dev
             * @param _position_std_dev New value to be moved in member position_std_dev
             */
            eProsima_user_DllExport void position_std_dev(
                    ros2_interface::msg::Point3D&& _position_std_dev);

            /*!
             * @brief This function returns a constant reference to member position_std_dev
             * @return Constant reference to member position_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& position_std_dev() const;

            /*!
             * @brief This function returns a reference to member position_std_dev
             * @return Reference to member position_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& position_std_dev();
            /*!
             * @brief This function copies the value in member orientation_std_dev
             * @param _orientation_std_dev New value to be copied in member orientation_std_dev
             */
            eProsima_user_DllExport void orientation_std_dev(
                    const ros2_interface::msg::Point3D& _orientation_std_dev);

            /*!
             * @brief This function moves the value in member orientation_std_dev
             * @param _orientation_std_dev New value to be moved in member orientation_std_dev
             */
            eProsima_user_DllExport void orientation_std_dev(
                    ros2_interface::msg::Point3D&& _orientation_std_dev);

            /*!
             * @brief This function returns a constant reference to member orientation_std_dev
             * @return Constant reference to member orientation_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& orientation_std_dev() const;

            /*!
             * @brief This function returns a reference to member orientation_std_dev
             * @return Reference to member orientation_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& orientation_std_dev();
            /*!
             * @brief This function copies the value in member linear_velocity_std_dev
             * @param _linear_velocity_std_dev New value to be copied in member linear_velocity_std_dev
             */
            eProsima_user_DllExport void linear_velocity_std_dev(
                    const ros2_interface::msg::Point3D& _linear_velocity_std_dev);

            /*!
             * @brief This function moves the value in member linear_velocity_std_dev
             * @param _linear_velocity_std_dev New value to be moved in member linear_velocity_std_dev
             */
            eProsima_user_DllExport void linear_velocity_std_dev(
                    ros2_interface::msg::Point3D&& _linear_velocity_std_dev);

            /*!
             * @brief This function returns a constant reference to member linear_velocity_std_dev
             * @return Constant reference to member linear_velocity_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_velocity_std_dev() const;

            /*!
             * @brief This function returns a reference to member linear_velocity_std_dev
             * @return Reference to member linear_velocity_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_velocity_std_dev();
            /*!
             * @brief This function copies the value in member linear_acceleration_std_dev
             * @param _linear_acceleration_std_dev New value to be copied in member linear_acceleration_std_dev
             */
            eProsima_user_DllExport void linear_acceleration_std_dev(
                    const ros2_interface::msg::Point3D& _linear_acceleration_std_dev);

            /*!
             * @brief This function moves the value in member linear_acceleration_std_dev
             * @param _linear_acceleration_std_dev New value to be moved in member linear_acceleration_std_dev
             */
            eProsima_user_DllExport void linear_acceleration_std_dev(
                    ros2_interface::msg::Point3D&& _linear_acceleration_std_dev);

            /*!
             * @brief This function returns a constant reference to member linear_acceleration_std_dev
             * @return Constant reference to member linear_acceleration_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& linear_acceleration_std_dev() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration_std_dev
             * @return Reference to member linear_acceleration_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& linear_acceleration_std_dev();
            /*!
             * @brief This function copies the value in member angular_velocity_std_dev
             * @param _angular_velocity_std_dev New value to be copied in member angular_velocity_std_dev
             */
            eProsima_user_DllExport void angular_velocity_std_dev(
                    const ros2_interface::msg::Point3D& _angular_velocity_std_dev);

            /*!
             * @brief This function moves the value in member angular_velocity_std_dev
             * @param _angular_velocity_std_dev New value to be moved in member angular_velocity_std_dev
             */
            eProsima_user_DllExport void angular_velocity_std_dev(
                    ros2_interface::msg::Point3D&& _angular_velocity_std_dev);

            /*!
             * @brief This function returns a constant reference to member angular_velocity_std_dev
             * @return Constant reference to member angular_velocity_std_dev
             */
            eProsima_user_DllExport const ros2_interface::msg::Point3D& angular_velocity_std_dev() const;

            /*!
             * @brief This function returns a reference to member angular_velocity_std_dev
             * @return Reference to member angular_velocity_std_dev
             */
            eProsima_user_DllExport ros2_interface::msg::Point3D& angular_velocity_std_dev();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Uncertainty& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Point3D m_position_std_dev;
            ros2_interface::msg::Point3D m_orientation_std_dev;
            ros2_interface::msg::Point3D m_linear_velocity_std_dev;
            ros2_interface::msg::Point3D m_linear_acceleration_std_dev;
            ros2_interface::msg::Point3D m_angular_velocity_std_dev;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_UNCERTAINTY_H_

