// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file UncertaintyTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Uncertainty.h"
#include "UncertaintyTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerUncertaintyTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::Uncertainty", ros2_interface::msg::GetUncertaintyIdentifier(true),
                        ros2_interface::msg::GetUncertaintyObject(true));
                factory->add_type_object("ros2_interface::msg::Uncertainty", ros2_interface::msg::GetUncertaintyIdentifier(false),
                        ros2_interface::msg::GetUncertaintyObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetUncertaintyIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Uncertainty", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetUncertaintyObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Uncertainty", complete);
        }

        const TypeObject* GetUncertaintyObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Uncertainty", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteUncertaintyObject();
            }
            //else
            return GetMinimalUncertaintyObject();
        }

        const TypeObject* GetMinimalUncertaintyObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Uncertainty", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_position_std_dev;
            mst_position_std_dev.common().member_id(memberId++);
            mst_position_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_position_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_std_dev.common().member_flags().IS_KEY(false);
            mst_position_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 position_std_dev_hash("position_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_std_dev.detail().name_hash()[i] = position_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_std_dev);

            MinimalStructMember mst_orientation_std_dev;
            mst_orientation_std_dev.common().member_id(memberId++);
            mst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_orientation_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_orientation_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_orientation_std_dev.common().member_flags().IS_KEY(false);
            mst_orientation_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_orientation_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 orientation_std_dev_hash("orientation_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_orientation_std_dev.detail().name_hash()[i] = orientation_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_orientation_std_dev);

            MinimalStructMember mst_linear_velocity_std_dev;
            mst_linear_velocity_std_dev.common().member_id(memberId++);
            mst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_KEY(false);
            mst_linear_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_velocity_std_dev_hash("linear_velocity_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity_std_dev.detail().name_hash()[i] = linear_velocity_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity_std_dev);

            MinimalStructMember mst_linear_acceleration_std_dev;
            mst_linear_acceleration_std_dev.common().member_id(memberId++);
            mst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_KEY(false);
            mst_linear_acceleration_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 linear_acceleration_std_dev_hash("linear_acceleration_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration_std_dev.detail().name_hash()[i] = linear_acceleration_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration_std_dev);

            MinimalStructMember mst_angular_velocity_std_dev;
            mst_angular_velocity_std_dev.common().member_id(memberId++);
            mst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_KEY(false);
            mst_angular_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(false));
            MD5 angular_velocity_std_dev_hash("angular_velocity_std_dev");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity_std_dev.detail().name_hash()[i] = angular_velocity_std_dev_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity_std_dev);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Uncertainty", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Uncertainty", false);
        }

        const TypeObject* GetCompleteUncertaintyObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Uncertainty", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_position_std_dev;
            cst_position_std_dev.common().member_id(memberId++);
            cst_position_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_position_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_std_dev.common().member_flags().IS_KEY(false);
            cst_position_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_position_std_dev.detail().name("position_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_std_dev);

            CompleteStructMember cst_orientation_std_dev;
            cst_orientation_std_dev.common().member_id(memberId++);
            cst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_orientation_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_orientation_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_orientation_std_dev.common().member_flags().IS_KEY(false);
            cst_orientation_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_orientation_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_orientation_std_dev.detail().name("orientation_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_orientation_std_dev);

            CompleteStructMember cst_linear_velocity_std_dev;
            cst_linear_velocity_std_dev.common().member_id(memberId++);
            cst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_KEY(false);
            cst_linear_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_velocity_std_dev.detail().name("linear_velocity_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity_std_dev);

            CompleteStructMember cst_linear_acceleration_std_dev;
            cst_linear_acceleration_std_dev.common().member_id(memberId++);
            cst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_KEY(false);
            cst_linear_acceleration_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_linear_acceleration_std_dev.detail().name("linear_acceleration_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration_std_dev);

            CompleteStructMember cst_angular_velocity_std_dev;
            cst_angular_velocity_std_dev.common().member_id(memberId++);
            cst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity_std_dev.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_KEY(false);
            cst_angular_velocity_std_dev.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity_std_dev.common().member_type_id(*ros2_interface::msg::GetPoint3DIdentifier(true));
            cst_angular_velocity_std_dev.detail().name("angular_velocity_std_dev");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity_std_dev);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Uncertainty");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Uncertainty", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Uncertainty", true);
        }

    } // namespace msg
} // namespace ros2_interface