// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file UssObstacle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "UssObstacle.h"
#include "UssObstacleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_UssObstacle_max_cdr_typesize 296ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_UssObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::UssObstacle::UssObstacle()
{
    // ros2_interface::msg::Header m_header

    // long m_uss_obstacle_region
    m_uss_obstacle_region = 0;
    // double m_mx
    m_mx = 0.0;
    // double m_my
    m_my = 0.0;

    // Just to register all known types
    registerUssObstacleTypes();
}

ros2_interface::msg::UssObstacle::~UssObstacle()
{




}

ros2_interface::msg::UssObstacle::UssObstacle(
        const UssObstacle& x)
{
    m_header = x.m_header;
    m_uss_obstacle_region = x.m_uss_obstacle_region;
    m_mx = x.m_mx;
    m_my = x.m_my;
}

ros2_interface::msg::UssObstacle::UssObstacle(
        UssObstacle&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_uss_obstacle_region = x.m_uss_obstacle_region;
    m_mx = x.m_mx;
    m_my = x.m_my;
}

ros2_interface::msg::UssObstacle& ros2_interface::msg::UssObstacle::operator =(
        const UssObstacle& x)
{

    m_header = x.m_header;
    m_uss_obstacle_region = x.m_uss_obstacle_region;
    m_mx = x.m_mx;
    m_my = x.m_my;

    return *this;
}

ros2_interface::msg::UssObstacle& ros2_interface::msg::UssObstacle::operator =(
        UssObstacle&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_uss_obstacle_region = x.m_uss_obstacle_region;
    m_mx = x.m_mx;
    m_my = x.m_my;

    return *this;
}

bool ros2_interface::msg::UssObstacle::operator ==(
        const UssObstacle& x) const
{

    return (m_header == x.m_header && m_uss_obstacle_region == x.m_uss_obstacle_region && m_mx == x.m_mx && m_my == x.m_my);
}

bool ros2_interface::msg::UssObstacle::operator !=(
        const UssObstacle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::UssObstacle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_UssObstacle_max_cdr_typesize;
}

size_t ros2_interface::msg::UssObstacle::getCdrSerializedSize(
        const ros2_interface::msg::UssObstacle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::UssObstacle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_uss_obstacle_region;
    scdr << m_mx;
    scdr << m_my;

}

void ros2_interface::msg::UssObstacle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_uss_obstacle_region;
    dcdr >> m_mx;
    dcdr >> m_my;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::UssObstacle::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::UssObstacle::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::UssObstacle::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::UssObstacle::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member uss_obstacle_region
 * @param _uss_obstacle_region New value for member uss_obstacle_region
 */
void ros2_interface::msg::UssObstacle::uss_obstacle_region(
        int32_t _uss_obstacle_region)
{
    m_uss_obstacle_region = _uss_obstacle_region;
}

/*!
 * @brief This function returns the value of member uss_obstacle_region
 * @return Value of member uss_obstacle_region
 */
int32_t ros2_interface::msg::UssObstacle::uss_obstacle_region() const
{
    return m_uss_obstacle_region;
}

/*!
 * @brief This function returns a reference to member uss_obstacle_region
 * @return Reference to member uss_obstacle_region
 */
int32_t& ros2_interface::msg::UssObstacle::uss_obstacle_region()
{
    return m_uss_obstacle_region;
}

/*!
 * @brief This function sets a value in member mx
 * @param _mx New value for member mx
 */
void ros2_interface::msg::UssObstacle::mx(
        double _mx)
{
    m_mx = _mx;
}

/*!
 * @brief This function returns the value of member mx
 * @return Value of member mx
 */
double ros2_interface::msg::UssObstacle::mx() const
{
    return m_mx;
}

/*!
 * @brief This function returns a reference to member mx
 * @return Reference to member mx
 */
double& ros2_interface::msg::UssObstacle::mx()
{
    return m_mx;
}

/*!
 * @brief This function sets a value in member my
 * @param _my New value for member my
 */
void ros2_interface::msg::UssObstacle::my(
        double _my)
{
    m_my = _my;
}

/*!
 * @brief This function returns the value of member my
 * @return Value of member my
 */
double ros2_interface::msg::UssObstacle::my() const
{
    return m_my;
}

/*!
 * @brief This function returns a reference to member my
 * @return Reference to member my
 */
double& ros2_interface::msg::UssObstacle::my()
{
    return m_my;
}



size_t ros2_interface::msg::UssObstacle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_UssObstacle_max_key_cdr_typesize;
}

bool ros2_interface::msg::UssObstacle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::UssObstacle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



