// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file UssObstacle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_USSOBSTACLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_USSOBSTACLE_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(USSOBSTACLE_SOURCE)
#define USSOBSTACLE_DllAPI __declspec( dllexport )
#else
#define USSOBSTACLE_DllAPI __declspec( dllimport )
#endif // USSOBSTACLE_SOURCE
#else
#define USSOBSTACLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define USSOBSTACLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure UssObstacle defined by the user in the IDL file.
         * @ingroup UssObstacle
         */
        class UssObstacle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport UssObstacle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~UssObstacle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::UssObstacle that will be copied.
             */
            eProsima_user_DllExport UssObstacle(
                    const UssObstacle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::UssObstacle that will be copied.
             */
            eProsima_user_DllExport UssObstacle(
                    UssObstacle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::UssObstacle that will be copied.
             */
            eProsima_user_DllExport UssObstacle& operator =(
                    const UssObstacle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::UssObstacle that will be copied.
             */
            eProsima_user_DllExport UssObstacle& operator =(
                    UssObstacle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::UssObstacle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const UssObstacle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::UssObstacle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const UssObstacle& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member uss_obstacle_region
             * @param _uss_obstacle_region New value for member uss_obstacle_region
             */
            eProsima_user_DllExport void uss_obstacle_region(
                    int32_t _uss_obstacle_region);

            /*!
             * @brief This function returns the value of member uss_obstacle_region
             * @return Value of member uss_obstacle_region
             */
            eProsima_user_DllExport int32_t uss_obstacle_region() const;

            /*!
             * @brief This function returns a reference to member uss_obstacle_region
             * @return Reference to member uss_obstacle_region
             */
            eProsima_user_DllExport int32_t& uss_obstacle_region();

            /*!
             * @brief This function sets a value in member mx
             * @param _mx New value for member mx
             */
            eProsima_user_DllExport void mx(
                    double _mx);

            /*!
             * @brief This function returns the value of member mx
             * @return Value of member mx
             */
            eProsima_user_DllExport double mx() const;

            /*!
             * @brief This function returns a reference to member mx
             * @return Reference to member mx
             */
            eProsima_user_DllExport double& mx();

            /*!
             * @brief This function sets a value in member my
             * @param _my New value for member my
             */
            eProsima_user_DllExport void my(
                    double _my);

            /*!
             * @brief This function returns the value of member my
             * @return Value of member my
             */
            eProsima_user_DllExport double my() const;

            /*!
             * @brief This function returns a reference to member my
             * @return Reference to member my
             */
            eProsima_user_DllExport double& my();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::UssObstacle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_uss_obstacle_region;
            double m_mx;
            double m_my;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_USSOBSTACLE_H_

