// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file UssObstacleList.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "UssObstacleList.h"
#include "UssObstacleListTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_UssObstacleList_max_cdr_typesize 30681ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_UssObstacle_max_cdr_typesize 296ULL;
#define ros2_interface_msg_UssObstacleList_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_UssObstacle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::UssObstacleList::UssObstacleList()
{
    // ros2_interface::msg::Header m_header

    // sequence<ros2_interface::msg::UssObstacle> m_uss_obstacles

    // sequence<double> m_uss_ranges

    // boolean m_is_valid
    m_is_valid = false;

    // Just to register all known types
    registerUssObstacleListTypes();
}

ros2_interface::msg::UssObstacleList::~UssObstacleList()
{




}

ros2_interface::msg::UssObstacleList::UssObstacleList(
        const UssObstacleList& x)
{
    m_header = x.m_header;
    m_uss_obstacles = x.m_uss_obstacles;
    m_uss_ranges = x.m_uss_ranges;
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::UssObstacleList::UssObstacleList(
        UssObstacleList&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_uss_obstacles = std::move(x.m_uss_obstacles);
    m_uss_ranges = std::move(x.m_uss_ranges);
    m_is_valid = x.m_is_valid;
}

ros2_interface::msg::UssObstacleList& ros2_interface::msg::UssObstacleList::operator =(
        const UssObstacleList& x)
{

    m_header = x.m_header;
    m_uss_obstacles = x.m_uss_obstacles;
    m_uss_ranges = x.m_uss_ranges;
    m_is_valid = x.m_is_valid;

    return *this;
}

ros2_interface::msg::UssObstacleList& ros2_interface::msg::UssObstacleList::operator =(
        UssObstacleList&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_uss_obstacles = std::move(x.m_uss_obstacles);
    m_uss_ranges = std::move(x.m_uss_ranges);
    m_is_valid = x.m_is_valid;

    return *this;
}

bool ros2_interface::msg::UssObstacleList::operator ==(
        const UssObstacleList& x) const
{

    return (m_header == x.m_header && m_uss_obstacles == x.m_uss_obstacles && m_uss_ranges == x.m_uss_ranges && m_is_valid == x.m_is_valid);
}

bool ros2_interface::msg::UssObstacleList::operator !=(
        const UssObstacleList& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::UssObstacleList::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_UssObstacleList_max_cdr_typesize;
}

size_t ros2_interface::msg::UssObstacleList::getCdrSerializedSize(
        const ros2_interface::msg::UssObstacleList& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.uss_obstacles().size(); ++a)
    {
        current_alignment += ros2_interface::msg::UssObstacle::getCdrSerializedSize(data.uss_obstacles().at(a), current_alignment);}

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.uss_ranges().size() > 0)
    {
        current_alignment += (data.uss_ranges().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::UssObstacleList::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_uss_obstacles;
    scdr << m_uss_ranges;
    scdr << m_is_valid;

}

void ros2_interface::msg::UssObstacleList::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_uss_obstacles;
    dcdr >> m_uss_ranges;
    dcdr >> m_is_valid;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::UssObstacleList::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::UssObstacleList::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::UssObstacleList::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::UssObstacleList::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member uss_obstacles
 * @param _uss_obstacles New value to be copied in member uss_obstacles
 */
void ros2_interface::msg::UssObstacleList::uss_obstacles(
        const std::vector<ros2_interface::msg::UssObstacle>& _uss_obstacles)
{
    m_uss_obstacles = _uss_obstacles;
}

/*!
 * @brief This function moves the value in member uss_obstacles
 * @param _uss_obstacles New value to be moved in member uss_obstacles
 */
void ros2_interface::msg::UssObstacleList::uss_obstacles(
        std::vector<ros2_interface::msg::UssObstacle>&& _uss_obstacles)
{
    m_uss_obstacles = std::move(_uss_obstacles);
}

/*!
 * @brief This function returns a constant reference to member uss_obstacles
 * @return Constant reference to member uss_obstacles
 */
const std::vector<ros2_interface::msg::UssObstacle>& ros2_interface::msg::UssObstacleList::uss_obstacles() const
{
    return m_uss_obstacles;
}

/*!
 * @brief This function returns a reference to member uss_obstacles
 * @return Reference to member uss_obstacles
 */
std::vector<ros2_interface::msg::UssObstacle>& ros2_interface::msg::UssObstacleList::uss_obstacles()
{
    return m_uss_obstacles;
}
/*!
 * @brief This function copies the value in member uss_ranges
 * @param _uss_ranges New value to be copied in member uss_ranges
 */
void ros2_interface::msg::UssObstacleList::uss_ranges(
        const std::vector<double>& _uss_ranges)
{
    m_uss_ranges = _uss_ranges;
}

/*!
 * @brief This function moves the value in member uss_ranges
 * @param _uss_ranges New value to be moved in member uss_ranges
 */
void ros2_interface::msg::UssObstacleList::uss_ranges(
        std::vector<double>&& _uss_ranges)
{
    m_uss_ranges = std::move(_uss_ranges);
}

/*!
 * @brief This function returns a constant reference to member uss_ranges
 * @return Constant reference to member uss_ranges
 */
const std::vector<double>& ros2_interface::msg::UssObstacleList::uss_ranges() const
{
    return m_uss_ranges;
}

/*!
 * @brief This function returns a reference to member uss_ranges
 * @return Reference to member uss_ranges
 */
std::vector<double>& ros2_interface::msg::UssObstacleList::uss_ranges()
{
    return m_uss_ranges;
}
/*!
 * @brief This function sets a value in member is_valid
 * @param _is_valid New value for member is_valid
 */
void ros2_interface::msg::UssObstacleList::is_valid(
        bool _is_valid)
{
    m_is_valid = _is_valid;
}

/*!
 * @brief This function returns the value of member is_valid
 * @return Value of member is_valid
 */
bool ros2_interface::msg::UssObstacleList::is_valid() const
{
    return m_is_valid;
}

/*!
 * @brief This function returns a reference to member is_valid
 * @return Reference to member is_valid
 */
bool& ros2_interface::msg::UssObstacleList::is_valid()
{
    return m_is_valid;
}



size_t ros2_interface::msg::UssObstacleList::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_UssObstacleList_max_key_cdr_typesize;
}

bool ros2_interface::msg::UssObstacleList::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::UssObstacleList::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



