// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Vehicle.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "Vehicle.h"
#include "VehicleTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Vehicle_max_cdr_typesize 3160ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Vehicle_max_key_cdr_typesize 0ULL;

ros2_interface::msg::Vehicle::Vehicle()
{
    // ros2_interface::msg::Header m_header

    // long m_vehicle_type
    m_vehicle_type = 0;
    // string m_vid
    m_vid ="";
    // string m_vehicle_num
    m_vehicle_num ="";
    // string m_oid
    m_oid ="";
    // long m_operation
    m_operation = 0;
    // double m_totalcurrent
    m_totalcurrent = 0.0;
    // double m_batterysoc
    m_batterysoc = 0.0;
    // double m_totalvoltage
    m_totalvoltage = 0.0;
    // double m_recharge
    m_recharge = 0.0;
    // long m_dcdc
    m_dcdc = 0;
    // unsigned long m_resistance
    m_resistance = 0;
    // sequence<uint8> m_seats

    // long m_servicemode
    m_servicemode = 0;
    // sequence<long> m_seat_belt

    // long m_engine_status
    m_engine_status = 0;
    // double m_battery_voltage
    m_battery_voltage = 0.0;
    // double m_battery_ammeter
    m_battery_ammeter = 0.0;
    // double m_battery_consumption
    m_battery_consumption = 0.0;
    // double m_battery_probe
    m_battery_probe = 0.0;
    // sequence<double> m_battery_temperatures

    // double m_battery_h_tepemperatures
    m_battery_h_tepemperatures = 0.0;
    // double m_battery_ltepemperatures
    m_battery_ltepemperatures = 0.0;
    // double m_battery_probe_code
    m_battery_probe_code = 0.0;
    // double m_battery_h_concentration
    m_battery_h_concentration = 0.0;
    // double m_battery_c_sensor_code
    m_battery_c_sensor_code = 0.0;
    // double m_battery_stress
    m_battery_stress = 0.0;
    // double m_battery_s_sensor_code
    m_battery_s_sensor_code = 0.0;
    // double m_battery_h_dc_dc
    m_battery_h_dc_dc = 0.0;
    // double m_battery_capacity
    m_battery_capacity = 0.0;
    // double m_airconditioning_idx
    m_airconditioning_idx = 0.0;
    // double m_airconditioning_status
    m_airconditioning_status = 0.0;
    // long m_airconditioning_model
    m_airconditioning_model = 0;
    // long m_airconditioning_volume
    m_airconditioning_volume = 0;
    // long m_airconditioning_defrost
    m_airconditioning_defrost = 0;
    // sequence<long> m_door_status

    // double m_rsrp
    m_rsrp = 0.0;
    // double m_sinr
    m_sinr = 0.0;
    // double m_uspeed
    m_uspeed = 0.0;
    // double m_dspeed
    m_dspeed = 0.0;
    // double m_loss
    m_loss = 0.0;
    // unsigned long m_delay
    m_delay = 0;
    // uint8 m_refrigeration_idx
    m_refrigeration_idx = 0;
    // long m_refrigeration_status
    m_refrigeration_status = 0;
    // double m_refrigeration_stemp
    m_refrigeration_stemp = 0.0;
    // double m_refrigeration_ctemp
    m_refrigeration_ctemp = 0.0;
    // uint8 m_driving_motor_idx
    m_driving_motor_idx = 0;
    // uint8 m_driving_motor_status
    m_driving_motor_status = 0;
    // double m_driving_motor_ctemp
    m_driving_motor_ctemp = 0.0;
    // uint8 m_driving_motor_rspeed
    m_driving_motor_rspeed = 0;
    // double m_driving_motor_torque
    m_driving_motor_torque = 0.0;
    // double m_driving_motor_etemp
    m_driving_motor_etemp = 0.0;
    // double m_driving_motor_voltage
    m_driving_motor_voltage = 0.0;
    // double m_driving_motor_ammeter
    m_driving_motor_ammeter = 0.0;
    // long m_outline_lamp_status
    m_outline_lamp_status = 0;
    // long m_warning_lamp_status
    m_warning_lamp_status = 0;
    // long m_parking_lamp_status
    m_parking_lamp_status = 0;
    // long m_interior_lamp_status
    m_interior_lamp_status = 0;
    // long m_ambient_lamp_status
    m_ambient_lamp_status = 0;
    // long m_welcome_lamp_status
    m_welcome_lamp_status = 0;
    // long m_backlight_lamp_status
    m_backlight_lamp_status = 0;
    // long m_positionlight_lamp_status
    m_positionlight_lamp_status = 0;
    // long m_brakelamp_lamp_status
    m_brakelamp_lamp_status = 0;
    // long m_backuplamp_lamp_status
    m_backuplamp_lamp_status = 0;
    // int8 m_length
    m_length = 0;
    // int8 m_width
    m_width = 0;
    // int8 m_height
    m_height = 0;
    // long m_traction
    m_traction = 0;
    // long m_abs
    m_abs = 0;
    // long m_scs
    m_scs = 0;
    // long m_brake_boost
    m_brake_boost = 0;
    // long m_aux_brakes
    m_aux_brakes = 0;

    // Just to register all known types
    registerVehicleTypes();
}

ros2_interface::msg::Vehicle::~Vehicle()
{








































































}

ros2_interface::msg::Vehicle::Vehicle(
        const Vehicle& x)
{
    m_header = x.m_header;
    m_vehicle_type = x.m_vehicle_type;
    m_vid = x.m_vid;
    m_vehicle_num = x.m_vehicle_num;
    m_oid = x.m_oid;
    m_operation = x.m_operation;
    m_totalcurrent = x.m_totalcurrent;
    m_batterysoc = x.m_batterysoc;
    m_totalvoltage = x.m_totalvoltage;
    m_recharge = x.m_recharge;
    m_dcdc = x.m_dcdc;
    m_resistance = x.m_resistance;
    m_seats = x.m_seats;
    m_servicemode = x.m_servicemode;
    m_seat_belt = x.m_seat_belt;
    m_engine_status = x.m_engine_status;
    m_battery_voltage = x.m_battery_voltage;
    m_battery_ammeter = x.m_battery_ammeter;
    m_battery_consumption = x.m_battery_consumption;
    m_battery_probe = x.m_battery_probe;
    m_battery_temperatures = x.m_battery_temperatures;
    m_battery_h_tepemperatures = x.m_battery_h_tepemperatures;
    m_battery_ltepemperatures = x.m_battery_ltepemperatures;
    m_battery_probe_code = x.m_battery_probe_code;
    m_battery_h_concentration = x.m_battery_h_concentration;
    m_battery_c_sensor_code = x.m_battery_c_sensor_code;
    m_battery_stress = x.m_battery_stress;
    m_battery_s_sensor_code = x.m_battery_s_sensor_code;
    m_battery_h_dc_dc = x.m_battery_h_dc_dc;
    m_battery_capacity = x.m_battery_capacity;
    m_airconditioning_idx = x.m_airconditioning_idx;
    m_airconditioning_status = x.m_airconditioning_status;
    m_airconditioning_model = x.m_airconditioning_model;
    m_airconditioning_volume = x.m_airconditioning_volume;
    m_airconditioning_defrost = x.m_airconditioning_defrost;
    m_door_status = x.m_door_status;
    m_rsrp = x.m_rsrp;
    m_sinr = x.m_sinr;
    m_uspeed = x.m_uspeed;
    m_dspeed = x.m_dspeed;
    m_loss = x.m_loss;
    m_delay = x.m_delay;
    m_refrigeration_idx = x.m_refrigeration_idx;
    m_refrigeration_status = x.m_refrigeration_status;
    m_refrigeration_stemp = x.m_refrigeration_stemp;
    m_refrigeration_ctemp = x.m_refrigeration_ctemp;
    m_driving_motor_idx = x.m_driving_motor_idx;
    m_driving_motor_status = x.m_driving_motor_status;
    m_driving_motor_ctemp = x.m_driving_motor_ctemp;
    m_driving_motor_rspeed = x.m_driving_motor_rspeed;
    m_driving_motor_torque = x.m_driving_motor_torque;
    m_driving_motor_etemp = x.m_driving_motor_etemp;
    m_driving_motor_voltage = x.m_driving_motor_voltage;
    m_driving_motor_ammeter = x.m_driving_motor_ammeter;
    m_outline_lamp_status = x.m_outline_lamp_status;
    m_warning_lamp_status = x.m_warning_lamp_status;
    m_parking_lamp_status = x.m_parking_lamp_status;
    m_interior_lamp_status = x.m_interior_lamp_status;
    m_ambient_lamp_status = x.m_ambient_lamp_status;
    m_welcome_lamp_status = x.m_welcome_lamp_status;
    m_backlight_lamp_status = x.m_backlight_lamp_status;
    m_positionlight_lamp_status = x.m_positionlight_lamp_status;
    m_brakelamp_lamp_status = x.m_brakelamp_lamp_status;
    m_backuplamp_lamp_status = x.m_backuplamp_lamp_status;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_traction = x.m_traction;
    m_abs = x.m_abs;
    m_scs = x.m_scs;
    m_brake_boost = x.m_brake_boost;
    m_aux_brakes = x.m_aux_brakes;
}

ros2_interface::msg::Vehicle::Vehicle(
        Vehicle&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_vehicle_type = x.m_vehicle_type;
    m_vid = std::move(x.m_vid);
    m_vehicle_num = std::move(x.m_vehicle_num);
    m_oid = std::move(x.m_oid);
    m_operation = x.m_operation;
    m_totalcurrent = x.m_totalcurrent;
    m_batterysoc = x.m_batterysoc;
    m_totalvoltage = x.m_totalvoltage;
    m_recharge = x.m_recharge;
    m_dcdc = x.m_dcdc;
    m_resistance = x.m_resistance;
    m_seats = std::move(x.m_seats);
    m_servicemode = x.m_servicemode;
    m_seat_belt = std::move(x.m_seat_belt);
    m_engine_status = x.m_engine_status;
    m_battery_voltage = x.m_battery_voltage;
    m_battery_ammeter = x.m_battery_ammeter;
    m_battery_consumption = x.m_battery_consumption;
    m_battery_probe = x.m_battery_probe;
    m_battery_temperatures = std::move(x.m_battery_temperatures);
    m_battery_h_tepemperatures = x.m_battery_h_tepemperatures;
    m_battery_ltepemperatures = x.m_battery_ltepemperatures;
    m_battery_probe_code = x.m_battery_probe_code;
    m_battery_h_concentration = x.m_battery_h_concentration;
    m_battery_c_sensor_code = x.m_battery_c_sensor_code;
    m_battery_stress = x.m_battery_stress;
    m_battery_s_sensor_code = x.m_battery_s_sensor_code;
    m_battery_h_dc_dc = x.m_battery_h_dc_dc;
    m_battery_capacity = x.m_battery_capacity;
    m_airconditioning_idx = x.m_airconditioning_idx;
    m_airconditioning_status = x.m_airconditioning_status;
    m_airconditioning_model = x.m_airconditioning_model;
    m_airconditioning_volume = x.m_airconditioning_volume;
    m_airconditioning_defrost = x.m_airconditioning_defrost;
    m_door_status = std::move(x.m_door_status);
    m_rsrp = x.m_rsrp;
    m_sinr = x.m_sinr;
    m_uspeed = x.m_uspeed;
    m_dspeed = x.m_dspeed;
    m_loss = x.m_loss;
    m_delay = x.m_delay;
    m_refrigeration_idx = x.m_refrigeration_idx;
    m_refrigeration_status = x.m_refrigeration_status;
    m_refrigeration_stemp = x.m_refrigeration_stemp;
    m_refrigeration_ctemp = x.m_refrigeration_ctemp;
    m_driving_motor_idx = x.m_driving_motor_idx;
    m_driving_motor_status = x.m_driving_motor_status;
    m_driving_motor_ctemp = x.m_driving_motor_ctemp;
    m_driving_motor_rspeed = x.m_driving_motor_rspeed;
    m_driving_motor_torque = x.m_driving_motor_torque;
    m_driving_motor_etemp = x.m_driving_motor_etemp;
    m_driving_motor_voltage = x.m_driving_motor_voltage;
    m_driving_motor_ammeter = x.m_driving_motor_ammeter;
    m_outline_lamp_status = x.m_outline_lamp_status;
    m_warning_lamp_status = x.m_warning_lamp_status;
    m_parking_lamp_status = x.m_parking_lamp_status;
    m_interior_lamp_status = x.m_interior_lamp_status;
    m_ambient_lamp_status = x.m_ambient_lamp_status;
    m_welcome_lamp_status = x.m_welcome_lamp_status;
    m_backlight_lamp_status = x.m_backlight_lamp_status;
    m_positionlight_lamp_status = x.m_positionlight_lamp_status;
    m_brakelamp_lamp_status = x.m_brakelamp_lamp_status;
    m_backuplamp_lamp_status = x.m_backuplamp_lamp_status;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_traction = x.m_traction;
    m_abs = x.m_abs;
    m_scs = x.m_scs;
    m_brake_boost = x.m_brake_boost;
    m_aux_brakes = x.m_aux_brakes;
}

ros2_interface::msg::Vehicle& ros2_interface::msg::Vehicle::operator =(
        const Vehicle& x)
{

    m_header = x.m_header;
    m_vehicle_type = x.m_vehicle_type;
    m_vid = x.m_vid;
    m_vehicle_num = x.m_vehicle_num;
    m_oid = x.m_oid;
    m_operation = x.m_operation;
    m_totalcurrent = x.m_totalcurrent;
    m_batterysoc = x.m_batterysoc;
    m_totalvoltage = x.m_totalvoltage;
    m_recharge = x.m_recharge;
    m_dcdc = x.m_dcdc;
    m_resistance = x.m_resistance;
    m_seats = x.m_seats;
    m_servicemode = x.m_servicemode;
    m_seat_belt = x.m_seat_belt;
    m_engine_status = x.m_engine_status;
    m_battery_voltage = x.m_battery_voltage;
    m_battery_ammeter = x.m_battery_ammeter;
    m_battery_consumption = x.m_battery_consumption;
    m_battery_probe = x.m_battery_probe;
    m_battery_temperatures = x.m_battery_temperatures;
    m_battery_h_tepemperatures = x.m_battery_h_tepemperatures;
    m_battery_ltepemperatures = x.m_battery_ltepemperatures;
    m_battery_probe_code = x.m_battery_probe_code;
    m_battery_h_concentration = x.m_battery_h_concentration;
    m_battery_c_sensor_code = x.m_battery_c_sensor_code;
    m_battery_stress = x.m_battery_stress;
    m_battery_s_sensor_code = x.m_battery_s_sensor_code;
    m_battery_h_dc_dc = x.m_battery_h_dc_dc;
    m_battery_capacity = x.m_battery_capacity;
    m_airconditioning_idx = x.m_airconditioning_idx;
    m_airconditioning_status = x.m_airconditioning_status;
    m_airconditioning_model = x.m_airconditioning_model;
    m_airconditioning_volume = x.m_airconditioning_volume;
    m_airconditioning_defrost = x.m_airconditioning_defrost;
    m_door_status = x.m_door_status;
    m_rsrp = x.m_rsrp;
    m_sinr = x.m_sinr;
    m_uspeed = x.m_uspeed;
    m_dspeed = x.m_dspeed;
    m_loss = x.m_loss;
    m_delay = x.m_delay;
    m_refrigeration_idx = x.m_refrigeration_idx;
    m_refrigeration_status = x.m_refrigeration_status;
    m_refrigeration_stemp = x.m_refrigeration_stemp;
    m_refrigeration_ctemp = x.m_refrigeration_ctemp;
    m_driving_motor_idx = x.m_driving_motor_idx;
    m_driving_motor_status = x.m_driving_motor_status;
    m_driving_motor_ctemp = x.m_driving_motor_ctemp;
    m_driving_motor_rspeed = x.m_driving_motor_rspeed;
    m_driving_motor_torque = x.m_driving_motor_torque;
    m_driving_motor_etemp = x.m_driving_motor_etemp;
    m_driving_motor_voltage = x.m_driving_motor_voltage;
    m_driving_motor_ammeter = x.m_driving_motor_ammeter;
    m_outline_lamp_status = x.m_outline_lamp_status;
    m_warning_lamp_status = x.m_warning_lamp_status;
    m_parking_lamp_status = x.m_parking_lamp_status;
    m_interior_lamp_status = x.m_interior_lamp_status;
    m_ambient_lamp_status = x.m_ambient_lamp_status;
    m_welcome_lamp_status = x.m_welcome_lamp_status;
    m_backlight_lamp_status = x.m_backlight_lamp_status;
    m_positionlight_lamp_status = x.m_positionlight_lamp_status;
    m_brakelamp_lamp_status = x.m_brakelamp_lamp_status;
    m_backuplamp_lamp_status = x.m_backuplamp_lamp_status;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_traction = x.m_traction;
    m_abs = x.m_abs;
    m_scs = x.m_scs;
    m_brake_boost = x.m_brake_boost;
    m_aux_brakes = x.m_aux_brakes;

    return *this;
}

ros2_interface::msg::Vehicle& ros2_interface::msg::Vehicle::operator =(
        Vehicle&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_vehicle_type = x.m_vehicle_type;
    m_vid = std::move(x.m_vid);
    m_vehicle_num = std::move(x.m_vehicle_num);
    m_oid = std::move(x.m_oid);
    m_operation = x.m_operation;
    m_totalcurrent = x.m_totalcurrent;
    m_batterysoc = x.m_batterysoc;
    m_totalvoltage = x.m_totalvoltage;
    m_recharge = x.m_recharge;
    m_dcdc = x.m_dcdc;
    m_resistance = x.m_resistance;
    m_seats = std::move(x.m_seats);
    m_servicemode = x.m_servicemode;
    m_seat_belt = std::move(x.m_seat_belt);
    m_engine_status = x.m_engine_status;
    m_battery_voltage = x.m_battery_voltage;
    m_battery_ammeter = x.m_battery_ammeter;
    m_battery_consumption = x.m_battery_consumption;
    m_battery_probe = x.m_battery_probe;
    m_battery_temperatures = std::move(x.m_battery_temperatures);
    m_battery_h_tepemperatures = x.m_battery_h_tepemperatures;
    m_battery_ltepemperatures = x.m_battery_ltepemperatures;
    m_battery_probe_code = x.m_battery_probe_code;
    m_battery_h_concentration = x.m_battery_h_concentration;
    m_battery_c_sensor_code = x.m_battery_c_sensor_code;
    m_battery_stress = x.m_battery_stress;
    m_battery_s_sensor_code = x.m_battery_s_sensor_code;
    m_battery_h_dc_dc = x.m_battery_h_dc_dc;
    m_battery_capacity = x.m_battery_capacity;
    m_airconditioning_idx = x.m_airconditioning_idx;
    m_airconditioning_status = x.m_airconditioning_status;
    m_airconditioning_model = x.m_airconditioning_model;
    m_airconditioning_volume = x.m_airconditioning_volume;
    m_airconditioning_defrost = x.m_airconditioning_defrost;
    m_door_status = std::move(x.m_door_status);
    m_rsrp = x.m_rsrp;
    m_sinr = x.m_sinr;
    m_uspeed = x.m_uspeed;
    m_dspeed = x.m_dspeed;
    m_loss = x.m_loss;
    m_delay = x.m_delay;
    m_refrigeration_idx = x.m_refrigeration_idx;
    m_refrigeration_status = x.m_refrigeration_status;
    m_refrigeration_stemp = x.m_refrigeration_stemp;
    m_refrigeration_ctemp = x.m_refrigeration_ctemp;
    m_driving_motor_idx = x.m_driving_motor_idx;
    m_driving_motor_status = x.m_driving_motor_status;
    m_driving_motor_ctemp = x.m_driving_motor_ctemp;
    m_driving_motor_rspeed = x.m_driving_motor_rspeed;
    m_driving_motor_torque = x.m_driving_motor_torque;
    m_driving_motor_etemp = x.m_driving_motor_etemp;
    m_driving_motor_voltage = x.m_driving_motor_voltage;
    m_driving_motor_ammeter = x.m_driving_motor_ammeter;
    m_outline_lamp_status = x.m_outline_lamp_status;
    m_warning_lamp_status = x.m_warning_lamp_status;
    m_parking_lamp_status = x.m_parking_lamp_status;
    m_interior_lamp_status = x.m_interior_lamp_status;
    m_ambient_lamp_status = x.m_ambient_lamp_status;
    m_welcome_lamp_status = x.m_welcome_lamp_status;
    m_backlight_lamp_status = x.m_backlight_lamp_status;
    m_positionlight_lamp_status = x.m_positionlight_lamp_status;
    m_brakelamp_lamp_status = x.m_brakelamp_lamp_status;
    m_backuplamp_lamp_status = x.m_backuplamp_lamp_status;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_traction = x.m_traction;
    m_abs = x.m_abs;
    m_scs = x.m_scs;
    m_brake_boost = x.m_brake_boost;
    m_aux_brakes = x.m_aux_brakes;

    return *this;
}

bool ros2_interface::msg::Vehicle::operator ==(
        const Vehicle& x) const
{

    return (m_header == x.m_header && m_vehicle_type == x.m_vehicle_type && m_vid == x.m_vid && m_vehicle_num == x.m_vehicle_num && m_oid == x.m_oid && m_operation == x.m_operation && m_totalcurrent == x.m_totalcurrent && m_batterysoc == x.m_batterysoc && m_totalvoltage == x.m_totalvoltage && m_recharge == x.m_recharge && m_dcdc == x.m_dcdc && m_resistance == x.m_resistance && m_seats == x.m_seats && m_servicemode == x.m_servicemode && m_seat_belt == x.m_seat_belt && m_engine_status == x.m_engine_status && m_battery_voltage == x.m_battery_voltage && m_battery_ammeter == x.m_battery_ammeter && m_battery_consumption == x.m_battery_consumption && m_battery_probe == x.m_battery_probe && m_battery_temperatures == x.m_battery_temperatures && m_battery_h_tepemperatures == x.m_battery_h_tepemperatures && m_battery_ltepemperatures == x.m_battery_ltepemperatures && m_battery_probe_code == x.m_battery_probe_code && m_battery_h_concentration == x.m_battery_h_concentration && m_battery_c_sensor_code == x.m_battery_c_sensor_code && m_battery_stress == x.m_battery_stress && m_battery_s_sensor_code == x.m_battery_s_sensor_code && m_battery_h_dc_dc == x.m_battery_h_dc_dc && m_battery_capacity == x.m_battery_capacity && m_airconditioning_idx == x.m_airconditioning_idx && m_airconditioning_status == x.m_airconditioning_status && m_airconditioning_model == x.m_airconditioning_model && m_airconditioning_volume == x.m_airconditioning_volume && m_airconditioning_defrost == x.m_airconditioning_defrost && m_door_status == x.m_door_status && m_rsrp == x.m_rsrp && m_sinr == x.m_sinr && m_uspeed == x.m_uspeed && m_dspeed == x.m_dspeed && m_loss == x.m_loss && m_delay == x.m_delay && m_refrigeration_idx == x.m_refrigeration_idx && m_refrigeration_status == x.m_refrigeration_status && m_refrigeration_stemp == x.m_refrigeration_stemp && m_refrigeration_ctemp == x.m_refrigeration_ctemp && m_driving_motor_idx == x.m_driving_motor_idx && m_driving_motor_status == x.m_driving_motor_status && m_driving_motor_ctemp == x.m_driving_motor_ctemp && m_driving_motor_rspeed == x.m_driving_motor_rspeed && m_driving_motor_torque == x.m_driving_motor_torque && m_driving_motor_etemp == x.m_driving_motor_etemp && m_driving_motor_voltage == x.m_driving_motor_voltage && m_driving_motor_ammeter == x.m_driving_motor_ammeter && m_outline_lamp_status == x.m_outline_lamp_status && m_warning_lamp_status == x.m_warning_lamp_status && m_parking_lamp_status == x.m_parking_lamp_status && m_interior_lamp_status == x.m_interior_lamp_status && m_ambient_lamp_status == x.m_ambient_lamp_status && m_welcome_lamp_status == x.m_welcome_lamp_status && m_backlight_lamp_status == x.m_backlight_lamp_status && m_positionlight_lamp_status == x.m_positionlight_lamp_status && m_brakelamp_lamp_status == x.m_brakelamp_lamp_status && m_backuplamp_lamp_status == x.m_backuplamp_lamp_status && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_traction == x.m_traction && m_abs == x.m_abs && m_scs == x.m_scs && m_brake_boost == x.m_brake_boost && m_aux_brakes == x.m_aux_brakes);
}

bool ros2_interface::msg::Vehicle::operator !=(
        const Vehicle& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::Vehicle::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Vehicle_max_cdr_typesize;
}

size_t ros2_interface::msg::Vehicle::getCdrSerializedSize(
        const ros2_interface::msg::Vehicle& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.vid().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.vehicle_num().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.oid().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.seats().size() > 0)
    {
        current_alignment += (data.seats().size() * 1) + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.seat_belt().size() > 0)
    {
        current_alignment += (data.seat_belt().size() * 4) + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);
    }



    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.battery_temperatures().size() > 0)
    {
        current_alignment += (data.battery_temperatures().size() * 8) + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);
    }



    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);

    if (data.door_status().size() > 0)
    {
        current_alignment += (data.door_status().size() * 4) + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);
    }



    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::Vehicle::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_vehicle_type;
    scdr << m_vid.c_str();
    scdr << m_vehicle_num.c_str();
    scdr << m_oid.c_str();
    scdr << m_operation;
    scdr << m_totalcurrent;
    scdr << m_batterysoc;
    scdr << m_totalvoltage;
    scdr << m_recharge;
    scdr << m_dcdc;
    scdr << m_resistance;
    scdr << m_seats;
    scdr << m_servicemode;
    scdr << m_seat_belt;
    scdr << m_engine_status;
    scdr << m_battery_voltage;
    scdr << m_battery_ammeter;
    scdr << m_battery_consumption;
    scdr << m_battery_probe;
    scdr << m_battery_temperatures;
    scdr << m_battery_h_tepemperatures;
    scdr << m_battery_ltepemperatures;
    scdr << m_battery_probe_code;
    scdr << m_battery_h_concentration;
    scdr << m_battery_c_sensor_code;
    scdr << m_battery_stress;
    scdr << m_battery_s_sensor_code;
    scdr << m_battery_h_dc_dc;
    scdr << m_battery_capacity;
    scdr << m_airconditioning_idx;
    scdr << m_airconditioning_status;
    scdr << m_airconditioning_model;
    scdr << m_airconditioning_volume;
    scdr << m_airconditioning_defrost;
    scdr << m_door_status;
    scdr << m_rsrp;
    scdr << m_sinr;
    scdr << m_uspeed;
    scdr << m_dspeed;
    scdr << m_loss;
    scdr << m_delay;
    scdr << m_refrigeration_idx;
    scdr << m_refrigeration_status;
    scdr << m_refrigeration_stemp;
    scdr << m_refrigeration_ctemp;
    scdr << m_driving_motor_idx;
    scdr << m_driving_motor_status;
    scdr << m_driving_motor_ctemp;
    scdr << m_driving_motor_rspeed;
    scdr << m_driving_motor_torque;
    scdr << m_driving_motor_etemp;
    scdr << m_driving_motor_voltage;
    scdr << m_driving_motor_ammeter;
    scdr << m_outline_lamp_status;
    scdr << m_warning_lamp_status;
    scdr << m_parking_lamp_status;
    scdr << m_interior_lamp_status;
    scdr << m_ambient_lamp_status;
    scdr << m_welcome_lamp_status;
    scdr << m_backlight_lamp_status;
    scdr << m_positionlight_lamp_status;
    scdr << m_brakelamp_lamp_status;
    scdr << m_backuplamp_lamp_status;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_traction;
    scdr << m_abs;
    scdr << m_scs;
    scdr << m_brake_boost;
    scdr << m_aux_brakes;

}

void ros2_interface::msg::Vehicle::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_vehicle_type;
    dcdr >> m_vid;
    dcdr >> m_vehicle_num;
    dcdr >> m_oid;
    dcdr >> m_operation;
    dcdr >> m_totalcurrent;
    dcdr >> m_batterysoc;
    dcdr >> m_totalvoltage;
    dcdr >> m_recharge;
    dcdr >> m_dcdc;
    dcdr >> m_resistance;
    dcdr >> m_seats;
    dcdr >> m_servicemode;
    dcdr >> m_seat_belt;
    dcdr >> m_engine_status;
    dcdr >> m_battery_voltage;
    dcdr >> m_battery_ammeter;
    dcdr >> m_battery_consumption;
    dcdr >> m_battery_probe;
    dcdr >> m_battery_temperatures;
    dcdr >> m_battery_h_tepemperatures;
    dcdr >> m_battery_ltepemperatures;
    dcdr >> m_battery_probe_code;
    dcdr >> m_battery_h_concentration;
    dcdr >> m_battery_c_sensor_code;
    dcdr >> m_battery_stress;
    dcdr >> m_battery_s_sensor_code;
    dcdr >> m_battery_h_dc_dc;
    dcdr >> m_battery_capacity;
    dcdr >> m_airconditioning_idx;
    dcdr >> m_airconditioning_status;
    dcdr >> m_airconditioning_model;
    dcdr >> m_airconditioning_volume;
    dcdr >> m_airconditioning_defrost;
    dcdr >> m_door_status;
    dcdr >> m_rsrp;
    dcdr >> m_sinr;
    dcdr >> m_uspeed;
    dcdr >> m_dspeed;
    dcdr >> m_loss;
    dcdr >> m_delay;
    dcdr >> m_refrigeration_idx;
    dcdr >> m_refrigeration_status;
    dcdr >> m_refrigeration_stemp;
    dcdr >> m_refrigeration_ctemp;
    dcdr >> m_driving_motor_idx;
    dcdr >> m_driving_motor_status;
    dcdr >> m_driving_motor_ctemp;
    dcdr >> m_driving_motor_rspeed;
    dcdr >> m_driving_motor_torque;
    dcdr >> m_driving_motor_etemp;
    dcdr >> m_driving_motor_voltage;
    dcdr >> m_driving_motor_ammeter;
    dcdr >> m_outline_lamp_status;
    dcdr >> m_warning_lamp_status;
    dcdr >> m_parking_lamp_status;
    dcdr >> m_interior_lamp_status;
    dcdr >> m_ambient_lamp_status;
    dcdr >> m_welcome_lamp_status;
    dcdr >> m_backlight_lamp_status;
    dcdr >> m_positionlight_lamp_status;
    dcdr >> m_brakelamp_lamp_status;
    dcdr >> m_backuplamp_lamp_status;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_traction;
    dcdr >> m_abs;
    dcdr >> m_scs;
    dcdr >> m_brake_boost;
    dcdr >> m_aux_brakes;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::Vehicle::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::Vehicle::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::Vehicle::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::Vehicle::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member vehicle_type
 * @param _vehicle_type New value for member vehicle_type
 */
void ros2_interface::msg::Vehicle::vehicle_type(
        int32_t _vehicle_type)
{
    m_vehicle_type = _vehicle_type;
}

/*!
 * @brief This function returns the value of member vehicle_type
 * @return Value of member vehicle_type
 */
int32_t ros2_interface::msg::Vehicle::vehicle_type() const
{
    return m_vehicle_type;
}

/*!
 * @brief This function returns a reference to member vehicle_type
 * @return Reference to member vehicle_type
 */
int32_t& ros2_interface::msg::Vehicle::vehicle_type()
{
    return m_vehicle_type;
}

/*!
 * @brief This function copies the value in member vid
 * @param _vid New value to be copied in member vid
 */
void ros2_interface::msg::Vehicle::vid(
        const std::string& _vid)
{
    m_vid = _vid;
}

/*!
 * @brief This function moves the value in member vid
 * @param _vid New value to be moved in member vid
 */
void ros2_interface::msg::Vehicle::vid(
        std::string&& _vid)
{
    m_vid = std::move(_vid);
}

/*!
 * @brief This function returns a constant reference to member vid
 * @return Constant reference to member vid
 */
const std::string& ros2_interface::msg::Vehicle::vid() const
{
    return m_vid;
}

/*!
 * @brief This function returns a reference to member vid
 * @return Reference to member vid
 */
std::string& ros2_interface::msg::Vehicle::vid()
{
    return m_vid;
}
/*!
 * @brief This function copies the value in member vehicle_num
 * @param _vehicle_num New value to be copied in member vehicle_num
 */
void ros2_interface::msg::Vehicle::vehicle_num(
        const std::string& _vehicle_num)
{
    m_vehicle_num = _vehicle_num;
}

/*!
 * @brief This function moves the value in member vehicle_num
 * @param _vehicle_num New value to be moved in member vehicle_num
 */
void ros2_interface::msg::Vehicle::vehicle_num(
        std::string&& _vehicle_num)
{
    m_vehicle_num = std::move(_vehicle_num);
}

/*!
 * @brief This function returns a constant reference to member vehicle_num
 * @return Constant reference to member vehicle_num
 */
const std::string& ros2_interface::msg::Vehicle::vehicle_num() const
{
    return m_vehicle_num;
}

/*!
 * @brief This function returns a reference to member vehicle_num
 * @return Reference to member vehicle_num
 */
std::string& ros2_interface::msg::Vehicle::vehicle_num()
{
    return m_vehicle_num;
}
/*!
 * @brief This function copies the value in member oid
 * @param _oid New value to be copied in member oid
 */
void ros2_interface::msg::Vehicle::oid(
        const std::string& _oid)
{
    m_oid = _oid;
}

/*!
 * @brief This function moves the value in member oid
 * @param _oid New value to be moved in member oid
 */
void ros2_interface::msg::Vehicle::oid(
        std::string&& _oid)
{
    m_oid = std::move(_oid);
}

/*!
 * @brief This function returns a constant reference to member oid
 * @return Constant reference to member oid
 */
const std::string& ros2_interface::msg::Vehicle::oid() const
{
    return m_oid;
}

/*!
 * @brief This function returns a reference to member oid
 * @return Reference to member oid
 */
std::string& ros2_interface::msg::Vehicle::oid()
{
    return m_oid;
}
/*!
 * @brief This function sets a value in member operation
 * @param _operation New value for member operation
 */
void ros2_interface::msg::Vehicle::operation(
        int32_t _operation)
{
    m_operation = _operation;
}

/*!
 * @brief This function returns the value of member operation
 * @return Value of member operation
 */
int32_t ros2_interface::msg::Vehicle::operation() const
{
    return m_operation;
}

/*!
 * @brief This function returns a reference to member operation
 * @return Reference to member operation
 */
int32_t& ros2_interface::msg::Vehicle::operation()
{
    return m_operation;
}

/*!
 * @brief This function sets a value in member totalcurrent
 * @param _totalcurrent New value for member totalcurrent
 */
void ros2_interface::msg::Vehicle::totalcurrent(
        double _totalcurrent)
{
    m_totalcurrent = _totalcurrent;
}

/*!
 * @brief This function returns the value of member totalcurrent
 * @return Value of member totalcurrent
 */
double ros2_interface::msg::Vehicle::totalcurrent() const
{
    return m_totalcurrent;
}

/*!
 * @brief This function returns a reference to member totalcurrent
 * @return Reference to member totalcurrent
 */
double& ros2_interface::msg::Vehicle::totalcurrent()
{
    return m_totalcurrent;
}

/*!
 * @brief This function sets a value in member batterysoc
 * @param _batterysoc New value for member batterysoc
 */
void ros2_interface::msg::Vehicle::batterysoc(
        double _batterysoc)
{
    m_batterysoc = _batterysoc;
}

/*!
 * @brief This function returns the value of member batterysoc
 * @return Value of member batterysoc
 */
double ros2_interface::msg::Vehicle::batterysoc() const
{
    return m_batterysoc;
}

/*!
 * @brief This function returns a reference to member batterysoc
 * @return Reference to member batterysoc
 */
double& ros2_interface::msg::Vehicle::batterysoc()
{
    return m_batterysoc;
}

/*!
 * @brief This function sets a value in member totalvoltage
 * @param _totalvoltage New value for member totalvoltage
 */
void ros2_interface::msg::Vehicle::totalvoltage(
        double _totalvoltage)
{
    m_totalvoltage = _totalvoltage;
}

/*!
 * @brief This function returns the value of member totalvoltage
 * @return Value of member totalvoltage
 */
double ros2_interface::msg::Vehicle::totalvoltage() const
{
    return m_totalvoltage;
}

/*!
 * @brief This function returns a reference to member totalvoltage
 * @return Reference to member totalvoltage
 */
double& ros2_interface::msg::Vehicle::totalvoltage()
{
    return m_totalvoltage;
}

/*!
 * @brief This function sets a value in member recharge
 * @param _recharge New value for member recharge
 */
void ros2_interface::msg::Vehicle::recharge(
        double _recharge)
{
    m_recharge = _recharge;
}

/*!
 * @brief This function returns the value of member recharge
 * @return Value of member recharge
 */
double ros2_interface::msg::Vehicle::recharge() const
{
    return m_recharge;
}

/*!
 * @brief This function returns a reference to member recharge
 * @return Reference to member recharge
 */
double& ros2_interface::msg::Vehicle::recharge()
{
    return m_recharge;
}

/*!
 * @brief This function sets a value in member dcdc
 * @param _dcdc New value for member dcdc
 */
void ros2_interface::msg::Vehicle::dcdc(
        int32_t _dcdc)
{
    m_dcdc = _dcdc;
}

/*!
 * @brief This function returns the value of member dcdc
 * @return Value of member dcdc
 */
int32_t ros2_interface::msg::Vehicle::dcdc() const
{
    return m_dcdc;
}

/*!
 * @brief This function returns a reference to member dcdc
 * @return Reference to member dcdc
 */
int32_t& ros2_interface::msg::Vehicle::dcdc()
{
    return m_dcdc;
}

/*!
 * @brief This function sets a value in member resistance
 * @param _resistance New value for member resistance
 */
void ros2_interface::msg::Vehicle::resistance(
        uint32_t _resistance)
{
    m_resistance = _resistance;
}

/*!
 * @brief This function returns the value of member resistance
 * @return Value of member resistance
 */
uint32_t ros2_interface::msg::Vehicle::resistance() const
{
    return m_resistance;
}

/*!
 * @brief This function returns a reference to member resistance
 * @return Reference to member resistance
 */
uint32_t& ros2_interface::msg::Vehicle::resistance()
{
    return m_resistance;
}

/*!
 * @brief This function copies the value in member seats
 * @param _seats New value to be copied in member seats
 */
void ros2_interface::msg::Vehicle::seats(
        const std::vector<uint8_t>& _seats)
{
    m_seats = _seats;
}

/*!
 * @brief This function moves the value in member seats
 * @param _seats New value to be moved in member seats
 */
void ros2_interface::msg::Vehicle::seats(
        std::vector<uint8_t>&& _seats)
{
    m_seats = std::move(_seats);
}

/*!
 * @brief This function returns a constant reference to member seats
 * @return Constant reference to member seats
 */
const std::vector<uint8_t>& ros2_interface::msg::Vehicle::seats() const
{
    return m_seats;
}

/*!
 * @brief This function returns a reference to member seats
 * @return Reference to member seats
 */
std::vector<uint8_t>& ros2_interface::msg::Vehicle::seats()
{
    return m_seats;
}
/*!
 * @brief This function sets a value in member servicemode
 * @param _servicemode New value for member servicemode
 */
void ros2_interface::msg::Vehicle::servicemode(
        int32_t _servicemode)
{
    m_servicemode = _servicemode;
}

/*!
 * @brief This function returns the value of member servicemode
 * @return Value of member servicemode
 */
int32_t ros2_interface::msg::Vehicle::servicemode() const
{
    return m_servicemode;
}

/*!
 * @brief This function returns a reference to member servicemode
 * @return Reference to member servicemode
 */
int32_t& ros2_interface::msg::Vehicle::servicemode()
{
    return m_servicemode;
}

/*!
 * @brief This function copies the value in member seat_belt
 * @param _seat_belt New value to be copied in member seat_belt
 */
void ros2_interface::msg::Vehicle::seat_belt(
        const std::vector<int32_t>& _seat_belt)
{
    m_seat_belt = _seat_belt;
}

/*!
 * @brief This function moves the value in member seat_belt
 * @param _seat_belt New value to be moved in member seat_belt
 */
void ros2_interface::msg::Vehicle::seat_belt(
        std::vector<int32_t>&& _seat_belt)
{
    m_seat_belt = std::move(_seat_belt);
}

/*!
 * @brief This function returns a constant reference to member seat_belt
 * @return Constant reference to member seat_belt
 */
const std::vector<int32_t>& ros2_interface::msg::Vehicle::seat_belt() const
{
    return m_seat_belt;
}

/*!
 * @brief This function returns a reference to member seat_belt
 * @return Reference to member seat_belt
 */
std::vector<int32_t>& ros2_interface::msg::Vehicle::seat_belt()
{
    return m_seat_belt;
}
/*!
 * @brief This function sets a value in member engine_status
 * @param _engine_status New value for member engine_status
 */
void ros2_interface::msg::Vehicle::engine_status(
        int32_t _engine_status)
{
    m_engine_status = _engine_status;
}

/*!
 * @brief This function returns the value of member engine_status
 * @return Value of member engine_status
 */
int32_t ros2_interface::msg::Vehicle::engine_status() const
{
    return m_engine_status;
}

/*!
 * @brief This function returns a reference to member engine_status
 * @return Reference to member engine_status
 */
int32_t& ros2_interface::msg::Vehicle::engine_status()
{
    return m_engine_status;
}

/*!
 * @brief This function sets a value in member battery_voltage
 * @param _battery_voltage New value for member battery_voltage
 */
void ros2_interface::msg::Vehicle::battery_voltage(
        double _battery_voltage)
{
    m_battery_voltage = _battery_voltage;
}

/*!
 * @brief This function returns the value of member battery_voltage
 * @return Value of member battery_voltage
 */
double ros2_interface::msg::Vehicle::battery_voltage() const
{
    return m_battery_voltage;
}

/*!
 * @brief This function returns a reference to member battery_voltage
 * @return Reference to member battery_voltage
 */
double& ros2_interface::msg::Vehicle::battery_voltage()
{
    return m_battery_voltage;
}

/*!
 * @brief This function sets a value in member battery_ammeter
 * @param _battery_ammeter New value for member battery_ammeter
 */
void ros2_interface::msg::Vehicle::battery_ammeter(
        double _battery_ammeter)
{
    m_battery_ammeter = _battery_ammeter;
}

/*!
 * @brief This function returns the value of member battery_ammeter
 * @return Value of member battery_ammeter
 */
double ros2_interface::msg::Vehicle::battery_ammeter() const
{
    return m_battery_ammeter;
}

/*!
 * @brief This function returns a reference to member battery_ammeter
 * @return Reference to member battery_ammeter
 */
double& ros2_interface::msg::Vehicle::battery_ammeter()
{
    return m_battery_ammeter;
}

/*!
 * @brief This function sets a value in member battery_consumption
 * @param _battery_consumption New value for member battery_consumption
 */
void ros2_interface::msg::Vehicle::battery_consumption(
        double _battery_consumption)
{
    m_battery_consumption = _battery_consumption;
}

/*!
 * @brief This function returns the value of member battery_consumption
 * @return Value of member battery_consumption
 */
double ros2_interface::msg::Vehicle::battery_consumption() const
{
    return m_battery_consumption;
}

/*!
 * @brief This function returns a reference to member battery_consumption
 * @return Reference to member battery_consumption
 */
double& ros2_interface::msg::Vehicle::battery_consumption()
{
    return m_battery_consumption;
}

/*!
 * @brief This function sets a value in member battery_probe
 * @param _battery_probe New value for member battery_probe
 */
void ros2_interface::msg::Vehicle::battery_probe(
        double _battery_probe)
{
    m_battery_probe = _battery_probe;
}

/*!
 * @brief This function returns the value of member battery_probe
 * @return Value of member battery_probe
 */
double ros2_interface::msg::Vehicle::battery_probe() const
{
    return m_battery_probe;
}

/*!
 * @brief This function returns a reference to member battery_probe
 * @return Reference to member battery_probe
 */
double& ros2_interface::msg::Vehicle::battery_probe()
{
    return m_battery_probe;
}

/*!
 * @brief This function copies the value in member battery_temperatures
 * @param _battery_temperatures New value to be copied in member battery_temperatures
 */
void ros2_interface::msg::Vehicle::battery_temperatures(
        const std::vector<double>& _battery_temperatures)
{
    m_battery_temperatures = _battery_temperatures;
}

/*!
 * @brief This function moves the value in member battery_temperatures
 * @param _battery_temperatures New value to be moved in member battery_temperatures
 */
void ros2_interface::msg::Vehicle::battery_temperatures(
        std::vector<double>&& _battery_temperatures)
{
    m_battery_temperatures = std::move(_battery_temperatures);
}

/*!
 * @brief This function returns a constant reference to member battery_temperatures
 * @return Constant reference to member battery_temperatures
 */
const std::vector<double>& ros2_interface::msg::Vehicle::battery_temperatures() const
{
    return m_battery_temperatures;
}

/*!
 * @brief This function returns a reference to member battery_temperatures
 * @return Reference to member battery_temperatures
 */
std::vector<double>& ros2_interface::msg::Vehicle::battery_temperatures()
{
    return m_battery_temperatures;
}
/*!
 * @brief This function sets a value in member battery_h_tepemperatures
 * @param _battery_h_tepemperatures New value for member battery_h_tepemperatures
 */
void ros2_interface::msg::Vehicle::battery_h_tepemperatures(
        double _battery_h_tepemperatures)
{
    m_battery_h_tepemperatures = _battery_h_tepemperatures;
}

/*!
 * @brief This function returns the value of member battery_h_tepemperatures
 * @return Value of member battery_h_tepemperatures
 */
double ros2_interface::msg::Vehicle::battery_h_tepemperatures() const
{
    return m_battery_h_tepemperatures;
}

/*!
 * @brief This function returns a reference to member battery_h_tepemperatures
 * @return Reference to member battery_h_tepemperatures
 */
double& ros2_interface::msg::Vehicle::battery_h_tepemperatures()
{
    return m_battery_h_tepemperatures;
}

/*!
 * @brief This function sets a value in member battery_ltepemperatures
 * @param _battery_ltepemperatures New value for member battery_ltepemperatures
 */
void ros2_interface::msg::Vehicle::battery_ltepemperatures(
        double _battery_ltepemperatures)
{
    m_battery_ltepemperatures = _battery_ltepemperatures;
}

/*!
 * @brief This function returns the value of member battery_ltepemperatures
 * @return Value of member battery_ltepemperatures
 */
double ros2_interface::msg::Vehicle::battery_ltepemperatures() const
{
    return m_battery_ltepemperatures;
}

/*!
 * @brief This function returns a reference to member battery_ltepemperatures
 * @return Reference to member battery_ltepemperatures
 */
double& ros2_interface::msg::Vehicle::battery_ltepemperatures()
{
    return m_battery_ltepemperatures;
}

/*!
 * @brief This function sets a value in member battery_probe_code
 * @param _battery_probe_code New value for member battery_probe_code
 */
void ros2_interface::msg::Vehicle::battery_probe_code(
        double _battery_probe_code)
{
    m_battery_probe_code = _battery_probe_code;
}

/*!
 * @brief This function returns the value of member battery_probe_code
 * @return Value of member battery_probe_code
 */
double ros2_interface::msg::Vehicle::battery_probe_code() const
{
    return m_battery_probe_code;
}

/*!
 * @brief This function returns a reference to member battery_probe_code
 * @return Reference to member battery_probe_code
 */
double& ros2_interface::msg::Vehicle::battery_probe_code()
{
    return m_battery_probe_code;
}

/*!
 * @brief This function sets a value in member battery_h_concentration
 * @param _battery_h_concentration New value for member battery_h_concentration
 */
void ros2_interface::msg::Vehicle::battery_h_concentration(
        double _battery_h_concentration)
{
    m_battery_h_concentration = _battery_h_concentration;
}

/*!
 * @brief This function returns the value of member battery_h_concentration
 * @return Value of member battery_h_concentration
 */
double ros2_interface::msg::Vehicle::battery_h_concentration() const
{
    return m_battery_h_concentration;
}

/*!
 * @brief This function returns a reference to member battery_h_concentration
 * @return Reference to member battery_h_concentration
 */
double& ros2_interface::msg::Vehicle::battery_h_concentration()
{
    return m_battery_h_concentration;
}

/*!
 * @brief This function sets a value in member battery_c_sensor_code
 * @param _battery_c_sensor_code New value for member battery_c_sensor_code
 */
void ros2_interface::msg::Vehicle::battery_c_sensor_code(
        double _battery_c_sensor_code)
{
    m_battery_c_sensor_code = _battery_c_sensor_code;
}

/*!
 * @brief This function returns the value of member battery_c_sensor_code
 * @return Value of member battery_c_sensor_code
 */
double ros2_interface::msg::Vehicle::battery_c_sensor_code() const
{
    return m_battery_c_sensor_code;
}

/*!
 * @brief This function returns a reference to member battery_c_sensor_code
 * @return Reference to member battery_c_sensor_code
 */
double& ros2_interface::msg::Vehicle::battery_c_sensor_code()
{
    return m_battery_c_sensor_code;
}

/*!
 * @brief This function sets a value in member battery_stress
 * @param _battery_stress New value for member battery_stress
 */
void ros2_interface::msg::Vehicle::battery_stress(
        double _battery_stress)
{
    m_battery_stress = _battery_stress;
}

/*!
 * @brief This function returns the value of member battery_stress
 * @return Value of member battery_stress
 */
double ros2_interface::msg::Vehicle::battery_stress() const
{
    return m_battery_stress;
}

/*!
 * @brief This function returns a reference to member battery_stress
 * @return Reference to member battery_stress
 */
double& ros2_interface::msg::Vehicle::battery_stress()
{
    return m_battery_stress;
}

/*!
 * @brief This function sets a value in member battery_s_sensor_code
 * @param _battery_s_sensor_code New value for member battery_s_sensor_code
 */
void ros2_interface::msg::Vehicle::battery_s_sensor_code(
        double _battery_s_sensor_code)
{
    m_battery_s_sensor_code = _battery_s_sensor_code;
}

/*!
 * @brief This function returns the value of member battery_s_sensor_code
 * @return Value of member battery_s_sensor_code
 */
double ros2_interface::msg::Vehicle::battery_s_sensor_code() const
{
    return m_battery_s_sensor_code;
}

/*!
 * @brief This function returns a reference to member battery_s_sensor_code
 * @return Reference to member battery_s_sensor_code
 */
double& ros2_interface::msg::Vehicle::battery_s_sensor_code()
{
    return m_battery_s_sensor_code;
}

/*!
 * @brief This function sets a value in member battery_h_dc_dc
 * @param _battery_h_dc_dc New value for member battery_h_dc_dc
 */
void ros2_interface::msg::Vehicle::battery_h_dc_dc(
        double _battery_h_dc_dc)
{
    m_battery_h_dc_dc = _battery_h_dc_dc;
}

/*!
 * @brief This function returns the value of member battery_h_dc_dc
 * @return Value of member battery_h_dc_dc
 */
double ros2_interface::msg::Vehicle::battery_h_dc_dc() const
{
    return m_battery_h_dc_dc;
}

/*!
 * @brief This function returns a reference to member battery_h_dc_dc
 * @return Reference to member battery_h_dc_dc
 */
double& ros2_interface::msg::Vehicle::battery_h_dc_dc()
{
    return m_battery_h_dc_dc;
}

/*!
 * @brief This function sets a value in member battery_capacity
 * @param _battery_capacity New value for member battery_capacity
 */
void ros2_interface::msg::Vehicle::battery_capacity(
        double _battery_capacity)
{
    m_battery_capacity = _battery_capacity;
}

/*!
 * @brief This function returns the value of member battery_capacity
 * @return Value of member battery_capacity
 */
double ros2_interface::msg::Vehicle::battery_capacity() const
{
    return m_battery_capacity;
}

/*!
 * @brief This function returns a reference to member battery_capacity
 * @return Reference to member battery_capacity
 */
double& ros2_interface::msg::Vehicle::battery_capacity()
{
    return m_battery_capacity;
}

/*!
 * @brief This function sets a value in member airconditioning_idx
 * @param _airconditioning_idx New value for member airconditioning_idx
 */
void ros2_interface::msg::Vehicle::airconditioning_idx(
        double _airconditioning_idx)
{
    m_airconditioning_idx = _airconditioning_idx;
}

/*!
 * @brief This function returns the value of member airconditioning_idx
 * @return Value of member airconditioning_idx
 */
double ros2_interface::msg::Vehicle::airconditioning_idx() const
{
    return m_airconditioning_idx;
}

/*!
 * @brief This function returns a reference to member airconditioning_idx
 * @return Reference to member airconditioning_idx
 */
double& ros2_interface::msg::Vehicle::airconditioning_idx()
{
    return m_airconditioning_idx;
}

/*!
 * @brief This function sets a value in member airconditioning_status
 * @param _airconditioning_status New value for member airconditioning_status
 */
void ros2_interface::msg::Vehicle::airconditioning_status(
        double _airconditioning_status)
{
    m_airconditioning_status = _airconditioning_status;
}

/*!
 * @brief This function returns the value of member airconditioning_status
 * @return Value of member airconditioning_status
 */
double ros2_interface::msg::Vehicle::airconditioning_status() const
{
    return m_airconditioning_status;
}

/*!
 * @brief This function returns a reference to member airconditioning_status
 * @return Reference to member airconditioning_status
 */
double& ros2_interface::msg::Vehicle::airconditioning_status()
{
    return m_airconditioning_status;
}

/*!
 * @brief This function sets a value in member airconditioning_model
 * @param _airconditioning_model New value for member airconditioning_model
 */
void ros2_interface::msg::Vehicle::airconditioning_model(
        int32_t _airconditioning_model)
{
    m_airconditioning_model = _airconditioning_model;
}

/*!
 * @brief This function returns the value of member airconditioning_model
 * @return Value of member airconditioning_model
 */
int32_t ros2_interface::msg::Vehicle::airconditioning_model() const
{
    return m_airconditioning_model;
}

/*!
 * @brief This function returns a reference to member airconditioning_model
 * @return Reference to member airconditioning_model
 */
int32_t& ros2_interface::msg::Vehicle::airconditioning_model()
{
    return m_airconditioning_model;
}

/*!
 * @brief This function sets a value in member airconditioning_volume
 * @param _airconditioning_volume New value for member airconditioning_volume
 */
void ros2_interface::msg::Vehicle::airconditioning_volume(
        int32_t _airconditioning_volume)
{
    m_airconditioning_volume = _airconditioning_volume;
}

/*!
 * @brief This function returns the value of member airconditioning_volume
 * @return Value of member airconditioning_volume
 */
int32_t ros2_interface::msg::Vehicle::airconditioning_volume() const
{
    return m_airconditioning_volume;
}

/*!
 * @brief This function returns a reference to member airconditioning_volume
 * @return Reference to member airconditioning_volume
 */
int32_t& ros2_interface::msg::Vehicle::airconditioning_volume()
{
    return m_airconditioning_volume;
}

/*!
 * @brief This function sets a value in member airconditioning_defrost
 * @param _airconditioning_defrost New value for member airconditioning_defrost
 */
void ros2_interface::msg::Vehicle::airconditioning_defrost(
        int32_t _airconditioning_defrost)
{
    m_airconditioning_defrost = _airconditioning_defrost;
}

/*!
 * @brief This function returns the value of member airconditioning_defrost
 * @return Value of member airconditioning_defrost
 */
int32_t ros2_interface::msg::Vehicle::airconditioning_defrost() const
{
    return m_airconditioning_defrost;
}

/*!
 * @brief This function returns a reference to member airconditioning_defrost
 * @return Reference to member airconditioning_defrost
 */
int32_t& ros2_interface::msg::Vehicle::airconditioning_defrost()
{
    return m_airconditioning_defrost;
}

/*!
 * @brief This function copies the value in member door_status
 * @param _door_status New value to be copied in member door_status
 */
void ros2_interface::msg::Vehicle::door_status(
        const std::vector<int32_t>& _door_status)
{
    m_door_status = _door_status;
}

/*!
 * @brief This function moves the value in member door_status
 * @param _door_status New value to be moved in member door_status
 */
void ros2_interface::msg::Vehicle::door_status(
        std::vector<int32_t>&& _door_status)
{
    m_door_status = std::move(_door_status);
}

/*!
 * @brief This function returns a constant reference to member door_status
 * @return Constant reference to member door_status
 */
const std::vector<int32_t>& ros2_interface::msg::Vehicle::door_status() const
{
    return m_door_status;
}

/*!
 * @brief This function returns a reference to member door_status
 * @return Reference to member door_status
 */
std::vector<int32_t>& ros2_interface::msg::Vehicle::door_status()
{
    return m_door_status;
}
/*!
 * @brief This function sets a value in member rsrp
 * @param _rsrp New value for member rsrp
 */
void ros2_interface::msg::Vehicle::rsrp(
        double _rsrp)
{
    m_rsrp = _rsrp;
}

/*!
 * @brief This function returns the value of member rsrp
 * @return Value of member rsrp
 */
double ros2_interface::msg::Vehicle::rsrp() const
{
    return m_rsrp;
}

/*!
 * @brief This function returns a reference to member rsrp
 * @return Reference to member rsrp
 */
double& ros2_interface::msg::Vehicle::rsrp()
{
    return m_rsrp;
}

/*!
 * @brief This function sets a value in member sinr
 * @param _sinr New value for member sinr
 */
void ros2_interface::msg::Vehicle::sinr(
        double _sinr)
{
    m_sinr = _sinr;
}

/*!
 * @brief This function returns the value of member sinr
 * @return Value of member sinr
 */
double ros2_interface::msg::Vehicle::sinr() const
{
    return m_sinr;
}

/*!
 * @brief This function returns a reference to member sinr
 * @return Reference to member sinr
 */
double& ros2_interface::msg::Vehicle::sinr()
{
    return m_sinr;
}

/*!
 * @brief This function sets a value in member uspeed
 * @param _uspeed New value for member uspeed
 */
void ros2_interface::msg::Vehicle::uspeed(
        double _uspeed)
{
    m_uspeed = _uspeed;
}

/*!
 * @brief This function returns the value of member uspeed
 * @return Value of member uspeed
 */
double ros2_interface::msg::Vehicle::uspeed() const
{
    return m_uspeed;
}

/*!
 * @brief This function returns a reference to member uspeed
 * @return Reference to member uspeed
 */
double& ros2_interface::msg::Vehicle::uspeed()
{
    return m_uspeed;
}

/*!
 * @brief This function sets a value in member dspeed
 * @param _dspeed New value for member dspeed
 */
void ros2_interface::msg::Vehicle::dspeed(
        double _dspeed)
{
    m_dspeed = _dspeed;
}

/*!
 * @brief This function returns the value of member dspeed
 * @return Value of member dspeed
 */
double ros2_interface::msg::Vehicle::dspeed() const
{
    return m_dspeed;
}

/*!
 * @brief This function returns a reference to member dspeed
 * @return Reference to member dspeed
 */
double& ros2_interface::msg::Vehicle::dspeed()
{
    return m_dspeed;
}

/*!
 * @brief This function sets a value in member loss
 * @param _loss New value for member loss
 */
void ros2_interface::msg::Vehicle::loss(
        double _loss)
{
    m_loss = _loss;
}

/*!
 * @brief This function returns the value of member loss
 * @return Value of member loss
 */
double ros2_interface::msg::Vehicle::loss() const
{
    return m_loss;
}

/*!
 * @brief This function returns a reference to member loss
 * @return Reference to member loss
 */
double& ros2_interface::msg::Vehicle::loss()
{
    return m_loss;
}

/*!
 * @brief This function sets a value in member delay
 * @param _delay New value for member delay
 */
void ros2_interface::msg::Vehicle::delay(
        uint32_t _delay)
{
    m_delay = _delay;
}

/*!
 * @brief This function returns the value of member delay
 * @return Value of member delay
 */
uint32_t ros2_interface::msg::Vehicle::delay() const
{
    return m_delay;
}

/*!
 * @brief This function returns a reference to member delay
 * @return Reference to member delay
 */
uint32_t& ros2_interface::msg::Vehicle::delay()
{
    return m_delay;
}

/*!
 * @brief This function sets a value in member refrigeration_idx
 * @param _refrigeration_idx New value for member refrigeration_idx
 */
void ros2_interface::msg::Vehicle::refrigeration_idx(
        uint8_t _refrigeration_idx)
{
    m_refrigeration_idx = _refrigeration_idx;
}

/*!
 * @brief This function returns the value of member refrigeration_idx
 * @return Value of member refrigeration_idx
 */
uint8_t ros2_interface::msg::Vehicle::refrigeration_idx() const
{
    return m_refrigeration_idx;
}

/*!
 * @brief This function returns a reference to member refrigeration_idx
 * @return Reference to member refrigeration_idx
 */
uint8_t& ros2_interface::msg::Vehicle::refrigeration_idx()
{
    return m_refrigeration_idx;
}

/*!
 * @brief This function sets a value in member refrigeration_status
 * @param _refrigeration_status New value for member refrigeration_status
 */
void ros2_interface::msg::Vehicle::refrigeration_status(
        int32_t _refrigeration_status)
{
    m_refrigeration_status = _refrigeration_status;
}

/*!
 * @brief This function returns the value of member refrigeration_status
 * @return Value of member refrigeration_status
 */
int32_t ros2_interface::msg::Vehicle::refrigeration_status() const
{
    return m_refrigeration_status;
}

/*!
 * @brief This function returns a reference to member refrigeration_status
 * @return Reference to member refrigeration_status
 */
int32_t& ros2_interface::msg::Vehicle::refrigeration_status()
{
    return m_refrigeration_status;
}

/*!
 * @brief This function sets a value in member refrigeration_stemp
 * @param _refrigeration_stemp New value for member refrigeration_stemp
 */
void ros2_interface::msg::Vehicle::refrigeration_stemp(
        double _refrigeration_stemp)
{
    m_refrigeration_stemp = _refrigeration_stemp;
}

/*!
 * @brief This function returns the value of member refrigeration_stemp
 * @return Value of member refrigeration_stemp
 */
double ros2_interface::msg::Vehicle::refrigeration_stemp() const
{
    return m_refrigeration_stemp;
}

/*!
 * @brief This function returns a reference to member refrigeration_stemp
 * @return Reference to member refrigeration_stemp
 */
double& ros2_interface::msg::Vehicle::refrigeration_stemp()
{
    return m_refrigeration_stemp;
}

/*!
 * @brief This function sets a value in member refrigeration_ctemp
 * @param _refrigeration_ctemp New value for member refrigeration_ctemp
 */
void ros2_interface::msg::Vehicle::refrigeration_ctemp(
        double _refrigeration_ctemp)
{
    m_refrigeration_ctemp = _refrigeration_ctemp;
}

/*!
 * @brief This function returns the value of member refrigeration_ctemp
 * @return Value of member refrigeration_ctemp
 */
double ros2_interface::msg::Vehicle::refrigeration_ctemp() const
{
    return m_refrigeration_ctemp;
}

/*!
 * @brief This function returns a reference to member refrigeration_ctemp
 * @return Reference to member refrigeration_ctemp
 */
double& ros2_interface::msg::Vehicle::refrigeration_ctemp()
{
    return m_refrigeration_ctemp;
}

/*!
 * @brief This function sets a value in member driving_motor_idx
 * @param _driving_motor_idx New value for member driving_motor_idx
 */
void ros2_interface::msg::Vehicle::driving_motor_idx(
        uint8_t _driving_motor_idx)
{
    m_driving_motor_idx = _driving_motor_idx;
}

/*!
 * @brief This function returns the value of member driving_motor_idx
 * @return Value of member driving_motor_idx
 */
uint8_t ros2_interface::msg::Vehicle::driving_motor_idx() const
{
    return m_driving_motor_idx;
}

/*!
 * @brief This function returns a reference to member driving_motor_idx
 * @return Reference to member driving_motor_idx
 */
uint8_t& ros2_interface::msg::Vehicle::driving_motor_idx()
{
    return m_driving_motor_idx;
}

/*!
 * @brief This function sets a value in member driving_motor_status
 * @param _driving_motor_status New value for member driving_motor_status
 */
void ros2_interface::msg::Vehicle::driving_motor_status(
        uint8_t _driving_motor_status)
{
    m_driving_motor_status = _driving_motor_status;
}

/*!
 * @brief This function returns the value of member driving_motor_status
 * @return Value of member driving_motor_status
 */
uint8_t ros2_interface::msg::Vehicle::driving_motor_status() const
{
    return m_driving_motor_status;
}

/*!
 * @brief This function returns a reference to member driving_motor_status
 * @return Reference to member driving_motor_status
 */
uint8_t& ros2_interface::msg::Vehicle::driving_motor_status()
{
    return m_driving_motor_status;
}

/*!
 * @brief This function sets a value in member driving_motor_ctemp
 * @param _driving_motor_ctemp New value for member driving_motor_ctemp
 */
void ros2_interface::msg::Vehicle::driving_motor_ctemp(
        double _driving_motor_ctemp)
{
    m_driving_motor_ctemp = _driving_motor_ctemp;
}

/*!
 * @brief This function returns the value of member driving_motor_ctemp
 * @return Value of member driving_motor_ctemp
 */
double ros2_interface::msg::Vehicle::driving_motor_ctemp() const
{
    return m_driving_motor_ctemp;
}

/*!
 * @brief This function returns a reference to member driving_motor_ctemp
 * @return Reference to member driving_motor_ctemp
 */
double& ros2_interface::msg::Vehicle::driving_motor_ctemp()
{
    return m_driving_motor_ctemp;
}

/*!
 * @brief This function sets a value in member driving_motor_rspeed
 * @param _driving_motor_rspeed New value for member driving_motor_rspeed
 */
void ros2_interface::msg::Vehicle::driving_motor_rspeed(
        uint8_t _driving_motor_rspeed)
{
    m_driving_motor_rspeed = _driving_motor_rspeed;
}

/*!
 * @brief This function returns the value of member driving_motor_rspeed
 * @return Value of member driving_motor_rspeed
 */
uint8_t ros2_interface::msg::Vehicle::driving_motor_rspeed() const
{
    return m_driving_motor_rspeed;
}

/*!
 * @brief This function returns a reference to member driving_motor_rspeed
 * @return Reference to member driving_motor_rspeed
 */
uint8_t& ros2_interface::msg::Vehicle::driving_motor_rspeed()
{
    return m_driving_motor_rspeed;
}

/*!
 * @brief This function sets a value in member driving_motor_torque
 * @param _driving_motor_torque New value for member driving_motor_torque
 */
void ros2_interface::msg::Vehicle::driving_motor_torque(
        double _driving_motor_torque)
{
    m_driving_motor_torque = _driving_motor_torque;
}

/*!
 * @brief This function returns the value of member driving_motor_torque
 * @return Value of member driving_motor_torque
 */
double ros2_interface::msg::Vehicle::driving_motor_torque() const
{
    return m_driving_motor_torque;
}

/*!
 * @brief This function returns a reference to member driving_motor_torque
 * @return Reference to member driving_motor_torque
 */
double& ros2_interface::msg::Vehicle::driving_motor_torque()
{
    return m_driving_motor_torque;
}

/*!
 * @brief This function sets a value in member driving_motor_etemp
 * @param _driving_motor_etemp New value for member driving_motor_etemp
 */
void ros2_interface::msg::Vehicle::driving_motor_etemp(
        double _driving_motor_etemp)
{
    m_driving_motor_etemp = _driving_motor_etemp;
}

/*!
 * @brief This function returns the value of member driving_motor_etemp
 * @return Value of member driving_motor_etemp
 */
double ros2_interface::msg::Vehicle::driving_motor_etemp() const
{
    return m_driving_motor_etemp;
}

/*!
 * @brief This function returns a reference to member driving_motor_etemp
 * @return Reference to member driving_motor_etemp
 */
double& ros2_interface::msg::Vehicle::driving_motor_etemp()
{
    return m_driving_motor_etemp;
}

/*!
 * @brief This function sets a value in member driving_motor_voltage
 * @param _driving_motor_voltage New value for member driving_motor_voltage
 */
void ros2_interface::msg::Vehicle::driving_motor_voltage(
        double _driving_motor_voltage)
{
    m_driving_motor_voltage = _driving_motor_voltage;
}

/*!
 * @brief This function returns the value of member driving_motor_voltage
 * @return Value of member driving_motor_voltage
 */
double ros2_interface::msg::Vehicle::driving_motor_voltage() const
{
    return m_driving_motor_voltage;
}

/*!
 * @brief This function returns a reference to member driving_motor_voltage
 * @return Reference to member driving_motor_voltage
 */
double& ros2_interface::msg::Vehicle::driving_motor_voltage()
{
    return m_driving_motor_voltage;
}

/*!
 * @brief This function sets a value in member driving_motor_ammeter
 * @param _driving_motor_ammeter New value for member driving_motor_ammeter
 */
void ros2_interface::msg::Vehicle::driving_motor_ammeter(
        double _driving_motor_ammeter)
{
    m_driving_motor_ammeter = _driving_motor_ammeter;
}

/*!
 * @brief This function returns the value of member driving_motor_ammeter
 * @return Value of member driving_motor_ammeter
 */
double ros2_interface::msg::Vehicle::driving_motor_ammeter() const
{
    return m_driving_motor_ammeter;
}

/*!
 * @brief This function returns a reference to member driving_motor_ammeter
 * @return Reference to member driving_motor_ammeter
 */
double& ros2_interface::msg::Vehicle::driving_motor_ammeter()
{
    return m_driving_motor_ammeter;
}

/*!
 * @brief This function sets a value in member outline_lamp_status
 * @param _outline_lamp_status New value for member outline_lamp_status
 */
void ros2_interface::msg::Vehicle::outline_lamp_status(
        int32_t _outline_lamp_status)
{
    m_outline_lamp_status = _outline_lamp_status;
}

/*!
 * @brief This function returns the value of member outline_lamp_status
 * @return Value of member outline_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::outline_lamp_status() const
{
    return m_outline_lamp_status;
}

/*!
 * @brief This function returns a reference to member outline_lamp_status
 * @return Reference to member outline_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::outline_lamp_status()
{
    return m_outline_lamp_status;
}

/*!
 * @brief This function sets a value in member warning_lamp_status
 * @param _warning_lamp_status New value for member warning_lamp_status
 */
void ros2_interface::msg::Vehicle::warning_lamp_status(
        int32_t _warning_lamp_status)
{
    m_warning_lamp_status = _warning_lamp_status;
}

/*!
 * @brief This function returns the value of member warning_lamp_status
 * @return Value of member warning_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::warning_lamp_status() const
{
    return m_warning_lamp_status;
}

/*!
 * @brief This function returns a reference to member warning_lamp_status
 * @return Reference to member warning_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::warning_lamp_status()
{
    return m_warning_lamp_status;
}

/*!
 * @brief This function sets a value in member parking_lamp_status
 * @param _parking_lamp_status New value for member parking_lamp_status
 */
void ros2_interface::msg::Vehicle::parking_lamp_status(
        int32_t _parking_lamp_status)
{
    m_parking_lamp_status = _parking_lamp_status;
}

/*!
 * @brief This function returns the value of member parking_lamp_status
 * @return Value of member parking_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::parking_lamp_status() const
{
    return m_parking_lamp_status;
}

/*!
 * @brief This function returns a reference to member parking_lamp_status
 * @return Reference to member parking_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::parking_lamp_status()
{
    return m_parking_lamp_status;
}

/*!
 * @brief This function sets a value in member interior_lamp_status
 * @param _interior_lamp_status New value for member interior_lamp_status
 */
void ros2_interface::msg::Vehicle::interior_lamp_status(
        int32_t _interior_lamp_status)
{
    m_interior_lamp_status = _interior_lamp_status;
}

/*!
 * @brief This function returns the value of member interior_lamp_status
 * @return Value of member interior_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::interior_lamp_status() const
{
    return m_interior_lamp_status;
}

/*!
 * @brief This function returns a reference to member interior_lamp_status
 * @return Reference to member interior_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::interior_lamp_status()
{
    return m_interior_lamp_status;
}

/*!
 * @brief This function sets a value in member ambient_lamp_status
 * @param _ambient_lamp_status New value for member ambient_lamp_status
 */
void ros2_interface::msg::Vehicle::ambient_lamp_status(
        int32_t _ambient_lamp_status)
{
    m_ambient_lamp_status = _ambient_lamp_status;
}

/*!
 * @brief This function returns the value of member ambient_lamp_status
 * @return Value of member ambient_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::ambient_lamp_status() const
{
    return m_ambient_lamp_status;
}

/*!
 * @brief This function returns a reference to member ambient_lamp_status
 * @return Reference to member ambient_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::ambient_lamp_status()
{
    return m_ambient_lamp_status;
}

/*!
 * @brief This function sets a value in member welcome_lamp_status
 * @param _welcome_lamp_status New value for member welcome_lamp_status
 */
void ros2_interface::msg::Vehicle::welcome_lamp_status(
        int32_t _welcome_lamp_status)
{
    m_welcome_lamp_status = _welcome_lamp_status;
}

/*!
 * @brief This function returns the value of member welcome_lamp_status
 * @return Value of member welcome_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::welcome_lamp_status() const
{
    return m_welcome_lamp_status;
}

/*!
 * @brief This function returns a reference to member welcome_lamp_status
 * @return Reference to member welcome_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::welcome_lamp_status()
{
    return m_welcome_lamp_status;
}

/*!
 * @brief This function sets a value in member backlight_lamp_status
 * @param _backlight_lamp_status New value for member backlight_lamp_status
 */
void ros2_interface::msg::Vehicle::backlight_lamp_status(
        int32_t _backlight_lamp_status)
{
    m_backlight_lamp_status = _backlight_lamp_status;
}

/*!
 * @brief This function returns the value of member backlight_lamp_status
 * @return Value of member backlight_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::backlight_lamp_status() const
{
    return m_backlight_lamp_status;
}

/*!
 * @brief This function returns a reference to member backlight_lamp_status
 * @return Reference to member backlight_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::backlight_lamp_status()
{
    return m_backlight_lamp_status;
}

/*!
 * @brief This function sets a value in member positionlight_lamp_status
 * @param _positionlight_lamp_status New value for member positionlight_lamp_status
 */
void ros2_interface::msg::Vehicle::positionlight_lamp_status(
        int32_t _positionlight_lamp_status)
{
    m_positionlight_lamp_status = _positionlight_lamp_status;
}

/*!
 * @brief This function returns the value of member positionlight_lamp_status
 * @return Value of member positionlight_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::positionlight_lamp_status() const
{
    return m_positionlight_lamp_status;
}

/*!
 * @brief This function returns a reference to member positionlight_lamp_status
 * @return Reference to member positionlight_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::positionlight_lamp_status()
{
    return m_positionlight_lamp_status;
}

/*!
 * @brief This function sets a value in member brakelamp_lamp_status
 * @param _brakelamp_lamp_status New value for member brakelamp_lamp_status
 */
void ros2_interface::msg::Vehicle::brakelamp_lamp_status(
        int32_t _brakelamp_lamp_status)
{
    m_brakelamp_lamp_status = _brakelamp_lamp_status;
}

/*!
 * @brief This function returns the value of member brakelamp_lamp_status
 * @return Value of member brakelamp_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::brakelamp_lamp_status() const
{
    return m_brakelamp_lamp_status;
}

/*!
 * @brief This function returns a reference to member brakelamp_lamp_status
 * @return Reference to member brakelamp_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::brakelamp_lamp_status()
{
    return m_brakelamp_lamp_status;
}

/*!
 * @brief This function sets a value in member backuplamp_lamp_status
 * @param _backuplamp_lamp_status New value for member backuplamp_lamp_status
 */
void ros2_interface::msg::Vehicle::backuplamp_lamp_status(
        int32_t _backuplamp_lamp_status)
{
    m_backuplamp_lamp_status = _backuplamp_lamp_status;
}

/*!
 * @brief This function returns the value of member backuplamp_lamp_status
 * @return Value of member backuplamp_lamp_status
 */
int32_t ros2_interface::msg::Vehicle::backuplamp_lamp_status() const
{
    return m_backuplamp_lamp_status;
}

/*!
 * @brief This function returns a reference to member backuplamp_lamp_status
 * @return Reference to member backuplamp_lamp_status
 */
int32_t& ros2_interface::msg::Vehicle::backuplamp_lamp_status()
{
    return m_backuplamp_lamp_status;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::Vehicle::length(
        int8_t _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
int8_t ros2_interface::msg::Vehicle::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
int8_t& ros2_interface::msg::Vehicle::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::Vehicle::width(
        int8_t _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
int8_t ros2_interface::msg::Vehicle::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
int8_t& ros2_interface::msg::Vehicle::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::Vehicle::height(
        int8_t _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
int8_t ros2_interface::msg::Vehicle::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
int8_t& ros2_interface::msg::Vehicle::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member traction
 * @param _traction New value for member traction
 */
void ros2_interface::msg::Vehicle::traction(
        int32_t _traction)
{
    m_traction = _traction;
}

/*!
 * @brief This function returns the value of member traction
 * @return Value of member traction
 */
int32_t ros2_interface::msg::Vehicle::traction() const
{
    return m_traction;
}

/*!
 * @brief This function returns a reference to member traction
 * @return Reference to member traction
 */
int32_t& ros2_interface::msg::Vehicle::traction()
{
    return m_traction;
}

/*!
 * @brief This function sets a value in member abs
 * @param _abs New value for member abs
 */
void ros2_interface::msg::Vehicle::abs(
        int32_t _abs)
{
    m_abs = _abs;
}

/*!
 * @brief This function returns the value of member abs
 * @return Value of member abs
 */
int32_t ros2_interface::msg::Vehicle::abs() const
{
    return m_abs;
}

/*!
 * @brief This function returns a reference to member abs
 * @return Reference to member abs
 */
int32_t& ros2_interface::msg::Vehicle::abs()
{
    return m_abs;
}

/*!
 * @brief This function sets a value in member scs
 * @param _scs New value for member scs
 */
void ros2_interface::msg::Vehicle::scs(
        int32_t _scs)
{
    m_scs = _scs;
}

/*!
 * @brief This function returns the value of member scs
 * @return Value of member scs
 */
int32_t ros2_interface::msg::Vehicle::scs() const
{
    return m_scs;
}

/*!
 * @brief This function returns a reference to member scs
 * @return Reference to member scs
 */
int32_t& ros2_interface::msg::Vehicle::scs()
{
    return m_scs;
}

/*!
 * @brief This function sets a value in member brake_boost
 * @param _brake_boost New value for member brake_boost
 */
void ros2_interface::msg::Vehicle::brake_boost(
        int32_t _brake_boost)
{
    m_brake_boost = _brake_boost;
}

/*!
 * @brief This function returns the value of member brake_boost
 * @return Value of member brake_boost
 */
int32_t ros2_interface::msg::Vehicle::brake_boost() const
{
    return m_brake_boost;
}

/*!
 * @brief This function returns a reference to member brake_boost
 * @return Reference to member brake_boost
 */
int32_t& ros2_interface::msg::Vehicle::brake_boost()
{
    return m_brake_boost;
}

/*!
 * @brief This function sets a value in member aux_brakes
 * @param _aux_brakes New value for member aux_brakes
 */
void ros2_interface::msg::Vehicle::aux_brakes(
        int32_t _aux_brakes)
{
    m_aux_brakes = _aux_brakes;
}

/*!
 * @brief This function returns the value of member aux_brakes
 * @return Value of member aux_brakes
 */
int32_t ros2_interface::msg::Vehicle::aux_brakes() const
{
    return m_aux_brakes;
}

/*!
 * @brief This function returns a reference to member aux_brakes
 * @return Reference to member aux_brakes
 */
int32_t& ros2_interface::msg::Vehicle::aux_brakes()
{
    return m_aux_brakes;
}



size_t ros2_interface::msg::Vehicle::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_Vehicle_max_key_cdr_typesize;
}

bool ros2_interface::msg::Vehicle::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::Vehicle::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



