// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file Vehicle.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLE_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(VEHICLE_SOURCE)
#define VEHICLE_DllAPI __declspec( dllexport )
#else
#define VEHICLE_DllAPI __declspec( dllimport )
#endif // VEHICLE_SOURCE
#else
#define VEHICLE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define VEHICLE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure Vehicle defined by the user in the IDL file.
         * @ingroup Vehicle
         */
        class Vehicle
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport Vehicle();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~Vehicle();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::Vehicle that will be copied.
             */
            eProsima_user_DllExport Vehicle(
                    const Vehicle& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::Vehicle that will be copied.
             */
            eProsima_user_DllExport Vehicle(
                    Vehicle&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::Vehicle that will be copied.
             */
            eProsima_user_DllExport Vehicle& operator =(
                    const Vehicle& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::Vehicle that will be copied.
             */
            eProsima_user_DllExport Vehicle& operator =(
                    Vehicle&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Vehicle object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const Vehicle& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::Vehicle object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const Vehicle& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member vehicle_type
             * @param _vehicle_type New value for member vehicle_type
             */
            eProsima_user_DllExport void vehicle_type(
                    int32_t _vehicle_type);

            /*!
             * @brief This function returns the value of member vehicle_type
             * @return Value of member vehicle_type
             */
            eProsima_user_DllExport int32_t vehicle_type() const;

            /*!
             * @brief This function returns a reference to member vehicle_type
             * @return Reference to member vehicle_type
             */
            eProsima_user_DllExport int32_t& vehicle_type();

            /*!
             * @brief This function copies the value in member vid
             * @param _vid New value to be copied in member vid
             */
            eProsima_user_DllExport void vid(
                    const std::string& _vid);

            /*!
             * @brief This function moves the value in member vid
             * @param _vid New value to be moved in member vid
             */
            eProsima_user_DllExport void vid(
                    std::string&& _vid);

            /*!
             * @brief This function returns a constant reference to member vid
             * @return Constant reference to member vid
             */
            eProsima_user_DllExport const std::string& vid() const;

            /*!
             * @brief This function returns a reference to member vid
             * @return Reference to member vid
             */
            eProsima_user_DllExport std::string& vid();
            /*!
             * @brief This function copies the value in member vehicle_num
             * @param _vehicle_num New value to be copied in member vehicle_num
             */
            eProsima_user_DllExport void vehicle_num(
                    const std::string& _vehicle_num);

            /*!
             * @brief This function moves the value in member vehicle_num
             * @param _vehicle_num New value to be moved in member vehicle_num
             */
            eProsima_user_DllExport void vehicle_num(
                    std::string&& _vehicle_num);

            /*!
             * @brief This function returns a constant reference to member vehicle_num
             * @return Constant reference to member vehicle_num
             */
            eProsima_user_DllExport const std::string& vehicle_num() const;

            /*!
             * @brief This function returns a reference to member vehicle_num
             * @return Reference to member vehicle_num
             */
            eProsima_user_DllExport std::string& vehicle_num();
            /*!
             * @brief This function copies the value in member oid
             * @param _oid New value to be copied in member oid
             */
            eProsima_user_DllExport void oid(
                    const std::string& _oid);

            /*!
             * @brief This function moves the value in member oid
             * @param _oid New value to be moved in member oid
             */
            eProsima_user_DllExport void oid(
                    std::string&& _oid);

            /*!
             * @brief This function returns a constant reference to member oid
             * @return Constant reference to member oid
             */
            eProsima_user_DllExport const std::string& oid() const;

            /*!
             * @brief This function returns a reference to member oid
             * @return Reference to member oid
             */
            eProsima_user_DllExport std::string& oid();
            /*!
             * @brief This function sets a value in member operation
             * @param _operation New value for member operation
             */
            eProsima_user_DllExport void operation(
                    int32_t _operation);

            /*!
             * @brief This function returns the value of member operation
             * @return Value of member operation
             */
            eProsima_user_DllExport int32_t operation() const;

            /*!
             * @brief This function returns a reference to member operation
             * @return Reference to member operation
             */
            eProsima_user_DllExport int32_t& operation();

            /*!
             * @brief This function sets a value in member totalcurrent
             * @param _totalcurrent New value for member totalcurrent
             */
            eProsima_user_DllExport void totalcurrent(
                    double _totalcurrent);

            /*!
             * @brief This function returns the value of member totalcurrent
             * @return Value of member totalcurrent
             */
            eProsima_user_DllExport double totalcurrent() const;

            /*!
             * @brief This function returns a reference to member totalcurrent
             * @return Reference to member totalcurrent
             */
            eProsima_user_DllExport double& totalcurrent();

            /*!
             * @brief This function sets a value in member batterysoc
             * @param _batterysoc New value for member batterysoc
             */
            eProsima_user_DllExport void batterysoc(
                    double _batterysoc);

            /*!
             * @brief This function returns the value of member batterysoc
             * @return Value of member batterysoc
             */
            eProsima_user_DllExport double batterysoc() const;

            /*!
             * @brief This function returns a reference to member batterysoc
             * @return Reference to member batterysoc
             */
            eProsima_user_DllExport double& batterysoc();

            /*!
             * @brief This function sets a value in member totalvoltage
             * @param _totalvoltage New value for member totalvoltage
             */
            eProsima_user_DllExport void totalvoltage(
                    double _totalvoltage);

            /*!
             * @brief This function returns the value of member totalvoltage
             * @return Value of member totalvoltage
             */
            eProsima_user_DllExport double totalvoltage() const;

            /*!
             * @brief This function returns a reference to member totalvoltage
             * @return Reference to member totalvoltage
             */
            eProsima_user_DllExport double& totalvoltage();

            /*!
             * @brief This function sets a value in member recharge
             * @param _recharge New value for member recharge
             */
            eProsima_user_DllExport void recharge(
                    double _recharge);

            /*!
             * @brief This function returns the value of member recharge
             * @return Value of member recharge
             */
            eProsima_user_DllExport double recharge() const;

            /*!
             * @brief This function returns a reference to member recharge
             * @return Reference to member recharge
             */
            eProsima_user_DllExport double& recharge();

            /*!
             * @brief This function sets a value in member dcdc
             * @param _dcdc New value for member dcdc
             */
            eProsima_user_DllExport void dcdc(
                    int32_t _dcdc);

            /*!
             * @brief This function returns the value of member dcdc
             * @return Value of member dcdc
             */
            eProsima_user_DllExport int32_t dcdc() const;

            /*!
             * @brief This function returns a reference to member dcdc
             * @return Reference to member dcdc
             */
            eProsima_user_DllExport int32_t& dcdc();

            /*!
             * @brief This function sets a value in member resistance
             * @param _resistance New value for member resistance
             */
            eProsima_user_DllExport void resistance(
                    uint32_t _resistance);

            /*!
             * @brief This function returns the value of member resistance
             * @return Value of member resistance
             */
            eProsima_user_DllExport uint32_t resistance() const;

            /*!
             * @brief This function returns a reference to member resistance
             * @return Reference to member resistance
             */
            eProsima_user_DllExport uint32_t& resistance();

            /*!
             * @brief This function copies the value in member seats
             * @param _seats New value to be copied in member seats
             */
            eProsima_user_DllExport void seats(
                    const std::vector<uint8_t>& _seats);

            /*!
             * @brief This function moves the value in member seats
             * @param _seats New value to be moved in member seats
             */
            eProsima_user_DllExport void seats(
                    std::vector<uint8_t>&& _seats);

            /*!
             * @brief This function returns a constant reference to member seats
             * @return Constant reference to member seats
             */
            eProsima_user_DllExport const std::vector<uint8_t>& seats() const;

            /*!
             * @brief This function returns a reference to member seats
             * @return Reference to member seats
             */
            eProsima_user_DllExport std::vector<uint8_t>& seats();
            /*!
             * @brief This function sets a value in member servicemode
             * @param _servicemode New value for member servicemode
             */
            eProsima_user_DllExport void servicemode(
                    int32_t _servicemode);

            /*!
             * @brief This function returns the value of member servicemode
             * @return Value of member servicemode
             */
            eProsima_user_DllExport int32_t servicemode() const;

            /*!
             * @brief This function returns a reference to member servicemode
             * @return Reference to member servicemode
             */
            eProsima_user_DllExport int32_t& servicemode();

            /*!
             * @brief This function copies the value in member seat_belt
             * @param _seat_belt New value to be copied in member seat_belt
             */
            eProsima_user_DllExport void seat_belt(
                    const std::vector<int32_t>& _seat_belt);

            /*!
             * @brief This function moves the value in member seat_belt
             * @param _seat_belt New value to be moved in member seat_belt
             */
            eProsima_user_DllExport void seat_belt(
                    std::vector<int32_t>&& _seat_belt);

            /*!
             * @brief This function returns a constant reference to member seat_belt
             * @return Constant reference to member seat_belt
             */
            eProsima_user_DllExport const std::vector<int32_t>& seat_belt() const;

            /*!
             * @brief This function returns a reference to member seat_belt
             * @return Reference to member seat_belt
             */
            eProsima_user_DllExport std::vector<int32_t>& seat_belt();
            /*!
             * @brief This function sets a value in member engine_status
             * @param _engine_status New value for member engine_status
             */
            eProsima_user_DllExport void engine_status(
                    int32_t _engine_status);

            /*!
             * @brief This function returns the value of member engine_status
             * @return Value of member engine_status
             */
            eProsima_user_DllExport int32_t engine_status() const;

            /*!
             * @brief This function returns a reference to member engine_status
             * @return Reference to member engine_status
             */
            eProsima_user_DllExport int32_t& engine_status();

            /*!
             * @brief This function sets a value in member battery_voltage
             * @param _battery_voltage New value for member battery_voltage
             */
            eProsima_user_DllExport void battery_voltage(
                    double _battery_voltage);

            /*!
             * @brief This function returns the value of member battery_voltage
             * @return Value of member battery_voltage
             */
            eProsima_user_DllExport double battery_voltage() const;

            /*!
             * @brief This function returns a reference to member battery_voltage
             * @return Reference to member battery_voltage
             */
            eProsima_user_DllExport double& battery_voltage();

            /*!
             * @brief This function sets a value in member battery_ammeter
             * @param _battery_ammeter New value for member battery_ammeter
             */
            eProsima_user_DllExport void battery_ammeter(
                    double _battery_ammeter);

            /*!
             * @brief This function returns the value of member battery_ammeter
             * @return Value of member battery_ammeter
             */
            eProsima_user_DllExport double battery_ammeter() const;

            /*!
             * @brief This function returns a reference to member battery_ammeter
             * @return Reference to member battery_ammeter
             */
            eProsima_user_DllExport double& battery_ammeter();

            /*!
             * @brief This function sets a value in member battery_consumption
             * @param _battery_consumption New value for member battery_consumption
             */
            eProsima_user_DllExport void battery_consumption(
                    double _battery_consumption);

            /*!
             * @brief This function returns the value of member battery_consumption
             * @return Value of member battery_consumption
             */
            eProsima_user_DllExport double battery_consumption() const;

            /*!
             * @brief This function returns a reference to member battery_consumption
             * @return Reference to member battery_consumption
             */
            eProsima_user_DllExport double& battery_consumption();

            /*!
             * @brief This function sets a value in member battery_probe
             * @param _battery_probe New value for member battery_probe
             */
            eProsima_user_DllExport void battery_probe(
                    double _battery_probe);

            /*!
             * @brief This function returns the value of member battery_probe
             * @return Value of member battery_probe
             */
            eProsima_user_DllExport double battery_probe() const;

            /*!
             * @brief This function returns a reference to member battery_probe
             * @return Reference to member battery_probe
             */
            eProsima_user_DllExport double& battery_probe();

            /*!
             * @brief This function copies the value in member battery_temperatures
             * @param _battery_temperatures New value to be copied in member battery_temperatures
             */
            eProsima_user_DllExport void battery_temperatures(
                    const std::vector<double>& _battery_temperatures);

            /*!
             * @brief This function moves the value in member battery_temperatures
             * @param _battery_temperatures New value to be moved in member battery_temperatures
             */
            eProsima_user_DllExport void battery_temperatures(
                    std::vector<double>&& _battery_temperatures);

            /*!
             * @brief This function returns a constant reference to member battery_temperatures
             * @return Constant reference to member battery_temperatures
             */
            eProsima_user_DllExport const std::vector<double>& battery_temperatures() const;

            /*!
             * @brief This function returns a reference to member battery_temperatures
             * @return Reference to member battery_temperatures
             */
            eProsima_user_DllExport std::vector<double>& battery_temperatures();
            /*!
             * @brief This function sets a value in member battery_h_tepemperatures
             * @param _battery_h_tepemperatures New value for member battery_h_tepemperatures
             */
            eProsima_user_DllExport void battery_h_tepemperatures(
                    double _battery_h_tepemperatures);

            /*!
             * @brief This function returns the value of member battery_h_tepemperatures
             * @return Value of member battery_h_tepemperatures
             */
            eProsima_user_DllExport double battery_h_tepemperatures() const;

            /*!
             * @brief This function returns a reference to member battery_h_tepemperatures
             * @return Reference to member battery_h_tepemperatures
             */
            eProsima_user_DllExport double& battery_h_tepemperatures();

            /*!
             * @brief This function sets a value in member battery_ltepemperatures
             * @param _battery_ltepemperatures New value for member battery_ltepemperatures
             */
            eProsima_user_DllExport void battery_ltepemperatures(
                    double _battery_ltepemperatures);

            /*!
             * @brief This function returns the value of member battery_ltepemperatures
             * @return Value of member battery_ltepemperatures
             */
            eProsima_user_DllExport double battery_ltepemperatures() const;

            /*!
             * @brief This function returns a reference to member battery_ltepemperatures
             * @return Reference to member battery_ltepemperatures
             */
            eProsima_user_DllExport double& battery_ltepemperatures();

            /*!
             * @brief This function sets a value in member battery_probe_code
             * @param _battery_probe_code New value for member battery_probe_code
             */
            eProsima_user_DllExport void battery_probe_code(
                    double _battery_probe_code);

            /*!
             * @brief This function returns the value of member battery_probe_code
             * @return Value of member battery_probe_code
             */
            eProsima_user_DllExport double battery_probe_code() const;

            /*!
             * @brief This function returns a reference to member battery_probe_code
             * @return Reference to member battery_probe_code
             */
            eProsima_user_DllExport double& battery_probe_code();

            /*!
             * @brief This function sets a value in member battery_h_concentration
             * @param _battery_h_concentration New value for member battery_h_concentration
             */
            eProsima_user_DllExport void battery_h_concentration(
                    double _battery_h_concentration);

            /*!
             * @brief This function returns the value of member battery_h_concentration
             * @return Value of member battery_h_concentration
             */
            eProsima_user_DllExport double battery_h_concentration() const;

            /*!
             * @brief This function returns a reference to member battery_h_concentration
             * @return Reference to member battery_h_concentration
             */
            eProsima_user_DllExport double& battery_h_concentration();

            /*!
             * @brief This function sets a value in member battery_c_sensor_code
             * @param _battery_c_sensor_code New value for member battery_c_sensor_code
             */
            eProsima_user_DllExport void battery_c_sensor_code(
                    double _battery_c_sensor_code);

            /*!
             * @brief This function returns the value of member battery_c_sensor_code
             * @return Value of member battery_c_sensor_code
             */
            eProsima_user_DllExport double battery_c_sensor_code() const;

            /*!
             * @brief This function returns a reference to member battery_c_sensor_code
             * @return Reference to member battery_c_sensor_code
             */
            eProsima_user_DllExport double& battery_c_sensor_code();

            /*!
             * @brief This function sets a value in member battery_stress
             * @param _battery_stress New value for member battery_stress
             */
            eProsima_user_DllExport void battery_stress(
                    double _battery_stress);

            /*!
             * @brief This function returns the value of member battery_stress
             * @return Value of member battery_stress
             */
            eProsima_user_DllExport double battery_stress() const;

            /*!
             * @brief This function returns a reference to member battery_stress
             * @return Reference to member battery_stress
             */
            eProsima_user_DllExport double& battery_stress();

            /*!
             * @brief This function sets a value in member battery_s_sensor_code
             * @param _battery_s_sensor_code New value for member battery_s_sensor_code
             */
            eProsima_user_DllExport void battery_s_sensor_code(
                    double _battery_s_sensor_code);

            /*!
             * @brief This function returns the value of member battery_s_sensor_code
             * @return Value of member battery_s_sensor_code
             */
            eProsima_user_DllExport double battery_s_sensor_code() const;

            /*!
             * @brief This function returns a reference to member battery_s_sensor_code
             * @return Reference to member battery_s_sensor_code
             */
            eProsima_user_DllExport double& battery_s_sensor_code();

            /*!
             * @brief This function sets a value in member battery_h_dc_dc
             * @param _battery_h_dc_dc New value for member battery_h_dc_dc
             */
            eProsima_user_DllExport void battery_h_dc_dc(
                    double _battery_h_dc_dc);

            /*!
             * @brief This function returns the value of member battery_h_dc_dc
             * @return Value of member battery_h_dc_dc
             */
            eProsima_user_DllExport double battery_h_dc_dc() const;

            /*!
             * @brief This function returns a reference to member battery_h_dc_dc
             * @return Reference to member battery_h_dc_dc
             */
            eProsima_user_DllExport double& battery_h_dc_dc();

            /*!
             * @brief This function sets a value in member battery_capacity
             * @param _battery_capacity New value for member battery_capacity
             */
            eProsima_user_DllExport void battery_capacity(
                    double _battery_capacity);

            /*!
             * @brief This function returns the value of member battery_capacity
             * @return Value of member battery_capacity
             */
            eProsima_user_DllExport double battery_capacity() const;

            /*!
             * @brief This function returns a reference to member battery_capacity
             * @return Reference to member battery_capacity
             */
            eProsima_user_DllExport double& battery_capacity();

            /*!
             * @brief This function sets a value in member airconditioning_idx
             * @param _airconditioning_idx New value for member airconditioning_idx
             */
            eProsima_user_DllExport void airconditioning_idx(
                    double _airconditioning_idx);

            /*!
             * @brief This function returns the value of member airconditioning_idx
             * @return Value of member airconditioning_idx
             */
            eProsima_user_DllExport double airconditioning_idx() const;

            /*!
             * @brief This function returns a reference to member airconditioning_idx
             * @return Reference to member airconditioning_idx
             */
            eProsima_user_DllExport double& airconditioning_idx();

            /*!
             * @brief This function sets a value in member airconditioning_status
             * @param _airconditioning_status New value for member airconditioning_status
             */
            eProsima_user_DllExport void airconditioning_status(
                    double _airconditioning_status);

            /*!
             * @brief This function returns the value of member airconditioning_status
             * @return Value of member airconditioning_status
             */
            eProsima_user_DllExport double airconditioning_status() const;

            /*!
             * @brief This function returns a reference to member airconditioning_status
             * @return Reference to member airconditioning_status
             */
            eProsima_user_DllExport double& airconditioning_status();

            /*!
             * @brief This function sets a value in member airconditioning_model
             * @param _airconditioning_model New value for member airconditioning_model
             */
            eProsima_user_DllExport void airconditioning_model(
                    int32_t _airconditioning_model);

            /*!
             * @brief This function returns the value of member airconditioning_model
             * @return Value of member airconditioning_model
             */
            eProsima_user_DllExport int32_t airconditioning_model() const;

            /*!
             * @brief This function returns a reference to member airconditioning_model
             * @return Reference to member airconditioning_model
             */
            eProsima_user_DllExport int32_t& airconditioning_model();

            /*!
             * @brief This function sets a value in member airconditioning_volume
             * @param _airconditioning_volume New value for member airconditioning_volume
             */
            eProsima_user_DllExport void airconditioning_volume(
                    int32_t _airconditioning_volume);

            /*!
             * @brief This function returns the value of member airconditioning_volume
             * @return Value of member airconditioning_volume
             */
            eProsima_user_DllExport int32_t airconditioning_volume() const;

            /*!
             * @brief This function returns a reference to member airconditioning_volume
             * @return Reference to member airconditioning_volume
             */
            eProsima_user_DllExport int32_t& airconditioning_volume();

            /*!
             * @brief This function sets a value in member airconditioning_defrost
             * @param _airconditioning_defrost New value for member airconditioning_defrost
             */
            eProsima_user_DllExport void airconditioning_defrost(
                    int32_t _airconditioning_defrost);

            /*!
             * @brief This function returns the value of member airconditioning_defrost
             * @return Value of member airconditioning_defrost
             */
            eProsima_user_DllExport int32_t airconditioning_defrost() const;

            /*!
             * @brief This function returns a reference to member airconditioning_defrost
             * @return Reference to member airconditioning_defrost
             */
            eProsima_user_DllExport int32_t& airconditioning_defrost();

            /*!
             * @brief This function copies the value in member door_status
             * @param _door_status New value to be copied in member door_status
             */
            eProsima_user_DllExport void door_status(
                    const std::vector<int32_t>& _door_status);

            /*!
             * @brief This function moves the value in member door_status
             * @param _door_status New value to be moved in member door_status
             */
            eProsima_user_DllExport void door_status(
                    std::vector<int32_t>&& _door_status);

            /*!
             * @brief This function returns a constant reference to member door_status
             * @return Constant reference to member door_status
             */
            eProsima_user_DllExport const std::vector<int32_t>& door_status() const;

            /*!
             * @brief This function returns a reference to member door_status
             * @return Reference to member door_status
             */
            eProsima_user_DllExport std::vector<int32_t>& door_status();
            /*!
             * @brief This function sets a value in member rsrp
             * @param _rsrp New value for member rsrp
             */
            eProsima_user_DllExport void rsrp(
                    double _rsrp);

            /*!
             * @brief This function returns the value of member rsrp
             * @return Value of member rsrp
             */
            eProsima_user_DllExport double rsrp() const;

            /*!
             * @brief This function returns a reference to member rsrp
             * @return Reference to member rsrp
             */
            eProsima_user_DllExport double& rsrp();

            /*!
             * @brief This function sets a value in member sinr
             * @param _sinr New value for member sinr
             */
            eProsima_user_DllExport void sinr(
                    double _sinr);

            /*!
             * @brief This function returns the value of member sinr
             * @return Value of member sinr
             */
            eProsima_user_DllExport double sinr() const;

            /*!
             * @brief This function returns a reference to member sinr
             * @return Reference to member sinr
             */
            eProsima_user_DllExport double& sinr();

            /*!
             * @brief This function sets a value in member uspeed
             * @param _uspeed New value for member uspeed
             */
            eProsima_user_DllExport void uspeed(
                    double _uspeed);

            /*!
             * @brief This function returns the value of member uspeed
             * @return Value of member uspeed
             */
            eProsima_user_DllExport double uspeed() const;

            /*!
             * @brief This function returns a reference to member uspeed
             * @return Reference to member uspeed
             */
            eProsima_user_DllExport double& uspeed();

            /*!
             * @brief This function sets a value in member dspeed
             * @param _dspeed New value for member dspeed
             */
            eProsima_user_DllExport void dspeed(
                    double _dspeed);

            /*!
             * @brief This function returns the value of member dspeed
             * @return Value of member dspeed
             */
            eProsima_user_DllExport double dspeed() const;

            /*!
             * @brief This function returns a reference to member dspeed
             * @return Reference to member dspeed
             */
            eProsima_user_DllExport double& dspeed();

            /*!
             * @brief This function sets a value in member loss
             * @param _loss New value for member loss
             */
            eProsima_user_DllExport void loss(
                    double _loss);

            /*!
             * @brief This function returns the value of member loss
             * @return Value of member loss
             */
            eProsima_user_DllExport double loss() const;

            /*!
             * @brief This function returns a reference to member loss
             * @return Reference to member loss
             */
            eProsima_user_DllExport double& loss();

            /*!
             * @brief This function sets a value in member delay
             * @param _delay New value for member delay
             */
            eProsima_user_DllExport void delay(
                    uint32_t _delay);

            /*!
             * @brief This function returns the value of member delay
             * @return Value of member delay
             */
            eProsima_user_DllExport uint32_t delay() const;

            /*!
             * @brief This function returns a reference to member delay
             * @return Reference to member delay
             */
            eProsima_user_DllExport uint32_t& delay();

            /*!
             * @brief This function sets a value in member refrigeration_idx
             * @param _refrigeration_idx New value for member refrigeration_idx
             */
            eProsima_user_DllExport void refrigeration_idx(
                    uint8_t _refrigeration_idx);

            /*!
             * @brief This function returns the value of member refrigeration_idx
             * @return Value of member refrigeration_idx
             */
            eProsima_user_DllExport uint8_t refrigeration_idx() const;

            /*!
             * @brief This function returns a reference to member refrigeration_idx
             * @return Reference to member refrigeration_idx
             */
            eProsima_user_DllExport uint8_t& refrigeration_idx();

            /*!
             * @brief This function sets a value in member refrigeration_status
             * @param _refrigeration_status New value for member refrigeration_status
             */
            eProsima_user_DllExport void refrigeration_status(
                    int32_t _refrigeration_status);

            /*!
             * @brief This function returns the value of member refrigeration_status
             * @return Value of member refrigeration_status
             */
            eProsima_user_DllExport int32_t refrigeration_status() const;

            /*!
             * @brief This function returns a reference to member refrigeration_status
             * @return Reference to member refrigeration_status
             */
            eProsima_user_DllExport int32_t& refrigeration_status();

            /*!
             * @brief This function sets a value in member refrigeration_stemp
             * @param _refrigeration_stemp New value for member refrigeration_stemp
             */
            eProsima_user_DllExport void refrigeration_stemp(
                    double _refrigeration_stemp);

            /*!
             * @brief This function returns the value of member refrigeration_stemp
             * @return Value of member refrigeration_stemp
             */
            eProsima_user_DllExport double refrigeration_stemp() const;

            /*!
             * @brief This function returns a reference to member refrigeration_stemp
             * @return Reference to member refrigeration_stemp
             */
            eProsima_user_DllExport double& refrigeration_stemp();

            /*!
             * @brief This function sets a value in member refrigeration_ctemp
             * @param _refrigeration_ctemp New value for member refrigeration_ctemp
             */
            eProsima_user_DllExport void refrigeration_ctemp(
                    double _refrigeration_ctemp);

            /*!
             * @brief This function returns the value of member refrigeration_ctemp
             * @return Value of member refrigeration_ctemp
             */
            eProsima_user_DllExport double refrigeration_ctemp() const;

            /*!
             * @brief This function returns a reference to member refrigeration_ctemp
             * @return Reference to member refrigeration_ctemp
             */
            eProsima_user_DllExport double& refrigeration_ctemp();

            /*!
             * @brief This function sets a value in member driving_motor_idx
             * @param _driving_motor_idx New value for member driving_motor_idx
             */
            eProsima_user_DllExport void driving_motor_idx(
                    uint8_t _driving_motor_idx);

            /*!
             * @brief This function returns the value of member driving_motor_idx
             * @return Value of member driving_motor_idx
             */
            eProsima_user_DllExport uint8_t driving_motor_idx() const;

            /*!
             * @brief This function returns a reference to member driving_motor_idx
             * @return Reference to member driving_motor_idx
             */
            eProsima_user_DllExport uint8_t& driving_motor_idx();

            /*!
             * @brief This function sets a value in member driving_motor_status
             * @param _driving_motor_status New value for member driving_motor_status
             */
            eProsima_user_DllExport void driving_motor_status(
                    uint8_t _driving_motor_status);

            /*!
             * @brief This function returns the value of member driving_motor_status
             * @return Value of member driving_motor_status
             */
            eProsima_user_DllExport uint8_t driving_motor_status() const;

            /*!
             * @brief This function returns a reference to member driving_motor_status
             * @return Reference to member driving_motor_status
             */
            eProsima_user_DllExport uint8_t& driving_motor_status();

            /*!
             * @brief This function sets a value in member driving_motor_ctemp
             * @param _driving_motor_ctemp New value for member driving_motor_ctemp
             */
            eProsima_user_DllExport void driving_motor_ctemp(
                    double _driving_motor_ctemp);

            /*!
             * @brief This function returns the value of member driving_motor_ctemp
             * @return Value of member driving_motor_ctemp
             */
            eProsima_user_DllExport double driving_motor_ctemp() const;

            /*!
             * @brief This function returns a reference to member driving_motor_ctemp
             * @return Reference to member driving_motor_ctemp
             */
            eProsima_user_DllExport double& driving_motor_ctemp();

            /*!
             * @brief This function sets a value in member driving_motor_rspeed
             * @param _driving_motor_rspeed New value for member driving_motor_rspeed
             */
            eProsima_user_DllExport void driving_motor_rspeed(
                    uint8_t _driving_motor_rspeed);

            /*!
             * @brief This function returns the value of member driving_motor_rspeed
             * @return Value of member driving_motor_rspeed
             */
            eProsima_user_DllExport uint8_t driving_motor_rspeed() const;

            /*!
             * @brief This function returns a reference to member driving_motor_rspeed
             * @return Reference to member driving_motor_rspeed
             */
            eProsima_user_DllExport uint8_t& driving_motor_rspeed();

            /*!
             * @brief This function sets a value in member driving_motor_torque
             * @param _driving_motor_torque New value for member driving_motor_torque
             */
            eProsima_user_DllExport void driving_motor_torque(
                    double _driving_motor_torque);

            /*!
             * @brief This function returns the value of member driving_motor_torque
             * @return Value of member driving_motor_torque
             */
            eProsima_user_DllExport double driving_motor_torque() const;

            /*!
             * @brief This function returns a reference to member driving_motor_torque
             * @return Reference to member driving_motor_torque
             */
            eProsima_user_DllExport double& driving_motor_torque();

            /*!
             * @brief This function sets a value in member driving_motor_etemp
             * @param _driving_motor_etemp New value for member driving_motor_etemp
             */
            eProsima_user_DllExport void driving_motor_etemp(
                    double _driving_motor_etemp);

            /*!
             * @brief This function returns the value of member driving_motor_etemp
             * @return Value of member driving_motor_etemp
             */
            eProsima_user_DllExport double driving_motor_etemp() const;

            /*!
             * @brief This function returns a reference to member driving_motor_etemp
             * @return Reference to member driving_motor_etemp
             */
            eProsima_user_DllExport double& driving_motor_etemp();

            /*!
             * @brief This function sets a value in member driving_motor_voltage
             * @param _driving_motor_voltage New value for member driving_motor_voltage
             */
            eProsima_user_DllExport void driving_motor_voltage(
                    double _driving_motor_voltage);

            /*!
             * @brief This function returns the value of member driving_motor_voltage
             * @return Value of member driving_motor_voltage
             */
            eProsima_user_DllExport double driving_motor_voltage() const;

            /*!
             * @brief This function returns a reference to member driving_motor_voltage
             * @return Reference to member driving_motor_voltage
             */
            eProsima_user_DllExport double& driving_motor_voltage();

            /*!
             * @brief This function sets a value in member driving_motor_ammeter
             * @param _driving_motor_ammeter New value for member driving_motor_ammeter
             */
            eProsima_user_DllExport void driving_motor_ammeter(
                    double _driving_motor_ammeter);

            /*!
             * @brief This function returns the value of member driving_motor_ammeter
             * @return Value of member driving_motor_ammeter
             */
            eProsima_user_DllExport double driving_motor_ammeter() const;

            /*!
             * @brief This function returns a reference to member driving_motor_ammeter
             * @return Reference to member driving_motor_ammeter
             */
            eProsima_user_DllExport double& driving_motor_ammeter();

            /*!
             * @brief This function sets a value in member outline_lamp_status
             * @param _outline_lamp_status New value for member outline_lamp_status
             */
            eProsima_user_DllExport void outline_lamp_status(
                    int32_t _outline_lamp_status);

            /*!
             * @brief This function returns the value of member outline_lamp_status
             * @return Value of member outline_lamp_status
             */
            eProsima_user_DllExport int32_t outline_lamp_status() const;

            /*!
             * @brief This function returns a reference to member outline_lamp_status
             * @return Reference to member outline_lamp_status
             */
            eProsima_user_DllExport int32_t& outline_lamp_status();

            /*!
             * @brief This function sets a value in member warning_lamp_status
             * @param _warning_lamp_status New value for member warning_lamp_status
             */
            eProsima_user_DllExport void warning_lamp_status(
                    int32_t _warning_lamp_status);

            /*!
             * @brief This function returns the value of member warning_lamp_status
             * @return Value of member warning_lamp_status
             */
            eProsima_user_DllExport int32_t warning_lamp_status() const;

            /*!
             * @brief This function returns a reference to member warning_lamp_status
             * @return Reference to member warning_lamp_status
             */
            eProsima_user_DllExport int32_t& warning_lamp_status();

            /*!
             * @brief This function sets a value in member parking_lamp_status
             * @param _parking_lamp_status New value for member parking_lamp_status
             */
            eProsima_user_DllExport void parking_lamp_status(
                    int32_t _parking_lamp_status);

            /*!
             * @brief This function returns the value of member parking_lamp_status
             * @return Value of member parking_lamp_status
             */
            eProsima_user_DllExport int32_t parking_lamp_status() const;

            /*!
             * @brief This function returns a reference to member parking_lamp_status
             * @return Reference to member parking_lamp_status
             */
            eProsima_user_DllExport int32_t& parking_lamp_status();

            /*!
             * @brief This function sets a value in member interior_lamp_status
             * @param _interior_lamp_status New value for member interior_lamp_status
             */
            eProsima_user_DllExport void interior_lamp_status(
                    int32_t _interior_lamp_status);

            /*!
             * @brief This function returns the value of member interior_lamp_status
             * @return Value of member interior_lamp_status
             */
            eProsima_user_DllExport int32_t interior_lamp_status() const;

            /*!
             * @brief This function returns a reference to member interior_lamp_status
             * @return Reference to member interior_lamp_status
             */
            eProsima_user_DllExport int32_t& interior_lamp_status();

            /*!
             * @brief This function sets a value in member ambient_lamp_status
             * @param _ambient_lamp_status New value for member ambient_lamp_status
             */
            eProsima_user_DllExport void ambient_lamp_status(
                    int32_t _ambient_lamp_status);

            /*!
             * @brief This function returns the value of member ambient_lamp_status
             * @return Value of member ambient_lamp_status
             */
            eProsima_user_DllExport int32_t ambient_lamp_status() const;

            /*!
             * @brief This function returns a reference to member ambient_lamp_status
             * @return Reference to member ambient_lamp_status
             */
            eProsima_user_DllExport int32_t& ambient_lamp_status();

            /*!
             * @brief This function sets a value in member welcome_lamp_status
             * @param _welcome_lamp_status New value for member welcome_lamp_status
             */
            eProsima_user_DllExport void welcome_lamp_status(
                    int32_t _welcome_lamp_status);

            /*!
             * @brief This function returns the value of member welcome_lamp_status
             * @return Value of member welcome_lamp_status
             */
            eProsima_user_DllExport int32_t welcome_lamp_status() const;

            /*!
             * @brief This function returns a reference to member welcome_lamp_status
             * @return Reference to member welcome_lamp_status
             */
            eProsima_user_DllExport int32_t& welcome_lamp_status();

            /*!
             * @brief This function sets a value in member backlight_lamp_status
             * @param _backlight_lamp_status New value for member backlight_lamp_status
             */
            eProsima_user_DllExport void backlight_lamp_status(
                    int32_t _backlight_lamp_status);

            /*!
             * @brief This function returns the value of member backlight_lamp_status
             * @return Value of member backlight_lamp_status
             */
            eProsima_user_DllExport int32_t backlight_lamp_status() const;

            /*!
             * @brief This function returns a reference to member backlight_lamp_status
             * @return Reference to member backlight_lamp_status
             */
            eProsima_user_DllExport int32_t& backlight_lamp_status();

            /*!
             * @brief This function sets a value in member positionlight_lamp_status
             * @param _positionlight_lamp_status New value for member positionlight_lamp_status
             */
            eProsima_user_DllExport void positionlight_lamp_status(
                    int32_t _positionlight_lamp_status);

            /*!
             * @brief This function returns the value of member positionlight_lamp_status
             * @return Value of member positionlight_lamp_status
             */
            eProsima_user_DllExport int32_t positionlight_lamp_status() const;

            /*!
             * @brief This function returns a reference to member positionlight_lamp_status
             * @return Reference to member positionlight_lamp_status
             */
            eProsima_user_DllExport int32_t& positionlight_lamp_status();

            /*!
             * @brief This function sets a value in member brakelamp_lamp_status
             * @param _brakelamp_lamp_status New value for member brakelamp_lamp_status
             */
            eProsima_user_DllExport void brakelamp_lamp_status(
                    int32_t _brakelamp_lamp_status);

            /*!
             * @brief This function returns the value of member brakelamp_lamp_status
             * @return Value of member brakelamp_lamp_status
             */
            eProsima_user_DllExport int32_t brakelamp_lamp_status() const;

            /*!
             * @brief This function returns a reference to member brakelamp_lamp_status
             * @return Reference to member brakelamp_lamp_status
             */
            eProsima_user_DllExport int32_t& brakelamp_lamp_status();

            /*!
             * @brief This function sets a value in member backuplamp_lamp_status
             * @param _backuplamp_lamp_status New value for member backuplamp_lamp_status
             */
            eProsima_user_DllExport void backuplamp_lamp_status(
                    int32_t _backuplamp_lamp_status);

            /*!
             * @brief This function returns the value of member backuplamp_lamp_status
             * @return Value of member backuplamp_lamp_status
             */
            eProsima_user_DllExport int32_t backuplamp_lamp_status() const;

            /*!
             * @brief This function returns a reference to member backuplamp_lamp_status
             * @return Reference to member backuplamp_lamp_status
             */
            eProsima_user_DllExport int32_t& backuplamp_lamp_status();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    int8_t _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport int8_t length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport int8_t& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    int8_t _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport int8_t width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport int8_t& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    int8_t _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport int8_t height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport int8_t& height();

            /*!
             * @brief This function sets a value in member traction
             * @param _traction New value for member traction
             */
            eProsima_user_DllExport void traction(
                    int32_t _traction);

            /*!
             * @brief This function returns the value of member traction
             * @return Value of member traction
             */
            eProsima_user_DllExport int32_t traction() const;

            /*!
             * @brief This function returns a reference to member traction
             * @return Reference to member traction
             */
            eProsima_user_DllExport int32_t& traction();

            /*!
             * @brief This function sets a value in member abs
             * @param _abs New value for member abs
             */
            eProsima_user_DllExport void abs(
                    int32_t _abs);

            /*!
             * @brief This function returns the value of member abs
             * @return Value of member abs
             */
            eProsima_user_DllExport int32_t abs() const;

            /*!
             * @brief This function returns a reference to member abs
             * @return Reference to member abs
             */
            eProsima_user_DllExport int32_t& abs();

            /*!
             * @brief This function sets a value in member scs
             * @param _scs New value for member scs
             */
            eProsima_user_DllExport void scs(
                    int32_t _scs);

            /*!
             * @brief This function returns the value of member scs
             * @return Value of member scs
             */
            eProsima_user_DllExport int32_t scs() const;

            /*!
             * @brief This function returns a reference to member scs
             * @return Reference to member scs
             */
            eProsima_user_DllExport int32_t& scs();

            /*!
             * @brief This function sets a value in member brake_boost
             * @param _brake_boost New value for member brake_boost
             */
            eProsima_user_DllExport void brake_boost(
                    int32_t _brake_boost);

            /*!
             * @brief This function returns the value of member brake_boost
             * @return Value of member brake_boost
             */
            eProsima_user_DllExport int32_t brake_boost() const;

            /*!
             * @brief This function returns a reference to member brake_boost
             * @return Reference to member brake_boost
             */
            eProsima_user_DllExport int32_t& brake_boost();

            /*!
             * @brief This function sets a value in member aux_brakes
             * @param _aux_brakes New value for member aux_brakes
             */
            eProsima_user_DllExport void aux_brakes(
                    int32_t _aux_brakes);

            /*!
             * @brief This function returns the value of member aux_brakes
             * @return Value of member aux_brakes
             */
            eProsima_user_DllExport int32_t aux_brakes() const;

            /*!
             * @brief This function returns a reference to member aux_brakes
             * @return Reference to member aux_brakes
             */
            eProsima_user_DllExport int32_t& aux_brakes();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::Vehicle& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_vehicle_type;
            std::string m_vid;
            std::string m_vehicle_num;
            std::string m_oid;
            int32_t m_operation;
            double m_totalcurrent;
            double m_batterysoc;
            double m_totalvoltage;
            double m_recharge;
            int32_t m_dcdc;
            uint32_t m_resistance;
            std::vector<uint8_t> m_seats;
            int32_t m_servicemode;
            std::vector<int32_t> m_seat_belt;
            int32_t m_engine_status;
            double m_battery_voltage;
            double m_battery_ammeter;
            double m_battery_consumption;
            double m_battery_probe;
            std::vector<double> m_battery_temperatures;
            double m_battery_h_tepemperatures;
            double m_battery_ltepemperatures;
            double m_battery_probe_code;
            double m_battery_h_concentration;
            double m_battery_c_sensor_code;
            double m_battery_stress;
            double m_battery_s_sensor_code;
            double m_battery_h_dc_dc;
            double m_battery_capacity;
            double m_airconditioning_idx;
            double m_airconditioning_status;
            int32_t m_airconditioning_model;
            int32_t m_airconditioning_volume;
            int32_t m_airconditioning_defrost;
            std::vector<int32_t> m_door_status;
            double m_rsrp;
            double m_sinr;
            double m_uspeed;
            double m_dspeed;
            double m_loss;
            uint32_t m_delay;
            uint8_t m_refrigeration_idx;
            int32_t m_refrigeration_status;
            double m_refrigeration_stemp;
            double m_refrigeration_ctemp;
            uint8_t m_driving_motor_idx;
            uint8_t m_driving_motor_status;
            double m_driving_motor_ctemp;
            uint8_t m_driving_motor_rspeed;
            double m_driving_motor_torque;
            double m_driving_motor_etemp;
            double m_driving_motor_voltage;
            double m_driving_motor_ammeter;
            int32_t m_outline_lamp_status;
            int32_t m_warning_lamp_status;
            int32_t m_parking_lamp_status;
            int32_t m_interior_lamp_status;
            int32_t m_ambient_lamp_status;
            int32_t m_welcome_lamp_status;
            int32_t m_backlight_lamp_status;
            int32_t m_positionlight_lamp_status;
            int32_t m_brakelamp_lamp_status;
            int32_t m_backuplamp_lamp_status;
            int8_t m_length;
            int8_t m_width;
            int8_t m_height;
            int32_t m_traction;
            int32_t m_abs;
            int32_t m_scs;
            int32_t m_brake_boost;
            int32_t m_aux_brakes;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLE_H_

