// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleConfig.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleConfig.h"
#include "VehicleConfigTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_VehicleParam_max_cdr_typesize 608ULL;
#define ros2_interface_msg_VehicleConfig_max_cdr_typesize 880ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_VehicleParam_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_VehicleConfig_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleConfig::VehicleConfig()
{
    // ros2_interface::msg::Header m_header

    // ros2_interface::msg::VehicleParam m_vehicle_param


    // Just to register all known types
    registerVehicleConfigTypes();
}

ros2_interface::msg::VehicleConfig::~VehicleConfig()
{


}

ros2_interface::msg::VehicleConfig::VehicleConfig(
        const VehicleConfig& x)
{
    m_header = x.m_header;
    m_vehicle_param = x.m_vehicle_param;
}

ros2_interface::msg::VehicleConfig::VehicleConfig(
        VehicleConfig&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_vehicle_param = std::move(x.m_vehicle_param);
}

ros2_interface::msg::VehicleConfig& ros2_interface::msg::VehicleConfig::operator =(
        const VehicleConfig& x)
{

    m_header = x.m_header;
    m_vehicle_param = x.m_vehicle_param;

    return *this;
}

ros2_interface::msg::VehicleConfig& ros2_interface::msg::VehicleConfig::operator =(
        VehicleConfig&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_vehicle_param = std::move(x.m_vehicle_param);

    return *this;
}

bool ros2_interface::msg::VehicleConfig::operator ==(
        const VehicleConfig& x) const
{

    return (m_header == x.m_header && m_vehicle_param == x.m_vehicle_param);
}

bool ros2_interface::msg::VehicleConfig::operator !=(
        const VehicleConfig& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleConfig::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleConfig_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleConfig::getCdrSerializedSize(
        const ros2_interface::msg::VehicleConfig& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += ros2_interface::msg::VehicleParam::getCdrSerializedSize(data.vehicle_param(), current_alignment);

    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleConfig::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_vehicle_param;

}

void ros2_interface::msg::VehicleConfig::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_vehicle_param;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::VehicleConfig::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::VehicleConfig::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::VehicleConfig::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::VehicleConfig::header()
{
    return m_header;
}
/*!
 * @brief This function copies the value in member vehicle_param
 * @param _vehicle_param New value to be copied in member vehicle_param
 */
void ros2_interface::msg::VehicleConfig::vehicle_param(
        const ros2_interface::msg::VehicleParam& _vehicle_param)
{
    m_vehicle_param = _vehicle_param;
}

/*!
 * @brief This function moves the value in member vehicle_param
 * @param _vehicle_param New value to be moved in member vehicle_param
 */
void ros2_interface::msg::VehicleConfig::vehicle_param(
        ros2_interface::msg::VehicleParam&& _vehicle_param)
{
    m_vehicle_param = std::move(_vehicle_param);
}

/*!
 * @brief This function returns a constant reference to member vehicle_param
 * @return Constant reference to member vehicle_param
 */
const ros2_interface::msg::VehicleParam& ros2_interface::msg::VehicleConfig::vehicle_param() const
{
    return m_vehicle_param;
}

/*!
 * @brief This function returns a reference to member vehicle_param
 * @return Reference to member vehicle_param
 */
ros2_interface::msg::VehicleParam& ros2_interface::msg::VehicleConfig::vehicle_param()
{
    return m_vehicle_param;
}


size_t ros2_interface::msg::VehicleConfig::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleConfig_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleConfig::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleConfig::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



