// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleMotion.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleMotion.h"
#include "VehicleMotionTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_VehicleMotionPoint_max_cdr_typesize 160ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_VehicleMotion_max_cdr_typesize 16264ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_VehicleMotionPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_VehicleMotion_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleMotion::VehicleMotion()
{
    // string m_name
    m_name ="";
    // sequence<ros2_interface::msg::VehicleMotionPoint> m_vehicle_motion_point


    // Just to register all known types
    registerVehicleMotionTypes();
}

ros2_interface::msg::VehicleMotion::~VehicleMotion()
{


}

ros2_interface::msg::VehicleMotion::VehicleMotion(
        const VehicleMotion& x)
{
    m_name = x.m_name;
    m_vehicle_motion_point = x.m_vehicle_motion_point;
}

ros2_interface::msg::VehicleMotion::VehicleMotion(
        VehicleMotion&& x) noexcept 
{
    m_name = std::move(x.m_name);
    m_vehicle_motion_point = std::move(x.m_vehicle_motion_point);
}

ros2_interface::msg::VehicleMotion& ros2_interface::msg::VehicleMotion::operator =(
        const VehicleMotion& x)
{

    m_name = x.m_name;
    m_vehicle_motion_point = x.m_vehicle_motion_point;

    return *this;
}

ros2_interface::msg::VehicleMotion& ros2_interface::msg::VehicleMotion::operator =(
        VehicleMotion&& x) noexcept
{

    m_name = std::move(x.m_name);
    m_vehicle_motion_point = std::move(x.m_vehicle_motion_point);

    return *this;
}

bool ros2_interface::msg::VehicleMotion::operator ==(
        const VehicleMotion& x) const
{

    return (m_name == x.m_name && m_vehicle_motion_point == x.m_vehicle_motion_point);
}

bool ros2_interface::msg::VehicleMotion::operator !=(
        const VehicleMotion& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleMotion::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleMotion_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleMotion::getCdrSerializedSize(
        const ros2_interface::msg::VehicleMotion& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.name().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    for(size_t a = 0; a < data.vehicle_motion_point().size(); ++a)
    {
        current_alignment += ros2_interface::msg::VehicleMotionPoint::getCdrSerializedSize(data.vehicle_motion_point().at(a), current_alignment);}


    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleMotion::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_name.c_str();
    scdr << m_vehicle_motion_point;

}

void ros2_interface::msg::VehicleMotion::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_name;
    dcdr >> m_vehicle_motion_point;
}

/*!
 * @brief This function copies the value in member name
 * @param _name New value to be copied in member name
 */
void ros2_interface::msg::VehicleMotion::name(
        const std::string& _name)
{
    m_name = _name;
}

/*!
 * @brief This function moves the value in member name
 * @param _name New value to be moved in member name
 */
void ros2_interface::msg::VehicleMotion::name(
        std::string&& _name)
{
    m_name = std::move(_name);
}

/*!
 * @brief This function returns a constant reference to member name
 * @return Constant reference to member name
 */
const std::string& ros2_interface::msg::VehicleMotion::name() const
{
    return m_name;
}

/*!
 * @brief This function returns a reference to member name
 * @return Reference to member name
 */
std::string& ros2_interface::msg::VehicleMotion::name()
{
    return m_name;
}
/*!
 * @brief This function copies the value in member vehicle_motion_point
 * @param _vehicle_motion_point New value to be copied in member vehicle_motion_point
 */
void ros2_interface::msg::VehicleMotion::vehicle_motion_point(
        const std::vector<ros2_interface::msg::VehicleMotionPoint>& _vehicle_motion_point)
{
    m_vehicle_motion_point = _vehicle_motion_point;
}

/*!
 * @brief This function moves the value in member vehicle_motion_point
 * @param _vehicle_motion_point New value to be moved in member vehicle_motion_point
 */
void ros2_interface::msg::VehicleMotion::vehicle_motion_point(
        std::vector<ros2_interface::msg::VehicleMotionPoint>&& _vehicle_motion_point)
{
    m_vehicle_motion_point = std::move(_vehicle_motion_point);
}

/*!
 * @brief This function returns a constant reference to member vehicle_motion_point
 * @return Constant reference to member vehicle_motion_point
 */
const std::vector<ros2_interface::msg::VehicleMotionPoint>& ros2_interface::msg::VehicleMotion::vehicle_motion_point() const
{
    return m_vehicle_motion_point;
}

/*!
 * @brief This function returns a reference to member vehicle_motion_point
 * @return Reference to member vehicle_motion_point
 */
std::vector<ros2_interface::msg::VehicleMotionPoint>& ros2_interface::msg::VehicleMotion::vehicle_motion_point()
{
    return m_vehicle_motion_point;
}


size_t ros2_interface::msg::VehicleMotion::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleMotion_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleMotion::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleMotion::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



