// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleMotion.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEMOTION_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEMOTION_H_

#include "VehicleMotionPoint.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(VEHICLEMOTION_SOURCE)
#define VEHICLEMOTION_DllAPI __declspec( dllexport )
#else
#define VEHICLEMOTION_DllAPI __declspec( dllimport )
#endif // VEHICLEMOTION_SOURCE
#else
#define VEHICLEMOTION_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define VEHICLEMOTION_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure VehicleMotion defined by the user in the IDL file.
         * @ingroup VehicleMotion
         */
        class VehicleMotion
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport VehicleMotion();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~VehicleMotion();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleMotion that will be copied.
             */
            eProsima_user_DllExport VehicleMotion(
                    const VehicleMotion& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleMotion that will be copied.
             */
            eProsima_user_DllExport VehicleMotion(
                    VehicleMotion&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleMotion that will be copied.
             */
            eProsima_user_DllExport VehicleMotion& operator =(
                    const VehicleMotion& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleMotion that will be copied.
             */
            eProsima_user_DllExport VehicleMotion& operator =(
                    VehicleMotion&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleMotion object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const VehicleMotion& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleMotion object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const VehicleMotion& x) const;

            /*!
             * @brief This function copies the value in member name
             * @param _name New value to be copied in member name
             */
            eProsima_user_DllExport void name(
                    const std::string& _name);

            /*!
             * @brief This function moves the value in member name
             * @param _name New value to be moved in member name
             */
            eProsima_user_DllExport void name(
                    std::string&& _name);

            /*!
             * @brief This function returns a constant reference to member name
             * @return Constant reference to member name
             */
            eProsima_user_DllExport const std::string& name() const;

            /*!
             * @brief This function returns a reference to member name
             * @return Reference to member name
             */
            eProsima_user_DllExport std::string& name();
            /*!
             * @brief This function copies the value in member vehicle_motion_point
             * @param _vehicle_motion_point New value to be copied in member vehicle_motion_point
             */
            eProsima_user_DllExport void vehicle_motion_point(
                    const std::vector<ros2_interface::msg::VehicleMotionPoint>& _vehicle_motion_point);

            /*!
             * @brief This function moves the value in member vehicle_motion_point
             * @param _vehicle_motion_point New value to be moved in member vehicle_motion_point
             */
            eProsima_user_DllExport void vehicle_motion_point(
                    std::vector<ros2_interface::msg::VehicleMotionPoint>&& _vehicle_motion_point);

            /*!
             * @brief This function returns a constant reference to member vehicle_motion_point
             * @return Constant reference to member vehicle_motion_point
             */
            eProsima_user_DllExport const std::vector<ros2_interface::msg::VehicleMotionPoint>& vehicle_motion_point() const;

            /*!
             * @brief This function returns a reference to member vehicle_motion_point
             * @return Reference to member vehicle_motion_point
             */
            eProsima_user_DllExport std::vector<ros2_interface::msg::VehicleMotionPoint>& vehicle_motion_point();

            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::VehicleMotion& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::string m_name;
            std::vector<ros2_interface::msg::VehicleMotionPoint> m_vehicle_motion_point;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEMOTION_H_

