// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleMotionPoint.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleMotionPoint.h"
#include "VehicleMotionPointTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_VehicleMotionPoint_max_cdr_typesize 160ULL;
#define ros2_interface_msg_TrajectoryPoint_max_cdr_typesize 148ULL;
#define ros2_interface_msg_PathPoint_max_cdr_typesize 88ULL;
#define ros2_interface_msg_VehicleMotionPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_TrajectoryPoint_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PathPoint_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleMotionPoint::VehicleMotionPoint()
{
    // ros2_interface::msg::TrajectoryPoint m_trajectory_point

    // double m_steer
    m_steer = 0.0;

    // Just to register all known types
    registerVehicleMotionPointTypes();
}

ros2_interface::msg::VehicleMotionPoint::~VehicleMotionPoint()
{


}

ros2_interface::msg::VehicleMotionPoint::VehicleMotionPoint(
        const VehicleMotionPoint& x)
{
    m_trajectory_point = x.m_trajectory_point;
    m_steer = x.m_steer;
}

ros2_interface::msg::VehicleMotionPoint::VehicleMotionPoint(
        VehicleMotionPoint&& x) noexcept 
{
    m_trajectory_point = std::move(x.m_trajectory_point);
    m_steer = x.m_steer;
}

ros2_interface::msg::VehicleMotionPoint& ros2_interface::msg::VehicleMotionPoint::operator =(
        const VehicleMotionPoint& x)
{

    m_trajectory_point = x.m_trajectory_point;
    m_steer = x.m_steer;

    return *this;
}

ros2_interface::msg::VehicleMotionPoint& ros2_interface::msg::VehicleMotionPoint::operator =(
        VehicleMotionPoint&& x) noexcept
{

    m_trajectory_point = std::move(x.m_trajectory_point);
    m_steer = x.m_steer;

    return *this;
}

bool ros2_interface::msg::VehicleMotionPoint::operator ==(
        const VehicleMotionPoint& x) const
{

    return (m_trajectory_point == x.m_trajectory_point && m_steer == x.m_steer);
}

bool ros2_interface::msg::VehicleMotionPoint::operator !=(
        const VehicleMotionPoint& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleMotionPoint::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleMotionPoint_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleMotionPoint::getCdrSerializedSize(
        const ros2_interface::msg::VehicleMotionPoint& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::TrajectoryPoint::getCdrSerializedSize(data.trajectory_point(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleMotionPoint::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_trajectory_point;
    scdr << m_steer;

}

void ros2_interface::msg::VehicleMotionPoint::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_trajectory_point;
    dcdr >> m_steer;
}

/*!
 * @brief This function copies the value in member trajectory_point
 * @param _trajectory_point New value to be copied in member trajectory_point
 */
void ros2_interface::msg::VehicleMotionPoint::trajectory_point(
        const ros2_interface::msg::TrajectoryPoint& _trajectory_point)
{
    m_trajectory_point = _trajectory_point;
}

/*!
 * @brief This function moves the value in member trajectory_point
 * @param _trajectory_point New value to be moved in member trajectory_point
 */
void ros2_interface::msg::VehicleMotionPoint::trajectory_point(
        ros2_interface::msg::TrajectoryPoint&& _trajectory_point)
{
    m_trajectory_point = std::move(_trajectory_point);
}

/*!
 * @brief This function returns a constant reference to member trajectory_point
 * @return Constant reference to member trajectory_point
 */
const ros2_interface::msg::TrajectoryPoint& ros2_interface::msg::VehicleMotionPoint::trajectory_point() const
{
    return m_trajectory_point;
}

/*!
 * @brief This function returns a reference to member trajectory_point
 * @return Reference to member trajectory_point
 */
ros2_interface::msg::TrajectoryPoint& ros2_interface::msg::VehicleMotionPoint::trajectory_point()
{
    return m_trajectory_point;
}
/*!
 * @brief This function sets a value in member steer
 * @param _steer New value for member steer
 */
void ros2_interface::msg::VehicleMotionPoint::steer(
        double _steer)
{
    m_steer = _steer;
}

/*!
 * @brief This function returns the value of member steer
 * @return Value of member steer
 */
double ros2_interface::msg::VehicleMotionPoint::steer() const
{
    return m_steer;
}

/*!
 * @brief This function returns a reference to member steer
 * @return Reference to member steer
 */
double& ros2_interface::msg::VehicleMotionPoint::steer()
{
    return m_steer;
}



size_t ros2_interface::msg::VehicleMotionPoint::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleMotionPoint_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleMotionPoint::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleMotionPoint::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



