// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleMotionPointTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "VehicleMotionPoint.h"
#include "VehicleMotionPointTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerVehicleMotionPointTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(true),
                        ros2_interface::msg::GetPathPointObject(true));
                factory->add_type_object("ros2_interface::msg::PathPoint", ros2_interface::msg::GetPathPointIdentifier(false),
                        ros2_interface::msg::GetPathPointObject(false));



                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(true),
                        ros2_interface::msg::GetTrajectoryPointObject(true));
                factory->add_type_object("ros2_interface::msg::TrajectoryPoint", ros2_interface::msg::GetTrajectoryPointIdentifier(false),
                        ros2_interface::msg::GetTrajectoryPointObject(false));



                factory->add_type_object("ros2_interface::msg::VehicleMotionPoint", ros2_interface::msg::GetVehicleMotionPointIdentifier(true),
                        ros2_interface::msg::GetVehicleMotionPointObject(true));
                factory->add_type_object("ros2_interface::msg::VehicleMotionPoint", ros2_interface::msg::GetVehicleMotionPointIdentifier(false),
                        ros2_interface::msg::GetVehicleMotionPointObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetVehicleMotionPointIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("VehicleMotionPoint", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetVehicleMotionPointObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("VehicleMotionPoint", complete);
        }

        const TypeObject* GetVehicleMotionPointObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleMotionPoint", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteVehicleMotionPointObject();
            }
            //else
            return GetMinimalVehicleMotionPointObject();
        }

        const TypeObject* GetMinimalVehicleMotionPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleMotionPoint", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_trajectory_point;
            mst_trajectory_point.common().member_id(memberId++);
            mst_trajectory_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_trajectory_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_trajectory_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_trajectory_point.common().member_flags().IS_OPTIONAL(false);
            mst_trajectory_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_trajectory_point.common().member_flags().IS_KEY(false);
            mst_trajectory_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_trajectory_point.common().member_type_id(*ros2_interface::msg::GetTrajectoryPointIdentifier(false));
            MD5 trajectory_point_hash("trajectory_point");
            for(int i = 0; i < 4; ++i)
            {
                mst_trajectory_point.detail().name_hash()[i] = trajectory_point_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_trajectory_point);

            MinimalStructMember mst_steer;
            mst_steer.common().member_id(memberId++);
            mst_steer.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steer.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steer.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steer.common().member_flags().IS_OPTIONAL(false);
            mst_steer.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steer.common().member_flags().IS_KEY(false);
            mst_steer.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steer.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steer_hash("steer");
            for(int i = 0; i < 4; ++i)
            {
                mst_steer.detail().name_hash()[i] = steer_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steer);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleMotionPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleMotionPoint", false);
        }

        const TypeObject* GetCompleteVehicleMotionPointObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleMotionPoint", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_trajectory_point;
            cst_trajectory_point.common().member_id(memberId++);
            cst_trajectory_point.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_trajectory_point.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_trajectory_point.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_trajectory_point.common().member_flags().IS_OPTIONAL(false);
            cst_trajectory_point.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_trajectory_point.common().member_flags().IS_KEY(false);
            cst_trajectory_point.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_trajectory_point.common().member_type_id(*ros2_interface::msg::GetTrajectoryPointIdentifier(true));
            cst_trajectory_point.detail().name("trajectory_point");

            type_object->complete().struct_type().member_seq().emplace_back(cst_trajectory_point);

            CompleteStructMember cst_steer;
            cst_steer.common().member_id(memberId++);
            cst_steer.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steer.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steer.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steer.common().member_flags().IS_OPTIONAL(false);
            cst_steer.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steer.common().member_flags().IS_KEY(false);
            cst_steer.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steer.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steer.detail().name("steer");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steer);


            // Header
            type_object->complete().struct_type().header().detail().type_name("VehicleMotionPoint");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleMotionPoint", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleMotionPoint", true);
        }

    } // namespace msg
} // namespace ros2_interface