// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleParam.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleParam.h"
#include "VehicleParamTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_VehicleParam_max_cdr_typesize 608ULL;
#define ros2_interface_msg_VehicleParam_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleParam::VehicleParam()
{
    // string m_brand
    m_brand ="";
    // long m_steer_mode
    m_steer_mode = 0;
    // double m_length
    m_length = 0.0;
    // double m_width
    m_width = 0.0;
    // double m_height
    m_height = 0.0;
    // double m_mass_fl
    m_mass_fl = 0.0;
    // double m_mass_fr
    m_mass_fr = 0.0;
    // double m_mass_rl
    m_mass_rl = 0.0;
    // double m_mass_rr
    m_mass_rr = 0.0;
    // double m_wheel_radius
    m_wheel_radius = 0.0;
    // double m_wheelbase
    m_wheelbase = 0.0;
    // double m_front_edge_to_center
    m_front_edge_to_center = 0.0;
    // double m_back_edge_to_center
    m_back_edge_to_center = 0.0;
    // double m_lf
    m_lf = 0.0;
    // double m_lr
    m_lr = 0.0;
    // double m_cf
    m_cf = 0.0;
    // double m_cr
    m_cr = 0.0;
    // double m_steer_ratio
    m_steer_ratio = 0.0;
    // double m_rolling_coefficient
    m_rolling_coefficient = 0.0;
    // double m_air_density
    m_air_density = 0.0;
    // double m_air_damping_coefficient
    m_air_damping_coefficient = 0.0;
    // double m_max_front_steer_angle
    m_max_front_steer_angle = 0.0;
    // double m_min_front_steer_angle
    m_min_front_steer_angle = 0.0;
    // double m_max_rear_steer_angle
    m_max_rear_steer_angle = 0.0;
    // double m_min_rear_steer_angle
    m_min_rear_steer_angle = 0.0;
    // double m_speed_limit
    m_speed_limit = 0.0;
    // double m_max_brake_value
    m_max_brake_value = 0.0;
    // double m_min_brake_value
    m_min_brake_value = 0.0;
    // double m_max_accel_value
    m_max_accel_value = 0.0;
    // double m_min_accel_value
    m_min_accel_value = 0.0;
    // double m_speed_deadzone
    m_speed_deadzone = 0.0;
    // double m_standstill_acceleration
    m_standstill_acceleration = 0.0;
    // double m_max_front_steer_angle_rate
    m_max_front_steer_angle_rate = 0.0;
    // double m_max_rear_steer_angle_rate
    m_max_rear_steer_angle_rate = 0.0;
    // double m_max_abs_speed_when_stopped
    m_max_abs_speed_when_stopped = 0.0;
    // double m_max_abs_speed_when_stopped_duration
    m_max_abs_speed_when_stopped_duration = 0.0;
    // double m_brake_value_when_gear_transitioning
    m_brake_value_when_gear_transitioning = 0.0;
    // double m_accel_deadzone
    m_accel_deadzone = 0.0;
    // double m_brake_deadzone
    m_brake_deadzone = 0.0;
    // double m_acceleration_in_idle
    m_acceleration_in_idle = 0.0;
    // double m_deceleration_in_idle
    m_deceleration_in_idle = 0.0;
    // double m_max_acceleration_jerk
    m_max_acceleration_jerk = 0.0;
    // double m_max_acceleration
    m_max_acceleration = 0.0;
    // double m_max_deceleration
    m_max_deceleration = 0.0;
    // double m_min_turning_radius
    m_min_turning_radius = 0.0;

    // Just to register all known types
    registerVehicleParamTypes();
}

ros2_interface::msg::VehicleParam::~VehicleParam()
{













































}

ros2_interface::msg::VehicleParam::VehicleParam(
        const VehicleParam& x)
{
    m_brand = x.m_brand;
    m_steer_mode = x.m_steer_mode;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_mass_fl = x.m_mass_fl;
    m_mass_fr = x.m_mass_fr;
    m_mass_rl = x.m_mass_rl;
    m_mass_rr = x.m_mass_rr;
    m_wheel_radius = x.m_wheel_radius;
    m_wheelbase = x.m_wheelbase;
    m_front_edge_to_center = x.m_front_edge_to_center;
    m_back_edge_to_center = x.m_back_edge_to_center;
    m_lf = x.m_lf;
    m_lr = x.m_lr;
    m_cf = x.m_cf;
    m_cr = x.m_cr;
    m_steer_ratio = x.m_steer_ratio;
    m_rolling_coefficient = x.m_rolling_coefficient;
    m_air_density = x.m_air_density;
    m_air_damping_coefficient = x.m_air_damping_coefficient;
    m_max_front_steer_angle = x.m_max_front_steer_angle;
    m_min_front_steer_angle = x.m_min_front_steer_angle;
    m_max_rear_steer_angle = x.m_max_rear_steer_angle;
    m_min_rear_steer_angle = x.m_min_rear_steer_angle;
    m_speed_limit = x.m_speed_limit;
    m_max_brake_value = x.m_max_brake_value;
    m_min_brake_value = x.m_min_brake_value;
    m_max_accel_value = x.m_max_accel_value;
    m_min_accel_value = x.m_min_accel_value;
    m_speed_deadzone = x.m_speed_deadzone;
    m_standstill_acceleration = x.m_standstill_acceleration;
    m_max_front_steer_angle_rate = x.m_max_front_steer_angle_rate;
    m_max_rear_steer_angle_rate = x.m_max_rear_steer_angle_rate;
    m_max_abs_speed_when_stopped = x.m_max_abs_speed_when_stopped;
    m_max_abs_speed_when_stopped_duration = x.m_max_abs_speed_when_stopped_duration;
    m_brake_value_when_gear_transitioning = x.m_brake_value_when_gear_transitioning;
    m_accel_deadzone = x.m_accel_deadzone;
    m_brake_deadzone = x.m_brake_deadzone;
    m_acceleration_in_idle = x.m_acceleration_in_idle;
    m_deceleration_in_idle = x.m_deceleration_in_idle;
    m_max_acceleration_jerk = x.m_max_acceleration_jerk;
    m_max_acceleration = x.m_max_acceleration;
    m_max_deceleration = x.m_max_deceleration;
    m_min_turning_radius = x.m_min_turning_radius;
}

ros2_interface::msg::VehicleParam::VehicleParam(
        VehicleParam&& x) noexcept 
{
    m_brand = std::move(x.m_brand);
    m_steer_mode = x.m_steer_mode;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_mass_fl = x.m_mass_fl;
    m_mass_fr = x.m_mass_fr;
    m_mass_rl = x.m_mass_rl;
    m_mass_rr = x.m_mass_rr;
    m_wheel_radius = x.m_wheel_radius;
    m_wheelbase = x.m_wheelbase;
    m_front_edge_to_center = x.m_front_edge_to_center;
    m_back_edge_to_center = x.m_back_edge_to_center;
    m_lf = x.m_lf;
    m_lr = x.m_lr;
    m_cf = x.m_cf;
    m_cr = x.m_cr;
    m_steer_ratio = x.m_steer_ratio;
    m_rolling_coefficient = x.m_rolling_coefficient;
    m_air_density = x.m_air_density;
    m_air_damping_coefficient = x.m_air_damping_coefficient;
    m_max_front_steer_angle = x.m_max_front_steer_angle;
    m_min_front_steer_angle = x.m_min_front_steer_angle;
    m_max_rear_steer_angle = x.m_max_rear_steer_angle;
    m_min_rear_steer_angle = x.m_min_rear_steer_angle;
    m_speed_limit = x.m_speed_limit;
    m_max_brake_value = x.m_max_brake_value;
    m_min_brake_value = x.m_min_brake_value;
    m_max_accel_value = x.m_max_accel_value;
    m_min_accel_value = x.m_min_accel_value;
    m_speed_deadzone = x.m_speed_deadzone;
    m_standstill_acceleration = x.m_standstill_acceleration;
    m_max_front_steer_angle_rate = x.m_max_front_steer_angle_rate;
    m_max_rear_steer_angle_rate = x.m_max_rear_steer_angle_rate;
    m_max_abs_speed_when_stopped = x.m_max_abs_speed_when_stopped;
    m_max_abs_speed_when_stopped_duration = x.m_max_abs_speed_when_stopped_duration;
    m_brake_value_when_gear_transitioning = x.m_brake_value_when_gear_transitioning;
    m_accel_deadzone = x.m_accel_deadzone;
    m_brake_deadzone = x.m_brake_deadzone;
    m_acceleration_in_idle = x.m_acceleration_in_idle;
    m_deceleration_in_idle = x.m_deceleration_in_idle;
    m_max_acceleration_jerk = x.m_max_acceleration_jerk;
    m_max_acceleration = x.m_max_acceleration;
    m_max_deceleration = x.m_max_deceleration;
    m_min_turning_radius = x.m_min_turning_radius;
}

ros2_interface::msg::VehicleParam& ros2_interface::msg::VehicleParam::operator =(
        const VehicleParam& x)
{

    m_brand = x.m_brand;
    m_steer_mode = x.m_steer_mode;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_mass_fl = x.m_mass_fl;
    m_mass_fr = x.m_mass_fr;
    m_mass_rl = x.m_mass_rl;
    m_mass_rr = x.m_mass_rr;
    m_wheel_radius = x.m_wheel_radius;
    m_wheelbase = x.m_wheelbase;
    m_front_edge_to_center = x.m_front_edge_to_center;
    m_back_edge_to_center = x.m_back_edge_to_center;
    m_lf = x.m_lf;
    m_lr = x.m_lr;
    m_cf = x.m_cf;
    m_cr = x.m_cr;
    m_steer_ratio = x.m_steer_ratio;
    m_rolling_coefficient = x.m_rolling_coefficient;
    m_air_density = x.m_air_density;
    m_air_damping_coefficient = x.m_air_damping_coefficient;
    m_max_front_steer_angle = x.m_max_front_steer_angle;
    m_min_front_steer_angle = x.m_min_front_steer_angle;
    m_max_rear_steer_angle = x.m_max_rear_steer_angle;
    m_min_rear_steer_angle = x.m_min_rear_steer_angle;
    m_speed_limit = x.m_speed_limit;
    m_max_brake_value = x.m_max_brake_value;
    m_min_brake_value = x.m_min_brake_value;
    m_max_accel_value = x.m_max_accel_value;
    m_min_accel_value = x.m_min_accel_value;
    m_speed_deadzone = x.m_speed_deadzone;
    m_standstill_acceleration = x.m_standstill_acceleration;
    m_max_front_steer_angle_rate = x.m_max_front_steer_angle_rate;
    m_max_rear_steer_angle_rate = x.m_max_rear_steer_angle_rate;
    m_max_abs_speed_when_stopped = x.m_max_abs_speed_when_stopped;
    m_max_abs_speed_when_stopped_duration = x.m_max_abs_speed_when_stopped_duration;
    m_brake_value_when_gear_transitioning = x.m_brake_value_when_gear_transitioning;
    m_accel_deadzone = x.m_accel_deadzone;
    m_brake_deadzone = x.m_brake_deadzone;
    m_acceleration_in_idle = x.m_acceleration_in_idle;
    m_deceleration_in_idle = x.m_deceleration_in_idle;
    m_max_acceleration_jerk = x.m_max_acceleration_jerk;
    m_max_acceleration = x.m_max_acceleration;
    m_max_deceleration = x.m_max_deceleration;
    m_min_turning_radius = x.m_min_turning_radius;

    return *this;
}

ros2_interface::msg::VehicleParam& ros2_interface::msg::VehicleParam::operator =(
        VehicleParam&& x) noexcept
{

    m_brand = std::move(x.m_brand);
    m_steer_mode = x.m_steer_mode;
    m_length = x.m_length;
    m_width = x.m_width;
    m_height = x.m_height;
    m_mass_fl = x.m_mass_fl;
    m_mass_fr = x.m_mass_fr;
    m_mass_rl = x.m_mass_rl;
    m_mass_rr = x.m_mass_rr;
    m_wheel_radius = x.m_wheel_radius;
    m_wheelbase = x.m_wheelbase;
    m_front_edge_to_center = x.m_front_edge_to_center;
    m_back_edge_to_center = x.m_back_edge_to_center;
    m_lf = x.m_lf;
    m_lr = x.m_lr;
    m_cf = x.m_cf;
    m_cr = x.m_cr;
    m_steer_ratio = x.m_steer_ratio;
    m_rolling_coefficient = x.m_rolling_coefficient;
    m_air_density = x.m_air_density;
    m_air_damping_coefficient = x.m_air_damping_coefficient;
    m_max_front_steer_angle = x.m_max_front_steer_angle;
    m_min_front_steer_angle = x.m_min_front_steer_angle;
    m_max_rear_steer_angle = x.m_max_rear_steer_angle;
    m_min_rear_steer_angle = x.m_min_rear_steer_angle;
    m_speed_limit = x.m_speed_limit;
    m_max_brake_value = x.m_max_brake_value;
    m_min_brake_value = x.m_min_brake_value;
    m_max_accel_value = x.m_max_accel_value;
    m_min_accel_value = x.m_min_accel_value;
    m_speed_deadzone = x.m_speed_deadzone;
    m_standstill_acceleration = x.m_standstill_acceleration;
    m_max_front_steer_angle_rate = x.m_max_front_steer_angle_rate;
    m_max_rear_steer_angle_rate = x.m_max_rear_steer_angle_rate;
    m_max_abs_speed_when_stopped = x.m_max_abs_speed_when_stopped;
    m_max_abs_speed_when_stopped_duration = x.m_max_abs_speed_when_stopped_duration;
    m_brake_value_when_gear_transitioning = x.m_brake_value_when_gear_transitioning;
    m_accel_deadzone = x.m_accel_deadzone;
    m_brake_deadzone = x.m_brake_deadzone;
    m_acceleration_in_idle = x.m_acceleration_in_idle;
    m_deceleration_in_idle = x.m_deceleration_in_idle;
    m_max_acceleration_jerk = x.m_max_acceleration_jerk;
    m_max_acceleration = x.m_max_acceleration;
    m_max_deceleration = x.m_max_deceleration;
    m_min_turning_radius = x.m_min_turning_radius;

    return *this;
}

bool ros2_interface::msg::VehicleParam::operator ==(
        const VehicleParam& x) const
{

    return (m_brand == x.m_brand && m_steer_mode == x.m_steer_mode && m_length == x.m_length && m_width == x.m_width && m_height == x.m_height && m_mass_fl == x.m_mass_fl && m_mass_fr == x.m_mass_fr && m_mass_rl == x.m_mass_rl && m_mass_rr == x.m_mass_rr && m_wheel_radius == x.m_wheel_radius && m_wheelbase == x.m_wheelbase && m_front_edge_to_center == x.m_front_edge_to_center && m_back_edge_to_center == x.m_back_edge_to_center && m_lf == x.m_lf && m_lr == x.m_lr && m_cf == x.m_cf && m_cr == x.m_cr && m_steer_ratio == x.m_steer_ratio && m_rolling_coefficient == x.m_rolling_coefficient && m_air_density == x.m_air_density && m_air_damping_coefficient == x.m_air_damping_coefficient && m_max_front_steer_angle == x.m_max_front_steer_angle && m_min_front_steer_angle == x.m_min_front_steer_angle && m_max_rear_steer_angle == x.m_max_rear_steer_angle && m_min_rear_steer_angle == x.m_min_rear_steer_angle && m_speed_limit == x.m_speed_limit && m_max_brake_value == x.m_max_brake_value && m_min_brake_value == x.m_min_brake_value && m_max_accel_value == x.m_max_accel_value && m_min_accel_value == x.m_min_accel_value && m_speed_deadzone == x.m_speed_deadzone && m_standstill_acceleration == x.m_standstill_acceleration && m_max_front_steer_angle_rate == x.m_max_front_steer_angle_rate && m_max_rear_steer_angle_rate == x.m_max_rear_steer_angle_rate && m_max_abs_speed_when_stopped == x.m_max_abs_speed_when_stopped && m_max_abs_speed_when_stopped_duration == x.m_max_abs_speed_when_stopped_duration && m_brake_value_when_gear_transitioning == x.m_brake_value_when_gear_transitioning && m_accel_deadzone == x.m_accel_deadzone && m_brake_deadzone == x.m_brake_deadzone && m_acceleration_in_idle == x.m_acceleration_in_idle && m_deceleration_in_idle == x.m_deceleration_in_idle && m_max_acceleration_jerk == x.m_max_acceleration_jerk && m_max_acceleration == x.m_max_acceleration && m_max_deceleration == x.m_max_deceleration && m_min_turning_radius == x.m_min_turning_radius);
}

bool ros2_interface::msg::VehicleParam::operator !=(
        const VehicleParam& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleParam::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleParam_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleParam::getCdrSerializedSize(
        const ros2_interface::msg::VehicleParam& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4) + data.brand().size() + 1;

    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleParam::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_brand.c_str();
    scdr << m_steer_mode;
    scdr << m_length;
    scdr << m_width;
    scdr << m_height;
    scdr << m_mass_fl;
    scdr << m_mass_fr;
    scdr << m_mass_rl;
    scdr << m_mass_rr;
    scdr << m_wheel_radius;
    scdr << m_wheelbase;
    scdr << m_front_edge_to_center;
    scdr << m_back_edge_to_center;
    scdr << m_lf;
    scdr << m_lr;
    scdr << m_cf;
    scdr << m_cr;
    scdr << m_steer_ratio;
    scdr << m_rolling_coefficient;
    scdr << m_air_density;
    scdr << m_air_damping_coefficient;
    scdr << m_max_front_steer_angle;
    scdr << m_min_front_steer_angle;
    scdr << m_max_rear_steer_angle;
    scdr << m_min_rear_steer_angle;
    scdr << m_speed_limit;
    scdr << m_max_brake_value;
    scdr << m_min_brake_value;
    scdr << m_max_accel_value;
    scdr << m_min_accel_value;
    scdr << m_speed_deadzone;
    scdr << m_standstill_acceleration;
    scdr << m_max_front_steer_angle_rate;
    scdr << m_max_rear_steer_angle_rate;
    scdr << m_max_abs_speed_when_stopped;
    scdr << m_max_abs_speed_when_stopped_duration;
    scdr << m_brake_value_when_gear_transitioning;
    scdr << m_accel_deadzone;
    scdr << m_brake_deadzone;
    scdr << m_acceleration_in_idle;
    scdr << m_deceleration_in_idle;
    scdr << m_max_acceleration_jerk;
    scdr << m_max_acceleration;
    scdr << m_max_deceleration;
    scdr << m_min_turning_radius;

}

void ros2_interface::msg::VehicleParam::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_brand;
    dcdr >> m_steer_mode;
    dcdr >> m_length;
    dcdr >> m_width;
    dcdr >> m_height;
    dcdr >> m_mass_fl;
    dcdr >> m_mass_fr;
    dcdr >> m_mass_rl;
    dcdr >> m_mass_rr;
    dcdr >> m_wheel_radius;
    dcdr >> m_wheelbase;
    dcdr >> m_front_edge_to_center;
    dcdr >> m_back_edge_to_center;
    dcdr >> m_lf;
    dcdr >> m_lr;
    dcdr >> m_cf;
    dcdr >> m_cr;
    dcdr >> m_steer_ratio;
    dcdr >> m_rolling_coefficient;
    dcdr >> m_air_density;
    dcdr >> m_air_damping_coefficient;
    dcdr >> m_max_front_steer_angle;
    dcdr >> m_min_front_steer_angle;
    dcdr >> m_max_rear_steer_angle;
    dcdr >> m_min_rear_steer_angle;
    dcdr >> m_speed_limit;
    dcdr >> m_max_brake_value;
    dcdr >> m_min_brake_value;
    dcdr >> m_max_accel_value;
    dcdr >> m_min_accel_value;
    dcdr >> m_speed_deadzone;
    dcdr >> m_standstill_acceleration;
    dcdr >> m_max_front_steer_angle_rate;
    dcdr >> m_max_rear_steer_angle_rate;
    dcdr >> m_max_abs_speed_when_stopped;
    dcdr >> m_max_abs_speed_when_stopped_duration;
    dcdr >> m_brake_value_when_gear_transitioning;
    dcdr >> m_accel_deadzone;
    dcdr >> m_brake_deadzone;
    dcdr >> m_acceleration_in_idle;
    dcdr >> m_deceleration_in_idle;
    dcdr >> m_max_acceleration_jerk;
    dcdr >> m_max_acceleration;
    dcdr >> m_max_deceleration;
    dcdr >> m_min_turning_radius;
}

/*!
 * @brief This function copies the value in member brand
 * @param _brand New value to be copied in member brand
 */
void ros2_interface::msg::VehicleParam::brand(
        const std::string& _brand)
{
    m_brand = _brand;
}

/*!
 * @brief This function moves the value in member brand
 * @param _brand New value to be moved in member brand
 */
void ros2_interface::msg::VehicleParam::brand(
        std::string&& _brand)
{
    m_brand = std::move(_brand);
}

/*!
 * @brief This function returns a constant reference to member brand
 * @return Constant reference to member brand
 */
const std::string& ros2_interface::msg::VehicleParam::brand() const
{
    return m_brand;
}

/*!
 * @brief This function returns a reference to member brand
 * @return Reference to member brand
 */
std::string& ros2_interface::msg::VehicleParam::brand()
{
    return m_brand;
}
/*!
 * @brief This function sets a value in member steer_mode
 * @param _steer_mode New value for member steer_mode
 */
void ros2_interface::msg::VehicleParam::steer_mode(
        int32_t _steer_mode)
{
    m_steer_mode = _steer_mode;
}

/*!
 * @brief This function returns the value of member steer_mode
 * @return Value of member steer_mode
 */
int32_t ros2_interface::msg::VehicleParam::steer_mode() const
{
    return m_steer_mode;
}

/*!
 * @brief This function returns a reference to member steer_mode
 * @return Reference to member steer_mode
 */
int32_t& ros2_interface::msg::VehicleParam::steer_mode()
{
    return m_steer_mode;
}

/*!
 * @brief This function sets a value in member length
 * @param _length New value for member length
 */
void ros2_interface::msg::VehicleParam::length(
        double _length)
{
    m_length = _length;
}

/*!
 * @brief This function returns the value of member length
 * @return Value of member length
 */
double ros2_interface::msg::VehicleParam::length() const
{
    return m_length;
}

/*!
 * @brief This function returns a reference to member length
 * @return Reference to member length
 */
double& ros2_interface::msg::VehicleParam::length()
{
    return m_length;
}

/*!
 * @brief This function sets a value in member width
 * @param _width New value for member width
 */
void ros2_interface::msg::VehicleParam::width(
        double _width)
{
    m_width = _width;
}

/*!
 * @brief This function returns the value of member width
 * @return Value of member width
 */
double ros2_interface::msg::VehicleParam::width() const
{
    return m_width;
}

/*!
 * @brief This function returns a reference to member width
 * @return Reference to member width
 */
double& ros2_interface::msg::VehicleParam::width()
{
    return m_width;
}

/*!
 * @brief This function sets a value in member height
 * @param _height New value for member height
 */
void ros2_interface::msg::VehicleParam::height(
        double _height)
{
    m_height = _height;
}

/*!
 * @brief This function returns the value of member height
 * @return Value of member height
 */
double ros2_interface::msg::VehicleParam::height() const
{
    return m_height;
}

/*!
 * @brief This function returns a reference to member height
 * @return Reference to member height
 */
double& ros2_interface::msg::VehicleParam::height()
{
    return m_height;
}

/*!
 * @brief This function sets a value in member mass_fl
 * @param _mass_fl New value for member mass_fl
 */
void ros2_interface::msg::VehicleParam::mass_fl(
        double _mass_fl)
{
    m_mass_fl = _mass_fl;
}

/*!
 * @brief This function returns the value of member mass_fl
 * @return Value of member mass_fl
 */
double ros2_interface::msg::VehicleParam::mass_fl() const
{
    return m_mass_fl;
}

/*!
 * @brief This function returns a reference to member mass_fl
 * @return Reference to member mass_fl
 */
double& ros2_interface::msg::VehicleParam::mass_fl()
{
    return m_mass_fl;
}

/*!
 * @brief This function sets a value in member mass_fr
 * @param _mass_fr New value for member mass_fr
 */
void ros2_interface::msg::VehicleParam::mass_fr(
        double _mass_fr)
{
    m_mass_fr = _mass_fr;
}

/*!
 * @brief This function returns the value of member mass_fr
 * @return Value of member mass_fr
 */
double ros2_interface::msg::VehicleParam::mass_fr() const
{
    return m_mass_fr;
}

/*!
 * @brief This function returns a reference to member mass_fr
 * @return Reference to member mass_fr
 */
double& ros2_interface::msg::VehicleParam::mass_fr()
{
    return m_mass_fr;
}

/*!
 * @brief This function sets a value in member mass_rl
 * @param _mass_rl New value for member mass_rl
 */
void ros2_interface::msg::VehicleParam::mass_rl(
        double _mass_rl)
{
    m_mass_rl = _mass_rl;
}

/*!
 * @brief This function returns the value of member mass_rl
 * @return Value of member mass_rl
 */
double ros2_interface::msg::VehicleParam::mass_rl() const
{
    return m_mass_rl;
}

/*!
 * @brief This function returns a reference to member mass_rl
 * @return Reference to member mass_rl
 */
double& ros2_interface::msg::VehicleParam::mass_rl()
{
    return m_mass_rl;
}

/*!
 * @brief This function sets a value in member mass_rr
 * @param _mass_rr New value for member mass_rr
 */
void ros2_interface::msg::VehicleParam::mass_rr(
        double _mass_rr)
{
    m_mass_rr = _mass_rr;
}

/*!
 * @brief This function returns the value of member mass_rr
 * @return Value of member mass_rr
 */
double ros2_interface::msg::VehicleParam::mass_rr() const
{
    return m_mass_rr;
}

/*!
 * @brief This function returns a reference to member mass_rr
 * @return Reference to member mass_rr
 */
double& ros2_interface::msg::VehicleParam::mass_rr()
{
    return m_mass_rr;
}

/*!
 * @brief This function sets a value in member wheel_radius
 * @param _wheel_radius New value for member wheel_radius
 */
void ros2_interface::msg::VehicleParam::wheel_radius(
        double _wheel_radius)
{
    m_wheel_radius = _wheel_radius;
}

/*!
 * @brief This function returns the value of member wheel_radius
 * @return Value of member wheel_radius
 */
double ros2_interface::msg::VehicleParam::wheel_radius() const
{
    return m_wheel_radius;
}

/*!
 * @brief This function returns a reference to member wheel_radius
 * @return Reference to member wheel_radius
 */
double& ros2_interface::msg::VehicleParam::wheel_radius()
{
    return m_wheel_radius;
}

/*!
 * @brief This function sets a value in member wheelbase
 * @param _wheelbase New value for member wheelbase
 */
void ros2_interface::msg::VehicleParam::wheelbase(
        double _wheelbase)
{
    m_wheelbase = _wheelbase;
}

/*!
 * @brief This function returns the value of member wheelbase
 * @return Value of member wheelbase
 */
double ros2_interface::msg::VehicleParam::wheelbase() const
{
    return m_wheelbase;
}

/*!
 * @brief This function returns a reference to member wheelbase
 * @return Reference to member wheelbase
 */
double& ros2_interface::msg::VehicleParam::wheelbase()
{
    return m_wheelbase;
}

/*!
 * @brief This function sets a value in member front_edge_to_center
 * @param _front_edge_to_center New value for member front_edge_to_center
 */
void ros2_interface::msg::VehicleParam::front_edge_to_center(
        double _front_edge_to_center)
{
    m_front_edge_to_center = _front_edge_to_center;
}

/*!
 * @brief This function returns the value of member front_edge_to_center
 * @return Value of member front_edge_to_center
 */
double ros2_interface::msg::VehicleParam::front_edge_to_center() const
{
    return m_front_edge_to_center;
}

/*!
 * @brief This function returns a reference to member front_edge_to_center
 * @return Reference to member front_edge_to_center
 */
double& ros2_interface::msg::VehicleParam::front_edge_to_center()
{
    return m_front_edge_to_center;
}

/*!
 * @brief This function sets a value in member back_edge_to_center
 * @param _back_edge_to_center New value for member back_edge_to_center
 */
void ros2_interface::msg::VehicleParam::back_edge_to_center(
        double _back_edge_to_center)
{
    m_back_edge_to_center = _back_edge_to_center;
}

/*!
 * @brief This function returns the value of member back_edge_to_center
 * @return Value of member back_edge_to_center
 */
double ros2_interface::msg::VehicleParam::back_edge_to_center() const
{
    return m_back_edge_to_center;
}

/*!
 * @brief This function returns a reference to member back_edge_to_center
 * @return Reference to member back_edge_to_center
 */
double& ros2_interface::msg::VehicleParam::back_edge_to_center()
{
    return m_back_edge_to_center;
}

/*!
 * @brief This function sets a value in member lf
 * @param _lf New value for member lf
 */
void ros2_interface::msg::VehicleParam::lf(
        double _lf)
{
    m_lf = _lf;
}

/*!
 * @brief This function returns the value of member lf
 * @return Value of member lf
 */
double ros2_interface::msg::VehicleParam::lf() const
{
    return m_lf;
}

/*!
 * @brief This function returns a reference to member lf
 * @return Reference to member lf
 */
double& ros2_interface::msg::VehicleParam::lf()
{
    return m_lf;
}

/*!
 * @brief This function sets a value in member lr
 * @param _lr New value for member lr
 */
void ros2_interface::msg::VehicleParam::lr(
        double _lr)
{
    m_lr = _lr;
}

/*!
 * @brief This function returns the value of member lr
 * @return Value of member lr
 */
double ros2_interface::msg::VehicleParam::lr() const
{
    return m_lr;
}

/*!
 * @brief This function returns a reference to member lr
 * @return Reference to member lr
 */
double& ros2_interface::msg::VehicleParam::lr()
{
    return m_lr;
}

/*!
 * @brief This function sets a value in member cf
 * @param _cf New value for member cf
 */
void ros2_interface::msg::VehicleParam::cf(
        double _cf)
{
    m_cf = _cf;
}

/*!
 * @brief This function returns the value of member cf
 * @return Value of member cf
 */
double ros2_interface::msg::VehicleParam::cf() const
{
    return m_cf;
}

/*!
 * @brief This function returns a reference to member cf
 * @return Reference to member cf
 */
double& ros2_interface::msg::VehicleParam::cf()
{
    return m_cf;
}

/*!
 * @brief This function sets a value in member cr
 * @param _cr New value for member cr
 */
void ros2_interface::msg::VehicleParam::cr(
        double _cr)
{
    m_cr = _cr;
}

/*!
 * @brief This function returns the value of member cr
 * @return Value of member cr
 */
double ros2_interface::msg::VehicleParam::cr() const
{
    return m_cr;
}

/*!
 * @brief This function returns a reference to member cr
 * @return Reference to member cr
 */
double& ros2_interface::msg::VehicleParam::cr()
{
    return m_cr;
}

/*!
 * @brief This function sets a value in member steer_ratio
 * @param _steer_ratio New value for member steer_ratio
 */
void ros2_interface::msg::VehicleParam::steer_ratio(
        double _steer_ratio)
{
    m_steer_ratio = _steer_ratio;
}

/*!
 * @brief This function returns the value of member steer_ratio
 * @return Value of member steer_ratio
 */
double ros2_interface::msg::VehicleParam::steer_ratio() const
{
    return m_steer_ratio;
}

/*!
 * @brief This function returns a reference to member steer_ratio
 * @return Reference to member steer_ratio
 */
double& ros2_interface::msg::VehicleParam::steer_ratio()
{
    return m_steer_ratio;
}

/*!
 * @brief This function sets a value in member rolling_coefficient
 * @param _rolling_coefficient New value for member rolling_coefficient
 */
void ros2_interface::msg::VehicleParam::rolling_coefficient(
        double _rolling_coefficient)
{
    m_rolling_coefficient = _rolling_coefficient;
}

/*!
 * @brief This function returns the value of member rolling_coefficient
 * @return Value of member rolling_coefficient
 */
double ros2_interface::msg::VehicleParam::rolling_coefficient() const
{
    return m_rolling_coefficient;
}

/*!
 * @brief This function returns a reference to member rolling_coefficient
 * @return Reference to member rolling_coefficient
 */
double& ros2_interface::msg::VehicleParam::rolling_coefficient()
{
    return m_rolling_coefficient;
}

/*!
 * @brief This function sets a value in member air_density
 * @param _air_density New value for member air_density
 */
void ros2_interface::msg::VehicleParam::air_density(
        double _air_density)
{
    m_air_density = _air_density;
}

/*!
 * @brief This function returns the value of member air_density
 * @return Value of member air_density
 */
double ros2_interface::msg::VehicleParam::air_density() const
{
    return m_air_density;
}

/*!
 * @brief This function returns a reference to member air_density
 * @return Reference to member air_density
 */
double& ros2_interface::msg::VehicleParam::air_density()
{
    return m_air_density;
}

/*!
 * @brief This function sets a value in member air_damping_coefficient
 * @param _air_damping_coefficient New value for member air_damping_coefficient
 */
void ros2_interface::msg::VehicleParam::air_damping_coefficient(
        double _air_damping_coefficient)
{
    m_air_damping_coefficient = _air_damping_coefficient;
}

/*!
 * @brief This function returns the value of member air_damping_coefficient
 * @return Value of member air_damping_coefficient
 */
double ros2_interface::msg::VehicleParam::air_damping_coefficient() const
{
    return m_air_damping_coefficient;
}

/*!
 * @brief This function returns a reference to member air_damping_coefficient
 * @return Reference to member air_damping_coefficient
 */
double& ros2_interface::msg::VehicleParam::air_damping_coefficient()
{
    return m_air_damping_coefficient;
}

/*!
 * @brief This function sets a value in member max_front_steer_angle
 * @param _max_front_steer_angle New value for member max_front_steer_angle
 */
void ros2_interface::msg::VehicleParam::max_front_steer_angle(
        double _max_front_steer_angle)
{
    m_max_front_steer_angle = _max_front_steer_angle;
}

/*!
 * @brief This function returns the value of member max_front_steer_angle
 * @return Value of member max_front_steer_angle
 */
double ros2_interface::msg::VehicleParam::max_front_steer_angle() const
{
    return m_max_front_steer_angle;
}

/*!
 * @brief This function returns a reference to member max_front_steer_angle
 * @return Reference to member max_front_steer_angle
 */
double& ros2_interface::msg::VehicleParam::max_front_steer_angle()
{
    return m_max_front_steer_angle;
}

/*!
 * @brief This function sets a value in member min_front_steer_angle
 * @param _min_front_steer_angle New value for member min_front_steer_angle
 */
void ros2_interface::msg::VehicleParam::min_front_steer_angle(
        double _min_front_steer_angle)
{
    m_min_front_steer_angle = _min_front_steer_angle;
}

/*!
 * @brief This function returns the value of member min_front_steer_angle
 * @return Value of member min_front_steer_angle
 */
double ros2_interface::msg::VehicleParam::min_front_steer_angle() const
{
    return m_min_front_steer_angle;
}

/*!
 * @brief This function returns a reference to member min_front_steer_angle
 * @return Reference to member min_front_steer_angle
 */
double& ros2_interface::msg::VehicleParam::min_front_steer_angle()
{
    return m_min_front_steer_angle;
}

/*!
 * @brief This function sets a value in member max_rear_steer_angle
 * @param _max_rear_steer_angle New value for member max_rear_steer_angle
 */
void ros2_interface::msg::VehicleParam::max_rear_steer_angle(
        double _max_rear_steer_angle)
{
    m_max_rear_steer_angle = _max_rear_steer_angle;
}

/*!
 * @brief This function returns the value of member max_rear_steer_angle
 * @return Value of member max_rear_steer_angle
 */
double ros2_interface::msg::VehicleParam::max_rear_steer_angle() const
{
    return m_max_rear_steer_angle;
}

/*!
 * @brief This function returns a reference to member max_rear_steer_angle
 * @return Reference to member max_rear_steer_angle
 */
double& ros2_interface::msg::VehicleParam::max_rear_steer_angle()
{
    return m_max_rear_steer_angle;
}

/*!
 * @brief This function sets a value in member min_rear_steer_angle
 * @param _min_rear_steer_angle New value for member min_rear_steer_angle
 */
void ros2_interface::msg::VehicleParam::min_rear_steer_angle(
        double _min_rear_steer_angle)
{
    m_min_rear_steer_angle = _min_rear_steer_angle;
}

/*!
 * @brief This function returns the value of member min_rear_steer_angle
 * @return Value of member min_rear_steer_angle
 */
double ros2_interface::msg::VehicleParam::min_rear_steer_angle() const
{
    return m_min_rear_steer_angle;
}

/*!
 * @brief This function returns a reference to member min_rear_steer_angle
 * @return Reference to member min_rear_steer_angle
 */
double& ros2_interface::msg::VehicleParam::min_rear_steer_angle()
{
    return m_min_rear_steer_angle;
}

/*!
 * @brief This function sets a value in member speed_limit
 * @param _speed_limit New value for member speed_limit
 */
void ros2_interface::msg::VehicleParam::speed_limit(
        double _speed_limit)
{
    m_speed_limit = _speed_limit;
}

/*!
 * @brief This function returns the value of member speed_limit
 * @return Value of member speed_limit
 */
double ros2_interface::msg::VehicleParam::speed_limit() const
{
    return m_speed_limit;
}

/*!
 * @brief This function returns a reference to member speed_limit
 * @return Reference to member speed_limit
 */
double& ros2_interface::msg::VehicleParam::speed_limit()
{
    return m_speed_limit;
}

/*!
 * @brief This function sets a value in member max_brake_value
 * @param _max_brake_value New value for member max_brake_value
 */
void ros2_interface::msg::VehicleParam::max_brake_value(
        double _max_brake_value)
{
    m_max_brake_value = _max_brake_value;
}

/*!
 * @brief This function returns the value of member max_brake_value
 * @return Value of member max_brake_value
 */
double ros2_interface::msg::VehicleParam::max_brake_value() const
{
    return m_max_brake_value;
}

/*!
 * @brief This function returns a reference to member max_brake_value
 * @return Reference to member max_brake_value
 */
double& ros2_interface::msg::VehicleParam::max_brake_value()
{
    return m_max_brake_value;
}

/*!
 * @brief This function sets a value in member min_brake_value
 * @param _min_brake_value New value for member min_brake_value
 */
void ros2_interface::msg::VehicleParam::min_brake_value(
        double _min_brake_value)
{
    m_min_brake_value = _min_brake_value;
}

/*!
 * @brief This function returns the value of member min_brake_value
 * @return Value of member min_brake_value
 */
double ros2_interface::msg::VehicleParam::min_brake_value() const
{
    return m_min_brake_value;
}

/*!
 * @brief This function returns a reference to member min_brake_value
 * @return Reference to member min_brake_value
 */
double& ros2_interface::msg::VehicleParam::min_brake_value()
{
    return m_min_brake_value;
}

/*!
 * @brief This function sets a value in member max_accel_value
 * @param _max_accel_value New value for member max_accel_value
 */
void ros2_interface::msg::VehicleParam::max_accel_value(
        double _max_accel_value)
{
    m_max_accel_value = _max_accel_value;
}

/*!
 * @brief This function returns the value of member max_accel_value
 * @return Value of member max_accel_value
 */
double ros2_interface::msg::VehicleParam::max_accel_value() const
{
    return m_max_accel_value;
}

/*!
 * @brief This function returns a reference to member max_accel_value
 * @return Reference to member max_accel_value
 */
double& ros2_interface::msg::VehicleParam::max_accel_value()
{
    return m_max_accel_value;
}

/*!
 * @brief This function sets a value in member min_accel_value
 * @param _min_accel_value New value for member min_accel_value
 */
void ros2_interface::msg::VehicleParam::min_accel_value(
        double _min_accel_value)
{
    m_min_accel_value = _min_accel_value;
}

/*!
 * @brief This function returns the value of member min_accel_value
 * @return Value of member min_accel_value
 */
double ros2_interface::msg::VehicleParam::min_accel_value() const
{
    return m_min_accel_value;
}

/*!
 * @brief This function returns a reference to member min_accel_value
 * @return Reference to member min_accel_value
 */
double& ros2_interface::msg::VehicleParam::min_accel_value()
{
    return m_min_accel_value;
}

/*!
 * @brief This function sets a value in member speed_deadzone
 * @param _speed_deadzone New value for member speed_deadzone
 */
void ros2_interface::msg::VehicleParam::speed_deadzone(
        double _speed_deadzone)
{
    m_speed_deadzone = _speed_deadzone;
}

/*!
 * @brief This function returns the value of member speed_deadzone
 * @return Value of member speed_deadzone
 */
double ros2_interface::msg::VehicleParam::speed_deadzone() const
{
    return m_speed_deadzone;
}

/*!
 * @brief This function returns a reference to member speed_deadzone
 * @return Reference to member speed_deadzone
 */
double& ros2_interface::msg::VehicleParam::speed_deadzone()
{
    return m_speed_deadzone;
}

/*!
 * @brief This function sets a value in member standstill_acceleration
 * @param _standstill_acceleration New value for member standstill_acceleration
 */
void ros2_interface::msg::VehicleParam::standstill_acceleration(
        double _standstill_acceleration)
{
    m_standstill_acceleration = _standstill_acceleration;
}

/*!
 * @brief This function returns the value of member standstill_acceleration
 * @return Value of member standstill_acceleration
 */
double ros2_interface::msg::VehicleParam::standstill_acceleration() const
{
    return m_standstill_acceleration;
}

/*!
 * @brief This function returns a reference to member standstill_acceleration
 * @return Reference to member standstill_acceleration
 */
double& ros2_interface::msg::VehicleParam::standstill_acceleration()
{
    return m_standstill_acceleration;
}

/*!
 * @brief This function sets a value in member max_front_steer_angle_rate
 * @param _max_front_steer_angle_rate New value for member max_front_steer_angle_rate
 */
void ros2_interface::msg::VehicleParam::max_front_steer_angle_rate(
        double _max_front_steer_angle_rate)
{
    m_max_front_steer_angle_rate = _max_front_steer_angle_rate;
}

/*!
 * @brief This function returns the value of member max_front_steer_angle_rate
 * @return Value of member max_front_steer_angle_rate
 */
double ros2_interface::msg::VehicleParam::max_front_steer_angle_rate() const
{
    return m_max_front_steer_angle_rate;
}

/*!
 * @brief This function returns a reference to member max_front_steer_angle_rate
 * @return Reference to member max_front_steer_angle_rate
 */
double& ros2_interface::msg::VehicleParam::max_front_steer_angle_rate()
{
    return m_max_front_steer_angle_rate;
}

/*!
 * @brief This function sets a value in member max_rear_steer_angle_rate
 * @param _max_rear_steer_angle_rate New value for member max_rear_steer_angle_rate
 */
void ros2_interface::msg::VehicleParam::max_rear_steer_angle_rate(
        double _max_rear_steer_angle_rate)
{
    m_max_rear_steer_angle_rate = _max_rear_steer_angle_rate;
}

/*!
 * @brief This function returns the value of member max_rear_steer_angle_rate
 * @return Value of member max_rear_steer_angle_rate
 */
double ros2_interface::msg::VehicleParam::max_rear_steer_angle_rate() const
{
    return m_max_rear_steer_angle_rate;
}

/*!
 * @brief This function returns a reference to member max_rear_steer_angle_rate
 * @return Reference to member max_rear_steer_angle_rate
 */
double& ros2_interface::msg::VehicleParam::max_rear_steer_angle_rate()
{
    return m_max_rear_steer_angle_rate;
}

/*!
 * @brief This function sets a value in member max_abs_speed_when_stopped
 * @param _max_abs_speed_when_stopped New value for member max_abs_speed_when_stopped
 */
void ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped(
        double _max_abs_speed_when_stopped)
{
    m_max_abs_speed_when_stopped = _max_abs_speed_when_stopped;
}

/*!
 * @brief This function returns the value of member max_abs_speed_when_stopped
 * @return Value of member max_abs_speed_when_stopped
 */
double ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped() const
{
    return m_max_abs_speed_when_stopped;
}

/*!
 * @brief This function returns a reference to member max_abs_speed_when_stopped
 * @return Reference to member max_abs_speed_when_stopped
 */
double& ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped()
{
    return m_max_abs_speed_when_stopped;
}

/*!
 * @brief This function sets a value in member max_abs_speed_when_stopped_duration
 * @param _max_abs_speed_when_stopped_duration New value for member max_abs_speed_when_stopped_duration
 */
void ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped_duration(
        double _max_abs_speed_when_stopped_duration)
{
    m_max_abs_speed_when_stopped_duration = _max_abs_speed_when_stopped_duration;
}

/*!
 * @brief This function returns the value of member max_abs_speed_when_stopped_duration
 * @return Value of member max_abs_speed_when_stopped_duration
 */
double ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped_duration() const
{
    return m_max_abs_speed_when_stopped_duration;
}

/*!
 * @brief This function returns a reference to member max_abs_speed_when_stopped_duration
 * @return Reference to member max_abs_speed_when_stopped_duration
 */
double& ros2_interface::msg::VehicleParam::max_abs_speed_when_stopped_duration()
{
    return m_max_abs_speed_when_stopped_duration;
}

/*!
 * @brief This function sets a value in member brake_value_when_gear_transitioning
 * @param _brake_value_when_gear_transitioning New value for member brake_value_when_gear_transitioning
 */
void ros2_interface::msg::VehicleParam::brake_value_when_gear_transitioning(
        double _brake_value_when_gear_transitioning)
{
    m_brake_value_when_gear_transitioning = _brake_value_when_gear_transitioning;
}

/*!
 * @brief This function returns the value of member brake_value_when_gear_transitioning
 * @return Value of member brake_value_when_gear_transitioning
 */
double ros2_interface::msg::VehicleParam::brake_value_when_gear_transitioning() const
{
    return m_brake_value_when_gear_transitioning;
}

/*!
 * @brief This function returns a reference to member brake_value_when_gear_transitioning
 * @return Reference to member brake_value_when_gear_transitioning
 */
double& ros2_interface::msg::VehicleParam::brake_value_when_gear_transitioning()
{
    return m_brake_value_when_gear_transitioning;
}

/*!
 * @brief This function sets a value in member accel_deadzone
 * @param _accel_deadzone New value for member accel_deadzone
 */
void ros2_interface::msg::VehicleParam::accel_deadzone(
        double _accel_deadzone)
{
    m_accel_deadzone = _accel_deadzone;
}

/*!
 * @brief This function returns the value of member accel_deadzone
 * @return Value of member accel_deadzone
 */
double ros2_interface::msg::VehicleParam::accel_deadzone() const
{
    return m_accel_deadzone;
}

/*!
 * @brief This function returns a reference to member accel_deadzone
 * @return Reference to member accel_deadzone
 */
double& ros2_interface::msg::VehicleParam::accel_deadzone()
{
    return m_accel_deadzone;
}

/*!
 * @brief This function sets a value in member brake_deadzone
 * @param _brake_deadzone New value for member brake_deadzone
 */
void ros2_interface::msg::VehicleParam::brake_deadzone(
        double _brake_deadzone)
{
    m_brake_deadzone = _brake_deadzone;
}

/*!
 * @brief This function returns the value of member brake_deadzone
 * @return Value of member brake_deadzone
 */
double ros2_interface::msg::VehicleParam::brake_deadzone() const
{
    return m_brake_deadzone;
}

/*!
 * @brief This function returns a reference to member brake_deadzone
 * @return Reference to member brake_deadzone
 */
double& ros2_interface::msg::VehicleParam::brake_deadzone()
{
    return m_brake_deadzone;
}

/*!
 * @brief This function sets a value in member acceleration_in_idle
 * @param _acceleration_in_idle New value for member acceleration_in_idle
 */
void ros2_interface::msg::VehicleParam::acceleration_in_idle(
        double _acceleration_in_idle)
{
    m_acceleration_in_idle = _acceleration_in_idle;
}

/*!
 * @brief This function returns the value of member acceleration_in_idle
 * @return Value of member acceleration_in_idle
 */
double ros2_interface::msg::VehicleParam::acceleration_in_idle() const
{
    return m_acceleration_in_idle;
}

/*!
 * @brief This function returns a reference to member acceleration_in_idle
 * @return Reference to member acceleration_in_idle
 */
double& ros2_interface::msg::VehicleParam::acceleration_in_idle()
{
    return m_acceleration_in_idle;
}

/*!
 * @brief This function sets a value in member deceleration_in_idle
 * @param _deceleration_in_idle New value for member deceleration_in_idle
 */
void ros2_interface::msg::VehicleParam::deceleration_in_idle(
        double _deceleration_in_idle)
{
    m_deceleration_in_idle = _deceleration_in_idle;
}

/*!
 * @brief This function returns the value of member deceleration_in_idle
 * @return Value of member deceleration_in_idle
 */
double ros2_interface::msg::VehicleParam::deceleration_in_idle() const
{
    return m_deceleration_in_idle;
}

/*!
 * @brief This function returns a reference to member deceleration_in_idle
 * @return Reference to member deceleration_in_idle
 */
double& ros2_interface::msg::VehicleParam::deceleration_in_idle()
{
    return m_deceleration_in_idle;
}

/*!
 * @brief This function sets a value in member max_acceleration_jerk
 * @param _max_acceleration_jerk New value for member max_acceleration_jerk
 */
void ros2_interface::msg::VehicleParam::max_acceleration_jerk(
        double _max_acceleration_jerk)
{
    m_max_acceleration_jerk = _max_acceleration_jerk;
}

/*!
 * @brief This function returns the value of member max_acceleration_jerk
 * @return Value of member max_acceleration_jerk
 */
double ros2_interface::msg::VehicleParam::max_acceleration_jerk() const
{
    return m_max_acceleration_jerk;
}

/*!
 * @brief This function returns a reference to member max_acceleration_jerk
 * @return Reference to member max_acceleration_jerk
 */
double& ros2_interface::msg::VehicleParam::max_acceleration_jerk()
{
    return m_max_acceleration_jerk;
}

/*!
 * @brief This function sets a value in member max_acceleration
 * @param _max_acceleration New value for member max_acceleration
 */
void ros2_interface::msg::VehicleParam::max_acceleration(
        double _max_acceleration)
{
    m_max_acceleration = _max_acceleration;
}

/*!
 * @brief This function returns the value of member max_acceleration
 * @return Value of member max_acceleration
 */
double ros2_interface::msg::VehicleParam::max_acceleration() const
{
    return m_max_acceleration;
}

/*!
 * @brief This function returns a reference to member max_acceleration
 * @return Reference to member max_acceleration
 */
double& ros2_interface::msg::VehicleParam::max_acceleration()
{
    return m_max_acceleration;
}

/*!
 * @brief This function sets a value in member max_deceleration
 * @param _max_deceleration New value for member max_deceleration
 */
void ros2_interface::msg::VehicleParam::max_deceleration(
        double _max_deceleration)
{
    m_max_deceleration = _max_deceleration;
}

/*!
 * @brief This function returns the value of member max_deceleration
 * @return Value of member max_deceleration
 */
double ros2_interface::msg::VehicleParam::max_deceleration() const
{
    return m_max_deceleration;
}

/*!
 * @brief This function returns a reference to member max_deceleration
 * @return Reference to member max_deceleration
 */
double& ros2_interface::msg::VehicleParam::max_deceleration()
{
    return m_max_deceleration;
}

/*!
 * @brief This function sets a value in member min_turning_radius
 * @param _min_turning_radius New value for member min_turning_radius
 */
void ros2_interface::msg::VehicleParam::min_turning_radius(
        double _min_turning_radius)
{
    m_min_turning_radius = _min_turning_radius;
}

/*!
 * @brief This function returns the value of member min_turning_radius
 * @return Value of member min_turning_radius
 */
double ros2_interface::msg::VehicleParam::min_turning_radius() const
{
    return m_min_turning_radius;
}

/*!
 * @brief This function returns a reference to member min_turning_radius
 * @return Reference to member min_turning_radius
 */
double& ros2_interface::msg::VehicleParam::min_turning_radius()
{
    return m_min_turning_radius;
}



size_t ros2_interface::msg::VehicleParam::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleParam_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleParam::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleParam::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



