// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleParam.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEPARAM_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEPARAM_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(VEHICLEPARAM_SOURCE)
#define VEHICLEPARAM_DllAPI __declspec( dllexport )
#else
#define VEHICLEPARAM_DllAPI __declspec( dllimport )
#endif // VEHICLEPARAM_SOURCE
#else
#define VEHICLEPARAM_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define VEHICLEPARAM_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure VehicleParam defined by the user in the IDL file.
         * @ingroup VehicleParam
         */
        class VehicleParam
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport VehicleParam();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~VehicleParam();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleParam that will be copied.
             */
            eProsima_user_DllExport VehicleParam(
                    const VehicleParam& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleParam that will be copied.
             */
            eProsima_user_DllExport VehicleParam(
                    VehicleParam&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleParam that will be copied.
             */
            eProsima_user_DllExport VehicleParam& operator =(
                    const VehicleParam& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleParam that will be copied.
             */
            eProsima_user_DllExport VehicleParam& operator =(
                    VehicleParam&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleParam object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const VehicleParam& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleParam object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const VehicleParam& x) const;

            /*!
             * @brief This function copies the value in member brand
             * @param _brand New value to be copied in member brand
             */
            eProsima_user_DllExport void brand(
                    const std::string& _brand);

            /*!
             * @brief This function moves the value in member brand
             * @param _brand New value to be moved in member brand
             */
            eProsima_user_DllExport void brand(
                    std::string&& _brand);

            /*!
             * @brief This function returns a constant reference to member brand
             * @return Constant reference to member brand
             */
            eProsima_user_DllExport const std::string& brand() const;

            /*!
             * @brief This function returns a reference to member brand
             * @return Reference to member brand
             */
            eProsima_user_DllExport std::string& brand();
            /*!
             * @brief This function sets a value in member steer_mode
             * @param _steer_mode New value for member steer_mode
             */
            eProsima_user_DllExport void steer_mode(
                    int32_t _steer_mode);

            /*!
             * @brief This function returns the value of member steer_mode
             * @return Value of member steer_mode
             */
            eProsima_user_DllExport int32_t steer_mode() const;

            /*!
             * @brief This function returns a reference to member steer_mode
             * @return Reference to member steer_mode
             */
            eProsima_user_DllExport int32_t& steer_mode();

            /*!
             * @brief This function sets a value in member length
             * @param _length New value for member length
             */
            eProsima_user_DllExport void length(
                    double _length);

            /*!
             * @brief This function returns the value of member length
             * @return Value of member length
             */
            eProsima_user_DllExport double length() const;

            /*!
             * @brief This function returns a reference to member length
             * @return Reference to member length
             */
            eProsima_user_DllExport double& length();

            /*!
             * @brief This function sets a value in member width
             * @param _width New value for member width
             */
            eProsima_user_DllExport void width(
                    double _width);

            /*!
             * @brief This function returns the value of member width
             * @return Value of member width
             */
            eProsima_user_DllExport double width() const;

            /*!
             * @brief This function returns a reference to member width
             * @return Reference to member width
             */
            eProsima_user_DllExport double& width();

            /*!
             * @brief This function sets a value in member height
             * @param _height New value for member height
             */
            eProsima_user_DllExport void height(
                    double _height);

            /*!
             * @brief This function returns the value of member height
             * @return Value of member height
             */
            eProsima_user_DllExport double height() const;

            /*!
             * @brief This function returns a reference to member height
             * @return Reference to member height
             */
            eProsima_user_DllExport double& height();

            /*!
             * @brief This function sets a value in member mass_fl
             * @param _mass_fl New value for member mass_fl
             */
            eProsima_user_DllExport void mass_fl(
                    double _mass_fl);

            /*!
             * @brief This function returns the value of member mass_fl
             * @return Value of member mass_fl
             */
            eProsima_user_DllExport double mass_fl() const;

            /*!
             * @brief This function returns a reference to member mass_fl
             * @return Reference to member mass_fl
             */
            eProsima_user_DllExport double& mass_fl();

            /*!
             * @brief This function sets a value in member mass_fr
             * @param _mass_fr New value for member mass_fr
             */
            eProsima_user_DllExport void mass_fr(
                    double _mass_fr);

            /*!
             * @brief This function returns the value of member mass_fr
             * @return Value of member mass_fr
             */
            eProsima_user_DllExport double mass_fr() const;

            /*!
             * @brief This function returns a reference to member mass_fr
             * @return Reference to member mass_fr
             */
            eProsima_user_DllExport double& mass_fr();

            /*!
             * @brief This function sets a value in member mass_rl
             * @param _mass_rl New value for member mass_rl
             */
            eProsima_user_DllExport void mass_rl(
                    double _mass_rl);

            /*!
             * @brief This function returns the value of member mass_rl
             * @return Value of member mass_rl
             */
            eProsima_user_DllExport double mass_rl() const;

            /*!
             * @brief This function returns a reference to member mass_rl
             * @return Reference to member mass_rl
             */
            eProsima_user_DllExport double& mass_rl();

            /*!
             * @brief This function sets a value in member mass_rr
             * @param _mass_rr New value for member mass_rr
             */
            eProsima_user_DllExport void mass_rr(
                    double _mass_rr);

            /*!
             * @brief This function returns the value of member mass_rr
             * @return Value of member mass_rr
             */
            eProsima_user_DllExport double mass_rr() const;

            /*!
             * @brief This function returns a reference to member mass_rr
             * @return Reference to member mass_rr
             */
            eProsima_user_DllExport double& mass_rr();

            /*!
             * @brief This function sets a value in member wheel_radius
             * @param _wheel_radius New value for member wheel_radius
             */
            eProsima_user_DllExport void wheel_radius(
                    double _wheel_radius);

            /*!
             * @brief This function returns the value of member wheel_radius
             * @return Value of member wheel_radius
             */
            eProsima_user_DllExport double wheel_radius() const;

            /*!
             * @brief This function returns a reference to member wheel_radius
             * @return Reference to member wheel_radius
             */
            eProsima_user_DllExport double& wheel_radius();

            /*!
             * @brief This function sets a value in member wheelbase
             * @param _wheelbase New value for member wheelbase
             */
            eProsima_user_DllExport void wheelbase(
                    double _wheelbase);

            /*!
             * @brief This function returns the value of member wheelbase
             * @return Value of member wheelbase
             */
            eProsima_user_DllExport double wheelbase() const;

            /*!
             * @brief This function returns a reference to member wheelbase
             * @return Reference to member wheelbase
             */
            eProsima_user_DllExport double& wheelbase();

            /*!
             * @brief This function sets a value in member front_edge_to_center
             * @param _front_edge_to_center New value for member front_edge_to_center
             */
            eProsima_user_DllExport void front_edge_to_center(
                    double _front_edge_to_center);

            /*!
             * @brief This function returns the value of member front_edge_to_center
             * @return Value of member front_edge_to_center
             */
            eProsima_user_DllExport double front_edge_to_center() const;

            /*!
             * @brief This function returns a reference to member front_edge_to_center
             * @return Reference to member front_edge_to_center
             */
            eProsima_user_DllExport double& front_edge_to_center();

            /*!
             * @brief This function sets a value in member back_edge_to_center
             * @param _back_edge_to_center New value for member back_edge_to_center
             */
            eProsima_user_DllExport void back_edge_to_center(
                    double _back_edge_to_center);

            /*!
             * @brief This function returns the value of member back_edge_to_center
             * @return Value of member back_edge_to_center
             */
            eProsima_user_DllExport double back_edge_to_center() const;

            /*!
             * @brief This function returns a reference to member back_edge_to_center
             * @return Reference to member back_edge_to_center
             */
            eProsima_user_DllExport double& back_edge_to_center();

            /*!
             * @brief This function sets a value in member lf
             * @param _lf New value for member lf
             */
            eProsima_user_DllExport void lf(
                    double _lf);

            /*!
             * @brief This function returns the value of member lf
             * @return Value of member lf
             */
            eProsima_user_DllExport double lf() const;

            /*!
             * @brief This function returns a reference to member lf
             * @return Reference to member lf
             */
            eProsima_user_DllExport double& lf();

            /*!
             * @brief This function sets a value in member lr
             * @param _lr New value for member lr
             */
            eProsima_user_DllExport void lr(
                    double _lr);

            /*!
             * @brief This function returns the value of member lr
             * @return Value of member lr
             */
            eProsima_user_DllExport double lr() const;

            /*!
             * @brief This function returns a reference to member lr
             * @return Reference to member lr
             */
            eProsima_user_DllExport double& lr();

            /*!
             * @brief This function sets a value in member cf
             * @param _cf New value for member cf
             */
            eProsima_user_DllExport void cf(
                    double _cf);

            /*!
             * @brief This function returns the value of member cf
             * @return Value of member cf
             */
            eProsima_user_DllExport double cf() const;

            /*!
             * @brief This function returns a reference to member cf
             * @return Reference to member cf
             */
            eProsima_user_DllExport double& cf();

            /*!
             * @brief This function sets a value in member cr
             * @param _cr New value for member cr
             */
            eProsima_user_DllExport void cr(
                    double _cr);

            /*!
             * @brief This function returns the value of member cr
             * @return Value of member cr
             */
            eProsima_user_DllExport double cr() const;

            /*!
             * @brief This function returns a reference to member cr
             * @return Reference to member cr
             */
            eProsima_user_DllExport double& cr();

            /*!
             * @brief This function sets a value in member steer_ratio
             * @param _steer_ratio New value for member steer_ratio
             */
            eProsima_user_DllExport void steer_ratio(
                    double _steer_ratio);

            /*!
             * @brief This function returns the value of member steer_ratio
             * @return Value of member steer_ratio
             */
            eProsima_user_DllExport double steer_ratio() const;

            /*!
             * @brief This function returns a reference to member steer_ratio
             * @return Reference to member steer_ratio
             */
            eProsima_user_DllExport double& steer_ratio();

            /*!
             * @brief This function sets a value in member rolling_coefficient
             * @param _rolling_coefficient New value for member rolling_coefficient
             */
            eProsima_user_DllExport void rolling_coefficient(
                    double _rolling_coefficient);

            /*!
             * @brief This function returns the value of member rolling_coefficient
             * @return Value of member rolling_coefficient
             */
            eProsima_user_DllExport double rolling_coefficient() const;

            /*!
             * @brief This function returns a reference to member rolling_coefficient
             * @return Reference to member rolling_coefficient
             */
            eProsima_user_DllExport double& rolling_coefficient();

            /*!
             * @brief This function sets a value in member air_density
             * @param _air_density New value for member air_density
             */
            eProsima_user_DllExport void air_density(
                    double _air_density);

            /*!
             * @brief This function returns the value of member air_density
             * @return Value of member air_density
             */
            eProsima_user_DllExport double air_density() const;

            /*!
             * @brief This function returns a reference to member air_density
             * @return Reference to member air_density
             */
            eProsima_user_DllExport double& air_density();

            /*!
             * @brief This function sets a value in member air_damping_coefficient
             * @param _air_damping_coefficient New value for member air_damping_coefficient
             */
            eProsima_user_DllExport void air_damping_coefficient(
                    double _air_damping_coefficient);

            /*!
             * @brief This function returns the value of member air_damping_coefficient
             * @return Value of member air_damping_coefficient
             */
            eProsima_user_DllExport double air_damping_coefficient() const;

            /*!
             * @brief This function returns a reference to member air_damping_coefficient
             * @return Reference to member air_damping_coefficient
             */
            eProsima_user_DllExport double& air_damping_coefficient();

            /*!
             * @brief This function sets a value in member max_front_steer_angle
             * @param _max_front_steer_angle New value for member max_front_steer_angle
             */
            eProsima_user_DllExport void max_front_steer_angle(
                    double _max_front_steer_angle);

            /*!
             * @brief This function returns the value of member max_front_steer_angle
             * @return Value of member max_front_steer_angle
             */
            eProsima_user_DllExport double max_front_steer_angle() const;

            /*!
             * @brief This function returns a reference to member max_front_steer_angle
             * @return Reference to member max_front_steer_angle
             */
            eProsima_user_DllExport double& max_front_steer_angle();

            /*!
             * @brief This function sets a value in member min_front_steer_angle
             * @param _min_front_steer_angle New value for member min_front_steer_angle
             */
            eProsima_user_DllExport void min_front_steer_angle(
                    double _min_front_steer_angle);

            /*!
             * @brief This function returns the value of member min_front_steer_angle
             * @return Value of member min_front_steer_angle
             */
            eProsima_user_DllExport double min_front_steer_angle() const;

            /*!
             * @brief This function returns a reference to member min_front_steer_angle
             * @return Reference to member min_front_steer_angle
             */
            eProsima_user_DllExport double& min_front_steer_angle();

            /*!
             * @brief This function sets a value in member max_rear_steer_angle
             * @param _max_rear_steer_angle New value for member max_rear_steer_angle
             */
            eProsima_user_DllExport void max_rear_steer_angle(
                    double _max_rear_steer_angle);

            /*!
             * @brief This function returns the value of member max_rear_steer_angle
             * @return Value of member max_rear_steer_angle
             */
            eProsima_user_DllExport double max_rear_steer_angle() const;

            /*!
             * @brief This function returns a reference to member max_rear_steer_angle
             * @return Reference to member max_rear_steer_angle
             */
            eProsima_user_DllExport double& max_rear_steer_angle();

            /*!
             * @brief This function sets a value in member min_rear_steer_angle
             * @param _min_rear_steer_angle New value for member min_rear_steer_angle
             */
            eProsima_user_DllExport void min_rear_steer_angle(
                    double _min_rear_steer_angle);

            /*!
             * @brief This function returns the value of member min_rear_steer_angle
             * @return Value of member min_rear_steer_angle
             */
            eProsima_user_DllExport double min_rear_steer_angle() const;

            /*!
             * @brief This function returns a reference to member min_rear_steer_angle
             * @return Reference to member min_rear_steer_angle
             */
            eProsima_user_DllExport double& min_rear_steer_angle();

            /*!
             * @brief This function sets a value in member speed_limit
             * @param _speed_limit New value for member speed_limit
             */
            eProsima_user_DllExport void speed_limit(
                    double _speed_limit);

            /*!
             * @brief This function returns the value of member speed_limit
             * @return Value of member speed_limit
             */
            eProsima_user_DllExport double speed_limit() const;

            /*!
             * @brief This function returns a reference to member speed_limit
             * @return Reference to member speed_limit
             */
            eProsima_user_DllExport double& speed_limit();

            /*!
             * @brief This function sets a value in member max_brake_value
             * @param _max_brake_value New value for member max_brake_value
             */
            eProsima_user_DllExport void max_brake_value(
                    double _max_brake_value);

            /*!
             * @brief This function returns the value of member max_brake_value
             * @return Value of member max_brake_value
             */
            eProsima_user_DllExport double max_brake_value() const;

            /*!
             * @brief This function returns a reference to member max_brake_value
             * @return Reference to member max_brake_value
             */
            eProsima_user_DllExport double& max_brake_value();

            /*!
             * @brief This function sets a value in member min_brake_value
             * @param _min_brake_value New value for member min_brake_value
             */
            eProsima_user_DllExport void min_brake_value(
                    double _min_brake_value);

            /*!
             * @brief This function returns the value of member min_brake_value
             * @return Value of member min_brake_value
             */
            eProsima_user_DllExport double min_brake_value() const;

            /*!
             * @brief This function returns a reference to member min_brake_value
             * @return Reference to member min_brake_value
             */
            eProsima_user_DllExport double& min_brake_value();

            /*!
             * @brief This function sets a value in member max_accel_value
             * @param _max_accel_value New value for member max_accel_value
             */
            eProsima_user_DllExport void max_accel_value(
                    double _max_accel_value);

            /*!
             * @brief This function returns the value of member max_accel_value
             * @return Value of member max_accel_value
             */
            eProsima_user_DllExport double max_accel_value() const;

            /*!
             * @brief This function returns a reference to member max_accel_value
             * @return Reference to member max_accel_value
             */
            eProsima_user_DllExport double& max_accel_value();

            /*!
             * @brief This function sets a value in member min_accel_value
             * @param _min_accel_value New value for member min_accel_value
             */
            eProsima_user_DllExport void min_accel_value(
                    double _min_accel_value);

            /*!
             * @brief This function returns the value of member min_accel_value
             * @return Value of member min_accel_value
             */
            eProsima_user_DllExport double min_accel_value() const;

            /*!
             * @brief This function returns a reference to member min_accel_value
             * @return Reference to member min_accel_value
             */
            eProsima_user_DllExport double& min_accel_value();

            /*!
             * @brief This function sets a value in member speed_deadzone
             * @param _speed_deadzone New value for member speed_deadzone
             */
            eProsima_user_DllExport void speed_deadzone(
                    double _speed_deadzone);

            /*!
             * @brief This function returns the value of member speed_deadzone
             * @return Value of member speed_deadzone
             */
            eProsima_user_DllExport double speed_deadzone() const;

            /*!
             * @brief This function returns a reference to member speed_deadzone
             * @return Reference to member speed_deadzone
             */
            eProsima_user_DllExport double& speed_deadzone();

            /*!
             * @brief This function sets a value in member standstill_acceleration
             * @param _standstill_acceleration New value for member standstill_acceleration
             */
            eProsima_user_DllExport void standstill_acceleration(
                    double _standstill_acceleration);

            /*!
             * @brief This function returns the value of member standstill_acceleration
             * @return Value of member standstill_acceleration
             */
            eProsima_user_DllExport double standstill_acceleration() const;

            /*!
             * @brief This function returns a reference to member standstill_acceleration
             * @return Reference to member standstill_acceleration
             */
            eProsima_user_DllExport double& standstill_acceleration();

            /*!
             * @brief This function sets a value in member max_front_steer_angle_rate
             * @param _max_front_steer_angle_rate New value for member max_front_steer_angle_rate
             */
            eProsima_user_DllExport void max_front_steer_angle_rate(
                    double _max_front_steer_angle_rate);

            /*!
             * @brief This function returns the value of member max_front_steer_angle_rate
             * @return Value of member max_front_steer_angle_rate
             */
            eProsima_user_DllExport double max_front_steer_angle_rate() const;

            /*!
             * @brief This function returns a reference to member max_front_steer_angle_rate
             * @return Reference to member max_front_steer_angle_rate
             */
            eProsima_user_DllExport double& max_front_steer_angle_rate();

            /*!
             * @brief This function sets a value in member max_rear_steer_angle_rate
             * @param _max_rear_steer_angle_rate New value for member max_rear_steer_angle_rate
             */
            eProsima_user_DllExport void max_rear_steer_angle_rate(
                    double _max_rear_steer_angle_rate);

            /*!
             * @brief This function returns the value of member max_rear_steer_angle_rate
             * @return Value of member max_rear_steer_angle_rate
             */
            eProsima_user_DllExport double max_rear_steer_angle_rate() const;

            /*!
             * @brief This function returns a reference to member max_rear_steer_angle_rate
             * @return Reference to member max_rear_steer_angle_rate
             */
            eProsima_user_DllExport double& max_rear_steer_angle_rate();

            /*!
             * @brief This function sets a value in member max_abs_speed_when_stopped
             * @param _max_abs_speed_when_stopped New value for member max_abs_speed_when_stopped
             */
            eProsima_user_DllExport void max_abs_speed_when_stopped(
                    double _max_abs_speed_when_stopped);

            /*!
             * @brief This function returns the value of member max_abs_speed_when_stopped
             * @return Value of member max_abs_speed_when_stopped
             */
            eProsima_user_DllExport double max_abs_speed_when_stopped() const;

            /*!
             * @brief This function returns a reference to member max_abs_speed_when_stopped
             * @return Reference to member max_abs_speed_when_stopped
             */
            eProsima_user_DllExport double& max_abs_speed_when_stopped();

            /*!
             * @brief This function sets a value in member max_abs_speed_when_stopped_duration
             * @param _max_abs_speed_when_stopped_duration New value for member max_abs_speed_when_stopped_duration
             */
            eProsima_user_DllExport void max_abs_speed_when_stopped_duration(
                    double _max_abs_speed_when_stopped_duration);

            /*!
             * @brief This function returns the value of member max_abs_speed_when_stopped_duration
             * @return Value of member max_abs_speed_when_stopped_duration
             */
            eProsima_user_DllExport double max_abs_speed_when_stopped_duration() const;

            /*!
             * @brief This function returns a reference to member max_abs_speed_when_stopped_duration
             * @return Reference to member max_abs_speed_when_stopped_duration
             */
            eProsima_user_DllExport double& max_abs_speed_when_stopped_duration();

            /*!
             * @brief This function sets a value in member brake_value_when_gear_transitioning
             * @param _brake_value_when_gear_transitioning New value for member brake_value_when_gear_transitioning
             */
            eProsima_user_DllExport void brake_value_when_gear_transitioning(
                    double _brake_value_when_gear_transitioning);

            /*!
             * @brief This function returns the value of member brake_value_when_gear_transitioning
             * @return Value of member brake_value_when_gear_transitioning
             */
            eProsima_user_DllExport double brake_value_when_gear_transitioning() const;

            /*!
             * @brief This function returns a reference to member brake_value_when_gear_transitioning
             * @return Reference to member brake_value_when_gear_transitioning
             */
            eProsima_user_DllExport double& brake_value_when_gear_transitioning();

            /*!
             * @brief This function sets a value in member accel_deadzone
             * @param _accel_deadzone New value for member accel_deadzone
             */
            eProsima_user_DllExport void accel_deadzone(
                    double _accel_deadzone);

            /*!
             * @brief This function returns the value of member accel_deadzone
             * @return Value of member accel_deadzone
             */
            eProsima_user_DllExport double accel_deadzone() const;

            /*!
             * @brief This function returns a reference to member accel_deadzone
             * @return Reference to member accel_deadzone
             */
            eProsima_user_DllExport double& accel_deadzone();

            /*!
             * @brief This function sets a value in member brake_deadzone
             * @param _brake_deadzone New value for member brake_deadzone
             */
            eProsima_user_DllExport void brake_deadzone(
                    double _brake_deadzone);

            /*!
             * @brief This function returns the value of member brake_deadzone
             * @return Value of member brake_deadzone
             */
            eProsima_user_DllExport double brake_deadzone() const;

            /*!
             * @brief This function returns a reference to member brake_deadzone
             * @return Reference to member brake_deadzone
             */
            eProsima_user_DllExport double& brake_deadzone();

            /*!
             * @brief This function sets a value in member acceleration_in_idle
             * @param _acceleration_in_idle New value for member acceleration_in_idle
             */
            eProsima_user_DllExport void acceleration_in_idle(
                    double _acceleration_in_idle);

            /*!
             * @brief This function returns the value of member acceleration_in_idle
             * @return Value of member acceleration_in_idle
             */
            eProsima_user_DllExport double acceleration_in_idle() const;

            /*!
             * @brief This function returns a reference to member acceleration_in_idle
             * @return Reference to member acceleration_in_idle
             */
            eProsima_user_DllExport double& acceleration_in_idle();

            /*!
             * @brief This function sets a value in member deceleration_in_idle
             * @param _deceleration_in_idle New value for member deceleration_in_idle
             */
            eProsima_user_DllExport void deceleration_in_idle(
                    double _deceleration_in_idle);

            /*!
             * @brief This function returns the value of member deceleration_in_idle
             * @return Value of member deceleration_in_idle
             */
            eProsima_user_DllExport double deceleration_in_idle() const;

            /*!
             * @brief This function returns a reference to member deceleration_in_idle
             * @return Reference to member deceleration_in_idle
             */
            eProsima_user_DllExport double& deceleration_in_idle();

            /*!
             * @brief This function sets a value in member max_acceleration_jerk
             * @param _max_acceleration_jerk New value for member max_acceleration_jerk
             */
            eProsima_user_DllExport void max_acceleration_jerk(
                    double _max_acceleration_jerk);

            /*!
             * @brief This function returns the value of member max_acceleration_jerk
             * @return Value of member max_acceleration_jerk
             */
            eProsima_user_DllExport double max_acceleration_jerk() const;

            /*!
             * @brief This function returns a reference to member max_acceleration_jerk
             * @return Reference to member max_acceleration_jerk
             */
            eProsima_user_DllExport double& max_acceleration_jerk();

            /*!
             * @brief This function sets a value in member max_acceleration
             * @param _max_acceleration New value for member max_acceleration
             */
            eProsima_user_DllExport void max_acceleration(
                    double _max_acceleration);

            /*!
             * @brief This function returns the value of member max_acceleration
             * @return Value of member max_acceleration
             */
            eProsima_user_DllExport double max_acceleration() const;

            /*!
             * @brief This function returns a reference to member max_acceleration
             * @return Reference to member max_acceleration
             */
            eProsima_user_DllExport double& max_acceleration();

            /*!
             * @brief This function sets a value in member max_deceleration
             * @param _max_deceleration New value for member max_deceleration
             */
            eProsima_user_DllExport void max_deceleration(
                    double _max_deceleration);

            /*!
             * @brief This function returns the value of member max_deceleration
             * @return Value of member max_deceleration
             */
            eProsima_user_DllExport double max_deceleration() const;

            /*!
             * @brief This function returns a reference to member max_deceleration
             * @return Reference to member max_deceleration
             */
            eProsima_user_DllExport double& max_deceleration();

            /*!
             * @brief This function sets a value in member min_turning_radius
             * @param _min_turning_radius New value for member min_turning_radius
             */
            eProsima_user_DllExport void min_turning_radius(
                    double _min_turning_radius);

            /*!
             * @brief This function returns the value of member min_turning_radius
             * @return Value of member min_turning_radius
             */
            eProsima_user_DllExport double min_turning_radius() const;

            /*!
             * @brief This function returns a reference to member min_turning_radius
             * @return Reference to member min_turning_radius
             */
            eProsima_user_DllExport double& min_turning_radius();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::VehicleParam& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            std::string m_brand;
            int32_t m_steer_mode;
            double m_length;
            double m_width;
            double m_height;
            double m_mass_fl;
            double m_mass_fr;
            double m_mass_rl;
            double m_mass_rr;
            double m_wheel_radius;
            double m_wheelbase;
            double m_front_edge_to_center;
            double m_back_edge_to_center;
            double m_lf;
            double m_lr;
            double m_cf;
            double m_cr;
            double m_steer_ratio;
            double m_rolling_coefficient;
            double m_air_density;
            double m_air_damping_coefficient;
            double m_max_front_steer_angle;
            double m_min_front_steer_angle;
            double m_max_rear_steer_angle;
            double m_min_rear_steer_angle;
            double m_speed_limit;
            double m_max_brake_value;
            double m_min_brake_value;
            double m_max_accel_value;
            double m_min_accel_value;
            double m_speed_deadzone;
            double m_standstill_acceleration;
            double m_max_front_steer_angle_rate;
            double m_max_rear_steer_angle_rate;
            double m_max_abs_speed_when_stopped;
            double m_max_abs_speed_when_stopped_duration;
            double m_brake_value_when_gear_transitioning;
            double m_accel_deadzone;
            double m_brake_deadzone;
            double m_acceleration_in_idle;
            double m_deceleration_in_idle;
            double m_max_acceleration_jerk;
            double m_max_acceleration;
            double m_max_deceleration;
            double m_min_turning_radius;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLEPARAM_H_

