// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleParamTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "VehicleParam.h"
#include "VehicleParamTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerVehicleParamTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::VehicleParam", ros2_interface::msg::GetVehicleParamIdentifier(true),
                        ros2_interface::msg::GetVehicleParamObject(true));
                factory->add_type_object("ros2_interface::msg::VehicleParam", ros2_interface::msg::GetVehicleParamIdentifier(false),
                        ros2_interface::msg::GetVehicleParamObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetVehicleParamIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("VehicleParam", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetVehicleParamObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("VehicleParam", complete);
        }

        const TypeObject* GetVehicleParamObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleParam", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteVehicleParamObject();
            }
            //else
            return GetMinimalVehicleParamObject();
        }

        const TypeObject* GetMinimalVehicleParamObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleParam", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_brand;
            mst_brand.common().member_id(memberId++);
            mst_brand.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brand.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brand.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brand.common().member_flags().IS_OPTIONAL(false);
            mst_brand.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brand.common().member_flags().IS_KEY(false);
            mst_brand.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brand.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 brand_hash("brand");
            for(int i = 0; i < 4; ++i)
            {
                mst_brand.detail().name_hash()[i] = brand_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brand);

            MinimalStructMember mst_steer_mode;
            mst_steer_mode.common().member_id(memberId++);
            mst_steer_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steer_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steer_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steer_mode.common().member_flags().IS_OPTIONAL(false);
            mst_steer_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steer_mode.common().member_flags().IS_KEY(false);
            mst_steer_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steer_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 steer_mode_hash("steer_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_steer_mode.detail().name_hash()[i] = steer_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steer_mode);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_mass_fl;
            mst_mass_fl.common().member_id(memberId++);
            mst_mass_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_mass_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_mass_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_mass_fl.common().member_flags().IS_OPTIONAL(false);
            mst_mass_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_mass_fl.common().member_flags().IS_KEY(false);
            mst_mass_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_mass_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 mass_fl_hash("mass_fl");
            for(int i = 0; i < 4; ++i)
            {
                mst_mass_fl.detail().name_hash()[i] = mass_fl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_mass_fl);

            MinimalStructMember mst_mass_fr;
            mst_mass_fr.common().member_id(memberId++);
            mst_mass_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_mass_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_mass_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_mass_fr.common().member_flags().IS_OPTIONAL(false);
            mst_mass_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_mass_fr.common().member_flags().IS_KEY(false);
            mst_mass_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_mass_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 mass_fr_hash("mass_fr");
            for(int i = 0; i < 4; ++i)
            {
                mst_mass_fr.detail().name_hash()[i] = mass_fr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_mass_fr);

            MinimalStructMember mst_mass_rl;
            mst_mass_rl.common().member_id(memberId++);
            mst_mass_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_mass_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_mass_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_mass_rl.common().member_flags().IS_OPTIONAL(false);
            mst_mass_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_mass_rl.common().member_flags().IS_KEY(false);
            mst_mass_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_mass_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 mass_rl_hash("mass_rl");
            for(int i = 0; i < 4; ++i)
            {
                mst_mass_rl.detail().name_hash()[i] = mass_rl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_mass_rl);

            MinimalStructMember mst_mass_rr;
            mst_mass_rr.common().member_id(memberId++);
            mst_mass_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_mass_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_mass_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_mass_rr.common().member_flags().IS_OPTIONAL(false);
            mst_mass_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_mass_rr.common().member_flags().IS_KEY(false);
            mst_mass_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_mass_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 mass_rr_hash("mass_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_mass_rr.detail().name_hash()[i] = mass_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_mass_rr);

            MinimalStructMember mst_wheel_radius;
            mst_wheel_radius.common().member_id(memberId++);
            mst_wheel_radius.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_radius.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_radius.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_radius.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_radius.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_radius.common().member_flags().IS_KEY(false);
            mst_wheel_radius.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_radius.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_radius_hash("wheel_radius");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_radius.detail().name_hash()[i] = wheel_radius_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_radius);

            MinimalStructMember mst_wheelbase;
            mst_wheelbase.common().member_id(memberId++);
            mst_wheelbase.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheelbase.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheelbase.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheelbase.common().member_flags().IS_OPTIONAL(false);
            mst_wheelbase.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheelbase.common().member_flags().IS_KEY(false);
            mst_wheelbase.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheelbase.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheelbase_hash("wheelbase");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheelbase.detail().name_hash()[i] = wheelbase_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheelbase);

            MinimalStructMember mst_front_edge_to_center;
            mst_front_edge_to_center.common().member_id(memberId++);
            mst_front_edge_to_center.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_edge_to_center.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_edge_to_center.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_edge_to_center.common().member_flags().IS_OPTIONAL(false);
            mst_front_edge_to_center.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_edge_to_center.common().member_flags().IS_KEY(false);
            mst_front_edge_to_center.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_edge_to_center.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_edge_to_center_hash("front_edge_to_center");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_edge_to_center.detail().name_hash()[i] = front_edge_to_center_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_edge_to_center);

            MinimalStructMember mst_back_edge_to_center;
            mst_back_edge_to_center.common().member_id(memberId++);
            mst_back_edge_to_center.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_back_edge_to_center.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_back_edge_to_center.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_back_edge_to_center.common().member_flags().IS_OPTIONAL(false);
            mst_back_edge_to_center.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_back_edge_to_center.common().member_flags().IS_KEY(false);
            mst_back_edge_to_center.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_back_edge_to_center.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 back_edge_to_center_hash("back_edge_to_center");
            for(int i = 0; i < 4; ++i)
            {
                mst_back_edge_to_center.detail().name_hash()[i] = back_edge_to_center_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_back_edge_to_center);

            MinimalStructMember mst_lf;
            mst_lf.common().member_id(memberId++);
            mst_lf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lf.common().member_flags().IS_OPTIONAL(false);
            mst_lf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lf.common().member_flags().IS_KEY(false);
            mst_lf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lf_hash("lf");
            for(int i = 0; i < 4; ++i)
            {
                mst_lf.detail().name_hash()[i] = lf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lf);

            MinimalStructMember mst_lr;
            mst_lr.common().member_id(memberId++);
            mst_lr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lr.common().member_flags().IS_OPTIONAL(false);
            mst_lr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lr.common().member_flags().IS_KEY(false);
            mst_lr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 lr_hash("lr");
            for(int i = 0; i < 4; ++i)
            {
                mst_lr.detail().name_hash()[i] = lr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lr);

            MinimalStructMember mst_cf;
            mst_cf.common().member_id(memberId++);
            mst_cf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cf.common().member_flags().IS_OPTIONAL(false);
            mst_cf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cf.common().member_flags().IS_KEY(false);
            mst_cf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cf_hash("cf");
            for(int i = 0; i < 4; ++i)
            {
                mst_cf.detail().name_hash()[i] = cf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cf);

            MinimalStructMember mst_cr;
            mst_cr.common().member_id(memberId++);
            mst_cr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_cr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_cr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_cr.common().member_flags().IS_OPTIONAL(false);
            mst_cr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_cr.common().member_flags().IS_KEY(false);
            mst_cr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_cr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 cr_hash("cr");
            for(int i = 0; i < 4; ++i)
            {
                mst_cr.detail().name_hash()[i] = cr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_cr);

            MinimalStructMember mst_steer_ratio;
            mst_steer_ratio.common().member_id(memberId++);
            mst_steer_ratio.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steer_ratio.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steer_ratio.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steer_ratio.common().member_flags().IS_OPTIONAL(false);
            mst_steer_ratio.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steer_ratio.common().member_flags().IS_KEY(false);
            mst_steer_ratio.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steer_ratio.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steer_ratio_hash("steer_ratio");
            for(int i = 0; i < 4; ++i)
            {
                mst_steer_ratio.detail().name_hash()[i] = steer_ratio_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steer_ratio);

            MinimalStructMember mst_rolling_coefficient;
            mst_rolling_coefficient.common().member_id(memberId++);
            mst_rolling_coefficient.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rolling_coefficient.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rolling_coefficient.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rolling_coefficient.common().member_flags().IS_OPTIONAL(false);
            mst_rolling_coefficient.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rolling_coefficient.common().member_flags().IS_KEY(false);
            mst_rolling_coefficient.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rolling_coefficient.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rolling_coefficient_hash("rolling_coefficient");
            for(int i = 0; i < 4; ++i)
            {
                mst_rolling_coefficient.detail().name_hash()[i] = rolling_coefficient_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rolling_coefficient);

            MinimalStructMember mst_air_density;
            mst_air_density.common().member_id(memberId++);
            mst_air_density.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_air_density.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_air_density.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_air_density.common().member_flags().IS_OPTIONAL(false);
            mst_air_density.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_air_density.common().member_flags().IS_KEY(false);
            mst_air_density.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_air_density.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 air_density_hash("air_density");
            for(int i = 0; i < 4; ++i)
            {
                mst_air_density.detail().name_hash()[i] = air_density_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_air_density);

            MinimalStructMember mst_air_damping_coefficient;
            mst_air_damping_coefficient.common().member_id(memberId++);
            mst_air_damping_coefficient.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_air_damping_coefficient.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_air_damping_coefficient.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_air_damping_coefficient.common().member_flags().IS_OPTIONAL(false);
            mst_air_damping_coefficient.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_air_damping_coefficient.common().member_flags().IS_KEY(false);
            mst_air_damping_coefficient.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_air_damping_coefficient.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 air_damping_coefficient_hash("air_damping_coefficient");
            for(int i = 0; i < 4; ++i)
            {
                mst_air_damping_coefficient.detail().name_hash()[i] = air_damping_coefficient_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_air_damping_coefficient);

            MinimalStructMember mst_max_front_steer_angle;
            mst_max_front_steer_angle.common().member_id(memberId++);
            mst_max_front_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_front_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_front_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_front_steer_angle.common().member_flags().IS_OPTIONAL(false);
            mst_max_front_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_front_steer_angle.common().member_flags().IS_KEY(false);
            mst_max_front_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_front_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_front_steer_angle_hash("max_front_steer_angle");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_front_steer_angle.detail().name_hash()[i] = max_front_steer_angle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_front_steer_angle);

            MinimalStructMember mst_min_front_steer_angle;
            mst_min_front_steer_angle.common().member_id(memberId++);
            mst_min_front_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_min_front_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_min_front_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_min_front_steer_angle.common().member_flags().IS_OPTIONAL(false);
            mst_min_front_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_min_front_steer_angle.common().member_flags().IS_KEY(false);
            mst_min_front_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_min_front_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 min_front_steer_angle_hash("min_front_steer_angle");
            for(int i = 0; i < 4; ++i)
            {
                mst_min_front_steer_angle.detail().name_hash()[i] = min_front_steer_angle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_min_front_steer_angle);

            MinimalStructMember mst_max_rear_steer_angle;
            mst_max_rear_steer_angle.common().member_id(memberId++);
            mst_max_rear_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_rear_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_rear_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_rear_steer_angle.common().member_flags().IS_OPTIONAL(false);
            mst_max_rear_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_rear_steer_angle.common().member_flags().IS_KEY(false);
            mst_max_rear_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_rear_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_rear_steer_angle_hash("max_rear_steer_angle");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_rear_steer_angle.detail().name_hash()[i] = max_rear_steer_angle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_rear_steer_angle);

            MinimalStructMember mst_min_rear_steer_angle;
            mst_min_rear_steer_angle.common().member_id(memberId++);
            mst_min_rear_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_min_rear_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_min_rear_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_min_rear_steer_angle.common().member_flags().IS_OPTIONAL(false);
            mst_min_rear_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_min_rear_steer_angle.common().member_flags().IS_KEY(false);
            mst_min_rear_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_min_rear_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 min_rear_steer_angle_hash("min_rear_steer_angle");
            for(int i = 0; i < 4; ++i)
            {
                mst_min_rear_steer_angle.detail().name_hash()[i] = min_rear_steer_angle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_min_rear_steer_angle);

            MinimalStructMember mst_speed_limit;
            mst_speed_limit.common().member_id(memberId++);
            mst_speed_limit.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_limit.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_limit.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_limit.common().member_flags().IS_OPTIONAL(false);
            mst_speed_limit.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_limit.common().member_flags().IS_KEY(false);
            mst_speed_limit.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_limit.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_limit_hash("speed_limit");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_limit.detail().name_hash()[i] = speed_limit_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_limit);

            MinimalStructMember mst_max_brake_value;
            mst_max_brake_value.common().member_id(memberId++);
            mst_max_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_brake_value.common().member_flags().IS_OPTIONAL(false);
            mst_max_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_brake_value.common().member_flags().IS_KEY(false);
            mst_max_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_brake_value_hash("max_brake_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_brake_value.detail().name_hash()[i] = max_brake_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_brake_value);

            MinimalStructMember mst_min_brake_value;
            mst_min_brake_value.common().member_id(memberId++);
            mst_min_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_min_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_min_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_min_brake_value.common().member_flags().IS_OPTIONAL(false);
            mst_min_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_min_brake_value.common().member_flags().IS_KEY(false);
            mst_min_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_min_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 min_brake_value_hash("min_brake_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_min_brake_value.detail().name_hash()[i] = min_brake_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_min_brake_value);

            MinimalStructMember mst_max_accel_value;
            mst_max_accel_value.common().member_id(memberId++);
            mst_max_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_accel_value.common().member_flags().IS_OPTIONAL(false);
            mst_max_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_accel_value.common().member_flags().IS_KEY(false);
            mst_max_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_accel_value_hash("max_accel_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_accel_value.detail().name_hash()[i] = max_accel_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_accel_value);

            MinimalStructMember mst_min_accel_value;
            mst_min_accel_value.common().member_id(memberId++);
            mst_min_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_min_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_min_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_min_accel_value.common().member_flags().IS_OPTIONAL(false);
            mst_min_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_min_accel_value.common().member_flags().IS_KEY(false);
            mst_min_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_min_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 min_accel_value_hash("min_accel_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_min_accel_value.detail().name_hash()[i] = min_accel_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_min_accel_value);

            MinimalStructMember mst_speed_deadzone;
            mst_speed_deadzone.common().member_id(memberId++);
            mst_speed_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_deadzone.common().member_flags().IS_OPTIONAL(false);
            mst_speed_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_deadzone.common().member_flags().IS_KEY(false);
            mst_speed_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_deadzone_hash("speed_deadzone");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_deadzone.detail().name_hash()[i] = speed_deadzone_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_deadzone);

            MinimalStructMember mst_standstill_acceleration;
            mst_standstill_acceleration.common().member_id(memberId++);
            mst_standstill_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_standstill_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_standstill_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_standstill_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_standstill_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_standstill_acceleration.common().member_flags().IS_KEY(false);
            mst_standstill_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_standstill_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 standstill_acceleration_hash("standstill_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_standstill_acceleration.detail().name_hash()[i] = standstill_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_standstill_acceleration);

            MinimalStructMember mst_max_front_steer_angle_rate;
            mst_max_front_steer_angle_rate.common().member_id(memberId++);
            mst_max_front_steer_angle_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_front_steer_angle_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_front_steer_angle_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_front_steer_angle_rate.common().member_flags().IS_OPTIONAL(false);
            mst_max_front_steer_angle_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_front_steer_angle_rate.common().member_flags().IS_KEY(false);
            mst_max_front_steer_angle_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_front_steer_angle_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_front_steer_angle_rate_hash("max_front_steer_angle_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_front_steer_angle_rate.detail().name_hash()[i] = max_front_steer_angle_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_front_steer_angle_rate);

            MinimalStructMember mst_max_rear_steer_angle_rate;
            mst_max_rear_steer_angle_rate.common().member_id(memberId++);
            mst_max_rear_steer_angle_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_rear_steer_angle_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_rear_steer_angle_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_rear_steer_angle_rate.common().member_flags().IS_OPTIONAL(false);
            mst_max_rear_steer_angle_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_rear_steer_angle_rate.common().member_flags().IS_KEY(false);
            mst_max_rear_steer_angle_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_rear_steer_angle_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_rear_steer_angle_rate_hash("max_rear_steer_angle_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_rear_steer_angle_rate.detail().name_hash()[i] = max_rear_steer_angle_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_rear_steer_angle_rate);

            MinimalStructMember mst_max_abs_speed_when_stopped;
            mst_max_abs_speed_when_stopped.common().member_id(memberId++);
            mst_max_abs_speed_when_stopped.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_abs_speed_when_stopped.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_abs_speed_when_stopped.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_abs_speed_when_stopped.common().member_flags().IS_OPTIONAL(false);
            mst_max_abs_speed_when_stopped.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_abs_speed_when_stopped.common().member_flags().IS_KEY(false);
            mst_max_abs_speed_when_stopped.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_abs_speed_when_stopped.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_abs_speed_when_stopped_hash("max_abs_speed_when_stopped");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_abs_speed_when_stopped.detail().name_hash()[i] = max_abs_speed_when_stopped_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_abs_speed_when_stopped);

            MinimalStructMember mst_max_abs_speed_when_stopped_duration;
            mst_max_abs_speed_when_stopped_duration.common().member_id(memberId++);
            mst_max_abs_speed_when_stopped_duration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_abs_speed_when_stopped_duration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_abs_speed_when_stopped_duration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_abs_speed_when_stopped_duration.common().member_flags().IS_OPTIONAL(false);
            mst_max_abs_speed_when_stopped_duration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_abs_speed_when_stopped_duration.common().member_flags().IS_KEY(false);
            mst_max_abs_speed_when_stopped_duration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_abs_speed_when_stopped_duration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_abs_speed_when_stopped_duration_hash("max_abs_speed_when_stopped_duration");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_abs_speed_when_stopped_duration.detail().name_hash()[i] = max_abs_speed_when_stopped_duration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_abs_speed_when_stopped_duration);

            MinimalStructMember mst_brake_value_when_gear_transitioning;
            mst_brake_value_when_gear_transitioning.common().member_id(memberId++);
            mst_brake_value_when_gear_transitioning.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_value_when_gear_transitioning.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_value_when_gear_transitioning.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_value_when_gear_transitioning.common().member_flags().IS_OPTIONAL(false);
            mst_brake_value_when_gear_transitioning.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_value_when_gear_transitioning.common().member_flags().IS_KEY(false);
            mst_brake_value_when_gear_transitioning.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_value_when_gear_transitioning.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_value_when_gear_transitioning_hash("brake_value_when_gear_transitioning");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_value_when_gear_transitioning.detail().name_hash()[i] = brake_value_when_gear_transitioning_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_value_when_gear_transitioning);

            MinimalStructMember mst_accel_deadzone;
            mst_accel_deadzone.common().member_id(memberId++);
            mst_accel_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_deadzone.common().member_flags().IS_OPTIONAL(false);
            mst_accel_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_deadzone.common().member_flags().IS_KEY(false);
            mst_accel_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 accel_deadzone_hash("accel_deadzone");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_deadzone.detail().name_hash()[i] = accel_deadzone_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_deadzone);

            MinimalStructMember mst_brake_deadzone;
            mst_brake_deadzone.common().member_id(memberId++);
            mst_brake_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_deadzone.common().member_flags().IS_OPTIONAL(false);
            mst_brake_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_deadzone.common().member_flags().IS_KEY(false);
            mst_brake_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_deadzone_hash("brake_deadzone");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_deadzone.detail().name_hash()[i] = brake_deadzone_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_deadzone);

            MinimalStructMember mst_acceleration_in_idle;
            mst_acceleration_in_idle.common().member_id(memberId++);
            mst_acceleration_in_idle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_acceleration_in_idle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_acceleration_in_idle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_acceleration_in_idle.common().member_flags().IS_OPTIONAL(false);
            mst_acceleration_in_idle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_acceleration_in_idle.common().member_flags().IS_KEY(false);
            mst_acceleration_in_idle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_acceleration_in_idle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 acceleration_in_idle_hash("acceleration_in_idle");
            for(int i = 0; i < 4; ++i)
            {
                mst_acceleration_in_idle.detail().name_hash()[i] = acceleration_in_idle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_acceleration_in_idle);

            MinimalStructMember mst_deceleration_in_idle;
            mst_deceleration_in_idle.common().member_id(memberId++);
            mst_deceleration_in_idle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_deceleration_in_idle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_deceleration_in_idle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_deceleration_in_idle.common().member_flags().IS_OPTIONAL(false);
            mst_deceleration_in_idle.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_deceleration_in_idle.common().member_flags().IS_KEY(false);
            mst_deceleration_in_idle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_deceleration_in_idle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 deceleration_in_idle_hash("deceleration_in_idle");
            for(int i = 0; i < 4; ++i)
            {
                mst_deceleration_in_idle.detail().name_hash()[i] = deceleration_in_idle_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_deceleration_in_idle);

            MinimalStructMember mst_max_acceleration_jerk;
            mst_max_acceleration_jerk.common().member_id(memberId++);
            mst_max_acceleration_jerk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_acceleration_jerk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_acceleration_jerk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_acceleration_jerk.common().member_flags().IS_OPTIONAL(false);
            mst_max_acceleration_jerk.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_acceleration_jerk.common().member_flags().IS_KEY(false);
            mst_max_acceleration_jerk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_acceleration_jerk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_acceleration_jerk_hash("max_acceleration_jerk");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_acceleration_jerk.detail().name_hash()[i] = max_acceleration_jerk_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_acceleration_jerk);

            MinimalStructMember mst_max_acceleration;
            mst_max_acceleration.common().member_id(memberId++);
            mst_max_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_max_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_acceleration.common().member_flags().IS_KEY(false);
            mst_max_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_acceleration_hash("max_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_acceleration.detail().name_hash()[i] = max_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_acceleration);

            MinimalStructMember mst_max_deceleration;
            mst_max_deceleration.common().member_id(memberId++);
            mst_max_deceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_max_deceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_max_deceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_max_deceleration.common().member_flags().IS_OPTIONAL(false);
            mst_max_deceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_max_deceleration.common().member_flags().IS_KEY(false);
            mst_max_deceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_max_deceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 max_deceleration_hash("max_deceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_max_deceleration.detail().name_hash()[i] = max_deceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_max_deceleration);

            MinimalStructMember mst_min_turning_radius;
            mst_min_turning_radius.common().member_id(memberId++);
            mst_min_turning_radius.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_min_turning_radius.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_min_turning_radius.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_min_turning_radius.common().member_flags().IS_OPTIONAL(false);
            mst_min_turning_radius.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_min_turning_radius.common().member_flags().IS_KEY(false);
            mst_min_turning_radius.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_min_turning_radius.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 min_turning_radius_hash("min_turning_radius");
            for(int i = 0; i < 4; ++i)
            {
                mst_min_turning_radius.detail().name_hash()[i] = min_turning_radius_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_min_turning_radius);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleParam", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleParam", false);
        }

        const TypeObject* GetCompleteVehicleParamObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleParam", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_brand;
            cst_brand.common().member_id(memberId++);
            cst_brand.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brand.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brand.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brand.common().member_flags().IS_OPTIONAL(false);
            cst_brand.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brand.common().member_flags().IS_KEY(false);
            cst_brand.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brand.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_brand.detail().name("brand");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brand);

            CompleteStructMember cst_steer_mode;
            cst_steer_mode.common().member_id(memberId++);
            cst_steer_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steer_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steer_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steer_mode.common().member_flags().IS_OPTIONAL(false);
            cst_steer_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steer_mode.common().member_flags().IS_KEY(false);
            cst_steer_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steer_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_steer_mode.detail().name("steer_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steer_mode);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_mass_fl;
            cst_mass_fl.common().member_id(memberId++);
            cst_mass_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_mass_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_mass_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_mass_fl.common().member_flags().IS_OPTIONAL(false);
            cst_mass_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_mass_fl.common().member_flags().IS_KEY(false);
            cst_mass_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_mass_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_mass_fl.detail().name("mass_fl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_mass_fl);

            CompleteStructMember cst_mass_fr;
            cst_mass_fr.common().member_id(memberId++);
            cst_mass_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_mass_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_mass_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_mass_fr.common().member_flags().IS_OPTIONAL(false);
            cst_mass_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_mass_fr.common().member_flags().IS_KEY(false);
            cst_mass_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_mass_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_mass_fr.detail().name("mass_fr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_mass_fr);

            CompleteStructMember cst_mass_rl;
            cst_mass_rl.common().member_id(memberId++);
            cst_mass_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_mass_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_mass_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_mass_rl.common().member_flags().IS_OPTIONAL(false);
            cst_mass_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_mass_rl.common().member_flags().IS_KEY(false);
            cst_mass_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_mass_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_mass_rl.detail().name("mass_rl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_mass_rl);

            CompleteStructMember cst_mass_rr;
            cst_mass_rr.common().member_id(memberId++);
            cst_mass_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_mass_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_mass_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_mass_rr.common().member_flags().IS_OPTIONAL(false);
            cst_mass_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_mass_rr.common().member_flags().IS_KEY(false);
            cst_mass_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_mass_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_mass_rr.detail().name("mass_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_mass_rr);

            CompleteStructMember cst_wheel_radius;
            cst_wheel_radius.common().member_id(memberId++);
            cst_wheel_radius.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_radius.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_radius.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_radius.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_radius.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_radius.common().member_flags().IS_KEY(false);
            cst_wheel_radius.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_radius.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_radius.detail().name("wheel_radius");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_radius);

            CompleteStructMember cst_wheelbase;
            cst_wheelbase.common().member_id(memberId++);
            cst_wheelbase.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheelbase.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheelbase.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheelbase.common().member_flags().IS_OPTIONAL(false);
            cst_wheelbase.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheelbase.common().member_flags().IS_KEY(false);
            cst_wheelbase.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheelbase.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheelbase.detail().name("wheelbase");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheelbase);

            CompleteStructMember cst_front_edge_to_center;
            cst_front_edge_to_center.common().member_id(memberId++);
            cst_front_edge_to_center.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_edge_to_center.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_edge_to_center.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_edge_to_center.common().member_flags().IS_OPTIONAL(false);
            cst_front_edge_to_center.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_edge_to_center.common().member_flags().IS_KEY(false);
            cst_front_edge_to_center.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_edge_to_center.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_edge_to_center.detail().name("front_edge_to_center");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_edge_to_center);

            CompleteStructMember cst_back_edge_to_center;
            cst_back_edge_to_center.common().member_id(memberId++);
            cst_back_edge_to_center.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_back_edge_to_center.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_back_edge_to_center.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_back_edge_to_center.common().member_flags().IS_OPTIONAL(false);
            cst_back_edge_to_center.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_back_edge_to_center.common().member_flags().IS_KEY(false);
            cst_back_edge_to_center.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_back_edge_to_center.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_back_edge_to_center.detail().name("back_edge_to_center");

            type_object->complete().struct_type().member_seq().emplace_back(cst_back_edge_to_center);

            CompleteStructMember cst_lf;
            cst_lf.common().member_id(memberId++);
            cst_lf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lf.common().member_flags().IS_OPTIONAL(false);
            cst_lf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lf.common().member_flags().IS_KEY(false);
            cst_lf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lf.detail().name("lf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lf);

            CompleteStructMember cst_lr;
            cst_lr.common().member_id(memberId++);
            cst_lr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lr.common().member_flags().IS_OPTIONAL(false);
            cst_lr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lr.common().member_flags().IS_KEY(false);
            cst_lr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_lr.detail().name("lr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lr);

            CompleteStructMember cst_cf;
            cst_cf.common().member_id(memberId++);
            cst_cf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cf.common().member_flags().IS_OPTIONAL(false);
            cst_cf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cf.common().member_flags().IS_KEY(false);
            cst_cf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cf.detail().name("cf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cf);

            CompleteStructMember cst_cr;
            cst_cr.common().member_id(memberId++);
            cst_cr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_cr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_cr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_cr.common().member_flags().IS_OPTIONAL(false);
            cst_cr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_cr.common().member_flags().IS_KEY(false);
            cst_cr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_cr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_cr.detail().name("cr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_cr);

            CompleteStructMember cst_steer_ratio;
            cst_steer_ratio.common().member_id(memberId++);
            cst_steer_ratio.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steer_ratio.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steer_ratio.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steer_ratio.common().member_flags().IS_OPTIONAL(false);
            cst_steer_ratio.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steer_ratio.common().member_flags().IS_KEY(false);
            cst_steer_ratio.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steer_ratio.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steer_ratio.detail().name("steer_ratio");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steer_ratio);

            CompleteStructMember cst_rolling_coefficient;
            cst_rolling_coefficient.common().member_id(memberId++);
            cst_rolling_coefficient.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rolling_coefficient.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rolling_coefficient.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rolling_coefficient.common().member_flags().IS_OPTIONAL(false);
            cst_rolling_coefficient.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rolling_coefficient.common().member_flags().IS_KEY(false);
            cst_rolling_coefficient.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rolling_coefficient.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rolling_coefficient.detail().name("rolling_coefficient");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rolling_coefficient);

            CompleteStructMember cst_air_density;
            cst_air_density.common().member_id(memberId++);
            cst_air_density.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_air_density.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_air_density.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_air_density.common().member_flags().IS_OPTIONAL(false);
            cst_air_density.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_air_density.common().member_flags().IS_KEY(false);
            cst_air_density.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_air_density.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_air_density.detail().name("air_density");

            type_object->complete().struct_type().member_seq().emplace_back(cst_air_density);

            CompleteStructMember cst_air_damping_coefficient;
            cst_air_damping_coefficient.common().member_id(memberId++);
            cst_air_damping_coefficient.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_air_damping_coefficient.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_air_damping_coefficient.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_air_damping_coefficient.common().member_flags().IS_OPTIONAL(false);
            cst_air_damping_coefficient.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_air_damping_coefficient.common().member_flags().IS_KEY(false);
            cst_air_damping_coefficient.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_air_damping_coefficient.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_air_damping_coefficient.detail().name("air_damping_coefficient");

            type_object->complete().struct_type().member_seq().emplace_back(cst_air_damping_coefficient);

            CompleteStructMember cst_max_front_steer_angle;
            cst_max_front_steer_angle.common().member_id(memberId++);
            cst_max_front_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_front_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_front_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_front_steer_angle.common().member_flags().IS_OPTIONAL(false);
            cst_max_front_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_front_steer_angle.common().member_flags().IS_KEY(false);
            cst_max_front_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_front_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_front_steer_angle.detail().name("max_front_steer_angle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_front_steer_angle);

            CompleteStructMember cst_min_front_steer_angle;
            cst_min_front_steer_angle.common().member_id(memberId++);
            cst_min_front_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_min_front_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_min_front_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_min_front_steer_angle.common().member_flags().IS_OPTIONAL(false);
            cst_min_front_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_min_front_steer_angle.common().member_flags().IS_KEY(false);
            cst_min_front_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_min_front_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_min_front_steer_angle.detail().name("min_front_steer_angle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_min_front_steer_angle);

            CompleteStructMember cst_max_rear_steer_angle;
            cst_max_rear_steer_angle.common().member_id(memberId++);
            cst_max_rear_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_rear_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_rear_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_rear_steer_angle.common().member_flags().IS_OPTIONAL(false);
            cst_max_rear_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_rear_steer_angle.common().member_flags().IS_KEY(false);
            cst_max_rear_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_rear_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_rear_steer_angle.detail().name("max_rear_steer_angle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_rear_steer_angle);

            CompleteStructMember cst_min_rear_steer_angle;
            cst_min_rear_steer_angle.common().member_id(memberId++);
            cst_min_rear_steer_angle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_min_rear_steer_angle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_min_rear_steer_angle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_min_rear_steer_angle.common().member_flags().IS_OPTIONAL(false);
            cst_min_rear_steer_angle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_min_rear_steer_angle.common().member_flags().IS_KEY(false);
            cst_min_rear_steer_angle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_min_rear_steer_angle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_min_rear_steer_angle.detail().name("min_rear_steer_angle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_min_rear_steer_angle);

            CompleteStructMember cst_speed_limit;
            cst_speed_limit.common().member_id(memberId++);
            cst_speed_limit.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_limit.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_limit.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_limit.common().member_flags().IS_OPTIONAL(false);
            cst_speed_limit.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_limit.common().member_flags().IS_KEY(false);
            cst_speed_limit.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_limit.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_limit.detail().name("speed_limit");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_limit);

            CompleteStructMember cst_max_brake_value;
            cst_max_brake_value.common().member_id(memberId++);
            cst_max_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_brake_value.common().member_flags().IS_OPTIONAL(false);
            cst_max_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_brake_value.common().member_flags().IS_KEY(false);
            cst_max_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_brake_value.detail().name("max_brake_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_brake_value);

            CompleteStructMember cst_min_brake_value;
            cst_min_brake_value.common().member_id(memberId++);
            cst_min_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_min_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_min_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_min_brake_value.common().member_flags().IS_OPTIONAL(false);
            cst_min_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_min_brake_value.common().member_flags().IS_KEY(false);
            cst_min_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_min_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_min_brake_value.detail().name("min_brake_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_min_brake_value);

            CompleteStructMember cst_max_accel_value;
            cst_max_accel_value.common().member_id(memberId++);
            cst_max_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_accel_value.common().member_flags().IS_OPTIONAL(false);
            cst_max_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_accel_value.common().member_flags().IS_KEY(false);
            cst_max_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_accel_value.detail().name("max_accel_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_accel_value);

            CompleteStructMember cst_min_accel_value;
            cst_min_accel_value.common().member_id(memberId++);
            cst_min_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_min_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_min_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_min_accel_value.common().member_flags().IS_OPTIONAL(false);
            cst_min_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_min_accel_value.common().member_flags().IS_KEY(false);
            cst_min_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_min_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_min_accel_value.detail().name("min_accel_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_min_accel_value);

            CompleteStructMember cst_speed_deadzone;
            cst_speed_deadzone.common().member_id(memberId++);
            cst_speed_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_deadzone.common().member_flags().IS_OPTIONAL(false);
            cst_speed_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_deadzone.common().member_flags().IS_KEY(false);
            cst_speed_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_deadzone.detail().name("speed_deadzone");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_deadzone);

            CompleteStructMember cst_standstill_acceleration;
            cst_standstill_acceleration.common().member_id(memberId++);
            cst_standstill_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_standstill_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_standstill_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_standstill_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_standstill_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_standstill_acceleration.common().member_flags().IS_KEY(false);
            cst_standstill_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_standstill_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_standstill_acceleration.detail().name("standstill_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_standstill_acceleration);

            CompleteStructMember cst_max_front_steer_angle_rate;
            cst_max_front_steer_angle_rate.common().member_id(memberId++);
            cst_max_front_steer_angle_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_front_steer_angle_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_front_steer_angle_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_front_steer_angle_rate.common().member_flags().IS_OPTIONAL(false);
            cst_max_front_steer_angle_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_front_steer_angle_rate.common().member_flags().IS_KEY(false);
            cst_max_front_steer_angle_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_front_steer_angle_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_front_steer_angle_rate.detail().name("max_front_steer_angle_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_front_steer_angle_rate);

            CompleteStructMember cst_max_rear_steer_angle_rate;
            cst_max_rear_steer_angle_rate.common().member_id(memberId++);
            cst_max_rear_steer_angle_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_rear_steer_angle_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_rear_steer_angle_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_rear_steer_angle_rate.common().member_flags().IS_OPTIONAL(false);
            cst_max_rear_steer_angle_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_rear_steer_angle_rate.common().member_flags().IS_KEY(false);
            cst_max_rear_steer_angle_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_rear_steer_angle_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_rear_steer_angle_rate.detail().name("max_rear_steer_angle_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_rear_steer_angle_rate);

            CompleteStructMember cst_max_abs_speed_when_stopped;
            cst_max_abs_speed_when_stopped.common().member_id(memberId++);
            cst_max_abs_speed_when_stopped.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_abs_speed_when_stopped.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_abs_speed_when_stopped.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_abs_speed_when_stopped.common().member_flags().IS_OPTIONAL(false);
            cst_max_abs_speed_when_stopped.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_abs_speed_when_stopped.common().member_flags().IS_KEY(false);
            cst_max_abs_speed_when_stopped.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_abs_speed_when_stopped.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_abs_speed_when_stopped.detail().name("max_abs_speed_when_stopped");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_abs_speed_when_stopped);

            CompleteStructMember cst_max_abs_speed_when_stopped_duration;
            cst_max_abs_speed_when_stopped_duration.common().member_id(memberId++);
            cst_max_abs_speed_when_stopped_duration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_abs_speed_when_stopped_duration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_abs_speed_when_stopped_duration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_abs_speed_when_stopped_duration.common().member_flags().IS_OPTIONAL(false);
            cst_max_abs_speed_when_stopped_duration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_abs_speed_when_stopped_duration.common().member_flags().IS_KEY(false);
            cst_max_abs_speed_when_stopped_duration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_abs_speed_when_stopped_duration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_abs_speed_when_stopped_duration.detail().name("max_abs_speed_when_stopped_duration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_abs_speed_when_stopped_duration);

            CompleteStructMember cst_brake_value_when_gear_transitioning;
            cst_brake_value_when_gear_transitioning.common().member_id(memberId++);
            cst_brake_value_when_gear_transitioning.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_value_when_gear_transitioning.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_value_when_gear_transitioning.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_value_when_gear_transitioning.common().member_flags().IS_OPTIONAL(false);
            cst_brake_value_when_gear_transitioning.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_value_when_gear_transitioning.common().member_flags().IS_KEY(false);
            cst_brake_value_when_gear_transitioning.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_value_when_gear_transitioning.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_value_when_gear_transitioning.detail().name("brake_value_when_gear_transitioning");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_value_when_gear_transitioning);

            CompleteStructMember cst_accel_deadzone;
            cst_accel_deadzone.common().member_id(memberId++);
            cst_accel_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_deadzone.common().member_flags().IS_OPTIONAL(false);
            cst_accel_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_deadzone.common().member_flags().IS_KEY(false);
            cst_accel_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_accel_deadzone.detail().name("accel_deadzone");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_deadzone);

            CompleteStructMember cst_brake_deadzone;
            cst_brake_deadzone.common().member_id(memberId++);
            cst_brake_deadzone.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_deadzone.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_deadzone.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_deadzone.common().member_flags().IS_OPTIONAL(false);
            cst_brake_deadzone.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_deadzone.common().member_flags().IS_KEY(false);
            cst_brake_deadzone.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_deadzone.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_deadzone.detail().name("brake_deadzone");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_deadzone);

            CompleteStructMember cst_acceleration_in_idle;
            cst_acceleration_in_idle.common().member_id(memberId++);
            cst_acceleration_in_idle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_acceleration_in_idle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_acceleration_in_idle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_acceleration_in_idle.common().member_flags().IS_OPTIONAL(false);
            cst_acceleration_in_idle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_acceleration_in_idle.common().member_flags().IS_KEY(false);
            cst_acceleration_in_idle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_acceleration_in_idle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_acceleration_in_idle.detail().name("acceleration_in_idle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_acceleration_in_idle);

            CompleteStructMember cst_deceleration_in_idle;
            cst_deceleration_in_idle.common().member_id(memberId++);
            cst_deceleration_in_idle.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_deceleration_in_idle.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_deceleration_in_idle.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_deceleration_in_idle.common().member_flags().IS_OPTIONAL(false);
            cst_deceleration_in_idle.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_deceleration_in_idle.common().member_flags().IS_KEY(false);
            cst_deceleration_in_idle.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_deceleration_in_idle.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_deceleration_in_idle.detail().name("deceleration_in_idle");

            type_object->complete().struct_type().member_seq().emplace_back(cst_deceleration_in_idle);

            CompleteStructMember cst_max_acceleration_jerk;
            cst_max_acceleration_jerk.common().member_id(memberId++);
            cst_max_acceleration_jerk.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_acceleration_jerk.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_acceleration_jerk.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_acceleration_jerk.common().member_flags().IS_OPTIONAL(false);
            cst_max_acceleration_jerk.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_acceleration_jerk.common().member_flags().IS_KEY(false);
            cst_max_acceleration_jerk.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_acceleration_jerk.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_acceleration_jerk.detail().name("max_acceleration_jerk");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_acceleration_jerk);

            CompleteStructMember cst_max_acceleration;
            cst_max_acceleration.common().member_id(memberId++);
            cst_max_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_max_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_acceleration.common().member_flags().IS_KEY(false);
            cst_max_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_acceleration.detail().name("max_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_acceleration);

            CompleteStructMember cst_max_deceleration;
            cst_max_deceleration.common().member_id(memberId++);
            cst_max_deceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_max_deceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_max_deceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_max_deceleration.common().member_flags().IS_OPTIONAL(false);
            cst_max_deceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_max_deceleration.common().member_flags().IS_KEY(false);
            cst_max_deceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_max_deceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_max_deceleration.detail().name("max_deceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_max_deceleration);

            CompleteStructMember cst_min_turning_radius;
            cst_min_turning_radius.common().member_id(memberId++);
            cst_min_turning_radius.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_min_turning_radius.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_min_turning_radius.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_min_turning_radius.common().member_flags().IS_OPTIONAL(false);
            cst_min_turning_radius.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_min_turning_radius.common().member_flags().IS_KEY(false);
            cst_min_turning_radius.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_min_turning_radius.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_min_turning_radius.detail().name("min_turning_radius");

            type_object->complete().struct_type().member_seq().emplace_back(cst_min_turning_radius);


            // Header
            type_object->complete().struct_type().header().detail().type_name("VehicleParam");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleParam", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleParam", true);
        }

    } // namespace msg
} // namespace ros2_interface