// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleSignal.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleSignal.h"
#include "VehicleSignalTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_VehicleSignal_max_cdr_typesize 8ULL;
#define ros2_interface_msg_VehicleSignal_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleSignal::VehicleSignal()
{
    // long m_turn_signal
    m_turn_signal = 0;
    // boolean m_high_beam
    m_high_beam = false;
    // boolean m_low_beam
    m_low_beam = false;
    // boolean m_horn
    m_horn = false;
    // boolean m_emergency_light
    m_emergency_light = false;

    // Just to register all known types
    registerVehicleSignalTypes();
}

ros2_interface::msg::VehicleSignal::~VehicleSignal()
{





}

ros2_interface::msg::VehicleSignal::VehicleSignal(
        const VehicleSignal& x)
{
    m_turn_signal = x.m_turn_signal;
    m_high_beam = x.m_high_beam;
    m_low_beam = x.m_low_beam;
    m_horn = x.m_horn;
    m_emergency_light = x.m_emergency_light;
}

ros2_interface::msg::VehicleSignal::VehicleSignal(
        VehicleSignal&& x) noexcept 
{
    m_turn_signal = x.m_turn_signal;
    m_high_beam = x.m_high_beam;
    m_low_beam = x.m_low_beam;
    m_horn = x.m_horn;
    m_emergency_light = x.m_emergency_light;
}

ros2_interface::msg::VehicleSignal& ros2_interface::msg::VehicleSignal::operator =(
        const VehicleSignal& x)
{

    m_turn_signal = x.m_turn_signal;
    m_high_beam = x.m_high_beam;
    m_low_beam = x.m_low_beam;
    m_horn = x.m_horn;
    m_emergency_light = x.m_emergency_light;

    return *this;
}

ros2_interface::msg::VehicleSignal& ros2_interface::msg::VehicleSignal::operator =(
        VehicleSignal&& x) noexcept
{

    m_turn_signal = x.m_turn_signal;
    m_high_beam = x.m_high_beam;
    m_low_beam = x.m_low_beam;
    m_horn = x.m_horn;
    m_emergency_light = x.m_emergency_light;

    return *this;
}

bool ros2_interface::msg::VehicleSignal::operator ==(
        const VehicleSignal& x) const
{

    return (m_turn_signal == x.m_turn_signal && m_high_beam == x.m_high_beam && m_low_beam == x.m_low_beam && m_horn == x.m_horn && m_emergency_light == x.m_emergency_light);
}

bool ros2_interface::msg::VehicleSignal::operator !=(
        const VehicleSignal& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleSignal::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleSignal_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleSignal::getCdrSerializedSize(
        const ros2_interface::msg::VehicleSignal& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);


    current_alignment += 1 + eprosima::fastcdr::Cdr::alignment(current_alignment, 1);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleSignal::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_turn_signal;
    scdr << m_high_beam;
    scdr << m_low_beam;
    scdr << m_horn;
    scdr << m_emergency_light;

}

void ros2_interface::msg::VehicleSignal::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_turn_signal;
    dcdr >> m_high_beam;
    dcdr >> m_low_beam;
    dcdr >> m_horn;
    dcdr >> m_emergency_light;
}

/*!
 * @brief This function sets a value in member turn_signal
 * @param _turn_signal New value for member turn_signal
 */
void ros2_interface::msg::VehicleSignal::turn_signal(
        int32_t _turn_signal)
{
    m_turn_signal = _turn_signal;
}

/*!
 * @brief This function returns the value of member turn_signal
 * @return Value of member turn_signal
 */
int32_t ros2_interface::msg::VehicleSignal::turn_signal() const
{
    return m_turn_signal;
}

/*!
 * @brief This function returns a reference to member turn_signal
 * @return Reference to member turn_signal
 */
int32_t& ros2_interface::msg::VehicleSignal::turn_signal()
{
    return m_turn_signal;
}

/*!
 * @brief This function sets a value in member high_beam
 * @param _high_beam New value for member high_beam
 */
void ros2_interface::msg::VehicleSignal::high_beam(
        bool _high_beam)
{
    m_high_beam = _high_beam;
}

/*!
 * @brief This function returns the value of member high_beam
 * @return Value of member high_beam
 */
bool ros2_interface::msg::VehicleSignal::high_beam() const
{
    return m_high_beam;
}

/*!
 * @brief This function returns a reference to member high_beam
 * @return Reference to member high_beam
 */
bool& ros2_interface::msg::VehicleSignal::high_beam()
{
    return m_high_beam;
}

/*!
 * @brief This function sets a value in member low_beam
 * @param _low_beam New value for member low_beam
 */
void ros2_interface::msg::VehicleSignal::low_beam(
        bool _low_beam)
{
    m_low_beam = _low_beam;
}

/*!
 * @brief This function returns the value of member low_beam
 * @return Value of member low_beam
 */
bool ros2_interface::msg::VehicleSignal::low_beam() const
{
    return m_low_beam;
}

/*!
 * @brief This function returns a reference to member low_beam
 * @return Reference to member low_beam
 */
bool& ros2_interface::msg::VehicleSignal::low_beam()
{
    return m_low_beam;
}

/*!
 * @brief This function sets a value in member horn
 * @param _horn New value for member horn
 */
void ros2_interface::msg::VehicleSignal::horn(
        bool _horn)
{
    m_horn = _horn;
}

/*!
 * @brief This function returns the value of member horn
 * @return Value of member horn
 */
bool ros2_interface::msg::VehicleSignal::horn() const
{
    return m_horn;
}

/*!
 * @brief This function returns a reference to member horn
 * @return Reference to member horn
 */
bool& ros2_interface::msg::VehicleSignal::horn()
{
    return m_horn;
}

/*!
 * @brief This function sets a value in member emergency_light
 * @param _emergency_light New value for member emergency_light
 */
void ros2_interface::msg::VehicleSignal::emergency_light(
        bool _emergency_light)
{
    m_emergency_light = _emergency_light;
}

/*!
 * @brief This function returns the value of member emergency_light
 * @return Value of member emergency_light
 */
bool ros2_interface::msg::VehicleSignal::emergency_light() const
{
    return m_emergency_light;
}

/*!
 * @brief This function returns a reference to member emergency_light
 * @return Reference to member emergency_light
 */
bool& ros2_interface::msg::VehicleSignal::emergency_light()
{
    return m_emergency_light;
}



size_t ros2_interface::msg::VehicleSignal::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleSignal_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleSignal::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleSignal::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



