// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleSignal.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESIGNAL_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESIGNAL_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(VEHICLESIGNAL_SOURCE)
#define VEHICLESIGNAL_DllAPI __declspec( dllexport )
#else
#define VEHICLESIGNAL_DllAPI __declspec( dllimport )
#endif // VEHICLESIGNAL_SOURCE
#else
#define VEHICLESIGNAL_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define VEHICLESIGNAL_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure VehicleSignal defined by the user in the IDL file.
         * @ingroup VehicleSignal
         */
        class VehicleSignal
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport VehicleSignal();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~VehicleSignal();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleSignal that will be copied.
             */
            eProsima_user_DllExport VehicleSignal(
                    const VehicleSignal& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleSignal that will be copied.
             */
            eProsima_user_DllExport VehicleSignal(
                    VehicleSignal&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleSignal that will be copied.
             */
            eProsima_user_DllExport VehicleSignal& operator =(
                    const VehicleSignal& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleSignal that will be copied.
             */
            eProsima_user_DllExport VehicleSignal& operator =(
                    VehicleSignal&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleSignal object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const VehicleSignal& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleSignal object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const VehicleSignal& x) const;

            /*!
             * @brief This function sets a value in member turn_signal
             * @param _turn_signal New value for member turn_signal
             */
            eProsima_user_DllExport void turn_signal(
                    int32_t _turn_signal);

            /*!
             * @brief This function returns the value of member turn_signal
             * @return Value of member turn_signal
             */
            eProsima_user_DllExport int32_t turn_signal() const;

            /*!
             * @brief This function returns a reference to member turn_signal
             * @return Reference to member turn_signal
             */
            eProsima_user_DllExport int32_t& turn_signal();

            /*!
             * @brief This function sets a value in member high_beam
             * @param _high_beam New value for member high_beam
             */
            eProsima_user_DllExport void high_beam(
                    bool _high_beam);

            /*!
             * @brief This function returns the value of member high_beam
             * @return Value of member high_beam
             */
            eProsima_user_DllExport bool high_beam() const;

            /*!
             * @brief This function returns a reference to member high_beam
             * @return Reference to member high_beam
             */
            eProsima_user_DllExport bool& high_beam();

            /*!
             * @brief This function sets a value in member low_beam
             * @param _low_beam New value for member low_beam
             */
            eProsima_user_DllExport void low_beam(
                    bool _low_beam);

            /*!
             * @brief This function returns the value of member low_beam
             * @return Value of member low_beam
             */
            eProsima_user_DllExport bool low_beam() const;

            /*!
             * @brief This function returns a reference to member low_beam
             * @return Reference to member low_beam
             */
            eProsima_user_DllExport bool& low_beam();

            /*!
             * @brief This function sets a value in member horn
             * @param _horn New value for member horn
             */
            eProsima_user_DllExport void horn(
                    bool _horn);

            /*!
             * @brief This function returns the value of member horn
             * @return Value of member horn
             */
            eProsima_user_DllExport bool horn() const;

            /*!
             * @brief This function returns a reference to member horn
             * @return Reference to member horn
             */
            eProsima_user_DllExport bool& horn();

            /*!
             * @brief This function sets a value in member emergency_light
             * @param _emergency_light New value for member emergency_light
             */
            eProsima_user_DllExport void emergency_light(
                    bool _emergency_light);

            /*!
             * @brief This function returns the value of member emergency_light
             * @return Value of member emergency_light
             */
            eProsima_user_DllExport bool emergency_light() const;

            /*!
             * @brief This function returns a reference to member emergency_light
             * @return Reference to member emergency_light
             */
            eProsima_user_DllExport bool& emergency_light();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::VehicleSignal& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_turn_signal;
            bool m_high_beam;
            bool m_low_beam;
            bool m_horn;
            bool m_emergency_light;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESIGNAL_H_

