// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleSignalTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "VehicleSignal.h"
#include "VehicleSignalTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerVehicleSignalTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::VehicleSignal", ros2_interface::msg::GetVehicleSignalIdentifier(true),
                        ros2_interface::msg::GetVehicleSignalObject(true));
                factory->add_type_object("ros2_interface::msg::VehicleSignal", ros2_interface::msg::GetVehicleSignalIdentifier(false),
                        ros2_interface::msg::GetVehicleSignalObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetVehicleSignalIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("VehicleSignal", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetVehicleSignalObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("VehicleSignal", complete);
        }

        const TypeObject* GetVehicleSignalObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleSignal", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteVehicleSignalObject();
            }
            //else
            return GetMinimalVehicleSignalObject();
        }

        const TypeObject* GetMinimalVehicleSignalObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleSignal", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_turn_signal;
            mst_turn_signal.common().member_id(memberId++);
            mst_turn_signal.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_turn_signal.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_turn_signal.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_turn_signal.common().member_flags().IS_OPTIONAL(false);
            mst_turn_signal.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_turn_signal.common().member_flags().IS_KEY(false);
            mst_turn_signal.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_turn_signal.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 turn_signal_hash("turn_signal");
            for(int i = 0; i < 4; ++i)
            {
                mst_turn_signal.detail().name_hash()[i] = turn_signal_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_turn_signal);

            MinimalStructMember mst_high_beam;
            mst_high_beam.common().member_id(memberId++);
            mst_high_beam.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_high_beam.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_high_beam.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_high_beam.common().member_flags().IS_OPTIONAL(false);
            mst_high_beam.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_high_beam.common().member_flags().IS_KEY(false);
            mst_high_beam.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_high_beam.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 high_beam_hash("high_beam");
            for(int i = 0; i < 4; ++i)
            {
                mst_high_beam.detail().name_hash()[i] = high_beam_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_high_beam);

            MinimalStructMember mst_low_beam;
            mst_low_beam.common().member_id(memberId++);
            mst_low_beam.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_low_beam.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_low_beam.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_low_beam.common().member_flags().IS_OPTIONAL(false);
            mst_low_beam.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_low_beam.common().member_flags().IS_KEY(false);
            mst_low_beam.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_low_beam.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 low_beam_hash("low_beam");
            for(int i = 0; i < 4; ++i)
            {
                mst_low_beam.detail().name_hash()[i] = low_beam_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_low_beam);

            MinimalStructMember mst_horn;
            mst_horn.common().member_id(memberId++);
            mst_horn.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_horn.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_horn.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_horn.common().member_flags().IS_OPTIONAL(false);
            mst_horn.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_horn.common().member_flags().IS_KEY(false);
            mst_horn.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_horn.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 horn_hash("horn");
            for(int i = 0; i < 4; ++i)
            {
                mst_horn.detail().name_hash()[i] = horn_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_horn);

            MinimalStructMember mst_emergency_light;
            mst_emergency_light.common().member_id(memberId++);
            mst_emergency_light.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_emergency_light.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_emergency_light.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_emergency_light.common().member_flags().IS_OPTIONAL(false);
            mst_emergency_light.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_emergency_light.common().member_flags().IS_KEY(false);
            mst_emergency_light.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_emergency_light.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 emergency_light_hash("emergency_light");
            for(int i = 0; i < 4; ++i)
            {
                mst_emergency_light.detail().name_hash()[i] = emergency_light_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_emergency_light);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleSignal", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleSignal", false);
        }

        const TypeObject* GetCompleteVehicleSignalObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleSignal", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_turn_signal;
            cst_turn_signal.common().member_id(memberId++);
            cst_turn_signal.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_turn_signal.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_turn_signal.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_turn_signal.common().member_flags().IS_OPTIONAL(false);
            cst_turn_signal.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_turn_signal.common().member_flags().IS_KEY(false);
            cst_turn_signal.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_turn_signal.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_turn_signal.detail().name("turn_signal");

            type_object->complete().struct_type().member_seq().emplace_back(cst_turn_signal);

            CompleteStructMember cst_high_beam;
            cst_high_beam.common().member_id(memberId++);
            cst_high_beam.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_high_beam.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_high_beam.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_high_beam.common().member_flags().IS_OPTIONAL(false);
            cst_high_beam.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_high_beam.common().member_flags().IS_KEY(false);
            cst_high_beam.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_high_beam.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_high_beam.detail().name("high_beam");

            type_object->complete().struct_type().member_seq().emplace_back(cst_high_beam);

            CompleteStructMember cst_low_beam;
            cst_low_beam.common().member_id(memberId++);
            cst_low_beam.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_low_beam.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_low_beam.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_low_beam.common().member_flags().IS_OPTIONAL(false);
            cst_low_beam.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_low_beam.common().member_flags().IS_KEY(false);
            cst_low_beam.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_low_beam.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_low_beam.detail().name("low_beam");

            type_object->complete().struct_type().member_seq().emplace_back(cst_low_beam);

            CompleteStructMember cst_horn;
            cst_horn.common().member_id(memberId++);
            cst_horn.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_horn.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_horn.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_horn.common().member_flags().IS_OPTIONAL(false);
            cst_horn.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_horn.common().member_flags().IS_KEY(false);
            cst_horn.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_horn.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_horn.detail().name("horn");

            type_object->complete().struct_type().member_seq().emplace_back(cst_horn);

            CompleteStructMember cst_emergency_light;
            cst_emergency_light.common().member_id(memberId++);
            cst_emergency_light.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_emergency_light.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_emergency_light.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_emergency_light.common().member_flags().IS_OPTIONAL(false);
            cst_emergency_light.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_emergency_light.common().member_flags().IS_KEY(false);
            cst_emergency_light.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_emergency_light.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_emergency_light.detail().name("emergency_light");

            type_object->complete().struct_type().member_seq().emplace_back(cst_emergency_light);


            // Header
            type_object->complete().struct_type().header().detail().type_name("VehicleSignal");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleSignal", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleSignal", true);
        }

    } // namespace msg
} // namespace ros2_interface