// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleState.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "VehicleState.h"
#include "VehicleStateTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Point3D_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Quaternion_max_cdr_typesize 32ULL;
#define ros2_interface_msg_PointENU_max_cdr_typesize 24ULL;
#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_Pose_max_cdr_typesize 208ULL;
#define ros2_interface_msg_VehicleState_max_cdr_typesize 600ULL;
#define ros2_interface_msg_Point3D_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Quaternion_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_PointENU_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Pose_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_VehicleState_max_key_cdr_typesize 0ULL;

ros2_interface::msg::VehicleState::VehicleState()
{
    // ros2_interface::msg::Header m_header

    // double m_x
    m_x = 0.0;
    // double m_y
    m_y = 0.0;
    // double m_z
    m_z = 0.0;
    // double m_timestamp
    m_timestamp = 0.0;
    // double m_roll
    m_roll = 0.0;
    // double m_pitch
    m_pitch = 0.0;
    // double m_yaw
    m_yaw = 0.0;
    // double m_heading
    m_heading = 0.0;
    // double m_kappa
    m_kappa = 0.0;
    // double m_linear_velocity
    m_linear_velocity = 0.0;
    // double m_angular_velocity
    m_angular_velocity = 0.0;
    // double m_linear_acceleration
    m_linear_acceleration = 0.0;
    // long m_gear
    m_gear = 0;
    // long m_driving_mode
    m_driving_mode = 0;
    // ros2_interface::msg::Pose m_pose

    // double m_front_steering_value
    m_front_steering_value = 0.0;
    // double m_rear_steering_value
    m_rear_steering_value = 0.0;

    // Just to register all known types
    registerVehicleStateTypes();
}

ros2_interface::msg::VehicleState::~VehicleState()
{


















}

ros2_interface::msg::VehicleState::VehicleState(
        const VehicleState& x)
{
    m_header = x.m_header;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_timestamp = x.m_timestamp;
    m_roll = x.m_roll;
    m_pitch = x.m_pitch;
    m_yaw = x.m_yaw;
    m_heading = x.m_heading;
    m_kappa = x.m_kappa;
    m_linear_velocity = x.m_linear_velocity;
    m_angular_velocity = x.m_angular_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_gear = x.m_gear;
    m_driving_mode = x.m_driving_mode;
    m_pose = x.m_pose;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
}

ros2_interface::msg::VehicleState::VehicleState(
        VehicleState&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_timestamp = x.m_timestamp;
    m_roll = x.m_roll;
    m_pitch = x.m_pitch;
    m_yaw = x.m_yaw;
    m_heading = x.m_heading;
    m_kappa = x.m_kappa;
    m_linear_velocity = x.m_linear_velocity;
    m_angular_velocity = x.m_angular_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_gear = x.m_gear;
    m_driving_mode = x.m_driving_mode;
    m_pose = std::move(x.m_pose);
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;
}

ros2_interface::msg::VehicleState& ros2_interface::msg::VehicleState::operator =(
        const VehicleState& x)
{

    m_header = x.m_header;
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_timestamp = x.m_timestamp;
    m_roll = x.m_roll;
    m_pitch = x.m_pitch;
    m_yaw = x.m_yaw;
    m_heading = x.m_heading;
    m_kappa = x.m_kappa;
    m_linear_velocity = x.m_linear_velocity;
    m_angular_velocity = x.m_angular_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_gear = x.m_gear;
    m_driving_mode = x.m_driving_mode;
    m_pose = x.m_pose;
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;

    return *this;
}

ros2_interface::msg::VehicleState& ros2_interface::msg::VehicleState::operator =(
        VehicleState&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_x = x.m_x;
    m_y = x.m_y;
    m_z = x.m_z;
    m_timestamp = x.m_timestamp;
    m_roll = x.m_roll;
    m_pitch = x.m_pitch;
    m_yaw = x.m_yaw;
    m_heading = x.m_heading;
    m_kappa = x.m_kappa;
    m_linear_velocity = x.m_linear_velocity;
    m_angular_velocity = x.m_angular_velocity;
    m_linear_acceleration = x.m_linear_acceleration;
    m_gear = x.m_gear;
    m_driving_mode = x.m_driving_mode;
    m_pose = std::move(x.m_pose);
    m_front_steering_value = x.m_front_steering_value;
    m_rear_steering_value = x.m_rear_steering_value;

    return *this;
}

bool ros2_interface::msg::VehicleState::operator ==(
        const VehicleState& x) const
{

    return (m_header == x.m_header && m_x == x.m_x && m_y == x.m_y && m_z == x.m_z && m_timestamp == x.m_timestamp && m_roll == x.m_roll && m_pitch == x.m_pitch && m_yaw == x.m_yaw && m_heading == x.m_heading && m_kappa == x.m_kappa && m_linear_velocity == x.m_linear_velocity && m_angular_velocity == x.m_angular_velocity && m_linear_acceleration == x.m_linear_acceleration && m_gear == x.m_gear && m_driving_mode == x.m_driving_mode && m_pose == x.m_pose && m_front_steering_value == x.m_front_steering_value && m_rear_steering_value == x.m_rear_steering_value);
}

bool ros2_interface::msg::VehicleState::operator !=(
        const VehicleState& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::VehicleState::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleState_max_cdr_typesize;
}

size_t ros2_interface::msg::VehicleState::getCdrSerializedSize(
        const ros2_interface::msg::VehicleState& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += ros2_interface::msg::Pose::getCdrSerializedSize(data.pose(), current_alignment);
    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::VehicleState::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_x;
    scdr << m_y;
    scdr << m_z;
    scdr << m_timestamp;
    scdr << m_roll;
    scdr << m_pitch;
    scdr << m_yaw;
    scdr << m_heading;
    scdr << m_kappa;
    scdr << m_linear_velocity;
    scdr << m_angular_velocity;
    scdr << m_linear_acceleration;
    scdr << m_gear;
    scdr << m_driving_mode;
    scdr << m_pose;
    scdr << m_front_steering_value;
    scdr << m_rear_steering_value;

}

void ros2_interface::msg::VehicleState::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_x;
    dcdr >> m_y;
    dcdr >> m_z;
    dcdr >> m_timestamp;
    dcdr >> m_roll;
    dcdr >> m_pitch;
    dcdr >> m_yaw;
    dcdr >> m_heading;
    dcdr >> m_kappa;
    dcdr >> m_linear_velocity;
    dcdr >> m_angular_velocity;
    dcdr >> m_linear_acceleration;
    dcdr >> m_gear;
    dcdr >> m_driving_mode;
    dcdr >> m_pose;
    dcdr >> m_front_steering_value;
    dcdr >> m_rear_steering_value;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::VehicleState::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::VehicleState::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::VehicleState::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::VehicleState::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member x
 * @param _x New value for member x
 */
void ros2_interface::msg::VehicleState::x(
        double _x)
{
    m_x = _x;
}

/*!
 * @brief This function returns the value of member x
 * @return Value of member x
 */
double ros2_interface::msg::VehicleState::x() const
{
    return m_x;
}

/*!
 * @brief This function returns a reference to member x
 * @return Reference to member x
 */
double& ros2_interface::msg::VehicleState::x()
{
    return m_x;
}

/*!
 * @brief This function sets a value in member y
 * @param _y New value for member y
 */
void ros2_interface::msg::VehicleState::y(
        double _y)
{
    m_y = _y;
}

/*!
 * @brief This function returns the value of member y
 * @return Value of member y
 */
double ros2_interface::msg::VehicleState::y() const
{
    return m_y;
}

/*!
 * @brief This function returns a reference to member y
 * @return Reference to member y
 */
double& ros2_interface::msg::VehicleState::y()
{
    return m_y;
}

/*!
 * @brief This function sets a value in member z
 * @param _z New value for member z
 */
void ros2_interface::msg::VehicleState::z(
        double _z)
{
    m_z = _z;
}

/*!
 * @brief This function returns the value of member z
 * @return Value of member z
 */
double ros2_interface::msg::VehicleState::z() const
{
    return m_z;
}

/*!
 * @brief This function returns a reference to member z
 * @return Reference to member z
 */
double& ros2_interface::msg::VehicleState::z()
{
    return m_z;
}

/*!
 * @brief This function sets a value in member timestamp
 * @param _timestamp New value for member timestamp
 */
void ros2_interface::msg::VehicleState::timestamp(
        double _timestamp)
{
    m_timestamp = _timestamp;
}

/*!
 * @brief This function returns the value of member timestamp
 * @return Value of member timestamp
 */
double ros2_interface::msg::VehicleState::timestamp() const
{
    return m_timestamp;
}

/*!
 * @brief This function returns a reference to member timestamp
 * @return Reference to member timestamp
 */
double& ros2_interface::msg::VehicleState::timestamp()
{
    return m_timestamp;
}

/*!
 * @brief This function sets a value in member roll
 * @param _roll New value for member roll
 */
void ros2_interface::msg::VehicleState::roll(
        double _roll)
{
    m_roll = _roll;
}

/*!
 * @brief This function returns the value of member roll
 * @return Value of member roll
 */
double ros2_interface::msg::VehicleState::roll() const
{
    return m_roll;
}

/*!
 * @brief This function returns a reference to member roll
 * @return Reference to member roll
 */
double& ros2_interface::msg::VehicleState::roll()
{
    return m_roll;
}

/*!
 * @brief This function sets a value in member pitch
 * @param _pitch New value for member pitch
 */
void ros2_interface::msg::VehicleState::pitch(
        double _pitch)
{
    m_pitch = _pitch;
}

/*!
 * @brief This function returns the value of member pitch
 * @return Value of member pitch
 */
double ros2_interface::msg::VehicleState::pitch() const
{
    return m_pitch;
}

/*!
 * @brief This function returns a reference to member pitch
 * @return Reference to member pitch
 */
double& ros2_interface::msg::VehicleState::pitch()
{
    return m_pitch;
}

/*!
 * @brief This function sets a value in member yaw
 * @param _yaw New value for member yaw
 */
void ros2_interface::msg::VehicleState::yaw(
        double _yaw)
{
    m_yaw = _yaw;
}

/*!
 * @brief This function returns the value of member yaw
 * @return Value of member yaw
 */
double ros2_interface::msg::VehicleState::yaw() const
{
    return m_yaw;
}

/*!
 * @brief This function returns a reference to member yaw
 * @return Reference to member yaw
 */
double& ros2_interface::msg::VehicleState::yaw()
{
    return m_yaw;
}

/*!
 * @brief This function sets a value in member heading
 * @param _heading New value for member heading
 */
void ros2_interface::msg::VehicleState::heading(
        double _heading)
{
    m_heading = _heading;
}

/*!
 * @brief This function returns the value of member heading
 * @return Value of member heading
 */
double ros2_interface::msg::VehicleState::heading() const
{
    return m_heading;
}

/*!
 * @brief This function returns a reference to member heading
 * @return Reference to member heading
 */
double& ros2_interface::msg::VehicleState::heading()
{
    return m_heading;
}

/*!
 * @brief This function sets a value in member kappa
 * @param _kappa New value for member kappa
 */
void ros2_interface::msg::VehicleState::kappa(
        double _kappa)
{
    m_kappa = _kappa;
}

/*!
 * @brief This function returns the value of member kappa
 * @return Value of member kappa
 */
double ros2_interface::msg::VehicleState::kappa() const
{
    return m_kappa;
}

/*!
 * @brief This function returns a reference to member kappa
 * @return Reference to member kappa
 */
double& ros2_interface::msg::VehicleState::kappa()
{
    return m_kappa;
}

/*!
 * @brief This function sets a value in member linear_velocity
 * @param _linear_velocity New value for member linear_velocity
 */
void ros2_interface::msg::VehicleState::linear_velocity(
        double _linear_velocity)
{
    m_linear_velocity = _linear_velocity;
}

/*!
 * @brief This function returns the value of member linear_velocity
 * @return Value of member linear_velocity
 */
double ros2_interface::msg::VehicleState::linear_velocity() const
{
    return m_linear_velocity;
}

/*!
 * @brief This function returns a reference to member linear_velocity
 * @return Reference to member linear_velocity
 */
double& ros2_interface::msg::VehicleState::linear_velocity()
{
    return m_linear_velocity;
}

/*!
 * @brief This function sets a value in member angular_velocity
 * @param _angular_velocity New value for member angular_velocity
 */
void ros2_interface::msg::VehicleState::angular_velocity(
        double _angular_velocity)
{
    m_angular_velocity = _angular_velocity;
}

/*!
 * @brief This function returns the value of member angular_velocity
 * @return Value of member angular_velocity
 */
double ros2_interface::msg::VehicleState::angular_velocity() const
{
    return m_angular_velocity;
}

/*!
 * @brief This function returns a reference to member angular_velocity
 * @return Reference to member angular_velocity
 */
double& ros2_interface::msg::VehicleState::angular_velocity()
{
    return m_angular_velocity;
}

/*!
 * @brief This function sets a value in member linear_acceleration
 * @param _linear_acceleration New value for member linear_acceleration
 */
void ros2_interface::msg::VehicleState::linear_acceleration(
        double _linear_acceleration)
{
    m_linear_acceleration = _linear_acceleration;
}

/*!
 * @brief This function returns the value of member linear_acceleration
 * @return Value of member linear_acceleration
 */
double ros2_interface::msg::VehicleState::linear_acceleration() const
{
    return m_linear_acceleration;
}

/*!
 * @brief This function returns a reference to member linear_acceleration
 * @return Reference to member linear_acceleration
 */
double& ros2_interface::msg::VehicleState::linear_acceleration()
{
    return m_linear_acceleration;
}

/*!
 * @brief This function sets a value in member gear
 * @param _gear New value for member gear
 */
void ros2_interface::msg::VehicleState::gear(
        int32_t _gear)
{
    m_gear = _gear;
}

/*!
 * @brief This function returns the value of member gear
 * @return Value of member gear
 */
int32_t ros2_interface::msg::VehicleState::gear() const
{
    return m_gear;
}

/*!
 * @brief This function returns a reference to member gear
 * @return Reference to member gear
 */
int32_t& ros2_interface::msg::VehicleState::gear()
{
    return m_gear;
}

/*!
 * @brief This function sets a value in member driving_mode
 * @param _driving_mode New value for member driving_mode
 */
void ros2_interface::msg::VehicleState::driving_mode(
        int32_t _driving_mode)
{
    m_driving_mode = _driving_mode;
}

/*!
 * @brief This function returns the value of member driving_mode
 * @return Value of member driving_mode
 */
int32_t ros2_interface::msg::VehicleState::driving_mode() const
{
    return m_driving_mode;
}

/*!
 * @brief This function returns a reference to member driving_mode
 * @return Reference to member driving_mode
 */
int32_t& ros2_interface::msg::VehicleState::driving_mode()
{
    return m_driving_mode;
}

/*!
 * @brief This function copies the value in member pose
 * @param _pose New value to be copied in member pose
 */
void ros2_interface::msg::VehicleState::pose(
        const ros2_interface::msg::Pose& _pose)
{
    m_pose = _pose;
}

/*!
 * @brief This function moves the value in member pose
 * @param _pose New value to be moved in member pose
 */
void ros2_interface::msg::VehicleState::pose(
        ros2_interface::msg::Pose&& _pose)
{
    m_pose = std::move(_pose);
}

/*!
 * @brief This function returns a constant reference to member pose
 * @return Constant reference to member pose
 */
const ros2_interface::msg::Pose& ros2_interface::msg::VehicleState::pose() const
{
    return m_pose;
}

/*!
 * @brief This function returns a reference to member pose
 * @return Reference to member pose
 */
ros2_interface::msg::Pose& ros2_interface::msg::VehicleState::pose()
{
    return m_pose;
}
/*!
 * @brief This function sets a value in member front_steering_value
 * @param _front_steering_value New value for member front_steering_value
 */
void ros2_interface::msg::VehicleState::front_steering_value(
        double _front_steering_value)
{
    m_front_steering_value = _front_steering_value;
}

/*!
 * @brief This function returns the value of member front_steering_value
 * @return Value of member front_steering_value
 */
double ros2_interface::msg::VehicleState::front_steering_value() const
{
    return m_front_steering_value;
}

/*!
 * @brief This function returns a reference to member front_steering_value
 * @return Reference to member front_steering_value
 */
double& ros2_interface::msg::VehicleState::front_steering_value()
{
    return m_front_steering_value;
}

/*!
 * @brief This function sets a value in member rear_steering_value
 * @param _rear_steering_value New value for member rear_steering_value
 */
void ros2_interface::msg::VehicleState::rear_steering_value(
        double _rear_steering_value)
{
    m_rear_steering_value = _rear_steering_value;
}

/*!
 * @brief This function returns the value of member rear_steering_value
 * @return Value of member rear_steering_value
 */
double ros2_interface::msg::VehicleState::rear_steering_value() const
{
    return m_rear_steering_value;
}

/*!
 * @brief This function returns a reference to member rear_steering_value
 * @return Reference to member rear_steering_value
 */
double& ros2_interface::msg::VehicleState::rear_steering_value()
{
    return m_rear_steering_value;
}



size_t ros2_interface::msg::VehicleState::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_VehicleState_max_key_cdr_typesize;
}

bool ros2_interface::msg::VehicleState::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::VehicleState::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



