// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleState.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESTATE_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESTATE_H_

#include "Header.h"
#include "Pose.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(VEHICLESTATE_SOURCE)
#define VEHICLESTATE_DllAPI __declspec( dllexport )
#else
#define VEHICLESTATE_DllAPI __declspec( dllimport )
#endif // VEHICLESTATE_SOURCE
#else
#define VEHICLESTATE_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define VEHICLESTATE_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure VehicleState defined by the user in the IDL file.
         * @ingroup VehicleState
         */
        class VehicleState
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport VehicleState();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~VehicleState();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleState that will be copied.
             */
            eProsima_user_DllExport VehicleState(
                    const VehicleState& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::VehicleState that will be copied.
             */
            eProsima_user_DllExport VehicleState(
                    VehicleState&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleState that will be copied.
             */
            eProsima_user_DllExport VehicleState& operator =(
                    const VehicleState& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::VehicleState that will be copied.
             */
            eProsima_user_DllExport VehicleState& operator =(
                    VehicleState&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleState object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const VehicleState& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::VehicleState object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const VehicleState& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member x
             * @param _x New value for member x
             */
            eProsima_user_DllExport void x(
                    double _x);

            /*!
             * @brief This function returns the value of member x
             * @return Value of member x
             */
            eProsima_user_DllExport double x() const;

            /*!
             * @brief This function returns a reference to member x
             * @return Reference to member x
             */
            eProsima_user_DllExport double& x();

            /*!
             * @brief This function sets a value in member y
             * @param _y New value for member y
             */
            eProsima_user_DllExport void y(
                    double _y);

            /*!
             * @brief This function returns the value of member y
             * @return Value of member y
             */
            eProsima_user_DllExport double y() const;

            /*!
             * @brief This function returns a reference to member y
             * @return Reference to member y
             */
            eProsima_user_DllExport double& y();

            /*!
             * @brief This function sets a value in member z
             * @param _z New value for member z
             */
            eProsima_user_DllExport void z(
                    double _z);

            /*!
             * @brief This function returns the value of member z
             * @return Value of member z
             */
            eProsima_user_DllExport double z() const;

            /*!
             * @brief This function returns a reference to member z
             * @return Reference to member z
             */
            eProsima_user_DllExport double& z();

            /*!
             * @brief This function sets a value in member timestamp
             * @param _timestamp New value for member timestamp
             */
            eProsima_user_DllExport void timestamp(
                    double _timestamp);

            /*!
             * @brief This function returns the value of member timestamp
             * @return Value of member timestamp
             */
            eProsima_user_DllExport double timestamp() const;

            /*!
             * @brief This function returns a reference to member timestamp
             * @return Reference to member timestamp
             */
            eProsima_user_DllExport double& timestamp();

            /*!
             * @brief This function sets a value in member roll
             * @param _roll New value for member roll
             */
            eProsima_user_DllExport void roll(
                    double _roll);

            /*!
             * @brief This function returns the value of member roll
             * @return Value of member roll
             */
            eProsima_user_DllExport double roll() const;

            /*!
             * @brief This function returns a reference to member roll
             * @return Reference to member roll
             */
            eProsima_user_DllExport double& roll();

            /*!
             * @brief This function sets a value in member pitch
             * @param _pitch New value for member pitch
             */
            eProsima_user_DllExport void pitch(
                    double _pitch);

            /*!
             * @brief This function returns the value of member pitch
             * @return Value of member pitch
             */
            eProsima_user_DllExport double pitch() const;

            /*!
             * @brief This function returns a reference to member pitch
             * @return Reference to member pitch
             */
            eProsima_user_DllExport double& pitch();

            /*!
             * @brief This function sets a value in member yaw
             * @param _yaw New value for member yaw
             */
            eProsima_user_DllExport void yaw(
                    double _yaw);

            /*!
             * @brief This function returns the value of member yaw
             * @return Value of member yaw
             */
            eProsima_user_DllExport double yaw() const;

            /*!
             * @brief This function returns a reference to member yaw
             * @return Reference to member yaw
             */
            eProsima_user_DllExport double& yaw();

            /*!
             * @brief This function sets a value in member heading
             * @param _heading New value for member heading
             */
            eProsima_user_DllExport void heading(
                    double _heading);

            /*!
             * @brief This function returns the value of member heading
             * @return Value of member heading
             */
            eProsima_user_DllExport double heading() const;

            /*!
             * @brief This function returns a reference to member heading
             * @return Reference to member heading
             */
            eProsima_user_DllExport double& heading();

            /*!
             * @brief This function sets a value in member kappa
             * @param _kappa New value for member kappa
             */
            eProsima_user_DllExport void kappa(
                    double _kappa);

            /*!
             * @brief This function returns the value of member kappa
             * @return Value of member kappa
             */
            eProsima_user_DllExport double kappa() const;

            /*!
             * @brief This function returns a reference to member kappa
             * @return Reference to member kappa
             */
            eProsima_user_DllExport double& kappa();

            /*!
             * @brief This function sets a value in member linear_velocity
             * @param _linear_velocity New value for member linear_velocity
             */
            eProsima_user_DllExport void linear_velocity(
                    double _linear_velocity);

            /*!
             * @brief This function returns the value of member linear_velocity
             * @return Value of member linear_velocity
             */
            eProsima_user_DllExport double linear_velocity() const;

            /*!
             * @brief This function returns a reference to member linear_velocity
             * @return Reference to member linear_velocity
             */
            eProsima_user_DllExport double& linear_velocity();

            /*!
             * @brief This function sets a value in member angular_velocity
             * @param _angular_velocity New value for member angular_velocity
             */
            eProsima_user_DllExport void angular_velocity(
                    double _angular_velocity);

            /*!
             * @brief This function returns the value of member angular_velocity
             * @return Value of member angular_velocity
             */
            eProsima_user_DllExport double angular_velocity() const;

            /*!
             * @brief This function returns a reference to member angular_velocity
             * @return Reference to member angular_velocity
             */
            eProsima_user_DllExport double& angular_velocity();

            /*!
             * @brief This function sets a value in member linear_acceleration
             * @param _linear_acceleration New value for member linear_acceleration
             */
            eProsima_user_DllExport void linear_acceleration(
                    double _linear_acceleration);

            /*!
             * @brief This function returns the value of member linear_acceleration
             * @return Value of member linear_acceleration
             */
            eProsima_user_DllExport double linear_acceleration() const;

            /*!
             * @brief This function returns a reference to member linear_acceleration
             * @return Reference to member linear_acceleration
             */
            eProsima_user_DllExport double& linear_acceleration();

            /*!
             * @brief This function sets a value in member gear
             * @param _gear New value for member gear
             */
            eProsima_user_DllExport void gear(
                    int32_t _gear);

            /*!
             * @brief This function returns the value of member gear
             * @return Value of member gear
             */
            eProsima_user_DllExport int32_t gear() const;

            /*!
             * @brief This function returns a reference to member gear
             * @return Reference to member gear
             */
            eProsima_user_DllExport int32_t& gear();

            /*!
             * @brief This function sets a value in member driving_mode
             * @param _driving_mode New value for member driving_mode
             */
            eProsima_user_DllExport void driving_mode(
                    int32_t _driving_mode);

            /*!
             * @brief This function returns the value of member driving_mode
             * @return Value of member driving_mode
             */
            eProsima_user_DllExport int32_t driving_mode() const;

            /*!
             * @brief This function returns a reference to member driving_mode
             * @return Reference to member driving_mode
             */
            eProsima_user_DllExport int32_t& driving_mode();

            /*!
             * @brief This function copies the value in member pose
             * @param _pose New value to be copied in member pose
             */
            eProsima_user_DllExport void pose(
                    const ros2_interface::msg::Pose& _pose);

            /*!
             * @brief This function moves the value in member pose
             * @param _pose New value to be moved in member pose
             */
            eProsima_user_DllExport void pose(
                    ros2_interface::msg::Pose&& _pose);

            /*!
             * @brief This function returns a constant reference to member pose
             * @return Constant reference to member pose
             */
            eProsima_user_DllExport const ros2_interface::msg::Pose& pose() const;

            /*!
             * @brief This function returns a reference to member pose
             * @return Reference to member pose
             */
            eProsima_user_DllExport ros2_interface::msg::Pose& pose();
            /*!
             * @brief This function sets a value in member front_steering_value
             * @param _front_steering_value New value for member front_steering_value
             */
            eProsima_user_DllExport void front_steering_value(
                    double _front_steering_value);

            /*!
             * @brief This function returns the value of member front_steering_value
             * @return Value of member front_steering_value
             */
            eProsima_user_DllExport double front_steering_value() const;

            /*!
             * @brief This function returns a reference to member front_steering_value
             * @return Reference to member front_steering_value
             */
            eProsima_user_DllExport double& front_steering_value();

            /*!
             * @brief This function sets a value in member rear_steering_value
             * @param _rear_steering_value New value for member rear_steering_value
             */
            eProsima_user_DllExport void rear_steering_value(
                    double _rear_steering_value);

            /*!
             * @brief This function returns the value of member rear_steering_value
             * @return Value of member rear_steering_value
             */
            eProsima_user_DllExport double rear_steering_value() const;

            /*!
             * @brief This function returns a reference to member rear_steering_value
             * @return Reference to member rear_steering_value
             */
            eProsima_user_DllExport double& rear_steering_value();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::VehicleState& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            double m_x;
            double m_y;
            double m_z;
            double m_timestamp;
            double m_roll;
            double m_pitch;
            double m_yaw;
            double m_heading;
            double m_kappa;
            double m_linear_velocity;
            double m_angular_velocity;
            double m_linear_acceleration;
            int32_t m_gear;
            int32_t m_driving_mode;
            ros2_interface::msg::Pose m_pose;
            double m_front_steering_value;
            double m_rear_steering_value;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_VEHICLESTATE_H_

