// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleStateTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "VehicleState.h"
#include "VehicleStateTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerVehicleStateTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(true),
                        ros2_interface::msg::GetPoint3DObject(true));
                factory->add_type_object("ros2_interface::msg::Point3D", ros2_interface::msg::GetPoint3DIdentifier(false),
                        ros2_interface::msg::GetPoint3DObject(false));



                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(true),
                        ros2_interface::msg::GetPointENUObject(true));
                factory->add_type_object("ros2_interface::msg::PointENU", ros2_interface::msg::GetPointENUIdentifier(false),
                        ros2_interface::msg::GetPointENUObject(false));



                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(true),
                        ros2_interface::msg::GetQuaternionObject(true));
                factory->add_type_object("ros2_interface::msg::Quaternion", ros2_interface::msg::GetQuaternionIdentifier(false),
                        ros2_interface::msg::GetQuaternionObject(false));



                factory->add_type_object("ros2_interface::msg::Pose", ros2_interface::msg::GetPoseIdentifier(true),
                        ros2_interface::msg::GetPoseObject(true));
                factory->add_type_object("ros2_interface::msg::Pose", ros2_interface::msg::GetPoseIdentifier(false),
                        ros2_interface::msg::GetPoseObject(false));



                factory->add_type_object("ros2_interface::msg::VehicleState", ros2_interface::msg::GetVehicleStateIdentifier(true),
                        ros2_interface::msg::GetVehicleStateObject(true));
                factory->add_type_object("ros2_interface::msg::VehicleState", ros2_interface::msg::GetVehicleStateIdentifier(false),
                        ros2_interface::msg::GetVehicleStateObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetVehicleStateIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("VehicleState", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetVehicleStateObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("VehicleState", complete);
        }

        const TypeObject* GetVehicleStateObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleState", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteVehicleStateObject();
            }
            //else
            return GetMinimalVehicleStateObject();
        }

        const TypeObject* GetMinimalVehicleStateObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleState", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_x;
            mst_x.common().member_id(memberId++);
            mst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_x.common().member_flags().IS_OPTIONAL(false);
            mst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_x.common().member_flags().IS_KEY(false);
            mst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 x_hash("x");
            for(int i = 0; i < 4; ++i)
            {
                mst_x.detail().name_hash()[i] = x_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_x);

            MinimalStructMember mst_y;
            mst_y.common().member_id(memberId++);
            mst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_y.common().member_flags().IS_OPTIONAL(false);
            mst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_y.common().member_flags().IS_KEY(false);
            mst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 y_hash("y");
            for(int i = 0; i < 4; ++i)
            {
                mst_y.detail().name_hash()[i] = y_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_y);

            MinimalStructMember mst_z;
            mst_z.common().member_id(memberId++);
            mst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_z.common().member_flags().IS_OPTIONAL(false);
            mst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_z.common().member_flags().IS_KEY(false);
            mst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 z_hash("z");
            for(int i = 0; i < 4; ++i)
            {
                mst_z.detail().name_hash()[i] = z_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_z);

            MinimalStructMember mst_timestamp;
            mst_timestamp.common().member_id(memberId++);
            mst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_timestamp.common().member_flags().IS_OPTIONAL(false);
            mst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_timestamp.common().member_flags().IS_KEY(false);
            mst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 timestamp_hash("timestamp");
            for(int i = 0; i < 4; ++i)
            {
                mst_timestamp.detail().name_hash()[i] = timestamp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_timestamp);

            MinimalStructMember mst_roll;
            mst_roll.common().member_id(memberId++);
            mst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_roll.common().member_flags().IS_OPTIONAL(false);
            mst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_roll.common().member_flags().IS_KEY(false);
            mst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 roll_hash("roll");
            for(int i = 0; i < 4; ++i)
            {
                mst_roll.detail().name_hash()[i] = roll_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_roll);

            MinimalStructMember mst_pitch;
            mst_pitch.common().member_id(memberId++);
            mst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pitch.common().member_flags().IS_OPTIONAL(false);
            mst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pitch.common().member_flags().IS_KEY(false);
            mst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 pitch_hash("pitch");
            for(int i = 0; i < 4; ++i)
            {
                mst_pitch.detail().name_hash()[i] = pitch_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pitch);

            MinimalStructMember mst_yaw;
            mst_yaw.common().member_id(memberId++);
            mst_yaw.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_yaw.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_yaw.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_yaw.common().member_flags().IS_OPTIONAL(false);
            mst_yaw.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_yaw.common().member_flags().IS_KEY(false);
            mst_yaw.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_yaw.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 yaw_hash("yaw");
            for(int i = 0; i < 4; ++i)
            {
                mst_yaw.detail().name_hash()[i] = yaw_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_yaw);

            MinimalStructMember mst_heading;
            mst_heading.common().member_id(memberId++);
            mst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_heading.common().member_flags().IS_OPTIONAL(false);
            mst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_heading.common().member_flags().IS_KEY(false);
            mst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 heading_hash("heading");
            for(int i = 0; i < 4; ++i)
            {
                mst_heading.detail().name_hash()[i] = heading_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_heading);

            MinimalStructMember mst_kappa;
            mst_kappa.common().member_id(memberId++);
            mst_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_kappa.common().member_flags().IS_OPTIONAL(false);
            mst_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_kappa.common().member_flags().IS_KEY(false);
            mst_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 kappa_hash("kappa");
            for(int i = 0; i < 4; ++i)
            {
                mst_kappa.detail().name_hash()[i] = kappa_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_kappa);

            MinimalStructMember mst_linear_velocity;
            mst_linear_velocity.common().member_id(memberId++);
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_velocity.common().member_flags().IS_KEY(false);
            mst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 linear_velocity_hash("linear_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_velocity.detail().name_hash()[i] = linear_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_velocity);

            MinimalStructMember mst_angular_velocity;
            mst_angular_velocity.common().member_id(memberId++);
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            mst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_angular_velocity.common().member_flags().IS_KEY(false);
            mst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_angular_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 angular_velocity_hash("angular_velocity");
            for(int i = 0; i < 4; ++i)
            {
                mst_angular_velocity.detail().name_hash()[i] = angular_velocity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_angular_velocity);

            MinimalStructMember mst_linear_acceleration;
            mst_linear_acceleration.common().member_id(memberId++);
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            mst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_linear_acceleration.common().member_flags().IS_KEY(false);
            mst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_linear_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 linear_acceleration_hash("linear_acceleration");
            for(int i = 0; i < 4; ++i)
            {
                mst_linear_acceleration.detail().name_hash()[i] = linear_acceleration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_linear_acceleration);

            MinimalStructMember mst_gear;
            mst_gear.common().member_id(memberId++);
            mst_gear.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear.common().member_flags().IS_OPTIONAL(false);
            mst_gear.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear.common().member_flags().IS_KEY(false);
            mst_gear.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_hash("gear");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear.detail().name_hash()[i] = gear_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear);

            MinimalStructMember mst_driving_mode;
            mst_driving_mode.common().member_id(memberId++);
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_mode.common().member_flags().IS_KEY(false);
            mst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 driving_mode_hash("driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_mode.detail().name_hash()[i] = driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_mode);

            MinimalStructMember mst_pose;
            mst_pose.common().member_id(memberId++);
            mst_pose.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_pose.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_pose.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_pose.common().member_flags().IS_OPTIONAL(false);
            mst_pose.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_pose.common().member_flags().IS_KEY(false);
            mst_pose.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_pose.common().member_type_id(*ros2_interface::msg::GetPoseIdentifier(false));
            MD5 pose_hash("pose");
            for(int i = 0; i < 4; ++i)
            {
                mst_pose.detail().name_hash()[i] = pose_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_pose);

            MinimalStructMember mst_front_steering_value;
            mst_front_steering_value.common().member_id(memberId++);
            mst_front_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_value.common().member_flags().IS_KEY(false);
            mst_front_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_value_hash("front_steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_value.detail().name_hash()[i] = front_steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_value);

            MinimalStructMember mst_rear_steering_value;
            mst_rear_steering_value.common().member_id(memberId++);
            mst_rear_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_value.common().member_flags().IS_KEY(false);
            mst_rear_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_value_hash("rear_steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_value.detail().name_hash()[i] = rear_steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_value);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleState", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleState", false);
        }

        const TypeObject* GetCompleteVehicleStateObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("VehicleState", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_x;
            cst_x.common().member_id(memberId++);
            cst_x.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_x.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_x.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_x.common().member_flags().IS_OPTIONAL(false);
            cst_x.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_x.common().member_flags().IS_KEY(false);
            cst_x.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_x.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_x.detail().name("x");

            type_object->complete().struct_type().member_seq().emplace_back(cst_x);

            CompleteStructMember cst_y;
            cst_y.common().member_id(memberId++);
            cst_y.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_y.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_y.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_y.common().member_flags().IS_OPTIONAL(false);
            cst_y.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_y.common().member_flags().IS_KEY(false);
            cst_y.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_y.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_y.detail().name("y");

            type_object->complete().struct_type().member_seq().emplace_back(cst_y);

            CompleteStructMember cst_z;
            cst_z.common().member_id(memberId++);
            cst_z.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_z.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_z.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_z.common().member_flags().IS_OPTIONAL(false);
            cst_z.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_z.common().member_flags().IS_KEY(false);
            cst_z.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_z.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_z.detail().name("z");

            type_object->complete().struct_type().member_seq().emplace_back(cst_z);

            CompleteStructMember cst_timestamp;
            cst_timestamp.common().member_id(memberId++);
            cst_timestamp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_timestamp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_timestamp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_timestamp.common().member_flags().IS_OPTIONAL(false);
            cst_timestamp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_timestamp.common().member_flags().IS_KEY(false);
            cst_timestamp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_timestamp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_timestamp.detail().name("timestamp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_timestamp);

            CompleteStructMember cst_roll;
            cst_roll.common().member_id(memberId++);
            cst_roll.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_roll.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_roll.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_roll.common().member_flags().IS_OPTIONAL(false);
            cst_roll.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_roll.common().member_flags().IS_KEY(false);
            cst_roll.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_roll.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_roll.detail().name("roll");

            type_object->complete().struct_type().member_seq().emplace_back(cst_roll);

            CompleteStructMember cst_pitch;
            cst_pitch.common().member_id(memberId++);
            cst_pitch.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pitch.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pitch.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pitch.common().member_flags().IS_OPTIONAL(false);
            cst_pitch.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pitch.common().member_flags().IS_KEY(false);
            cst_pitch.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pitch.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_pitch.detail().name("pitch");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pitch);

            CompleteStructMember cst_yaw;
            cst_yaw.common().member_id(memberId++);
            cst_yaw.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_yaw.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_yaw.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_yaw.common().member_flags().IS_OPTIONAL(false);
            cst_yaw.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_yaw.common().member_flags().IS_KEY(false);
            cst_yaw.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_yaw.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_yaw.detail().name("yaw");

            type_object->complete().struct_type().member_seq().emplace_back(cst_yaw);

            CompleteStructMember cst_heading;
            cst_heading.common().member_id(memberId++);
            cst_heading.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_heading.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_heading.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_heading.common().member_flags().IS_OPTIONAL(false);
            cst_heading.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_heading.common().member_flags().IS_KEY(false);
            cst_heading.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_heading.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_heading.detail().name("heading");

            type_object->complete().struct_type().member_seq().emplace_back(cst_heading);

            CompleteStructMember cst_kappa;
            cst_kappa.common().member_id(memberId++);
            cst_kappa.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_kappa.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_kappa.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_kappa.common().member_flags().IS_OPTIONAL(false);
            cst_kappa.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_kappa.common().member_flags().IS_KEY(false);
            cst_kappa.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_kappa.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_kappa.detail().name("kappa");

            type_object->complete().struct_type().member_seq().emplace_back(cst_kappa);

            CompleteStructMember cst_linear_velocity;
            cst_linear_velocity.common().member_id(memberId++);
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_linear_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_velocity.common().member_flags().IS_KEY(false);
            cst_linear_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_linear_velocity.detail().name("linear_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_velocity);

            CompleteStructMember cst_angular_velocity;
            cst_angular_velocity.common().member_id(memberId++);
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_angular_velocity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_angular_velocity.common().member_flags().IS_OPTIONAL(false);
            cst_angular_velocity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_angular_velocity.common().member_flags().IS_KEY(false);
            cst_angular_velocity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_angular_velocity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_angular_velocity.detail().name("angular_velocity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_angular_velocity);

            CompleteStructMember cst_linear_acceleration;
            cst_linear_acceleration.common().member_id(memberId++);
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_linear_acceleration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_linear_acceleration.common().member_flags().IS_OPTIONAL(false);
            cst_linear_acceleration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_linear_acceleration.common().member_flags().IS_KEY(false);
            cst_linear_acceleration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_linear_acceleration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_linear_acceleration.detail().name("linear_acceleration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_linear_acceleration);

            CompleteStructMember cst_gear;
            cst_gear.common().member_id(memberId++);
            cst_gear.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear.common().member_flags().IS_OPTIONAL(false);
            cst_gear.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear.common().member_flags().IS_KEY(false);
            cst_gear.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear.detail().name("gear");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear);

            CompleteStructMember cst_driving_mode;
            cst_driving_mode.common().member_id(memberId++);
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_mode.common().member_flags().IS_KEY(false);
            cst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_driving_mode.detail().name("driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_mode);

            CompleteStructMember cst_pose;
            cst_pose.common().member_id(memberId++);
            cst_pose.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_pose.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_pose.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_pose.common().member_flags().IS_OPTIONAL(false);
            cst_pose.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_pose.common().member_flags().IS_KEY(false);
            cst_pose.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_pose.common().member_type_id(*ros2_interface::msg::GetPoseIdentifier(true));
            cst_pose.detail().name("pose");

            type_object->complete().struct_type().member_seq().emplace_back(cst_pose);

            CompleteStructMember cst_front_steering_value;
            cst_front_steering_value.common().member_id(memberId++);
            cst_front_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_value.common().member_flags().IS_KEY(false);
            cst_front_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_value.detail().name("front_steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_value);

            CompleteStructMember cst_rear_steering_value;
            cst_rear_steering_value.common().member_id(memberId++);
            cst_rear_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_value.common().member_flags().IS_KEY(false);
            cst_rear_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_value.detail().name("rear_steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_value);


            // Header
            type_object->complete().struct_type().header().detail().type_name("VehicleState");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("VehicleState", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("VehicleState", true);
        }

    } // namespace msg
} // namespace ros2_interface