// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file VehicleTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Vehicle.h"
#include "VehicleTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerVehicleTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Vehicle", ros2_interface::msg::GetVehicleIdentifier(true),
                        ros2_interface::msg::GetVehicleObject(true));
                factory->add_type_object("ros2_interface::msg::Vehicle", ros2_interface::msg::GetVehicleIdentifier(false),
                        ros2_interface::msg::GetVehicleObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetVehicleIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Vehicle", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetVehicleObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Vehicle", complete);
        }

        const TypeObject* GetVehicleObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Vehicle", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteVehicleObject();
            }
            //else
            return GetMinimalVehicleObject();
        }

        const TypeObject* GetMinimalVehicleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Vehicle", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_vehicle_type;
            mst_vehicle_type.common().member_id(memberId++);
            mst_vehicle_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_vehicle_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_vehicle_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_vehicle_type.common().member_flags().IS_OPTIONAL(false);
            mst_vehicle_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_vehicle_type.common().member_flags().IS_KEY(false);
            mst_vehicle_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_vehicle_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 vehicle_type_hash("vehicle_type");
            for(int i = 0; i < 4; ++i)
            {
                mst_vehicle_type.detail().name_hash()[i] = vehicle_type_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_vehicle_type);

            MinimalStructMember mst_vid;
            mst_vid.common().member_id(memberId++);
            mst_vid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_vid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_vid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_vid.common().member_flags().IS_OPTIONAL(false);
            mst_vid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_vid.common().member_flags().IS_KEY(false);
            mst_vid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_vid.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 vid_hash("vid");
            for(int i = 0; i < 4; ++i)
            {
                mst_vid.detail().name_hash()[i] = vid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_vid);

            MinimalStructMember mst_vehicle_num;
            mst_vehicle_num.common().member_id(memberId++);
            mst_vehicle_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_vehicle_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_vehicle_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_vehicle_num.common().member_flags().IS_OPTIONAL(false);
            mst_vehicle_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_vehicle_num.common().member_flags().IS_KEY(false);
            mst_vehicle_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_vehicle_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 vehicle_num_hash("vehicle_num");
            for(int i = 0; i < 4; ++i)
            {
                mst_vehicle_num.detail().name_hash()[i] = vehicle_num_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_vehicle_num);

            MinimalStructMember mst_oid;
            mst_oid.common().member_id(memberId++);
            mst_oid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_oid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_oid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_oid.common().member_flags().IS_OPTIONAL(false);
            mst_oid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_oid.common().member_flags().IS_KEY(false);
            mst_oid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_oid.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            MD5 oid_hash("oid");
            for(int i = 0; i < 4; ++i)
            {
                mst_oid.detail().name_hash()[i] = oid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_oid);

            MinimalStructMember mst_operation;
            mst_operation.common().member_id(memberId++);
            mst_operation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_operation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_operation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_operation.common().member_flags().IS_OPTIONAL(false);
            mst_operation.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_operation.common().member_flags().IS_KEY(false);
            mst_operation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_operation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 operation_hash("operation");
            for(int i = 0; i < 4; ++i)
            {
                mst_operation.detail().name_hash()[i] = operation_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_operation);

            MinimalStructMember mst_totalcurrent;
            mst_totalcurrent.common().member_id(memberId++);
            mst_totalcurrent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_totalcurrent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_totalcurrent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_totalcurrent.common().member_flags().IS_OPTIONAL(false);
            mst_totalcurrent.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_totalcurrent.common().member_flags().IS_KEY(false);
            mst_totalcurrent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_totalcurrent.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 totalcurrent_hash("totalcurrent");
            for(int i = 0; i < 4; ++i)
            {
                mst_totalcurrent.detail().name_hash()[i] = totalcurrent_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_totalcurrent);

            MinimalStructMember mst_batterysoc;
            mst_batterysoc.common().member_id(memberId++);
            mst_batterysoc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_batterysoc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_batterysoc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_batterysoc.common().member_flags().IS_OPTIONAL(false);
            mst_batterysoc.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_batterysoc.common().member_flags().IS_KEY(false);
            mst_batterysoc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_batterysoc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 batterysoc_hash("batterysoc");
            for(int i = 0; i < 4; ++i)
            {
                mst_batterysoc.detail().name_hash()[i] = batterysoc_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_batterysoc);

            MinimalStructMember mst_totalvoltage;
            mst_totalvoltage.common().member_id(memberId++);
            mst_totalvoltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_totalvoltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_totalvoltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_totalvoltage.common().member_flags().IS_OPTIONAL(false);
            mst_totalvoltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_totalvoltage.common().member_flags().IS_KEY(false);
            mst_totalvoltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_totalvoltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 totalvoltage_hash("totalvoltage");
            for(int i = 0; i < 4; ++i)
            {
                mst_totalvoltage.detail().name_hash()[i] = totalvoltage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_totalvoltage);

            MinimalStructMember mst_recharge;
            mst_recharge.common().member_id(memberId++);
            mst_recharge.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_recharge.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_recharge.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_recharge.common().member_flags().IS_OPTIONAL(false);
            mst_recharge.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_recharge.common().member_flags().IS_KEY(false);
            mst_recharge.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_recharge.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 recharge_hash("recharge");
            for(int i = 0; i < 4; ++i)
            {
                mst_recharge.detail().name_hash()[i] = recharge_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_recharge);

            MinimalStructMember mst_dcdc;
            mst_dcdc.common().member_id(memberId++);
            mst_dcdc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_dcdc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_dcdc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_dcdc.common().member_flags().IS_OPTIONAL(false);
            mst_dcdc.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_dcdc.common().member_flags().IS_KEY(false);
            mst_dcdc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_dcdc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 dcdc_hash("dcdc");
            for(int i = 0; i < 4; ++i)
            {
                mst_dcdc.detail().name_hash()[i] = dcdc_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_dcdc);

            MinimalStructMember mst_resistance;
            mst_resistance.common().member_id(memberId++);
            mst_resistance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_resistance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_resistance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_resistance.common().member_flags().IS_OPTIONAL(false);
            mst_resistance.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_resistance.common().member_flags().IS_KEY(false);
            mst_resistance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_resistance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 resistance_hash("resistance");
            for(int i = 0; i < 4; ++i)
            {
                mst_resistance.detail().name_hash()[i] = resistance_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_resistance);

            MinimalStructMember mst_seats;
            mst_seats.common().member_id(memberId++);
            mst_seats.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_seats.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_seats.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_seats.common().member_flags().IS_OPTIONAL(false);
            mst_seats.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_seats.common().member_flags().IS_KEY(false);
            mst_seats.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_seats.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("uint8_t", 100, false));


            MD5 seats_hash("seats");
            for(int i = 0; i < 4; ++i)
            {
                mst_seats.detail().name_hash()[i] = seats_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_seats);

            MinimalStructMember mst_servicemode;
            mst_servicemode.common().member_id(memberId++);
            mst_servicemode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_servicemode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_servicemode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_servicemode.common().member_flags().IS_OPTIONAL(false);
            mst_servicemode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_servicemode.common().member_flags().IS_KEY(false);
            mst_servicemode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_servicemode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 servicemode_hash("servicemode");
            for(int i = 0; i < 4; ++i)
            {
                mst_servicemode.detail().name_hash()[i] = servicemode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_servicemode);

            MinimalStructMember mst_seat_belt;
            mst_seat_belt.common().member_id(memberId++);
            mst_seat_belt.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_seat_belt.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_seat_belt.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_seat_belt.common().member_flags().IS_OPTIONAL(false);
            mst_seat_belt.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_seat_belt.common().member_flags().IS_KEY(false);
            mst_seat_belt.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_seat_belt.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, false));


            MD5 seat_belt_hash("seat_belt");
            for(int i = 0; i < 4; ++i)
            {
                mst_seat_belt.detail().name_hash()[i] = seat_belt_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_seat_belt);

            MinimalStructMember mst_engine_status;
            mst_engine_status.common().member_id(memberId++);
            mst_engine_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_engine_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_engine_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_engine_status.common().member_flags().IS_OPTIONAL(false);
            mst_engine_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_engine_status.common().member_flags().IS_KEY(false);
            mst_engine_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_engine_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 engine_status_hash("engine_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_engine_status.detail().name_hash()[i] = engine_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_engine_status);

            MinimalStructMember mst_battery_voltage;
            mst_battery_voltage.common().member_id(memberId++);
            mst_battery_voltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_voltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_voltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_voltage.common().member_flags().IS_OPTIONAL(false);
            mst_battery_voltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_voltage.common().member_flags().IS_KEY(false);
            mst_battery_voltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_voltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_voltage_hash("battery_voltage");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_voltage.detail().name_hash()[i] = battery_voltage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_voltage);

            MinimalStructMember mst_battery_ammeter;
            mst_battery_ammeter.common().member_id(memberId++);
            mst_battery_ammeter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_ammeter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_ammeter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_ammeter.common().member_flags().IS_OPTIONAL(false);
            mst_battery_ammeter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_ammeter.common().member_flags().IS_KEY(false);
            mst_battery_ammeter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_ammeter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_ammeter_hash("battery_ammeter");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_ammeter.detail().name_hash()[i] = battery_ammeter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_ammeter);

            MinimalStructMember mst_battery_consumption;
            mst_battery_consumption.common().member_id(memberId++);
            mst_battery_consumption.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_consumption.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_consumption.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_consumption.common().member_flags().IS_OPTIONAL(false);
            mst_battery_consumption.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_consumption.common().member_flags().IS_KEY(false);
            mst_battery_consumption.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_consumption.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_consumption_hash("battery_consumption");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_consumption.detail().name_hash()[i] = battery_consumption_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_consumption);

            MinimalStructMember mst_battery_probe;
            mst_battery_probe.common().member_id(memberId++);
            mst_battery_probe.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_probe.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_probe.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_probe.common().member_flags().IS_OPTIONAL(false);
            mst_battery_probe.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_probe.common().member_flags().IS_KEY(false);
            mst_battery_probe.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_probe.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_probe_hash("battery_probe");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_probe.detail().name_hash()[i] = battery_probe_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_probe);

            MinimalStructMember mst_battery_temperatures;
            mst_battery_temperatures.common().member_id(memberId++);
            mst_battery_temperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_temperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_temperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_temperatures.common().member_flags().IS_OPTIONAL(false);
            mst_battery_temperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_temperatures.common().member_flags().IS_KEY(false);
            mst_battery_temperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_temperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, false));


            MD5 battery_temperatures_hash("battery_temperatures");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_temperatures.detail().name_hash()[i] = battery_temperatures_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_temperatures);

            MinimalStructMember mst_battery_h_tepemperatures;
            mst_battery_h_tepemperatures.common().member_id(memberId++);
            mst_battery_h_tepemperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_h_tepemperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_h_tepemperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_h_tepemperatures.common().member_flags().IS_OPTIONAL(false);
            mst_battery_h_tepemperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_h_tepemperatures.common().member_flags().IS_KEY(false);
            mst_battery_h_tepemperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_h_tepemperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_h_tepemperatures_hash("battery_h_tepemperatures");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_h_tepemperatures.detail().name_hash()[i] = battery_h_tepemperatures_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_h_tepemperatures);

            MinimalStructMember mst_battery_ltepemperatures;
            mst_battery_ltepemperatures.common().member_id(memberId++);
            mst_battery_ltepemperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_ltepemperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_ltepemperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_ltepemperatures.common().member_flags().IS_OPTIONAL(false);
            mst_battery_ltepemperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_ltepemperatures.common().member_flags().IS_KEY(false);
            mst_battery_ltepemperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_ltepemperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_ltepemperatures_hash("battery_ltepemperatures");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_ltepemperatures.detail().name_hash()[i] = battery_ltepemperatures_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_ltepemperatures);

            MinimalStructMember mst_battery_probe_code;
            mst_battery_probe_code.common().member_id(memberId++);
            mst_battery_probe_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_probe_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_probe_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_probe_code.common().member_flags().IS_OPTIONAL(false);
            mst_battery_probe_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_probe_code.common().member_flags().IS_KEY(false);
            mst_battery_probe_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_probe_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_probe_code_hash("battery_probe_code");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_probe_code.detail().name_hash()[i] = battery_probe_code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_probe_code);

            MinimalStructMember mst_battery_h_concentration;
            mst_battery_h_concentration.common().member_id(memberId++);
            mst_battery_h_concentration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_h_concentration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_h_concentration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_h_concentration.common().member_flags().IS_OPTIONAL(false);
            mst_battery_h_concentration.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_h_concentration.common().member_flags().IS_KEY(false);
            mst_battery_h_concentration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_h_concentration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_h_concentration_hash("battery_h_concentration");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_h_concentration.detail().name_hash()[i] = battery_h_concentration_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_h_concentration);

            MinimalStructMember mst_battery_c_sensor_code;
            mst_battery_c_sensor_code.common().member_id(memberId++);
            mst_battery_c_sensor_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_c_sensor_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_c_sensor_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_c_sensor_code.common().member_flags().IS_OPTIONAL(false);
            mst_battery_c_sensor_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_c_sensor_code.common().member_flags().IS_KEY(false);
            mst_battery_c_sensor_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_c_sensor_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_c_sensor_code_hash("battery_c_sensor_code");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_c_sensor_code.detail().name_hash()[i] = battery_c_sensor_code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_c_sensor_code);

            MinimalStructMember mst_battery_stress;
            mst_battery_stress.common().member_id(memberId++);
            mst_battery_stress.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_stress.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_stress.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_stress.common().member_flags().IS_OPTIONAL(false);
            mst_battery_stress.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_stress.common().member_flags().IS_KEY(false);
            mst_battery_stress.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_stress.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_stress_hash("battery_stress");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_stress.detail().name_hash()[i] = battery_stress_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_stress);

            MinimalStructMember mst_battery_s_sensor_code;
            mst_battery_s_sensor_code.common().member_id(memberId++);
            mst_battery_s_sensor_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_s_sensor_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_s_sensor_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_s_sensor_code.common().member_flags().IS_OPTIONAL(false);
            mst_battery_s_sensor_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_s_sensor_code.common().member_flags().IS_KEY(false);
            mst_battery_s_sensor_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_s_sensor_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_s_sensor_code_hash("battery_s_sensor_code");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_s_sensor_code.detail().name_hash()[i] = battery_s_sensor_code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_s_sensor_code);

            MinimalStructMember mst_battery_h_dc_dc;
            mst_battery_h_dc_dc.common().member_id(memberId++);
            mst_battery_h_dc_dc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_h_dc_dc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_h_dc_dc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_h_dc_dc.common().member_flags().IS_OPTIONAL(false);
            mst_battery_h_dc_dc.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_h_dc_dc.common().member_flags().IS_KEY(false);
            mst_battery_h_dc_dc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_h_dc_dc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_h_dc_dc_hash("battery_h_dc_dc");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_h_dc_dc.detail().name_hash()[i] = battery_h_dc_dc_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_h_dc_dc);

            MinimalStructMember mst_battery_capacity;
            mst_battery_capacity.common().member_id(memberId++);
            mst_battery_capacity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_battery_capacity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_battery_capacity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_battery_capacity.common().member_flags().IS_OPTIONAL(false);
            mst_battery_capacity.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_battery_capacity.common().member_flags().IS_KEY(false);
            mst_battery_capacity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_battery_capacity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 battery_capacity_hash("battery_capacity");
            for(int i = 0; i < 4; ++i)
            {
                mst_battery_capacity.detail().name_hash()[i] = battery_capacity_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_battery_capacity);

            MinimalStructMember mst_airconditioning_idx;
            mst_airconditioning_idx.common().member_id(memberId++);
            mst_airconditioning_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_airconditioning_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_airconditioning_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_airconditioning_idx.common().member_flags().IS_OPTIONAL(false);
            mst_airconditioning_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_airconditioning_idx.common().member_flags().IS_KEY(false);
            mst_airconditioning_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_airconditioning_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 airconditioning_idx_hash("airconditioning_idx");
            for(int i = 0; i < 4; ++i)
            {
                mst_airconditioning_idx.detail().name_hash()[i] = airconditioning_idx_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_airconditioning_idx);

            MinimalStructMember mst_airconditioning_status;
            mst_airconditioning_status.common().member_id(memberId++);
            mst_airconditioning_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_airconditioning_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_airconditioning_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_airconditioning_status.common().member_flags().IS_OPTIONAL(false);
            mst_airconditioning_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_airconditioning_status.common().member_flags().IS_KEY(false);
            mst_airconditioning_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_airconditioning_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 airconditioning_status_hash("airconditioning_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_airconditioning_status.detail().name_hash()[i] = airconditioning_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_airconditioning_status);

            MinimalStructMember mst_airconditioning_model;
            mst_airconditioning_model.common().member_id(memberId++);
            mst_airconditioning_model.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_airconditioning_model.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_airconditioning_model.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_airconditioning_model.common().member_flags().IS_OPTIONAL(false);
            mst_airconditioning_model.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_airconditioning_model.common().member_flags().IS_KEY(false);
            mst_airconditioning_model.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_airconditioning_model.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 airconditioning_model_hash("airconditioning_model");
            for(int i = 0; i < 4; ++i)
            {
                mst_airconditioning_model.detail().name_hash()[i] = airconditioning_model_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_airconditioning_model);

            MinimalStructMember mst_airconditioning_volume;
            mst_airconditioning_volume.common().member_id(memberId++);
            mst_airconditioning_volume.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_airconditioning_volume.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_airconditioning_volume.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_airconditioning_volume.common().member_flags().IS_OPTIONAL(false);
            mst_airconditioning_volume.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_airconditioning_volume.common().member_flags().IS_KEY(false);
            mst_airconditioning_volume.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_airconditioning_volume.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 airconditioning_volume_hash("airconditioning_volume");
            for(int i = 0; i < 4; ++i)
            {
                mst_airconditioning_volume.detail().name_hash()[i] = airconditioning_volume_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_airconditioning_volume);

            MinimalStructMember mst_airconditioning_defrost;
            mst_airconditioning_defrost.common().member_id(memberId++);
            mst_airconditioning_defrost.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_airconditioning_defrost.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_airconditioning_defrost.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_airconditioning_defrost.common().member_flags().IS_OPTIONAL(false);
            mst_airconditioning_defrost.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_airconditioning_defrost.common().member_flags().IS_KEY(false);
            mst_airconditioning_defrost.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_airconditioning_defrost.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 airconditioning_defrost_hash("airconditioning_defrost");
            for(int i = 0; i < 4; ++i)
            {
                mst_airconditioning_defrost.detail().name_hash()[i] = airconditioning_defrost_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_airconditioning_defrost);

            MinimalStructMember mst_door_status;
            mst_door_status.common().member_id(memberId++);
            mst_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_door_status.common().member_flags().IS_KEY(false);
            mst_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, false));


            MD5 door_status_hash("door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_door_status.detail().name_hash()[i] = door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_door_status);

            MinimalStructMember mst_rsrp;
            mst_rsrp.common().member_id(memberId++);
            mst_rsrp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rsrp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rsrp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rsrp.common().member_flags().IS_OPTIONAL(false);
            mst_rsrp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rsrp.common().member_flags().IS_KEY(false);
            mst_rsrp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rsrp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rsrp_hash("rsrp");
            for(int i = 0; i < 4; ++i)
            {
                mst_rsrp.detail().name_hash()[i] = rsrp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rsrp);

            MinimalStructMember mst_sinr;
            mst_sinr.common().member_id(memberId++);
            mst_sinr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sinr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sinr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sinr.common().member_flags().IS_OPTIONAL(false);
            mst_sinr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sinr.common().member_flags().IS_KEY(false);
            mst_sinr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sinr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 sinr_hash("sinr");
            for(int i = 0; i < 4; ++i)
            {
                mst_sinr.detail().name_hash()[i] = sinr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sinr);

            MinimalStructMember mst_uspeed;
            mst_uspeed.common().member_id(memberId++);
            mst_uspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_uspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_uspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_uspeed.common().member_flags().IS_OPTIONAL(false);
            mst_uspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_uspeed.common().member_flags().IS_KEY(false);
            mst_uspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_uspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 uspeed_hash("uspeed");
            for(int i = 0; i < 4; ++i)
            {
                mst_uspeed.detail().name_hash()[i] = uspeed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_uspeed);

            MinimalStructMember mst_dspeed;
            mst_dspeed.common().member_id(memberId++);
            mst_dspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_dspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_dspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_dspeed.common().member_flags().IS_OPTIONAL(false);
            mst_dspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_dspeed.common().member_flags().IS_KEY(false);
            mst_dspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_dspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 dspeed_hash("dspeed");
            for(int i = 0; i < 4; ++i)
            {
                mst_dspeed.detail().name_hash()[i] = dspeed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_dspeed);

            MinimalStructMember mst_loss;
            mst_loss.common().member_id(memberId++);
            mst_loss.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_loss.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_loss.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_loss.common().member_flags().IS_OPTIONAL(false);
            mst_loss.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_loss.common().member_flags().IS_KEY(false);
            mst_loss.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_loss.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 loss_hash("loss");
            for(int i = 0; i < 4; ++i)
            {
                mst_loss.detail().name_hash()[i] = loss_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_loss);

            MinimalStructMember mst_delay;
            mst_delay.common().member_id(memberId++);
            mst_delay.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_delay.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_delay.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_delay.common().member_flags().IS_OPTIONAL(false);
            mst_delay.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_delay.common().member_flags().IS_KEY(false);
            mst_delay.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_delay.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            MD5 delay_hash("delay");
            for(int i = 0; i < 4; ++i)
            {
                mst_delay.detail().name_hash()[i] = delay_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_delay);

            MinimalStructMember mst_refrigeration_idx;
            mst_refrigeration_idx.common().member_id(memberId++);
            mst_refrigeration_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_refrigeration_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_refrigeration_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_refrigeration_idx.common().member_flags().IS_OPTIONAL(false);
            mst_refrigeration_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_refrigeration_idx.common().member_flags().IS_KEY(false);
            mst_refrigeration_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_refrigeration_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 refrigeration_idx_hash("refrigeration_idx");
            for(int i = 0; i < 4; ++i)
            {
                mst_refrigeration_idx.detail().name_hash()[i] = refrigeration_idx_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_refrigeration_idx);

            MinimalStructMember mst_refrigeration_status;
            mst_refrigeration_status.common().member_id(memberId++);
            mst_refrigeration_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_refrigeration_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_refrigeration_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_refrigeration_status.common().member_flags().IS_OPTIONAL(false);
            mst_refrigeration_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_refrigeration_status.common().member_flags().IS_KEY(false);
            mst_refrigeration_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_refrigeration_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 refrigeration_status_hash("refrigeration_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_refrigeration_status.detail().name_hash()[i] = refrigeration_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_refrigeration_status);

            MinimalStructMember mst_refrigeration_stemp;
            mst_refrigeration_stemp.common().member_id(memberId++);
            mst_refrigeration_stemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_refrigeration_stemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_refrigeration_stemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_refrigeration_stemp.common().member_flags().IS_OPTIONAL(false);
            mst_refrigeration_stemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_refrigeration_stemp.common().member_flags().IS_KEY(false);
            mst_refrigeration_stemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_refrigeration_stemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 refrigeration_stemp_hash("refrigeration_stemp");
            for(int i = 0; i < 4; ++i)
            {
                mst_refrigeration_stemp.detail().name_hash()[i] = refrigeration_stemp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_refrigeration_stemp);

            MinimalStructMember mst_refrigeration_ctemp;
            mst_refrigeration_ctemp.common().member_id(memberId++);
            mst_refrigeration_ctemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_refrigeration_ctemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_refrigeration_ctemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_refrigeration_ctemp.common().member_flags().IS_OPTIONAL(false);
            mst_refrigeration_ctemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_refrigeration_ctemp.common().member_flags().IS_KEY(false);
            mst_refrigeration_ctemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_refrigeration_ctemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 refrigeration_ctemp_hash("refrigeration_ctemp");
            for(int i = 0; i < 4; ++i)
            {
                mst_refrigeration_ctemp.detail().name_hash()[i] = refrigeration_ctemp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_refrigeration_ctemp);

            MinimalStructMember mst_driving_motor_idx;
            mst_driving_motor_idx.common().member_id(memberId++);
            mst_driving_motor_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_idx.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_idx.common().member_flags().IS_KEY(false);
            mst_driving_motor_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 driving_motor_idx_hash("driving_motor_idx");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_idx.detail().name_hash()[i] = driving_motor_idx_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_idx);

            MinimalStructMember mst_driving_motor_status;
            mst_driving_motor_status.common().member_id(memberId++);
            mst_driving_motor_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_status.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_status.common().member_flags().IS_KEY(false);
            mst_driving_motor_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 driving_motor_status_hash("driving_motor_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_status.detail().name_hash()[i] = driving_motor_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_status);

            MinimalStructMember mst_driving_motor_ctemp;
            mst_driving_motor_ctemp.common().member_id(memberId++);
            mst_driving_motor_ctemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_ctemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_ctemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_ctemp.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_ctemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_ctemp.common().member_flags().IS_KEY(false);
            mst_driving_motor_ctemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_ctemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 driving_motor_ctemp_hash("driving_motor_ctemp");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_ctemp.detail().name_hash()[i] = driving_motor_ctemp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_ctemp);

            MinimalStructMember mst_driving_motor_rspeed;
            mst_driving_motor_rspeed.common().member_id(memberId++);
            mst_driving_motor_rspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_rspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_rspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_rspeed.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_rspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_rspeed.common().member_flags().IS_KEY(false);
            mst_driving_motor_rspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_rspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            MD5 driving_motor_rspeed_hash("driving_motor_rspeed");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_rspeed.detail().name_hash()[i] = driving_motor_rspeed_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_rspeed);

            MinimalStructMember mst_driving_motor_torque;
            mst_driving_motor_torque.common().member_id(memberId++);
            mst_driving_motor_torque.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_torque.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_torque.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_torque.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_torque.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_torque.common().member_flags().IS_KEY(false);
            mst_driving_motor_torque.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_torque.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 driving_motor_torque_hash("driving_motor_torque");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_torque.detail().name_hash()[i] = driving_motor_torque_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_torque);

            MinimalStructMember mst_driving_motor_etemp;
            mst_driving_motor_etemp.common().member_id(memberId++);
            mst_driving_motor_etemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_etemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_etemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_etemp.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_etemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_etemp.common().member_flags().IS_KEY(false);
            mst_driving_motor_etemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_etemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 driving_motor_etemp_hash("driving_motor_etemp");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_etemp.detail().name_hash()[i] = driving_motor_etemp_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_etemp);

            MinimalStructMember mst_driving_motor_voltage;
            mst_driving_motor_voltage.common().member_id(memberId++);
            mst_driving_motor_voltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_voltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_voltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_voltage.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_voltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_voltage.common().member_flags().IS_KEY(false);
            mst_driving_motor_voltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_voltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 driving_motor_voltage_hash("driving_motor_voltage");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_voltage.detail().name_hash()[i] = driving_motor_voltage_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_voltage);

            MinimalStructMember mst_driving_motor_ammeter;
            mst_driving_motor_ammeter.common().member_id(memberId++);
            mst_driving_motor_ammeter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_motor_ammeter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_motor_ammeter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_motor_ammeter.common().member_flags().IS_OPTIONAL(false);
            mst_driving_motor_ammeter.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_motor_ammeter.common().member_flags().IS_KEY(false);
            mst_driving_motor_ammeter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_motor_ammeter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 driving_motor_ammeter_hash("driving_motor_ammeter");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_motor_ammeter.detail().name_hash()[i] = driving_motor_ammeter_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_motor_ammeter);

            MinimalStructMember mst_outline_lamp_status;
            mst_outline_lamp_status.common().member_id(memberId++);
            mst_outline_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_outline_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_outline_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_outline_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_outline_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_outline_lamp_status.common().member_flags().IS_KEY(false);
            mst_outline_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_outline_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 outline_lamp_status_hash("outline_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_outline_lamp_status.detail().name_hash()[i] = outline_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_outline_lamp_status);

            MinimalStructMember mst_warning_lamp_status;
            mst_warning_lamp_status.common().member_id(memberId++);
            mst_warning_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_warning_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_warning_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_warning_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_warning_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_warning_lamp_status.common().member_flags().IS_KEY(false);
            mst_warning_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_warning_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 warning_lamp_status_hash("warning_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_warning_lamp_status.detail().name_hash()[i] = warning_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_warning_lamp_status);

            MinimalStructMember mst_parking_lamp_status;
            mst_parking_lamp_status.common().member_id(memberId++);
            mst_parking_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_parking_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_lamp_status.common().member_flags().IS_KEY(false);
            mst_parking_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_lamp_status_hash("parking_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_lamp_status.detail().name_hash()[i] = parking_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_lamp_status);

            MinimalStructMember mst_interior_lamp_status;
            mst_interior_lamp_status.common().member_id(memberId++);
            mst_interior_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_interior_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_interior_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_interior_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_interior_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_interior_lamp_status.common().member_flags().IS_KEY(false);
            mst_interior_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_interior_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 interior_lamp_status_hash("interior_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_interior_lamp_status.detail().name_hash()[i] = interior_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_interior_lamp_status);

            MinimalStructMember mst_ambient_lamp_status;
            mst_ambient_lamp_status.common().member_id(memberId++);
            mst_ambient_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_ambient_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_ambient_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_ambient_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_ambient_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_ambient_lamp_status.common().member_flags().IS_KEY(false);
            mst_ambient_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_ambient_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 ambient_lamp_status_hash("ambient_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_ambient_lamp_status.detail().name_hash()[i] = ambient_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_ambient_lamp_status);

            MinimalStructMember mst_welcome_lamp_status;
            mst_welcome_lamp_status.common().member_id(memberId++);
            mst_welcome_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_welcome_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_welcome_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_welcome_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_welcome_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_welcome_lamp_status.common().member_flags().IS_KEY(false);
            mst_welcome_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_welcome_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 welcome_lamp_status_hash("welcome_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_welcome_lamp_status.detail().name_hash()[i] = welcome_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_welcome_lamp_status);

            MinimalStructMember mst_backlight_lamp_status;
            mst_backlight_lamp_status.common().member_id(memberId++);
            mst_backlight_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_backlight_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_backlight_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_backlight_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_backlight_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_backlight_lamp_status.common().member_flags().IS_KEY(false);
            mst_backlight_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_backlight_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 backlight_lamp_status_hash("backlight_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_backlight_lamp_status.detail().name_hash()[i] = backlight_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_backlight_lamp_status);

            MinimalStructMember mst_positionlight_lamp_status;
            mst_positionlight_lamp_status.common().member_id(memberId++);
            mst_positionlight_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_positionlight_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_positionlight_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_positionlight_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_positionlight_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_positionlight_lamp_status.common().member_flags().IS_KEY(false);
            mst_positionlight_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_positionlight_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 positionlight_lamp_status_hash("positionlight_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_positionlight_lamp_status.detail().name_hash()[i] = positionlight_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_positionlight_lamp_status);

            MinimalStructMember mst_brakelamp_lamp_status;
            mst_brakelamp_lamp_status.common().member_id(memberId++);
            mst_brakelamp_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brakelamp_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brakelamp_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brakelamp_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_brakelamp_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brakelamp_lamp_status.common().member_flags().IS_KEY(false);
            mst_brakelamp_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brakelamp_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brakelamp_lamp_status_hash("brakelamp_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_brakelamp_lamp_status.detail().name_hash()[i] = brakelamp_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brakelamp_lamp_status);

            MinimalStructMember mst_backuplamp_lamp_status;
            mst_backuplamp_lamp_status.common().member_id(memberId++);
            mst_backuplamp_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_backuplamp_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_backuplamp_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_backuplamp_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_backuplamp_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_backuplamp_lamp_status.common().member_flags().IS_KEY(false);
            mst_backuplamp_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_backuplamp_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 backuplamp_lamp_status_hash("backuplamp_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_backuplamp_lamp_status.detail().name_hash()[i] = backuplamp_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_backuplamp_lamp_status);

            MinimalStructMember mst_length;
            mst_length.common().member_id(memberId++);
            mst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_length.common().member_flags().IS_OPTIONAL(false);
            mst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_length.common().member_flags().IS_KEY(false);
            mst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 length_hash("length");
            for(int i = 0; i < 4; ++i)
            {
                mst_length.detail().name_hash()[i] = length_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_length);

            MinimalStructMember mst_width;
            mst_width.common().member_id(memberId++);
            mst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_width.common().member_flags().IS_OPTIONAL(false);
            mst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_width.common().member_flags().IS_KEY(false);
            mst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 width_hash("width");
            for(int i = 0; i < 4; ++i)
            {
                mst_width.detail().name_hash()[i] = width_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_width);

            MinimalStructMember mst_height;
            mst_height.common().member_id(memberId++);
            mst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_height.common().member_flags().IS_OPTIONAL(false);
            mst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_height.common().member_flags().IS_KEY(false);
            mst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            MD5 height_hash("height");
            for(int i = 0; i < 4; ++i)
            {
                mst_height.detail().name_hash()[i] = height_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_height);

            MinimalStructMember mst_traction;
            mst_traction.common().member_id(memberId++);
            mst_traction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_traction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_traction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_traction.common().member_flags().IS_OPTIONAL(false);
            mst_traction.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_traction.common().member_flags().IS_KEY(false);
            mst_traction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_traction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 traction_hash("traction");
            for(int i = 0; i < 4; ++i)
            {
                mst_traction.detail().name_hash()[i] = traction_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_traction);

            MinimalStructMember mst_abs;
            mst_abs.common().member_id(memberId++);
            mst_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_abs.common().member_flags().IS_OPTIONAL(false);
            mst_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_abs.common().member_flags().IS_KEY(false);
            mst_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 abs_hash("abs");
            for(int i = 0; i < 4; ++i)
            {
                mst_abs.detail().name_hash()[i] = abs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_abs);

            MinimalStructMember mst_scs;
            mst_scs.common().member_id(memberId++);
            mst_scs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_scs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_scs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_scs.common().member_flags().IS_OPTIONAL(false);
            mst_scs.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_scs.common().member_flags().IS_KEY(false);
            mst_scs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_scs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 scs_hash("scs");
            for(int i = 0; i < 4; ++i)
            {
                mst_scs.detail().name_hash()[i] = scs_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_scs);

            MinimalStructMember mst_brake_boost;
            mst_brake_boost.common().member_id(memberId++);
            mst_brake_boost.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_boost.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_boost.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_boost.common().member_flags().IS_OPTIONAL(false);
            mst_brake_boost.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_boost.common().member_flags().IS_KEY(false);
            mst_brake_boost.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_boost.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_boost_hash("brake_boost");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_boost.detail().name_hash()[i] = brake_boost_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_boost);

            MinimalStructMember mst_aux_brakes;
            mst_aux_brakes.common().member_id(memberId++);
            mst_aux_brakes.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_aux_brakes.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_aux_brakes.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_aux_brakes.common().member_flags().IS_OPTIONAL(false);
            mst_aux_brakes.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_aux_brakes.common().member_flags().IS_KEY(false);
            mst_aux_brakes.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_aux_brakes.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 aux_brakes_hash("aux_brakes");
            for(int i = 0; i < 4; ++i)
            {
                mst_aux_brakes.detail().name_hash()[i] = aux_brakes_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_aux_brakes);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Vehicle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Vehicle", false);
        }

        const TypeObject* GetCompleteVehicleObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Vehicle", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_vehicle_type;
            cst_vehicle_type.common().member_id(memberId++);
            cst_vehicle_type.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_vehicle_type.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_vehicle_type.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_vehicle_type.common().member_flags().IS_OPTIONAL(false);
            cst_vehicle_type.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_vehicle_type.common().member_flags().IS_KEY(false);
            cst_vehicle_type.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_vehicle_type.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_vehicle_type.detail().name("vehicle_type");

            type_object->complete().struct_type().member_seq().emplace_back(cst_vehicle_type);

            CompleteStructMember cst_vid;
            cst_vid.common().member_id(memberId++);
            cst_vid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_vid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_vid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_vid.common().member_flags().IS_OPTIONAL(false);
            cst_vid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_vid.common().member_flags().IS_KEY(false);
            cst_vid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_vid.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_vid.detail().name("vid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_vid);

            CompleteStructMember cst_vehicle_num;
            cst_vehicle_num.common().member_id(memberId++);
            cst_vehicle_num.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_vehicle_num.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_vehicle_num.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_vehicle_num.common().member_flags().IS_OPTIONAL(false);
            cst_vehicle_num.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_vehicle_num.common().member_flags().IS_KEY(false);
            cst_vehicle_num.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_vehicle_num.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_vehicle_num.detail().name("vehicle_num");

            type_object->complete().struct_type().member_seq().emplace_back(cst_vehicle_num);

            CompleteStructMember cst_oid;
            cst_oid.common().member_id(memberId++);
            cst_oid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_oid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_oid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_oid.common().member_flags().IS_OPTIONAL(false);
            cst_oid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_oid.common().member_flags().IS_KEY(false);
            cst_oid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_oid.common().member_type_id(*TypeObjectFactory::get_instance()->get_string_identifier(255, false));


            cst_oid.detail().name("oid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_oid);

            CompleteStructMember cst_operation;
            cst_operation.common().member_id(memberId++);
            cst_operation.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_operation.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_operation.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_operation.common().member_flags().IS_OPTIONAL(false);
            cst_operation.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_operation.common().member_flags().IS_KEY(false);
            cst_operation.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_operation.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_operation.detail().name("operation");

            type_object->complete().struct_type().member_seq().emplace_back(cst_operation);

            CompleteStructMember cst_totalcurrent;
            cst_totalcurrent.common().member_id(memberId++);
            cst_totalcurrent.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_totalcurrent.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_totalcurrent.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_totalcurrent.common().member_flags().IS_OPTIONAL(false);
            cst_totalcurrent.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_totalcurrent.common().member_flags().IS_KEY(false);
            cst_totalcurrent.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_totalcurrent.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_totalcurrent.detail().name("totalcurrent");

            type_object->complete().struct_type().member_seq().emplace_back(cst_totalcurrent);

            CompleteStructMember cst_batterysoc;
            cst_batterysoc.common().member_id(memberId++);
            cst_batterysoc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_batterysoc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_batterysoc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_batterysoc.common().member_flags().IS_OPTIONAL(false);
            cst_batterysoc.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_batterysoc.common().member_flags().IS_KEY(false);
            cst_batterysoc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_batterysoc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_batterysoc.detail().name("batterysoc");

            type_object->complete().struct_type().member_seq().emplace_back(cst_batterysoc);

            CompleteStructMember cst_totalvoltage;
            cst_totalvoltage.common().member_id(memberId++);
            cst_totalvoltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_totalvoltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_totalvoltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_totalvoltage.common().member_flags().IS_OPTIONAL(false);
            cst_totalvoltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_totalvoltage.common().member_flags().IS_KEY(false);
            cst_totalvoltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_totalvoltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_totalvoltage.detail().name("totalvoltage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_totalvoltage);

            CompleteStructMember cst_recharge;
            cst_recharge.common().member_id(memberId++);
            cst_recharge.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_recharge.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_recharge.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_recharge.common().member_flags().IS_OPTIONAL(false);
            cst_recharge.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_recharge.common().member_flags().IS_KEY(false);
            cst_recharge.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_recharge.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_recharge.detail().name("recharge");

            type_object->complete().struct_type().member_seq().emplace_back(cst_recharge);

            CompleteStructMember cst_dcdc;
            cst_dcdc.common().member_id(memberId++);
            cst_dcdc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_dcdc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_dcdc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_dcdc.common().member_flags().IS_OPTIONAL(false);
            cst_dcdc.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_dcdc.common().member_flags().IS_KEY(false);
            cst_dcdc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_dcdc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_dcdc.detail().name("dcdc");

            type_object->complete().struct_type().member_seq().emplace_back(cst_dcdc);

            CompleteStructMember cst_resistance;
            cst_resistance.common().member_id(memberId++);
            cst_resistance.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_resistance.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_resistance.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_resistance.common().member_flags().IS_OPTIONAL(false);
            cst_resistance.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_resistance.common().member_flags().IS_KEY(false);
            cst_resistance.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_resistance.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_resistance.detail().name("resistance");

            type_object->complete().struct_type().member_seq().emplace_back(cst_resistance);

            CompleteStructMember cst_seats;
            cst_seats.common().member_id(memberId++);
            cst_seats.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_seats.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_seats.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_seats.common().member_flags().IS_OPTIONAL(false);
            cst_seats.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_seats.common().member_flags().IS_KEY(false);
            cst_seats.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_seats.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("uint8_t", 100, true));


            cst_seats.detail().name("seats");

            type_object->complete().struct_type().member_seq().emplace_back(cst_seats);

            CompleteStructMember cst_servicemode;
            cst_servicemode.common().member_id(memberId++);
            cst_servicemode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_servicemode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_servicemode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_servicemode.common().member_flags().IS_OPTIONAL(false);
            cst_servicemode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_servicemode.common().member_flags().IS_KEY(false);
            cst_servicemode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_servicemode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_servicemode.detail().name("servicemode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_servicemode);

            CompleteStructMember cst_seat_belt;
            cst_seat_belt.common().member_id(memberId++);
            cst_seat_belt.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_seat_belt.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_seat_belt.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_seat_belt.common().member_flags().IS_OPTIONAL(false);
            cst_seat_belt.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_seat_belt.common().member_flags().IS_KEY(false);
            cst_seat_belt.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_seat_belt.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, true));


            cst_seat_belt.detail().name("seat_belt");

            type_object->complete().struct_type().member_seq().emplace_back(cst_seat_belt);

            CompleteStructMember cst_engine_status;
            cst_engine_status.common().member_id(memberId++);
            cst_engine_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_engine_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_engine_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_engine_status.common().member_flags().IS_OPTIONAL(false);
            cst_engine_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_engine_status.common().member_flags().IS_KEY(false);
            cst_engine_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_engine_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_engine_status.detail().name("engine_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_engine_status);

            CompleteStructMember cst_battery_voltage;
            cst_battery_voltage.common().member_id(memberId++);
            cst_battery_voltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_voltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_voltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_voltage.common().member_flags().IS_OPTIONAL(false);
            cst_battery_voltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_voltage.common().member_flags().IS_KEY(false);
            cst_battery_voltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_voltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_voltage.detail().name("battery_voltage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_voltage);

            CompleteStructMember cst_battery_ammeter;
            cst_battery_ammeter.common().member_id(memberId++);
            cst_battery_ammeter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_ammeter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_ammeter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_ammeter.common().member_flags().IS_OPTIONAL(false);
            cst_battery_ammeter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_ammeter.common().member_flags().IS_KEY(false);
            cst_battery_ammeter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_ammeter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_ammeter.detail().name("battery_ammeter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_ammeter);

            CompleteStructMember cst_battery_consumption;
            cst_battery_consumption.common().member_id(memberId++);
            cst_battery_consumption.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_consumption.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_consumption.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_consumption.common().member_flags().IS_OPTIONAL(false);
            cst_battery_consumption.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_consumption.common().member_flags().IS_KEY(false);
            cst_battery_consumption.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_consumption.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_consumption.detail().name("battery_consumption");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_consumption);

            CompleteStructMember cst_battery_probe;
            cst_battery_probe.common().member_id(memberId++);
            cst_battery_probe.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_probe.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_probe.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_probe.common().member_flags().IS_OPTIONAL(false);
            cst_battery_probe.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_probe.common().member_flags().IS_KEY(false);
            cst_battery_probe.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_probe.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_probe.detail().name("battery_probe");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_probe);

            CompleteStructMember cst_battery_temperatures;
            cst_battery_temperatures.common().member_id(memberId++);
            cst_battery_temperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_temperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_temperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_temperatures.common().member_flags().IS_OPTIONAL(false);
            cst_battery_temperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_temperatures.common().member_flags().IS_KEY(false);
            cst_battery_temperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_temperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("double", 100, true));


            cst_battery_temperatures.detail().name("battery_temperatures");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_temperatures);

            CompleteStructMember cst_battery_h_tepemperatures;
            cst_battery_h_tepemperatures.common().member_id(memberId++);
            cst_battery_h_tepemperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_h_tepemperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_h_tepemperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_h_tepemperatures.common().member_flags().IS_OPTIONAL(false);
            cst_battery_h_tepemperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_h_tepemperatures.common().member_flags().IS_KEY(false);
            cst_battery_h_tepemperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_h_tepemperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_h_tepemperatures.detail().name("battery_h_tepemperatures");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_h_tepemperatures);

            CompleteStructMember cst_battery_ltepemperatures;
            cst_battery_ltepemperatures.common().member_id(memberId++);
            cst_battery_ltepemperatures.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_ltepemperatures.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_ltepemperatures.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_ltepemperatures.common().member_flags().IS_OPTIONAL(false);
            cst_battery_ltepemperatures.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_ltepemperatures.common().member_flags().IS_KEY(false);
            cst_battery_ltepemperatures.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_ltepemperatures.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_ltepemperatures.detail().name("battery_ltepemperatures");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_ltepemperatures);

            CompleteStructMember cst_battery_probe_code;
            cst_battery_probe_code.common().member_id(memberId++);
            cst_battery_probe_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_probe_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_probe_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_probe_code.common().member_flags().IS_OPTIONAL(false);
            cst_battery_probe_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_probe_code.common().member_flags().IS_KEY(false);
            cst_battery_probe_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_probe_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_probe_code.detail().name("battery_probe_code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_probe_code);

            CompleteStructMember cst_battery_h_concentration;
            cst_battery_h_concentration.common().member_id(memberId++);
            cst_battery_h_concentration.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_h_concentration.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_h_concentration.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_h_concentration.common().member_flags().IS_OPTIONAL(false);
            cst_battery_h_concentration.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_h_concentration.common().member_flags().IS_KEY(false);
            cst_battery_h_concentration.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_h_concentration.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_h_concentration.detail().name("battery_h_concentration");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_h_concentration);

            CompleteStructMember cst_battery_c_sensor_code;
            cst_battery_c_sensor_code.common().member_id(memberId++);
            cst_battery_c_sensor_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_c_sensor_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_c_sensor_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_c_sensor_code.common().member_flags().IS_OPTIONAL(false);
            cst_battery_c_sensor_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_c_sensor_code.common().member_flags().IS_KEY(false);
            cst_battery_c_sensor_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_c_sensor_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_c_sensor_code.detail().name("battery_c_sensor_code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_c_sensor_code);

            CompleteStructMember cst_battery_stress;
            cst_battery_stress.common().member_id(memberId++);
            cst_battery_stress.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_stress.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_stress.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_stress.common().member_flags().IS_OPTIONAL(false);
            cst_battery_stress.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_stress.common().member_flags().IS_KEY(false);
            cst_battery_stress.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_stress.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_stress.detail().name("battery_stress");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_stress);

            CompleteStructMember cst_battery_s_sensor_code;
            cst_battery_s_sensor_code.common().member_id(memberId++);
            cst_battery_s_sensor_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_s_sensor_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_s_sensor_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_s_sensor_code.common().member_flags().IS_OPTIONAL(false);
            cst_battery_s_sensor_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_s_sensor_code.common().member_flags().IS_KEY(false);
            cst_battery_s_sensor_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_s_sensor_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_s_sensor_code.detail().name("battery_s_sensor_code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_s_sensor_code);

            CompleteStructMember cst_battery_h_dc_dc;
            cst_battery_h_dc_dc.common().member_id(memberId++);
            cst_battery_h_dc_dc.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_h_dc_dc.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_h_dc_dc.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_h_dc_dc.common().member_flags().IS_OPTIONAL(false);
            cst_battery_h_dc_dc.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_h_dc_dc.common().member_flags().IS_KEY(false);
            cst_battery_h_dc_dc.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_h_dc_dc.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_h_dc_dc.detail().name("battery_h_dc_dc");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_h_dc_dc);

            CompleteStructMember cst_battery_capacity;
            cst_battery_capacity.common().member_id(memberId++);
            cst_battery_capacity.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_battery_capacity.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_battery_capacity.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_battery_capacity.common().member_flags().IS_OPTIONAL(false);
            cst_battery_capacity.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_battery_capacity.common().member_flags().IS_KEY(false);
            cst_battery_capacity.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_battery_capacity.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_battery_capacity.detail().name("battery_capacity");

            type_object->complete().struct_type().member_seq().emplace_back(cst_battery_capacity);

            CompleteStructMember cst_airconditioning_idx;
            cst_airconditioning_idx.common().member_id(memberId++);
            cst_airconditioning_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_airconditioning_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_airconditioning_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_airconditioning_idx.common().member_flags().IS_OPTIONAL(false);
            cst_airconditioning_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_airconditioning_idx.common().member_flags().IS_KEY(false);
            cst_airconditioning_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_airconditioning_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_airconditioning_idx.detail().name("airconditioning_idx");

            type_object->complete().struct_type().member_seq().emplace_back(cst_airconditioning_idx);

            CompleteStructMember cst_airconditioning_status;
            cst_airconditioning_status.common().member_id(memberId++);
            cst_airconditioning_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_airconditioning_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_airconditioning_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_airconditioning_status.common().member_flags().IS_OPTIONAL(false);
            cst_airconditioning_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_airconditioning_status.common().member_flags().IS_KEY(false);
            cst_airconditioning_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_airconditioning_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_airconditioning_status.detail().name("airconditioning_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_airconditioning_status);

            CompleteStructMember cst_airconditioning_model;
            cst_airconditioning_model.common().member_id(memberId++);
            cst_airconditioning_model.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_airconditioning_model.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_airconditioning_model.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_airconditioning_model.common().member_flags().IS_OPTIONAL(false);
            cst_airconditioning_model.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_airconditioning_model.common().member_flags().IS_KEY(false);
            cst_airconditioning_model.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_airconditioning_model.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_airconditioning_model.detail().name("airconditioning_model");

            type_object->complete().struct_type().member_seq().emplace_back(cst_airconditioning_model);

            CompleteStructMember cst_airconditioning_volume;
            cst_airconditioning_volume.common().member_id(memberId++);
            cst_airconditioning_volume.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_airconditioning_volume.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_airconditioning_volume.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_airconditioning_volume.common().member_flags().IS_OPTIONAL(false);
            cst_airconditioning_volume.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_airconditioning_volume.common().member_flags().IS_KEY(false);
            cst_airconditioning_volume.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_airconditioning_volume.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_airconditioning_volume.detail().name("airconditioning_volume");

            type_object->complete().struct_type().member_seq().emplace_back(cst_airconditioning_volume);

            CompleteStructMember cst_airconditioning_defrost;
            cst_airconditioning_defrost.common().member_id(memberId++);
            cst_airconditioning_defrost.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_airconditioning_defrost.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_airconditioning_defrost.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_airconditioning_defrost.common().member_flags().IS_OPTIONAL(false);
            cst_airconditioning_defrost.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_airconditioning_defrost.common().member_flags().IS_KEY(false);
            cst_airconditioning_defrost.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_airconditioning_defrost.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_airconditioning_defrost.detail().name("airconditioning_defrost");

            type_object->complete().struct_type().member_seq().emplace_back(cst_airconditioning_defrost);

            CompleteStructMember cst_door_status;
            cst_door_status.common().member_id(memberId++);
            cst_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_door_status.common().member_flags().IS_KEY(false);
            cst_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, true));


            cst_door_status.detail().name("door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_door_status);

            CompleteStructMember cst_rsrp;
            cst_rsrp.common().member_id(memberId++);
            cst_rsrp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rsrp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rsrp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rsrp.common().member_flags().IS_OPTIONAL(false);
            cst_rsrp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rsrp.common().member_flags().IS_KEY(false);
            cst_rsrp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rsrp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rsrp.detail().name("rsrp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rsrp);

            CompleteStructMember cst_sinr;
            cst_sinr.common().member_id(memberId++);
            cst_sinr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sinr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sinr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sinr.common().member_flags().IS_OPTIONAL(false);
            cst_sinr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sinr.common().member_flags().IS_KEY(false);
            cst_sinr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sinr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_sinr.detail().name("sinr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sinr);

            CompleteStructMember cst_uspeed;
            cst_uspeed.common().member_id(memberId++);
            cst_uspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_uspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_uspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_uspeed.common().member_flags().IS_OPTIONAL(false);
            cst_uspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_uspeed.common().member_flags().IS_KEY(false);
            cst_uspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_uspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_uspeed.detail().name("uspeed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_uspeed);

            CompleteStructMember cst_dspeed;
            cst_dspeed.common().member_id(memberId++);
            cst_dspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_dspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_dspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_dspeed.common().member_flags().IS_OPTIONAL(false);
            cst_dspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_dspeed.common().member_flags().IS_KEY(false);
            cst_dspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_dspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_dspeed.detail().name("dspeed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_dspeed);

            CompleteStructMember cst_loss;
            cst_loss.common().member_id(memberId++);
            cst_loss.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_loss.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_loss.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_loss.common().member_flags().IS_OPTIONAL(false);
            cst_loss.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_loss.common().member_flags().IS_KEY(false);
            cst_loss.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_loss.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_loss.detail().name("loss");

            type_object->complete().struct_type().member_seq().emplace_back(cst_loss);

            CompleteStructMember cst_delay;
            cst_delay.common().member_id(memberId++);
            cst_delay.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_delay.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_delay.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_delay.common().member_flags().IS_OPTIONAL(false);
            cst_delay.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_delay.common().member_flags().IS_KEY(false);
            cst_delay.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_delay.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint32_t", false));

            cst_delay.detail().name("delay");

            type_object->complete().struct_type().member_seq().emplace_back(cst_delay);

            CompleteStructMember cst_refrigeration_idx;
            cst_refrigeration_idx.common().member_id(memberId++);
            cst_refrigeration_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_refrigeration_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_refrigeration_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_refrigeration_idx.common().member_flags().IS_OPTIONAL(false);
            cst_refrigeration_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_refrigeration_idx.common().member_flags().IS_KEY(false);
            cst_refrigeration_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_refrigeration_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_refrigeration_idx.detail().name("refrigeration_idx");

            type_object->complete().struct_type().member_seq().emplace_back(cst_refrigeration_idx);

            CompleteStructMember cst_refrigeration_status;
            cst_refrigeration_status.common().member_id(memberId++);
            cst_refrigeration_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_refrigeration_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_refrigeration_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_refrigeration_status.common().member_flags().IS_OPTIONAL(false);
            cst_refrigeration_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_refrigeration_status.common().member_flags().IS_KEY(false);
            cst_refrigeration_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_refrigeration_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_refrigeration_status.detail().name("refrigeration_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_refrigeration_status);

            CompleteStructMember cst_refrigeration_stemp;
            cst_refrigeration_stemp.common().member_id(memberId++);
            cst_refrigeration_stemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_refrigeration_stemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_refrigeration_stemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_refrigeration_stemp.common().member_flags().IS_OPTIONAL(false);
            cst_refrigeration_stemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_refrigeration_stemp.common().member_flags().IS_KEY(false);
            cst_refrigeration_stemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_refrigeration_stemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_refrigeration_stemp.detail().name("refrigeration_stemp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_refrigeration_stemp);

            CompleteStructMember cst_refrigeration_ctemp;
            cst_refrigeration_ctemp.common().member_id(memberId++);
            cst_refrigeration_ctemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_refrigeration_ctemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_refrigeration_ctemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_refrigeration_ctemp.common().member_flags().IS_OPTIONAL(false);
            cst_refrigeration_ctemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_refrigeration_ctemp.common().member_flags().IS_KEY(false);
            cst_refrigeration_ctemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_refrigeration_ctemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_refrigeration_ctemp.detail().name("refrigeration_ctemp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_refrigeration_ctemp);

            CompleteStructMember cst_driving_motor_idx;
            cst_driving_motor_idx.common().member_id(memberId++);
            cst_driving_motor_idx.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_idx.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_idx.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_idx.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_idx.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_idx.common().member_flags().IS_KEY(false);
            cst_driving_motor_idx.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_idx.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_driving_motor_idx.detail().name("driving_motor_idx");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_idx);

            CompleteStructMember cst_driving_motor_status;
            cst_driving_motor_status.common().member_id(memberId++);
            cst_driving_motor_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_status.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_status.common().member_flags().IS_KEY(false);
            cst_driving_motor_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_driving_motor_status.detail().name("driving_motor_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_status);

            CompleteStructMember cst_driving_motor_ctemp;
            cst_driving_motor_ctemp.common().member_id(memberId++);
            cst_driving_motor_ctemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_ctemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_ctemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_ctemp.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_ctemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_ctemp.common().member_flags().IS_KEY(false);
            cst_driving_motor_ctemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_ctemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_driving_motor_ctemp.detail().name("driving_motor_ctemp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_ctemp);

            CompleteStructMember cst_driving_motor_rspeed;
            cst_driving_motor_rspeed.common().member_id(memberId++);
            cst_driving_motor_rspeed.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_rspeed.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_rspeed.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_rspeed.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_rspeed.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_rspeed.common().member_flags().IS_KEY(false);
            cst_driving_motor_rspeed.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_rspeed.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("uint8_t", false));

            cst_driving_motor_rspeed.detail().name("driving_motor_rspeed");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_rspeed);

            CompleteStructMember cst_driving_motor_torque;
            cst_driving_motor_torque.common().member_id(memberId++);
            cst_driving_motor_torque.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_torque.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_torque.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_torque.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_torque.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_torque.common().member_flags().IS_KEY(false);
            cst_driving_motor_torque.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_torque.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_driving_motor_torque.detail().name("driving_motor_torque");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_torque);

            CompleteStructMember cst_driving_motor_etemp;
            cst_driving_motor_etemp.common().member_id(memberId++);
            cst_driving_motor_etemp.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_etemp.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_etemp.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_etemp.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_etemp.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_etemp.common().member_flags().IS_KEY(false);
            cst_driving_motor_etemp.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_etemp.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_driving_motor_etemp.detail().name("driving_motor_etemp");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_etemp);

            CompleteStructMember cst_driving_motor_voltage;
            cst_driving_motor_voltage.common().member_id(memberId++);
            cst_driving_motor_voltage.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_voltage.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_voltage.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_voltage.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_voltage.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_voltage.common().member_flags().IS_KEY(false);
            cst_driving_motor_voltage.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_voltage.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_driving_motor_voltage.detail().name("driving_motor_voltage");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_voltage);

            CompleteStructMember cst_driving_motor_ammeter;
            cst_driving_motor_ammeter.common().member_id(memberId++);
            cst_driving_motor_ammeter.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_motor_ammeter.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_motor_ammeter.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_motor_ammeter.common().member_flags().IS_OPTIONAL(false);
            cst_driving_motor_ammeter.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_motor_ammeter.common().member_flags().IS_KEY(false);
            cst_driving_motor_ammeter.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_motor_ammeter.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_driving_motor_ammeter.detail().name("driving_motor_ammeter");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_motor_ammeter);

            CompleteStructMember cst_outline_lamp_status;
            cst_outline_lamp_status.common().member_id(memberId++);
            cst_outline_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_outline_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_outline_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_outline_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_outline_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_outline_lamp_status.common().member_flags().IS_KEY(false);
            cst_outline_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_outline_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_outline_lamp_status.detail().name("outline_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_outline_lamp_status);

            CompleteStructMember cst_warning_lamp_status;
            cst_warning_lamp_status.common().member_id(memberId++);
            cst_warning_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_warning_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_warning_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_warning_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_warning_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_warning_lamp_status.common().member_flags().IS_KEY(false);
            cst_warning_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_warning_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_warning_lamp_status.detail().name("warning_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_warning_lamp_status);

            CompleteStructMember cst_parking_lamp_status;
            cst_parking_lamp_status.common().member_id(memberId++);
            cst_parking_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_parking_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_lamp_status.common().member_flags().IS_KEY(false);
            cst_parking_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_lamp_status.detail().name("parking_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_lamp_status);

            CompleteStructMember cst_interior_lamp_status;
            cst_interior_lamp_status.common().member_id(memberId++);
            cst_interior_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_interior_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_interior_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_interior_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_interior_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_interior_lamp_status.common().member_flags().IS_KEY(false);
            cst_interior_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_interior_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_interior_lamp_status.detail().name("interior_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_interior_lamp_status);

            CompleteStructMember cst_ambient_lamp_status;
            cst_ambient_lamp_status.common().member_id(memberId++);
            cst_ambient_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_ambient_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_ambient_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_ambient_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_ambient_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_ambient_lamp_status.common().member_flags().IS_KEY(false);
            cst_ambient_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_ambient_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_ambient_lamp_status.detail().name("ambient_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_ambient_lamp_status);

            CompleteStructMember cst_welcome_lamp_status;
            cst_welcome_lamp_status.common().member_id(memberId++);
            cst_welcome_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_welcome_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_welcome_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_welcome_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_welcome_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_welcome_lamp_status.common().member_flags().IS_KEY(false);
            cst_welcome_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_welcome_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_welcome_lamp_status.detail().name("welcome_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_welcome_lamp_status);

            CompleteStructMember cst_backlight_lamp_status;
            cst_backlight_lamp_status.common().member_id(memberId++);
            cst_backlight_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_backlight_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_backlight_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_backlight_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_backlight_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_backlight_lamp_status.common().member_flags().IS_KEY(false);
            cst_backlight_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_backlight_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_backlight_lamp_status.detail().name("backlight_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_backlight_lamp_status);

            CompleteStructMember cst_positionlight_lamp_status;
            cst_positionlight_lamp_status.common().member_id(memberId++);
            cst_positionlight_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_positionlight_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_positionlight_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_positionlight_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_positionlight_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_positionlight_lamp_status.common().member_flags().IS_KEY(false);
            cst_positionlight_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_positionlight_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_positionlight_lamp_status.detail().name("positionlight_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_positionlight_lamp_status);

            CompleteStructMember cst_brakelamp_lamp_status;
            cst_brakelamp_lamp_status.common().member_id(memberId++);
            cst_brakelamp_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brakelamp_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brakelamp_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brakelamp_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_brakelamp_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brakelamp_lamp_status.common().member_flags().IS_KEY(false);
            cst_brakelamp_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brakelamp_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brakelamp_lamp_status.detail().name("brakelamp_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brakelamp_lamp_status);

            CompleteStructMember cst_backuplamp_lamp_status;
            cst_backuplamp_lamp_status.common().member_id(memberId++);
            cst_backuplamp_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_backuplamp_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_backuplamp_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_backuplamp_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_backuplamp_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_backuplamp_lamp_status.common().member_flags().IS_KEY(false);
            cst_backuplamp_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_backuplamp_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_backuplamp_lamp_status.detail().name("backuplamp_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_backuplamp_lamp_status);

            CompleteStructMember cst_length;
            cst_length.common().member_id(memberId++);
            cst_length.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_length.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_length.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_length.common().member_flags().IS_OPTIONAL(false);
            cst_length.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_length.common().member_flags().IS_KEY(false);
            cst_length.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_length.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_length.detail().name("length");

            type_object->complete().struct_type().member_seq().emplace_back(cst_length);

            CompleteStructMember cst_width;
            cst_width.common().member_id(memberId++);
            cst_width.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_width.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_width.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_width.common().member_flags().IS_OPTIONAL(false);
            cst_width.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_width.common().member_flags().IS_KEY(false);
            cst_width.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_width.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_width.detail().name("width");

            type_object->complete().struct_type().member_seq().emplace_back(cst_width);

            CompleteStructMember cst_height;
            cst_height.common().member_id(memberId++);
            cst_height.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_height.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_height.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_height.common().member_flags().IS_OPTIONAL(false);
            cst_height.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_height.common().member_flags().IS_KEY(false);
            cst_height.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_height.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int8_t", false));

            cst_height.detail().name("height");

            type_object->complete().struct_type().member_seq().emplace_back(cst_height);

            CompleteStructMember cst_traction;
            cst_traction.common().member_id(memberId++);
            cst_traction.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_traction.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_traction.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_traction.common().member_flags().IS_OPTIONAL(false);
            cst_traction.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_traction.common().member_flags().IS_KEY(false);
            cst_traction.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_traction.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_traction.detail().name("traction");

            type_object->complete().struct_type().member_seq().emplace_back(cst_traction);

            CompleteStructMember cst_abs;
            cst_abs.common().member_id(memberId++);
            cst_abs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_abs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_abs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_abs.common().member_flags().IS_OPTIONAL(false);
            cst_abs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_abs.common().member_flags().IS_KEY(false);
            cst_abs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_abs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_abs.detail().name("abs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_abs);

            CompleteStructMember cst_scs;
            cst_scs.common().member_id(memberId++);
            cst_scs.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_scs.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_scs.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_scs.common().member_flags().IS_OPTIONAL(false);
            cst_scs.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_scs.common().member_flags().IS_KEY(false);
            cst_scs.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_scs.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_scs.detail().name("scs");

            type_object->complete().struct_type().member_seq().emplace_back(cst_scs);

            CompleteStructMember cst_brake_boost;
            cst_brake_boost.common().member_id(memberId++);
            cst_brake_boost.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_boost.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_boost.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_boost.common().member_flags().IS_OPTIONAL(false);
            cst_brake_boost.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_boost.common().member_flags().IS_KEY(false);
            cst_brake_boost.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_boost.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_boost.detail().name("brake_boost");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_boost);

            CompleteStructMember cst_aux_brakes;
            cst_aux_brakes.common().member_id(memberId++);
            cst_aux_brakes.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_aux_brakes.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_aux_brakes.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_aux_brakes.common().member_flags().IS_OPTIONAL(false);
            cst_aux_brakes.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_aux_brakes.common().member_flags().IS_KEY(false);
            cst_aux_brakes.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_aux_brakes.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_aux_brakes.detail().name("aux_brakes");

            type_object->complete().struct_type().member_seq().emplace_back(cst_aux_brakes);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Vehicle");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Vehicle", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Vehicle", true);
        }

    } // namespace msg
} // namespace ros2_interface