// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WarningCommand.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "WarningCommand.h"
#include "WarningCommandTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_WarningCommand_max_cdr_typesize 16ULL;
#define ros2_interface_msg_WarningCommand_max_key_cdr_typesize 0ULL;

ros2_interface::msg::WarningCommand::WarningCommand()
{
    // long m_sound_alarm
    m_sound_alarm = 0;
    // long m_light_alarm
    m_light_alarm = 0;
    // long m_media_alarm
    m_media_alarm = 0;
    // long m_motion_alarm
    m_motion_alarm = 0;

    // Just to register all known types
    registerWarningCommandTypes();
}

ros2_interface::msg::WarningCommand::~WarningCommand()
{




}

ros2_interface::msg::WarningCommand::WarningCommand(
        const WarningCommand& x)
{
    m_sound_alarm = x.m_sound_alarm;
    m_light_alarm = x.m_light_alarm;
    m_media_alarm = x.m_media_alarm;
    m_motion_alarm = x.m_motion_alarm;
}

ros2_interface::msg::WarningCommand::WarningCommand(
        WarningCommand&& x) noexcept 
{
    m_sound_alarm = x.m_sound_alarm;
    m_light_alarm = x.m_light_alarm;
    m_media_alarm = x.m_media_alarm;
    m_motion_alarm = x.m_motion_alarm;
}

ros2_interface::msg::WarningCommand& ros2_interface::msg::WarningCommand::operator =(
        const WarningCommand& x)
{

    m_sound_alarm = x.m_sound_alarm;
    m_light_alarm = x.m_light_alarm;
    m_media_alarm = x.m_media_alarm;
    m_motion_alarm = x.m_motion_alarm;

    return *this;
}

ros2_interface::msg::WarningCommand& ros2_interface::msg::WarningCommand::operator =(
        WarningCommand&& x) noexcept
{

    m_sound_alarm = x.m_sound_alarm;
    m_light_alarm = x.m_light_alarm;
    m_media_alarm = x.m_media_alarm;
    m_motion_alarm = x.m_motion_alarm;

    return *this;
}

bool ros2_interface::msg::WarningCommand::operator ==(
        const WarningCommand& x) const
{

    return (m_sound_alarm == x.m_sound_alarm && m_light_alarm == x.m_light_alarm && m_media_alarm == x.m_media_alarm && m_motion_alarm == x.m_motion_alarm);
}

bool ros2_interface::msg::WarningCommand::operator !=(
        const WarningCommand& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::WarningCommand::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_WarningCommand_max_cdr_typesize;
}

size_t ros2_interface::msg::WarningCommand::getCdrSerializedSize(
        const ros2_interface::msg::WarningCommand& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::WarningCommand::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_sound_alarm;
    scdr << m_light_alarm;
    scdr << m_media_alarm;
    scdr << m_motion_alarm;

}

void ros2_interface::msg::WarningCommand::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_sound_alarm;
    dcdr >> m_light_alarm;
    dcdr >> m_media_alarm;
    dcdr >> m_motion_alarm;
}

/*!
 * @brief This function sets a value in member sound_alarm
 * @param _sound_alarm New value for member sound_alarm
 */
void ros2_interface::msg::WarningCommand::sound_alarm(
        int32_t _sound_alarm)
{
    m_sound_alarm = _sound_alarm;
}

/*!
 * @brief This function returns the value of member sound_alarm
 * @return Value of member sound_alarm
 */
int32_t ros2_interface::msg::WarningCommand::sound_alarm() const
{
    return m_sound_alarm;
}

/*!
 * @brief This function returns a reference to member sound_alarm
 * @return Reference to member sound_alarm
 */
int32_t& ros2_interface::msg::WarningCommand::sound_alarm()
{
    return m_sound_alarm;
}

/*!
 * @brief This function sets a value in member light_alarm
 * @param _light_alarm New value for member light_alarm
 */
void ros2_interface::msg::WarningCommand::light_alarm(
        int32_t _light_alarm)
{
    m_light_alarm = _light_alarm;
}

/*!
 * @brief This function returns the value of member light_alarm
 * @return Value of member light_alarm
 */
int32_t ros2_interface::msg::WarningCommand::light_alarm() const
{
    return m_light_alarm;
}

/*!
 * @brief This function returns a reference to member light_alarm
 * @return Reference to member light_alarm
 */
int32_t& ros2_interface::msg::WarningCommand::light_alarm()
{
    return m_light_alarm;
}

/*!
 * @brief This function sets a value in member media_alarm
 * @param _media_alarm New value for member media_alarm
 */
void ros2_interface::msg::WarningCommand::media_alarm(
        int32_t _media_alarm)
{
    m_media_alarm = _media_alarm;
}

/*!
 * @brief This function returns the value of member media_alarm
 * @return Value of member media_alarm
 */
int32_t ros2_interface::msg::WarningCommand::media_alarm() const
{
    return m_media_alarm;
}

/*!
 * @brief This function returns a reference to member media_alarm
 * @return Reference to member media_alarm
 */
int32_t& ros2_interface::msg::WarningCommand::media_alarm()
{
    return m_media_alarm;
}

/*!
 * @brief This function sets a value in member motion_alarm
 * @param _motion_alarm New value for member motion_alarm
 */
void ros2_interface::msg::WarningCommand::motion_alarm(
        int32_t _motion_alarm)
{
    m_motion_alarm = _motion_alarm;
}

/*!
 * @brief This function returns the value of member motion_alarm
 * @return Value of member motion_alarm
 */
int32_t ros2_interface::msg::WarningCommand::motion_alarm() const
{
    return m_motion_alarm;
}

/*!
 * @brief This function returns a reference to member motion_alarm
 * @return Reference to member motion_alarm
 */
int32_t& ros2_interface::msg::WarningCommand::motion_alarm()
{
    return m_motion_alarm;
}



size_t ros2_interface::msg::WarningCommand::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_WarningCommand_max_key_cdr_typesize;
}

bool ros2_interface::msg::WarningCommand::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::WarningCommand::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



