// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WarningCommand.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WARNINGCOMMAND_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WARNINGCOMMAND_H_


#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(WARNINGCOMMAND_SOURCE)
#define WARNINGCOMMAND_DllAPI __declspec( dllexport )
#else
#define WARNINGCOMMAND_DllAPI __declspec( dllimport )
#endif // WARNINGCOMMAND_SOURCE
#else
#define WARNINGCOMMAND_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define WARNINGCOMMAND_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure WarningCommand defined by the user in the IDL file.
         * @ingroup WarningCommand
         */
        class WarningCommand
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport WarningCommand();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~WarningCommand();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::WarningCommand that will be copied.
             */
            eProsima_user_DllExport WarningCommand(
                    const WarningCommand& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::WarningCommand that will be copied.
             */
            eProsima_user_DllExport WarningCommand(
                    WarningCommand&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::WarningCommand that will be copied.
             */
            eProsima_user_DllExport WarningCommand& operator =(
                    const WarningCommand& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::WarningCommand that will be copied.
             */
            eProsima_user_DllExport WarningCommand& operator =(
                    WarningCommand&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::WarningCommand object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const WarningCommand& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::WarningCommand object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const WarningCommand& x) const;

            /*!
             * @brief This function sets a value in member sound_alarm
             * @param _sound_alarm New value for member sound_alarm
             */
            eProsima_user_DllExport void sound_alarm(
                    int32_t _sound_alarm);

            /*!
             * @brief This function returns the value of member sound_alarm
             * @return Value of member sound_alarm
             */
            eProsima_user_DllExport int32_t sound_alarm() const;

            /*!
             * @brief This function returns a reference to member sound_alarm
             * @return Reference to member sound_alarm
             */
            eProsima_user_DllExport int32_t& sound_alarm();

            /*!
             * @brief This function sets a value in member light_alarm
             * @param _light_alarm New value for member light_alarm
             */
            eProsima_user_DllExport void light_alarm(
                    int32_t _light_alarm);

            /*!
             * @brief This function returns the value of member light_alarm
             * @return Value of member light_alarm
             */
            eProsima_user_DllExport int32_t light_alarm() const;

            /*!
             * @brief This function returns a reference to member light_alarm
             * @return Reference to member light_alarm
             */
            eProsima_user_DllExport int32_t& light_alarm();

            /*!
             * @brief This function sets a value in member media_alarm
             * @param _media_alarm New value for member media_alarm
             */
            eProsima_user_DllExport void media_alarm(
                    int32_t _media_alarm);

            /*!
             * @brief This function returns the value of member media_alarm
             * @return Value of member media_alarm
             */
            eProsima_user_DllExport int32_t media_alarm() const;

            /*!
             * @brief This function returns a reference to member media_alarm
             * @return Reference to member media_alarm
             */
            eProsima_user_DllExport int32_t& media_alarm();

            /*!
             * @brief This function sets a value in member motion_alarm
             * @param _motion_alarm New value for member motion_alarm
             */
            eProsima_user_DllExport void motion_alarm(
                    int32_t _motion_alarm);

            /*!
             * @brief This function returns the value of member motion_alarm
             * @return Value of member motion_alarm
             */
            eProsima_user_DllExport int32_t motion_alarm() const;

            /*!
             * @brief This function returns a reference to member motion_alarm
             * @return Reference to member motion_alarm
             */
            eProsima_user_DllExport int32_t& motion_alarm();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::WarningCommand& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            int32_t m_sound_alarm;
            int32_t m_light_alarm;
            int32_t m_media_alarm;
            int32_t m_motion_alarm;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WARNINGCOMMAND_H_

