// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WarningCommandTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "WarningCommand.h"
#include "WarningCommandTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerWarningCommandTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::WarningCommand", ros2_interface::msg::GetWarningCommandIdentifier(true),
                        ros2_interface::msg::GetWarningCommandObject(true));
                factory->add_type_object("ros2_interface::msg::WarningCommand", ros2_interface::msg::GetWarningCommandIdentifier(false),
                        ros2_interface::msg::GetWarningCommandObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetWarningCommandIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("WarningCommand", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetWarningCommandObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("WarningCommand", complete);
        }

        const TypeObject* GetWarningCommandObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WarningCommand", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteWarningCommandObject();
            }
            //else
            return GetMinimalWarningCommandObject();
        }

        const TypeObject* GetMinimalWarningCommandObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WarningCommand", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_sound_alarm;
            mst_sound_alarm.common().member_id(memberId++);
            mst_sound_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_sound_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_sound_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_sound_alarm.common().member_flags().IS_OPTIONAL(false);
            mst_sound_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_sound_alarm.common().member_flags().IS_KEY(false);
            mst_sound_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_sound_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 sound_alarm_hash("sound_alarm");
            for(int i = 0; i < 4; ++i)
            {
                mst_sound_alarm.detail().name_hash()[i] = sound_alarm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_sound_alarm);

            MinimalStructMember mst_light_alarm;
            mst_light_alarm.common().member_id(memberId++);
            mst_light_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_light_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_light_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_light_alarm.common().member_flags().IS_OPTIONAL(false);
            mst_light_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_light_alarm.common().member_flags().IS_KEY(false);
            mst_light_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_light_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 light_alarm_hash("light_alarm");
            for(int i = 0; i < 4; ++i)
            {
                mst_light_alarm.detail().name_hash()[i] = light_alarm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_light_alarm);

            MinimalStructMember mst_media_alarm;
            mst_media_alarm.common().member_id(memberId++);
            mst_media_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_media_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_media_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_media_alarm.common().member_flags().IS_OPTIONAL(false);
            mst_media_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_media_alarm.common().member_flags().IS_KEY(false);
            mst_media_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_media_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 media_alarm_hash("media_alarm");
            for(int i = 0; i < 4; ++i)
            {
                mst_media_alarm.detail().name_hash()[i] = media_alarm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_media_alarm);

            MinimalStructMember mst_motion_alarm;
            mst_motion_alarm.common().member_id(memberId++);
            mst_motion_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_motion_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_motion_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_motion_alarm.common().member_flags().IS_OPTIONAL(false);
            mst_motion_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_motion_alarm.common().member_flags().IS_KEY(false);
            mst_motion_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_motion_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 motion_alarm_hash("motion_alarm");
            for(int i = 0; i < 4; ++i)
            {
                mst_motion_alarm.detail().name_hash()[i] = motion_alarm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_motion_alarm);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("WarningCommand", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("WarningCommand", false);
        }

        const TypeObject* GetCompleteWarningCommandObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WarningCommand", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_sound_alarm;
            cst_sound_alarm.common().member_id(memberId++);
            cst_sound_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_sound_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_sound_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_sound_alarm.common().member_flags().IS_OPTIONAL(false);
            cst_sound_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_sound_alarm.common().member_flags().IS_KEY(false);
            cst_sound_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_sound_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_sound_alarm.detail().name("sound_alarm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_sound_alarm);

            CompleteStructMember cst_light_alarm;
            cst_light_alarm.common().member_id(memberId++);
            cst_light_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_light_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_light_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_light_alarm.common().member_flags().IS_OPTIONAL(false);
            cst_light_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_light_alarm.common().member_flags().IS_KEY(false);
            cst_light_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_light_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_light_alarm.detail().name("light_alarm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_light_alarm);

            CompleteStructMember cst_media_alarm;
            cst_media_alarm.common().member_id(memberId++);
            cst_media_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_media_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_media_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_media_alarm.common().member_flags().IS_OPTIONAL(false);
            cst_media_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_media_alarm.common().member_flags().IS_KEY(false);
            cst_media_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_media_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_media_alarm.detail().name("media_alarm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_media_alarm);

            CompleteStructMember cst_motion_alarm;
            cst_motion_alarm.common().member_id(memberId++);
            cst_motion_alarm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_motion_alarm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_motion_alarm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_motion_alarm.common().member_flags().IS_OPTIONAL(false);
            cst_motion_alarm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_motion_alarm.common().member_flags().IS_KEY(false);
            cst_motion_alarm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_motion_alarm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_motion_alarm.detail().name("motion_alarm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_motion_alarm);


            // Header
            type_object->complete().struct_type().header().detail().type_name("WarningCommand");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("WarningCommand", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("WarningCommand", true);
        }

    } // namespace msg
} // namespace ros2_interface