// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WheelInfo.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace {
char dummy;
}  // namespace
#endif  // _WIN32

#include "WheelInfo.h"
#include "WheelInfoTypeObject.h"
#include <fastcdr/Cdr.h>

#include <fastcdr/exceptions/BadParamException.h>
using namespace eprosima::fastcdr::exception;

#include <utility>

#define ros2_interface_msg_Time_max_cdr_typesize 8ULL;
#define ros2_interface_msg_Header_max_cdr_typesize 272ULL;
#define ros2_interface_msg_WheelInfo_max_cdr_typesize 384ULL;
#define ros2_interface_msg_Time_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_Header_max_key_cdr_typesize 0ULL;
#define ros2_interface_msg_WheelInfo_max_key_cdr_typesize 0ULL;

ros2_interface::msg::WheelInfo::WheelInfo()
{
    // ros2_interface::msg::Header m_header

    // long m_moving_status
    m_moving_status = 0;
    // long m_steer_driving_mode
    m_steer_driving_mode = 0;
    // double m_steering_value
    m_steering_value = 0.0;
    // double m_steering_torque_nm
    m_steering_torque_nm = 0.0;
    // double m_steering_rate_dps
    m_steering_rate_dps = 0.0;
    // double m_speed_mps
    m_speed_mps = 0.0;
    // long m_wheel_direction_rr
    m_wheel_direction_rr = 0;
    // double m_wheel_spd_rr
    m_wheel_spd_rr = 0.0;
    // long m_wheel_direction_rl
    m_wheel_direction_rl = 0;
    // double m_wheel_spd_rl
    m_wheel_spd_rl = 0.0;
    // long m_wheel_direction_fr
    m_wheel_direction_fr = 0;
    // double m_wheel_spd_fr
    m_wheel_spd_fr = 0.0;
    // long m_wheel_direction_fl
    m_wheel_direction_fl = 0;
    // double m_wheel_spd_fl
    m_wheel_spd_fl = 0.0;
    // double m_yaw_rate
    m_yaw_rate = 0.0;

    // Just to register all known types
    registerWheelInfoTypes();
}

ros2_interface::msg::WheelInfo::~WheelInfo()
{
















}

ros2_interface::msg::WheelInfo::WheelInfo(
        const WheelInfo& x)
{
    m_header = x.m_header;
    m_moving_status = x.m_moving_status;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_value = x.m_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_steering_rate_dps = x.m_steering_rate_dps;
    m_speed_mps = x.m_speed_mps;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_yaw_rate = x.m_yaw_rate;
}

ros2_interface::msg::WheelInfo::WheelInfo(
        WheelInfo&& x) noexcept 
{
    m_header = std::move(x.m_header);
    m_moving_status = x.m_moving_status;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_value = x.m_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_steering_rate_dps = x.m_steering_rate_dps;
    m_speed_mps = x.m_speed_mps;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_yaw_rate = x.m_yaw_rate;
}

ros2_interface::msg::WheelInfo& ros2_interface::msg::WheelInfo::operator =(
        const WheelInfo& x)
{

    m_header = x.m_header;
    m_moving_status = x.m_moving_status;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_value = x.m_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_steering_rate_dps = x.m_steering_rate_dps;
    m_speed_mps = x.m_speed_mps;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_yaw_rate = x.m_yaw_rate;

    return *this;
}

ros2_interface::msg::WheelInfo& ros2_interface::msg::WheelInfo::operator =(
        WheelInfo&& x) noexcept
{

    m_header = std::move(x.m_header);
    m_moving_status = x.m_moving_status;
    m_steer_driving_mode = x.m_steer_driving_mode;
    m_steering_value = x.m_steering_value;
    m_steering_torque_nm = x.m_steering_torque_nm;
    m_steering_rate_dps = x.m_steering_rate_dps;
    m_speed_mps = x.m_speed_mps;
    m_wheel_direction_rr = x.m_wheel_direction_rr;
    m_wheel_spd_rr = x.m_wheel_spd_rr;
    m_wheel_direction_rl = x.m_wheel_direction_rl;
    m_wheel_spd_rl = x.m_wheel_spd_rl;
    m_wheel_direction_fr = x.m_wheel_direction_fr;
    m_wheel_spd_fr = x.m_wheel_spd_fr;
    m_wheel_direction_fl = x.m_wheel_direction_fl;
    m_wheel_spd_fl = x.m_wheel_spd_fl;
    m_yaw_rate = x.m_yaw_rate;

    return *this;
}

bool ros2_interface::msg::WheelInfo::operator ==(
        const WheelInfo& x) const
{

    return (m_header == x.m_header && m_moving_status == x.m_moving_status && m_steer_driving_mode == x.m_steer_driving_mode && m_steering_value == x.m_steering_value && m_steering_torque_nm == x.m_steering_torque_nm && m_steering_rate_dps == x.m_steering_rate_dps && m_speed_mps == x.m_speed_mps && m_wheel_direction_rr == x.m_wheel_direction_rr && m_wheel_spd_rr == x.m_wheel_spd_rr && m_wheel_direction_rl == x.m_wheel_direction_rl && m_wheel_spd_rl == x.m_wheel_spd_rl && m_wheel_direction_fr == x.m_wheel_direction_fr && m_wheel_spd_fr == x.m_wheel_spd_fr && m_wheel_direction_fl == x.m_wheel_direction_fl && m_wheel_spd_fl == x.m_wheel_spd_fl && m_yaw_rate == x.m_yaw_rate);
}

bool ros2_interface::msg::WheelInfo::operator !=(
        const WheelInfo& x) const
{
    return !(*this == x);
}

size_t ros2_interface::msg::WheelInfo::getMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_WheelInfo_max_cdr_typesize;
}

size_t ros2_interface::msg::WheelInfo::getCdrSerializedSize(
        const ros2_interface::msg::WheelInfo& data,
        size_t current_alignment)
{
    (void)data;
    size_t initial_alignment = current_alignment;


    current_alignment += ros2_interface::msg::Header::getCdrSerializedSize(data.header(), current_alignment);
    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 4 + eprosima::fastcdr::Cdr::alignment(current_alignment, 4);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);


    current_alignment += 8 + eprosima::fastcdr::Cdr::alignment(current_alignment, 8);



    return current_alignment - initial_alignment;
}

void ros2_interface::msg::WheelInfo::serialize(
        eprosima::fastcdr::Cdr& scdr) const
{

    scdr << m_header;
    scdr << m_moving_status;
    scdr << m_steer_driving_mode;
    scdr << m_steering_value;
    scdr << m_steering_torque_nm;
    scdr << m_steering_rate_dps;
    scdr << m_speed_mps;
    scdr << m_wheel_direction_rr;
    scdr << m_wheel_spd_rr;
    scdr << m_wheel_direction_rl;
    scdr << m_wheel_spd_rl;
    scdr << m_wheel_direction_fr;
    scdr << m_wheel_spd_fr;
    scdr << m_wheel_direction_fl;
    scdr << m_wheel_spd_fl;
    scdr << m_yaw_rate;

}

void ros2_interface::msg::WheelInfo::deserialize(
        eprosima::fastcdr::Cdr& dcdr)
{

    dcdr >> m_header;
    dcdr >> m_moving_status;
    dcdr >> m_steer_driving_mode;
    dcdr >> m_steering_value;
    dcdr >> m_steering_torque_nm;
    dcdr >> m_steering_rate_dps;
    dcdr >> m_speed_mps;
    dcdr >> m_wheel_direction_rr;
    dcdr >> m_wheel_spd_rr;
    dcdr >> m_wheel_direction_rl;
    dcdr >> m_wheel_spd_rl;
    dcdr >> m_wheel_direction_fr;
    dcdr >> m_wheel_spd_fr;
    dcdr >> m_wheel_direction_fl;
    dcdr >> m_wheel_spd_fl;
    dcdr >> m_yaw_rate;
}

/*!
 * @brief This function copies the value in member header
 * @param _header New value to be copied in member header
 */
void ros2_interface::msg::WheelInfo::header(
        const ros2_interface::msg::Header& _header)
{
    m_header = _header;
}

/*!
 * @brief This function moves the value in member header
 * @param _header New value to be moved in member header
 */
void ros2_interface::msg::WheelInfo::header(
        ros2_interface::msg::Header&& _header)
{
    m_header = std::move(_header);
}

/*!
 * @brief This function returns a constant reference to member header
 * @return Constant reference to member header
 */
const ros2_interface::msg::Header& ros2_interface::msg::WheelInfo::header() const
{
    return m_header;
}

/*!
 * @brief This function returns a reference to member header
 * @return Reference to member header
 */
ros2_interface::msg::Header& ros2_interface::msg::WheelInfo::header()
{
    return m_header;
}
/*!
 * @brief This function sets a value in member moving_status
 * @param _moving_status New value for member moving_status
 */
void ros2_interface::msg::WheelInfo::moving_status(
        int32_t _moving_status)
{
    m_moving_status = _moving_status;
}

/*!
 * @brief This function returns the value of member moving_status
 * @return Value of member moving_status
 */
int32_t ros2_interface::msg::WheelInfo::moving_status() const
{
    return m_moving_status;
}

/*!
 * @brief This function returns a reference to member moving_status
 * @return Reference to member moving_status
 */
int32_t& ros2_interface::msg::WheelInfo::moving_status()
{
    return m_moving_status;
}

/*!
 * @brief This function sets a value in member steer_driving_mode
 * @param _steer_driving_mode New value for member steer_driving_mode
 */
void ros2_interface::msg::WheelInfo::steer_driving_mode(
        int32_t _steer_driving_mode)
{
    m_steer_driving_mode = _steer_driving_mode;
}

/*!
 * @brief This function returns the value of member steer_driving_mode
 * @return Value of member steer_driving_mode
 */
int32_t ros2_interface::msg::WheelInfo::steer_driving_mode() const
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function returns a reference to member steer_driving_mode
 * @return Reference to member steer_driving_mode
 */
int32_t& ros2_interface::msg::WheelInfo::steer_driving_mode()
{
    return m_steer_driving_mode;
}

/*!
 * @brief This function sets a value in member steering_value
 * @param _steering_value New value for member steering_value
 */
void ros2_interface::msg::WheelInfo::steering_value(
        double _steering_value)
{
    m_steering_value = _steering_value;
}

/*!
 * @brief This function returns the value of member steering_value
 * @return Value of member steering_value
 */
double ros2_interface::msg::WheelInfo::steering_value() const
{
    return m_steering_value;
}

/*!
 * @brief This function returns a reference to member steering_value
 * @return Reference to member steering_value
 */
double& ros2_interface::msg::WheelInfo::steering_value()
{
    return m_steering_value;
}

/*!
 * @brief This function sets a value in member steering_torque_nm
 * @param _steering_torque_nm New value for member steering_torque_nm
 */
void ros2_interface::msg::WheelInfo::steering_torque_nm(
        double _steering_torque_nm)
{
    m_steering_torque_nm = _steering_torque_nm;
}

/*!
 * @brief This function returns the value of member steering_torque_nm
 * @return Value of member steering_torque_nm
 */
double ros2_interface::msg::WheelInfo::steering_torque_nm() const
{
    return m_steering_torque_nm;
}

/*!
 * @brief This function returns a reference to member steering_torque_nm
 * @return Reference to member steering_torque_nm
 */
double& ros2_interface::msg::WheelInfo::steering_torque_nm()
{
    return m_steering_torque_nm;
}

/*!
 * @brief This function sets a value in member steering_rate_dps
 * @param _steering_rate_dps New value for member steering_rate_dps
 */
void ros2_interface::msg::WheelInfo::steering_rate_dps(
        double _steering_rate_dps)
{
    m_steering_rate_dps = _steering_rate_dps;
}

/*!
 * @brief This function returns the value of member steering_rate_dps
 * @return Value of member steering_rate_dps
 */
double ros2_interface::msg::WheelInfo::steering_rate_dps() const
{
    return m_steering_rate_dps;
}

/*!
 * @brief This function returns a reference to member steering_rate_dps
 * @return Reference to member steering_rate_dps
 */
double& ros2_interface::msg::WheelInfo::steering_rate_dps()
{
    return m_steering_rate_dps;
}

/*!
 * @brief This function sets a value in member speed_mps
 * @param _speed_mps New value for member speed_mps
 */
void ros2_interface::msg::WheelInfo::speed_mps(
        double _speed_mps)
{
    m_speed_mps = _speed_mps;
}

/*!
 * @brief This function returns the value of member speed_mps
 * @return Value of member speed_mps
 */
double ros2_interface::msg::WheelInfo::speed_mps() const
{
    return m_speed_mps;
}

/*!
 * @brief This function returns a reference to member speed_mps
 * @return Reference to member speed_mps
 */
double& ros2_interface::msg::WheelInfo::speed_mps()
{
    return m_speed_mps;
}

/*!
 * @brief This function sets a value in member wheel_direction_rr
 * @param _wheel_direction_rr New value for member wheel_direction_rr
 */
void ros2_interface::msg::WheelInfo::wheel_direction_rr(
        int32_t _wheel_direction_rr)
{
    m_wheel_direction_rr = _wheel_direction_rr;
}

/*!
 * @brief This function returns the value of member wheel_direction_rr
 * @return Value of member wheel_direction_rr
 */
int32_t ros2_interface::msg::WheelInfo::wheel_direction_rr() const
{
    return m_wheel_direction_rr;
}

/*!
 * @brief This function returns a reference to member wheel_direction_rr
 * @return Reference to member wheel_direction_rr
 */
int32_t& ros2_interface::msg::WheelInfo::wheel_direction_rr()
{
    return m_wheel_direction_rr;
}

/*!
 * @brief This function sets a value in member wheel_spd_rr
 * @param _wheel_spd_rr New value for member wheel_spd_rr
 */
void ros2_interface::msg::WheelInfo::wheel_spd_rr(
        double _wheel_spd_rr)
{
    m_wheel_spd_rr = _wheel_spd_rr;
}

/*!
 * @brief This function returns the value of member wheel_spd_rr
 * @return Value of member wheel_spd_rr
 */
double ros2_interface::msg::WheelInfo::wheel_spd_rr() const
{
    return m_wheel_spd_rr;
}

/*!
 * @brief This function returns a reference to member wheel_spd_rr
 * @return Reference to member wheel_spd_rr
 */
double& ros2_interface::msg::WheelInfo::wheel_spd_rr()
{
    return m_wheel_spd_rr;
}

/*!
 * @brief This function sets a value in member wheel_direction_rl
 * @param _wheel_direction_rl New value for member wheel_direction_rl
 */
void ros2_interface::msg::WheelInfo::wheel_direction_rl(
        int32_t _wheel_direction_rl)
{
    m_wheel_direction_rl = _wheel_direction_rl;
}

/*!
 * @brief This function returns the value of member wheel_direction_rl
 * @return Value of member wheel_direction_rl
 */
int32_t ros2_interface::msg::WheelInfo::wheel_direction_rl() const
{
    return m_wheel_direction_rl;
}

/*!
 * @brief This function returns a reference to member wheel_direction_rl
 * @return Reference to member wheel_direction_rl
 */
int32_t& ros2_interface::msg::WheelInfo::wheel_direction_rl()
{
    return m_wheel_direction_rl;
}

/*!
 * @brief This function sets a value in member wheel_spd_rl
 * @param _wheel_spd_rl New value for member wheel_spd_rl
 */
void ros2_interface::msg::WheelInfo::wheel_spd_rl(
        double _wheel_spd_rl)
{
    m_wheel_spd_rl = _wheel_spd_rl;
}

/*!
 * @brief This function returns the value of member wheel_spd_rl
 * @return Value of member wheel_spd_rl
 */
double ros2_interface::msg::WheelInfo::wheel_spd_rl() const
{
    return m_wheel_spd_rl;
}

/*!
 * @brief This function returns a reference to member wheel_spd_rl
 * @return Reference to member wheel_spd_rl
 */
double& ros2_interface::msg::WheelInfo::wheel_spd_rl()
{
    return m_wheel_spd_rl;
}

/*!
 * @brief This function sets a value in member wheel_direction_fr
 * @param _wheel_direction_fr New value for member wheel_direction_fr
 */
void ros2_interface::msg::WheelInfo::wheel_direction_fr(
        int32_t _wheel_direction_fr)
{
    m_wheel_direction_fr = _wheel_direction_fr;
}

/*!
 * @brief This function returns the value of member wheel_direction_fr
 * @return Value of member wheel_direction_fr
 */
int32_t ros2_interface::msg::WheelInfo::wheel_direction_fr() const
{
    return m_wheel_direction_fr;
}

/*!
 * @brief This function returns a reference to member wheel_direction_fr
 * @return Reference to member wheel_direction_fr
 */
int32_t& ros2_interface::msg::WheelInfo::wheel_direction_fr()
{
    return m_wheel_direction_fr;
}

/*!
 * @brief This function sets a value in member wheel_spd_fr
 * @param _wheel_spd_fr New value for member wheel_spd_fr
 */
void ros2_interface::msg::WheelInfo::wheel_spd_fr(
        double _wheel_spd_fr)
{
    m_wheel_spd_fr = _wheel_spd_fr;
}

/*!
 * @brief This function returns the value of member wheel_spd_fr
 * @return Value of member wheel_spd_fr
 */
double ros2_interface::msg::WheelInfo::wheel_spd_fr() const
{
    return m_wheel_spd_fr;
}

/*!
 * @brief This function returns a reference to member wheel_spd_fr
 * @return Reference to member wheel_spd_fr
 */
double& ros2_interface::msg::WheelInfo::wheel_spd_fr()
{
    return m_wheel_spd_fr;
}

/*!
 * @brief This function sets a value in member wheel_direction_fl
 * @param _wheel_direction_fl New value for member wheel_direction_fl
 */
void ros2_interface::msg::WheelInfo::wheel_direction_fl(
        int32_t _wheel_direction_fl)
{
    m_wheel_direction_fl = _wheel_direction_fl;
}

/*!
 * @brief This function returns the value of member wheel_direction_fl
 * @return Value of member wheel_direction_fl
 */
int32_t ros2_interface::msg::WheelInfo::wheel_direction_fl() const
{
    return m_wheel_direction_fl;
}

/*!
 * @brief This function returns a reference to member wheel_direction_fl
 * @return Reference to member wheel_direction_fl
 */
int32_t& ros2_interface::msg::WheelInfo::wheel_direction_fl()
{
    return m_wheel_direction_fl;
}

/*!
 * @brief This function sets a value in member wheel_spd_fl
 * @param _wheel_spd_fl New value for member wheel_spd_fl
 */
void ros2_interface::msg::WheelInfo::wheel_spd_fl(
        double _wheel_spd_fl)
{
    m_wheel_spd_fl = _wheel_spd_fl;
}

/*!
 * @brief This function returns the value of member wheel_spd_fl
 * @return Value of member wheel_spd_fl
 */
double ros2_interface::msg::WheelInfo::wheel_spd_fl() const
{
    return m_wheel_spd_fl;
}

/*!
 * @brief This function returns a reference to member wheel_spd_fl
 * @return Reference to member wheel_spd_fl
 */
double& ros2_interface::msg::WheelInfo::wheel_spd_fl()
{
    return m_wheel_spd_fl;
}

/*!
 * @brief This function sets a value in member yaw_rate
 * @param _yaw_rate New value for member yaw_rate
 */
void ros2_interface::msg::WheelInfo::yaw_rate(
        double _yaw_rate)
{
    m_yaw_rate = _yaw_rate;
}

/*!
 * @brief This function returns the value of member yaw_rate
 * @return Value of member yaw_rate
 */
double ros2_interface::msg::WheelInfo::yaw_rate() const
{
    return m_yaw_rate;
}

/*!
 * @brief This function returns a reference to member yaw_rate
 * @return Reference to member yaw_rate
 */
double& ros2_interface::msg::WheelInfo::yaw_rate()
{
    return m_yaw_rate;
}



size_t ros2_interface::msg::WheelInfo::getKeyMaxCdrSerializedSize(
        size_t current_alignment)
{
    static_cast<void>(current_alignment);
    return ros2_interface_msg_WheelInfo_max_key_cdr_typesize;
}

bool ros2_interface::msg::WheelInfo::isKeyDefined()
{
    return false;
}

void ros2_interface::msg::WheelInfo::serializeKey(
        eprosima::fastcdr::Cdr& scdr) const
{
    (void) scdr;
}



