// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WheelInfo.h
 * This header file contains the declaration of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifndef _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WHEELINFO_H_
#define _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WHEELINFO_H_

#include "Header.h"

#include <fastrtps/utils/fixed_size_string.hpp>

#include <stdint.h>
#include <array>
#include <string>
#include <vector>
#include <map>
#include <bitset>

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#define eProsima_user_DllExport __declspec( dllexport )
#else
#define eProsima_user_DllExport
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define eProsima_user_DllExport
#endif  // _WIN32

#if defined(_WIN32)
#if defined(EPROSIMA_USER_DLL_EXPORT)
#if defined(WHEELINFO_SOURCE)
#define WHEELINFO_DllAPI __declspec( dllexport )
#else
#define WHEELINFO_DllAPI __declspec( dllimport )
#endif // WHEELINFO_SOURCE
#else
#define WHEELINFO_DllAPI
#endif  // EPROSIMA_USER_DLL_EXPORT
#else
#define WHEELINFO_DllAPI
#endif // _WIN32

namespace eprosima {
namespace fastcdr {
class Cdr;
} // namespace fastcdr
} // namespace eprosima


namespace ros2_interface {
    namespace msg {
        /*!
         * @brief This class represents the structure WheelInfo defined by the user in the IDL file.
         * @ingroup WheelInfo
         */
        class WheelInfo
        {
        public:

            /*!
             * @brief Default constructor.
             */
            eProsima_user_DllExport WheelInfo();

            /*!
             * @brief Default destructor.
             */
            eProsima_user_DllExport ~WheelInfo();

            /*!
             * @brief Copy constructor.
             * @param x Reference to the object ros2_interface::msg::WheelInfo that will be copied.
             */
            eProsima_user_DllExport WheelInfo(
                    const WheelInfo& x);

            /*!
             * @brief Move constructor.
             * @param x Reference to the object ros2_interface::msg::WheelInfo that will be copied.
             */
            eProsima_user_DllExport WheelInfo(
                    WheelInfo&& x) noexcept;

            /*!
             * @brief Copy assignment.
             * @param x Reference to the object ros2_interface::msg::WheelInfo that will be copied.
             */
            eProsima_user_DllExport WheelInfo& operator =(
                    const WheelInfo& x);

            /*!
             * @brief Move assignment.
             * @param x Reference to the object ros2_interface::msg::WheelInfo that will be copied.
             */
            eProsima_user_DllExport WheelInfo& operator =(
                    WheelInfo&& x) noexcept;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::WheelInfo object to compare.
             */
            eProsima_user_DllExport bool operator ==(
                    const WheelInfo& x) const;

            /*!
             * @brief Comparison operator.
             * @param x ros2_interface::msg::WheelInfo object to compare.
             */
            eProsima_user_DllExport bool operator !=(
                    const WheelInfo& x) const;

            /*!
             * @brief This function copies the value in member header
             * @param _header New value to be copied in member header
             */
            eProsima_user_DllExport void header(
                    const ros2_interface::msg::Header& _header);

            /*!
             * @brief This function moves the value in member header
             * @param _header New value to be moved in member header
             */
            eProsima_user_DllExport void header(
                    ros2_interface::msg::Header&& _header);

            /*!
             * @brief This function returns a constant reference to member header
             * @return Constant reference to member header
             */
            eProsima_user_DllExport const ros2_interface::msg::Header& header() const;

            /*!
             * @brief This function returns a reference to member header
             * @return Reference to member header
             */
            eProsima_user_DllExport ros2_interface::msg::Header& header();
            /*!
             * @brief This function sets a value in member moving_status
             * @param _moving_status New value for member moving_status
             */
            eProsima_user_DllExport void moving_status(
                    int32_t _moving_status);

            /*!
             * @brief This function returns the value of member moving_status
             * @return Value of member moving_status
             */
            eProsima_user_DllExport int32_t moving_status() const;

            /*!
             * @brief This function returns a reference to member moving_status
             * @return Reference to member moving_status
             */
            eProsima_user_DllExport int32_t& moving_status();

            /*!
             * @brief This function sets a value in member steer_driving_mode
             * @param _steer_driving_mode New value for member steer_driving_mode
             */
            eProsima_user_DllExport void steer_driving_mode(
                    int32_t _steer_driving_mode);

            /*!
             * @brief This function returns the value of member steer_driving_mode
             * @return Value of member steer_driving_mode
             */
            eProsima_user_DllExport int32_t steer_driving_mode() const;

            /*!
             * @brief This function returns a reference to member steer_driving_mode
             * @return Reference to member steer_driving_mode
             */
            eProsima_user_DllExport int32_t& steer_driving_mode();

            /*!
             * @brief This function sets a value in member steering_value
             * @param _steering_value New value for member steering_value
             */
            eProsima_user_DllExport void steering_value(
                    double _steering_value);

            /*!
             * @brief This function returns the value of member steering_value
             * @return Value of member steering_value
             */
            eProsima_user_DllExport double steering_value() const;

            /*!
             * @brief This function returns a reference to member steering_value
             * @return Reference to member steering_value
             */
            eProsima_user_DllExport double& steering_value();

            /*!
             * @brief This function sets a value in member steering_torque_nm
             * @param _steering_torque_nm New value for member steering_torque_nm
             */
            eProsima_user_DllExport void steering_torque_nm(
                    double _steering_torque_nm);

            /*!
             * @brief This function returns the value of member steering_torque_nm
             * @return Value of member steering_torque_nm
             */
            eProsima_user_DllExport double steering_torque_nm() const;

            /*!
             * @brief This function returns a reference to member steering_torque_nm
             * @return Reference to member steering_torque_nm
             */
            eProsima_user_DllExport double& steering_torque_nm();

            /*!
             * @brief This function sets a value in member steering_rate_dps
             * @param _steering_rate_dps New value for member steering_rate_dps
             */
            eProsima_user_DllExport void steering_rate_dps(
                    double _steering_rate_dps);

            /*!
             * @brief This function returns the value of member steering_rate_dps
             * @return Value of member steering_rate_dps
             */
            eProsima_user_DllExport double steering_rate_dps() const;

            /*!
             * @brief This function returns a reference to member steering_rate_dps
             * @return Reference to member steering_rate_dps
             */
            eProsima_user_DllExport double& steering_rate_dps();

            /*!
             * @brief This function sets a value in member speed_mps
             * @param _speed_mps New value for member speed_mps
             */
            eProsima_user_DllExport void speed_mps(
                    double _speed_mps);

            /*!
             * @brief This function returns the value of member speed_mps
             * @return Value of member speed_mps
             */
            eProsima_user_DllExport double speed_mps() const;

            /*!
             * @brief This function returns a reference to member speed_mps
             * @return Reference to member speed_mps
             */
            eProsima_user_DllExport double& speed_mps();

            /*!
             * @brief This function sets a value in member wheel_direction_rr
             * @param _wheel_direction_rr New value for member wheel_direction_rr
             */
            eProsima_user_DllExport void wheel_direction_rr(
                    int32_t _wheel_direction_rr);

            /*!
             * @brief This function returns the value of member wheel_direction_rr
             * @return Value of member wheel_direction_rr
             */
            eProsima_user_DllExport int32_t wheel_direction_rr() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_rr
             * @return Reference to member wheel_direction_rr
             */
            eProsima_user_DllExport int32_t& wheel_direction_rr();

            /*!
             * @brief This function sets a value in member wheel_spd_rr
             * @param _wheel_spd_rr New value for member wheel_spd_rr
             */
            eProsima_user_DllExport void wheel_spd_rr(
                    double _wheel_spd_rr);

            /*!
             * @brief This function returns the value of member wheel_spd_rr
             * @return Value of member wheel_spd_rr
             */
            eProsima_user_DllExport double wheel_spd_rr() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_rr
             * @return Reference to member wheel_spd_rr
             */
            eProsima_user_DllExport double& wheel_spd_rr();

            /*!
             * @brief This function sets a value in member wheel_direction_rl
             * @param _wheel_direction_rl New value for member wheel_direction_rl
             */
            eProsima_user_DllExport void wheel_direction_rl(
                    int32_t _wheel_direction_rl);

            /*!
             * @brief This function returns the value of member wheel_direction_rl
             * @return Value of member wheel_direction_rl
             */
            eProsima_user_DllExport int32_t wheel_direction_rl() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_rl
             * @return Reference to member wheel_direction_rl
             */
            eProsima_user_DllExport int32_t& wheel_direction_rl();

            /*!
             * @brief This function sets a value in member wheel_spd_rl
             * @param _wheel_spd_rl New value for member wheel_spd_rl
             */
            eProsima_user_DllExport void wheel_spd_rl(
                    double _wheel_spd_rl);

            /*!
             * @brief This function returns the value of member wheel_spd_rl
             * @return Value of member wheel_spd_rl
             */
            eProsima_user_DllExport double wheel_spd_rl() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_rl
             * @return Reference to member wheel_spd_rl
             */
            eProsima_user_DllExport double& wheel_spd_rl();

            /*!
             * @brief This function sets a value in member wheel_direction_fr
             * @param _wheel_direction_fr New value for member wheel_direction_fr
             */
            eProsima_user_DllExport void wheel_direction_fr(
                    int32_t _wheel_direction_fr);

            /*!
             * @brief This function returns the value of member wheel_direction_fr
             * @return Value of member wheel_direction_fr
             */
            eProsima_user_DllExport int32_t wheel_direction_fr() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_fr
             * @return Reference to member wheel_direction_fr
             */
            eProsima_user_DllExport int32_t& wheel_direction_fr();

            /*!
             * @brief This function sets a value in member wheel_spd_fr
             * @param _wheel_spd_fr New value for member wheel_spd_fr
             */
            eProsima_user_DllExport void wheel_spd_fr(
                    double _wheel_spd_fr);

            /*!
             * @brief This function returns the value of member wheel_spd_fr
             * @return Value of member wheel_spd_fr
             */
            eProsima_user_DllExport double wheel_spd_fr() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_fr
             * @return Reference to member wheel_spd_fr
             */
            eProsima_user_DllExport double& wheel_spd_fr();

            /*!
             * @brief This function sets a value in member wheel_direction_fl
             * @param _wheel_direction_fl New value for member wheel_direction_fl
             */
            eProsima_user_DllExport void wheel_direction_fl(
                    int32_t _wheel_direction_fl);

            /*!
             * @brief This function returns the value of member wheel_direction_fl
             * @return Value of member wheel_direction_fl
             */
            eProsima_user_DllExport int32_t wheel_direction_fl() const;

            /*!
             * @brief This function returns a reference to member wheel_direction_fl
             * @return Reference to member wheel_direction_fl
             */
            eProsima_user_DllExport int32_t& wheel_direction_fl();

            /*!
             * @brief This function sets a value in member wheel_spd_fl
             * @param _wheel_spd_fl New value for member wheel_spd_fl
             */
            eProsima_user_DllExport void wheel_spd_fl(
                    double _wheel_spd_fl);

            /*!
             * @brief This function returns the value of member wheel_spd_fl
             * @return Value of member wheel_spd_fl
             */
            eProsima_user_DllExport double wheel_spd_fl() const;

            /*!
             * @brief This function returns a reference to member wheel_spd_fl
             * @return Reference to member wheel_spd_fl
             */
            eProsima_user_DllExport double& wheel_spd_fl();

            /*!
             * @brief This function sets a value in member yaw_rate
             * @param _yaw_rate New value for member yaw_rate
             */
            eProsima_user_DllExport void yaw_rate(
                    double _yaw_rate);

            /*!
             * @brief This function returns the value of member yaw_rate
             * @return Value of member yaw_rate
             */
            eProsima_user_DllExport double yaw_rate() const;

            /*!
             * @brief This function returns a reference to member yaw_rate
             * @return Reference to member yaw_rate
             */
            eProsima_user_DllExport double& yaw_rate();


            /*!
            * @brief This function returns the maximum serialized size of an object
            * depending on the buffer alignment.
            * @param current_alignment Buffer alignment.
            * @return Maximum serialized size.
            */
            eProsima_user_DllExport static size_t getMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function returns the serialized size of a data depending on the buffer alignment.
             * @param data Data which is calculated its serialized size.
             * @param current_alignment Buffer alignment.
             * @return Serialized size.
             */
            eProsima_user_DllExport static size_t getCdrSerializedSize(
                    const ros2_interface::msg::WheelInfo& data,
                    size_t current_alignment = 0);


            /*!
             * @brief This function serializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serialize(
                    eprosima::fastcdr::Cdr& cdr) const;

            /*!
             * @brief This function deserializes an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void deserialize(
                    eprosima::fastcdr::Cdr& cdr);



            /*!
             * @brief This function returns the maximum serialized size of the Key of an object
             * depending on the buffer alignment.
             * @param current_alignment Buffer alignment.
             * @return Maximum serialized size.
             */
            eProsima_user_DllExport static size_t getKeyMaxCdrSerializedSize(
                    size_t current_alignment = 0);

            /*!
             * @brief This function tells you if the Key has been defined for this type
             */
            eProsima_user_DllExport static bool isKeyDefined();

            /*!
             * @brief This function serializes the key members of an object using CDR serialization.
             * @param cdr CDR serialization object.
             */
            eProsima_user_DllExport void serializeKey(
                    eprosima::fastcdr::Cdr& cdr) const;

        private:

            ros2_interface::msg::Header m_header;
            int32_t m_moving_status;
            int32_t m_steer_driving_mode;
            double m_steering_value;
            double m_steering_torque_nm;
            double m_steering_rate_dps;
            double m_speed_mps;
            int32_t m_wheel_direction_rr;
            double m_wheel_spd_rr;
            int32_t m_wheel_direction_rl;
            double m_wheel_spd_rl;
            int32_t m_wheel_direction_fr;
            double m_wheel_spd_fr;
            int32_t m_wheel_direction_fl;
            double m_wheel_spd_fl;
            double m_yaw_rate;

        };
    } // namespace msg
} // namespace ros2_interface

#endif // _FAST_DDS_GENERATED_ROS2_INTERFACE_MSG_WHEELINFO_H_

