// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file WheelInfoTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "WheelInfo.h"
#include "WheelInfoTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerWheelInfoTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::WheelInfo", ros2_interface::msg::GetWheelInfoIdentifier(true),
                        ros2_interface::msg::GetWheelInfoObject(true));
                factory->add_type_object("ros2_interface::msg::WheelInfo", ros2_interface::msg::GetWheelInfoIdentifier(false),
                        ros2_interface::msg::GetWheelInfoObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetWheelInfoIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("WheelInfo", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetWheelInfoObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("WheelInfo", complete);
        }

        const TypeObject* GetWheelInfoObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WheelInfo", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteWheelInfoObject();
            }
            //else
            return GetMinimalWheelInfoObject();
        }

        const TypeObject* GetMinimalWheelInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WheelInfo", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_moving_status;
            mst_moving_status.common().member_id(memberId++);
            mst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moving_status.common().member_flags().IS_OPTIONAL(false);
            mst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moving_status.common().member_flags().IS_KEY(false);
            mst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moving_status_hash("moving_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_moving_status.detail().name_hash()[i] = moving_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moving_status);

            MinimalStructMember mst_steer_driving_mode;
            mst_steer_driving_mode.common().member_id(memberId++);
            mst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_steer_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steer_driving_mode.common().member_flags().IS_KEY(false);
            mst_steer_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steer_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 steer_driving_mode_hash("steer_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_steer_driving_mode.detail().name_hash()[i] = steer_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steer_driving_mode);

            MinimalStructMember mst_steering_value;
            mst_steering_value.common().member_id(memberId++);
            mst_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_value.common().member_flags().IS_KEY(false);
            mst_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steering_value_hash("steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_value.detail().name_hash()[i] = steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_value);

            MinimalStructMember mst_steering_torque_nm;
            mst_steering_torque_nm.common().member_id(memberId++);
            mst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().IS_OPTIONAL(false);
            mst_steering_torque_nm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_torque_nm.common().member_flags().IS_KEY(false);
            mst_steering_torque_nm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_torque_nm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steering_torque_nm_hash("steering_torque_nm");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_torque_nm.detail().name_hash()[i] = steering_torque_nm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_torque_nm);

            MinimalStructMember mst_steering_rate_dps;
            mst_steering_rate_dps.common().member_id(memberId++);
            mst_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            mst_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_rate_dps.common().member_flags().IS_KEY(false);
            mst_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steering_rate_dps_hash("steering_rate_dps");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_rate_dps.detail().name_hash()[i] = steering_rate_dps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_rate_dps);

            MinimalStructMember mst_speed_mps;
            mst_speed_mps.common().member_id(memberId++);
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            mst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_mps.common().member_flags().IS_KEY(false);
            mst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_mps_hash("speed_mps");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_mps.detail().name_hash()[i] = speed_mps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_mps);

            MinimalStructMember mst_wheel_direction_rr;
            mst_wheel_direction_rr.common().member_id(memberId++);
            mst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_rr.common().member_flags().IS_KEY(false);
            mst_wheel_direction_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_rr_hash("wheel_direction_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_rr.detail().name_hash()[i] = wheel_direction_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_rr);

            MinimalStructMember mst_wheel_spd_rr;
            mst_wheel_spd_rr.common().member_id(memberId++);
            mst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_rr.common().member_flags().IS_KEY(false);
            mst_wheel_spd_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_rr_hash("wheel_spd_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_rr.detail().name_hash()[i] = wheel_spd_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_rr);

            MinimalStructMember mst_wheel_direction_rl;
            mst_wheel_direction_rl.common().member_id(memberId++);
            mst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_rl.common().member_flags().IS_KEY(false);
            mst_wheel_direction_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_rl_hash("wheel_direction_rl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_rl.detail().name_hash()[i] = wheel_direction_rl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_rl);

            MinimalStructMember mst_wheel_spd_rl;
            mst_wheel_spd_rl.common().member_id(memberId++);
            mst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_rl.common().member_flags().IS_KEY(false);
            mst_wheel_spd_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_rl_hash("wheel_spd_rl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_rl.detail().name_hash()[i] = wheel_spd_rl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_rl);

            MinimalStructMember mst_wheel_direction_fr;
            mst_wheel_direction_fr.common().member_id(memberId++);
            mst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_fr.common().member_flags().IS_KEY(false);
            mst_wheel_direction_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_fr_hash("wheel_direction_fr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_fr.detail().name_hash()[i] = wheel_direction_fr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_fr);

            MinimalStructMember mst_wheel_spd_fr;
            mst_wheel_spd_fr.common().member_id(memberId++);
            mst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_fr.common().member_flags().IS_KEY(false);
            mst_wheel_spd_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_fr_hash("wheel_spd_fr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_fr.detail().name_hash()[i] = wheel_spd_fr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_fr);

            MinimalStructMember mst_wheel_direction_fl;
            mst_wheel_direction_fl.common().member_id(memberId++);
            mst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_fl.common().member_flags().IS_KEY(false);
            mst_wheel_direction_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_fl_hash("wheel_direction_fl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_fl.detail().name_hash()[i] = wheel_direction_fl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_fl);

            MinimalStructMember mst_wheel_spd_fl;
            mst_wheel_spd_fl.common().member_id(memberId++);
            mst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_fl.common().member_flags().IS_KEY(false);
            mst_wheel_spd_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_fl_hash("wheel_spd_fl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_fl.detail().name_hash()[i] = wheel_spd_fl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_fl);

            MinimalStructMember mst_yaw_rate;
            mst_yaw_rate.common().member_id(memberId++);
            mst_yaw_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_yaw_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_yaw_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_yaw_rate.common().member_flags().IS_OPTIONAL(false);
            mst_yaw_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_yaw_rate.common().member_flags().IS_KEY(false);
            mst_yaw_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_yaw_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 yaw_rate_hash("yaw_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_yaw_rate.detail().name_hash()[i] = yaw_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_yaw_rate);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("WheelInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("WheelInfo", false);
        }

        const TypeObject* GetCompleteWheelInfoObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("WheelInfo", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_moving_status;
            cst_moving_status.common().member_id(memberId++);
            cst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moving_status.common().member_flags().IS_OPTIONAL(false);
            cst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moving_status.common().member_flags().IS_KEY(false);
            cst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moving_status.detail().name("moving_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moving_status);

            CompleteStructMember cst_steer_driving_mode;
            cst_steer_driving_mode.common().member_id(memberId++);
            cst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_steer_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steer_driving_mode.common().member_flags().IS_KEY(false);
            cst_steer_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steer_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_steer_driving_mode.detail().name("steer_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steer_driving_mode);

            CompleteStructMember cst_steering_value;
            cst_steering_value.common().member_id(memberId++);
            cst_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_value.common().member_flags().IS_KEY(false);
            cst_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steering_value.detail().name("steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_value);

            CompleteStructMember cst_steering_torque_nm;
            cst_steering_torque_nm.common().member_id(memberId++);
            cst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().IS_OPTIONAL(false);
            cst_steering_torque_nm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_torque_nm.common().member_flags().IS_KEY(false);
            cst_steering_torque_nm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_torque_nm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steering_torque_nm.detail().name("steering_torque_nm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_torque_nm);

            CompleteStructMember cst_steering_rate_dps;
            cst_steering_rate_dps.common().member_id(memberId++);
            cst_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            cst_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_rate_dps.common().member_flags().IS_KEY(false);
            cst_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steering_rate_dps.detail().name("steering_rate_dps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_rate_dps);

            CompleteStructMember cst_speed_mps;
            cst_speed_mps.common().member_id(memberId++);
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            cst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_mps.common().member_flags().IS_KEY(false);
            cst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_mps.detail().name("speed_mps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_mps);

            CompleteStructMember cst_wheel_direction_rr;
            cst_wheel_direction_rr.common().member_id(memberId++);
            cst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_rr.common().member_flags().IS_KEY(false);
            cst_wheel_direction_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_rr.detail().name("wheel_direction_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_rr);

            CompleteStructMember cst_wheel_spd_rr;
            cst_wheel_spd_rr.common().member_id(memberId++);
            cst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_rr.common().member_flags().IS_KEY(false);
            cst_wheel_spd_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_rr.detail().name("wheel_spd_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_rr);

            CompleteStructMember cst_wheel_direction_rl;
            cst_wheel_direction_rl.common().member_id(memberId++);
            cst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_rl.common().member_flags().IS_KEY(false);
            cst_wheel_direction_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_rl.detail().name("wheel_direction_rl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_rl);

            CompleteStructMember cst_wheel_spd_rl;
            cst_wheel_spd_rl.common().member_id(memberId++);
            cst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_rl.common().member_flags().IS_KEY(false);
            cst_wheel_spd_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_rl.detail().name("wheel_spd_rl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_rl);

            CompleteStructMember cst_wheel_direction_fr;
            cst_wheel_direction_fr.common().member_id(memberId++);
            cst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_fr.common().member_flags().IS_KEY(false);
            cst_wheel_direction_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_fr.detail().name("wheel_direction_fr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_fr);

            CompleteStructMember cst_wheel_spd_fr;
            cst_wheel_spd_fr.common().member_id(memberId++);
            cst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_fr.common().member_flags().IS_KEY(false);
            cst_wheel_spd_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_fr.detail().name("wheel_spd_fr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_fr);

            CompleteStructMember cst_wheel_direction_fl;
            cst_wheel_direction_fl.common().member_id(memberId++);
            cst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_fl.common().member_flags().IS_KEY(false);
            cst_wheel_direction_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_fl.detail().name("wheel_direction_fl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_fl);

            CompleteStructMember cst_wheel_spd_fl;
            cst_wheel_spd_fl.common().member_id(memberId++);
            cst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_fl.common().member_flags().IS_KEY(false);
            cst_wheel_spd_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_fl.detail().name("wheel_spd_fl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_fl);

            CompleteStructMember cst_yaw_rate;
            cst_yaw_rate.common().member_id(memberId++);
            cst_yaw_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_yaw_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_yaw_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_yaw_rate.common().member_flags().IS_OPTIONAL(false);
            cst_yaw_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_yaw_rate.common().member_flags().IS_KEY(false);
            cst_yaw_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_yaw_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_yaw_rate.detail().name("yaw_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_yaw_rate);


            // Header
            type_object->complete().struct_type().header().detail().type_name("WheelInfo");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("WheelInfo", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("WheelInfo", true);
        }

    } // namespace msg
} // namespace ros2_interface