// Copyright 2016 Proyectos y Sistemas de Mantenimiento SL (eProsima).
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/*!
 * @file ChassisTypeObject.cpp
 * This source file contains the definition of the described types in the IDL file.
 *
 * This file was generated by the tool gen.
 */

#ifdef _WIN32
// Remove linker warning LNK4221 on Visual Studio
namespace { char dummy; }
#endif

#include "Chassis.h"
#include "ChassisTypeObject.h"
#include <mutex>
#include <utility>
#include <sstream>
#include <fastrtps/rtps/common/SerializedPayload.h>
#include <fastrtps/utils/md5.h>
#include <fastrtps/types/TypeObjectFactory.h>
#include <fastrtps/types/TypeNamesGenerator.h>
#include <fastrtps/types/AnnotationParameterValue.h>
#include <fastcdr/FastBuffer.h>
#include <fastcdr/Cdr.h>

using namespace eprosima::fastrtps::rtps;

void registerChassisTypes()
{
    static std::once_flag once_flag;
    std::call_once(once_flag, []()
            {
                TypeObjectFactory *factory = TypeObjectFactory::get_instance();
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(true),
                        ros2_interface::msg::GetTimeObject(true));
                factory->add_type_object("ros2_interface::msg::Time", ros2_interface::msg::GetTimeIdentifier(false),
                        ros2_interface::msg::GetTimeObject(false));



                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(true),
                        ros2_interface::msg::GetHeaderObject(true));
                factory->add_type_object("ros2_interface::msg::Header", ros2_interface::msg::GetHeaderIdentifier(false),
                        ros2_interface::msg::GetHeaderObject(false));



                factory->add_type_object("ros2_interface::msg::Chassis", ros2_interface::msg::GetChassisIdentifier(true),
                        ros2_interface::msg::GetChassisObject(true));
                factory->add_type_object("ros2_interface::msg::Chassis", ros2_interface::msg::GetChassisIdentifier(false),
                        ros2_interface::msg::GetChassisObject(false));



            });
}

namespace ros2_interface {
    namespace msg {
        const TypeIdentifier* GetChassisIdentifier(bool complete)
        {
            const TypeIdentifier * c_identifier = TypeObjectFactory::get_instance()->get_type_identifier("Chassis", complete);
            if (c_identifier != nullptr && (!complete || c_identifier->_d() == EK_COMPLETE))
            {
                return c_identifier;
            }

            GetChassisObject(complete); // Generated inside
            return TypeObjectFactory::get_instance()->get_type_identifier("Chassis", complete);
        }

        const TypeObject* GetChassisObject(bool complete)
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Chassis", complete);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }
            else if (complete)
            {
                return GetCompleteChassisObject();
            }
            //else
            return GetMinimalChassisObject();
        }

        const TypeObject* GetMinimalChassisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Chassis", false);
            if (c_type_object != nullptr)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_MINIMAL);
            type_object->minimal()._d(TK_STRUCTURE);

            type_object->minimal().struct_type().struct_flags().IS_FINAL(false);
            type_object->minimal().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->minimal().struct_type().struct_flags().IS_NESTED(false);
            type_object->minimal().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            MinimalStructMember mst_header;
            mst_header.common().member_id(memberId++);
            mst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_header.common().member_flags().IS_OPTIONAL(false);
            mst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_header.common().member_flags().IS_KEY(false);
            mst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(false));
            MD5 header_hash("header");
            for(int i = 0; i < 4; ++i)
            {
                mst_header.detail().name_hash()[i] = header_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_header);

            MinimalStructMember mst_moving_status;
            mst_moving_status.common().member_id(memberId++);
            mst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_moving_status.common().member_flags().IS_OPTIONAL(false);
            mst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_moving_status.common().member_flags().IS_KEY(false);
            mst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 moving_status_hash("moving_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_moving_status.detail().name_hash()[i] = moving_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_moving_status);

            MinimalStructMember mst_driving_mode;
            mst_driving_mode.common().member_id(memberId++);
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_driving_mode.common().member_flags().IS_KEY(false);
            mst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 driving_mode_hash("driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_driving_mode.detail().name_hash()[i] = driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_driving_mode);

            MinimalStructMember mst_steer_driving_mode;
            mst_steer_driving_mode.common().member_id(memberId++);
            mst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steer_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_steer_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steer_driving_mode.common().member_flags().IS_KEY(false);
            mst_steer_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steer_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 steer_driving_mode_hash("steer_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_steer_driving_mode.detail().name_hash()[i] = steer_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steer_driving_mode);

            MinimalStructMember mst_steering_status;
            mst_steering_status.common().member_id(memberId++);
            mst_steering_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_status.common().member_flags().IS_OPTIONAL(false);
            mst_steering_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_status.common().member_flags().IS_KEY(false);
            mst_steering_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 steering_status_hash("steering_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_status.detail().name_hash()[i] = steering_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_status);

            MinimalStructMember mst_front_steering_value;
            mst_front_steering_value.common().member_id(memberId++);
            mst_front_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_value.common().member_flags().IS_KEY(false);
            mst_front_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_value_hash("front_steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_value.detail().name_hash()[i] = front_steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_value);

            MinimalStructMember mst_rear_steering_value;
            mst_rear_steering_value.common().member_id(memberId++);
            mst_rear_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_value.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_value.common().member_flags().IS_KEY(false);
            mst_rear_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_value_hash("rear_steering_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_value.detail().name_hash()[i] = rear_steering_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_value);

            MinimalStructMember mst_steering_torque_nm;
            mst_steering_torque_nm.common().member_id(memberId++);
            mst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_steering_torque_nm.common().member_flags().IS_OPTIONAL(false);
            mst_steering_torque_nm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_steering_torque_nm.common().member_flags().IS_KEY(false);
            mst_steering_torque_nm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_steering_torque_nm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 steering_torque_nm_hash("steering_torque_nm");
            for(int i = 0; i < 4; ++i)
            {
                mst_steering_torque_nm.detail().name_hash()[i] = steering_torque_nm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_steering_torque_nm);

            MinimalStructMember mst_front_steering_rate_dps;
            mst_front_steering_rate_dps.common().member_id(memberId++);
            mst_front_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            mst_front_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_steering_rate_dps.common().member_flags().IS_KEY(false);
            mst_front_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 front_steering_rate_dps_hash("front_steering_rate_dps");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_steering_rate_dps.detail().name_hash()[i] = front_steering_rate_dps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_steering_rate_dps);

            MinimalStructMember mst_rear_steering_rate_dps;
            mst_rear_steering_rate_dps.common().member_id(memberId++);
            mst_rear_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            mst_rear_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_steering_rate_dps.common().member_flags().IS_KEY(false);
            mst_rear_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 rear_steering_rate_dps_hash("rear_steering_rate_dps");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_steering_rate_dps.detail().name_hash()[i] = rear_steering_rate_dps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_steering_rate_dps);

            MinimalStructMember mst_accel_driving_mode;
            mst_accel_driving_mode.common().member_id(memberId++);
            mst_accel_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_accel_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_driving_mode.common().member_flags().IS_KEY(false);
            mst_accel_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 accel_driving_mode_hash("accel_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_driving_mode.detail().name_hash()[i] = accel_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_driving_mode);

            MinimalStructMember mst_accel_status;
            mst_accel_status.common().member_id(memberId++);
            mst_accel_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_status.common().member_flags().IS_OPTIONAL(false);
            mst_accel_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_status.common().member_flags().IS_KEY(false);
            mst_accel_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 accel_status_hash("accel_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_status.detail().name_hash()[i] = accel_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_status);

            MinimalStructMember mst_accel_value;
            mst_accel_value.common().member_id(memberId++);
            mst_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_accel_value.common().member_flags().IS_OPTIONAL(false);
            mst_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_accel_value.common().member_flags().IS_KEY(false);
            mst_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 accel_value_hash("accel_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_accel_value.detail().name_hash()[i] = accel_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_accel_value);

            MinimalStructMember mst_brake_driving_mode;
            mst_brake_driving_mode.common().member_id(memberId++);
            mst_brake_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_brake_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_driving_mode.common().member_flags().IS_KEY(false);
            mst_brake_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_driving_mode_hash("brake_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_driving_mode.detail().name_hash()[i] = brake_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_driving_mode);

            MinimalStructMember mst_brake_status;
            mst_brake_status.common().member_id(memberId++);
            mst_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_status.common().member_flags().IS_KEY(false);
            mst_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_status_hash("brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_status.detail().name_hash()[i] = brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_status);

            MinimalStructMember mst_brake_value;
            mst_brake_value.common().member_id(memberId++);
            mst_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_value.common().member_flags().IS_OPTIONAL(false);
            mst_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_value.common().member_flags().IS_KEY(false);
            mst_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 brake_value_hash("brake_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_value.detail().name_hash()[i] = brake_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_value);

            MinimalStructMember mst_brake_padel;
            mst_brake_padel.common().member_id(memberId++);
            mst_brake_padel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_padel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_padel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_padel.common().member_flags().IS_OPTIONAL(false);
            mst_brake_padel.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_padel.common().member_flags().IS_KEY(false);
            mst_brake_padel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_padel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_padel_hash("brake_padel");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_padel.detail().name_hash()[i] = brake_padel_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_padel);

            MinimalStructMember mst_lf_wheel_wheel_brake_status;
            mst_lf_wheel_wheel_brake_status.common().member_id(memberId++);
            mst_lf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lf_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lf_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_lf_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lf_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            mst_lf_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lf_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 lf_wheel_wheel_brake_status_hash("lf_wheel_wheel_brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_lf_wheel_wheel_brake_status.detail().name_hash()[i] = lf_wheel_wheel_brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lf_wheel_wheel_brake_status);

            MinimalStructMember mst_rf_wheel_wheel_brake_status;
            mst_rf_wheel_wheel_brake_status.common().member_id(memberId++);
            mst_rf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rf_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rf_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_rf_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rf_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            mst_rf_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rf_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 rf_wheel_wheel_brake_status_hash("rf_wheel_wheel_brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rf_wheel_wheel_brake_status.detail().name_hash()[i] = rf_wheel_wheel_brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rf_wheel_wheel_brake_status);

            MinimalStructMember mst_lr_wheel_wheel_brake_status;
            mst_lr_wheel_wheel_brake_status.common().member_id(memberId++);
            mst_lr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lr_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lr_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_lr_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lr_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            mst_lr_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lr_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 lr_wheel_wheel_brake_status_hash("lr_wheel_wheel_brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_lr_wheel_wheel_brake_status.detail().name_hash()[i] = lr_wheel_wheel_brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lr_wheel_wheel_brake_status);

            MinimalStructMember mst_rr_wheel_wheel_brake_status;
            mst_rr_wheel_wheel_brake_status.common().member_id(memberId++);
            mst_rr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rr_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rr_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_rr_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rr_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            mst_rr_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rr_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 rr_wheel_wheel_brake_status_hash("rr_wheel_wheel_brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rr_wheel_wheel_brake_status.detail().name_hash()[i] = rr_wheel_wheel_brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rr_wheel_wheel_brake_status);

            MinimalStructMember mst_backup_brake_driving_mode;
            mst_backup_brake_driving_mode.common().member_id(memberId++);
            mst_backup_brake_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_backup_brake_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_backup_brake_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_backup_brake_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_backup_brake_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_backup_brake_driving_mode.common().member_flags().IS_KEY(false);
            mst_backup_brake_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_backup_brake_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 backup_brake_driving_mode_hash("backup_brake_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_backup_brake_driving_mode.detail().name_hash()[i] = backup_brake_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_backup_brake_driving_mode);

            MinimalStructMember mst_backup_brake_status;
            mst_backup_brake_status.common().member_id(memberId++);
            mst_backup_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_backup_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_backup_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_backup_brake_status.common().member_flags().IS_OPTIONAL(false);
            mst_backup_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_backup_brake_status.common().member_flags().IS_KEY(false);
            mst_backup_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_backup_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 backup_brake_status_hash("backup_brake_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_backup_brake_status.detail().name_hash()[i] = backup_brake_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_backup_brake_status);

            MinimalStructMember mst_backup_brake_value;
            mst_backup_brake_value.common().member_id(memberId++);
            mst_backup_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_backup_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_backup_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_backup_brake_value.common().member_flags().IS_OPTIONAL(false);
            mst_backup_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_backup_brake_value.common().member_flags().IS_KEY(false);
            mst_backup_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_backup_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 backup_brake_value_hash("backup_brake_value");
            for(int i = 0; i < 4; ++i)
            {
                mst_backup_brake_value.detail().name_hash()[i] = backup_brake_value_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_backup_brake_value);

            MinimalStructMember mst_epb_driving_mode;
            mst_epb_driving_mode.common().member_id(memberId++);
            mst_epb_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_epb_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_epb_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_epb_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_epb_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_epb_driving_mode.common().member_flags().IS_KEY(false);
            mst_epb_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_epb_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 epb_driving_mode_hash("epb_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_epb_driving_mode.detail().name_hash()[i] = epb_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_epb_driving_mode);

            MinimalStructMember mst_epb_status;
            mst_epb_status.common().member_id(memberId++);
            mst_epb_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_epb_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_epb_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_epb_status.common().member_flags().IS_OPTIONAL(false);
            mst_epb_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_epb_status.common().member_flags().IS_KEY(false);
            mst_epb_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_epb_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 epb_status_hash("epb_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_epb_status.detail().name_hash()[i] = epb_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_epb_status);

            MinimalStructMember mst_epb_level;
            mst_epb_level.common().member_id(memberId++);
            mst_epb_level.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_epb_level.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_epb_level.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_epb_level.common().member_flags().IS_OPTIONAL(false);
            mst_epb_level.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_epb_level.common().member_flags().IS_KEY(false);
            mst_epb_level.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_epb_level.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 epb_level_hash("epb_level");
            for(int i = 0; i < 4; ++i)
            {
                mst_epb_level.detail().name_hash()[i] = epb_level_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_epb_level);

            MinimalStructMember mst_gear_driving_mode;
            mst_gear_driving_mode.common().member_id(memberId++);
            mst_gear_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_driving_mode.common().member_flags().IS_OPTIONAL(false);
            mst_gear_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_driving_mode.common().member_flags().IS_KEY(false);
            mst_gear_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_driving_mode_hash("gear_driving_mode");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_driving_mode.detail().name_hash()[i] = gear_driving_mode_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_driving_mode);

            MinimalStructMember mst_gear_status;
            mst_gear_status.common().member_id(memberId++);
            mst_gear_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_status.common().member_flags().IS_OPTIONAL(false);
            mst_gear_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_status.common().member_flags().IS_KEY(false);
            mst_gear_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_status_hash("gear_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_status.detail().name_hash()[i] = gear_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_status);

            MinimalStructMember mst_gear_location;
            mst_gear_location.common().member_id(memberId++);
            mst_gear_location.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_gear_location.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_gear_location.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_gear_location.common().member_flags().IS_OPTIONAL(false);
            mst_gear_location.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_gear_location.common().member_flags().IS_KEY(false);
            mst_gear_location.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_gear_location.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 gear_location_hash("gear_location");
            for(int i = 0; i < 4; ++i)
            {
                mst_gear_location.detail().name_hash()[i] = gear_location_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_gear_location);

            MinimalStructMember mst_engine_rpm;
            mst_engine_rpm.common().member_id(memberId++);
            mst_engine_rpm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_engine_rpm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_engine_rpm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_engine_rpm.common().member_flags().IS_OPTIONAL(false);
            mst_engine_rpm.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_engine_rpm.common().member_flags().IS_KEY(false);
            mst_engine_rpm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_engine_rpm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 engine_rpm_hash("engine_rpm");
            for(int i = 0; i < 4; ++i)
            {
                mst_engine_rpm.detail().name_hash()[i] = engine_rpm_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_engine_rpm);

            MinimalStructMember mst_engine_torque;
            mst_engine_torque.common().member_id(memberId++);
            mst_engine_torque.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_engine_torque.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_engine_torque.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_engine_torque.common().member_flags().IS_OPTIONAL(false);
            mst_engine_torque.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_engine_torque.common().member_flags().IS_KEY(false);
            mst_engine_torque.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_engine_torque.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 engine_torque_hash("engine_torque");
            for(int i = 0; i < 4; ++i)
            {
                mst_engine_torque.detail().name_hash()[i] = engine_torque_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_engine_torque);

            MinimalStructMember mst_is_speed_valid;
            mst_is_speed_valid.common().member_id(memberId++);
            mst_is_speed_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_speed_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_speed_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_speed_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_speed_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_speed_valid.common().member_flags().IS_KEY(false);
            mst_is_speed_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_speed_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_speed_valid_hash("is_speed_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_speed_valid.detail().name_hash()[i] = is_speed_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_speed_valid);

            MinimalStructMember mst_speed_mps;
            mst_speed_mps.common().member_id(memberId++);
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            mst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_speed_mps.common().member_flags().IS_KEY(false);
            mst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 speed_mps_hash("speed_mps");
            for(int i = 0; i < 4; ++i)
            {
                mst_speed_mps.detail().name_hash()[i] = speed_mps_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_speed_mps);

            MinimalStructMember mst_is_veh_lat_accel_valid;
            mst_is_veh_lat_accel_valid.common().member_id(memberId++);
            mst_is_veh_lat_accel_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_veh_lat_accel_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_veh_lat_accel_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_veh_lat_accel_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_veh_lat_accel_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_veh_lat_accel_valid.common().member_flags().IS_KEY(false);
            mst_is_veh_lat_accel_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_veh_lat_accel_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_veh_lat_accel_valid_hash("is_veh_lat_accel_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_veh_lat_accel_valid.detail().name_hash()[i] = is_veh_lat_accel_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_veh_lat_accel_valid);

            MinimalStructMember mst_veh_lat_accel;
            mst_veh_lat_accel.common().member_id(memberId++);
            mst_veh_lat_accel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_veh_lat_accel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_veh_lat_accel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_veh_lat_accel.common().member_flags().IS_OPTIONAL(false);
            mst_veh_lat_accel.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_veh_lat_accel.common().member_flags().IS_KEY(false);
            mst_veh_lat_accel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_veh_lat_accel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 veh_lat_accel_hash("veh_lat_accel");
            for(int i = 0; i < 4; ++i)
            {
                mst_veh_lat_accel.detail().name_hash()[i] = veh_lat_accel_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_veh_lat_accel);

            MinimalStructMember mst_is_veh_lon_accel_valid;
            mst_is_veh_lon_accel_valid.common().member_id(memberId++);
            mst_is_veh_lon_accel_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_veh_lon_accel_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_veh_lon_accel_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_veh_lon_accel_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_veh_lon_accel_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_veh_lon_accel_valid.common().member_flags().IS_KEY(false);
            mst_is_veh_lon_accel_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_veh_lon_accel_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_veh_lon_accel_valid_hash("is_veh_lon_accel_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_veh_lon_accel_valid.detail().name_hash()[i] = is_veh_lon_accel_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_veh_lon_accel_valid);

            MinimalStructMember mst_veh_lon_accel;
            mst_veh_lon_accel.common().member_id(memberId++);
            mst_veh_lon_accel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_veh_lon_accel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_veh_lon_accel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_veh_lon_accel.common().member_flags().IS_OPTIONAL(false);
            mst_veh_lon_accel.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_veh_lon_accel.common().member_flags().IS_KEY(false);
            mst_veh_lon_accel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_veh_lon_accel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 veh_lon_accel_hash("veh_lon_accel");
            for(int i = 0; i < 4; ++i)
            {
                mst_veh_lon_accel.detail().name_hash()[i] = veh_lon_accel_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_veh_lon_accel);

            MinimalStructMember mst_is_yaw_rate_valid;
            mst_is_yaw_rate_valid.common().member_id(memberId++);
            mst_is_yaw_rate_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_yaw_rate_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_yaw_rate_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_yaw_rate_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_yaw_rate_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_yaw_rate_valid.common().member_flags().IS_KEY(false);
            mst_is_yaw_rate_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_yaw_rate_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_yaw_rate_valid_hash("is_yaw_rate_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_yaw_rate_valid.detail().name_hash()[i] = is_yaw_rate_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_yaw_rate_valid);

            MinimalStructMember mst_yaw_rate;
            mst_yaw_rate.common().member_id(memberId++);
            mst_yaw_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_yaw_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_yaw_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_yaw_rate.common().member_flags().IS_OPTIONAL(false);
            mst_yaw_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_yaw_rate.common().member_flags().IS_KEY(false);
            mst_yaw_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_yaw_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 yaw_rate_hash("yaw_rate");
            for(int i = 0; i < 4; ++i)
            {
                mst_yaw_rate.detail().name_hash()[i] = yaw_rate_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_yaw_rate);

            MinimalStructMember mst_odometer_m;
            mst_odometer_m.common().member_id(memberId++);
            mst_odometer_m.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_odometer_m.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_odometer_m.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_odometer_m.common().member_flags().IS_OPTIONAL(false);
            mst_odometer_m.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_odometer_m.common().member_flags().IS_KEY(false);
            mst_odometer_m.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_odometer_m.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 odometer_m_hash("odometer_m");
            for(int i = 0; i < 4; ++i)
            {
                mst_odometer_m.detail().name_hash()[i] = odometer_m_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_odometer_m);

            MinimalStructMember mst_daytime_running_lights_status;
            mst_daytime_running_lights_status.common().member_id(memberId++);
            mst_daytime_running_lights_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_daytime_running_lights_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_daytime_running_lights_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_daytime_running_lights_status.common().member_flags().IS_OPTIONAL(false);
            mst_daytime_running_lights_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_daytime_running_lights_status.common().member_flags().IS_KEY(false);
            mst_daytime_running_lights_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_daytime_running_lights_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 daytime_running_lights_status_hash("daytime_running_lights_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_daytime_running_lights_status.detail().name_hash()[i] = daytime_running_lights_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_daytime_running_lights_status);

            MinimalStructMember mst_automatic_light_control_status;
            mst_automatic_light_control_status.common().member_id(memberId++);
            mst_automatic_light_control_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_automatic_light_control_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_automatic_light_control_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_automatic_light_control_status.common().member_flags().IS_OPTIONAL(false);
            mst_automatic_light_control_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_automatic_light_control_status.common().member_flags().IS_KEY(false);
            mst_automatic_light_control_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_automatic_light_control_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 automatic_light_control_status_hash("automatic_light_control_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_automatic_light_control_status.detail().name_hash()[i] = automatic_light_control_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_automatic_light_control_status);

            MinimalStructMember mst_parking_lights_status;
            mst_parking_lights_status.common().member_id(memberId++);
            mst_parking_lights_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_parking_lights_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_parking_lights_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_parking_lights_status.common().member_flags().IS_OPTIONAL(false);
            mst_parking_lights_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_parking_lights_status.common().member_flags().IS_KEY(false);
            mst_parking_lights_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_parking_lights_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 parking_lights_status_hash("parking_lights_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_parking_lights_status.detail().name_hash()[i] = parking_lights_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_parking_lights_status);

            MinimalStructMember mst_high_beam_status;
            mst_high_beam_status.common().member_id(memberId++);
            mst_high_beam_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_high_beam_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_high_beam_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_high_beam_status.common().member_flags().IS_OPTIONAL(false);
            mst_high_beam_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_high_beam_status.common().member_flags().IS_KEY(false);
            mst_high_beam_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_high_beam_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 high_beam_status_hash("high_beam_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_high_beam_status.detail().name_hash()[i] = high_beam_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_high_beam_status);

            MinimalStructMember mst_low_beam_status;
            mst_low_beam_status.common().member_id(memberId++);
            mst_low_beam_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_low_beam_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_low_beam_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_low_beam_status.common().member_flags().IS_OPTIONAL(false);
            mst_low_beam_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_low_beam_status.common().member_flags().IS_KEY(false);
            mst_low_beam_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_low_beam_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 low_beam_status_hash("low_beam_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_low_beam_status.detail().name_hash()[i] = low_beam_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_low_beam_status);

            MinimalStructMember mst_horn_status;
            mst_horn_status.common().member_id(memberId++);
            mst_horn_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_horn_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_horn_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_horn_status.common().member_flags().IS_OPTIONAL(false);
            mst_horn_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_horn_status.common().member_flags().IS_KEY(false);
            mst_horn_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_horn_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 horn_status_hash("horn_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_horn_status.detail().name_hash()[i] = horn_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_horn_status);

            MinimalStructMember mst_turn_lamp_status;
            mst_turn_lamp_status.common().member_id(memberId++);
            mst_turn_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_turn_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_turn_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_turn_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_turn_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_turn_lamp_status.common().member_flags().IS_KEY(false);
            mst_turn_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_turn_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 turn_lamp_status_hash("turn_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_turn_lamp_status.detail().name_hash()[i] = turn_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_turn_lamp_status);

            MinimalStructMember mst_front_wiper_status;
            mst_front_wiper_status.common().member_id(memberId++);
            mst_front_wiper_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_wiper_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_wiper_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_wiper_status.common().member_flags().IS_OPTIONAL(false);
            mst_front_wiper_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_wiper_status.common().member_flags().IS_KEY(false);
            mst_front_wiper_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_wiper_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 front_wiper_status_hash("front_wiper_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_wiper_status.detail().name_hash()[i] = front_wiper_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_wiper_status);

            MinimalStructMember mst_rear_wiper_status;
            mst_rear_wiper_status.common().member_id(memberId++);
            mst_rear_wiper_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_wiper_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_wiper_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_wiper_status.common().member_flags().IS_OPTIONAL(false);
            mst_rear_wiper_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_wiper_status.common().member_flags().IS_KEY(false);
            mst_rear_wiper_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_wiper_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rear_wiper_status_hash("rear_wiper_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_wiper_status.detail().name_hash()[i] = rear_wiper_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_wiper_status);

            MinimalStructMember mst_position_lamp_status;
            mst_position_lamp_status.common().member_id(memberId++);
            mst_position_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_position_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_position_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_position_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_position_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_position_lamp_status.common().member_flags().IS_KEY(false);
            mst_position_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_position_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 position_lamp_status_hash("position_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_position_lamp_status.detail().name_hash()[i] = position_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_position_lamp_status);

            MinimalStructMember mst_front_fog_lamp_status;
            mst_front_fog_lamp_status.common().member_id(memberId++);
            mst_front_fog_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_front_fog_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_front_fog_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_front_fog_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_front_fog_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_front_fog_lamp_status.common().member_flags().IS_KEY(false);
            mst_front_fog_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_front_fog_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 front_fog_lamp_status_hash("front_fog_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_front_fog_lamp_status.detail().name_hash()[i] = front_fog_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_front_fog_lamp_status);

            MinimalStructMember mst_rear_fog_lamp_status;
            mst_rear_fog_lamp_status.common().member_id(memberId++);
            mst_rear_fog_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rear_fog_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rear_fog_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rear_fog_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_rear_fog_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rear_fog_lamp_status.common().member_flags().IS_KEY(false);
            mst_rear_fog_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rear_fog_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rear_fog_lamp_status_hash("rear_fog_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rear_fog_lamp_status.detail().name_hash()[i] = rear_fog_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rear_fog_lamp_status);

            MinimalStructMember mst_brake_lamp_status;
            mst_brake_lamp_status.common().member_id(memberId++);
            mst_brake_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_brake_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_brake_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_brake_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_brake_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_brake_lamp_status.common().member_flags().IS_KEY(false);
            mst_brake_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_brake_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 brake_lamp_status_hash("brake_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_brake_lamp_status.detail().name_hash()[i] = brake_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_brake_lamp_status);

            MinimalStructMember mst_alarm_lamp_status;
            mst_alarm_lamp_status.common().member_id(memberId++);
            mst_alarm_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_alarm_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_alarm_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_alarm_lamp_status.common().member_flags().IS_OPTIONAL(false);
            mst_alarm_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_alarm_lamp_status.common().member_flags().IS_KEY(false);
            mst_alarm_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_alarm_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 alarm_lamp_status_hash("alarm_lamp_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_alarm_lamp_status.detail().name_hash()[i] = alarm_lamp_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_alarm_lamp_status);

            MinimalStructMember mst_lf_door_status;
            mst_lf_door_status.common().member_id(memberId++);
            mst_lf_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lf_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lf_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lf_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_lf_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lf_door_status.common().member_flags().IS_KEY(false);
            mst_lf_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lf_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lf_door_status_hash("lf_door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_lf_door_status.detail().name_hash()[i] = lf_door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lf_door_status);

            MinimalStructMember mst_rf_door_status;
            mst_rf_door_status.common().member_id(memberId++);
            mst_rf_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rf_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rf_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rf_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_rf_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rf_door_status.common().member_flags().IS_KEY(false);
            mst_rf_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rf_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rf_door_status_hash("rf_door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rf_door_status.detail().name_hash()[i] = rf_door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rf_door_status);

            MinimalStructMember mst_lr_door_status;
            mst_lr_door_status.common().member_id(memberId++);
            mst_lr_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_lr_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_lr_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_lr_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_lr_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_lr_door_status.common().member_flags().IS_KEY(false);
            mst_lr_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_lr_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 lr_door_status_hash("lr_door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_lr_door_status.detail().name_hash()[i] = lr_door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_lr_door_status);

            MinimalStructMember mst_rr_door_status;
            mst_rr_door_status.common().member_id(memberId++);
            mst_rr_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rr_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rr_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rr_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_rr_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rr_door_status.common().member_flags().IS_KEY(false);
            mst_rr_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rr_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rr_door_status_hash("rr_door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rr_door_status.detail().name_hash()[i] = rr_door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rr_door_status);

            MinimalStructMember mst_rearview_mirror_status;
            mst_rearview_mirror_status.common().member_id(memberId++);
            mst_rearview_mirror_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_rearview_mirror_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_rearview_mirror_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_rearview_mirror_status.common().member_flags().IS_OPTIONAL(false);
            mst_rearview_mirror_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_rearview_mirror_status.common().member_flags().IS_KEY(false);
            mst_rearview_mirror_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_rearview_mirror_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 rearview_mirror_status_hash("rearview_mirror_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_rearview_mirror_status.detail().name_hash()[i] = rearview_mirror_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_rearview_mirror_status);

            MinimalStructMember mst_trunk_status;
            mst_trunk_status.common().member_id(memberId++);
            mst_trunk_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_trunk_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_trunk_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_trunk_status.common().member_flags().IS_OPTIONAL(false);
            mst_trunk_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_trunk_status.common().member_flags().IS_KEY(false);
            mst_trunk_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_trunk_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 trunk_status_hash("trunk_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_trunk_status.detail().name_hash()[i] = trunk_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_trunk_status);

            MinimalStructMember mst_engine_bay_door_status;
            mst_engine_bay_door_status.common().member_id(memberId++);
            mst_engine_bay_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_engine_bay_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_engine_bay_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_engine_bay_door_status.common().member_flags().IS_OPTIONAL(false);
            mst_engine_bay_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_engine_bay_door_status.common().member_flags().IS_KEY(false);
            mst_engine_bay_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_engine_bay_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 engine_bay_door_status_hash("engine_bay_door_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_engine_bay_door_status.detail().name_hash()[i] = engine_bay_door_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_engine_bay_door_status);

            MinimalStructMember mst_wheel_direction_rr;
            mst_wheel_direction_rr.common().member_id(memberId++);
            mst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_rr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_rr.common().member_flags().IS_KEY(false);
            mst_wheel_direction_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_rr_hash("wheel_direction_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_rr.detail().name_hash()[i] = wheel_direction_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_rr);

            MinimalStructMember mst_wheel_spd_rr;
            mst_wheel_spd_rr.common().member_id(memberId++);
            mst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_rr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_rr.common().member_flags().IS_KEY(false);
            mst_wheel_spd_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_rr_hash("wheel_spd_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_rr.detail().name_hash()[i] = wheel_spd_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_rr);

            MinimalStructMember mst_wheel_direction_rl;
            mst_wheel_direction_rl.common().member_id(memberId++);
            mst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_rl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_rl.common().member_flags().IS_KEY(false);
            mst_wheel_direction_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_rl_hash("wheel_direction_rl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_rl.detail().name_hash()[i] = wheel_direction_rl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_rl);

            MinimalStructMember mst_wheel_spd_rl;
            mst_wheel_spd_rl.common().member_id(memberId++);
            mst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_rl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_rl.common().member_flags().IS_KEY(false);
            mst_wheel_spd_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_rl_hash("wheel_spd_rl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_rl.detail().name_hash()[i] = wheel_spd_rl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_rl);

            MinimalStructMember mst_wheel_direction_fr;
            mst_wheel_direction_fr.common().member_id(memberId++);
            mst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_fr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_fr.common().member_flags().IS_KEY(false);
            mst_wheel_direction_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_fr_hash("wheel_direction_fr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_fr.detail().name_hash()[i] = wheel_direction_fr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_fr);

            MinimalStructMember mst_wheel_spd_fr;
            mst_wheel_spd_fr.common().member_id(memberId++);
            mst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_fr.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_fr.common().member_flags().IS_KEY(false);
            mst_wheel_spd_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_fr_hash("wheel_spd_fr");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_fr.detail().name_hash()[i] = wheel_spd_fr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_fr);

            MinimalStructMember mst_wheel_direction_fl;
            mst_wheel_direction_fl.common().member_id(memberId++);
            mst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_direction_fl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_direction_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_direction_fl.common().member_flags().IS_KEY(false);
            mst_wheel_direction_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_direction_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wheel_direction_fl_hash("wheel_direction_fl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_direction_fl.detail().name_hash()[i] = wheel_direction_fl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_direction_fl);

            MinimalStructMember mst_wheel_spd_fl;
            mst_wheel_spd_fl.common().member_id(memberId++);
            mst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wheel_spd_fl.common().member_flags().IS_OPTIONAL(false);
            mst_wheel_spd_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wheel_spd_fl.common().member_flags().IS_KEY(false);
            mst_wheel_spd_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wheel_spd_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 wheel_spd_fl_hash("wheel_spd_fl");
            for(int i = 0; i < 4; ++i)
            {
                mst_wheel_spd_fl.detail().name_hash()[i] = wheel_spd_fl_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wheel_spd_fl);

            MinimalStructMember mst_is_wss_rr_edges_sum_valid;
            mst_is_wss_rr_edges_sum_valid.common().member_id(memberId++);
            mst_is_wss_rr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_wss_rr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_wss_rr_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_wss_rr_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_wss_rr_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_wss_rr_edges_sum_valid.common().member_flags().IS_KEY(false);
            mst_is_wss_rr_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_wss_rr_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_wss_rr_edges_sum_valid_hash("is_wss_rr_edges_sum_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_wss_rr_edges_sum_valid.detail().name_hash()[i] = is_wss_rr_edges_sum_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_wss_rr_edges_sum_valid);

            MinimalStructMember mst_wss_rr_edges_sum;
            mst_wss_rr_edges_sum.common().member_id(memberId++);
            mst_wss_rr_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wss_rr_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wss_rr_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wss_rr_edges_sum.common().member_flags().IS_OPTIONAL(false);
            mst_wss_rr_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wss_rr_edges_sum.common().member_flags().IS_KEY(false);
            mst_wss_rr_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wss_rr_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wss_rr_edges_sum_hash("wss_rr_edges_sum");
            for(int i = 0; i < 4; ++i)
            {
                mst_wss_rr_edges_sum.detail().name_hash()[i] = wss_rr_edges_sum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wss_rr_edges_sum);

            MinimalStructMember mst_is_wss_rl_edges_sum_valid;
            mst_is_wss_rl_edges_sum_valid.common().member_id(memberId++);
            mst_is_wss_rl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_wss_rl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_wss_rl_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_wss_rl_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_wss_rl_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_wss_rl_edges_sum_valid.common().member_flags().IS_KEY(false);
            mst_is_wss_rl_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_wss_rl_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_wss_rl_edges_sum_valid_hash("is_wss_rl_edges_sum_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_wss_rl_edges_sum_valid.detail().name_hash()[i] = is_wss_rl_edges_sum_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_wss_rl_edges_sum_valid);

            MinimalStructMember mst_wss_rl_edges_sum;
            mst_wss_rl_edges_sum.common().member_id(memberId++);
            mst_wss_rl_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wss_rl_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wss_rl_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wss_rl_edges_sum.common().member_flags().IS_OPTIONAL(false);
            mst_wss_rl_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wss_rl_edges_sum.common().member_flags().IS_KEY(false);
            mst_wss_rl_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wss_rl_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wss_rl_edges_sum_hash("wss_rl_edges_sum");
            for(int i = 0; i < 4; ++i)
            {
                mst_wss_rl_edges_sum.detail().name_hash()[i] = wss_rl_edges_sum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wss_rl_edges_sum);

            MinimalStructMember mst_is_wss_fr_edges_sum_valid;
            mst_is_wss_fr_edges_sum_valid.common().member_id(memberId++);
            mst_is_wss_fr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_wss_fr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_wss_fr_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_wss_fr_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_wss_fr_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_wss_fr_edges_sum_valid.common().member_flags().IS_KEY(false);
            mst_is_wss_fr_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_wss_fr_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_wss_fr_edges_sum_valid_hash("is_wss_fr_edges_sum_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_wss_fr_edges_sum_valid.detail().name_hash()[i] = is_wss_fr_edges_sum_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_wss_fr_edges_sum_valid);

            MinimalStructMember mst_wss_fr_edges_sum;
            mst_wss_fr_edges_sum.common().member_id(memberId++);
            mst_wss_fr_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wss_fr_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wss_fr_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wss_fr_edges_sum.common().member_flags().IS_OPTIONAL(false);
            mst_wss_fr_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wss_fr_edges_sum.common().member_flags().IS_KEY(false);
            mst_wss_fr_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wss_fr_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wss_fr_edges_sum_hash("wss_fr_edges_sum");
            for(int i = 0; i < 4; ++i)
            {
                mst_wss_fr_edges_sum.detail().name_hash()[i] = wss_fr_edges_sum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wss_fr_edges_sum);

            MinimalStructMember mst_is_wss_fl_edges_sum_valid;
            mst_is_wss_fl_edges_sum_valid.common().member_id(memberId++);
            mst_is_wss_fl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_wss_fl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_wss_fl_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_wss_fl_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_wss_fl_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_wss_fl_edges_sum_valid.common().member_flags().IS_KEY(false);
            mst_is_wss_fl_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_wss_fl_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            MD5 is_wss_fl_edges_sum_valid_hash("is_wss_fl_edges_sum_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_wss_fl_edges_sum_valid.detail().name_hash()[i] = is_wss_fl_edges_sum_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_wss_fl_edges_sum_valid);

            MinimalStructMember mst_wss_fl_edges_sum;
            mst_wss_fl_edges_sum.common().member_id(memberId++);
            mst_wss_fl_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_wss_fl_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_wss_fl_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_wss_fl_edges_sum.common().member_flags().IS_OPTIONAL(false);
            mst_wss_fl_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_wss_fl_edges_sum.common().member_flags().IS_KEY(false);
            mst_wss_fl_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_wss_fl_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 wss_fl_edges_sum_hash("wss_fl_edges_sum");
            for(int i = 0; i < 4; ++i)
            {
                mst_wss_fl_edges_sum.detail().name_hash()[i] = wss_fl_edges_sum_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_wss_fl_edges_sum);

            MinimalStructMember mst_is_tire_pressure_ok;
            mst_is_tire_pressure_ok.common().member_id(memberId++);
            mst_is_tire_pressure_ok.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_tire_pressure_ok.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_tire_pressure_ok.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_tire_pressure_ok.common().member_flags().IS_OPTIONAL(false);
            mst_is_tire_pressure_ok.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_tire_pressure_ok.common().member_flags().IS_KEY(false);
            mst_is_tire_pressure_ok.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_tire_pressure_ok.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 is_tire_pressure_ok_hash("is_tire_pressure_ok");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_tire_pressure_ok.detail().name_hash()[i] = is_tire_pressure_ok_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_tire_pressure_ok);

            MinimalStructMember mst_is_tire_pressure_lf_valid;
            mst_is_tire_pressure_lf_valid.common().member_id(memberId++);
            mst_is_tire_pressure_lf_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_tire_pressure_lf_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_tire_pressure_lf_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_tire_pressure_lf_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_tire_pressure_lf_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_tire_pressure_lf_valid.common().member_flags().IS_KEY(false);
            mst_is_tire_pressure_lf_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_tire_pressure_lf_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 is_tire_pressure_lf_valid_hash("is_tire_pressure_lf_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_tire_pressure_lf_valid.detail().name_hash()[i] = is_tire_pressure_lf_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_tire_pressure_lf_valid);

            MinimalStructMember mst_tire_pressure_lf;
            mst_tire_pressure_lf.common().member_id(memberId++);
            mst_tire_pressure_lf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tire_pressure_lf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tire_pressure_lf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tire_pressure_lf.common().member_flags().IS_OPTIONAL(false);
            mst_tire_pressure_lf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tire_pressure_lf.common().member_flags().IS_KEY(false);
            mst_tire_pressure_lf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tire_pressure_lf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tire_pressure_lf_hash("tire_pressure_lf");
            for(int i = 0; i < 4; ++i)
            {
                mst_tire_pressure_lf.detail().name_hash()[i] = tire_pressure_lf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tire_pressure_lf);

            MinimalStructMember mst_is_tire_pressure_rf_valid;
            mst_is_tire_pressure_rf_valid.common().member_id(memberId++);
            mst_is_tire_pressure_rf_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_tire_pressure_rf_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_tire_pressure_rf_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_tire_pressure_rf_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_tire_pressure_rf_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_tire_pressure_rf_valid.common().member_flags().IS_KEY(false);
            mst_is_tire_pressure_rf_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_tire_pressure_rf_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 is_tire_pressure_rf_valid_hash("is_tire_pressure_rf_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_tire_pressure_rf_valid.detail().name_hash()[i] = is_tire_pressure_rf_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_tire_pressure_rf_valid);

            MinimalStructMember mst_tire_pressure_rf;
            mst_tire_pressure_rf.common().member_id(memberId++);
            mst_tire_pressure_rf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tire_pressure_rf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tire_pressure_rf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tire_pressure_rf.common().member_flags().IS_OPTIONAL(false);
            mst_tire_pressure_rf.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tire_pressure_rf.common().member_flags().IS_KEY(false);
            mst_tire_pressure_rf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tire_pressure_rf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tire_pressure_rf_hash("tire_pressure_rf");
            for(int i = 0; i < 4; ++i)
            {
                mst_tire_pressure_rf.detail().name_hash()[i] = tire_pressure_rf_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tire_pressure_rf);

            MinimalStructMember mst_is_tire_pressure_lr_valid;
            mst_is_tire_pressure_lr_valid.common().member_id(memberId++);
            mst_is_tire_pressure_lr_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_tire_pressure_lr_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_tire_pressure_lr_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_tire_pressure_lr_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_tire_pressure_lr_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_tire_pressure_lr_valid.common().member_flags().IS_KEY(false);
            mst_is_tire_pressure_lr_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_tire_pressure_lr_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 is_tire_pressure_lr_valid_hash("is_tire_pressure_lr_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_tire_pressure_lr_valid.detail().name_hash()[i] = is_tire_pressure_lr_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_tire_pressure_lr_valid);

            MinimalStructMember mst_tire_pressure_lr;
            mst_tire_pressure_lr.common().member_id(memberId++);
            mst_tire_pressure_lr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tire_pressure_lr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tire_pressure_lr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tire_pressure_lr.common().member_flags().IS_OPTIONAL(false);
            mst_tire_pressure_lr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tire_pressure_lr.common().member_flags().IS_KEY(false);
            mst_tire_pressure_lr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tire_pressure_lr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tire_pressure_lr_hash("tire_pressure_lr");
            for(int i = 0; i < 4; ++i)
            {
                mst_tire_pressure_lr.detail().name_hash()[i] = tire_pressure_lr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tire_pressure_lr);

            MinimalStructMember mst_is_tire_pressure_rr_valid;
            mst_is_tire_pressure_rr_valid.common().member_id(memberId++);
            mst_is_tire_pressure_rr_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_is_tire_pressure_rr_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_is_tire_pressure_rr_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_is_tire_pressure_rr_valid.common().member_flags().IS_OPTIONAL(false);
            mst_is_tire_pressure_rr_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_is_tire_pressure_rr_valid.common().member_flags().IS_KEY(false);
            mst_is_tire_pressure_rr_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_is_tire_pressure_rr_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 is_tire_pressure_rr_valid_hash("is_tire_pressure_rr_valid");
            for(int i = 0; i < 4; ++i)
            {
                mst_is_tire_pressure_rr_valid.detail().name_hash()[i] = is_tire_pressure_rr_valid_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_is_tire_pressure_rr_valid);

            MinimalStructMember mst_tire_pressure_rr;
            mst_tire_pressure_rr.common().member_id(memberId++);
            mst_tire_pressure_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_tire_pressure_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_tire_pressure_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_tire_pressure_rr.common().member_flags().IS_OPTIONAL(false);
            mst_tire_pressure_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_tire_pressure_rr.common().member_flags().IS_KEY(false);
            mst_tire_pressure_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_tire_pressure_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            MD5 tire_pressure_rr_hash("tire_pressure_rr");
            for(int i = 0; i < 4; ++i)
            {
                mst_tire_pressure_rr.detail().name_hash()[i] = tire_pressure_rr_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_tire_pressure_rr);

            MinimalStructMember mst_air_bag_status;
            mst_air_bag_status.common().member_id(memberId++);
            mst_air_bag_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_air_bag_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_air_bag_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_air_bag_status.common().member_flags().IS_OPTIONAL(false);
            mst_air_bag_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_air_bag_status.common().member_flags().IS_KEY(false);
            mst_air_bag_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_air_bag_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 air_bag_status_hash("air_bag_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_air_bag_status.detail().name_hash()[i] = air_bag_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_air_bag_status);

            MinimalStructMember mst_charging_gun_status;
            mst_charging_gun_status.common().member_id(memberId++);
            mst_charging_gun_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_charging_gun_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_charging_gun_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_charging_gun_status.common().member_flags().IS_OPTIONAL(false);
            mst_charging_gun_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_charging_gun_status.common().member_flags().IS_KEY(false);
            mst_charging_gun_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_charging_gun_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 charging_gun_status_hash("charging_gun_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_charging_gun_status.detail().name_hash()[i] = charging_gun_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_charging_gun_status);

            MinimalStructMember mst_charge;
            mst_charge.common().member_id(memberId++);
            mst_charge.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_charge.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_charge.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_charge.common().member_flags().IS_OPTIONAL(false);
            mst_charge.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_charge.common().member_flags().IS_KEY(false);
            mst_charge.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_charge.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 charge_hash("charge");
            for(int i = 0; i < 4; ++i)
            {
                mst_charge.detail().name_hash()[i] = charge_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_charge);

            MinimalStructMember mst_vehicle_power_status;
            mst_vehicle_power_status.common().member_id(memberId++);
            mst_vehicle_power_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_vehicle_power_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_vehicle_power_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_vehicle_power_status.common().member_flags().IS_OPTIONAL(false);
            mst_vehicle_power_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_vehicle_power_status.common().member_flags().IS_KEY(false);
            mst_vehicle_power_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_vehicle_power_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            MD5 vehicle_power_status_hash("vehicle_power_status");
            for(int i = 0; i < 4; ++i)
            {
                mst_vehicle_power_status.detail().name_hash()[i] = vehicle_power_status_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_vehicle_power_status);

            MinimalStructMember mst_chassis_error_code;
            mst_chassis_error_code.common().member_id(memberId++);
            mst_chassis_error_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            mst_chassis_error_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            mst_chassis_error_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            mst_chassis_error_code.common().member_flags().IS_OPTIONAL(false);
            mst_chassis_error_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            mst_chassis_error_code.common().member_flags().IS_KEY(false);
            mst_chassis_error_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            mst_chassis_error_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, false));


            MD5 chassis_error_code_hash("chassis_error_code");
            for(int i = 0; i < 4; ++i)
            {
                mst_chassis_error_code.detail().name_hash()[i] = chassis_error_code_hash.digest[i];
            }
            type_object->minimal().struct_type().member_seq().emplace_back(mst_chassis_error_code);


            // Header
            // TODO Inheritance
            //type_object->minimal().struct_type().header().base_type()._d(EK_MINIMAL);
            //type_object->minimal().struct_type().header().base_type().equivalence_hash()[0..13];

            TypeIdentifier identifier;
            identifier._d(EK_MINIMAL);

            SerializedPayload_t payload(static_cast<uint32_t>(
                MinimalStructType::getCdrSerializedSize(type_object->minimal().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Chassis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Chassis", false);
        }

        const TypeObject* GetCompleteChassisObject()
        {
            const TypeObject* c_type_object = TypeObjectFactory::get_instance()->get_type_object("Chassis", true);
            if (c_type_object != nullptr && c_type_object->_d() == EK_COMPLETE)
            {
                return c_type_object;
            }

            TypeObject *type_object = new TypeObject();
            type_object->_d(EK_COMPLETE);
            type_object->complete()._d(TK_STRUCTURE);

            type_object->complete().struct_type().struct_flags().IS_FINAL(false);
            type_object->complete().struct_type().struct_flags().IS_APPENDABLE(false);
            type_object->complete().struct_type().struct_flags().IS_MUTABLE(false);
            type_object->complete().struct_type().struct_flags().IS_NESTED(false);
            type_object->complete().struct_type().struct_flags().IS_AUTOID_HASH(false); // Unsupported

            MemberId memberId = 0;
            CompleteStructMember cst_header;
            cst_header.common().member_id(memberId++);
            cst_header.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_header.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_header.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_header.common().member_flags().IS_OPTIONAL(false);
            cst_header.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_header.common().member_flags().IS_KEY(false);
            cst_header.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_header.common().member_type_id(*ros2_interface::msg::GetHeaderIdentifier(true));
            cst_header.detail().name("header");

            type_object->complete().struct_type().member_seq().emplace_back(cst_header);

            CompleteStructMember cst_moving_status;
            cst_moving_status.common().member_id(memberId++);
            cst_moving_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_moving_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_moving_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_moving_status.common().member_flags().IS_OPTIONAL(false);
            cst_moving_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_moving_status.common().member_flags().IS_KEY(false);
            cst_moving_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_moving_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_moving_status.detail().name("moving_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_moving_status);

            CompleteStructMember cst_driving_mode;
            cst_driving_mode.common().member_id(memberId++);
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_driving_mode.common().member_flags().IS_KEY(false);
            cst_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_driving_mode.detail().name("driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_driving_mode);

            CompleteStructMember cst_steer_driving_mode;
            cst_steer_driving_mode.common().member_id(memberId++);
            cst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steer_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_steer_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steer_driving_mode.common().member_flags().IS_KEY(false);
            cst_steer_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steer_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_steer_driving_mode.detail().name("steer_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steer_driving_mode);

            CompleteStructMember cst_steering_status;
            cst_steering_status.common().member_id(memberId++);
            cst_steering_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_status.common().member_flags().IS_OPTIONAL(false);
            cst_steering_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_status.common().member_flags().IS_KEY(false);
            cst_steering_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_steering_status.detail().name("steering_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_status);

            CompleteStructMember cst_front_steering_value;
            cst_front_steering_value.common().member_id(memberId++);
            cst_front_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_value.common().member_flags().IS_KEY(false);
            cst_front_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_value.detail().name("front_steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_value);

            CompleteStructMember cst_rear_steering_value;
            cst_rear_steering_value.common().member_id(memberId++);
            cst_rear_steering_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_value.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_value.common().member_flags().IS_KEY(false);
            cst_rear_steering_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_value.detail().name("rear_steering_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_value);

            CompleteStructMember cst_steering_torque_nm;
            cst_steering_torque_nm.common().member_id(memberId++);
            cst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_steering_torque_nm.common().member_flags().IS_OPTIONAL(false);
            cst_steering_torque_nm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_steering_torque_nm.common().member_flags().IS_KEY(false);
            cst_steering_torque_nm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_steering_torque_nm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_steering_torque_nm.detail().name("steering_torque_nm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_steering_torque_nm);

            CompleteStructMember cst_front_steering_rate_dps;
            cst_front_steering_rate_dps.common().member_id(memberId++);
            cst_front_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            cst_front_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_steering_rate_dps.common().member_flags().IS_KEY(false);
            cst_front_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_front_steering_rate_dps.detail().name("front_steering_rate_dps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_steering_rate_dps);

            CompleteStructMember cst_rear_steering_rate_dps;
            cst_rear_steering_rate_dps.common().member_id(memberId++);
            cst_rear_steering_rate_dps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_steering_rate_dps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_steering_rate_dps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_steering_rate_dps.common().member_flags().IS_OPTIONAL(false);
            cst_rear_steering_rate_dps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_steering_rate_dps.common().member_flags().IS_KEY(false);
            cst_rear_steering_rate_dps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_steering_rate_dps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_rear_steering_rate_dps.detail().name("rear_steering_rate_dps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_steering_rate_dps);

            CompleteStructMember cst_accel_driving_mode;
            cst_accel_driving_mode.common().member_id(memberId++);
            cst_accel_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_accel_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_driving_mode.common().member_flags().IS_KEY(false);
            cst_accel_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_accel_driving_mode.detail().name("accel_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_driving_mode);

            CompleteStructMember cst_accel_status;
            cst_accel_status.common().member_id(memberId++);
            cst_accel_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_status.common().member_flags().IS_OPTIONAL(false);
            cst_accel_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_status.common().member_flags().IS_KEY(false);
            cst_accel_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_accel_status.detail().name("accel_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_status);

            CompleteStructMember cst_accel_value;
            cst_accel_value.common().member_id(memberId++);
            cst_accel_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_accel_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_accel_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_accel_value.common().member_flags().IS_OPTIONAL(false);
            cst_accel_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_accel_value.common().member_flags().IS_KEY(false);
            cst_accel_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_accel_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_accel_value.detail().name("accel_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_accel_value);

            CompleteStructMember cst_brake_driving_mode;
            cst_brake_driving_mode.common().member_id(memberId++);
            cst_brake_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_brake_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_driving_mode.common().member_flags().IS_KEY(false);
            cst_brake_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_driving_mode.detail().name("brake_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_driving_mode);

            CompleteStructMember cst_brake_status;
            cst_brake_status.common().member_id(memberId++);
            cst_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_status.common().member_flags().IS_KEY(false);
            cst_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_status.detail().name("brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_status);

            CompleteStructMember cst_brake_value;
            cst_brake_value.common().member_id(memberId++);
            cst_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_value.common().member_flags().IS_OPTIONAL(false);
            cst_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_value.common().member_flags().IS_KEY(false);
            cst_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_brake_value.detail().name("brake_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_value);

            CompleteStructMember cst_brake_padel;
            cst_brake_padel.common().member_id(memberId++);
            cst_brake_padel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_padel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_padel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_padel.common().member_flags().IS_OPTIONAL(false);
            cst_brake_padel.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_padel.common().member_flags().IS_KEY(false);
            cst_brake_padel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_padel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_padel.detail().name("brake_padel");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_padel);

            CompleteStructMember cst_lf_wheel_wheel_brake_status;
            cst_lf_wheel_wheel_brake_status.common().member_id(memberId++);
            cst_lf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lf_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lf_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_lf_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lf_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            cst_lf_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lf_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_lf_wheel_wheel_brake_status.detail().name("lf_wheel_wheel_brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lf_wheel_wheel_brake_status);

            CompleteStructMember cst_rf_wheel_wheel_brake_status;
            cst_rf_wheel_wheel_brake_status.common().member_id(memberId++);
            cst_rf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rf_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rf_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rf_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_rf_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rf_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            cst_rf_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rf_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_rf_wheel_wheel_brake_status.detail().name("rf_wheel_wheel_brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rf_wheel_wheel_brake_status);

            CompleteStructMember cst_lr_wheel_wheel_brake_status;
            cst_lr_wheel_wheel_brake_status.common().member_id(memberId++);
            cst_lr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lr_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lr_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_lr_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lr_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            cst_lr_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lr_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_lr_wheel_wheel_brake_status.detail().name("lr_wheel_wheel_brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lr_wheel_wheel_brake_status);

            CompleteStructMember cst_rr_wheel_wheel_brake_status;
            cst_rr_wheel_wheel_brake_status.common().member_id(memberId++);
            cst_rr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rr_wheel_wheel_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rr_wheel_wheel_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rr_wheel_wheel_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_rr_wheel_wheel_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rr_wheel_wheel_brake_status.common().member_flags().IS_KEY(false);
            cst_rr_wheel_wheel_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rr_wheel_wheel_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_rr_wheel_wheel_brake_status.detail().name("rr_wheel_wheel_brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rr_wheel_wheel_brake_status);

            CompleteStructMember cst_backup_brake_driving_mode;
            cst_backup_brake_driving_mode.common().member_id(memberId++);
            cst_backup_brake_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_backup_brake_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_backup_brake_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_backup_brake_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_backup_brake_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_backup_brake_driving_mode.common().member_flags().IS_KEY(false);
            cst_backup_brake_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_backup_brake_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_backup_brake_driving_mode.detail().name("backup_brake_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_backup_brake_driving_mode);

            CompleteStructMember cst_backup_brake_status;
            cst_backup_brake_status.common().member_id(memberId++);
            cst_backup_brake_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_backup_brake_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_backup_brake_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_backup_brake_status.common().member_flags().IS_OPTIONAL(false);
            cst_backup_brake_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_backup_brake_status.common().member_flags().IS_KEY(false);
            cst_backup_brake_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_backup_brake_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_backup_brake_status.detail().name("backup_brake_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_backup_brake_status);

            CompleteStructMember cst_backup_brake_value;
            cst_backup_brake_value.common().member_id(memberId++);
            cst_backup_brake_value.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_backup_brake_value.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_backup_brake_value.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_backup_brake_value.common().member_flags().IS_OPTIONAL(false);
            cst_backup_brake_value.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_backup_brake_value.common().member_flags().IS_KEY(false);
            cst_backup_brake_value.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_backup_brake_value.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_backup_brake_value.detail().name("backup_brake_value");

            type_object->complete().struct_type().member_seq().emplace_back(cst_backup_brake_value);

            CompleteStructMember cst_epb_driving_mode;
            cst_epb_driving_mode.common().member_id(memberId++);
            cst_epb_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_epb_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_epb_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_epb_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_epb_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_epb_driving_mode.common().member_flags().IS_KEY(false);
            cst_epb_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_epb_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_epb_driving_mode.detail().name("epb_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_epb_driving_mode);

            CompleteStructMember cst_epb_status;
            cst_epb_status.common().member_id(memberId++);
            cst_epb_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_epb_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_epb_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_epb_status.common().member_flags().IS_OPTIONAL(false);
            cst_epb_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_epb_status.common().member_flags().IS_KEY(false);
            cst_epb_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_epb_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_epb_status.detail().name("epb_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_epb_status);

            CompleteStructMember cst_epb_level;
            cst_epb_level.common().member_id(memberId++);
            cst_epb_level.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_epb_level.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_epb_level.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_epb_level.common().member_flags().IS_OPTIONAL(false);
            cst_epb_level.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_epb_level.common().member_flags().IS_KEY(false);
            cst_epb_level.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_epb_level.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_epb_level.detail().name("epb_level");

            type_object->complete().struct_type().member_seq().emplace_back(cst_epb_level);

            CompleteStructMember cst_gear_driving_mode;
            cst_gear_driving_mode.common().member_id(memberId++);
            cst_gear_driving_mode.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_driving_mode.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_driving_mode.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_driving_mode.common().member_flags().IS_OPTIONAL(false);
            cst_gear_driving_mode.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_driving_mode.common().member_flags().IS_KEY(false);
            cst_gear_driving_mode.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_driving_mode.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_driving_mode.detail().name("gear_driving_mode");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_driving_mode);

            CompleteStructMember cst_gear_status;
            cst_gear_status.common().member_id(memberId++);
            cst_gear_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_status.common().member_flags().IS_OPTIONAL(false);
            cst_gear_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_status.common().member_flags().IS_KEY(false);
            cst_gear_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_status.detail().name("gear_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_status);

            CompleteStructMember cst_gear_location;
            cst_gear_location.common().member_id(memberId++);
            cst_gear_location.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_gear_location.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_gear_location.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_gear_location.common().member_flags().IS_OPTIONAL(false);
            cst_gear_location.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_gear_location.common().member_flags().IS_KEY(false);
            cst_gear_location.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_gear_location.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_gear_location.detail().name("gear_location");

            type_object->complete().struct_type().member_seq().emplace_back(cst_gear_location);

            CompleteStructMember cst_engine_rpm;
            cst_engine_rpm.common().member_id(memberId++);
            cst_engine_rpm.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_engine_rpm.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_engine_rpm.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_engine_rpm.common().member_flags().IS_OPTIONAL(false);
            cst_engine_rpm.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_engine_rpm.common().member_flags().IS_KEY(false);
            cst_engine_rpm.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_engine_rpm.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_engine_rpm.detail().name("engine_rpm");

            type_object->complete().struct_type().member_seq().emplace_back(cst_engine_rpm);

            CompleteStructMember cst_engine_torque;
            cst_engine_torque.common().member_id(memberId++);
            cst_engine_torque.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_engine_torque.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_engine_torque.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_engine_torque.common().member_flags().IS_OPTIONAL(false);
            cst_engine_torque.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_engine_torque.common().member_flags().IS_KEY(false);
            cst_engine_torque.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_engine_torque.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_engine_torque.detail().name("engine_torque");

            type_object->complete().struct_type().member_seq().emplace_back(cst_engine_torque);

            CompleteStructMember cst_is_speed_valid;
            cst_is_speed_valid.common().member_id(memberId++);
            cst_is_speed_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_speed_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_speed_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_speed_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_speed_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_speed_valid.common().member_flags().IS_KEY(false);
            cst_is_speed_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_speed_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_speed_valid.detail().name("is_speed_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_speed_valid);

            CompleteStructMember cst_speed_mps;
            cst_speed_mps.common().member_id(memberId++);
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_speed_mps.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_speed_mps.common().member_flags().IS_OPTIONAL(false);
            cst_speed_mps.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_speed_mps.common().member_flags().IS_KEY(false);
            cst_speed_mps.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_speed_mps.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_speed_mps.detail().name("speed_mps");

            type_object->complete().struct_type().member_seq().emplace_back(cst_speed_mps);

            CompleteStructMember cst_is_veh_lat_accel_valid;
            cst_is_veh_lat_accel_valid.common().member_id(memberId++);
            cst_is_veh_lat_accel_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_veh_lat_accel_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_veh_lat_accel_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_veh_lat_accel_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_veh_lat_accel_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_veh_lat_accel_valid.common().member_flags().IS_KEY(false);
            cst_is_veh_lat_accel_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_veh_lat_accel_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_veh_lat_accel_valid.detail().name("is_veh_lat_accel_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_veh_lat_accel_valid);

            CompleteStructMember cst_veh_lat_accel;
            cst_veh_lat_accel.common().member_id(memberId++);
            cst_veh_lat_accel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_veh_lat_accel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_veh_lat_accel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_veh_lat_accel.common().member_flags().IS_OPTIONAL(false);
            cst_veh_lat_accel.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_veh_lat_accel.common().member_flags().IS_KEY(false);
            cst_veh_lat_accel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_veh_lat_accel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_veh_lat_accel.detail().name("veh_lat_accel");

            type_object->complete().struct_type().member_seq().emplace_back(cst_veh_lat_accel);

            CompleteStructMember cst_is_veh_lon_accel_valid;
            cst_is_veh_lon_accel_valid.common().member_id(memberId++);
            cst_is_veh_lon_accel_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_veh_lon_accel_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_veh_lon_accel_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_veh_lon_accel_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_veh_lon_accel_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_veh_lon_accel_valid.common().member_flags().IS_KEY(false);
            cst_is_veh_lon_accel_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_veh_lon_accel_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_veh_lon_accel_valid.detail().name("is_veh_lon_accel_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_veh_lon_accel_valid);

            CompleteStructMember cst_veh_lon_accel;
            cst_veh_lon_accel.common().member_id(memberId++);
            cst_veh_lon_accel.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_veh_lon_accel.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_veh_lon_accel.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_veh_lon_accel.common().member_flags().IS_OPTIONAL(false);
            cst_veh_lon_accel.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_veh_lon_accel.common().member_flags().IS_KEY(false);
            cst_veh_lon_accel.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_veh_lon_accel.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_veh_lon_accel.detail().name("veh_lon_accel");

            type_object->complete().struct_type().member_seq().emplace_back(cst_veh_lon_accel);

            CompleteStructMember cst_is_yaw_rate_valid;
            cst_is_yaw_rate_valid.common().member_id(memberId++);
            cst_is_yaw_rate_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_yaw_rate_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_yaw_rate_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_yaw_rate_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_yaw_rate_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_yaw_rate_valid.common().member_flags().IS_KEY(false);
            cst_is_yaw_rate_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_yaw_rate_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_yaw_rate_valid.detail().name("is_yaw_rate_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_yaw_rate_valid);

            CompleteStructMember cst_yaw_rate;
            cst_yaw_rate.common().member_id(memberId++);
            cst_yaw_rate.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_yaw_rate.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_yaw_rate.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_yaw_rate.common().member_flags().IS_OPTIONAL(false);
            cst_yaw_rate.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_yaw_rate.common().member_flags().IS_KEY(false);
            cst_yaw_rate.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_yaw_rate.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_yaw_rate.detail().name("yaw_rate");

            type_object->complete().struct_type().member_seq().emplace_back(cst_yaw_rate);

            CompleteStructMember cst_odometer_m;
            cst_odometer_m.common().member_id(memberId++);
            cst_odometer_m.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_odometer_m.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_odometer_m.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_odometer_m.common().member_flags().IS_OPTIONAL(false);
            cst_odometer_m.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_odometer_m.common().member_flags().IS_KEY(false);
            cst_odometer_m.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_odometer_m.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_odometer_m.detail().name("odometer_m");

            type_object->complete().struct_type().member_seq().emplace_back(cst_odometer_m);

            CompleteStructMember cst_daytime_running_lights_status;
            cst_daytime_running_lights_status.common().member_id(memberId++);
            cst_daytime_running_lights_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_daytime_running_lights_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_daytime_running_lights_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_daytime_running_lights_status.common().member_flags().IS_OPTIONAL(false);
            cst_daytime_running_lights_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_daytime_running_lights_status.common().member_flags().IS_KEY(false);
            cst_daytime_running_lights_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_daytime_running_lights_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_daytime_running_lights_status.detail().name("daytime_running_lights_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_daytime_running_lights_status);

            CompleteStructMember cst_automatic_light_control_status;
            cst_automatic_light_control_status.common().member_id(memberId++);
            cst_automatic_light_control_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_automatic_light_control_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_automatic_light_control_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_automatic_light_control_status.common().member_flags().IS_OPTIONAL(false);
            cst_automatic_light_control_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_automatic_light_control_status.common().member_flags().IS_KEY(false);
            cst_automatic_light_control_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_automatic_light_control_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_automatic_light_control_status.detail().name("automatic_light_control_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_automatic_light_control_status);

            CompleteStructMember cst_parking_lights_status;
            cst_parking_lights_status.common().member_id(memberId++);
            cst_parking_lights_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_parking_lights_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_parking_lights_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_parking_lights_status.common().member_flags().IS_OPTIONAL(false);
            cst_parking_lights_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_parking_lights_status.common().member_flags().IS_KEY(false);
            cst_parking_lights_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_parking_lights_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_parking_lights_status.detail().name("parking_lights_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_parking_lights_status);

            CompleteStructMember cst_high_beam_status;
            cst_high_beam_status.common().member_id(memberId++);
            cst_high_beam_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_high_beam_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_high_beam_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_high_beam_status.common().member_flags().IS_OPTIONAL(false);
            cst_high_beam_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_high_beam_status.common().member_flags().IS_KEY(false);
            cst_high_beam_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_high_beam_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_high_beam_status.detail().name("high_beam_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_high_beam_status);

            CompleteStructMember cst_low_beam_status;
            cst_low_beam_status.common().member_id(memberId++);
            cst_low_beam_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_low_beam_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_low_beam_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_low_beam_status.common().member_flags().IS_OPTIONAL(false);
            cst_low_beam_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_low_beam_status.common().member_flags().IS_KEY(false);
            cst_low_beam_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_low_beam_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_low_beam_status.detail().name("low_beam_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_low_beam_status);

            CompleteStructMember cst_horn_status;
            cst_horn_status.common().member_id(memberId++);
            cst_horn_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_horn_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_horn_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_horn_status.common().member_flags().IS_OPTIONAL(false);
            cst_horn_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_horn_status.common().member_flags().IS_KEY(false);
            cst_horn_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_horn_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_horn_status.detail().name("horn_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_horn_status);

            CompleteStructMember cst_turn_lamp_status;
            cst_turn_lamp_status.common().member_id(memberId++);
            cst_turn_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_turn_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_turn_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_turn_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_turn_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_turn_lamp_status.common().member_flags().IS_KEY(false);
            cst_turn_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_turn_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_turn_lamp_status.detail().name("turn_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_turn_lamp_status);

            CompleteStructMember cst_front_wiper_status;
            cst_front_wiper_status.common().member_id(memberId++);
            cst_front_wiper_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_wiper_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_wiper_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_wiper_status.common().member_flags().IS_OPTIONAL(false);
            cst_front_wiper_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_wiper_status.common().member_flags().IS_KEY(false);
            cst_front_wiper_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_wiper_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_front_wiper_status.detail().name("front_wiper_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_wiper_status);

            CompleteStructMember cst_rear_wiper_status;
            cst_rear_wiper_status.common().member_id(memberId++);
            cst_rear_wiper_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_wiper_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_wiper_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_wiper_status.common().member_flags().IS_OPTIONAL(false);
            cst_rear_wiper_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_wiper_status.common().member_flags().IS_KEY(false);
            cst_rear_wiper_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_wiper_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rear_wiper_status.detail().name("rear_wiper_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_wiper_status);

            CompleteStructMember cst_position_lamp_status;
            cst_position_lamp_status.common().member_id(memberId++);
            cst_position_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_position_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_position_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_position_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_position_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_position_lamp_status.common().member_flags().IS_KEY(false);
            cst_position_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_position_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_position_lamp_status.detail().name("position_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_position_lamp_status);

            CompleteStructMember cst_front_fog_lamp_status;
            cst_front_fog_lamp_status.common().member_id(memberId++);
            cst_front_fog_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_front_fog_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_front_fog_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_front_fog_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_front_fog_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_front_fog_lamp_status.common().member_flags().IS_KEY(false);
            cst_front_fog_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_front_fog_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_front_fog_lamp_status.detail().name("front_fog_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_front_fog_lamp_status);

            CompleteStructMember cst_rear_fog_lamp_status;
            cst_rear_fog_lamp_status.common().member_id(memberId++);
            cst_rear_fog_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rear_fog_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rear_fog_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rear_fog_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_rear_fog_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rear_fog_lamp_status.common().member_flags().IS_KEY(false);
            cst_rear_fog_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rear_fog_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rear_fog_lamp_status.detail().name("rear_fog_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rear_fog_lamp_status);

            CompleteStructMember cst_brake_lamp_status;
            cst_brake_lamp_status.common().member_id(memberId++);
            cst_brake_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_brake_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_brake_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_brake_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_brake_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_brake_lamp_status.common().member_flags().IS_KEY(false);
            cst_brake_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_brake_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_brake_lamp_status.detail().name("brake_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_brake_lamp_status);

            CompleteStructMember cst_alarm_lamp_status;
            cst_alarm_lamp_status.common().member_id(memberId++);
            cst_alarm_lamp_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_alarm_lamp_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_alarm_lamp_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_alarm_lamp_status.common().member_flags().IS_OPTIONAL(false);
            cst_alarm_lamp_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_alarm_lamp_status.common().member_flags().IS_KEY(false);
            cst_alarm_lamp_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_alarm_lamp_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_alarm_lamp_status.detail().name("alarm_lamp_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_alarm_lamp_status);

            CompleteStructMember cst_lf_door_status;
            cst_lf_door_status.common().member_id(memberId++);
            cst_lf_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lf_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lf_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lf_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_lf_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lf_door_status.common().member_flags().IS_KEY(false);
            cst_lf_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lf_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lf_door_status.detail().name("lf_door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lf_door_status);

            CompleteStructMember cst_rf_door_status;
            cst_rf_door_status.common().member_id(memberId++);
            cst_rf_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rf_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rf_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rf_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_rf_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rf_door_status.common().member_flags().IS_KEY(false);
            cst_rf_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rf_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rf_door_status.detail().name("rf_door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rf_door_status);

            CompleteStructMember cst_lr_door_status;
            cst_lr_door_status.common().member_id(memberId++);
            cst_lr_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_lr_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_lr_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_lr_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_lr_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_lr_door_status.common().member_flags().IS_KEY(false);
            cst_lr_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_lr_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_lr_door_status.detail().name("lr_door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_lr_door_status);

            CompleteStructMember cst_rr_door_status;
            cst_rr_door_status.common().member_id(memberId++);
            cst_rr_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rr_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rr_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rr_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_rr_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rr_door_status.common().member_flags().IS_KEY(false);
            cst_rr_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rr_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rr_door_status.detail().name("rr_door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rr_door_status);

            CompleteStructMember cst_rearview_mirror_status;
            cst_rearview_mirror_status.common().member_id(memberId++);
            cst_rearview_mirror_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_rearview_mirror_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_rearview_mirror_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_rearview_mirror_status.common().member_flags().IS_OPTIONAL(false);
            cst_rearview_mirror_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_rearview_mirror_status.common().member_flags().IS_KEY(false);
            cst_rearview_mirror_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_rearview_mirror_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_rearview_mirror_status.detail().name("rearview_mirror_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_rearview_mirror_status);

            CompleteStructMember cst_trunk_status;
            cst_trunk_status.common().member_id(memberId++);
            cst_trunk_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_trunk_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_trunk_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_trunk_status.common().member_flags().IS_OPTIONAL(false);
            cst_trunk_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_trunk_status.common().member_flags().IS_KEY(false);
            cst_trunk_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_trunk_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_trunk_status.detail().name("trunk_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_trunk_status);

            CompleteStructMember cst_engine_bay_door_status;
            cst_engine_bay_door_status.common().member_id(memberId++);
            cst_engine_bay_door_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_engine_bay_door_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_engine_bay_door_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_engine_bay_door_status.common().member_flags().IS_OPTIONAL(false);
            cst_engine_bay_door_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_engine_bay_door_status.common().member_flags().IS_KEY(false);
            cst_engine_bay_door_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_engine_bay_door_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_engine_bay_door_status.detail().name("engine_bay_door_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_engine_bay_door_status);

            CompleteStructMember cst_wheel_direction_rr;
            cst_wheel_direction_rr.common().member_id(memberId++);
            cst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_rr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_rr.common().member_flags().IS_KEY(false);
            cst_wheel_direction_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_rr.detail().name("wheel_direction_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_rr);

            CompleteStructMember cst_wheel_spd_rr;
            cst_wheel_spd_rr.common().member_id(memberId++);
            cst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_rr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_rr.common().member_flags().IS_KEY(false);
            cst_wheel_spd_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_rr.detail().name("wheel_spd_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_rr);

            CompleteStructMember cst_wheel_direction_rl;
            cst_wheel_direction_rl.common().member_id(memberId++);
            cst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_rl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_rl.common().member_flags().IS_KEY(false);
            cst_wheel_direction_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_rl.detail().name("wheel_direction_rl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_rl);

            CompleteStructMember cst_wheel_spd_rl;
            cst_wheel_spd_rl.common().member_id(memberId++);
            cst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_rl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_rl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_rl.common().member_flags().IS_KEY(false);
            cst_wheel_spd_rl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_rl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_rl.detail().name("wheel_spd_rl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_rl);

            CompleteStructMember cst_wheel_direction_fr;
            cst_wheel_direction_fr.common().member_id(memberId++);
            cst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_fr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_fr.common().member_flags().IS_KEY(false);
            cst_wheel_direction_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_fr.detail().name("wheel_direction_fr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_fr);

            CompleteStructMember cst_wheel_spd_fr;
            cst_wheel_spd_fr.common().member_id(memberId++);
            cst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_fr.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_fr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_fr.common().member_flags().IS_KEY(false);
            cst_wheel_spd_fr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_fr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_fr.detail().name("wheel_spd_fr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_fr);

            CompleteStructMember cst_wheel_direction_fl;
            cst_wheel_direction_fl.common().member_id(memberId++);
            cst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_direction_fl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_direction_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_direction_fl.common().member_flags().IS_KEY(false);
            cst_wheel_direction_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_direction_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wheel_direction_fl.detail().name("wheel_direction_fl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_direction_fl);

            CompleteStructMember cst_wheel_spd_fl;
            cst_wheel_spd_fl.common().member_id(memberId++);
            cst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wheel_spd_fl.common().member_flags().IS_OPTIONAL(false);
            cst_wheel_spd_fl.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wheel_spd_fl.common().member_flags().IS_KEY(false);
            cst_wheel_spd_fl.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wheel_spd_fl.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_wheel_spd_fl.detail().name("wheel_spd_fl");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wheel_spd_fl);

            CompleteStructMember cst_is_wss_rr_edges_sum_valid;
            cst_is_wss_rr_edges_sum_valid.common().member_id(memberId++);
            cst_is_wss_rr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_wss_rr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_wss_rr_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_wss_rr_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_wss_rr_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_wss_rr_edges_sum_valid.common().member_flags().IS_KEY(false);
            cst_is_wss_rr_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_wss_rr_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_wss_rr_edges_sum_valid.detail().name("is_wss_rr_edges_sum_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_wss_rr_edges_sum_valid);

            CompleteStructMember cst_wss_rr_edges_sum;
            cst_wss_rr_edges_sum.common().member_id(memberId++);
            cst_wss_rr_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wss_rr_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wss_rr_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wss_rr_edges_sum.common().member_flags().IS_OPTIONAL(false);
            cst_wss_rr_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wss_rr_edges_sum.common().member_flags().IS_KEY(false);
            cst_wss_rr_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wss_rr_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wss_rr_edges_sum.detail().name("wss_rr_edges_sum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wss_rr_edges_sum);

            CompleteStructMember cst_is_wss_rl_edges_sum_valid;
            cst_is_wss_rl_edges_sum_valid.common().member_id(memberId++);
            cst_is_wss_rl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_wss_rl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_wss_rl_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_wss_rl_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_wss_rl_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_wss_rl_edges_sum_valid.common().member_flags().IS_KEY(false);
            cst_is_wss_rl_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_wss_rl_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_wss_rl_edges_sum_valid.detail().name("is_wss_rl_edges_sum_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_wss_rl_edges_sum_valid);

            CompleteStructMember cst_wss_rl_edges_sum;
            cst_wss_rl_edges_sum.common().member_id(memberId++);
            cst_wss_rl_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wss_rl_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wss_rl_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wss_rl_edges_sum.common().member_flags().IS_OPTIONAL(false);
            cst_wss_rl_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wss_rl_edges_sum.common().member_flags().IS_KEY(false);
            cst_wss_rl_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wss_rl_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wss_rl_edges_sum.detail().name("wss_rl_edges_sum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wss_rl_edges_sum);

            CompleteStructMember cst_is_wss_fr_edges_sum_valid;
            cst_is_wss_fr_edges_sum_valid.common().member_id(memberId++);
            cst_is_wss_fr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_wss_fr_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_wss_fr_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_wss_fr_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_wss_fr_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_wss_fr_edges_sum_valid.common().member_flags().IS_KEY(false);
            cst_is_wss_fr_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_wss_fr_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_wss_fr_edges_sum_valid.detail().name("is_wss_fr_edges_sum_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_wss_fr_edges_sum_valid);

            CompleteStructMember cst_wss_fr_edges_sum;
            cst_wss_fr_edges_sum.common().member_id(memberId++);
            cst_wss_fr_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wss_fr_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wss_fr_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wss_fr_edges_sum.common().member_flags().IS_OPTIONAL(false);
            cst_wss_fr_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wss_fr_edges_sum.common().member_flags().IS_KEY(false);
            cst_wss_fr_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wss_fr_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wss_fr_edges_sum.detail().name("wss_fr_edges_sum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wss_fr_edges_sum);

            CompleteStructMember cst_is_wss_fl_edges_sum_valid;
            cst_is_wss_fl_edges_sum_valid.common().member_id(memberId++);
            cst_is_wss_fl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_wss_fl_edges_sum_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_wss_fl_edges_sum_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_wss_fl_edges_sum_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_wss_fl_edges_sum_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_wss_fl_edges_sum_valid.common().member_flags().IS_KEY(false);
            cst_is_wss_fl_edges_sum_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_wss_fl_edges_sum_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("bool", false));

            cst_is_wss_fl_edges_sum_valid.detail().name("is_wss_fl_edges_sum_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_wss_fl_edges_sum_valid);

            CompleteStructMember cst_wss_fl_edges_sum;
            cst_wss_fl_edges_sum.common().member_id(memberId++);
            cst_wss_fl_edges_sum.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_wss_fl_edges_sum.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_wss_fl_edges_sum.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_wss_fl_edges_sum.common().member_flags().IS_OPTIONAL(false);
            cst_wss_fl_edges_sum.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_wss_fl_edges_sum.common().member_flags().IS_KEY(false);
            cst_wss_fl_edges_sum.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_wss_fl_edges_sum.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_wss_fl_edges_sum.detail().name("wss_fl_edges_sum");

            type_object->complete().struct_type().member_seq().emplace_back(cst_wss_fl_edges_sum);

            CompleteStructMember cst_is_tire_pressure_ok;
            cst_is_tire_pressure_ok.common().member_id(memberId++);
            cst_is_tire_pressure_ok.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_tire_pressure_ok.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_tire_pressure_ok.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_tire_pressure_ok.common().member_flags().IS_OPTIONAL(false);
            cst_is_tire_pressure_ok.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_tire_pressure_ok.common().member_flags().IS_KEY(false);
            cst_is_tire_pressure_ok.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_tire_pressure_ok.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_is_tire_pressure_ok.detail().name("is_tire_pressure_ok");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_tire_pressure_ok);

            CompleteStructMember cst_is_tire_pressure_lf_valid;
            cst_is_tire_pressure_lf_valid.common().member_id(memberId++);
            cst_is_tire_pressure_lf_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_tire_pressure_lf_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_tire_pressure_lf_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_tire_pressure_lf_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_tire_pressure_lf_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_tire_pressure_lf_valid.common().member_flags().IS_KEY(false);
            cst_is_tire_pressure_lf_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_tire_pressure_lf_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_is_tire_pressure_lf_valid.detail().name("is_tire_pressure_lf_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_tire_pressure_lf_valid);

            CompleteStructMember cst_tire_pressure_lf;
            cst_tire_pressure_lf.common().member_id(memberId++);
            cst_tire_pressure_lf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tire_pressure_lf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tire_pressure_lf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tire_pressure_lf.common().member_flags().IS_OPTIONAL(false);
            cst_tire_pressure_lf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tire_pressure_lf.common().member_flags().IS_KEY(false);
            cst_tire_pressure_lf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tire_pressure_lf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tire_pressure_lf.detail().name("tire_pressure_lf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tire_pressure_lf);

            CompleteStructMember cst_is_tire_pressure_rf_valid;
            cst_is_tire_pressure_rf_valid.common().member_id(memberId++);
            cst_is_tire_pressure_rf_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_tire_pressure_rf_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_tire_pressure_rf_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_tire_pressure_rf_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_tire_pressure_rf_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_tire_pressure_rf_valid.common().member_flags().IS_KEY(false);
            cst_is_tire_pressure_rf_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_tire_pressure_rf_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_is_tire_pressure_rf_valid.detail().name("is_tire_pressure_rf_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_tire_pressure_rf_valid);

            CompleteStructMember cst_tire_pressure_rf;
            cst_tire_pressure_rf.common().member_id(memberId++);
            cst_tire_pressure_rf.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tire_pressure_rf.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tire_pressure_rf.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tire_pressure_rf.common().member_flags().IS_OPTIONAL(false);
            cst_tire_pressure_rf.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tire_pressure_rf.common().member_flags().IS_KEY(false);
            cst_tire_pressure_rf.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tire_pressure_rf.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tire_pressure_rf.detail().name("tire_pressure_rf");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tire_pressure_rf);

            CompleteStructMember cst_is_tire_pressure_lr_valid;
            cst_is_tire_pressure_lr_valid.common().member_id(memberId++);
            cst_is_tire_pressure_lr_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_tire_pressure_lr_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_tire_pressure_lr_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_tire_pressure_lr_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_tire_pressure_lr_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_tire_pressure_lr_valid.common().member_flags().IS_KEY(false);
            cst_is_tire_pressure_lr_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_tire_pressure_lr_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_is_tire_pressure_lr_valid.detail().name("is_tire_pressure_lr_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_tire_pressure_lr_valid);

            CompleteStructMember cst_tire_pressure_lr;
            cst_tire_pressure_lr.common().member_id(memberId++);
            cst_tire_pressure_lr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tire_pressure_lr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tire_pressure_lr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tire_pressure_lr.common().member_flags().IS_OPTIONAL(false);
            cst_tire_pressure_lr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tire_pressure_lr.common().member_flags().IS_KEY(false);
            cst_tire_pressure_lr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tire_pressure_lr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tire_pressure_lr.detail().name("tire_pressure_lr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tire_pressure_lr);

            CompleteStructMember cst_is_tire_pressure_rr_valid;
            cst_is_tire_pressure_rr_valid.common().member_id(memberId++);
            cst_is_tire_pressure_rr_valid.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_is_tire_pressure_rr_valid.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_is_tire_pressure_rr_valid.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_is_tire_pressure_rr_valid.common().member_flags().IS_OPTIONAL(false);
            cst_is_tire_pressure_rr_valid.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_is_tire_pressure_rr_valid.common().member_flags().IS_KEY(false);
            cst_is_tire_pressure_rr_valid.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_is_tire_pressure_rr_valid.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_is_tire_pressure_rr_valid.detail().name("is_tire_pressure_rr_valid");

            type_object->complete().struct_type().member_seq().emplace_back(cst_is_tire_pressure_rr_valid);

            CompleteStructMember cst_tire_pressure_rr;
            cst_tire_pressure_rr.common().member_id(memberId++);
            cst_tire_pressure_rr.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_tire_pressure_rr.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_tire_pressure_rr.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_tire_pressure_rr.common().member_flags().IS_OPTIONAL(false);
            cst_tire_pressure_rr.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_tire_pressure_rr.common().member_flags().IS_KEY(false);
            cst_tire_pressure_rr.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_tire_pressure_rr.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("double", false));

            cst_tire_pressure_rr.detail().name("tire_pressure_rr");

            type_object->complete().struct_type().member_seq().emplace_back(cst_tire_pressure_rr);

            CompleteStructMember cst_air_bag_status;
            cst_air_bag_status.common().member_id(memberId++);
            cst_air_bag_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_air_bag_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_air_bag_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_air_bag_status.common().member_flags().IS_OPTIONAL(false);
            cst_air_bag_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_air_bag_status.common().member_flags().IS_KEY(false);
            cst_air_bag_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_air_bag_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_air_bag_status.detail().name("air_bag_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_air_bag_status);

            CompleteStructMember cst_charging_gun_status;
            cst_charging_gun_status.common().member_id(memberId++);
            cst_charging_gun_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_charging_gun_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_charging_gun_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_charging_gun_status.common().member_flags().IS_OPTIONAL(false);
            cst_charging_gun_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_charging_gun_status.common().member_flags().IS_KEY(false);
            cst_charging_gun_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_charging_gun_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_charging_gun_status.detail().name("charging_gun_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_charging_gun_status);

            CompleteStructMember cst_charge;
            cst_charge.common().member_id(memberId++);
            cst_charge.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_charge.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_charge.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_charge.common().member_flags().IS_OPTIONAL(false);
            cst_charge.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_charge.common().member_flags().IS_KEY(false);
            cst_charge.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_charge.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_charge.detail().name("charge");

            type_object->complete().struct_type().member_seq().emplace_back(cst_charge);

            CompleteStructMember cst_vehicle_power_status;
            cst_vehicle_power_status.common().member_id(memberId++);
            cst_vehicle_power_status.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_vehicle_power_status.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_vehicle_power_status.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_vehicle_power_status.common().member_flags().IS_OPTIONAL(false);
            cst_vehicle_power_status.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_vehicle_power_status.common().member_flags().IS_KEY(false);
            cst_vehicle_power_status.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_vehicle_power_status.common().member_type_id(*TypeObjectFactory::get_instance()->get_type_identifier("int32_t", false));

            cst_vehicle_power_status.detail().name("vehicle_power_status");

            type_object->complete().struct_type().member_seq().emplace_back(cst_vehicle_power_status);

            CompleteStructMember cst_chassis_error_code;
            cst_chassis_error_code.common().member_id(memberId++);
            cst_chassis_error_code.common().member_flags().TRY_CONSTRUCT1(false); // Unsupported
            cst_chassis_error_code.common().member_flags().TRY_CONSTRUCT2(false); // Unsupported
            cst_chassis_error_code.common().member_flags().IS_EXTERNAL(false); // Unsupported
            cst_chassis_error_code.common().member_flags().IS_OPTIONAL(false);
            cst_chassis_error_code.common().member_flags().IS_MUST_UNDERSTAND(false);
            cst_chassis_error_code.common().member_flags().IS_KEY(false);
            cst_chassis_error_code.common().member_flags().IS_DEFAULT(false); // Doesn't apply
            cst_chassis_error_code.common().member_type_id(*TypeObjectFactory::get_instance()->get_sequence_identifier("int32_t", 100, true));


            cst_chassis_error_code.detail().name("chassis_error_code");

            type_object->complete().struct_type().member_seq().emplace_back(cst_chassis_error_code);


            // Header
            type_object->complete().struct_type().header().detail().type_name("Chassis");
            // TODO inheritance


            TypeIdentifier identifier;
            identifier._d(EK_COMPLETE);

            SerializedPayload_t payload(static_cast<uint32_t>(
                CompleteStructType::getCdrSerializedSize(type_object->complete().struct_type()) + 4));
            eprosima::fastcdr::FastBuffer fastbuffer((char*) payload.data, payload.max_size);
            // Fixed endian (Page 221, EquivalenceHash definition of Extensible and Dynamic Topic Types for DDS document)
            eprosima::fastcdr::Cdr ser(
                fastbuffer, eprosima::fastcdr::Cdr::LITTLE_ENDIANNESS,
                eprosima::fastcdr::Cdr::DDS_CDR); // Object that serializes the data.
            payload.encapsulation = CDR_LE;

            type_object->serialize(ser);
            payload.length = (uint32_t)ser.getSerializedDataLength(); //Get the serialized length
            MD5 objectHash;
            objectHash.update((char*)payload.data, payload.length);
            objectHash.finalize();
            for(int i = 0; i < 14; ++i)
            {
                identifier.equivalence_hash()[i] = objectHash.digest[i];
            }

            TypeObjectFactory::get_instance()->add_type_object("Chassis", &identifier, type_object);
            delete type_object;
            return TypeObjectFactory::get_instance()->get_type_object("Chassis", true);
        }

    } // namespace msg
} // namespace ros2_interface